#!/usr/bin/env python
import httplib, mimetypes, os, sys, time, webbrowser
import urllib, re

def post_multipart(host, selector, fields, files):
    content_type, body = encode_multipart_formdata(fields, files)
    h = httplib.HTTP(host)
    h.putrequest('POST', selector)
    h.putheader('content-type', content_type)
    h.putheader('content-length', str(len(body)))
    h.putheader('authorization', 'Basic YWRtaW46YWRtaW4=')
    h.putheader('referer','http://'+host+'/update.asp')
    h.endheaders()
    h.send(body)
    errcode, errmsg, headers = h.getreply()
    return h.file.read()

def encode_multipart_formdata(fields, files):
    BOUNDARY = '----------ThIs_Is_tHe_bouNdaRY_$'
    CRLF = '\r\n'
    L = []
    for (key, value) in fields:
        L.append('--' + BOUNDARY)
        L.append('Content-Disposition: form-data; name="%s"' % key)
        L.append('')
        L.append(value)
    for (key, filename, value) in files:
        L.append('--' + BOUNDARY)
        L.append('Content-Disposition: form-data; name="%s"; filename="%s"' % (key, filename))
        L.append('Content-Type: %s' % get_content_type(filename))
        L.append('')
        L.append(value)
    L.append('--' + BOUNDARY + '--')
    L.append('')
    body = CRLF.join(L)
    content_type = 'multipart/form-data; boundary=%s' % BOUNDARY
    return content_type, body

def get_content_type(filename):
    return mimetypes.guess_type(filename)[0] or 'application/octet-stream'

def post_only_value(host, selector, fields):
  content_type = 'application/x-www-form-urlencoded'
  body = encode_form_urlencoded(fields)
  h = httplib.HTTP(host)
  h.putrequest('POST', selector)
  h.putheader('content-type', content_type)
  h.putheader('content-length', str(len(body)))
  h.putheader('authorization', 'Basic YWRtaW46YWRtaW4=')
  h.putheader('referer','http://'+host+'/update.asp')
  h.endheaders()
  h.send(body)
  errcode, errmsg, headers = h.getreply()
  return h.file.read()

def encode_form_urlencoded(fields):
  L = []
  for (key, value) in fields:
    L.append(key+'='+value)
    L.append('&')
  L.pop()
  body = ''.join(L)
  return body

def get_do_upgrade_firmware(route_ip='192.168.1.254', page='/do_upgrade_firmware.asp'):
  h = httplib.HTTP(route_ip)
  h.putrequest('GET', page)
  h.putheader('authorization', 'Basic YWRtaW46YWRtaW4=')
  h.endheaders()
  h.send('\r\n')
  #errcode, errmsg, headers = h.getreply()
  #return h.file.read()
  return None

def do_set_update_factory(route_ip='192.168.1.254', value=True):
  if value:
    value_str = '1'
  else:
    value_str = '0'
  post_only_value(route_ip, '/goform/factory', [('factory_v',value_str),('factory','on')])

def do_update_firmware(route_ip='192.168.1.254', file='1234567.img'):
  op = open(file,'rb')
  value = op.read()
  op.close()
  files = [('newcode', file, value)]
  post_multipart(route_ip, '/goform/update', [], files)


if __name__ == '__main__':
#    os.system('/home/compile.sh')
    now_dir = os.getcwd()
    os.chdir('/home/TC/linux')
    ip, firmware_name, reset = None, None, None
    if ip == None:
        ip = '192.168.1.254'
    if firmware_name == None:
        firmware_name = '1234567.img'
    if reset == None:
        reset = False
        #reset = True
    print ip, firmware_name, reset
    do_set_update_factory(ip, reset)
    do_update_firmware(ip, firmware_name)
    # time.sleep(3)
    get_do_upgrade_firmware(ip)
    os.chdir('/home/TC/')
    time.sleep(130)
    for i in range(10):
       data = urllib.urlopen('http://admin:admin@192.168.1.254/update.asp').read()
       data = ''.join(data.split())
       pat = r'/\*'
       if re.search(pat, data):
	 time.sleep(2)
	 print 'not ok', i
	 pass
       else:
         webbrowser.open_new("py_ok.htm");
	 break
    os.chdir(now_dir)
