/******************************************************************************
Copyright LSI Logic Ltd 2001
  
abm_tst.c - ABMTEST Source file
******************************************************************************/
#include <linux/config.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/proc_fs.h>
#include <linux/errno.h>
#include <linux/delay.h>
#include <linux/ioport.h> /* for request_region */
#include <linux/uio.h>
#include <linux/init.h>
#include <linux/capability.h>
#include <linux/bitops.h>
#include <linux/miscdevice.h>
#include <asm/byteorder.h>
#include <asm/system.h>
#include <asm/string.h>
#include <asm/io.h>
#include <asm/atomic.h>
#include <asm/uaccess.h>

#include "abm_tst.h"
#include "../abm_ext.h"


/* macros */

    
/* Function declarations */
static void __exit abmtest_exit(void);
static int __init abmtest_init(void);
module_init(abmtest_init);
module_exit(abmtest_exit);


/* Globals */
char *pBufLarge[11];
char *pBufSmall[11];

    
/****************************************************
Initalise ABMTEST
*****************************************************/
static int __init abmtest_init(void)
{
    int i;
    char *pbuf;

    PDEBUG("ABM-TESTER installed\n");
    for (i=0 ; i<11 ; i++)
    {
        pBufLarge[i] = abm_nget_bmup(128);
        if (pBufLarge[i] == NULL)
            PDEBUG("Failed (large) to get number %d\n", i+1);
        else
            *pBufLarge[i] = 1;
    }
    
    for (i=0 ; i<6 ; i++)
    {
        pBufSmall[i] = abm_nget_bmup(128);
        if (pBufSmall[i] == NULL)
            PDEBUG("Failed (small) to get number %d\n", i+1);
        else
            *pBufSmall[i] = 1;
    }
    return 0;
}


/****************************************************
Exit for ABMTEST
*****************************************************/
static void __exit abmtest_exit(void)
{
    int i;
    for (i=0 ; i<11 ; i++)
    {
        if (abm_free_bmup(pBufLarge[i]) != 0)
            PDEBUG("Failed (large) to free number %i -> 0x%p\n", i+1, pBufLarge[i]);
    }

    for (i=0 ; i<6 ; i++)
    {
        if (abm_free_bmup(pBufSmall[i]) != 0)
            PDEBUG("Failed (small) to free number %i -> 0x%p\n", i+1, pBufSmall[i]);
    }

    PDEBUG("ABM-TESTER de-installed\n");
}


/******************************************************************************
End of abm_tst.c
******************************************************************************/
