#include <stdio.h>
#include <string.h>
#include "linux/config.h"

#define include_ipsec
extern int vconfig_main( int argc, char *argv[]);
extern int ez_ipupdate_main(int argc, char *argv[]);
extern int brctl_main(int argc, char *argv[]);
extern int profile_main(int argc, char *argv[]);
extern int vpctrl_main(int argc, char *argv[]);
extern int mac_config_main(int argc, char *argv[]);
extern int login_main(int argc, char *argv[]);
//extern int tcwdog_main(int argc, char *argv[]);
//extern int factoryreset_main(int argc, char *argv[]);
extern int AdslFactoryResetAutoScan_main(int argc, char *argv[]);
//extern int syslogd_main(int argc, char *argv[]);
extern int alertmail_main(int argc, char *argv[]);
//extern int ntpd_main(int argc, char *argv[]);
extern int selfinit_main(int argc, char *argv[]);
extern int pstncheck_main(int argc, char *argv[]);
extern int sip_alg_wk_main(int argc, char *argv[]);
#ifdef _SUPPORT_BEKO_VOIP
extern int splitxconfig_main(int argc, char *argv[]);
#endif
extern int expand_main(int argc, char *argv[]);
extern int FakedDnsProxy_main(int argc, char *argv[]);
extern int PPPoELoginProxy_main(int argc, char *argv[]);
extern int wipc_mail_main(int argc, char *argv[]);
struct app_record {
		char *name;
		int (*main)(int, char **);
};

//extern int eroute_main(int argc, char *argv[]);
//extern int tncfg_main(int argc, char *argv[]);
//extern int spi_main(int argc, char *argv[]);
//extern int spigrp_main(int argc, char *argv[]);
//extern int whack_main(int argc, char *argv[]);
//extern int pluto_main(int argc, char *argv[]);
//extern int _pluto_adns_main(int argc, char *argv[]);

/* Most frequently run applications first. */
struct app_record app_records[] = {
	{ "vpctrl", vpctrl_main },
	{ "brctl", brctl_main },
	{ "login", login_main },
//	{ "tcwdog", tcwdog_main },
//	{ "factoryreset", factoryreset_main },
//	{ "AdslFactoryResetAutoScan", AdslFactoryResetAutoScan_main },
	{ "AFResetAutoScan", AdslFactoryResetAutoScan_main },
//	{ "syslogd", syslogd_main },
	{ "alertmail", alertmail_main },
//	{ "ntpd", ntpd_main },
	{ "selfinit", selfinit_main },
//	{ "pstncheck", pstncheck_main},
//	{ "sip_alg_wk", sip_alg_wk_main},
#ifdef _SUPPORT_BEKO_VOIP
	{ "splitxconfig", splitxconfig_main},
#endif
	{ "expand", expand_main },
	{ "FakedDnsProxy", FakedDnsProxy_main },
	{ "PPPoELoginProxy", PPPoELoginProxy_main },
	{ "wipc_mail", wipc_mail_main },
#ifdef include_ipsec
//	{ "eroute", eroute_main },
//	{ "spi", spi_main },
//	{ "spigrp", spigrp_main },
//	{ "tncfg", tncfg_main },
//	{ "whack", whack_main },
//	{ "pluto", pluto_main }, // is a task
//	{ "_pluto_adns", _pluto_adns_main },// is a task
#endif
	//{ "mac_config", mac_config_main },
	{ "vconfig", vconfig_main },
	{ "profile",profile_main }
};

#define MAX_APP_RECORDS (sizeof(app_records)/sizeof(struct app_record))

char *get_app_name(char *path)
{
	char *p;

	p = strrchr(path, '/');
	if (!p)
	{
		return path;
	}
	p++;
	return p;
}

int main(int argc, char *argv[])
{
	int i;
	char *app_name = get_app_name(argv[0]);

	for (i = 0; i < MAX_APP_RECORDS; i++)
	{
		//printf("%s,%s\n",app_name,app_records[i].name);
		if (strcmp(app_name, app_records[i].name) == 0)
		{
			return app_records[i].main(argc, argv);
		}
	}
	printf("Application %s not found\n", app_name);
	return -1;
}
