/****************************************************************************
 *
 *  Copyright (c) 2001 by LSI Logic Corporation, all rights reserved.
 *
 *                         LSI Logic confidential
 *  The information contained herein is proprietary of LSI Logic Corporation.
 *
 *  This software is provided "as is" without any express or implied warranty.
 *  LSI Logic disclaims all representations and warranties with regard to
 *  this software, including all implied warranties of merchantability and
 *  fitness for a particular purpose. In no event shall LSI Logic be liable
 *  for any special, indirect or consequential damages or any damages
 *  whatsoever resulting from loss of use, data or profits, whether in an
 *  action of contract, negligence or other tortious act or omission,
 *  arising out of or in connection with the use or performance of this
 *  software.
 *
 *  File Description:
 *
 *  This is the top level file for the Getafix bootloader.
 *
 ****************************************************************************/

#include "flashmemcpy.h"
#include <stdio.h>

int main(void);

static unsigned char dest[32];
static unsigned char src[32];

int main(void)
{
	int i;
	int len, src_start, dest_start, maxlen, maxlen1, maxlen2;

	for (i = 0; i < sizeof(src); i++)
	{
		src[i] = (unsigned char)i;
	}


	for (dest_start = 0; dest_start < sizeof(dest); dest_start++)
	{
		maxlen2 = sizeof(dest) - dest_start;
		for (src_start = 0; src_start < sizeof(src); src_start++)
		{
			maxlen1 = sizeof(src) - src_start;
			maxlen = (maxlen1 < maxlen2) ? maxlen1 : maxlen2;
			for (len = 1; len <= maxlen; len++)
			{
				for (i = 0; i < sizeof(dest); i++) dest[i] = 0xff;
				FlashMemcpy((__u32)(dest + dest_start), (__u32)(src + src_start), len);
				for (i = 0; i < sizeof(dest); i++)
				{
					if (i < dest_start)
					{
              if (dest[i] != (unsigned char)0xff)
              {
                  printf("(-1) i=%d, dest_start=%d, src_start=%d, len=%d\n", 
                         i, dest_start, src_start, len);
                  return -1;
              }
					}
					else if (i < dest_start + len)
					{
              if (dest[i] != src[src_start - dest_start + i])
              {
                  printf("(-2) i=%d, dest_start=%d, src_start=%d, len=%d\n", 
                         i, dest_start, src_start, len);
                  return -2;
              }
					}
					else
					{
              if (dest[i] != (unsigned char)0xff)
              {
                  printf("(-3) i=%d, dest_start=%d, src_start=%d, len=%d\n", 
                         i, dest_start, src_start, len);
                  return -3;
              }
					}
				}
			}
		}
	}
  printf("Passed\n");
	return 0;
}
