

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include "cli.h"
#include "sys_cmd.h"
#include "wan_cmd.h"
#include "setenv.h"
//#include <unistd.h>
//#include <sys/socket.h>
//#include <sys/ioctl.h>
//#include <linux/if.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>
char	CopyRight [80];




#ifdef LIBVER
#define MAINFUNC cli_main
#else
#define MAINFUNC main
#endif


#if !defined(min)
#define min(a,b)  ((a) < (b) ? (a) : (b))
#endif
extern cmds_table  sysCmdsDisplay[];
extern cmds_table  wanCmds[];
extern cmds_table  sysCmds[];
extern cmds_table etherCmds[];

char Prompt[80];

/*function prototypes*/

static int doSys(int argc, char *argv[], void *p);
static int doExitCli(int argc, char *argv[], void *p);
static int doetherCmd(int argc,char *argv[],void	*p);
static int dowanCmd(int argc,char *argv[],void	*p);



const cmds_table Cmds[] = {
	
	{"sys",      doSys,     Normal_Level, 0, "sys subcmd"},
  //	{"exit",     doExitCli,  Debug_Level, 0, "exit CLI"},
	{"lan",    doetherCmd, Normal_Level,	0, "Set/Get lan ipaddr"},
	{"wan",      dowanCmd,  Normal_Level,	0, "wan subcmd"},
	{NULL,	     NULL,	0,	  0, NULL}
};


void strip_CR(char	*s)
{
	char	*cp;
	if((cp = strchr(s,'\n')) != NULL) {
		*cp = '\0';
		if ( cp != s && *(--cp) == '\r' ) {
			*cp = '\0';
		}
	}
} /* strip_CR */


int subcmd(const cmds_table tab[],int argc,char *argv[],void *p)
{
	char	*error_msg = NULL;
	const cmds_table *cmdp  = tab;
	char	*cmd0 = argv[0];	/* current command		*/
	int found  = FALSE;
	
	if (argc < 1)
	{
		/* no subcommand */
		error_msg = "Missing subcommand. valid subcommands are:";
	}
        else if (argc ==1)
        {
         if ( argv[1] == "" )
	 {
 	  //check if it is sys commands.  FOr some hidden commands, will not be displayed.
	  if(tab==sysCmds)
		  valid_cmd_show(sysCmdsDisplay);
	  else
		  valid_cmd_show(tab);
          return ERR_NOT_FOUND;
	 }
         
        }
	else 
	{	/* subcommand */
		argc--;
		argv++;
		
		for ( cmdp = tab; cmdp->name != NULL;cmdp++ )
		{
			if ( strncmp(argv[0],cmdp->name,strlen(argv[0])) == 0 )
			break;
						
		}
	}
	if ( cmdp->func == NULL )
	{
		printf("No such cmd function!\n");
		return -1;
	}	

	return (*cmdp->func)(argc,argv,p);
} /* subcmd */



int valid_cmd_show(const cmds_table cmds[])
			
{
	char	buf[SHOW_BUFFER_SIZE + 1];
	cmds_table *cmdp;
	int index;
        int indexA;

	memset ( buf, ' ', SHOW_BUFFER_SIZE );
	buf[SHOW_BUFFER_SIZE] = '\0';
	for ( index = 0, cmdp = cmds; cmdp->name != NULL; cmdp++, index = (index+1)%4 )
        {
         if( cmdp->Level !=Debug_Level)
         {
          //printf("%s,index=%d\n",cmdp->name,index);
	  indexA=index;	
	  cmd_show( cmdp, buf, SHOW_BUFFER_SIZE, &index );
         }else
          {
           //printf("Debug Level cmd==%s, index=%d",cmdp->name,index);
           index=index-1; 
           indexA=index;
           //printf("sub back for index==%d\n",index);
          }
	}
        if(indexA < 3 )
           printf ( "%s\n", buf );
	return 0;
} /* valid_cmd_show */



int cmd_show(cmds_table *cmdp, char *buf,int buf_size,int *ii)
{
	int ii1 = (*ii) * CMD_NAME_SIZE;

      
        strncpy( buf+ii1, cmdp->name, min(CMD_NAME_SIZE,strlen(cmdp->name)) );
	if ( *ii == 3 )
	{
		printf ( "%s\n", buf );
		memset ( buf, ' ', buf_size );
		buf[buf_size] = '\0';
	}
	return 0;
} /* cmd_show */


static char *string_parse(char	*line)
{
	char	*cp = line;
	unsigned int num;

	while ( *line != '\0' && *line != '\"' )
	{
		if ( *line == '\\' )
		{
			line++;
			switch ( *line++ ) {
			case 'n':
				*cp++ = '\n';
				break;
			case 't':
				*cp++ = '\t';
				break;
			case 'v':
				*cp++ = '\v';
				break;
			case 'b':
				*cp++ = '\b';
				break;
			case 'r':
				*cp++ = '\r';
				break;
			case 'f':
				*cp++ = '\f';
				break;
			case 'a':
				*cp++ = '\a';
				break;
			case '\\':
				*cp++ = '\\';
				break;
			case '\?':
				*cp++ = '\?';
				break;
			case '\'':
				*cp++ = '\'';
				break;
			case '\"':
				*cp++ = '\"';
				break;
			case 'x':
				num = strtoul( --line, &line, 16 );
				*cp++ = (char) num;
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
				num = strtoul( --line, &line, 8 );
				*cp++ = (char) num;
				break;
			case '\0':
				return NULL;
			default:
				*cp++ = *(line - 1);
				break;
			};
		} else
		{
			*cp++ = *line++;
		}
	}

	if ( *line == '\"' )
		line++; 		
	*cp = '\0';           
	return line;
} /* string_parse */


int clicmdparser(const cmds_table cmds[], char *line,	void *p)
{
	
	const cmds_table *cmdp;
	char	*argv[NumberARG];
	char	*cp;
	int argc;
	int qflag = FALSE;
	int cmd_len;
	int i;
         
        strip_CR(line);
        for ( argc = 0; argc < NumberARG; argc++ )
		argv[argc] = NULL;

	for ( argc = 0; argc < NumberARG; )
	{
		qflag = FALSE;

		/* Skip leading white space */
		while ( *line == ' ' || *line == '\t' )
			line++;
		if ( *line == '\0' )
			break;
		/* return if comment character first non-white */
		if ( argc == 0	&& *line == '#' )
			return 0;
		/* Check for quoted token */
		if ( *line == '\"' )
		{
			line++; /* Suppress quote */
			qflag = TRUE;
		}
		/* Beginning of token */
		argv[argc++] = line;

		if ( qflag )
		{
			/* Find terminating delimiter */
			if ( (line = string_parse(line)) == NULL )
			{
				return ERR_STR_PARSE;
			}
		}
		else
		{
			/* Find space or tab. If not present,
			 * then we've already found the last
			 * token.
			 */
			if((cp = strchr(line,' ')) == NULL
			 && (cp = strchr(line,'\t')) == NULL){
				break;
			}
			*cp++ = '\0';
			line = cp;
		}
	}

	if (argc < 1)  /* empty command line */
	{
		argc = 1;
		argv[0] = "";
	}

	for ( i = argc; i<(argc+5) , i < NumberARG; i++ ) {
		argv[i]="";
	}
        
	if ( (cmd_len = strlen(argv[0])) == 0 )
		return 1;
	
	for ( cmdp = cmds; cmdp->name != NULL; cmdp++ )
	{
	    if ( strncmp(argv[0],cmdp->name,cmd_len) == 0 )
		break;
	}
	if ( cmdp->name == NULL  || (!strcmp(argv[0], "?")) || (!strcmp(argv[0], "help")) || (!strcmp(argv[0], "Help")))
	{
          printf("Valid commands are:\n");
          
	  //check if it is sys commands.  FOr some hidden commands, will not be displayed.
	  if(cmds==sysCmds)
		  valid_cmd_show(sysCmdsDisplay);
	  else
		  valid_cmd_show(cmds);
          return ERR_NOT_FOUND;
	}

	if( ((argc-1 < cmdp->argcmin) || ((argv[1]!= NULL ) && (!strcmp(argv[1], "?"))) ||
	 ((argv[1]!= NULL ) && (!strcmp(argv[1], "help")))) && (!(cmdp->Level & SUBCMD)) && ((cmdp->Level & Normal_Level)))
	{
		if ( cmdp->cmd_msg != NULL )
			printf("Usage: %s\n",cmdp->cmd_msg);
		else	printf("Usage: no help\n");

		return ERR_SHOW_HELP;
	}
	if (cmdp->func == NULL)
	{
	  printf("Can't find command: argv [%s] cmdp->name [%s]\n",argv[0],cmdp->name);
	  return -1;
	}
	return (*cmdp->func)(argc,argv,p);
}




int MAINFUNC(int argc, char *argv[])
{
	
	char cmdbuf [256], *pCmdBuffer;
	char syscmd_buf [128];
	char filePath[100];
	char Hostname[128];
        int i=0; 
	int status=ERR_NOT_FOUND;
	FILE* fs;
         signal(SIGINT,SIG_IGN);
    printf("\033[H\033[J"); /*clear screen*/ 
    strcpy(CopyRight, "Copyright (c) 2001 - 2004 ADSL Company");	
	printf( "%s\n", CopyRight );
	
          gethostname(Hostname, 128);
          sprintf(Prompt,"%s>", Hostname);
	for(;;) {
			printf (Prompt);
			bzero(cmdbuf, sizeof(cmdbuf));
			pCmdBuffer = fgets (cmdbuf, sizeof (cmdbuf), stdin);
			if( pCmdBuffer == cmdbuf)
			status = clicmdparser (Cmds, cmdbuf, NULL);
			else
			  status = EXIT_CLI;
			if (status == EXIT_CLI )
		    break;			
			}
		
}




static int doetherCmd(int argc,char *argv[],void	*p)
{
	return subcmd(etherCmds,argc,argv,p);
} /* doShowCmd */

static int dowanCmd(int argc,char *argv[],void	*p)
{
	 return subcmd(wanCmds,argc,argv,p);
} /* dowanCmd */


static int doSys(int argc,char *argv[],void *p)
{
    return subcmd(sysCmds,argc,argv,p);
} /* doSys */

static int doExitCli(int argc,char *argv[],void	*p)
{
	printf("Bye Bye, have a nice day!!\n");
	return (EXIT_CLI);
} /* doExitCi */
  


