

#ifndef _CLI_H
#define _CLI_H
/*	Constant Declaration*/
			
#define EXIT_CLI 		-100			

#define FALSE 0
#define TRUE 1


#define NumberARG		32	
#define SHOW_BUFFER_SIZE	66
#define CMD_NAME_SIZE		16
#define ERR_STR_PARSE	-1
#define ERR_SHOW_HELP	-2
#define ERR_NOT_FOUND	-3
#define ERR_SHOW_HELP2	-4

#define DMT_READ_FILE "/proc/dmtctrl/dmtread"
#define DMT_WRITE_FILE "/proc/dmtctrl/dmtwrite"



/*	Command Struct*/
typedef struct {
	char	*name;		                    /* Name of command*/
	int (*func)(int argc,char *argv[],void *p);/* Function to execute command*/
	int Level;		
	int argcmin;	
	char *cmd_msg;	
} cmds_table;

#define Normal_Level		0x01	
#define Debug_Level		0x02	

#define SUBCMD		0x10	/* commands contains subcommands	*/


extern const cmds_table Cmds[];

int clicmdparser(const cmds_table cmds[], char *line, void *p);
static char *string_parse(char	*line);
void strip_CR(char *);
int subcmd(const cmds_table tab[],int argc,char *argv[],void *p);
int valid_cmd_show(const cmds_table cmds[]);
int cmd_show(cmds_table *cmdp,char *buf,int buf_size,int *ii);
#include <linux/tc3162dmtctrl.h>
#endif	/* _CLI_H */
