#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/if.h>
#include <linux/sockios.h>
#include <linux/tc3162ioctl.h>
#include <sys/socket.h>
#include <sys/ioctl.h>

/* KenWang added 2005/11/21: set port mode -- begin -- */
#include "../iptables-1.2.11/runFunc.h"
#include "../websconfig/port_status.h"
#include <sys/syslog.h>
/* KenWang added 2005/11/21: set port mode -- end -- */

FILE* TTYS0;
#if 0
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
#else
#define DPRINTF(args...)
#endif

static int read_reg_status(int phy, int mii, int *value)
{
	int fd;
	struct ifreq ifr;
	struct IP175C_vlan_ioctl_args request_args;

	if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	  DPRINTF("FATAL:  Couldn't open a socket..go figure!\n");
		return -1;
	}   
	memset(&ifr, 0, sizeof(struct ifreq));
	
	strcpy(ifr.ifr_name, "eth0"); 

	request_args.phyaddr=phy;
	request_args.regid=mii;
	request_args.request_cmd=Get_Lan_Mii;
	ifr.ifr_data=(char*)&request_args;
	// if(request_args.regvalue==0 || ioctl(fd, SIOCGVLANPORT, &ifr)<0)
	// if(request_args.regvalue==0 || ioctl(fd, SIOCSVLANPORT, &ifr)<0)
	if(ioctl(fd, SIOCSVLANPORT, &ifr)<0) {
		DPRINTF("try to read lan mii reg fail\n");
		*value = 0;
		return -1;
	} else {
	  DPRINTF("reg %d.%d ==%x\n",request_args.phyaddr,request_args.regid,request_args.regvalue);
		*value = request_args.regvalue;
		return 0;
	}
}

#define GET_BIT(value,bit)  ((value>>bit) & 0x1)

static int read_port_link(int port)
{
	int value;
	read_reg_status(port, 1, &value);
	return GET_BIT(value,2);
}

#define FULL_100 1
#define HALF_100 2
#define FULL_10 3
#define HALF_10 4

/* KenWang added 2005/11/21: set port mode -- begin -- */
#define PORT_AUTO_MODE 0
#define PORT_FORCE_MODE 1

int read_port_mode(int port)
{
	int value;
	read_reg_status(29, 22, &value);
	if(GET_BIT(value, (port+11)) == 0)
		return PORT_AUTO_MODE;
	else
		return PORT_FORCE_MODE;
}
/* KenWang added 2005/11/21: set port mode -- end -- */

static int read_port_10_100(int port)
{
	int value;
	/* KenWang modified 2005/11/21: set port mode -- begin -- */
	if(read_port_mode(port) == PORT_AUTO_MODE) {
		read_reg_status(port, 5, &value);
		if(GET_BIT(value,8))
			return FULL_100;
		if(GET_BIT(value,7))
			return HALF_100;
		if(GET_BIT(value,6))
			return FULL_10;
		if(GET_BIT(value,5))
			return HALF_10;
	}
	else {
		read_reg_status(29, 22, &value);
		if((GET_BIT(value, (port+6))==1) && (GET_BIT(value, (port+1))==1))
			return FULL_100;
		if((GET_BIT(value, (port+6))==1) && (GET_BIT(value, (port+1))==0))
			return HALF_100;
		if((GET_BIT(value, (port+6))==0) && (GET_BIT(value, (port+1))==1))
			return FULL_10;
		if((GET_BIT(value, (port+6))==0) && (GET_BIT(value, (port+1))==0))
			return HALF_10;
	}
	return -1;
	/* KenWang modified 2005/11/21: set port mode -- end -- */
}

int port_status()
{
	int i=0;
	char buf_up_down[16]="Down";
	char buf_10_100[16]="N/A";
	char buf_half_duplex[16]="N/A";
	char buf_mode[16]="AUTO"; // KenWang added 2005/11/21
	char print_buf[512];

	// name, link on/off, 10/100, half/duplex
	/* KenWang modified 2005/11/21: set port mode -- begin -- */
	//char *header="%-12s%-8s%-12s%-10s\n";
	//char *content="Port%-8d%-8s%-12s%-10s\n";
	char *header="%-12s%-8s%-12s%-10s%-10s\n";
	char *content="Port%-8d%-8s%-12s%-10s%-10s\n";
	//char *tailer="-----------------------------------------------\n";

	//printf(header,"Name", "Link","Speed 10/100", "Duplex");
	printf(header,"Name", "Link","Speed 10/100", "Duplex", "Mode");
	/* KenWang modified 2005/11/21: set port mode -- end -- */

	//sprintf(print_buf, "port1 %d port2 %d port3 %d port4 %d",
	//    read_port_link(0), read_port_link(1), read_port_link(2), read_port_link(3));

	for(i=0;i<4;i++){
		/* KenWang modified 2005/11/21: set port mode -- begin -- */
		//if(read_port_link(i)){
		if(read_port_link(i) || (read_port_mode(i)==PORT_FORCE_MODE)) {
			if(read_port_link(i))
				strcpy(buf_up_down, "Up");
			else
				strcpy(buf_up_down, "Down");
		/* KenWang modified 2005/11/21: set port mode -- end -- */
			switch(read_port_10_100(i)){
			case FULL_100:
			        strcpy(buf_10_100,"100");
				strcpy(buf_half_duplex,"Full");
				break;
			case HALF_100:
			        strcpy(buf_10_100,"100");
				strcpy(buf_half_duplex,"Half");
				break;
			case FULL_10:
			        strcpy(buf_10_100,"10");
				strcpy(buf_half_duplex,"Full");
				break;
			case HALF_10:
			        strcpy(buf_10_100,"10");
				strcpy(buf_half_duplex,"Half");
				break;
			}
		}else{
			strcpy(buf_up_down, "Down");
			strcpy(buf_10_100,"N/A");
			strcpy(buf_half_duplex,"N/A");
		}
		/* KenWang added 2005/11/21: set port mode -- begin -- */
		if(read_port_mode(i) == 0)
			strcpy(buf_mode, "AUTO");
		else
			strcpy(buf_mode, "FORCE");
		//printf(content,
		//	i+1, buf_up_down,
		//	buf_10_100,
		//	buf_half_duplex);
		printf(content, i+1, buf_up_down, buf_10_100, buf_half_duplex, buf_mode);
		/* KenWang added 2005/11/21: set port mode -- end -- */
	}
	return 0;
}

/* KenWang added 2005/11/21: set port mode -- begin -- */

struct port_ctrl pl[4];

static void load_port_ctrl_conf()
{
	FILE *fp;
	int i, ret;
	char line[128];

	memset(pl, 0, sizeof(pl));

	fp = fopen(PORT_CTRL_CONF, "r");
	if(fp) {
		for(i=0; i<4; ++i) {
			if(fgets(line, sizeof(line), fp)) {
				ret = sscanf(line, "|%d|%d|%d|%d|\n", &(pl[i].index), &(pl[i].speed), &(pl[i].duplex), &(pl[i].mode));
				if(ret < 4) {
					DPRINTF("get %s failed at %d\n", PORT_CTRL_CONF, i);
					pl[i].index = i;
					pl[i].speed = 1;
					pl[i].duplex = 1;
					pl[i].mode = 0;
				}
			}
		}
		fclose(fp);
	}
	else {
		DPRINTF("open %s failed\n", PORT_CTRL_CONF);
		for(i=0; i<4; ++i) {
		       pl[i].index = i;
		       pl[i].speed = 1;
		       pl[i].duplex = 1;
		       pl[i].mode = 0;
		}
	}
}

static void save_port_ctrl_conf()
{
	FILE *fp;
	int i;
	
	fp = fopen(PORT_CTRL_CONF, "w");
	if(fp) {
		for(i=0; i<4; ++i) {
			fprintf(fp, "|%d|%d|%d|%d|\n", pl[i].index, pl[i].speed, pl[i].duplex, pl[i].mode);
		}
		fclose(fp);
	}
	else {
		DPRINTF("open %s failed\n", PORT_CTRL_CONF);
	}
}

void show_port_ctrl_usage()
{
	printf("Usage    : lan portctrl <port num> <mode> <speed> <duplex>\n");
	printf("port num : 1 - 4\n");
	printf("mode     : 'auto' or 'force'\n");
	printf("speed    : '10' or '100'\n");
	printf("duplex   : 'half' or 'full'\n");
}

int doPortCtrl(int argc, char *argv[], void *p)
{
	int index, speed, duplex, mode;
	char funcNum[32];

	if(argc < 3) {
		printf("Not enough args\n");
		show_port_ctrl_usage();
		return 0;
	}
	load_port_ctrl_conf();


	index = atoi(argv[1]) - 1;
	if(index<0 || index>3) {
		printf("port num should be between 1 and 4\n");
		return 0;
	}

	if(!strcmp(argv[2], "auto")) {
		mode = PORT_AUTO_MODE;
		speed = 1;
		duplex = 1;
		/* nothing has to be changed */
		if(pl[index].mode == mode)
			return;
	}
	else if(!strcmp(argv[2], "force"))
		mode = PORT_FORCE_MODE;
	else {
		printf("mode should be 'auto' or 'force'\n");
		return 0;
	}

	if(mode != 0) {
		if(!strcmp(argv[3], "10"))
			speed = 0;
		else if(!strcmp(argv[3], "100"))
			speed = 1;
		else {
			printf("speed should be '10' or '100'\n");
			return 0;
		}
		
		if(!strcmp(argv[4], "half"))
			duplex = 0;
		else if(!strcmp(argv[4], "full"))
			duplex = 1;
		else {
			printf("duplex should be 'half' or 'full'\n");
			return 0;
		}
	}

	if((pl[index].speed != speed) || (pl[index].duplex != duplex) || (pl[index].mode != mode)) {
		pl[index].index = index;
		pl[index].speed = speed;
		pl[index].duplex = duplex;
		pl[index].mode = mode;
		if(mode == PORT_FORCE_MODE)
			syslog(LOG_INFO, "LAN port%d is set to %s %s duplex mode\n", 
			       index+1, speed ? "100" : "10", duplex ? "Full" : "Half");
		else
			syslog(LOG_INFO, "LAN port%d is set to AUTO mode\n", index+1);
		save_port_ctrl_conf();
		sprintf(funcNum, "%d", FUNCTION_NUM_PORT_CTRL);
		do_command("/usr/sbin/runFunc", "/usr/sbin/runFunc", "start", funcNum, NULL);
	}
}

/* KenWang added 2005/11/21: set port mode -- end -- */
