
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include "cli.h"
#include "sys_cmd.h"


extern 	int interface_status();
extern  int sys_uptime();
extern cmds_table  arpCmds[];

extern char Prompt;
int doreboot(int argc,char *argv[],void	*p)
{

	do_command("/bin/vpctrl", "/bin/vpctrl", "active", "no", NULL); // KenWang added 2005/11/21: reset switch
       
        kill(1, SIGTERM);
	return 0; 

} /* doreboot */

int doreset(int argc,char *argv[],void	*p)
{

	do_command("profile", "profile", "put", "/etc/default", 0);

       
        //kill(1, SIGTERM);
	return 0; 

} /* doreset */



int doHostname(int argc,char *argv[],void *p)
{
	char *argv_ptr = *(argv+1);
        char buf[80];

      
        if(argc == 2)
        {
           if (sethostname(argv_ptr, strlen(argv_ptr)) < 0) 
		printf("Set hostname fail\n");	
           
             //sprintf(Prompt,"%s>", argv_ptr);
	}	
        else
	{
          gethostname(buf, 80);
	  printf("%s\n",buf);	
	}

		return 0;
} /* doHostname */

int doversion(int argc, char *argv[], void *p)
{
  char sysver[80];
  FILE *fp;
	fp = fopen("/etc/version", "r");
	memset(sysver, 0, sizeof(sysver));
	if(fp!=NULL){
		fgets(sysver, sizeof(sysver), fp);
                fclose(fp);
	}else
         printf("open file fail\n");
  printf("%s\n",sysver);
  return 0;
} /* doversion */

int doremotedbg(int argc,char *argv[],void *p)
{
	char *argv_ptr = *(argv+1);
        char buf[80];
        FILE *fp;
      
        if(argc == 2)
        {
           fp=fopen("/var/remoteaccess","r");
           if (fp == NULL)
              {
                fp = fopen("/var/remoteaccess", "a");
                fprintf(fp, "%d\n", atoi(argv_ptr));
                fclose(fp);
              }	else
              {
               fclose(fp);
               fp=fopen("/var/remoteaccess","w");
               //printf("remoteaccess file ok, write=%d\n",atoi(argv_ptr));
               fprintf(fp, "%d\n", atoi(argv_ptr));
               fclose(fp);
               }
       }	
        return 0;
} /* doremotedbg */

int doArp(int argc,char *argv[],void *p)
{
	if ( argc == 1 ) { /* show usage */
		printf("show\tadd\tdel\n");
		return 0;
	}

	return subcmd(arpCmds, argc, argv, p);
} /* doArp */

int doSaveConfig(int argc, char *argv[], void *p)
{
	do_command("profile", "profile", "put", "/flash", 0);
}

static int change_password(char *passwd)
{
	FILE *fpr=NULL, *fpw;
	int ret=0;
	char line[255],temp1[20],temp2[234];

	fpr = fopen("/flash/webuser.txt","r");
	fpw = fopen("/flash/webuser.txt~","w");
	
	if(fpr==NULL || fpw==NULL) printf("can't open password file\n");

	if(fpr) {
		while(fgets(line, sizeof(line), fpr)) {
			  sscanf(line,"%20[^=]=%s\n",temp1,temp2);
			  if(strcmp(temp1,"password")==0) {
				  ret = fprintf(fpw,"password=%s\n",passwd);  
			  }else{
				  ret = fputs(line,fpw);
			  }
		}
		fclose(fpr);
		fclose(fpw);
	}

	do_command("cp", "cp", "/flash/webuser.txt~", "/flash/webuser.txt",0);
	return 0;
}

int doPassword(int argc, char *argv[], void *p)
{
	if(argc != 2) {
		printf("sys password <new password>\n");
		return 0;
	}

	printf("change password %s\n", argv[1]);
	change_password(argv[1]);
	return 0;
}

int doTrafficStat(int argc, char *argv[], void *p)
{
	if(argc != 1) {
		printf("Usage : sys trafficstat\n");
		return 0;
	}

	interface_status();
	return 0;
}


int doUpTime(int argc, char *argv[], void *p)
{
	if(argc != 1) {
		printf("Usage : sys uptime\n");
		return 0;
	}

	sys_uptime();
	return 0;
}

// KenWang added 2005/11/09
int doSysLog(int argc, char *argv[], void *P)
{
	if(argc != 1) {
		printf("Usage : sys log\n");
		return 0;
	}
	do_command("cat", "cat", "/var/log/messages", NULL);
	return 0;
}

int doFreeMem(int argc,char *argv[],void *p)
{
	do_command("cat","cat","/proc/meminfo", 0);
	return 0;
} /* doTaskList */


const cmds_table sysCmdsDisplay[] = {
	{"hostname",    doHostname, Normal_Level, 1, "sys hostname <hostname>"},
	{"password",    doPassword, Normal_Level, 0, "sys password <new password>"},
	{"reboot",      doreboot,      Normal_Level, 0, "sys reboot"},
	{"reset",      doreset,      Normal_Level, 0, "sys reset"},
        {"rd",      doremotedbg,     Debug_Level, 1, "sys rd <0|1>"},
	{"version",     doversion,     Normal_Level, 0, "sys version"},
	{"arp",         doArp,        Normal_Level,     0,   "sys arp <show|add|del>"},
	{"saveconfig",  doSaveConfig, Normal_Level,     0,   "saveconfig"},
	{"trafficstat",  doTrafficStat, Normal_Level,     0,   "trafficstat"},
	{"uptime",  doUpTime, Normal_Level,     0,   "uptime"},
	{"log",         doSysLog, Normal_Level, 0, "sys log"}, // KenWang added 2005/11/09
	{NULL,		NULL,		0,	  0, NULL},
};
const cmds_table sysCmds[] = {
	{"hostname",    doHostname, Normal_Level, 1, "sys hostname <hostname>"},
	{"password",    doPassword, Normal_Level, 0, "sys password <new password>"},
	{"reboot",      doreboot,      Normal_Level, 0, "sys reboot"},
	{"reset",      doreset,      Normal_Level, 0, "sys reset"},
        {"rd",      doremotedbg,     Debug_Level, 1, "sys rd <0|1>"},
	{"version",     doversion,     Normal_Level, 0, "sys version"},
	{"arp",         doArp,        Normal_Level,     0,   "sys arp <show|add|del>"},
	{"saveconfig",  doSaveConfig, Normal_Level,     0,   "saveconfig"},
	{"trafficstat",  doTrafficStat, Normal_Level,     0,   "trafficstat"},
	{"uptime",  doUpTime, Normal_Level,     0,   "uptime"},
	{"log",         doSysLog, Normal_Level, 0, "sys log"}, // KenWang added 2005/11/09
	{"reboot_m",       doFreeMem,        Normal_Level,     0,   "sys freeMem"},
	{NULL,		NULL,		0,	  0, NULL},

};
