/* Albert Sep.-Oct. 2005 */

#ifndef _WAN_PROTO_H_
#define _WAN_PROTO_H_

#define WAN_CONFIG_FILE 		"/flash/wan.conf"
#define WAN_0_CONFIG_FILE               "/flash/wan0.conf"
#define WAN_1_CONFIG_FILE               "/flash/wan1.conf"
#define WAN_2_CONFIG_FILE               "/flash/wan2.conf"
#define WAN_3_CONFIG_FILE               "/flash/wan3.conf"

#define VOD_0_START_SCRIPT		"/etc/scripts/vod0_start.sh"
#define VOD_1_START_SCRIPT		"/etc/scripts/vod1_start.sh"
#define VOD_2_START_SCRIPT		"/etc/scripts/vod2_start.sh"
#define VOD_3_START_SCRIPT		"/etc/scripts/vod3_start.sh"

#define VOD_0_STOP_SCRIPT		"/etc/scripts/vod0_stop.sh"
#define VOD_1_STOP_SCRIPT		"/etc/scripts/vod1_stop.sh"
#define VOD_2_STOP_SCRIPT		"/etc/scripts/vod2_stop.sh"
#define VOD_3_STOP_SCRIPT		"/etc/scripts/vod3_stop.sh"

#define CHK_RANGE(VAL,MIN,MAX) (VAL<MIN||VAL>MAX)
#define CHK_RANGE_VOD_NUM(VAL) (CHK_RANGE(VAL,0,3))
#define CHK_RANGE_VPI(VAL)  (CHK_RANGE(VAL,0,255))
#define CHK_RANGE_VCI(VAL)  (CHK_RANGE(VAL,0,65535))
#define IS_ENC_LLC(VAL)  (strncmp(VAL,"llc",3)==0)
#define IS_ENC_VC(VAL)  (strncmp(VAL,"vcmux",5)==0)

#define    VOD_USAGE_MESSAGES     "wan proto vod <num> <vpi> <vci> <llc|vcmux>\n"
#define    VOD_NUM_MESSAGES   "num: range <1-4>\n"
#define    VOD_VPI_MESSAGES   "vpi: range <0-255>\n"
#define    VOD_VCI_MESSAGES   "vci: range <0-65535>\n"
#define    VOD_ENC_MESSAGES   "<llc> or <vcmux>\n"

#define    VOD_NUM   (atoi(argv[1])-1)
#define    VOD_VPI   (atoi(argv[2]))
#define    VOD_VCI   (atoi(argv[3]))
#define    VOD_VPI_S   (argv[2])
#define    VOD_VCI_S   (argv[3])
#define    VOD_ENC_S   (argv[4])

#define DHCP_USAGE_MESSAGES  "wan proto dhcp <vpi> <vci> <llc|vcmux>\n"
#define DHCP_VPI_MESSAGES   "vpi: range <0-255>\n"
#define DHCP_VCI_MESSAGES   "vci: range <0-65535>\n"
#define DHCP_ENC_MESSAGES   "<llc> or <vcmux>\n"
#define DHCP_VPI  (atoi(argv[1]))
#define DHCP_VCI  (atoi(argv[2]))
#define DHCP_VPI_S  (argv[1])
#define DHCP_VCI_S  (argv[2])
#define DHCP_ENC_S  (argv[3])

typedef struct {
	
	int Wan_Type; 
	int Quick_Wan_Type;		
	// 1483 Routed
	char Routed_Description[50];
	unsigned short Routed_VPI;
	unsigned short Routed_VCI;
	int Routed_ATM_Class;
	int Routed_NAT;
	int Routed_Encapsulation_Method;
	int Routed_IP_Assignment;
	char Routed_IP[20];
	char Routed_Netmask[20];
	char Routed_Gateway[20];
	int Routed_RIP;
	unsigned short Routed_MTU;	

	//1483 Bridge
        char Bridged_Description[50];
	unsigned short Bridged_VPI;
        unsigned short Bridged_VCI;
	int Bridged_ATM_Class;
	int Bridged_Encapsulation_Method;
	int Bridged_Ether_Filter_Type;
	int Bridged_Spanning_Bridge_Interface;
//Julian add for vod atm 20050921
	unsigned short Bridged_PCR;
	unsigned short Bridged_SCR;
	unsigned short Bridged_MBS;

	//PPPOA
        char PPPOA_Description[50];
	unsigned short PPPOA_VPI;
        unsigned short PPPOA_VCI;
        int PPPOA_ATM_Class;
	int PPPOA_NAT;
	char PPPOA_Username[256];
        char PPPOA_Password[256];
	char PPPOA_IP[20];
	int PPPOA_Authentication_Protocol;
	int PPPOA_Connection;
	unsigned short PPPOA_Idle_Timeout;
        int PPPOA_RIP;
	unsigned short PPPOA_MTU;
		
	//IPOA
	char IPOA_Description[50];
	unsigned short IPOA_VPI;
	unsigned short IPOA_VCI;
	int IPOA_ATM_Class;
	int IPOA_NAT;
	int IPOA_IP_Assignment;
	char IPOA_IP[20];
	char IPOA_Netmask[20];
	char IPOA_Gateway[20];
	int IPOA_RIP;
	unsigned short IPOA_MTU;
		
	//PPPOE
        char PPPOE_Description[50];
	unsigned short PPPOE_VPI;
        unsigned short PPPOE_VCI;
        int PPPOE_ATM_Class;
	int PPPOE_NAT;
	char PPPOE_Username[257];
        char PPPOE_Password[257];
	char PPPOE_Service_Name[32];
	char PPPOE_IP[20];
	int PPPOE_Authentication_Protocol;
	int PPPOE_Connection;
	unsigned short PPPOE_Idle_Timeout;
        int PPPOE_RIP;
	unsigned short PPPOE_MTU;
	int PPPOE_RELAY;
} WAN_CONFIG_DATA;

WAN_CONFIG_DATA wan_config;
WAN_CONFIG_DATA old_wan_config;

WAN_CONFIG_DATA wan0_config;
WAN_CONFIG_DATA old_wan0_config;

WAN_CONFIG_DATA wan1_config;
WAN_CONFIG_DATA old_wan1_config;

WAN_CONFIG_DATA wan2_config;
WAN_CONFIG_DATA old_wan2_config;

WAN_CONFIG_DATA wan3_config;
WAN_CONFIG_DATA old_wan3_config;

int doVod (int argc,char *argv[],void *p);
int doDhcp(int argc,char *argv[],void *p);

#endif /* _WANPROTO_H */
