/*
 * IPSEC interface configuration
 * Copyright (C) 2003 LSI Logic Europe Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#include <stdio.h>
#include <string.h>

extern int eroute_main(int argc, char *argv[]);
extern int spi_main(int argc, char *argv[]);
extern int spigrp_main(int argc, char *argv[]);
extern int tncfg_main(int argc, char *argv[]);


static void print_usage(void)
{
    printf("Usage: myipsec <command> [<parameters> ...]\n");
}


int main(int argc, char *argv[])
{
    if (argc>1) switch (*argv[1])
    {
    case 'e':
        if (strcmp(argv[1], "eroute")==0)
        {
            return eroute_main(argc-1, &argv[1]);
        }
        break;

    case 's':
        if (strcmp(argv[1], "spi")==0)
        {
            return spi_main(argc-1, &argv[1]);
        }
        else
        if (strcmp(argv[1], "spigrp")==0)
        {
            return spigrp_main(argc-1, &argv[1]);
        }
        break;

    case 't':
        if (strcmp(argv[1], "tncfg")==0)
        {
            return tncfg_main(argc-1, &argv[1]);
        }
        break;

#ifdef BEFORE_AES_PATCH
    case 'w':
        if (strcmp(argv[1], "whack")==0)
        {
            return whack_main(argc-1, &argv[1]);
        }
        break;
#endif

    default:
        break;
    }

    print_usage();
    return 0;
}
