/*
 * The program is refered from iptables.c, iptables-standalone.c and iptabled-restore.c
 * The main purpose is to prevent from calling the iptc_init() and iptc_commit() while every one iptables command is issued.
 * It can reduce the timing a lot.
 * 
 * NOTE:
 * It is not allowed to have more than two different cur-processing. It will cause the 2nd iptc_commit() fail. 
 *
*/

#include <getopt.h>
#include <sys/errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iptables.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <stdarg.h>
#include <signal.h>
#include "runFunc.h"
#include "../websconfig/timezone.h"
#include "../websconfig/ddns.h"
#include "../websconfig/blk_hack.h"
#include "../websconfig/blockwan.h"
#include "../websconfig/lan_conf.h"
#include "../websconfig/wan.h"
#include "../websconfig/misc.h"
#include "../websconfig/upnp.h"
#include "../websconfig/route.h"
#include "../websconfig/remote.h"
#include "../websconfig/igmp.h"
#include "../websconfig/adsl.h"
#include "../websconfig/wireless.h"
#include "../websconfig/wipca.h"
#include "../websconfig/vlan.h"     // KenWang added 2005/12/23
#include "../websconfig/wan_vod.h"  // KenWang added 2005/12/23
#include <linux/tc3162dmtctrl.h>
#include <linux/sockios.h> // KenWang added 2005/11/21
#include <linux/tc3162ioctl.h> // KenWang added 2005/11/21
#include <sys/ioctl.h>  /* ioctl */
//#define _INCLUDE_IPSEC_
#undef _INCLUDE_IPSEC_

//#define Telefonica 


#ifdef _INCLUDE_IPSEC_
#include "../websconfig/ipsec_config.h"
// For IPSec, we will not provide apply, only when FW.SH up.
void RunFunc_IPSec_Stop(void);
int RunFunc_IPSec_Start(void);
#endif	
extern void RunFunc_QOS_Start(void);

//#ifdef _DPRINTF_
#if 1
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
	
#define JP(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,"\n--\ntest:%d\n--\n",args); \
	fclose(TTYS0) 
#else
#define DPRINTF(args...)  
#endif /* _DPRINTF_ */

#define MAX_CONFIG_ITEM		60
#define MAX_STRING_LEN 		20

//#define jj   // debug message

/* global new argv and argc */
static char *newargv[64]={0};
static int newargc;
WAN_CONFIG_DATA wan_config;
WAN_CONFIG_DATA old_wan_config;
void firewall_clean_all_iptables(void);
int firewall_start_all_iptables(void);
char configName [MAX_CONFIG_ITEM][MAX_STRING_LEN+1]={{0}};
char configValue[MAX_CONFIG_ITEM][MAX_STRING_LEN+1]={{0}};
int configItem=0;	

/* variable */
char wan[MAX_STRING_LEN+1]={0};
char wan_if[MAX_STRING_LEN+1]={0};
char router[MAX_STRING_LEN+1]={0};
char lan_if[MAX_STRING_LEN+1]={0};
char lan_ip[MAX_STRING_LEN+1]={0};
char lan_mask[MAX_STRING_LEN+1]={0};
char wan_ip[MAX_STRING_LEN+1]={0};
extern long* find_pid_by_name( char* pidName);
extern int route_main(int argc, char **argv);
void stop_specific_function(int specficFuncNum,int isApply,char *parm1);
int stop_specific_task(int specficFuncNum);
void check_firewall(int rb_firewall_up);
void iptableScriptInstall(char *iptableScriptFile);
void stop_all_wan_relative_tasks(void);
int check_firewall_up(void);
int firewall_start_all_functions(void);
char* read_file_para_value(char *filename, char *arg1 ,char *buf);
#ifdef _RALINK_WIRELESS_DRIVER_
int Add_WDSMAC(int num,char *MAC);
int Del_WDSMAC(int num);

void execute_ralink_iwpriv(char *Cmd,char *Value){
	char str_temp[256];
	memset(str_temp,0,sizeof(str_temp));
	sprintf(str_temp,"%s=%s",Cmd,Value);
	DPRINTF("iwpriv ra0 set %s\n",str_temp);
	run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv","ra0","set",str_temp,NULL);
}
#endif

int check_firewall_up(void){
	FILE* fp;
	fp = fopen("/var/state/firewall_up.lock","r");
	if(!fp){
		return 0;
	}else{
		fclose(fp);
		return 1;
	}
}
void check_firewall(int rb_firewall_up)
{
	   if(rb_firewall_up)
	   {
		   //insmod /lib/modules/net/ipv4/netfilter/
		   FILE* fp;
		   fp = fopen("/var/state/firewall_up.lock","r");
		  if(!fp)
		  {
		  run_task("/sbin/insmod","/sbin/insmod","-r","pdfm",NULL); 
		  //tcpmss
#ifdef _sso_spary
// only for Spray old F-secure
		 	iptableScriptInstall(TCPMSS_ADD_IPTBALE_SHELL_SPRAY);	
#else
		 	iptableScriptInstall(TCPMSS_ADD_IPTBALE_SHELL);	
#endif
		   fp = fopen("/var/state/firewall_up.lock","w"); //touch
		   if(fp)
			   fclose(fp);
		  }
		  else fclose(fp); // Added 20070502
	   }
	   else
	   {
		   //rmmod -a
		   FILE* fp;
		   int count=0;

			//check if firewall still up
			fp = fopen("/var/state/_ip_sh_url","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			fp = fopen("/var/state/_ip_sh_macf","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			/*
			if(fp = fopen("/var/state/_ip_sh_blkw","r"))
			{
				count++;
				fclose(fp);
			}
			*/
			fp = fopen("/var/state/_ip_sh_blkh","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			fp = fopen("/var/state/_ip_sh_vs","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			fp = fopen("/var/state/_ip_sh_dmz","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			fp = fopen("/var/state/_ip_sh_pf","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			fp = fopen("/var/state/_ip_sh_qos","r");
			if(fp)
			{
				count++;
				fclose(fp);
			}
			if(!count)
			{
				fp = fopen("/var/state/firewall_up.lock","r");
			   if(fp)
			   {
				   //remove tcpmss script first!
				   //
				  iptableScriptInstall(TCPMSS_DEL_IPTBALE_SHELL);	
		  run_task("/sbin/rmmod","/sbin/rmmod","-r",NULL); 
				  //delete the lock
				  fclose(fp);
				  unlink("/var/state/firewall_up.lock");
			   }
			}
	   }

}

/* function adding one argument to newargv, updating newargc
 * returns true if argument added, false otherwise */
static int add_argv(char *what) {
        if (what && ((newargc + 1) < sizeof(newargv)/sizeof(char *))) {
                newargv[newargc] = strdup(what);
                newargc++;
                return 1;
        } else
                return 0;
}
                                                                                                             
static void free_argv(void) {
        int i;
                                                                                                             
        for (i = 0; i < newargc; i++)
                free(newargv[i]);
}

int ParseNameValue(char *buf, char **name, char **value)
{
	char *tmp;
	char in_quote=0;

        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++) ;

        if (!(*buf) || *buf == '\n' || // empty line
            *buf == '#')  // comment
                return -1;

	/* find name */
	*name = buf;
	for (; *buf && *buf != ' ' && *buf != '\t' &&
		   *buf != '=' && *buf != '\n'; buf++);
	tmp = buf;

	/* find the operator */
        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf != '=')
		return -1;
	*tmp = '\0';
                          
	/* find the value */
        /* skip the leading space */
        for (buf++; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf == '"') {
		in_quote = 1;
	}
	if (in_quote) {
	        for (*value=++buf; *buf && *buf != '"' && *buf != '\n'; buf++);
	}
	else {
                for (*value=buf; *buf && *buf != ' ' && *buf != '\t' && *buf != '\n'; buf++);

	}
        *buf = '\0';
	return 0;
}

int GetValue(char *name, char *value)
{
	int i;
	for (i=0; i<configItem; i++) {
                if (!strcmp(configName[i],name)) 
                        break;
	}
	if (i>=configItem) {
printf("can not found :%s \n", name);
		*value = '\0';
		return -1;
	}
	else {
		strncpy(value, configValue[i], MAX_STRING_LEN);
		return i;
	}
	
}

void SetValue(char *name, char *value)
{
	int i;

        for (i=0; i<configItem; i++) {
		if (!strcmp(configName[i],name))
			break; 
        }
        if (i>=configItem) { /* add it */
		strncpy(configName[configItem], name, MAX_STRING_LEN);
		strncpy(configValue[configItem], value, MAX_STRING_LEN);
		configItem++;
        }
        else {
                strncpy(configValue[i], value, MAX_STRING_LEN);
        }
 }

void GetParam(char *buf, char num, char deli, char *field)
{
        char i, *ptr;
                                                                                                                                               
        for (ptr=buf, i=0; *ptr && i<num; ++ptr) {
                if (*ptr==deli)
                        ++i;
        }
        while (*ptr && *ptr != deli) {
                *(field++) = *(ptr++);
        }
        *field = '\0';
}
 
void ReadSysStatus()
{
        FILE    *in;
        char    buffer[80];
        char    *name, *value;
                                                                                                                                               
#ifdef jj
        printf("Read SysStatus ...\n");
#endif
        in = fopen(VAR_ETC_STATUS_FILE, "r");
        while (fgets(buffer, sizeof(buffer), in)) {
                if (!ParseNameValue(buffer, &name, &value))
                        SetValue(name,value);
        }
                                                                                                                                               
        fclose(in);

}

                                                                                                      
int findParmVal(char *param_buffer,char *valueBuffer)
{
	// what if $LAN_IP/$LAN_MASK   
	char *p2=NULL;
	
	if((p2=strstr(param_buffer,"/$")))
	{
		p2[0]='\0';// null string for p1;
		// there are 2 parameters in the buffer
		p2+=2;//skip "/$"
	}
	if(GetValue(param_buffer,valueBuffer)>=0)
	{
		if(p2)
		{
			char value2[30];
		
			if(GetValue(p2,value2)<0)
			{
#ifdef jj
				printf("findParmVal:p2:Can not found parameter %s\n",p2);
#endif
				return 0;
			}
			strcat(valueBuffer,"/");
			strcat(valueBuffer,value2);
		}
#ifdef jj
		printf("findvalueInVar:get the value = %s\n",valueBuffer);
#endif	
		return 1;
	}
	else
	{
#ifdef jj
		printf("findParmVal:Can not found parameter %s\n",param_buffer);
#endif
	}
        return 0;// not find
}
#define VS_CFG_FILE       "/flash/vscfg.conf"
int
anyRuleActiveForVS(void)
{
    FILE           *fp;
    int DMZ_Enable; 
	struct in_addr host_ip;
	unsigned short	public_port;
	unsigned short	end_public_port;    // Mulder added 4-18-2003 for port range
	unsigned short	private_port;
	unsigned int	proto_type; 

    fp = fopen(VS_CFG_FILE, "r");
    if (!fp) {
	return 0;
    }

    /*
     * read DMT Enable and DMT Host Ip address 
     */
    // 1 2
    // |DMT Enable|DMT HostIP|
    if (fscanf(fp, "|%d|%08X|\n", &DMZ_Enable,	// 1
	       &host_ip.s_addr	// 2
	) == -1){
	fclose(fp);
	return 0;
    }

	// 1 2 3 4
	// |type|Port start|Port End|IP Address
	if (fscanf(fp, "|%d|%hu|%hu|%08X|%hu|\n", (int *) &proto_type,	// 1
		   &public_port,	// 2
		   &end_public_port,	// 3
		   &host_ip.s_addr,	// 4
		   &private_port	// 5
	    ) == -1)
	{
		fclose(fp);
 		return 0;
	}
    fclose(fp);
    return 1;
}

void iptableScriptInstall(char *iptableScriptFile)
{
	char *filter_table = "filter";
	char *nat_table = "nat";
	char *mangle_table = "mangle";
	char **cur_table = NULL;
       	char **pre_table = NULL ;
        iptc_handle_t handle=NULL;
        char buffer[256], *buf = NULL;
        int ret;
	FILE *in=NULL;
	char *param_start=NULL, *curchar=NULL;
	int quote_open, table_id;
                                                                                                                                               
        memset(buffer,0,sizeof(buffer));                                                                                                                                       
        in = fopen(iptableScriptFile, "r");
        if (!in) {
             fprintf(stderr, "Can't open %s: %s", iptableScriptFile, strerror(errno));
             return;
        }
	/* default table */	
	cur_table = pre_table = &filter_table;

//	DPRINTF("######## start  %s  #########\n",iptableScriptFile);
        while (fgets(buffer, sizeof(buffer), in)) {

                if (buffer[0] == '\n')
                        continue;
		/* skip the first space character first */
		for (buf = buffer; (*buf) && (*buf == ' ' || *buf == '\t' || *buf == '\n'); buf++);
		if (!(*buf) || *buf == '\n')
			continue; /* empty line */

                if (*buf == '#')  /* comment; skip */
                        continue;

                if (strncmp(buf, "iptables ", 9))
			continue; /* does not start with iptables */

		// reset the counter 
                newargc = quote_open = table_id = 0;
		param_start = buf;

                for (curchar = buf; *curchar; curchar++) {
                        if (*curchar == '"') {
                                /* quote_open cannot be true if there
                                 * was no previous character.  Thus,
                                 * curchar-1 has to be within bounds */
                                if (quote_open &&
                                    *(curchar-1) != '\\') {
                                        quote_open = 0;
                                        *curchar = ' ';
                                } else {
                                        quote_open = 1;
                                        param_start++;
                                }
                        }
                        if (*curchar == ' '
                            || *curchar == '\t'
                            || * curchar == '\n') {
                                char param_buffer[256];
                                int param_len = curchar-param_start;
                                  char valueBuf[60];        
                                                                           
                                if (quote_open)
                                        continue;
                                                                                                           
                                if (!param_len) {
                                        /* two spaces? */
                                        param_start++;
                                        continue;
                                }
                                                                                                             
                                /* end of one parameter */
                                strncpy(param_buffer, param_start,
                                        param_len);
                                *(param_buffer+param_len) = '\0';
                                param_start += param_len + 1;

                                /* check if table name specified */
                                if (!strncmp(param_buffer, "-t", 3)
                                   || !strncmp(param_buffer, "--table", 8)) {
    	 				/* table specified */
					table_id = 1;
					add_argv(param_buffer);
					continue;
                                }
                                                                                                            
                                if (table_id==1) {
#ifdef jj
					printf("table is %s\n", param_buffer);
#endif
					if (!strcmp(param_buffer, "filter")) {
						cur_table = &filter_table;
					} else if (!strcmp(param_buffer, "nat")) {
                                                cur_table = &nat_table;
					} else if (!strcmp(param_buffer, "mangle")) {
                                                cur_table = &mangle_table;
 					}
					/* reset the id */
					table_id = 0;
				}
				
				/* check whether it is the variable, if yes, update it to the correct value */
				if((param_buffer[0]=='$') &&// start with a $ sign
				     (findParmVal(param_buffer+1,valueBuf))) //skip "$"
				{
#ifdef jj
					printf("runFunc:repalce %s with %s\n",param_buffer, valueBuf);
#endif
					add_argv(valueBuf); 
				}
				else 
	                                add_argv(param_buffer);
 			} /* endof of para */
		} /* end of for */

		if (handle == NULL) { /* the first time */
#ifdef jj
			printf("init %s\n", *cur_table);
#endif 
			handle = iptc_init(*cur_table);
			pre_table = cur_table;
		}
		else if (pre_table != cur_table) {
#ifdef jj
	                printf("commit %s ..\n", *pre_table);
#endif
        	        if (!iptc_commit(&handle))
                	        printf("Can't commit %s", iptc_strerror(errno));

                        handle = iptc_init(*cur_table);
#ifdef jj
                        printf("init %s\n", *cur_table);
#endif

                        pre_table = cur_table;
		}
	
#ifdef jj
{
	int a;
	for (a=0; a<newargc; ++a)
                        DPRINTF("%s ", newargv[a]);
}

#endif

                                                                                                                                             
                ret = do_command(newargc, newargv, cur_table, &handle); 
                if (!ret){ 
			DPRINTF("runFunc do iptables rule failed\n");
		}
		
 		
		free_argv();
		/* restore to the default table */
		cur_table = &filter_table;
	}	
	fclose(in);

	/* write to the tables */ 
	if (handle) {
#ifdef jj
		printf("commit %s ..\n", *pre_table);
#endif
                if (!iptc_commit(&handle))
                        printf("Can't commit %s", iptc_strerror(errno));
	}
}


void run_task(char *cmd, ...)
{
        va_list args;
        char *param[40];
        int i=0, background=0;
        pid_t pid;
                
#ifdef jj
printf("run_task: %s\n", cmd);  
#endif
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char*)))
                        break;
        }
        va_end(args);
                                                                                                                                               
        if (!strcmp(param[i-2],"&")) {
#ifdef jj
printf("run_task: a back ground task\n");  
#endif
                background = 1;
                param[i-2] = 0;
        }

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}

static int Load_BlockWan_Config (BLOCKWAN_CONFIG_DATA *blockwan_config)
{
	FILE *fp;
 	blockwan_config->block_wan=0;// nonActive
	blockwan_config->block_wan_log=1;// not log
	fp=fopen(BLK_WAN_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d\n",&blockwan_config->block_wan,&blockwan_config->block_wan_log);
		fclose(fp);
	}
	return 0;
}


static int Load_BlockHack_Config (HACK_ATTCK_DATA *blk_hack)
{

	FILE *fp;

 	memset(blk_hack,0,sizeof(HACK_ATTCK_DATA));
	fp=fopen(BLK_HACK_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d %d %s %s %s \n",
				&blk_hack->protectionEnabled, 
				&blk_hack->alertEnabled, 
				&blk_hack->alerttime, 
				blk_hack->sendaddr, 
				blk_hack->alertaddr, 
				blk_hack->alertsmtp);
			if(blk_hack->sendaddr[0]=='&')
				blk_hack->sendaddr[0]='\0';
			if(blk_hack->alertaddr[0]=='&')
				blk_hack->alertaddr[0]='\0';
			if(blk_hack->alertsmtp[0]=='&')
				blk_hack->alertsmtp[0]='\0';
		fclose(fp);
	}
	return 0;
}

static int Load_Remote_Config (REMOTE_CONFIG_DATA *remote_config)
{
	FILE *fp;
	memset(remote_config,0,sizeof(REMOTE_CONFIG_DATA));
	fp=fopen(REMOTE_CONFIG_FILE,"r");
	if (fp){
		fscanf(fp,"|%d|%20[^|]|%20[^|]|\n",&remote_config->enable,remote_config->IpStart,remote_config->IpEnd);	
		fclose(fp);
	print_blank_string(remote_config->IpStart);
	print_blank_string(remote_config->IpEnd);
	}
	return 0;
}
static void resetCurrentEmbeddedCfg(void)
{
        EMBEDDED_CONFIG_DATA *d = &embedded_config;
	memset(d,0,sizeof(EMBEDDED_CONFIG_DATA));
}
static void Load_Embedded_Config (EMBEDDED_CONFIG_DATA *embedded_config)
{
	FILE *fp;
	
	resetCurrentEmbeddedCfg();

	if((fp=fopen(EMBEDDED_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%s %s %s\n",embedded_config->Http_Port, embedded_config->IP,embedded_config->logouttime); 
	//DPRINTF("Load Remote Config:Remote %d Port %d\n",remotecontrol_config.Remote, remotecontrol_config.Http_Port);
	fclose(fp);
	}
}

static void Load_Upnp1_Config (UPNP1_CONFIG_DATA *upnp1_config)
{
	FILE *fp;
	
        upnp1_config->enable=0;
        upnp1_config->upnpport=2800;

	fp=fopen(UPNP1_CONFIG_FILE,"r");
	if(fp){
		fscanf(fp,"%d %d\n",&upnp1_config->enable, &upnp1_config->upnpport); 
		fclose(fp);
	}
}
static void Snmpd_DESC_Load(int *snmp_desc_enable)
{
	FILE *fp;

	// load to SNMPD_DESC_FN 
	*snmp_desc_enable=0;
	fp=fopen(SNMPD_DESC_FN, "r");
	if(fp!=NULL){
		fscanf(fp,"%d\n",snmp_desc_enable); 
		fclose(fp);
	}
}
void resetCurrentWirelessCfg(void)
{
	WIRELESS_CONFIG_DATA *d=&wireless_config;
	memset(d,0,sizeof(WIRELESS_CONFIG_DATA));
}
static int Load_Wireless_Config (void)
{
	FILE *fp;
	resetCurrentWirelessCfg();
	fp=fopen(WIRELESS_CONFIG_FILE,"r");
	if(fp) {
		// KenWang modified 2005/06/14
		//fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%32[^|]|\n",
#ifdef _RALINK_WIRELESS_DRIVER_
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|\n",
#else
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%32[^|]|\n",
#endif
			&wireless_config.Enable,
			&wireless_config.Mode,
			wireless_config.Essid,
			&wireless_config.HideEssid,
			&wireless_config.RegulationDomain,
			&wireless_config.ChannelID,
			&wireless_config.WMM_QOS_Enable,
			&wireless_config.QMM_Power_Saving_Enable,
			&wireless_config.WDSEnable,
#ifdef _RALINK_WIRELESS_DRIVER_
			wireless_config.WDSMAC1,
			wireless_config.WDSMAC2,
			wireless_config.WDSMAC3,
			wireless_config.WDSMAC4);
#else
			wireless_config.WDSMAC);
#endif
		//fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|%d|\n",
#ifdef _RALINK_WIRELESS_DRIVER_
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
#else
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
#endif
			wireless_config.Sec_Mode,
			wireless_config.WPA_Algorithm,
			wireless_config.WPA_Shared_Key,
			&wireless_config.WPA_Group_Key_Renewal,
#ifdef _RALINK_WIRELESS_DRIVER_
			wireless_config.WPA2_Algorithm,
			wireless_config.WPA2_Shared_Key,
			&wireless_config.WPA2_Group_Key_Renewal,
#endif
//			&wireless_config.WPA_Hide_Essid,
			&wireless_config.WEP_Encryption,
			&wireless_config.WEP_Authentication,
			&wireless_config.WEP_Phrase_Type,
			&wireless_config.WEP_Keyid,
			wireless_config.WEP_Key1,
			wireless_config.WEP_Key2,
			wireless_config.WEP_Key3,
			wireless_config.WEP_Key4,
			wireless_config.WEP_Passphrase);
//			&wireless_config.WEP_Hide_Essid);
/*			
	print_blank_string(&wireless_config.Essid);
	print_blank_string(&wireless_config.WDSMAC);
	print_blank_string(&wireless_config.Sec_Mode);
	print_blank_string(&wireless_config.WPA_Algorithm);
	print_blank_string(&wireless_config.WPA_Shared_Key);
	print_blank_string(&wireless_config.WEP_Key1);
	print_blank_string(&wireless_config.WEP_Key2);
	print_blank_string(&wireless_config.WEP_Key3);
	print_blank_string(&wireless_config.WEP_Key4);
	print_blank_string(&wireless_config.WEP_Passphrase);
	*/
	fclose(fp);
	}
	return 0;
}

static int Load_Wipca_Config (WAN_IP_CHANGE_ALERT_CONFIG_DATA *wipca_config)
{

	FILE *fp;

	memset(wipca_config,0,sizeof(WAN_IP_CHANGE_ALERT_CONFIG_DATA));
	fp=fopen(WIPCA_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %s %s\n",
				&wipca_config->enable, 
				wipca_config->alertaddr, 
				wipca_config->alertsmtp);
			if(wipca_config->alertaddr[0]=='&')
				wipca_config->alertaddr[0]='\0';
			if(wipca_config->alertsmtp[0]=='&')
				wipca_config->alertsmtp[0]='\0';
		fclose(fp);
	}
	return 0;
}



/***************************************************************************/
/*  Following functions is for the START the specific fucntions             */		
/***************************************************************************/

void clean_all(){
	check_firewall(1);
	stop_all_wan_relative_tasks();
	firewall_clean_all_iptables();
	check_firewall(0);
}	
extern  u_int32_t aspectou32(char *astr, int dns) ;
int start_specific_iptables(int specficFuncNum)
{
	FILE *fp;
        
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_URL_FILTER:
			if((fp = fopen(URL_FILTER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
			{
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_url","w");
				if(fp) fclose(fp);
				iptableScriptInstall(URL_FILTER_CONF_RULE_ADD_IPTBALE_SHELL);
				return 1;
			}
			break;
		case FUNCTION_NUM_MAC_FILTER:
			if((fp = fopen(MAC_FILTER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
			{			
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_macf","w");
				if(fp) fclose(fp);
				iptableScriptInstall(MAC_FILTER_CONF_RULE_ADD_IPTBALE_SHELL);	
				return 1;
			}
			break;
		case FUNCTION_NUM_BLOCK_HACK:
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_blkh","w");
				if(fp) fclose(fp);
			iptableScriptInstall(HACK_IPTBALE_START_SHELL);	
			return 1;
		case FUNCTION_NUM_BLOCK_WAN:
			{
				BLOCKWAN_CONFIG_DATA blockwan_config;
				Load_BlockWan_Config( &blockwan_config);
				if(blockwan_config.block_wan)
				{
//for Markku case , we must get rid of block_wan.
//				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_blkw","w");
				if(fp) fclose(fp);
if(check_firewall_up()){	
					iptableScriptInstall(BLOCK_WAN_START_IPTBALE_SHELL);	
}else{
					iptableScriptInstall(BLOCK_WAN_START_IPTBALE_SHELL1);	
}
					return 1;
				}
			}
			break;
		case FUNCTION_NUM_REMOTE_CONFIG:
			{
				FILE *fp,*fp2;
				EMBEDDED_CONFIG_DATA embedded_config;
				HACK_ATTCK_DATA blk_hack;
				REMOTE_CONFIG_DATA remote_config;
				unsigned long IpFrom,IpTo;				
				char iprange[20]="";	
				char sipstr[45]="";						
				Load_Remote_Config( &remote_config);
				Load_Embedded_Config (&embedded_config);
				Load_BlockHack_Config(&blk_hack);

				if((fp=fopen(REMOTE_CONFIG_ADD_IPTBALE_SHELL,"w"))!=NULL){
				if((fp2=fopen(REMOTE_CONFIG_DEL_IPTBALE_SHELL,"w"))!=NULL){

				IpFrom = aspectou32(remote_config.IpStart,0);
				IpTo = aspectou32(remote_config.IpEnd,0);
				if(IpFrom==0)
					iprange[0]='\0';
				else
					strcpy(iprange,"-m iprange");
				// NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
				if(IpTo)
					sprintf(sipstr,"--src-range %s-%s",remote_config.IpStart,remote_config.IpEnd);
				////  We shall have the drop rules for subnet other than ACCEPT ones.
				//// Then, if the IPFrom and IPTo IPs are nulls, we may have accept it and drop it rules at the 
				//// same time.  But, it is OK since first rules process first.
				/// Why DROP first? because we have use inserting.
				{
//for speeding up with no firewall,robert 20050727
if(check_firewall_up()){	
					fprintf(fp,"iptables -I INPUT -p tcp --dport %s --destination %s -j DROP\n",
						embedded_config.Http_Port,
						wan_ip);
					fprintf(fp2,"iptables -D INPUT -p tcp --dport %s --destination %s -j DROP\n",
						embedded_config.Http_Port,
						wan_ip);
}else{
					fprintf(fp,"iptables -t nat -I PREROUTING -p tcp --dport %s --destination %s -j DROP\n",
						embedded_config.Http_Port,
						wan_ip);
					fprintf(fp2,"iptables -t nat -D PREROUTING -p tcp --dport %s --destination %s -j DROP\n",
						embedded_config.Http_Port,
						wan_ip);
}
				}	
				if(remote_config.enable)
				{
//for speeding up with no firewall,robert 20050727
if(check_firewall_up()){	
					fprintf(fp,"iptables -I INPUT %s %s -p tcp --dport %s --destination %s -j ACCEPT\n",
						iprange, sipstr,embedded_config.Http_Port,
						wan_ip);
					fprintf(fp2,"iptables -D INPUT %s %s -p tcp --dport %s --destination %s -j ACCEPT\n",
						iprange, sipstr,embedded_config.Http_Port,
						wan_ip);
}else{
					fprintf(fp,"iptables -t nat -I PREROUTING %s %s -p tcp --dport %s --destination %s -j ACCEPT\n",
						iprange, sipstr,embedded_config.Http_Port,
						wan_ip);
					fprintf(fp2,"iptables -t nat -D PREROUTING %s %s -p tcp --dport %s --destination %s -j ACCEPT\n",
						iprange, sipstr,embedded_config.Http_Port,
						wan_ip);
}				


				}	
				if((blk_hack.protectionEnabled)||anyRuleActiveForVS())
				{
					/*fprintf(fp,"iptables -t nat -I HCK_PRT -m state --state NEW -p tcp -d %s --dport %s -j ACCEPT\n",
					wan_ip,embedded_config.Http_Port);
					fprintf(fp2,"iptables -t nat -D HCK_PRT -m state --state NEW -p tcp -d %s --dport %s -j ACCEPT\n",
					wan_ip,embedded_config.Http_Port); */
					// From Mulder. we need to also consider the VS for Markku's reported Remote management bug issues.
					// Also, it shall be PREROUTING to prevent the VS take over the remotemangement
					fprintf(fp,"iptables -t nat -I PREROUTING -m state --state NEW -p tcp -d %s --dport %s -j ACCEPT\n",
					wan_ip,embedded_config.Http_Port);
					fprintf(fp2,"iptables -t nat -D PREROUTING -m state --state NEW -p tcp -d %s --dport %s -j ACCEPT\n",
					wan_ip,embedded_config.Http_Port);
				}
				fclose(fp2);
				}
				fclose(fp);
				}
				//DPRINTF("runFunc REMOTE_CONFIG_ADD_IPTABLE 828\n");
				iptableScriptInstall(REMOTE_CONFIG_ADD_IPTBALE_SHELL);	
				return 1;
			}
			break;
			
		case FUNCTION_NUM_UPNP:
			{  // WE need to stop the old tasks since it is already start in rcS.   for iptables rules, it
				// is deleted in fw_stop
				UPNP1_CONFIG_DATA upnp1_config;
				Load_Upnp1_Config(&upnp1_config);
				if(upnp1_config.enable)
				{
					if(strcmp(wan, "bridge"))
					{   //if [ "$WAN" != "bridge" ]  ; then	
						fp=fopen(UPNP_ADD_IPTBALE_SHELL,"w");
						if(fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
							fprintf(fp,"iptables -I INPUT -p tcp -s %s/%s --dport %d -j ACCEPT\n",
							lan_ip,lan_mask,upnp1_config.upnpport);
							fprintf(fp,"iptables -I INPUT -p udp -s %s/%s --dport 1900 -j ACCEPT\n",
							lan_ip,lan_mask);
}else{
							fprintf(fp,"iptables -I PREROUTING -t nat -p tcp -s %s/%s --dport %d -j ACCEPT\n",
							lan_ip,lan_mask,upnp1_config.upnpport);
							fprintf(fp,"iptables -I PREROUTING -t nat -p udp -s %s/%s --dport 1900 -j ACCEPT\n",
							lan_ip,lan_mask);
}
 						fclose(fp);
						}
						fp=fopen(UPNP_DEL_IPTBALE_SHELL,"w");
						if(fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
							fprintf(fp,"iptables -D INPUT -p tcp -s %s/%s --dport %d -j ACCEPT\n",
							lan_ip,lan_mask,upnp1_config.upnpport);
							fprintf(fp,"iptables -D INPUT -p udp -s %s/%s --dport 1900 -j ACCEPT\n",
							lan_ip,lan_mask);
}else{
							fprintf(fp,"iptables -D PREROUTING -t nat -p tcp -s %s/%s --dport %d -j ACCEPT\n",
							lan_ip,lan_mask,upnp1_config.upnpport);
							fprintf(fp,"iptables -D PREROUTING -t nat -p udp -s %s/%s --dport 1900 -j ACCEPT\n",
							lan_ip,lan_mask);
}
						fclose(fp);
						}
						iptableScriptInstall(UPNP_ADD_IPTBALE_SHELL);					
					}
					return 1;
				}
			}
		break;
		case FUNCTION_NUM_RIP:
			if((fp = fopen(RIP_CONFIG_FILE, "r")))
			{  // WE need to stop the old tasks since it is already start in rcS.   for iptables rules, it
				// is deleted in fw_stop
				int rip=0;
				fscanf(fp,"!%d\n",&rip);
				fclose(fp);		
				if(rip)
				{
					if( strcmp(wan, "bridge"))
					{   //if [ "$WAN" != "bridge" ]  ; then	
						fp=fopen(RIP_ADD_IPTBALE_SHELL,"w");
						if(fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
						fprintf(fp,"iptables -A INPUT -p tcp -s %s/%s --dport 2600 -j ACCEPT\n",
						lan_ip,lan_mask);			
						fprintf(fp,"iptables -A INPUT -p udp -s %s/%s --dport 520 -j ACCEPT\n",
						lan_ip,lan_mask);
}else{
						fprintf(fp,"iptables -A PREROUTING -t nat -p tcp -s %s/%s --dport 2600 -j ACCEPT\n",
						lan_ip,lan_mask);			
						fprintf(fp,"iptables -A PREROUTING -t nat -p udp -s %s/%s --dport 520 -j ACCEPT\n",
						lan_ip,lan_mask);
}
						fclose(fp);
						}
						fp=fopen(RIP_DEL_IPTBALE_SHELL,"w");
						if(fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
						fprintf(fp,"iptables -D INPUT -p tcp -s %s/%s --dport 2600 -j ACCEPT\n",
						lan_ip,lan_mask);				
						fprintf(fp,"iptables -D INPUT -p udp -s %s/%s --dport 520 -j ACCEPT\n",
						lan_ip,lan_mask);
}else{
						fprintf(fp,"iptables -D PREROUTING -t nat -p tcp -s %s/%s --dport 2600 -j ACCEPT\n",
						lan_ip,lan_mask);				
						fprintf(fp,"iptables -D PREROUTING -t nat -p udp -s %s/%s --dport 520 -j ACCEPT\n",
						lan_ip,lan_mask);
}
						fclose(fp);
						}
						iptableScriptInstall(RIP_ADD_IPTBALE_SHELL);	
					}
					return 1;
				}		
			}
		break;
		case FUNCTION_NUM_SNMP:
			{
				int snmp_desc_enable;
				Snmpd_DESC_Load(&snmp_desc_enable);
				if(snmp_desc_enable)
				{
					if (strcmp(wan,"bridge")){
					fp=fopen(SNMP_ADD_IPTBALE_SHELL,"w");
					if (fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
					fprintf(fp,"iptables -I INPUT -p udp -s %s/%s --dport 161 -j ACCEPT\n",
						lan_ip,lan_mask);
}else{
					fprintf(fp,"iptables -I PREROUTING -t nat -p udp -s %s/%s --dport 161 -j ACCEPT\n",
						lan_ip,lan_mask);
}
					fclose(fp);
					}
					fp=fopen(SNMP_DEL_IPTBALE_SHELL,"w");
					if(fp){
//for speeding up with no firewall up,Robert 07272005							
if(check_firewall_up()){	
					fprintf(fp,"iptables -D INPUT -p udp -s %s/%s --dport 161 -j ACCEPT\n",
						lan_ip,lan_mask);
}else{
					fprintf(fp,"iptables -D PREROUTING -t nat -p udp -s %s/%s --dport 161 -j ACCEPT\n",
						lan_ip,lan_mask);
}
					fclose(fp);
					}
					iptableScriptInstall(SNMP_ADD_IPTBALE_SHELL);
					}
					return 1;
				}	
			}       	       		
			break;
		case FUNCTION_NUM_VIRTUAL_SERVER_DMZ:
			if( !strcmp(router, "nat") )
			{//if [ "$ROUTER" = "nat" ] ;
				int haveAdded=0;
				//Julian Virtual run first ,DMZ run last because -I 20050519  
				if((fp = fopen(DMZ_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
				{
					fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_dmz","w");
				if(fp) fclose(fp);
					iptableScriptInstall(DMZ_CONF_RULE_ADD_IPTBALE_SHELL);			
					haveAdded=1;
				}
				if((fp = fopen(VIRTUAL_SERVER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
				{
					fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_vs","w");
				if(fp) fclose(fp);
					iptableScriptInstall(VIRTUAL_SERVER_CONF_RULE_ADD_IPTBALE_SHELL);
					haveAdded=1;
				}
				return haveAdded;
			}
 			break;
 		case FUNCTION_NUM_PACKET_FILTER:
			if((fp = fopen(PACKET_FILTER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
			{
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_pf","w");
				if(fp) fclose(fp);
				iptableScriptInstall(PACKET_FILTER_CONF_RULE_ADD_IPTBALE_SHELL);			
				return 1;
			}
 			break;
 		case FUNCTION_NUM_QOS:
			if((fp = fopen(QOS_CONF_FN_RULE_IPT_ADD, "r")))
			{
				fclose(fp);
				if((fp = fopen("/var/state/sip_proxy.lock", "r")))
				{ 
					fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_qos","w");
				if(fp) fclose(fp);
					iptableScriptInstall(SIP_IPTBALE_DEL_SHELL); 
					iptableScriptInstall(SIP_RUN_IPTBALE_DEL_SHELL); 
					iptableScriptInstall(QOS_CONF_FN_RULE_IPT_ADD);			
					iptableScriptInstall(SIP_RUN_IPTBALE_ADD_SHELL); 
					iptableScriptInstall(SIP_IPTBALE_ADD_SHELL); 
				}
				else
				{
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_qos","w");
				if(fp) fclose(fp);
					iptableScriptInstall(QOS_CONF_FN_RULE_IPT_ADD);			
				}
				return 1;
			}
			break;
 		case FUNCTION_NUM_TMSS:
			if((fp = fopen("/tmp/tmss_stat", "r")))
			{
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_tmss","w");
				if(fp) fclose(fp);
				iptableScriptInstall(TMSS_IPTBALE_SHELL);
			}
			return 1;
		case FUNCTION_NUM_SIP_PROXY:
if(check_firewall_up()){	
			iptableScriptInstall(SIP_RUN_IPTBALE_ADD_SHELL);
			iptableScriptInstall(SIP_IPTBALE_ADD_SHELL);
}else{
			iptableScriptInstall(SIP_RUN_IPTBALE_ADD_SHELL1);
			iptableScriptInstall(SIP_IPTBALE_ADD_SHELL1);
}	
			return 1;
			case FUNCTION_NUM_CLOSE_WAN_PORT:
if(check_firewall_up()){	
			iptableScriptInstall(CLOSE_WAN_PORT_IPTBALE_ADD_SHELL);
}else{
			iptableScriptInstall(CLOSE_WAN_PORT_IPTBALE_ADD_SHELL1);
}	
			return 1;

	}
	return 0;
}

static void
do1_extern_cmd(char *cmd, char *argv[], char *filename)
{
    char            path[100];
    int             pid, fd = -1,fd2 = -1;

    fflush(stdout);
    signal(SIGCHLD, SIG_DFL);
    if ((pid = vfork()))
	waitpid(pid, NULL, 0);
    if (pid == 0) {		// child process
	if (filename != NULL && *filename) {
	    strcpy(path, filename);
	    fd = open(path, O_RDWR | O_CREAT | O_TRUNC);
	    strcat(path, ".err");
	    fd2 = open(path, O_RDWR | O_CREAT | O_TRUNC);
	}
	if (fd >= 0 && fd2 >= 0) {
	    dup2(fd, STDOUT_FILENO);
	    dup2(fd2, STDERR_FILENO);
	    execvp(cmd, argv);
	}
	exit(0);
    }
}
int run_script(char *filename, char *arg1, char *arg2, char *arg3)
{
    char           *argv[] = { "sh", filename, arg1, arg2, arg3, NULL };
    do1_extern_cmd("sh", argv, "/var/tmp/run_script");
    return 0;
}

int print_blank_string(void *d)
{
	if (strcmp(d,BLANK_SYMBOL)==0)
              strcpy(d,"");
	return 1;
}

#define FUNCTION_START 0
#define FUNCTION_STOP 1
#define STATIC_ROUTE_LAN 1
#define STATIC_ROUTE_WAN 2
// KenWang modified 2005/05/17: update valid state when the function is called
int RunFunc_StaticRoute (int operation,int interface)
{
	FILE *fp;
	int i, j;
	char line[1024];
	char Interface[20];
	ROUTE_CONFIG_DATA route_config[MAX_ROUTES];	
	char costStr[20];
	char oper[7]="add";
	int has_added_route=0;
		
	if ((fp=fopen(ROUTE_CONFIG_FILE,"r+"))==NULL)
	{
		printf("unable to open ROUTE_CONFIG_FILE\n");
		return 0;
	}
	
	if(operation==FUNCTION_STOP)
		strcpy(oper,"del");
	for(i=0;i<MAX_ROUTES;i++)
	{	
		int runOperation=1;
		if (fgets(line, 1024, fp))
		{
			sscanf(line,"|%d|%20[^|]|%20[^|]|%20[^|]|%d|%d|\n",
			&route_config[i].valid,
			route_config[i].destination,
			route_config[i].netmask,
			route_config[i].gateway,
			&route_config[i].interface,
			&route_config[i].cost
			);
			if(interface!=route_config[i].interface)	
				continue;// Shall be the specify interface		
			print_blank_string(&route_config[i].destination);
			print_blank_string(&route_config[i].netmask);
			print_blank_string(&route_config[i].gateway);

			if (route_config[i].interface==STATIC_ROUTE_LAN)
				strcpy(Interface,lan_if);
			else if (route_config[i].interface==STATIC_ROUTE_WAN)
				strcpy(Interface,wan_if);
			else
				strcpy(Interface,"");
			sprintf(costStr,"%d",route_config[i].cost);
			
			if(operation==FUNCTION_STOP)
			{
				if(!route_config[i].valid)
					runOperation=0;				
			}
			else
			{
				has_added_route=1;
			}
			
			if(runOperation)
			{
				char *argv1[]={"route",oper,"-net",route_config[i].destination,"gw",route_config[i].gateway,
				"netmask",route_config[i].netmask,"metric",costStr,Interface,NULL};
				route_config[i].valid=route_main(12,argv1);
			}
			
		}
		else break;
	}
	if(operation == FUNCTION_START)
	{
		rewind(fp);
		for(j = 0; j < i; j++)
		{
			fprintf(fp, "|%d|%s|%s|%s|%d|%d|\n",
				route_config[j].valid, route_config[j].destination, route_config[j].netmask,
				route_config[j].gateway, route_config[j].interface, route_config[j].cost);
		}
	}
	fclose(fp);
	return has_added_route;
}

int RunFunc_BlockHack_Start(void)
{
	FILE *fp;
	HACK_ATTCK_DATA blk_hack;
	
	Load_BlockHack_Config(&blk_hack);
	if(!blk_hack.protectionEnabled)
	{
		return 0;
	}
	
	check_firewall(1);
	fp = fopen("/var/state/_ip_sh_blkh","w");
	if(fp) fclose(fp);

	fp = fopen("/var/log/boot", "w");
	if(fp){
	fprintf(fp,"Installing block hacker script\n");
	fclose(fp);
	}
	//# Enable syn-cookies (syn-flooding attacks)
	fp = fopen("/proc/sys/net/ipv4/tcp_syncookies", "w");
	if(fp){
	fprintf(fp,"1");	
	fclose(fp);
	}
	//##### Shut off source-routing and enable IP spoof detection
	//#Drop all source-routed packtes
	fp = fopen("/proc/sys/net/ipv4/conf/all/accept_source_route", "w");
	if(fp){
	fprintf(fp,"0");
	fclose(fp);
	}
	//#Enable source-address verification (anti spoofing)
	fp = fopen("proc/sys/net/ipv4/conf/all/rp_filter", "w");
	if(fp){
	fprintf(fp,"1");
	fclose(fp);
	}
	//Don't respond to broadcast pings. Disable ICMP echo-request to broadcast address (Smurf amplifier)
	fp = fopen("/proc/sys/net/ipv4/icmp_echo_ignore_broadcasts", "w");
	if(fp){
	fprintf(fp,"1");
	fclose(fp);
	}
	//#Kill ICMP re-directs
	fp = fopen("/proc/sys/net/ipv4/conf/all/accept_redirects", "w");
	if(fp){
	fprintf(fp,"0");
	fclose(fp);
	}
	//#Enable bad error message protection
	/*fp = fopen("/proc/sys/net/ipv4/icmp_ignore_bogus_error_responses", "w");
	fprintf(fp,"1");
	fclose(fp); */
	if(blk_hack.alertEnabled)
	{
		fp = fopen("/var/state/alertmail.lock", "w");//touch
		if(fp)
			fclose(fp);
		run_task("/usr/sbin/alertmail","/usr/sbin/alertmail","&",NULL);
	}
	return 1;
}
int RunFunc_AlertMail_Start(void)
{
	HACK_ATTCK_DATA blk_hack;
	
	Load_BlockHack_Config(&blk_hack);
	if((blk_hack.protectionEnabled)&&(blk_hack.alertEnabled))
	{
		run_task("/usr/sbin/alertmail","/usr/sbin/alertmail","&",NULL);
		return 1;
	}
	return 0;
}

int RunFunc_UPNP_Start(void)
{
	FILE *fp;
	
	if((fp = fopen(UPNP1_CONFIG_FILE, "r")))
	{  // WE need to stop the old tasks since it is already start in rcS.   for iptables rules, it
		// is deleted in fw_stop
		fclose(fp);
		int needToAddMulticastRoute=1;
		UPNP1_CONFIG_DATA upnp1_config;
		Load_Upnp1_Config(&upnp1_config);

		if((fp = fopen("/var/state/upnp.lock", "r")))
		{// pnp task is started
			//run_task("/bin/kill","/bin/kill","-9","`pidof upnp`","&",NULL);
			needToAddMulticastRoute=0;// already added
			fclose(fp);
		}			
				
		if(upnp1_config.enable)
		{
			char upnpportStr[10];
 		
			if(needToAddMulticastRoute)
			{
				run_task("/sbin/route","/sbin/route","add","239.255.255.250",
				lan_if,NULL);
			}
			sprintf(upnpportStr,"%d",upnp1_config.upnpport);				
		//	run_task("/usr/sbin/upnp","/usr/sbin/upnp","-L",
 		//		lan_if,"-W",
		//		wan_if,"-P",upnpportStr,"&",NULL);
		
			run_task("/usr/sbin/upnp","/usr/sbin/upnp","&",NULL);
			fp = fopen("/var/state/upnp.lock", "w");//touch
			if(fp)
				fclose(fp);
			return 1;
		}
	}
	return 0;
}

int RunFunc_WANIPChangeAlertEmail(void)
{
	WAN_IP_CHANGE_ALERT_CONFIG_DATA wipca_config;
	
	Load_Wipca_Config(&wipca_config);
	if(wipca_config.enable)
	{
		run_task("/usr/sbin/wipc_mail","/usr/sbin/wipc_mail","&",NULL);
		return 1;
	}
	return 0;
}

/* KenWang added 2005/11/21: set port mode -- begin -- */
static unsigned short load_port_ctrl_conf()
{
	FILE *fp;
	int i, ret, index, speed, duplex, mode;
	char line[128];
	unsigned short value = 0x420;

	fp = fopen(PORT_CTRL_CONF, "r");
	if(fp) {
		for(i=0; i<4; ++i) {
			if(fgets(line, sizeof(line), fp)) {
				ret = sscanf(line, "|%d|%d|%d|%d|\n", &index, &speed, &duplex, &mode);
				if(ret < 4) {
					DPRINTF("get %s failed at %d\n", PORT_CTRL_CONF, i);
				}
				value |= mode<<(i+11) | speed<<(i+6) | duplex<<(i+1);
			}
		}
		fclose(fp);
	}
     /*	else {
		DPRINTF("open %s failed\n", PORT_CTRL_CONF);
	} */
	return value;
}

static int set_port_mode(unsigned int *value)
{
	struct IP175C_vlan_ioctl_args request_args;
	int fd;
	struct ifreq ifr;

	if((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		DPRINTF("open socket failed\n");
		return 0;
	}

	memset(&ifr, 0, sizeof(struct ifreq));
	strcpy(ifr.ifr_name, "eth0");

	/* Write value to MII */
	request_args.phyaddr = 29;
	request_args.regid = 22;
	request_args.regvalue = *value;
	DPRINTF("value = %x\n", request_args.regvalue);
	request_args.request_cmd = Set_Lan_Mii;
	ifr.ifr_data = (char*)&request_args;
	if(ioctl(fd, SIOCSVLANPORT, &ifr) < 0) {
		DPRINTF("try to write lan mii reg failed\n");
		return 0;
	}
	
	/* reset switch */
	request_args.request_cmd = Switch_Reset;
	ifr.ifr_data = (char*)&request_args;
	if(ioctl(fd, SIOCSVLANPORT, &ifr) < 0) {
		DPRINTF("try to reset switch failed\n");
		return 0;
	}
	return 1;
}
/* KenWang added 2005/11/21: set port mode -- end -- */

static void resetCurrentWanCfg(void){
	//reboot_flag=0;
	WAN_CONFIG_DATA *d = &old_wan_config;
	WAN_CONFIG_DATA *d1 = &wan_config;
	memset(d,0,sizeof(WAN_CONFIG_DATA));
	memset(d1,0,sizeof(WAN_CONFIG_DATA));

}


void Load_Wan_Config (void){
	FILE *fp;
	char line[1024];
	resetCurrentWanCfg();
	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL)
	{
	if (fgets(line, 1024, fp))
		sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	//1483 Routed
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		wan_config.Routed_Description,
		&wan_config.Routed_VPI,
		&wan_config.Routed_VCI,
		(int *)&wan_config.Routed_ATM_Class,
		(int *)&wan_config.Routed_NAT,
        	(int *)&wan_config.Routed_Encapsulation_Method,
	        (int *)&wan_config.Routed_IP_Assignment,
		wan_config.Routed_IP,
		wan_config.Routed_Netmask,
		wan_config.Routed_Gateway,
		(int *)&wan_config.Routed_RIP,
		&wan_config.Routed_MTU
		);
	}
	print_blank_string(&wan_config.Routed_Description);
	print_blank_string(&wan_config.Routed_IP);
	print_blank_string(&wan_config.Routed_Netmask);
	print_blank_string(&wan_config.Routed_Gateway);
	
	//1483 Bridged
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|\n",
		wan_config.Bridged_Description,
		&wan_config.Bridged_VPI,
		&wan_config.Bridged_VCI,
		(int *)&wan_config.Bridged_ATM_Class,
		(int *)&wan_config.Bridged_Encapsulation_Method,
        	(int *)&wan_config.Bridged_Ether_Filter_Type,
	        (int *)&wan_config.Bridged_Spanning_Bridge_Interface
		);
	}
	
	print_blank_string(&wan_config.Bridged_Description);	
	//PPPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%20[^|]|%d|%d|%hu|%d|%hu|\n",
		wan_config.PPPOA_Description,
		&wan_config.PPPOA_VPI,
		&wan_config.PPPOA_VCI,
		(int *)&wan_config.PPPOA_ATM_Class,
		(int *)&wan_config.PPPOA_Encapsulation_Method,
		(int *)&wan_config.PPPOA_NAT,
		wan_config.PPPOA_Username,
		wan_config.PPPOA_Password,
		wan_config.PPPOA_IP,
	        (int *)&wan_config.PPPOA_Authentication_Protocol,
	        (int *)&wan_config.PPPOA_Connection,
	        &wan_config.PPPOA_Idle_Timeout,
		(int *)&wan_config.PPPOA_RIP,
		&wan_config.PPPOA_MTU
		);
	}
	
	print_blank_string(&wan_config.PPPOA_Description);
	print_blank_string(&wan_config.PPPOA_Username);
	print_blank_string(&wan_config.PPPOA_Password);
	print_blank_string(&wan_config.PPPOA_IP);	
	//IPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,"|%50[^|]|%hu|%hu|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",wan_config.IPOA_Description,
		&wan_config.IPOA_VPI,
		&wan_config.IPOA_VCI,
		(int *)&wan_config.IPOA_ATM_Class,
		(int *)&wan_config.IPOA_NAT,
	        (int *)&wan_config.IPOA_IP_Assignment,
		wan_config.IPOA_IP,
		wan_config.IPOA_Netmask,
		wan_config.IPOA_Gateway,
		(int *)&wan_config.IPOA_RIP,
		&wan_config.IPOA_MTU
		);
	}	
	
	print_blank_string(&wan_config.IPOA_Description);
	print_blank_string(&wan_config.IPOA_IP);
	print_blank_string(&wan_config.IPOA_Netmask);
	print_blank_string(&wan_config.IPOA_Gateway);	
	//PPPOE
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%32[^|]|%20[^|]|%d|%d|%hu|%d|%hu|%d|\n",
		wan_config.PPPOE_Description,
		&wan_config.PPPOE_VPI,
		&wan_config.PPPOE_VCI,
		(int *)&wan_config.PPPOE_ATM_Class,
		(int *)&wan_config.PPPOE_Encapsulation_Method,
		(int *)&wan_config.PPPOE_NAT,
		wan_config.PPPOE_Username,
		wan_config.PPPOE_Password,
		wan_config.PPPOE_Service_Name,
		wan_config.PPPOE_IP,
	        (int *)&wan_config.PPPOE_Authentication_Protocol,
	        (int *)&wan_config.PPPOE_Connection,
	        &wan_config.PPPOE_Idle_Timeout,
		(int *)&wan_config.PPPOE_RIP,
		&wan_config.PPPOE_MTU,
		(int *)&wan_config.PPPOE_RELAY
		);
	}
	print_blank_string(&wan_config.PPPOE_Description);
	print_blank_string(&wan_config.PPPOE_Username);
	print_blank_string(&wan_config.PPPOE_Password);
	print_blank_string(&wan_config.PPPOE_Service_Name);
	print_blank_string(&wan_config.PPPOE_IP);
	fclose(fp);
	}
//	if (wan_config.Quick_Wan_Type==0)
//		wan_config.Quick_Wan_Type=wan_config.Wan_Type;	
}

int start_specific_task(int specficFuncNum)
{
	FILE *fp;
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_TIME_ZONE:
		       if((fp = fopen(TIMEZONE_CONFIG_FILE, "r")))
		       {
			       int ntp_config_enabled=0;
				fscanf(fp,"%d\n",&ntp_config_enabled);
				fclose(fp);
				if(ntp_config_enabled)
				{
					run_task("/usr/sbin/ntpd","/usr/sbin/ntpd","&",NULL);
					return 1;// indicate it is enabled.
				}
		       }
		       break;
		case FUNCTION_NUM_DDNS:
		       if((fp = fopen(DDNS_CONFIG_FILE, "r")))
		       {
			       int ddns_config_enabled=0;
				fscanf(fp,"#:%d:\n",&ddns_config_enabled);
				fclose(fp);
				if(ddns_config_enabled)
				{
					run_task("/bin/ez-ipupdate","/bin/ez-ipupdate","-i",
					wan_if,"-b","/flash/ddns_st",
					"-c",DDNS_CONFIG_FILE,"&",NULL);
					return 1;// indicate it is enabled.
				}
		       }
		       break;
		case FUNCTION_NUM_STATIC_ROUTE_LAN:
			return RunFunc_StaticRoute(FUNCTION_START,STATIC_ROUTE_LAN);
		case FUNCTION_NUM_STATIC_ROUTE_WAN:
			return RunFunc_StaticRoute(FUNCTION_START,STATIC_ROUTE_WAN);
		case FUNCTION_NUM_BLOCK_HACK:
			return RunFunc_BlockHack_Start();
		case FUNCTION_NUM_ALERT_MAIL_ONLY:
			return RunFunc_AlertMail_Start();
		case FUNCTION_NUM_UPNP:
			return RunFunc_UPNP_Start();
		case FUNCTION_NUM_EMBEDED_WEB_SERVER:
//			run_task("webs","webs","&",NULL);
			break;
		case FUNCTION_NUM_RIP:
			if((fp = fopen(RIP_CONFIG_FILE, "r")))
			{
				int rip=0;
				fscanf(fp,"!%d\n",&rip);
				fclose(fp);
				
				if(rip)
				{
					stop_specific_function(FUNCTION_NUM_RIP,0,NULL);
						
					run_task("/usr/sbin/zebra","/usr/sbin/zebra","&",NULL);
					fp = fopen("/var/state/rip.lock", "w");//touch
					if(fp)
						fclose(fp);
					return 1;
				}
			}
			break;
		case FUNCTION_NUM_SNMP:
			{
				  int snmpd_config_enabled=0;
				  Snmpd_DESC_Load(&snmpd_config_enabled);
				  if(snmpd_config_enabled)
				  {
				       run_task("/usr/sbin/snmpd","/usr/sbin/snmpd","-f", "&", NULL);
				       return 1;// indicate it is enabled.
				  }
			}
			break;
		case FUNCTION_NUM_QOS:
			if((fp = fopen(QOS_CONF_FN_RULE_SHELL_ADD, "r")))
			{ // we need to add the rules by shell
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_qos","w");
				if(fp) fclose(fp);
				run_script(QOS_CONF_FN_RULE_SHELL_ADD,0,0,0);
				return 1;
			}
			break;
		case FUNCTION_NUM_TMSS:
			if((fp = fopen("/tmp/tmss_stat", "r")))
			{
				char tmss_status[5]="";
			
				fscanf(fp,"%s\n",tmss_status);
				fclose(fp);
				if(!strcmp(tmss_status,"NO"))
				{
					fp = fopen("/tmp/tmss_stat", "w");
					if (fp){
					fprintf(fp,"YES\n");
					fflush(fp);
					fclose(fp);
					}
					// aki removed 03/18/2005, using string comparision.
					////run_task("/usr/sbin/tmHostent","/usr/sbin/tmHostent","&",NULL);
					// aki change the position
					run_task("/usr/sbin/tmLicChk","/usr/sbin/tmLicChk","/flash/tm.conf","&",NULL);
					//run_task("/usr/sbin/thpd","/usr/sbin/thpd","/flash/tm.conf","&",NULL);
					run_task("/usr/sbin/tmdpd","/usr/sbin/tmdpd","&",NULL);
					run_task("/usr/sbin/tmAUChecker","/usr/sbin/tmAUChecker","/flash/tm.conf","&",NULL);
					//run_task("/usr/sbin/tmLicChk","/usr/sbin/tmLicChk","/flash/tm.conf","&",NULL);
					return 1;
				}
			}
			break;
		case FUNCTION_NUM_IGMP_PROXY:
			{
			int igmp_proxy_enabled=0;
			int igmp_snooping_enabled=0;

			fp=fopen(IGMP_CONFIG_FILE,"r");
			if(fp) {
				fscanf(fp,"%d %d\n",&igmp_proxy_enabled,&igmp_snooping_enabled);
				fclose(fp);
				if(igmp_proxy_enabled==1){
					if(strcmp(wan, "bridge"))
					{
		       			run_task("/usr/sbin/igmp-proxy","/usr/sbin/igmp-proxy","-n",wan_if, "&", NULL);
					fp = fopen("/var/state/igmp_proxy.lock", "w");//touch
					if(fp)
						fclose(fp);
					return 1;// indicate it is enabled.
					}
				}
				if(igmp_proxy_enabled==0){
					stop_specific_task(FUNCTION_NUM_IGMP_PROXY);
					unlink("/var/state/igmp_proxy.lock");
				}
			}
			}
			break;
		case FUNCTION_NUM_IGMP_SNOOPING:
			{
			int igmp_proxy_enabled=0;
			int igmp_snooping_enabled=0;
			fp=fopen(IGMP_CONFIG_FILE,"r");
			if(fp) {
				fscanf(fp,"%d %d\n",&igmp_proxy_enabled,&igmp_snooping_enabled);
				fclose(fp);
				if(igmp_snooping_enabled==1){
		       			run_task("brctl","brctl","igmpsnoop","br0","on", NULL);
					fp = fopen("/var/state/igmp_snooping.lock", "w");//touch
					if(fp)
						fclose(fp);
				}
				if(igmp_snooping_enabled==0){
		       			run_task("brctl","brctl","igmpsnoop","br0","off", NULL);
					unlink("/var/state/igmp_snooping.lock");
				}
			}
			}
			break;
		// KenWang added 2005/06/10
#ifdef _RALINK_WIRELESS_DRIVER_
		case FUNCTION_NUM_WIRELESS_MAC_FILTER:
		fp = fopen("/flash/wireless_mf.conf", "r");
		if(fp)
		{
			char mf[4];
			int tmp;
			memset(mf, 0, 4);
			fscanf(fp, "|%d|", &tmp);
			fclose(fp);
			if(tmp > 0)
			{
				fp = fopen("/var/tmp/wireless_macfilter_list", "r");
				if(fp)
				{
					if (tmp==2)/* default Drop */
						sprintf(mf, "%d", 1 );
					if (tmp==1)/* default forward */
						sprintf(mf, "%d", 2);
			
					int rule_num=0,i=0;
					char line[255];
					char maclist[32][18];
					char str_temp[1024];
					memset(maclist,0,sizeof(maclist));
					memset(line,0,sizeof(line));
					memset(str_temp,0,sizeof(str_temp));
					while(fgets(line,255,fp)){
						strncpy(maclist[rule_num],line,17);
						//DPRINTF("maclist[%d]:%s\n",rule_num,maclist[rule_num]);
						rule_num++;
					}
					fclose(fp);
					if(rule_num!=0){
					/*  AccessPolicy Start */	
			
					/*  iwpriv ra0 set AccessPolicy={0~2}
					 *  0:Disable
					 *  1:Allow All
					 *  2:Reject All
					 *  
					 *  iwpriv ra0 set AccessControlList={"MAC_ADDR1;MAC_ADDR2;...;MAC_ADDR32"}
					*/
					execute_ralink_iwpriv("AccessPolicy",mf);		
					/* AccessPolicy End */		

					for(i=0;i<rule_num;i++){
						if (rule_num==1){
							sprintf(str_temp,"%s",maclist[i]);
						}else{
							if(i==0){
								sprintf(str_temp,"%s",maclist[i]);
							}else{
								memset(line,0,sizeof(line));
								sprintf(line,";%s",maclist[i]);
								strcat(str_temp,line);
							}
						}
						//DPRINTF("str_temp[%d]:%s\n",i,str_temp);
						execute_ralink_iwpriv("AccessControlList",str_temp);		
					}
				}
			return 1;
			}
		}
		}
		break;
#else /* Inprocom */
		case FUNCTION_NUM_WIRELESS_MAC_FILTER:
		fp = fopen("/flash/wireless_mf.conf", "r");
		if(fp)
		{
			char mf[4];
			int tmp;
			memset(mf, 0, 4);
			fscanf(fp, "|%d|", &tmp);
			fclose(fp);
			if(tmp > 0)
			{
				fp = fopen("/var/tmp/wireless_macfilter_list", "r");
				if(fp)
				{
				if (tmp==2)/* default Drop */
					sprintf(mf, "%d", 1 );
				if (tmp==1)/* default forward */
					sprintf(mf, "%d", 2);
								
					run_task("/usr/sbin/iwsta", "/usr/sbin/iwsta", "wlan0", "macfilter", mf, NULL);
			DPRINTF("iwsta wlan0 macfilter %s\n",mf);
					fclose(fp);
					return 1;
				}
			}
		}
		case FUNCTION_NUM_ACT :
		run_script("/usr/bin/act_spt",0,0,0);
//			run_task("/usr/bin/act","/usr/bin/act","&",NULL);
//			run_task("/usr/bin/actact","/usr/bin/actact","&",NULL);
		break;
#endif		
		case FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT:
		return RunFunc_WANIPChangeAlertEmail();
		break;

	}
		return 0;
}

void reload_config_specific_task(int specficFuncNum)
{
	long *killpid=NULL;
	int nSignal=SIGUSR1;
	
	
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_UPNP:
		killpid=find_pid_by_name("upnp");
	}
	if (killpid && (*killpid>0))
		kill(*killpid,nSignal);
}

#ifdef _RALINK_WIRELESS_DRIVER_
int Del_WDSMAC(int num){
	
	FILE *fp=NULL;
	char mac[32];
	char str_temp[256];
	char str_touch[256];
	char str_if[20];
	memset(str_if,0,sizeof(str_if));
	sprintf(str_if,"ra%d",num);
	memset(str_touch,0,sizeof(str_touch));
	sprintf(str_touch,"/var/state/wlanwds%d.lock",num);	
	if((fp = fopen(str_touch, "r")) != NULL){
		memset(mac,0,sizeof(mac));
		fscanf(fp,"%s\n",mac);
		DPRINTF("DEL MAC%d:%s\n",num,mac);
		memset(str_temp,0,sizeof(str_temp));
		run_task("ifconfig","ifconfig",str_if,"down",NULL);	
		DPRINTF("ifconfig %s down\n",str_if);
		run_task("brctl","brctl","delif","br0",str_if);
		DPRINTF("brctl delif br0 %s\n",str_if);
		memset(str_temp,0,sizeof(str_temp));
		sprintf(str_temp,"DelWdsList=%s",mac);
		run_task("iwpriv","iwpriv","ra0","set",str_temp,NULL);
		DPRINTF("iwpriv ra0 set %s\n",str_temp);
		fclose(fp);
		unlink(str_touch);
	}
	return 1;
}

int Add_WDSMAC(int num,char *MAC){
	FILE *in=NULL;
	char wlan_wds_if[20];
	char wlan_if[20];
	char str_temp[256];
	memset(wlan_wds_if,0,sizeof(wlan_wds_if));
	memset(wlan_if,0,sizeof(wlan_if));
	
	sprintf(wlan_wds_if,"ra%d",num);
	strcpy(wlan_if,"ra0");

	/* AddWdsList Start*/
	
	memset(str_temp,0,sizeof(str_temp));
	sprintf(str_temp,"AddWdsList=%s",MAC);
	run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"set",str_temp,NULL);
	DPRINTF("%s:iwpriv %s set %s\n",wlan_wds_if,wlan_if,str_temp);

	/* AddWdsList End*/

	run_task("brctl","brctl","addif","br0",wlan_wds_if,NULL);
	DPRINTF("brctl addif br0 %s\n",wlan_wds_if);

	run_task("ifconfig","ifconfig",wlan_wds_if,"0.0.0.0","up",NULL);	
	DPRINTF("ifconfig %s 0.0.0.0 up\n",wlan_wds_if);


	memset(str_temp,0,sizeof(str_temp));
	sprintf(str_temp,"/var/state/wlanwds%d.lock",num);
	if ((in = fopen(str_temp, "w")) != NULL) {
		fprintf(in,"%s\n",MAC);
//		DPRINTF("Touch %s WDSMAC%d:%s\n",str_temp,num,MAC);
		fclose(in);
	}
	return 1;
}
#endif

/* KenWang added 2005/12/30 for other wan bridge -- begin -- */
static void resetCurrentWanVodCfg(OTHER_WAN_BRIDGE_DATA *d)
{
     memset(d,0,sizeof(OTHER_WAN_BRIDGE_DATA));
}

void Load_Other_Wan_Bridge_Config (OTHER_WAN_BRIDGE_DATA *d)
{
	FILE *fp;
	char line[1024];
	int i;
	
	//DPRINTF("Load_Other_Wan_Bridge_Config is called\n");
	resetCurrentWanVodCfg(d);
	if ((fp=fopen(OTHER_WAN_BRGIDE_CONFIG_FILE, "r"))==NULL) 
		return;
	//1483 Bridged only for current stage
	fscanf(fp,"%d\n",&d->wan_bridge_no);
	if(!d->wan_bridge_no)
	{
		fclose(fp);
		return;
	}
	for(i=0;i<d->wan_bridge_no;i++)
	{
		if (fgets(line, 1024, fp))
		{
			sscanf(line,
			"|%50[^|]|%d|%hu|%hu|%d|%d|%d|%d|\n",
			 d->Bridged_Description[i],
			 &d->usingSamePVCFromExistingWanConnection[i],
			 &d->Bridged_VPI[i],
			 &d->Bridged_VCI[i],
			 (int *)&d->Bridged_ATM_Class[i],
			 (int *)&d->Bridged_Encapsulation_Method[i],
			 (int *)&d->Bridged_Ether_Filter_Type[i],
			 (int *)&d->Bridged_Spanning_Bridge_Interface[i]
		       );
		       print_blank_string(&d->Bridged_Description[i]);
		}
		else
			break;
	}
	fclose(fp);
}

void resetCurrentVlanCfg(VLAN_CONFIG_DATA *d)
{
	memset(d,0,sizeof(VLAN_CONFIG_DATA));
}

static int Load_Vlan_Config (VLAN_CONFIG_DATA *d)
{
	int i;
	FILE *fp;

	resetCurrentVlanCfg(d);
	fp=fopen(VLAN_CONFIG_FILE,"r");
	if(!fp) {
		return 0;
	}
	//fscanf(fp,"%d\n",&d->management_vlan_group);
	/* KenWang added 2006/03/23 -- begin -- */
	fscanf(fp, "|%d|%d|%d|%d|%d|%d|\n",
	       &d->VLAN_TAGGING_enable[0],
	       &d->VLAN_TAGGING_enable[1],
	       &d->VLAN_TAGGING_enable[2],
	       &d->VLAN_TAGGING_enable[3],
	       &d->VLAN_TAGGING_enable[4],
	       &d->VLAN_TAGGING_enable[5]);
	/* KenWang added 2006/03/23 -- end -- */
	for(i=0;i<MAX_RULE;i++)
			fscanf(fp,"|%24[^|]|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				&d->Rule[i].VLAN_ID, 
			        // KenWang marked 2006/03/23 &d->Rule[i].LAN_TAGGING_enable, 
				&d->Rule[i].lan_port_enabled[0], 
				&d->Rule[i].lan_port_enabled[1], 
				&d->Rule[i].lan_port_enabled[2], 
				&d->Rule[i].lan_port_enabled[3], 
				&d->Rule[i].lan_port_enabled[4], 
				&d->Rule[i].WAN_connection_index, 
				&d->Rule[i].WAN_TAGGING_enable);	
	fclose(fp);
	return 0;
}

/* KenWang added 2005/12/30 for other wan bridge -- end -- */

void init_ADSLDMT(int argc) // Change execute DMT command sequence : added 091206 begin ---
{
	int ADSLMODE=0;//open annex type and follow DSLAM's setting 
	int ADSLRATE=1;//ADSL1 
	FILE *fp;
	unsigned int Arg;
	unsigned char Arg2;
	int nFd = open( "/dev/dmtdev", O_RDWR );

	if( nFd == -1  )
	{
		printf("severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
	
	fp=fopen(ADSL_CONFIG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d\n",&ADSLMODE,&ADSLRATE);
		fclose(fp);
	}
    //ioctl( nFd, DMTIOCTL_SET_DMTRESET, &Arg );
	switch(ADSLRATE)
	{
		case 0:
			Arg=Multi;
			break;
		case 2:
			Arg=ADSL2;
			break;
		case 3:
			Arg=ADSL2Plus;
			break;
		case 4:
			Arg=GLite;
			break;
		case 5:
			Arg=ANSI;
			break;
		case 6:
			Arg=GDMT;
			break;
		default:
			Arg=ADSL1_MultiMode;
			//brad modify 20050509
			//Arg=GDMT;
	}
	if (argc==0){
		ioctl( nFd, DMTIOCTL_SET_LINE_OPMODE , &Arg );
	
	} else if (argc==1){
		DMTCTRL_DMT_INFO Arg1;
		ioctl( nFd, DMTIOCTL_GET_DMT_INFO , &Arg1 );
		if(Arg1.dmt_status!=ADSL_UP)
			ioctl( nFd, DMTIOCTL_SET_DMTRESET, &Arg );
	}else if(argc==2){
		//set annex 20050509 julian
		char buf1[64];
		char str_annex[64];
		strcpy(str_annex,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"ANNEX=",buf1));
		if(!strncmp(str_annex,"B",1)){
			Arg2=ANNEX_B;
		}else{
			switch(ADSLMODE)
			{
			case 0:
				Arg2=ANNEX_AIJLM;
				break;
			case 2:
				Arg2=ANNEX_L;
				break;
			case 3:
				Arg2=ANNEX_M;
				break;
			case 4:
				Arg2=ANNEX_J;
				break;
			default:
				Arg2=ANNEX_A;
			}
		}
		//do_command("wan","wan","ghs","set","annex",str_annex,NULL);
		ioctl( nFd, DMTIOCTL_SET_ANNEX , &Arg2);
	}
	close(nFd);
}
// Change execute DMT command sequence : added 091206 end ---

void start_specific_function(int specficFuncNum,int isApply,char *parm1) //isApply means not the start for all functions.  is WebGui's "APPLY"
{
	FILE *fp;
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_PPPOE:
		{
		char Auth[2]; 
		char MTU[16]; 
//		char buf[32]; 
		char Idletime[10]; 
		Load_Wan_Config();
		sprintf(Auth,"%d",wan_config.PPPOE_Authentication_Protocol);
		sprintf(MTU,"%d",wan_config.PPPOE_MTU);
		sprintf(Idletime,"%d",wan_config.PPPOE_Idle_Timeout);
		if (wan_config.PPPOE_RELAY){
			run_task("brctl","brctl","addif","br0","nas0",0);
			strcpy(wan_if,"br0");
		}
//		strcpy(str_wan_if,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
		if (wan_config.PPPOE_Connection==0){
			if (strlen(wan_config.PPPOE_Service_Name)>0){
					run_task("pppoecd","pppoecd",wan_if,"-d","-k",
							"-u",wan_config.PPPOE_Username,
							"-p",wan_config.PPPOE_Password,
							"-s",wan_config.PPPOE_Service_Name,
							"-A",Auth,
							"-L",wan_config.PPPOE_IP,
							"-t",MTU,
							"-I","30",
							"-T","30",
							"-N","10"
							,"&",NULL);
			}else{
					run_task("pppoecd","pppoecd",wan_if,"-d","-k",
							"-u",wan_config.PPPOE_Username,
							"-p",wan_config.PPPOE_Password,
							"-A",Auth,
							"-L",wan_config.PPPOE_IP,
							"-t",MTU,
							"-I","30",
							"-T","30",
							"-N","10",
							"&",NULL);		
			}
		}else{
			if (strlen(wan_config.PPPOE_Service_Name)>0){
					run_task("pppoecd","pppoecd",wan_if,"-d","-k",
							"-u",wan_config.PPPOE_Username,
							"-p",wan_config.PPPOE_Password,
							"-s",wan_config.PPPOE_Service_Name,
							"-i",Idletime,
							"-A",Auth,
							"-L",wan_config.PPPOE_IP,
							"-t",MTU,
							"-I","30",
							"-T","30",
							"-N","10",
							"&",NULL);
			}else{
					run_task("pppoecd","pppoecd",wan_if,"-d","-k",
							"-u",wan_config.PPPOE_Username,
							"-p",wan_config.PPPOE_Password,
							"-i",Idletime,
							"-A",Auth,
							"-L",wan_config.PPPOE_IP,
							"-t",MTU,
							"-I","30",
							"-T","30",
							"-N","10",
							"&",NULL);
			}
		}
		}
			break;
#ifdef _RALINK_WIRELESS_DRIVER_	
		case FUNCTION_NUM_WIRELESS:
		{
			char wlan_if[10];
			char str_temp[256];
			Load_Wireless_Config();
			memset(wlan_if,0,sizeof(wlan_if));
			strcpy(wlan_if,"ra0");
			
			/* 
			 *     Ralink 
			 *
			 *     WirelessMode=
			 *     0: B/G mixed
			 *     1: B only
			 *     2: G only
			 *     3: A only
			 */
/* WirelessMode Start */	
			memset(str_temp,0,sizeof(str_temp));
			int wireless_mode=wireless_config.Mode;
			if (wireless_config.Mode==1)
				wireless_mode=2;
			if (wireless_config.Mode==2)
				wireless_mode=1;
			sprintf(str_temp,"%d",wireless_mode);
			execute_ralink_iwpriv("WirelessMode",str_temp);		
/* WirelessMode End */		

/* BasicRate Start */			
			memset(str_temp,0,sizeof(str_temp));
			if (wireless_config.Mode==0)
				sprintf(str_temp,"15");
			else if (wireless_config.Mode==2)
				sprintf(str_temp,"3");
			else if (wireless_config.Mode==1)
				sprintf(str_temp,"351");
			else
				sprintf(str_temp,"15");
			execute_ralink_iwpriv("BasicRate",str_temp);		
/* BasicRate End */			


			
/* HideSSID Start */		
			memset(str_temp,0,sizeof(str_temp));
			sprintf(str_temp, "%d", wireless_config.HideEssid);
			execute_ralink_iwpriv("HideSSID",str_temp);		
/* HideSSID End */		
		
/* CountryRegion Start */		
			/*
			 *  CountryRegion=
			 *  0: 1~11 channel
			 *  1: 1~13 channel
			 *  2: 10, 11 chanel
			 *  3: 10~13 channel
			 *  4: 14 channel
			 *  5: 1~14 channel
			 *  6: 3~9 channel
			 */
			
			memset(str_temp,0,sizeof(str_temp));
			if(wireless_config.RegulationDomain==0)/*N.America*/
				strcpy(str_temp,"0");
			else if(wireless_config.RegulationDomain==1)/*Europe*/
				strcpy(str_temp,"1");
			else if(wireless_config.RegulationDomain==2)/*France*/
				strcpy(str_temp,"3");
			else if(wireless_config.RegulationDomain==3)/*Spain*/
				strcpy(str_temp,"2");
			else if(wireless_config.RegulationDomain==4)/*Japan*/
				strcpy(str_temp,"5");
			else if(wireless_config.RegulationDomain==5)/*Israel*/
				strcpy(str_temp,"0"); /* Not match 5.6.7, we use 0~11 */
			else if(wireless_config.RegulationDomain==6)/*Australia*/
				strcpy(str_temp,"1"); 
			else
				strcpy(str_temp,"5");

			//execute_ralink_iwpriv("CountryRegion",str_temp);		
/* CountryRegion End */		

/* WMM QOS Start */		
                     /*	memset(str_temp,0,sizeof(str_temp));
			sprintf(str_temp,"%d",wireless_config.WMM_QOS_Enable);
		     	execute_ralink_iwpriv("WmmCapable",str_temp); */
/* WMM QOS End */		

/* QMM Power Saving Start */		
		     /*	memset(str_temp,0,sizeof(str_temp));
			sprintf(str_temp,"%d",wireless_config.QMM_Power_Saving_Enable);
		     	execute_ralink_iwpriv("APSDCapable",str_temp); */
/* QMM Power Saving End */

/* SSID Start */		
			execute_ralink_iwpriv("SSID",wireless_config.Essid);
/* SSID End */		

/* CountryCode Start */		
			if(wireless_config.RegulationDomain==0)/*N.America*/
				strcpy(str_temp,"US");
			else if(wireless_config.RegulationDomain==1)/*Europe*/
				strcpy(str_temp,"FI"); /* ISO have no Eurpoe's countrycode, I use FI indicate all of them */
			else if(wireless_config.RegulationDomain==2)/*France*/
				strcpy(str_temp,"FR");
			else if(wireless_config.RegulationDomain==3)/*Spain*/
				strcpy(str_temp,"ES");
			else if(wireless_config.RegulationDomain==4)/*Japan*/
				strcpy(str_temp,"JP");
			else if(wireless_config.RegulationDomain==5)/*Israel*/
				strcpy(str_temp,"IL"); 
			else if(wireless_config.RegulationDomain==6)/*Australia*/
				strcpy(str_temp,"AU"); 
			else
				strcpy(str_temp,"FI");

// Sam marked out 052606.  FOr Markku case, Intel Mini MAC WLAN IOT issue.
			//execute_ralink_iwpriv("CountryCode",str_temp);		
/* CountryCode End */		
			
/* Channel Start */		
			memset(str_temp,0,sizeof(str_temp));
			sprintf(str_temp,"%d",wireless_config.ChannelID);
			execute_ralink_iwpriv("Channel",str_temp);		
/* Channel End */		

/* SSID Start */		
//			execute_ralink_iwpriv("SSID",wireless_config.Essid);		
/* SSID End */		

		}
		break;
#else /* Inprocom */		
		case FUNCTION_NUM_WIRELESS:
		{
			Load_Wireless_Config();
			char wlan_if[10];
			char str_rate[2];
			char str_domain[8];
			char str_channel[4];
			char hidessid[4];
			strcpy(wlan_if,"wlan0");
			sprintf(str_rate,"%d",wireless_config.Mode);
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"ratemode",str_rate,NULL);
			DPRINTF("iwpriv %s ratemode %s\n",wlan_if,str_rate);
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"essid",wireless_config.Essid,NULL);
			DPRINTF("iwpriv %s essid %s\n",wlan_if,wireless_config.Essid);
			// KenWang added 2005/06/14
			sprintf(hidessid, "%d", !wireless_config.HideEssid);
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"broadcastssid",hidessid,NULL);
			DPRINTF("iwpriv %s broadcastssid %s\n",wlan_if,hidessid);
			
			if(wireless_config.RegulationDomain==0)/*N.America*/
				strcpy(str_domain,"0x10");
			else if(wireless_config.RegulationDomain==1)/*Europe*/
				strcpy(str_domain,"0x30");
			else if(wireless_config.RegulationDomain==2)/*France*/
				strcpy(str_domain,"0x32");
			else if(wireless_config.RegulationDomain==3)/*Spain*/
				strcpy(str_domain,"0x31");
			else if(wireless_config.RegulationDomain==4)/*Japan*/
				strcpy(str_domain,"0x40");
			else
				strcpy(str_domain,"0x30");
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"domain",str_domain,NULL);
			DPRINTF("iwpriv %s domain %s\n",wlan_if,str_domain);

			sprintf(str_channel,"%d",wireless_config.ChannelID);
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"channel",str_channel,NULL);
			DPRINTF("iwpriv %s channel %s\n",wlan_if,str_channel);
			run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"nostation","0",NULL);
			DPRINTF("iwpriv %s nostation 0\n",wlan_if);
			char wlan_wds_if[20];
			int wlanwds=0,wlanwds_reboot=0;
			if ((fp = fopen("/var/state/wlanwds.lock", "r")) != NULL) {
				wlanwds++;
				fclose(fp);
			}
			if ((fp = fopen("/var/state/wlanwds.reboot.lock", "r")) != NULL) {
				wlanwds_reboot++;
				fclose(fp);
				unlink("/var/state/wlanwds.reboot.lock");
			}
			if(!wlanwds_reboot){
				strcpy(wlan_wds_if,"wlan0wds0");
				if (wlanwds){
					char delmac[32];	
			
					if ((fp = fopen("/var/state/wlanwds.lock", "r")) != NULL) {
						fscanf(fp,"%s\n",delmac);
						fclose(fp);
					}
			
					run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wdsdelmac",delmac,NULL);
					DPRINTF("iwpriv %s wdsdelmac %s\n",wlan_if,delmac);
					run_task("ifconfig","ifconfig",wlan_wds_if,"down",NULL);
					DPRINTF("ifconfig %s down\n",wlan_wds_if);
					run_task("brctl","brctl","delif","br0",wlan_wds_if,NULL);
					DPRINTF("brctl delif br0 %s\n",wlan_wds_if);
					unlink("/var/state/wlanwds.lock");
				}
				if (wireless_config.Enable){
				if (wireless_config.WDSEnable){
					run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wdsaddmac",wireless_config.WDSMAC,NULL);
					DPRINTF("iwpriv %s wdsaddmac %s\n",wlan_if,wireless_config.WDSMAC);
					run_task("ifconfig","ifconfig",wlan_wds_if,"up",NULL);
					DPRINTF("ifconfig %s up\n",wlan_wds_if);
					run_task("brctl","brctl","addif","br0",wlan_wds_if,NULL);
					DPRINTF("brctl addif br0 %s\n",wlan_wds_if);
					
					if ((fp = fopen("/var/state/wlanwds.lock", "w")) != NULL) {
						fprintf(fp,"%s\n",wireless_config.WDSMAC);
						fclose(fp);
					}
				}
				}
			}
		}
		break;
#endif /* _RALINK_WIRELESS_DRIVER_ */	
#ifdef _RALINK_WIRELESS_DRIVER_	
		case FUNCTION_NUM_WIRELESS_SEC:
		{
			char wlan_if[10];
			char str_temp[256];
			Load_Wireless_Config();
			memset(wlan_if,0,sizeof(wlan_if));
			strcpy(wlan_if,"ra0");
			if (wireless_config.Enable){
				if (strcmp(wireless_config.Sec_Mode,"no")){
					if (!strcmp("WEP",wireless_config.Sec_Mode)){

/* AuthMode Start */						
						if(wireless_config.WEP_Authentication==0) /* open system */
						{
							execute_ralink_iwpriv("AuthMode","OPEN");		
							
						}else if(wireless_config.WEP_Authentication==2){
							execute_ralink_iwpriv("AuthMode","SHARED");		
						}else if(wireless_config.WEP_Authentication==3){
							execute_ralink_iwpriv("AuthMode","WEPAUTO");		
						}
						
/* AuthMode End */				
						
/* EncrypType Start */						
						execute_ralink_iwpriv("EncrypType","WEP");
/* EncrypType End */						
						
/* IEEE8021X Start */						
						execute_ralink_iwpriv("IEEE8021X","0");	
/* IEEE8021X End */
						
if(wireless_config.WEP_Keyid==0){
	
/* Key1 Start*/						
						execute_ralink_iwpriv("Key1",wireless_config.WEP_Key1);
/* Key1 End*/			
						
}else if(wireless_config.WEP_Keyid==1){
						
/* Key2 Start*/						
						execute_ralink_iwpriv("Key2",wireless_config.WEP_Key2);
/* Key2 End*/				
						
}else if(wireless_config.WEP_Keyid==2){
	
/* Key3 Start*/						
						execute_ralink_iwpriv("Key3",wireless_config.WEP_Key3);
/* Key3 End*/					
						
}else if(wireless_config.WEP_Keyid==3){
	
/* Key4 Start*/						
						execute_ralink_iwpriv("Key4",wireless_config.WEP_Key4);
/* Key4 End*/						
}		
						
/* DefaultKeyID Start*/				
						memset(str_temp,0,sizeof(str_temp));			
						sprintf(str_temp,"%d",wireless_config.WEP_Keyid+1);
						execute_ralink_iwpriv("DefaultKeyID",str_temp);
/* DefaultKeyID End*/						
					}
					else if (!strcmp("WPA",wireless_config.Sec_Mode))
					{
/* AuthMode Start */						
						execute_ralink_iwpriv("AuthMode","WPAPSK");
/* AuthMode End */						
						
/* EncrypType Start */						
						execute_ralink_iwpriv("EncrypType",wireless_config.WPA_Algorithm);
/* EncrypType End */						
						
/* IEEE8021X Start */						
						execute_ralink_iwpriv("IEEE8021X","0");	
/* IEEE8021X End */

/* SSID Start */		
						execute_ralink_iwpriv("SSID",wireless_config.Essid);
/* SSID End */	

/* WPAPSK Start */						
						execute_ralink_iwpriv("WPAPSK",wireless_config.WPA_Shared_Key);
/* WPAPSK End */					
sleep(3);
/* DefaultKeyID Start*/				
						execute_ralink_iwpriv("DefaultKeyID","2");
/* DefaultKeyID End*/						
					
/*  RekeyInterval Start */						
						memset(str_temp,0,sizeof(str_temp));			
						sprintf(str_temp,"%d",wireless_config.WPA_Group_Key_Renewal);
						execute_ralink_iwpriv("RekeyInterval",str_temp);
/*  RekeyInterval End */

/*  RekeyMethod Start */						
						execute_ralink_iwpriv("RekeyMethod","TIME");
/*  RekeyMethod End */						
						
						
					}
					else if (!strcmp("WPA2",wireless_config.Sec_Mode))
					{
/* AuthMode Start */						
						execute_ralink_iwpriv("AuthMode","WPA2PSK");
/* AuthMode End */						
						
/* EncrypType Start */						
						execute_ralink_iwpriv("EncrypType",wireless_config.WPA2_Algorithm);
/* EncrypType End */						
						
/* IEEE8021X Start */						
						execute_ralink_iwpriv("IEEE8021X","0");	
/* IEEE8021X End */

/* SSID Start */		
						execute_ralink_iwpriv("SSID",wireless_config.Essid);
/* SSID End */	

/* WPAPSK Start */						
						execute_ralink_iwpriv("WPAPSK",wireless_config.WPA2_Shared_Key);
/* WPAPSK End */					

/* DefaultKeyID Start*/				
						execute_ralink_iwpriv("DefaultKeyID","2");
/* DefaultKeyID End*/						
					
/*  RekeyInterval Start */						
						memset(str_temp,0,sizeof(str_temp));			
						sprintf(str_temp,"%d",wireless_config.WPA2_Group_Key_Renewal);
						execute_ralink_iwpriv("RekeyInterval",str_temp);
/*  RekeyInterval End */

/*  RekeyMethod Start */						
						execute_ralink_iwpriv("RekeyMethod","TIME");
/*  RekeyMethod End */						
						
						
					}

				}
				else{ /* Open */
/* AuthMode Start */						
					execute_ralink_iwpriv("AuthMode","OPEN");
/* AuthMode End */						
						
/* EncrypType Start */						
					execute_ralink_iwpriv("EncrypType","NONE");
/* EncrypType End */						

/* IEEE8021X Start */						
					execute_ralink_iwpriv("IEEE8021X","0");	
/* IEEE8021X End */
				}

/* SSID Start */		
			execute_ralink_iwpriv("SSID",wireless_config.Essid);
/* SSID End */		

/* WDS Start */	
			
			execute_ralink_iwpriv("WdsEnable","0");		//Disable all wds
	
			Del_WDSMAC(1);
			Del_WDSMAC(2);
			Del_WDSMAC(3);
			Del_WDSMAC(4);

/* WdsEncrypType Start */						
			execute_ralink_iwpriv("WdsEncrypType","NONE");
/* WdsEncrypType End */					
			
			if (wireless_config.WDSEnable){
				if (strncmp(wireless_config.WDSMAC1,"&",1)){
					Add_WDSMAC(1,wireless_config.WDSMAC1);
				}
				if (strncmp(wireless_config.WDSMAC2,"&",1)){
					Add_WDSMAC(2,wireless_config.WDSMAC2);
				}
				if (strncmp(wireless_config.WDSMAC3,"&",1)){
					Add_WDSMAC(3,wireless_config.WDSMAC3);
				}
				if (strncmp(wireless_config.WDSMAC4,"&",1)){
					Add_WDSMAC(4,wireless_config.WDSMAC4);
				}
			}
/* WDS End */	
/* WDS Security Start */
			if (wireless_config.WDSEnable){
			if (strcmp(wireless_config.Sec_Mode,"no")){
				if (!strcmp("WEP",wireless_config.Sec_Mode)){
/* WdsEncrypType Start */						
					execute_ralink_iwpriv("WdsEncrypType","WEP");
/* WdsEncrypType End */						
				}else if (!strcmp("WPA",wireless_config.Sec_Mode)){
					if (!strcmp(wireless_config.WPA_Algorithm,"AES")){
/* WdsEncrypType Start */						
						execute_ralink_iwpriv("WdsEncrypType","AES");
/* WdsEncrypType End */						
						
					}else if (!strcmp(wireless_config.WPA_Algorithm,"TKIP")){
/* WdsEncrypType Start */						
						execute_ralink_iwpriv("WdsEncrypType","TKIP");
/* WdsEncrypType End */						
					}
/* WdsKey Start */
						execute_ralink_iwpriv("WdsKey",wireless_config.WPA_Shared_Key);
/* WdsKey End */						
				}else if (!strcmp("WPA2",wireless_config.Sec_Mode)){
					if (!strcmp(wireless_config.WPA2_Algorithm,"AES")){
/* WdsEncrypType Start */						
						execute_ralink_iwpriv("WdsEncrypType","AES");
/* WdsEncrypType End */						
						
					}else if (!strcmp(wireless_config.WPA2_Algorithm,"TKIP")){
/* WdsEncrypType Start */						
						execute_ralink_iwpriv("WdsEncrypType","TKIP");
/* WdsEncrypType End */				
						
					}
/* WdsKey Start */
						execute_ralink_iwpriv("WdsKey",wireless_config.WPA2_Shared_Key);
/* WdsKey End */						
				}
			}else{
/* WdsEncrypType Start */						
				execute_ralink_iwpriv("WdsEncrypType","NONE");
/* WdsEncrypType End */					
			}

			}
/* WDS Security End */

		       }
		}
		break;
#else /* Inprocom */
		case FUNCTION_NUM_WIRELESS_SEC:
		{
			Load_Wireless_Config();
			char str_encryption[2];
			char str_defkey[2];
			char str_hideessid[2];
			char wlan_wds_if[20];
			char wlan_if[20];
			char str_authentication[2]; // KenWang added 2005/06/14
			strcpy(wlan_wds_if,"wlan0wds0");
			strcpy(wlan_if,"wlan0");
			if (wireless_config.Enable){
				if (strcmp(wireless_config.Sec_Mode,"no")){
					if (!strcmp("WEP",wireless_config.Sec_Mode)){
						// KenWang modified 2005/06/14
						sprintf(str_authentication, "%d", wireless_config.WEP_Authentication);
						//run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"authmode","3",NULL);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"authmode", str_authentication,NULL);
			DPRINTF("iwpriv %s authmode 3\n",wlan_if);
						sprintf(str_encryption,"%d",wireless_config.WEP_Encryption);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"cipher",str_encryption,NULL);
			DPRINTF("iwpriv %s cipher %s\n",wlan_if,str_encryption);
			
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkeyid","0",NULL);
			DPRINTF("iwpriv %s wepkeyid 0\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkey",wireless_config.WEP_Key1,NULL);
			DPRINTF("iwpriv %s wepkey %s\n",wlan_if,wireless_config.WEP_Key1);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkeyid","1",NULL);
			DPRINTF("iwpriv %s wepkeyid 1\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkey",wireless_config.WEP_Key2,NULL);
			DPRINTF("iwpriv %s wepkey %s\n",wlan_if,wireless_config.WEP_Key2);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkeyid","2",NULL);
			DPRINTF("iwpriv %s wepkeyid 2\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkey",wireless_config.WEP_Key3,NULL);
			DPRINTF("iwpriv %s wepkey %s\n",wlan_if,wireless_config.WEP_Key3);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkeyid","3",NULL);
			DPRINTF("iwpriv %s wepkeyid 3\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"wepkey",wireless_config.WEP_Key4,NULL);
			DPRINTF("iwpriv %s wepkey %s\n",wlan_if,wireless_config.WEP_Key4);


						sprintf(str_defkey,"%d",wireless_config.WEP_Keyid);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"defwepkeyid",str_defkey,NULL);
			DPRINTF("iwpriv %s defwepkeyid %s\n",wlan_if,str_defkey);
						if (wireless_config.WDSEnable){
							run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_wds_if,"wdscipher","1",NULL);
			DPRINTF("iwpriv %s wdscipher 1\n",wlan_wds_if);
							//wdskey the same with WEP_Key1 
							run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_wds_if,"wdskey",wireless_config.WEP_Key1,NULL);
			DPRINTF("iwpriv %s wdskey %s\n",wlan_wds_if,wireless_config.WEP_Key1);
						}
						// KenWang marked 2005/06/14
						//sprintf(str_hideessid,"%d",wireless_config.WEP_Hide_Essid);
						//run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"broadcastssid",str_hideessid,NULL);
			DPRINTF("iwpriv %s broadcastssid %s\n",wlan_if,str_hideessid);
					}
					else/* if (!strcmp("WPA",wireless_config.Sec_Mode))*/
					{
						char str_wpa_period[10];
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"authmode","5",NULL);
			DPRINTF("iwpriv %s authmode 5\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"cipher","2",NULL);
			DPRINTF("iwpriv %s cipher 2\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"passphrase",wireless_config.WPA_Shared_Key,NULL);
			DPRINTF("iwpriv %s passphrase %s\n",wlan_if,wireless_config.WPA_Shared_Key);
						sprintf(str_wpa_period,"%d",wireless_config.WPA_Group_Key_Renewal);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"gkrekeyperiod",str_wpa_period,NULL);
			DPRINTF("iwpriv %s gkrekeyperiod %s\n",wlan_if,str_wpa_period);
						// KenWang markded 2005/06/14
						//sprintf(str_hideessid,"%d",wireless_config.WPA_Hide_Essid);
						//run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"broadcastssid",str_hideessid,NULL);
			DPRINTF("iwpriv %s broadcastssid %s\n",wlan_if,str_hideessid);
					}
				}
				else{
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"authmode","0",NULL);
			DPRINTF("iwpriv %s authmode 0\n",wlan_if);
						run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"cipher","0",NULL);
			DPRINTF("iwpriv %s cipher 0\n",wlan_if);
						if (wireless_config.WDSEnable){
							
							run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_wds_if,"wdscipher","0",NULL);
			DPRINTF("iwpriv %s wdscipher 0\n",wlan_wds_if);
						}
						// KenWang marked 2005/06/14
						//run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv",wlan_if,"broadcastssid","1",NULL);
			DPRINTF("iwpriv %s broadcastssid 1\n",wlan_if);
				}
//				return 1;// indicate it is enabled.
		       }
		}
		break;

#endif /* _RALINK_WIRELESS_DRIVER_ */		
		
		case FUNCTION_NUM_ADSL:
	    /* Change execute DMT command sequence : marked 091206 begin ---
	       if((fp = fopen(ADSL_CONFIG_FILE, "r"))){
		       FILE *out;
			       	int adslmode=0;//open annex type and follow DSLAM's setting
			       	int adslrate=1;//adsl 1
					unsigned int Arg;
					unsigned char Arg1;
				int nFd = open( "/dev/dmtdev", O_RDWR );
				int iptv=0;
	
    			if( nFd == -1  )
				{
					printf("severe error for open /dev/dmtdev for ADSL device\n");
					break;
				}
				fscanf(fp,"%d %d\n",&adslmode,&adslrate);
				fclose(fp);
				switch(adslrate)
				{
					case 0:
					Arg=Multi;
					break;
					case 2:
					Arg=ADSL2;
					break;
					case 3:
					Arg=ADSL2Plus;
					break;
					case 4:
					Arg=GLite;
					break;
					case 5:
					Arg=ANSI;
					break;
					case 6:
					Arg=GDMT;
					break;
					default:
					Arg=ADSL1_MultiMode;
					//Arg=GDMT;
				}
				ioctl( nFd, DMTIOCTL_SET_LINE_OPMODE , &Arg );
				ioctl( nFd, DMTIOCTL_SET_DMTRESET, &Arg );
						
				char buf1[64];
				char str_annex[64];
				strcpy(str_annex,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"ANNEX=",buf1));
				DPRINTF("str_annex:%s\n",str_annex);	
				if(!strncmp(str_annex,"B",1)){
					Arg1=ANNEX_B;
				}else{
					switch(adslmode)
					{
						case 0:
							Arg1=ANNEX_AIJLM;
							break;
						case 2:
							Arg1=ANNEX_L;
							break;
						case 3:
							Arg1=ANNEX_M;
							break;
						case 4:
							Arg1=ANNEX_J;
							break;
						default:
							Arg1=ANNEX_A;
					}
				}
				DPRINTF("Arg1:%d\n",Arg1);	
				ioctl( nFd, DMTIOCTL_SET_ANNEX , &Arg1 ); 
			     // Change execute DMT command sequence : marked end */
			     // Change execute DMT command sequence : added 091206 begin ---
			     	init_ADSLDMT(1); //dmt reset
				init_ADSLDMT(0); //set dmt mode 
				init_ADSLDMT(1); //dmt reset
				init_ADSLDMT(2); //set dmt annex 
			     // Change execute DMT command sequence : added 091206 end ---
				
				// albert 2005.06.20 after dmt 3.3.0.6
				//run_task("w","w", "ghs", "set","std", "adsl2plus_multi_ansioff", NULL);
				//run_task("w","w", "hwdmt", "afe", "set", "ecpause", "4000", NULL);
				// albert 2005.07.11
				// wan tcif set olswitch off
				// wan hwdmt afe ec off
				// w ghs set nakefpause 7000
				run_task("w","w", "tcif", "set", "olswitch", "off", NULL);

// Set Noise Margin for IPTV application will follow DSLAM settings.
			     // Change execute DMT command sequence added 091206 begin ---
		    		char str_annex[64];
		    		char buf1[64];
				FILE *out;
				int iptv=0;
			     // Change execute DMT command sequence added end ---
				strcpy(str_annex,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"ANNEX=",buf1));
				if(!strncmp(str_annex,"B",1))
				{// AS from TC/david suggestion, for Annex B ComLab, it is better to use the noise Margin setting follow the DLSAM setting.
				}
				else
				{
				out=fopen("/flash/iptv.conf","r");
					if(out) 
					{// 0: -512 for Markku, 1:IPTV for Markku, 2:Max line rate for Markku.  3. Other customers.
					fscanf(out,"%d\n",&iptv);
					if(iptv==0)
					{// set snrmoffset to -512 , -512 for normal user.  For IPTV user. it will depend on DSLAM
						run_task("w","w", "dmt2", "set", "snrmoffset", "-512", "-512", NULL);
					} else if(iptv==2) // set to 768 for max line rate.
						run_task("w","w", "dmt2", "set", "snrmoffset", "768", "0", NULL);
					fclose(out);
				}
				}
				run_task("w","w", "dmt2", "set", "snrmcnt", "1", NULL);
				if(strncmp(str_annex,"B",1))
				{
					run_task("w","w", "hwdmt", "afe", "ec", "off", NULL);// david request to remove this form 7300GB for DMT 3.5.10.6 and 3.5.18.0
				}
				//run_task("w","w", "ghs", "set", "nakefpause", "7000", NULL);
	
				// OK, for Annex B,COMLAB, the testing last shall be 1.
				if(!strncmp(str_annex,"B",1))
				{
#ifdef _ANNEX_UR2_
					run_task("w","w", "dmt2", "db", "tlb", "6", NULL); // Camiu added 2006/06/09 for German PPG UR2	
#else
					run_task("w","w", "dmt", "db", "tlb", "1", NULL);// For Annex B, the dmt or dmt2 setting for tlb 1 is the same command as from TC/david.
#endif
				}
				else
				{
					if(iptv<3)// only for Markku
						run_task("w","w", "dmt2", "db", "tlb", "15", NULL);
					else if(iptv==3)// test lab 18 for Australlian Ericsson(Quentin)
						run_task("w","w", "dmt2", "db", "tlb", "18", NULL);
					//run_task("w","w", "dmt2", "set", "updatesync", "on",NULL);// it has been written it in source code. For DMT 3.5.12.2
				} 
				// end - markku

				//return 1;// indicate it is enabled.
		 // } Change execute DMT command sequence : marked 091206
		break;
		case FUNCTION_NUM_TIME_ZONE:
		if(start_specific_task(FUNCTION_NUM_TIME_ZONE))
		{
			fp = fopen("/var/state/ntpd.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_DDNS:
		if(start_specific_task(FUNCTION_NUM_DDNS))
		{
			fp = fopen("/var/state/ddns.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;		
		case FUNCTION_NUM_STATIC_ROUTE_LAN:
		if(start_specific_task(FUNCTION_NUM_STATIC_ROUTE_LAN))
		{
			fp = fopen("/var/state/route_lan.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_STATIC_ROUTE_WAN:
		if(start_specific_task(FUNCTION_NUM_STATIC_ROUTE_WAN))
		{
			fp = fopen("/var/state/route_wan.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_BLOCK_HACK:
		if(start_specific_task(FUNCTION_NUM_BLOCK_HACK))
		{
			fp = fopen("/var/state/blk_hack.lock", "w");//touch
			if(fp)
				fclose(fp);
			//We start all iptables here--instead of the specific ones.
			if(isApply)
			{
			clean_all();
			firewall_start_all_functions();
			//	firewall_clean_all_iptables();
			//	firewall_start_all_iptables();//Change for enabled parameters will restart the whole firewall.
			}
			else
			{
				start_specific_iptables(FUNCTION_NUM_BLOCK_HACK);
			}
		}
		break;
		case FUNCTION_NUM_ALERT_MAIL_ONLY:
		if(start_specific_task(FUNCTION_NUM_ALERT_MAIL_ONLY))
		{
			fp = fopen("/var/state/alertmail.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_BLOCK_WAN:
		if(start_specific_iptables(FUNCTION_NUM_BLOCK_WAN))
		{
			fp = fopen("/var/state/blk_wan.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_URL_FILTER:
		if(start_specific_iptables(FUNCTION_NUM_URL_FILTER)) 
		{
			fp = fopen("/var/state/url_flt.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_MAC_FILTER:
		if(start_specific_iptables(FUNCTION_NUM_MAC_FILTER))
		{
			DPRINTF("robert inside mac filter\n");
			fp = fopen("/var/state/mac_flt.lock", "w");//touch
			if(fp)
				fclose(fp);
			/* KenWang added 2005/06/27 -- begin -- */
			/* notify factoryreset to update iptables for wireless clients */
			int facpid = 0;
			if((fp = fopen("/var/state/factoryreset.pid", "r")) != NULL)
			{
				fscanf(fp, "%d", &facpid);
				kill(facpid, SIGUSR2);
				fclose(fp);
			}
			/* KenWang added 2005/06/27 -- end -- */
		}
		break;
		case FUNCTION_NUM_REMOTE_CONFIG:
		if(start_specific_iptables(FUNCTION_NUM_REMOTE_CONFIG))
		{
			fp = fopen("/var/state/remote_config.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_EMBEDED_WEB_SERVER:
		// strat the webs server
		start_specific_task(FUNCTION_NUM_EMBEDED_WEB_SERVER);
		break;
		case FUNCTION_NUM_TELNET_CONFIG:
			start_specific_task(FUNCTION_NUM_TELNET_CONFIG);
			run_script("/etc/scripts/telnetd.sh",0,0,0);
			fp = fopen("/var/state/telnet_config.lock", "w");//touch
			if(fp)
				fclose(fp);
		break;

		case FUNCTION_NUM_UPNP:
		{
			int hasInstalled=1;
			
			/* Julian add prevent upnp non-start when rcS 20050426 */
			fp = fopen("/var/state/upnp.lock", "r");
			if(fp){
				fclose(fp);
			}
			else
				isApply=1;
			// Since UPnP will not removed when the configuration changes( Only if disable/enable)
			// Here we will only start the UPnP task, when rcS and apply.
			// For firewall, we will only start the script and ask the UPnP task to reload the configuration here.
			if(isApply)
				hasInstalled=start_specific_task(FUNCTION_NUM_UPNP);
			else
				reload_config_specific_task(FUNCTION_NUM_UPNP);

			start_specific_iptables(FUNCTION_NUM_UPNP); 
			if(hasInstalled)
			{
				fp = fopen("/var/state/upnp.lock", "w");//touch
				if(fp)
					fclose(fp);
			}
		}
		break;
		case FUNCTION_NUM_RIP:
		{
			int hasInstalled=start_specific_task(FUNCTION_NUM_RIP);
			start_specific_iptables(FUNCTION_NUM_RIP); 
			if(hasInstalled)
			{
				fp = fopen("/var/state/rip.lock", "w");//touch
				if(fp)
					fclose(fp);
			}
		}
		break;
		case FUNCTION_NUM_SNMP:
		{
			int hasInstalled=start_specific_task(FUNCTION_NUM_SNMP);
			start_specific_iptables(FUNCTION_NUM_SNMP);
			if(hasInstalled)
			{
				fp = fopen("/var/state/snmpd.lock", "w");//touch
				if(fp)
					fclose(fp);
			}
		}
		break;
		case FUNCTION_NUM_VIRTUAL_SERVER_DMZ:
		{
		int haveAdded=0;
		if(isApply)
		{
			clean_all();
			firewall_start_all_functions();
			//firewall_clean_all_iptables();
			//firewall_start_all_iptables();//Change for enabled parameters will restart the whole firewall.
		}
		else
		{
			start_specific_iptables(FUNCTION_NUM_VIRTUAL_SERVER_DMZ);
		}
		haveAdded=0;
		if((fp = fopen(VIRTUAL_SERVER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
		{
			fclose(fp);
			haveAdded=1;
		}
		if((fp = fopen(DMZ_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
		{
			fclose(fp);
			haveAdded=1;
		}
		if(haveAdded)
		{
			fp = fopen("/var/state/vs_dmz.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		}
		break;
		case FUNCTION_NUM_PACKET_FILTER:
//		fp = fopen("/var/state/pf.lock", "w");//touch
//		if(fp)
//			fclose(fp);
		//start_specific_iptables(FUNCTION_NUM_VIRTUAL_SERVER_DMZ); 
		//Yes, that simpler.
		if(isApply)
		{
			clean_all();
			firewall_start_all_functions();
			//firewall_clean_all_iptables();
			//firewall_start_all_iptables();//Change for enabled parameters will restart the whole firewall.
		}
		else
		{
			start_specific_iptables(FUNCTION_NUM_PACKET_FILTER);
		}
		if((fp = fopen(PACKET_FILTER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
		{
			fclose(fp);
			fp = fopen("/var/state/pf.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_QOS:
		{
			RunFunc_QOS_Start();
			int hasInstalled=start_specific_task(FUNCTION_NUM_QOS);
			start_specific_iptables(FUNCTION_NUM_QOS); 
			if(hasInstalled)
			{
				fp = fopen("/var/state/qos.lock", "w");//touch
				if(fp)
					fclose(fp);
			}
		}
		break;
		case FUNCTION_NUM_SIP_PROXY:
		if( !strcmp(router, "nat") )
		{//if [ "$ROUTER" = "nat" ] ;
			if(start_specific_iptables(FUNCTION_NUM_SIP_PROXY))
			{
				fp = fopen("/var/state/sip_proxy.lock", "w");//touch
				if(fp)
					fclose(fp);
			}
		}
		break;
		case FUNCTION_NUM_CLOSE_WAN_PORT:
		if(start_specific_iptables(FUNCTION_NUM_CLOSE_WAN_PORT))
		{
			fp = fopen("/var/state/close_wan_port.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_IGMP_PROXY:
			start_specific_task(FUNCTION_NUM_IGMP_PROXY);
		break;
		case FUNCTION_NUM_IGMP_SNOOPING:
			start_specific_task(FUNCTION_NUM_IGMP_SNOOPING);
		break;
#ifdef _INCLUDE_IPSEC_
		case FUNCTION_NUM_IPSEC_START:
		//NOTE !!! For Apply, it is only  valid when there is no acitive rules and changed to, at least, one active rules.
		RunFunc_IPSec_Start();
		break;
#endif	
		case FUNCTION_NUM_WIRELESS_MAC_FILTER:
		if(start_specific_task(FUNCTION_NUM_WIRELESS_MAC_FILTER))
		{
			fp = fopen("/var/state/wireless_mf.lock", "w");
			if(fp)
				fclose(fp);
		}
		break;
		case FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT:
		if(start_specific_task(FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT))
		{
			fp = fopen("/var/state/wipca.lock", "w");//touch
			if(fp)
				fclose(fp);
		}
		break;
		/* KenWang added 2005/11/21: set port mode -- begin -- */
		case FUNCTION_NUM_PORT_CTRL:
		{
			unsigned int value = 0;
			value = load_port_ctrl_conf();
			if(set_port_mode(&value)) {
				fp = fopen("/var/state/port_ctrl.lock", "w"); //touch
				if(fp)
					fclose(fp);
			}
			break;
		}
		/* KenWang added 2005/11/21: set port mode -- end -- */
		/* KenWang added 2005/12/23 for other wan bridge -- begin -- */
	        case FUNCTION_NUM_OTHER_WAN_BRIDGE:
		{
			char line[128];
			int i, hasAdded = 0;
			OTHER_WAN_BRIDGE_DATA wanbr;
			//char *atm_qos[] = {"abr", "cbr", "vbr", "vbr-nrt", "ubr"};
			char *pNasNo, *pPvc, *pEnc, *pNas;

			pNasNo = line + 10;
			pPvc = pNasNo + 10;
			pEnc = pPvc + 10;
			pNas = pEnc + 10;

			Load_Other_Wan_Bridge_Config(&wanbr);

			/* create bridges, ATM QOS is NOT considered now */
			for(i=0; i<wanbr.wan_bridge_no; i++) {
				/* if bridge number is specified, start it only */
				/* KenWang modified 2006/01/26 */
				//if(strcmp(parm1, "")) {
				if(parm1 != NULL) {
					if(*parm1 == 'o') {
						if(i+2 != atoi(parm1+1))
							continue;
					}
					else if(*parm1 == 'u') {
						if(i+2 < atoi(parm1+1))
							continue;
					}
					else
						continue;
				}

				/* if main wan is not bridge and has other bridge use same pvc, we create brwan */
				/* if main wan is bridge we use br0 then */
				if(wanbr.usingSamePVCFromExistingWanConnection[i] == 1) {
					if(strcmp(wan, "bridge")!=0) {
						run_task("brctl", "brctl", "addbr", "brwan", NULL);
						run_task("brctl", "brctl", "setfd", "brwan", "0", NULL);
						run_task("brctl", "brctl", "stp", "brwan", "off", NULL);
						/* KenWang modified 2006/01/26 */
						if(strncmp(wan_if, "br", 2) != 0)
							run_task("brctl", "brctl", "addif", "brwan", wan_if, NULL);
						run_task("ifconfig", "ifconfig", "brwan", "up", NULL);
						hasAdded = 1;
					}
				}
				else {
					sprintf(line, "br%d", i+2); // WAN_connection_index starts from 2 (0:disabled, 1:main wan)
					sprintf(pNasNo, "%d", i+2);
					sprintf(pPvc, "0.%d.%d", wanbr.Bridged_VPI[i], wanbr.Bridged_VCI[i]);
					sprintf(pEnc, "%d", wanbr.Bridged_Encapsulation_Method[i]);
					run_task(line, line, "-c", pNasNo, "-e", pEnc, "-a", pPvc, "&", NULL);
					fprintf(stderr, "%s -c %s -e %s -a %s\n", line, pNasNo, pEnc, pPvc);
					/* atm qos */
					/* run_task("sarchangeqos", "sarchangeqos", ... ); */
					sleep(2);
					sprintf(pNas, "nas%d", i+2);
					run_task("ifconfig", "ifconfig", pNas, "up", NULL);
					run_task("brctl", "brctl", "addbr", line, NULL);
					run_task("brctl", "brctl", "setfd", line, "0", NULL);
					run_task("brctl", "brctl", "stp", line, "off", NULL);
					run_task("brctl", "brctl", "addif", line, pNas, NULL);
					run_task("ifconfig", "ifconfig", line, "up", NULL);
					hasAdded = 1;
				}
			}
			if(hasAdded) {
				fp = fopen("/var/state/other_wanbr.lock", "w");
				fclose(fp);
			}
		}
		break;
		/* KenWang added 2005/12/23 for other wan bridge -- end -- */
		/* KenWang added 2005/12/23 for vlan -- begin -- */
	        case FUNCTION_NUM_VLAN:
		{
			char line[512], vlan_if[32], wlan_if[32], v_wan_if[32];
			int ruleNum = 0, i = 0, wireless;
			char *pVlanMask, *pTagMask, *pVid0, *pVid1, *pVid2, *pVid3, *pVid4, *pVid5, *pVid6, *pVid7, *pWireless;
			unsigned short tag_mask;
			unsigned int vlan_mask;
			OTHER_WAN_BRIDGE_DATA wanbr;

#if 0
			unsigned char BaseMac[20], mac[3][20], *pMac1, *pMac2;
			unsigned int Mac1=0,Mac2=0;

			//GetValue("ETH0_MAC", BaseMac);
			read_file_para_value(VAR_SYS_STATUS_FILE, "ETH0_MAC=", BaseMac);
			
			pMac1 = (unsigned char *)&Mac1; 
			pMac2 = (unsigned char *)&Mac2;

			sscanf(BaseMac, "%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx",
			       pMac1+1, pMac1+2, pMac1+3, pMac2+1, pMac2+2, pMac2+3);

			Mac2++;
			for(i=0;i<3;i++) {
				Mac2++;
				sprintf(mac[i], "%02x:%02x:%02x:%02x:%02x:%02x",
					*(pMac1+1), *(pMac1+2), *(pMac1+3), 
					*(pMac2+1), *(pMac2+2), *(pMac2+3));
				printf("mac[%d]=%s\n", i, mac[i]);
			}
#endif
			
			VLAN_CONFIG_DATA vlan_group;

			pVlanMask = line;
			pTagMask = pVlanMask + 10;
			pVid0 = pTagMask + 10;
			pVid1 = pVid0 + 10;
			pVid2 = pVid1 + 10;
			pVid3 = pVid2 + 10;
			pVid4 = pVid3 + 10;
			pVid5 = pVid4 + 10;
			pVid6 = pVid5 + 10;
			pVid7 = pVid6 + 10;
			pWireless = pVid7 + 10;
			
			read_file_para_value("/flash/config", "WIRELESS=", pWireless);
			read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if);

			fp = fopen(VLAN_CONFIG_FILE, "r");
			if(fp) {
				/* KenWang added 2006/03/23 -- begin -- */
				fscanf(fp, "|%d|%d|%d|%d|%d|%d|\n",
				       &vlan_group.VLAN_TAGGING_enable[0],
				       &vlan_group.VLAN_TAGGING_enable[1],
				       &vlan_group.VLAN_TAGGING_enable[2],
				       &vlan_group.VLAN_TAGGING_enable[3],
				       &vlan_group.VLAN_TAGGING_enable[4],
				       &vlan_group.VLAN_TAGGING_enable[5]);
				/* KenWang added 2006/03/23 -- end -- */
				while(fgets(line, 512, fp)) {
					i = sscanf(line, "|%24[^|]|%d|%d|%d|%d|%d|%d|%d|%d|\n",
						   vlan_group.Rule[ruleNum].Name,
						   &vlan_group.Rule[ruleNum].VLAN_ID,
						   // KenWang markded 2006/03/23 &vlan_group.Rule[ruleNum].LAN_TAGGING_enable,
						   &vlan_group.Rule[ruleNum].lan_port_enabled[0],
						   &vlan_group.Rule[ruleNum].lan_port_enabled[1],
						   &vlan_group.Rule[ruleNum].lan_port_enabled[2],
						   &vlan_group.Rule[ruleNum].lan_port_enabled[3],
						   &vlan_group.Rule[ruleNum].lan_port_enabled[4],
						   &vlan_group.Rule[ruleNum].WAN_connection_index,
						   &vlan_group.Rule[ruleNum].WAN_TAGGING_enable);

					if(i == 9) { 
#if 0 /* WLAN tag */
						/* add vlan interface for wlan */
						if(vlan_group.Rule[ruleNum].lan_port_enabled[4]) {
#ifdef _RALINK_WIRELESS_DRIVER_
							if(vlan_group.Rule[ruleNum].LAN_TAGGING_enable) {
								sprintf(line, "%d", vlan_group.Rule[ruleNum].VLAN_ID);
								execute_ralink_iwpriv(VLANID, line);
							}
#endif /* _RALINK_WIRELESS_DRIVER_ */
							sprintf(line, "%d", vlan_group.Rule[ruleNum].VLAN_ID);
							fprintf(stderr, "vconfig add %s %s\n", wlan_if, line);
							run_task("vconfig", "vconfig", "add", wlan_if, line, NULL);
							sprintf(line, "%s.%d", wlan_if, vlan_group.Rule[ruleNum].VLAN_ID);
							fprintf(stderr, "ifconfig %s up\n", line);
							run_task("ifconfig", "ifconfig", line, "up", NULL);
							i = 1;
						}
#endif /* if 0 */
						if(vlan_group.Rule[ruleNum].lan_port_enabled[0] ||
						       vlan_group.Rule[ruleNum].lan_port_enabled[1] ||
						       vlan_group.Rule[ruleNum].lan_port_enabled[2] ||
						   vlan_group.Rule[ruleNum].lan_port_enabled[3]) 
						ruleNum++;
					}
				}
				fclose(fp);

				if(ruleNum == 0) {
					/* only wlan is enabled */
					if(i) {
						fp = fopen("/var/state/vlan.lock", "w");
						if(fp)
							fclose(fp);
					}
					//stop_specific_function(FUNCTION_NUM_VLAN, 0, NULL);
					return;
				}
			}
			else
				return;

			fprintf(stderr, "ruleNum: %d\n", ruleNum);

			/* port ordering is different between 7202 and 7202G */
			if(strcmp(pWireless, "yes") == 0)
				wireless = 1;
			else
				wireless = 0;

			vlan_mask = 0;
			/* only consider 8 active rules most now */
			for(i=0; i<ruleNum && ruleNum<=8; i++) {
				/* vlan mask */
				if(vlan_group.Rule[i].lan_port_enabled[0])
					vlan_mask |= (wireless ? 8 : 1)<<(i*4);
				if(vlan_group.Rule[i].lan_port_enabled[1])
					vlan_mask |= (wireless ? 4 : 2)<<(i*4);
				if(vlan_group.Rule[i].lan_port_enabled[2])
					vlan_mask |= (wireless ? 2 : 4)<<(i*4);
				if(vlan_group.Rule[i].lan_port_enabled[3])
					vlan_mask |= (wireless ? 1 : 8)<<(i*4);
#if 0
				/* tag mask */
				if(vlan_group.Rule[i].LAN_TAGGING_enable) {
					if(vlan_group.Rule[i].lan_port_enabled[0])
						tag_mask |= wireless ? 8 : 1;
					if(vlan_group.Rule[i].lan_port_enabled[1])
						tag_mask |= wireless ? 4 : 2;
					if(vlan_group.Rule[i].lan_port_enabled[2])
						tag_mask |= wireless ? 2 : 4;
					if(vlan_group.Rule[i].lan_port_enabled[3])
						tag_mask |= wireless ? 1 : 8;
#endif
				}
			tag_mask = 0x07c2;
			if(vlan_group.VLAN_TAGGING_enable[0])
				tag_mask |= (wireless ? 0x4200 : 0x0840) & 0xffff;
			if(vlan_group.VLAN_TAGGING_enable[1])
				tag_mask |= (wireless ? 0x2100 : 0x1080) & 0xffff;
			if(vlan_group.VLAN_TAGGING_enable[2])
				tag_mask |= (wireless ? 0x1080 : 0x2100) & 0xffff;
			if(vlan_group.VLAN_TAGGING_enable[3])
				tag_mask |= (wireless ? 0x0840 : 0x4200) & 0xffff;

			DPRINTF("vlan_mask: %x\ntag_mask: %x\n", vlan_mask, tag_mask);

			/* ioctl to kernel to set ICPLUS175C vlan function */
			sprintf(pVlanMask, "%u", vlan_mask);
			sprintf(pTagMask, "%u", (int)tag_mask);
			sprintf(pVid0, "%d", ruleNum>=1 ? vlan_group.Rule[0].VLAN_ID : 2);
			sprintf(pVid1, "%d", ruleNum>=2 ? vlan_group.Rule[1].VLAN_ID : 3);
			sprintf(pVid2, "%d", ruleNum>=3 ? vlan_group.Rule[2].VLAN_ID : 4);
			sprintf(pVid3, "%d", ruleNum>=4 ? vlan_group.Rule[3].VLAN_ID : 5);
			sprintf(pVid4, "%d", ruleNum>=5 ? vlan_group.Rule[4].VLAN_ID : 0);
			sprintf(pVid5, "%d", ruleNum>=6 ? vlan_group.Rule[5].VLAN_ID : 0);
			sprintf(pVid6, "%d", ruleNum>=7 ? vlan_group.Rule[6].VLAN_ID : 0);
			sprintf(pVid7, "%d", ruleNum>=8 ? vlan_group.Rule[7].VLAN_ID : 0);
			DPRINTF("vpctrl vodx 0 %s %s %s %s %s %s %s %s %s %s\n", 
				pVlanMask, pTagMask, pVid0, pVid1, pVid2, pVid3, pVid4, pVid5, pVid6, pVid7);
			run_task("vpctrl", "vpctrl", "vodx", "0", 
				 pVlanMask, pTagMask, pVid0, pVid1, pVid2, pVid3, pVid4, pVid5, pVid6, pVid7, NULL);

			/* create vlan interfaces */
			for(i=0; i<ruleNum && ruleNum<=8; i++) {
				sprintf(pVid0, "%d", vlan_group.Rule[i].VLAN_ID);
				sprintf(vlan_if, "vlan%d", vlan_group.Rule[i].VLAN_ID);
				run_task("vconfig", "vconfig", "set_name_type", "VLAN_PLUS_VID_NO_PAD", NULL);
				run_task("vconfig", "vconfig", "add", "eth0", pVid0, NULL);
#if 0
				if(i > 0)
					run_task("ifconfig", "ifconfig", vlan_if, "hw", "ether", mac[i-1], NULL);
#endif
				run_task("ifconfig", "ifconfig", vlan_if, "up", NULL);
#if 1
				/* WAN tagging */
				if(vlan_group.Rule[i].WAN_TAGGING_enable && vlan_group.Rule[i].WAN_connection_index>0) {
					Load_Other_Wan_Bridge_Config(&wanbr);
					if((vlan_group.Rule[i].WAN_connection_index >= 2 &&
					    wanbr.usingSamePVCFromExistingWanConnection[vlan_group.Rule[i].WAN_connection_index-2] == 1) ||
					   vlan_group.Rule[i].WAN_connection_index == 1)
						sprintf(v_wan_if, "nas0");
					else
					sprintf(v_wan_if, "nas%d", vlan_group.Rule[i].WAN_connection_index);
					run_task("vconfig", "vconfig", "set_name_type", "DEV_PLUS_VID_NO_PAD", NULL);
					DPRINTF("vconfig add %s %s\n", v_wan_if, pVid0);
					run_task("vconfig", "vconfig", "add", v_wan_if, pVid0, NULL);
					sprintf(line, "%s.%s", v_wan_if, pVid0);
					DPRINTF("ifconfig %s up\n", line);
					run_task("ifconfig", "ifconfig", line, "up", NULL);
				}
#endif
			}

			fp = fopen("/var/state/vlan.lock", "w");
			if(fp)
				fclose(fp);
		}
		break;
		/* KenWang added 2005/12/23 for vlan -- end -- */
	}
}

/***************************************************************************/
/*  Following functions is for the STOP the specific fucntions             */		
/***************************************************************************/

//For following start/stop specific iptables.  if the function's iptable rule is simple, then
//we can delete/add specific. Otherwise, we need to stop all and add all.
// For examples. VS, DMZ and Packet has major impact. So we can stop and start it.
// But for UPNP, RIP, we can remove it and insert it again.
int stop_specific_iptables(int specficFuncNum)
{
	FILE *fp;
        
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_URL_FILTER:
			iptableScriptInstall(URL_FILTER_CONF_RULE_DEL_IPTBALE_SHELL);			
			unlink("/var/state/_ip_sh_url");
				check_firewall(0);
			break;
		case FUNCTION_NUM_MAC_FILTER:
			iptableScriptInstall(MAC_FILTER_CONF_RULE_DEL_IPTBALE_SHELL);			
			unlink("/var/state/_ip_sh_macf");
				check_firewall(0);
			break;
		case FUNCTION_NUM_BLOCK_WAN:
			iptableScriptInstall(BLOCK_WAN_STOP_IPTBALE_SHELL);			
			unlink("/var/state/_ip_sh_blkw");
				//check_firewall(0);
			break;
		case FUNCTION_NUM_BLOCK_HACK:
			iptableScriptInstall(HACK_IPTBALE_STOP_SHELL);			
			unlink("/var/state/_ip_sh_blkh");
				check_firewall(0);
			break;
		case FUNCTION_NUM_REMOTE_CONFIG:
			iptableScriptInstall(REMOTE_CONFIG_DEL_IPTBALE_SHELL);			
			break;			
		case FUNCTION_NUM_UPNP:
			{
			if(strcmp(wan, "bridge"))
			iptableScriptInstall(UPNP_DEL_IPTBALE_SHELL);					
			}
			break;
		case FUNCTION_NUM_RIP:
			{
			if(strcmp(wan, "bridge"))
			iptableScriptInstall(RIP_DEL_IPTBALE_SHELL);	
			}
			break;
		case FUNCTION_NUM_SNMP:
			{
			if(strcmp(wan, "bridge"))
			iptableScriptInstall(SNMP_DEL_IPTBALE_SHELL);	
			}
			break;
		case FUNCTION_NUM_VIRTUAL_SERVER_DMZ:
			if((fp = fopen(VIRTUAL_SERVER_CONF_RULE_DEL_IPTBALE_SHELL, "r")))
			{
				fclose(fp);
				iptableScriptInstall(VIRTUAL_SERVER_CONF_RULE_DEL_IPTBALE_SHELL);			
				unlink("/var/state/_ip_sh_vs");
				check_firewall(0);
			}
			if((fp = fopen(DMZ_CONF_RULE_DEL_IPTBALE_SHELL, "r")))
			{
				fclose(fp);
				iptableScriptInstall(DMZ_CONF_RULE_DEL_IPTBALE_SHELL);
				unlink("/var/state/_ip_sh_dmz");
				check_firewall(0);
			}
			break;
 		case FUNCTION_NUM_PACKET_FILTER:
			iptableScriptInstall(PACKET_FILTER_CONF_RULE_DEL_IPTBALE_SHELL);
				unlink("/var/state/_ip_sh_pf");
				check_firewall(0);
 			break;
 		case FUNCTION_NUM_QOS:
			iptableScriptInstall(QOS_CONF_FN_RULE_IPT_DEL);
				unlink("/var/state/_ip_sh_qos");
				check_firewall(0);
			break;
 		case FUNCTION_NUM_SIP_PROXY:
			iptableScriptInstall(SIP_IPTBALE_DEL_SHELL);			
			iptableScriptInstall(SIP_RUN_IPTBALE_DEL_SHELL);			
			break;
		case FUNCTION_NUM_CLOSE_WAN_PORT:
			iptableScriptInstall(CLOSE_WAN_PORT_IPTBALE_DEL_SHELL);		
			break;
	}
	return 0;
}


extern long* find_pid_by_name( char* pidName);
//#define KILL_TASK_SHELL "/etc/scripts/kill_task.sh"
int stop_specific_task(int specficFuncNum)
{
	long *killpid=NULL;
	int nSignal=SIGTERM;
	
	
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_TIME_ZONE:
		killpid=find_pid_by_name("ntpd");
		break;
		case FUNCTION_NUM_DDNS:
		killpid=find_pid_by_name("ez-ipupdate");
		break;		
		case FUNCTION_NUM_STATIC_ROUTE_LAN:
		RunFunc_StaticRoute(FUNCTION_STOP,STATIC_ROUTE_LAN);
		break;
		case FUNCTION_NUM_STATIC_ROUTE_WAN:
		RunFunc_StaticRoute(FUNCTION_STOP,STATIC_ROUTE_WAN);
		break;
		case FUNCTION_NUM_ALERT_MAIL_ONLY:
		killpid=find_pid_by_name("alertmail");
		break;
		case FUNCTION_NUM_UPNP:
		killpid=find_pid_by_name("upnp");
		break;
		case FUNCTION_NUM_RIP:
		killpid=find_pid_by_name("zebra");
		break;
		case FUNCTION_NUM_TELNET_CONFIG:
		//killpid=find_pid_by_name("telnetd");
		run_script("/etc/scripts/telnetd_del.sh",0,0,0);
		break;
		case FUNCTION_NUM_ACT:
//		killpid=find_pid_by_name("act");
		run_script("/usr/bin/act_del",0,0,0);
		return 1;
		break;
//		case FUNCTION_NUM_ACTACT:
//		killpid=find_pid_by_name("actact");
//		break;
		case FUNCTION_NUM_SNMP:
		killpid=find_pid_by_name("snmpd");
		break;
		case FUNCTION_NUM_QOS:
		run_script(QOS_CONF_FN_RULE_SHELL_DEL,0,0,0);
				unlink("/var/state/_ip_sh_qos");
				check_firewall(0);
		break;
		case FUNCTION_NUM_EMBEDED_WEB_SERVER:
		killpid=find_pid_by_name("webs");
		break;
		case FUNCTION_NUM_IPSEC_PLUTO:
		killpid=find_pid_by_name("pluto");
		break;
		case FUNCTION_NUM_IGMP_PROXY:
		killpid=find_pid_by_name("igmp-proxy");
		break;
		case FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT:
		killpid=find_pid_by_name("wipc_mail");
		break;
	}
	if (killpid && (*killpid>0)){
		kill(*killpid,nSignal);
		kill(*killpid,SIGKILL);
		return 1;  // kill task  -- Mulder added -- 
	}
	return 0;   // do nothing    -- Mulder added --
}



void stop_specific_function(int specficFuncNum,int isApply,char *parm1)
{
	FILE *fp;
	switch(specficFuncNum)
	{
		case FUNCTION_NUM_TIME_ZONE:
		if((fp = fopen("/var/state/ntpd.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_TIME_ZONE);
			unlink("/var/state/ntpd.lock");
		}
		break;
		case FUNCTION_NUM_DDNS:
		if((fp = fopen("/var/state/ddns.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			unlink("/var/state/ddns.lock");
			stop_specific_task(FUNCTION_NUM_DDNS);
			//start_specific_iptables(FUNCTION_NUM_DDNS); No for DDNS
		}
		break;		
		case FUNCTION_NUM_STATIC_ROUTE_LAN:
		if((fp = fopen("/var/state/route_lan.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			unlink("/var/state/route_lan.lock");
			stop_specific_task(FUNCTION_NUM_STATIC_ROUTE_LAN);
		}
		break;
		case FUNCTION_NUM_STATIC_ROUTE_WAN:
		if((fp = fopen("/var/state/route_wan.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			unlink("/var/state/route_wan.lock");
			stop_specific_task(FUNCTION_NUM_STATIC_ROUTE_WAN);
		}
		break;
		case FUNCTION_NUM_BLOCK_HACK:
		if((fp = fopen("/var/state/blk_hack.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_BLOCK_HACK); 
			unlink("/var/state/blk_hack.lock");
		}
		case FUNCTION_NUM_ALERT_MAIL_ONLY:
		if((fp = fopen("/var/state/alertmail.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_ALERT_MAIL_ONLY);
			unlink("/var/state/alertmail.lock");
		}
		break;
		case FUNCTION_NUM_URL_FILTER:
		if((fp = fopen("/var/state/url_flt.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_URL_FILTER); 
			unlink("/var/state/url_flt.lock");
		}
		break;
		case FUNCTION_NUM_MAC_FILTER:
		if((fp = fopen("/var/state/mac_flt.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_MAC_FILTER); 
			unlink("/var/state/mac_flt.lock");
			/* KenWang added 2005/06/29 -- begin -- */
			/* notify factoryreset to clear accept_list */
			int facpid;
			if((fp = fopen("/var/state/factoryreset.pid", "r")) != NULL)
			{
				fscanf(fp, "%d", &facpid);
				kill(facpid, SIGUSR2);
				fclose(fp);
			}
			/* KenWang added 2005/06/29 -- end -- */
		}
		break;
		case FUNCTION_NUM_BLOCK_WAN:
		if((fp = fopen("/var/state/blk_wan.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_BLOCK_WAN); 
			unlink("/var/state/blk_wan.lock");
		}
		break;
		case FUNCTION_NUM_REMOTE_CONFIG:
		if((fp = fopen("/var/state/remote_config.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_REMOTE_CONFIG); 
			unlink("/var/state/remote_config.lock");
		}
		break;
		case FUNCTION_NUM_TELNET_CONFIG:
		if((fp = fopen("/var/state/telnet_config.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_TELNET_CONFIG); 
			unlink("/var/state/telnet_config.lock");
		}
		break;
		case FUNCTION_NUM_EMBEDED_WEB_SERVER:
			stop_specific_task(FUNCTION_NUM_EMBEDED_WEB_SERVER); 
			break;// no lock file need since it will start in rcS and restart in the Apply for webserver
		case FUNCTION_NUM_UPNP:
		if((fp = fopen("/var/state/upnp.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_UPNP); 
			if(isApply)
				stop_specific_task(FUNCTION_NUM_UPNP);
			else
				reload_config_specific_task(FUNCTION_NUM_UPNP);
			unlink("/var/state/upnp.lock");
		}
		break;
		case FUNCTION_NUM_IGMP_PROXY:
		if((fp = fopen("/var/state/igmp_proxy.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_IGMP_PROXY);
			unlink("/var/state/igmp_proxy.lock");
		}
		break;
		case FUNCTION_NUM_SNMP:
		if((fp = fopen("/var/state/snmpd.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_SNMP);
			stop_specific_task(FUNCTION_NUM_SNMP);
			unlink("/var/state/snmpd.lock");
		}
		break;
		case FUNCTION_NUM_RIP:
		if((fp = fopen("/var/state/rip.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_RIP); 
			stop_specific_task(FUNCTION_NUM_RIP);
			unlink("/var/state/rip.lock");
		}
		break;
		case FUNCTION_NUM_VIRTUAL_SERVER_DMZ:
		if((fp = fopen("/var/state/vs_dmz.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_VIRTUAL_SERVER_DMZ); 
			unlink("/var/state/vs_dmz.lock");
		}
		break;
		case FUNCTION_NUM_PACKET_FILTER:
		if((fp = fopen("/var/state/pf.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_PACKET_FILTER); 
			unlink("/var/state/pf.lock");
		}
		break;
		case FUNCTION_NUM_QOS:
		if((fp = fopen("/var/state/qos.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_QOS);
			stop_specific_iptables(FUNCTION_NUM_QOS); 
			unlink("/var/state/qos.lock");
		}
		break;
		case FUNCTION_NUM_SIP_PROXY:
		if((fp = fopen("/var/state/sip_proxy.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_iptables(FUNCTION_NUM_SIP_PROXY); 
			unlink("/var/state/sip_proxy.lock");
		}
		break;
		case FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT:
		if((fp = fopen("/var/state/wipca.lock", "r")))
		{ // No need to do anything
			fclose(fp);
			stop_specific_task(FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT);
			unlink("/var/state/wipca.lock");
		}
		break;
		/* KenWang added 2006/01/02 for other wan bridge -- begin --*/
	        case FUNCTION_NUM_OTHER_WAN_BRIDGE:
		if((fp = fopen("/var/state/other_wanbr.lock", "r")))
		{
			int i;
			char line[128];
			OTHER_WAN_BRIDGE_DATA wanbr;
			long *killpid = NULL;

			fclose(fp);
			Load_Other_Wan_Bridge_Config(&wanbr);

			for(i=0; i<wanbr.wan_bridge_no; i++) {
				/* stop bridge number bigger then specifed one 
				   to keep bridge numbering continueous */
				/* KenWang modified 2006/01/26 */
				//if(strcmp(parm1, "")) {
				if(parm1 != NULL) {
					if(*parm1 == 'o') {
						if(i+2 != atoi(parm1+1))
							continue;
					}
					else if(*parm1 == 'u') {
						if(i+2 < atoi(parm1+1))
							continue;
					}
					else
						continue;
				}
				if(wanbr.usingSamePVCFromExistingWanConnection[i] == 1) {
					/* KenWang 2006/01/04 */
					/* to delete a wan bridge use same pvc as main wan 
					   should save config and reboot, that is, 
					   it should not get in here. */
				}
				else {
					sprintf(line, "br%d", i+2);
					run_task("ifconfig", "ifconfig", line, "down", NULL);
					run_task("brctl", "brctl", "delbr", line, NULL);
					killpid = find_pid_by_name(line);
					if(killpid && (*killpid>0)) {
						kill(*killpid, SIGTERM);
						kill(*killpid, SIGKILL);
					}
					sprintf(line, "%d", i+2);
					run_task("br2684ctl", "br2684ctl", "-d", line, NULL);
				}
			}
			if(wanbr.wan_bridge_no == 0)
				unlink("/var/state/other_wanbr.lock");
		}
		break;
		/* KenWang added 2006/01/02 for other wan bridge -- end --*/
		/* KenWang added 2006/01/02 for vlan -- begin --*/
	        case FUNCTION_NUM_VLAN:
		if((fp = fopen("/var/state/vlan.lock", "r")))
		{
			char line[32];
			int i;
			VLAN_CONFIG_DATA d;
			OTHER_WAN_BRIDGE_DATA wanbr;

			fclose(fp);
			Load_Vlan_Config(&d);

			/* remove vlan interfaces */
			for(i=0; i<MAX_RULE; i++) {
				if(d.Rule[i].lan_port_enabled[0] ||
				   d.Rule[i].lan_port_enabled[1] ||
				   d.Rule[i].lan_port_enabled[2] ||
				   d.Rule[i].lan_port_enabled[3]) {
					sprintf(line, "vlan%d", d.Rule[i].VLAN_ID);
					run_task("ifconfig", "ifconfig", line, "down", NULL);
					run_task("vconfig", "vconfig", "rem", line, NULL);
				}
#if 0
				if(d.Rule[i].lan_port_enabled[4]) {
					read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", line);
					run_task("ifconfig", "ifconfig", line, "down", NULL);
					run_task("vconfig", "vconfig", "rem", line, NULL);
#ifdef _RALINK_WIRELESS_DRIVER_
					sprintf(line, "VLANID=0");
					run_task("iwpriv", "iwpriv", "ra0", "set", line, NULL);
#endif /* _RALINK_WIRELESS_DRIVER_ */
			}
#endif /* if 0 */
				/* KenWang added 2006/03/24 for WAN tag -- begin -- */
				if(d.Rule[i].WAN_TAGGING_enable && d.Rule[i].WAN_connection_index>0) {
					Load_Other_Wan_Bridge_Config(&wanbr);
					if(wanbr.usingSamePVCFromExistingWanConnection[d.Rule[i].WAN_connection_index] == 1 ||
					   d.Rule[i].WAN_connection_index == 1)
						sprintf(line, "nas0.%d", d.Rule[i].VLAN_ID);
					else
					sprintf(line, "nas%d.%d", d.Rule[i].WAN_connection_index, d.Rule[i].VLAN_ID);
					run_task("ifconfig", "ifconfig", line, "down", NULL);
					run_task("vconfig", "vconfig", "rem", line, NULL);
				}
				/* KenWang added 2006/03/24 for WAN tag -- end -- */
			}
			/* disable vlan */
			run_task("vpctrl", "vpctrl", "active", "no", NULL);
			//sleep(5);
			unlink("/var/state/vlan.lock");
		}
		break;
		/* KenWang added 2006/01/02 for vlan -- end --*/
	}
}

/***************************************************************************/
/*  Following functions is for the whole firewall                          */		
/***************************************************************************/
 
void stop_all_wan_relative_tasks(void)
{
	// only start those functions that have tasks.
	stop_specific_function(FUNCTION_NUM_STATIC_ROUTE_WAN,0,NULL);
	stop_specific_function(FUNCTION_NUM_TIME_ZONE,0,NULL);
	stop_specific_function(FUNCTION_NUM_DDNS,0,NULL);
	stop_specific_function(FUNCTION_NUM_IGMP_PROXY,0,NULL);
	stop_specific_function(FUNCTION_NUM_ALERT_MAIL_ONLY,0,NULL);// For BLK_HACK, only alert tasks.
	stop_specific_function(FUNCTION_NUM_UPNP,0,NULL);
	stop_specific_function(FUNCTION_NUM_RIP,0,NULL);
	stop_specific_function(FUNCTION_NUM_QOS,0,NULL);
	stop_specific_function(FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT,0,NULL);
	//for act's task
	stop_specific_task(FUNCTION_NUM_ACT);
	stop_specific_task(FUNCTION_NUM_ACTACT);
	start_specific_task(FUNCTION_NUM_ACT);
	//start_specific_task(FUNCTION_NUM_ACTACT);
#ifdef _INCLUDE_IPSEC_
	RunFunc_IPSec_Stop();
#endif	
}

void firewall_clean_all_iptables(void)
{
	FILE *fp;
	//Albert add 	
	if((fp = fopen("/proc/sys/net/ipv4/ip_forward", "w")))
	{
		fprintf(fp,"0");
		fclose(fp);
	} 

	/* Modified 20070503 -- begin -- */
	if((fp = fopen("/var/state/firewall_up.lock", "r")))
	{
		fclose(fp);
		iptableScriptInstall(INIT_IPTBALE_SHELL);
	}
	/* Modified 20070503 -- end -- */
#ifdef jj
	fprintf(stderr,"stop_all_firewall_iptables:INIT_IPTBALE_SHELL\n");
#endif
	if((fp = fopen("/var/state/firewall.lock", "r")))
	{ // No need to do anything
		fclose(fp);
		unlink("/var/state/firewall.lock");
#ifdef jj
		fprintf(stderr,"remove/var/state/firewall.lock \n");// only set/remove when whole firewall is started/stopped
#endif
	}
}

//marked by Robert 07272005, seems no one use it.
#if 0
int firewall_start_all_iptables(void)
{   
	FILE *fp;    
	//int i;
	//char filename[30];
	
 	if( !strcmp(router, "nat") )
	{//if [ "$ROUTER" = "nat" ] ;
		iptableScriptInstall(NAT_IPTBALE_SHELL);
	}

	//Albert add

	if((fp = fopen("/proc/sys/net/ipv4/ip_forward", "w")))
	{
		fprintf(fp,"1");
		fclose(fp);
	} 

#ifdef jj
printf("firewall_start_all_iptables is called\n");
#endif
	start_specific_iptables(FUNCTION_NUM_BLOCK_HACK); //jj; moved
	start_specific_iptables(FUNCTION_NUM_URL_FILTER);
	start_specific_iptables(FUNCTION_NUM_MAC_FILTER);
	start_specific_iptables(FUNCTION_NUM_BLOCK_WAN);
	start_specific_iptables(FUNCTION_NUM_REMOTE_CONFIG);
	start_specific_iptables(FUNCTION_NUM_UPNP);
	start_specific_iptables(FUNCTION_NUM_RIP);
	start_specific_iptables(FUNCTION_NUM_SNMP);
 	iptableScriptInstall(TCPMSS_IPTBALE_SHELL);	
 	start_specific_iptables(FUNCTION_NUM_VIRTUAL_SERVER_DMZ);
	start_specific_iptables(FUNCTION_NUM_PACKET_FILTER); 	

	//start_specific_iptables(FUNCTION_NUM_BLOCK_HACK);
	//For Tmss, we will not stop it once it is started.       		
	start_specific_iptables(FUNCTION_NUM_TMSS);// Will not need to start specifically
			
	start_specific_iptables(FUNCTION_NUM_QOS);
	
	start_specific_iptables(FUNCTION_NUM_SIP_PROXY);
#ifdef _INCLUDE_IPSEC_

	for (i = 0; i < MAX_RULE; i++)
	{
		sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
		if ((fp = fopen(filename, "r")))
		{
			fclose(fp);
			iptableScriptInstall(filename);
		}
	}
#endif	
	return 0;
}
#endif


int firewall_start_all_functions(void)
{
	// Note TMSS, TCPMSS will only start once, no matter disconnect
      
 	FILE *fp;
        
#ifdef jj
	fprintf(stderr,"start_all_functions entering\n");
#endif
        
      
 	if( !strcmp(router, "nat") )
	{//if [ "$ROUTER" = "nat" ] ;
			iptableScriptInstall(NAT_IPTBALE_SHELL);
			
			//when no filter, tcpmss still need  Julian 20050817
			iptableScriptInstall(TCPMSS_ADD_IPTBALE_SHELL1);
		
	}
	if((fp = fopen("/proc/sys/net/ipv4/ip_forward", "w")))
	{
		fprintf(fp,"1");
		fclose(fp);
	} 

	start_specific_function(FUNCTION_NUM_TIME_ZONE,0,NULL);
	start_specific_function(FUNCTION_NUM_DDNS,0,NULL);
	//start_specific_function(FUNCTION_NUM_STATIC_ROUTE_LAN,0);// is done in rcS. ONLY is called when system start and Apply changes
	start_specific_function(FUNCTION_NUM_STATIC_ROUTE_WAN,0,NULL);
	start_specific_function(FUNCTION_NUM_BLOCK_HACK,0,NULL);
	start_specific_function(FUNCTION_NUM_URL_FILTER,0,NULL);
	start_specific_function(FUNCTION_NUM_MAC_FILTER,0,NULL);
	start_specific_function(FUNCTION_NUM_BLOCK_WAN,0,NULL);
	//start_specific_function(FUNCTION_NUM_REMOTE_CONFIG,0,NULL);
	start_specific_function(FUNCTION_NUM_IGMP_PROXY,0,NULL);
		
	start_specific_function(FUNCTION_NUM_UPNP,0,NULL);

	start_specific_function(FUNCTION_NUM_RIP,0,NULL);
	start_specific_function(FUNCTION_NUM_SNMP,0,NULL);
//  move to check if firewall is up. Robert, 07272005	
// 	iptableScriptInstall(TCPMSS_ADD_IPTBALE_SHELL);	
//	check_firewall(1);
#ifdef _sso_spary
//For Spray's old F-secure, the TCP MSS for incoming connection shall be lest than 1460.  So, we need to change it to 1450.
// But only FORWARD target work.  So, We have to start the filter module.
	check_firewall(1);
#endif


 	start_specific_function(FUNCTION_NUM_VIRTUAL_SERVER_DMZ,0,NULL);
     start_specific_function(FUNCTION_NUM_QOS,0,NULL); // Fixed can not remote access bug after set qos and restart 2007/04/26
	start_specific_function(FUNCTION_NUM_REMOTE_CONFIG,0,NULL);//Move from above to here to prevent the conflict between VS and RemoteManagment
	start_specific_function(FUNCTION_NUM_PACKET_FILTER,0,NULL); 	

	//For Tmss, we will not stop it once it is started.       		
	start_specific_task(FUNCTION_NUM_TMSS);
	start_specific_iptables(FUNCTION_NUM_TMSS);// Will not need to start specifically
	//for act's task
	stop_specific_task(FUNCTION_NUM_ACT);
	stop_specific_task(FUNCTION_NUM_ACTACT);
	start_specific_task(FUNCTION_NUM_ACT);
//	start_specific_task(FUNCTION_NUM_ACTACT);

			
     //	start_specific_function(FUNCTION_NUM_QOS,0,NULL); Fixed can not remote access bug after set qos and restart 2007/04/26 Marked

	
	start_specific_function(FUNCTION_NUM_SIP_PROXY,0,NULL);
	start_specific_function(FUNCTION_NUM_CLOSE_WAN_PORT,0,NULL);
	start_specific_function(FUNCTION_NUM_WIRELESS_MAC_FILTER, 0, NULL); // KenWang added 2005/06/10
	
	start_specific_function(FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT,0,NULL);
	
#ifdef _INCLUDE_IPSEC_
	RunFunc_IPSec_Start();
#endif	
	// indicate firewall is done			
    	fp = fopen("/var/state/firewall.lock", "w");//touch
	if (fp)
		fclose(fp);
	return 0;
}

#ifdef LIBVER
#define MAINFUNC runFunc_main
#else
#define MAINFUNC main
#endif

int
MAINFUNC(int argc, char *argv[])
{
	FILE *fp; //b028 added 07-12-06

	int specificFun=FIREWALL_FUNCTIONS;// default is all
	char *parm1;
	if (argc < 3){
		fprintf(stderr,"runFunc start/stop firewall/funcNum [parm1]\n");
		return -1;
	}
	if(strcmp(argv[2],"firewall"))
		specificFun=atoi(argv[2]);
	parm1=argv[3];

#ifdef jj
	fprintf(stderr,"runFunc entering (func=%s) the specific func=%d\n",argv[2],specificFun);
#endif
        program_name = "runFunc";
        program_version = IPTABLES_VERSION;
    
	configItem=0;	
       ReadSysStatus();

	   
	// get the status to local public values.
	GetValue("WAN_IF", wan_if);
	GetValue("WAN", wan);
	GetValue("ROUTER", router);
	GetValue("LAN_IF", lan_if);
	GetValue("LAN_IP", lan_ip);
	GetValue("LAN_MASK", lan_mask);
	GetValue("WAN_IP", wan_ip);

	
	
	if(!strcmp(wan, "bridge")) //b028 added 07-12-06 to allow MAC filter iptables to run even if PPP is not connected
	{	
		char str_num1[10];
		DPRINTF("Start MAC iptables\n");
		if(!strcmp(argv[1],"start"))
		{	
				DPRINTF("Start MAC iptables1.1\n");
				sprintf(str_num1,"%d",FUNCTION_NUM_MAC_FILTER);
				if(!strcmp(argv[2],str_num1)){
					start_specific_function(specificFun,1,parm1);
				}
		}
	}
	//b028 added 07-12-06
	
		
 	// check if no wan config or only brigde
	if( (!strcmp(wan, "no"))  || (!strcmp(wan, "bridge")) )
	{//if [ "$WAN" = "no" ] | [ "$WAN" = "bridge" ]
        	//check if the firewall is start.  If so, stop all firewall and all functions Here
	       
		char str_num[10];
		/* Julian add for wireless  20050318 */
		if(!strcmp(argv[1],"start"))
		{
			sprintf(str_num,"%d",FUNCTION_NUM_WIRELESS);
			if(!strcmp(argv[2],str_num)){
				start_specific_function(specificFun,1,parm1);
			}
			sprintf(str_num,"%d",FUNCTION_NUM_WIRELESS_SEC);
			if(!strcmp(argv[2],str_num)){
				start_specific_function(specificFun,1,parm1);
			}
			//Julian add for UPnP enable/disable in purebidge mode 08012005
			sprintf(str_num,"%d",FUNCTION_NUM_UPNP);
			if(!strcmp(argv[2],str_num)){
				DPRINTF("runFuc UPNP start\n");
				start_specific_function(specificFun,1,parm1);
			}
			sprintf(str_num,"%d",FUNCTION_NUM_SNMP);
			if(!strcmp(argv[2],str_num)){
				DPRINTF("runFuc SNMPD start\n");
				start_specific_function(specificFun,1,parm1);
			}
			/* KenWang added 2005/12/14: allow igmp_snoop config in pure bridge mode -- begin -- */
			sprintf(str_num,"%d",FUNCTION_NUM_IGMP_SNOOPING);
			if(!strcmp(argv[2], str_num)) {
				DPRINTF("runFunc IGMP_SNOOPING start\n");
				start_specific_function(specificFun,1,parm1);
			}
			/* KenWang added 2005/12/14: allow igmp_snoop config in pure bridge mode -- end -- */

			/* KenWang added 2006/01/04 for other wan bridge and vlan -- begin -- */
			sprintf(str_num, "%d", FUNCTION_NUM_OTHER_WAN_BRIDGE);
			if(!strcmp(argv[2], str_num)) {
			        start_specific_function(specificFun, 1, parm1);
			}
			sprintf(str_num, "%d", FUNCTION_NUM_VLAN);
			if(!strcmp(argv[2], str_num)) {
				start_specific_function(specificFun, 1, parm1);
			}
			/* KenWang added 2006/01/04 for other wan bridge and vlan -- end -- */

			/* KenWang added 2006/05/15 for static route in bridge mode  -- begin -- */
			sprintf(str_num, "%d", FUNCTION_NUM_STATIC_ROUTE_LAN);
			if(!strcmp(argv[2], str_num)) {
				DPRINTF("runFunc STATIC_ROUTE_LAN start\n");
				start_specific_function(specificFun, 1, parm1);
			}
			/* KenWang added 2006/05/15 for static route in bridge mode  -- end -- */
			
			// Aki add for ADSL annex type change for Bridge Mode			
			sprintf(str_num,"%d",FUNCTION_NUM_ADSL);
			if(!strcmp(argv[2], str_num)) {
				DPRINTF("runFunc FUNCTION_NUM_ADSL start\n");
				start_specific_function(specificFun,1,parm1);
			}
			//start_specific_task(specificFun);
			//start_specific_fw_iptables(specificFun);
		}
		if(!strcmp(argv[1],"stop"))
		{
			sprintf(str_num,"%d",FUNCTION_NUM_WIRELESS);
			if(!strcmp(argv[2],str_num)){
				stop_specific_function(specificFun,1,parm1);
			}
			sprintf(str_num,"%d",FUNCTION_NUM_WIRELESS_SEC);
			if(!strcmp(argv[2],str_num)){
				stop_specific_function(specificFun,1,parm1);
			}
			//Julian add for UPnP enable/disable in purebidge mode 08012005
			sprintf(str_num,"%d",FUNCTION_NUM_UPNP);
			if(!strcmp(argv[2],str_num)){
				DPRINTF("runFuc UPNP stop\n");
				stop_specific_function(specificFun,1,parm1);
			}
			sprintf(str_num,"%d",FUNCTION_NUM_SNMP);
			if(!strcmp(argv[2],str_num)){
				DPRINTF("runFuc SNMP stop\n");
				stop_specific_function(specificFun,1,parm1);
			}
			/* KenWang added 2006/01/04 for other wan bridge and vlan -- begin -- */
			sprintf(str_num, "%d", FUNCTION_NUM_OTHER_WAN_BRIDGE);
			if(!strcmp(argv[2], str_num)) {
			        stop_specific_function(specificFun, 1, parm1);
			}
			sprintf(str_num, "%d", FUNCTION_NUM_VLAN);
			if(!strcmp(argv[2], str_num)) {
				stop_specific_function(specificFun, 1, parm1);
			}
			// Aki add for ADSL annex type change for Bridge Mode			
			sprintf(str_num,"%d",FUNCTION_NUM_ADSL);
			if(!strcmp(argv[2], str_num)) {
				stop_specific_function(specificFun, 1, parm1);
			}
			/* KenWang added 2006/01/04 for other wan bridge and vlan -- end -- */

			/* KenWang added 2006/05/15 for static route in bridge mode  -- begin -- */
			sprintf(str_num, "%d", FUNCTION_NUM_STATIC_ROUTE_LAN);
			if(!strcmp(argv[2], str_num)) {
				DPRINTF("runFunc STATIC_ROUTE_LAN stop\n");
				stop_specific_function(specificFun, 1, parm1);
			}
			/* KenWang added 2006/05/15 for static route in bridge mode  -- end -- */


		}
		return 0;// no need firewall
        }
#ifdef NO_SHARED_LIBS
        init_extensions();
#endif

	// You may simply call stop /start or restart. Then, it will decide, in the individual function, whether
	// or not to performance the iptables/functions add/remove.
       if(!strcmp(argv[1],"start"))
	{
		if(specificFun)
 		{
			start_specific_function(specificFun,1,parm1);
			//start_specific_task(specificFun);
			//start_specific_fw_iptables(specificFun);
		}
		else
		{// start all func, then start the firewall
			//start_all_tasks();
			//firewall_start_all_iptables();	
			firewall_start_all_functions();
		}
	}
        else if(!strcmp(argv[1],"stop"))		
	{
		if(specificFun)
 		{
			stop_specific_function(specificFun,1,parm1);
			//stop_specific_task(specificFun);
			//stop_specific_iptables(specificFun);
		}
		else
		{	
			clean_all();
			
			//b028 added 12-07-06
			if((fp = fopen(MAC_FILTER_CONF_RULE_ADD_IPTBALE_SHELL, "r")))
			{			
				DPRINTF("Start MAC iptables2\n");
				fclose(fp);
				check_firewall(1);
				fp = fopen("/var/state/_ip_sh_macf","w");
				if(fp) fclose(fp);
				iptableScriptInstall(MAC_FILTER_CONF_RULE_ADD_IPTBALE_SHELL);	
			}			
		}
	}
        return 0;
}

char* read_file_para_value(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
	char tmp_line[255]={0};
	char str_return[50]={0};
	//char_t *str_return=NULL;
	char str_temp[50]={0};
	*buf='\0';
	memset(tmp_line,0,sizeof(tmp_line));
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(tmp_line,sizeof(tmp_line),fp)){
		        if (strncmp(tmp_line,arg1,strlen(arg1)) == 0){
       				sscanf(tmp_line,"%50[^=]=\"%50[^\"]\"\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
			//	DPRINTF("1.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	       	fclose(fp);
	}
	return buf;
}

