#include <getopt.h>
#include <sys/errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iptables.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <stdarg.h>
#include <signal.h>
#include "runFunc.h"
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <dlfcn.h>
#include <ctype.h>
#include <limits.h>
#include <iptables.h>
#include "../websconfig/ipsec_config.h"
#include "../tmss/include/tmSemaphore.h"
#include "../tmss/include/tmShm.h"

extern long* find_pid_by_name( char* pidName);
extern void run_task(char *cmd, ...);
extern void iptableScriptInstall(char *iptableScriptFile);
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
extern int stop_specific_task(int specficFuncNum);
extern void SetValue(char *name, char *value);

extern char lan_ip[];
extern char lan_mask[];
extern char router[];
void saveIPsecStatus(int instance, int state);
void IPSecConnectStatus_Init(void);

int GetIPSecRuleFromConfig(FILE *fp,IPSEC_RULE_T *rule)
{		
	if(fscanf(fp, "|%d|%40[^|]|%d|%20[^|]|%20[^|]|%40[^|]|%40[^|]|%20[^|]|%20[^|]|%40[^|]"
                      "|%d|%d|%d|%d|%d|%d|%d|%100[^|]|\n",
                &rule->Active,
				rule->name,
                &rule->ApplicationType,
                rule->LocalSubnet,
                rule->LocalSubnetMask,
                rule->LocalIKE_ID,
                rule->RemoteIP,
                rule->RemoteSubnet,
                rule->RemoteSubnetMask,
                rule->RemoteIKE_ID,
                //
                &rule->Proposal,
                &rule->Esp,
                &rule->Phase1_SA_Lifetime,
                &rule->Phase2_SA_Lifetime,
                &rule->perfect_forward_secrecy,
                &rule->AggressiveMode,
                &rule->responder_only,
                rule->PreSharedKey) == -1)
	{
 		    return 0;
	}
	if(rule->LocalSubnet[0]=='&')
		rule->LocalSubnet[0]='\0';
	if(rule->LocalSubnetMask[0]=='&')
		rule->LocalSubnetMask[0]='\0';
	if(rule->LocalIKE_ID[0]=='&')
		rule->LocalIKE_ID[0]='\0';
	if(rule->RemoteIP[0]=='&')
		rule->RemoteIP[0]='\0';
	if(rule->RemoteSubnet[0]=='&')
		rule->RemoteSubnet[0]='\0';
	if(rule->RemoteSubnetMask[0]=='&')
		rule->RemoteSubnetMask[0]='\0';
	if(rule->RemoteIKE_ID[0]=='&')
		rule->RemoteIKE_ID[0]='\0';
	return 1;
}
 
int startIPSecPluto(int NAT_Traversal_Enabled,int NAT_T_KL_Sec)
{
	long *pid = find_pid_by_name("/bin/pluto");
	FILE *fp;
	
	if (!pid || *pid<=0)
	{
		if(NAT_Traversal_Enabled)
		{
			char  p[20];
			sprintf(p,"%d",NAT_T_KL_Sec);
			run_task("/bin/pluto","/bin/pluto","--nat_traversal","--keep_alive",p,NULL);
		}    
		#if 0
		run_task("/bin/pluto","/bin/pluto","--secretsfile",IPSEC_SECRETS_FILE,"--nofork","&",NULL);
		#else
		if ((fp = fopen("/var/etc/pluto_start.sh", "w")) == NULL)
		{
        //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
	  	  return 0;
		}
  		
		fprintf(fp, "#!/bin/sh\n");
		fprintf(fp,"/bin/pluto --secretsfile %s --nofork --debug-raw --debug-crypt --debug-parsing --debug-emitting --debug-control --debug-klips &",IPSEC_SECRETS_FILE);
		fflush(fp);
		fclose(fp);
		chmod("/var/etc/pluto_start.sh", S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH);
		run_script("/var/etc/pluto_start.sh",0,0,0);
		#endif
	}
	else
	{
				printf("  Process pluto exists\n");
	}
	return 1;
 }
 
 


#define inet_ntoa_b(inet_addr,dest_string) strcpy(dest_string, inet_ntoa(inet_addr))

/*
--host ip-address
--host %any
the IP address of the end (generally the public interface). If pluto is to act as a responder for IKE negotiations
 initiated from unknown IP addresses (the ``Road Warrior'' case), the IP address should be specified
  as %any (currently, the obsolete notation 0.0.0.0 is also accepted for this). 
  
--client subnet
the subnet for which the IPsec traffic will be destined. If not specified, the host will be the client. 
The subnet can be specified in any of the forms supported by ipsec_atosubnet(3). 
The general form is address/mask. The address can be either a domain name or four decimal numbers 
(specifying octets) separated by dots. The most convenient form of the mask is a decimal integer,
 specifying the number of leading one bits in the mask. So, for example, 10.0.0.0/8 would specify the class A
  network ``Net 10''. 


 The application Type has 3 modules: LAN_LAN, LAN_HOST repsonder,LAN_HOST initiator, HOST_HOST
 for LAN_LAN
 left:
     --host: %ifaddress
     --client :the whole localLan(if 0.0.0.0, but must give a subnet in the script, can not give 0.0.0.0)or specified local LAN present
right: --to
     --host :if 0.0.0.0, then we are the responder, otherwise is the remote gateway.
     --client:Any subnet. (If is responder, then  0.0.0.0 means any subnet is accepted)
--tunnel mode
  


 for LAN_HOST responder
 left:
     --host: %ifaddress
     --client :the whole localLan(if 0.0.0.0)or specified local LAN present
right: --to
     --host : 0.0.0.0 or an specific allowed IP.
     --client: (Not present)
--tunnel mode
 
  for LAN_HOST Initiator
 left:
     --host: %ifaddress
     --client :(Not present)
right: --to
     --host : an remote Gateway (must not 0.0.0.0)
     --client: Any subnet.
--tunnel mode

  for HOST_HOST
 left:
     --host: %ifaddress
     --client :(Not present)
right: --to
     --host : an remote Gateway(if 0.0.0.0 then can only be a responder) 
     --client:(Not present)
--tunnel mode shall not present.
 */
 
 
#define IPSEC_IPTABLES_INSERT 0
#define IPSEC_IPTABLES_DEL 1
void createIPSecIptablesScript(int operation,char *wanNetwork,int instance,IPSEC_RULE_T *tmptr)
{
	char oper[4];
	char filename[30];
	FILE *fp;
	
	//# Configure the ipsec device
	if(operation==IPSEC_IPTABLES_INSERT)
	{
			sprintf(filename, "/var/etc/ipsec_ipt%d.add", instance);
 		strcpy(oper,"-I");
	}
	else
	{
			sprintf(filename, "/var/etc/ipsec_ipt%d.del", instance);
 		strcpy(oper,"-D");
	}

	if ((fp = fopen(filename, "w")) == NULL)
	{
        //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
	  	  return;
	}
	fprintf(fp,"iptables %s INPUT -p udp -i $WAN_IF -s $RIP%i --dport 500 -j ACCEPT\n"   /* Input IKE protocol from peer */
	"iptables %s INPUT -p esp -i $WAN_IF -s $RIP%i -j ACCEPT\n"               /* Input ESP protocol from peer */
	"iptables %s INPUT -p ah -i $WAN_IF -s $RIP%i -j ACCEPT\n"                /* Input AH protocol from peer */
	"iptables %s INPUT -i ipsec%d -j ACCEPT\n"                       /* Input IPsec dev  */
	"iptables %s FORWARD -i ipsec%d -j ACCEPT\n"                     /* Fowarding from IPsec dev  */
	"iptables %s FORWARD -o ipsec%d -j ACCEPT\n",                     /* Fowarding to IPsec dev  */
			           oper,instance, 
			           oper,instance, 
			           oper,instance,
					   oper,instance,
					   oper,instance,
					   oper,instance
						      ); 

	/* Test Masquerade on the PHY interface */
	if( !strcmp(router, "nat") )
	{//if [ "$ROUTER" = "nat" ] ;
		fprintf(fp, "iptables -t nat %s PREROUTING -p esp -i $WAN_IF -s $RIP%i -j ACCEPT\n",oper,instance);   /* Nat Table ESP protocol from peer */
		fprintf(fp, "iptables -t nat %s PREROUTING -p ah -i $WAN_IF -s $RIP%i -j ACCEPT\n", oper,instance);    /* Nat Table AH protocol from peer */
		fprintf(fp, "iptables -t nat %s PREROUTING -i ipsec%d -j ACCEPT\n", oper,instance);        /* Nat Table IPsec dev  */
		fprintf(fp, "iptables -t nat %s POSTROUTING -o ipsec%d -d %s -j MASQUERADE\n",oper,instance, wanNetwork);
	}

#define AES_MSS 1392
	// if it is AES.  We need to reduce 8 bytes more (1400->1388???)for outgoing MSS (to ipsecx interface)
	if (tmptr->Esp==IPSEC_ESP_AES)
		fprintf(fp,"iptables %s  FORWARD -o ipsec%d -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --set-mss %d\n"
			"iptables %s  FORWARD -i ipsec%d -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --set-mss %d\n",
			oper,instance,AES_MSS,oper,instance,AES_MSS );

	fflush(fp);
	fclose(fp);
}

int	createIPsecTaskScript(IPSEC_RULE_T* tmptr,char *wan_net,int instance)
{
 	struct sockaddr_in server_addr;
	char remoteIPAddrStr[20];
	char wanNetwork[40],lanNetwork[40];
	char filename[30];
	FILE *fp;
    unsigned char mask;
    struct in_addr addr;
	char localIDstr[80]="",remoteIDstr[80]="";
	char espAlg[30]="";
	int localClientLanPresent,remoteClientLanPresent;

			sprintf(filename, "/var/etc/ipsec_creat%d.sh",instance);
	if ((fp = fopen(filename, "w")) == NULL)
	{
        //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
	  	  return 0;
	}
	fprintf(fp, "#!/bin/sh\n");
	fprintf(fp, ". %s\n",VAR_ETC_STATUS_FILE);
	fprintf(fp, ". %s\n",VAR_ETC_IPSEC_VAR_FILE);
	
	//environment variables
	sprintf(lanNetwork,"--client $LAN_NET%i",instance);
	sprintf(remoteIPAddrStr,"$RIP%i",instance);

	/* get wan network/mask */
	inet_aton(tmptr->RemoteSubnetMask, &addr);
	/* get number of bits of the mask */
	for( mask=0 ; (addr.s_addr&0x80000000) && mask != 32 ; mask++, addr.s_addr=(addr.s_addr<<1) );
	sprintf(wan_net, "%s/%d", tmptr->RemoteSubnet, mask);
	sprintf(wanNetwork, "--client %s",wan_net);
	//DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script wanNetwork [%s]\n", wanNetwork);

	if(tmptr->Proposal==IPSEC_PROPOSAL_ESP)
	{
		if (tmptr->Esp==IPSEC_ESP_AES)
			sprintf(espAlg,"--esp aes");
		else if (tmptr->Esp==IPSEC_ESP_DES)
			sprintf(espAlg,"--esp des");
		else
			sprintf(espAlg,"--esp 3des");
	}

	//Here we have to check if valid remote/local id is present
	// We have to add @ for a FQDN.

	// first check if is an IP address
      server_addr.sin_family = AF_INET;
	if (!inet_aton(tmptr->LocalIKE_ID, &server_addr.sin_addr))
	{// is not an valid IP address, note 0.0.0.0 is wild card and still is an vaild IP address
        // then check if there is an "@" in the
		if( (strlen(tmptr->LocalIKE_ID)!=0)// if null, then we will not put the id field into whack since it is optional
         &&  (strchr(tmptr->LocalIKE_ID, '@') == NULL))
        {// not a USER_ID_FQDN
           // For linux, we need to add an @
           sprintf(localIDstr,"--id @%s",tmptr->LocalIKE_ID);
        }
	}
	if (!inet_aton(tmptr->RemoteIKE_ID, &server_addr.sin_addr))
	{// is not an valid IP address, note 0.0.0.0 is wild card and still is an vaild IP address
        // then check if there is an "@" in the
		if( (strlen(tmptr->RemoteIKE_ID)!=0)// if null, then we will not put the id field into whack since it is optional
         &&  (strchr(tmptr->RemoteIKE_ID, '@') == NULL))
        {// not a USER_ID_FQDN
           // For linux, we need to add an @
           sprintf(remoteIDstr,"--id @%s",tmptr->RemoteIKE_ID);
        }
	}
      
      // check the application Type first.
#define TRUE 1
#define FALSE 0
	localClientLanPresent=FALSE;
	remoteClientLanPresent=FALSE;
	switch(tmptr->ApplicationType)
	{
      	 case IPSEC_APPLICATION_TYPE_LAN_LAN:
      	        localClientLanPresent=TRUE;
      	        remoteClientLanPresent=TRUE;
      	        break;
       	 case IPSEC_APPLICATION_TYPE_HOST_LAN_RESP:
      	        localClientLanPresent=TRUE;
       	        remoteClientLanPresent=FALSE;
     	        break;
       	 case IPSEC_APPLICATION_TYPE_HOST_LAN_INIT:
      	        localClientLanPresent=FALSE;
       	        remoteClientLanPresent=TRUE;
      	        break;
      	 case IPSEC_APPLICATION_TYPE_HOST_HOST:
      	        localClientLanPresent=FALSE;
      	        remoteClientLanPresent=FALSE;
      	        break;
	}	  
	fprintf(fp, "# Create SAs for a ipsec connection.\n"
                  "whack --name %s --host $WAN_IP %s %s --to --host %s %s %s "
                  "--psk %s %s %s --disablearrivalcheck "
                  "--ikelifetime %d --ipseclifetime %d %s --updown /etc/ipsec_scripts/_updown %s \n\n",
                  tmptr->name,
                 localIDstr,
                  (localClientLanPresent==TRUE)?lanNetwork:"" ,
 				  remoteIPAddrStr,
				  remoteIDstr,
                  (remoteClientLanPresent==TRUE)?wanNetwork:"",        	
         	//
                  (tmptr->Proposal==IPSEC_PROPOSAL_AH) ? "--authenticate" : "--encrypt",
                  (tmptr->ApplicationType==IPSEC_APPLICATION_TYPE_HOST_HOST) ?"": "--tunnel" ,
                  (tmptr->perfect_forward_secrecy==IPSEC_PFS_Yes) ? "--pfs" : "",
                  
                  //
				  tmptr->Phase1_SA_Lifetime*60,
				  tmptr->Phase2_SA_Lifetime*60,
                  espAlg,
                  (tmptr->AggressiveMode)?"--aggrmode":""
                 );
      fprintf(fp, "# Configure the ipsec device\n"
                  "tncfg --attach --virtual ipsec%d --physical $WAN_IF\n"
                  "ifconfig ipsec%d $WAN_IP\n\n",
                  instance,
                  instance
                  );
	fprintf(fp, "# listening connection\n"
                  "whack --unlisten\n"    /* unlisten then listen to make sure ipsec.secrets is reparsed */
                  "whack --listen\n"
                  );
	fflush(fp);
	fclose(fp);
	chmod(filename, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH);

	// if the connection can be responder only , we will not create the initiate script
  	//  This routine can be a function by run tasks.
	if(tmptr->responder_only==IPSEC_ResponderOnly_No)
    {
		sprintf(filename, "/var/etc/ipsec_init%d.sh",instance);
 	  	if ((fp = fopen(filename, "w")) == NULL)
		{
        	//DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
			return -1;
		}

      	fprintf(fp, "#!/bin/sh\n\n");
      	fprintf(fp, "# activate connection\n"
                  "whack --initiate --name %s --asynchronous\n\n",  //asynchronous (background) mode 
                  tmptr->name);

		// indicate the connection is initiated.  When shall we clear it?  Terminate???
		fclose(fp);
		chmod(filename, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH);
	}


    /* IPsec Destroy Script */
	sprintf(filename, "/var/etc/ipsec_dstry%d.sh",instance);
	if ((fp = fopen(filename, "w")) == NULL)
	{
        //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
		return -1;
	}
	fprintf(fp, "#!/bin/sh\n\n"
                  "# delete SAs for the ipsec connection\n"
                  "whack --name %s --terminate\n"
                  "whack --name %s --delete\n"
                  "whack --unlisten\n"    /* unlisten then listen to make sure ipsec.secrets is reparsed */
                  "whack --listen\n",
                  tmptr->name,
                  tmptr->name
                  );
     fprintf(fp, "#  remove the ipsec device\n"
                  "tncfg --detach --virtual ipsec%d --physical $WAN_IF\n"
                  "ifconfig ipsec%d down\n\n",
                  instance,
                  instance
                  );
				  
	fflush(fp);
	fclose(fp);
	chmod(filename, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH);
	

	sprintf(filename, "/var/etc/ipsec_term%d.sh",instance);
	if ((fp = fopen(filename, "w")) == NULL)
	{
        //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script open file %s error\n", filename);
	  	  return -1;
	}

	fprintf(fp, "#!/bin/sh\n\n"
                  "whack --name %s --terminate\n"
                  "whack --unlisten\n"    /* unlisten then listen to make sure ipsec.secrets is reparsed */
                  "whack --listen\n",tmptr->name);
	fflush(fp);
	fclose(fp);
	chmod(filename, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH);
	return 0;
}


void ipsecResolveEnvironmentalVariablesForARule(FILE *fp,IPSEC_RULE_T* tmptr,int instance)
{
 	struct sockaddr_in server_addr;
	char	str[INET6_ADDRSTRLEN];
    struct in_addr remoteIPAddr;
	char lanNetwork[40];
	unsigned char mask;
    struct in_addr addr;
	char name[10];
	
	// resolve the Environmental variables.
	//1.resolve the remote Gateway IP
	server_addr.sin_family = AF_INET;
	sprintf(name,"RIP%i",instance);
	if (!inet_aton(tmptr->RemoteIP, &server_addr.sin_addr))
	{// is not an valid IP address, note 0.0.0.0 is wild card and still is an vaild IP address
		struct hostent          *ipsec_hostent;
		ipsec_hostent = gethostbyname(tmptr->RemoteIP);
		if (ipsec_hostent == NULL)
		{
			fprintf(fp, "%s=\"%s\"\n",name, tmptr->RemoteIP);//keep the old one
			// set the RIP variable to our current task environment variables.
			SetValue(name,tmptr->RemoteIP);
		}
		else
		{			
			remoteIPAddr.s_addr = inet_addr(inet_ntop(ipsec_hostent->h_addrtype,ipsec_hostent->h_addr_list[0], str, sizeof(str)));		
			fprintf(fp, "%s=\"%s\"\n", name,inet_ntoa(remoteIPAddr));
			// set the RIP variable to our current task environment variables.
			SetValue(name,inet_ntoa(remoteIPAddr));
		}
	}	
	else
	{
		fprintf(fp, "%s=\"%s\"\n", name,tmptr->RemoteIP);
 		// set the RIP variable to our current task environment variables.
		SetValue(name,tmptr->RemoteIP);
	}
	//resolve the local subnet
	inet_aton(tmptr->LocalSubnetMask, &addr);
	// if the local network is 0.0.0.0 then we shall take the whole Local LAN.
	if(addr.s_addr==0)
	{
			/* get whole lan network/mask */
			inet_aton(lan_mask, &addr);
			addr.s_addr=htonl(addr.s_addr);
			/* get number of bits of the mask */
			for( mask=0 ; (addr.s_addr&0x80000000) && mask != 32 ; mask++, addr.s_addr=(addr.s_addr<<1) );
			sprintf(lanNetwork, "%s/%d", lan_ip, mask);
			//DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script lan [%s]\n", lanNetwork);
	}
	else
	{   // NOTE NOTE!!!! LOCAL SHALL BE IN THE SUBNET of LOCAL LAN    
    	  /* get number of bits of the mask */
    	  for( mask=0 ; (addr.s_addr&0x80000000) && mask != 32 ; mask++, addr.s_addr=(addr.s_addr<<1) );
    	  sprintf(lanNetwork, "%s/%d", lan_ip,mask);
    	  //DEBUG_LOG (LOG_USER | LOG_ERR, "ipsec_save_script lanNetwork [%s]\n", lanNetwork);
	}
	fprintf(fp, "LAN_NET%i=\"%s\"\n", instance,lanNetwork);
}

void RunFunc_IPSec_Stop(void)
{
	int i;
	char filename[30];
	FILE *fp;

	IPSecConnectStatus_Init();

	stop_specific_task(FUNCTION_NUM_IPSEC_PLUTO);
	for (i = 0; i < MAX_RULE; i++)
	{
		
		//1.terminate the ipsec connection
		sprintf(filename, "/var/etc/ipsec_term%d.sh",i);
		if ((fp = fopen(filename, "r")))
		{
			run_script(filename,0,0,0);
			unlink(filename);
			sprintf(filename, CONFIG_DIR"/ipsec%d.secrets", i);
			unlink(filename);
		}
		
		//2. deinstall iptables scripts
			sprintf(filename, "/var/etc/ipsec_ipt%d.del", i);
		if ((fp = fopen(filename, "r")))
		{
			iptableScriptInstall(filename);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
			unlink(filename);
		}
		
		//3. run task.first
		sprintf(filename, "/var/etc/ipsec_dstry%d.sh",i);
		if ((fp = fopen(filename, "r")))
		{
			run_script(filename,0,0,0);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_creat%d.sh",i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_init%d.sh",i);
			unlink(filename);
		}
		
	}	
}	

int RunFunc_IPSec_Start(void)
{
	int i;
	FILE *fp,*fpConf,*fpSecret,*fpEnv;
	char wan_net[30];
	int NAT_Traversal_Enabled;
	int NAT_T_KL_Sec;
	int plutoIsStart=0;
	IPSEC_RULE_T aRule,*tmptr=&aRule;
	char filename[30];
	unsigned int version;
	
	IPSecConnectStatus_Init();
	//GetConfigToIPSecTable(&table);	
	//if(!ipsecIfAnyRulesActive(&table))
	//	return 0;

	fpConf = fopen(IPSEC_CONFIG_FILE, "r");
	if (!fpConf) {
		return -1;
	}

	if(fscanf(fpConf,"|%x|\n",&version)!=1)
	{
				fclose(fpConf);
				return -1; //default is used
	}
	if(fscanf(fpConf,"|%d|%d|\n",&NAT_Traversal_Enabled,&NAT_T_KL_Sec)!=2)
	{
				fclose(fpConf);
				return -1; //default is used
	}
	//startIPSecPluto(&table);
	//set up the environment variables for ipsec before running
	if ((fpEnv = fopen(VAR_ETC_IPSEC_VAR_FILE, "w")) == NULL)
  	{
		printf(" error opening %s file\n",VAR_ETC_IPSEC_VAR_FILE);
	  	return -1;
  	}
	//we need not unlink this since it can include no secret files.
	if ((fpSecret = fopen(IPSEC_SECRETS_FILE, "w")) == NULL)
  	{
		printf(" error opening %s file\n",IPSEC_SECRETS_FILE);
	  	return -1;
  	}
    fprintf(fpSecret, "# This file holds shared secrets or RSA private keys for inter-Pluto\n"
                "# authentication.  See ipsec_pluto(8) manpage, and HTML documentation.\n\n");
	for (i = 0; i < MAX_RULE; i++)
	{
		if(!GetIPSecRuleFromConfig(fpConf,tmptr))
			break;
		if(!tmptr->Active)
		{
			char filename[30];
			sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_ipt%d.del", i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_creat%d.sh",i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_term%d.sh",i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_dstry%d.sh",i);
			unlink(filename);
			sprintf(filename, "/var/etc/ipsec_init%d.sh",i);
			unlink(filename);
			sprintf(filename, CONFIG_DIR"/ipsec%d.secrets", i);
			unlink(filename);
			continue;
		}
		if(!plutoIsStart)
		{
			startIPSecPluto(NAT_Traversal_Enabled,NAT_T_KL_Sec);
			plutoIsStart=1;
		}
		
		//1. resolve the environmental variables
		ipsecResolveEnvironmentalVariablesForARule(fpEnv,tmptr,i);		
		
		//2. create the scret file
		sprintf(filename, CONFIG_DIR"/ipsec%d.secrets", i);
		fprintf(fpSecret, "include %s\n\n", filename);
		fp=fopen(filename, "w");
		if (fp)
		{
			fprintf(fp,"\"%s\"\n",tmptr->PreSharedKey);
			fclose(fp);
		}
		else
		{
			printf( "ipsec_handle_file unable to open file [%s]\n", filename);
		}
		
		//3. create task shell script
		createIPsecTaskScript(tmptr,wan_net,i);
		fprintf(fpEnv, "WAN_NET%i=\"%s\"\n", i,wan_net);
		
		//4. create iptables script
		createIPSecIptablesScript(IPSEC_IPTABLES_INSERT,wan_net,i,tmptr);
		createIPSecIptablesScript(IPSEC_IPTABLES_DEL,wan_net,i,tmptr);
		
		
		//5. install iptables scripts
			sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
		iptableScriptInstall(filename);
		
		//6. run task.first
		sprintf(filename, "/var/etc/ipsec_creat%d.sh",i);
		run_script(filename,0,0,0); 
	/*	//7.make the ipsec connection
 		run_task("whack","whack","--initiate","--name",tmptr->name,"--asynchronous",NULL);//asynchronous (background) mode		
		saveIPsecStatus(i,IPSEC_CHANNEL_CONNECTING);  */
	}
	fclose(fpSecret);
	fclose(fpEnv);
	fclose(fpConf);
	return 1;
}

void IPSecConnectStatus_Init(void){
	int i;
	IPSEC_CFG_STATUS *ics=NULL;
	int IPSecStatusShmid;
	struct tm_sem_st IPSecStatusLock;
	
	IPSecStatusShmid = shm_init(IPSEC_STATUS_SHMKEY, sizeof(IPSEC_CFG_STATUS)*MAX_RULE);
	tm_lock_create(IPSEC_STATUS_SEMLOCKKEY, &IPSecStatusLock);
	if (tm_lock(&IPSecStatusLock) == -1)
	{
        printf("IPSecConnectStatus_Init(), lock shared memroy error\n");
	}
	ics = (IPSEC_CFG_STATUS*)shm_attach(IPSecStatusShmid);
	// we reset the status table for IPsec
	memset(ics, 0, sizeof(IPSEC_CFG_STATUS)*MAX_RULE);
	for(i=0;i<MAX_RULE;i++)
	{
		strcpy(ics[0].remoteGatewayStrForDomainName,"0.0.0.0");
	}
	shm_detach(ics);
	if (tm_unlock(&IPSecStatusLock) == -1)
	{
	printf("IPSecConnectStatus_Init(), unlock shared memroy error\n");
	}
	tm_lock_close(&IPSecStatusLock);
}

void saveIPsecStatus(int instance, int state)
{
	int IPSecStatusShmid;
	struct tm_sem_st        IPSecStatusLock;
	IPSEC_CFG_STATUS *icsShmPtr,*ics;
	IPSecStatusShmid = shm_init(IPSEC_STATUS_SHMKEY, sizeof(IPSEC_CFG_STATUS)*MAX_RULE);
	tm_lock_create(IPSEC_STATUS_SEMLOCKKEY, &IPSecStatusLock);
	if (tm_lock(&IPSecStatusLock) == -1)
	{
        printf("ipsec_status_action(), lock shared memroy error\n");
	return;
	}
	icsShmPtr = (IPSEC_CFG_STATUS *)shm_attach(IPSecStatusShmid);
	// we reset the status table for IPsec
	// If the connection is responder only, then we only allow disconnect.
  	ics=&icsShmPtr[instance];
	ics->connected=state;
	shm_detach(icsShmPtr);
	if (tm_unlock(&IPSecStatusLock) == -1)
	{
	printf("IPSecConnectStatus_Init(), unlock shared memroy error\n");
	}
	tm_lock_close(&IPSecStatusLock);
}


