#include <getopt.h>
#include <sys/errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iptables.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <stdarg.h>
#include <signal.h>
#include "runFunc.h"
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <dlfcn.h>
#include <ctype.h>
#include <limits.h>
#include <iptables.h>
#include "../websconfig/qos_conf.h"
/* dmt status */
#include <linux/tc3162dmtctrl.h>
#include <sys/ioctl.h>  /* ioctl */

extern char wan_if[];

int CreateQOSTableToScript(QOS_TABLE_T *table,int outBoundRule,int inBoundRule);
int GetConfigToQOSTable(QOS_TABLE_T *table);
// CreateQOSTableToScript
void outputQOSRuleToScript(QOS_RULE_T *rule,int ruleIndex,int uplinkspeed,int downlinkspeed,int *gRate);
/*-----------------------------------------------*/
extern void outputTimeBLockForIptables(TIME_BLOCK_T *timeblock,char *timeBlocking);
// dmt status
#define DMT_READ_FN "/proc/dmtctrl/dmtread"
#define DMT_WRITE_FN "/proc/dmtctrl/dmtwrite"

void dmt_write_cmd(int cmd)
{
	FILE *fp;
	fp = fopen(DMT_WRITE_FN, "w");
	if(fp!=NULL){
		fprintf(fp, "%d" , cmd);
		fclose(fp);
	}
}
char buf1[255];

char *dmt_read_status(char *buf)
{
	FILE *fp;
	fp = fopen(DMT_READ_FN, "r");
	if(fp!=NULL){
		memset(buf1,0,sizeof(buf1));
		fgets(buf1, sizeof(buf1), fp);
		fclose(fp);
		strcpy(buf,buf1);
		return buf;
	}
	return NULL;
}

/* aspectou32 should convert the address portion of a spec...
 * "base10"
 * "0base8"
 * "0xbase16"
 * "hostname"
 * "address" */
u_int32_t
aspectou32 (char *astr, int dns)
{
  u_int32_t addr = 0;
  struct in_addr s;

  // So we can input the domain name instead of the IP address.
  if (inet_aton (astr, &s))
    addr = ntohl (s.s_addr);
  else
    fprintf (stderr, "unable to parse \"%s\"", astr);
  return (addr);
}
char *days_match_str[] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };

void
outputTimeBLockForIptables (TIME_BLOCK_T * timeblock, char *timeBlocking)
{
  if ((!timeblock->alwaysBlock) && (timeblock->days_match > 0))
    {
      int daysMask = 0x01;
      int firstOne = 1, kk;	// No "," for first one
      char daysBlock[40];
      memset (daysBlock, 0, sizeof (daysBlock));
      sprintf (daysBlock, "--days ");
      for (kk = 0; kk < 7; kk++)
	{
	  if (timeblock->days_match & daysMask)
	    {
	      if (!firstOne)
		strcat (daysBlock, ",");
	      else
		firstOne = 0;
	      strcat (daysBlock, days_match_str[kk]);
	    }
	  daysMask <<= 0x01;
	}

      sprintf (timeBlocking,
	       "-m time --timestart %02d:%02d --timestop %02d:%02d %s",
	       timeblock->time_start / 60, timeblock->time_start % 60,
	       timeblock->time_stop / 60, timeblock->time_stop % 60,
	       daysBlock);
    }
}

#if 0
static char buf1_255[255],buf3_255[255];
void getDownUpStreamRate(int *downlinkspeed,int *uplinkspeed)
{
	int dumb1,dumb2,dumb3,dumb4;
	dmt_write_cmd(DMT_LINERATE);
	strcpy(buf1_255,(char *)dmt_read_status(buf3_255));

	if( strlen(buf1_255) > 0)
		sscanf(buf1_255,"%d %d %d %d", 
		&dumb1,&dumb2,&dumb3,&dumb4);
		if(dumb1)
			*downlinkspeed=dumb1;
		if(dumb2)
			*downlinkspeed=dumb2;
		if(dumb3)
			*uplinkspeed=dumb3;
		if(dumb4)
			*uplinkspeed=dumb4;

		//DPRINTF("getDownUpStreamRate:downlinkspeed=%d,uplinkspeed=%d\n",*downlinkspeed,*uplinkspeed);

}
#else
void getDownUpStreamRate(int *downlinkspeed,int *uplinkspeed)
{
    DMTCTRL_CONNECTION_INFO Arg;
    int nFd = open( "/dev/dmtdev", O_RDWR );
    if( nFd == -1  )
	{
		printf("getDownUpStreamRate:severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
    ioctl( nFd, DMTIOCTL_GET_CONNECTION_INFO, &Arg );
        
	printf("near-end interleaved channel bit rate: %d kbps\n",Arg.actualBitrateNearInt);
	printf("near-end fast channel bit rate: %d kbps\n",Arg.actualBitrateNearFast);
	printf("far-end interleaved channel bit rate: %d kbps\n",Arg.actualBitrateFarInt);
	printf("far-end fast channel bit rate: %d kbps\n",Arg.actualBitrateFarFast);
 	if(Arg.actualBitrateNearInt)
		*downlinkspeed=Arg.actualBitrateNearInt;
	if(Arg.actualBitrateNearFast)
		*downlinkspeed=Arg.actualBitrateNearFast;
	if(Arg.actualBitrateFarInt)
		*uplinkspeed=Arg.actualBitrateFarInt;
	if(Arg.actualBitrateFarFast)
		*uplinkspeed=Arg.actualBitrateFarFast;
	close(nFd);      
}
#endif


int qosIfAnyRulesExist(QOS_TABLE_T *table,int *outBoundRule,int *inBoundRule)
{
	QOS_RULE_T *rule;
	int i;
	int outBoundRuleLocal=0,inBoundRuleLocal=0;
	
	for (i = 0; i < MAX_RULE; i++) 
	{
		rule = &table->Rule[i];
		if( rule->Item != 0 ) 
		{
			 if(rule->Flow==QOS_Flow_OUT)
			 	outBoundRuleLocal=1;
			 if(rule->Flow==QOS_Flow_IN)
			 	inBoundRuleLocal=1;
		}// rule != 0
	}	
	// end for loop
	if(outBoundRule)
		*outBoundRule=outBoundRuleLocal;
	if(inBoundRule)
		*inBoundRule=inBoundRuleLocal;
	if((!outBoundRuleLocal)&&(!inBoundRuleLocal))
	{
		return 0; 
	}
	return 1;
}

void RunFunc_QOS_Start(void)
{
	QOS_TABLE_T table;
	int outBoundRule,inBoundRule;
	if(GetConfigToQOSTable(&table))
	{
		qosIfAnyRulesExist(&table,&outBoundRule,&inBoundRule);
		CreateQOSTableToScript(&table,outBoundRule,inBoundRule);	
	}
}
int GetConfigToQOSTable(QOS_TABLE_T *table)
{
	int NonAsgnRateType=0,i=0;
	QOS_RULE_T *rule;
	char signature[4];
	int version;
	FILE *fp;
	

	//fp = fopen(PROGRAM_SCRIPT_FILE, "r");
	memset( (void *)table, 0, sizeof(QOS_TABLE_T));
	fp = fopen("/flash/qos_conf1.conf", "r");
	if (!fp) {
		return 0;
	}
	fscanf(fp,"%s\n", signature);
	if(strcmp(signature,"QOS"))
	{
		fclose(fp);
		return  0;
	}
	fscanf(fp,"%d\n", &version);
	if(version !=0x10)// we can not forward version compatible
	{
		fclose(fp);
		return  0;
	}
	if ( fscanf(fp,"%d\n",&table->ISPBandwidthType)!=1)
	{
		fclose(fp);
		return  0;
	} 

	if ( fscanf(fp,"|%d|%d|\n",&table->ISPUpstreamInputRate,&table->ISPDownstreamInputRate)!=2)
	{
		fclose(fp);
		return 0;
	} 
	for (i = 0; i < MAX_RULE; i++) {
			rule = &table->Rule[i];
			if ( fscanf(fp,
				"|%20[^|]|%d|%d|%d|%d|%20[^|]|%20[^|]|%hu|%hu|%20[^|]|%20[^|]|%hu|%hu|%d|%d|%d|%d|%d|%d|\n",
				rule->Name, 
				(int *)&rule->Flow, 
				(int *)&rule->AppType, 
				(int *)&rule->RateType, 
				(int *)&rule->Priority, 
				rule->LocalIpStart, 
				rule->LocalIpEnd, 
				&rule->LocalPortStart, 
				&rule->LocalPortEnd, 
				rule->RemoteIpStart, 
				rule->RemoteIpEnd, 
				&rule->RemotePortStart, 
				&rule->RemotePortEnd, 
				&rule->gauranteeRate, // ubit of r2q.  For examples, if r2q is 2, then the unit is 2*12k.  so, the rate is (rule->gauranteeRate)*12*2kbit
				&rule->dscpMarking ,//index to the dscpMarkingTable
				&rule->timeblock.alwaysBlock, 
				&rule->timeblock.days_match, 
				&rule->timeblock.time_start, 
				&rule->timeblock.time_stop
				) == -1 ) break;
			if(rule->gauranteeRate == 0) //impossible
				break;
			rule->Item = i+1; 
			if(rule->LocalIpStart[0]=='&')
				rule->LocalIpStart[0]='\0';
			if(rule->LocalIpEnd[0]=='&')
				rule->LocalIpEnd[0]='\0';
			if(rule->RemoteIpStart[0]=='&')
				rule->RemoteIpStart[0]='\0';
			if(rule->RemoteIpEnd[0]=='&')
				rule->RemoteIpEnd[0]='\0';
			table->TotalNum++;
			table->NextItem++;
	}
	if(table->TotalNum == 0)
	fscanf(fp,"\n");
	if ( fscanf(fp,"%d\n",&NonAsgnRateType)!=1)
	{
		fclose(fp);
		return -1;
	} 
	table->NonAsgnRateType=NonAsgnRateType;
	fclose(fp);
 	return i;
}// end GetConfigToQOSTable


FILE *outfp_ipt_add,*outfp_ipt_del,*outfp_sh_add,*outfp_sh_del,*outfp_tc_batch;

int CreateQOSTableToScript(QOS_TABLE_T *table,int outBoundRule,int inBoundRule)
{
	QOS_RULE_T *rule;
	int r2qUpstream;
	int r2qDownstream;
	int gRates,accuOutBoundRate=0,accuInBoundRate=0,remaindingOutboundRate,remaindingInboundRate;
	int realOutMaxRate,realInMaxRate,i;
	int uplinkspeed,downlinkspeed;
	
	outfp_ipt_add = fopen(QOS_CONF_FN_RULE_IPT_ADD, "w");
	if(!outfp_ipt_add)
	{
		printf("open file %s for write error!\n",QOS_CONF_FN_RULE_IPT_ADD);
		return -1;
	}
	//rename(QOS_CONF_FN_RULE_DEL, QOS_CONF_FN_RULE_DEL_OLD); // keep the old del scripts.
	outfp_ipt_del = fopen(QOS_CONF_FN_RULE_IPT_DEL, "w");
	if(!outfp_ipt_del)
	{
		printf("open file %s for write error!\n",QOS_CONF_FN_RULE_IPT_DEL);
		return -1;
	}

	outfp_sh_add = fopen(QOS_CONF_FN_RULE_SHELL_ADD, "w");
	if(!outfp_sh_add)
	{
		printf("open file %s for write error!\n",QOS_CONF_FN_RULE_SHELL_ADD);
		return -1;
	}
	outfp_sh_del = fopen(QOS_CONF_FN_RULE_SHELL_DEL, "w");
	if(!outfp_sh_del)
	{
		printf("open file %s for write error!\n",QOS_CONF_FN_RULE_SHELL_DEL);
		return -1;
	}
	outfp_tc_batch = fopen(QOS_CONF_FN_TC_BATCH, "w");
	if(!outfp_tc_batch)
	{
		printf("open file %s for write error!\n",QOS_CONF_FN_TC_BATCH);
		return -1;
	}
	//Note if ADSL is OK, we need to change this defs.
//#define WAN_IF "vlan2"

	
	fprintf(outfp_sh_add, "#!/bin/sh\n");
	//fprintf(outfp_sh_add, ". /var/etc/status\n");
	
	if(table->ISPBandwidthType) // from maunal input
	{
		uplinkspeed=table->ISPUpstreamInputRate;
		downlinkspeed=table->ISPDownstreamInputRate;
	}
	else
		getDownUpStreamRate(&downlinkspeed,&uplinkspeed);
	realOutMaxRate=(int)(((double)uplinkspeed)*0.9);
	//realInMaxRate=(int)(((double)downlinkspeed)*0.9);
	realInMaxRate=(int)(((double)downlinkspeed)*0.85);// We test with Seednet.
 // if the rate is too low, need to use r2q. We shall use r2q to set it to 12k bits.
// the deafult r2q is 10 (10*12 kbits).  r2q=smallest rate you have /12kbits.
// When r2q is 1, the max rate is 1559kbit.   So, the max. ADSL rate is 1.7M. (1.7M *0.9=1.53M) (OR 1.8M *0.85=1.534.M)
// so, if ADSL rate <1.7M, the r2q is 1 and the granulity (mini. rate) shall be 12k.
// so, if ADSL rate <3.4M, >1.7M the r2q is 2 and the  the granulity (mini. rate) shall be 24k.
//.........
	r2qUpstream=uplinkspeed/1700+1;/* 1700K=1.7M*/
	//r2qDownstream=downlinkspeed/1700+1;/* 1700K=1.7M*/
	r2qDownstream=downlinkspeed/1800+1;/* 1800K=1.8M*/
	
	if(outBoundRule)
	{
		//fprintf(outfp_sh_add, "#for outbound main qdisc\n");
		fprintf(outfp_tc_batch, "qdisc add dev %s root handle 1: htb default 0x100 r2q %d\n",wan_if,r2qUpstream);
		fprintf(outfp_tc_batch, "class add dev %s parent 1: classid 1:1 htb rate %dkbit ceil %dkbit\n",wan_if,realOutMaxRate,realOutMaxRate);
		fprintf(outfp_ipt_add, "iptables -t mangle -N MYSHAPER-OUT\n");
		fprintf(outfp_ipt_add, "iptables -t mangle -I POSTROUTING -o %s -j MYSHAPER-OUT\n",wan_if);
	}
	
	if(inBoundRule)
	{
		//fprintf(outfp_sh_add, "#for inbound main qdisc\n");
		fprintf(outfp_tc_batch, "qdisc add dev imq0 root handle 1: htb default 0x100 r2q %d\n",r2qDownstream);
		fprintf(outfp_tc_batch, "class add dev imq0 parent 1: classid 1:1 htb rate %dkbit ceil %dkbit\n",realInMaxRate,realInMaxRate);
		fprintf(outfp_ipt_add, "iptables -t mangle -N MYSHAPER-IN\n");
		//fprintf(outfp, "iptables -t mangle -I PREROUTING -i %s -j MYSHAPER-IN\n",WAN_IF);
		fprintf(outfp_ipt_add, "iptables -t mangle -I FORWARD -i %s -j MYSHAPER-IN\n",wan_if); // after NAT ???
	}
	
	
	// clean existing down- and uplink qdiscs, hide errors
	fprintf(outfp_sh_del, "#!/bin/sh\n");
	//fprintf(outfp_sh_del, ". /var/etc/status\n");
	if(outBoundRule)
	{
		fprintf(outfp_sh_del,"tc qdisc del dev %s root  \n",wan_if); 
		fprintf(outfp_ipt_del,"iptables -t mangle -D POSTROUTING -o %s -j MYSHAPER-OUT \n",wan_if); 
		fprintf(outfp_ipt_del,"iptables -t mangle -F MYSHAPER-OUT\n"); 
		fprintf(outfp_ipt_del,"iptables -t mangle -X MYSHAPER-OUT \n"); 
	}
	if(inBoundRule)
	{
		fprintf(outfp_sh_del, "ifconfig imq0 down\n");
		fprintf(outfp_sh_del,"tc qdisc del dev imq0 root  \n"); 
		fprintf(outfp_ipt_del,"iptables -t mangle -D FORWARD -i %s -j MYSHAPER-IN \n",wan_if); 
		fprintf(outfp_ipt_del,"iptables -t mangle -F MYSHAPER-IN \n");
		fprintf(outfp_ipt_del,"iptables -t mangle -X MYSHAPER-IN \n");
		// We implement imq in a static way
		//fprintf(outfp_sh_del,"# ip link set imq0 down 2> /dev/null > /dev/null\n");// if imq
		//fprintf(outfp_sh_del,"#rmmod imq0 2> /dev/null > /dev/null\n"); // if imq
	}
	
	gRates=0;
	if(table->TotalNum)
	{
	for (i = 0; i < MAX_RULE; i++) {
		rule = &table->Rule[i];
		if( rule->Item != 0 ) {
			outputQOSRuleToScript(rule,i,realOutMaxRate,realInMaxRate,&gRates);
			if(rule->Flow == QOS_Flow_OUT)
				accuOutBoundRate+=gRates;
			else
				accuInBoundRate+=gRates;
		}// rule != 0
	}// end for loop
	}
	
	// We then configure the deafult( remaining ones if exists.)
	remaindingOutboundRate=realOutMaxRate-accuOutBoundRate;
	if((outBoundRule)&&(remaindingOutboundRate>=(r2qUpstream*12)))// too small, we then will not add a default one
	{
		if(table->NonAsgnRateType == 0)
		{
		fprintf(outfp_tc_batch,"class add dev %s parent 1:1 classid 1:0x100 htb rate %dkbit ceil %dkbit\n",
		wan_if,remaindingOutboundRate,remaindingOutboundRate);
		}
		else
		{
		fprintf(outfp_tc_batch,"class add dev %s parent 1:1 classid 1:0x100 htb rate %dkbit ceil %dkbit prio 1\n",
		wan_if,remaindingOutboundRate,realOutMaxRate);
		}
		fprintf(outfp_tc_batch,"qdisc add dev %s parent 1:0x100 handle 0x100:  sfq perturb 10\n",wan_if);
	}

	remaindingInboundRate=realInMaxRate-accuInBoundRate;
	if((inBoundRule)&&(remaindingInboundRate>=(r2qDownstream*12)))// too small, we then will not add a default one
	{
		if(table->NonAsgnRateType == 0)
		{
		fprintf(outfp_tc_batch,"class add dev imq0 parent 1:1 classid 1:0x100 htb rate %dkbit ceil %dkbit\n",
		remaindingInboundRate,remaindingInboundRate);
		}
		else
		{
		fprintf(outfp_tc_batch,"class add dev imq0 parent 1:1 classid 1:0x100 htb rate %dkbit ceil %dkbit prio 1\n",
		remaindingInboundRate,realInMaxRate);
		}
		
		fprintf(outfp_tc_batch,"qdisc add dev imq0 parent 1:0x100 handle 0x100:  sfq perturb 10\n");
	}
	if(inBoundRule)
	{
		fprintf(outfp_ipt_add, "# finally, instruct these packets to go through the imq0 we set up above using iptables\n");
		//fprintf(outfp_ipt_add, "iptables -t mangle -A MYSHAPER-IN -j IMQ \n");// Yes, we keep this iptables in shell scripts.
		fprintf(outfp_ipt_add, "iptables -t mangle -A MYSHAPER-IN -j IMQ --todev 0\n");// Yes, we keep this iptables in shell scripts.
 		fprintf(outfp_sh_add, "ifconfig imq0 up\n");
	}
	fflush(outfp_ipt_add);
   	fclose(outfp_ipt_add);	
    fclose(outfp_ipt_del);	
	
	fprintf(outfp_sh_add, "tc -batch %s\n",QOS_CONF_FN_TC_BATCH);
    fclose(outfp_sh_add);
	
    fclose(outfp_sh_del);	
	fclose(outfp_tc_batch);	
	chmod(QOS_CONF_FN_RULE_IPT_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(QOS_CONF_FN_RULE_IPT_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(QOS_CONF_FN_RULE_SHELL_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(QOS_CONF_FN_RULE_SHELL_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;


	return 0;
}// end CreateQOSTableToScript

/* aspectou32 should convert the address portion of a spec...
 * "base10"
 * "0base8"
 * "0xbase16"
 * "hostname"
 * "address" */
extern  u_int32_t aspectou32(char *astr, int dns) ;
#define QOS_DSCP_MARK_DISABLE 0xFF
#define QOS_DSCP_MARK_BESTEFFORT 0x0
#define QOS_DSCP_MARK_PREMIUM 0x2E
#define QOS_DSCP_MARK_GOLD_LOW 0x1A
#define QOS_DSCP_MARK_GOLD_MED 0x1C
#define QOS_DSCP_MARK_GOLD_HIGH 0x1E
#define QOS_DSCP_MARK_SILVER_LOW 0x12
#define QOS_DSCP_MARK_SILVER_MED 0x14
#define QOS_DSCP_MARK_SILVER_HIGH 0x16
#define QOS_DSCP_MARK_BRONZE_LOW 0x0A
#define QOS_DSCP_MARK_BRONZE_MED 0x0C
#define QOS_DSCP_MARK_BRONZE_HIGH 0x0E

unsigned char dscpMarkingTable[]={QOS_DSCP_MARK_DISABLE,QOS_DSCP_MARK_BESTEFFORT,QOS_DSCP_MARK_PREMIUM,
	QOS_DSCP_MARK_GOLD_LOW,QOS_DSCP_MARK_GOLD_MED,QOS_DSCP_MARK_GOLD_HIGH,
	QOS_DSCP_MARK_SILVER_LOW,QOS_DSCP_MARK_SILVER_MED,QOS_DSCP_MARK_SILVER_HIGH,
QOS_DSCP_MARK_BRONZE_LOW,QOS_DSCP_MARK_BRONZE_MED,QOS_DSCP_MARK_BRONZE_HIGH};
void outputQOSRuleToScript(QOS_RULE_T *rule,int ruleIndex,int realOutMaxRate,int realInMaxRate,int *gRate)
{	
	u_int32_t qosSIpFrom,qosSIpTo,qosDIpFrom,qosDIpTo;
	int qosSPF,qosSPT,qosDPF,qosDPT;
	char *qosSIpFromStr,*qosSIpToStr,*qosDIpFromStr,*qosDIpToStr;

        char iprange[20]="",sipstr[45]="",dipstr[45]="", protstr[8]="",sportstr[20]="",dportstr[20]="";
	int assignedHandle=0x10*(ruleIndex+1);
	char timeBlocking[128]="";
	int needSeparateRulesForUDPAndTCP=0;
	
	// We need to transfer the local/Remote to Source/Detination
	if(rule->Flow==QOS_Flow_OUT)
	{
		qosSIpFromStr=rule->LocalIpStart;
		qosSIpToStr=rule->LocalIpEnd;
		qosDIpFromStr=rule->RemoteIpStart;
		qosDIpToStr=rule->RemoteIpEnd;
		qosSPF=rule->LocalPortStart;
		qosSPT=rule->LocalPortEnd;
		qosDPF=rule->RemotePortStart;
		qosDPT=rule->RemotePortEnd;
	}
	else
	{
		qosSIpFromStr=rule->RemoteIpStart;
		qosSIpToStr=rule->RemoteIpEnd;
		qosDIpFromStr=rule->LocalIpStart;
		qosDIpToStr=rule->LocalIpEnd;
		qosSPF=rule->RemotePortStart;
		qosSPT=rule->RemotePortEnd;
		qosDPF=rule->LocalPortStart;
		qosDPT=rule->LocalPortEnd;
	}
	
	
	qosSIpFrom = aspectou32(qosSIpFromStr,0);
	qosSIpTo = aspectou32(qosSIpToStr,0);
	qosDIpFrom = aspectou32(qosDIpFromStr,0);
	qosDIpTo = aspectou32(qosDIpToStr,0);
	
	if((qosSIpFrom==0)&&(qosDIpFrom==0))
		;
	else
		strcpy(iprange,"-m iprange");
		
	if(qosSIpFrom!=0)
	{
		// NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
		if(qosSIpTo)
			sprintf(sipstr,"--src-range %s-%s",qosSIpFromStr,qosSIpToStr);
		else
			sprintf(sipstr,"--src-range %s",qosSIpFromStr);
	}
	if(qosDIpFrom!=0)
	{
		// NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
		if(qosDIpTo)
			sprintf(dipstr,"--dst-range %s-%s",qosDIpFromStr,qosDIpToStr);
		else
			sprintf(dipstr,"--dst-range %s",qosDIpFromStr);
	}
	
			 
	if(qosSPF!=0)
	{
		if(qosSPT!=0)
			sprintf(sportstr,"--sport %d:%d", qosSPF,qosSPT);
		else
			sprintf(sportstr,"--sport %d", qosSPF);
	}
	if(qosDPF!=0)
	{
		if(qosDPT!=0)
			sprintf(dportstr,"--dport %d:%d", qosDPF,qosDPT);
		else
			sprintf(dportstr,"--dport %d", qosDPF);
	}
	
	// Process the post string to save code
	switch(rule->AppType)
	{

		 case QOS_APP_Type_ANY:
		 	// special concerns for proto type = any when port is present
		 	if((qosSPF==0)&&(qosDPF==0))
				break;
			needSeparateRulesForUDPAndTCP=1;
			//we need to make the rules both for UDP and TCP, we make TCP in default.
		 case QOS_APP_Type_TCP:
			 strcpy(protstr, "-p TCP");
		     break;
		 case QOS_APP_Type_UDP:
			 strcpy(protstr, "-p UDP");
			 break;
		 case QOS_APP_Type_ICMP:
			 strcpy(protstr, "-p ICMP");
		     break;
		 case QOS_APP_Type_GRE:
			 strcpy(protstr, "-p 47");
		     break;
		 default:
		     break;
	 }
	outputTimeBLockForIptables(&rule->timeblock,timeBlocking);

	if((rule->Flow==QOS_Flow_OUT))
	{
		fprintf(outfp_ipt_add,"iptables -t mangle -A MYSHAPER-OUT %s %s %s %s %s %s %s -j MARK --set-mark 0x%x\n",
			iprange, sipstr,dipstr ,protstr,sportstr,dportstr, timeBlocking,assignedHandle);
		if(needSeparateRulesForUDPAndTCP)
		{  //now is the turn for udp protocol
			fprintf(outfp_ipt_add,"iptables -t mangle -A MYSHAPER-OUT %s %s %s %s %s %s %s -j MARK --set-mark 0x%x\n",
			iprange, sipstr,dipstr ,"-p UDP",sportstr,dportstr, timeBlocking,assignedHandle);
		}
			//*gRate=rule->gauranteeRate*r2qUpstream*12;
		*gRate=(rule->gauranteeRate*realOutMaxRate)/100;
		if(rule->RateType==QOS_Rate_Type_FIXED)
		{
			fprintf(outfp_tc_batch,"class add dev %s parent 1:1 classid 1:0x%x htb rate %dkbit ceil %dkbit\n",
			wan_if,assignedHandle,*gRate,*gRate);
		}
		else
		{
			fprintf(outfp_tc_batch,"class add dev %s parent 1:1 classid 1:0x%x htb rate %dkbit ceil %dkbit prio %d\n",
				wan_if,assignedHandle,*gRate,realOutMaxRate,rule->Priority);
		}
		
		fprintf(outfp_tc_batch,"filter add dev %s parent 1:0 prio 1 protocol ip handle 0x%x fw flowid 1:0x%x\n",
		wan_if,assignedHandle,assignedHandle);
		fprintf(outfp_tc_batch,"qdisc add dev %s parent 1:0x%x handle 0x%x:  pfifo limit 5\n",
		wan_if,assignedHandle,assignedHandle);
		// only DCSP marking for outgoing and for TCP only
		if(dscpMarkingTable[rule->dscpMarking]!=QOS_DSCP_MARK_DISABLE)
		{
			fprintf(outfp_ipt_add,"iptables -I FORWARD -t mangle -o %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x\n",
			wan_if,iprange, sipstr,dipstr ,protstr,sportstr,dportstr, dscpMarkingTable[rule->dscpMarking]);
			fprintf(outfp_ipt_del,"iptables -D FORWARD -t mangle -o %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x\n",
			wan_if,iprange, sipstr,dipstr ,protstr,sportstr,dportstr, dscpMarkingTable[rule->dscpMarking]);
			if(needSeparateRulesForUDPAndTCP)
			{  //now is the turn for udp protocol
				fprintf(outfp_ipt_add,"iptables -I FORWARD -t mangle -o %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x\n",
				wan_if,iprange, sipstr,dipstr ,"-p UDP",sportstr,dportstr, dscpMarkingTable[rule->dscpMarking]);
				fprintf(outfp_ipt_del,"iptables -D FORWARD -t mangle -o %s %s %s %s %s %s %s -j DSCP --set-dscp 0x%x\n",
				wan_if,iprange, sipstr,dipstr ,"-p UDP",sportstr,dportstr, dscpMarkingTable[rule->dscpMarking]);
			}
		}
	}
	else
	{
		fprintf(outfp_ipt_add,"iptables -t mangle -A MYSHAPER-IN %s %s %s %s %s %s %s -j MARK --set-mark 0x%x\n",
		iprange, sipstr,dipstr ,protstr,sportstr,dportstr, timeBlocking,assignedHandle);

//		fprintf(outfp_ipt_add,"iptables -t mangle -A MYSHAPER-IN %s %s %s %s %s %s %s -j IMQ --todev 0\n",
//		iprange, sipstr,dipstr ,protstr,sportstr,dportstr, timeBlocking);//,assignedHandle);
		if(needSeparateRulesForUDPAndTCP)
		{  //now is the turn for udp protocol
			fprintf(outfp_ipt_add,"iptables -t mangle -A MYSHAPER-IN %s %s %s %s %s %s %s -j MARK --set-mark 0x%x\n",
			iprange, sipstr,dipstr ,"-p UDP",sportstr,dportstr, timeBlocking,assignedHandle);
		}
		//*gRate=rule->gauranteeRate*r2qDownstream*12;
		*gRate=(rule->gauranteeRate*realInMaxRate)/100;
		if(rule->RateType==QOS_Rate_Type_FIXED)
		{
		fprintf(outfp_tc_batch,"class add dev imq0 parent 1:1 classid 1:0x%x htb rate %dkbit ceil %dkbit\n",
		assignedHandle,*gRate,*gRate);
		}
		else
		{
		fprintf(outfp_tc_batch,"class add dev imq0 parent 1:1 classid 1:0x%x htb rate %dkbit ceil %dkbit prio %d\n",
		assignedHandle,*gRate,realInMaxRate,rule->Priority);
		}
		//fprintf(outfp_tc_batch,"filter add dev imq0 parent 1:0 prio 1 protocol ip handle 0x%x fw flowid 1:0x%x\n",
		fprintf(outfp_tc_batch,"filter add dev imq0 parent 1:0 prio 0 protocol ip handle 0x%x fw flowid 1:0x%x\n",
		assignedHandle,assignedHandle);

		//fprintf(outfp_tc_batch,"qdisc add dev imq0 parent 1:0x%x handle 0x%x:  pfifo limit 5\n",
		fprintf(outfp_tc_batch,"qdisc add dev imq0 parent 1:0x%x handle 0x%x:  sfq perturb 10\n",
		assignedHandle,assignedHandle);
	}	
 }



