#include <stdio.h>
#include <string.h>
#include "linux/config.h"

extern int pstncheck_main(int argc, char *argv[]);
extern int sip_alg_wk_main(int argc, char *argv[]);
struct app_record {
		char *name;
		int (*main)(int, char **);
};

/* Most frequently run applications first. */
struct app_record app_records[] = {
	{ "pstncheck", pstncheck_main},
	{ "sip_alg_wk", sip_alg_wk_main},
};

#define MAX_APP_RECORDS (sizeof(app_records)/sizeof(struct app_record))

char *get_app_name(char *path)
{
	char *p;

	p = strrchr(path, '/');
	if (!p)
	{
		return path;
	}
	p++;
	return p;
}

int main(int argc, char *argv[])
{
	int i;
	char *app_name = get_app_name(argv[0]);

	for (i = 0; i < MAX_APP_RECORDS; i++)
	{
		//printf("%s,%s\n",app_name,app_records[i].name);
		if (strcmp(app_name, app_records[i].name) == 0)
		{
			return app_records[i].main(argc, argv);
		}
	}
	printf("Application %s not found\n", app_name);
	return -1;
}
