#include <stdio.h>
#include <unistd.h>
#include <ctype.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/tc3162dmtctrl.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <string.h>

extern void run_task (char *cmd, ...);
#define PSTNRULES "0,1,15,1,0,,PSTN;1,1,15,1,1,,PSTN;2,1,15,1,2,,PSTN;3,1,15,1,3,,PSTN;4,1,15,1,4,,PSTN;5,1,15,1,5,,PSTN;6,1,15,1,6,,PSTN;7,1,15,1,7,,PSTN;8,1,15,1,8,,PSTN;9,1,15,1,9,,PSTN;"

#define REGISTER_OK "Register OK"
#define LINE_TALK "TALK"

#define DPRINTF printf
#ifdef LIBVER
#define MAINFUNC pstncheck_main
#else
#define MAINFUNC main
#endif

#define ST_ADSL 1
#define ST_SIP	2
#define ST_TALK 4

typedef struct LINE_STATUS
{
  char sip[32];
  char line[32];
} Line_Status;

static Line_Status l[2];

static int
get_voip_status (int i)
{
  FILE *fp;
  char buf1[64];
  int j = 0;
  int k = 0;
  char line[16];
  /* get registrar status and line status */
  sprintf (line, "/tmp/line%d", i);
  fp = fopen (line, "r");
  if (fp != 0)
    {
      memset (&l[i], 0, sizeof (Line_Status));
      fgets (buf1, 64, fp);
      k = sscanf (buf1, "#%20[^#]#\n", &(l[i].sip));
      j += k;
      fgets (buf1, 64, fp);
      k = sscanf (buf1, "#%20[^#]#\n", &(l[i].line));
      j += k;
      fclose (fp);
    }
  return j;
}


int
MAINFUNC ()
{
  char status = 0;
  char old_status = 0;
  char testbuf[512];
  char newbuf[512];
  char buf[64];
  char *loc;
  int num1 = 0;
  int num2 = 0;
  char *newbufptr = newbuf;
  FILE *fp1;
  FILE *fp2;
  //char fac_pid[32];
  int fac_pid;
  FILE *fp;
  int i = 0;
  int j = 0;
  int count=0;
  int nFd;
  DMTCTRL_CONNECTION_INFO Arg;
  DMTCTRL_DMT_INFO ArgStatus;
//    signal(SIGUSR1, SIG_IGN);
  while (1)
    {
#ifndef _SUPPORT_TELEWELL_VOIP
      nFd = open ("/dev/dmtdev", O_RDWR);

      ioctl (nFd, DMTIOCTL_GET_DMT_INFO, &ArgStatus);
      close (nFd);

      if (ArgStatus.dmt_status == ADSL_UP)
	{
	  (status) |= ST_ADSL;
	}
      else
	{
	  (status) = 0;
	}
#endif
/* ioctl and read adsl status */
      /* notify factoryreset to update SIP status */
/* polling talk status */
#if 1
      if ((status) & ST_TALK)
	{
//	  printf ("talking\n");
	  /* read file to check talk is over */
	  fp1 = fopen ("/tmp/line0over", "r");
	  fp2 = fopen ("/tmp/line1over", "r");
	  if (fp1 != 0)
	    {
	      /* if talk is over */
	      (status) &= ~(ST_TALK);
	      fclose (fp1);
	      unlink ("/tmp/line0over");
	    }
	  if (fp2 != 0)
	    {
	      /* if talk is over */
	      (status) &= ~(ST_TALK);
	      fclose (fp2);
	      unlink ("/tmp/line1over");
	    }
	}
      else
#endif
	{
/* signal and read sip status */
#if 1
	//	run_script("/usr/bin/renew_sip.sh",0,0,0,0);
	      run_task ("/bin/echo", "/bin/echo", "-r", NULL);
	  if ((fp = fopen ("/var/state/actact.pid", "r")) != NULL)
	    {
	      fscanf (fp, "%d", &fac_pid);
//	      printf ("pid=%s\n", fac_pid);
	      //memory leakage
	      kill (fac_pid, SIGUSR1);
	//      run_task ("/bin/kill", "/bin/kill", "-16", fac_pid, NULL);
	      fclose (fp);
	    }
#endif
#if 1
	  /* Robert added 2006/05/09 -- end -- */
	  i = get_voip_status (0);
	  j += i;
	  i = get_voip_status (1);
	  j += i;
	  if (j != 0)
	    {
	      if ((strcmp (l[0].sip, REGISTER_OK) == 0)
		  || (strcmp (l[1].sip, REGISTER_OK) == 0))
		{
		  (status) |= (ST_SIP);
		  if ((strcmp (l[0].line, LINE_TALK) == 0)
		      || (strcmp (l[1].line, LINE_TALK) == 0))
		    {
		      (status) |= (ST_TALK);
		    }
		  else
		    {
		      (status) &= ~(ST_TALK);
		    }
		}
	      else
		{
		  (status) &= ~(ST_SIP);
//		  printf ("error reading line status!\n");
		}
	    }
#endif
	}
//      query_status (&status);
      //printf("status=%d\n",status);
#ifndef _SUPPORT_TELEWELL_VOIP
      if (status != old_status)
	{
	  FILE *fp;
	  fp = fopen ("/flash/dialplan.cfg", "r");
	  if (fp != 0)
	    {
	      fgets (testbuf, 512, fp);
	      fclose (fp);
	    }
	  else
	    continue;
	 // printf ("%s\n", testbuf);
	  loc = (char *) ((unsigned int) (testbuf) - 1);
	  memset(newbuf,0,512);
  	  newbufptr = newbuf;
	  do
	    {
	      memset (buf, 0, sizeof (buf));
	      i = sscanf (loc + 1, "%64[^;];", buf);
	      if (i > 0)
		{
		  //printf ("%s\n", buf);
		  j = sscanf (buf, "%d,1,15,1,%d,,PSTN", &num1, &num2);
		  if (j > 0 && num1 == num2 && num1 < 10 && num1 > -1)
		    {
		      //printf ("bingo %d\n", num1);
		    }
		  else
		    {
		      strcpy (newbufptr, buf);
		      newbufptr += strlen (buf);
		      strcpy (newbufptr++, ";");
		    }

		}
	      loc = strstr ((loc + 1), ";");
	    }
	  while (loc != 0);

	  if (status == (ST_ADSL | ST_SIP))
	    {
	      fp = fopen ("/tmp/postdata", "w");
	      if (fp != 0)
		{
		  fprintf (fp, "!/bin/sh\n");
		  fprintf (fp,
			   "wget --post-data=\"table_data=%s&daa=1&prefix=&min=&max=&del=&add=&ip=&protocol=\" http://127.0.0.1:9999/dialplan.asp\n",
			   newbuf);
		  fclose (fp);
		}
	      run_script ("/tmp/postdata", 0, 0, 0, 0);
	      unlink ("/tmp/dialplan.asp");
	    }
	  else if (status == ST_ADSL || status == ST_SIP || status == 0)
	    {
	      fp = fopen ("/tmp/postdata", "w");
	      if (fp != 0)
		{
		  fprintf (fp, "!/bin/sh\n");
		  fprintf (fp,
			   "wget --post-data=\"table_data=%s%s&daa=1&prefix=0&min=1&max=15&del=1&add=0&ip=&protocol=PSTN\" http://127.0.0.1:9999/dialplan.asp\n",
			   PSTNRULES, newbuf);
		  fclose (fp);
		}
	      run_script ("/tmp/postdata", 0, 0, 0, 0);
	      unlink ("/tmp/dialplan.asp");
	    }
	  old_status = status;
	}
#endif

	//update actact pid
      sleep (10);
#if 0
      count++;
      if(count > 20)
      {
	      printf("33\n");
//restart actact //act's bug
	run_task("/bin/kill","bin/kill",fac_pid,NULL);
	run_task("/usr/bin/actact","/usr/bin/actact",NULL);
	printf("44\n");
	count=0;
      }
#endif
    }
}
