/*
	Auto Scan when ADSL Sync up at Factory Reset 1st 
	Behavior:
		1.If AUTOSCAN=yes then do auto-scan
		2.Do auto scan after Sync up
		3.If Result Num == 1  then change wan setting and restart this wan then set AUTOSCAN=no
		4.If Result Num >1 or <1 then Give-up this setting
		5.exit

	Author:	Julian
	Date:2005/06/16
		
*/
#include <string.h> /* memset */
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h> /* sleep */
#include <fcntl.h>      /* open */ 
#include <sys/ioctl.h>  /* ioctl */
#include <sys/syslog.h>
#include <linux/tc3162dmtctrl.h>
#include "../websconfig/lan_conf.h" 
#include "../websconfig/wan.h" 
#include "../iptables-1.2.11/runFunc.h"
enum wan_connect_status {
        DISCONNECTED=0,
        CONNECTED,
        CONNECTING,
        DISCONNECTING
};
#define WAN_QUICK_TYPE_NO_WAN_PROTOCOL 0
#define WAN_QUICK_TYPE_BRIDGE_VC     9
#define WAN_QUICK_TYPE_BRIDGE_LLC    10
#define WAN_QUICK_TYPE_DHCPC_VC     7
#define WAN_QUICK_TYPE_DHCPC_LLC    8
#define WAN_QUICK_TYPE_PPPOE_VC     12
#define WAN_QUICK_TYPE_PPPOE_LLC    2
#define WAN_QUICK_TYPE_PPPOA_VC     1
#define WAN_QUICK_TYPE_PPPOA_LLC    11


extern long* find_pid_by_name1( char* pidName);
extern char* read_file_para_value(char *filename, char *arg1 ,char *buf);
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
WAN_CONFIG_DATA wan_config;
//WAN_CONFIG_DATA old_wan_config;
static void resetCurrentWanCfg(void){
	//WAN_CONFIG_DATA *d = &old_wan_config;
	WAN_CONFIG_DATA *d1 = &wan_config;
	//memset(d,0,sizeof(WAN_CONFIG_DATA));
	memset(d1,0,sizeof(WAN_CONFIG_DATA));
}
int IsExistProcess(char *ProcessName){
	long *killpid;
	
	killpid=find_pid_by_name1(ProcessName);
	if (!killpid || *killpid<=0)
		return 0;
	else
		return 1;
}
static void Save_Wan_Config (int i,WAN_CONFIG_DATA *d){
	
	FILE *fp;
	d->Wan_Type=i;
	if((fp=fopen(WAN_CONFIG_FILE,"w"))!=NULL)
	{
	
	/*
	 *  i=0 1483 Routed
	 *  i=1 1483 Bridged
	 *  i=2 PPPOA
	 *  i=3 IPOA
	 *  i=4 PPPOE
	 */
	
	fprintf(fp, "#:%d:%d\n",d->Wan_Type,d->Quick_Wan_Type);
	//1483 Routed
	load_blank_string(&d->Routed_Description);
	load_blank_string(&d->Routed_IP);
	load_blank_string(&d->Routed_Netmask);
	load_blank_string(&d->Routed_Gateway);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->Routed_Description,
		d->Routed_VPI,
		d->Routed_VCI,
		d->Routed_ATM_Class,
		d->Routed_NAT,
        	d->Routed_Encapsulation_Method,
	        d->Routed_IP_Assignment,
		d->Routed_IP,
		d->Routed_Netmask,
		d->Routed_Gateway,
		d->Routed_RIP,
		d->Routed_MTU
		);
	
	load_blank_string(&d->Bridged_Description);	
	//1483 Bridged
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|\n",
		d->Bridged_Description,
		d->Bridged_VPI,
		d->Bridged_VCI,
		d->Bridged_ATM_Class,
		d->Bridged_Encapsulation_Method,
        	d->Bridged_Ether_Filter_Type,
	        d->Bridged_Spanning_Bridge_Interface
		);

	load_blank_string(&d->PPPOA_Description);
	load_blank_string(&d->PPPOA_Username);
	load_blank_string(&d->PPPOA_Password);
	load_blank_string(&d->PPPOA_IP);
	//PPPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%d|%hu|%d|%hu|\n",
		d->PPPOA_Description,
		d->PPPOA_VPI,
		d->PPPOA_VCI,
		d->PPPOA_ATM_Class,
		d->PPPOA_Encapsulation_Method,
		d->PPPOA_NAT,
		d->PPPOA_Username,
		d->PPPOA_Password,
		d->PPPOA_IP,
	        d->PPPOA_Authentication_Protocol,
	        d->PPPOA_Connection,
	        d->PPPOA_Idle_Timeout,
		d->PPPOA_RIP,
		d->PPPOA_MTU
		);
	
	load_blank_string(&d->IPOA_Description);
	load_blank_string(&d->IPOA_IP);
	load_blank_string(&d->IPOA_Netmask);
	load_blank_string(&d->IPOA_Gateway);
	//IPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->IPOA_Description,
		d->IPOA_VPI,
		d->IPOA_VCI,
		d->IPOA_ATM_Class,
		d->IPOA_NAT,
	        d->IPOA_IP_Assignment,
		d->IPOA_IP,
		d->IPOA_Netmask,
		d->IPOA_Gateway,
		d->IPOA_RIP,
		d->IPOA_MTU
		);
		
	//PPPOE
	load_blank_string(&d->PPPOE_Description);
	load_blank_string(&d->PPPOE_Username);
	load_blank_string(&d->PPPOE_Password);
	load_blank_string(&d->PPPOE_Service_Name);
	load_blank_string(&d->PPPOE_IP);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%s|%d|%d|%hu|%d|%hu|%d|\n",
		d->PPPOE_Description,
		d->PPPOE_VPI,
		d->PPPOE_VCI,
		d->PPPOE_ATM_Class,
		d->PPPOE_Encapsulation_Method,
		d->PPPOE_NAT,
		d->PPPOE_Username,
		d->PPPOE_Password,
		d->PPPOE_Service_Name,
		d->PPPOE_IP,
	        d->PPPOE_Authentication_Protocol,
	        d->PPPOE_Connection,
	        d->PPPOE_Idle_Timeout,
		d->PPPOE_RIP,
		d->PPPOE_MTU,
		d->PPPOE_RELAY
		);
	fclose(fp);
	}
//	d->Quick_Wan_Type=d->Wan_Type;
}	
static void Load_Wan_Config (void){
	#define WAN_CONFIG_FILE "/flash/wan.conf"
	FILE *fp;
	char line[1024];
	resetCurrentWanCfg();
	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL)
	{
	if (fgets(line, 1024, fp))
		sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	//1483 Routed
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		wan_config.Routed_Description,
		&wan_config.Routed_VPI,
		&wan_config.Routed_VCI,
		(int *)&wan_config.Routed_ATM_Class,
		(int *)&wan_config.Routed_NAT,
        	(int *)&wan_config.Routed_Encapsulation_Method,
	        (int *)&wan_config.Routed_IP_Assignment,
		wan_config.Routed_IP,
		wan_config.Routed_Netmask,
		wan_config.Routed_Gateway,
		(int *)&wan_config.Routed_RIP,
		&wan_config.Routed_MTU
		);
	}
	print_blank_string(&wan_config.Routed_Description);
	print_blank_string(&wan_config.Routed_IP);
	print_blank_string(&wan_config.Routed_Netmask);
	print_blank_string(&wan_config.Routed_Gateway);
	
	//1483 Bridged
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|\n",
		wan_config.Bridged_Description,
		&wan_config.Bridged_VPI,
		&wan_config.Bridged_VCI,
		(int *)&wan_config.Bridged_ATM_Class,
		(int *)&wan_config.Bridged_Encapsulation_Method,
        	(int *)&wan_config.Bridged_Ether_Filter_Type,
	        (int *)&wan_config.Bridged_Spanning_Bridge_Interface
		);
	}
	
	print_blank_string(&wan_config.Bridged_Description);	
	//PPPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%20[^|]|%d|%d|%hu|%d|%hu|\n",
		wan_config.PPPOA_Description,
		&wan_config.PPPOA_VPI,
		&wan_config.PPPOA_VCI,
		(int *)&wan_config.PPPOA_ATM_Class,
		(int *)&wan_config.PPPOA_Encapsulation_Method,
		(int *)&wan_config.PPPOA_NAT,
		wan_config.PPPOA_Username,
		wan_config.PPPOA_Password,
		wan_config.PPPOA_IP,
	        (int *)&wan_config.PPPOA_Authentication_Protocol,
	        (int *)&wan_config.PPPOA_Connection,
	        &wan_config.PPPOA_Idle_Timeout,
		(int *)&wan_config.PPPOA_RIP,
		&wan_config.PPPOA_MTU
		);
	}
	
	print_blank_string(&wan_config.PPPOA_Description);
	print_blank_string(&wan_config.PPPOA_Username);
	print_blank_string(&wan_config.PPPOA_Password);
	print_blank_string(&wan_config.PPPOA_IP);	
	//IPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,"|%50[^|]|%hu|%hu|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",wan_config.IPOA_Description,
		&wan_config.IPOA_VPI,
		&wan_config.IPOA_VCI,
		(int *)&wan_config.IPOA_ATM_Class,
		(int *)&wan_config.IPOA_NAT,
	        (int *)&wan_config.IPOA_IP_Assignment,
		wan_config.IPOA_IP,
		wan_config.IPOA_Netmask,
		wan_config.IPOA_Gateway,
		(int *)&wan_config.IPOA_RIP,
		&wan_config.IPOA_MTU
		);
	}	
	
	print_blank_string(&wan_config.IPOA_Description);
	print_blank_string(&wan_config.IPOA_IP);
	print_blank_string(&wan_config.IPOA_Netmask);
	print_blank_string(&wan_config.IPOA_Gateway);	
	//PPPOE
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%32[^|]|%20[^|]|%d|%d|%hu|%d|%hu|%d|\n",
		wan_config.PPPOE_Description,
		&wan_config.PPPOE_VPI,
		&wan_config.PPPOE_VCI,
		(int *)&wan_config.PPPOE_ATM_Class,
		(int *)&wan_config.PPPOE_Encapsulation_Method,
		(int *)&wan_config.PPPOE_NAT,
		wan_config.PPPOE_Username,
		wan_config.PPPOE_Password,
		wan_config.PPPOE_Service_Name,
		wan_config.PPPOE_IP,
	        (int *)&wan_config.PPPOE_Authentication_Protocol,
	        (int *)&wan_config.PPPOE_Connection,
	        &wan_config.PPPOE_Idle_Timeout,
		(int *)&wan_config.PPPOE_RIP,
	       &wan_config.PPPOE_MTU,
		&wan_config.PPPOE_RELAY
		);
	}
	print_blank_string(&wan_config.PPPOE_Description);
	print_blank_string(&wan_config.PPPOE_Username);
	print_blank_string(&wan_config.PPPOE_Password);
	print_blank_string(&wan_config.PPPOE_Service_Name);
	print_blank_string(&wan_config.PPPOE_IP);
	fclose(fp);
	}
//	if (wan_config.Quick_Wan_Type==0)
//		wan_config.Quick_Wan_Type=wan_config.Wan_Type;	
}
static void runStartBr2684ctl(int Vpi,int Vci,int Enc){
	char str_vpi[10];
	char str_vci[10];
	char str_enc[2];
	sprintf(str_vpi,"%d",Vpi);
	sprintf(str_vci,"%d",Vci);
	sprintf(str_enc,"%d",Enc);
	run_script("/etc/scripts/br2684ctl_start.sh",str_vpi,str_vci,str_enc);
}
static void runStopPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/pppoa.sh","stop",0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

static void runStartPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	run_script("/etc/scripts/pppoa.sh","start",0,0);
}

static void runStopRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","stop",0,0);
}
static void runStopFirewall(){
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	
	//run_script("/etc/scripts/fw.sh","stop",0,0);
}
static void runStopDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/dhcpc.sh","stop",0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
}
static void runStartDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	run_script("/etc/scripts/dhcpc.sh","start",0,0);
}
static void runStopBr2684ctl(){
	long *pid;
	char str_pid[10];
	pid=find_pid_by_name1("br2684ctl");
	sprintf(str_pid,"%lu",*pid);
	run_task("kill","kill","-15",str_pid,NULL);	
	sleep(1);
	run_task("br2684ctl","br2684ctl","-d","0",NULL);	
//	run_script("/etc/scripts/br2684ctl_stop.sh",0,0,0);
}
static void runStopPppoecd(){
	long *pppoepid;
	char str_pppoepid[10];
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	pppoepid=find_pid_by_name1("pppoecd");
	sprintf(str_pppoepid,"%lu",*pppoepid);
	run_task("/usr/sbin/dmt","setpppoe","0");
	run_task("/usr/sbin/dmt","setpid", "0");
	run_task("kill","kill","-15",str_pppoepid,NULL);
	sleep(3);
	run_task("kill","kill","-9",str_pppoepid,NULL);	
	run_task("route","route","del","default","gw","0.0.0.0",NULL);	
	run_task("brctl","brctl","delif","br0","nas0",NULL);	
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

static void runStartPppoecd(){
	char funcNum[4];
	long *pppoepid;
	char str_pppoepid[10];
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");

	//prevent pppoe run twice on demand mode 20050518
	/*
	Load_Wan_Config();
	if(wan_config.PPPOE_Connection==1)
		runStopPppoecd();
	*/
	// auth fail cause pppoe exist, so if pppoe task exist ,kill it. Julian 20050608
	if (IsExistProcess("pppoecd")){
		runStopPppoecd();
	}
	

	sprintf(funcNum,"%d",FUNCTION_NUM_PPPOE);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	//run_script("/etc/scripts/pppoe.sh","start",0,0);
	pppoepid=find_pid_by_name1("pppoecd");
	sprintf(str_pppoepid,"%lu",*pppoepid);
	run_task("/usr/sbin/dmt","setpppoe","1");
	run_task("/usr/sbin/dmt","setpid", str_pppoepid);
}

/////////////////////////////////////////////////////////////////
static void Run1483Routed(WAN_CONFIG_DATA *d1,int Enc){
	
		/*
		DPRINTF("d->Wan_Type:%d\n",d->Wan_Type);		
		DPRINTF("d1->Wan_Type:%d\n",d1->Wan_Type);		
		DPRINTF("d->Quick_Wan_Type:%d\n",d->Quick_Wan_Type);		
		DPRINTF("d1->Quick_Wan_Type:%d\n",d1->Quick_Wan_Type);		
		DPRINTF("d->Routed_IP_Assignment:%d\n",d->Routed_IP_Assignment);		
		DPRINTF("d1->Routed_IP_Assignment:%d\n",d1->Routed_IP_Assignment);		
		DPRINTF("d->Routed_Encapsulation_Method:%d\n",d->Routed_Encapsulation_Method);		
		DPRINTF("d1->Routed_Encapsulation_Method:%d\n",d1->Routed_Encapsulation_Method);		
		*/
		if(d1->Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");

	
		if(d1->Routed_NAT==0)
			save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
		else	
			save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","dynamic");
		//save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
		save_globe_config(SYS_STATUS_FILE,"WAN=","dynamic");	
		//save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
		runStopRip();
		runStopFirewall();
		runStopDhcpc();
		runStopBr2684ctl();
		sleep(3);
		runStartBr2684ctl(d1->Routed_VPI,d1->Routed_VCI,Enc);
		runStartDhcpc();
}

/////////////////////////////////////////////////////////////////
static void DhdpReleaseForBridge(void){	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","dynamic");
		save_globe_config(SYS_STATUS_FILE,"WAN=","dynamic");	
		runStartDhcpc();
		sleep(3);
		runStopRip();
		runStopFirewall();
		runStopDhcpc();
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","bridge");
		save_globe_config(SYS_STATUS_FILE,"WAN=","bridge");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","br0");
		save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");	
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		save_globe_config(SYS_STATUS_FILE,"WAN_IF=","br0");	
		run_script("/etc/scripts/bridge_back.sh",0,0,0);//set back back the LAN_IP as the br0's IP.
}

static void RunPPPoE(WAN_CONFIG_DATA *d1,int Enc)
{
	
		runStopRip();
		runStopFirewall();
		runStopPppoecd();
		runStopBr2684ctl();
		runStartBr2684ctl(d1->PPPOE_VPI,d1->PPPOE_VCI,Enc);
		runStartPppoecd();
}

static void RunPPPoA(WAN_CONFIG_DATA *d1,int Enc)
{
	
		runStopRip();
		runStopFirewall();
		runStopPppoa();
		//albert: sleep for preventing device crash due to slow atm open
		sleep(10);
		runStartPppoa();
}

#define WAN_QUICK_TYPE_NO_WAN_PROTOCOL 0
#define WAN_QUICK_TYPE_BRIDGE_VC     9
#define WAN_QUICK_TYPE_BRIDGE_LLC    10
#define WAN_QUICK_TYPE_DHCPC_VC     7
#define WAN_QUICK_TYPE_DHCPC_LLC    8
#define WAN_QUICK_TYPE_PPPOE_VC     12
#define WAN_QUICK_TYPE_PPPOE_LLC    2
#define WAN_QUICK_TYPE_PPPOA_VC     1
#define WAN_QUICK_TYPE_PPPOA_LLC    11


#define WAN_TYPE_DHCPC 1
#define WAN_TYPE_BRIDGE 2
#define WAN_TYPE_PPPOA 3
#define WAN_TYPE_PPPOE 5

void restart_wan(){
	openlog("AUTOSCAN", LOG_NDELAY, LOG_DAEMON);
	DPRINTF("Restart wan start");
	FILE *f;
	int Wan_Vpi_Detected=0,Wan_Vci_Detected=0;
	char enc[32];
	char ip[32];
	char line[255];
	char gateway[32];
	int Quick_Wan_Type_Detected=WAN_QUICK_TYPE_NO_WAN_PROTOCOL;
	
	//Load_Wan_Config(); done in the start up
	//memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
	f=fopen("/var/tmp/first_scanpvc_result","r");
	if(!f)
	{
		DPRINTF("first_scanpvc_result does not exist!!!\n");
		return;
	}
	if (!fgets(line,255,f))
	{
		DPRINTF("first_scanpvc_result can not be read!\n");
		fclose(f);
		return;
	}

	sscanf(line,"VPI %d VCI %d %s %s %s",&Wan_Vpi_Detected,&Wan_Vci_Detected,enc,ip,gateway);
	fclose(f);
	
	// Note Fixed IP shall not running the FactoryResetAutoScan,
	// So fixed IP is not what we concern here.
	if((wan_config.Wan_Type==WAN_TYPE_DHCPC)&&(wan_config.Routed_IP_Assignment))
	{// fixed IP mode.
		DPRINTF("AdslFactoryResetAutoScan: is configured as Fixed IP. No need to run FactoryReset AutoPVC.\n");
		syslog(LOG_INFO,"AdslFactoryResetAutoScan: is configured as Fixed IP. No need to run FactoryReset AutoPVC.");
		return;
	}	
	//1. determine Quick_Wan_Type_Detected
	if(!strcmp(enc,"DHCPC_LLC_VALID"))
			{
		switch(wan_config.Wan_Type)
		{
			case WAN_TYPE_DHCPC:
				Quick_Wan_Type_Detected=WAN_QUICK_TYPE_DHCPC_LLC;
				break;
			case WAN_TYPE_BRIDGE:
				Quick_Wan_Type_Detected=WAN_QUICK_TYPE_BRIDGE_LLC;
				break;
		}
		
	}
	else if(!strcmp(enc,"DHCPC_VC_VALID"))
		{
		switch(wan_config.Wan_Type)
			{
			case WAN_TYPE_DHCPC:
				Quick_Wan_Type_Detected=WAN_QUICK_TYPE_DHCPC_VC;
				break;
			case WAN_TYPE_BRIDGE:
				Quick_Wan_Type_Detected=WAN_QUICK_TYPE_BRIDGE_VC;
				break;
		}
	}
	else if(!strcmp(enc,"PPPOE_LLC_VALID"))
	{
		if(wan_config.Wan_Type==WAN_TYPE_PPPOE)
			Quick_Wan_Type_Detected=WAN_QUICK_TYPE_PPPOE_LLC;
	}
	else if(!strcmp(enc,"PPPOE_VC_VALID"))
	{
		if(wan_config.Wan_Type==WAN_TYPE_PPPOE)
			Quick_Wan_Type_Detected=WAN_QUICK_TYPE_PPPOE_VC;
	}
	else if(!strcmp(enc,"PPPOA_LLC_VALID"))
	{
		if(wan_config.Wan_Type==WAN_TYPE_PPPOA)
			Quick_Wan_Type_Detected=WAN_QUICK_TYPE_PPPOA_LLC;
	}
	else if(!strcmp(enc,"PPPOA_VC_VALID"))
	{
		if(wan_config.Wan_Type==WAN_TYPE_PPPOA)
			Quick_Wan_Type_Detected=WAN_QUICK_TYPE_PPPOA_VC;
	}	
	
	// Quick Wan type is not assigned for example, enc=="FIXIP_2684B_VC_VALID" is detected
	if(!Quick_Wan_Type_Detected)
	{
		DPRINTF("AdslFactoryResetAutoScan: detected Enc is %s and configure wan_type=%d.  Can not determine the quick_wan_type \n",enc,wan_config.Wan_Type);
		syslog(LOG_INFO,"AdslFactoryResetAutoScan: detected Enc is %s and configure wan_type=%d.  Can not determine the quick_wan_type",enc,wan_config.Wan_Type);
		return;
	}
	
	//Reach here, we have  "he "WAN TYPE PVC Enc"s only allowed to change by the FactoryResetAutoScan task.
	// For examples, brigde and DHCPC can have different encap to run the AutoScan.
	//(Fixed IP shall not run FactoryresetAutoScan.)
	
		
	//2. any change need to restart 
	if( (Wan_Vpi_Detected==wan_config.Bridged_VPI) &&
	    (Wan_Vci_Detected==wan_config.Bridged_VCI) &&
	   (Quick_Wan_Type_Detected==wan_config.Quick_Wan_Type) )
	{
		// at this moment we still need to check if IP is OK. If not, then
		char str_wanip[20];
		char buf1[50];
		if(wan_config.Wan_Type==2)
		{// This is bridge, no need for the auto scan
			DPRINTF("AdslFactoryResetAutoScan: configured and dected are same VCI/PCI encfor brigde Mode.\n");
			syslog(LOG_INFO,"AdslFactoryResetAutoScan: configured and dected are same VCI/PCI enc for brigde Mode.\n");
#if 1
			// if it is bridge mode and the auto PVC scanned is DHCPC LLC/VC. then, we have to release the locked IP (which is because of the AUTP PVC. 
			// for bridge mode, it shall not lock the IP for the router.) by start the DHCPC, then stop it again.
			// This is bridge, try to release the locked IP.
			DhdpReleaseForBridge();
#endif
			return;
		}
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		if(isValidIP(str_wanip))
		{
			DPRINTF("AdslFactoryResetAutoScan: configured and dected are same VCI/PCI enc. And, get the valid IP..\n");
			syslog(LOG_INFO,"AdslFactoryResetAutoScan: configured and dected are same VCI/PCI enc. And, get the valid IP..\n");			
			return;
		}
		DPRINTF("AdslFactoryResetAutoScan: configured and dected are same VCI/PCI enc. But not yet get the valid IP..\n");
		syslog(LOG_INFO,"AdslFactoryResetAutoScan: configured and dected are same VCI/PCI enc. But not yet get the valid IP..\n");			
	}
	wan_config.Quick_Wan_Type=Quick_Wan_Type_Detected;
	switch(wan_config.Wan_Type)
	{
		case WAN_TYPE_BRIDGE:
			wan_config.Bridged_VPI=Wan_Vpi_Detected;
			wan_config.Bridged_VCI=Wan_Vci_Detected;
			Save_Wan_Config(WAN_TYPE_BRIDGE, &wan_config);
			DPRINTF("restart pure bridge(enc=%s) vpi/vci %d/%d\n ",enc, Wan_Vpi_Detected, Wan_Vci_Detected);
			syslog(LOG_INFO, "restart pure bridge(enc=%s) vpi/vci %d/%d",enc, Wan_Vpi_Detected, Wan_Vci_Detected);
			runStopBr2684ctl();
			if(Quick_Wan_Type_Detected==WAN_QUICK_TYPE_BRIDGE_LLC)
				runStartBr2684ctl(Wan_Vpi_Detected,Wan_Vci_Detected,0);
			else// others treat as VC
				runStartBr2684ctl(Wan_Vpi_Detected,Wan_Vci_Detected,1);
#if 1
			// if it is bridge mode and the auto PVC scanned is DHCPC LLC/VC. then, we have to release the locked IP (which is because of the AUTP PVC. 
			// for bridge mode, it shall not lock the IP for the router.) by start the DHCPC, then stop it again.
			// This is bridge, try to release the locked IP.
			DhdpReleaseForBridge();
#endif
			break;
		case WAN_TYPE_DHCPC:
        		wan_config.Routed_VPI=Wan_Vpi_Detected;
        		wan_config.Routed_VCI=Wan_Vci_Detected;
			Save_Wan_Config(WAN_TYPE_DHCPC, &wan_config);
			DPRINTF("restart dhcp client vpi/vci(enc=%s) %d/%d\n",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			syslog(LOG_INFO,"restart dhcp client vpi/vci(enc=%s) %d/%d",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			if(Quick_Wan_Type_Detected==WAN_QUICK_TYPE_DHCPC_LLC)
					Run1483Routed(&wan_config,0);
				else
			Run1483Routed(&wan_config,1);
			break;
		case WAN_TYPE_PPPOE:
 			wan_config.PPPOE_VPI=Wan_Vpi_Detected;
			wan_config.PPPOE_VCI=Wan_Vci_Detected;
			Save_Wan_Config(WAN_TYPE_PPPOE, &wan_config);
			DPRINTF("restart PPPoE vpi/vci(enc=%s) %d/%d\n",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			syslog(LOG_INFO,"restart PPPoE vpi/vci(enc=%s) %d/%d",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			if(wan_config.Quick_Wan_Type==WAN_QUICK_TYPE_PPPOE_LLC)
					RunPPPoE(&wan_config,0);
				else
					RunPPPoE(&wan_config,1);
			break;
		case WAN_TYPE_PPPOA:
 			wan_config.PPPOA_VPI=Wan_Vpi_Detected;
			wan_config.PPPOA_VCI=Wan_Vci_Detected;
			Save_Wan_Config(WAN_TYPE_PPPOA, &wan_config);
			DPRINTF("restart PPPoA vpi/vci(enc=%s) %d/%d\n",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			syslog(LOG_INFO,"restart PPPoA vpi/vci(enc=%s) %d/%d",enc,Wan_Vpi_Detected,Wan_Vci_Detected);
			if(wan_config.Quick_Wan_Type==WAN_QUICK_TYPE_PPPOA_LLC)
					RunPPPoA(&wan_config,0);
				else
					RunPPPoA(&wan_config,1); 
			break;
	}
}
	
static void change_wan_setting(int result_num){
	FILE *f;
	char line[64];
	int vpi=0,vci=0;
	char enc[32];
	int srcIP1=0;
	int srcIP2=0;
	int srcIP3=0;
	int srcIP4=0;
	int destIP1=0;
	int destIP2=0;
	int destIP3=0;
	int destIP4=0;
	char ip[20];
	char gateway[20];

	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		fgets(line,sizeof(line),f);
		sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
		fclose(f);
		DPRINTF("Take the first one Auto Scan Result:vpi=%d vci=%d enc=%s\n",vpi,vci,enc);
		syslog(LOG_INFO,"Take the first one Auto Scan Result:vpi=%d vci=%d enc=%s",vpi,vci,enc);
	}
	f=fopen("/flash/fixscanpvc.conf","r");
	if(f){
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&srcIP1,&srcIP2,&srcIP3,&srcIP4);
			sprintf(ip,"%d.%d.%d.%d",srcIP1,srcIP2,srcIP3,srcIP4);
		}
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&destIP1,&destIP2,&destIP3,&destIP4);
			sprintf(gateway,"%d.%d.%d.%d",destIP1,destIP2,destIP3,destIP4);
		}
		fclose(f);
	DPRINTF("Auto:ip=%s gw=%s\n",ip,gateway);
	}

	f=fopen("/var/tmp/first_scanpvc_result","w");
	if(f){
		fprintf(f,"VPI %d VCI %d %s\n",vpi,vci,enc);	
		fclose(f);
	}
	

}
static int autoscan_action(){
	unlink("/var/tmp/scanpvc_result");
	openlog("AUTOSCAN", LOG_NDELAY, LOG_DAEMON);
	syslog(LOG_INFO,"do sardoing set");
	DPRINTF("sardoing 0\n");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","0",0);
	//sleep(10);
	sleep(18);
	syslog(LOG_INFO,"do sardoing get");
	DPRINTF("sardoing 1\n");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","1",0);

	FILE *f;
	char line[64];
	int i=0;
	//char enc[32];

	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		while(fgets(line,sizeof(line),f)){
		i++;
		}
		fclose(f);
	}
	return i;

}

int scantime=0;
int result_num=0;
 
#ifdef LIBVER
#define MAINFUNC AdslFactoryResetAutoScan_main
#else
#define MAINFUNC main
#endif

int MAINFUNC(int argc, char* argv[])
{
	openlog("AUTOSCAN", LOG_NDELAY, LOG_DAEMON);
	syslog(LOG_INFO,"start");
	DPRINTF("AdslFactoryResetAutoScan Task starts!\n");
	syslog(LOG_INFO,"AdslFactoryResetAutoScan Task starts!");
	char str_autoscan[10];
	char buf[64];
	strcpy(str_autoscan,(char *)read_file_para_value("/flash/config","AUTOSCAN=",buf));
	if (!strcmp(str_autoscan,"no")){
		syslog(LOG_INFO,"exit:no need start");
		exit(1);
	}
	
	// We can not change the WAN type.  User has to do himself to make it works.
	// THat is, if configured protocol is different form the scanned one.
	// then we shall just change the vci, pci values. Not change the protocol.
	//Before starting the Auto PVC task we have to check if the wan IP is got form non-brigde and non-Fixed IP mode.
	// If already get, then no need to have run this task.
	Load_Wan_Config();
	if(wan_config.Wan_Type==2)
	{// This is bridge, do the auto scan
	}
	else if((wan_config.Wan_Type==1)&&(wan_config.Routed_IP_Assignment))
	{// Fixed on.  Shall not do the AutoScan
			exit(1);
	}
	else
	{  // Then, we chceck if IP is exist.  If exist, then we need no auto scan any more before we have the IP.
		char str_wanip[20];
		char buf1[50];
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		if(isValidIP(str_wanip))
		{
			DPRINTF("AdslFactoryResetAutoScan Task:valid WAN IP(%s) is got! No need to run autoScan.\n",str_wanip);
			syslog(LOG_INFO,"AdslFactoryResetAutoScan Task:valid WAN IP(%s) is got! No need to run autoScan.",str_wanip);
			exit(1);
		}			
	}
		
	while(1)
	{
		int nFd = open( "/dev/dmtdev", O_RDWR );
		if( nFd == -1  )
		{
			DPRINTF("get_atm_status:severe error for open /dev/dmtdev for ADSL device\n");
			return -1;
		}
		DMTCTRL_DMT_INFO Arg;
 	       	ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
 		close(nFd);
	       	if(Arg.dmt_status==ADSL_UP){
			
			if(wan_config.Wan_Type==2)
			{// This is bridge, do the auto scan
			}
			else
			{  // Then, we chceck if IP is exist.  If exist, then we need no auto scan any more before we have the IP.
				char str_wanip[20];
				char buf1[50];
				sleep(5);//sleep 5 seconds to let the orginal one get the IP.
				strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
				if(isValidIP(str_wanip))
				{
					DPRINTF("AdslFactoryResetAutoScan Task2:valid WAN IP(%s) is got! No need to run autoScan.\n",str_wanip);
					syslog(LOG_INFO,"AdslFactoryResetAutoScan Task2:valid WAN IP(%s) is got! No need to run autoScan.",str_wanip);
					exit(1);
				}			
			}
			
			syslog(LOG_INFO,"sync up");
			syslog(LOG_INFO,"do scan:%d",scantime+1);
			DPRINTF("do scan:%d\n",scantime+1);
			result_num=autoscan_action();
			DPRINTF("%d.scanned num:%d\n",scantime+1,result_num);
			syslog(LOG_INFO,"%d.scanned num:%d",scantime+1,result_num);
			if (result_num==0){
				if (scantime<=2)
				{
					DPRINTF("scanned nothing:rescan\n");
					syslog(LOG_INFO,"scanned nothing:rescan");
				}
				scantime++;
			}else {
				// If more than 2 protocol scan, then we choose the best one.
				DPRINTF("%d protocols scanned. Take the first one.\n",result_num);
				syslog(LOG_INFO,"%d protocols scanned.Take the first one.",result_num);
				change_wan_setting(result_num);
				restart_wan();
				save_globe_config("/flash/config","AUTOSCAN=","no");
				syslog(LOG_INFO,"exit:close");
				exit(1);	
			}			
		}
		if (scantime>2){
			syslog(LOG_INFO,"exit:scan over 3 times.");
			exit(1);	
		}
	}
	DPRINTF("AdslFactoryResetAutoScan Task finished!\n");
	syslog(LOG_INFO,"AdslFactoryResetAutoScan Task finished!");
}

