/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file thpd.c
 *  @brief TMOG HTTP Proxy Module - main
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */
#undef NDEBUG
#define jj
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <locale.h>
#include <libintl.h>
#include <dirent.h>
#include <ctype.h>
#define READ_BUF_SIZE	50
#define IP_REDIRECT
#ifdef  IP_REDIRECT
#include <limits.h>
#include <linux/netfilter_ipv4.h>
#endif
#include <stdio.h>
#include <stdarg.h>
#include <linux/tc3162dmtctrl.h>
#include <../websconfig/lan_conf.h>
#include <../websconfig/home.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../tmss/include/log.h"
#include "../tmss/include/tmPidUtil.h"
#include "../websconfig/wan.h" 
#include "../iptables-1.2.11/runFunc.h"

#include <sys/ioctl.h>  /* ioctl */
#define JP_DEBUG
#ifdef JP_DEBUG
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
#define printf DPRINTF
#else
#define DPRINTF(args...)
#endif

#define PIDFILE             "/var/run/PPPoELogin.pid"
#define WAN_CONFIG_FILE 		"/flash/wan.conf"
#define DMT_WRITE_FN "/proc/dmtctrl/dmtwrite"
#define POLL_TIMEOUT 4
#define MAGIC_HASH_MD5_VALUE                                 "24b8cbc738ff6fd2a8b69b0a2e1d0432" // from calcMD5(("nochange")), just a random key to prevent user input the same password with this identifier
#define DMT_READ_FN "/proc/dmtctrl/dmtread"
#define THPD_MAX_PROC	          (1)
#define THPD_HTTP_PROXY_PORT      (10080)
#define MAX_BUF_INIT_LEN 8192    					
#define PPPOE_PROXY_REDIRECT_STOP "/etc/scripts/pppoe_proxy_stop.sh"
#define FAKED_DNS_PROXY_STOP "/etc/scripts/faked_dns_proxy_stop.sh"
#define STOP_FAKED_DNS_PROXY_TASK "/etc/scripts/stop_faked_dns_proxy.sh"
#define RESTART_FAKED_DNS_PROXY_TASK "/etc/scripts/restart_faked_dns_proxy.sh"
#define PPPOE_PROXY_RUN_PPPOECD "/var/etc/pppoe_proxy_run_pppoecd.sh"
#define PPPOA_PROXY_RUN_PPPD "/var/etc/pppoa_proxy_run_pppd.sh"
#define DEFAULT_CONFIG_FILE	"/etc/default/config"

extern long* find_pid_by_name1( char* pidName);
extern int read_value_from_file(char *filename);
int LoginInProgress=0;
#define MAX_AUTOSCAN_RETRY_TIME 3
int autoScanRetryTime=0;
WAN_CONFIG_DATA wan_config;
WAN_CONFIG_DATA old_wan_config;
void Save_Wan_Config (int i,WAN_CONFIG_DATA *d);
void Load_Wan_Config (WAN_CONFIG_DATA *d);
enum wan_connect_status {
        DISCONNECTED=0,
        CONNECTED,
        CONNECTING,
        DISCONNECTING
};
enum wan_scan_type {
        Nothing_Scanned=1,
        PPPoE_Scanned,
        PPPoA_Scanned,
        DHCP_Scanned,
        More_Than_One_Scanned
};


typedef struct service_table_st
{
    int sd;
    int port;
}
service_table_t;

char buf[MAX_BUF_INIT_LEN];
char req_url[1024];
char host[512];
//char tmpUrl[1024];
char tmpHost[512];
int poll_ret;
int sd;
int optval;
int client_sd;
struct sockaddr_in service_addr;
struct sockaddr_in client_addr;
socklen_t client_addr_len;

int ReScanned=1;
static service_table_t service_table;
static struct pollfd pollfdList[1];
static int poolfd_nfds;
static const char ModuleName[]="PPPoELogin";
static volatile int GO_HELL=0;
void processReqUrl(char *req_url);
static char tmp_line[256];
long* find_pid_by_name1( char* pidName){

	DIR *dir;
	struct dirent *next;
	long* pidList=NULL;
	int i=0;

	dir = opendir("/proc");
	if (!dir){
		DPRINTF("Cannot open /proc");
	}
	while ((next = readdir(dir)) != NULL) {
		FILE *status;
		char filename[READ_BUF_SIZE];
		char buffer[READ_BUF_SIZE];
		char name[READ_BUF_SIZE];

		/* Must skip ".." since that is outside /proc */
		if (strcmp(next->d_name, "..") == 0)
			continue;

		/* If it isn't a number, we don't want it */
		if (!isdigit(*next->d_name))
			continue;

		sprintf(filename, "/proc/%s/status", next->d_name);
		if (! (status = fopen(filename, "r")) ) {
			continue;
		}
		if (fgets(buffer, READ_BUF_SIZE-1, status) == NULL) {
			fclose(status);
			continue;
		}
		fclose(status);

		/* Buffer should contain a string like "Name:   binary_name" */
		sscanf(buffer, "%*s %s", name);
		if (strcmp(name, pidName) == 0) {
			pidList=realloc( pidList, sizeof(long) * (i+2));
			pidList[i++]=strtol(next->d_name, NULL, 0);
		}
	}

	if (pidList) {
		pidList[i]=0;
	} else {
		pidList=realloc( pidList, sizeof(long));
		pidList[0]=-1;
	}
	return pidList;
}
void CopyFile(char *filename1,char *filename2){
	FILE *fp,*fp1;
	memset(tmp_line,0,sizeof(tmp_line));
	/* from filename1 to filename2 */ 
	if ((fp = fopen(filename1, "r"))!=NULL){
	  	if ((fp1 = fopen(filename2, "w"))!=NULL){
			while (fgets(tmp_line,sizeof(tmp_line),fp))
				fprintf(fp1,"%s",tmp_line);
			fclose(fp1);
		}
	fclose(fp);
	}
}
void run_task(char *cmd, ...)
{
        va_list args;
        char *param[40];
        char i=0, background=0;
        pid_t  pid;
                
//printf("run_task: %s\n", cmd);  
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char * )))
                       break;
        }
        va_end(args);
                                                                                                                                               
        if (!strcmp(param[i-2],"&")) {
//printf("run_task: a back ground task\n");  
                background = 1;
                param[i-2] = 0;
        }

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}
int save_globe_config(char *filename, char *arg1, char *arg2)
{
//	char line[256];
//	int i,j;
	FILE *fp,*fp1;
//	i=0;
	memset(tmp_line,0,sizeof(tmp_line));	
	if((fp=fopen(filename,"r"))!=NULL){
		if((fp1=fopen("/var/tmp/tmpfile","w"))!=NULL){
			while(fgets(tmp_line,sizeof(tmp_line),fp))
			{
				if ((strncmp(arg1,tmp_line,strlen(arg1))) == 0){
				//	sprintf(config_line[i],"%s\"%s\"\n",arg1,arg2);
					fprintf(fp1,"%s\"%s\"\n",arg1,arg2);
				}
				else{
				//	sprintf(config_line[i],"%s",line);
					fprintf(fp1,"%s",tmp_line);
				}
	//		i++;
			}
	
		fclose(fp1);
	}
	fclose(fp);
	}
	/*
	if ((fp=fopen(filename,"w"))!=NULL){
	for(j=0;j<i;j++)
		fprintf(fp,"%s",config_line[j]);
	fclose(fp);
	}
	*/
	CopyFile("/var/tmp/tmpfile",filename);
	return 1;	
}
void KillProcessByName(char *ProcessName,int signal){
	
	long *killpid;
	
	killpid=find_pid_by_name1(ProcessName);
	if (!killpid || *killpid<=0)
	{
		//DPRINTF(" %s : No Such Process\n",ProcessName);
	}
	else
	{
		//DPRINTF("kill -%d `pidof %s`\n",signal,ProcessName);
		kill(*killpid,signal);
	}
}

int isValidIP(char *IPaddr){
 struct in_addr inp;
   if (inet_aton(IPaddr,&inp)!=0) /* success */
	   return 1;
   else
	   return 0;
}
int write_value_to_file(char *filename, int arg1)
{
	FILE *fp;
	if ((fp=fopen(filename,"w"))!=NULL)
        {
		fprintf(fp,"%d\n",arg1);
		fclose(fp);
		return 1;
	}
	else
		return 0;
	

}
int load_blank_string(void *d)
{
	if (strlen(d)==0)
              strcpy(d,BLANK_SYMBOL);
	return 1;
}

int print_blank_string(void *d)
{
	if (strcmp(d,BLANK_SYMBOL)==0)
              strcpy(d,"");
	return 1;
}
void do_extern_cmd(char *cmd, char *argv[], char *filename)
{
    char path[100];
    int  pid, fd = -1, fd2 = -1;
    
    fflush(stdout);
    signal(SIGCHLD, SIG_DFL);
    if ( (pid = vfork()))
        waitpid(pid, NULL, 0);
    if(pid == 0){  // child process
        if ( filename != NULL && *filename )  {
            strcpy(path, filename);
            fd = open(path, O_RDWR|O_CREAT|O_TRUNC);
            strcat(path, ".err");
            fd2 = open(path, O_RDWR|O_CREAT|O_TRUNC);
        }
		if ( fd >= 0 && fd2 >= 0 )   {
            dup2(fd, STDOUT_FILENO);
            dup2(fd2, STDERR_FILENO);
            
	//DPRINTF("\n\n  ------------------------------\n");
	//DPRINTF("Web page run_script\t");
	//DPRINTF("  ------------------------------\n");
	/*
	DPRINTF("%s\t",argv[1]);
	if (argv[2])
		DPRINTF("%s\t",argv[2]);
	if (argv[3])
		DPRINTF("%s\t",argv[3]);
	if (argv[4])
		DPRINTF("%s\t",argv[4]);
//	DPRINTF("  ------------------------------\n\n");
	DPRINTF("\n");
	*/
	    execvp(cmd, argv);
        }
        exit(0); 
    }
}
int run_script(char *filename, char *arg1, char *arg2, char *arg3)
{
    	char *argv[] = { "sh", filename, arg1,arg2,arg3, NULL };
	do_extern_cmd("sh", argv, "/var/tmp/run_script");
	return 0;
}
//char *mid(char *ss,int start,int num,char *buf1);

#if 0
//extern char* read_file_para_value(char *filename, char *arg1,char *buf);
//extern long* find_pid_by_name1( char* pidName);
//extern int read_value_from_file(char *filename);
char* read_file_para_value(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
//	char line[255];
	char str_return[50]={0};
	//char_t *str_return=NULL;
	char str_temp[50]={0};
	*buf='\0';
	memset(tmp_line,0,sizeof(tmp_line));
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(tmp_line,sizeof(tmp_line),fp)){
		        if (strncmp(tmp_line,arg1,strlen(arg1)) == 0){
       				sscanf(tmp_line,"%50[^=]=\"%50[^\"]\"\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
			//	DPRINTF("1.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	       	fclose(fp);
	}
	return buf;
}
#endif

int read_value_from_file(char *filename){
	int arg1=0;
	FILE *fp;
	if ((fp=fopen(filename,"r"))!=NULL)
        {
		fscanf(fp,"%d\n",&arg1);
		fclose(fp);
	}
	return arg1;
}
#if 0
#define WRONG_PASSWORD_WARNING \
"<tr>\r\n"\
"<td valign=\"center\" width=\"10\" bgcolor=\"#C7CBCA\"></td>\r\n"\
"<td class=\"tableheader\" bgcolor=\"#E00505\">\r\n"\
"<div align=\"center\"><img src=\"icons_warning.gif?%s\">WRONG USERNAME/PASSWORD<br>\r\n"\
"Wrong Username/Password for your ISP PPPoE account is given. Please retry again. </div>\r\n"\
"</td></tr>\r\n"\
"<tr>\r\n"

#define LOGIN_PAGE_MESSAGE \
"<html>\r\n"\
"<head>\r\n"\
"<title>PPPoE Login</title>\r\n"\
"<META http-equiv=\"Pragma\" content=\"no-cache\">\r\n"\
"<META http-equiv=\"Expires\" content=\"-1\">\r\n"\
"<link rel=\"stylesheet\" type=\"text/css\" href=\"/default.css?%s\">\r\n"\
"<SCRIPT language=javascript src=/utility.js?%s></SCRIPT>\r\n"\
"<SCRIPT language='javascript'>\r\n"\
"<!--\r\n"\
"function RetPage()\r\n"\
"{\r\n"\
"var form=document.myForm;\r\n"\
"location.replace(\"/pppoeLogin.asp?%s&\"+form.usernm.value+\"&\"+form.passwd.value);\r\n"\
"}\r\n"\
"//-->\r\n"\
"</SCRIPT>\r\n"\
"</head>\r\n"\
"<body leftmargin=\"0\" topmargin=\"0\" marginheight=\"0\" marginwidth=\r\n"\
"\"0\">\r\n"\
"<table cellspacing=\"0\" cellpadding=\"0\" width=\"757\" align=\"center\"\r\n"\
"border=\"0\">\r\n"\
"<tbody>\r\n"\
"<tr>\r\n"\
"<td bgcolor=\"#C7CBCA\"><img height=\"119\" src=\"/logo.jpg?%s\"\r\n"\
"width=\"757\"></td>\r\n"\
"</tr>\r\n"\
"<tr>\r\n"\
"<td bgcolor=\"#C7CBCA\">\r\n"\
"<table cellspacing=\"3\" cellpadding=\"0\" width=\"100%%\">\r\n"\
"<tbody>\r\n"\
"<tr>\r\n"\
"<td valign=\"top\" class=\"content\" bgcolor=\"#FFFFFF\"><br>\r\n"\
" \r\n"\
"<table height=\"320\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%%\"\r\n"\
"border=\"0\">\r\n"\
"<tbody>\r\n"\
"<tr>\r\n"\
"<td valign=\"top\" width=\"200\">\r\n"\
"<table cellspacing=\"0\" cellpadding=\"0\" width=\"80%%\" align=\"center\"\r\n"\
"border=\"0\">\r\n"\
"<tbody>\r\n"\
"<tr valign=\"top\">\r\n"\
"<td class=\"redtitle\" width=\"100%%\" colspan=\"2\" height=\"25\">\r\n"\
"&nbsp;</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</td>\r\n"\
"<td valign=\"top\">\r\n"\
"<table cellspacing=\"0\" cellpadding=\"0\" width=\"90%%\" align=\"center\"\r\n"\
"border=\"0\">\r\n"\
"<tbody>\r\n"\
"%s\r\n"\
"<tr>\r\n"\
"<td>\r\n"\
"\r\n"\
"<table cellspacing=\"0\" cellpadding=\"0\" width=\"100%%\" border=\"0\">\r\n"\
"<tbody>\r\n"\
"<td class=\"tableheader\" bgcolor=\"#E00505\">\r\n"\
"<div align=\"center\">PPPoE Login Page<br>\r\n"\
"Log on with your UserName and Password for PPPoE account to access the Internet.\r\n"\
"</div>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"<tr>\r\n"\
"<td valign=\"top\" bgcolor=\"#FFFFFF\">\r\n"\
"<table cellspacing=\"0\" cellpadding=\"0\" width=\"100%%\" border=\"0\">\r\n"\
"<tbody>\r\n"\
"<form method=\"post\" name=\"myForm\" action=\"PPPoELogon\" "\
"<tr>\r\n"\
"<td class=\"content\">\r\n"\
"<div align=\"center\"><span class=\"contentbold\">User name:<br>\r\n"\
"</span>\r\n"\
"<input class=\"content\" type=\"username\" name=\"usernm\" size=\"40\">\r\n"\
"</div>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"<tr>\r\n"\
"<td class=\"content\">\r\n"\
"<div align=\"center\"><span class=\"contentbold\">Password:<br>\r\n"\
"</span>\r\n"\
"<input class=\"content\" type=\"password\" name=\"passwd\" size=\"40\">\r\n"\
"</div>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"<td height=\"32\">\r\n"\
"<div align=\"center\">\r\n"\
"<input type=\"button\" value=\"Login\" onClick=\"RetPage()\">\r\n"\
"</form>\r\n"\
"</div>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"<br>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</td>\r\n"\
"</tr>\r\n"\
"</tbody>\r\n"\
"</table>\r\n"\
"</body>\r\n"\
"</html>"


#define PPPoE_LOGIN_STATUS \
"<html>\r\n"\
"<head>\r\n"\
"<META http-equiv=\"Pragma\" content=\"no-cache\">\r\n"\
"<META http-equiv=\"Expires\" content=\"-1\">\r\n"\
"<link rel=\"stylesheet\" type=\"text/css\" href=\"default.css?%s\">\r\n"\
"<SCRIPT language='javascript'>\r\n"\
"function refpage()\r\n"\
"{\r\n"\
"location.replace(\"/pppoeLgSt.asp?%s\");\r\n"\
"}\r\n"\
"function changetimeout()\r\n"\
"{\r\n"\
"setTimeout(\"refpage();\",%d);\r\n"\
"}\r\n"\
"</SCRIPT>\r\n"\
"</head>\r\n"\
"<body class=\"main\" link=\"#3300cc\" alink=\"#ff0000\" vlink=\"#990066\" onload=\"changetimeout();\" >\r\n"\
"<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" scrolling=\"no\" style=\"border-collapse: collapse\" bordercolor=\"#FFFFFF\" width=\"80%%\">\r\n"\
"<tr><td class=\"headline\" colspan=2>%s</td></tr>\r\n"\
"</table>\r\n"\
"</body>\r\n"\
"</html>"


#define PPPoE_LOGIN_SUCCESS \
"<html>\r\n"\
"<head>\r\n"\
"<META http-equiv=\"Pragma\" content=\"no-cache\">\r\n"\
"<META http-equiv=\"Expires\" content=\"-1\">\r\n"\
"<SCRIPT language='javascript'>\r\n"\
"function displayUrl()\r\n"\
"{\r\n"\
"alert('PPPoE connection is established.  Please open a browser windows to surf the internet again. (This window will be closed after the popup window is closed)');\r\n"\
"window.close();\r\n"\
"return true;\r\n"\
"}\r\n"\
"</SCRIPT>\r\n"\
"</head>\r\n"\
"<body class=\"main\" link=\"#3300cc\" alink=\"#ff0000\" vlink=\"#990066\" onload=\"displayUrl()\";>\r\n"\
"</table>\r\n"\
"</body>\r\n"\
"</html>"

#define _PPPOE_LOGNIN_PORTAL_
#ifdef _PPPOE_LOGNIN_PORTAL_
#define PORTAL_HOST "www.brikks.com"
#define PORTAL_URL ""
#define PPPoE_LOGIN_SUCCESS_PORTAL \
"<html>\r\n"\
"<head>\r\n"\
"<META http-equiv=\"Pragma\" content=\"no-cache\">\r\n"\
"<META http-equiv=\"Expires\" content=\"-1\">\r\n"\
"<SCRIPT language='javascript'>\r\n"\
"function displayUrl()\r\n"\
"{\r\n"\
"alert('PPPoE connection is established.  Enjoy your surfing to the internet.Windows will be redirected to http://%s%s');\r\n"\
"location.replace(\"http://%s%s\");\r\n"\
"return true;\r\n"\
"}\r\n"\
"</SCRIPT>\r\n"\
"</head>\r\n"\
"<body class=\"main\" link=\"#3300cc\" alink=\"#ff0000\" vlink=\"#990066\" onload=\"displayUrl()\";>\r\n"\
"</table>\r\n"\
"</body>\r\n"\
"</html>"
#endif
#endif


/**********************************************
** Usage : qStrupr(string);
** Return: Pointer of converted string.
** Do    : Convert small character to big character.
**********************************************/
char *qStrupr(char *str) {
  char *cp;

  if(!str) return NULL;
  for(cp = str; *cp; cp++) if(*cp >= 'a' && *cp <= 'z') *cp -= 32;
  return str;
}
/**********************************************
** Usage : qStricmp(char *orgstr, char *tokstr);
** Return: s1 < s2 less than 0, s1 = s2 0, s1 > s2 greater than 0.
** Do    : qDecoder implementation of stricmp() because
**         some systems do not support this function.
**********************************************/
int qStricmp(char *s1, char *s2) {
  char *bs1, *bs2;
  int result;

  if(s1 == NULL || s2 == NULL) return 0;
  if((bs1 = strdup(s1)) == NULL) return 0;
  if((bs2 = strdup(s2)) == NULL) { free(bs1); return 0; }

  qStrupr(bs1), qStrupr(bs2);
  result = strcmp(bs1, bs2);
  free(bs1), free(bs2);

  return result;
}
  
#define PORTAL_HOST "www.yahoo.com"

#ifdef _sso_spary
#undef PORTAL_HOST
#define PORTAL_HOST "www.spray.se" 
#endif
#ifdef _sso_billion
#undef PORTAL_HOST
#define PORTAL_HOST "www.billion.com" 
#endif
#ifdef _sso_ppg
#undef PORTAL_HOST
#define PORTAL_HOST "www.billion.com" 
#endif
#ifdef _sso_glocalnet
#undef PORTAL_HOST
#define PORTAL_HOST "www.glocalnet.se"
#endif
#ifdef _sso_telenor
#undef PORTAL_HOST
#define PORTAL_HOST "www.noline.no"
#endif
#ifdef _sso_levelone
#undef PORTAL_HOST
#define PORTAL_HOST "www.level1.com"
#endif
#ifdef _sso_atlantis
#undef PORTAL_HOST
#define PORTAL_HOST "www.atlantis-land.com" 
#endif
#ifdef _sso_bec
#undef PORTAL_HOST
#define PORTAL_HOST "www.bectechnologies.net" 
#endif
#ifdef _sso_billionsa
#undef PORTAL_HOST
#define PORTAL_HOST "www.billionsa.com" 
#endif
//#define PORTAL_HOST "www.brikks.com"
static void sig_hup(int signo)
{
//    LoadSettings("by signal SIGHUP");
}

static void go_hell_handler(int signo)
{
    GO_HELL=1;
}

int checkIfPPPAuthFailed(void)	// add by honor
{	
	FILE *fp;
	int ret=0;
	
	if ((fp = fopen("/tmp/ppp/log", "r"))) {
		char buf[40];
		fscanf(fp, "%s", buf);
		if((strcmp("PAP_AUTH_FAIL",buf)==0)||(strcmp("CHAP_AUTH_FAIL",buf)==0)||(strcmp("AUTH_FAIL",buf)==0))
		{
			ret=1;
		}
		fclose(fp);
	}	
	return ret;
}


#if 0
void runStopRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","stop",0,0);
}

void runStartRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","start",0,0);
}
#endif
void runStopPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
#if 0
	run_script("/etc/scripts/pppoe.sh","stop",0,0);
#else
	KillProcessByName("pppd",SIGTERM);		
	//kill -9 `pidof fw.sh`
	run_task("route","del","default","gw","0.0.0.0",0);
#endif
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

void runStopPppoecd(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
#if 0
	run_script("/etc/scripts/pppoe.sh","stop",0,0);
#else
	KillProcessByName("pppoecd",SIGTERM);		
	//kill -9 `pidof fw.sh`
	run_task("route","del","default","gw","0.0.0.0",0);
#endif
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

void runPPPoA_sh()
{


	char idleTime[20]="";
	char str_wanif[20];
	char buf[32];
	char serviceName[80]="";
	FILE *outfp;
        Load_Wan_Config(&wan_config);
	if (wan_config.PPPOA_Connection !=0 )
		sprintf(idleTime,"-i %d",wan_config.PPPOA_Idle_Timeout);
	strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
	
	// open a shell script files and run it.
	outfp = fopen (PPPOA_PROXY_RUN_PPPD, "w");
	if (!outfp)
	{
		LOGERROR("open file %s for write error!\n",PPPOA_PROXY_RUN_PPPD);
		return;
	}
	fprintf(outfp,"#!/bin/sh\n");
	//fprintf(outfp,". /var/etc/status\n");
	//pppoecd $WAN_IF -d -k -u $Username -p $Password -s $ServiceName -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &

	fprintf(outfp,"pppd -c 0 -l %d -a 0.%d.%d -k -u %s -p %s %s -A %d -L %s -T %d &\n",
	wan_config.PPPOA_Encapsulation_Method,		
	wan_config.PPPOA_VPI,
	wan_config.PPPOA_VCI,
	wan_config.PPPOA_Username,
	wan_config.PPPOA_Password,
	serviceName,
	wan_config.PPPOA_Authentication_Protocol,
	wan_config.PPPOA_IP,
	wan_config.PPPOA_MTU);
	fclose(outfp);
	chmod (PPPOA_PROXY_RUN_PPPD,S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH |S_IWOTH | S_IXOTH);
	run_script(PPPOA_PROXY_RUN_PPPD,0,0,0);
}
void runPPPoE_sh()
{
//	PPPOE_CONFIG_DATA pppoe_config;
	char idleTime[20]="";
	char str_wanif[20];
	char buf[32];
	char serviceName[80]="";
	FILE *outfp;
        Load_Wan_Config(&wan_config);
	if (wan_config.PPPOE_Connection !=0 )
		sprintf(idleTime,"-i %d",wan_config.PPPOE_Idle_Timeout);
	if (strcmp(wan_config.PPPOE_Service_Name,"&") !=0 )
		sprintf(serviceName,"-s %s",wan_config.PPPOE_Service_Name);
	strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
	
	// open a shell script files and run it.
	outfp = fopen (PPPOE_PROXY_RUN_PPPOECD, "w");
	if (!outfp)
	{
		LOGERROR("open file %s for write error!\n",PPPOE_PROXY_RUN_PPPOECD);
		return;
	}
	fprintf(outfp,"#!/bin/sh\n");
	//fprintf(outfp,". /var/etc/status\n");
	//pppoecd $WAN_IF -d -k -u $Username -p $Password -s $ServiceName -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &

	fprintf(outfp,"pppoecd %s -d -k -u %s -p %s %s -A %d -L %s %s -t %d -I 30 -T 30 -N 10 &\n",
	str_wanif,
	wan_config.PPPOE_Username,
	wan_config.PPPOE_Password,
	serviceName,
	wan_config.PPPOE_Authentication_Protocol,
	wan_config.PPPOE_IP,
	idleTime,
	wan_config.PPPOE_MTU);
	fclose(outfp);
	chmod (PPPOE_PROXY_RUN_PPPOECD,S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH |S_IWOTH | S_IXOTH);
	run_script(PPPOE_PROXY_RUN_PPPOECD,0,0,0);
}
void runStartPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
#if 0
	run_script("/etc/scripts/pppoe.sh","start",0,0);
#else
	runPPPoA_sh();
#endif
}
void runStartPppoecd(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
#if 0
	run_script("/etc/scripts/pppoe.sh","start",0,0);
#else
	runPPPoE_sh();
#endif
}
char LoginWanType[10]="";
char username[256]="",password[256]="";
char fixed_ipaddress[32]="",fixed_netmask[32]="",fixed_gateway[32]="",fixed_dns[32]="";
int changePPPoAUserNamePassword()//char *username,char *password)
{
	//FILE *fp,*fp2;
	//char line[1024];
	Load_Wan_Config(&wan_config);
	strcpy(wan_config.PPPOA_Username,username);
	strcpy(wan_config.PPPOA_Password,password);
	Save_Wan_Config (3,&wan_config);
	return 1;
	
/*	if ((fp=fopen(WAN_CONFIG_FILE,"r"))==NULL)
	{
		LOGERROR("can not open %s for read",WAN_CONFIG_FILE);
		return -1;
	}
	if ((fp2=fopen("/tmp/tmp_wan.conf","w"))==NULL)
	{
		LOGERROR("can not open /tmp/tmp_wan.conf for write");
		return -1;
	}
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 11111");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	//1483 Routed
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 22222");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	
	//1483 Bridged
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 33333");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//PPPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 44444");
		goto onErr1;
	}
	LOGDEBUG("Writing username=%s and password=%s",username,password);
	fprintf(fp2,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%d|%hu|%d|%hu|\n",
		wan_config.PPPOA_Description,
		wan_config.PPPOA_VPI,
		wan_config.PPPOA_VCI,
		wan_config.PPPOA_ATM_Class,
		wan_config.PPPOA_Encapsulation_Method,
		wan_config.PPPOA_NAT,
		username,
		password,
		wan_config.PPPOA_IP,
	        wan_config.PPPOA_Authentication_Protocol,
	        wan_config.PPPOA_Connection,
	        wan_config.PPPOA_Idle_Timeout,
		wan_config.PPPOA_RIP,
		wan_config.PPPOA_MTU
		);

	//IPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 555555");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//PPPoE
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 666666");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	fclose(fp);
	fclose(fp2);
	unlink(WAN_CONFIG_FILE);
	rename("/tmp/tmp_wan.conf", WAN_CONFIG_FILE);
	return 1;
onErr1:    
	fclose(fp);
	fclose(fp2);
	return -1; */
}
int changePPPoEUserNamePassword()//char *username,char *password)
{
	//FILE *fp,*fp2;
	//char line[1024];
	Load_Wan_Config(&wan_config);
	strcpy(wan_config.PPPOE_Username,username);
	strcpy(wan_config.PPPOE_Password,password);
	//LOGDEBUG("Entering changePPPoEUserNamePassword:Username=%s password=%s",username,password);
	//DPRINTF("Entering changePPPoEUserNamePassword:Username=%s password=%s",username,password);
	Save_Wan_Config (5,&wan_config);
	return 1;
	
/*	LOGERROR("Entering changePPPoEUserNamePassword:Username=%s password=%s",username,password);
	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))==NULL)
	{
		LOGERROR("can not open %s for read",WAN_CONFIG_FILE);
		return -1;
	}
	if ((fp2=fopen("/tmp/tmp_wan.conf","w"))==NULL)
	{
		LOGERROR("can not open /tmp/tmp_wan.conf for write");
		return -1;
	}
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 11111");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	//1483 Routed
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 22222");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	
	//1483 Bridged
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 33333");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//PPPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 44444");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//IPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 555555");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	//PPPoE
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 666666");
		goto onErr1;
	}
	fclose(fp);
	LOGDEBUG("Writing username=%s and password=%s",username,password);
	load_blank_string(&wan_config.PPPOE_Description);
	load_blank_string(&wan_config.PPPOE_Username);
	load_blank_string(&wan_config.PPPOE_Password);
	load_blank_string(&wan_config.PPPOE_Service_Name);
	load_blank_string(&wan_config.PPPOE_IP);
	fprintf(fp2,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%s|%d|%d|%hu|%d|%hu|%d|\n",
		wan_config.PPPOE_Description,
		wan_config.PPPOE_VPI,
		wan_config.PPPOE_VCI,
		wan_config.PPPOE_ATM_Class,
		wan_config.PPPOE_Encapsulation_Method,
		wan_config.PPPOE_NAT,
		username,
		password,
		wan_config.PPPOE_Service_Name,
		wan_config.PPPOE_IP,
	        wan_config.PPPOE_Authentication_Protocol,
	        wan_config.PPPOE_Connection,
	        wan_config.PPPOE_Idle_Timeout,
		wan_config.PPPOE_RIP,
		wan_config.PPPOE_MTU,
		wan_config.PPPOE_RELAY
		);
	fclose(fp2);
	unlink(WAN_CONFIG_FILE);
	rename("/tmp/tmp_wan.conf", WAN_CONFIG_FILE);
	return 1;
onErr1:    
	fclose(fp);
	fclose(fp2);
	return -1; */
}

static void resetCurrentWanCfg(void){
	WAN_CONFIG_DATA *d = &old_wan_config;
	WAN_CONFIG_DATA *d1 = &wan_config;
	memset(d,0,sizeof(WAN_CONFIG_DATA));
	memset(d1,0,sizeof(WAN_CONFIG_DATA));
}
void Save_Wan_Config (int i,WAN_CONFIG_DATA *d){
	
	FILE *fp;
	d->Wan_Type=i;
	if((fp=fopen(WAN_CONFIG_FILE,"w"))!=NULL)
	{
	
	/*
	 *  i=1 1483 Routed
	 *  i=2 1483 Bridged
	 *  i=3 PPPOA
	 *  i=4 IPOA
	 *  i=5 PPPOE
	 */
	
	fprintf(fp, "#:%d:%d\n",d->Wan_Type,d->Quick_Wan_Type);
	//1483 Routed
	load_blank_string(&d->Routed_Description);
	load_blank_string(&d->Routed_IP);
	load_blank_string(&d->Routed_Netmask);
	load_blank_string(&d->Routed_Gateway);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->Routed_Description,
		d->Routed_VPI,
		d->Routed_VCI,
		d->Routed_ATM_Class,
		d->Routed_NAT,
        	d->Routed_Encapsulation_Method,
	        d->Routed_IP_Assignment,
		d->Routed_IP,
		d->Routed_Netmask,
		d->Routed_Gateway,
		d->Routed_RIP,
		d->Routed_MTU
		);
	
	load_blank_string(&d->Bridged_Description);	
	//1483 Bridged
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|\n",
		d->Bridged_Description,
		d->Bridged_VPI,
		d->Bridged_VCI,
		d->Bridged_ATM_Class,
		d->Bridged_Encapsulation_Method,
        	d->Bridged_Ether_Filter_Type,
	        d->Bridged_Spanning_Bridge_Interface
		);

	load_blank_string(&d->PPPOA_Description);
	load_blank_string(&d->PPPOA_Username);
	load_blank_string(&d->PPPOA_Password);
	load_blank_string(&d->PPPOA_IP);
	//PPPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%d|%hu|%d|%hu|\n",
		d->PPPOA_Description,
		d->PPPOA_VPI,
		d->PPPOA_VCI,
		d->PPPOA_ATM_Class,
		d->PPPOA_Encapsulation_Method,
		d->PPPOA_NAT,
		d->PPPOA_Username,
		d->PPPOA_Password,
		d->PPPOA_IP,
	        d->PPPOA_Authentication_Protocol,
	        d->PPPOA_Connection,
	        d->PPPOA_Idle_Timeout,
		d->PPPOA_RIP,
		d->PPPOA_MTU
		);
	
	load_blank_string(&d->IPOA_Description);
	load_blank_string(&d->IPOA_IP);
	load_blank_string(&d->IPOA_Netmask);
	load_blank_string(&d->IPOA_Gateway);
	//IPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->IPOA_Description,
		d->IPOA_VPI,
		d->IPOA_VCI,
		d->IPOA_ATM_Class,
		d->IPOA_NAT,
	        d->IPOA_IP_Assignment,
		d->IPOA_IP,
		d->IPOA_Netmask,
		d->IPOA_Gateway,
		d->IPOA_RIP,
		d->IPOA_MTU
		);
		
	//PPPOE
	load_blank_string(&d->PPPOE_Description);
	load_blank_string(&d->PPPOE_Username);
	load_blank_string(&d->PPPOE_Password);
	load_blank_string(&d->PPPOE_Service_Name);
	load_blank_string(&d->PPPOE_IP);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%s|%d|%d|%hu|%d|%hu|%d|\n",
		d->PPPOE_Description,
		d->PPPOE_VPI,
		d->PPPOE_VCI,
		d->PPPOE_ATM_Class,
		d->PPPOE_Encapsulation_Method,
		d->PPPOE_NAT,
		d->PPPOE_Username,
		d->PPPOE_Password,
		d->PPPOE_Service_Name,
		d->PPPOE_IP,
	        d->PPPOE_Authentication_Protocol,
	        d->PPPOE_Connection,
	        d->PPPOE_Idle_Timeout,
		d->PPPOE_RIP,
		d->PPPOE_MTU,
		d->PPPOE_RELAY
		);
	fclose(fp);
	}
//	d->Quick_Wan_Type=d->Wan_Type;
}	
void Load_Wan_Config (WAN_CONFIG_DATA *d){
	FILE *fp;
	char line[1024];
	resetCurrentWanCfg();
	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL)
	{
	if (fgets(line, 1024, fp))
		sscanf(line,"#:%d:%d\n",(int *)&d->Wan_Type,(int *)&d->Quick_Wan_Type);
		
	//1483 Routed
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		d->Routed_Description,
		&d->Routed_VPI,
		&d->Routed_VCI,
		(int *)&d->Routed_ATM_Class,
		(int *)&d->Routed_NAT,
        	(int *)&d->Routed_Encapsulation_Method,
	        (int *)&d->Routed_IP_Assignment,
		d->Routed_IP,
		d->Routed_Netmask,
		d->Routed_Gateway,
		(int *)&d->Routed_RIP,
		&d->Routed_MTU
		);
	}
	print_blank_string(&d->Routed_Description);
	print_blank_string(&d->Routed_IP);
	print_blank_string(&d->Routed_Netmask);
	print_blank_string(&d->Routed_Gateway);
	
	//1483 Bridged
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|\n",
		d->Bridged_Description,
		&d->Bridged_VPI,
		&d->Bridged_VCI,
		(int *)&d->Bridged_ATM_Class,
		(int *)&d->Bridged_Encapsulation_Method,
        	(int *)&d->Bridged_Ether_Filter_Type,
	        (int *)&d->Bridged_Spanning_Bridge_Interface
		);
	}
	
	print_blank_string(&d->Bridged_Description);	
	//PPPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%20[^|]|%d|%d|%hu|%d|%hu|\n",
		d->PPPOA_Description,
		&d->PPPOA_VPI,
		&d->PPPOA_VCI,
		(int *)&d->PPPOA_ATM_Class,
        	(int *)&d->PPPOA_Encapsulation_Method,
		(int *)&d->PPPOA_NAT,
		d->PPPOA_Username,
		d->PPPOA_Password,
		d->PPPOA_IP,
	        (int *)&d->PPPOA_Authentication_Protocol,
	        (int *)&d->PPPOA_Connection,
	        &d->PPPOA_Idle_Timeout,
		(int *)&d->PPPOA_RIP,
		&d->PPPOA_MTU
		);
	}
	
	print_blank_string(&d->PPPOA_Description);
	print_blank_string(&d->PPPOA_Username);
	print_blank_string(&d->PPPOA_Password);
	print_blank_string(&d->PPPOA_IP);	
	//IPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,"|%50[^|]|%hu|%hu|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",d->IPOA_Description,
		&d->IPOA_VPI,
		&d->IPOA_VCI,
		(int *)&d->IPOA_ATM_Class,
		(int *)&d->IPOA_NAT,
	        (int *)&d->IPOA_IP_Assignment,
		d->IPOA_IP,
		d->IPOA_Netmask,
		d->IPOA_Gateway,
		(int *)&d->IPOA_RIP,
		&d->IPOA_MTU
		);
	}	
	
	print_blank_string(&d->IPOA_Description);
	print_blank_string(&d->IPOA_IP);
	print_blank_string(&d->IPOA_Netmask);
	print_blank_string(&d->IPOA_Gateway);	
	//PPPOE
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%32[^|]|%20[^|]|%d|%d|%hu|%d|%hu|%d|\n",
		d->PPPOE_Description,
		&d->PPPOE_VPI,
		&d->PPPOE_VCI,
		(int *)&d->PPPOE_ATM_Class,
        	(int *)&d->PPPOE_Encapsulation_Method,
		(int *)&d->PPPOE_NAT,
		d->PPPOE_Username,
		d->PPPOE_Password,
		d->PPPOE_Service_Name,
		d->PPPOE_IP,
	        (int *)&d->PPPOE_Authentication_Protocol,
	        (int *)&d->PPPOE_Connection,
	        &d->PPPOE_Idle_Timeout,
		(int *)&d->PPPOE_RIP,
	       &d->PPPOE_MTU,
		&d->PPPOE_RELAY
		);
	}
	print_blank_string(&d->PPPOE_Description);
	print_blank_string(&d->PPPOE_Username);
	print_blank_string(&d->PPPOE_Password);
	print_blank_string(&d->PPPOE_Service_Name);
	print_blank_string(&d->PPPOE_IP);
	fclose(fp);
	}
//	if (d->Quick_Wan_Type==0)
//		d->Quick_Wan_Type=d->Wan_Type;	
}
static void runStartBr2684ctl(int Vpi,int Vci,int Enc){
	char str_vpi[10];
	char str_vci[10];
	char str_enc[2];
	sprintf(str_vpi,"%d",Vpi);
	sprintf(str_vci,"%d",Vci);
	sprintf(str_enc,"%d",Enc);
	run_script("/etc/scripts/br2684ctl_start.sh",str_vpi,str_vci,str_enc);
}
/*
static void runStopRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","stop",0,0);
}
static void runStopFirewall(){
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	
	//run_script("/etc/scripts/fw.sh","stop",0,0);
}*/

static void runStopDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/dhcpc.sh","stop",0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
}
static void runStartDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	run_script("/etc/scripts/dhcpc.sh","start","&",0);
        //udhcpc -i $WAN_IF -s /etc/scripts/udhcpc.sh -p /var/run/udhcpc.pid &
	//run_task("udhcpc","udhcpc","-i","nas0","-s","/etc/scripts/udhcpc.sh","-p","/var/run/udhcpc.pid","&",NULL);
//	sleep(2);
//        sleep 2
												
}
static void runStopBr2684ctl(){
	long *pid;
	char str_pid[10];
	pid=find_pid_by_name1("br2684ctl");
	if (!pid || *pid<=0)
	{
		//DPRINTF(" %s : No Such Process\n",ProcessName);
	}
	else
	{
	sprintf(str_pid,"%lu",*pid);
	run_task("kill","kill","-15",str_pid,NULL);	
	sleep(1);
	run_task("br2684ctl","br2684ctl","-d","0",NULL);	
//	run_script("/etc/scripts/br2684ctl_stop.sh",0,0,0);
	}
}
void RunPPPoA(WAN_CONFIG_DATA *d1){
	/*
	
	int IsRipChange=0;
	int IsFirewallChange=0;
	int IsPppoecdChange=0;
	int IsBr2684ctlChange=0;
	int ISREBOOT=0;
	DPRINTF("old_pppoe_ip:%s\n",d->PPPOE_IP);
	DPRINTF("new_pppoe_ip:%s\n",d1->PPPOE_IP);
	DPRINTF("ols_Wan_Type:%d\n",d->Wan_Type);
	DPRINTF("new_Wan_Type:%d\n",d1->Wan_Type);
	DPRINTF("quick_old_Wan_Type:%d\n",d->Quick_Wan_Type);
	DPRINTF("quick_new_Wan_Type:%d\n",d1->Quick_Wan_Type);
	*/

	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","pppoa");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","ppp0");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		if (d1->PPPOE_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else	
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
			
	
	save_globe_config(SYS_STATUS_FILE,"WAN=","pppoa");	
	save_globe_config(SYS_STATUS_FILE,"WAN_IF=","ppp0");
	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	if (d1->PPPOE_NAT==0)
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
	else	
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
//DPRINTF("stop rip\n");	
		//runStopRip();
//DPRINTF("stop firewall\n");	
		//runStopFirewall();
DPRINTF("stop pppoecd\n");	
		runStopPppoecd();
DPRINTF("stop br2684ctl\n");	
		runStopBr2684ctl();
DPRINTF("start pppoa\n");	
		runStartPppoa();
}

void RunPPPoE(WAN_CONFIG_DATA *d1){
	/*
	
	int IsRipChange=0;
	int IsFirewallChange=0;
	int IsPppoecdChange=0;
	int IsBr2684ctlChange=0;
	int ISREBOOT=0;
	DPRINTF("old_pppoe_ip:%s\n",d->PPPOE_IP);
	DPRINTF("new_pppoe_ip:%s\n",d1->PPPOE_IP);
	DPRINTF("ols_Wan_Type:%d\n",d->Wan_Type);
	DPRINTF("new_Wan_Type:%d\n",d1->Wan_Type);
	DPRINTF("quick_old_Wan_Type:%d\n",d->Quick_Wan_Type);
	DPRINTF("quick_new_Wan_Type:%d\n",d1->Quick_Wan_Type);
	*/

	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","pppoe");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		if (d1->PPPOE_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else	
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
			
	
	save_globe_config(SYS_STATUS_FILE,"WAN=","pppoe");	
	save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	if (d1->PPPOE_NAT==0)
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
	else	
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
//DPRINTF("stop rip\n");	
		//runStopRip();
//DPRINTF("stop firewall\n");	
		//runStopFirewall();
DPRINTF("stop pppoecd\n");	
		runStopPppoecd();
DPRINTF("stop br2684ctl\n");	
		runStopBr2684ctl();
DPRINTF("start br2684ctl\n");	
		runStartBr2684ctl(d1->PPPOE_VPI,d1->PPPOE_VCI,d1->PPPOE_Encapsulation_Method);
DPRINTF("start pppoecd\n");	
		runStartPppoecd();
}
void Run1483Routed(WAN_CONFIG_DATA *d1,int Enc){
	
		/*
		DPRINTF("d->Wan_Type:%d\n",d->Wan_Type);		
		DPRINTF("d1->Wan_Type:%d\n",d1->Wan_Type);		
		DPRINTF("d->Quick_Wan_Type:%d\n",d->Quick_Wan_Type);		
		DPRINTF("d1->Quick_Wan_Type:%d\n",d1->Quick_Wan_Type);		
		DPRINTF("d->Routed_IP_Assignment:%d\n",d->Routed_IP_Assignment);		
		DPRINTF("d1->Routed_IP_Assignment:%d\n",d1->Routed_IP_Assignment);		
		DPRINTF("d->Routed_Encapsulation_Method:%d\n",d->Routed_Encapsulation_Method);		
		DPRINTF("d1->Routed_Encapsulation_Method:%d\n",d1->Routed_Encapsulation_Method);		
		*/
		if(d1->Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");

	
		if(d1->Routed_NAT==0)
			save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
		else	
			save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","dynamic");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
		save_globe_config(SYS_STATUS_FILE,"WAN=","dynamic");	
		save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
		//runStopRip();
		//runStopFirewall();
		DPRINTF("stop DHCPC\n");
		runStopDhcpc();
		DPRINTF("stop br2684\n");
		runStopBr2684ctl();
		DPRINTF("start br2684\n");
		runStartBr2684ctl(d1->Routed_VPI,d1->Routed_VCI,Enc);
		DPRINTF("start dhcpc\n");
		runStartDhcpc();
}
/*
void restart_dns_proxy(){
	run_script(FAKED_DNS_PROXY_STOP,0,0,0);
//KillProcessByName("FakedDnsProxy",SIGKILL);
	DPRINTF("Stop FakedDnsProxy\n");
	//run_task("dnsmasq","dnsmasq","&",NULL);
	DPRINTF("Start dnsmasq\n");
}
*/
int Enc=0;
static int restart_wan(){
	DPRINTF("Restart wan start\n");
	FILE *f;
	int Wan_Vpi=0,Wan_Vci=0;
	char enc[32];
	char ip[32];
	char line[255];
	char gateway[32];
	Load_Wan_Config(&wan_config);
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
	f=fopen("/var/tmp/first_scanpvc_result","r");
	if(f){
		if (fgets(line,255,f)){
		sscanf(line,"VPI %d VCI %d %s %s %s",&Wan_Vpi,&Wan_Vci,enc,ip,gateway);
		if(!strcmp(enc,"DHCPC_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		Save_Wan_Config(1,&wan_config);
		//if ((wan_config.Routed_VPI!=old_wan_config.Routed_VPI)||(wan_config.Routed_VCI!=old_wan_config.Routed_VCI)){
			DPRINTF("Dhcp llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
			LOGDEBUG("Dhcp llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
			/*
			Run1483Routed(&wan_config,0);
			restart_dns_proxy();
			*/
			write_value_to_file("/tmp/pppoe_login_protocol",DHCP_Scanned);
			Enc=0;
		fclose(f);
			return 1;
		//}
		}
		if(!strcmp(enc,"DHCPC_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		Save_Wan_Config(1,&wan_config);
		//if ((wan_config.Routed_VPI!=old_wan_config.Routed_VPI)||(wan_config.Routed_VCI!=old_wan_config.Routed_VCI)){
			LOGDEBUG("Dhcp VC-Mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
			DPRINTF("Dhcp VC-Mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
			/*
			Run1483Routed(&wan_config,1);
			restart_dns_proxy();
			*/
			Enc=1;
			write_value_to_file("/tmp/pppoe_login_protocol",DHCP_Scanned);
		fclose(f);
			return 1;
		//}
		}
		if(!strcmp(enc,"PPPOE_LLC_VALID")){
		wan_config.Quick_Wan_Type=2;
		wan_config.Wan_Type=5;
        	wan_config.PPPOE_VPI=Wan_Vpi;
        	wan_config.PPPOE_VCI=Wan_Vci;
        	wan_config.PPPOE_Encapsulation_Method=0;
		Save_Wan_Config(5,&wan_config);
		DPRINTF("PPPoE llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		LOGDEBUG("PPPoE llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		write_value_to_file("/tmp/pppoe_login_protocol",PPPoE_Scanned);
		fclose(f);
			return 1;
		}
		if(!strcmp(enc,"PPPOE_VC_VALID")){
		wan_config.Quick_Wan_Type=12;
		wan_config.Wan_Type=5;
        	wan_config.PPPOE_VPI=Wan_Vpi;
        	wan_config.PPPOE_VCI=Wan_Vci;
        	wan_config.PPPOE_Encapsulation_Method=1;
		Save_Wan_Config(5,&wan_config);
		DPRINTF("PPPoE vc-mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		LOGDEBUG("PPPoE vc-mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		write_value_to_file("/tmp/pppoe_login_protocol",PPPoE_Scanned);
		fclose(f);
			return 1;
		}
		if(!strcmp(enc,"PPPOA_VC_VALID")){
		wan_config.Quick_Wan_Type=1;
		wan_config.Wan_Type=3;
        	wan_config.PPPOA_VPI=Wan_Vpi;
        	wan_config.PPPOA_VCI=Wan_Vci;
        	wan_config.PPPOA_Encapsulation_Method=1;
		Save_Wan_Config(3,&wan_config);
		DPRINTF("PPPoA vc-mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		LOGDEBUG("PPPoA vc-mux %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		write_value_to_file("/tmp/pppoe_login_protocol",PPPoA_Scanned);
		fclose(f);
		return 1;
		}
		if(!strcmp(enc,"PPPOA_LLC_VALID")){
		wan_config.Quick_Wan_Type=11;
		wan_config.Wan_Type=3;
        	wan_config.PPPOA_VPI=Wan_Vpi;
        	wan_config.PPPOA_VCI=Wan_Vci;
        	wan_config.PPPOA_Encapsulation_Method=0;
		Save_Wan_Config(3,&wan_config);
		DPRINTF("PPPoA llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		LOGDEBUG("PPPoA llc %d/%d scanned\n",Wan_Vpi,Wan_Vci);
		write_value_to_file("/tmp/pppoe_login_protocol",PPPoA_Scanned);
		fclose(f);
			return 1;
		}
		if(!strcmp(enc,"FIXIP_2684B_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=1;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		}
		if(!strcmp(enc,"FIXIP_2684B_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
		wan_config.Routed_IP_Assignment=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		}
		}
		fclose(f);
	}
		return 0;
}

static int change_wan_setting(){
	FILE *f;
	char line[64];
	int vpi=0,vci=0;
	char enc[32];
	int srcIP1=0;
	int srcIP2=0;
	int srcIP3=0;
	int srcIP4=0;
	int destIP1=0;
	int destIP2=0;
	int destIP3=0;
	int destIP4=0;
	char ip[20];
	char gateway[20];

	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		fgets(line,sizeof(line),f);
		sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
		fclose(f);
	//DPRINTF("Auto:vpi=%d vci=%d enc=%s\n",vpi,vci,enc);
	}
	f=fopen("/flash/fixscanpvc.conf","r");
	if(f){
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&srcIP1,&srcIP2,&srcIP3,&srcIP4);
			sprintf(ip,"%d.%d.%d.%d",srcIP1,srcIP2,srcIP3,srcIP4);
		}
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&destIP1,&destIP2,&destIP3,&destIP4);
			sprintf(gateway,"%d.%d.%d.%d",destIP1,destIP2,destIP3,destIP4);
		}
		fclose(f);
	//DPRINTF("Auto:ip=%s gw=%s\n",ip,gateway);
	}

	f=fopen("/var/tmp/first_scanpvc_result","w");
	if(f){
		fprintf(f,"VPI %d VCI %d %s\n",vpi,vci,enc);	
		fclose(f);
	}
	return 1;
}
static int autoscan_action(){
	unlink("/var/tmp/scanpvc_result");
	DPRINTF("sardoing 0\n");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","0",0);
	// Sam sleep(10);
	sleep(18);
	DPRINTF("sardoing 1\n");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","1",0);

	FILE *f;
	char line[64];
	int i=0;
	//char enc[32];

	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
	DPRINTF("open /var/tmp/scanpvc_result for reading\n");
		while(fgets(line,sizeof(line),f)){
		i++;
		}
		fclose(f);
	}
	else
	{
	DPRINTF("can not open /var/tmp/scanpvc_result for reading\n");
	}
	return i;

}

//int scantime=0;
extern int result_num;

int scanned_protocol=0;
/*
int pppoeScanned=0;
int pppoaScanned=0;
int dhcpScanned=0;
*/
#if 1
int autoScanStarted=0;
void start_auto_scan(){
	DMTCTRL_DMT_INFO Arg;
 	unlink("/tmp/pppoe_login_protocol");
	if(autoScanStarted)
	{
		DPRINTF("start_auto_scan: auto scan is running. Quit\n");
		return;
	}
	autoScanStarted=1;
	//while(1)
	{
		int nFd = open( "/dev/dmtdev", O_RDWR );
		if( nFd == -1  )
		{
			DPRINTF("get_atm_status:severe error for open /dev/dmtdev for ADSL device\n");
			autoScanStarted=0;
			return ;
		}
	       	ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
 		close(nFd);
	       	if(Arg.dmt_status==ADSL_UP)
		{
			result_num=autoscan_action();
			DPRINTF("AutoScan num: %d\n",result_num);
			if (result_num==0)
			{
				ReScanned=0;
			write_value_to_file("/tmp/pppoe_login_protocol",Nothing_Scanned);
				//scantime++;
				//break;
			}
			else if (result_num>1)
			{
				ReScanned=0;
				write_value_to_file("/tmp/pppoe_login_protocol",More_Than_One_Scanned);
				//scantime++;
				//break;
			}
			else if (result_num==1)
			{
				ReScanned=0;
				change_wan_setting();
				restart_wan();
				save_globe_config("/flash/config","PPPoELogin=","no");
				//scantime++;
				//run_task("profile","profile","put","/flash","&",NULL);
				//sleep(5);
				//break;
			}
		}
		else{
		DPRINTF("start_auto_scan: (Arg.dmt_status is not ADSL_UP\n");
		} 
	}

	//sleep(10);
	scanned_protocol=read_value_from_file("/tmp/pppoe_login_protocol");
	DPRINTF("scanned protocol:%d\n",scanned_protocol);

	autoScanStarted=0;
	
}
#else
void start_auto_scan(){
	//DPRINTF("start AdslFactoryResetAutoScan\n");
	unlink("/tmp/pppoe_login_protocol");

	while(1)
	{
		int nFd = open( "/dev/dmtdev", O_RDWR );
		if( nFd == -1  )
		{
			DPRINTF("get_atm_status:severe error for open /dev/dmtdev for ADSL device\n");
			return ;
		}
		DMTCTRL_DMT_INFO Arg;
 	       	ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
 		close(nFd);
	       	if(Arg.dmt_status==ADSL_UP){
			result_num=autoscan_action();
			DPRINTF("AutoScan num: %d\n",result_num);
			if (result_num==0){
				ReScanned=0;
			write_value_to_file("/tmp/pppoe_login_protocol",Nothing_Scanned);
				//scantime++;
				break;
			}else if (result_num>1){
				ReScanned=0;
				write_value_to_file("/tmp/pppoe_login_protocol",More_Than_One_Scanned);
				//scantime++;
				break;
			}else if (result_num==1){
				ReScanned=0;
				change_wan_setting();
				restart_wan();
				save_globe_config("/flash/config","PPPoELogin=","no");
				//scantime++;
				//run_task("profile","profile","put","/flash","&",NULL);
				//sleep(5);
				break;
			}
			
			
		}else{
			sleep(3);
		}
	}

	//run_task("AdslFactoryResetAutoScan","AdslFactoryResetAutoScan","&",NULL);
	//sleep(10);
	scanned_protocol=read_value_from_file("/tmp/pppoe_login_protocol");
	DPRINTF("scanned protocol:%d\n",scanned_protocol);
	/*
	if (scanned_protocol==Nothing_Scanned){
		dhcpScanned=0;		
		pppoeScanned=0;		
		pppoaScanned=0;		
	}else if(scanned_protocol==PPPoE_Scanned){
		dhcpScanned=0;		
		pppoeScanned=1;		
		pppoaScanned=0;		
	}else if(scanned_protocol==DHCP_Scanned){
		dhcpScanned=1;		
		pppoeScanned=0;		
		pppoaScanned=0;		
	}else if(scanned_protocol==PPPoA_Scanned){
		dhcpScanned=0;		
		pppoeScanned=0;		
		pppoaScanned=1;		

	}else{
		dhcpScanned=1;		
		pppoeScanned=1;		
		pppoaScanned=1;		
	}
	*/
	
}
#endif

void ADSLCheckPages(int client_sd,char *buf)//,char *username,char *password)
{
	int nFd = open( "/dev/dmtdev", O_RDWR );
	DMTCTRL_DMT_INFO Arg;
	if( nFd == -1  )
	{
		LOGERROR("pppoeLogin:ADSLCheckPages:severe error for open /dev/dmtdev for ADSL device\n");
	}
    ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
	close(nFd);

	if(Arg.dmt_status>=ADSL_TRAINING_2)
	{// up or training
		// since the PPPauth failued is kept of last pppoe action, so we will not check if changePWD is on.
		
		processReqUrl("/pppoe_link_status_connecting_check.html");
		DPRINTF("ADSL check page when ADSL status =%d.\n",Arg.dmt_status);
		close(client_sd);
		if ((scanned_protocol==0)&&(Arg.dmt_status==ADSL_UP)){
	 	//if (!dhcpScanned&&!pppoeScanned&&!pppoaScanned){
		//	if (scantime==0)
			start_auto_scan();
		//	scantime++;
			return;			
		}
	}
	else
	{
		 //sprintf(buf,PPPoE_LOGIN_STATUS,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,5000,"ADSL Line is not ready. Please check it on.");
		 //write(client_sd, buf, strlen(buf));					
		processReqUrl("/pppoe_link_status_ADSL_NotReady_check.html");
		close(client_sd);
		ReScanned=1;
		scanned_protocol=0;
		//scantime=0;
	}
}
int pppoeStarted=0;
int pppoaStarted=0;
int pppoeConnected=0;
int first_start_pppoe=0;
int first_start_pppoa=0;
int first_start_dhcp=0;
void displayStatusPages(int client_sd,char *buf)//,char *username,char *password)
{
	int nFd = open( "/dev/dmtdev", O_RDWR );
	DMTCTRL_DMT_INFO Arg;
	if( nFd == -1  )
	{
		LOGERROR("pppoeLogin:displayStatusPages:severe error for open /dev/dmtdev for ADSL device\n");
	}
    ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
	close(nFd);

	if(Arg.dmt_status>=ADSL_TRAINING_2)
	{// up or training
		// since the PPPauth failued is kept of last pppoe action, so we will not check if changePWD is on.
			if (first_start_pppoe==1){
				processReqUrl("/pppoe_link_status_connecting.html");
				close(client_sd);
				RunPPPoE(&wan_config);
				first_start_pppoe++;
				return;
			}else if (first_start_pppoa==1){
				processReqUrl("/pppoe_link_status_connecting.html");
				close(client_sd);
				RunPPPoA(&wan_config);
				first_start_pppoa++;
				return;
			}



			
			// Yes, only if password is change, so we need to restart the PPPoE
			// display first page.
			//sprintf(buf,PPPoE_LOGIN_STATUS,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,10000,"PPPoE connection is logging on. Please wait......");
			//write(client_sd, buf, strlen(buf));
			if(checkIfPPPAuthFailed())
			{
				//char wrongPasswordMsg[512];
				//sprintf(wrongPasswordMsg,WRONG_PASSWORD_WARNING,MAGIC_HASH_MD5_VALUE);
				//sprintf(buf,LOGIN_PAGE_MESSAGE,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,wrongPasswordMsg);
				//write(client_sd, buf, strlen(buf));		
				processReqUrl("/pppoe_login_failed.html");
				close(client_sd);
				if(scanned_protocol==PPPoE_Scanned){
				pppoeStarted=0;
				LOGDEBUG("Stop the PPPoeCD");			
				runStopPppoecd();
				}else if(scanned_protocol==PPPoA_Scanned){
					pppoaStarted=0;
					LOGDEBUG("Stop the PPPoA");			
					runStopPppoa();
				}
			}
			else
			{
				//sprintf(buf,PPPoE_LOGIN_STATUS,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,8000,"PPPoE connection is logging on. Please wait......");
				//write(client_sd, buf, strlen(buf));		
				processReqUrl("/pppoe_link_status_connecting.html");
				close(client_sd);
			}

	}
	else
	{
		 //sprintf(buf,PPPoE_LOGIN_STATUS,MAGIC_HASH_MD5_VALUE,MAGIC_HASH_MD5_VALUE,5000,"ADSL Line is not ready. Please check it on.");
		 //write(client_sd, buf, strlen(buf));					
		processReqUrl("/pppoe_link_status_ADSL_NotReady_check.html");
		//processReqUrl("/pppoe_link_status_ADSL_NotReady.html");
		close(client_sd);
		scanned_protocol=0;
		ReScanned=1;
		//scantime=0;
	}
}

void fwriteFile(char *filename)
{
	FILE *fp;
	int fsize;

	fp = fopen(filename,"r");
	if (fp==NULL)
	{
		//LOGERROR( "no match %s",req_url);//==>:%s",buff);
		return;
	}
	fseek(fp,0L, SEEK_END);
	fsize=ftell(fp);
	//LOGDEBUG("fsize=%d",fsize);
	rewind(fp);
#define MAX_PAGE_SIZE 1024
    while(fsize)
	{
		if(fsize>MAX_PAGE_SIZE)
		{					
			fread(buf, 1024, 1,  fp);
			write(client_sd, buf,1024);
			fsize-=MAX_PAGE_SIZE;
		}
		else
		{
			fread(buf, fsize, 1,  fp);
			write(client_sd, buf,fsize);
			fsize=0;
		}
		
		//LOGDEBUG("fsize left=%d",fsize);
	}
	fclose(fp);
}

void processReqUrl(char *req_url)
{
	char filename[80];
	sprintf(filename,"/html%s",req_url);
	fwriteFile(filename);
}



int getSpecificScanResult(int i)
{
	char line[255];
	int j=0;
	FILE *scanfp,*f;
	scanfp=fopen("/var/tmp/scanpvc_result","r");
	if(!scanfp)
	{
		return 0;
	}
			
	while(fgets(line,sizeof(line),scanfp))
	{
		if(i==j)
		{	
			DPRINTF("getSpecificScanResult: get the %dth string\n",i);
			f=fopen("/var/tmp/first_scanpvc_result","w");
			if(f){
				fputs(line,f);	
				fclose(f);
			}
			fclose(scanfp);
			return 1;
		}
		j++;
	}
	fclose(scanfp);
	return 0;
}

//WE need to define a way that which auto scan result is to be the default one.
// So, we used greading.  THe exact match first one is choosed.
// If no exact match then,
// The same protcol and encap. is 80 
// The same protcol is 70
// Other is 0.
int defaultProtcolRating[50];
#define PROTOCOL_SELECT_STRING "<!--pselect()-->"
void processReqUrl_PPPoELogin_html(void)
{
	FILE *infp,*outfp,*scanfp;
	char line[255];
	int vpi=0,vci=0,i,defaultScanResult=0,kk;
	char enc[32];
	char TableLabel[]="<tr><H2>Auto Scan Result</H2></tr>"
	"<tr><td class=title></td><td class=title>NO.</td><td class=title>VPI</td><td class=title>VCI</td><td class=title>Encapsulation</td>";
	char IdxValue[]="<input type=\"hidden\" name=\"IdxVal\" value=\"%d\">";
	int defaultIndexValue=0;
	char TableFmt[]="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\"  onClick=\"switchsel(this.value);\" %s></td>"
	"<td>%d</td>\n"
	"<td>%d</td>\n"
	"<td>%d</td>\n"
	"<td>%s</td></tr>\n";
	infp = fopen("/html/pppoe_login.html","r");
	if (infp==NULL)
	{
		return;
	}
	outfp = fopen("/tmp/pppoe_login.html","w");
	if (outfp==NULL)
	{
		fclose(infp);
		return;
	}
	
	
	while(fgets(line, sizeof(line), infp))
	{
		if(strstr(line,PROTOCOL_SELECT_STRING))
		{//We got the place to put our select into.	
			fprintf(outfp,TableLabel);
			scanfp=fopen("/var/tmp/scanpvc_result","r");
			if(!scanfp)
			{
				fclose(infp);
				fclose(outfp);
				return;
			}
			
			//First, we check if the config default exist in the scan result. If so, it is default.
			// Otherwise, the first one is default
	
			Load_Wan_Config(&wan_config);
		
			defaultScanResult=0;
			memset(defaultProtcolRating,0,sizeof(defaultProtcolRating));
			while(fgets(line,sizeof(line),scanfp))
			{
				memset(enc,0,sizeof(enc));
				sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
		
				switch(wan_config.Quick_Wan_Type)
				{
					case 8://DHCPC_LLC
					if((!strcmp(enc,"DHCPC_LLC_VALID"))&&(wan_config.Routed_VPI==vpi)&&(wan_config.Routed_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"DHCPC_LLC_VALID"))||(!strcmp(enc,"DHCPC_VC_VALID")))
					{
						if(!strcmp(enc,"DHCPC_LLC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
					case 7://DHCPC_VC
					if((!strcmp(enc,"DHCPC_VC_VALID"))&&(wan_config.Routed_VPI==vpi)&&(wan_config.Routed_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"DHCPC_LLC_VALID"))||(!strcmp(enc,"DHCPC_VC_VALID")))
					{
						if(!strcmp(enc,"DHCPC_VC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
					case 2://PPPOE_LLC
					if((!strcmp(enc,"PPPOE_LLC_VALID"))&&(wan_config.PPPOE_VPI==vpi)&&(wan_config.PPPOE_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"PPPOE_LLC_VALID"))||(!strcmp(enc,"PPPOE_VC_VALID")))
					{
						if(!strcmp(enc,"PPPOE_LLC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
					case 12://PPPOE_VC
					if((!strcmp(enc,"PPPOE_VC_VALID"))&&(wan_config.PPPOE_VPI==vpi)&&(wan_config.PPPOE_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"PPPOE_LLC_VALID"))||(!strcmp(enc,"PPPOE_VC_VALID")))
					{
						if(!strcmp(enc,"PPPOE_VC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
					case 11://PPPOA_LLC
					if((!strcmp(enc,"PPPOA_LLC_VALID"))&&(wan_config.PPPOE_VPI==vpi)&&(wan_config.PPPOE_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"PPPOA_LLC_VALID"))||(!strcmp(enc,"PPPOA_VC_VALID")))
					{
						if(!strcmp(enc,"PPPOA_LLC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
					case 1://PPPOA_VC
					if((!strcmp(enc,"PPPOA_VC_VALID"))&&(wan_config.PPPOE_VPI==vpi)&&(wan_config.PPPOE_VCI==vci))
						goto exitHere;
					if((!strcmp(enc,"PPPOA_LLC_VALID"))||(!strcmp(enc,"PPPOA_VC_VALID")))
					{
						if(!strcmp(enc,"PPPOA_VC_VALID"))
							defaultProtcolRating[defaultScanResult]=80;// same DHCPC and same enc
						else
							defaultProtcolRating[defaultScanResult]=70;// same DHCP C but not same enc
					}
					break;
				}// For FIXIP_2684B_LLC_VALID/FIXIP_2684B_VC_VALID, we do not support SSO.
				defaultScanResult++;
			}
			//We did not found the one who has the same VPI and VCI and protocol as default setting.
			// SO, we then choose next that have same protcol
			// first choose score is 80
			for(kk=0;kk<defaultScanResult;kk++)
			{// fine a best value.
				if(defaultProtcolRating[kk]==80)
				{	
					defaultScanResult=kk;
					goto exitHere;// We got the first scored 80
				}
			}
			// again, looking for scoring 70
			for(kk=0;kk<defaultScanResult;kk++)
			{// fine a best value.
				if(defaultProtcolRating[kk]==70)
				{	
					defaultScanResult=kk;
					goto exitHere;// We got the first scored 80
				}
			}
			defaultScanResult=0;//then. First one as default
					
				
		exitHere:	
			rewind(scanfp);
			i=0;
			while(fgets(line,sizeof(line),scanfp))
			{
				int idx;
				memset(enc,0,sizeof(enc));
				sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
				if((!strcmp(enc,"DHCPC_LLC_VALID"))||(!strcmp(enc,"DHCPC_VC_VALID")))
				{
					// it is HDCP.
					idx=0x100+i;
				}
				else
					idx=i;
				// Idx value(2 bytes) = first byte check if it is dhcp, second byte for index in the /var/tmp/scanpvc_result
				if(i==defaultScanResult)
				{
					fprintf(outfp,TableFmt,idx,"checked",i+1,vpi,vci,enc);
					defaultIndexValue=idx;
				}
				else
					fprintf(outfp,TableFmt,idx,"",i+1,vpi,vci,enc);				
				i++;
			}
			fclose(scanfp);			
			fprintf(outfp,IdxValue,defaultIndexValue);
			if(i==0)
				fprintf(outfp,"<tr><td colspan=5 align=center>SSO Error(SHALL HAVE ITEMS)</td></tr>");	
		}
		else
		{// them simply copy the string into tmp
			fputs(line,outfp);
		}
	}
	fclose(outfp);
	fclose(infp);
	fwriteFile("/tmp/pppoe_login.html");
//	unlink("/tmp/pppoe_login.html");
}
#define WEB_CONSOLE_STRING "<!--xxx-->"
void processReqUrl_PPPoELoginIspFailed_html(void)
{
	FILE *infp,*outfp;
	char line[255];
	char lan_ip[20];
	char TableFmt2[]="Please contact your ISP or login to the router Web console (<a href=\"http://%s\">http://%s</a>) to set up the configurations.";

	
	infp = fopen("/html/pppoe_login_isp_failed.html","r");
	if (infp==NULL)
	{
		return;
	}
	outfp = fopen("/tmp/pppoe_login_isp_failed.html","w");
	if (outfp==NULL)
	{
		fclose(infp);
		return;
	}
	
	
	strcpy(lan_ip,(char *)read_file_para_value("/var/etc/status","LAN_IP=",buf));
	while(fgets(line, sizeof(line), infp))
	{
		if(strstr(line,WEB_CONSOLE_STRING))
		{//We got the place to the lan address of this router	
			fprintf(outfp,TableFmt2,lan_ip,lan_ip);
		}
		else
		{// them simply copy the string into tmp
			fputs(line,outfp);
		}
	}
	fclose(outfp);
	fclose(infp);
	fwriteFile("/tmp/pppoe_login_isp_failed.html");
//	unlink("/tmp/pppoe_login_isp_failed.html");
}
/*
static int changetoDHCP(){
	FILE *fp,*fp2;
	char line[1024];
	ROUTED_CONFIG_DATA route_config;
	
	printf("changetoDHCP \n");

	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))==NULL)
	{
		LOGERROR("can not open %s for read",WAN_CONFIG_FILE);
		return -1;
	}
	if ((fp2=fopen("/tmp/tmp_wan.conf","w"))==NULL)
	{
		LOGERROR("can not open /tmp/tmp_wan.conf for write");
		return -1;
	}
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 11111");
		goto onErr1;
	}
	//sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	fprintf(fp2,"#:1:8\n");
	//1483 Routed
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 22222");
		goto onErr1;
	}
	sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		route_config.Routed_Description,
		&route_config.Routed_VPI,
		&route_config.Routed_VCI,
		(int *)&route_config.Routed_ATM_Class,
		(int *)&route_config.Routed_NAT,
        	(int *)&route_config.Routed_Encapsulation_Method,
	        (int *)&route_config.Routed_IP_Assignment,
		route_config.Routed_IP,
		route_config.Routed_Netmask,
		route_config.Routed_Gateway,
		(int *)&route_config.Routed_RIP,
		&route_config.Routed_MTU
		);

	fprintf(fp2,
		"|%s|%hu|%hu|%d|%d|%d|0|0.0.0.0|0.0.0.0|0.0.0.0|%d|%hu|\n",
		route_config.Routed_Description,
		route_config.Routed_VPI,
		route_config.Routed_VCI,
		route_config.Routed_ATM_Class,
		route_config.Routed_NAT,
        	route_config.Routed_Encapsulation_Method,
		route_config.Routed_RIP,
		route_config.Routed_MTU
		);

	printf("route line:%s\n",line);
	//1483 Bridged
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 33333");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("bridge line:%s\n",line);
	
	//PPPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 44444");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("pppoa line:%s\n",line);
	//IPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 555555");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("ipoa line:%s\n",line);
	//PPPoE
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 666666");
		goto onErr1;
	}
	printf("pppoe line:%s\n",line);
	fprintf(fp2,"%s",line);
	fclose(fp);
	fclose(fp2);
	unlink(WAN_CONFIG_FILE);
	rename("/tmp/tmp_wan.conf", WAN_CONFIG_FILE);

	//No need dns
	fp=fopen("/flash/resolv.conf","w");
	if(fp){
		fprintf(fp,"nameserver %s\n",fixed_dns);
		fclose(fp);
	}
	save_globe_config("/flash/config","WAN=","dynamic");
	save_globe_config("/flash/config","PPPoELogin=","no");
	save_globe_config("/flash/config","WAN_IP=","");
	save_globe_config("/flash/config","WAN_MASK=","");
	save_globe_config("/flash/config","GATEWAY=","");
	return 1;
onErr1:    
	fclose(fp);
	fclose(fp2);
	return -1;

return 1;	
}
*/
#ifdef Reboot
static int reboot_router(){
	run_task("profile","profile","put","/flash",0);
	sleep(3);
	run_script("/etc/scripts/reboot.sh",0,0,0);
return 1;	
}
#endif
#ifdef fixedip 
static int changetoFixedIP(){
	FILE *fp,*fp2;
	char line[1024];
	ROUTED_CONFIG_DATA route_config;
	
	printf("changetoFixedIP  start Fixed IP IP:%s netmask:%s Gateway:%s Dns:%s\n",
						fixed_ipaddress,
						fixed_netmask,
						fixed_gateway,
						fixed_dns						
					);	

	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))==NULL)
	{
		LOGERROR("can not open %s for read",WAN_CONFIG_FILE);
		return -1;
	}
	if ((fp2=fopen("/tmp/tmp_wan.conf","w"))==NULL)
	{
		LOGERROR("can not open /tmp/tmp_wan.conf for write");
		return -1;
	}
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 11111");
		goto onErr1;
	}
	//sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	fprintf(fp2,"#:1:8\n");
	//1483 Routed
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 22222");
		goto onErr1;
	}
	sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		route_config.Routed_Description,
		&route_config.Routed_VPI,
		&route_config.Routed_VCI,
		(int *)&route_config.Routed_ATM_Class,
		(int *)&route_config.Routed_NAT,
        	(int *)&route_config.Routed_Encapsulation_Method,
	        (int *)&route_config.Routed_IP_Assignment,
		route_config.Routed_IP,
		route_config.Routed_Netmask,
		route_config.Routed_Gateway,
		(int *)&route_config.Routed_RIP,
		&route_config.Routed_MTU
		);

	fprintf(fp2,
		"|%s|%hu|%hu|%d|%d|%d|1|%s|%s|%s|%d|%hu|\n",
		route_config.Routed_Description,
		route_config.Routed_VPI,
		route_config.Routed_VCI,
		route_config.Routed_ATM_Class,
		route_config.Routed_NAT,
        	route_config.Routed_Encapsulation_Method,
		fixed_ipaddress,
		fixed_netmask,
		fixed_gateway,
		route_config.Routed_RIP,
		route_config.Routed_MTU
		);

	printf("route line:%s\n",line);
	//1483 Bridged
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 33333");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("bridge line:%s\n",line);
	
	//PPPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 44444");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("pppoa line:%s\n",line);
	//IPOA
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 555555");
		goto onErr1;
	}
	fprintf(fp2,"%s",line);
	printf("ipoa line:%s\n",line);
	//PPPoE
	if (!fgets(line, 1024, fp))
	{
		LOGERROR("can not read 666666");
		goto onErr1;
	}
	printf("pppoe line:%s\n",line);
	fprintf(fp2,"%s",line);
	fclose(fp);
	fclose(fp2);
	unlink(WAN_CONFIG_FILE);
	rename("/tmp/tmp_wan.conf", WAN_CONFIG_FILE);

	//dns
	fp=fopen("/flash/resolv.conf","w");
	if(fp){
		fprintf(fp,"nameserver %s\n",fixed_dns);
		fclose(fp);
	}
	save_globe_config("/flash/config","WAN=","fixed");
	save_globe_config("/flash/config","PPPoELogin=","no");
	save_globe_config("/flash/config","WAN_IP=",fixed_ipaddress);
	save_globe_config("/flash/config","WAN_MASK=",fixed_netmask);
	save_globe_config("/flash/config","GATEWAY=",fixed_gateway);
	return 1;
onErr1:    
	fclose(fp);
	fclose(fp2);
	return -1;
}
#endif
/*
int  first_output(int client_sd,char *req_url,int num){
	int istrue=0;
	char tmpbuf[num+1];
	char buf1[num+1];
#define GIF_LOGO "/spray_logo.gif"
#define CSS_SCREEN "/screen.css"
#define GIF_CONNECTING "/128_connectinglobe.gif"
#define JS_LOGIN "/login.js"
	memset(tmpbuf,0,sizeof(num+1));
	memset(buf1,0,sizeof(num+1));
strcpy(tmpbuf,(char *)mid(req_url,1,num,buf1));
DPRINTF("first output: req_url:%s num:%d tmpbuf:%s\n",req_url,num,tmpbuf);
	if (!(strcmp(tmpbuf,GIF_LOGO))){
		istrue=1;	
	}
	if (!(strcmp(tmpbuf,CSS_SCREEN))){
		istrue=1;	
	}
	if (!(strcmp(tmpbuf,GIF_CONNECTING))){
		istrue=1;	
	}
	if (!(strcmp(tmpbuf,JS_LOGIN))){
		istrue=1;	
	}
	if (istrue){
		char tmpurl[1024];
		sprintf(tmpurl,"/html%s",tmpbuf);
		processReqUrl(tmpurl);
		close(client_sd);
		return 1;
	}else{
		return 0;
	}
}
*/	
char value[64];
int has_wireless(void)
{
	char buf1[64];
	strcpy(value,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"WIRELESS=",buf1));
  	if(strcmp(value,"yes")==0)
	{
		return 1;
	}
	return 0;
}
	
//char tmpHost[256];
#ifdef LIBVER
#define MAINFUNC PPPoELoginProxy_main
#else
#define MAINFUNC main
#endif
int MAINFUNC(int argc, char *argv[])
{
	char *bp,*bp1;
	//FILE *fp;
	int ret;
	//char filename[80];
	//FILE *outfp;
	char *magic;
							

    LOGOPEN("PPOELOGIN");
    LOGINFO("init");
    LOGDEBUG_ON();

    argc -= optind;
    argv += optind;

    service_table.sd = -1;
    service_table.port = THPD_HTTP_PROXY_PORT;
 


    //LOGDEBUG("hook SIGHUP");
    { /* monitor for config reload signal */
        if(SIG_ERR==signal(SIGHUP, sig_hup))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    //LOGDEBUG("hook SIGTERM");
    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGTERM, go_hell_handler))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }

    //LOGDEBUG("hook SIGINT");
    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGINT, go_hell_handler))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }

    //LOGINFO("create pid file: %s", PIDFILE);
    write_pid(PIDFILE);

    LOGDEBUG("bind service port");
	/* bind service port */
 

	sd=socket(PF_INET, SOCK_STREAM, 0);
	//sd=socket(PF_INET, SOCK_RAW, 0);

	optval=1;
	setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(optval));
	//       optval=1200;
	//     setsockopt(sd, IPPROTO_TCP, TCP_MAXSEG, &optval, sizeof(optval));
	
	memset(&service_addr, 0, sizeof(service_addr));
	service_addr.sin_family=AF_INET;
	service_addr.sin_port=htons(service_table.port);
	service_addr.sin_addr.s_addr=INADDR_ANY;
	bind(sd, (struct sockaddr *)&service_addr, sizeof(service_addr));

	//listen(sd, 5);
	listen(sd, 1);

	service_table.sd=sd;

	LOGINFO("proxy service :%d ready", service_table.port);
 
   /* wait for connections */
   
	/* initialize pollfds */
	pollfdList[0].fd=service_table.sd;
	pollfdList[0].events=POLLIN;
	poolfd_nfds=1;
	 
	LOGDEBUG("begin service loop");
	LoginInProgress=0;
	/* service loop */
	for(;GO_HELL==0;)
	{
		poll_ret=poll(pollfdList, poolfd_nfds, 3*1000);
		if(-1==poll_ret)
		{
			if(errno==EINTR)
			{
				/* go on */
				continue;
			}
			else
			{
				LOGERROR("poll: %m");
				break;
			}
		}
		else if(0==poll_ret)
		{
		

			// stop PPPoE if (checkIfPPPAuthFailed())
			if(checkIfPPPAuthFailed())
			{
				if(scanned_protocol==PPPoE_Scanned)
				runStopPppoecd();
				if(scanned_protocol==PPPoA_Scanned)
					runStopPppoa();
			}
			continue;
		}
				
		if (POLLHUP & pollfdList[0].revents)
		{
			/* give handler a chance before close connection */
			//(*conn->handler)(conn, NULL, NULL);
			LOGERROR(": rec.POLLHUP ");
			continue;
		}
	
		client_addr_len=sizeof(client_addr);
		if(-1==(client_sd=accept(pollfdList[0].fd, (struct sockaddr*) &client_addr, &client_addr_len)))
		{
			LOGERROR("accept for %d, reason: %m",service_table.port);
			continue;				
		}
		//LOGDEBUG("accept the connection from src addr=[%s]:[%hu] client_sd=%d ", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port),client_sd);
		//Yes, need to check if the password and user name if missing then send the login page to the users.
		// Looking for the host
		ret = read(client_sd, buf, 3072);
		if((bp1=strstr(buf,"\r\n"))==NULL)	
		{
			//LOGERROR( "can not get the end of first line");//==>:%s",buff);
			close(client_sd);
			continue;
		}
	
		// The GET shall be in the first line???
		bp=strstr(buf,"GET");
		if((!bp)||(bp>bp1))// the  "GET" is before "\r\n."
		{
			//LOGERROR( "can not get the GET in the first of first line");//==>:%s",buff);
			close(client_sd);
			continue;
		}
		if((bp=strstr(buf,"Host"))==NULL)
		{
			LOGERROR( "can not get Host");//==>:%s",buff);
			// We have to pass through.....
			close(client_sd);
			continue;
		}
		bp+=4;
		//skip ":"
		bp=strstr(bp,":");
		bp+=1;
		//sscanf(bp,"%s",tmpHost);
		sscanf(bp,"%s",host);
		//LOGDEBUG("The host  is %s", host);

		//reset to buffer to looking for the url.	
		bp=buf;
		sscanf(bp,"GET %s",req_url);
		//LOGDEBUG("request URL ='%s' ",req_url);
		if(req_url[0]=='\0')
		{
			// Not accept the "" string
			close(client_sd);
			continue;
		}
		//	restart the proxy server
		/* WE now change to following state model for SSO to accept windows are closed.
		1. WE change to stateless model.  That is, removing proxyServiceOn flag to just first url page.
		2. Accept any page with MD5 before login_in_progress
		3. Since our DNS proxy can removed once DNS at a time.  So, we can restart it after recived one 
		4. url request (or SSO page with MD5 request.) or DNS proxy itself reniitUDP.
		*/
		// scan "?" to find out first paramter
		bp=strstr(req_url,"?");
		if(!bp)// We got ? for magic
		{
			// THis is the normal pages, not our SSO pages.
			// We shall keep the last host
			strcpy(tmpHost,host);// keep the last since we do not know which one is the one which sent credentials to us. 
		}
		else
		{
			*bp='\0';//then req_url is the real string
			bp++;//skip ?
			magic=bp;
			if(!strncmp(magic,MAGIC_HASH_MD5_VALUE,strlen(MAGIC_HASH_MD5_VALUE)))
			{
				//LOGDEBUG("magic found");// THis is our SSO URL

				if(strcmp(req_url,"/SSO_Reset.asp")==0)
				{
					LOGDEBUG("received/SSO_Reset.asp  start faked DNS proxy");
					LoginInProgress=0;
					close(client_sd);
					run_script(RESTART_FAKED_DNS_PROXY_TASK,0,0,0);
					continue;
				}
				if(strcmp(req_url,"/pppoe_connecting.asp")==0)
				{
	//			DPRINTF("pppoe_connecting.asp 2661 dhcpScanned:[%d] pppoeScanned:[%d] pppoaScanned:[%d]\n",dhcpScanned,pppoeScanned,pppoaScanned);
				if(ReScanned==1){
					DPRINTF("Try to scan\n");
					LOGDEBUG("Try to scan\n");
					ADSLCheckPages(client_sd,buf);
						run_script(RESTART_FAKED_DNS_PROXY_TASK,0,0,0);
						close(client_sd);		
					continue;
				}else if (scanned_protocol==Nothing_Scanned){
					DPRINTF("Nothing scanned and autoScanRetryTime=%d(MAX_AUTOSCAN_RETRY_TIME=%d)\n",
					autoScanRetryTime,MAX_AUTOSCAN_RETRY_TIME);
					LOGDEBUG("Nothing scanned and autoScanRetryTime=%d(MAX_AUTOSCAN_RETRY_TIME=%d)\n",
					autoScanRetryTime,MAX_AUTOSCAN_RETRY_TIME);
					if(++autoScanRetryTime<MAX_AUTOSCAN_RETRY_TIME)
					{
						scanned_protocol=0;//reset it.
						ADSLCheckPages(client_sd,buf);
						//keep the ReScanned since ADSL is up.
						//run_script(RESTART_FAKED_DNS_PROXY_TASK,0,0,0);
					}
					else
					{
						run_script(FAKED_DNS_PROXY_STOP,0,0,0);
						//processReqUrl("/pppoe_login_isp_failed.html");
						processReqUrl_PPPoELoginIspFailed_html();
						run_script(PPPOE_PROXY_REDIRECT_STOP,0,0,0);
					}
					close(client_sd);		
					continue;
				}else if (scanned_protocol==DHCP_Scanned){
					DPRINTF("DHCP client start\n");
					LOGDEBUG("DHCP client start\n");
						processReqUrl("/pppoe_login_done1.html");
						close(client_sd);		
						run_script(FAKED_DNS_PROXY_STOP,0,0,0);
						//		DPRINTF("Enc:%s\n",Enc?"Vc-Mux":"LLC");	
						Run1483Routed(&wan_config,Enc);
						run_task("/etc/scripts/flash","/etc/scripts/flash", "write",NULL);
	
						LoginInProgress=2;//Yes, it is connected.
						continue;
				}else if (scanned_protocol==PPPoE_Scanned){
//				}else if(pppoeScanned&&!dhcpScanned&&!pppoaScanned){
					LOGDEBUG("PPPoE start\n");
					DPRINTF("PPPoE start\n");
							processReqUrl("/pppoe_login.html");
							close(client_sd);		
							//LoginInProgress=1;
							continue;
				}else if (scanned_protocol==PPPoA_Scanned){
				//}else if(pppoaScanned&&!dhcpScanned&&!pppoeScanned){
					LOGDEBUG("PPPoA protcol scanned\n");
					DPRINTF("PPPoA protcol scanned\n");
					processReqUrl("/pppoe_login.html");
					close(client_sd);		
					//LoginInProgress=1;
					continue;
				}else if (scanned_protocol==More_Than_One_Scanned){
#if 1
							LOGDEBUG("Above two protocols scanned\n");
					DPRINTF("Above two protocols scanned\n");
							//TBD for scanned both
						////We shall keep the DNS or RESTART it???
						//////run_script(FAKED_DNS_PROXY_STOP,0,0,0);
					//processReqUrl("/pppoe_login_isp_failed.html");
					processReqUrl_PPPoELogin_html();
					run_script(RESTART_FAKED_DNS_PROXY_TASK,0,0,0);
							close(client_sd);		
							continue;
#else
// simulate the Nothing scanned
					DPRINTF("Simulate Nothing scanned\n");
					LOGDEBUG("Simulate Nothing scanned\n");
						////ADSLCheckPages(client_sd,buf);
						//run_script(RESTART_FAKED_DNS_PROXY_TASK,0,0,0);
						run_script(FAKED_DNS_PROXY_STOP,0,0,0);
					//processReqUrl("/pppoe_login_isp_failed.html");
					processReqUrl_PPPoELoginIspFailed_html();
						run_script(PPPOE_PROXY_REDIRECT_STOP,0,0,0);
							close(client_sd);		
							continue;
#endif
					}
				}
				
				LOGDEBUG("request URL change to ='%s'",req_url);
				// special process for and pppoeLogin.asp pppoeLgSt.asp
				//only pppoeLogin.asp can have 2nd/3rd parameters.
				if(((strcmp(req_url,"/pppoe_login_done.html")==0)||(strcmp(req_url,"/pppoe_login_done_portal.html")==0)||
					(strcmp(req_url,"/pppoe_login_done_w.html")==0)||(strcmp(req_url,"/pppoe_login_done_portal_w.html")==0))&&(LoginInProgress==2))
				{  // connected and is the last url request
					//end Of Login
					DPRINTF("req_url=%s is reach. End of Login\n",req_url);
					LOGDEBUG("%s  closing proxy",req_url);
					processReqUrl(req_url);
					close(client_sd);		
					run_script(PPPOE_PROXY_REDIRECT_STOP,0,0,0);
					LoginInProgress=0;//reset it.
					goto byebye;
				}
			
				if(strcmp(req_url,"/pppoeLogin.asp")==0)
				{

					// then looking for the usernm and passwd
					char *un,*pwd;
					bp=strstr(magic,"&");
					if(!bp) // no user name
					{
						LOGERROR("pppoeLogin.asp without username");
					}
					*bp='\0';
					bp++;//skip &
					un=bp;
					bp=strstr(un,"&");
					if(!bp) // no password
					{
						LOGERROR("pppoeLogin.asp without password");
					}
					*bp='\0';
					bp++;//skip &
					pwd=bp;
					bp=strstr(pwd,"&");
					if(bp) // Yes. User has assigned the PCI VCI and protocols for multiple protcol aquired.
					{
						int j;
						*bp='\0';
						bp++;//skip &
						DPRINTF("The protcol is %s\n",bp);
						j=atoi(bp);
						if(j>=256) j-=256;//remove the DHCP flag if exist
						getSpecificScanResult(j);//Now it have been kept in /tmp/first_scanpvc_result
						restart_wan();// according to the one stored in /tmp/first_scanpvc_result, we reassign the scanned_protocol
						              //it then write the selected protocol to the /tmp/pppoe_login_protocol
						scanned_protocol=read_value_from_file("/tmp/pppoe_login_protocol");// reassign the scanned_protocol
					}
					//run_script(FAKED_DNS_PROXY_STOP,0,0,0);
					// the status page  with username and password. So, we write the PPPoE login in progress messages
					// Then we need to stop the PPPoECD
					// We need to keep the username and password for retry when ADSL line is not OK
					if (scanned_protocol==DHCP_Scanned){
					DPRINTF("DHCP client start\n");
					LOGDEBUG("DHCP client start\n");
						processReqUrl("/pppoe_login_done1.html");
						close(client_sd);		
						run_script(FAKED_DNS_PROXY_STOP,0,0,0);
						//		DPRINTF("Enc:%s\n",Enc?"Vc-Mux":"LLC");	
						Run1483Routed(&wan_config,Enc);
						run_task("/etc/scripts/flash","/etc/scripts/flash", "write",NULL);
	
						LoginInProgress=2;//Yes, it is connected.
						continue;
					}
					strcpy(username,un);
					strcpy(password,pwd);
					DPRINTF("PPP start, scanned_protocol=%d, username=%s, password=%s\n",scanned_protocol,username,password);
					if((username[0]=='\0')||(password[0]=='\0')) 
					{
						LOGERROR("pppoeLogin.asp without username or password");
						close(client_sd);
						continue;
					}
				if(scanned_protocol==PPPoE_Scanned){
					DPRINTF("changePPPoEUserNamePasswod is called\n");
					changePPPoEUserNamePassword();//username,password);
					first_start_pppoe=1;
				}else if(scanned_protocol==PPPoA_Scanned){
					DPRINTF("changePPPoEUserNamePasswod is called\n");
					changePPPoAUserNamePassword();//username,password);
					first_start_pppoa=1;
				}
					
					// Once it is Login In progress, then only accept the http with magic ID.
					LoginInProgress=1;
					//then we need to clear the auth result for last time.
					unlink("/tmp/ppp/log");

					///strcpy(tmpHost,host); It only changed to 10.77.139.104
					//DPRINTF("PPPoE PRoxy 2029:username:%s password:%s\n",username,password);			
					displayStatusPages(client_sd,buf);//start pppoe or pppoa				
					continue;
				}
				// check the pppoe Login status.
				// if OK. then shows oK(with user's first browse url) and save to flash
				// if failed, then show the LOGIN_PAGE_MESSAGE with logon wrong password and username.
				// if ADSL is not OK, then show ADSL not OK and ask users to connection and try 30 seconds????
				if(strcmp(req_url,"/pppoeLgSt.asp")==0)
				{
					// check if PPPoE connection is OK.
					char str_wanip[20];
					char buf1[50];
					strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
					if(isValidIP(str_wanip))
					{
						run_script(FAKED_DNS_PROXY_STOP,0,0,0);
						//run_task("/usr/sbin/dnsmasq","/usr/sbin/dnsmasq", "&",NULL);
						//KillProcessByName("FakedDnsProxy",SIGTERM);		
						//run_task("/etc/scripts/flash","/etc/scripts/flash", "write",NULL);
						run_task("profile","profile","put","/flash",0);
						sleep(4);
					
						//check if the url is the portal
						DPRINTF(" tmpHost=%s\n",tmpHost);
						if(!qStricmp(tmpHost,PORTAL_HOST))
						{
						//not the host name we kept, given the ones w/ portal
						//sprintf(buf,PPPoE_LOGIN_SUCCESS_PORTAL,PORTAL_HOST,PORTAL_URL,PORTAL_HOST,PORTAL_URL);
						DPRINTF("it is portal since tmpHost=%s\n",tmpHost);
						#ifdef _sso_spary
							if(has_wireless())
								processReqUrl("/pppoe_link_ok_portal_w.html");
							else
						#endif
							processReqUrl("/pppoe_link_ok_portal.html");
						}else{
						//DPRINTF("it is not portal since tmpHost=%s\n",tmpHost);
						#ifdef _sso_spary
							if(has_wireless())
								processReqUrl("/pppoe_link_ok_w.html");
							else
						#endif
							processReqUrl("/pppoe_link_ok.html");
						}
						//sprintf(buf,PPPoE_LOGIN_SUCCESS);//,tmpHost,tmpUrl);//,tmpHost,tmpUrl);
						//ret = write(client_sd, buf, strlen(buf));
						close(client_sd);		

						//aki 04152005 I think we shall wait for the last request from the PC for the jpg, or css in /pppoe_link_ok.htm					
						//////run_script(PPPOE_PROXY_REDIRECT_STOP,0,0,0);
						LoginInProgress=2;//Yes, it is connected.
						continue;
					}
					else
					{
						//RunPPPoE(&wan_config);
						first_start_pppoe=0;
				first_start_pppoa=0;
						displayStatusPages(client_sd,buf);//,0,NULL,NULL);// close the sd in the displayStatusPages
						close(client_sd);	
						continue;//
					}
				}
				
				//For Other SSO page, like logo.jmp, src=.., we let it get from our html directory.
				// process the req_url in the/html
				processReqUrl(req_url);
				close(client_sd);	
				continue;
			}
		}
		
		//For other page do not have our magic, we give them the connecting page.
		//processReqUrl("/pppoe_link_status_connecting.html");
		processReqUrl("/pppoe_link_status_connecting_check.html");
		close(client_sd);
		// We need to keep the url for later usages
		//strcpy(tmpUrl,req_url);
		// since we have receive it. Means DNS has resolve it.  So, we kill the DNS
		//run_script(STOP_FAKED_DNS_PROXY_TASK,0,0,0);
	}

byebye:
    { /* close all service sd */
       
        {
            if(service_table.sd>=0)
            {
                close(service_table.sd);
                service_table.sd=-1;
            }
        }
    }
	
 
/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

    LOGINFO("remove pid file: %s", PIDFILE);
    remove_pid(PIDFILE);


 
/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    LOGINFO("shutdown");
    return 0;
}

char *mid(char *ss,int start,int num,char *buf1){
	char *ori=ss;
	char result[num+1];
	int i=0;
	memset(result,0,sizeof(result));
	for(i=0;i<start-1;i++)
		*ss++;
	
	strncpy(result,ss,num);
	strcpy(buf1,result);
	DPRINTF("mid(%s,%d,%d)=%s\n",ori,start,num,buf1);
	return buf1;
}
