
/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include <sys/time.h>
#include <syslog.h>
#include <wait.h>

#define DEBUG_ALERTMAIL

//#define ALERT_MAIL_TIMER 29
int ALERT_MAIL_TIMER=0; 
typedef struct {
    int protectionEnabled;/* 1 for enabled, 0 for disabled */
    int alertEnabled;/* 1 for enabled, 0 for disabled */
    int alerttime;
    char sendaddr[128];
    char alertaddr[128];
    char alertsmtp[128];
} HACK_ATTCK_DATA;

#define BLK_HACK_CONF_FN "/flash/blk_hack.conf"
#define ALERT_MAIL_FN "/var/log/alertmail"
#define ALERT_SUBJECT "Security Log/Alert From Gateway"

HACK_ATTCK_DATA CurrentHackAttckCfg;

void resetCurrentHackAttckCfg(void)
{
	HACK_ATTCK_DATA *d=&CurrentHackAttckCfg;
	memset(d,0,sizeof(HACK_ATTCK_DATA));
	/*
 	d->protectionEnabled=0;// nonActive
	d->alertEnabled=0;
    strcpy(d->sendaddr,"");
    strcpy(d->alertaddr,"");
    strcpy(d->alertsmtp,"");
    */
}

static int
Load_HackAttck_Config (void)
{

	FILE *fp;
	HACK_ATTCK_DATA *d=&CurrentHackAttckCfg;

	resetCurrentHackAttckCfg();
	fp=fopen(BLK_HACK_CONF_FN,"r");
	if (fp) {
		fscanf(fp,"%d %d %d %s %s %s\n",
//		fscanf(fp,"%d,%d,%64[^,],%64[^,],%64[^;];",
			&d->protectionEnabled, &d->alertEnabled, &d->alerttime, d->sendaddr, d->alertaddr, d->alertsmtp);
		fclose(fp);
			if(d->sendaddr[0]=='&')
				d->sendaddr[0]='\0';
			if(d->alertaddr[0]=='&')
				d->alertaddr[0]='\0';
			if(d->alertsmtp[0]=='&')
				d->alertsmtp[0]='\0';
		ALERT_MAIL_TIMER=d->alerttime*60;
#ifdef DEBUG_ALERTMAIL	
	printf("HackAttck_Config: protectionEbnabled:%d alertEnabled::%d ALERT_MAIL_TIME::%d(seconds) send=%s addr=%s smtp=%s\n", 
			d->protectionEnabled, d->alertEnabled, ALERT_MAIL_TIMER,d->sendaddr, d->alertaddr, d->alertsmtp);
#endif
	}
	return 0;
}


/* for SMTP */
void do_smtp(void)
{
	HACK_ATTCK_DATA *d=&CurrentHackAttckCfg;
    char buf1[100], buf2[128];
    int ret;
//cat /var/log/alertmail|smtpclient -s "Security Log/Alert From test test" -f cjw@billion.com -S billion.com  cjw@billion.com.tw &
//cat /var/log/alertmail|smtplient -s "Security Log/Alert From $GATEWAY_NAME" -f $c -S $d  $c 
	char *argv[] = {"smtpclient", "-s", buf1, "-F", ALERT_MAIL_FN, "-f", buf2, 
					"-S", d->alertsmtp, d->alertaddr, NULL };
	int  pid;
   	FILE *fp;
   char my_name[BUFSIZ];

	if ( (fp = fopen(ALERT_MAIL_FN, "r")) == (FILE *) NULL) {
#ifdef DEBUG_ALERTMAIL	
	printf("do_smtp: no alertmail file\n");
#endif
		return;
	}	
	fclose(fp);
	
#ifdef DEBUG_ALERTMAIL	
	printf("do_smtp: call smtpclient\n");
#endif

    if (gethostname(my_name, sizeof(my_name) - 1) < 0) {
        printf("gethostname: error\n");
    }
#ifdef DEBUG_ALERTMAIL	
    printf("gethostname: %s\n", my_name);
#endif

	sprintf(buf1, "%s %s", ALERT_SUBJECT, my_name); 

	if (d->sendaddr)
		strcpy(buf2, d->sendaddr); 
	else	
		strcpy(buf2, d->alertaddr); 

	if ( (pid = vfork()))
		waitpid(pid, NULL, 0);
        
	if(pid == 0){  // child process
		execvp("/usr/sbin/smtpclient", argv);  
		_exit(0);
	}

#ifdef DEBUG_ALERTMAIL	
	printf("do_smtp: call smtpcleint finished\n");
#endif

	if ( (fp = fopen("/var/etc/smtpclient_status", "r")) != (FILE *) NULL) {
		fclose(fp);
		//syslog( LOG_DEBUG, "Alert Mail: send log to %s", d->alertaddr);
		syslog( LOG_INFO, "Alert Mail: send log to %s", d->alertaddr);
		unlink("/var/etc/smtpclient_status");
		unlink("/var/log/alertmail");
	}	
}


//static int do_smtp_flag = 0;
#ifdef LIBVER
#define MAINFUNC alertmail_main
#else
#define MAINFUNC main
#endif
int
MAINFUNC(int argc, char **argv)
{
//	int status;
//	pid_t pid;
//	int interval;
	HACK_ATTCK_DATA *d=&CurrentHackAttckCfg;
	int update_time_flag = 0;
   
	Load_HackAttck_Config();
//	printf("ntp_main: argument %s %s\n", argv[0],argv[1]);
/*
	if (!strcmp(argv[1], "dst"))
	{
		return 0;
	}
*/	
	while(1)
	{
//		pid = vfork();
//		switch(pid)
//		{
//			case -1:
//				perror("fork failed");
//				_exit(1);
//			case 0:
//				if (do_smtp_flag == 0 ) {	// avoid to re-entering
//					do_smtp_flag = 1; // Mulder test
					if (d->protectionEnabled && d->alertEnabled)
						do_smtp();
//					do_smtp_flag = 0; // Mulder test
//				}
/*
				else
				{	
					sleep(10);
					fprintf(stderr, "smtp: nothing to do...\n");
					continue;
				}	
*/
//				_exit(0);
//				break;
//			default:
//				waitpid(pid, &status, 0);
				//dprintf("parent\n");
//				printf("parent\n");
//				break;
//		} // end switch
#ifdef DEBUG_ALERTMAIL	
				printf("alertmail sleeping %d sec\n", ALERT_MAIL_TIMER);
#endif

		sleep(ALERT_MAIL_TIMER);
	} // end while
} // end main
