
#include <stdio.h>
#include <string.h>

char *ext_ip, *ext_if, *int_if;
char *ipt_bin= "/usr/sbin/iptables";

void print_usage(void)
{
	printf(
"Usage: alertmailfilter [OPTIONS]\n\n"  
"-f  specify input file to be filtered\n"
"-o 	specify output file of the alert mail\n"	
	);
}

/*
 * ex. PROT="TCP";ORIG_IP="$WAN_IP";ORIG_PORT="113";NEW_IP="192.168.2.11";ORIG_PORT="113"
 *     parm[0]		parm[1]			parm[2]			parm[3]					parm[4]
 */
void do_forward(FILE *infp, FILE *outfp)
{
	char line[255], *word;
	int  num;
	char *parm[5];
	
	while(fgets(line, sizeof(line), infp)){
		num = 0;
		word = line;
		for(num=0 ; num < 5 ; num++) {
			parm[num] = strstr(word, "\"")+1;
			word = strstr(parm[num], "\"");
			*word = '\0';
			word++;
		}
	
	fprintf(outfp, "%s -t nat -A PREROUTING -i %s -p %s -d %s --dport %s -j DNAT --to %s:%s\n",
				ipt_bin, "eth1", parm[0], strcmp("$WAN_IP", parm[1])? parm[1] : ext_ip , parm[2], parm[3], parm[4]);
	fprintf(outfp, "%s -A FORWARD -i %s -o %s -p %s -m state --state NEW %s -d %s --dport %s -j ACCEPT\n",
				ipt_bin, ext_if, int_if,  parm[0], !strcmp(parm[0], "TCP") ? "--syn": "",  parm[3], parm[4]);
			
	}
}
/*
 * ex. PROT="tcp";TRIGGER_PORT="5190";IN_PROT="tcp";IN_PORT="2222:2225";ALG_MOD="alg_aim.o"
 *		parm[0]				parm[1]			parm[2]			parm[3]				parm[4]
 */
void do_trigger(FILE *infp, FILE *outfp)
{
	char line[255], *word, *p;
	int  num;
	char *parm[4];

	while(fgets(line, sizeof(line), infp)){
		num = 0;
		word = line;
		for(num=0 ; num < 5 ; num++) {
			parm[num] = strstr(word, "\"")+1;
			word = strstr(parm[num], "\"");
			*word = '\0';
			word++;
		}
		p = parm[3];
		while(*p != '\0'){
			if( *p == ':')
				*p = ',';
			p++;
		}
		if( (*parm[4] == '\0') || !strcmp(parm[4], "alg_trg.o") ){
			if( (*parm[1] != '\0') && (*parm[3] != '\0') ){
				
				fprintf(outfp, "insmod /tmp/alg_trg.o ports=%s inport=%s\n", parm[1], parm[3]);
				
			}
		} else {
			
			fprintf(outfp, "insmod %s ports=%s %s%s\n", parm[4], parm[1], *parm[3] != '\0' ? "inport=" : "", *parm[3] != '\0' ? parm[3] : "");
		}
		
	}

}

/*
 * ex. MAC="";SIP="192.168.2.101";PROT="TCP";PORT="333";
 *		parm[0]		parm[1]			parm[2]		parm[3]
 */
/*
void do_filter(FILE *infp, FILE *outfp)
{
	char line[255],buffer[255], *word;
	int  num;
	char *parm[4];
	char *ipstr[20]={0};
	
	while(fgets(line, sizeof(line), infp)){
		num = 0;
		word = line;
		for(num=0 ; num < 8 ; num++) {
			parm[num] = strstr(word, "\"")+1;
			word = strstr(parm[num], "\"");
			*word = '\0';
			word++;
		}
	if(*parm[0] != '\0')
		fprintf(outfp, "%s -I FORWARD -m state --state NEW -m mac --mac-source %s -j DROP\n",
					ipt_bin, parm[0]);
					
	else if( (*parm[2] != '\0') && (*parm[3] != '\0')){
		if(*parm[1] != '\0')
			sprintf(ipstr, "-s %s", parm[1]);
			
		fprintf(outfp,"%s -I FORWARD -m state --state NEW %s -p %s --dport %s -j DROP\n",
					ipt_bin, ipstr, parm[2], parm[3]);
					
	}else if(*parm[1] != '\0')
		fprintf(outfp,"%s -I FORWARD -m state --state NEW -s %s -j DROP\n",
					ipt_bin, parm[1]);
	}
}
*/
/*                                            "DROP"
 * ex. DIR="FORWARD";ACT="ACCEPT";SIP="192.168.1.0/255.255.255.240";DIP="192.168.5.10/255.255.255.240";PROT="";SPORT="3333:4444";DPORT="";
 *		parm[0]	            parm[1]			      parm[2]		                                          parm[3]                                         parm[4]         parm[5]                parm[6]
 */
void do_hackAttackFilter(FILE *infp, FILE *outfp)
{
	char line[255],sipstr[40]="",dipstr[40]="", protstr[6]="",sportstr[20]="",dportstr[20]="",*word;
	int  num;
	char *parm[4];
	
	while(fgets(line, sizeof(line), infp)){
		if(strncmp(line,"HackAttack:",11) 
			continue; //not the hackAttack
		sscanf(line,"HackAttack:%d",&hackType);
		switch(
		num = 0;
		word = line;
		for(num=0 ; num < 7 ; num++) {
			parm[num] = strstr(word, "\"")+1;
			word = strstr(parm[num], "\"");
			*word = '\0';
			word++;
		}
					
		if(*parm[2] != '\0')
			sprintf(sipstr, " -s %s", parm[2]);
		if(*parm[3] != '\0')
			sprintf(dipstr, " -d %s", parm[3]);
		if(*parm[4] != '\0')
			sprintf(protstr, " -p %s", parm[4]);
		if(*parm[5] != '\0')
			sprintf(sportstr ," --sport %s", parm[5]);
		if(*parm[6] != '\0')
			sprintf(dportstr ," --dport %s", parm[6]);
	
		fprintf(outfp,"%s -I %s -m state --state NEW %s  %s  %s %s  %s -j %s\n",
					ipt_bin, parm[0], sipstr,dipstr ,protstr,sportstr,dportstr, parm[1]);
	}				
}
	
/*                                            "DROP"
 * ex. ACT="ACCEPT";MAC="11:22:33:44:55:66";
 *		parm[0]	                  parm[1]			   
 */
void do_mac_filter(FILE *infp, FILE *outfp)
{
	char line[255]="",*word;
	int  num;
	char *parm[4];
	
	while(fgets(line, sizeof(line), infp)){
		num = 0;
		word = line;
		for(num=0 ; num < 7 ; num++) {
			parm[num] = strstr(word, "\"")+1;
			word = strstr(parm[num], "\"");
			*word = '\0';
			word++;
		}	
		fprintf(outfp, "%s -I FORWARD -m state --state NEW -m mac --mac-source %s  -j %s\n",
					ipt_bin, parm[1],parm[0]);
	}				
}

void main(int argc, char **argv)
{
	FILE *infp, *outfp;
	char *infile, *outfile, *type;
	int argn;
		
	argn = 1;
    while ( argn < argc && argv[argn][0] == '-' )
	{
		if ( strcmp( argv[argn], "-f" ) == 0 && argn + 1 < argc ){
	    	++argn;
	    	infile = argv[argn];
	     } else if( strcmp( argv[argn], "-o" ) == 0 && argn + 1 < argc ){
			++argn;
	    	outfile = argv[argn];
	    } else{
	    	print_usage();
	    	exit(1);
		}
		++argn;
	}
	if ( argn != argc || argn == 1 ){
		print_usage();
		exit(1);
	}
	
	infp = fopen(infile, "r");
	if(!infp){
		printf("%s is not exist!!\n", infile);
		exit(1);
	}
	outfp = fopen(outfile, "w");
	if(!outfp)
		printf("open file error!\n");
	fprintf(outfp, "#!/bin/sh\n");
	
    if( !strcmp( type, "filter") )
    	do_hackAttackFilter(infp, outfp);
	else if( !strcmp( type, "macfilter") )
    	do_mac_filter(infp, outfp);
    else
    	print_usage();
out:    	
    if(infp)
    	fclose(infp);
    if(outfp)
    	fclose(outfp);
}
