/* ###########################################################################
# (c) Copyright Billion Electric  2001
#
# SNTP_DST.H
#
# Head file for Daylight Saving Time
#
# ##########################################################################*/



#ifndef SNTP_DST_H
#define SNTP_DST_H

#define TIME_BEGIN_YEAR_TM		1900

#define ONE_SECOND			1000		// Ticks per Second
#define ONE_MINUTE			(60 * ONE_SECOND)
#define MINUTE_OFFSET			60 		// in seconds
#define HOUR_OFFSET			3600 		// in seconds

#define DEFAULT_SNTP_QUERY_INTERVAL_F	ONE_MINUTE
#define DEFAULT_SNTP_QUERY_INTERVAL_S	(ONE_MINUTE*10)

#define DEFAULT_SNTP_QUERY_WAIT_TIME	(5 * ONE_SECOND)

#define DST_CHECK_INTERVAL		(5 * ONE_SECOND)



extern void check_adjust_DST(void);

extern int fnDST_NA(struct tm *ptmST);
extern int fnDST_EU(struct tm *ptmST);
extern int fnDST_Israel(struct tm *ptmST);

extern int fnDST_Brazil(struct tm *ptmST);
extern int fnDST_AU(struct tm *ptmST);
extern int fnDST_AU_T(struct tm *ptmST);

extern int fnDST_NZ(struct tm *ptmST);
extern int fnDST_Egypt(struct tm *ptmST);
extern int fnDST_Iraq(struct tm *ptmST);




#endif	// SNTP_DST_H
