/*
	Factory Reset
	Behavior:
		1. push the reset button and hold it over 1 second
		2. reset to default
		3. flash all leds
		4. reboot
*/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>      /* open */ 
#include <sys/ioctl.h>  /* ioctl */
#include <linux/tc3162dmtctrl.h>
#include <ctype.h>
#include <dirent.h>
#include <stdarg.h>
/* For reset switch ioctl */
#include <sys/socket.h>
#include <linux/tc3162ioctl.h>
#include <linux/if.h>
/* reset switch ioctl end*/
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/types.h>
#include "../iptables-1.2.11/runFunc.h"

#include "../websconfig/lan_conf.h"
#include "../websconfig/dhcp.h"
#include "../websconfig/wan.h"
#include "../websconfig/wan_vod.h"
//int save_globe_config(char *filename, char *arg1, char *arg2);
#define RIP_CONFIG_FILE 		"/flash/ripd.conf"
extern void run_task(char *cmd, ...);
extern void CopyFile(char *filename1,char *filename2);

#if 1
FILE *TTYS0;
#define DPRINTF(arg...) \
	TTYS0 = fopen("/dev/ttyS0", "w"); \
	fprintf(TTYS0, arg); \
	fclose(TTYS0)
#else
#define DPRINTF(arg...) ;
#endif
/* KenWang added 2005/06/23 -- end -- */

#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
int start_sip_cnt = 0;
int start_sip = 0;
#endif

void
TCDMT_SetDmtClose (void)
{
    unsigned char Arg;
    int nFd = open( "/dev/dmtdev", O_RDWR );
    if( nFd == -1  )
	{
		DPRINTF("getDownUpStreamRate:severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
    ioctl( nFd, DMTIOCTL_SET_DMTCLOSE, &Arg );
	close(nFd);
} /* TCDMT_SetDmtClose */
static inline void GUop(FILE* filep,char* si,char* fn)
{
	filep = fopen(fn,"w");
	fprintf(filep,"%s",si);
	fclose(filep);
	fflush(filep);
}


//#define DPRINTF printf

#define READ_BUF_SIZE	50


/* KenWang added 2005/06/23 -- begin -- */
#define WLAN_CLIENT_SIZE 30
char accept_list[WLAN_CLIENT_SIZE][20];

long* find_pid_by_name( char* pidName){

	DIR *dir;
	struct dirent *next;
	long* pidList=NULL;
	int i=0;

	dir = opendir("/proc");
	if (!dir){
		DPRINTF("Cannot open /proc");
	}
	while ((next = readdir(dir)) != NULL) {
		FILE *status;
		char filename[READ_BUF_SIZE];
		char buffer[READ_BUF_SIZE];
		char name[READ_BUF_SIZE];

		/* Must skip ".." since that is outside /proc */
		if (strcmp(next->d_name, "..") == 0)
			continue;

		/* If it isn't a number, we don't want it */
		if (!isdigit(*next->d_name))
			continue;

      sprintf (filename, "/proc/%s/status", next->d_name);
      if (!(status = fopen (filename, "r")))
	{
	  continue;
	}
      if (fgets (buffer, READ_BUF_SIZE - 1, status) == NULL)
	{
	  fclose (status);
	  continue;
	}
      fclose (status);

      /* Buffer should contain a string like "Name:   binary_name" */
      sscanf (buffer, "%*s %s", name);
      if (strcmp (name, pidName) == 0)
	{
	  pidList = realloc (pidList, sizeof (long) * (i + 2));
	  pidList[i++] = strtol (next->d_name, NULL, 0);
	}
    }

  if (pidList)
    {
      pidList[i] = 0;
    }
  else
    {
      pidList = realloc (pidList, sizeof (long));
      pidList[0] = -1;
    }
  return pidList;
}

static int
KillAllProcess ()
{
  FILE *fp;
  long *killpid;
  char line[255];
  char str_process_name[255];

  fp = fopen ("/etc/preUpload", "r");
  if (fp == NULL)
    return -1;

  while (fgets (line, 255, fp))
    {
      sscanf (line, "%s", str_process_name);
      if (strncmp (line, "factoryreset", 12))
	{
	  killpid = find_pid_by_name (str_process_name);

	  if (!killpid || *killpid <= 0)
	    {
	      //DPRINTF(" %s : No Such Process\n",str_process_name);
	    }
	  else
	    {
	      kill (*killpid, SIGTERM);
	      DPRINTF (" %s : Process killed\n", str_process_name);
	    }
	}
    }
  fclose (fp);
  DPRINTF ("\n");
  return 1;
}

/* KenWang added 2005/06/23 -- begin -- */
void do_command(char *cmd, ...)
{
        va_list args;
        char *param[40];
        int i=0, background=0;
        pid_t pid;
                
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char*)))
                        break;
        }
        va_end(args);
                                                                                                                                               
        if (!strcmp(param[i-2],"&")) {
                background = 1;
                param[i-2] = 0;
        }
#if 0
{
 int  j;
 for (j=0; param[j]; ++j)
    printf("%s ", param[j]);
 printf("\n");
}
#endif

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}

#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
static void
handle_usr1 (int sig)
{
  FILE *fp;
  start_sip = 1;
  start_sip_cnt = 0;
#if 0
  if ((fp = fopen ("/var/state/factoryreset.alive", "w")) != NULL)
    {
      fclose (fp);
    }
#endif
  return;
}
#endif

static void
handle_usr2 (int sig)
{
  FILE *fp;
  char buffer[1024];
  char line[20];
  int pid = 0, ret = 0, i, j;
  unsigned char match;
  char *argv[] = { "/usr/sbin/iwsta", "wlan0", "stalist", NULL };

  if ((fp = fopen ("/var/state/mac_flt.lock", "r")) != NULL)
    {
      fclose (fp);
      if ((fp = fopen ("/flash/mf_conf.conf", "r")) != NULL)
	{
	  fscanf (fp, "|%d|", &ret);
	  if (ret != 2)
	    {
//                              DPRINTF("default rule = %d\n", ret);
	      return;
	    }
	  fclose (fp);
	}
      else
	{
//                      DPRINTF("open /flash/mf_conf.conf failed\n");
	  return;
	}
    }
  else
    {
//              DPRINTF("open mac_flt.lock failed\n");
      memset (accept_list, 0, sizeof (accept_list));
      return;
    }

  pid = vfork ();
  if (pid < 0)
    {
      DPRINTF ("factoryreset: handle_usr2 fork failed\n");
    }
  else if (pid == 0)
    {
      execvp ("/usr/sbin/iwsta", argv);
      _exit (0);
    }
  else
    {
      waitpid (pid, NULL, 0);
    }

  if ((fp = fopen ("/var/tmp/mac_list", "r")) != NULL)
    {
      memset (buffer, 0, sizeof (buffer));
      ret = fread (buffer, 1, 1024, fp);
      //DPRINTF("ret: %d\n", ret);
      fclose (fp);
      /* check if the mac is in the accept_list, if not, add it */
      i = 0;
      while (i < ret)
	{
	  sscanf (&buffer[i], "%s\n", line);
	  match = 0;
	  for (j = 0; j < WLAN_CLIENT_SIZE; j++)
	    {
	      if (!strcmp (&accept_list[j][0], line))
		{
		  match = 1;
		  break;
		}
	    }

	  if (j == WLAN_CLIENT_SIZE && !match)
	    {			// The mac is not in iptable and accept_list yet.
	      DPRINTF ("Add %s to iptable\n", line);
	      do_command ("/usr/sbin/iptables", "/usr/sbin/iptables", "-I",
			  "MF_INT", "-z", "1", "-m", "mac", "--mac-source",
			  line, "-j", "ACCEPT", 0);
	      do_command ("/usr/sbin/iptables", "/usr/sbin/iptables", "-I",
			  "MF_FWD", "-z", "2", "-m", "mac", "--mac-source",
			  line, "-j", "ACCEPT", 0);

	      for (j = 0; accept_list[j][0] != '\0' || j >= 20; j++);
	      if (j >= 20)
		{
		  DPRINTF ("factoryreset: accept_list is full\n");
		  return;
		}
	      else
		strcpy (&accept_list[j][0], line);
	    }
	  i = i + strlen (line) + 1;	// +1 to skip '\n'
	}
      for (j = 0; j < 20; j++)
	{
	  char *inTheAcceptList = strstr (buffer, &accept_list[j][0]);
	  if (inTheAcceptList == NULL)
	    {			// the mac is not in the maclist, delete it from iptable and accept_list
	      DPRINTF ("Delete %s from iptable\n", &accept_list[j][0]);
	      do_command ("/usr/sbin/iptables", "/usr/sbin/iptables", "-D",
			  "MF_INT", "-z", "1", "-m", "mac", "--mac-source",
			  &accept_list[j][0], "-j", "ACCEPT", 0);
	      do_command ("/usr/sbin/iptables", "/usr/sbin/iptables", "-D",
			  "MF_FWD", "-z", "2", "-m", "mac", "--mac-source",
			  &accept_list[j][0], "-j", "ACCEPT", 0);
	      accept_list[j][0] = '\0';
	    }
	}
    }

  /*
     DPRINTF("----------------------------\n");
     for(i = 0; i < 20; i++)
     {
     DPRINTF("#%d\t%s\n", i, &accept_list[i][0]);
     }
     DPRINTF("----------------------------\n");
   */
}

/* KenWang added 2005/06/23 -- end -- */

#if 0
void
CopyFile (char *filename1, char *filename2)
{
  FILE *fp, *fp1;
  char tmp_line[256];
  memset (tmp_line, 0, sizeof (tmp_line));
  /* from filename1 to filename2 */
  if ((fp = fopen (filename1, "r")) != NULL)
    {
      if ((fp1 = fopen (filename2, "w")) != NULL)
	{
	  while (fgets (tmp_line, sizeof (tmp_line), fp))
	    fprintf (fp1, "%s", tmp_line);
	  fclose (fp1);
	}
      fclose (fp);
    }
}

int
save_globe_config (char *filename, char *arg1, char *arg2)
{
  char tmp_line[256];
//      char line[256];
//      int i,j;
  FILE *fp, *fp1;
//      i=0;
  memset (tmp_line, 0, sizeof (tmp_line));
  if ((fp = fopen (filename, "r")) != NULL)
    {
      if ((fp1 = fopen ("/var/tmp/tmpfile", "w")) != NULL)
	{
	  while (fgets (tmp_line, sizeof (tmp_line), fp))
	    {
	      if ((strncmp (arg1, tmp_line, strlen (arg1))) == 0)
		{
		  //      sprintf(config_line[i],"%s\"%s\"\n",arg1,arg2);
		  fprintf (fp1, "%s\"%s\"\n", arg1, arg2);
		}
	      else
		{
		  //      sprintf(config_line[i],"%s",line);
		  fprintf (fp1, "%s", tmp_line);
		}
	      //              i++;
	    }

	  fclose (fp1);
	}
      fclose (fp);
    }
  /*
     if ((fp=fopen(filename,"w"))!=NULL){
     for(j=0;j<i;j++)
     fprintf(fp,"%s",config_line[j]);
     fclose(fp);
     }
   */
  CopyFile ("/var/tmp/tmpfile", filename);
  return 1;
}
#endif
#ifdef _SUPPORT_12SEC_RESET_
void
Save_TCWD_Config (int tc_wd)
{
  FILE *fp;
  fp = fopen ("/flash/tcwd.conf", "w");
  if (fp)
    {
      fprintf (fp, "%d\n", tc_wd);
      fclose (fp);
    }
}
void
resetCurrentVodTypeCfg (KNOWN_VOD_TYPE_LIST * d)
{
  memset (d, 0, sizeof (KNOWN_VOD_TYPE_LIST));
}

void
Load_Known_VOD_Type (KNOWN_VOD_TYPE_LIST * d)
{
  FILE *fp;
  char line[1024];
  int i;

  //DPRINTF("Load_Other_Wan_Bridge_Config is called\n");
  resetCurrentVodTypeCfg (d);
  if ((fp = fopen (KNOWN_VOD_TYPE_LIST_CONFIG_FILE, "r")) == NULL)
    return;
  fscanf (fp, "%d\n", &d->previous_selected_vod_type_no);
  fscanf (fp, "%d\n", &d->known_vod_type_no);
  if (!d->known_vod_type_no)
    {
      fclose (fp);
      return;
    }
  for (i = 0; i < d->known_vod_type_no; i++)
    {
      if (fgets (line, 1024, fp))
	{
	  sscanf (line,
		  "|%d|%128[^|]|%d|%100[^|]|%100[^|]|%d|%d|\n",
		  &d->pvc_no[i],
		  d->description[i],
		  &d->indexToWanConfigFile[i],
		  d->WAN[i], d->WAN_IF[i], &d->tcwd[i], &d->autoScanNeed[i]);
	  print_blank_string (&d->description[i]);
	  print_blank_string (&d->WAN[i]);
	  print_blank_string (&d->WAN_IF[i]);
	  // DPRINTF("desc %s\n", d->Bridged_Description[i]);
	  //DPRINTF("usingSamePVCFromExistingWanConnection %d\n", d->usingSamePVCFromExistingWanConnection[i]);
	  //DPRINTF("vpi %d\n", d->Bridged_VPI[i]);
	  //DPRINTF("vci %d\n", d->Bridged_VCI[i]);
	  //DPRINTF("class %d\n", d->Bridged_ATM_Class);
	  //DPRINTF("enc %d\n", d->Bridged_Encapsulation_Method);
	  // DPRINTF("eth %d\n", d->Bridged_Ether_Filter_Type);
	  // DPRINTF("spa %d\n", d->Bridged_Spanning_Bridge_Interface);
	}
      else
	break;
    }
  fclose (fp);
}

void
Save_Known_VOD_Type (KNOWN_VOD_TYPE_LIST * d)
{
  FILE *fp;
  int i;

  if ((fp = fopen (KNOWN_VOD_TYPE_LIST_CONFIG_FILE, "w")) == NULL)
    return;
  fprintf (fp, "%d\n", d->previous_selected_vod_type_no);
  fprintf (fp, "%d\n", d->known_vod_type_no);
  for (i = 0; i < d->known_vod_type_no; i++)
    {
      load_blank_string (&d->description[i]);
      load_blank_string (&d->WAN[i]);
      load_blank_string (&d->WAN_IF[i]);
      fprintf (fp, "|%d|%s|%d|%s|%s|%d|%d|\n",
	       d->pvc_no[i],
	       d->description[i],
	       d->indexToWanConfigFile[i],
	       d->WAN[i], d->WAN_IF[i], d->tcwd[i], d->autoScanNeed[i]);
    }
  fclose (fp);
}

void
rebootWith12SecType (void)
{
  FILE *fp, *fp2;
  char filename[80], line[256];
  KNOWN_VOD_TYPE_LIST known_vod_type_list;
  KNOWN_VOD_TYPE_LIST *d = &known_vod_type_list;

  Load_Known_VOD_Type (d);
  if (d->previous_selected_vod_type_no == 1)
    {				//if mode is VOD TYPE 1 bridge, bridge. Then, we switch to Type 0 normal router default
      d->previous_selected_vod_type_no = 0;
    }
  else
    {				//if mode is NOT Type 1. Then, we switch to VOD TYPE 1 bridge, bridge
      d->previous_selected_vod_type_no = 1;
    }

  // So, add a new type, what we need:
  //wan.conf, config, wanbr.conf, vlan.conf, config, dhcpd.conf and also, the tcwd.conf
  // first of all reset the /flash direction.....
  do_command ("profile", "profile", "put", "/etc/default", 0);
  do_command ("profile", "profile", "get", "/flash", 0);
  sleep (3);

  Save_Known_VOD_Type (d);

  //We start to copy the wanx.conf wanbrx.conf and vlanx.conf to wan.conf, wanbr.conf and vlan.conf and adjust the HDCP server and reboot.
  sprintf (filename, "/flash/wan%d.conf",
	   d->indexToWanConfigFile[d->previous_selected_vod_type_no]);
  CopyFile (filename, "/flash/wan.conf");
  sprintf (filename, "/flash/wanbr%d.conf",
	   d->indexToWanConfigFile[d->previous_selected_vod_type_no]);
  CopyFile (filename, "/flash/wanbr.conf");
  sprintf (filename, "/flash/vlan%d.conf",
	   d->indexToWanConfigFile[d->previous_selected_vod_type_no]);
  CopyFile (filename, "/flash/vlan.conf");
  //write_ripd_config_Internal();



  //pure bridge, then disable the dhcp server
#if 1
  //pure bridge, then disable the dhcp server
  CopyFile (DHCPD_CONFIG_FILE, "/tmp/dh.confs");
  fp = fopen (DHCPD_CONFIG_FILE, "w");
  if (strcmp (d->WAN[d->previous_selected_vod_type_no], "bridge") == 0)
    {
      fprintf (fp, "#:0:\n");
      save_globe_config (SYS_STATUS_FILE, "ROUTER=", "no");
    }
  else
    {
      fprintf (fp, "#:1:\n");
    }
  fp2 = fopen ("/tmp/dh.confs", "r");
  fgets (line, 255, fp2);	//skip the first line since we disable it.
  while (fgets (line, 255, fp2))
    fprintf (fp, line);
  fclose (fp);
  fclose (fp2);
  unlink ("/tmp/dh.confs");
#else
  if (strcmp (d->WAN[d->previous_selected_vod_type_no], "bridge") == 0)
    {
      dhcp_change_internal (0);
      save_globe_config (SYS_STATUS_FILE, "ROUTER=", "no");
    }
  else
    {
      dhcp_change_internal (1);
      // How about if user want to have the NAT is no for router?, .....
      //save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
    }
#endif


  Save_TCWD_Config (d->tcwd[d->previous_selected_vod_type_no]);
  save_globe_config (SYS_STATUS_FILE, "WAN=",
		     d->WAN[d->previous_selected_vod_type_no]);
  save_globe_config (SYS_STATUS_FILE, "WAN_IF=",
		     d->WAN_IF[d->previous_selected_vod_type_no]);
  if (d->autoScanNeed[d->previous_selected_vod_type_no])	// Type 1 also turn off the auto PVC because of IP is not released for Markku
    {
      // turn on the autoscan.
      save_globe_config ("/flash/config", "AUTOSCAN=", "yes");	// If user edit the wan and apply, then autoSCAN PVC shall stop in next reboot.
    }
  else
    {
      // turn off the autoscan f
      save_globe_config ("/flash/config", "AUTOSCAN=", "no");	// 
    }
}
#endif
#undef LIBVER
#ifdef LIBVER
#define MAINFUNC factoryreset_main
#else
#define MAINFUNC main
#endif

int
MAINFUNC (int argc, char *argv[])
{
  /* Add for software switch reset */
  struct IP175C_vlan_ioctl_args request_args;
  int fd;
  struct ifreq ifr;
  /* software switch reset end */
  FILE *proc_sys, *proc_ppp, *proc_reset;	//, *fp;
  int resetvalue = 1;
  int resetvalue1 = 1;
  int j = 0;
  int pid = 0;
#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
  long* pid1;
  static int pid2=0;
  static int pid3=0;
  FILE* fp1;
#endif
#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
  /* Robert added for scan ACT sip server status */
  int l = 0;
  FILE *fp;
  FILE* fp1;
  sigset (SIGUSR1, handle_usr1);
//  sigset (SIGCHLD, SIG_IGN);
//    signal(SIGCHLD, SIG_DFL);
#endif

  /* KenWang added 2005/06/23 -- begin -- */
  sigset (SIGUSR2, handle_usr2);
  memset (accept_list, 0, sizeof (accept_list));
  /* KenWang added 2005/06/23 -- end -- */

  DPRINTF ("factoryreset daemon start!\n");

  while (1)
    {

    loop_start:
      proc_reset = fopen ("/proc/GPIOUSER/reset", "r");
      fscanf (proc_reset, "%d\n", &resetvalue);
      fclose (proc_reset);
      if (resetvalue == 0)
	{
	  /* reset-pin: low trigger */
	  /* 1: reset button up */
	  /* 0: reset button dn */
#ifdef _SUPPORT_12SEC_RESET_
	    		for(j=0;j<21;j++)
			{
				sleep(1);
				proc_reset = fopen("/proc/GPIOUSER/reset","r");
				fscanf(proc_reset,"%d\n",&resetvalue1);
				fclose(proc_reset);
				if (resetvalue1 == 1)
				{
					if(j<6)// Less than 6 seconds, not ada
						goto loop_start;
					goto ResetStart;
				}
			}
#else
	    	for(j=0;j<10;j++)
			{
				proc_reset = fopen("/proc/GPIOUSER/reset","r");
				fscanf(proc_reset,"%d\n",&resetvalue1);
				fclose(proc_reset);
				if (resetvalue1 == 1)
					goto loop_start;
			}
#endif
   ResetStart:
#if 1
			DPRINTF("reset button pushed!\n");
			DPRINTF("reset switch and flash all leds\n");
			//turn off lights
			GUop(proc_sys,"0","/proc/GPIOUSER/sysled");
			GUop(proc_ppp,"0","/proc/GPIOUSER/pppled");
			/* 7300G adsl led can not be closed,robert,01192006 */
			//GUop(proc_adsl,"0","/proc/GPIOUSER/adslled");
			sleep(1);
			//reset switch
			//turn on lights
	  //GUop(dev_switch,"reset","/dev/switch");

	  /* reset switch */
	  if ((fd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
	    {
	      DPRINTF ("open socket failed\n");
	      return 0;
	    }

	  memset (&ifr, 0, sizeof (struct ifreq));
	  strcpy (ifr.ifr_name, "eth0");

	  request_args.request_cmd = Switch_Reset;
	  ifr.ifr_data = (char *) &request_args;
	  if (ioctl (fd, SIOCSVLANPORT, &ifr) < 0)
	    {
	      DPRINTF ("try to reset switch failed\n");
	    }
	  /* reset switch end */

	  GUop (proc_sys, "1", "/proc/GPIOUSER/sysled");
	  GUop (proc_ppp, "1", "/proc/GPIOUSER/pppled");
	  /* 7300G adsl led can not be closed,robert,01192006 */
	  //GUop(proc_adsl,"1","/proc/GPIOUSER/adslled");

	  sleep (1);
	  //turn off lights
	  GUop (proc_sys, "0", "/proc/GPIOUSER/sysled");
	  GUop (proc_ppp, "0", "/proc/GPIOUSER/pppled");
	  /* 7300G adsl led can not be closed,robert,01192006 */
	  //GUop(proc_adsl,"0","/proc/GPIOUSER/adslled");


#endif

	  DPRINTF ("factory reset\n");
#ifdef _SUPPORT_12SEC_RESET_
	  //if(j>12) // Markku change from 12 seconds to 20 seconds
	  if (j > 20)
	    {			// more than 20 seconds -- Normal router reset for finish default
	      DPRINTF ("Finnish default reset 20 sec!\n");
	      rebootWith12SecType ();
	    }
	  // else
	  // 6 seconds to 12 seconds -- Factory reset

#endif

	  //do we need to sleep 5 secs?
//                      sleep(5)
	  pid = vfork ();
//                      run_script("/etc/scripts/killctl.sh",0,0,0);
	  if (pid < 0)
	    {
	      DPRINTF ("fork failed!\n");
	      exit (1);
	    }
	  else if (pid == 0)
	    {
	      //child
	      //run killctl.sh
	      //profile put /etc/default
	      char *argv[] = { "sh", "/etc/scripts/default.sh", NULL, NULL };
#ifdef _SUPPORT_12SEC_RESET_
	      char *argv_12SecFinnishDefault[] =
		{ "sh", "/etc/scripts/12sec_rst.sh", NULL, NULL };
	      if (j > 12)
		{		// more than 12 seconds -- Normal router reset for Finnish default
		  execvp ("/bin/sh", argv_12SecFinnishDefault);
		}
	      else		// 6 seconds to 12 seconds -- Factory reset
#endif
		{
		  execvp ("/bin/sh", argv);
		}


	      return 0;
	    }
	  else
	    {
	      //parent
	      waitpid (pid, NULL, 0);
	    }

	  //DPRINTF("default.sh\n");
	  KillAllProcess ();
	  DPRINTF ("kill all process in /etc/preUpload\n");
	  sleep (3);
	  TCDMT_SetDmtClose ();
	  /*
	     fp = fopen("/proc/dmtctrl/dmtwrite", "w");
	     if(fp!=NULL){
	     //shutdown dmt
	     fprintf(fp, "5");
	     fclose(fp);
	     }
	     DPRINTF("shutdown dmt in /proc/dmtctrl/dmtwrite\n");
	   */
	  sleep (2);
	  //reboot
	  break;

	}
     sleep (1);
#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
pid1 = find_pid_by_name ("sip_alg_wk");
  if ((*pid1) != pid2)
  {
//write to sip_apid in kernel
  fp1 = fopen ("/proc/net/ip_sip_apid","w");
  fprintf(fp1,"%d\n",(*pid1));
  fclose(fp1);
  pid2 = (*pid1);
  }
pid1 = find_pid_by_name ("actact");
  if ((*pid1) != pid3)
  {
//write to sip_apid in kernel
  fp1 = fopen ("/var/state/actact.pid","w");
  fprintf(fp1,"%d\n",(*pid1));
  fclose(fp1);
  pid3 = (*pid1);
  }
#endif
#if 0
//#ifdef _SUPPORT_TELEWELL_VOIP
      if (start_sip && (fp = fopen ("/usr/bin/getsipstatus", "r")) != 0)
	{
	  if (start_sip_cnt > 40)
	    {
	      start_sip = 0;
	      start_sip_cnt = 0;
	     // unlink ("/var/state/factoryreset.alive");
	    }
	  else
	    start_sip_cnt++;
	  if (l > 20)
	    {
	      l = 0;
                      run_script("/usr/bin/getsipstatus",0,0,0);
#if 0
	      pid = vfork ();
//                      run_script("/etc/scripts/killctl.sh",0,0,0);
	      if (pid < 0)
		{
		  DPRINTF ("fork failed!\n");
		  exit (1);
		}
	      else if (pid == 0)
		{
		  //child
		  //run killctl.sh
		  //profile put /etc/default
		  char *argv[] =
		    { "sh", "/usr/bin/getsipstatus", NULL, NULL };
		  execvp ("/bin/sh", argv);
		  exit (0);
		  //return 0;
		}
	      else
		{
		  //parent
		  waitpid (pid, NULL, 0);
		}
#endif
	    }
	  else
	    l++;
	  fclose (fp);
	}
      /* renew sip*/
#endif

    }
  //reboot process
  kill (1, SIGTERM);
  exit (1);

}
