#include <stdio.h>
#include <ctype.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#define READ_BUF_SIZE	50

#define DPRINTF printf
#ifdef LIBVER
#define MAINFUNC renew_sip_main
#else
#define MAINFUNC main
#endif
#ifndef LIBVER
long *
find_pid_by_name (char *pidName)
{

  DIR *dir;
  struct dirent *next;
  long *pidList = NULL;
  int i = 0;

  dir = opendir ("/proc");
  if (!dir)
    {
      DPRINTF ("Cannot open /proc");
    }
  while ((next = readdir (dir)) != NULL)
    {
      FILE *status;
      char filename[READ_BUF_SIZE];
      char buffer[READ_BUF_SIZE];
      char name[READ_BUF_SIZE];

      /* Must skip ".." since that is outside /proc */
      if (strcmp (next->d_name, "..") == 0)
	continue;

      /* If it isn't a number, we don't want it */
      if (!isdigit (*next->d_name))
	continue;

      sprintf (filename, "/proc/%s/status", next->d_name);
      if (!(status = fopen (filename, "r")))
	{
	  continue;
	}
      if (fgets (buffer, READ_BUF_SIZE - 1, status) == NULL)
	{
	  fclose (status);
	  continue;
	}
      fclose (status);

      /* Buffer should contain a string like "Name:   binary_name" */
      sscanf (buffer, "%*s %s", name);
      if (strcmp (name, pidName) == 0)
	{
	  pidList = realloc (pidList, sizeof (long) * (i + 2));
	  pidList[i++] = strtol (next->d_name, NULL, 0);
	}
    }

  if (pidList)
    {
      pidList[i] = 0;
    }
  else
    {
      pidList = realloc (pidList, sizeof (long));
      pidList[0] = -1;
    }
  return pidList;
}
#endif
/* renew sip */
int
MAINFUNC ()
{
  long *pid;
  static int pid_old = 0;
  static int pid3 = 0;
  int count = 0;
  FILE *fp;

  while (1)
    {
      pid = find_pid_by_name ("sip_alg_wk");
      if ((*pid) != pid_old)
	{
	  fp = fopen ("/proc/net/ip_sip_apid", "w");
	  if (fp != 0)
	    {
	      fprintf (fp, "%d\n", (*pid));
	      fclose (fp);
	    }

	  pid_old = *pid;
	}

      pid = find_pid_by_name ("actact");
      if ((*pid) != pid3)
	{
//write to sip_apid in kernel
	  fp = fopen ("/var/state/actact.pid", "w");
	  fprintf (fp, "%d\n", (*pid));
	  fclose (fp);
	  pid3 = (*pid);
	}

      if (count > 10)
	{
	  run_script ("/usr/bin/delay_go_renewsip", 0, 0, 0);
	  goto finish_loop;
	}
      count++;
      sleep (1);
    }

finish_loop:
  exit (0);
}
