/* vi: set sw=4 ts=4: */
/*
 * Mini watchdog implementation for busybox
 *
 * Copyright (C) 2000  spoon <spoon@ix.netcom.com>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

/* getopt not needed */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
//#include "busybox.h"

static unsigned int timer_duration = 30;

void show_usage(void)
{
	printf("Usage: tcwdog -t <time duration> <file>\n");
}
#undef LIBVER
#ifdef LIBVER
#define MAINFUNC tcwdog_main
#else
#define MAINFUNC main
#endif

int MAINFUNC(int argc, char **argv)
{
	char *thisarg;
	int fd;

	argc--;
	argv++;
	/* Parse any options */
	while (argc >= 1 && **argv == '-') {
		thisarg = *argv;
		thisarg++;
		switch (*thisarg) {
		case 't':
			if (--argc <= 0)
			        show_usage();
			argv++;
			timer_duration = atoi(*argv);
			break;
		default:
			show_usage();
		}
		argc--;
		argv++;
	}
	if (argc < 1)
		show_usage();

	if ((fd=open(*argv, O_WRONLY)) == -1) {
		printf("%s open error.\n", *argv);
		exit(0);
	}

	while (1) {
		write(fd, "\0", 1);
		sleep(timer_duration);
	}

	return 0;
}
