/*
	Factory Reset
	Behavior:
		1. push the reset button and hold it over 1 second
		2. reset to default
		3. flash all leds
		4. reboot
*/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>      /* open */ 
#include <sys/ioctl.h>  /* ioctl */
#include <linux/tc3162dmtctrl.h>
#define DPRINTF printf

void TCDMT_SetDmtClose(void )
{
    unsigned char Arg;
    int nFd = open( "/dev/dmtdev", O_RDWR );
    if( nFd == -1  )
	{
		DPRINTF("getDownUpStreamRate:severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
    ioctl( nFd, DMTIOCTL_SET_DMTCLOSE, &Arg );
	close(nFd);
} /* TCDMT_SetDmtClose */
static inline void GUop(FILE* filep,char* si,char* fn)
{
	filep = fopen(fn,"w");
	fprintf(filep,"%s",si);
	fclose(filep);
	fflush(filep);
}

static int KillAllProcess(){
	FILE *fp;
	long *killpid;
	char line[255];
	char str_process_name[255];

	fp=fopen("/etc/preUpload","r");
		if(fp==NULL) return -1;
		
		while (fgets(line,255,fp)){
			sscanf(line,"%s",str_process_name);
			if(strncmp(line,"factoryreset",12)){
			killpid=FIND_Process_ID_FROM_NAME(str_process_name);
			
			if (!killpid || *killpid<=0)
			{
				//DPRINTF(" %s : No Such Process\n",str_process_name);
			}else	{
				kill(*killpid,SIGTERM);
				DPRINTF(" %s : Process killed\n",str_process_name);
			}
			}
		}
		fclose(fp);
		DPRINTF("\n");
		return 1;
}

int main(int argc, char* argv[])
{
	FILE *proc_sys, *proc_ppp, *proc_adsl, *proc_reset, *dev_switch, *fp;
	int resetvalue=1;
	int resetvalue1=1;
	int i=0,j=0;
	int pid=0;

	DPRINTF("factoryreset daemon start!\n");

	while(1)
	{

loop_start:
		proc_reset = fopen("/proc/GPIOUSER/reset","r");
		fscanf(proc_reset,"%d\n",&resetvalue);
		fclose(proc_reset);
		if(resetvalue == 0)
		{
			/* reset-pin: low trigger */
			/* 1: reset button up */
			/* 0: reset button dn */
	    	for(j=0;j<10;j++)
			{
				proc_reset = fopen("/proc/GPIOUSER/reset","r");
				fscanf(proc_reset,"%d\n",&resetvalue1);
				fclose(proc_reset);
				if (resetvalue1 == 1)
					goto loop_start;
			}
#if 1
			DPRINTF("reset button pushed!\n");
			DPRINTF("reset switch and flash all leds\n");
			//turn off lights
			GUop(proc_sys,"0","/proc/GPIOUSER/sysled");
			GUop(proc_ppp,"0","/proc/GPIOUSER/pppled");
			GUop(proc_adsl,"0","/proc/GPIOUSER/adslled");
			sleep(1);
			//reset switch
			//turn on lights
			GUop(dev_switch,"reset","/dev/switch");
			GUop(proc_sys,"1","/proc/GPIOUSER/sysled");
			GUop(proc_ppp,"1","/proc/GPIOUSER/pppled");
			GUop(proc_adsl,"1","/proc/GPIOUSER/adslled");
			
			sleep(1);
			//turn off lights
			GUop(proc_sys,"0","/proc/GPIOUSER/sysled");
			GUop(proc_ppp,"0","/proc/GPIOUSER/pppled");
			GUop(proc_adsl,"0","/proc/GPIOUSER/adslled");

			
#endif
			
			DPRINTF("factory reset\n");
			//do we need to sleep 5 secs?
//			sleep(5)
			pid = vfork();
//			run_script("/etc/scripts/killctl.sh",0,0,0);
			if(pid < 0)
			{
				DPRINTF("fork failed!\n");
				exit(1);
			}
			else if (pid == 0)
			{
				//child
				//run killctl.sh
				//profile put /etc/default
		        char *argv[] = { "sh", "/etc/scripts/default.sh", NULL, NULL };
				execvp("/bin/sh", argv);
				return 0;
			}
			else
			{
				//parent
				waitpid(pid, NULL, 0);
			}

			DPRINTF("default.sh\n");
			KillAllProcess();
			DPRINTF("kill all process in /etc/preUpload\n");
			sleep(3);
			TCDMT_SetDmtClose();
			/*
			fp = fopen("/proc/dmtctrl/dmtwrite", "w");
			if(fp!=NULL){
				//shutdown dmt
				fprintf(fp, "5");
				fclose(fp);
			}
			DPRINTF("shutdown dmt in /proc/dmtctrl/dmtwrite\n");
			*/
			sleep(2);
			//reboot
			break;

		}
		sleep(1);
	}



	//reboot process
 	kill(1, SIGTERM);
	exit(1);

}

