
/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include <sys/time.h>
#include <syslog.h>
#include <wait.h>

//#include <bcmnvram.h>
//#include <netconf.h>
//#include <shutils.h>
//#include <rc.h>

#include "dst.h"
#include "ntp.h"
/* header file in websconfig */
#include "../websconfig/timezone.h"

//#define DEBUG_NTP 

// Mulder modified 2004-08-02
// #define NTP_M_TIMER "3600" 
//#define NTP_N_TIMER "30" 
#define NTP_M_TIMER 3600 
#define NTP_N_TIMER 30

#define DEFAULT_TIME_ZONE 	"0GMT"         // (GMT)Greenwich Mean Time
#define DEFAULT_NTP_POLL_INTV 	60             // minutes

#define MAX_SNTP_SERVER 4
typedef struct {
	int enabled;
	char localGMTTimeZone[MAX_TIMEZONE_STRING];// {"-1200E"...."+200HP",.....}
	int resyncPeriod; // default=60 ( 60 minutes)
	int DaylightSavingAuto; //0:disabled. 1:enabled.
	char SNTPServerIP[MAX_SNTP_SERVER][128];  // 0.0.0.0 shall be filled as default
} TimeZoneData;


TimeZoneData timezonedata;

 void resetCurrentTimeZoneCfg(void)
{
	TimeZoneData *d=&timezonedata;
  	//d->localGMTTimeZone=0;// GMT greenwich
	strcpy(d->localGMTTimeZone, DEFAULT_TIME_ZONE);  
	d->DaylightSavingAuto=1; // auto time saving
 	d->resyncPeriod = DEFAULT_NTP_POLL_INTV; 
/*
    strcpy(d->SNTPServerIP[0],"time.nist.gov");
    strcpy(d->SNTPServerIP[1],"india.Colorado.EDU");
    strcpy(d->SNTPServerIP[2],"time-b.nist.gov");
    strcpy(d->SNTPServerIP[3],"time.stdtime.gov.tw");
*/	
 	strcpy(d->SNTPServerIP[0],"192.43.244.18"); 	// time.nist.gov
	strcpy(d->SNTPServerIP[1],"128.138.140.44"); // india.Colorado.EDU
	strcpy(d->SNTPServerIP[2],"129.6.15.29");  	// time-b.nist.gov
	strcpy(d->SNTPServerIP[3],"131.107.1.10"); 	// time-nw.nist.gov

}

TimeZoneData timezonedata;

static int
Load_TimeZone_Config (void)
{

	FILE *fp;
	TimeZoneData *d=&timezonedata;

	resetCurrentTimeZoneCfg();
	fp=fopen(TIMEZONE_CONFIG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d\n%s\n%d\n%d\n%s\n%s\n%s\n%s\n",
		&d->enabled, d->localGMTTimeZone, &d->resyncPeriod, &d->DaylightSavingAuto, 
		d->SNTPServerIP[0], d->SNTPServerIP[1], d->SNTPServerIP[2], d->SNTPServerIP[3]);
		fclose(fp);
	}
	return 0;
}

void do_dst(TimeZoneData *d)
{
	int daylight_time, dstDiff;
	int TimeZone_Idx, i;  
    struct timeval tv;
    struct timezone tz;
    struct tm tm;
    char buf4[20];

	gettimeofday(&tv,&tz);
	memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));
	if((tm.tm_year+1900) < 2004 )
	{	
#ifdef DEBUG_NTP	
		printf("do_dst do nothing");
#endif
		return;
	}	
#ifdef DEBUG_NTP	
	printf("\nYear:%d,Month:%d,Day:%d,Hour:%d,Min:%d,Sec:%d\n",tm.tm_year+1900,tm.tm_mon+1,tm.tm_mday,tm.tm_hour,tm.tm_min,tm.tm_sec);	
#endif
	i=0;
	TimeZone_Idx=0;;  
	daylight_time=d->DaylightSavingAuto;
	strcpy(buf4,d->localGMTTimeZone);

	while (strncmp(buf4,tzEntry[i].name,strlen(tzEntry[i].name))!=0) 
		i++;

	if (i< tzEntrySize) 
		TimeZone_Idx = i;

   	gettimeofday(&tv,&tz);
//         	tv.tv_sec=tv.tv_sec+time_zone*3600;
    tv.tv_sec=tv.tv_sec+tzEntry[TimeZone_Idx].gmtOffset;
    settimeofday(&tv,&tz);

	if (daylight_time)
	{
		FN_DST_CHECK fnCheckDST=NULL;  
			
		if ((fnCheckDST= tzEntry[TimeZone_Idx].fnDST) != NULL)
		{
			gettimeofday(&tv,&tz);
			memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));

			dstDiff = fnCheckDST(&tm);
			if (dstDiff) {
				tv.tv_sec = tv.tv_sec + 3600;
				settimeofday(&tv,&tz);
#ifdef DEBUG_NTP	
				printf("in daylight saving time\n");
#endif
			}
#ifdef DEBUG_NTP	
			else
				printf("out daylight saving time\n");
#endif
		}
#ifdef DEBUG_NTP	
		else
			printf("no daylight saving time in this time zone\n");
#endif			
	} /* daylight */
#ifdef DEBUG_NTP	
	else 
		printf("daylight_time = 0\n");
#endif
}

/* for NTP */
int do_ntp(void)
{
	TimeZoneData *d=&timezonedata;
    int cnt;
    char buf[20];
    struct timeval tv;
    struct timezone tz;
    struct tm tm;
    time_t now;
    int ret;
	int mt;
//	char *ntpclient_argv[] = { "ntpclient", "-h", buf, "-l", "-s", NULL };
	char *argv[] = { "ntpclient", "-h", buf, "-l", "-s", NULL };
	int  pid;
   	FILE *fp;

    /* Sync time */
    time(&now);
  	cnt=now % 4 ;
	if (cnt < 0)
		cnt = cnt + 4;
	strcpy(buf,d->SNTPServerIP[cnt]); 

    ret=1;
	////ret=_eval(ntpclient_argv, NULL, 20, NULL);
	//ret=ntpclient_main(5,ntpclient_argv);
	if ( (pid = vfork()))
		waitpid(pid, NULL, 0);
        
	if(pid == 0){  // child process
		execvp("/usr/sbin/ntpclient", argv);  
		_exit(0);
	}

	if ( (fp = fopen("/var/etc/ntpclient_status", "r")) != (FILE *) NULL) {
		char buf[8];
		ret = atoi(fgets(buf, sizeof(buf), fp));
		fclose(fp);
		unlink("/var/etc/ntpclient_status");
	}	

   	gettimeofday(&tv,&tz);
	memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));
	mt=2;
//#ifdef DEBUG_NTP	
	printf("\nYear:%d,Month:%d,Day:%d,Hour:%d,Min:%d,Sec:%d\n",tm.tm_year+1900,tm.tm_mon+1,tm.tm_mday,tm.tm_hour,tm.tm_min,tm.tm_sec);	
//#endif
// Mulder modified 2004-7-30 because the defualt time is 20003 in Waveplus 
	if((tm.tm_year+1900) < 2004 )	
//	if((tm.tm_year+1900) < 2004 )	
	{
		mt=0;
#ifdef DEBUG_NTP	
		printf("ret=%d,mt=%d,time incorrect! \n",ret,mt);
#endif
	}
	else 
	{
	    mt=1;
#ifdef DEBUG_NTP	
	    printf("ret=%d,mt=%d,ntp time correct! \n",ret,mt);
#endif
	}

	if((mt==1) && ( ret==0))
	{

		do_dst(d);
		/* firewall.c : synchronize the filter rules by TOD scheduling */
//		printf("ntp: filtersync\n");
	// TBD	filtersync_main();
		// if OK then try it in maximum seconds.
//		d->resyncPeriod=NTP_M_TIMER;
   	gettimeofday(&tv,&tz);
	syslog( LOG_DEBUG, "NTP current time is %s", (char *)ctime(&tv.tv_sec) );

        return 1;

	} /* get gmt time successfully */
	else
	{
//		d->resyncPeriod=NTP_N_TIMER;
		// if not OK then try it in minimum seconds.
        return 0;
	}
//         return 0;
}

#define  ACT_IDLE 0
int check_action(void)
{
	 return ACT_IDLE;
}

static int do_ntp_flag = 0;
int
//ntp_main(int argc, char **argv)
main(int argc, char **argv)
{
//	int status;
//	pid_t pid;
//	int interval;
	TimeZoneData *d=&timezonedata;
	int update_time_flag = 0;
   
	Load_TimeZone_Config ();
//	printf("ntp_main: argument %s %s\n", argv[0],argv[1]);
/*
	if (!strcmp(argv[1], "dst"))
	{
		do_dst(d);
		return 0;
	}
*/	
	while(1)
	{
//		pid = vfork();
//		switch(pid)
//		{
//			case -1:
//				perror("fork failed");
//				_exit(1);
//			case 0:
//				if (check_action() == ACT_IDLE){	// Don't execute during upgrading
//				if ( (do_ntp_flag == 0 ) && (check_action() == ACT_IDLE) ) {	// Don't execute during upgrading
				if (do_ntp_flag == 0 ) {	// avoid to re-entering
				//	eval("killall","-9","ntpclient");	 TBD
//					fprintf(stderr, "do ntp enter...\n");
					do_ntp_flag = 1; // Mulder test
					update_time_flag = do_ntp();
//					fprintf(stderr, "do ntp left ...\n");
					do_ntp_flag = 0; // Mulder test
				}
				else
				{	
					sleep(10);
					fprintf(stderr, "ntp: nothing to do...\n");
					continue;
				}	
//				_exit(0);
//				break;
//			default:
//				waitpid(pid, &status, 0);
				//dprintf("parent\n");
//				printf("parent\n");
//				break;
//		} // end switch

		if (update_time_flag)
		{	
			fprintf(stderr, "ntp: sleep %d min \n", d->resyncPeriod);
			sleep(d->resyncPeriod*60);
			Load_TimeZone_Config ();
		}
		else
		{	
			fprintf(stderr, "ntp: sleep %d sec --- \n", NTP_N_TIMER);
			sleep(NTP_N_TIMER);
//			Load_TimeZone_Config ();
		}	
	} // end while
} // end main

