
/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#define MAX_TIMEZONE_STRING 	  8         /* timezone abbreviation */ 
#define SNTP_DEFAULT_TIMEZONE	  "0GMT"     

typedef int (* FN_DST_CHECK)(struct tm *);

struct timeZoneTable_ {
           unsigned char name[MAX_TIMEZONE_STRING];
           int           gmtOffset;
//           char          dstFlag;
    FN_DST_CHECK fnDST;
};

typedef struct timeZoneTable_ timeZoneTable;
/* 
struct dstTable_ {
           unsigned char  startDay[21];
           unsigned char  endDay[21];
           unsigned char  startMonth;
           unsigned char  endMonth;
           unsigned char  diffMonth;
           char           resv;
           int            dstBias;
};
typedef struct dstTable_ dstTable;
*/
const timeZoneTable tzEntry[] = {
  /* Timezone abbreviation, +-hrs GMT, Timezone description */
  { "-1200E", -12*3600,/*	"Eniwetok, Kwajalein" 					,*/ NULL },
  { "-1100M", -11*3600,/*	"Midway Island, Samoa" 					,*/ NULL },
  { "-1000H", -10*3600,/*	"Hawaii" 								,*/ NULL },
  { "-900A",  -9*3600,	/*	"Alaska" 								,*/ fnDST_NA },	// DST
  { "-800P",  -8*3600,	/*	"Pacific Time (US & Canada); Tijuana"  	,*/ fnDST_NA },	// DST
  { "-700A",  -7*3600,	/*	"Arizona"  								,*/ NULL },
  { "-700M",  -7*3600,	/*	"Mountain Time (US & Canada)"  			,*/ fnDST_NA },	// DST
  { "-600CA", -6*3600,	/*	"Central America"  						,*/ NULL },  
  { "-600CT", -6*3600,	/*	"Central Time (US & Canada)"			,*/ fnDST_NA },	// DST
  { "-600M",  -6*3600,	/*	"Mexico City, Tegucigalpa"				,*/ fnDST_NA },	// DST
  { "-600S",  -6*3600,	/*	"Saskatchewan" 							,*/ NULL },
  { "-500B",  -5*3600,	/*	"Bogota, Lima, Quito"  					,*/ NULL }, 
  { "-500E",  -5*3600,	/*	"Eastern Time (US & Canada)"			,*/ fnDST_NA },	// DST
  { "-500I",  -5*3600,	/*	"Indiana (East)" 						,*/ NULL },
  { "-400A",  -4*3600,	/*	"Atlantic Time (Canada)" 				,*/ fnDST_NA },	// DST
  { "-400C",  -4*3600,	/*	"Caracas, La Paz"  						,*/ NULL },
  { "-400S",  -4*3600,	/*	"Santiago"  							,*/ NULL },	// DST		
  { "-330N",  -12600,   /*-330*//*	"Newfoundland"  						,*/ fnDST_NA },	// DST	
  { "-300B",  -3*3600, /*	"Brasilia" 								,*/ fnDST_Brazil }, // DST
  { "-300BA", -3*3600, /*	"Buenos Aires, Georgetown"				,*/ NULL },	
  { "-200M",  -2*3600,	/*	"Mid-Atlantic"  						,*/ NULL },	// DST	
  { "-100A",  -1*3600, /*	"Azores, Cape Verde Is."  				,*/ NULL },	// DST
  { "0C",      000, /* 	"Casablanca, Monrovia"  				,*/ NULL },
  { "0D",      000, /* 	"Dublin, Edinburgh, Lisbon, London"		,*/ fnDST_EU },
  { "0GMT",    000, /* 	"Greenwich Mean Time"					,*/ NULL },
  { "+100A",   1*3600, /* 	"Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna"		,*/ fnDST_EU },
  { "+100BB",  1*3600, /* 	"Belgrade, Bratislava, Budapest, Ljubljana, Prague"  	,*/ fnDST_EU },
  { "+100BC",  1*3600, /* 	"Brussels, Copenhagen, Madrid, Paris, Vilnius"  		,*/ fnDST_EU },
  { "+100S",   1*3600, /* 	"Sarajevo, Skopje, Sofija, Warsaw, Zagreb"  			,*/ fnDST_EU },
  { "+100W",   1*3600, /* 	"West Central Africa"  					,*/ NULL },
  { "+200A",   2*3600,	/*	"Athens, Istanbul, Minsk" 				,*/ fnDST_EU },
  { "+200B",   2*3600,	/*	"Bucharest"  							,*/ fnDST_EU },
  { "+200C",   2*3600,	/*	"Cairo"  								,*/ NULL },	// DST
  { "+200HP",  2*3600,	/*	"Harare, Pretoria"  					,*/ NULL },
  { "+200HR",  2*3600,	/*	"Helsinki, Riga, Tallinn" 				,*/ fnDST_EU },
  { "+200J",   2*3600,	/*	"Jerusalem"								,*/ fnDST_Israel },
  { "+300B",   3*3600,	/*	"Baghdad, Kuwait, Riyadh" 				,*/ NULL },
  { "+300M",   3*3600,	/*	"Moscow, St. Petersburg, Volgograd" 	,*/ fnDST_EU },
  { "+300N",   3*3600,	/*	"Nairobi" 								,*/ NULL },
  { "+330T",   12600,   /*330*//*	"Tehran"  								,*/ NULL },	// DST
  { "+400A",   4*3600,	/*	"Abu Dhabi, Muscat"						,*/ NULL },
  { "+400B",   4*3600,	/*	"Buka, Tbilisi"							,*/ NULL },	// (Tbilisi: Georgia)
  { "+400K",   4*3600,	/*	"Kazan"									,*/ NULL },	// ?
  { "+430K",   16200,	/*430*//*	"Kabul"  								,*/ NULL },
  { "+500E",   5*3600,	/*	"Ekaterinburg"  						,*/ NULL },	// DST
  { "+500I",   5*3600,	/*	"Islamabad, Karachi, Tashkent"  		,*/ NULL },
  { "+530B",   19800,	/*530*//*	"Bombay, Calcutta, Madras, New Delhi"  	,*/ NULL },
  { "+545K",   20700,	/*545*//*	"Kathmandu"  							,*/ NULL },
  { "+600A",   6*3600,	/*	"Astana, Almaty, Dhaka" 				,*/ NULL },	// (Astana: Kazakhstan)
  { "+600S",   6*3600,	/*	"Sri Jayawardenepura"					,*/ NULL },	// (Capital of Sri Lanka)	
  { "+630R",   6*3600,	/*	"Rangoon" 								,*/ NULL },	
  { "+700B",   7*3600,	/*	"Bangkok, Hanoi, Jakarta" 				,*/ NULL },
  { "+700K",   7*3600,	/*	"Krasnoyarsk" 							,*/ NULL },	// DST
  { "+800B",   8*3600,	/*	"Beijing, Chongqing, Hong Kong, Urumqi"	,*/ NULL },
  { "+800I",   8*3600,	/*	"Irkutsk, Ulaan Bataar"  				,*/ NULL },	// DST
  { "+800K",   8*3600,	/*	"Kuala Lumpur, Singapore"				,*/ NULL },
  { "+800P",   8*3600,	/*	"Perth"  								,*/ NULL },
  { "+800T",   8*3600,	/*	"Taipei"  								,*/ NULL },
  { "+900TO",  9*3600,	/*	"Tokyo, Osaka, Sapporo" 				,*/ NULL },
  { "+900S",   9*3600,	/*	"Seoul" 								,*/ NULL },
  { "+900Y",   9*3600,	/*	"Yakutsk" 								,*/ NULL },	// DST
  { "+930A",   34200, 	/*930*//*	"Adelaide"								,*/ fnDST_AU },	// DST
  { "+930D",   34200, 	/*930*//*	"Darwin"  								,*/ NULL },
  { "+1000B", 10*3600,	/*	"Brisbane"  							,*/ NULL },
  { "+1000C", 10*3600,	/*	"Canberra, Melbourne, Sydney"  			,*/ fnDST_AU },	// DST
  { "+1000G", 10*3600,	/*	"Guam, Port Moresby"					,*/ NULL },
  { "+1000H", 10*3600,	/*	"Hobart"  								,*/ fnDST_AU_T },	// DST (Capital of Tasmania)
  { "+1000V", 10*3600,	/*	"Vladivostok"  							,*/ NULL },	// DST
  { "+1100M", 11*3600,	/*	"Magadan, Solomon Is., New Caledonia"	,*/ NULL },
  { "+1200A", 12*3600,	/*	"Auckland, Wellington"					,*/ fnDST_NZ },	// DST
  { "+1200F", 12*3600,	/*	"Fiji, Kamchatka, Marshall Is."  		,*/ NULL },
  { "+1300N", 13*3600,	/*	"Nuku'alofa"  							,*/ NULL },	// (Tonga)
//  {"DONE",       0,     /* ""										,*/ NULL}
};
/*
const  dstTable dstEntry[] = {
	{{ },                                   { },                                    0, 0, 0, 0, 0},
		//4 first sun - 10 last sun
	{{7,6,4,3,2,1,6,5,4,3,1,7,6,5,3,2,1,7,5,4,3}, {27,26,31,30,29,28,26,25,31,30,28,27,26,25,30,29,28,27,25,31,30}, 4, 10, 0, 0, 3600},
		//3 last sun - 10 last sun
	{{31,30,28,27,26,25,30,29,28,27,25,31,30,29,27,26,25,31,29,28,27}, {27,26,31,30,29,28,26,25,31,30,28,27,26,25,30,29,28,27,25,31,30}, 3, 10, 0, 0, 3600},
	{{31,30,28,27,26,25,30,29,28,27,25,31,30,29,27,26,25,31,29,28,27}, {27,26,31,30,29,28,26,25,31,30,28,27,26,25,30,29,28,27,25,31,30}, 3, 10, 0, 0, 3600},
		//10 last sun - 3 last sun
	{{27,26,31,30,29,28,26,25,31,30,28,27,26,25,30,29,28,27,25,31,30}, {31,30,28,27,26,25,30,29,28,27,25,31,30,29,27,26,25,31,29,28,27}, 10, 3, 1, 0, 3600},
	};
*/
const int tzEntrySize = sizeof(tzEntry) / sizeof(timeZoneTable) ;
