//
// small file system Albert Chuang
// profile header file
//

#define FLASH_CONF_DEV       "/dev/mtd2"
#define FLASH_MAC_DEV	   "/dev/mtd1"
#define MAC_LENGTH         6
#define OFFSET_MAC_ADDR    (MAC_LENGTH*3)

#define SIGNATURE_SIZE 32
#define BLOCK_TOTAL    64
#define FLASH_CONF_SIZE	(0xc000)
#define FLASH_MAC_SIZE 50 //(sizeof(struct flashMapMac))
#define NAME_SIZE	32
#define BUFFER_SIZE    (FLASH_CONF_SIZE - SIGNATURE_SIZE - BLOCK_TOTAL * sizeof(struct Table_T))

#define DEFAULT_MAC0 0x00
#define DEFAULT_MAC1 0x04
#define DEFAULT_MAC2 0xed
#define DEFAULT_MAC3 0xaa
#define DEFAULT_MAC4 0xbb
#define DEFAULT_MAC5 0xcc

#define DEFAULT_MAC1_FN "/mac/lan.mac"
#define DEFAULT_MAC2_FN "/mac/wan.mac"
#define DEFAULT_MAC3_FN "/mac/wlan.mac"



struct Table_T {
	unsigned char status;
	char name[NAME_SIZE];
	unsigned int offset;
	unsigned int size;
	unsigned int csum;
};

struct flashMap {
	unsigned char signature[SIGNATURE_SIZE];
	struct Table_T blocks[BLOCK_TOTAL];
	unsigned char buffer[BUFFER_SIZE];
};

enum MAC_TYPE {
	LAN_MAC,
	WAN_MAC,
	WIRELESS_MAC
};

typedef struct HW_DATA_S 
{
	char lan_mac[MAC_LENGTH];
	char wan_mac[MAC_LENGTH];
	char wireless_mac[MAC_LENGTH];
}HW_DATA_T;

struct flashMapMac {
	unsigned char signature[SIGNATURE_SIZE];
	HW_DATA_T macs;
};

