
/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/
#define WIPC_ALERT_MAIL_TIMER 5
#define DEBUG_ALERTMAIL
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include <sys/time.h>
#include <syslog.h>
#include <wait.h>

#define WIPCA_CFG_FILE "/flash/wipca.conf"
#define VAR_SYS_STATUS_FILE 		"/var/etc/status"
int isValidIP(char *IPaddr){
 struct in_addr inp;
   if (inet_aton(IPaddr,&inp)!=0) /* success */
	   return 1;
   else
	   return 0;
}
static char tmp_line[256];

char* read_file_para_value(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
//	char line[255];
	char str_return[50]={0};
	//char_t *str_return=NULL;
	char str_temp[50]={0};
	buf[0]="\0";
	memset(tmp_line,0,sizeof(tmp_line));
	*buf='\0';
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(tmp_line,sizeof(tmp_line),fp)){
		        if (strncmp(tmp_line,arg1,strlen(arg1)) == 0){
       				sscanf(tmp_line,"%50[^=]=\"%50[^\"]\"\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
			//	DPRINTF("1.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	       	fclose(fp);
	}
	return buf;
}

typedef struct {
	int enable;//1 is enabled
  // char sendaddr[128];
   char alertaddr[128];
    char alertsmtp[128];
								
} WAN_IP_CHANGE_ALERT_CONFIG_DATA;	

WAN_IP_CHANGE_ALERT_CONFIG_DATA wipca_config;


void resetCurrentWipcaCfg(void)
{
	WAN_IP_CHANGE_ALERT_CONFIG_DATA *d=&wipca_config;
 	memset(d,0,sizeof(WAN_IP_CHANGE_ALERT_CONFIG_DATA));
}


static int Load_Wipca_Config (void)
{

	FILE *fp;

	resetCurrentWipcaCfg();
	fp=fopen(WIPCA_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %s %s\n",
				&wipca_config.enable, 
				wipca_config.alertaddr, 
				wipca_config.alertsmtp);
			if(wipca_config.alertaddr[0]=='&')
				wipca_config.alertaddr[0]='\0';
			if(wipca_config.alertsmtp[0]=='&')
				wipca_config.alertsmtp[0]='\0';
		fclose(fp);
	}
	return 0;
}



#define SYS_LOG_FILE "/var/log/messages"
#define WIPC_OLD_ADDRESS "/tmp/wipcoa"
static char str_wanip[20];
static char buf1[50];

void RunFunc_WANIPChangeAlertEmail(void)
{
	WAN_IP_CHANGE_ALERT_CONFIG_DATA *d=&wipca_config;
    char buf2[128];
//cat /var/log/alertmail|smtpclient -s "Security Log/Alert From test test" -f cjw@billion.com -S billion.com  cjw@billion.com.tw &
//cat /var/log/alertmail|smtplient -s "Security Log/Alert From $GATEWAY_NAME" -f $c -S $d  $c 
	char *argv[] = {"smtpclient", "-s", buf1, "-F", SYS_LOG_FILE, "-f", buf2, 
					"-S", d->alertsmtp, d->alertaddr, NULL };
	int  pid;
   	FILE *fp;
   char my_name[BUFSIZ];

	if ( (fp = fopen(SYS_LOG_FILE, "r")) == (FILE *) NULL) {
#ifdef DEBUG_ALERTMAIL	
	printf("WIPCA: no alertmail file\n");
#endif
		return;
	}	
	fclose(fp);
	
#ifdef DEBUG_ALERTMAIL	
	printf("WIPCA: call smtpclient\n");
#endif

    if (gethostname(my_name, sizeof(my_name) - 1) < 0) {
        printf("gethostname: error\n");
    }
#ifdef DEBUG_ALERTMAIL	
    printf("gethostname: %s\n", my_name);
#endif

	sprintf(buf1, "WAN IP Change notice  from %s (new IP: %s)", my_name, str_wanip); 

//	if (d->sendaddr)
//		strcpy(buf2, d->sendaddr); 
//	else	
		strcpy(buf2, d->alertaddr); 

	if ( (pid = vfork()))
		waitpid(pid, NULL, 0);
        
	if(pid == 0){  // child process
		execvp("/usr/sbin/smtpclient", argv);  
		_exit(0);
	}

#ifdef DEBUG_ALERTMAIL	
	printf("WIPCA: call smtpcleint finished str_wanip=%s\n",str_wanip);
#endif

}

int
main(int argc, char **argv)
{
	static char str_wanip_old[20];
	WAN_IP_CHANGE_ALERT_CONFIG_DATA *d=&wipca_config;
	FILE *fp;
	Load_Wipca_Config();
	while(1)
	{
					if (d->enable)
					{// also check if the WAN IP is change from last loop
						strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
						if((isValidIP(str_wanip)))
						{ // compare old and new if the same
							// ready if there are existing old WAN IP
							if ( (fp = fopen(WIPC_OLD_ADDRESS, "r")) ) {
								fscanf(fp,"%s\n",str_wanip_old);
								fclose(fp);
							}	
							else
							{
								sprintf(str_wanip_old,"0.0.0.0");
							}
							
#ifdef DEBUG_ALERTMAIL	
	printf("WIPCA: new wan IP=%s old wan IP=%s\n",str_wanip,str_wanip_old);
#endif
							if (strcmp(str_wanip,str_wanip_old))
							{	// not the same
								RunFunc_WANIPChangeAlertEmail();
								
								// write the old wanip to an tmp file
								fp=fopen(WIPC_OLD_ADDRESS,"w");
								if(!fp) {
									return -1;
								}			
								fprintf(fp,"%s\n",str_wanip);
								fflush(fp);
								fclose(fp);
							}
						}
					}

#ifdef DEBUG_ALERTMAIL	
				printf("WIPCA sleeping %d sec\n", WIPC_ALERT_MAIL_TIMER);
#endif

		sleep(WIPC_ALERT_MAIL_TIMER);
	} // end while
} // end main
