#include <windows.h>
#include <process.h>    /* _beginthread, _endthread */
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "../oam.h"
#include "../oam_ext.h"
#include "../crc10.h"



void timer(void *dummy);
void processor(void *dummy);
int send_cell(unsigned int id, void *pCellPayload, unsigned char pti);
int main();

extern unsigned char oam_timer_running;
extern void oam_wait_for_timeout(void *dummy);
extern void win_oam_process_ticks();
extern void win_oam_process_timeout();
extern int module_init();
extern void module_exit(void);

HANDLE hTimeoutMutex;

/* For locking each thread to simulate kernel thread's
   which are nonpreemptive */
HANDLE hProcessMutex;

BOOL repeat = TRUE;
unsigned long htimeoutThread;


/****************************************************
*****************************************************/
int main()
{
    char proc[4096] = {0};
    char idstring[2] = {0,0};
    char c;
    unsigned char id;
    unsigned short crc;
/* Continuity check cell */
static unsigned char CCcell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | OAM_FM_CC, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET,
0
};
/* RDI cell */
static unsigned char RDIcell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | OAM_FM_RDI, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET,
0
};
/* AIS cell */
static unsigned char AIScell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | OAM_FM_AIS, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET,
0
};
unsigned char LBcell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | OAM_FM_LB, 1, 0xAA, 0xAA, 0xAA, 0xAA,
 'L', 'S', 'I', '_', 'G', 'e', 't', 'a', 'f', 'i', 'x', '_', 'N', 'T', '_', '\0'
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET ,
0, 0
};
unsigned char anyLBcell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | OAM_FM_LB, 1, 0xAA, 0xAA, 0xAA, 0xAA,
 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET ,
0, 0
};
unsigned char badcell[OAM_PAYLOAD_SIZE] = { OAM_TYPE_FAULT_MGMT | 0x5,  1, 0xAA, 0xAA, 0xAA, 0xAA,
 'L', 'S', 'I', '_', 'G', 'e', 't', 'a', 'f', 'i', 'x', '_', 'N', 'T', '_', '\0'
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET
, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET, OAM_UNUSED_OCTET ,
0, 0
};
    unsigned char CCActcell[OAM_PAYLOAD_SIZE] = {OAM_TYPE_ACT_DEACT | OAM_ACT_CC, 0};
    unsigned char CCDeactcell[OAM_PAYLOAD_SIZE] = {OAM_TYPE_ACT_DEACT | OAM_ACT_CC, 0};
    unsigned char cellpayload[OAM_PAYLOAD_SIZE];

    module_init();
//    crc10_print_table();

    hTimeoutMutex = CreateEvent(NULL, FALSE, FALSE, "oamtimeout");
    hProcessMutex = CreateMutex(NULL, FALSE, NULL);
	_beginthread(oam_wait_for_timeout, 0, NULL);
	htimeoutThread = _beginthread(timer, 0, NULL);

    /* enable channels */
    oam_channel_enable(0, OAM_F4_SEG_FLOW);
    oam_channel_enable(1, OAM_F4_ETE_FLOW);
    oam_channel_enable(2, OAM_F5_FLOW);
    oam_channel_enable(3, OAM_F5_FLOW);
    oam_channel_enable(5, OAM_F5_FLOW);
    oam_channel_enable(7, OAM_F5_FLOW);
    oam_channel_enable(8, OAM_F5_FLOW);
    oam_channel_enable(9, OAM_F5_FLOW);

    while(repeat)
    {
        printf("Enter code:");
        c = getch();
        putch(c);
        printf("\n");
        if (c == 'q')
            break;
        if (c=='1' || c=='2' || c=='p')
            ;
        else
        {
            printf("Enter channel id:");
            idstring[0] = getch();
            putch(idstring[0]);
            id = atoi(idstring);
        }
        printf("\n");
        switch(c)
        {
        case '1':
            oam_adsl_adaptor_defect_set();
            break;
        case '2':
            oam_adsl_adaptor_defect_clear();
            break;
        case 'c':
            memcpy(cellpayload, CCActcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FUNC_SPEC_INDEX+OAM_ACT_MESSAGE_ID_DIR_FS_INDEX] = OAM_ACT_MSG_ID_ACTIVATE | OAM_ACT_DIR_NA;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'o':
            memcpy(cellpayload, CCActcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FUNC_SPEC_INDEX+OAM_ACT_MESSAGE_ID_DIR_FS_INDEX] = OAM_ACT_MSG_ID_ACTIVATE | OAM_ACT_DIR_NA;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x05);
            break;
        case 'd':
            memcpy(cellpayload, CCDeactcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FUNC_SPEC_INDEX+OAM_ACT_MESSAGE_ID_DIR_FS_INDEX] = OAM_ACT_MSG_ID_DEACTIVATE | OAM_ACT_DIR_NA;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'f':
            memcpy(cellpayload, CCDeactcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FUNC_SPEC_INDEX+OAM_ACT_MESSAGE_ID_DIR_FS_INDEX] = OAM_ACT_MSG_ID_DEACTIVATE | OAM_ACT_DIR_NA;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x05);
            break;
        case 'e':
            memcpy(cellpayload, CCcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'w':
            memcpy(cellpayload, CCcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x05);
            break;
        case 'r':
            memcpy(cellpayload, RDIcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'a':
            memcpy(cellpayload, AIScell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'z':
            memcpy(cellpayload, AIScell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x05);
            break;
        case 'l':
            memcpy(cellpayload, LBcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FM_LB_LBID_INDEX+OAM_FUNC_SPEC_INDEX] = 1;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'L':
            memcpy(cellpayload, anyLBcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_FM_LB_LBID_INDEX+OAM_FUNC_SPEC_INDEX] = 1;
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'b':
            /* bad cell test */
            memcpy(cellpayload, badcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            crc = update_crc10_by_bytes(0, cellpayload, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] ^= crc>>8;
            cellpayload[OAM_CRC_INDEX_LO] ^= crc &0xFF;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'B':
            /* bad cell test */
            memcpy(cellpayload, badcell, OAM_PAYLOAD_SIZE);
            cellpayload[OAM_CRC_INDEX_HI] &= ~OAM_CRC_MSB_MASK;
            cellpayload[OAM_CRC_INDEX_LO] = 0;
            send_cell(id, cellpayload, 0x04);
            break;
        case 'q':
            repeat = FALSE;
            break;
        case 'u':
            oam_user_cell_seen(id);
            break;
        case 'p':
            win_oam_read_proc(proc, NULL, 0, 0, NULL, NULL);
            printf(proc);
            break;
        default:
            break;
        }
    }
    
    oam_timer_running = 0;
    getch();
    module_exit();
    return 0;
}


/****************************************************
Simulate timer interrupt
*****************************************************/
void timer(void *dummy)
{
    while(oam_timer_running)
    {
        Sleep(500);
        PulseEvent(hTimeoutMutex);
    }
    printf("End timer thread\n");
    _endthread();
}

/****************************************************
Simulate Kernel thread
*****************************************************/
void oam_wait_for_timeout(void *dummy)
{
    /* block here */
    while(oam_timer_running && WaitForSingleObject(hTimeoutMutex, INFINITE) != WAIT_FAILED)
    {
        WaitForSingleObject(hProcessMutex, INFINITE);
        win_oam_process_ticks();
        win_oam_process_timeout();
        ReleaseMutex(hProcessMutex);
    }
    printf("End oam_wait_for_timeout thread\n");
    _endthread();
}

/* Simulate sending of a cell */
int send_cell(unsigned int id, void *pCellPayload, unsigned char pti)
{
    int res;

    WaitForSingleObject(hProcessMutex, INFINITE);
    res = oam_process_cell(id, pCellPayload, pti);
    ReleaseMutex(hProcessMutex);
    
    return res;
}