/*
**  sardoing.c, version:1.1,  2005/Feb/02,  Sam Hung/Billion
**  TC3162 ATM SAR ioctl userland program
**  Add scanpvc function feature FIXIP_RFC2684B_LLC and FIXIP_RFC2684B_VC
**
**
**  sardoing.c, version:1.0,  2005/Feb/01,  Sam Hung/Billion
**  TC3162 ATM SAR ioctl userland program
**  This version is base on scanpvc.c version 1.1
**  Feature:
**  1. Support scanpvc function
**  1.a Support multi-type protocol determine (OAMF5/RFC2684B_VC/RFC2684B_LLC/PPPOE_LLC/PPPOE_VC/DHCPC_LLC/DHCPC_VC/PPPOA_LLC/PPPOA_VC)
**  1.b Now only support 16 pvcs table scanning function
**
**  2. support send oam function
**  2.a support send out OAM F4/F5 AIS/RDI/LOOP BACK/CC packets
**  2.b NOT support get OAM response now !!
**
**
**  scanpvc.c, version:1.1,  2005/Jan/29,  Sam Hung/Billion
**  scanpvc userland program
**  usage: scanpvc [0/1]  (0 for set scanpvc, 1 for get scanpvc result)
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdint.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/syslog.h>
#include <linux/atm.h>
#include <linux/atmdev.h>
#include <asm/tc3162/tc3162_atm_ioc.h>
#include "../websconfig/lan_conf.h" 
#include "../websconfig/wan.h" 
#include "../3rdparty/goahead/ws030930/webs.h" 
#include "../tmss/include/log.h"

#define SCANPVC_CONFIG_FILE "/etc/default/scanpvc.conf"
#define FIXEDIP_SCANPVC_CONFIG_FILE "/flash/fixscanpvc.conf"

extern char* read_file_para_value(char *filename, char *arg1,char *buf);
static pvc_table_list_t pvc_list_info;
static void Load_ScanPVC_Config(void);

//pvc_table_list_t pvc_list_info={{0x0,0x0,0xaa,0xbb,0xcc,0xdd},{0x00,0x00,0x00,0x00},{0x00,0x00,0x00,0x00},{16},{{0,31,0},{0,33,0},{0,34,0},{0,35,0},{0,36,0},{0,37,0},{0,38,0},{0,39,0},{0,40,0},{0,32,0},{0,50,0},{0,66,0},{0,77,0},{0,88,0},{0,99,0},{0,123,0}}};
//pvc_table_list_t pvc_list_info={{0x0,0x0,0xaa,0xbb,0xcc,0xdd},{8},{{0,310,0},{0,33,0},{0,32,0},{0,35,0},{0,36,0},{0,37,0},{0,38,0},{0,39,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0}}};

void show_usage(void);
void fill_scanpvc_table(struct atmif_sioc* );
void dump_get_scanpvc_result(pvc_table_list_t * );
static void Load_ScanPVC_Config(void){
	FILE *f;
	uint8_t i=0;
	int vpi,vci,pvc_list1,pvc_list2,pvc_list3,pvc_list4,pvc_list5,pvc_list6,sourceip1,sourceip2,sourceip3,sourceip4,desip1,desip2,desip3,desip4;
	char line[255];
	char buf[32];
	char str_eth1_mac[18];
	
	pvcmap_t *pvcmap;
	pvcmap = pvc_list_info.pvc_table;
	f=fopen(SCANPVC_CONFIG_FILE,"r");
	if(f){
		while(fgets(line,sizeof(line),f)){
//			memset(&pvcmap[i],0,sizeof(pvcmap[i]));
			sscanf(line,"|%d|%d|\n",&vpi,&vci);
				//&pvcmap[i].vpi,
				//&pvcmap[i].vci);
				pvcmap[i].vpi=vpi;
				pvcmap[i].vci=vci;
				pvcmap[i].result=0;
				/*
				DPRINTF("pvcmap[%d]:vpi=%d vci=%d\n",i,pvcmap[i].vpi,pvcmap[i].vci);
				DPRINTF("pvcmap[%d]:vpi=%d vci=%d\n",i,vpi,vci);
				*/
			i++;
		}
		fclose(f);		
	}

	
	//strcpy(str_eth1_mac,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"ETH1_MAC=",buf));
	memcpy(str_eth1_mac,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"ETH1_MAC=",buf),18);
	DPRINTF("scanpvc:eth1_mac:%s\n",str_eth1_mac);
	sscanf(str_eth1_mac,"%2x:%2x:%2x:%2x:%2x:%2x"
			,&pvc_list1
			,&pvc_list2
			,&pvc_list3
			,&pvc_list4
			,&pvc_list5
			,&pvc_list6
			/*
			,&pvc_list_info.mac_addr[0]
			,&pvc_list_info.mac_addr[1]
			,&pvc_list_info.mac_addr[2]
			,&pvc_list_info.mac_addr[3]
			,&pvc_list_info.mac_addr[4]
			,&pvc_list_info.mac_addr[5]
			*/
			);
	
	pvc_list_info.mac_addr[0]=pvc_list1;
	pvc_list_info.mac_addr[1]=pvc_list2;
	pvc_list_info.mac_addr[2]=pvc_list3;
	pvc_list_info.mac_addr[3]=pvc_list4;
	pvc_list_info.mac_addr[4]=pvc_list5;
	pvc_list_info.mac_addr[5]=pvc_list6;
	/*
	DPRINTF("eth1_mac0:%2x\n",pvc_list_info.mac_addr[0]);
	DPRINTF("eth1_mac1:%2x\n",pvc_list_info.mac_addr[1]);
	
	DPRINTF("eth1_mac2:%2x\n",pvc_list_info.mac_addr[2]);
	DPRINTF("eth1_mac3:%2x\n",pvc_list_info.mac_addr[3]);
	DPRINTF("eth1_mac4:%2x\n",pvc_list_info.mac_addr[4]);
	DPRINTF("eth1_mac5:%2x\n",pvc_list_info.mac_addr[5]);
	*/	
	f=fopen(FIXEDIP_SCANPVC_CONFIG_FILE,"r");
	if(f){
		if(fgets(line,sizeof(line),f))
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&sourceip1,&sourceip2,&sourceip3,&sourceip4);
		if(fgets(line,sizeof(line),f))
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&desip1,&desip2,&desip3,&desip4);
		fclose(f);
	}	
	pvc_list_info.src_ip[0]=sourceip1;
	pvc_list_info.src_ip[1]=sourceip2;
	pvc_list_info.src_ip[2]=sourceip3;
	pvc_list_info.src_ip[3]=sourceip4;
	pvc_list_info.dst_ip[0]=desip1;
	pvc_list_info.dst_ip[1]=desip2;
	pvc_list_info.dst_ip[2]=desip3;
	pvc_list_info.dst_ip[3]=desip4;
	/*
	DPRINTF("srcip:%2x.%2x.%2x.%2x\n",pvc_list_info.src_ip[0],pvc_list_info.src_ip[1],pvc_list_info.src_ip[2],pvc_list_info.src_ip[3]);
	DPRINTF("dstip:%2x.%2x.%2x.%2x\n",pvc_list_info.dst_ip[0],pvc_list_info.dst_ip[1],pvc_list_info.dst_ip[2],pvc_list_info.dst_ip[3]);
	*/
	pvc_list_info.pvc_count=i;
	
}
int main(int argc, char **argv)
{
	int sock_id;
	struct atmif_sioc atmioc;

	openlog("SARDOING", LOG_NDELAY, LOG_DAEMON);
   if ((argc != 2) && (argc != 7)) 
   {
	show_usage();
	return -EINVAL;
   }
   else 
   {	
	if (argc == 2)
	{
		int ioctl_ret;
		int command;
		pvc_table_list_t ioctl_ret_table_list;
		command = atoi(argv[1]);
		if ( command < 0 || command > 1 )
		{
			show_usage();
			return -EINVAL;
		}

		sock_id = socket(AF_ATMPVC,SOCK_DGRAM,ATM_AAL5);

		if (sock_id < 0)
		{
			fprintf(stdout,"Can not create ATM ioctl socket\n");
			return -ENODEV;
		}
		switch (command)
		{
			case 0:  /* ATM_SET_SCANPVC */
				syslog(LOG_INFO,"set scan pvc");
				fill_scanpvc_table(&atmioc);
				ioctl_ret = ioctl( sock_id, ATM_SET_SCANPVC, &atmioc);
				break;
			case 1: /* ATM_GET_SCANPVC */
				syslog(LOG_INFO,"get scan pvc");
				atmioc.number = 0;
				atmioc.length = sizeof(pvc_table_list_t);
				atmioc.arg = &ioctl_ret_table_list;

				ioctl_ret = ioctl( sock_id, ATM_GET_SCANPVC, &atmioc);
				if ( ioctl_ret != 0 )
				fprintf(stdout,"return in scanpvc %08x\n",ioctl_ret);
				else
				dump_get_scanpvc_result(atmioc.arg);
				break;
			default:
				break;
		}
		close(sock_id);	
	}
	else if (argc == 7)
	{
	        int ioctl_ret,oam_cmd_type;
		oamdatareq_t oamdatareq;
		oam_cmd_type = atoi(argv[1]);
	        oamdatareq.vpi = atoi(argv[2]);
	        oamdatareq.vci = atoi(argv[3]);
	        oamdatareq.f5  = atoi(argv[4]);
	        oamdatareq.endtoEnd =atoi(argv[5]);
	        oamdatareq.funcType =atoi(argv[6]);

		if (oam_cmd_type == 0)
		{
	        	if ( oamdatareq.vpi < 0 || oamdatareq.vpi > 255 || oamdatareq.vci < 0 || oamdatareq.vci > 65535 )
	        	{
	                	show_usage();
	                	return -EINVAL;
	        	}
	        	if ((oamdatareq.f5 != 0 && oamdatareq.f5 !=1 )||(oamdatareq.endtoEnd != 0 && oamdatareq.endtoEnd != 1))
	        	{
	               		show_usage();
	                	return -EINVAL;
	        	}
	        	if (oamdatareq.funcType < 0 || oamdatareq.funcType > 3)
	        	{
	        	        show_usage();
	               		return -EINVAL;
	        	}

		        atmioc.number = 0;
		        atmioc.arg = &oamdatareq;
	        	atmioc.length = sizeof(oamdatareq);
                                                                                                                                               
		        sock_id = socket(AF_ATMPVC,SOCK_DGRAM,ATM_AAL5);
		        if (sock_id < 0)
	       		{
	                	fprintf(stdout,"Can not create ATM ioctl socket\n");
	                	return -ENODEV;
	        	}
	        	ioctl_ret = ioctl( sock_id, ATM_SETOAM, &atmioc);
	        	//fprintf(stdout,"ioctl return value is %d \n",ioctl_ret);
	        	close(sock_id);
		}
		else 
		{
			fprintf(stdout,"GET OAM command is not support now..\n");
			show_usage();
		}
	}
   }
   return 0;
}

void fill_scanpvc_table(struct atmif_sioc* atmioc)
{
	Load_ScanPVC_Config();
	atmioc -> number = 0;
	atmioc -> length = sizeof(pvc_list_info);
	atmioc -> arg = &pvc_list_info;
}

void dump_get_scanpvc_result(pvc_table_list_t* dump_pvc_info_list)
{
	int i;
	uint16_t result; 
	FILE *f;
	openlog("SARDOING", LOG_NDELAY, LOG_DAEMON);
	fprintf(stdout,"Total available PVC table NUM %d\n",dump_pvc_info_list -> pvc_count);
	f=fopen("/var/tmp/scanpvc_result","w");
	if(f==NULL) return;
	for ( i=0; i<dump_pvc_info_list->pvc_count; i++ )
	{
		result = dump_pvc_info_list->pvc_table[i].result;
	
	//	fprintf(stdout,"VPI %d, VCI %02d result %04x\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci,dump_pvc_info_list->pvc_table[i].result);
	if (result & OAM_F5_VALID){
		syslog(LOG_INFO,"OAM F5 scanned");
		fprintf(stdout,"VPI %d VCI %02d OAM_F5_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	//	fprintf(f,"VPI %d VCI %02d OAM_F5_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & RFC2684B_LLC_VALID){
		syslog(LOG_INFO,"RFC2684B llc scanned");
		fprintf(stdout,"VPI %d VCI %02d RFC2684B_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	//	fprintf(f,"VPI %d VCI %02d RFC2684B_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & RFC2684B_VC_VALID){
		syslog(LOG_INFO,"RFC2684B vc scanned");
		fprintf(stdout,"VPI %d VCI %02d RFC2684B_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	//	fprintf(f,"VPI %d VCI %02d RFC2684B_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}

	if (result & DHCPC_LLC_VALID){
		syslog(LOG_INFO,"DHCP Client LLC scanned");
		fprintf(stdout,"VPI %d VCI %02d DHCPC_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d DHCPC_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d DHCPC_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & DHCPC_VC_VALID){
		syslog(LOG_INFO,"DHCP Client VC scanned");
		fprintf(stdout,"VPI %d VCI %02d DHCPC_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d DHCPC_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d DHCPC_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & PPPOE_LLC_VALID){
		syslog(LOG_INFO,"PPPoE LLC scanned");
		fprintf(stdout,"VPI %d VCI %02d PPPOE_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d PPPOE_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d PPPOE_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & PPPOE_VC_VALID){
		syslog(LOG_INFO,"PPPoE VC scanned");
		fprintf(stdout,"VPI %d VCI %02d PPPOE_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		//fprintf(f,"VPI %d VCI %02d PPPOE_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}	
	if (result & PPPOA_LLC_VALID){
		syslog(LOG_INFO,"PPPoA LLC scanned");
		fprintf(stdout,"VPI %d VCI %02d PPPOA_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		//fprintf(f,"VPI %d VCI %02d PPPOA_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		//DPRINTF("VPI %d VCI %02d PPPOA_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & PPPOA_VC_VALID){
		syslog(LOG_INFO,"PPPoA VC scanned");
		fprintf(stdout,"VPI %d VCI %02d PPPOA_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d PPPOA_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d PPPOA_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & FIXIP_2684B_LLC_VALID){
		syslog(LOG_INFO,"FixIP llc scanned");
		fprintf(stdout,"VPI %d VCI %02d FIXIP_2684B_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d FIXIP_2684B_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d FIXIP_2684B_LLC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	if (result & FIXIP_2684B_VC_VALID){
		syslog(LOG_INFO,"FixIP vc scanned");
		fprintf(stdout,"VPI %d VCI %02d FIXIP_2684B_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		fprintf(f,"VPI %d VCI %02d FIXIP_2684B_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
		DPRINTF("VPI %d VCI %02d FIXIP_2684B_VC_VALID\n",dump_pvc_info_list -> pvc_table[i].vpi,dump_pvc_info_list->pvc_table[i].vci);
	}
	}
	fclose(f);
}


void show_usage(void)
{
      fprintf(stdout,"Usage : sardoing [scanpvc/getpvc]  0 for scanpvc, 1 for getpvc\n");

      fprintf(stdout,"Usage : sardoing [setoam/getoam] [vpi] [vci] [f4/f5] [end to end] [function type]\n");
      fprintf(stdout,"setoam/getoam : 0 for setoam, 1 for get oam\n");
      fprintf(stdout,"vpi   : vpi number(0-255)\n");
      fprintf(stdout,"vci   : vci number(0-65535)\n");
      fprintf(stdout,"f4/f5 : 0 for OAM F4, 1 for OAM F5\n");
      fprintf(stdout,"end to end    : 0 for segment to segment, 1 for end to end\n");
      fprintf(stdout,"Function type : 0 for OAM_AIS, 1 for OAM_RDI, 2 for OAM_LOOPBACK, 3 for OAM_CC\n");
}


