#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

int main(int argc, char *argv[])
{
  int rx_fd, tx_fd;
  char buf[255];
  int rc;
  fd_set rfds;
  int selrc;
  char *rx_pipe;
  char *tx_pipe;

  rx_pipe = (char *)malloc(strlen(argv[argc - 1]) + 4);
  sprintf(rx_pipe, "%s_rx", argv[argc - 1]);

  tx_pipe = (char *)malloc(strlen(argv[argc - 1]) + 4);
  sprintf(tx_pipe, "%s_tx", argv[argc - 1]);

  rx_fd = open(rx_pipe, O_RDWR | O_NONBLOCK);
  if (rx_fd == -1)
    {
      perror("open rx pipe");
      /* return -1;*/
      /* opening read-only */
      printf("Opening for read-only\n");
    }

  tx_fd = open(tx_pipe, O_RDWR | O_NONBLOCK);
  if (tx_fd == -1)
    {
      perror("open tx pipe");
      if (rx_fd != -1)
	{
	  close(rx_fd);
	}
      return -1;
    }

  while (1)
    {
      FD_ZERO(&rfds);
      if (rx_fd != -1)
	{
	  FD_SET(0, &rfds);
	}
      FD_SET(tx_fd, &rfds);

      selrc = select(tx_fd + 1, &rfds, NULL, NULL, NULL);
      /* Don't rely on the value of tv now! */
      if (selrc == -1)
	{
	  perror("select");
	  return -1;
	}
      if (rx_fd != -1)
	{
	  if (FD_ISSET(0, &rfds))
	    {
	      /* read from serial */
	      rc = read(0, buf, 255);
	      if (rc == -1)
		{
		  perror("read from stdin");
		  return -1;
		}
	      buf[rc] = '\0';
	
	      /* write to pipe */
	      rc = write(rx_fd, buf, strlen(buf));
	      if (rc == -1)
		{
		  perror("write to rx pipe");
		  return -1;
		}
	    }
	}
      if (FD_ISSET(tx_fd, &rfds))
	{
	  /* read from pipe */
	  rc = read(tx_fd, buf, 255);
	  if (rc == -1)
	    {
	      perror("read from tx pipe");
	      return -1;
	    }
	  buf[rc] = '\0';

	  /* write to serial */
	  rc = write(1, buf, strlen(buf));
	  if (rc == -1)
	    {
	      perror("write to stdout");
	      return -1;
	    }
	}
    }

  if (rx_fd != -1)
    {
      close(rx_fd);
    }
  close(tx_fd);

  return 0;
}
