#!/bin/sh
. /etc/scripts/sysdef
. $sys_status
cat /flash/dhcpd.conf |
read text;
case "$text" in
	\#:1:) 
		DHCP="yes"
		;;
	\#:2:) 
		DHCP="relay"
		;;
	*) 
		DHCP="no"
		;;
esac

case "$DHCP" in 
	yes)
		case "$1" in
  		start)
			echo "DHCPD start"
			echo "" > /var/dhcp/dhcpd.leases
 			if [ -f /proc/driver/br0 ]; then
       			/bin/dhcpd -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases br0 &
			else
        		/bin/dhcpd -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases $ETH0 &
			fi
			;;
  		stop)
  			echo "DHCPD stop"
			kill -9 `pidof dhcpd`
			kill -9 `pidof dhcrelay`
	    		;;
  		restart)
  			$0 stop
  			$0 start
  			;;
		esac
		;;

	relay)
		case "$1" in
  		start)
			echo "DHCPD Relay start"
		        if [ -f /proc/driver/br0 ]; then
                		/bin/dhcrelay -d -i br0 `cat /flash/dhcprelay.conf` &
			else
		                /bin/dhcrelay -d -i $ETH0 `cat /flash/dhcprelay.conf` &
			fi
			;;
  		stop)
  			echo "DHCPD Replay stop"
			kill -9 `pidof dhcpd`
			kill -9 `pidof dhcrelay`
	    		;;

  		restart)
  			$0 stop
  			$0 start
  			;;
		esac
		;;

	no)
		if [ "$1" = "stop" -o "$1" = "restart" ] ; then
				kill -9 `pidof dhcpd`
				kill -9 `pidof dhcrelay`
		fi
		;;
esac
