		iptables -t nat -N HCK_PRT
		iptables -N HCK_INP
		iptables -N HCK_FWD
		iptables -N bad-ping

		iptables -t nat -I PREROUTING -j HCK_PRT
		iptables -I INPUT -j HCK_INP
		iptables -I FORWARD -j HCK_FWD

		#Ping of Death       <ICMP>
		iptables -A bad-ping -p icmp --icmp-type echo-request -m limit --limit 1/s -j RETURN
		iptables -A bad-ping -p icmp -j LOG --log-level 7 --log-prefix "HackAttack:5"
		iptables -A bad-ping -p icmp -j REJECT
		iptables -I INPUT -p icmp --icmp-type echo-request -m state --state NEW -j bad-ping

		#stealth mode for www.grc.com and scan.sygate.com
		iptables -t nat -A HCK_PRT -m state --state NEW -p tcp -d $WAN_IP --dport 0:1055 -j DROP
		iptables -A HCK_INP -m state --state NEW -p tcp -d $WAN_IP --dport 0:1055 -j DROP
		iptables -t nat -A HCK_PRT -m state --state NEW -p udp -d $WAN_IP --dport 0:1055 -j DROP
		iptables -A HCK_INP -m state --state NEW -p udp -d $WAN_IP --dport 0:1055 -j DROP
		iptables -t nat -A HCK_PRT -m state --state NEW -p tcp -d $WAN_IP -m multiport --dports 1080,1720,5000,8080 -j DROP
		iptables -A HCK_INP -m state --state NEW -p tcp -d $WAN_IP  -m multiport --dports 1080,1720,5000,8080 -j DROP
		iptables -t nat -A HCK_PRT -m state --state NEW -p udp -d $WAN_IP -m multiport --dports 1080,1720,5000,8080 -j DROP
		iptables -A HCK_INP -m state --state NEW -p udp -d $WAN_IP  -m multiport --dports 1080,1720,5000,8080 -j DROP
		#SPI protections --Drop packets with illegal flag combinations
		iptables -A HCK_INP -m state --state INVALID -j LOG --log-level 7 --log-prefix "HackAttack:16"
		iptables -t nat -A HCK_PRT -m state --state INVALID -j LOG --log-level 7 --log-prefix "HackAttack:16"
		iptables -A HCK_FWD -m state --state INVALID -j LOG --log-level 7 --log-prefix "HackAttack:16"
		iptables -A HCK_INP -m state --state INVALID -j DROP
		iptables -t nat -A HCK_PRT -m state --state INVALID -j DROP
		iptables -A HCK_FWD -m state --state INVALID -j DROP
		#Reject connections from WAN to local interface
		iptables -A HCK_INP -d 127.0.0.0/8 -j REJECT
		#Drop pings headed for the LAN
		iptables -A HCK_FWD -p icmp --icmp-type echo-request -o $LAN_IF -j DROP
		#Drop Trojan Scan         <TCP>
		iptables -t nat -A HCK_PRT -p tcp -m multiport --dports 1243,1999,6776,7789,31337,54320,54321 -j LOG --log-level 7 --log-prefix "HackAttack:15"
		iptables -A HCK_INP -p tcp -m multiport --dports 1243,1999,6776,7789,31337,54320,54321 -j LOG --log-level 7 --log-prefix "HackAttack:15"
		iptables -t nat -A HCK_PRT -p tcp -m multiport --dports 1243,1999,6776,7789,31337,54320,54321 -j DROP
		iptables -A HCK_INP -p tcp -m multiport --dports 1243,1999,6776,7789,31337,54320,54321 -j DROP
		#Drop Back Orifice Scan   <UDP>
		iptables -t nat -A HCK_PRT -p udp --dport 31337  -j LOG --log-level 7 --log-prefix "HackAttack:14"
		iptables -A HCK_INP -p udp --dport 31337  -j LOG --log-level 7 --log-prefix "HackAttack:14"
		iptables -t nat -A HCK_PRT -p udp --dport 31337  -j DROP
		iptables -A HCK_INP -p udp --dport 31337  -j DROP
		#Drop Net Bus Scan        <TCP>
		iptables -t nat -A HCK_PRT -p tcp -m multiport --dports 12345,12346,23456 -j LOG --log-level 7 --log-prefix "HackAttack:13"
		iptables -A HCK_INP -p tcp -m multiport --dports 12345,12346,23456 -j LOG --log-level 7 --log-prefix "HackAttack:13"
		iptables -t nat -A HCK_PRT -p tcp -m multiport --dports 12345,12346,23456 -j DROP
		iptables -A HCK_INP -p tcp -m multiport --dports 12345,12346,23456 -j DROP
		#Drop IMAP SYN/FIN Scan   <TCP>
		iptables -t nat -A HCK_PRT -p tcp -m multiport --sports 0,65535 -m multiport  --dport 143 --tcp-flags SYN,FIN SYN,FIN  -j LOG --log-level 7 --log-prefix "HackAttack:12"
		iptables -A HCK_INP -p tcp -m multiport --sports 0,65535 -m multiport --dport 143  --tcp-flags SYN,FIN SYN,FIN  -j LOG --log-level 7 --log-prefix "HackAttack:12"
		iptables -t nat -A HCK_PRT -p tcp -m multiport --sports 0,65535 -m multiport  --dport 143 --tcp-flags SYN,FIN SYN,FIN  -j DROP
		iptables -A HCK_INP -p tcp -m multiport --sports 0,65535 -m multiport  --dport 143 --tcp-flags SYN,FIN SYN,FIN  -j DROP
		#Drop WinNuke Attack         <TCP>
		iptables -t nat -A HCK_PRT -p tcp --dport 135  -j LOG --log-level 7 --log-prefix "HackAttack:10"
		iptables -t nat -A HCK_PRT -p tcp --dport 137:139  -j LOG --log-level 7 --log-prefix "HackAttack:10"
		iptables -A HCK_INP -p tcp --dport 135  -j LOG --log-level 7 --log-prefix "HackAttack:10"
		iptables -A HCK_INP -p tcp --dport 137:139  -j LOG --log-level 7 --log-prefix "HackAttack:10"
		iptables -t nat -A HCK_PRT -p tcp --dport 135  -j DROP
		iptables -t nat -A HCK_PRT -p tcp --dport 137:139  -j DROP
		iptables -A HCK_INP -p tcp --dport 135  -j DROP
		iptables -A HCK_INP -p tcp --dport 137:139  -j DROP
		#TCP XMAS Scan       <TCP>
		iptables -t nat -A HCK_PRT -p tcp --tcp-flags ALL ALL -j LOG --log-level 7 --log-prefix "HackAttack:9"
		iptables -A HCK_INP -p tcp --tcp-flags ALL ALL -j LOG --log-level 7 --log-prefix "HackAttack:9"
		iptables -t nat -A HCK_PRT -p tcp --tcp-flags ALL ALL -j DROP
		iptables -A HCK_INP -p tcp --tcp-flags ALL ALL -j DROP
		#TCP Null Scan       <TCP> (possible, still need to check if tcp-seq=0)
		iptables -t nat -A HCK_PRT -p tcp --tcp-flags ALL NONE -j LOG --log-level 7 --log-prefix "HackAttack:6"
		iptables -A HCK_INP -p tcp --tcp-flags ALL NONE -j LOG --log-level 7 --log-prefix "HackAttack:6"
		iptables -t nat -A HCK_PRT -p tcp --tcp-flags ALL NONE -j DROP
		iptables -A HCK_INP -p tcp --tcp-flags ALL NONE -j DROP
		#Drop Snork               <UDP>
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,19,135 -m multiport   --dport 135 -j LOG --log-level 7 --log-prefix "HackAttack:3"
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,19,135 -m multiport   --dport 135 -j LOG --log-level 7 --log-prefix "HackAttack:3"
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,19,135 -m multiport   --dport 135 -j DROP
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,19,135 -m multiport   --dport 135 -j DROP
		#UDP Port LoopBack   <UDP>
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  7 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  7 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  7 -j DROP
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  7 -j DROP
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport 17 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  17 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  17 -j DROP
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  17 -j DROP
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  19 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  19 -j LOG --log-level 7 --log-prefix "HackAttack:2"
		iptables -t nat -A HCK_PRT -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  19 -j DROP
		iptables -A HCK_INP -p udp  -m multiport  --sports 7,17,19 -m multiport  --dport  19 -j DROP
		#Land Attack         <TCP>
		iptables -t nat -A HCK_PRT -s $WAN_IP -j LOG --log-level 7 --log-prefix "HackAttack:1"
		iptables -A HCK_INP -s $WAN_IP -j LOG --log-level 7 --log-prefix "HackAttack:1"
		iptables -t nat -A HCK_PRT -s $WAN_IP -j DROP
		iptables -A HCK_INP -s $WAN_IP -j DROP

