#!/bin/sh
. /etc/scripts/sysdef
. $sys_status
case "$1" in
	start)
		if [ -f /flash/remote_config.conf ]  ; then
			cat /flash/remote_config.conf|
			read Remote HttpPort;
			if [  "$Remote" = "0" ] ; then
				echo "Remote control start"
				iptables -I INPUT -i $WAN_IF -p tcp --dport $HttpPort -j DROP
				touch /var/state/remote_control.lock
			else
				echo "Remote control stop"
				iptables -I INPUT -i $WAN_IF -p tcp --dport $HttpPort -j ACCEPT
				touch /var/state/remote_control.lock
			fi
			
			#for lan web page access
			iptables -I INPUT -i $LAN_IF -p tcp --dport $HttpPort  -j ACCEPT
		fi
		;;
	stop)
		if [ -f /var/state/remote_control.lock ] ; then		
			iptables -D INPUT -i $LAN_IF -p tcp --dport $HttpPort -j DROP
			iptables -I INPUT -i $LAN_IF -p tcp --dport $HttpPort -j ACCEPT
			rm -f /var/state/remote_control.lock
		fi
		;;
	restart)
		$0 stop 
		$0 start 
		;;
esac

