#!/bin/sh
. /var/etc/status
cat /flash/dhcpd.conf |
read text;
case "$text" in
	\#:1:) 
		DHCP="yes"
		;;
	\#:2:) 
		DHCP="relay"
		;;
	*) 
		DHCP="no"
		;;
esac

case "$DHCP" in 
	yes)
		case "$1" in
  		start)
			if [ "$WAN" != "bridge" ] ; then
			echo "DHCPD start"
			echo -n > /var/dhcp/dhcpd.leases 
			echo -n > /var/dhcp/dhcpd.leases~ 
        		dhcpd $LAN_IF -d -cf /flash/dhcpd.conf -lf /var/dhcp/dhcpd.leases &
			fi
			;;
  		stop)
			if [ "$WAN" != "bridge" ] ; then
			echo "DHCPD stop"
			kill -9 `pidof dhcpd`
			kill -9 `pidof dhcrelay`
			echo -n > /var/dhcp/dhcpd.leases 
			echo -n > /var/dhcp/dhcpd.leases~ 
			fi
			;;
		esac
		;;

	relay)
		case "$1" in
  		start)
			if [ "$WAN" != "bridge" ] ; then
			echo "DHCPD Relay start"
			echo -n > /var/dhcp/dhcpd.leases 
			echo -n > /var/dhcp/dhcpd.leases~ 
		        dhcrelay -d -i $LAN_IF `cat /flash/dhcprelay.conf` &
			fi
			;;
  		stop)
			if [ "$WAN" != "bridge" ] ; then
  			echo "DHCPD Replay stop"
			kill -9 `pidof dhcpd`
			kill -9 `pidof dhcrelay`
			echo -n > /var/dhcp/dhcpd.leases 
			echo -n > /var/dhcp/dhcpd.leases~ 
			fi
			;;
		esac
		;;

	no)
		if [ "$1" = "stop" -o "$1" = "restart" ] ; then
				kill -9 `pidof dhcpd`
				kill -9 `pidof dhcrelay`
				echo -n > /var/dhcp/dhcpd.leases 
				echo -n > /var/dhcp/dhcpd.leases~ 
		fi
		;;
esac
