#!/bin/sh
# url filter
. /var/etc/status
#iptables -N URL_FLT
#iptables -N UF_REJ
iptables -I FORWARD -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP --dport 80 -j URL_FLT

# packet filter 
#iptables -N PKT_FLT
iptables -I FORWARD -j PKT_FLT

# mac filter
#iptables -N MF_FWD
#iptables -N MF_INT
iptables -I FORWARD -j MF_FWD
iptables -I INPUT -j MF_INT

# block wan 
#iptables -N BLK_WAN_FWD
#iptables -N BLK_WAN_INT
iptables -I FORWARD -j BLK_WAN_FWD
iptables -I INPUT -j BLK_WAN_INT

# block hacker attack
iptables -t nat -N HCK_PRT
#iptables -N HCK_INP
#iptables -N HCK_FWD
#iptables -N bad-ping
iptables -t nat -I PREROUTING -j HCK_PRT
iptables -I INPUT -j HCK_INP
iptables -I FORWARD -j HCK_FWD
iptables -I INPUT -p icmp --icmp-type echo-request -m state --state NEW -j bad-ping

# # all services will be started by their web config functions EXCEPT the ones specified here(Those are NO list in the config. files)
# remote config
#iptables -N REMOTE_INT
iptables -I INPUT -j REMOTE_INT
# 
# for lan web page access
#iptables -N LAN_ACCESS
iptables -I INPUT -j LAN_ACCESS

# if [ "$ROUTER" = "nat" ] ; then
iptables -t nat -N NAT_POSTRT
iptables -t nat -I POSTROUTING -j NAT_POSTRT

#iptables -N SIP_INT
iptables -A INPUT -j SIP_INT

iptables -t nat -N SIP_POSTRT
iptables -t nat -A POSTROUTING -j SIP_POSTRT

# dmz 
iptables -t nat -N DMZ_PRT
#iptables -N DMZ_FWD
iptables -t nat -I PREROUTING -j DMZ_PRT
iptables -I FORWARD -j DMZ_FWD

# virtual server
iptables -t nat -N VS_PRT
#iptables -N VS_FWD
iptables -t nat -I PREROUTING -j VS_PRT
iptables -I FORWARD -j VS_FWD

# upnp virtual server
iptables -t nat -N UPNP_PRT
#iptables -N UPNP_FWD
iptables -t nat -I PREROUTING -j UPNP_PRT
iptables -I FORWARD -j UPNP_FWD

# misc
#iptables -N MSS_FWD
iptables -t mangle -N MSS_MG_PRT
iptables -t mangle -N MSS_MG_POSTRT
#iptables -N MSS_OUT
#iptables -N MSS_INT
iptables -I FORWARD -j MSS_FWD
iptables -t mangle -I PREROUTING -j MSS_MG_PRT
iptables -t mangle -I POSTROUTING -j MSS_MG_POSTRT
iptables -I OUTPUT -j MSS_OUT
iptables -I INPUT -j MSS_INT

# upnp
#iptables -N UPNP_INT
iptables -I INPUT -j UPNP_INT

# snmpd
#iptables -N SNMP_INT
iptables -I INPUT -j SNMP_INT

# ripd
#iptables -N RIP_INT
iptables -I INPUT -j RIP_INT

