#!/bin/sh
. /etc/scripts/sysdef
. $sys_status

if [ -f /tmp/tmss_stat ] ; then
	case "$1" in
	start)
		iptables  -N TMSS
		iptables  -N TMSS_AVE
		iptables  -N TMSS_BLK
		iptables -A TMSS -z 115 -p tcp -m webstr --tmss 1 -j RETURN
		iptables -A TMSS -z 116 -p tcp -m webstr --tmss 2 -j TMSS_AVE
		iptables -A TMSS -z 117 -p tcp -m webstr --tmss 4 -j RETURN
		iptables -A TMSS -z 118 -p tcp -m webstr --tmss 8 -j TMSS_BLK
		iptables -A TMSS -z 119 -p tcp -j DROP
		#We take icmp-admin-prohibited as to send a TMSS REDIRECT page to client
		iptables  -A TMSS_AVE -z 120 -p tcp -j REJECT --reject-with icmp-admin-prohibited
		#check  in blocked cache  in REJECT.
		iptables  -A TMSS_BLK -z 121 -p tcp -j REJECT --reject-with icmp-host-prohibited
		cat /tmp/tmss_stat |
        	read a;
		
		if [ "$a" = "NO" ] ; then 
		echo "YES" > /tmp/tmss_stat
		tmHostent &
		tmdpd &
		tmAUChecker /flash/tm.conf &
		tmLicChk /flash/tm.conf  &
		fi
		iptables  -A FORWARD -z 122 -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP --dport 80 -j TMSS		
	;;
	stop)
		#We only stop the script which is done with iptables -X -F but keep the task working
		iptables  -D FORWARD -z 122 -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP --dport 80 -j TMSS		
		iptables  -F TMSS
		iptables  -F TMSS_AVE
		iptables  -F TMSS_BLK
		iptables  -X TMSS
		iptables  -X TMSS_AVE
		iptables  -X TMSS_BLK
	;;
	restart)
		$0 stop
		$0 start
	;;
	esac
fi

