#!/bin/sh
. /var/etc/status

cat /flash/wan.conf|
read wantypeline;
read routedline;
read bridgedline;
read pppoaline;
read ipoaline;
read pppoeline;

case "$1" in
	start)
		case "$2" in
		dynamic)
			echo "dhcp client start"
			echo 2 > /tmp/ppp/wan_connect_status
			kill -16 `pidof udhcpc`
			;;
		pppoe)
			echo "PPPoE start"
			echo 2 > /tmp/ppp/wan_connect_status
			Username=`echo $pppoeline | cut -f7 -d"|"`
			Password=`echo $pppoeline | cut -f8 -d"|"`
			Auth=`echo $pppoeline | cut -f11 -d"|"`
			Ondemand=`echo $pppoeline | cut -f12 -d"|"`
			IP=`echo $pppoeline | cut -f10 -d"|"`
			Idletime=`echo $pppoeline | cut -f13 -d"|"`
			MTU=`echo $pppoeline | cut -f15 -d"|"`
			kill -9 `pidof zebra`	
			PPPoEPID=`pidof pppoecd`
			if [ "$PPPoEPID" = "" ] ; then
				if [ "$Ondemand" = "0" ] ; then
					pppoecd nas0 -d -k -u $Username -p $Password -A $Auth -L $IP -t $MTU -I 30 -T 30 -N 10 &
				else
					pppoecd nas0 -d -k -u $Username -p $Password -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &
				fi	
			else		
			#	sleep 1
			#	ping 168.95.1.1
			touch /var/tmp/pppoestart
			kill -16 `pidof pppoecd`
			fi
			;;
		pppoa)
			echo "PPPoA start"
			echo 2 > /tmp/ppp/wan_connect_status
			kill -9 `pidof zebra`
			VPI=`echo $pppoaline | cut -f3 -d"|"`
			VCI=`echo $pppoaline | cut -f4 -d"|"`
			Encap=`echo $pppoaline | cut -f6 -d"|"`
			Username=`echo $pppoaline | cut -f8 -d"|"`
			Password=`echo $pppoaline | cut -f9 -d"|"`
			Auth=`echo $pppoaline | cut -f11 -d"|"`
			IP=`echo $pppoaline | cut -f10 -d"|"`
			MTU=`echo $pppoaline | cut -f15 -d"|"`
			sleep 3
			echo pppd -c 0 -l $Encap -a 0.$VPI.$VCI -k -u $Username -p $Password -A $Auth -L $IP -T $MTU
			pppd -c 0 -l $Encap -a 0.$VPI.$VCI -k -u $Username -p $Password -A $Auth -L $IP -T $MTU &
			;;
		esac
		;;	
	stop)
		case "$2" in
		dynamic)
			echo 3 > /tmp/ppp/wan_connect_status
			kill -17 `pidof udhcpc`
			echo 0 > /tmp/ppp/wan_connect_status
			;;
		pppoe)
			echo 3 > /tmp/ppp/wan_connect_status
			kill -15 `pidof zebra`
#			kill -15 `pidof pppoecd`
			touch /var/tmp/pppoestop
			kill -16 `pidof pppoecd`
			kill -9 `pidof fw.sh`
			route del default gw 0.0.0.0
			if [ -f /flash/ripd.conf ] ; then
			cat /flash/ripd.conf|
			read text;
				if [ "$text" = "!1" ] || [ "$text" = "!3" ] ; then
					kill -9 `pidof zebra`
					echo "ripd start"
					zebra &
					iptables -I INPUT -p udp -s $LAN_IP/$LAN_MASK --dport 520 -j ACCEPT
					iptables -I INPUT -p tcp -s $LAN_IP/$LAN_MASK --dport 2600 -j ACCEPT
				fi
			fi	
			echo 0 > /tmp/ppp/wan_connect_status
			echo 0 > /proc/GPIOUSER/pppled
			;;
		pppoa)
			echo 3 > /tmp/ppp/wan_connect_status
			kill -15 `pidof zebra`
			kill -15 `pidof pppd`
			kill -9 `pidof fw.sh`
#			route del default gw 0.0.0.0
			if [ -f /flash/ripd.conf ] ; then
			cat /flash/ripd.conf|
			read text;
				if [ "$text" = "!1" ] || [ "$text" = "!3" ] ; then
					kill -9 `pidof zebra`
					echo "ripd start"
					zebra &
					iptables -I INPUT -p udp -s $LAN_IP/$LAN_MASK --dport 520 -j ACCEPT
					iptables -I INPUT -p tcp -s $LAN_IP/$LAN_MASK --dport 2600 -j ACCEPT
				fi
			fi	
			echo 0 > /tmp/ppp/wan_connect_status
			echo 0 > /proc/GPIOUSER/pppled
			;;
		esac
		;;
	restart)
		$0 stop
		$0 start $2
		;;
esac
