#include <stdlib.h>
#include <stdio.h>
  
int dump(unsigned long addr, unsigned long len)
{
	register int n, m, c, r;
	unsigned char temp[16];
		
	for( n = len; n > 0; ){
			printf("%.8x", addr);
			putchar(' ');
			r = n < 16? n: 16;
			memcpy((void *) temp, (void *) addr, r);
			addr += r;
			for( m = 0; m < r; ++m ){
					putchar((m & 3) == 0 && m > 0? '.': ' ');
					printf("%.2x", temp[m]);
			}
			for(; m < 16; ++m )
					printf("   ");
			printf("  |");
			for( m = 0; m < r; ++m ){
				c = temp[m];
				putchar(' ' <= c && c <= '~'? c: '.');
			}
			n -= r;
			for(; m < 16; ++m )
					putchar(' ');
			printf("|\n");
	}
	
	return 0;
}

int doSys(int argc, char **argv) 
{
	unsigned long *ptr;
	unsigned long value;
	
	if (argc < 3) {
		printf("sys command error.\n");
		return 0;
	}

	if (strcmp(argv[1], "memrl") == 0) {
		ptr = (unsigned long *)strtoul(argv[2], NULL, 16);
		printf("\r\n<Address>\t<Value>\r\n");
		printf("0x%08lx\t0x%08x\r\n", ptr, *ptr);
	} else if (strcmp(argv[1], "memwl") == 0) {
		ptr = (unsigned long *)strtoul(argv[2], NULL, 16);
		value = (unsigned long)strtoul(argv[3], NULL, 16);
		*ptr = value;
	} else if (strcmp(argv[1], "memory") == 0) {
		unsigned long addr, len;

		addr = strtoul(argv[2], NULL, 16);
		len = strtoul(argv[3], NULL, 16);
		dump(addr, len);
	}
}

int main(int argc, char **argv) 
{
	FILE *proc_file;
	char cmd[80];
	const char *s;
	const char *applet_name;
	int i;

	applet_name = argv[0];

	for (s = applet_name; *s != '\0';) {
		if (*s++ == '/')
			applet_name = s;
	}

	if (strcmp(applet_name, "sys") == 0) {
		doSys(argc, argv);
		return 0;
	}

	strcpy(cmd, applet_name);
	for (i = 1; i < argc; i++) {
		strcat(cmd, " ");
		strcat(cmd, argv[i]);
	}

    proc_file = fopen("/proc/tc3162dmt/adsl_cmd", "w");
	if (!proc_file) {
		printf("open /proc/tc3162dmt/adsl_cmd fail\n");
		return 0;
	}
        //printf("cmd=%s\n",cmd);
	fprintf(proc_file, "%s", cmd);
	fclose(proc_file);

	return 0;
}
