/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file   TmCommon.h
 *  @brief  This file defines the source ID for error code structure for this 
 *          project.  It originate from IMSS project. 
 */

/*
 *  Change Log
 *  2004-02-14  Jeremy  initial version
 */
#ifndef _TM_COMMON_H_
#define _TM_COMMON_H_

/*******************/
/*  Include files  */
/*******************/

/**
 * We do not use the whole unicode definition from ICU package,
 * just define some primitive data type for our program use
 */
//#include <unicode/utypes.h>
#include "TmDataType.h"

/***********************/
/*  Macro definitions  */
/***********************/

#include "TmMacros.h"

/****************************/
/*  Module ID declarations  */
/****************************/

enum TmModuleID {
  TM_MODULE_ID_UNKNOWN      = 0x00,
  TM_MODULE_ID_MESSAGE      = 0x01,
  TM_MODULE_ID_POLICY       = 0x02,
  TM_MODULE_ID_SCAN         = 0x03,
  TM_MODULE_ID_ADAPTER      = 0x04,
  TM_MODULE_ID_ACL          = 0x05,
  TM_MODULE_ID_FILTER_EMGR  = 0xD1,
  TM_MODULE_ID_FILTER_VSAPI = 0xD2,  /* above are old definition from IMSS project */ 
  TM_MODULE_ID_AU_INFO      = 0xE0,
  TM_MODULE_ID_CLIENTINFO   = 0xE1,
  TM_MODULE_ID_AVENFORCER   = 0xE2,
  TM_MODULE_ID_LIMIT
};

/**************************/
/*  Error/condition code  */
/**************************/

#include "TmErrors.h"

/* Add other types we might define ourselves here. */

#endif /* _TM_COMMON_H_ */









