/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @file tmSignalHandler.c
 *  @brief TMOG Discovery Module - Signal Handler
 */

/*
 *  Change Log
 *  2004-02-19 Jim Wu    Initial Version
 */

#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include "tmdpCommonDef.h"  /* common type define */
#include "log.h"
#include "tmSignalHandler.h"
#include "tmPidUtil.h"

int g_nAvf = 0; /* signal for AVEnforcer */
int Child_Process(void);

static const char ModuleName[]="signalhandler";


static void Signal_Child(int signo)
{
    pid_t pid;
    int status;    
    
    if (signo == SIGCHLD)
    {
        /* LOGDEBUG("got SIGCHILD\n");*/
    }    
    
    while((pid=waitpid(-1, &status, WNOHANG))>0)
    {    
    }    
}

static void SignalHandler(int sig)
{
    /* receive signal, check if signal is from Request Interface */		
	
    /* signal is from Request Interface */    
    
    
    if (sig == SIGUSR1)
    {
       LOGDEBUG("got SIGUSR1 for terminating\n");
       remove_pid(TempPIdPath);		
       exit(0);
    }
	
    else if (sig == SIGUSR2)
    {			
         LOGDEBUG("Got Signal2 \n");
        /* SIGUSER2 is the user predefine signal type, passed from request interface
           which is used to trigger the discovery daemon */         
        g_nAvf = 1;				
    }	        
    else
    {
        LOGDEBUG("Got Signal%d \n", sig);       
    }
}

int DiscoveryDaemon(void)
{	
    signal(SIGUSR1, SignalHandler);	
    signal(SIGUSR2, SignalHandler);	
    signal(SIGCHLD, Signal_Child);	    
	
    while (1)
    {		
      //since it is from kernel, so we do not send kill signal from kernel.
      //if (g_nAvf)
       {
           //got signal from avenforcer 
 	  Child_Process();  		
       }		
       
       g_nAvf = 0;
        
//	   sleep(100);
        sleep(1);// want is the period that we have to check if SIGUSER2 which is the user predefine signal 
	// type, passed from request interface, is used to trigger the discovery daemon?  maybe 5 seconds??
    }
	
    return PARENT_PROCESS;	
}

int SetupPIdTemp(void)
{
    if (write_pid(TempPIdPath) == 0)
    {
        LOGERROR("ERROR! writing temp file %s, You need root permision !\n", TempPIdPath);
        return FAIL;
    }
    
    return NO_ERROR;
}
