/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @pccipc.h
 *  @
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */

#ifndef PCC_IPC_H
#define PCC_IPC_H

typedef struct 
{
	char szMagicNumber[4];
	char szMajorVersion[1];
	char szMinorVersion[1];
	char szCommandType[2];
	char szLength[2];
	char szReserved[2];
}DP_MSG_HEADER; /* size is 12 */

typedef struct 
{
	char szCompID[2];
	char szLength[2];
	char szIPAddr[16];
	char szNodeName[32];
	char szNodeId[32];
	char szReserved[32];
	char szP2PProtocol[2]; /* no use */
	char szP2PPort[2];     /* no use */
	char szPlatformId[4];  /*	Unknown is 0,	Windows is 0x1	Linux is 0x2 */
	char szPlatformInfo[16]; /* variable for IHV */
	char szProductId[8];  /* 0x2 here for TMSS */
	/* The rest 128 bytes are Product Information,*/
	char szBoxId[16];		
	char szVenderId[16];	
	char szAUProductId[4];	 /*TMSS should use 0x0 */
	char szProductVer[16];	/* for PCC */
	char szEngineId[4];		/* TMSS use 0x0 */
	char szEngineVer[16];   /* TMSS fill 0x0  */
	char szPatternNum[12];  /* TMSS fill 0x0  */
	char szReserved2[44];	
}DP_RESPONSE_MSG_COMP;  /* size is 276 */


typedef struct 
{
	char szCompID[8];
}DP_COMP_INFO;

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* LOG_H */
