/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @SimReq.c
 *  @
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include "tmdpCommonDef.h"  /* common type define */
#include "tmnfRequestInterface.h"

int main(int argc, char *argv[])
{	
   if (argc < 2) /* use argument for temporary use, will be removed later */
   {  
       printf("Usage: %s [options] <ip>, options = -q, -d, -n\n", argv[0]);
       exit(1);
   }		  	    	    
  
   if (strcmp(argv[1], "-q") == 0)
   {
  	   tmnf_TerminateDaemon();
  	   return 0;
   }  
   else if (strcmp(argv[1], "-d") == 0)
   {
       __u32 nIP = 0;  	
       int nRet;
    
       if (argc != 3) /* use argument for temporary use, will be removed later */
	   {  
	       printf("Usage: %s [options] <ip>, options = -q, -d, -n\n", argv[0]);
  	       exit(1);
	   }		  	    	    
		        
	   inet_pton(AF_INET, argv[2], &nIP);    	    
		    	
	   /* just call Notification Interface to update client information */	
	
	   nRet = tmnf_UpdateClientInfo(nIP); 
	
	   if (nRet == -1)
	   {
		   /* there is error */
	   }	
	}
	else if (strcmp(argv[1], "-n") == 0)
    {  
       __u32 nIP = 0;	
       int nRet;
       if (argc != 3) /* use argument for temporary use, will be removed later */
       {  
	       printf("Usage: %s [options] <ip>, options = -q, -d, -n\n", argv[0]);
           exit(1);
	   }		  	    	    
		        
	   inet_pton(AF_INET, argv[2], &nIP);    	    
		    	
	   /* just call Notification Interface to update client information */	
		
	   nRet = tmnf_UpdateClientPattern(nIP); 
	   
	   if (nRet == -1)
	   {
		   /* there is error */
	   }	
	}
	
	return 0;		  
}
