/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @conn.h
 *  @
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */

#ifndef CONN_HEADER
#define CONN_HEADER

#include <stdio.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>

#ifdef __cplusplus
extern "C"
{
#endif

    typedef struct conn_st *conn_t;
 //   typedef struct connpool_st *connpool_t;

    /* conn_handler_t:
     *   ret: >=0: ret bytes processed, continue process
     *        ==-1: terminate
     *        <=-2: abort
     *   conn: 
     *   p:    begin of buffer
     *   e:    end of buffer
     */
    typedef int (*conn_handler_t)(conn_t conn, unsigned char *p, unsigned char *e);
//#define CONN_BUF_SIZE   (32768)
//#define CONN_BUF_SIZE   (3072)

    struct conn_st
    {
         int          sd;
        unsigned short            index;// connection index in the array
		 unsigned short  assoHttp;
#define CONN_IS_FREE 0
#define CONN_CLIENT 1
#define CONN_SERVER 2		
		unsigned short   conn_type;
     // unsigned char  buf[32768];
      //  unsigned char  buf[CONN_BUF_SIZE];
      //  int            size;
      //  int            less;
      //  unsigned char *pbuf;
      //  unsigned char *ebuf;
        /* flag to indicate if the buffer is full */
     //   int            buf_full; /* cheton.20021007: handle buffer full */
      //  struct in_addr sockaddr; /* cheton.20031127: get the socket address/port */
         struct in_addr peeraddr; /* cheton.20031127: get the peer address/port */
      	//unsigned short sockport;
      //   unsigned short peerport;always 80

   //     conn_handler_t handler;
        //void          *arg;
		//http_t*   arg;
    /*    enum {
            conn_req_wait_crlf,
            conn_req_wait_size,
        } req_type;
        int req_size; */
		
		conn_t nextConn;
 
       // connpool_t connpool;
    };

    /***************************************************************************
     * tmConnInit(): initialize conn_t and allocate resources
     * Parameters:
     *     conn_t *conn: OUT : pointer to conn_t
     * Return:
     *     0: success
     *    <0: failed
     **************************************************************************/
conn_t tmConnInit(unsigned short conn_type);

    /***************************************************************************
     * tmConnFini(): close conn_t and release resource
     * Parameters:
     *     conn_t *conn: IN/OUT : pointer to conn_t obtained by tmConnInit()
     * Return:
     *     0: success
     **************************************************************************/
    int tmConnFini(int k);
void connFree(int k);

    /****f* conn/conn_less() ***************************************************
     * NAME
     *     conn_less()
     * SYNOPSIS
     *     int conn_less(conn_t *conn, int n);
     * DESCRIPTION
     *     Returns all but the first n characters of the current token back to
     *     the input stream.
     * PARAMETERS
     *     conn_t *conn: IN : connection handle
     *     int n: IN : number of characters to ?skip?
     * RETURN VALUE
     *     >=0: success
     *      <0: failed
     * SEE ALSO
     *     tmConnInit()
     **************************************************************************/
#define conn_less(conn, n)        {(conn)->less=n; }

void conn_set_sd(conn_t conn,int s);      

#define conn_set_handler(conn, h) {(conn)->handler=(h); }
#define conn_set_arg(conn, a)     {(conn)->arg=(a); }
#define conn_set_req_size(conn,s) {struct conn_st *_xc_=(conn); _xc_->req_type=conn_req_wait_size; _xc_->req_size=(s); }
#define conn_set_req_crlf(conn)   {(conn)->req_type=conn_req_wait_crlf; }

//#define conn_get_sd(conn)         ((conn)->sd)
//#define conn_get_sockaddr(conn)   ((conn)->sockaddr)
//#define conn_get_sockport(conn)   (ntohs((conn)->sockport))
//#define conn_get_peeraddr(conn)   ((conn)->peeraddr)
//#define conn_get_peerport(conn)   (ntohs((conn)->peerport))
//#define conn_get_handler(conn)    ((conn)->handler)
//#define conn_get_arg(conn)        ((conn)->arg)

//#define conn_get_connpool(conn)   ((conn)->connpool)

#define POLL_TIMEOUT    100         /* POLL timeout (seconds) */


 /*   int tmConnPoolInit(connpool_t *connpool);
    int tmConnPoolFini(connpool_t *connpool);
    int connpool_loop(connpool_t connpool);
    int tmConnPoolInsertConn(connpool_t connpool, conn_t conn);
    int connpool_remove_conn(connpool_t connpool, conn_t conn);
*/
#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
