/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @ht_tok.h
 *  @parsing token utility. ( for HTTP header only )
 */

/*
 *  Change Log
 *  2001-08-07 Kenneth Kuo  Initialization version
 */

#ifndef _HT_TOKHEADER_FILE_
#define _HT_TOKHEADER_FILE_

#include <stdio.h>

#ifdef  __cplusplus
extern "C"
{
#endif

    struct ht_tok_st
    {
        enum {
            HT_QS=0,
            HT_TOKEN,
            HT_SEP,
            HT_CMT,
            HT_CRLF,
            HT_LWS,
            HT_UNKNOWN
        } type;

        const char *p;
        const char *e;
    };

    /*                                                                         *
     * get token of HTTP header.                                               * 
     *                                                                         * 
     * MARK: 1.You MUST feed a block without broken token.                     * 
     *                                                                         * 
     *       2.How to define end pointer ?                                     * 
     *         If feeding block is ABCDE, end should be like below.            * 
     *                                                                         * 
     *             pbuf                                                        * 
     *              |                                                          * 
     *        xxxxxxABCDExxxxxx                                                * 
     *                   |                                                     * 
     *                  end                                                    * 
     *                                                                         * 
     * RETURN:   0    -> get token successfully.                               * 
     *           < 0  -> indicate error.                                       * 
     *                                                                         */
    int ht_tok_get(struct ht_tok_st *tok, const char **pbuf, const char *end);
    const char *ht_tok_typename(struct ht_tok_st *tok);

#ifdef __cplusplus
}
#endif

#endif /* _HT_TOKHEADER_FILE_ */
