/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @http_buffer.h
 *  @HTTP Message Buffering
 */

/*
 *  Change Log
 *  2002-10-02 Cheton Wu    Initialization version
 */


#ifndef HTTP_BUFFER_HEADER
#define HTTP_BUFFER_HEADER

#ifdef __cplusplus
extern "C"
{
#endif

    /* initial 4K byte buffer */
#define HTTP_BUFFER_SIZE    (4096)

    typedef struct http_buffer_st
    {
        size_t size;
        size_t capacity;
        void* buffer;
    }
    http_buffer_t;

    int http_buffer_init(struct http_buffer_st* http_buffer);
    int http_buffer_rset(struct http_buffer_st* http_buffer);
    int http_buffer_append(struct http_buffer_st* http_buffer, char *ptr, size_t size);
    int http_buffer_resize(struct http_buffer_st* http_buffer, size_t size);
    int http_buffer_size(struct http_buffer_st* http_buffer);
    int http_buffer_capacity(struct http_buffer_st* http_buffer);
    int http_buffer_realloc(struct http_buffer_st* http_buffer, size_t capacity);
    int http_buffer_fini(struct http_buffer_st* http_buffer);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif

