/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file thpd.c
 *  @brief TMOG HTTP Proxy Module - main
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <locale.h>
#include <libintl.h>
//#define	TCP_MAXSEG	 2	/* Set maximum segment size  */
#define IP_REDIRECT
#ifdef  IP_REDIRECT
#include <limits.h>
#include <linux/netfilter_ipv4.h>
#endif
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>

#include "adsl_line_mon.h"

/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

#define PIDFILE             "/var/run/adsl_mon.pid"

//static int gnURLFilterLicChkInterval = 86400;

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/



static volatile int GO_HELL=0;


static const char ModuleName[]="adsl_mon";


static void sig_hup(int signo)
{
} 


/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

static void go_hell_handler(int signo)
{
    GO_HELL=1;
}

#define   BUFFER 255 
#define   PERM S_IRUSR|S_IWUSR 
 /*
struct msgtype { 
 long mtype; 
 char buffer[BUFFER+1]; 
 }
 
*/

int main(int argc, char *argv[])
{

    int msgid; 
    URL_REQUEST_MESSAGE_ITEM QueueItem,* pQueueItem=&QueueItem;


    { /* monitor for config reload signal */
        if(SIG_ERR==signal(SIGHUP, sig_hup))
        {
            fprintf(stderr,"signal: %m\n");
           return 1;
        }
    }

 

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGTERM, go_hell_handler))
        {
            fprintf(stderr,"signal: %m\n");
            return 1;
        }
    }

    LOGDEBUG("hook SIGINT");
    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGINT, go_hell_handler))
        {
            fprintf(stderr,"signal: %m\n");
            return 1;
        }
    }
   

    write_pid(PIDFILE);

    //getHostByNameForFilterHost();
	


   if((msgid=msgget((key_t)ADSL_LINE_MONITOR_SHARE_KEY,PERM|IPC_CREAT|IPC_EXCL))==-1) 
    { 
	    fprintf(stderr,"Creat Message Queue  Error:%s\a\n",strerror(errno)); 
	    return -1; 
    } 
   LOGDEBUG("begin service loop");
 
   for(;GO_HELL==0;)
	{

		//Read the message cache. Check if any one need to send URL request to survel. server
		/* need to retrieve item from the queue */
		//Search the whole urlIrq Shared Memory to see if any url need to serve
   //LOGDEBUG("going to read msg from msgq,");
		msgrcv(msgid,pQueueItem,sizeof(URL_REQUEST_MESSAGE_ITEM)-sizeof(long),1,0); 
 	//	msgrcv(msgid,&a,10,1,0); 
    //LOGDEBUG("read msg from msgq,mtype=%d,pQueueItem->commandType=%x",pQueueItem->mtype,pQueueItem->commandType);
//   LOGDEBUG("read msg from msgq,mtype=%d, ddata=%s",a.mtype,a.t);
		
		if(KERNEL_TO_THPD_CMD_URL_REQ==pQueueItem->commandType)
#ifdef URL_RATING
			tmURLFilter(pQueueItem->clientIP, pQueueItem->url, pQueueItem->host, "80", &rating_response);
#else
			tmURLFilter(pQueueItem->clientIP, "/", pQueueItem->host, "80", &rating_response);
#endif
		else if(KERNEL_TO_THPD_CMD_UPDATE_CLIENT_PTRN==pQueueItem->commandType)
			tmnf_UpdateClientPattern(pQueueItem->clientIP);
		else if(KERNEL_TO_THPD_CMD_UPDATE_CLIENT_INFO==pQueueItem->commandType)
			tmave_HookTrigger(pQueueItem->clientIP);
		else //KERNEL_TO_THPD_CMD_INCREASE_BLOCK_CAT
		{
			extern const int gTmUrlFilterDefinedCatMap[] ;

			url_filter_config_t UrlFilterConfig;
			CopyUrlConfToLocal(&UrlFilterConfig);
			tmAddUrlFilterStatisticCount(pQueueItem->clientIP,// yes, clientIP is used for rspblck
                                         gTmUrlFilterDefinedCatMap, &UrlFilterConfig);
		}
			
	}
	
    /* wait child process DEAD */
    daemon_fini();

/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

    printf("remove pid file: %s\n", PIDFILE);
    remove_pid(PIDFILE);

	

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    printf("shutdown\n");
    return 0;
}
