/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file thpd.c
 *  @brief TMOG HTTP Proxy Module - main
 */

/*
 *  Change Log
 *  xxxx-xx-xx name    description
 */
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <locale.h>
#include <libintl.h>
//#define	TCP_MAXSEG	 2	/* Set maximum segment size  */
#define IP_REDIRECT
#ifdef  IP_REDIRECT
#include <limits.h>
#include <linux/netfilter_ipv4.h>
#endif
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>

#include "daemon.h"
#include "log.h"
#include "tmURLCache.h"
#include "thpd.h"

/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/
//#include <pthread.h>
#include "tmClientInfo.h"
#include "tmAVEnforcer.h"
#include "tmException.h"
#include "tmPidUtil.h"
#include "tmURLFilter.h"
#include "tmShm.h"
#include "tmSemaphore.h"
#include "tmURLFilterConf.h"
#include "tmURLFilterStatistic.h"
#include "tmURLFilterLicense.h"
#include "tmFunction.h"
#include "tmShm.h"
#include "tmSemaphore.h"
#include "tmnfRequestInterface.h"

//#ifndef TM_NO_URL_FILTERING_CACHE
//#include "tmURLCache.h"
//#endif

#define PIDFILE             "/var/run/thpd.pid"
extern void SetPendingAV(uint32_t ip, unsigned char *mac);

//static int gnURLFilterLicChkInterval = 86400;

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/


#define THPD_MAX_PROC	          (1)

static volatile int GO_HELL=0;

/************************************************************************
 *
 *
 *
 ***********************************************************************/
//static URL_REQUEST_MESSAGE_ITEM *g_url_req_shared_memory = 0;
//static int nextUrlReq=0;// We keep next UrlReq to be served.  Since we scan all items in the shared memory, we still need to rememeber which one is first one to be served.

//#define __DEBUG__
/* function prototype */
static const char ModuleName[]="tmReqQ";




/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

#define MAX_FILE_PATH  128
static char gConfigFile[MAX_FILE_PATH] = {0};

/* Get the URL Filtering Cache Size from Shared Memory */
/*
static int tmGetUrlFilteringCacheSize(void)
{
    int nUrlFilterConfShmid;
    struct tm_sem_st UrlFilterConfLock;
    url_filter_config_t *pUrlFilterConf; // point to shared memroy
    int nCacheSize;
    
    nUrlFilterConfShmid = shm_init(TMSS_URL_FILTER_CONFSHMKEY, sizeof(url_filter_config_t));
    tm_lock_create(TMSS_URL_FILTER_CONFSEMLOCKKEY, &UrlFilterConfLock);
    if (tm_lock(&UrlFilterConfLock) == -1)
    {
        LOGERROR("tmGetUrlFilteringCacheSize(), lock shared memroy error");
    }
    pUrlFilterConf = (url_filter_config_t*)shm_attach(nUrlFilterConfShmid);
    
    nCacheSize = pUrlFilterConf->nUrlCacheSize;
    
    shm_detach(pUrlFilterConf);
    if (tm_unlock(&UrlFilterConfLock) == -1)
    {
        LOGERROR("tmGetUrlFilteringCacheSize(), unlock shared memroy error");
    }
    tm_lock_close(&UrlFilterConfLock);
    
    return nCacheSize;
}
*/

static void LoadSettings(const char *pFrom)
{
    LOGINFO("Load Settings %s", pFrom);

    //tmexp_LoadSettings(gConfigFile); we move to task tmHostent since it will handle the exception.
    tmave_LoadSettings(gConfigFile);
    tmLoadUrlFilterConf(gConfigFile);
#ifndef TM_NO_URL_FILTERING_CACHE
/* Do we need to clear the Url Filter Cache n Kernel if the category allowance is changed.   ????
   If so, we just need to implement a clearUrlFitlerCacheToKernel
   Currently, we check this in kerenel for the blocking of specific category. */
   // tmInitUrlFilterCache(tmGetUrlFilteringCacheSize());
   // tmDumpUrlCache(tmGetUrlFilteringCacheSize(), 2); /* Dump the Cahce status in Log */
#endif
}

static void sig_hup(int signo)
{
    LoadSettings("by signal SIGHUP");
}
/*
static void sig_usr1(int signo)
{
    pthread_t tid;
    int nRetVal;
    
    if ((nRetVal = pthread_create(&tid,NULL,&tmURLFilterLicenseCheckForActivate,(void*)gConfigFile)) != 0)
    {
        LOGERROR("Create thread tmURLFilterLicenseCheckForActivate() to check license fail. Err=%d",nRetVal);
    }
    if ((nRetVal = pthread_detach(tid)) != 0)
    {
        LOGERROR("Detach thread tmURLFilterLicenseCheckForActivate() fail. Err=%d",nRetVal);
    }
    
}

static unsigned int GetURLFilterLicChkInterval()
{
    url_filter_config_t UrlFilterConfig;
    
    CopyUrlConfToLocal(&UrlFilterConfig);
    
    return UrlFilterConfig.nLicChkInterval;
}  */

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

static void go_hell_handler(int signo)
{
    GO_HELL=1;
}
//extern void getHostByNameForFilterHost(void);

#define   BUFFER 255 
#define   PERM S_IRUSR|S_IWUSR 
 /*
struct msgtype { 
 long mtype; 
 char buffer[BUFFER+1]; 
 }
 
*/
int sendInitClientInfoToKernel(void);
extern const int gTmUrlFilterDefinedCatMap[] ;
tmufsaci_response_meta rating_response;

int nUrlFilterStatisticShmid;
int nUrlFilterConfShmid;
int msgid; 
URL_REQUEST_MESSAGE_ITEM QueueItem,* pQueueItem=&QueueItem;

int main(int argc, char *argv[])
{
 //   unsigned long last = 0;   /* last time when config reloaded */
  //  unsigned long now;
  // 	 int nShmid;
    int nUrlFilterStatisticShmid;
    int nUrlFilterConfShmid;
//#ifndef TM_NO_URL_FILTERING_CACHE
//    int nUrlFilterCacheShmid;
//#endif
    int msgid; 
    URL_REQUEST_MESSAGE_ITEM QueueItem,* pQueueItem=&QueueItem;

    if (argc != 2)
    {
        fprintf(stderr, "Usage: %s [config file]\n", argv[0]);
        exit(1);
    }

    /* save config file path */
    strncpy(gConfigFile, argv[1], sizeof(gConfigFile));
    gConfigFile[sizeof(gConfigFile)-1] = 0;
    LOGOPEN("THPD");
    LOGINFO("init");
    LOGDEBUG_ON();

    argc -= optind;
    argv += optind;

    { /* init daemon process */
        LOGDEBUG("initialize daemon process: max_proc=%d", THPD_MAX_PROC);
        if(0>daemon_init(1, THPD_MAX_PROC))
        {
            LOGERROR("failed to initialize daemon process");
            return -1;
        }
    }

/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

    tmci_InitClientTable();
    sendInitClientInfoToKernel();

    nUrlFilterConfShmid = shm_init(TMSS_URL_FILTER_CONFSHMKEY, sizeof(url_filter_config_t));

    nUrlFilterStatisticShmid = shm_init(TMSS_URL_FILTER_LOG_SHMKEY, sizeof(url_filter_statistic_t)*HV_DEFINED_CAT_NUM + sizeof(time_t));
    
    tmResetURLStatisticCount();

    /* load all configuration settings */
    LoadSettings("by program start");
    
    /* load URL Filtering License Check Interval to a local static variable for later use*/
    //gnURLFilterLicChkInterval = GetURLFilterLicChkInterval();

    /* restore clientinfo */
    tmci_ReadClient(gConfigFile);

//#ifndef TM_NO_URL_FILTERING_CACHE
//    nUrlFilterCacheShmid = shm_init(TMSS_URL_FILTER_CACHE_SHMKEY, sizeof(url_cache_t)+ sizeof(requested_url_t)*(tmGetUrlFilteringCacheSize()));
//    LOGINFO("URL Cache Memory size = %d bytes", sizeof(url_cache_t)+ sizeof(requested_url_t)*(tmGetUrlFilteringCacheSize()));
//#endif

    LOGDEBUG("hook SIGHUP");
    { /* monitor for config reload signal */
        if(SIG_ERR==signal(SIGHUP, sig_hup))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }

 /*   LOGDEBUG("hook SIGUSR1");
    { // monitor for license activation check signal
        if(SIG_ERR==signal(SIGUSR1, sig_usr1))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }*/


/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    LOGDEBUG("hook SIGTERM");
    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGTERM, go_hell_handler))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }

    LOGDEBUG("hook SIGINT");
    { /* monitor for shutdown signal */
        if(SIG_ERR==signal(SIGINT, go_hell_handler))
        {
            LOGERROR("signal: %m");
            return 1;
        }
    }
   

    LOGINFO("create pid file: %s", PIDFILE);
    write_pid(PIDFILE);

    //getHostByNameForFilterHost();
	


   if((msgid=msgget((key_t)URL_REQUEST_SHARE_KEY,PERM|IPC_CREAT|IPC_EXCL))==-1) 
    { 
	    fprintf(stderr,"Creat Message Queue  Error:%s\a\n",strerror(errno)); 
	    return -1; 
    } 
   LOGDEBUG("begin service loop");
 
   for(;GO_HELL==0;)
	{
      int retVal;

		//Read the message cache. Check if any one need to send URL request to survel. server
		/* need to retrieve item from the queue */
		//Search the whole urlIrq Shared Memory to see if any url need to serve
   LOGDEBUG("going to read msg from msgq,");
		retVal=msgrcv(msgid,pQueueItem,sizeof(URL_REQUEST_MESSAGE_ITEM)-sizeof(long),0, MSG_NOERROR); 
		
		if(retVal==-1)
		{
			LOGERROR("msgrcv error =%d.....really length=%d(%d-%d).................................\n",errno,sizeof(URL_REQUEST_MESSAGE_ITEM)-sizeof(long)
			,sizeof(URL_REQUEST_MESSAGE_ITEM),sizeof(long));
			continue;//TBD
		}
		else
		{
		//	LOGINFO("msgrcv:length=%d and the really length=%d(%d-%d)......\n",retVal,sizeof(URL_REQUEST_MESSAGE_ITEM)-sizeof(long)
		//	,sizeof(URL_REQUEST_MESSAGE_ITEM),sizeof(long));
		}
		
 	//	msgrcv(msgid,&a,10,1,0); 
    LOGDEBUG("read msg from msgq,mtype=%d,pQueueItem->commandType=%x",pQueueItem->mtype,pQueueItem->commandType);
//   LOGDEBUG("read msg from msgq,mtype=%d, ddata=%s",a.mtype,a.t);
		
		if(KERNEL_TO_THPD_CMD_URL_REQ==pQueueItem->commandType)
#ifdef URL_RATING
			tmURLFilter(pQueueItem->clientIP, pQueueItem->url, pQueueItem->host, "80", &rating_response);
#else
			tmURLFilter(pQueueItem->clientIP, "/", pQueueItem->host, "80", &rating_response);
#endif
		else if(KERNEL_TO_THPD_CMD_UPDATE_CLIENT_INFO==pQueueItem->commandType)
			tmave_HookTrigger(pQueueItem->clientIP);
		else if(KERNEL_TO_THPD_CMD_UPDATE_CLIENT_PTRN==pQueueItem->commandType)
			tmnf_UpdateClientPattern(pQueueItem->clientIP);
		else //KERNEL_TO_THPD_CMD_INCREASE_BLOCK_CAT
		{

			url_filter_config_t UrlFilterConfig;
			CopyUrlConfToLocal(&UrlFilterConfig);
			tmAddUrlFilterStatisticCount(pQueueItem->clientIP,// yes, clientIP is used for rspblck
                                         gTmUrlFilterDefinedCatMap, &UrlFilterConfig);
		}
			
	/*	time(&now);
		//Check URL Filtering License from Entitlement server 
		if (now - last >= gnURLFilterLicChkInterval)
		{
			LOGDEBUG("tmURLFilterLicense, Time to Check URL Filtering License. now=%lu,last=%lu,interval=%u",now,last,gnURLFilterLicChkInterval);
			if (tmURLFilterLicenseCheck(gConfigFile, &nLicStatus) == 0)
			{
				LOGDEBUG("tmURLFilterLicense, License Check OK. Status=%d",nLicStatus);
				last = now;
			}
			else
			{
				LOGERROR("tmURLFilterLicense, Check url filtering license fail");
			}
		}
		else
		{
			LOGDEBUG("tmURLFilterLicense, NOT Time to Check URL Filtering License. now=%lu,last=%lu,interval=%u",now,last,gnURLFilterLicChkInterval);
		} */
	}
	
    /* wait child process DEAD */
    daemon_fini();

/*******************************************************************************
* Porting Required Section Start
*******************************************************************************/

    LOGINFO("remove pid file: %s", PIDFILE);
    remove_pid(PIDFILE);

    shm_fini(nUrlFilterStatisticShmid);
  //  shm_fini(nUrlFilterConfShmid);

//#ifndef TM_NO_URL_FILTERING_CACHE
//    shm_fini(nUrlFilterCacheShmid);
//#endif

// When we received it.  It is too late....
   // tmci_WriteClient(gConfigFile);
   // tmci_DestroyClientTable();
	

/*******************************************************************************
* Porting Required Section End
*******************************************************************************/

    LOGINFO("shutdown");
    return 0;
}
