/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmAVEnforcer.h
 *  @brief TMOG AVEnforcer Module
 */

/*
 *  Change Log
 *  2004-02-18 Eric Li
 *  Initialization version
 */


#ifndef AVENFORCER_H
#define AVENFORCER_H

#ifndef __KERNEL__
#include "tmdpCommonDef.h"
#endif

#define AV_PASS                     0
#define AV_REDIRECT                 1

#define TMSS_AVE_CONFSHMKEY              ((key_t)1964)
#define TMSS_AVE_CONFSEMLOCKKEY          ((key_t)1965)

/* maximum length of URL should we follow */
#define MAX_URL_LENGTH      256
#define CONF_MODULE         "avenforcer"
#define REDIRECT_INTERVAL_SHORT 180 /* 3 minutes  */
#define REDIR_RETRY_MAX 5 /* redirect retry max times */
#define DO_NOT_REDIR_TIME 60 /* do not redirect the traffic for 3 ---> 1 minutes after client info created */


#define LAN_IF_ETH0 0
#define LAN_IF_BR0  1
typedef struct 
{
	unsigned int version;
	unsigned int lan_if;
	unsigned int gEnable;           /* enable avenforcer? */
	unsigned int gTimeReport;     /* interval to show report */
	unsigned int gTimeOutdate;   /* Timeout for any record */
	unsigned int gTimeUpdate ;     /* Timeout for triggering update */
	char gAvSvrURL[MAX_URL_LENGTH];
} AVEConf;

#ifndef __KERNEL__
int   tmave_HookTrigger(uint32_t srcip);
int   tmave_HookAction(uint32_t srcip, uint32_t dstip, const char *url);
void  tmave_LoadSettings(const char *file);
#endif
const char *tmave_GetAVServerURL(void);


#endif

