/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmCGIErrMsg.h
 *  @brief TMSS Error String Header
 */

/*
 *  Change Log
 *  2004-04-14 Henry Lin    Initialization version
 */


#ifndef __TM_CGI_ERR_MSG_H__
#define __TM_CGI_ERR_MSG_H__

/* Errors shouldn't happen in normal use */
#define ERR_STRING_OPEN_CONFIG              "Open config file failed."
#define ERR_STRING_READ_CONFIG_PARAM        "Read config file (module: %s, parameter: %s) failed."
#define ERR_STRING_READ_CONFIG_MODULE       "Read config file (module: %s) failed."
#define ERR_STRING_WRITE_CONFIG_PARAM       "Write config file (module: %s, parameter: %s) failed."
#define ERR_STRING_WRITE_CONFIG_PARAM_2     "Write config file (module: %s, parameter: %s%d) failed."
#define ERR_STRING_WRITE_CONFIG_MODULE      "Write config file (module: %s) failed."
#define ERR_STRING_WRITE_CONFIG             "Write config file failed."
#define ERR_STRING_READ_HTML_VAR            "Read html variable failed."
#define ERR_STRING_READ_HTML_VAR_NAME       "Read html variable %s failed."
#define ERR_STRING_INVALID_HTML_VAR_NAME    "Invalid html variable %s."
#define ERR_STRING_MALLOC                   "memory allocation error."
#define ERR_STRING_CLIENT_BUFFER_SIZE       "Buffer size for client table not enough."
#define ERR_STRING_COM_LIST_BUFFER_SIZE     "Buffer not enough to display all computers in list"
#define ERR_STRING_NULL_INPUT               "Error: NULL Input."

#ifdef _PROXY_
/* Proxy Settings */
#define ERR_STRING_PROXY_SERVER_NAME        "Invalid Proxy Server name or IP address."
#define ERR_STRING_PROXY_PORT               "Invalid Proxy Port Number."
#define ERR_STRING_PROXY_USERNAME           "Invalid Proxy Username."
#define ERR_STRING_PROXY_PASSWORD           "Invalid Proxy Password."
#define PROXY_PAGE_TITLE                    "Proxy Settings"
#endif

/* Service Settings */
#define SERVICE_PAGE_TITLE                  "Service Settings"


/* Virus Protection */
#define VIRUS_PROTECTION_PAGE_TITLE         "Virus Protection"
#define PCCILLIN_NAME                       "Internet Security Suite"
#define NO_CLIENT                           "<tr>"\
                                            "<td height=\"%s\" class=\"%s\" colspan=6 align=center>No Client</td>"\
                                            "</tr>"
#define STR_STATUS_AVOK                     "Up to date"
#define STR_STATUS_AVOLD                    "<strong>Needs update</strong>"
#define STR_STATUS_AVOTHERS                 "Potential threat"
#define STR_OLD                             "<em><font color=#FF0000>(Needs updating)</font></em>"
#define STR_NA                              "n/a"

/* Parental Controls */
#define ERR_STRING_PARENTAL_SCHEDULE_MOR    "Invalid Schedule Time Morning"
#define ERR_STRING_PARENTAL_SCHEDULE_AFT    "Invalid Schedule Time Afternoon"
#define URL_FILTER_PAGE_TITLE               "Parental Controls"
#define URL_FILTER_LOG_PAGE_TITLE           "Parental Controls Log"
#define URLFILTER_PAGE_REPLACE_VALUE_LIC_DISABLE "(Disabled by License Control)"
#define URLFILTER_CATEGORY_PORNOGRAPHY      "Pornography"
#define URLFILTER_CATEGORY_ALCOHOL_TABACCO  "Alcohol/Tabacco"
#define URLFILTER_CATEGORY_ILLEGAL_QUEST    "Illegal/Questionable"
#define URLFILTER_CATEGORY_GAMBLING         "Gambling"
#define URLFILTER_CATEGORY_VIOLENCE         "Violence/Hate/Racism"
#define URLFILTER_CATEGORY_ABORTION         "Abortion"
#define URLFILTER_CATEGORY_ILLEGAL_DRUGS    "Illegal Drugs"


#endif
