/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmCGILib.h
 *  @brief TMOG CGI Library Header
 */

/*
 *  Change Log
 *  2004-04-14 Henry Lin    Initialization version
 */


#ifndef __TM_CGI_LIB_H__
#define __TM_CGI_LIB_H__

#include "qDecoder.h"

typedef Q_Entry TM_Entry;

/* Function define for CGI Library - qDecoder API */
#define tmDecoder()                                 qDecoder()
#define tmContentType(mimetype)                     qContentType(mimetype)
#define tmSedArgAdd(first, name, format, args...)   qSedArgAdd(first, name, format, ## args)
#define tmSedFile(first, filename, fpout)           qSedFile(first, filename, fpout)
#define tmSedArgFree(first)                         qSedArgFree(first)
#define tmPrint()                                   qPrint()
#define tmFree()                                    qFree()
#define tmValue(format, args...)                    qValue(format, ## args)
#define tmValueDefault(defstr, format, args...)     qValueDefault(defstr, format, ## args)
#define tmURLdecode(str)                            qURLdecode(str)
#define tmValueFirst(format, args...)               qValueFirst(format, ## args)
#define tmValueNext()                               qValueNext()

/*
* ------------------------------------------------------------------------------
* Type Definitions
* ------------------------------------------------------------------------------
*/


/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
