/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmGetHardwareInfo.h
 *  @brief TMSS Get Hardware Information
 */

/*
 *  Change Log
 *  2004-05-19 Henry Lin    Initialization version
 */


#ifndef __TM_GET_HARDWARE_INFO_H__
#define __TM_GET_HARDWARE_INFO_H__

#define TMSS_MAX_BUF_BOX_ID         20
#define TMSS_MAX_BUF_VENDER_ID      20
#define TMSS_MAX_BUF_BOX_IP         64
#define TMSS_MAX_BUF_BOX_VERSION    32
#define TMSS_MAX_BUF_BOX_BUILD      32

/*
* ------------------------------------------------------------------------------
* Type Definitions
* ------------------------------------------------------------------------------
*/
//#define TMDP_Vendor_ID      "TWG1001001"    /* constring string for vendors, 16 byte, can be modified */
#define TMDP_Vendor_ID      "TWS1002002"    /* constring string for vendors, 16 byte, can be modified */
#define TM_BOX_CONFIG_URL     "<WEB_CONFIG__IP>/" /* web configure URL to config this TMSS router, 
                                                     hardware vendor need to modify this value ex. "192.168.0.1/" */
#define TM_BOX_FIRMWARE_VERSION "1.0"
#define TM_BOX_FIRMWARE_BUILD   "1000"

/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

int tmGetBoxID(char *szBoxId);
int tmGetVendorID(char *szVendorId);
int tmGetBoxIp(char *szBoxIp);
int tmGetBoxVersion(char *szBoxVersion);
int tmGetBoxBuild(char *szBoxBuild);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
