/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmSemaphore.h
 *  @brief TMOG Semaphore Module
 */

/*
 *  Change Log
 *  2004-02-19 Henry Lin    Initialization version
 */


#ifndef __TMSEMAPHORE_H__
#define __TMSEMAPHORE_H__

#ifndef __KERNEL__
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <errno.h>

extern int errno;
#endif

#define SEMPERM 0666
#define SEM_CAPACITY 1

typedef struct tm_sem_st *tm_lock_t;

struct tm_sem_st 
{
	int	semid;	/* semaphore id */
	key_t	semkey;
};

#ifndef __KERNEL__
#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
   /* union semun is defined by including <sys/sem.h> */
#else
   /* according to X/OPEN we have to define it ourselves */
   union semun {
         int val;                    /* value for SETVAL */
         struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
         unsigned short int *array;  /* array for GETALL, SETALL */
         struct seminfo *__buf;      /* buffer for IPC_INFO */
   };
#endif             
#endif

#ifdef __cplusplus
extern "C" {
#endif

int tm_lock_create(key_t key, struct tm_sem_st *sem);/*tm_lock_t sem);*/
int tm_lock(struct tm_sem_st *sem);/*tm_lock_t sem);*/
int tm_unlock(struct tm_sem_st *sem);/*tm_lock_t sem);*/
void tm_lock_close(struct tm_sem_st *sem);/*tm_lock_t sem);*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
