/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmShm.h
 *  @brief TMOG Shared Memory Module
 */

/*
 *  Change Log
 *  2004-02-19 Henry Lin    Initialization version
 */


#ifndef __TMSHM_H__
#define __TMSHM_H__

#include <sys/types.h> /* key_t */

/*
* ------------------------------------------------------------------------------
* Type Definitions
* ------------------------------------------------------------------------------
*/


/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

int shm_init(key_t key, int size);
void *shm_attach(int shmid);
int shm_detach(void *addr);
int shm_fini(int shmid);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
