/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmURLFilter.h
 *  @brief TMOG URL Filtering Module
 */

/*
 *  Change Log
 *  2004-01-08 Henry Lin    Initialization version
 */

#ifndef __TMURLFILTER_H__
#define __TMURLFILTER_H__

#ifndef __KERNEL__
#include "tmURLRater.h"     /* tmufsaci_response_meta */
#include "TmCommon.h"       /* uint32_t */
int tmURLFilter(uint32_t srcip, unsigned char *req_url, unsigned char *hdr_host, unsigned char *hdr_port,tmufsaci_response_meta *p_rating_response);
#endif

/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif
enum
{
            HTTP_MSG_ACTION_UNKNOWN = 0,
            HTTP_MSG_ACTION_RELAY,
            HTTP_MSG_ACTION_BLOCK,
            HTTP_MSG_ACTION_REDIRECT,      /* For AV Enforcer */
           HTTP_MSG_ACTION_DISCARD,
 };//action;



#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
