/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmURLFilterLicense.h
 *  @brief TMSS URL Filtering Module - License Check
 */

/*
 *  Change Log
 *  2004-05-17 Henry Lin    Initialization Version
 */

#ifndef __TM_URL_FILTER_LICENSE_H__
#define __TM_URL_FILTER_LICENSE_H__

#define TM_PACKET_BUF_SIZE 2048

#define TM_URL_FILTER_ENTITLEMENT_CHECK_ERROR -1

#define TM_URL_FILTER_ENTITLEMENT_RET_MODULE "RESPONSE"
#define TM_URL_FILTER_ENTITLEMENT_RET "RET"
#define TM_URL_FILTER_ENTITLEMENT_RET_VALUE_LEN 3


#define TM_URL_FILTER_COMPONENT_ID "TS10S003" /* TrendMicro Defined URL Filtering ID */

#define TM_URL_FILTER_LICENCE_REQ_PACKET \
"GET %s?BOXID=%s&VID=%s&PID=%s HTTP/1.0\r\n" \
"Accept: */*\r\n" \
"Accept-Language: en-us\r\n" \
"User-Agent: TMSS/1.0\r\n" \
"Host: %s:%d\r\n" \
"Connection: close\r\n\r\n"


#ifdef __cplusplus
extern "C" {
#endif

int tmURLFilterLicenseCheck(char* pszConfigFilePath, int* pnLicStatus);
void *tmURLFilterLicenseCheckForActivate(char* pszConfigFilePath);
int tmURLFilterLicenseCheckForStartup(char* pszConfigFilePath);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
