/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmURLFilterStatistic.h
 *  @brief TMOG URL Filtering Statistic Log Module
 */

/*
 *  Change Log
 *  2004-03-03 Henry Lin    Initialization version
 */


#ifndef __TMURLFILTERSTATISTIC_H__
#define __TMURLFILTERSTATISTIC_H__

#ifndef __KERNEL__
#include <sys/types.h>       /* key_t */
#include "tmURLFilterConf.h" /* url_filter_config_t */
#endif

#define TMSS_URL_FILTER_LOG_SHMKEY              ((key_t)1922)
#define TMSS_URL_FILTER_LOG_SEMLOCKKEY          ((key_t)1923)

/*
* ------------------------------------------------------------------------------
* Type Definitions
* ------------------------------------------------------------------------------
*/

typedef struct url_filter_statistic_st
{
    int nAccessCount;
    int nBlockedCount;
    time_t LastAccessTime;
    time_t LastBlockedTime;
}
url_filter_statistic_t;

/*
* ------------------------------------------------------------------------------
* Function Prototypes Section.
* ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

void tmResetURLStatisticCount(void);
#ifndef __KERNEL__
void tmAddUrlFilterStatisticCount(unsigned long BlockCat, const int *gTmUrlFilterDefinedCatMap, url_filter_config_t *UrlFilterConfig);
#else
void tmAddUrlFilterStatisticCount(unsigned long BlockCat);
#endif
url_filter_statistic_t* tmGetURLStatisticCount(url_filter_statistic_t *pUrlFilterStatisticBuf, int nBufSize, time_t *StartTime);
void tmDumpURLStatisticCount(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
