/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @file tmdpCommonDef.h
 *  @brief TMOG Discovery Module Common header
 */

/*
 *  Change Log
 *  2004-02-17 Jim Wu    Initial Version
 */

#ifndef DP_COMMON_DEF_H
#define DP_COMMON_DEF_H


typedef struct sockaddr SA;

#define PCC_COMMUNICATION_PORT   40116
#define DQM_DRM_BUFFER_SIZE      500
#define PATTERN_BUFFER_SIZE      12
#define MAC_ADDRESS_SIZE         6

typedef unsigned int   __u32;
typedef unsigned short __u16;

#define TIME_INTERVAL 5 /* 5 seconds for time out value of socket retrieving data */

#define TempPIdPath   "/var/tmp/tmdp.pid"   /* temporary file path */

/* function return code */
#define NO_ERROR 0
#define FAIL 		 -1


typedef enum
{
	PARENT_PROCESS,
	CHILD_PROCESS,
}PROCESS_STATUS;

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* LOG_H */
