/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @file tmdpMsgComposer.h
 *  @brief TMOG Discovery Message Composer header
 */

/*
 *  Change Log
 *  2004-03-19 Jim Wu    Initial Version
 */


#ifndef __DPCOMPOSER_H__
#define __DPCOMPOSER_H__

#define TMDP_MagicNumber    "TMDP"  /* const string for TMDP protocol, can not modify */
#define TMDP_Node_Name      "TMSS_TEST_NODE"      /* constring string for Node Name, 32 byte, can be modified */

#ifdef __cplusplus
extern "C" {
#endif

  int  tmdpx_GetPCCDRMSize(void);   /* function used to get the DRM size from PCC*/
  int  tmdpx_GetDRMSize(void);      /* function used to get the DRM size for TMSS */
  int  tmdpx_GetDQMSize(void);      /* function used to get the DQM size */
  int  tmdpx_ParseDQM(char *szBuff);/* function used to parse the DQM from PCC */
  int  tmdpx_ParsePCCDRM(char *szBuff, unsigned int nIP);  /* function used to parse the DRM from PCC */
  void tmdpx_PrepareDQM(char *szBuff); /* function used to prepare the DQM packet*/
  void tmdpx_PrepareDRM(char *szBuff, unsigned int nIP, /* function used to prepare the DRM packet*/
                char *szEngineVer, char *szPatternNum);

#ifdef __cplusplus
} /* extern "C" */
#endif



#endif

