/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @file tmnfRequestInterface.h
 *  @brief TMOG Request Module
 */

/*
 *  Change Log
 *  2004-04-13 Henry Lin    Initialization Version
 */



#ifndef _REQUEST_INTERFACE_H
#define _REQUEST_INTERFACE_H

#ifdef __cplusplus
extern "C" {
#endif

/** function used to trigger tmdpd daemon to query 
    PCC client information, nClientIP is the client's 
    IP address */
int tmnf_UpdateClientInfo(__u32 nClientIP);

/** function used to trigger tmdpd daemon to notify 
    PCC client to update engine/pattern, nClientIP 
    is the client's IP address */
int tmnf_UpdateClientPattern(__u32 nClientIP);

/** function used to terminate the tmdpd daemon*/
int tmnf_TerminateDaemon(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif

