/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/** 
 *  @file tmrqRequestQueue.h
 *  @brief TMOG Request Module
 */

/*
 *  Change Log
 *  2004-04-13 Henry Lin    Initialization Version
 */


#ifndef _REQUEST_Q_H
#define _REQUEST_Q_H

enum COMMAND_TYPE
{
    UPDATE_CLIENT_INFO,
    UPDATE_PATTERN_ENGINE
};

#define IP_SIZE  20

typedef struct 
{	
    int   nCommandType;
    char  szClientIP[IP_SIZE];	
}MESSAGE_ITEM;

#define SHARE_KEY	0x1905
#define REQUEST_QUEUE_SIZE 10 
#define REQUEST_QUEUE_SEMLOCK_KEY 0x1906


#ifdef __cplusplus
extern "C" {
#endif

int  tmrq_IsItemExist(MESSAGE_ITEM *messageItem);
int  tmrq_InsertQueue(MESSAGE_ITEM *messageItem);
void tmrq_ResetQueue(void);    
int  tmrq_IsQueueEmpty(void);  
int  tmrq_GetLastItem(MESSAGE_ITEM *pMessageItem); 
int  tmrq_IsQueueFull(void);               
int  tmrq_DeleteLastItem(MESSAGE_ITEM *pMessageItem);

void tmrq_SetQueueHead(int *pIndex);
void tmrq_SetQueueTail(int *pIndex);
void tmrq_SetMsgItemHead(MESSAGE_ITEM *pMessageItem);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif

