/******************************************************************************
*
*  (C) Copyright 2004 Trend Micro, Inc.
*
*  All Rights Reserved.
*  This program is an unpublished copyrighted work which is proprietary
*  to Trend Micro, Inc. and contains confidential information that is not
*  to be reproduced or disclosed to any other person or entity without
*  prior written consent from Trend Micro, Inc. in each and every instance.
*
*  WARNING:  Unauthorized reproduction of this program as well as
*  unauthorized preparation of derivative works based upon the
*  program or distribution of copies by sale, rental, lease or
*  lending are violations of federal copyright laws and state trade
*  secret laws, punishable by civil and criminal penalties.
*
*****************************************************************************/

/**
*  @tmSemaphoreTest.c
*  @TMSS semaphore module testing
*/

/*
*  Change Log
*  2004-02-20 Henry Lin    Initialization version
*/


#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include "tmSemaphore.h"

int main(void)
{
    struct tm_sem_st lockd;
    int pid;
    int count=0;
    char feed;

    tm_lock_create(90009,&lockd);
    
    pid = vfork();
    if (pid == 0)
    feed='C';
    else
    feed='P';

    /* Paul note: comment out tm_lock, tm_unlock  or not to observe the difference */
    tm_lock(&lockd);
    for(count=0;count<5;count++)
    {
        printf("%c",feed);
        fflush(stdout);
        sleep(1);
    }
    tm_unlock(&lockd);

    if(pid==0)
        return 0;
    else
        wait((int *) 0);

    putchar('\n');
    tm_lock_close(&lockd);
    return 0;
}

