/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file tmSocketClient.h
 *  @brief TMOG URL Filtering Socket Module
 */

/*
 *  Change Log
 *  2004-02-17 Henry Lin    Initialization Version
 */

#ifndef __TM_SOCKET_CLIENT_H__
#define __TM_SOCKET_CLIENT_H__

#include <arpa/inet.h>
#define TM_URL_FILTER_SOCK_FAILURE -1

#ifdef __cplusplus
extern "C" {
#endif

int tm_url_filter_tcp_connect(const struct in_addr * pAddr, unsigned short port);
int tm_url_filter_sock_srv_write(int sd, const unsigned char * pData, int dataSize, long timeout);
int tm_url_filter_sock_srv_read(int sd, unsigned char * pOutputBuffer, int bufferSize, long timeout);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
