
#ifndef _RIJNDAEL_H_
#define _RIJNDAEL_H_

#include "platform.h"

//namespace PR_COMMON {

#pragma pack(1)
typedef struct _aes_sec_cnt{
	u4byte  k_len;
	u4byte  e_key[64];
	u4byte  d_key[64];
	u1byte  pow_tab[256];
	u1byte  log_tab[256];
	u1byte  sbx_tab[256];
	u1byte  isb_tab[256];
	u4byte  rco_tab[ 10];
	u4byte  ft_tab[4][256];
	u4byte  it_tab[4][256];
	#ifdef  PR_LARGE_TABLES
	  u4byte  fl_tab[4][256];
	  u4byte  il_tab[4][256];
	#endif
	u4byte  tab_gen;
} aes_sec_cnt;
#pragma pack()
/* Standard interface for AES cryptographic routines */
/*
#ifdef  __cplusplus
extern "C" {
#endif
*/
/* char*   name(void); */

/* "key_len" is counted in bit and in Rijndael would be 128,192,256. */
/* f: 1=encrypt, 2=decrypt, 3=both */
void set_key(aes_sec_cnt* pCnt, const u1byte key[], const u4byte key_len, u1byte f);

void encrypt(aes_sec_cnt* pCnt, const u1byte in_blk[], u1byte out_blk[]);
void decrypt(aes_sec_cnt* pCnt, const u1byte in_blk[], u1byte out_blk[]);
/*
#ifdef  __cplusplus
};
#endif
*/
//} /* namespace PR_COMMON */

#endif /* _RIJNDAEL_H_ */
