
/************************************************************************
 *
 * tmpraes.cpp
 *
 * PR Internal function -
 * AES (Advance Encryption Standard) Encryption / Decryption .
 *
 ************************************************************************
 *
 * Update log
 *
 * No.		Date         Modified By    Description
 * =======  ==========   ============   =================================
 *
 ************************************************************************/


/* Standard C library */
#include <stdio.h>
#include <string.h>
#include <limits.h>

/* PR Module */
#include "platform.h"
#include "tmpraes.h"

/* AES kernel code */
#include "rijndael.h"

//namespace PR_COMMON {

#ifdef _TMPRSRV_
int _encryptAES(unsigned char pKey[AES_KEYLEN], unsigned char *pInBuf, 
				unsigned char *pOutBuf)
{
	unsigned char	pTmpBuf[AES_BLOCK_SIZE];
	aes_sec_cnt _cnt;

    /* Input pararmeter checking */
	if(pKey == NULL || pInBuf == NULL || pOutBuf == NULL)
		return PR_ERROR_INVALID_PARAMETER;

    /* Initial DES key (void) */
    set_key(&_cnt, pKey, AES_KEYLEN * CHAR_BIT, 1);

    /* AES encrypt (void) */
    encrypt(&_cnt, pInBuf, pTmpBuf);

	/* Copy result from temp-buffer to destination */
	memcpy(pOutBuf, pTmpBuf, AES_BLOCK_SIZE);

    /* Success */
    return PR_SUCCESS;
}
#endif

int _decryptAES(unsigned char pKey[AES_KEYLEN], unsigned char *pInBuf, 
				unsigned char *pOutBuf)
{
	unsigned char	pTmpBuf[AES_BLOCK_SIZE];
	aes_sec_cnt _cnt;

    /* Input pararmeter checking */
	if(pKey == NULL || pInBuf == NULL || pOutBuf == NULL)
		return PR_ERROR_INVALID_PARAMETER;

    /* Initial DES key */
    set_key(&_cnt, pKey, AES_KEYLEN * CHAR_BIT, 2);

    /* AES decrypt */
    decrypt(&_cnt, pInBuf, pTmpBuf);

	/* Copy result from temp-buffer to destination */
	memcpy(pOutBuf, pTmpBuf, AES_BLOCK_SIZE);

    /* Success */
    return PR_SUCCESS;
}

//} /* namespace PR_COMMON */
