
/************************************************************************
 *
 * tmpraes.h
 *
 * PR Internal function -
 * AES (Advance Encryption Standard) Encryption / Decryption .
 *
 ************************************************************************
 *
 * Update log
 *
 * No.		Date         Modified By    Description
 * =======  ==========   ============   =================================
 *
 ************************************************************************/

#ifndef _PR_AES_H_
#define _PR_AES_H_

/*#include "tmprcomm.h"*/
#include "pr_error.h"

//namespace PR_COMMON {

/* Key length of AES */
#define AES_KEYLEN		(16)

/* Block length per round for AES */
#define AES_BLOCK_SIZE	(16)

#ifdef _TMPRSRV_
/************************************************************************
 *	_encryptAES
 *
 *	Description :
 *		AES encrypt .
 *
 *	Parameters :
 *		pKey			[in]	Input key data array (16 bytes) .
 *		pSourceData		[in]	Pointer of input source data
 *								(The size must be 16 bytes) .
 *		pEncryptData	[out]	Pointer of output encrypt data buffer.
 *								(The size must be 16 bytes) .
 *
 *	Return :
 *		PR_SUCCESS					Success .
 *		PR_ERROR_INVALID_PARAMETER		Fail, error input parameter .
 *
 ************************************************************************/
int _encryptAES(unsigned char pKey[AES_KEYLEN], unsigned char *pInBuf,
				unsigned char *pOutBuf);
#endif

/************************************************************************
 *	_decryptAES
 *
 *	Description :
 *		AES decrypt .
 *
 *	Parameters :
 *		pKey			[in]	Input key data array (16 bytes) .
 *		pEncryptData	[in]	Pointer of input encrypt data
 *								(The size must be 16 bytes) .
 *		pDecryptData	[out]	Pointer of output decrypt data buffer.
 *								(The size must be 16 bytes) .
 *
 *	Return code:
 *		PR_SUCCESS					Success .
 *		PR_ERROR_INVALID_PARAMETER		Fail, error input parameter .
 *
 ************************************************************************/
int _decryptAES(unsigned char pKey[AES_KEYLEN], unsigned char *pInBuf,
				unsigned char *pOutBuf);

//} /* namespace PR_COMMON */

#endif /* _PR_AES_H_ */
