%{

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "tmcfg_yacc.tab.h"

#define yyterminate() { yy_delete_buffer(YY_CURRENT_BUFFER); return 0; }

%}

%option noyywrap

QS       \"([^\"]|(\"\"))*\"
SP       [ \t\r\n]+

%%

{QS}     { char *p; int i;
           // fprintf(stderr, "QS=[%s]:[%d]\n", yytext, yyleng); 
           if(NULL!=(yylval.charval=p=malloc(yyleng+1))) {
             for(i=1; i<yyleng-1; i++) {
	       *p=yytext[i];
	       p++;
	       if(yytext[i]=='\"') {
		 i++;
	       }
	     }
	     *p='\0';
	   }
	   // printf("yylval.charval=[%s]\n", yylval.charval);
           return QS; }

module   { return MODULE; }
param    { return PARAM; }
name     { return NAME; }
value    { return VALUE; }
option   { return OPTION; }

{SP}     { ; }

.        { return yytext[0]; }

%%

void __cfg_set_yyin(FILE *file) {
  yyin=file;
  yyrestart(yyin);
}
