/******************************************************************************
 *
 *  (C) Copyright 2004 Trend Micro, Inc.
 *
 *  All Rights Reserved.
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Trend Micro, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Trend Micro, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 *****************************************************************************/

/**
 *  @file  tmHostent.c
 *  @brief TMOG AVEnforcer Module
 */

/*
 *  Change Log
 *  2004-03-11 Eric Li Initialization version
 */
 

#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include "tmFunction.h"
#include "tmException.h"

#define url_avserver "beta.tmss.trendmicro.com"
#define au_server_url "beta.activeupdate.trendmicro.com"
#define url_avserver_production "tmss.trendmicro.com"
#define au_server_url_production "tmss-p.activeupdate.trendmicro.com"
#define ave_except1 "tmss-sp.trendmicro.com"
#define ave_except2 "tmss.url.trendmicro.com"
#define ave_except3 "tmssreg.trendmicro.com"
#define ave_except4 "drh.digitalriver.com"
#define ave_except5 "ccc.trendmicro.com"
#define ave_except6 "www.trendmicro.com"
#define path_avedst "/tmp/avedst.dat"
#define tm_conf   "/flash/tm.conf"
char *exceptionHostLst[]={url_avserver,au_server_url,url_avserver_production,au_server_url_production,ave_except1,
ave_except2,ave_except3,ave_except4,ave_except5,ave_except6};
int main(int argc, char **argv)
{
    char            **pptr;
    char            str[INET6_ADDRSTRLEN];
    struct hostent  *hptr;
    const char      *pStrIP;
  FILE *fp;
  int i;

 
  /*  if (argc != 2) 
    {
        fprintf(stderr, "Usage: %s hostname\n", argv[0]);
        exit(1);
    }

    ptr = argv[1];

    ptr = *++argv; */
    if((fp = fopen(path_avedst, "w")) == NULL) return 0;

    for(i=0;i<10;i++)
    {
	    
	    if ((hptr = tmGethostbyname(exceptionHostLst[i])) == NULL) 
	    {
		    fprintf(stderr, "tmGethostbyname fail: %s: %s\n", exceptionHostLst[i], hstrerror(h_errno));
		    continue;
	    }

	    switch (hptr->h_addrtype) 
	    {
		    case AF_INET:
		    pptr = hptr->h_addr_list;
		    for ( ; *pptr != NULL; pptr++)
		    {
			    pStrIP = inet_ntop(hptr->h_addrtype, *pptr, str, sizeof(str));
			    fprintf(stderr,"exceptionHostLst[i]=%s %s\n",exceptionHostLst[i], pStrIP);
			    fprintf(fp,"%s\n", pStrIP);
		    }
		    break;
	    }
    }
    fclose(fp);
    //strncpy(gConfigFile, argv[1], sizeof(gConfigFile));
    //gConfigFile[sizeof(gConfigFile)-1] = 0;
    tmexp_LoadSettings(tm_conf); 

    return 0;
}

