/*
 *  Copyright 2001-2003, Broadcom Corporation   
 *  All Rights Reserved.   
 *     
 *  THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY   
 *  KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM   
 *  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS   
 *  FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.   
 *
 *  $Id: lanhostconfig.c,v 1.1.1.1 2005/09/15 13:37:02 root Exp $
 */

#include "upnp_dbg.h"
#include "upnp_osl.h"
#include "upnp.h"
#include "igd.h"
#include "lanhostconfig.h"
#include "bcmnvram.h"

int LANHostConfig_GetVar(struct Service *psvc, int varindex)
{
    struct StateVar *var;
Load_Router_Status();
    var = &(psvc->vars[varindex]);

    switch (varindex) {

    case VAR_DomainName: 
	//strcpy(var->value, nvram_safe_get("lan_domain"));
	DPRINTF("LAN_DOMAIN:%s\n",LAN_DOMAIN);
	strcpy(var->value, LAN_DOMAIN);
	
	break;

    case VAR_SubnetMask:
    DPRINTF("LAN_NETMASK:%s\n",LAN_NETMASK);
	
	strcpy(var->value, LAN_NETMASK);
	//strcpy(var->value, nvram_safe_get("lan_netmask"));
	break;

    case VAR_MinAddress:
	    DPRINTF("DHCP_START:%s\n",DHCP_START);
	
	strcpy(var->value, DHCP_START);
	//strcpy(var->value, nvram_safe_get("dhcp_start"));
	
	break;

    case VAR_MaxAddress:
	    DPRINTF("DHCP_END:%s\n",DHCP_END);
	//strcpy(var->value, nvram_safe_get("dhcp_end"));
	strcpy(var->value, DHCP_END);
	break;
    } /* end-switch */

    return TRUE;
}


int LANHostConfig_SetDomainName(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
//       {"NewDomainName", VAR_DomainName, VAR_IN},
{
    uint success = TRUE; /* assume no error will occur */

    nvram_set("lan_domain", ac->params[0].value);
    nvram_commit();
    // restart ?? 
    
    return success;
}
