/*
 *  Copyright 2001-2003, Broadcom Corporation   
 *  All Rights Reserved.   
 *     
 *  THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY   
 *  KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM   
 *  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS   
 *  FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.   
 *
 *  $Id: wanppp.c,v 1.1.1.1 2005/09/15 13:37:02 root Exp $
 */

#include "upnp_dbg.h"
#include "upnp_osl.h"
#include "upnp.h"
#include "igd.h"
#include "wanipc.h"
#include "wanppp.h"
#include "bcmnvram.h"

#if defined(linux)
#define    pppoe_up()
#define    pppoe_down()
#else
extern void pppoe_up();
extern void pppoe_down();
#endif


extern void igd_restart(int secs);
extern char * safe_snprintf(char *str, int *len, const char *fmt, ...);

extern char *WANPPPConnection_PossibleConnectionTypes_allowedValueList[];


int WANPPPConnection_GetVar(struct Service *psvc, int varindex)
{
    PWANPPPConnectionData data = psvc->opaque;
    struct StateVar *var;
    char **p, *cur;
    int len;
	Load_Router_Status();

    var = &(psvc->vars[varindex]);

    switch (varindex) {
    case    VAR_PortMappingNumberOfEntries:
	    	sprintf(var->value, "%d", data->nportmappings);
		//DPRINTF("wanppp.c VAR_PortMappingNumberOfEntries:%s\n",var->value);
	    break;
    case VAR_ConnectionStatus:
	    switch(read_value_from_file("/tmp/ppp/wan_connect_status")){
	    case 0:
		    strcpy(var->value,"Disconnected");
		    break;
	    case 1:
		    strcpy(var->value,"Connected");
		    break;
	    case 2:
		    strcpy(var->value,"Connecting");
		    break;
	    case 3:
	    default:	
		    strcpy(var->value,"Disconnected");
		    break;		    
	    }
    break;
    case VAR_PossibleConnectionTypes:
/*
	cur = var->value;
	len = sizeof(var->value);
	for (p = WANPPPConnection_PossibleConnectionTypes_allowedValueList; *p; p++) {
		//DPRINTF("p:%s\n",*p);
		if (cur != var->value){
		cur = safe_snprintf(cur, &len, ",");
		//DPRINTF("1.cur:%s\n",cur);
		}
	    cur = safe_snprintf(cur, &len, "%s", *p);
	    //DPRINTF("2.cur:%s len:%d\n",cur,len);
		
	}
*/
	strcpy(var->value,"IP_Routed");
	break;
    case VAR_UserName:
	//DPRINTF("wanppp.c 53 PPPOE_USERNAME:%s\n",PPPOE_USERNAME);
	strcpy(var->value, PPPOE_USERNAME);
	//strcpy(var->value, nvram_safe_get("pppoe_username"));
	break;
    case VAR_Password:
    //DPRINTF("wanppp.c 59 PPPOE_PASSWORD:%s\n",PPPOE_PASSWORD);
	strcpy(var->value, PPPOE_PASSWORD);
	//strcpy(var->value, nvram_safe_get("pppoe_passwd"));
	break;
    case VAR_IdleDisconnectTime:
	// DPRINTF("wanppp.c 65 PPPOE_IDLETIME:%s\n",PPPOE_IDLETIME);
	strcpy(var->value, PPPOE_IDLETIME);
	//strcpy(var->value, nvram_safe_get("pppoe_idletime"));
	break;
    case VAR_ExternalIPAddress:
    DPRINTF("wanppp.c 70 WAN_IP:%s\n",WAN_IP);
    strcpy(var->value, WAN_IP);
	//strcpy(var->value, nvram_safe_get("wan_ipaddr"));
	break;
    }
    return TRUE;
}


int WANPPPConnection_ConfigureConnection(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
//       {"NewUserName", VAR_UserName, VAR_IN},
//       {"NewPassword", VAR_Password, VAR_IN},
{
    uint success = TRUE; /* assume no error will occur */

    if (strlen(ac->params[0].value) > 32 || strlen(ac->params[1].value) > 32) {
	soap_error( uclient, SOAP_INVALID_ARGS);
	success = FALSE;
    } else {
	nvram_set("pppoe_username", ac->params[0].value);
	nvram_set("pppoe_passwd", ac->params[1].value);
	nvram_commit();
    }

    return success;
}


int WANPPPConnection_SetIdleDisconnectTime(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
//       {"NewIdleDisconnectTime", VAR_IdleDisconnectTime, VAR_IN},
{
    uint success = TRUE; /* assume no error will occur */

    nvram_set("pppoe_idletime", ac->params[0].value);
    nvram_commit();

    return success;
}


int WANPPPConnection_RequestConnection(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
{
    char tmp[100];

    /* should probably confirm that the pppoe_username and ppoe_passwd
       are set here. */
    nvram_set(igd_pri_wan_var(tmp, sizeof(tmp), "proto"), "pppoe");
    nvram_commit();
    pppoe_up();
    
    return TRUE;
}

int WANPPPConnection_ForceTermination(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
{
    pppoe_down();
    
    return TRUE;
}


int WANPPPConnection_SetConnectionType(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs)
/*     "SetConnectionType", WANPPPConnection_SetConnectionType, */
{
    snprintf(psvc->vars[VAR_ConnectionType].value, sizeof(psvc->vars[VAR_ConnectionType].value), ac->params[0].value);

    return TRUE;
}
