/*
    Copyright 2001-2003, Broadcom Corporation   
    All Rights Reserved.   
       
    THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY   
    KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM   
    SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS   
    FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.   

    This file was automatically generated by xml2c.pl
*/


#include "upnp_dbg.h"
#include "upnp_osl.h"
#include "upnp.h"
#include "igd.h"
#include "wanipc.h"
#include "wanppp.h"
#include "wandsllink.h"
#include <sys/sysinfo.h>
#include <sys/ioctl.h>  /* ioctl */
/* dmt status */
#include <linux/tc3162dmtctrl.h>
/* 

    Below you will find definitions for a number of Action structures.
    The second argument to those structures is a pointer to a function
    that implements that action.  Your job is to define all of the
    actions so that none of them is left unimplemented.

    As a convenience, all generated actions have been predefined to
    invoke the action 'NotImplemented', an action that will print an
    error message whenever it is invoked.  As you define functions for
    each action, be sure to remove that function name from the list of
    'NotImplemented' defines in the list below.
    
    The following are pre-defined action functions that you can use:

    NotImplemented - prints an error message on the console 
                     and returns 0 parameters to the caller.

    DefaultAction  - Returns all 'out' parameters with values
                     taken from the corresponding 'relatedStateVariable'.
                     This function actually covers the behavior of 
                     a surprisingly large number of UPnP actions.

*/

extern int WANPPPConnection_ConfigureConnection(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
extern int WANPPPConnection_SetIdleDisconnectTime(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
extern int WANPPPConnection_RequestConnection(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
extern int WANPPPConnection_ForceTermination(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
extern int WANPPPConnection_SetConnectionType(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
extern int GetGenericPortMappingEntry(UFILE *, PService , PAction, pvar_entry_t , int );
extern int GetSpecificPortMappingEntry(UFILE *, PService , PAction, pvar_entry_t , int);
extern int AddPortMapping(UFILE *, PService, PAction, pvar_entry_t, int);
extern int DeletePortMapping(UFILE *, PService, PAction, pvar_entry_t, int);

#define GetConnectionTypeInfo DefaultAction
#define GetLinkLayerMaxBitRates DefaultAction
#define GetNATRSIPStatus DefaultAction
#define GetUserName DefaultAction
#define GetPassword DefaultAction
#define GetStatusInfo DefaultAction
#define GetIdleDisconnectTime DefaultAction
#define GetExternalIPAddress DefaultAction

/* VAR_ offsets are include from wanppp.h */


char *WANPPPConnection_PossibleConnectionTypes_allowedValueList[] = { "Unconfigured", "IP_Routed", "DHCP_Spoofed", "PPPOE_Bridged", "PPTP_Relay", "L2TP_Relay", "PPOE_Relay", NULL };
static char *ConnectionStatus_allowedValueList[] = { "Unconfigured", "Connecting", "Authenticating", "Connected", "PendingDisconnect", "Disconnecting", "Disconnected", NULL };
static char *LastConnectionError_allowedValueList[] = { "ERROR_NONE", "ERROR_UNKNOWN", NULL };
static char *PortMappingProtocol_allowedValueList[] = { "TCP", "UDP", NULL };


static VarTemplate StateVariables[] = {
    { "ConnectionType", "IP_Routed", VAR_STRING|VAR_LIST,  (allowedValue) { WANPPPConnection_PossibleConnectionTypes_allowedValueList }  },
    { "PossibleConnectionTypes", "", VAR_EVENTED|VAR_STRING|VAR_LIST,  (allowedValue) { WANPPPConnection_PossibleConnectionTypes_allowedValueList } },
    { "ConnectionStatus", "Unconfigured", VAR_EVENTED|VAR_STRING|VAR_LIST,  (allowedValue) { ConnectionStatus_allowedValueList } },
    { "Uptime", "", VAR_ULONG },
    { "UpstreamMaxBitRate", "10000000", VAR_ULONG },
    { "DownstreamMaxBitRate", "10000000", VAR_ULONG },
    { "LastConnectionError", "", VAR_STRING|VAR_LIST,  (allowedValue) { LastConnectionError_allowedValueList } },
    { "IdleDisconnectTime", "", VAR_ULONG },
    { "RSIPAvailable", "1", VAR_BOOL },
    { "NATEnabled", "1", VAR_BOOL },
    { "UserName", "", VAR_STRING },
    { "Password", "", VAR_STRING },
    { "ExternalIPAddress", "", VAR_EVENTED|VAR_STRING },
    { "PortMappingNumberOfEntries", "", VAR_EVENTED|VAR_USHORT },
    { "PortMappingEnabled", "", VAR_BOOL },
    { "PortMappingLeaseDuration", "", VAR_ULONG },
    { "RemoteHost", "", VAR_STRING },
    { "ExternalPort", "", VAR_USHORT },
    { "InternalPort", "", VAR_USHORT },
    { "PortMappingProtocol", "", VAR_STRING|VAR_LIST,  (allowedValue) { PortMappingProtocol_allowedValueList } },
    { "InternalClient", "", VAR_STRING },
    { "PortMappingDescription", "", VAR_STRING },

    { NULL }
};


static Action _SetConnectionType = {
    "SetConnectionType", WANPPPConnection_SetConnectionType,
   (Param []) {
       {"NewConnectionType", VAR_ConnectionType, VAR_IN},
       { 0 }
    }
};

static Action _GetConnectionTypeInfo = {
    "GetConnectionTypeInfo", GetConnectionTypeInfo,
   (Param []) {
       {"NewConnectionType", VAR_ConnectionType, VAR_OUT},
       {"NewPossibleConnectionTypes", VAR_PossibleConnectionTypes, VAR_OUT},
       { 0 }
    }
};

static Action _ConfigureConnection = {
    "ConfigureConnection", WANPPPConnection_ConfigureConnection,
   (Param []) {
       {"NewUserName", VAR_UserName, VAR_IN},
       {"NewPassword", VAR_Password, VAR_IN},
       { 0 }
    }
};

static Action _RequestConnection = {
    "RequestConnection", WANPPPConnection_RequestConnection,
   (Param []) {
       { 0 }
    }
};

static Action _ForceTermination = {
    "ForceTermination", WANPPPConnection_ForceTermination,
   (Param []) {
       { 0 }
    }
};

static Action _SetIdleDisconnectTime = {
    "SetIdleDisconnectTime", WANPPPConnection_SetIdleDisconnectTime,
   (Param []) {
       {"NewIdleDisconnectTime", VAR_IdleDisconnectTime, VAR_IN},
       { 0 }
    }
};

static Action _GetStatusInfo = {
    "GetStatusInfo", GetStatusInfo,
   (Param []) {
       {"NewConnectionStatus", VAR_ConnectionStatus, VAR_OUT},
       {"NewLastConnectionError", VAR_LastConnectionError, VAR_OUT},
       {"NewUptime", VAR_Uptime, VAR_OUT},
       { 0 }
    }
};

static Action _GetLinkLayerMaxBitRates = {
    "GetLinkLayerMaxBitRates", GetLinkLayerMaxBitRates,
   (Param []) {
       {"NewUpstreamMaxBitRate", VAR_UpstreamMaxBitRate, VAR_OUT},
       {"NewDownstreamMaxBitRate", VAR_DownstreamMaxBitRate, VAR_OUT},
       { 0 }
    }
};

static Action _GetUserName = {
    "GetUserName", GetUserName,
   (Param []) {
       {"NewUserName", VAR_UserName, VAR_OUT},
       { 0 }
    }
};

static Action _GetPassword = {
    "GetPassword", GetPassword,
   (Param []) {
       {"NewPassword", VAR_Password, VAR_OUT},
       { 0 }
    }
};

static Action _GetIdleDisconnectTime = {
    "GetIdleDisconnectTime", GetIdleDisconnectTime,
   (Param []) {
       {"NewIdleDisconnectTime", VAR_IdleDisconnectTime, VAR_OUT},
       { 0 }
    }
};

static Action _GetNATRSIPStatus = {
    "GetNATRSIPStatus", GetNATRSIPStatus,
   (Param []) {
       {"NewRSIPAvailable", VAR_RSIPAvailable, VAR_OUT},
       {"NewNATEnabled", VAR_NATEnabled, VAR_OUT},
       { 0 }
    }
};

static Action _GetGenericPortMappingEntry = {
    "GetGenericPortMappingEntry", GetGenericPortMappingEntry,
   (Param []) {
       {"NewPortMappingIndex", VAR_PortMappingNumberOfEntries, VAR_IN},
       {"NewRemoteHost", VAR_RemoteHost, VAR_OUT},
       {"NewExternalPort", VAR_ExternalPort, VAR_OUT},
       {"NewProtocol", VAR_PortMappingProtocol, VAR_OUT},
       {"NewInternalPort", VAR_InternalPort, VAR_OUT},
       {"NewInternalClient", VAR_InternalClient, VAR_OUT},
       {"NewEnabled", VAR_PortMappingEnabled, VAR_OUT},
       {"NewPortMappingDescription", VAR_PortMappingDescription, VAR_OUT},
       {"NewLeaseDuration", VAR_PortMappingLeaseDuration, VAR_OUT},
       { 0 }
    }
};

static Action _GetSpecificPortMappingEntry = {
    "GetSpecificPortMappingEntry", GetSpecificPortMappingEntry,
   (Param []) {
       {"NewRemoteHost", VAR_RemoteHost, VAR_IN},
       {"NewExternalPort", VAR_ExternalPort, VAR_IN},
       {"NewProtocol", VAR_PortMappingProtocol, VAR_IN},
       {"NewInternalPort", VAR_InternalPort, VAR_OUT},
       {"NewInternalClient", VAR_InternalClient, VAR_OUT},
       {"NewEnabled", VAR_PortMappingEnabled, VAR_OUT},
       {"NewPortMappingDescription", VAR_PortMappingDescription, VAR_OUT},
       {"NewLeaseDuration", VAR_PortMappingLeaseDuration, VAR_OUT},
       { 0 }
    }
};

static Action _AddPortMapping = {
    "AddPortMapping", AddPortMapping,
   (Param []) {
       {"NewRemoteHost", VAR_RemoteHost, VAR_IN},
       {"NewExternalPort", VAR_ExternalPort, VAR_IN},
       {"NewProtocol", VAR_PortMappingProtocol, VAR_IN},
       {"NewInternalPort", VAR_InternalPort, VAR_IN},
       {"NewInternalClient", VAR_InternalClient, VAR_IN},
       {"NewEnabled", VAR_PortMappingEnabled, VAR_IN},
       {"NewPortMappingDescription", VAR_PortMappingDescription, VAR_IN},
       {"NewLeaseDuration", VAR_PortMappingLeaseDuration, VAR_IN},
       { 0 }
    }
};

static Action _DeletePortMapping = {
    "DeletePortMapping", DeletePortMapping,
   (Param []) {
       {"NewRemoteHost", VAR_RemoteHost, VAR_IN},
       {"NewExternalPort", VAR_ExternalPort, VAR_IN},
       {"NewProtocol", VAR_PortMappingProtocol, VAR_IN},
       { 0 }
    }
};

static Action _GetExternalIPAddress = {
    "GetExternalIPAddress", GetExternalIPAddress,
   (Param []) {
       {"NewExternalIPAddress", VAR_ExternalIPAddress, VAR_OUT},
       { 0 }
    }
};



static PAction Actions[] = {
    &_SetConnectionType,
    &_GetConnectionTypeInfo,
    &_ConfigureConnection,
    &_RequestConnection,
    &_ForceTermination,
    &_SetIdleDisconnectTime,
    &_GetStatusInfo,
    &_GetLinkLayerMaxBitRates,
    &_GetUserName,
    &_GetPassword,
    &_GetIdleDisconnectTime,
    &_GetNATRSIPStatus,
    &_GetGenericPortMappingEntry,
    &_GetSpecificPortMappingEntry,
    &_AddPortMapping,
    &_DeletePortMapping,
    &_GetExternalIPAddress,
    NULL
};

int WANDSLConnection_GetVar(struct Service *psvc, int varindex)
{
	   struct StateVar *var;
    char **p, *cur;
    int len,nFd;
	Load_Router_Status();

    var = &(psvc->vars[varindex]);
  //  DPRINTF("WANDSLCOnnection_varindex:%d\n",varindex);
    switch (varindex) {
    case    VAR_GetDSLLinkInfo:
	    {
	    
	    nFd = open( "/dev/dmtdev", O_RDWR );
	if( nFd == -1  )
	{
		//DPRINTF("get_atm_status:severe error for open /dev/dmtdev for ADSL device\n");
		return FALSE;
	}

	DMTCTRL_DMT_INFO Arg;
        ioctl( nFd, DMTIOCTL_GET_DMT_INFO, &Arg );
	close(nFd);
	if(Arg.dmt_status==ADSL_UP)
	       strcpy(var->value,"Up");
       	else
	       strcpy(var->value,"Down");
       break;
	    }
    case VAR_GetAutoConfig:
	    strcpy(var->value,"1");
	    break;
    }
    return TRUE;
}

static VarTemplate StateVariables_DSL[] = {
    { "NewSetDSLLinkType", "", VAR_STRING },
    { "LinkStatus", "", VAR_EVENTED|VAR_STRING },
    { "AutoConfig", "1", VAR_EVENTED|VAR_BOOL },
    { NULL }
};

int SetDSLLinkType(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs );
int GetDSLLinkInfo(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);
int GetAutoConfig(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs);

int SetDSLLinkType(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs){
}
int GetDSLLinkInfo(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs){
}
int GetAutoConfig(UFILE *uclient, PService psvc, PAction ac, pvar_entry_t args, int nargs){
}

static Action _SetDSLLinkType = {
    "SetDSLLinkType", SetDSLLinkType,
   (Param []) {
       {"NewSetDSLLinkType", VAR_SetDSLLinkType, VAR_IN},
       { 0 }
    }
};

static Action _GetDSLLinkInfo = {
    "GetDSLLinkInfo", GetDSLLinkInfo,
   (Param []) {
       {"GetDSLLinkInfo", VAR_GetDSLLinkInfo, VAR_OUT},
       { 0 }
    }
};
static Action _GetAutoConfig = {
    "GetAutoConfig", GetAutoConfig,
   (Param []) {
       {"GetAutoConfig", VAR_GetAutoConfig, VAR_OUT},
       { 0 }
    }
};

static PAction Actions_DSL[] = {
    &_SetDSLLinkType,
    &_GetDSLLinkInfo,
    &_GetAutoConfig,
    NULL
//    &_GetModulationType,
//    &_SetDestinationAddress,
//    &_GetDestinationAddress,
//    &_SetATMEncapsulcation,
//    &_GetATMEncapsulcation,
//    &_SetFCSPreserved,

};
struct DSLLinkConfig {
    struct Service *default_svc;
};

static int DSLLinkConfig_Init(PService psvc, service_state_t state)
{
    struct DSLLinkConfig *pdata;

    switch (state) {
    case SERVICE_CREATE:
	pdata = (struct DSLLinkConfig *) malloc(sizeof(struct DSLLinkConfig));
	if (pdata) {
	    memset(pdata, 0, sizeof(struct DSLLinkConfig));
	    pdata->default_svc = NULL;
	    psvc->opaque = (void *) pdata;
	}
	break;
    case SERVICE_DESTROY:
	pdata = (struct DSLLinkConfig *) psvc->opaque;
	free(pdata);
	break;
    } /* end switch */

    return 0;
}
ServiceTemplate Template_DSLLinkConfig = {
    "WANDSLLinkConfig:1",	/* name of service */
    DSLLinkConfig_Init,		/* PFSVCINIT service initialization function */
    WANDSLConnection_GetVar,		/* PFGETVAR get service state variable function */
    NULL,		/* SVCXML service XML generation function (not used) */
    ARRAYSIZE(StateVariables_DSL)-1, /* number of state variables */
    StateVariables_DSL,     /* pointer to list of state variables */
    Actions_DSL,             /* pointer to list of actions */
    0,			/* count */
    "urn:upnp-org:serviceId:WANDSLLinkConn",	/* service id */
    NULL		/* schema */
};


extern int igd_config_generation;
/* this is run once a second from WANPPPConnection_Update. */
static bool update_connection_status(PService psvc)
{
    PWANPPPConnectionData pdata = (PWANPPPConnectionData) psvc->opaque;
    PWANDevicePrivateData pdevdata = (PWANDevicePrivateData) psvc->device->parent->opaque;
    ip_conn_t old_status = pdata->connection_status;
    bool wan_connected;
    struct sysinfo info;
    wan_connected = osl_wan_isup(pdevdata->ifname);
    switch (pdata->connection_status) {
    case IP_CONNECTING: 
	{
	    if (wan_connected) {
		pdata->connection_status = IP_CONNECTED;
		//pdata->connected_time = time(NULL);
		sysinfo(&info);
		pdata->connected_time = (time_t)info.uptime;	// by honor, use uptime rather than system time 
	    } else if (pdata->connection_timeout-- <= 0) {
		pdata->connection_status = IP_DISCONNECTED;
	    }
	}
	break;

    case IP_CONNECTED: 
	{
	    if (!wan_connected) {
		pdata->connection_status = IP_DISCONNECTED;
	    } 
	}
	break;
    case IP_DISCONNECTING: 
	{
	    if (wan_connected) {
		pdata->connection_status = IP_CONNECTING;
	    } else {
		pdata->connection_status = IP_DISCONNECTED;
	    }
	}
	break;
	
    case IP_DISCONNECTED: 
	{
	    if (wan_connected) {
		pdata->connection_status = IP_CONNECTING;
	    }
	}
	break;
    default:
	fprintf(stderr,"%s:%d Unexpected connection_status %d\n", __FILE__, __LINE__, pdata->connection_status);
    }

    if (old_status != pdata->connection_status)
	mark_changed(psvc, VAR_ConnectionStatus);

    return (old_status != pdata->connection_status);
}
static bool update_external_address(PService psvc)
{
    PWANPPPConnectionData pdata = (PWANPPPConnectionData) psvc->opaque;
    PWANDevicePrivateData pdevdata = (PWANDevicePrivateData) psvc->device->parent->opaque;
    struct in_addr ipaddr = {0} ;
    //fprintf(stderr,"update_external_address\n");

    if (osl_wan_isup(pdevdata->ifname)) {
	    
	osl_ifaddr(pdevdata->ifname, &ipaddr);
	//DPRINTF("1.ppp:wan_ipipaddr:%x\n",ipaddr);
    }
    if (pdata->external_ipaddr.s_addr != ipaddr.s_addr) {
	    //DPRINTF("2.ppp:wan_ip:ipaddr:%x\n",ipaddr);
	pdata->external_ipaddr = ipaddr;
	mark_changed(psvc, VAR_ExternalIPAddress);
    }

    return (pdata->external_ipaddr.s_addr != ipaddr.s_addr);
}
static void WANPPPConnection_Update(timer_t t, PService psvc)
{
	//DPRINTF("wanppp.c 186 WANPPPConnection_Update\n");
    PWANPPPConnectionData pdata = (PWANPPPConnectionData) psvc->opaque;

    if (igd_config_generation != pdata->igd_generation) {
	pdata->igd_generation = igd_config_generation;
	mapmgr_update();
	if (pdata->nportmappings != mapmgr_port_map_count()) {
	    pdata->nportmappings = mapmgr_port_map_count();
	    mark_changed(psvc, VAR_PortMappingNumberOfEntries);
	}
    }

    update_external_address(psvc);
    update_connection_status(psvc);

    if ((psvc->flags & VAR_CHANGED) == VAR_CHANGED) {
	update_all_subscriptions(psvc);
    }
}

static int WANPPPConnectionInit(struct Service *psvc, service_state_t state)
{
    struct  itimerspec  timer;
    PWANPPPConnectionData pdata;
    PWANDevicePrivateData pdevdata;	
    struct sysinfo info;

//DPRINTF("WANPPPConnectionInit\n");

    fprintf(stderr,"WANPPPConnectionInit\n");
    switch (state) {
    case SERVICE_CREATE:
	pdevdata = (PWANDevicePrivateData) psvc->device->parent->opaque;
	pdata = (PWANPPPConnectionData) malloc(sizeof(WANPPPConnectionData));
	if (pdata) {
	    memset(pdata, 0, sizeof(WANPPPConnectionData));
	    pdata->connection_status = IP_CONNECTING;
	    //pdata->connected_time = time(NULL);
	    sysinfo(&info);
	    pdata->connected_time = info.uptime;	// by honor, use uptime rather than system time
	    pdata->igd_generation = igd_config_generation;
	    upnp_table_init();	
	    mapmgr_update();
	    pdata->nportmappings = mapmgr_port_map_count();
	    
	    osl_ifaddr(pdevdata->ifname, &pdata->external_ipaddr);
	    psvc->opaque = (void *) pdata;
	    
	    /* once a second we want to update the statistics variables in the WANIPConnection service */
	    memset(&timer, 0, sizeof(timer));
	    timer.it_interval.tv_sec = 2;
	    timer.it_value.tv_sec = 2;
	    pdata->eventhandle = enqueue_event(&timer, (event_callback_t)WANPPPConnection_Update, (void *) psvc );
	}
	break;

    case SERVICE_DESTROY:
	pdata = (PWANPPPConnectionData) psvc->opaque;
	
	timer_delete(pdata->eventhandle);
	free(pdata);
	break;
    } /* end switch */

    return 0;
}




ServiceTemplate Template_WANPPPConnection = {
    "WANPPPConnection:1",	/* name of service */
WANPPPConnectionInit,/* PFSVCINIT service initialization function */
//    NULL,		/* PFSVCINIT service initialization function */
    WANPPPConnection_GetVar,		/* PFGETVAR get service state variable function */
    NULL,		/* SVCXML service XML generation function (not used) */
    ARRAYSIZE(StateVariables)-1, /* number of state variables */
    StateVariables,     /* pointer to list of state variables */
    Actions,             /* pointer to list of actions */
    0,			/* count */
    "urn:upnp-org:serviceId:WANPPPConn",	/* service id */
    NULL		/* schema */
};
