/*
 *  apply.c: use to restart functions besides on affected ones.
 */
#include "webs.h"
#include "applyAffected.h"
#include "scripts.h"

typedef struct {
    char *restartScriptFile;
    //void *restart
    unsigned long type;
}   RESTART_FUNC;

extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
// NOTE, the DMZ, VS, and PF shall be in the last 3 and in order.  Then, follow the function will accept packets...

//#define MAX_RESTART_FUNC 32  : the length of bit fields of an "unigned long"
static RESTART_FUNC retart_func[] = {
    {TIMEZONE_SCRIPT_FILE,        TYPE_TIMEZONE},
    {DDNS_SCRIPT_FILE,          TYPE_DDNS},
    {ROUTE_SCRIPT_FILE,          TYPE_ROUTE},
    {URL_FILTER_SCRIPT_FILE,          TYPE_URL_FILTER},
    {MAC_FILTER_SCRIPT_FILE,          TYPE_MAC_FILTER},
    {IP_QOS_SCRIPT_FILE,          TYPE_IP_QOS},
     {BLK_WAN_SCRIPT_FILE,          TYPE_BLOCK_WAN},
   {BLK_HACK_SCRIPT_FILE,          TYPE_HACK_ATTACK},
   {REMOTE_CONTORL_SCRIPT_FILE,          TYPE_REMOTE_CONTORL},
   {UPNP_SCRIPT_FILE,          TYPE_UPNP},
    {SNMPD_SCRIPT_FILE,          TYPE_SNMP},
   {RIP_SCRIPT_FILE,          TYPE_RIP},
   {VLAN_SCRIPT_FILE,          TYPE_VLAN},
    {VS_SCRIPT_FILE,          TYPE_VIRTURL_SERVER},
  {DMZ_SCRIPT_FILE,          TYPE_DMZ},
     {PACKET_FILTER_SCRIPT_FILE,          TYPE_PACKET_FILTER},
   {TMSS_SCRIPT_FILE,          TYPE_TMSS},  // will accept packages, so it shall put after the packet filter.
   {SIP_SCRIPT_FILE,          TYPE_SIP}  // will accept packages, so it shall put after the packet filter.
 };

void restartAffectedFunctions(int type_sum)
{
	int MAX_RESTART_FUNC=sizeof(retart_func)/sizeof(RESTART_FUNC);
	int i;
	for(i=0;i<MAX_RESTART_FUNC;i++)
	{
		if(retart_func[i].type&type_sum)
		{
		run_script(retart_func[i].restartScriptFile,"restart",0,0);
	}
}
}
		
