/*
 *  arp.asp: ARP Configuration
 */
#include "webs.h"
#include "arp.h"
#include "locale.h"
extern char *Arp_L1[];
extern char *Arp_L2[];
extern char *Arp_L3[];
extern char *Arp_L4[];
extern char *Arp_L5[];

static int arp_config_num = 0;
static int show_arp_status (int ejid, webs_t wp, int argc, char_t **argv);

static int get_static_arp_num(int ejid, webs_t wp, int argc, char_t **argv)
{
	int i;
	Load_Arp_Config();
	
	i = atoi(argv[0]);

	return websWrite(wp, T("%d"), arp_config_num+i);
}

static int get_static_arp_status(int ejid, webs_t wp, int argc, char_t **argv)
{
	int i;
	Load_Arp_Config();
	
	i = atoi(argv[1])-1;
	if(!strcmp(argv[0], "IP_Address"))
		return websWrite(wp, T("%s"), arp_config[i].IP);
	else if(!strcmp(argv[0], "MAC_Address"))
		return websWrite(wp, T("%s"), arp_config[i].HW_Address);
	else
		return websWrite(wp, T(""));
}

static int check_if_name(char *name,char *name1)
{
    char *namelist[] = { "br0", "br10", "br1", "br2", "br3",
			 "vlan2", "vlan3", "vlan4", "vlan5"};
    char *toname[] = { "iplan", "ipvod1","ipvod2","ipvod3","ipvod4",
		       "ipport1", "ipport2", "ipport3", "ipport4"};
    int i;

    //DPRINTF("size  %d \n", sizeof(namelist)/sizeof(char*));

    for(i=0;i<sizeof(namelist)/sizeof(char*);i++){
	if( !strcmp(name, namelist[i]) ){
	    strcpy(name1, toname[i]);
	    return 1; // OK
	}
    }
    return 0; // ERROR
}

static int show_arp_status (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *fp;
	char_t line[255];
//	char_t buf[64];
	char toname[32]={0};
	int i,num=0;
	if((fp=fopen(SYS_ARP_CONF,"r"))!=0){
		fgets(line, 1024, fp);
		for(i=0;i<MAX_ARP;i++){	
			if(fgets(line, 1024, fp)){
				num++;
			sscanf(line,"%s %s %s %s %s %s\n",
				arp_config[i].IP,
				arp_config[i].HW_Type,
				arp_config[i].Flags,
				arp_config[i].HW_Address,
				arp_config[i].Mask,
				arp_config[i].Device);
			}
	#if 0	
	DPRINTF("\ni:%d\n",i);
	DPRINTF("d->Iface:%s\n",route_config1[i].Iface);
	DPRINTF("d->Destination:%s\n",route_config1[i].Destination);
	DPRINTF("d->Gateway:%s\n",route_config1[i].Gateway);
	DPRINTF("d->Flags:%s\n",route_config1[i].Flags);
	DPRINTF("d->RefCnt:%s\n",route_config1[i].RefCnt);
	DPRINTF("d->Use:%s\n",route_config1[i].Use);
	DPRINTF("d->Metric:%s\n",route_config1[i].Metric);
	DPRINTF("d->Mask:%s\n",route_config1[i].Mask);
	DPRINTF("d->MTU:%s\n",route_config1[i].MTU);
	DPRINTF("d->Window:%s\n",route_config1[i].Window);
	DPRINTF("d->IRTT:%s\n",route_config1[i].IRTT);
	#endif
	}
	fclose(fp);
	}
	
	char_t *TableFmt="\t<tr>\n\t<td><nobr>%s</nobr></td>\n"
			 "\t<td><nobr>%s</nobr></td>\n"
			 "\t<td><nobr>%s</nobr></td>\n"
			 "\t<td><nobr>%s</nobr></td>\n\t</tr>\n";

	for (i=0;i<num;i++) {
		//websWrite(wp, T(TableFmt),arp_config[i].IP,arp_config[i].HW_Address,(!strcmp(arp_config[i].Device,"br0")) ? "iplan" : "ipwan",Arp_L1[locale_config.locale]);
	 	/* KenWang modified 2006/07/12 for static arp -- begin -- */
		if(check_if_name(arp_config[i].Device, toname)){
			//websWrite(wp, T(TableFmt),arp_config[i].IP,arp_config[i].HW_Address, toname, Arp_L1[locale_config.locale]);
			websWrite(wp, T(TableFmt),
					arp_config[i].IP,
					arp_config[i].HW_Address, toname, 
					(atoi(arp_config[i].Flags+2)&0x4)?Arp_L2[locale_config.locale]:Arp_L1[locale_config.locale]);
		}else{
			//websWrite(wp, T(TableFmt),arp_config[i].IP,arp_config[i].HW_Address, "ipwan", Arp_L1[locale_config.locale]);
			websWrite(wp, T(TableFmt),
					arp_config[i].IP,
					arp_config[i].HW_Address, 
					"ipwan", 
					(atoi(arp_config[i].Flags+2)&0x4)?Arp_L2[locale_config.locale]:Arp_L1[locale_config.locale]);
		}
		/* KenWang modified 2006/07/12 for static arp -- end -- */
	}
	return 1;
}

static void resetCurrentArpCfg(void)
{
	memset(arp_config, 0, sizeof(ARP_CONFIG_DATA));
}

void Load_Arp_Config(void)
{
	FILE *fp;
	int i = 0, ret = 0;
	char_t line[1024];
	resetCurrentArpCfg();
	if((fp=fopen(ARP_CONFIG_FILE,"r"))!=NULL) 
	{
		while (fgets(line, 1024, fp)) 
		{
			ret = sscanf(line, "|%20[^|]|%20[^|]|\n",
				     arp_config[i].IP,
				     arp_config[i].HW_Address);
			print_blank_string(arp_config[i].IP);
			print_blank_string(arp_config[i].HW_Address);
			if(ret == 2) i++;
		}
		arp_config_num = i;
		fclose(fp);
	}	
}

void Save_Arp_Config(void)
{
	FILE *fp;
	int i=0;
	if((fp=fopen(ARP_CONFIG_FILE,"w"))!=NULL)
	{
		for(i=0;i<arp_config_num;i++) 
		{
			load_blank_string(arp_config[i].IP);
			load_blank_string(arp_config[i].HW_Address);
			if(strcmp(arp_config[i].IP, "&") != 0)
			{
				fprintf(fp, "|%s|%s|\n",
					    arp_config[i].IP,
					    arp_config[i].HW_Address);
			}
		}
		fclose(fp);
	}
}

static int read_static_arp(int ejid, webs_t wp, int argc, char_t **argv)
{
	int i;
	char_t *TableFmt="<tr>\n"
			"\t<td><nobr>%d</nobr></td>\n"
			"\t<td><nobr>%s</nobr></td>\n"
			"\t<td><nobr>%s</nobr></td>\n"
			"\t<form name=arpedit action=static_arp_edit.asp method=post>\n"
			"\t\t<INPUT type=hidden name=arpid value=%d>\n"
			"\t\t<td><nobr><a href=\"javascript:arp_edit(%d)\">%s"
			"<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			"\t</form>\n"
			"\t<form name=arpdelete action=static_arp_delete.asp method=post>\n"
			"\t\t<INPUT type=hidden name=arpid value=%d>\n"
			"\t\t<td><nobr><a href=\"javascript:arp_delete(%d)\">%s"
			"<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			"\t</form>\n"
		        "\t</tr>\n";
	char_t *TableFmt1 = "\t<TR>\n"
			    "\t\t<TD colSpan=5>\n"
			    "\t\t<BR>\n"
			    "\t\t\t<A href=\"static_arp_create.asp\">%s"
			    "<IMG align=middle border=0 src=\"/link1.gif\"></A>\n"
			    "\t\t</TD>\n\t<TR>\n";


	Load_Arp_Config();
	for (i=0;i<arp_config_num;i++){
			websWrite(wp, T(TableFmt),
			i+1,
			arp_config[i].IP,
			arp_config[i].HW_Address,
			i,
			i,
			Arp_L3[locale_config.locale],
			i,
			i,
			Arp_L4[locale_config.locale]
			);
	       }
	// KenWang added 2005/05/17: show "Create" if webpage if contents of static route is less then 20
	if(arp_config_num < MAX_ARP)
	{
		websWrite(wp, T(TableFmt1),Arp_L5[locale_config.locale]);
				 
	}
	return 0;
}

void form_arp_add_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
	Load_Arp_Config(); 	

	buf=websGetVar(wp, T("arpid"), "");
        rulenum=atoi(buf)-1;
	
	buf=websGetVar(wp, T("IP_Address"), "");
        strcpy(arp_config[rulenum].IP,buf);
        
	buf=websGetVar(wp, T("MAC_Address"),"0");
        strcpy(arp_config[rulenum].HW_Address,buf);

	arp_config_num++;

	Save_Arp_Config();
	run_task("/usr/sbin/arp", "/usr/sbin/arp", "-s", arp_config[rulenum].IP, arp_config[rulenum].HW_Address, NULL);
	websRedirect(wp,T("StaticArp.asp"));	
}

void form_arp_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
   	
	buf=websGetVar(wp, T("arpid"), "");
        rulenum=atoi(buf)-1;
	run_task("/usr/sbin/arp", "/usr/sbin/arp", "-d", arp_config[rulenum].IP, NULL);
	
	buf=websGetVar(wp, T("IP_Address"), "");
        strcpy(arp_config[rulenum].IP,buf);
                   	       
	buf=websGetVar(wp, T("MAC_Address"), "");
        strcpy(arp_config[rulenum].HW_Address,buf);
	
	Save_Arp_Config();
	run_task("/usr/sbin/arp", "/usr/sbin/arp", "-s", arp_config[rulenum].IP, arp_config[rulenum].HW_Address,NULL);
	websRedirect(wp,T("StaticArp.asp"));	
}

void form_arp_delete_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
   	
	buf=websGetVar(wp, T("arpid"), "");
        rulenum=atoi(buf)-1;
	
	run_task("/usr/sbin/arp", "/usr/sbin/arp", "-d", arp_config[rulenum].IP, NULL);

        strcpy(arp_config[rulenum].IP,"");
                   	       
        strcpy(arp_config[rulenum].HW_Address,"");

	Save_Arp_Config();
	arp_config_num--;
	websRedirect(wp,T("StaticArp.asp"));	
}

static int get_static_arp_js (int ejid, webs_t wp, int argc, char_t **argv)
{
	if (arp_config_num==0)
		websWrite(wp,T(""));
	else if (arp_config_num==1){
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction arp_edit(){\n"));
		websWrite(wp,T("\t\t\tdocument.arpedit.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction arp_delete(){\n"));
		websWrite(wp,T("\t\t\tdocument.arpdelete.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	else{
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction arp_edit(t){\n"));
		websWrite(wp,T("\t\t\tdocument.arpedit[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction arp_delete(t){\n"));
		websWrite(wp,T("\t\t\tdocument.arpdelete[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	return 0;
}

void DefineWebFunctions_arp()
{
	websAspDefine(T("show_arp_status"), show_arp_status);
	websAspDefine(T("read_static_arp"), read_static_arp);
	websAspDefine(T("get_static_arp_num"), get_static_arp_num);
	websAspDefine(T("get_static_arp_js"), get_static_arp_js);
	websAspDefine(T("get_static_arp_status"), get_static_arp_status);
	websFormDefine(T("arpadd"), form_arp_add_conf);
	websFormDefine(T("arpedit"), form_arp_edit_conf);
	websFormDefine(T("arpdelete"), form_arp_delete_conf);
}
