/*
 *  blk_hack.htm: Intrusion Detection/Block Hack Pattern
 */
#include "webs.h"
#include "blk_hack.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

HACK_ATTCK_DATA blk_hack;

extern char WAN_IP[];
static int Load_BlockHack_Config (void);
static int Save_BlockHack_Config (HACK_ATTCK_DATA *d);
static void Init_Intrusion_Detection();
int Load_Intrusion_Detection_Config();
static void IntrusionDetection_Form(webs_t wp,char_t * path,char_t * query);
static int blkhack_Enable (int eid, webs_t wp, int argc, char_t ** argv);
static int Alert_CK (int eid, webs_t wp, int argc, char_t ** argv);
static int Alert_Mail_SendAddr (int eid, webs_t wp, int argc, char_t ** argv);
static int Alert_Mail_Addr (int eid, webs_t wp, int argc, char_t ** argv);
static int Alert_Mail_SMTP_Server (int eid, webs_t wp, int argc, char_t ** argv);
static int Alert_Time (int eid, webs_t wp, int argc, char_t ** argv);
static int Load_BlockHack_Config (void);
static int Save_BlockHack_Config (HACK_ATTCK_DATA *d);

  void resetCurrentHackAttckCfg(void)
{
	HACK_ATTCK_DATA *d=&blk_hack;
 	memset(d,0,sizeof(HACK_ATTCK_DATA));
	/*d->protectionEnabled=0;// nonActive
	d->alertEnabled=0;
    strcpy(d->sendaddr,"");
   strcpy(d->alertaddr,"");
    strcpy(d->alertsmtp,""); */
}

static int blkhack_Enable (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockHack_Config();
	if  (blk_hack.protectionEnabled==0) 
   		return websWrite(wp, T("0"));
  	else
  		return	websWrite(wp, T("1"));
}

static int Alert_CK (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockHack_Config();
	if (blk_hack.alertEnabled==1)
		return websWrite (wp, T ("checked"));
	else
		return websWrite (wp, T (""));
}
static int Alert_Mail_SendAddr (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockHack_Config();
	char_t psendaddr[128];
	strcpy(psendaddr,blk_hack.sendaddr);
//if (palertaddr!=NULL)
		return  websWrite (wp, T ("%s"), psendaddr);
//	else
//		return  websWrite (wp, T ("%s"), "");
}

static int Alert_Mail_Addr (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockHack_Config();
	char_t palertaddr[128];
	strcpy(palertaddr,blk_hack.alertaddr);
//if (palertaddr!=NULL)
		return  websWrite (wp, T ("%s"), palertaddr);
//	else
//		return  websWrite (wp, T ("%s"), "");
}

static int Alert_Mail_SMTP_Server (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockHack_Config();
	char_t palertsmtp[128];
	strcpy(palertsmtp,blk_hack.alertsmtp);
	//if (palertsmtp==NULL)
		return  websWrite (wp, T ("%s"), palertsmtp);
	//else
	//	return  websWrite (wp, T ("%s"), "");
}

static int Alert_Time (int eid, webs_t wp, int argc, char_t ** argv){
	
	Load_BlockHack_Config();
	return  websWrite (wp, T ("%d"), blk_hack.alerttime);
}
static void IntrusionDetection_Form (webs_t wp,char_t * path, char_t * query)
{
	char_t *pTimeBlkHack;
	char_t *pEnableBlkHack;
	char_t *psendaddr;
	char_t *palertck;
	char_t *palertaddr;
	char_t *palertsmtp;
	HACK_ATTCK_DATA old_blk_hack;
	char funcNum[4];
	

	
	pEnableBlkHack = websGetVar(wp, T("EnableBlkHack"), "0");
	memcpy(&old_blk_hack,&blk_hack,sizeof(HACK_ATTCK_DATA));
 	blk_hack.protectionEnabled=atoi(pEnableBlkHack); 
	if (blk_hack.protectionEnabled==1)
	{
	palertck = websGetVar(wp, T("alertck"), "0");
	psendaddr = websGetVar(wp, T("sendaddr"), "");
	palertaddr = websGetVar(wp, T("alertaddr"), "");
	palertsmtp = websGetVar(wp, T("alertsmtp"), "");
	pTimeBlkHack = websGetVar(wp, T("alerttime"), "");
	
	blk_hack.alertEnabled=atoi(palertck);
		blk_hack.alerttime=atoi(pTimeBlkHack);
    	strcpy(blk_hack.sendaddr,psendaddr);
   	strcpy(blk_hack.alertaddr,palertaddr);
    	strcpy(blk_hack.alertsmtp,palertsmtp);
	}
	// Mulder added 2005-5-17 for avoiding to starting/stopping function
	if (memcmp(&old_blk_hack,&blk_hack,sizeof(HACK_ATTCK_DATA)) == 0)  
	{
		if(blk_hack.protectionEnabled==1)
			websRedirect(wp, T("blkhackEnable.asp"));
		else
			websRedirect(wp, T("blkhackDisable.asp"));
		return;
	}
	
	//move from after runFunc stop
	Save_BlockHack_Config (&blk_hack);
	// Decide to STOP the old ones.
        // Since the editing one and the using one is the same one, so we have to use the old config
        // to stop it before it be changed.	
	if(blk_hack.protectionEnabled!=old_blk_hack.protectionEnabled)
	{
		sprintf(funcNum,"%d",FUNCTION_NUM_BLOCK_HACK);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
		
 	}
	else
	{ // there is no change for protectionEnabled
		if( old_blk_hack.alertEnabled && 
		((blk_hack.alertEnabled!=old_blk_hack.alertEnabled)||
		(blk_hack.alerttime!=old_blk_hack.alerttime) ||
		(blk_hack.sendaddr!=old_blk_hack.sendaddr) ||
		(blk_hack.alertsmtp!=old_blk_hack.alertsmtp) ||
		(blk_hack.alertaddr!=old_blk_hack.alertaddr)) 
		)
		{ //stop only the ALERT MAIL
			char funcNum[4];
			sprintf(funcNum,"%d",FUNCTION_NUM_ALERT_MAIL_ONLY);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
		}
	}
	
	//move to before runFunc stop..
	//Save_BlockHack_Config (&blk_hack);
	if(blk_hack.protectionEnabled==1)
	{   //NOTE ONLY WHEN WAN INTERFACE is ready, then we start the function
		char_t str_wanip[20];
		char_t buf1[64];
		
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		if(isValidIP(str_wanip))
		{
			if(blk_hack.protectionEnabled!=old_blk_hack.protectionEnabled)
			{
				sprintf(funcNum,"%d",FUNCTION_NUM_BLOCK_HACK);
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			}
			else
			{ // there is no change for protectionEnabled
				if(blk_hack.alertEnabled)
				{ //only start the ALERT MAIL
					sprintf(funcNum,"%d",FUNCTION_NUM_ALERT_MAIL_ONLY);
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);		
				}
			}
		}
		//else running when wan_ip ready.		
		websRedirect(wp, T("blkhackEnable.asp"));
	}
	else
	{
/*	Can not do here since there may be a old delete problem
	if (isValidIP(str_wanip)){
			DPRINTF("str_wanip:%s\n",str_wanip);
		run_script(BLK_HACK_SCRIPT_FILE,"stop",0,0); 
		} */
   		websRedirect(wp, T("blkhackDisable.asp"));
	}
}

static int Load_BlockHack_Config (void)
{

	FILE *fp;

	resetCurrentHackAttckCfg();
	fp=fopen(BLK_HACK_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d %d %s %s %s\n",
				&blk_hack.protectionEnabled, 
				&blk_hack.alertEnabled, 
				&blk_hack.alerttime, 
				blk_hack.sendaddr, 
				blk_hack.alertaddr, 
				blk_hack.alertsmtp);
			if(blk_hack.sendaddr[0]=='&')
				blk_hack.sendaddr[0]='\0';
			if(blk_hack.alertaddr[0]=='&')
				blk_hack.alertaddr[0]='\0';
			if(blk_hack.alertsmtp[0]=='&')
				blk_hack.alertsmtp[0]='\0';
		fclose(fp);
	}
	return 0;
}

static int Save_BlockHack_Config (HACK_ATTCK_DATA *d)
{

	FILE *fp;

	fp=fopen(BLK_HACK_CFG_FILE,"w");
	if(!fp) {
		return -1;
	}			
	fprintf(fp,"%d %d %d %s %s %s\n",d->protectionEnabled,d->alertEnabled,d->alerttime,
	(d->sendaddr[0]=='\0')?"&":d->sendaddr,
	(d->alertaddr[0]=='\0')?"&":d->alertaddr,
	(d->alertsmtp[0]=='\0')?"&":d->alertsmtp);
	fflush(fp);
	fclose(fp);

	return 0;
}


static void Init_Intrusion_Detection()
{
	resetCurrentHackAttckCfg();  	
}

int Load_Intrusion_Detection_Config()
{
 	Load_BlockHack_Config();
	return 0;
}


void DefineWebFunctions_blkhack () {
	Init_Intrusion_Detection();
	Load_Intrusion_Detection_Config();
	websAspDefine(T("blkhack_Enable"), blkhack_Enable);
	websAspDefine(T("ALERT_CK"), Alert_CK);
	websAspDefine(T("SEND_ADDR"), Alert_Mail_SendAddr);
	websAspDefine(T("ALERT_ADDR"), Alert_Mail_Addr);
	websAspDefine(T("ALERT_SMTP"), Alert_Mail_SMTP_Server);
	websAspDefine(T("ALERT_TIME"), Alert_Time);
	websFormDefine(T("blkhack"), IntrusionDetection_Form);

}
