/*
 *  blockwan.htm: Block WAN Request
 */
#include "webs.h"
#include "lan_conf.h"
#include "wan.h"
#include "blockwan.h"
#include "../iptables-1.2.11/runFunc.h"

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

/*************************************************************/
/*      block hack Config File                               */
/*************************************************************/
extern void run_task(char *cmd, ...);
extern char WAN_IP[];
void resetCurrentBlockWanCfg(void);
static int Load_BlockWan_Config (void);
static int Save_BlockWan_Config (BLOCKWAN_CONFIG_DATA *d);
static void blockwan_Form(webs_t wp,char_t * path,char_t * query);
static int blockwan_Enable (int eid, webs_t wp, int argc, char_t ** argv);
static int get_blockwan_mod (int eid, webs_t wp, int argc, char_t ** argv);
static int blockwan_Enable (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_BlockWan_Config();
	
	if  (blockwan_config.block_wan==0) 
   		return websWrite(wp, T("0"));
  	else
  		return	websWrite(wp, T("1"));
}
static int get_blockwan_mod (int eid, webs_t wp, int argc, char_t ** argv)
{
	int i,j;
	Load_BlockWan_Config();
	i=atoi(argv[0]);
	j=blockwan_config.block_wan;
	if (i==j)
   		return websWrite(wp, T("checked"));
	else
   		return websWrite(wp, T(""));
		
	
}
static void blockwan_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char_t str_wanip[20];
	char_t buf1[20];
	char funcNum[4];
	Load_BlockWan_Config();
	
	buf = websGetVar(wp, T("BlockWAN"),"");

 	blockwan_config.block_wan=atoi(buf); 
	Save_BlockWan_Config(&blockwan_config);
	strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));

	sprintf(funcNum,"%d",FUNCTION_NUM_BLOCK_WAN);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	if ((isValidIP(str_wanip)) && (blockwan_config.block_wan==1))
	{   //NOTE ONLY WHEN WAN INTERFACE is ready, then we start the function
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);	
	}
	websRedirect(wp, T("blockwan.asp"));
}

void resetCurrentBlockWanCfg(void)
{
	BLOCKWAN_CONFIG_DATA *d=&blockwan_config;
 	d->block_wan=0;// nonActive
	d->block_wan_log=1;// not log
}

static int Load_BlockWan_Config (void)
{
	FILE *fp;
	resetCurrentBlockWanCfg();
	fp=fopen(BLK_WAN_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d\n",&blockwan_config.block_wan,&blockwan_config.block_wan_log);
		fclose(fp);
	}
	return 0;
}

static int Save_BlockWan_Config (BLOCKWAN_CONFIG_DATA *d)
{
	FILE *fp;
	fp=fopen(BLK_WAN_CFG_FILE,"w");
	if(fp) {
		fprintf(fp,"%d %d\n",d->block_wan,d->block_wan_log);
		fclose(fp);
	}
	return 0;
}

void DefineWebFunctions_blockwan() {
	websAspDefine(T("blockwan_Enable"), blockwan_Enable);
	websAspDefine(T("get_blockwan_mod"), get_blockwan_mod);
	websFormDefine(T("blockwan"), blockwan_Form);
}
