/*
 *  dhcp.asp: DHCP configuration
 */
#include "webs.h"
#include "lan_conf.h"
#include "dhcp.h"
#include "arp.h"
#include "filem.h"
#include "dns_conf.h"

#include "locale.h"
extern char *Dhcp_L1[];
extern char *Dhcp_L2[];
extern char *Dhcp_L3[];
extern char *Dhcp_L4[];
extern char *Dhcp_L5[];
extern char *Dhcp_L6[];
extern char *Dhcp_L7[];
extern char *Dhcp_L8[];
extern char *Dhcp_L9[];
extern char *Dhcp_L10[];
extern char *Dhcp_L11[];
extern char *Dhcp_L12[];
extern char *Dhcp_L13[];
extern char *Dhcp_L14[];
extern char *Dhcp_L15[];
extern char *Dhcp_L16[];
extern char *Dhcp_L17[];
extern char *Dhcp_L18[];
extern char *Dhcp_L19[];

//#define improvement
DHCPD_CONFIG_DATA dhcpd_config;
extern LAN_CONFIG_DATA lan_config;
extern void Load_Lan_Config (LAN_CONFIG_DATA *d);

static int get_dhcp_mod (int ejid, webs_t wp, int argc, char_t **argv);
static int get_dhcp_dns_mod (int ejid, webs_t wp, int argc, char_t **argv);
static int get_dhcp_status (int ejid, webs_t wp, int argc, char_t **argv);
static int get_fixed_dhcp (int ejid, webs_t wp, int argc, char_t **argv);
static int read_dhcp_status (int ejid, webs_t wp, int argc, char_t **argv);

static void form_dhcp_conf(webs_t wp, char_t * path,char_t * query);
static void form_dhcp_disable(webs_t wp, char_t * path,char_t * query);
static void form_dhcp_relay(webs_t wp, char_t * path,char_t * query);

static void resetCurrentDhcpdCfg(DHCPD_CONFIG_DATA  *d);
void Save_Dhcpd_Config (int i,DHCPD_CONFIG_DATA *d);
void Load_Dhcpd_Config (DHCPD_CONFIG_DATA  *d,LAN_CONFIG_DATA *l);

//move the following to globe variable for safe,it will affect vs function 20050825 by Julian
#define MAX_DHCP_CLIENT_DISCOVER 2048
	char_t str_start_weekday[MAX_DHCP_CLIENT_DISCOVER][2]={{0}};
	char_t str_start_date[MAX_DHCP_CLIENT_DISCOVER][11]={{0}};
	char_t str_start_time[MAX_DHCP_CLIENT_DISCOVER][9]={{0}};
	char_t str_end_weekday[MAX_DHCP_CLIENT_DISCOVER][2]={{0}};
	char_t str_end_date[MAX_DHCP_CLIENT_DISCOVER][11]={{0}};
	char_t str_end_time[MAX_DHCP_CLIENT_DISCOVER][9]={{0}};
	char_t str_hw_address[MAX_DHCP_CLIENT_DISCOVER][18]={{0}};
	char_t str_uid[MAX_DHCP_CLIENT_DISCOVER][20]={{0}};
	char_t str_ip[MAX_DHCP_CLIENT_DISCOVER][20]={{0}};
	char_t str_client_name[MAX_DHCP_CLIENT_DISCOVER][50]={{0}};

static int read_dhcpd_status (int ejid, webs_t wp, int argc, char_t **argv);
static int read_dhcpd_status (int ejid, webs_t wp, int argc, char_t **argv){
	
	FILE *fp;
	int i=0,j=0,flag=0;
//	char_t *TableFmt1=NULL;
	char_t line[255]={0};
	//DPRINTF("read_dhcpd_status\n");
#ifdef improvement
			int i1,num1=0;
			if((fp=fopen(SYS_ARP_CONF,"r"))!=0){
				fgets(line, 255, fp);
				for(i1=0;i1<MAX_ARP;i1++){	
				if(fgets(line, 255, fp)){
					num1++;
					sscanf(line,"%s %s %s %s %s %s\n",
					arp_config[i1].IP,
					arp_config[i1].HW_Type,
					arp_config[i1].Flags,
					arp_config[i1].HW_Address,
					arp_config[i1].Mask,
					arp_config[i1].Device);
				}
			#if 0	
			DPRINTF("\ni1:%d\n",i1);
			DPRINTF("d->IP:%s\n",arp_config[i1].IP);
			DPRINTF("d->HW_Type:%s\n",arp_config[i1].HW_Type);
			DPRINTF("d->HW_Address:%s\n",arp_config[i1].HW_Address);
			DPRINTF("d->Flags:%s\n",arp_config[i1].Flags);
			DPRINTF("d->Mask:%s\n",arp_config[i1].Mask);
			DPRINTF("d->Device:%s\n",arp_config[i1].Device);
			#endif
			}
			fclose(fp);
			}
#endif
	int num=0;
	if((fp=fopen("/var/dhcp/dhcpd.leases","r"))!=NULL){
		while (fgets(line,255,fp)){
			if (!strncmp(line,"lease",5))	{	
				sscanf(line,"lease %s {\n",str_ip[num]);
				while(fgets(line,255,fp)){
					if (!strncmp(line,"starts",6))		
						sscanf(line,"\tstarts %s %s %20[^;]s;\n",str_start_weekday[num],str_start_date[num],str_start_time[num]);
					if (!strncmp(line,"ends",4))		
						sscanf(line,"\tends %s %s %20[^;]s;\n",str_end_weekday[num],str_end_date[num],str_end_time[num]);
					if (!strncmp(line,"hardware",8))		
						sscanf(line,"\thardware ethernet %18[^;]s;\n",str_hw_address[num]);
					if (!strncmp(line,"uid",3))		
						sscanf(line,"\tuid %20[^;]s;\n",str_uid[num]);
					if (!strncmp(line,"client-hostname",15))		
						sscanf(line,"\tclient-hostname %50[^;]s;",str_client_name[num]);
					if (!strncmp(line,"}",1))
						break;
				}
				num++;
			}	
		}
		fclose(fp);
		num--;
		char_t *TableFmt1="\t<TR>\n\t<TD>%s<TD>%s<TD>%s<TD>%s %s - %s %s</TR>";
		for(i=num;i>=0;i--){
			j=i;
			flag=0;
			while(j<=num){
			/*
			DPRINTF("i=%d num=%d j=%d\n",i,num,j);
			DPRINTF("1.str_hw_address[%d]:%s\n",i,str_hw_address[i]);
			DPRINTF("2.str_hw_address[%d]:%s\n",j+1,str_hw_address[j+1]);
			*/
			//Julian modify: sort by unique IP 
			if (!strcmp(str_ip[i],str_ip[j+1])){
//			if (!strcmp(str_hw_address[i],str_hw_address[j+1])){
				flag++;	
			}
			j++;
			}
#ifdef improvement 
			if (flag==0){
			int k=0,istrue=0;
			for(k=0;k<=i1;k++){
				//DPRINTF("i1:%d arp_config[%d].IP:%s str_ip[%d]:%s\n",i1,k,arp_config[k].IP,i,str_ip[i]);
				if (!strcmp(arp_config[k].IP,str_ip[i])){
					//DPRINTF("########\n");
					istrue++;
				}
			}
			if(istrue>0)
#else
			if (flag==0)
#endif			
			{	
			websWrite(wp, T(TableFmt1),
						str_ip[i],
						str_hw_address[i],
						str_client_name[i],
						str_start_date[i],
						str_start_time[i],
						str_end_date[i],
						str_end_time[i]);
				//	DPRINTF("str_ip[%d]:%s\n",i,str_ip[i]);
				//	DPRINTF("str_start_weekday[%d]:%s\n",i,str_start_weekday[i]);
				//	DPRINTF("str_start_date[%d]:%s\n",i,str_start_date[i]);
				//	DPRINTF("str_start_time[%d]:%s\n",i,str_start_time[i]);
				//	DPRINTF("str_end_weekday[%d]:%s\n",i,str_end_weekday[i]);
				//	DPRINTF("str_end_date[%d]:%s\n",i,str_end_date[i]);
				//	DPRINTF("str_end_time[%d]:%s\n",i,str_end_time[i]);
				//	DPRINTF("str_hw_address[%d]:%s\n",i,str_hw_address[i]);
				//	DPRINTF("str_uid[%d]:%s\n",i,str_uid[i]);
				//	DPRINTF("str_client_name[%d]:%s\n",i,str_client_name[i]);
			}
	
		}
	}
	return 1;
}

static void resetCurrentDhcpdCfg(DHCPD_CONFIG_DATA  *d)
{
	//int i=0;
	//DHCPD_CONFIG_DATA *d = &dhcpd_config;
	memset(d,0,sizeof(DHCPD_CONFIG_DATA));
/*	d->Enable=0;
	strcpy(d->DomainName,"");
	strcpy(d->PrimaryDNS,"");
	strcpy(d->SecondaryDNS,"");
	d->DefaultLeaseTime=0;
	d->MaxLeaseTime=0;
	strcpy(d->Subnet,"");
	strcpy(d->Netmask,"");
	strcpy(d->Router,"");
	strcpy(d->Broadcast_address,"");
	strcpy(d->Range_start,"");
	strcpy(d->Range_end,"");
	strcpy(d->Relay,"");
	for(i=0;i<10;i++){
		strcpy(d->name[i],"");
		strcpy(d->macaddr[i],"");
		strcpy(d->ipaddr[i],"");
	} */
	d->hostIsDnsServer=1;
}

void Load_Dhcpd_Config (DHCPD_CONFIG_DATA  *d,LAN_CONFIG_DATA *l)
{
        FILE *fp;
	int i=0;
	char_t line[255];
        resetCurrentDhcpdCfg(d);
	Load_Lan_Config(l);	
	if((fp = fopen(DHCPD_CONFIG_FILE, "r"))!=NULL){
	if (fgets(line, 255, fp))
	{
	        if (sscanf(line, "#:%d:\n",
	        &d->Enable)  != 1)
	        {
			//error format
		}
	}
	if (fgets(line, 255, fp))
	{
	        if (sscanf(line, "#:%d:\n",
	        &d->hostIsDnsServer)  != 1)
	        {
			//error format
		}
	}

    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "option domain-name \"%[^\";]\";\n", 
    		d->DomainName)  != 1)
    		{
     			//error format
    		}
    	}
    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "option domain-name-servers %[^,], %[^;];s",
               	d->PrimaryDNS,
               	d->SecondaryDNS) != 2)
    		{
     			//error format 
    		}
    	}
	
	if (d->hostIsDnsServer==1){
		strcpy(d->PrimaryDNS,l->HostAddress);
		strcpy(d->SecondaryDNS,"");
	}
	else{
	if (!isValidIP(d->SecondaryDNS))
		sscanf(d->PrimaryDNS,"%[^;];s",d->PrimaryDNS);
	}
    
    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "option tftp-server-name \"%[^\";]\";\n", 
             	d->TFTP_Server_Name_option66) != 1)
		{//tftp-server-name do not present
			// clear the tftp-server-name in our config
			d->TFTP_Server_Name_option66[0]='\0';
			
    		if (sscanf(line, "default-lease-time %d\n",
               	&d->DefaultLeaseTime) != 1)
    		{
     			//error format 
    		}
    	}	
		else
		{//tftp-server-name present
			if (fgets(line, 255, fp))
			{
				if (sscanf(line, "default-lease-time %d\n",
					&d->DefaultLeaseTime) != 1)
				{
					//error format 
				}
			}
 		}
	}

    	if (fgets(line, 255, fp))
    	{
     		if (sscanf(line, "max-lease-time %d\n",
               	&d->MaxLeaseTime) != 1)
    		{
     			//error format 
    		}
    	} 
    	
    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "subnet %s netmask %s {\n",
               	d->Subnet, d->Netmask) != 2)
    		{
     			//error format 
    		}
    	}
    	
    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "\toption routers %[^;]s\n",
               	d->Router) != 1)
    		{
     			//error format 
    		}
    	}
  	
  	    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "\toption broadcast-address %[^;]s\n",
               	d->Broadcast_address) != 1)
    		{
     			//error format 
    		}
    	}
    	    	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "\trange %s %[^;]s\n",
               	d->Range_start, d->Range_end) != 2)
    		{
     			//error format 
    		}
    	}	

    	    	fgets(line, 255, fp);
    	    	fgets(line, 255, fp);
	
	for (i=0;i<10;i++){	
		if (fgets(line, 255, fp) !="\t}\n}\n")
    		{
			sscanf(line, "\t\thost %s {\n",d->name[i]);
		}
		if (fgets(line, 255, fp) !="\t}\n}\n")
    		{
			sscanf(line, "\t\t\thardware ethernet %[^;]s\n",d->macaddr[i]);
		}
		if (fgets(line, 255, fp) !="\t}\n}\n")
    		{
			sscanf(line, "\t\t\tfixed-address %[^;]s\n",d->ipaddr[i]);
		}
		if (fgets(line, 255, fp) !="\t}\n}\n")
    		{
			sscanf(line, "\t\t}\n");
		}
	}
	fclose(fp);
	}
	
	if((fp = fopen(DHCP_RELAY_CONFIG_FILE, "r"))!=NULL){
  	if (fgets(line, 255, fp))
    	{
    		if (sscanf(line, "%s\n",d->Relay)!=1)	{
     			//error format 
    		}
    	}
	fclose(fp);
	}
}

void Save_Dhcpd_Config (int i,DHCPD_CONFIG_DATA  *d)
{
	FILE *fp;
	/* 
	 * i=0 disable
	 * i=1 dhcpd enable
	 * i=2 dhcrelay enable
	 */
		
	/* write config to DHCPD_CONFIG_FILE */
	//DPRINTF("test i:%d",i);
	if((fp = fopen(DHCPD_CONFIG_FILE, "w"))!=NULL){
	fprintf(fp, "#:%d:\n",i); 
	fprintf(fp, "#:%d:\n",d->hostIsDnsServer); 
	fprintf(fp, "option domain-name \"%s\";\n", d->DomainName);
	if (d->hostIsDnsServer==1)
		fprintf(fp, "option domain-name-servers %s;\n",lan_config.HostAddress);
	else{
	if (isValidIP(d->SecondaryDNS))
		fprintf(fp, "option domain-name-servers %s, %s;\n",d->PrimaryDNS,d->SecondaryDNS);
	else
		fprintf(fp, "option domain-name-servers %s;\n",d->PrimaryDNS);
	}
		
	if (isValidIP(d->TFTP_Server_Name_option66))
		fprintf(fp, "option tftp-server-name \"%s\";\n", d->TFTP_Server_Name_option66);
	fprintf(fp, "default-lease-time %d;\n", d->DefaultLeaseTime);
	fprintf(fp, "max-lease-time %d;\n", d->MaxLeaseTime);
	fprintf(fp, "subnet %s netmask %s {\n", d->Subnet, d->Netmask);
	fprintf(fp, "\toption routers %s;\n",d->Router);
	fprintf(fp, "\toption broadcast-address %s;\n", d->Broadcast_address);
	fprintf(fp, "\trange %s %s;\n",	d->Range_start, d->Range_end);
	fprintf(fp, "\tgroup {\n\t\tuse-host-decl-names on;\n");
	for(i=0;i<10;i++){
		if (strlen(d->name[i]) > 0){
			fprintf(fp,"\t\thost %s {\n",d->name[i]);
			fprintf(fp,"\t\t\thardware ethernet %s;\n",d->macaddr[i]);
			fprintf(fp,"\t\t\tfixed-address %s;\n",d->ipaddr[i]);
			fprintf(fp,"\t\t}\n");
		}
	}
	fprintf(fp, "\t}\n}\n");
	fclose(fp);
	}
	
	if((fp = fopen(DHCP_RELAY_CONFIG_FILE, "w"))!=NULL){
	fprintf(fp, "%s\n",d->Relay); 
	fclose(fp);
	}
}
static int read_dhcp_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t tmp_status[20];
	char_t TableFmt2[10][255];
	Load_Dhcpd_Config(&dhcpd_config,&lan_config);
	int i;
	if (dhcpd_config.Enable==0)
	{
		char_t *TableFmt1="\t<TR>\n\t\t<TD colSpan=2 width=35%%>%s</TD>\n\t</TR>\n";
		return websWrite(wp, T(TableFmt1),Dhcp_L1[locale_config.locale]);
	}
	else if (dhcpd_config.Enable==1){

		strcpy(tmp_status,Dhcp_L2[locale_config.locale]);
						
		char_t *TableFmt1="\t<TR>\n\t\t<TD class=header colSpan=2>%s</TD>\n\t</TR>"
			          "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=header colSpan=2>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s %s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%d / %d %s</TD>\n\t</TR>"
				  
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s - %s</TD>\n\t</TR>";
			for(i=0;i<10;i++)
			{
				if (strlen(dhcpd_config.name[i]) > 0)
					strcpy(TableFmt2[i],"\t<TR>\n\t\t<TD class=title width=35%%>%s %d </TD>\n\t\t<TD>%s - %s - %s</TD>\n\t</TR>");
			}
			
			websWrite(wp, T(TableFmt1),
			Dhcp_L3[locale_config.locale],
			Dhcp_L4[locale_config.locale],
			tmp_status,
			Dhcp_L5[locale_config.locale],
			Dhcp_L6[locale_config.locale],
			dhcpd_config.Subnet,
			Dhcp_L7[locale_config.locale],
			dhcpd_config.Netmask,
			Dhcp_L8[locale_config.locale],
			dhcpd_config.DomainName,
			Dhcp_L9[locale_config.locale],
			dhcpd_config.PrimaryDNS,
			dhcpd_config.SecondaryDNS,
			Dhcp_L10[locale_config.locale],
			dhcpd_config.MaxLeaseTime,
			dhcpd_config.DefaultLeaseTime,
			Dhcp_L11[locale_config.locale],
			Dhcp_L12[locale_config.locale],
			dhcpd_config.Range_start,
			dhcpd_config.Range_end);
			for(i=0;i<10;i++)
			{
			if (strlen(dhcpd_config.name[i]) > 0)
				websWrite(wp, T(TableFmt2[i]),
					Dhcp_L13[locale_config.locale],
					i+1,
					dhcpd_config.name[i],
					dhcpd_config.macaddr[i],
					dhcpd_config.ipaddr[i]);
			}
			return 1;
	}
	else {
			strcpy(tmp_status,Dhcp_L14[locale_config.locale]);
			char_t *TableFmt1="\t<TR>\n\t\t<TD class=header colSpan=2>%s</TD>\n\t</TR>"
			          "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>"
				  "\t<TR>\n\t\t<TD class=title width=35%%>%s</TD>\n\t\t<TD>%s</TD>\n\t</TR>";

		return websWrite(wp, T(TableFmt1),
			Dhcp_L15[locale_config.locale],
			Dhcp_L4[locale_config.locale],
			tmp_status,
			Dhcp_L16[locale_config.locale],
			dhcpd_config.Relay);
	}
}

static int get_dhcp_dns_mod (int ejid, webs_t wp, int argc, char_t **argv)
{
	Load_Dhcpd_Config(&dhcpd_config,&lan_config);

	if (dhcpd_config.hostIsDnsServer)
		return websWrite(wp, T("%s"),"checked");
	else
	        return websWrite(wp, T(""));
}
void dhcp_change_internal(int enabled)
{
	Load_Dhcpd_Config(&dhcpd_config,&lan_config);
	if(enabled)
	{
	Save_Dhcpd_Config(1,&dhcpd_config);
	}
	else
	{
	FILE *fp;

	Save_Dhcpd_Config(0,&dhcpd_config);
	
	fp=fopen(DNS_CONFIG_FILE,"w");
	fprintf(fp,"nameserver %s\n",dhcpd_config.PrimaryDNS);
	fprintf(fp,"nameserver %s\n",dhcpd_config.SecondaryDNS);
	fclose(fp);
	}
}
static int get_dhcp_mod (int ejid, webs_t wp, int argc, char_t **argv)
{
        int i,j=0;
        Load_Dhcpd_Config(&dhcpd_config,&lan_config);
        i=dhcpd_config.Enable;
        j=atoi(argv[0]);
        if (i==j)
                return websWrite(wp, T("checked"));
        else
 	       return websWrite(wp, T(""));
}

static int get_dhcp_status (int ejid, webs_t wp, int argc, char_t **argv)
{
  	if (strcmp(argv[0],"Enable")==0){
		Load_Dhcpd_Config(&dhcpd_config,&lan_config);
		if  (dhcpd_config.Enable==0)
  	  		return websWrite(wp, T("%s"),Dhcp_L17[locale_config.locale]);
		else if (dhcpd_config.Enable==1)
			return websWrite(wp, T("%s"),Dhcp_L18[locale_config.locale]);
		else
			return websWrite(wp, T("%s"),Dhcp_L19[locale_config.locale]);
	}
  	if  (strcmp(argv[0],"DomainName")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.DomainName);
	if  (strcmp(argv[0],"DefaultLeaseTime")==0)
  	  	return websWrite(wp, T("%d"),dhcpd_config.DefaultLeaseTime);
	if  (strcmp(argv[0],"MaxLeaseTime")==0)
  	  	return websWrite(wp, T("%d"),dhcpd_config.MaxLeaseTime);
	if  (strcmp(argv[0],"PrimaryDns")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.PrimaryDNS);
	if  (strcmp(argv[0],"SecondaryDns")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.SecondaryDNS);
	if  (strcmp(argv[0],"Subnet")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Subnet);
	if  (strcmp(argv[0],"Netmask")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Netmask);
	if  (strcmp(argv[0],"Router")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Router);
	if  (strcmp(argv[0],"Range_start")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Range_start);
	if  (strcmp(argv[0],"Range_end")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Range_end);
	if  (strcmp(argv[0],"Relay")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.Relay);
	if  (strcmp(argv[0],"opt66")==0)
  	  	return websWrite(wp, T("%s"),dhcpd_config.TFTP_Server_Name_option66);
	else
		return 1;
}

static int get_fixed_dhcp (int ejid, webs_t wp, int argc, char_t **argv)
{
	int num,item; 
	num = atoi(argv[0]);
	item = atoi(argv[1]);
		if (item==1)		
			return websWrite(wp, T("%s"), dhcpd_config.name[num]);
		if (item==2)		
			return websWrite(wp, T("%s"), dhcpd_config.macaddr[num]);
		if (item==3)		
			return websWrite(wp, T("%s"), dhcpd_config.ipaddr[num]);
	return 1;
}

static void form_dhcp_disable(webs_t wp, char_t * path,char_t * query)
{
	FILE *fp;
	Load_Dhcpd_Config(&dhcpd_config,&lan_config);

	Save_Dhcpd_Config(0,&dhcpd_config);
	
	fp=fopen(DNS_CONFIG_FILE,"w");
	fprintf(fp,"nameserver %s\n",dhcpd_config.PrimaryDNS);
	fprintf(fp,"nameserver %s\n",dhcpd_config.SecondaryDNS);
	fclose(fp);
	
	run_script(DHCP_SCRIPT_FILE,"stop",0,0);
      	websRedirect(wp, T("dhcp.asp"));
}

static void form_dhcp_conf(webs_t wp, char_t * path,char_t * query)
{
	//FILE *fp;
	int i;	
	char_t *buf=NULL;
    // Since LAN IP or mask is changed by user. We need no to keep the old LAN IP and mask for PPPoA NAT disabled case
	//we destory the TEMP_LAN_INFO
	unlink(TEMP_LAN_INFO);

    	Load_Dhcpd_Config(&dhcpd_config,&lan_config);
	buf=websGetVar(wp, T("DomainName"), "");
        strcpy(dhcpd_config.DomainName,buf);
   	buf=websGetVar(wp, T("hostIsDnsServer"), "");
        dhcpd_config.hostIsDnsServer=atoi(buf);
	buf=websGetVar(wp, T("PrimaryDns"), "");
        strcpy(dhcpd_config.PrimaryDNS,buf);
   	buf=websGetVar(wp, T("SecondaryDns"), "");
        strcpy(dhcpd_config.SecondaryDNS,buf);
   	buf=websGetVar(wp, T("DefaultLeaseTime"), "");
        dhcpd_config.DefaultLeaseTime=atoi(buf);
   	buf=websGetVar(wp, T("MaxLeaseTime"), "");
        dhcpd_config.MaxLeaseTime=atoi(buf);
   	buf=websGetVar(wp, T("Range_start"), "");
        strcpy(dhcpd_config.Range_start,buf);
   	buf=websGetVar(wp, T("Range_end"), "");
        strcpy(dhcpd_config.Range_end,buf);
   	buf=websGetVar(wp, T("opt66"), "");
        strcpy(dhcpd_config.TFTP_Server_Name_option66,buf);
	
	buf=websGetVar(wp, T("name"), "");
	for (i=0;i<10;i++){
		strcpy(dhcpd_config.name[i],"");	
		strcpy(dhcpd_config.macaddr[i],"");	
		strcpy(dhcpd_config.ipaddr[i],"");	
	}
	sscanf(buf,"%s %s %s %s %s %s %s %s %s %s\n",
		dhcpd_config.name[0],
		dhcpd_config.name[1],
		dhcpd_config.name[2],
		dhcpd_config.name[3],
		dhcpd_config.name[4],
		dhcpd_config.name[5],
		dhcpd_config.name[6],
		dhcpd_config.name[7],
		dhcpd_config.name[8],
		dhcpd_config.name[9]
		);
	buf=websGetVar(wp, T("macaddr"), "");
       	sscanf(buf,"%s %s %s %s %s %s %s %s %s %s\n",
		dhcpd_config.macaddr[0],
		dhcpd_config.macaddr[1],
		dhcpd_config.macaddr[2],
		dhcpd_config.macaddr[3],
		dhcpd_config.macaddr[4],
		dhcpd_config.macaddr[5],
		dhcpd_config.macaddr[6],
		dhcpd_config.macaddr[7],
		dhcpd_config.macaddr[8],
		dhcpd_config.macaddr[9]
		);
	buf=websGetVar(wp, T("ipaddr"), "");
       	sscanf(buf,"%s %s %s %s %s %s %s %s %s %s\n",
		dhcpd_config.ipaddr[0],
		dhcpd_config.ipaddr[1],
		dhcpd_config.ipaddr[2],
		dhcpd_config.ipaddr[3],
		dhcpd_config.ipaddr[4],
		dhcpd_config.ipaddr[5],
		dhcpd_config.ipaddr[6],
		dhcpd_config.ipaddr[7],
		dhcpd_config.ipaddr[8],
		dhcpd_config.ipaddr[9]
		);
	
    	/*
	DPRINTF("Enable:%d\n",dhcpd_config.Enable);
	DPRINTF("DomainName:%s\n",dhcpd_config.DomainName);
	DPRINTF("PrimaryDNS:%s\n",dhcpd_config.PrimaryDNS);
	DPRINTF("SecondaryDNS:%s\n",dhcpd_config.SecondaryDNS);
	DPRINTF("DefaultLeaseTime:%d\n",dhcpd_config.DefaultLeaseTime);
	DPRINTF("MaxLeaseTime:%d\n",dhcpd_config.MaxLeaseTime);
	DPRINTF("Subnet:%s\n",dhcpd_config.Subnet);
	DPRINTF("Netmask:%s\n",dhcpd_config.Netmask);
	DPRINTF("Router:%s\n",dhcpd_config.Router);
	DPRINTF("Broadcast_address:%s\n",dhcpd_config.Broadcast_address);
	DPRINTF("Range_start:%s\n",dhcpd_config.Range_start);
	DPRINTF("Range_end:%s\n",dhcpd_config.Range_end);
	for (i=0;i<10;i++){	
	DPRINTF("form_name[%d]:%s\n",i,dhcpd_config.name[i]);
	DPRINTF("macaddr[%d]:%s\n",i,dhcpd_config.macaddr[i]);
	DPRINTF("ipaddr[%d]:%s\n",i,dhcpd_config.ipaddr[i]);
	}
   	*/

	Save_Dhcpd_Config(1,&dhcpd_config);
	/*
	fp=fopen(DNS_CONFIG_FILE,"w");
	fprintf(fp,"nameserver %s\n",dhcpd_config.PrimaryDNS);
	fprintf(fp,"nameserver %s\n",dhcpd_config.SecondaryDNS);
	fclose(fp);
	*/
	run_script(DHCP_SCRIPT_FILE,"stop",0,0);
	run_script(DHCP_SCRIPT_FILE,"start",0,0);
      	
	websRedirect(wp, T("dhcp.asp"));
}


static void form_dhcp_relay(webs_t wp, char_t * path,char_t * query)
{
	char_t *buf=NULL;
    	Load_Dhcpd_Config(&dhcpd_config,&lan_config);
	buf=websGetVar(wp, T("dhcprelay"), "");
        strcpy(dhcpd_config.Relay,buf);
	
	Save_Dhcpd_Config(2,&dhcpd_config);
	
  	run_script(DHCP_SCRIPT_FILE,"stop",0,0);
  	run_script(DHCP_SCRIPT_FILE,"start",0,0);
	
	websRedirect(wp, T("dhcp.asp"));
}
extern int check_if_wan_quick_type_13_14(void);

static int is_not_bridge (int ejid, webs_t wp, int argc, char_t **argv)
{
 	char_t str_wan[50];
	char_t buf1[64];
	int i;
	
	strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1));
 	if (strcmp(str_wan,"bridge")!=0)
		return websWrite(wp, T(""));
	
#ifdef _WAN_TYPE_13_14_
	// check if quick Type is 13 and 14, then we need to turn it on.
	if(check_if_wan_quick_type_13_14())
		return websWrite(wp, T(""));
#endif
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else
		return websWrite(wp, T("-->"));
}

void DefineWebFunctions_dhcp()
{
	websAspDefine(T("get_dhcp_mod"), get_dhcp_mod);  	
	websAspDefine(T("get_dhcp_dns_mod"), get_dhcp_dns_mod);  	
	websAspDefine(T("get_dhcp_status"), get_dhcp_status);
  	websAspDefine(T("get_fixed_dhcp"), get_fixed_dhcp);
  	websAspDefine(T("read_dhcp_status"), read_dhcp_status);  	
  	websAspDefine(T("read_dhcpd_status"), read_dhcpd_status);  	
 	websAspDefine(T("is_not_bridge"), is_not_bridge);
  	websFormDefine(T("dhcpdisable"), form_dhcp_disable);
  	websFormDefine(T("dhcpserver"), form_dhcp_conf);
  	websFormDefine(T("dhcprelay"), form_dhcp_relay);
}
