/*
 *  dns_conf.htm: DNS configuration
 */
#include "webs.h"
#include "dns_conf.h"
#include "dhcp.h"
#include "lan_conf.h"
#include "home.h"
#include "wan.h"

static int get_dns_status (int ejid, webs_t wp, int argc, char_t **argv);
static int get_flash_dns_status (int ejid, webs_t wp, int argc, char_t **argv);
static void form_dns_conf(webs_t wp, char_t * path,char_t * query);

static void resetCurrentDnsCfg(void);
void Load_Dns_Config (int i);
void Save_Dns_Config (int i,DNS_CONFIG_DATA *d);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

static void resetCurrentDnsCfg(void)
{
        DNS_CONFIG_DATA *d = &dns_config;
	        strcpy(d->Enable,"1");
	        strcpy(d->PrimaryDNS,"");
	        strcpy(d->SecondaryDNS,"");
}

void Load_Dns_Config (int i)
{
        FILE *fp;
        char_t line[255];
        char_t dns_config_file[30];
        resetCurrentDnsCfg();
	
        if((fp = fopen(FLASH_DNS_CONFIG1_FILE, "r"))!=NULL){	
		if (fgets(line, 255, fp))
			sscanf(line, "%s\n",dns_config.Enable);
		fclose(fp);
	}
	
	if (i==0)
		strcpy(dns_config_file,FLASH_DNS_CONFIG_FILE);
	else if (i==1)
		strcpy(dns_config_file,DNS_CONFIG_FILE);
	else 
		strcpy(dns_config_file,TMP_RESOLV_CONF_FILE);
		
        if((fp = fopen(dns_config_file, "r"))!=NULL){	
		if (fgets(line, 255, fp)){
			sscanf(line, "nameserver %s\n",dns_config.PrimaryDNS);
		}
		if (fgets(line, 255, fp)){
			sscanf(line, "nameserver %s\n",dns_config.SecondaryDNS);
		}
	fclose(fp);
	}
}

void Save_Dns_Config (int i,DNS_CONFIG_DATA *d)
{
        FILE *fp;
        char_t dns_config_file[30];	
        char_t dns1[20];	
        char_t dns2[20];	
        char_t dns3[20];	
        char_t dns4[20];	
	
	if((fp=fopen(FLASH_DNS_CONFIG1_FILE,"w"))!=NULL){
		fprintf(fp,"%s\n",d->Enable);
		fclose(fp);
	}
	
	if (i==0){
		strcpy(dns_config_file,FLASH_DNS_CONFIG_FILE);
		if((fp=fopen(dns_config_file,"w"))!=NULL){
			if (strlen(d->PrimaryDNS)!=0)
				fprintf(fp,"nameserver %s\n",d->PrimaryDNS);
			if (strlen(d->SecondaryDNS)!=0)
				fprintf(fp,"nameserver %s\n",d->SecondaryDNS);
			fclose(fp);
		}
	}
	else if (i==1){
		strcpy(dns_config_file,DNS_CONFIG_FILE);
		if((fp=fopen(dns_config_file,"w"))!=NULL){
			if (strlen(d->PrimaryDNS)!=0)
				fprintf(fp,"nameserver %s\n",d->PrimaryDNS);
			if (strlen(d->SecondaryDNS)!=0)
				fprintf(fp,"nameserver %s\n",d->SecondaryDNS);
			fclose(fp);
		}
	}
	else{
		Load_Dns_Config(0); /* load from /flash/resolv.conf */
		strcpy(dns1,dns_config.PrimaryDNS);	
		strcpy(dns2,dns_config.SecondaryDNS);
		Load_Dns_Config(2); /* load from /tmp/ppp/resolv.conf */
		strcpy(dns3,dns_config.PrimaryDNS);	
		strcpy(dns4,dns_config.SecondaryDNS);
		if((fp=fopen(DNS_CONFIG_FILE,"w"))!=NULL){
			if (!strcmp(dns_config.Enable,"1")){
				if (isValidIP(dns3))
					fprintf(fp,"nameserver %s\n",dns3);
				if (isValidIP(dns4))
					fprintf(fp,"nameserver %s\n",dns4);
			}
			else{
				if (isValidIP(dns1))
					fprintf(fp,"nameserver %s\n",dns1);
				if (isValidIP(dns2))
					fprintf(fp,"nameserver %s\n",dns2);
			}
				fclose(fp);
		}
			
	}
	
}

static int get_flash_dns_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	Load_Dns_Config(0);
	
      	if  (strcmp(argv[0],"AutoDNS")==0){
		if (!strcmp(dns_config.Enable,"1"))
      	      		return websWrite(wp, T("checked"));
		else
      	      		return websWrite(wp, T(""));
	}
		
      	if  (strcmp(argv[0],"PrimaryDNS")==0)
      	      	return websWrite(wp, T("%s"), dns_config.PrimaryDNS);
      	if  (strcmp(argv[0],"SecondaryDNS")==0)
      	      	return websWrite(wp, T("%s"), dns_config.SecondaryDNS);
	return 1;
}


static int get_dns_status (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *fp;
	char_t line[255];
	char_t is_connect[255];


	if((fp=fopen(WAN_CONNECT_STATUS_FILE,"r"))!=NULL){
		if (fgets(line, 255, fp))
			sscanf(line, "%s\n",is_connect);
		fclose(fp);
	}
	
	if (!strcmp(is_connect,"1")){		
		Load_Dns_Config(1);
	      	if  (strcmp(argv[0],"PrimaryDNS")==0)
      		      	return websWrite(wp, T("%s"), dns_config.PrimaryDNS);
	      	if  (strcmp(argv[0],"SecondaryDNS")==0)
      		      	return websWrite(wp, T("%s"), dns_config.SecondaryDNS);
		else
	      	      	return websWrite(wp, T(""));
	}
	else
      	      	return websWrite(wp, T(""));
}

static void form_dns_conf(webs_t wp, char_t * path,char_t * query)
{
	char_t str_wan[50];
	char_t *buf=NULL;
	char_t buf1[64];
	Load_Dns_Config(0);	
 	
   	buf=websGetVar(wp, T("autodns"), "");
        strcpy(dns_config.Enable,buf);

   	buf=websGetVar(wp, T("primary_dns"), "");
        strcpy(dns_config.PrimaryDNS,buf);
                   	       
        buf=websGetVar(wp, T("secondary_dns"),"");
	strcpy(dns_config.SecondaryDNS,buf);
	
	Save_Dns_Config(0,&dns_config);

	strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1));
	if (strcmp(str_wan,"fixed")==0)
		Save_Dns_Config(1,&dns_config);
	else if (strcmp(str_wan,"dynamic")==0)
		Save_Dns_Config(2,&dns_config);
	else if (strcmp(str_wan,"pppoa")==0)
		Save_Dns_Config(2,&dns_config);
	else if (strcmp(str_wan,"pppoe")==0)
		Save_Dns_Config(2,&dns_config);
	else if (strcmp(str_wan,"bridge")==0)
		Save_Dns_Config(1,&dns_config);
	else
		Save_Dns_Config(1,&dns_config);
		
	websRedirect(wp, T("dns_conf.asp"));
}


void DefineWebFunctions_dns()
{
	websAspDefine(T("get_dns_status"), get_dns_status);  	
	websAspDefine(T("get_flash_dns_status"), get_flash_dns_status);  	
  	websFormDefine ( T("dns"), form_dns_conf);
}

