/****************************************************************************
 *
 *  Copyright (c) 2001 by LSI Logic Corporation, all rights reserved.
 *
 *                         LSI Logic confidential
 *  The information contained herein is proprietary of LSI Logic Corporation.
 *
 *  This software is provided "as is" without any express or implied warranty.
 *  LSI Logic disclaims all representations and warranties with regard to
 *  this software, including all implied warranties of merchantability and
 *  fitness for a particular purpose. In no event shall LSI Logic be liable
 *  for any special, indirect or consequential damages or any damages
 *  whatsoever resulting from loss of use, data or profits, whether in an
 *  action of contract, negligence or other tortious act or omission,
 *  arising out of or in connection with the use or performance of this
 *  software.
 *
 *  $Id: $
 *
 *  Revision Details
 *  $Log:  $
 *
 *
 *  File Description:
 *  Header file for the DHCP Configuration CGI script.
 *
 ****************************************************************************/

#ifndef _GEN_CONFIG_H
#define _GEN_CONFIG_H

/****************************************************************************
 * includes
 ****************************************************************************/
#include <ctype.h>

/****************************************************************************
 * definitions (macros)
 ****************************************************************************/
#define CONFIG_DIR "/flash"

/****************************************************************************
 * definitions (types)
 ****************************************************************************/
typedef struct field {
		struct field *next;
		char *name;
		char *value;
}Field;

typedef struct {
		int count;
		Field *fields;
}FieldList;

/****************************************************************************
 * Function Name  : validate_macaddress
 * Arguments      : macaddr
 * Returns        : 0 success, -1 fail
 * Variables      : 
 * Modifies       : 
 * Description    : 
 ****************************************************************************/
static inline int validate_macaddress(char *macaddr)
{
	unsigned int b1, b2, b3, b4, b5, b6;
	/* 00:00:00:00:00:00 */
	if (sscanf(macaddr, "%2x:%2x:%2x:%2x:%2x:%2x", &b1, &b2, &b3, &b4, &b5, &b6) != 6)
	{
		return -1;
	}
	return 0;
}

/****************************************************************************
 * Function Name  : validate_ipaddress
 * Arguments      : ipaddr
 * Returns        : 0 success, -1 fail
 * Variables      : 
 * Modifies       : 
 * Description    : 
 ****************************************************************************/
static inline int validate_ipaddress(char *ipaddr)
{
	int b1, b2, b3, b4;
	int i;
	for (i = 0; i < strlen(ipaddr); i++)
	{
		if ((!isdigit(ipaddr[i])) && (ipaddr[i] != '.'))
		{
			return -1;
		}
	}
	if (sscanf(ipaddr, "%d.%d.%d.%d", &b1, &b2, &b3, &b4) != 4)
	{
		return -1;
	}
	if (b1 < 0 || b1 > 255 || b2 < 0 || b2 > 255 || b3 < 0 || b3 > 255 || b4 < 0 || b4 > 255)
	{
		return -1;
	}
	return 0;
}

#endif

