#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>

#include <ctype.h>
#include <dirent.h>
#include "../3rdparty/goahead/ws030930/webs.h" 
#define READ_BUF_SIZE	50
/*
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
*/

#define MAX_CONFIG_ITEM		40
#define MAX_STRING_LEN 		20

static char configName [MAX_CONFIG_ITEM][MAX_STRING_LEN+1];
static char configValue[MAX_CONFIG_ITEM][MAX_STRING_LEN+1];
static int configItem;	

#define NIPQUAD(addr) \
        ((unsigned char *)&addr)[0], \
        ((unsigned char *)&addr)[1], \
        ((unsigned char *)&addr)[2], \
        ((unsigned char *)&addr)[3]

#define BLANK_SYMBOL "&"
#define DELETE_MODEM_ANT "/etc/preUpload"
#if 0
#define DMT_READ_FN "/proc/dmtctrl/dmtread"
#define DMT_WRITE_FN "/proc/dmtctrl/dmtwrite"
#endif
int run_script(char *filename, char *arg1, char *arg2, char *arg3);
int run_purebridge_script(char *filename, char *arg1, char *arg2, char *arg3, char *arg4, char *arg5, char *arg6, char *arg7); // Camiu added 2006/05/30
int save_globe_config(char *filename, char *arg1, char *arg2);
int isValidIP(char *IPaddr);
void KillProcessByName(char *ProcessName,int signal);
int IsExistProcess(char *ProcessName);
void TouchFile(char *FileName);
int KillAllProcess(void);
char* read_file_para_value(char *filename, char *arg1,char *buf);
int write_value_to_file(char *filename, int arg1);
int read_value_from_file(char *filename);
char *HextoDec_ip(char *ip_value,char *buf); 
char *get_ip_segment(int num,char *ip_value,char *buf); 
void CopyFile(char *filename1,char *filename2);
int load_blank_string(void *d);
int print_blank_string(void *d);
//void dmt_write_cmd(int cmd);
//char *dmt_read_status(char *buf);
void run_task(char *cmd, ...);
static char tmp_line[256];
//char buf1[255];
int ParseNameValue(char *buf, char **name, char **value)
{
	char *tmp;
	char in_quote=0;

        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++) ;

        if (!(*buf) || *buf == '\n' || // empty line
            *buf == '#')  // comment
                return -1;

	/* find name */
	*name = buf;
	for (; *buf && *buf != ' ' && *buf != '\t' &&
		   *buf != '=' && *buf != '\n'; buf++);
	tmp = buf;

	/* find the operator */
        /* skip the leading space */
        for (; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf != '=')
		return -1;
	*tmp = '\0';
                          
	/* find the value */
        /* skip the leading space */
        for (buf++; *buf && (*buf == '\t' || *buf == ' '); buf++);
	if (*buf == '"') {
		in_quote = 1;
	}
	if (in_quote) {
	        for (*value=++buf; *buf && *buf != '"' && *buf != '\n'; buf++);
	}
	else {
                for (*value=buf; *buf && *buf != ' ' && *buf != '\t' && *buf != '\n'; buf++);

	}
        *buf = '\0';
	return 0;
}

int GetValue(char *name, char *value)
{
	int i;
	for (i=0; i<configItem; i++) {
                if (!strcmp(configName[i],name)) 
                        break;
	}
	if (i>=configItem) {
printf("can not found :%s \n", name);
		*value = '\0';
		return -1;
	}
	else {
		strncpy(value, configValue[i], MAX_STRING_LEN);
		return i;
	}
	
}

void SetValue(char *name, char *value)
{
	int i;

        for (i=0; i<configItem; i++) {
		if (!strcmp(configName[i],name))
			break; 
        }
        if (i>=configItem) { /* add it */
		strncpy(configName[configItem], name, MAX_STRING_LEN);
		strncpy(configValue[configItem], value, MAX_STRING_LEN);
		configItem++;
        }
        else {
                strncpy(configValue[i], value, MAX_STRING_LEN);
        }
                                                                                                                                               

}

void GetParam(char *buf, char num, char deli, char *field)
{
        char i, *ptr;
                                                                                                                                               
        for (ptr=buf, i=0; *ptr && i<num; ++ptr) {
                if (*ptr==deli)
                        ++i;
        }
        while (*ptr && *ptr != deli) {
                *(field++) = *(ptr++);
        }
        *field = '\0';
}
 
long* find_pid_by_name1( char* pidName){

	DIR *dir;
	struct dirent *next;
	long* pidList=NULL;
	int i=0;

	dir = opendir("/proc");
	if (!dir){
		DPRINTF("Cannot open /proc");
	}
	while ((next = readdir(dir)) != NULL) {
		FILE *status;
		char filename[READ_BUF_SIZE];
		char buffer[READ_BUF_SIZE];
		char name[READ_BUF_SIZE];

		/* Must skip ".." since that is outside /proc */
		if (strcmp(next->d_name, "..") == 0)
			continue;

		/* If it isn't a number, we don't want it */
		if (!isdigit(*next->d_name))
			continue;

		sprintf(filename, "/proc/%s/status", next->d_name);
		if (! (status = fopen(filename, "r")) ) {
			continue;
		}
		if (fgets(buffer, READ_BUF_SIZE-1, status) == NULL) {
			fclose(status);
			continue;
		}
		fclose(status);

		/* Buffer should contain a string like "Name:   binary_name" */
		sscanf(buffer, "%*s %s", name);
		if (strcmp(name, pidName) == 0) {
			pidList=realloc( pidList, sizeof(long) * (i+2));
			pidList[i++]=strtol(next->d_name, NULL, 0);
		}
	}

	if (pidList) {
		pidList[i]=0;
	} else {
		pidList=realloc( pidList, sizeof(long));
		pidList[0]=-1;
	}
	return pidList;
}
#if 0
void dmt_write_cmd(int cmd)
{
	FILE *fp;
	fp = fopen(DMT_WRITE_FN, "w");
	if(fp!=NULL){
		fprintf(fp, "%d" , cmd);
		fclose(fp);
	}
}
#endif
void TouchFile(char *FileName){

	FILE *fp;
	fp = fopen(FileName, "w");
	if(fp){
		fclose(fp);
	}
}

#if 0
char buf1[255];
char *dmt_read_status(char *buf)
{
	FILE *fp;
	fp = fopen(DMT_READ_FN, "r");
	if(fp!=NULL){
		memset(buf1,0,sizeof(buf1));
		fgets(buf1, sizeof(buf1), fp);
		fclose(fp);
		strcpy(buf,buf1);
		return buf;
	}
	return NULL;
}
#endif

int IsExistProcess(char *ProcessName){
	long *killpid;
	
	killpid=find_pid_by_name1(ProcessName);
	if (!killpid || *killpid<=0)
		return 0;
	else
		return 1;
}

int KillAllProcess(void){
	FILE *fp;
	long *killpid;
//	char line[255];
	char str_process_name[255];

	fp=fopen(DELETE_MODEM_ANT,"r");
		if(fp==NULL) return -1;
		
		memset(tmp_line,0,sizeof(tmp_line));
		while (fgets(tmp_line,sizeof(tmp_line),fp)){
			sscanf(tmp_line,"%s",str_process_name);
			killpid=find_pid_by_name1(str_process_name);
			
			if (!killpid || *killpid<=0)
			{
				//DPRINTF(" %s : No Such Process\n",str_process_name);
			}
			else
			{
				kill(*killpid,SIGTERM);
				sleep(1); // kk test
				kill(*killpid,SIGKILL);
				//DPRINTF(" %s : Process killed\n",str_process_name);
			}
		}
		fclose(fp);
		//DPRINTF("\n");
		return 1;
}
		
void CopyFile(char *filename1,char *filename2){
	FILE *fp,*fp1;
	memset(tmp_line,0,sizeof(tmp_line));
	/* from filename1 to filename2 */ 
	if ((fp = fopen(filename1, "r"))!=NULL){
	  	if ((fp1 = fopen(filename2, "w"))!=NULL){
			while (fgets(tmp_line,sizeof(tmp_line),fp))
				fprintf(fp1,"%s",tmp_line);
			fclose(fp1);
		}
	fclose(fp);
	}
}
#if 0
void CopyFile(char *filename1,char *filename2){
	FILE *fp,*fp1;
	char line[512];
	/* from filename1 to filename2 */ 
	if ((fp = fopen(filename1, "r"))!=NULL){
	  	if ((fp1 = fopen(filename2, "w"))!=NULL){
			while (fgets(line,255,fp))
				fprintf(fp1,"%s",line);
			fclose(fp1);
		}
	fclose(fp);
	}
}
#endif

void KillProcessByName(char *ProcessName,int signal){
	
	long *killpid;
	
	killpid=find_pid_by_name1(ProcessName);
	if (!killpid || *killpid<=0)
	{
		//DPRINTF(" %s : No Such Process\n",ProcessName);
	}
	else
	{
		//DPRINTF("kill -%d `pidof %s`\n",signal,ProcessName);
		kill(*killpid,signal);
	}
}

int isValidIP(char *IPaddr){
 struct in_addr inp;
   if (inet_aton(IPaddr,&inp)!=0) /* success */
	   return 1;
   else
	   return 0;
}
/*
char* read_file_para_value1(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
	char line[255];
	char str_return[50];
	//char_t *str_return=NULL;
	char str_temp[50];
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(line,255,fp)){
		        if (strncmp(line,arg1,strlen(arg1)) == 0){
       				sscanf(line,"%50[^=]=%50s\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
				//DPRINTF("0.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	}
	return NULL;

}
*/
char* read_file_para_value(char *filename, char *arg1 ,char *buf)
{
	FILE *fp;
//	char line[255];
	char str_return[50]={0};
	//char_t *str_return=NULL;
	char str_temp[50]={0};
	*buf='\0';
	memset(tmp_line,0,sizeof(tmp_line));
	if ((fp=fopen(filename,"r"))!=NULL)
        {
        	while(fgets(tmp_line,sizeof(tmp_line),fp)){
		        if (strncmp(tmp_line,arg1,strlen(arg1)) == 0){
       				sscanf(tmp_line,"%50[^=]=\"%50[^\"]\"\n",str_temp,str_return);
	        		fclose(fp);
				strcpy(buf,str_return);
			//	DPRINTF("1.%s:%s\n",str_temp,buf);
				return buf;	
			}
		}
	       	fclose(fp);
	}
	return buf;
}

int read_value_from_file(char *filename){
	int arg1=0;
	FILE *fp;
	if ((fp=fopen(filename,"r"))!=NULL)
        {
		fscanf(fp,"%d\n",&arg1);
		fclose(fp);
	}
	return arg1;
}

int write_value_to_file(char *filename, int arg1)
{
	FILE *fp;
	if ((fp=fopen(filename,"w"))!=NULL)
        {
		fprintf(fp,"%d\n",arg1);
		fclose(fp);
		return 1;
	}
	else
		return 0;
	

}



int load_blank_string(void *d)
{
	if (strlen(d)==0)
              strcpy(d,BLANK_SYMBOL);
	return 1;
}

int print_blank_string(void *d)
{
	if (strcmp(d,BLANK_SYMBOL)==0)
              strcpy(d,"");
	return 1;
}

void do_extern_cmd(char *cmd, char *argv[], char *filename)
{
    char path[100];
    int  pid, fd = -1, fd2 = -1;
    
    fflush(stdout);
    signal(SIGCHLD, SIG_DFL);
    if ( (pid = vfork()))
        waitpid(pid, NULL, 0);
    if(pid == 0){  // child process
        if ( filename != NULL && *filename )  {
            strcpy(path, filename);
            fd = open(path, O_RDWR|O_CREAT|O_TRUNC);
            strcat(path, ".err");
            fd2 = open(path, O_RDWR|O_CREAT|O_TRUNC);
        }
		if ( fd >= 0 && fd2 >= 0 )   {
            dup2(fd, STDOUT_FILENO);
            dup2(fd2, STDERR_FILENO);
            
	//DPRINTF("\n\n  ------------------------------\n");
	//DPRINTF("Web page run_script\t");
	//DPRINTF("  ------------------------------\n");
	/*
	DPRINTF("%s\t",argv[1]);
	if (argv[2])
		DPRINTF("%s\t",argv[2]);
	if (argv[3])
		DPRINTF("%s\t",argv[3]);
	if (argv[4])
		DPRINTF("%s\t",argv[4]);
//	DPRINTF("  ------------------------------\n\n");
	DPRINTF("\n");
	*/
	    execvp(cmd, argv);
        }
        exit(0);
    }
}

void run_task(char *cmd, ...)
{
        va_list args;
        char *param[40];
        char i=0, background=0;
        pid_t  pid;
                
//printf("run_task: %s\n", cmd);  
        va_start(args, cmd);
        for (;;) {
                if (!(param[i++] = va_arg(args, char * )))
                       break;
        }
        va_end(args);
                                                                                                                                               
        if (!strcmp(param[i-2],"&")) {
//printf("run_task: a back ground task\n");  
                background = 1;
                param[i-2] = 0;
        }

        if (!(pid = vfork())) {
		execvp(cmd, param);
                _exit(0);
        }
        else if (!background && pid > 0)
		waitpid(pid, NULL, 0);
}


/****************************************************************************
 * Function Name  : save_globe_config 
 * Arguments      : filename
 *                  arg1
 *                  arg2
 *                  arg3
 * Returns        : int
 * Variables      :
 * Modifies       :
 * Description    : save flash variable
 ****************************************************************************/
int save_globe_config(char *filename, char *arg1, char *arg2)
{
//	char line[256];
//	int i,j;
	FILE *fp,*fp1;
//	i=0;
	memset(tmp_line,0,sizeof(tmp_line));	
	if((fp=fopen(filename,"r"))!=NULL){
		if((fp1=fopen("/var/tmp/tmpfile","w"))!=NULL){
			while(fgets(tmp_line,sizeof(tmp_line),fp))
			{
				if ((strncmp(arg1,tmp_line,strlen(arg1))) == 0){
				//	sprintf(config_line[i],"%s\"%s\"\n",arg1,arg2);
					fprintf(fp1,"%s\"%s\"\n",arg1,arg2);
				}
				else{
				//	sprintf(config_line[i],"%s",line);
					fprintf(fp1,"%s",tmp_line);
				}
	//		i++;
			}
	
		fclose(fp1);
	}
	fclose(fp);
	}
	/*
	if ((fp=fopen(filename,"w"))!=NULL){
	for(j=0;j<i;j++)
		fprintf(fp,"%s",config_line[j]);
	fclose(fp);
	}
	*/
	CopyFile("/var/tmp/tmpfile",filename);
	return 1;	
}
/*
int save_globe_config(char *filename, char *arg1, char *arg2)
{
	char config_line[30][300];
	char line[300];
	int i,j;
	FILE *fp;
	i=0;
	if((fp=fopen(filename,"r"))!=NULL){
	while(fgets(line,300,fp))
	{
		if ((strncmp(arg1,line,strlen(arg1))) == 0)
			sprintf(config_line[i],"%s\"%s\"\n",arg1,arg2);
		else
			sprintf(config_line[i],"%s",line);
		i++;
	}
	fclose(fp);
	}
	if ((fp=fopen(filename,"w"))!=NULL){
	for(j=0;j<i;j++)
		fprintf(fp,"%s",config_line[j]);
	fclose(fp);
	}
	return 1;	
}
*/
int run_script(char *filename, char *arg1, char *arg2, char *arg3)
{
    	char *argv[] = { "sh", filename, arg1,arg2,arg3, NULL };
	do_extern_cmd("sh", argv, "/var/tmp/run_script");
	return 0;
}

int run_purebridge_script(char *filename, char *arg1, char *arg2, char *arg3, char *arg4, char *arg5, char *arg6, char *arg7)
{
    	char *argv[] = { "sh", filename, arg1,arg2,arg3,arg4,arg5,arg6,arg7, NULL };
	do_extern_cmd("sh", argv, "/var/tmp/run_purebridge_script");
	return 0;
}

char *HextoDec_ip(char *ip_value,char *buf){
	/* 
	 * julian 2004/11/23
	 * return the dec ipaddress
	 *
	 * ex:
	 * HextoDec_ip("FFFFFFFF") return 255.255.255.255
	 */ 	
     //   char_t ipaddr_s[3];
    //    unsigned long msb[4];
        unsigned long msb1;
	msb1=strtoul(ip_value,NULL,16);

	/*		msb[0] = (msb1 & (0xff000000)) >> 24;
			msb[1] = (msb1 & (0x00ff0000)) >> 16;
			msb[2] = (msb1 & (0x0000ff00)) >> 8;
			msb[3] = (msb1 & (0x000000ff)) ;
			sprintf(ipaddr_s,"%d.%d.%d.%d",msb[0],msb[1],msb[2],msb[3]);
	strcpy(buf,ipaddr_s);
	//DPRINTF("ipaddr_s:%s\n",ipaddr_s); */
	sprintf(buf,"%u.%u.%u.%u",NIPQUAD(msb1));
	return buf;

}

char *get_ip_segment(int num,char *ip_value,char *buf)
{
	
	/* 
	 * julian 2004/10/17
	 * return the segment of ipaddress
	 *
	 * ex:
	 * get_ip_segment(1,"192.168.1.254") return 192
	 * 		  2	                    168
	 * 		  3                           1
	 * 		  4		 	    254
	 */ 		  
        struct in_addr in;
//        char ipaddr_s[3];
  //      unsigned long msb;//[4];
	
	if (inet_aton(ip_value, &in) != 0){
		sprintf(buf,"%u",(in.s_addr>>((4-num)*8))&(0x000000ff));
		
/*		
		if (num==1)
		{
			msb[0] = (in.s_addr & 0xff000000) >> (24;
			sprintf(ipaddr_s,"%d",msb[0]);
		}
		if (num==2)
		{
			msb[1] = (in.s_addr & 0x00ff0000) >> 16;
			sprintf(ipaddr_s,"%d",msb[1]);
		}
		if (num==3)
		{
			msb[2] = (in.s_addr & 0x0000ff00) >> 8;
			sprintf(ipaddr_s,"%d",msb[2]);
		}
		if (num==4)
		{
			msb[3] = (in.s_addr & 0x000000ff) ;
			sprintf(ipaddr_s,"%d",msb[3]);
		}
		


	strcpy(buf,ipaddr_s); */
	}
	//DPRINTF("ipaddr_s:%s\n",ipaddr_s);
	return buf;
}
void drop_newline(char *str)
{
	int i;
	for(i=0; str[i]!='\n'; i++);

	str[i]=0;
}
