/*
 *  home.asp: status summary
 */
#include "webs.h"
#include "lan_conf.h"
#include "dhcp.h"
#include "home.h"
#include "wan.h"
#include "dns_conf.h"
#include <sys/time.h>
#include <linux/kernel.h>
#include <signal.h>
#include "locale.h"

extern char *Home_L1[];
extern char *Home_L2[];
extern char *Home_L3[];
extern char *Home_L4[];
extern char *Home_L5[];
extern char *Home_L6[];
extern char *Home_L7[];
extern char *Home_L8[];

extern char *Home_L9[];
extern char *Home_L10[];
extern char *Home_L11[];
extern char *Home_L12[];
extern char *Home_L13[];
extern char *Home_L14[];
extern char *Home_L15[];
extern char *Home_L16[];
extern char *Home_L17[];
extern char *Home_L18[];
extern char *Home_L19[];
extern char *Home_L20[];
extern char *Home_L21[];
extern char *Home_L22[];
extern char *Home_L23[];


extern char *URL_L8[];
extern char *URL_L9[];
extern char *URL_L10[];
extern char *URL_L11[];
extern char *URL_L12[];
extern char *URL_L13[];
extern char *URL_L14[];
extern LAN_CONFIG_DATA lan_config;
extern void Load_Dhcpd_Config (DHCPD_CONFIG_DATA  *d,LAN_CONFIG_DATA *l);

//static int get_mac (int ejid, webs_t wp, int argc, char_t **argv);
static int get_home_status (int ejid, webs_t wp, int argc, char_t **argv);
//static int get_version (int ejid, webs_t wp, int argc, char_t **argv);
static int display_time_go (int ejid, webs_t wp, int argc, char_t **argv);
static int display_time (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_type (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_ip_status (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_ipcp_type (int ejid, webs_t wp, int argc, char_t **argv);
static int get_vod_type(int ejid, webs_t wp, int argc, char_t **argv); // KenWang added 2007/02/06
static int get_connection_status (int ejid, webs_t wp, int argc, char_t **argv);
static int read_connect_button (int ejid, webs_t wp, int argc, char_t **argv);
static void form_hostname_conf (webs_t wp, char_t *path, char_t *query);
//static void ping_action (webs_t wp, char_t *path, char_t *query);
static void connect_action (webs_t wp, char_t *path, char_t *query);
static void disconnect_action (webs_t wp, char_t *path, char_t *query);
static int get_model_name (int ejid, webs_t wp, int argc, char_t **argv);
/*
static int get_url (int ejid, webs_t wp, int argc, char_t **argv);
static int get_url_name (int ejid, webs_t wp, int argc, char_t **argv);
*/
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

// albert 2004.12.30
//static char_t buf2[1024];
static char_t buf_512[512];
static char_t buf1_255[255], buf2_255[255], buf3_255[255];

extern void runStopPppoecd();
extern void runStartPppoecd();
static int get_home_status (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	if ((f=fopen(argv[1],"r"))!=NULL){
		fclose(f);
		strcpy(buf1_255,(char *)read_file_para_value(argv[1],argv[0],buf3_255));
	}
	else
		strcpy(buf1_255,"");
		
		return websWrite(wp,T("%s"),buf1_255);

}
static int get_model_name (int ejid, webs_t wp, int argc, char_t **argv){


	strcpy(buf1_255,read_file_para_value("/var/etc/status","WIRELESS=",buf_512));
	strcpy(buf2_255,read_file_para_value("/etc/default/config","MODEL_NAME=",buf_512));
	strcpy(buf3_255,read_file_para_value("/etc/default/config","MODEL_NAME_G=",buf_512));
	if (!strcmp(buf1_255,"yes"))
		return websWrite(wp,T("%s"),buf3_255);
	else
		return websWrite(wp,T("%s"),buf2_255);
}
/*
static int get_url (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	if ((f=fopen("/flash/config","r"))!=NULL){
		fclose(f);
		strcpy(buf1_255,read_file_para_value("/flash/config","HOME_URL=",buf3_255));

	}
	else
		strcpy(buf1_255,"");
		
		return websWrite(wp,T("%s"),buf1_255);
}
static int get_version (int ejid, webs_t wp, int argc, char_t **argv) 
{
	FILE *f;
	if ((f=fopen("/flash/config","r"))!=NULL){
		fclose(f);
		if (!strcmp(argv[0],"hardware"))
			strcpy(buf1_255,read_file_para_value("/flash/config","HARDWARE_VER=",buf3_255));
		else
			strcpy(buf1_255,read_file_para_value("/flash/config","SOFTWARE_VER=",buf3_255));
	}
	else{
		strcpy(buf1_255,"");
	}
		return websWrite(wp,T("%s"),buf1_255);
}
*/
static int display_time (int ejid, webs_t wp, int argc, char_t **argv)
{	
	struct timeval tv;
	struct timezone tz;
	gettimeofday(&tv,&tz);

	char date_buf[30];
	char week_buf[20];
	char month_buf[20];
	char day_buf[20];
	char time_buf[20];
	char year_buf[20];
	sprintf(date_buf,"%s",(char *)ctime(&tv.tv_sec));
	//DPRINTF("date_buf:%s\n",date_buf);
	//Mon Jun 27 12:28:05 2005
	sscanf(date_buf,"%s %s %s %s %s",week_buf,month_buf,day_buf,time_buf,year_buf);
	/*
	DPRINTF("week_buf:%s\n",week_buf);
	DPRINTF("month_buf:%s\n",month_buf);
	DPRINTF("day_buf:%s\n",day_buf);
	DPRINTF("time_buf:%s\n",time_buf);
	DPRINTF("year_buf:%s\n",year_buf);
	*/
	if (!strcmp(week_buf,"Mon")){
		sprintf(week_buf,"%s",URL_L9[locale_config.locale]);
	}else if (!strcmp(week_buf,"Sun")){
		sprintf(week_buf,"%s",URL_L8[locale_config.locale]);
	}else if (!strcmp(week_buf,"Tue")){
		sprintf(week_buf,"%s",URL_L10[locale_config.locale]);
	}else if (!strcmp(week_buf,"Wed")){
		sprintf(week_buf,"%s",URL_L11[locale_config.locale]);
	}else if (!strcmp(week_buf,"Thu")){
		sprintf(week_buf,"%s",URL_L12[locale_config.locale]);
	}else if (!strcmp(week_buf,"Fri")){
		sprintf(week_buf,"%s",URL_L13[locale_config.locale]);
	}else if (!strcmp(week_buf,"Sat")){
		sprintf(week_buf,"%s",URL_L14[locale_config.locale]);
	}
	if (!strcmp(month_buf,"Jan")){
		sprintf(month_buf,"%s",Home_L9[locale_config.locale]);
	}else if (!strcmp(month_buf,"Feb")){
		sprintf(month_buf,"%s",Home_L10[locale_config.locale]);
	}else if (!strcmp(month_buf,"Mar")){
		sprintf(month_buf,"%s",Home_L11[locale_config.locale]);
	}else if (!strcmp(month_buf,"Apr")){
		sprintf(month_buf,"%s",Home_L12[locale_config.locale]);
	}else if (!strcmp(month_buf,"May")){
		sprintf(month_buf,"%s",Home_L13[locale_config.locale]);
	}else if (!strcmp(month_buf,"Jun")){
		sprintf(month_buf,"%s",Home_L14[locale_config.locale]);
	}else if (!strcmp(month_buf,"Jul")){
		sprintf(month_buf,"%s",Home_L15[locale_config.locale]);
	}else if (!strcmp(month_buf,"Aug")){
		sprintf(month_buf,"%s",Home_L16[locale_config.locale]);
	}else if (!strcmp(month_buf,"Sep")){
		sprintf(month_buf,"%s",Home_L17[locale_config.locale]);
	}else if (!strcmp(month_buf,"Oct")){
		sprintf(month_buf,"%s",Home_L18[locale_config.locale]);
	}else if (!strcmp(month_buf,"Nov")){
		sprintf(month_buf,"%s",Home_L19[locale_config.locale]);
	}else if (!strcmp(month_buf,"Dec")){
		sprintf(month_buf,"%s",Home_L20[locale_config.locale]);
	}
        return websWrite(wp,T("%s %s %s %s %s"),week_buf,month_buf,day_buf,time_buf,year_buf );


//        return websWrite(wp,T("%s"), (char *)ctime(&tv.tv_sec));
}

static int display_time_go (int ejid, webs_t wp, int argc, char_t **argv)
{	
	int updays, uphours, upminutes;
	struct sysinfo info;

	sysinfo(&info);

	updays = (int) info.uptime / (60*60*24);
	if (updays)
		websWrite(wp, T("%d %s, "), updays,Home_L21[locale_config.locale]);
	upminutes = (int) info.uptime / 60;
	uphours = (upminutes / 60) % 24;
	upminutes %= 60;
	if(uphours)
	        websWrite(wp, T("%2d %s %02d %s"), uphours,Home_L22[locale_config.locale],  upminutes,Home_L23[locale_config.locale]);
	else
		websWrite(wp, T("%d %s"), upminutes,Home_L23[locale_config.locale]);

	return 0;  
}
static int display_pppoe_time_go (int ejid, webs_t wp, int argc, char_t **argv)
{	
	int updays, uphours, upminutes;
	struct sysinfo info;
	FILE *f;
	int start_time=0;
	int start_time_show=0;
	int isconnected=0;
	f=fopen("/tmp/ppp/pppoe_start_time","r");
	if(f){
	  fscanf(f,"%d",&start_time);
	  fclose(f);
	}
	sysinfo(&info);
	//DPRINTF("info.uptime=%d\n",(int)info.uptime);
	//DPRINTF("start_time=%d\n",start_time);

	start_time_show=((int) info.uptime) - start_time;
	//DPRINTF("start_time_show=%d\n",start_time_show);
	strcpy(buf3_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1_255));
	f=fopen("/tmp/ppp/wan_connect_status","r");
	if(f){
	  fscanf(f,"%d",&isconnected);
	  fclose(f);
	}
	//DPRINTF("isconnected=%d\n",isconnected);
	if (isconnected==1){
	updays = (int) start_time_show / (60*60*24);
	if (updays)
		websWrite(wp, T("%d %s, "), updays,Home_L21[locale_config.locale]);
	upminutes = (int) start_time_show / 60;
	uphours = (upminutes / 60) % 24;
	upminutes %= 60;
		if(uphours){
			websWrite(wp, T("%2d %s %02d %s"), uphours,Home_L22[locale_config.locale], upminutes,Home_L23[locale_config.locale]);
		}else if(upminutes){
			websWrite(wp, T("%d %s"), upminutes,Home_L23[locale_config.locale]);
		}else{
			websWrite(wp, T("< 1 %s"),Home_L23[locale_config.locale]);
		}
	}else{
	  	websWrite(wp,T(""));
	}

	return 0;  
}
static void form_hostname_conf (webs_t wp, char_t *path, char_t *query)
{
	char_t *pbuf=NULL;
	Load_Lan_Config(&lan_config);

	pbuf=websGetVar(wp, T("HostName"), "");
	strcpy(lan_config.HostName,pbuf);
		
	Save_Lan_Config(&lan_config);
   
	save_globe_config(SYS_STATUS_FILE,"GATEWAY_NAME=",lan_config.HostName);
	save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY_NAME=",lan_config.HostName);
  	run_script(HOSTS_SCRIPT_FILE,0,0,0);
  	websRedirect(wp, T("home.asp")); 
}
static int get_bootrom_version (int ejid, webs_t wp, int argc, char_t **argv)
{
        FILE *fp;
        if((fp=fopen("/proc/GPIOUSER/bootv","r"))!=NULL){
		fscanf(fp,"%s\n",buf2_255);
		fclose(fp);
		return websWrite(wp,T("%s"),buf2_255);  
	}
	else
		return websWrite(wp,T(""));  
}

static int get_wan_ip_status (int ejid, webs_t wp, int argc, char_t **argv)
{
        int PINGSTATUS=0;
	//char_t str_wan_ip[20],str_wan_netmask[20],str_wan_gateway[20];
	//albert  string buf move from function
	//char_t line[255];
	// buf_512 -> line
	// buf1_255 -> str_wan_ip
	// buf2_255 -> str_wan_netmask
	// buf3_255 -> str_wan_gateway
	FILE *fp,*fp1;
	if ((fp1 = fopen(WAN_ERROR_LOG_FILE, "r"))==NULL){      	/* pppoecd success */
		if((fp=fopen(WAN_CONNECT_STATUS_FILE,"r"))!=NULL){
			if (fgets(buf_512,255,fp))
				sscanf(buf_512,"%d\n",&PINGSTATUS);
			fclose(fp); 
		}else{
			strcpy(buf1_255,""); // str_wan_ip
			strcpy(buf2_255,""); // str_wan_netmask
			strcpy(buf3_255,""); // str_wan_gateway
		}
	
		if (PINGSTATUS==1){	
			strcpy(buf1_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf_512));
			strcpy(buf2_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_MASK=",buf_512));
			strcpy(buf3_255,read_file_para_value(VAR_SYS_STATUS_FILE,"GATEWAY=",buf_512));
			/*
		        if((fp=fopen(WAN_IP_STATUS_FILE,"r"))!=NULL){
		        	if (fgets(buf_512,255,fp))
					sscanf(buf_512,"WAN_IP=\"%255[^\"]\"\n",buf1_255);
				if (fgets(buf_512,255,fp))
					sscanf(buf_512,"WAN_MASK=\"%255[^\"]\"\n",buf2_255);
			        if (fgets(buf_512,255,fp))
					sscanf(buf_512,"GATEWAY=\"%255[^\"]\"\n",buf3_255);
				fclose(fp);
			} 
			else {
				strcpy(buf1_255,"");
				strcpy(buf2_255,"");
				strcpy(buf3_255,"");
			}
			*/	
		} 
		else {
				strcpy(buf1_255,"");
				strcpy(buf2_255,"");
				strcpy(buf3_255,"");
		}
	} 
	else { /* fail */ 
		strcpy(buf1_255,"");
		strcpy(buf2_255,"");
		strcpy(buf3_255,"");
		fclose(fp1);
	}
	if (!isValidIP(buf1_255)) // str_wan_ip
		strcpy(buf1_255,"");
	if (!isValidIP(buf2_255)) // str_wan_netmask
		strcpy(buf2_255,"");
	if (!isValidIP(buf3_255)) // str_wan_gateway
		strcpy(buf3_255,"");
	if (strcmp(argv[0],"ipaddress")==0)// str_wan_ip
		websWrite(wp,T("%s"),buf1_255);
	if (strcmp(argv[0],"netmask")==0) // str_wan_netmask
		websWrite(wp,T("%s"),buf2_255);
	if (strcmp(argv[0],"gateway")==0)// str_wan_gateway
		websWrite(wp,T("%s"),buf3_255);
	return 1;
}

static int get_wan_ipcp_type (int ejid, webs_t wp, int argc, char_t **argv)
{
//        char_t str_wan_ipcp_type[255],tmp_str_wan_ipcp_type[255];//albert  string buf move from function
//        char_t line[255]; //albert  string buf move from function
        FILE *fp;
	// buf1_255 -> line
	// buf2_255 -> str_wan_ipcp_type
	// buf3_255 -> tmp_str_wan_ipcp_type
        if((fp=fopen(WAN_ERROR_LOG_FILE,"r"))!=NULL){
		if (fgets(buf1_255,255,fp))
				sprintf(buf2_255," - %s",buf1_255);
		fclose(fp);
	}	
	else
		strcpy(buf2_255,"");
	return websWrite(wp,T("%s"),buf2_255);  
	
}

static int get_vod_type (int ejid, webs_t wp, int argc, char_t **argv)
{
	char buf[255];
	memset(buf, 0, sizeof(buf));
	read_file_para_value(SYS_STATUS_FILE, "VOD_TYPE=", buf);
	if(strcmp(buf,"") != 0)
		return websWrite(wp, T(" - IPTV-%s"), buf);
	else
		return websWrite(wp, "");
}

static int get_wan_type (int ejid, webs_t wp, int argc, char_t **argv)
{
        //char_t temp_str_wan_type[255];//albert  string buf move from function
        //char_t line[255];//albert  string buf move from function
        int str_wan_type=0;
	int str_wan_quick_type=0;
	FILE *fp;
	// buf1_255 -> line
	// buf2_255 -> temp_str_wan_type
        if((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL){
	        if (fgets(buf1_255,255,fp))
			sscanf(buf1_255,"#:%d:%d\n",&str_wan_type,&str_wan_quick_type);
	        fclose(fp);
	}
	switch(str_wan_quick_type)
	{
		case 1:
		strcpy(buf2_255,"PPPoA VC-Mux");
		break;
		case 2:
		strcpy(buf2_255,"PPPoE LLC");
		break;
		case 3:
		strcpy(buf2_255,"1483 Routed IP VC-Mux");
		break;
		case 4:
		strcpy(buf2_255,"1483 Routed IP LLC");
		break;
		case 5:
		strcpy(buf2_255,"1483 LLC MER");
		break;
		case 6:
		strcpy(buf2_255,"Classical IP (1577)");
		break;
		case 7:
		strcpy(buf2_255,"1483 Bridged IP VC-Mux");
		break;
		case 8:
		strcpy(buf2_255,"1483 Bridged IP LLC");
		break;
		case 9:
		strcpy(buf2_255,"Pure Bridged VC-Mux");
		break;
		case 10:
		strcpy(buf2_255,"Pure Bridged LLC");
		break;
		case 11:
		strcpy(buf2_255,"PPPoA LLC");
		break;
		case 12:
		strcpy(buf2_255,"PPPoE VC-Mux");
		break;
		default:
		strcpy(buf2_255,"No Connection");
	}	
/*	if (str_wan_type==0)
		strcpy(buf2_255,"No Connection");
	else if (str_wan_type==1)
		strcpy(buf2_255,"RFC1483-Route");
	else if (str_wan_type==2)
		strcpy(buf2_255,"RFC1483-Bridge");
	else if (str_wan_type==3)
		strcpy(buf2_255,"PPPoA");
	else if (str_wan_type==4)
		strcpy(buf2_255,"IPoA");
	else if (str_wan_type==5)
		strcpy(buf2_255,"PPPoE");
	else
		strcpy(buf2_255,"");*/
	return websWrite(wp,T("%s"),buf2_255);  
}

static int read_connect_button (int ejid, webs_t wp, int argc, char_t **argv)
{
  //        char_t str_button[512];
        //char_t line[255];//albert  string buf move from function
        int str_wan_type=0;
        int str_connect_status=0;
	FILE *fp;
	// buf_512 -> str_button
	// buf1_255 -> line
        if((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL){
	        if (fgets(buf1_255,255,fp))
			sscanf(buf1_255,"#:%d:\n",&str_wan_type);
	        fclose(fp);
	}
        if((fp=fopen(WAN_CONNECT_STATUS_FILE,"r"))!=NULL){
	        if (fgets(buf1_255,255,fp))
			sscanf(buf1_255,"%d\n",&str_connect_status);
	        fclose(fp);
	}
	
	if (str_wan_type==0)
		strcpy(buf_512,"");
	else if (str_wan_type==1){
		Load_Wan_Config();
		
		if (str_connect_status!=CONNECTING){
			if (wan_config.Routed_IP_Assignment==0) /* dhclient */
				sprintf(buf_512,"<input type=button name=connect value=%s onClick=\"Connection_Action(1);\"> &nbsp; <input type=button name=connect value=%s onClick=\"Connection_Action(0);\">",Home_L1[locale_config.locale],Home_L2[locale_config.locale]);
			else
				strcpy(buf_512,"");
		}
		else /* Fixed IP */
			strcpy(buf_512,"");
	} else if (str_wan_type==2) {
		strcpy(buf_512,"");
	} else if (str_wan_type==3) {/* PPPoA */
		if (str_connect_status==0)
			sprintf(buf_512,"<input type=button name=connect value=%s onClick=\"Connection_Action(1);\">",Home_L3[locale_config.locale]);
		else if (str_connect_status==1)
			sprintf(buf_512,"<input type=button name=connect value=\"%s\" onClick=\"Connection_Action(0);\">",Home_L4[locale_config.locale]);
		else
			strcpy(buf_512,"");
	} else if (str_wan_type==4) {
		strcpy(buf_512,"");
	} else if (str_wan_type==5) {
		if (str_connect_status==0)
			sprintf(buf_512,"<input type=button name=connect value=%s onClick=\"Connection_Action(1);\">",Home_L3[locale_config.locale]);
		else if (str_connect_status==1)
			sprintf(buf_512,"<input type=button name=connect value=\"%s\" onClick=\"Connection_Action(0);\">",Home_L4[locale_config.locale]);
		else
			strcpy(buf_512,"");
	} else
		strcpy(buf_512,"");
	return websWrite(wp,T("%s"),buf_512);  
}

static int get_connection_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	int PINGSTATUS=0,str_status=0;
        FILE *fp,*fp1;
	//char_t line[255];//albert  string buf move from function
	// char_t buf[64];
	//char_t str_wan_connect_status[255];//albert  string buf move from function
	//char_t str_wan[10];
	// buf_512 -> line
	// buf1_255 -> buf
	// buf2_255 -> str_wan_connect_status
	// buf3_255 -> str_wan
        if (!strcmp(argv[0],"string"))
        	str_status=0;
        else if (!strcmp(argv[0],"button"))
		str_status=1;
	else /* hidden */
		str_status=2;
	
	if((fp=fopen(WAN_CONNECT_STATUS_FILE,"r"))!=NULL){
		if (fgets(buf_512,255,fp))
			sscanf(buf_512,"%d\n",&PINGSTATUS);
		fclose(fp);
	}
	
	if (str_status==0) /* string */
	{	
		if((fp1=fopen(WAN_ERROR_LOG_FILE,"r"))!=NULL)
		{
			sprintf(buf2_255,"%s",Home_L7[locale_config.locale]);
			fclose(fp1);
		}
		else
		{
			if (PINGSTATUS == CONNECTING)
	 			sprintf(buf2_255,"%s",Home_L6[locale_config.locale]);
			else if ( PINGSTATUS == CONNECTED )
				sprintf(buf2_255,"%s",Home_L5[locale_config.locale]);
			else if ( PINGSTATUS == DISCONNECTING )
				sprintf(buf2_255,"%s",Home_L8[locale_config.locale]);
			else /* DISCONNECTED */	
				sprintf(buf2_255,"%s",Home_L7[locale_config.locale]);
		}
	}
        else if (str_status==1) /* button */
	{	
		if ( PINGSTATUS == CONNECTED )
			sprintf(buf2_255,"%s",Home_L4[locale_config.locale]);
		else if ( PINGSTATUS == DISCONNECTED )
			sprintf(buf2_255,"%s",Home_L3[locale_config.locale]);
		else /* DISCONNECTING || CPNNECTING */	
			strcpy(buf2_255,"");
	}
	strcpy(buf3_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1_255));
//don't show connection status as 7500G
//	if (!strcmp(str_wan,"bridge"))
	if ((!strcmp(buf3_255,"bridge")) || (!strcmp(buf3_255,"routed")) || (!strcmp(buf3_255,"fixed")))
		return websWrite(wp,T("")); 
	else{	
	//	strcpy(buf3_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1_255));
	//	if(isValidIP(buf3_255)) 
			return websWrite(wp,T("%s"),buf2_255); 
	//	else{
	//		write_value_to_file(WAN_CONNECT_STATUS_FILE,DISCONNECTED);
	//		unlink(DNS_CONFIG_FILE);
	//		return websWrite(wp,T("Disconnected")); 
	//	}
	}
}
/*
static void ping_action (webs_t wp, char_t *path, char_t *query)
{

	run_script(PING_SCRIPT_FILE,0,0,0);
	//run_script("/etc/scripts/ping_loop.sh","&",0,0);
  	sleep(3);
	websRedirect(wp, T("home.asp")); 
}
*/
static void connect_action (webs_t wp, char_t *path, char_t *query)
{
	//char_t str_wan[10];
	//char_t buf[64]; //albert  string buf move from function
	
	// buf1_255 -> str_wan
	// buf2_255 -> buf

	strcpy(buf1_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf2_255));
/*	
	unlink(WAN_IP_STATUS_FILE);	
	unlink(WAN_ERROR_LOG_FILE);	
	unlink(TMP_RESOLV_CONF_FILE);	
	unlink(DNS_CONFIG_FILE);	
	unlink(WAN_ROUTE_SCRIPT_FILE);	
*/
	//if(strcmp(buf1_255,"dynamic")){
	//run_script("/etc/scripts/fw.sh","stop",0,0);
	//}
		
	if (!strcmp(buf1_255,"pppoe")) /* pppoe */
	{
		
		//echo 2 > /tmp/ppp/wan_connect_status
		write_value_to_file("/tmp/ppp/wan_connect_status",CONNECTING);
		runStartPppoecd();
#if 0
		if (IsExistProcess("pppoecd")){
			//touch /var/tmp/pppoestart
			TouchFile("/var/tmp/pppoestart");
			//kill -16 `pidof pppoecd`
			KillProcessByName("pppoecd",SIGUSR1);
		}
		else{
			run_script("/etc/scripts/pppoe.sh","start",0,0);
			/*
			Username=`echo $pppoeline | cut -f7 -d"|"`
			Password=`echo $pppoeline | cut -f8 -d"|"`
			Auth=`echo $pppoeline | cut -f11 -d"|"`
			Ondemand=`echo $pppoeline | cut -f12 -d"|"`
			IP=`echo $pppoeline | cut -f10 -d"|"`
			Idletime=`echo $pppoeline | cut -f13 -d"|"`
			MTU=`echo $pppoeline | cut -f15 -d"|"`
			PPPoEPID=`pidof pppoecd`
			if [ "$PPPoEPID" = "" ] ; then
				if [ "$Ondemand" = "0" ] ; then
					pppoecd nas0 -d -k -u $Username -p $Password -A $Auth -L $IP -t $MTU -I 30 -T 30 -N 10 &
				else
					pppoecd nas0 -d -k -u $Username -p $Password -A $Auth -L $IP -i $Idletime -t $MTU -I 30 -T 30 -N 10 &
				fi	
			else		
			#	sleep 1
			#	ping 168.95.1.1
			touch /var/tmp/pppoestart
			kill -16 `pidof pppoecd`
			fi
			*/
		}
#endif				
		//run_script(CONNECT_WAN_SCRIPT_FILE,"start","pppoe",0);
	}
	else if (!strcmp(buf1_255,"dynamic")) /* dynamic */
	{
	//	run_script(CONNECT_WAN_SCRIPT_FILE,"stop","dynamic",0);
		
		//run_script(CONNECT_WAN_SCRIPT_FILE,"start","dynamic",0);
	//	echo 2 > /tmp/ppp/wan_connect_status
		write_value_to_file("/tmp/ppp/wan_connect_status",CONNECTING);
	
	//	kill -16 `pidof udhcpc`
		KillProcessByName("udhcpc",SIGUSR1);
	}
	else if(!strcmp(buf1_255,"pppoa")) /* pppoa */
	{
		run_script(CONNECT_WAN_SCRIPT_FILE,"stop","pppoa",0);
		run_script(CONNECT_WAN_SCRIPT_FILE,"start","pppoa",0);
	}
	else /* if (!strcmp(str_wan,"fixed")) */
	{	
		run_script(CONNECT_WAN_SCRIPT_FILE,"stop","fixed",0);
		run_script(CONNECT_WAN_SCRIPT_FILE,"start","fixed",0);
	}
	websRedirect(wp, T("home.asp")); 
}
extern LAN_CONFIG_DATA lan_config;
extern DHCPD_CONFIG_DATA dhcpd_config;
extern void Save_Dhcpd_Config (int i,DHCPD_CONFIG_DATA  *d);

void restore_dhcpd_and_lan(void)
{
	FILE *fp;

	DPRINTF("entering restore_dhcpd_and_lan  in web\n");
  // we need to restore the old lan/netmask info when the IPCP is down and if there exists TEMP_LAN_INFO
    fp=fopen(TEMP_LAN_INFO,"r");
	if(!fp)	
	{		
		//notice("empty %s\n",TEMP_LAN_INFO);
		return;
    }
  
    Load_Dhcpd_Config(&dhcpd_config,&lan_config);
    if( dhcpd_config.Enable != 0)
		run_script(DHCP_SCRIPT_FILE,"stop",0,0);

    Load_Lan_Config(&lan_config);
 	fscanf(fp, "%s %s\n",lan_config.HostAddress,lan_config.HostNetmask);
    Save_Lan_Config(&lan_config);
    save_globe_config("/var/etc/status", "LAN_IP=", lan_config.HostAddress);
    save_globe_config("/flash/config", "LAN_IP=", lan_config.HostAddress);
    run_task("/sbin/ifconfig","/sbin/ifconfig", "br0", lan_config.HostAddress, "netmask", lan_config.HostNetmask, NULL);    

 	fscanf(fp,"%d\n",&dhcpd_config.Enable);
	fscanf(fp, "%s %s %s %s %s %s\n",dhcpd_config.Subnet,dhcpd_config.Netmask,dhcpd_config.Router,
	dhcpd_config.Broadcast_address, dhcpd_config.Range_start,dhcpd_config.Range_end);
	fclose(fp);		
	unlink(TEMP_LAN_INFO);

    Save_Dhcpd_Config (dhcpd_config.Enable, &dhcpd_config);

    run_script(DHCP_SCRIPT_FILE,"start",0,0);
	DPRINTF("exit restore_dhcpd_and_lan  in web\n");
}
static void disconnect_action (webs_t wp, char_t *path, char_t *query)
{
	//FILE *fp;
	//char_t line[255];
	//char_t str_wan[10];
	//char_t buf[64];
	
	// buf1_255 -> line
	// buf2_255 -> str_wan
	// buf3_255 -> buf

	// wait for 1 seconds???/
	restore_dhcpd_and_lan();
	strcpy(buf2_255,read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf3_255));

//	unlink(WAN_IP_STATUS_FILE);
//	unlink(WAN_ERROR_LOG_FILE);
//	unlink(TMP_RESOLV_CONF_FILE);	
//	unlink(DNS_CONFIG_FILE);
//	unlink(WAN_ROUTE_SCRIPT_FILE);
// solve bug4 of 1.00a2 bug list from terry
//	run_script("/etc/scripts/fw.sh","stop",0,0);
	
	if (!strcmp(buf2_255,"pppoe")){
			//echo 3 > /tmp/ppp/wan_connect_status
			write_value_to_file("/tmp/ppp/wan_connect_status",DISCONNECTING);
			//kill -15 `pidof zebra`
			KillProcessByName("zebra",SIGTERM);
	strcpy(buf1_255,read_file_para_value(DEFAULT_CONFIG_FILE,"VOIP=",buf3_255));
	if (!strcmp(buf1_255,"yes")){
			KillProcessByName("act",SIGTERM);		
			KillProcessByName("actact",SIGTERM);		
		run_script("/usr/bin/act_spt",0,0,0);
         }
			//touch /var/tmp/pppoestop
			runStopPppoecd();
#if 0
			TouchFile("/var/tmp/pppoestop");
			//kill -16 `pidof pppoecd`
			KillProcessByName("pppoecd",SIGUSR1);
			sleep(5);
			//kill -9 `pidof fw.sh`
			run_task("route","del","default","gw","0.0.0.0",0);
#endif			
			/*
			if [ -f /flash/ripd.conf ] ; then
			cat /flash/ripd.conf|
			read text;
				if [ "$text" = "!1" ] || [ "$text" = "!3" ] ; then
					kill -9 `pidof zebra`
					echo "ripd start"
					zebra &
					iptables -I INPUT -p udp -s $LAN_IP/$LAN_MASK --dport 520 -j ACCEPT
					iptables -I INPUT -p tcp -s $LAN_IP/$LAN_MASK --dport 2600 -j ACCEPT
				fi
			fi
			*/
			//echo 0 > /proc/GPIOUSER/pppled
			//write_value_to_file("/proc/GPIOUSER/pppled",DISCONNECTED);
			//echo 0 > /tmp/ppp/wan_connect_status
			//write_value_to_file("/tmp/ppp/wan_connect_status",DISCONNECTED);

		//run_script(CONNECT_WAN_SCRIPT_FILE,"stop","pppoe",0);
		//run_script("/etc/scripts/pppoe_stop.sh",0,0,0);
	}else if (!strcmp(buf2_255,"pppoa")){
		run_script(CONNECT_WAN_SCRIPT_FILE,"stop","pppoa",0);
	}else if (!strcmp(buf2_255,"dynamic")){
			//echo 3 > /tmp/ppp/wan_connect_status
			write_value_to_file("/tmp/ppp/wan_connect_status",DISCONNECTING);
		
			//kill -17 `pidof udhcpc`
			KillProcessByName("udhcpc",SIGUSR2);
			
			//echo 0 > /tmp/ppp/wan_connect_status
			write_value_to_file("/tmp/ppp/wan_connect_status",DISCONNECTED);
//		run_script(CONNECT_WAN_SCRIPT_FILE,"stop","dynamic",0);
	}
	else{ /* if (!strcmp(str_wan,"fixed")) */
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
		run_script(CONNECT_WAN_SCRIPT_FILE,"stop","fixed",0);
	}
// solve bug4 of 1.00a2 bug list from terry
	//run_script("/etc/scripts/fw.sh","stop",0,0);
	websRedirect(wp, T("home.asp"));
}





void DefineWebFunctions_home() 
{
  	websFormDefine(T("hostname"), form_hostname_conf);
	websAspDefine(T("get_home_status"), get_home_status);
/*	
	websAspDefine(T("get_version"), get_version);
	websAspDefine(T("get_url"), get_url);
	websAspDefine(T("get_url_name"), get_url_name);
*/	
	websAspDefine(T("get_model_name"), get_model_name);
	websAspDefine(T("display_time_go"), display_time_go);
	websAspDefine(T("display_pppoe_time_go"), display_pppoe_time_go);
	websAspDefine(T("display_time"), display_time);
	websAspDefine(T("get_bootrom_version"), get_bootrom_version);
	websAspDefine(T("get_wan_type"), get_wan_type);
	websAspDefine(T("get_wan_ipcp_type"), get_wan_ipcp_type);
	websAspDefine(T("get_vod_type"), get_vod_type); // KenWang added 2007/02/06
	websAspDefine(T("get_wan_ip_status"), get_wan_ip_status);
	websAspDefine(T("get_connection_status"), get_connection_status);
	websAspDefine(T("read_connect_button"), read_connect_button);
//	websFormDefine(T("ping"), ping_action);
	websFormDefine(T("connect"), connect_action);
	websFormDefine(T("disconnect"), disconnect_action);
}                                                                                           
