/****************************************************************************
 *
 *  Copyright (c) 2001 by LSI Logic Corporation, all rights reserved.
 *
 *                         LSI Logic confidential
 *  The information contained herein is proprietary of LSI Logic Corporation.
 *
 *  This software is provided "as is" without any express or implied warranty.
 *  LSI Logic disclaims all representations and warranties with regard to
 *  this software, including all implied warranties of merchantability and
 *  fitness for a particular purpose. In no event shall LSI Logic be liable
 *  for any special, indirect or consequential damages or any damages
 *  whatsoever resulting from loss of use, data or profits, whether in an
 *  action of contract, negligence or other tortious act or omission,
 *  arising out of or in connection with the use or performance of this
 *  software.
 *
 *  $Id: $
 *
 *  Revision Details
 *  $Log:  $
 *
 *
 *  File Description:
 *  Header file for the DHCP Configuration CGI script.
 *
 ****************************************************************************/

#ifndef _HOST_CONFIG_H
#define _HOST_CONFIG_H

/****************************************************************************
 * includes
 ****************************************************************************/
#include "gen_config.h"

/****************************************************************************
 * definitions (macros)
 ****************************************************************************/
#define HOSTS_CONFIG_FILE CONFIG_DIR"/myhosts"
#define HOSTS_SCRIPT_FILE CONFIG_DIR"/hostscript"

/****************************************************************************
 * definitions (types)
 ****************************************************************************/

typedef struct {
		char *host_name;
		char *host_address;
		char *netmask;
    char *media;
}HostData;

/****************************************************************************
 * function prototypes
 ****************************************************************************/
extern int host_load_config(void *);
extern int host_save_config(void *);
extern int host_validate(char **error_str, void *user_data);
extern int host_run_script(void);
extern char *host_get_name_v(void);
extern void host_set_name_v(char *value);
extern char *host_get_address_v(void);
extern void host_set_address_v(char *value);
extern char *host_get_netmask_v(void);
extern void host_set_netmask_v(char *value);
extern char *host_get_media_v(void);
extern void host_set_media_v(char *value);

#endif
