/*
 *  igmp.asp: IGMP Proxy and Snooping
 */
#include "webs.h"
#include "lan_conf.h"
#include "wan.h"
#include "igmp.h"
#include "../iptables-1.2.11/runFunc.h"
IGMP_CONFIG_DATA igmp_config;
void resetCurrentIgmpCfg(void);
static int Load_Igmp_Config (void);
static int Save_Igmp_Config (IGMP_CONFIG_DATA *d);
static void Igmp_Form(webs_t wp,char_t * path,char_t * query);
static int get_igmp_mod (int eid, webs_t wp, int argc, char_t ** argv);
static int get_igmp_mod (int eid, webs_t wp, int argc, char_t ** argv)
{
	int i,j;
	Load_Igmp_Config();
	i=atoi(argv[1]);
	if (!strcmp(argv[0],"proxy"))
		j=igmp_config.igmp_proxy;
	else
		j=igmp_config.igmp_snooping;
	if (i==j)
   		return websWrite(wp, T("checked"));
	else
   		return websWrite(wp, T(""));
}
static void Igmp_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
	char_t str_wanip[20];
	char_t buf2[64];

	Load_Igmp_Config();
	buf = websGetVar(wp, T("IGMP"),"");
 	igmp_config.igmp_proxy=atoi(buf); 
		buf = websGetVar(wp, T("Qbridge"),"");
	 	igmp_config.igmp_snooping=atoi(buf); 
	
	Save_Igmp_Config(&igmp_config);
	
	strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf2));
	if(isValidIP(str_wanip))
	{   //NOTE ONLY WHEN WAN INTERFACE is ready, then we start the function
	sprintf(funcNum,"%d",FUNCTION_NUM_IGMP_PROXY);		
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	}

		DPRINTF("run IGMP SNOOPING");
		sprintf(funcNum1,"%d",FUNCTION_NUM_IGMP_SNOOPING);		
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
	websRedirect(wp, T("igmp.asp"));
}

void resetCurrentIgmpCfg(void)
{
	IGMP_CONFIG_DATA *d=&igmp_config;
	memset(d,0,sizeof(IGMP_CONFIG_DATA));
}

static int Load_Igmp_Config (void)
{
	FILE *fp;
	resetCurrentIgmpCfg();
	fp=fopen(IGMP_CONFIG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %d\n",&igmp_config.igmp_proxy,&igmp_config.igmp_snooping);
		fclose(fp);
	}
	return 0;
}

static int Save_Igmp_Config (IGMP_CONFIG_DATA *d)
{
	FILE *fp;
	fp=fopen(IGMP_CONFIG_FILE,"w");
	if(fp) {
		fprintf(fp,"%d %d\n",d->igmp_proxy,d->igmp_snooping);
		fclose(fp);
	}
	return 0;
}

int igmp_snoop_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
	
	//if there are multiple interfaces in the wired LAN.  So, we need to enable the configuration of igmp snooping
	return websWrite(wp, T(""));
}


void DefineWebFunctions_igmp() {
	websAspDefine(T("get_igmp_mod"), get_igmp_mod);
	websAspDefine(T("igmp_snoop_enabled"), igmp_snoop_enabled);
	websFormDefine(T("igmp"), Igmp_Form);
}
