#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/if.h>

#include "webs.h"


FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 


#define _PATH_PROCNET_DEV               "/proc/net/dev"

struct user_net_device_stats {
  //    unsigned long long rx_packets;	/* total packets received       */
  //  unsigned long long tx_packets;	/* total packets transmitted    */
  //  unsigned long long rx_bytes;	/* total bytes received         */
  //  unsigned long long tx_bytes;	/* total bytes transmitted      */
    unsigned  long rx_packets;	/* total packets received       */
    unsigned  long tx_packets;	/* total packets transmitted    */
    unsigned  long rx_bytes;	/* total bytes received         */
    unsigned  long tx_bytes;	/* total bytes transmitted      */
    unsigned long rx_errors;	/* bad packets received         */
    unsigned long tx_errors;	/* packet transmit problems     */
    unsigned long rx_dropped;	/* no space in linux buffers    */
    unsigned long tx_dropped;	/* no space available in linux  */
    unsigned long rx_multicast;	/* multicast packets received   */
    unsigned long rx_compressed;
    unsigned long tx_compressed;
    unsigned long collisions;

    /* detailed rx_errors: */
    unsigned long rx_length_errors;
    unsigned long rx_over_errors;	/* receiver ring buff overflow  */
    unsigned long rx_crc_errors;	/* recved pkt with crc error    */
    unsigned long rx_frame_errors;	/* recv'd frame alignment error */
    unsigned long rx_fifo_errors;	/* recv'r fifo overrun          */
    unsigned long rx_missed_errors;	/* receiver missed packet     */
    /* detailed tx_errors */
    unsigned long tx_aborted_errors;
    unsigned long tx_carrier_errors;
    unsigned long tx_fifo_errors;
    unsigned long tx_heartbeat_errors;
    unsigned long tx_window_errors;
};

struct interface {
    struct interface *next, *prev; 
    char name[IFNAMSIZ];	/* interface name        */
    short type;			/* if type               */
    short flags;		/* various flags         */
    int metric;			/* routing metric        */
    int mtu;			/* MTU value             */
    int tx_queue_len;		/* transmit queue length */
    struct ifmap map;		/* hardware setup        */
    struct sockaddr addr;	/* IP address            */
    struct sockaddr dstaddr;	/* P-P IP address        */
    struct sockaddr broadaddr;	/* IP broadcast address  */
    struct sockaddr netmask;	/* IP network mask       */
    struct sockaddr ipxaddr_bb;	/* IPX network address   */
    struct sockaddr ipxaddr_sn;	/* IPX network address   */
    struct sockaddr ipxaddr_e3;	/* IPX network address   */
    struct sockaddr ipxaddr_e2;	/* IPX network address   */
    struct sockaddr ddpaddr;	/* Appletalk DDP address */
    struct sockaddr ecaddr;	/* Econet address        */
    int has_ip;
    int has_ipx_bb;
    int has_ipx_sn;
    int has_ipx_e3;
    int has_ipx_e2;
    int has_ax25;
    int has_ddp;
    int has_econet;
    char hwaddr[32];		/* HW address            */
    int statistics_valid;
    struct user_net_device_stats stats;		/* statistics            */
    int keepalive;		/* keepalive value for SLIP */
    int outfill;		/* outfill value for SLIP */
};

#if 0
static void print_bytes_scaled(unsigned long long ull, const char *end)
{
	unsigned long long int_part;
	unsigned long frac_part;
	const char *ext;
	int i;

	frac_part = 0;
	ext = TRext;
	int_part = ull;
	for (i=0 ; i<2 ; i++) {
		if (int_part >= 1024) {
			frac_part = ((int_part % 1024) * 10) / 1024;
			int_part /= 1024;
			ext += 2;			/* Kb, Mb */
		}
	}

	DPRINTF("X bytes:%Lu (%Lu.%lu %sb)%s", ull, int_part, frac_part, ext, end);
}

static void ife_print(struct interface *ptr)
{
    if (ptr->statistics_valid) {
	DPRINTF(_("RX packets:%Lu errors:%lu dropped:%lu overruns:%lu frame:%lu\n"),
	       ptr->stats.rx_packets, ptr->stats.rx_errors,
	       ptr->stats.rx_dropped, ptr->stats.rx_fifo_errors,
	       ptr->stats.rx_frame_errors);
	PRINTT("          ");
	DPRINTF(_("TX packets:%Lu errors:%lu dropped:%lu overruns:%lu carrier:%lu\n"),
	       ptr->stats.tx_packets, ptr->stats.tx_errors,
	       ptr->stats.tx_dropped, ptr->stats.tx_fifo_errors,
	       ptr->stats.tx_carrier_errors);
	DPRINTF(_("          collisions:%lu "), ptr->stats.collisions);
	if (can_compress)
	    DRPINTF(_("compressed:%lu "), ptr->stats.tx_compressed);
	if (ptr->tx_queue_len != -1)
	    DPRINTF(_("txqueuelen:%d "), ptr->tx_queue_len);
	printf("\n          R");
	print_bytes_scaled(ptr->stats.rx_bytes, "  T");
	print_bytes_scaled(ptr->stats.tx_bytes, "\n");
    }    
}
#endif

static char *get_name(char *name, char *p)
{
    while (isspace(*p))
	p++;
    while (*p) {
	if (isspace(*p))
	    break;
	if (*p == ':') {	/* could be an alias */
	    char *dot = p, *dotname = name;
	    *name++ = *p++;
	    while (isdigit(*p))
		*name++ = *p++;
	    if (*p != ':') {	/* it wasn't, backup */
		p = dot;
		name = dotname;
	    }
	    if (*p == '\0')
		return NULL;
	    p++;
	    break;
	}
	*name++ = *p++;
    }
    *name++ = '\0';
    return p;
}

static int get_dev_fields(char *bp, struct interface *ife)
{
    sscanf(bp,
	   "%lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu",
	   &ife->stats.rx_bytes,
	   &ife->stats.rx_packets,
	   &ife->stats.rx_errors,
	   &ife->stats.rx_dropped,
	   &ife->stats.rx_fifo_errors,
	   &ife->stats.rx_frame_errors,
	   &ife->stats.rx_compressed,
	   &ife->stats.rx_multicast,

	   &ife->stats.tx_bytes,
	   &ife->stats.tx_packets,
	   &ife->stats.tx_errors,
	   &ife->stats.tx_dropped,
	   &ife->stats.tx_fifo_errors,
	   &ife->stats.collisions,
	   &ife->stats.tx_carrier_errors,
	   &ife->stats.tx_compressed);
#if 0
    DPRINTF("1: -%s-\n", bp);
    printf("2: %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
	   ife->stats.rx_bytes,
	   ife->stats.rx_packets,
	   ife->stats.rx_errors,
	   ife->stats.rx_dropped,
	   ife->stats.rx_fifo_errors,
	   ife->stats.rx_frame_errors,
	   ife->stats.rx_compressed,
	   ife->stats.rx_multicast,

	   ife->stats.tx_bytes,
	   ife->stats.tx_packets,
	   ife->stats.tx_errors,
	   ife->stats.tx_dropped,
	   ife->stats.tx_fifo_errors,
	   ife->stats.collisions,
	   ife->stats.tx_carrier_errors,
	   ife->stats.tx_compressed);
#endif
    return 0;
}

#if 0
static int get_proc_net() 
{
    char buf[512];
    struct interface ife;

    fh = fopen(_PATH_PROCNET_DEV, "r");
    if (!fh) {
	    fprintf(stderr, "can't get net information\n");
	    return -1;
    }

    fgets(buf, sizeof buf, fh);	/* eat line */
    fgets(buf, sizeof buf, fh);

    // using version 3
    while (fgets(buf, sizeof buf, fh)) {
	char *s, name[IFNAMSIZ];
	s = get_name(name, buf);
	//ife = add_interface(name);
	printf("%s name\n", name);
	get_dev_fields(s, &ife);
	ife.statistics_valid = 1;
    }
    fclose(fh);
    return 0;
}
#endif

static int check_if_name(char *name,char *name1)
{
    char *namelist[] = { "vlan2", "vlan3", "vlan4", "vlan5",
			 "nas0", "nas10", "nas1", "nas2", "nas3", "wlan0", "br0"};
    char *toname[] = { "Port1", "Port2", "Port3", "Port4",
		       "ATM0(Wan)", "ATM1(Vod1)", "ATM2(Vod2)", "ATM3(Vod3)", "ATM4(Vod4)", "Wireless", "LAN"};
    int i;

    //DPRINTF("size  %d \n", sizeof(namelist)/sizeof(char*));

    for(i=0;i<sizeof(namelist)/sizeof(char*);i++){
	if( !strcmp(name, namelist[i]) ){
	    strcpy(name1, toname[i]);
	    return 1; // OK
	}
    }
    return 0; // ERROR
}

static int interface_status(int eid, webs_t wp, int argc, char_t ** argv)
{
    char buf[512];
    char print_buf[512];
    struct interface ife;
    FILE *fh=NULL;
    //char *fmt="<tr><td>%s</td><td>%s</td></tr>\n";
    // bytes, packets, errors, dropped
    char *fmt="<tr><td>%s</td><td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td><td>%lu</td></tr>";
    char *strfmt="<tr><td class='title'>Name</td><td class='title'>Rx Bytes</td><td class='title'>Rx Packets</td><td class='title'>Rx Errors</td><td class='title'>Rx Droppd</td><td class='title'>Tx Bytes</td><td class='title'>Tx Packets</td><td class='title'>Tx Errors</td><td class='title'>Tx Dropped</td></tr>";
    fh = fopen(_PATH_PROCNET_DEV, "r");
    if (!fh) {
	    fprintf(stderr, "can't get net information\n");
	    return -1;
    }

    fgets(buf, sizeof buf, fh);	/* eat line */
    fgets(buf, sizeof buf, fh);

    websWrite(wp, T(strfmt));
    // using version 3
    while (fgets(buf, sizeof buf, fh)) {
	char *s, name[IFNAMSIZ], name1[32];
	s = get_name(name, buf);
	//ife = add_interface(name);
	//printf("%s name\n", name);

	get_dev_fields(s, &ife);
	ife.statistics_valid = 1;

#if 1
	if(check_if_name(name, name1)) {
	    sprintf(print_buf, fmt,
		    name1,
		    ife.stats.rx_bytes,
		    ife.stats.rx_packets,
		    ife.stats.rx_errors,
		    ife.stats.rx_dropped,
		    
		    ife.stats.tx_bytes,
		    ife.stats.tx_packets,
		    ife.stats.tx_errors,
		    ife.stats.tx_dropped
		);
	    //DPRINTF("3: %s\n",print_buf);
	    websWrite(wp, T(print_buf));
	}
#else
	websWrite(wp, T(fmt),	
		  name,
		ife.stats.rx_bytes,
		ife.stats.rx_packets,
		ife.stats.rx_errors,
		ife.stats.rx_dropped,
		
		ife.stats.tx_bytes,
		ife.stats.tx_packets,
		ife.stats.tx_errors,
		ife.stats.tx_dropped
		);
#endif
    }
    fclose(fh);
    return 0;
}

void DefineWebFunction_interface_status()
{
	websAspDefine(T("interface_status"), interface_status);
}
