/*
 *  IPSEC
 */

#include "webs.h"
#include "uemf.h"
#include "ipsec.h"       
#include "ipsec_config.h"
#include "time.h"
#include "home.h"
#include "../iptables-1.2.11/runFunc.h"
#include "../tmss/include/tmSemaphore.h"
#include "../tmss/include/tmShm.h"


typedef char I8_T;
typedef unsigned char UI8_T;
typedef unsigned int UI32_T;
typedef short BOOL;

extern char WAN_IP[];

#define inet_ntoa_b(inet_addr,dest_string) strcpy(dest_string, inet_ntoa(inet_addr))
#define IPSEC_POLILCY_RULE IPSEC_RULE_T
#define DEFAULT_CONFIG_FILE "/etc/default/config"

extern char_t *SelectListOption( char_t **Option_List, int num, int who);
extern void run_task(char *cmd, ...);
//int ipsecCheckIfAllConnectionsAreDisconnected();
/*
 * IPSec Config: ipsec.asp, ipsec1.asp, ipsec2.asp, ipsec_st.asp
 */

//Define Form Func
static void formIpsec(webs_t wp, char_t *path, char_t *query);
static void formIpsec1(webs_t wp, char_t *path, char_t *query);
static void formIpsec2(webs_t wp, char_t *path, char_t *query);
static void formStatIpsec(webs_t wp, char_t *path, char_t *query);

// web pages function
//static int aspGetIpsecEnable_status(int eid, webs_t wp, int argc, char_t **argv);
//static int aspGetIpsecSaveConfWarning(int eid, webs_t wp, int argc, char_t **argv);
static int aspIpsecShow(int eid, webs_t wp, int argc, char_t **argv);
static int aspIPSec1_Now(int eid, webs_t wp, int argc, char_t **argv);
static int aspIPSec1_Page(int eid, webs_t wp, int argc, char_t **argv);
static int aspIPSec2_Page(int eid, webs_t wp, int argc, char_t **argv);


static int aspGetIpsecNATTraversalEnable(int eid, webs_t wp, int argc, char_t **argv);
static int aspGetIpsecNAT_KL_Seconds(int eid, webs_t wp, int argc, char_t **argv);
//static int aspGetIpsecNATForceKeepalive(int eid, webs_t wp, int argc, char_t **argv);
//static int aspGetIpsecNATDisablePortFloating(int eid, webs_t wp, int argc, char_t **argv);

static int aspGetIpsecConnectStatusList(int eid, webs_t wp, int argc, char_t **argv);
static int aspGetIpsecRefreshTimeSel(int eid, webs_t wp, int argc, char_t **argv);
void copySaveIPsecStatusToFromLocal(int action,int instance, IPSEC_CFG_STATUS *ics);

UI32_T ipsecRefreshTimeSel=1;//started from 0:5 sec.  1:10 sec. 2:15 Sec. 3:30 sec 4:45 Sec. 5:60 sec

extern int ipsec_load_config(void);
extern int ipsec_save_config(void);
extern int ipsec_run_dod_check(void);
IPSEC_CFG_STATUS ipsec_cfg_status[MAX_RULE];
//void IPSecConnectStatus_Init(void);

static void Define_IPSEC_ipsec();
int GetConfigToIPSecTable(IPSEC_TABLE_T *table);

void DefineWebFunctions_IPSec() {
	Define_IPSEC_ipsec();
}

/*
 * albert 20030207 for qos.asp, qos1.asp
 */
IPSEC_TABLE_T IPSec_Table,IPSec_TableShow;

int ipsecIfAnyRulesActive(IPSEC_TABLE_T *table)	
{
	IPSEC_RULE_T *rule;
	int i;
   for (i = 0; i < MAX_RULE; i++) 
   {
     rule = &(table->Rule[i]);
     if( rule->Item != 0 ) {
       if( rule->Active == 1 )
       {
		return 1;
       }
     }	
   }	
   return 0; 
}


/*	tmp.Item = 5;
	tmp.Active = IPSEC_Rule_Yes;	//2
	strcpy(tmp.RemoteIP,"testhost.ip\0");	//3
	inet_aton("192.168.11.0",&tmp.Subnet);	//4
	inet_aton("255.255.255.0",&tmp.SubnetMask);//5
	tmp.Proposal=IPSEC_PROPOSAL_AH;//6
	tmp.Esp=IPSEC_ESP_3DES;//7
	strcpy(tmp.PreSharedKey,"testkeys");//8
	tmp.Phase1_SA_Lifetime=480;//9
	tmp.Phase2_SA_Lifetime=480;//10
	tmp.perfect_forward_secrecy=IPSEC_PFS_Yes;//11
	tmp.responder_only=IPSEC_ResponderOnly_No;//11

*/
void IPSec_Table_Init(IPSEC_TABLE_T *table);
int IPSec_AddRule(IPSEC_TABLE_T *table, IPSEC_RULE_T *rule);
int IPSec_SetRule(IPSEC_TABLE_T *table, IPSEC_RULE_T *rule, int item);
int IPSec_DelRule(IPSEC_TABLE_T *table, int item);
int IPSec_CopyTable(IPSEC_TABLE_T *DstTable, IPSEC_TABLE_T *SrcTable);
int SetIPSecTableToConfig (IPSEC_TABLE_T * table);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
//extern int CreateIPSecTableToScript (IPSEC_TABLE_T * table);
static int ipsec_st_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
	int j;
	FILE *fp;
	char filename[30];

	
	// check if any rules in the whack
	for (j = 0; j < MAX_RULE; j++)
	{		
		//1. how do we know the ipsec rule exist in the  current setup ipsec database (Not the newest modified
		// IPsec configuration one, since we only apply the changes when the fw.sh start.)
		sprintf(filename, "/var/etc/ipsec_ipt%d.add", j);
		if ((fp = fopen(filename, "r")))
		{ 
			fclose(fp);
			break;
		}
	}

 	if(j>=MAX_RULE)
	{ // Not valid active ipsec rules in database
		int i;
		i=atoi(argv[0]);
		if(i==0)//comment begin
			return websWrite(wp, T("<!--"));
		else
			return websWrite(wp, T("-->"));
	}
	return websWrite(wp, T(""));
}
extern int checked_function_enabled (char *parameter, webs_t wp, char_t **argv);

static int is_ipsec_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("IPSEC=",wp,argv);
}

static void Define_IPSEC_ipsec() {

	IPSec_Table_Init(&IPSec_Table);
	IPSec_Table_Init(&IPSec_TableShow);
	GetConfigToIPSecTable(&IPSec_Table);
	GetConfigToIPSecTable(&IPSec_TableShow);

	//CreateIPSecTableToScript(&IPSec_Table); Mmmmm.... we create it when FW.SH is ready
	//IPSecConnectStatus_Init();

	websAspDefine(T("is_ipsec_enabled"), is_ipsec_enabled);
	//ipsec.asp
	websFormDefine(T("ipsec"), formIpsec);

	//websAspDefine(T("ipsecSaveConfWarning"),aspGetIpsecSaveConfWarning);
	websAspDefine(T("ipsecRuleList"), aspIpsecShow);

	websAspDefine(T("ipsec_NAT_TravesalVal"), aspGetIpsecNATTraversalEnable);
	websAspDefine(T("ipsec_NAT_KL_SecVal"), aspGetIpsecNAT_KL_Seconds);
//	websAspDefine(T("ipsec_NAT_ForceKL"), aspGetIpsecNATForceKeepalive);
//	websAspDefine(T("ipsec_NAT_DisablePF"), aspGetIpsecNATDisablePortFloating);
 
	//ipsec1.asp
	websFormDefine(T("ipsec1"), formIpsec1);
	websAspDefine(T("ipsec1_Table"), aspIPSec1_Page);

	websAspDefine(T("ipsecNow"), aspIPSec1_Now);

	//ipsec2.asp
	websFormDefine(T("ipsec2"), formIpsec2);
	websAspDefine(T("ipsec2_Table"), aspIPSec2_Page);
	//ipsec_st.asp
	websAspDefine(T("ipsec_st_enabled"), ipsec_st_enabled);
	websFormDefine(T("stat_ipsec"), formStatIpsec);

	websAspDefine(T("ipsecConnectStatusList"), aspGetIpsecConnectStatusList);
	websAspDefine(T("ipsecRefreshTimeSel"), aspGetIpsecRefreshTimeSel);
    //ipsec_run_dod_check();
}

/*==========================================

 	ASP Function for IPSEC
 	
  ==========================================*/
//---------------------For IPSec ------------------------------------
char *connectStatusStr[]={"Not Connected","Connecting","Connected","Disconnecting"};
static enum ClickOption IPSec_Func = Click_Func_CENCEL;
static int ipsecAdvanceEdit=0;// Not the Adavanced editing.
static int IPSec_Edit_Index = 0;

int	L2TPhtmlPage=FALSE;

/* for ipsec.asp
static int aspGetIpsecSaveConfWarning(int eid, webs_t wp, int argc, char_t **argv)
{
#if 1
	// check if any connection is NOT in DISCONNECTED or DISCONNECTING, the warning page disappeared
	if(ipsecCheckIfAllConnectionsAreDisconnected())
		websWrite(wp, T("true"));  	//Set "TRUE" for the saveConf function in ipsec.asp
	else
		websWrite(wp, T("confirm(warningStr)"));
#endif
	return 0;
}
*/
static int aspIpsecShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i;
	char	RemoteSubnet[40];
	IPSEC_RULE_T *  rule;

	char_t *TableFmt="<tr align=center><td><input type=\"radio\" name=\"Idx\" value=%d></td>"
		"<td>%d</td>"
		"<td>%s</td>"
		"<td>%s</td>"
		"<td>%s</td></tr>\n";
	for( i = 0; i < IPSec_TableShow.TotalNum; i++)
	{
		rule = &IPSec_TableShow.Rule[i];
		if( rule->Item != 0)
		{			
		//shawn Mar 12th,2003 for SSH host IP setting
		//		strcpy(RemoteNetworkStr,argvWeb[REMOTE_NETWORK_IN_CMD_STRING_INDEX]);	//Shawn for SSH
		sprintf(RemoteSubnet,"%s/%s",rule->RemoteSubnet,rule->RemoteSubnetMask);
		nBytes += websWrite(wp, T(TableFmt),
		                    i+1,
		                    i+1,
		                    (rule->Active==1 ? "Yes" : "No"),
		                    rule->RemoteIP,
		                    RemoteSubnet);
		}
	}
	return nBytes;
}

static int aspIPSec1_Now(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(IPSec_Func)
	{
		case Click_Func_ADD:
		return websWrite(wp, T("%d"), IPSec_TableShow.NextItem);
		case Click_Func_EDIT:
		return websWrite(wp, T("%d"), IPSec_Edit_Index);
		default:
		return websWrite(wp, T("%d"), IPSec_TableShow.NextItem);
	}
}
static IPSEC_RULE_T gTmpRule;// Note, we use this global page to keep the editing values for a rule which has to 


static int aspIPSec1_Page(int eid, webs_t wp, int argc, char_t **argv)
{
char_t *ipsec1_TableFmt1_1 =
"<TR>\n"
"<TD class=header colSpan=4>Rule %d</TD></TR><TR>\n"
"<TD class=header colSpan=1> Active </TD>\n"
"<TD class=title1 colspan=3><SELECT name=ruleAct>\n"
"%s\n\r"
"</SELECT>\n"
"</TD></TR>\n"
"<TR>\n"
"<TD class=header colSpan=1>Name</TD>\n"
"<TD class=title1 colSpan=3>\n"
"<INPUT type=text name=ipsec_name maxlength=42 size=40 value=%s>\n"
"</TD>\n</TR>\n";

char_t *ipsec1_TableFmt1_2 =
"<TR>\n"
"<TD class=header colSpan=1>Application Type\n"
"<TD class=title1  colSpan=3>"
"<SELECT name=ApplType>\n"
"%s\n"
"</SELECT>\n"
"</TD>\n</TR>\n";

char_t *ipsec1_TableFmt2_1 =
"<TR>\n"
"<TD class=header colSpan=4>Local Site(optional)</TD>\n"
"</TR>\n"
"<TR>\n"
"<TD class=title  colSpan=1>Subnet</TD>\n"
"<TD class=title1 colSpan=3>%s\n"
//"<INPUT type=text name=LocalNet maxlength=17 size=15 value=%s>\n"
"</TD>\n"
"</TR>\n";

char_t *ipsec1_TableFmt2_2 =
"<TR>\n"
"<TD class=title  colSpan=1>Subnet Mask</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=LocalNetmask maxlength=17 size=15 value=%s>\n"
"</TD>\n"
"</TR>\n"
"<TD class=title  colSpan=1>IKE ID</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=LocalIKEID maxlength=40 size=42 value=%s>\n"
"</TD>\n"
"</TR>\n";

char_t *ipsec1_TableFmt3_1 =
"<TR>\n"
"<TD class=header colSpan=4>Remote Site</TD>\n"
"</TR>\n"
"<TR>\n"
"<TD class=title  colSpan=1>Remote Gateway IP/Host Name</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=RGIP maxlength=100 size=25 value=%s>\n"
"</TD>\n"
"</TR>\n"
"<TR>\n"
"<TD class=title  colSpan=1>Subnet</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=RemoteNet maxlength=17 size=15 value=%s>\n"
"</TD>\n"
"</TR>\n";

char_t *ipsec1_TableFmt3_2 =
"<TD class=title  colSpan=1>Subnet Mask</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=RemoteNetmask maxlength=17 size=15 value=%s>\n"
"</TD>\n"
"</TR>\n"
"<TD class=title  colSpan=1>IKE ID:(optional)</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=RemoteIKEID maxlength=40 size=42 value=%s>\n"
"</TD>\n"
"</TR>\n";
char_t *ipsec1_TableFmt4 =
"<TR><TD class=header  colSpan=1>Proposal</TD>\n"
"<TD class=title1  colSpan=2><INPUT type=radio name=ESPAH_CH  onclick=\"espIsClick(this.form);\" value=0 %s>ESP\n"
"&nbsp;&nbsp;\n"
"<SELECT name=EspOpt>\n"
"%s"
"</SELECT>\n"
"</TD>\n"
"<TD class=title1  colSpan=1><INPUT type=radio name=ESPAH_CH  onclick=\"ahIsClick(this.form);\" value=1 %s>AH</TD>\n"
"</TR>\n";
char_t *ipsec1_TableFmt5 =
"<TR>\n"
"<TD class=header colSpan=1>PreShared Key</TD>\n"
"<TD class=title1  colSpan=3>\n"
"<INPUT type=text name=ipsec_PSK maxlength=90 size=48 value=%s>\n"
"</TD>\n"
"</TR>\n";

	const int ActiveNum=2, ActiveDefault=1; char *ActiveList[]={"No", "Yes"};
	const int ApplTypeNum=4, ApplTypeDefault=0; 
	char *ApplTypeList[]={"VPN:LAN-LAN(Tunnel Mode)","Road Warrior:LAN-Host,Dial-in(Tunnel Mode)",
	"Road Warrior:Host-LAN,Dial-out(Tunnel Mode)","Host-Host:(Transport Mode)"};
	const int EspOptNum=3, EspOptDefault=0; char *EspOptList[]={"3DES", "AES","DES"};
	char_t buf1[64];
	char_t str_lanip[20];
	strcpy(str_lanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IP=",buf1));

	if((IPSec_Func==Click_Func_ADD)&&(ipsecAdvanceEdit==0))
	{ // A new one and also not return form the advanced editing pages
		char defaultName[10];
		
		memset(&gTmpRule,0, sizeof(IPSEC_RULE_T));	
		//need to give the adance page default values.
		gTmpRule.Phase1_SA_Lifetime=60;
		gTmpRule.Phase2_SA_Lifetime=60;
		sprintf(defaultName,"conn%d",IPSec_TableShow.NextItem+1);
		websWrite(wp, T(ipsec1_TableFmt1_1),
			IPSec_TableShow.NextItem+1,
			SelectListOption(ActiveList, ActiveNum, ActiveDefault),
			defaultName
			);
		websWrite(wp, T(ipsec1_TableFmt1_2),
			SelectListOption(ApplTypeList, ApplTypeNum, ApplTypeDefault)
			);
		websWrite(wp, T(ipsec1_TableFmt2_1),str_lanip);
		websWrite(wp, T(ipsec1_TableFmt2_2),"","");
		websWrite(wp, T(ipsec1_TableFmt3_1),"0.0.0.0",""); // default is wildcard. "%any" can accept any incoming call
		websWrite(wp, T(ipsec1_TableFmt3_2),"","");
		websWrite(wp, T(ipsec1_TableFmt4),
			"checked",	
			SelectListOption(EspOptList, EspOptNum, EspOptDefault),
			"");
		websWrite(wp, T(ipsec1_TableFmt5),"");
	}
	else
	{
		IPSEC_RULE_T *rule;
		if(ipsecAdvanceEdit)
		{
			rule=&gTmpRule;
			ipsecAdvanceEdit=0;//reset it	
		}
		else
			rule = &IPSec_TableShow.Rule[IPSec_Edit_Index];
		websWrite(wp, T(ipsec1_TableFmt1_1),
			// 0 Rule's number, int
			IPSec_Edit_Index+1,
			// 3 Active options "Yes" or "No", string
			SelectListOption(ActiveList, ActiveNum,rule->Active),
			rule->name);
		websWrite(wp, T(ipsec1_TableFmt1_2),
			SelectListOption(ApplTypeList, ApplTypeNum,rule->ApplicationType));
			
		websWrite(wp, T(ipsec1_TableFmt2_1),str_lanip);//rule->LocalSubnet);
		websWrite(wp, T(ipsec1_TableFmt2_2),rule->LocalSubnetMask,rule->LocalIKE_ID);
		websWrite(wp, T(ipsec1_TableFmt3_1),rule->RemoteIP,rule->RemoteSubnet); // default is wildcard. "%any" can accept any incoming call
		websWrite(wp, T(ipsec1_TableFmt3_2),rule->RemoteSubnetMask,rule->RemoteIKE_ID);
		websWrite(wp, T(ipsec1_TableFmt4),
			(rule->Proposal == IPSEC_PROPOSAL_ESP)?"checked":"",	
			SelectListOption(EspOptList, EspOptNum, rule->Esp),
			(rule->Proposal == IPSEC_PROPOSAL_ESP)?"":"checked");
		websWrite(wp, T(ipsec1_TableFmt5),rule->PreSharedKey);
		memcpy(&gTmpRule,rule, sizeof(IPSEC_RULE_T));	// put the one in the global tmp for later reference			
	}
	return 0;
}// end aspIPSec1_Page
	
////// for urlfde1.asp table format, the keyword table
static int aspIPSec2_Page(int eid, webs_t wp, int argc, char_t **argv)
{
char_t *ipsec1_TableFmt1 =
"\t<TR>  \n"
"\t\t<TD class=header>PHASE 1 SA LIFE TIME</TD>  \n\r"
"\t\t<TD class=title> \n\r"
"\t\t<INPUT type=text name=ipsec_PH1 maxlength=15 size=8 value=%s>minutes&nbsp;\n\r"
"\t\t</TD>  \n\r"
"\t</TR>  \n\r"
"\t<TR>  \n"
"\t\t<TD class=header>PHASE 2 SA LIFE TIME</TD>  \n\r"
"\t\t<TD class=title> \n\r"
"\t\t<INPUT type=text name=ipsec_PH2 maxlength=15 size=8 value=%s>minutes&nbsp;\n\r"
"\t\t</TD>  \n\r"
"\t</TR>  \n\r"
"\t\t<TD class=header> \n\r"
"\t\t<TD class=title> \n\r"
"\t\t<INPUT type=Checkbox name=ipsec_PFS value=1 %s>Perfect Forward Secrecy\n\r"
"\t\t</TD>  \n\r"
"\t</TR>  \n\r";

char_t *ipsec1_TableFmt2 =
"\t<TR>  \n"
"\t\t<TD class=header>Phase I IKE Exchange Type</TD>  \n\r"
"\t\t<TD class=title> \n\r"
"\t\t\t<SELECT name=IkeXchgType>  \n\r"
"\t\t%s"
"\t\t</SELECT>  \n\r"
"\t\t</TD></TR>  \n\r";
	IPSEC_RULE_T *rule=&gTmpRule;
	const int IkeXchgTypeNum=2, IkeXchgTypeDefault=0; char *IkeXchgTypeList[]={"Main Mode", "Aggressive Mode"};
 	
				
	if((IPSec_Func==Click_Func_ADD)&&(ipsecAdvanceEdit==0))
	{
		websWrite(wp, T(ipsec1_TableFmt1),
			"60",
			"60",
			"");			
		websWrite(wp, T(ipsec1_TableFmt2),
			SelectListOption(IkeXchgTypeList, IkeXchgTypeNum, IkeXchgTypeDefault));
	}
	else
	{
		char str1[6],str2[6];
		sprintf(str1,"%d",rule->Phase1_SA_Lifetime);
		sprintf(str2,"%d",rule->Phase2_SA_Lifetime);
		websWrite(wp, T(ipsec1_TableFmt1),
			str1,
			str2,
			(rule->perfect_forward_secrecy == IPSEC_PFS_No)?"":"checked");			
		websWrite(wp, T(ipsec1_TableFmt2),
			SelectListOption(IkeXchgTypeList, IkeXchgTypeNum, rule->AggressiveMode));
	}
		
	return 0;
}
	

static int aspGetIpsecNATTraversalEnable(int eid, webs_t wp, int argc, char_t **argv)
{

		if(IPSec_TableShow.NAT_Traversal_Enabled == IPSEC_NAT_T_No)
				return websWrite(wp,T(""));
		else
				return websWrite(wp, T("CHECKED"));
}

static int aspGetIpsecNAT_KL_Seconds(int eid, webs_t wp, int argc, char_t **argv)
{
	I8_T cgi_ipsecNAT_KL_Seconds[8];

	memset(cgi_ipsecNAT_KL_Seconds, 0 , sizeof(cgi_ipsecNAT_KL_Seconds));
	sprintf(cgi_ipsecNAT_KL_Seconds,"%d",IPSec_TableShow.NAT_T_KL_Sec);
	return websWrite(wp, T("%s") , cgi_ipsecNAT_KL_Seconds);
}

int ipsecIfAnyRulesIsRunning(void)
{
	FILE *fp;
	char filename[40];
	int i;
	for (i = 0; i < MAX_RULE; i++)
	{
		
		//1. how do we know the ipsec rule exist in the  current setup ipsec database (Not the newest modified
		// IPsec configuration one, since we only apply the changes when the fw.sh start.)
		sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
		if ((fp = fopen(filename, "r")))
		{ 
			fclose(fp);
			return 1;
		}
	}
	return 0;
}

/*----------------------------------------------------------------- */
/* void formIpsec : submit the "ipsec.asp" */
/*-----------------------------------------------------------------*/


static void formIpsec(webs_t wp, char_t *path, char_t *query)
{
	I8_T	*szS_FUNC = "ipsecFUNC", *szIdx ="Idx";
	I8_T	*pStr;
	pStr = websGetVar(wp, T(szS_FUNC), "");
	IPSec_Func = atoi(pStr);

	pStr = websGetVar(wp, T(szIdx), "");
//	fprintf(p_ttyS0,"Idx(IPSec_Edit_Index)=%s\n",pStr);
	((strcmp(pStr,"")) ? (IPSec_Edit_Index = atoi(pStr)-1) : (IPSec_Edit_Index = -1));

	ipsecAdvanceEdit=0;		
	//memset(&gTmpRule,0, sizeof(IPSEC_RULE_T));	
	websHeader(wp);

	switch(IPSec_Func)
	{

	case Click_Func_ADD: //ADD
		if(IPSec_TableShow.NextItem < MAX_RULE)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else	// Then we shall give a new one for the Adding
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;

	case Click_Func_EDIT: //EDIT
		websHeader(wp);
		if(IPSec_Edit_Index >= 0)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else	// no select an item
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
	case Click_Func_DEL: //DEL
		if(IPSec_Edit_Index >= 0)
			IPSec_DelRule(&IPSec_TableShow, IPSec_Edit_Index);
		websHeader(wp);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
	case Click_Func_APPLY: //APPLY
		{
			I8_T 	*pStr;
			I8_T	*szNAT_Traversal = "ipsec_NAT_Traversal", *szNAT_KL_Sec = "ipsec_NAT_KL_Sec";
			char funcNum[4];
			char str_wanip[20];
			char buf1[64];
		
			pStr = websGetVar(wp, T(szNAT_Traversal), "");
			if(!strcmp(pStr,""))// unchecked
				IPSec_TableShow.NAT_Traversal_Enabled=IPSEC_NAT_T_No;
			else
				IPSec_TableShow.NAT_Traversal_Enabled=IPSEC_NAT_T_Yes;
			pStr = websGetVar(wp, T(szNAT_KL_Sec), "20");
			IPSec_TableShow.NAT_T_KL_Sec=atoi(pStr);
			
			//It have some many script need to create or unlink, so we do it in CreateIPSecTableToScript
			SetIPSecTableToConfig(&IPSec_TableShow);
			IPSec_CopyTable(&IPSec_Table, &IPSec_TableShow);
			////CreateIPSecTableToScript(&IPSec_TableShow);  Do it when  fw.sh is up

//	 IF changes any thing, do we apply the changes, only if system restart or WAN connection is rebuilt.
// BUT ONLY ONE CONDITION IS EXCEPTIONAL.  That is when there is no rules active in the old(current rules) database, and 
// we have at least one is active in the new database, then we will start the IPSec NOW.

// NOTE NOTE, the old database means the ones in the running PSEC whack database. 
			strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
			if((isValidIP(str_wanip))&&(!ipsecIfAnyRulesIsRunning()) && //check if any rules active in the old config
				(ipsecIfAnyRulesActive(&IPSec_TableShow)) ) //check if any rules is active in the new database
			{
					sprintf(funcNum,"%d",FUNCTION_NUM_IPSEC_START);
					// we then start it. Note, we will not have stop for apply since we only
					// consider from none is active to, at least, one is active.
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			}	
		}
			
/*		if(isValidIP(str_wanip))
			IPSEC_RULE_T *old_rule,*new_rule;
			int i;
			sprintf(funcNum,"%d",FUNCTION_NUM_IPSEC_PLUTO);
			strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		
			//Check if Pluto have been changed.
			if((IPSec_TableShow.NAT_Traversal_Enabled!=IPSec_Table.NAT_Traversal_Enabled)||
			(IPSec_TableShow.NAT_T_KL_Sec!=IPSec_Table.NAT_T_KL_Sec))
			{
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			}
			// ONLY START THE ONLY THAT IS NOT START in the rules.  we have
			// to build the state model:
			// CREATED --> CONNECTING --> CONNECTED ---->DISCONNECTING--->CREATED-->DESTROYED
			//We shall only stop the ones that different????
			//We will base on name and check if it is have been changed or deleted.  If so, we stop  it.
			// Since the IPSec_Table is the old one and IPSec_TableShow is the new one, we can then itemize them 
			// by name and check if any changee.
		
			// WE WILL NOT ALLOW THE SAME NAME FOR TWO RULES
			//We need to check the differences and apply it by name
			// Our algorithm is:
			// For each name in old tables, check if it is also exist in new table.
			// If it is no more exist, then remove it(disconnect and remove it.)
			// If it is 
			for (i = 0; i < MAX_RULE; i++) 
			{
				old_rule = &(table->Rule[i]);
				old_rule = &(IPSec_TableShow->Rule[i]);
				
				// We need t
				IPSec_CheckIfNeedChange();
				
				if( rule->Item != 0 ) {
					if( rule->Active == 1 )
					{
						return 1;
					}
				}	
			}	
		
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,ruleNum,NULL);

			}//else running when wan_ip ready.
		}   */
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
		
	case Click_Func_CENCEL: //CENCEL
		IPSec_CopyTable(&IPSec_TableShow, &IPSec_Table);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
	default:
		websRedirect(wp, T("ipsec.asp"));
	}
}
				// traverse several pages.

//extern int convert_mask_string_2_number(char *maskStr,char *bitMaskNumberStr);
//extern int setWebConfigIPSecValues(unsigned long ruleIndex,I8_T *newRemoteGatewayIP,I8_T *newRemoteNetwork,I8_T *newIpsecPSK,I8_T *newIpsecPH1,I8_T *newIpsecPH2,I8_T *newIpsecPFS,I8_T *newEncapMode);
//extern void ipsecIncreaseRuleTable_Web(void);
//extern UI32_T ipsec_cfg_SetProposal(unsigned long index,UI32_T ESPAH_Choice,UI32_T AhProposalOpt,UI32_T EspProposalOpt);


/*-----------------------------------------------------------------*/
/*  void formIpsec1 : submit the "ipsec1.asp"  */
/*-----------------------------------------------------------------*/
static void formIpsec1(webs_t wp, char_t *path, char_t *query)
{	// Note this rules just edit the RAM data for ipsec, do not save it to the flash
	// That is, the save it, use page ipsec11.htm (Apply)
	I8_T	*szIpsecFUNC,*szIpsecNow;
	I8_T	*szIpsecRuleActiveOpt,*szIpsecApplicationTypeOpt,*szIPSec_ESPAH_Choice,*szIpsecEspProposalOpt;
	I8_T	*szRemoteGatewayIP, *szRemoteSubnet,*szLocalIKE_ID, *szRemoteIKE_ID;
	I8_T	*szRemoteNetmask, *szIpsecPSK,*szLocalSubnet, *szLocalNetmask,*pipsecAdvanced;
	struct sockaddr_in server_addr;
	
	szIpsecPSK = websGetVar(wp, T("ipsec_PSK"), "");
	szIpsecFUNC = websGetVar(wp, T("ipsecFUNC"), "0");
	szIpsecNow = websGetVar(wp, T("ipsecNow"), "0");
	szIpsecRuleActiveOpt = websGetVar(wp, T("ruleAct"), "1");
	szIpsecApplicationTypeOpt = websGetVar(wp, T("ApplType"), "1");
	szIPSec_ESPAH_Choice = websGetVar(wp, T("ESPAH_CH"), "0");
	szIpsecEspProposalOpt = websGetVar(wp, T("EspOpt"), "1");
	szRemoteGatewayIP = websGetVar(wp, T("RGIP"), "");
	szRemoteSubnet = websGetVar(wp, T("RemoteNet"), "");
	szRemoteNetmask = websGetVar(wp, T("RemoteNetmask"), "");
	szLocalSubnet = websGetVar(wp, T("LocalNet"), "");
	szLocalNetmask = websGetVar(wp, T("LocalNetmask"), "");
	pipsecAdvanced = websGetVar(wp, T("ipsecAdv"), "0");// if advanced Edit press

	// Shall we check the duplucate name????
	strcpy(gTmpRule.name, websGetVar(wp, T("ipsec_name"), "conn"));// Shall be conn%d????
	// check valid IKE ID
	//
	szLocalIKE_ID = websGetVar(wp, T("LocalIKEID"), "");
	server_addr.sin_family = AF_INET;
	if (!inet_aton(szLocalIKE_ID, &server_addr.sin_addr))
	{// is not an valid IP address, note 0.0.0.0 is wild card and still is an vaild IP address
		// then check if there is an "@" in the
		if (strchr(szLocalIKE_ID, '@') == NULL)
			// check if is FQDN??? No. at least 1 bytes
			if((strlen(szLocalIKE_ID)!=0)&&(strchr(szLocalIKE_ID, '.') == NULL)  )
			{
				//		syslog(LOG_USER | LOG_ERR,"ERROR! Not a valid Local IKE ID.\n"));
				websRedirect(wp, T("ipsec1.asp"));
				return;
			}
	}	

	szRemoteIKE_ID = websGetVar(wp, T("RemoteIKEID"), "");
	server_addr.sin_family = AF_INET;
	if (!inet_aton(szRemoteIKE_ID, &server_addr.sin_addr))
	{// is not an valid IP address, note 0.0.0.0 is wild card and still is an vaild IP address
		// then check if there is an "@" in the
		if (strchr(szRemoteIKE_ID, '@') == NULL)
			// check if is FQDN??? No. at least 1 bytes
       			if((strlen(szRemoteIKE_ID)!=0)
			&&(strchr(szRemoteIKE_ID, '.') == NULL)  )
			{
				//syslog(LOG_USER | LOG_ERR,"ERROR! Not a valid Remote IKE ID.\n"));
				websRedirect(wp, T("ipsec1.asp"));
				return;
			}
	}
	szIpsecPSK = websGetVar(wp, T("ipsec_PSK"), "");
/*		pStr = websGetVar(wp, T(szIpsecResponderOnly), "");
	if(!strcmp(pStr,"")) {  	//ResponderOnly is unchecked
		IpsecResponderOnly=IPSEC_ResponderOnly_No;
	}
	else {
		IpsecResponderOnly=IPSEC_ResponderOnly_Yes;
	} */
	
	gTmpRule.Item = atoi(szIpsecNow)+1; 
	gTmpRule.Active = atoi(szIpsecRuleActiveOpt)-1;
	gTmpRule.ApplicationType = atoi(szIpsecApplicationTypeOpt)-1;	
	gTmpRule.Proposal = atoi(szIPSec_ESPAH_Choice);	
	gTmpRule.Esp = atoi(szIpsecEspProposalOpt)-1;	
	strcpy(gTmpRule.RemoteIP,szRemoteGatewayIP); 
	strcpy(gTmpRule.PreSharedKey,szIpsecPSK); 
	strcpy(gTmpRule.RemoteIKE_ID,szRemoteIKE_ID); 
	strcpy(gTmpRule.LocalIKE_ID,szLocalIKE_ID); 
	strcpy(gTmpRule.RemoteSubnet,szRemoteSubnet);
	strcpy(gTmpRule.RemoteSubnetMask,szRemoteNetmask);
	strcpy(gTmpRule.LocalSubnet,szLocalSubnet);
	strcpy(gTmpRule.LocalSubnetMask,szLocalNetmask);

	websHeader(wp);
	if( atoi(szIpsecFUNC) == 6 )
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec1.asp\");</script>"));
	else
	{
		ipsecAdvanceEdit=atoi(pipsecAdvanced);
		if(ipsecAdvanceEdit>0)
		{
			//we shall keep the editing gTmpRules.
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec2.asp\");</script>"));
		}	
		else
		{
			switch(IPSec_Func)
			{
			case Click_Func_ADD:
			IPSec_AddRule(&IPSec_TableShow, &gTmpRule);
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"add\");</script>"));
			break;
			case Click_Func_EDIT:
			IPSec_SetRule(&IPSec_TableShow, &gTmpRule, gTmpRule.Item-1);
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"set\");</script>"));
			break;
			default:
			// do nothing
			break;
			}
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/ipsec.asp\");</script>"));
			//memset(&gTmpRule, 0, sizeof(URLFILTER_RULE_T));
		}
	}
	websFooter(wp);
	websDone(wp, 200);
}

/*-----------------------------------------------------------------*/
/*  void formIpsec2 : submit the "ipsec2.asp"        */
/*-----------------------------------------------------------------*/
static void formIpsec2(webs_t wp, char_t *path, char_t *query)
{
	I8_T	*szIpsecAggrMode ;
	I8_T	*szIpsecPFS,*szIpsecPH1, *szIpsecPH2  ;

	szIpsecPH1 = websGetVar(wp, T("ipsec_PH1"), "60");
	gTmpRule.Phase1_SA_Lifetime = atoi(szIpsecPH1);

	szIpsecPH2 = websGetVar(wp, T("ipsec_PH2"), "480");
	gTmpRule.Phase2_SA_Lifetime = atoi(szIpsecPH2);

	szIpsecPFS = websGetVar(wp, T("ipsec_PFS"), "0");
	gTmpRule.perfect_forward_secrecy = atoi(szIpsecPFS);

	szIpsecAggrMode = websGetVar(wp, T("IkeXchgType"), "1");
	gTmpRule.AggressiveMode = atoi(szIpsecAggrMode)-1;
	ipsecAdvanceEdit=1;// we have commit the changes
	websRedirect(wp, T("ipsec2.asp"));
}

void ipsec_status_action(unsigned long	userDefinedPolicyNum);
void readAllIPSecConnectStatus(void);

/*-----------------------------------------------------------------*/
/*  void formStatIpsec : submit the "ipsec_st.asp"     */
/*-----------------------------------------------------------------*/
static void formStatIpsec(webs_t wp, char_t *path, char_t *query)
{
	I8_T  *pStr;  
	//I8_T  *szIpsecStatusActionRuleNo; 
//	I8_T  *szL2tpStatusActionRuleNo = "l2tpStatusAction";// L2TP will live on IPSec status 
//	I8_T  *szRefreshSecSel; 
 	UI32_T	ipsecStatusActionRuleNo = 0;
// 	UI32_T	l2tpStatusActionRuleNo = 0;
 	UI32_T	refreshSecSel = 1; 			// default is 1:10 sec
 				
	pStr = websGetVar(wp, T("ipsecStatusAction"), "0");
//printf("IpsecStatusActionRuleNo=%s\n",pStr);
	ipsecStatusActionRuleNo = atoi(pStr); 		//0:don't do anything;  1:clear 

	if(ipsecStatusActionRuleNo>0)
	ipsec_status_action(ipsecStatusActionRuleNo);
		
/*	pStr = websGetVar(wp, T(szL2tpStatusActionRuleNo), "0");
//printf("L2tpStatusActionRuleNo=%s\n",pStr);
	l2tpStatusActionRuleNo = atoi(pStr); 		//0:don't do anything;  1:clear 
	if(l2tpStatusActionRuleNo>0)
		l2tp_status_action(l2tpStatusActionRuleNo);
*/			
	pStr = websGetVar(wp, T("refreshSecSel"), "");
//printf("RefreshSecSel=%s\n",pStr);
	if(strcmp(pStr,"")) 
		refreshSecSel = atoi(pStr);
	if(refreshSecSel<6)
		ipsecRefreshTimeSel=refreshSecSel;
	websRedirect(wp, T("ipsec_st.asp"));
}
static void  showConnectType(IPSEC_CFG_STATUS *ics,char *connectTypeStr);
static void showSecondsInHHMMSS(time_t td,char *str);

int ipsec_GRIP_Resolve(char *RGIP,struct in_addr *resolvedIP)
{
	struct hostent          *ahostent;
	char                    str[INET6_ADDRSTRLEN];
 	ahostent = gethostbyname(RGIP);
	if (ahostent == NULL)
	{
		DPRINTF( "ERROR:ipsec_GRIP_Resolve fail: %s: %s", RGIP, hstrerror(h_errno));
	}
	else
	{
		resolvedIP->s_addr = inet_addr(inet_ntop(ahostent->h_addrtype,ahostent->h_addr_list[0], str, sizeof(str)));
		if(resolvedIP->s_addr)
			return 1;//resolved.
	}
	return 0;// failed;
}
IPSEC_CFG_STATUS theIcs;
static int aspGetIpsecConnectStatusList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i;
	char	RemoteNetworkStr[20], RemoteGatewayIPStr[128],connectTypeStr[30],connectTime[15];
	struct sockaddr_in server_addr;
	int RGIPisValid=0;
	char filename[30];
	IPSEC_CFG_STATUS *ics=&theIcs;
		
	char_t *TableFmt1="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>%s  <input type=button value=Drop onclick=\"ipsecStatusAction.value=%d;document.stat_ipsec.submit();\"></td></tr>\n";
	
/*	char_t *TableFmt2="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>Disconnected%s</td></tr>\n";
*/	
	char_t *TableFmt3="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>%s  <input type=button value=Connect onclick=\"ipsecStatusAction.value=%d;document.stat_ipsec.submit();\"></td></tr>\n";
	
	char_t *TableFmt4="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>Connecting(%s) <input type=button value=Drop onclick=\"ipsecStatusAction.value=%d;document.stat_ipsec.submit();\"></td></tr>\n";
	
	char_t *TableFmt5="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>%s <input type=button value=Drop onclick=\"ipsecStatusAction.value=%d;document.stat_ipsec.submit();\"></td></tr>\n";
	
/*	char_t *TableFmt6="<tr align=center><td>%s</td>"
	"<td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%d</td><td>%d</td>"
	"<td>Disconnected(Responder Only)</td></tr>\n";
*/	
	
	// NOTE NOTE if wan is not ready, this page shall not present.
	//strcpy(str_remoteip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
	///if(!isValidIP(str_wanip))
	///	return 0;

	//Seince we only apply the changed configuration when WAN interface restart, so
	// here we can not use IPSec.Table.  We shall use state table
	for (i = 0; i < MAX_RULE; i++)
	{
		FILE *fp;
		char str_remoteip[20];
		char buf1[20];
		char tmpVar[12];
		
		//1. how do we know the ipsec rule exist in the  current setup ipsec database (Not the newest modified
		// IPsec configuration one, since we only apply the changes when the fw.sh start.)
		sprintf(filename, "/var/etc/ipsec_ipt%d.add", i);
		if (!(fp = fopen(filename, "r")))
		{ 
			continue;
		}
		
		//get the enviornment var for the remote IP.  If it is not resolved, we resolve it here.
 		
		sprintf(tmpVar,"RIP%i=",i);
		strcpy(str_remoteip,(char *)read_file_para_value(VAR_ETC_IPSEC_VAR_FILE,tmpVar,buf1));
 		server_addr.sin_family = AF_INET;
		strcpy(RemoteGatewayIPStr,str_remoteip); // default is the configured one
		if (!inet_aton(str_remoteip, &server_addr.sin_addr))
		{  // is an domain name, we have to check if it has been resolved
			strcat(RemoteGatewayIPStr," (Can not Be Pinged)");// default is not resolved
			if(ipsec_GRIP_Resolve(str_remoteip,&server_addr.sin_addr))
			{
				sprintf(RemoteGatewayIPStr,"%s",inet_ntoa(server_addr.sin_addr));				
			}
		}
		if((!str_remoteip)||(!server_addr.sin_addr.s_addr))
		{
				RGIPisValid=0;
		}
		else
		{
				RGIPisValid=1;
		}
		
		// get the remote network environmental var.
		sprintf(tmpVar,"WAN_NET%i=",i);
		strcpy(RemoteNetworkStr,(char *)read_file_para_value(VAR_ETC_IPSEC_VAR_FILE,tmpVar,buf1));
//This version L2tp can't over IPSec, so IPSec & L2TP connect button are independent. If the function is OK, shall modify this behavior 
//in aspGetIpsecConnectStatusList & aspGetL2tpConnectStatusList

		copySaveIPsecStatusToFromLocal(COPY_IPSEC_STATUS_TO_LOCAL,i,ics);
		
	DPRINTF("ics->connected=%x\n",ics->connected);
 	DPRINTF("ics->disconnectedReason=%x\n",ics->disconnectedReason);
 	DPRINTF("ics->connectType=%x %x %x %x\n",ics->connectType[0],ics->connectType[1],ics->connectType[2],ics->connectType[3]);
 	DPRINTF("ics->txPacket=%d\n",ics->txPacket);
	DPRINTF("ics->rxPacket=%d\n",ics->rxPacket);
	DPRINTF("ics->remoteGatewayStrForDomainName=%s\n",ics->remoteGatewayStrForDomainName);
		if(ics->connected==IPSEC_CHANNEL_CONNECTED)
		{
			time_t td=0,currenttime;
			
			showConnectType(ics,connectTypeStr);
			//clock_gettime(CLOCK_REALTIME,&currenttime);
			time(&currenttime);
			td = abs(currenttime - ics->connectTimeStart);
			showSecondsInHHMMSS(td,connectTime);
			// we need to iptables to get a packet rx/tx list.  Then, parse it to get the
			// rx/tx  packet numbers.
			//readIPSecTxRxPkt(i);
			nBytes += websWrite(wp, T(TableFmt1),
						"IPSec",
						i+1, 
						ics->remoteGatewayStrForDomainName,//RemoteGatewayIPStr, // for 0.0.0.0 we have to give the real IP
						RemoteNetworkStr,
						connectTypeStr,
						connectTime,
						ics->txPacket,
						ics->rxPacket,
						connectStatusStr[ics->connected], 
						i+1
						);
		}																													   
		else if(ics->connected==IPSEC_CHANNEL_DISCONNECTED)
		{
//			if(rule->responder_only==IPSEC_ResponderOnly_No)
//			{
					nBytes += websWrite(wp, T(TableFmt3),
						"IPSec",
						i+1, 						
						RemoteGatewayIPStr,
						RemoteNetworkStr,
						"",
						"",
						0,
						0,
						connectStatusStr[ics->connected],
						i+1
						);
/*			}
			else
			{// responder only
					nBytes += websWrite(wp, T(TableFmt6),
						"IPSec",
						i+1,
						RemoteGatewayIPStr,
						RemoteNetworkStr,
						NULL,
						NULL,
						0,
						0
						);
			} */
		} 
		else if(ics->connected==IPSEC_CHANNEL_CONNECTING)
		{
			nBytes += websWrite(wp, T(TableFmt4),
						"IPSec",
						i+1, 						
						RemoteGatewayIPStr,
						RemoteNetworkStr,
						NULL,
						NULL,
						0,
						0,
						connectStatusStr[ics->connected],
						i+1
						);
		}
		else
		{
			nBytes += websWrite(wp, T(TableFmt5),
						"IPSec",
						i+1, 						
						RemoteGatewayIPStr,
						RemoteNetworkStr,
						"",
						"",
						0,
						0,
						connectStatusStr[ics->connected],
						i+1
						);
		}
	}//end for
	
	return nBytes;
}

static int aspGetIpsecRefreshTimeSel(int eid, webs_t wp, int argc, char_t **argv)
{	
	websWrite(wp, T("%d"), ipsecRefreshTimeSel);
	return 0;
}

static void  showConnectType(IPSEC_CFG_STATUS *ics,char *connectTypeStr)
{
	if(ics->connectType[SA_MODE_BYTE]==IPSEC_SA_MODE_TRANSPORT)
		strcpy(connectTypeStr,"Transport ");
	else
		strcpy(connectTypeStr,"Tunnel ");
	if(ics->connectType[SA_TYPE_BYTE]==IPSEC_SA_TYPE_AH)
		strcat(connectTypeStr,"AH ");
	else if(ics->connectType[SA_TYPE_BYTE]==IPSEC_SA_TYPE_ESP)
		strcat(connectTypeStr,"ESP ");

	if(ics->connectType[SA_HMAC_ALG_BYTE]==IPSEC_SA_HMAC_MD5)
		strcat(connectTypeStr,"MD5 ");
	else if(ics->connectType[SA_HMAC_ALG_BYTE]==IPSEC_SA_HMAC_SHA1)
		strcat(connectTypeStr,"SHA1 ");

	if(ics->connectType[SA_ENC_ALG_BYTE]==IPSEC_SA_ENC_AES)
		strcat(connectTypeStr,"AES");
	else if(ics->connectType[SA_ENC_ALG_BYTE]==IPSEC_SA_ENC_3DES)
		strcat(connectTypeStr,"3DES");
}
   // default is given
  /* the ipsec.conf is created in utils/armfs/makedisk
    ##################
    # ipsec conf file
    ##################
    // first parameter is the number of rules
    echo ":0:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    // 2nd is for ipsec nat traversal
    echo ":0:20:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    //default is psk, proposal is 3DES, no pfs, ikelifetime=480min.  ipsecliketime=480min.
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
    echo ":0:0:0.0.0.0:0.0.0.0:-:0.0.0.0:0.0.0.0:0.0.0.0:-:0:0:480:480:0:0:0:0:-:" >> $RAMDISK_FILESYSTEM/flash/ipsec.conf
	   */
#define CURRENT_IPSEC_CONFIG_VERSION 0x10

int GetConfigToIPSecTable(IPSEC_TABLE_T *table)
{
	int i;
	FILE *fp;
	unsigned int version;
	IPSEC_RULE_T aRule, *rule=&aRule;
		
	fp = fopen(IPSEC_CONFIG_FILE, "r");
	if (!fp) {
		return -1;
	}
	
	if(fscanf(fp,"|%x|\n",&version)!=1)
	{
				fclose(fp);
				return -1; //default is used
	}
	if(version!=CURRENT_IPSEC_CONFIG_VERSION)
	{
		DPRINTF("GetConfigToIPSecTable:the old version is %x, our version is %x\n",version,CURRENT_IPSEC_CONFIG_VERSION);
		//convert the configuration here.....
		// current, default is taken.
		fclose(fp);
		unlink(IPSEC_CONFIG_FILE);
		//WE shall save the flash??????
		return 0;
	}	
	if(fscanf(fp,"|%d|%d|\n",&table->NAT_Traversal_Enabled,&table->NAT_T_KL_Sec)!=2)
	{
				fclose(fp);
				return -1; //default is used
	}
	for (i = 0; i < MAX_RULE; i++)
 	{
		if(fscanf(fp, "|%d|%40[^|]|%d|%20[^|]|%20[^|]|%40[^|]|%40[^|]|%20[^|]|%20[^|]|%40[^|]"
                      "|%d|%d|%d|%d|%d|%d|%d|%100[^|]|\n",
                &rule->Active,
				rule->name,
                &rule->ApplicationType,
                rule->LocalSubnet,
                rule->LocalSubnetMask,
                rule->LocalIKE_ID,
                rule->RemoteIP,
                rule->RemoteSubnet,
                rule->RemoteSubnetMask,
                rule->RemoteIKE_ID,
                //
                &rule->Proposal,
                &rule->Esp,
                &rule->Phase1_SA_Lifetime,
                &rule->Phase2_SA_Lifetime,
                &rule->perfect_forward_secrecy,
                &rule->AggressiveMode,
                &rule->responder_only,
                rule->PreSharedKey) == -1)
		{
 		    break;
		}
		if(rule->LocalSubnet[0]=='&')
				rule->LocalSubnet[0]='\0';
		if(rule->LocalSubnetMask[0]=='&')
				rule->LocalSubnetMask[0]='\0';
		if(rule->LocalIKE_ID[0]=='&')
				rule->LocalIKE_ID[0]='\0';
		if(rule->RemoteIP[0]=='&')
				rule->RemoteIP[0]='\0';
		if(rule->RemoteSubnet[0]=='&')
				rule->RemoteSubnet[0]='\0';
		if(rule->RemoteSubnetMask[0]=='&')
				rule->RemoteSubnetMask[0]='\0';
		if(rule->RemoteIKE_ID[0]=='&')
				rule->RemoteIKE_ID[0]='\0';
		rule->Item = i+1; //0
		IPSec_AddRule(table, rule);
	}
 	fclose(fp);
	return 0;
}

// SetIPSecTableToConfig
int SetIPSecTableToConfig (IPSEC_TABLE_T * table)
{
	int i;
	IPSEC_RULE_T *rule;
	FILE *fp;

	fp = fopen (IPSEC_CONFIG_FILE, "w");
	if (!fp)
	{
		return -1;
	}
	fprintf(fp,"|%x|\n",CURRENT_IPSEC_CONFIG_VERSION);
	fprintf(fp,"|%d|%d|\n",table->NAT_Traversal_Enabled,table->NAT_T_KL_Sec);
	for (i = 0; i < MAX_RULE; i++)
	{
		rule = &table->Rule[i];
		if (rule->Item != 0)
		{
		//rule.Item = i+1; //0
		fprintf (fp,"|%d|%s|%d|%s|%s|%s|%s|%s|%s|%s|%d|%d|%d|%d|%d|%d|%d|%s|\n",
	           rule->Active,
			   rule->name,
                rule->ApplicationType,
                (rule->LocalSubnet[0] == '\0') ? "&" : rule->LocalSubnet,	
                (rule->LocalSubnetMask[0] == '\0') ? "&" : rule->LocalSubnetMask,	
                (rule->LocalIKE_ID[0] == '\0') ? "&" : rule->LocalIKE_ID,	
                (rule->RemoteIP[0] == '\0') ? "&" : rule->RemoteIP,	
                (rule->RemoteSubnet[0] == '\0') ? "&" : rule->RemoteSubnet,	
                (rule->RemoteSubnetMask[0] == '\0') ? "&" : rule->RemoteSubnetMask,	
                (rule->RemoteIKE_ID[0] == '\0') ? "&" : rule->RemoteIKE_ID,	
                 //
                rule->Proposal,
                rule->Esp,
                rule->Phase1_SA_Lifetime,
                rule->Phase2_SA_Lifetime,
                rule->perfect_forward_secrecy,
                rule->AggressiveMode,
                rule->responder_only,
                rule->PreSharedKey);
		}
	}
	fflush(fp);
	fclose (fp);
	return 0;
}	

static void showSecondsInHHMMSS(time_t td,char *str)
{
   unsigned int secs,mins,hours;

	secs=td%60;
	mins=(td/60)%60;
	hours=td/3600;
	sprintf(str,"%d:%02d:%02d",hours,mins,secs);
}

void copySaveIPsecStatusToFromLocal(int action,int instance, IPSEC_CFG_STATUS *ics)
{
	int IPSecStatusShmid;
	struct tm_sem_st        IPSecStatusLock;
	IPSEC_CFG_STATUS *icsShmPtr;
	IPSecStatusShmid = shm_init(IPSEC_STATUS_SHMKEY, sizeof(IPSEC_CFG_STATUS)*MAX_RULE);
	tm_lock_create(IPSEC_STATUS_SEMLOCKKEY, &IPSecStatusLock);
	if (tm_lock(&IPSecStatusLock) == -1)
	{
        DPRINTF("ipsec_status_action(), lock shared memroy error\n");
	return;
	}
	icsShmPtr = (IPSEC_CFG_STATUS *)shm_attach(IPSecStatusShmid);
	// we reset the status table for IPsec
	// If the connection is responder only, then we only allow disconnect.
  	ics=&icsShmPtr[instance];
	if(SAVE_IPSEC_STATUS_FROM_LOCAL)
		memcpy((void *)&(icsShmPtr[instance]),(void *)ics,sizeof(IPSEC_CFG_STATUS));
	else
		memcpy((void *)ics,(void *)&(icsShmPtr[instance]),sizeof(IPSEC_CFG_STATUS));
	shm_detach(icsShmPtr);
	if (tm_unlock(&IPSecStatusLock) == -1)
	{
	DPRINTF("IPSecConnectStatus_Init(), unlock shared memroy error\n");
	}
	tm_lock_close(&IPSecStatusLock);
	//dump ics
	DPRINTF("ics->connected=%x\n",ics->connected);
 	DPRINTF("ics->disconnectedReason=%x\n",ics->disconnectedReason);
 	DPRINTF("ics->connectType=%x %x %x %x\n",ics->connectType[0],ics->connectType[1],ics->connectType[2],ics->connectType[3]);
 	DPRINTF("ics->txPacket=%d\n",ics->txPacket);
	DPRINTF("ics->rxPacket=%d\n",ics->rxPacket);
	DPRINTF("ics->remoteGatewayStrForDomainName=%s\n",ics->remoteGatewayStrForDomainName);
}

// NOTE NOTE !!! WE only accept connect requrest when it is in DISCONNECTED. 
// WE only accept disconnect request when it is in CONNECTED and CONNECTING state.
void ipsec_status_action(unsigned long	instance)
{
	int IPSecStatusShmid;
	struct tm_sem_st        IPSecStatusLock;
	IPSEC_CFG_STATUS *icsShmPtr,*ics;
	char funcNum[4];
	
	//1. change the state
	IPSecStatusShmid = shm_init(IPSEC_STATUS_SHMKEY, sizeof(IPSEC_CFG_STATUS)*MAX_RULE);
	tm_lock_create(IPSEC_STATUS_SEMLOCKKEY, &IPSecStatusLock);
	if (tm_lock(&IPSecStatusLock) == -1)
	{
        DPRINTF("ipsec_status_action(), lock shared memroy error\n");
		return;
	}
	icsShmPtr = (IPSEC_CFG_STATUS *)shm_attach(IPSecStatusShmid);
	// we reset the status table for IPsec
	// If the connection is responder only, then we only allow disconnect.
  	ics=&icsShmPtr[instance];
	// If the connection is responder only, then we only allow disconnect.
	if(ics->connected==IPSEC_CHANNEL_DISCONNECTED)
	{ // ONLY ACCEPT CONNECT
		// The operation shall be connect requesting
		//we have to check if the connnection has been already existed
		ics->connected=IPSEC_CHANNEL_CONNECTING;
	}
	else if((ics->connected==IPSEC_CHANNEL_CONNECTED)||(ics->connected==IPSEC_CHANNEL_CONNECTING))
	{ // ONLY ACCEPT DISCONNECT
		// The operation shall be drop
		ics->connected=IPSEC_CHANNEL_DISCONNECTING; //dropping
	}
	//else
	// no action allowed in disconnecting state
	// else	 we will ignore the operation if status is in disconnecting
	shm_detach(icsShmPtr);
	if (tm_unlock(&IPSecStatusLock) == -1)
	{
	DPRINTF("IPSecConnectStatus_Init(), unlock shared memroy error\n");
	}
	tm_lock_close(&IPSecStatusLock);
	
	//2. THEN RUN TASK
	sprintf(funcNum,"%d",FUNCTION_NUM_IPSEC_MANUAL_CONNECT);
	if(ics->connected==IPSEC_CHANNEL_DISCONNECTED)
	{ // ONLY ACCEPT CONNECT
		// The operation shall be connect requesting
		//we have to check if the connnection has been already existed
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	}
	else if((ics->connected==IPSEC_CHANNEL_CONNECTED)||(ics->connected==IPSEC_CHANNEL_CONNECTING))
	{ // ONLY ACCEPT DISCONNECT
		// The operation shall be drop
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	}
}

