// Applied CTS numbers:
// CTS-001000: modified

#if __cplusplus
extern "C" {
#endif

#ifndef IPSEC_CFG_H
#define IPSEC_CFG_H

//#include <coretype.h>
//#include <prd_cfg.h>


enum    IPSEC_CFG_ERROR_CODE_E
{
    IPSEC_CFG_NO_ERROR = 0,    
    IPSEC_CFG_INVALID_MODE,  
    IPSEC_CFG_INVALID_IP_CHECK,
    IPSEC_CFG_INVALID_ENTRY,  
    IPSEC_CFG_ALLOCATE_EMEORY,
 //Vovtel add v.33 05/31/01
/* by jeremy */
    IPSEC_CFG_INVALID_IPRANGE,
    IPSEC_CFG_INVALID_PROTOCOL,
    IPSEC_CFG_INVALID_PORTRANGE,
/* end of by jeremy */  
    IPSEC_CFG_INVALID_APP_MAP,
    IPSEC_CFG_INVALID_APP_TYPE,
    IPSEC_CFG_INVALID_APP_VALUE,
    IPSEC_CFG_INVALID_BLOCK_FLAG, 
	IPSEC_CFG_SAME_VALUE_APPLY

};


#define IPSEC_CFG_MODE_ENABLE			0
#define IPSEC_CFG_MODE_DISABLE			1
#define IPSEC_DEFAULT_MODE			IPSEC_CFG_MODE_DISABLE 
#define IPSEC_CFG_MODE_DEFAULT			IPSEC_DEFAULT_MODE

#define	IPSEC_CFG_PROPOSAL_ESP			0 
#define	IPSEC_CFG_PROPOSAL_AH			1 

#define	IPSEC_CFG_PROPOSAL_AH_MD5			0 
#define	IPSEC_CFG_PROPOSAL_AH_SHA			1 

#define	IPSEC_CFG_PROPOSAL_ESP_DES			0 
#define	IPSEC_CFG_PROPOSAL_ESP_3DES			1 
#define	IPSEC_CFG_PROPOSAL_ESP_DES_MD5		2 
#define	IPSEC_CFG_PROPOSAL_ESP_DES_SHA		3 
#define	IPSEC_CFG_PROPOSAL_ESP_3DES_MD5		4 
#define	IPSEC_CFG_PROPOSAL_ESP_3DES_SHA		5 
#define	IPSEC_CFG_PROPOSAL_ESP_MD5		6 
#define	IPSEC_CFG_PROPOSAL_ESP_SHA		7 

#define	IPSEC_CFG_ACTIVE_DEFAULT			1 //default:set					// 0: Disabled Rule		1: Enabled Rule
#define	IPSEC_CFG_ESPAH_DEFAULT			IPSEC_CFG_PROPOSAL_ESP 
#define	IPSEC_CFG_PROPOSAL_AH_DEFAULT			IPSEC_CFG_PROPOSAL_AH_MD5 
#define	IPSEC_CFG_PROPOSAL_ESP_DEFAULT			IPSEC_CFG_PROPOSAL_ESP_DES 


#define IPSEC_MAX_POLICY_RULE 		4 //the number of IPSec policy we allow max rules					

#define IPSEC_MAX_POLICY_RULE_STRING  200	   // So,IPSec totally has less than 1K
#define RULE_NUMBER_IN_CMD_STRING_INDEX 0   // start from ikeadd 
#define LOCAL_GATEWAY_IN_CMD_STRING_INDEX 1   // start from ikeadd 
#define LOCAL_NETWORK_IN_CMD_STRING_INDEX 2   // start from ikeadd 
#define REMOTE_GATEWAY_IN_CMD_STRING_INDEX 3   // start from ikeadd 
#define REMOTE_NETWORK_IN_CMD_STRING_INDEX 4
#define AH_IN_CMD_STRING_INDEX 5
#define ESP_ENC_IN_CMD_STRING_INDEX 6
#define ESP_AUTH_IN_CMD_STRING_INDEX 7
#define PFS_IN_CMD_STRING_INDEX 8
#define PHASE1_TIMER_IN_CMD_STRING_INDEX 9
#define PHASE2_TIMER_IN_CMD_STRING_INDEX 10
#define REMARGIN_TIMER_IN_CMD_STRING_INDEX 11
// for Version 1.1 supporting transport mode
#define TRANSPORT_MODE_IN_CMD_STRING_INDEX 12
#define PSK_IN_CMD_STRING_INDEX_V10 12 // old V1.0's PSK position
#define PSK_IN_CMD_STRING_INDEX 13

typedef struct _IPSEC_CFG_STATUS
{
//	UI8_T isRulePutIntoSPD; 
      /* Used to indicate if the rule has been put into the SPD (the connection object is created from the rules).
	     When the 0.0.0.0 is configured for localGW of an rule, we can not put it in SPD until we have valid localGW (get
		 from get_WAN_IF_ip().  
		 Since it is configured to 0.0.0.0 for the localGW, then  we may later
		 to examine to check if the rule can be put into the SPD if the localGW is given in:
		 1. The IPSec task startup (e.g, the static IP is given when system startup)
		 2. packet is outgoing(by ipsec_outgoing_filter) or incoming(by ipsec_incoming_filter) 
		 3. user dial out a rules.(by sendIPSecCmdStrIkeInit())
		 If then IP can get the valid localGW, then the flag is set to 1 (TRUE). Initially, it is 0( FALSE).
		 Note that the rule shall be ACTIVE. And, if the LocalGW is not 0.0.0.0, then of course, this flag
		 shall be TRUE;
		 */

#define IPSEC_CHANNEL_DISCONNECTED 0
#define IPSEC_CHANNEL_CONNECTING 1
#define IPSEC_CHANNEL_CONNECTED 2
#define IPSEC_CHANNEL_DISCONNECTING 3
  int connected;// Is Connected?

#define REASON_NORMAL 0	//Normal disconnection or not yet disconnected
#define REASON_NO_VALID_REMOTE_GW_IP 1	//Normal disconnection or not yet disconnected
	int disconnectedReason;

#define SA_MODE_BYTE 0
#define SA_TYPE_BYTE 1
#define SA_HMAC_ALG_BYTE 2
#define SA_ENC_ALG_BYTE 3
	int  connectType[4];	// 1 BYTE is for SA mode, 2nd BYTE is SA Type, 3rd Byte is for SA Hmac
	                        // 4 BYTE is for SA EncAlg
							
// SA Mode Values 
#define IPSEC_SA_MODE_TUNNEL	1
#define IPSEC_SA_MODE_TRANSPORT	2

// Sa Type Values
#define	IPSEC_SA_TYPE_AH	2
#define IPSEC_SA_TYPE_ESP	3	

// Sa HmacAlg Values
#define IPSEC_SA_HMAC_NULL	0
#define IPSEC_SA_HMAC_MD5	1
#define IPSEC_SA_HMAC_SHA1	2

// Sa EncAlg Values 
#define IPSEC_SA_ENC_DES	2
#define IPSEC_SA_ENC_3DES	3
#define IPSEC_SA_ENC_NULL	11
#define IPSEC_SA_ENC_AES  12


	time_t connectTimeStart;// the timestamp that connect is estalblished.
	int txPacket;//when connected, the tx packets.
	int rxPacket;//when connected, the Rx packets.

	char remoteGatewayStrForDomainName[20];
} IPSEC_CFG_STATUS;

typedef struct _IPSEC_POLILCY_RULE
{
	unsigned char active;//0:No, 1:Yes
	unsigned char Initiator;  //0:No, 1:Yes
	char  cmdStr[IPSEC_MAX_POLICY_RULE_STRING];	//We keep the rule in string format (char.)
} IPSEC_POLILCY_RULE;
typedef struct IPSEC_CFG_S
{
    unsigned char version; // xxxx.xxxx   0x10 is versoin 1.0
	unsigned char			mode;    	// Enable or disable whole IPSec function
	unsigned char  		count;		// record current number of rules;
   IPSEC_POLILCY_RULE 	ipsecPolicyRule[IPSEC_MAX_POLICY_RULE];	
} IPSEC_CFG_T;

#endif

#if __cplusplus
}
#endif
