/*
 *  IPSEC
 */
/* Robert ,2003/10/22 */
//#include "webs.h"
//#include "uemf.h"
/****************************************************************************
 * standard include files
 ****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <syslog.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/****************************************************************************
 * project include files
 ****************************************************************************/
#include "filem.h"
#include "ipsec_config.h"
#include "host_config.h"
#include "connections_config.h"
#include "program_config.h"
#include "fw_config.h"
#include "gen_config.h"
#include "ipsec_config.h"
/*
void Init_IPSEC_Rule(IPSEC_RULE_T *rule)
{
	rule->Active=IPSEC_Rule_Yes;
	rule->ActiveApplicationType=IPSEC_APPLICATION_TYPE_LAN_LAN;
	rule->ActiveLocalSubnet.s_addr=0;
	rule->ActiveLocalSubnetMask.s_addr=0;
	strcpy(rule->ActiveLocalIKE_ID,"");
	strcpy(rule->ActiveRemoteIP,"0.0.0.0"); // default is wildcard. "%any" can accept any incoming call
	rule->ActiveRemoteSubnet.s_addr=0;
	rule->ActiveRemoteSubnetMask.s_addr=0;
	strcpy(rule->ActiveRemoteIKE_ID,"");
	rule->ActiveProposal=IPSEC_PROPOSAL_ESP;
	rule->ActiveEsp=IPSEC_ESP_3DES;
	rule->ActivePhase1_SA_Lifetime=480;
	rule->ActivePhase2_SA_Lifetime=480;
	rule->Activeperfect_forward_secrecy=IPSEC_PFS_No;
	rule->ActiveAggressiveMode=IPSEC_AggrMode_No;
	rule->Activeresponder_only=IPSEC_ResponderOnly_Yes; // if remote IP is 0.0.0.0
}
*/
void IPSec_Table_Init(IPSEC_TABLE_T *table) {
	memset( (void *)table, 0, sizeof(IPSEC_TABLE_T));
	table->NAT_Traversal_Enabled = IPSEC_NAT_T_No;
	table->NAT_T_KL_Sec = 20;
	//for(i=0;i<MAX_RULE;i++) {
	//	Init_IPSEC_Rule(&table->Rule[i]);
	//}
}

int IPSec_AdjustTable(IPSEC_TABLE_T *table)
{
	IPSEC_TABLE_T tableTmp;
	int i = 0;
	
	IPSec_Table_Init(&tableTmp);
	
	for( i = 0; i < MAX_RULE; i++)
	{
		if( table->Rule[i].Item != 0 )
		{
			memcpy((void*)&(tableTmp.Rule[tableTmp.NextItem++]), (void*)&(table->Rule[i]), sizeof(IPSEC_RULE_T));
			tableTmp.TotalNum++;
		}
	}
	memcpy((void*)table, (void*)&tableTmp, sizeof(IPSEC_TABLE_T));
	return 0;
}

int IPSec_CopyTable(IPSEC_TABLE_T *DstTable, IPSEC_TABLE_T *SrcTable)
{
	IPSec_Table_Init(DstTable);
	memcpy((void*)DstTable, (void*)SrcTable, sizeof(IPSEC_TABLE_T));
	return 0;
}

int IPSec_AddRule(IPSEC_TABLE_T *table, IPSEC_RULE_T *rule)
{
	if( table->TotalNum < 0 || table->TotalNum >= MAX_RULE)
		return -1;
	table->Rule[table->NextItem++] = *rule;
	table->TotalNum++;
	return 0;
}

int IPSec_SetRule(IPSEC_TABLE_T *table, IPSEC_RULE_T *rule, int item)
{
	if( item < 0 || item > table->NextItem)
		return -1;
	table->Rule[item] = *rule;
	return 0;
}

int IPSec_DelRule(IPSEC_TABLE_T *table, int item)
{
	if( item < 0 || item >= table->NextItem)
		return -1;
	//table->Rule[item] = (URLFILTER_RULE_T){0};
	memset( &(table->Rule[item]), 0, sizeof(IPSEC_RULE_T));
	IPSec_AdjustTable(table);
	return 0;
}



