/*
 *  lan_conf.htm: LAN Configuration
 */ 
#include "webs.h"
#include "lan_conf.h"
#include "dhcp.h"
#include "wan.h"

#include <netinet/in.h>
extern void write_ripd_config(LAN_CONFIG_DATA *d1,WAN_CONFIG_DATA *d);
static int get_lan_status (int ejid, webs_t wp, int argc, char_t **argv);
static void form_lan_conf (webs_t wp, char_t *path, char_t *query);
extern void flash_write();
extern void Load_Wan_Config (void);
extern void runStopRip();
extern void runStartRip();
extern void run_task(char *cmd, ...);
extern void Load_Dhcpd_Config (DHCPD_CONFIG_DATA  *d,LAN_CONFIG_DATA *l);

static void resetCurrentLanCfg(LAN_CONFIG_DATA *d);
void Load_Lan_Config (LAN_CONFIG_DATA *d);
void Save_Lan_Config (LAN_CONFIG_DATA *d);
static int run_hosts_script (int ejid, webs_t wp, int argc, char_t **argv);
extern char *get_ip_segment(int num,char *ip_value,char *buf); 

LAN_CONFIG_DATA lan_config;
LAN_CONFIG_DATA old_lan_config;
extern DHCPD_CONFIG_DATA dhcpd_config;

static int get_lan_mod (int ejid, webs_t wp, int argc, char_t **argv){
	int i=0,j;
	Load_Lan_Config(&lan_config);
	j=atoi(argv[1]);
	if (strcmp(argv[0],"RIP")==0)
		i=atoi(lan_config.RIP);

	if (i==j)
		return websWrite(wp, T("%s"),argv[2]);
	else
	        return websWrite(wp, T(""));
}

static void resetCurrentLanCfg(LAN_CONFIG_DATA *d)
{
	//LAN_CONFIG_DATA *d = &lan_config;
	memset(d,0,sizeof(LAN_CONFIG_DATA));
	/*
		strcpy(d->HostAddress,"");
		strcpy(d->HostName,"");
		strcpy(d->HostNetmask,"");
		strcpy(d->HostAddress2,"");
		strcpy(d->RIP,"0");
	*/
}

void Load_Lan_Config (LAN_CONFIG_DATA *d)
{
	FILE *fp;
	resetCurrentLanCfg(d);
	if((fp=fopen(HOSTS_CONFIG_FILE,"r"))!=NULL){
	if(fp) {
		fscanf(fp,"%s %s %s %s %s\n",
		d->HostAddress,
		d->HostName,
		d->HostNetmask,
		d->RIP,
		d->HostAddress2
		);
	}
	fclose(fp);
	}
}

void Save_Lan_Config (LAN_CONFIG_DATA *d)
{
	FILE *fp;
	if((fp = fopen(HOSTS_CONFIG_FILE, "w"))!=NULL){
	
	fprintf(fp, "%s %s %s %s %s\n", 
		d->HostAddress, 
		d->HostName,
		d->HostNetmask,
		d->RIP,
		d->HostAddress2 
          	);
        fclose(fp);
	}
	
	/* Save the /etc/hosts file in the /flash directory. Otherwise, ftpd doesn't work when the /etc/hosts file doesn't match the hostname returned from "uname". */


	if((fp = fopen(HOSTS_ETC_FILE, "w"))!=NULL){
	        fprintf(fp, "127.0.0.1 %s localhost\n", d->HostName);
	        fclose(fp);
	}
		
}

static int get_lan_status (int ejid, webs_t wp, int argc, char_t **argv) 
{
	char_t buf[32];
	if  (strcmp(argv[0],"HostAddress")==0)
	{
		Load_Lan_Config(&lan_config);
		websWrite(wp,T("%s"),lan_config.HostAddress);
	}
	if  (strcmp(argv[0],"HostNetmask")==0)
		websWrite(wp,T("%s"),lan_config.HostNetmask);
	if  (strcmp(argv[0],"HostName")==0)
	{
		Load_Lan_Config(&lan_config);
		websWrite(wp,T("%s"),lan_config.HostName);
	}
	if  (strcmp(argv[0],"HostAddress1")==0)
	{
		Load_Lan_Config(&lan_config);
		websWrite(wp,T("%s"),get_ip_segment(1,lan_config.HostAddress,buf));
	}
	if  (strcmp(argv[0],"HostAddress2")==0)
		websWrite(wp,T("%s"),get_ip_segment(2,lan_config.HostAddress,buf));
	if  (strcmp(argv[0],"HostAddress3")==0)
		websWrite(wp,T("%s"),get_ip_segment(3,lan_config.HostAddress,buf));
	if  (strcmp(argv[0],"HostAddress4")==0)
		websWrite(wp,T("%s"),get_ip_segment(4,lan_config.HostAddress,buf));
	if  (strcmp(argv[0],"HostNetmask1")==0)
		websWrite(wp,T("%s"),get_ip_segment(1,lan_config.HostNetmask,buf));
	if  (strcmp(argv[0],"HostNetmask2")==0)
		websWrite(wp,T("%s"),get_ip_segment(2,lan_config.HostNetmask,buf));
	if  (strcmp(argv[0],"HostNetmask3")==0)
		websWrite(wp,T("%s"),get_ip_segment(3,lan_config.HostNetmask,buf));
	if  (strcmp(argv[0],"HostNetmask4")==0)
		websWrite(wp,T("%s"),get_ip_segment(4,lan_config.HostNetmask,buf));
	if  (strcmp(argv[0],"SecondaryHostAddress")==0)
		websWrite(wp,T("%s"),lan_config.HostAddress2);
	return 1;
}

static void form_lan_conf (webs_t wp, char_t *path, char_t *query)
{
	FILE *fp;
        char_t ipaddr_s[20],subnet_s[20],netmask_s[20],broadcast_s[20],range_start_s[20],range_end_s[20];
        unsigned long msb1,msb2,msb3,msb4,subnet_i,broadcast_i,ranges_i,rangee_i,temp_ranges_i;
        //unsigned long subnet_i,broadcast_i,ranges_i,rangee_i,temp_ranges_i;
        struct in_addr in,in1,in2,in3;
	int i;
	int ISREBOOT=0;
	int IsRipChange=0;
//	int IsFirewallChange=0;
	char_t *buf=NULL;

    // Since LAN IP or mask is changed by user. We need no to keep the old LAN IP and mask for PPPoA NAT disabled case
	//we destory the TEMP_LAN_INFO
	unlink(TEMP_LAN_INFO);

	Load_Lan_Config(&lan_config);
	memcpy(&old_lan_config,&lan_config,sizeof(LAN_CONFIG_DATA));	

	buf=websGetVar(wp, T("HostAddress"), "");
	strcpy(lan_config.HostAddress,buf);
	           	       
	buf=websGetVar(wp, T("HostAddress2"), "");
	strcpy(lan_config.HostAddress2,buf);
	
	buf=websGetVar(wp, T("RIP"), "");
	strcpy(lan_config.RIP,buf);
        
	buf=websGetVar(wp, T("HostNetmask"),"255.255.255.0");
	strcpy(lan_config.HostNetmask,buf);
	

	strcpy(ipaddr_s,lan_config.HostAddress);
	/* Work out a subnet - simplified */
	if (inet_aton(ipaddr_s, &in) != 0)
        {
	Save_Lan_Config(&lan_config);	
	Load_Dhcpd_Config(&dhcpd_config,&lan_config);
	strcpy(range_start_s,dhcpd_config.Range_start);
	strcpy(range_end_s,dhcpd_config.Range_end);
		strcpy(netmask_s,lan_config.HostNetmask);
		
		inet_aton(netmask_s, &in3);
		subnet_i = in.s_addr & in3.s_addr;
	//	sprintf(subnet_s,"%ld",subnet_i);
	//	sprintf(subnet_s,"%s",(char *)HextoDec_ip(subnet_s,buf1));
		
		msb1 = subnet_i & 0xff000000;
		msb2 = subnet_i & 0x00ff0000;
		msb3 = subnet_i & 0x0000ff00;
		msb4 = subnet_i & 0x000000ff;
		msb1 = msb1 >> 24;
		msb2 = msb2 >> 16;
		msb3 = msb3 >> 8;
		sprintf(subnet_s,"%ld.%ld.%ld.%ld",msb1,msb2,msb3,msb4);
	
		broadcast_i=(subnet_i | ~in3.s_addr);
//		sprintf(broadcast_s,"%ld",broadcast_i);
//		sprintf(broadcast_s,"%s",(char *)HextoDec_ip(broadcast_s,buf1));
		
		msb1 = broadcast_i & 0xff000000;
		msb2 = broadcast_i & 0x00ff0000;
		msb3 = broadcast_i & 0x0000ff00;
		msb4 = broadcast_i & 0x000000ff;
		msb1 = msb1 >> 24 ;
		msb2 = msb2 >> 16 ;
		msb3 = msb3 >> 8;
		sprintf(broadcast_s,"%ld.%ld.%ld.%ld",msb1,msb2,msb3,msb4);
		
		inet_aton(range_start_s, &in1); 
		ranges_i=(in1.s_addr & (~in3.s_addr)) | subnet_i;
			
		inet_aton(range_end_s, &in2); 
		rangee_i=(in2.s_addr & (~in3.s_addr)) | subnet_i;
		if (ranges_i > rangee_i){
			temp_ranges_i=ranges_i;
			ranges_i=rangee_i;
			rangee_i=temp_ranges_i;
	}
		/*
		sprintf(range_start_s,"%ld",ranges_i);
		sprintf(range_start_s,"%s",(char *)HextoDec_ip(range_start_s,buf1));
		sprintf(range_end_s,"%ld",rangee_i);
		sprintf(range_end_s,"%s",(char *)HextoDec_ip(range_end_s,buf1));
		*/
		msb1 = ranges_i & 0xff000000;
		msb2 = ranges_i & 0x00ff0000;
		msb3 = ranges_i & 0x0000ff00;
		msb4 = ranges_i & 0x000000ff;
		msb1 = msb1 >> 24;
		msb2 = msb2 >> 16;
		msb3 = msb3 >> 8;
		sprintf(range_start_s,"%ld.%ld.%ld.%ld",msb1,msb2,msb3,msb4);
		msb1 = rangee_i & 0xff000000;
		msb2 = rangee_i & 0x00ff0000;
		msb3 = rangee_i & 0x0000ff00;
		msb4 = rangee_i & 0x000000ff;
		msb1 = msb1 >> 24;
		msb2 = msb2 >> 16;
		msb3 = msb3 >> 8;
		sprintf(range_end_s,"%ld.%ld.%ld.%ld",msb1,msb2,msb3,msb4);

	/* change /flash/dhcpd.conf */
	fp = fopen(DHCPD_CONFIG_FILE, "w");
	if(fp){
	fprintf(fp, "#:%d:\n",dhcpd_config.Enable); 
	fprintf(fp, "#:%d:\n",dhcpd_config.hostIsDnsServer); 
	fprintf(fp, "option domain-name \"%s\";\n", dhcpd_config.DomainName);
	if (dhcpd_config.hostIsDnsServer==1)
		fprintf(fp, "option domain-name-servers %s;\n",lan_config.HostAddress);
	else{		
	if (isValidIP(dhcpd_config.SecondaryDNS))
		fprintf(fp, "option domain-name-servers %s, %s;\n",dhcpd_config.PrimaryDNS,dhcpd_config.SecondaryDNS);
	else
		fprintf(fp, "option domain-name-servers %s;\n",dhcpd_config.PrimaryDNS);
	}	
	fprintf(fp, "default-lease-time %d;\n", dhcpd_config.DefaultLeaseTime);
	fprintf(fp, "max-lease-time %d;\n", dhcpd_config.MaxLeaseTime);
		fprintf(fp, "subnet %s netmask %s {\n",subnet_s,lan_config.HostNetmask);
	fprintf(fp, "\toption routers %s;\n",lan_config.HostAddress);
	fprintf(fp, "\toption broadcast-address %s;\n", broadcast_s);
	fprintf(fp, "\trange %s %s;\n",	range_start_s, range_end_s);
	fprintf(fp, "\tgroup {\n\t\tuse-host-decl-names on;\n");
	for(i=0;i<10;i++)
	{
		if (strlen(dhcpd_config.name[i]) > 0)
		{
			fprintf(fp,"\t\thost %s {\n",dhcpd_config.name[i]);
			fprintf(fp,"\t\t\thardware ethernet %s;\n",dhcpd_config.macaddr[i]);
			fprintf(fp,"\t\t\tfixed-address %s;\n",dhcpd_config.ipaddr[i]);
			fprintf(fp,"\t\t}\n");
		}
	}
	fprintf(fp, "\t}\n}\n");
	fclose(fp);
	}
	
	Load_Wan_Config();
	write_ripd_config(&lan_config,&wan_config);
	save_globe_config(SYS_STATUS_FILE,"LAN_IP=",lan_config.HostAddress);
	save_globe_config(SYS_STATUS_FILE,"LAN_MASK=",lan_config.HostNetmask);

	if ((strcmp(lan_config.HostAddress,old_lan_config.HostAddress)!=0)||	
	    (strcmp(lan_config.HostNetmask,old_lan_config.HostNetmask)!=0))
		ISREBOOT=1;
	//	IsFirewallChange=1;
       //DPRINTF("lan_config.HostAddress:%s\n",lan_config.HostAddress);	
       //DPRINTF("old_lan_config.HostAddress:%s\n",old_lan_config.HostAddress);	
       //DPRINTF("lan_config.HostNetmask:%s\n",lan_config.HostNetmask);	
       //DPRINTF("old_lan_config.HostNetmask:%s\n",old_lan_config.HostNetmask);	
	
	if (ISREBOOT){
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
	save_globe_config(VAR_SYS_STATUS_FILE,"LAN_IP=",lan_config.HostAddress);
	save_globe_config(VAR_SYS_STATUS_FILE,"LAN_MASK=",lan_config.HostNetmask);
		if (strcmp(lan_config.RIP,old_lan_config.RIP)!=0)	
			IsRipChange=1;
        
		if (strcmp(lan_config.HostAddress2,old_lan_config.HostAddress2)!=0){
			runStopRip();
			run_task("ifconfig","ifconfig","br0:SecondaryIP","down",NULL);
			run_script(HOSTS_SCRIPT_FILE,0,0,0);
			runStartRip();
			IsRipChange=0;
		}
	
		if(IsRipChange){
			runStopRip();
			runStartRip();
		}
	}
	websRedirect(wp, T("lan_conf.asp"));
//websRedirect(wp, T("lan_conf_apply.asp")); 
}
}

static int run_hosts_script (int ejid, webs_t wp, int argc, char_t **argv)
{
	run_script(HOSTS_SCRIPT_FILE,0,0,0);
	//run_script("/etc/scripts/fw.sh","stop",0,0);
	//run_script("/etc/scripts/fw.sh","start",0,0);
  run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start","firewall",NULL);
return 1;
}

void DefineWebFunctions_lan() 
{
	websFormDefine(T ("lan"), form_lan_conf);
	websAspDefine (T ("get_lan_status"), get_lan_status);
	websAspDefine (T ("get_lan_mod"), get_lan_mod);
	websAspDefine (T ("run_hosts_script"), run_hosts_script);
}
