/*
 *  Locale CONFIGURATION
 */
#include "webs.h"
#include "locale.h"
#include "locale1.h"
#include "lan_conf.h"
#include "wan.h"

extern char* read_file_para_value(char *filename, char *arg1,char *buf);
extern int checked_function_enabled (char *parameter, webs_t wp, char_t **argv);

#ifdef Language_en
int LANGUAGE_INDEX=0;
#endif
#ifdef Language_fi
int LANGUAGE_INDEX=1;
#endif
#ifdef Language_fr
int LANGUAGE_INDEX=2;
#endif
#ifdef Language_tu
int LANGUAGE_INDEX=3;
#endif
#ifdef Language_de
int LANGUAGE_INDEX=4;
#endif


char *str_other_language_dir[]={"/html","/html_fi","/html_fr","/html_tu","/html_de",NULL};
char *str_language_name[]={"English","Finnish","French","Turkish","Deutsch",NULL};

// 0.English 1.Finnish 2.French
char *ADSL_NOT_UP[]={"N/A (ADSL is not UP)","ADSL -linja ei ole päällä","N/A (ADSL is not UP)","N/A (ADSL is not UP)","N/A (ADSL is not UP)",NULL};
//arp.c
char *Arp_L1[]={"No","Ei","Non","No","Nein",NULL};
char *Arp_L2[]={"Yes","Kyllä","Oui","","Ja",NULL};
char *Arp_L3[]={"Edit","Muuta","Editer","","Bearbeiten",NULL};
char *Arp_L4[]={"Delete","Poista","Supprimer","","Löschen",NULL};
char *Arp_L5[]={"Create","Lisää","Créer","","Erstellen",NULL};

//dhcp.c
char *Dhcp_L1[]={"The DHCP server (or relay) is disabled","DHCP palvelin ja reley pois päältä","Le serveur DHCP (ou relais) est désactivé","","Der DHCP Server (oder Relay) ist deaktiviert",NULL};
char *Dhcp_L2[]={"DHCP Server Running","DHCP -palvelin käytössä","Le serveur DHCP est en fonction","","Der DHCP Server ist aktiv",NULL};
char *Dhcp_L3[]={"DHCP Server Status","DHCP -palvelimen tila","Statut du serveur DHCP","","DHCP Server Status",NULL};
char *Dhcp_L4[]={"Status","Tila","Statut","","Status",NULL};
char *Dhcp_L5[]={"Subnet Definitions","Aliverkon asetukset","Définitions du sous réseau","","Subnetz Definitionen",NULL};
char *Dhcp_L6[]={"Subnet Value","Aliverkko","Valeur du sous réseau","","Subnetz Wert",NULL};
char *Dhcp_L7[]={"SubnetNetmask","Aliverkonpeite","Masque de sous réseau","","Subnetzmaske",NULL};
char *Dhcp_L8[]={"Domain Name","Toimialue","Nom de Domaine","","Domain Name",NULL};
char *Dhcp_L9[]={"DNS Server","Nimipalvelin","Serveur DNS","","DNS Server",NULL};
char *Dhcp_L10[]={"Maximum/Default Lease Time","IP osoitteen voimassaoloaika","Temps du bail Maximum/Defaut","","Maximale/Werkseitige Lease Zeit",NULL};
char *Dhcp_L11[]={"seconds","sekuntia","secondes","","Sekunden",NULL};
char *Dhcp_L12[]={"IP Range","IP alue","Plage d'IP","","IP Bereich",NULL};
char *Dhcp_L13[]={"MAC Mapping to IP : rule","MAC -> IP : sääntöä","Mappage MAC vers IP : règle","","MAC Adresse mappen mit IP",NULL};
char *Dhcp_L14[]={"DHCP Relay Server Running","DHCP -välityspalvelin käytössä","Le relais DHCP est en fonction","","DHCP Relay Server aktiv",NULL};
char *Dhcp_L15[]={"DHCP Server Status","DHCP -tiedot","Statut du serveur DHCP","","DHCP Server Status",NULL};
char *Dhcp_L16[]={"DHCP Relay Server","DHCP relauy palvelin","Relais DHCP","","DHCP Relay Server",NULL};
char *Dhcp_L17[]={"Disabled","Pois päältä","Déconnecté","","Deaktiviert",NULL};
char *Dhcp_L18[]={"DHCP Server Running","DHCP -palvelin käytössä","Le serveur DHCP est en fonction","","DHCP Server aktiv",NULL};
char *Dhcp_L19[]={"DHCP Relay Server Running","DHCP -välityspalvelin käytössä","Le relais DHCP est en fonction","","DHCP Relay Server aktiv",NULL};

//home.c
char *Home_L1[]={"Renew","Uudista","Renommer","","Erneuern",NULL};
char *Home_L2[]={"Release","Vapauta","Liberer","","Freigeben",NULL};
char *Home_L3[]={"Connect","Yhdistä","Connecter","","Verbinden",NULL};
char *Home_L4[]={"Disconnect","Sulje yhteys","Déconnecter","","Trennen",NULL};
char *Home_L5[]={"Connected","Yhdistetty","Connecté","","Verbunden",NULL};
char *Home_L6[]={"Connecting","Muodostetaan yhteys","En connexion","","Verbinden",NULL};
char *Home_L7[]={"Disconnected","Katkaistu","Déconnecté","","Getrennt",NULL};
char *Home_L8[]={"Disconnecting","Yhteyden lopetus","En Déconnexion","","Trennen",NULL};
char *Home_L9[]={"Jan","tammikuu","Jan","","Jan",NULL};
char *Home_L10[]={"Feb","helmikuu","Feb","","Feb",NULL};
char *Home_L11[]={"Mar","maaliskuu","Mar","","Mar",NULL};
char *Home_L12[]={"Apr","huhtikuu","Apr","","Apr",NULL};
char *Home_L13[]={"May","toukokuu","May","","Mai",NULL};
char *Home_L14[]={"Jun","kesäkuu","Jun","","Jun",NULL};
char *Home_L15[]={"Jul","heinäkuu","Jul","","Jul",NULL};
char *Home_L16[]={"Aug","elokuu","Aug","","Aug",NULL};
char *Home_L17[]={"Sep","syyskuu","Sep","","Sep",NULL};
char *Home_L18[]={"Oct","lokakuu","Oct","","Okt",NULL};
char *Home_L19[]={"Nov","marraskuu","Nov","","Nov",NULL};
char *Home_L20[]={"Dec","joulukuu","Dec","","Dez",NULL};
char *Home_L21[]={"day(s)","päivä(ä)","Jour","","Tag",NULL};
char *Home_L22[]={"hour(s)","tunti(a)","Heure","","Stunde",NULL};
char *Home_L23[]={"min(s)","minuutti(a)","Min","","Min",NULL};

//macf.c
char *MACFiler_L1[]={"Forward","Salli","Avancer","","Erlauben",NULL};
char *MACFiler_L2[]={"Drop","Estä","Reculer","","Blockieren",NULL};
char *MACFiler_L3[]={"No","Ei","Non","","Nein",NULL};
char *MACFiler_L4[]={"Yes","Kyllä","Oui","","Ja",NULL};
char *MACFiler_L5[]={"Rule","Sääntö","Règle","","Regel",NULL};
char *MACFiler_L6[]={"Active","Aktiivinen","Actif","","Aktiv",NULL};
char *MACFiler_L7[]={"Action When Matched","Toiminto","Action si OK","","Aktion bei Übereinstimmung",NULL};
char *MACFiler_L8[]={"Log","Loki","Log","","Protokollieren",NULL};
char *MACFiler_L9[]={"Mac Address","MAC -osoite","Adresse Mac","","MAC Adresse",NULL};
char *MACFiler_L10[]={"Default Rules Drop mode cannot be enabled without any rules. Doing so could block all access to the router and to the Internet. Now reverting to default Forward mode.","Estot toimintoa ei voi asettaa päälle ilman sääntöjä! Jos teet tämän niin laite on toimintakyvytön.Palataan oletustilaan.","Le \"Mode Drop\" ne peut fonctionner sans réglages. Cela pourra engendrer le blocage du routeur et l'accès ? internet.","","Die Standard Regel kann nicht auf Blockieren stehen, ohne eine aktive Regel erstellt zu haben. Dies würde dazu führen dass kein Zugriff auf den Router bzw. das Internet möglich ist. Die Standard Regel wird nun wieder auf Erlauben gesetzt.",NULL};
char *MACFiler_L11[]={"Candidates","Ehdokas","Candidats","","Aktive PCs",NULL};

//pf.c
char *PacketFilter_L1[]={"User Defined","User definied ? Käyttäjän määritys","Défini par l'utilisateur","","Benutzerdefiniert",NULL};
char *PacketFilter_L2[]={"Forward","Salli","Avancer","","Weiterleiten",NULL};
char *PacketFilter_L3[]={"Drop","Estä","Reculer","","Verwerfen",NULL};
char *PacketFilter_L4[]={"Any","Kaikki","Tous","","Jedes",NULL};
char *PacketFilter_L5[]={"No","Ei","Non","","Nein",NULL};
char *PacketFilter_L6[]={"Yes","Kyllä","Oui","","Ja",NULL};
char *PacketFilter_L7[]={"Out","Lähtevä","En dehors","","Ausgehend",NULL};
char *PacketFilter_L8[]={"In","Saapuva","Dedans","","Eingehend",NULL};
char *PacketFilter_L9[]={"Application Type","Sovellus tyyppi","Type de Application","","Anwendung Typ",NULL};
char *PacketFilter_L10[]={"Reverse Direction","Käänteinen suunta","Direction","","Umgekehrte Rechnung",NULL};
//char *PacketFilter_L11[]={"Rule number","Sääntö nro","Numéro de règle","","Regel",NULL};
char *PacketFilter_L11[]={"Name","Nimi","Nom","","Name",NULL};
char *PacketFilter_L12[]={"Packet Flow","Pakettien kulku","Flux des paquets","","Richtung",NULL};
char *PacketFilter_L13[]={"Outgoing(Local to Remote)","Lähtevä","Sortant","","Ausgehend",NULL};
char *PacketFilter_L14[]={"Incoming(Remote to Local)","Saapuva","Entrant","","Eingehend",NULL};
char *PacketFilter_L15[]={"Active","Aktiivinen","Actif","","Aktiv",NULL};
char *PacketFilter_L16[]={"Packet Type","Pakettien kulku","Type de paquet","","Paket Typ",NULL};
char *PacketFilter_L17[]={"Log","Loki","Log","","Protokollieren",NULL};
char *PacketFilter_L18[]={"Action When Matched","Toiminto","Action si OK","","Aktion bei Übereinstimmung",NULL};
char *PacketFilter_L19[]={"Source IP Address(Leave blanks for all ranges)","Lähde IP","Adresse IP de la source","","Quell IP Adresse",NULL};
char *PacketFilter_L20[]={"Destination IP Address(Leave blanks for all ranges)","Kohde IP","Adresse IP de la destination","","Ziel IP Adresse",NULL};
char *PacketFilter_L21[]={"from","Alk.","De","","von",NULL};
char *PacketFilter_L22[]={"to","->","Vers","","nach",NULL};
char *PacketFilter_L23[]={"Source Port","Lähteen portti","Port de la source","","Quell Port",NULL};
char *PacketFilter_L24[]={"Destination Port","Kohteen portti","Port de la destination","","Ziel Port",NULL};
char *PacketFilter_L25[]={"Schedule Time","Ajastukset","Horaire programmé","","Zeitplan",NULL};
char *PacketFilter_L26[]={"Always","Aina","Toujours","","Immer",NULL};
char *PacketFilter_L27[]={"Schedule from","Ajastus alkaen","Horaire pour","","Zeit von",NULL};
char *PacketFilter_L28[]={"Default Rules Drop mode cannot be enabled without any rules. Doing so could block all access to the Internet. Now reverting to default Forward mode.","Estot toimintoa ei voi asettaa päälle ilman sääntöjä! Jos teet tämän niin laite on toimintakyvytön.Palataan oletustilaan.","Le \"Mode Reculer\" ne peut fonctionner sans réglages. Cela pourra engendrer le blocage de l'accès ? internet.","","Die Standard Regel kann nicht auf Blockieren stehen, ohne eine aktive Regel erstellt zu haben. Dies würde dazu führen dass kein Zugriff auf den Router bzw. das Internet möglich ist. Die Standard Regel wird nun wieder auf Erlauben gesetzt.",NULL};
//char *PacketFilter_L29[]={"In/Out","Saapuva/Lähtevä","Dedans/En dehors","","Eingehend/Ausgehend",NULL};
char *PacketFilter_L29[]={"</SELECT>(You may select a predefined packet filtering profile for a well-known application here.)","</SELECT>(Voit valita listan yleisitä määrityksistä tai voit tehdä oman määrityksen)","</SELECT>(You may select a predefined packet filtering profile for a well-known application here.)","</SELECT>(You may select a predefined packet filtering profile for a well-known application here.)","</SELECT>(You may select a predefined packet filtering profile for a well-known application here.)",NULL};

//pwduser.c
char *PWDUser_L1[]={"Edit","Muuta","Editer","","Bearbeiten",NULL};
char *PWDUser_L2[]={"Delete","Poista","Supprimer","","Löschen",NULL};
char *PWDUser_L3[]={"True","Kyllä","Vrai","","Wahr",NULL};
char *PWDUser_L4[]={"False","Ei","Faux","","Falsch",NULL};

//qos.c
char *Qos_L1[]={"Non-Assigned Bandwidth Ratio","Rajoittamaton käyttö","Pas de ratio de bande passante assigné","","Anteil der nicht zugewiesenen Bandbreite",NULL};
char *Qos_L2[]={"to","->","Vers","","bis",NULL};
char *Qos_L3[]={"Controlled Traffic Flow","Liikenteen suunta","Contrôle du trafic flux","","Zu kontrollierender Datenfluss",NULL};
char *Qos_L4[]={"Application","Sovellus","Type de Pacquet","","Anwendung",NULL};
char *Qos_L5[]={"Packet Type","Paketin tyyppi","Packet Type","","Paket Typ",NULL};
char *Qos_L6[]={"Assigned Data Rate","Asetettu nopeus","Taux de transfert assigné","","Zugewiesen Datenrate",NULL};
char *Qos_L7[]={"Rate Type","Nopeus","Type de transfert","","Zuweisung",NULL};
char *Qos_L8[]={"Data Ratio","Arvo","Ratio","","Rate",NULL};
char *Qos_L9[]={"Priority for Non-used Bandwidth","Muu etuoikeus","Priorité ? la bande passante libre","","Priorität für nicht benötigte Bandbreite",NULL};
char *Qos_L10[]={"DSCP Marking","DSCP merkintä","Marquage DSCP","","DSCP Markierung",NULL};
char *Qos_L11[]={"Local Machine IPs","Sisäverkon IP","IPs des machines locales","","IPs der lokalen Rechner",NULL};
char *Qos_L12[]={"Remote Machine IPs","Kohteen IP","IPs des machines distantes","","IPs der entfernten Rechner",NULL};
char *Qos_L13[]={"from","Alk.","De","","von",NULL};
char *Qos_L14[]={"Local Application Ports","Sovellusten portit","Ports Locaux des applications","","Ports der lokalen Anwendung",NULL};
char *Qos_L15[]={"Remote Application Ports","Kohteen portit","Ports distants des applications","","Ports der entfernten Anwendung",NULL};
char *Qos_L16[]={"Schedule Time","Ajastukset","Horaire programmé","","Zeitplan",NULL};
char *Qos_L17[]={"Always","Aina","Toujours","","Immer",NULL};
char *Qos_L18[]={"Schedule from","Ajastus alkaen","Horaire pour","","Zeit von",NULL};
char *Qos_L19[]={"LAN to WAN","LAN -> WAN","LAN vers WAN","","LAN zum WAN",NULL};
char *Qos_L20[]={"WAN to LAN","WAN -> LAN","WAN vers LAN","","WAN zum LAN",NULL};
char *Qos_L21[]={"Any","Kaikki","Tous","","Jedes",NULL};
char *Qos_L22[]={"High","Korkea","Haut","","Hoch",NULL};
char *Qos_L23[]={"Normal","Normaali","Normal","","Normal",NULL};
char *Qos_L24[]={"Low","Matala","Bas","","Niedrig",NULL};
char *dscpMarkingList[6][15]={
	{"Disabled","Best Effort", "Premium",
	 "Gold service(L)","Gold service(M)","Gold service(H)","Silver service(L)","Silver service(M)","Silver service(H)",
	 "Bronze service(L)","Bronze service(M)","Bronze service(H)"},
	{"Disabled","Best Effort", "Premium",
	 "Gold service(L)","Gold service(M)","Gold service(H)","Silver service(L)","Silver service(M)","Silver service(H)",
	 "Bronze service(L)","Bronze service(M)","Bronze service(H)"},
	{"Disabled","Best Effort", "Premium",
	 "Gold service(L)","Gold service(M)","Gold service(H)","Silver service(L)","Silver service(M)","Silver service(H)",
	 "Bronze service(L)","Bronze service(M)","Bronze service(H)"},
	{"Disabled","Best Effort", "Premium",
	 "Gold service(L)","Gold service(M)","Gold service(H)","Silver service(L)","Silver service(M)","Silver service(H)",
	 "Bronze service(L)","Bronze service(M)","Bronze service(H)"},
	{"Deaktiviert","Beste Leistung", "Premium",
	 "Gold service(L)","Gold service(M)","Gold service(H)","Silber service(L)","Silber service(M)","Silber service(H)",
	 "Bronze service(L)","Bronze service(M)","Bronze service(H)"},
};
//char *Qos_L25[]={"Fixed (Maximum)","","","","Fixed (Maximum)",NULL};
//char *Qos_L26[]={"Guaranteed (Minimum)","","","","Guaranteed (Minimum)",NULL};

//quick.c
char *Quick_L1[]={"Enable","Päälle","Activé","","Aktivieren",NULL};
char *Quick_L2[]={"Disable","Pois päältä","Désactivé","","Deaktivieren",NULL};
char *Quick_L3[]={"Optional Settings","Lisäasetukset","Réglages optionnels","","Optionale Einstellungen",NULL};
char *Quick_L4[]={"IP Address","IP -osoite","Adresse IP","","IP Adresse",NULL};
char *Quick_L5[]={"('0.0.0.0' means 'Obtain an IP address automatically')","('0.0.0.0' IP haetaan automaattisesti)","('0.0.0.0' IP donnée automatiquement)","","('0.0.0.0' bedeutet das die IP Adresse automatisch bezogen wird')",NULL};
char *Quick_L6[]={"SubnetNetmask","Aliverkon peite","Masque de sous réseau","","Subnetzmaske",NULL};
char *Quick_L7[]={"Default Gateway","Yhdyskäytävä","Passerelle par défaut","","Standardgateway",NULL};
char *Quick_L8[]={"Obtain DNS automatically","Hae DNS automaattisesti","Obtenir les DNS automatiquement","","DNS automatisch beziehen",NULL};
char *Quick_L9[]={"Primary DNS","Ensisijainen nimipalvelin","DNS primaire","","Primärer DNS",NULL};
char *Quick_L10[]={"Secondary DNS","Vaihtoehtoinen nimipalvelin","DNS secondaire","","Sekundärer DNS",NULL};
char *Quick_L11[]={"Username","Käyttäjän nimi","Nom d'utilisateur","","Benutzername",NULL};
char *Quick_L12[]={"Password","Salasana","Mot de passe","","Passwort",NULL};

char *URL_L1[]={"Always Block","Aina Estot","Toujours bloqué","","Immer blockieren",NULL};
char *URL_L2[]={"Always","Aina","Toujours","","Immer",NULL};
char *URL_L3[]={"No","Ei","Non","","Nein",NULL};
char *URL_L4[]={"Yes","Kyllä","Oui","","Ja",NULL};
char *URL_L5[]={"Enable","Päälle","Activé","","Aktivieren",NULL};
char *URL_L6[]={"Disable","Pois päältä","Désactivé","","Deaktivieren",NULL};
char *URL_L7[]={"to","->","Vers","","bis",NULL};
char *URL_L8[]={"Sun","Sunnuntai","Sun","","Son",NULL};
char *URL_L9[]={"Mon","Maanantai","Mon","","Mon",NULL};
char *URL_L10[]={"Tue","Tiistai","Tue","","Die",NULL};
char *URL_L11[]={"Wed","Keskiviikko","Wed","","Mit",NULL};
char *URL_L12[]={"Thu","Torstai","Thu","","Don",NULL};
char *URL_L13[]={"Fri","Perjantai","Fri","","Fre",NULL};
char *URL_L14[]={"Sat","Lauantai","Sat","","Sam",NULL};
char *URL_L15[]={"Rule","Sääntö","Règle","","Regel",NULL};
char *URL_L16[]={"Active","Aktiivinen","Actif","","Akitv",NULL};
char *URL_L17[]={"PC IP Address Range","PC:n IP -osoitteet","Plage d'adresse IP des PC","","PC IP Adress Bereich",NULL};
char *URL_L18[]={"from","Alk.","De","","von",NULL};
char *URL_L19[]={"Keywords Filtering","Avaimen mukainen suodatus","Filtrage par mots clés","","Schlüsselwörter filtern",NULL};
char *URL_L20[]={"Enable","Päälle","Activé","","Aktivieren",NULL};
char *URL_L21[]={"Details","Tiedot","Details","","Details",NULL};
char *URL_L22[]={"Restrict URL Features","Rajoita WWW -ominaisuuksia","Restriction d'URL","","URL Features einschränken",NULL};
char *URL_L23[]={"Block","Estä","blocage","","Blockiere",NULL};
char *URL_L24[]={"Block Mode","Estot tila","Mode de blocage","","Blockier Modus",NULL};
char *URL_L25[]={"Always Block","Estä aina","Toujours bloqué","","Immer blockieren",NULL};
char *URL_L26[]={"Block from","Estä alkaen","Blocage venant de","","Blockieren von",NULL};
char *URL_L27[]={"Delete","Poista","Supprimer","","Löschen",NULL};
char *URL_L28[]={"Keyword","Avainsana","Mot clé","","Schlüsselwort",NULL};
char *URL_L29[]={"Apply","Tallenna","Appliquer","","Übernehmen",NULL};
char *URL_L30[]={"Domain Name","Toimialue","Nom de domaine","","Domain Name",NULL};
char *URL_L31[]={"Domains Filtering","Toimialueiden estot","Filtrage par nom de domaine","","Domain Filter",NULL};

//route.c
char *Route_L1[]={"Edit","Muuta","Editer","","Bearbeiten",NULL};
char *Route_L2[]={"Delete","Poista","Supprimer","","Löschen",NULL};
char *Route_L3[]={"True","Kyllä","Vrai","","Wahr",NULL};
char *Route_L4[]={"False","Ei","Faux","","Falsch",NULL};
char *Route_L5[]={"Create","Tiedot","Créer","","Erstellen",NULL};

//scanpvc.c
char *Scanpvc_L1[]={"Apply","Tallenna","Appliquer","","Übernehmen",NULL};

// Camiu added 2006/05/08
//vlan.c
char_t *vlan_TableFmt2[] ={
	"<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>No</option>\n"
	"<OPTION value=\"2\" %s>Main WAN connection(Management)</option>\n",
	"<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>No</option>\n"
	"<OPTION value=\"2\" %s>Main WAN connection(Management)</option>\n",
	"<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>No</option>\n"
	"<OPTION value=\"2\" %s>Main WAN connection(Management)</option>\n",
	"<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>No</option>\n"
	"<OPTION value=\"2\" %s>Main WAN connection(Management)</option>\n",
	"<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>Keine</option>\n"
	"<OPTION value=\"2\" %s>Primäre WAN Verbindung(Management)</option>\n",
};
// Camiu added 2006/05/08 end

// added 2007/01/17 begin
char_t *vlan_TableFmt4[] ={ 
"<TR>\n"
"\t<TD class=header colSpan=10>LAN Tagging</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n",
"<TR>\n"
"\t<TD class=header colSpan=10>LAN -ohjaus (VLAN tag)</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n",
"<TR>\n"
"\t<TD class=header colSpan=10>LAN Tagging</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n",
"<TR>\n"
"\t<TD class=header colSpan=10>LAN Tagging</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n",
"<TR>\n"
"\t<TD class=header colSpan=10>LAN Tagging</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n",
};
// added 2007/01/17 end

//wan_adv.c
char *WAN_ADV_L1[]={"Edit","Muuta","Editer","","Bearbeiten",NULL};
char *WAN_ADV_L2[]={"Change","Korvaa","Changer","","Ändern",NULL};
char *WAN_ADV_L3[]={"Routed","Reititetty","Routée","","Routed",NULL};
char *WAN_ADV_L4[]={"Bridged","Sillattu","en pont","","Bridged",NULL};


void resetCurrentLocaleCfg(void);
static int Load_Locale_Config (void);
static int Save_Locale_Config (LOCALE_CONFIG_DATA *d);
static int other_language_id (int eid, webs_t wp, int argc, char_t ** argv);
static int other_language_name (int eid, webs_t wp, int argc, char_t ** argv);
static int get_language_name (int eid, webs_t wp, int argc, char_t ** argv);
static int change_language_to_en (int eid, webs_t wp, int argc, char_t ** argv);
static int change_language_to_other (int eid, webs_t wp, int argc, char_t ** argv);
static int is_multi_language_selection_enabled (int ejid, webs_t wp, int argc, char_t **argv);
static int other_language_id (int eid, webs_t wp, int argc, char_t ** argv){
	char languageid[10];
	char buf[32];
	strcpy(languageid,(char *)read_file_para_value("/etc/default/config","OTHER_LANGUAGE=",buf));
	return websWrite(wp,T("%s"),languageid);	
}
static int get_language_name (int eid, webs_t wp, int argc, char_t ** argv){
	Load_Locale_Config();
	//DPRINTF("str_language_name[LANGUAGE_INDEX]:%s\n",str_language_name[LANGUAGE_INDEX]);
	return websWrite(wp,T("%s"),str_language_name[locale_config.locale]);		
}
static int other_language_name (int eid, webs_t wp, int argc, char_t ** argv){
	//DPRINTF("str_language_name[LANGUAGE_INDEX]:%s\n",str_language_name[LANGUAGE_INDEX]);
	return websWrite(wp,T("%s"),str_language_name[LANGUAGE_INDEX]);		
}
static int is_multi_language_selection_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("MULTI_LANGUAGE_SELECTION=",wp,argv);
}
static int change_language_to_en (int eid, webs_t wp, int argc, char_t ** argv){
	Load_Locale_Config();
        locale_config.locale=0;
	Save_Locale_Config(&locale_config);
	websSetDefaultDir(str_other_language_dir[0]);
	return 1;
}
static int change_language_to_other (int eid, webs_t wp, int argc, char_t ** argv){
	
	Load_Locale_Config();
        locale_config.locale=LANGUAGE_INDEX;
	Save_Locale_Config(&locale_config);
	
	websSetDefaultDir(str_other_language_dir[LANGUAGE_INDEX]);
	return 1;
}
void resetCurrentLocaleCfg(void)
{
	LOCALE_CONFIG_DATA *d=&locale_config;
	memset(d,0,sizeof(LOCALE_CONFIG_DATA));
}

static int Load_Locale_Config (void)
{
	FILE *fp;
	resetCurrentLocaleCfg();
	fp=fopen(locale_config_file,"r");
	if(fp){
		fscanf(fp,"%d",&locale_config.locale);
		fclose(fp);
	}
	return 0;
}

static int Load_Default_Locale (){
	Load_Locale_Config();
	if (locale_config.locale==LANGUAGE_INDEX)
		websSetDefaultDir(str_other_language_dir[LANGUAGE_INDEX]);
	return 1;	
	
}
static int Save_Locale_Config (LOCALE_CONFIG_DATA *d){
	
        FILE *fp;
	fp=fopen(locale_config_file,"w");
	if(fp) {
		fprintf(fp,"%d",d->locale);
		fclose(fp);
		return 1;
	}
	return 0;
}
void DefineWebFunctions_locale(){
	Load_Default_Locale();
	websAspDefine(T("change_language_to_en"),change_language_to_en);
	websAspDefine(T("is_multi_language_selection_enabled"),is_multi_language_selection_enabled);
	websAspDefine(T("change_language_to_other"),change_language_to_other);
	websAspDefine(T("other_language_id"),other_language_id);
	websAspDefine(T("other_language_name"),other_language_name);
	websAspDefine(T("get_language_name"),get_language_name);
}
