#include "webs.h"
#include "profile.h"
#define __S_Table(x) __S_TABLE[(x-48)]

int __S_TABLE[] = {
0,1,2,3,4,5,6,7,8,9,	/* 48, .., 57 */
0,0,0,0,0,0,0,10,11,12, /* 58, .., 67 */
13,14,15,0,0,0,0,0,0,0, /* 68, .., 77 */
0,0,0,0,0,0,0,0,0,0,	/* 78, .., 87 */
0,0,0,0,0,0,0,0,0,10,	/* 88, .., 97 */
11,12,13,14,15			/* 98, .., 102 */
};


void defineMacCnf();
static int LANMAC_addr(int eid, webs_t wp, int argc, char_t **argv);
static void formMac(webs_t wp, char_t *path, char_t *query);

extern void flash_write_mac();


void defineMacCnf()
{
	websAspDefine(T("LANMAC_addr"), LANMAC_addr);
	websFormDefine(T("formMac"), formMac);
}


static int LANMAC_addr(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE* fp1;
	int nBytes=0;
  char * mac_address_string = 
"<input type=\"text\" maxLength=\"2\" name=\"mac1\" size=\"1\" value=\"%02X\">-\n"
"<input type=\"text\" maxLength=\"2\" name=\"mac2\" size=\"1\" value=\"%02X\">-\n"
"<input type=\"text\" maxLength=\"2\" name=\"mac3\" size=\"1\" value=\"%02X\">-\n"
"<input type=\"text\" maxLength=\"2\" name=\"mac4\" size=\"1\" value=\"%02X\">-\n"
"<input type=\"text\" maxLength=\"2\" name=\"mac5\" size=\"1\" value=\"%02X\">-\n"
"<input type=\"text\" maxLength=\"2\" name=\"mac6\" size=\"1\" value=\"%02X\">\n"  ;

	HW_DATA_T hwd;
	//int i=0;
/* (AA-AA-AA-AA-AA-AA) */
	fp1 = fopen(DEFAULT_MAC1_FN,"rb");
	if (fp1 == 0)
	{
		printf("%s open failed\n",DEFAULT_MAC1_FN);
		return -1;
	}
	fread(hwd.lan_mac,1,MAC_LENGTH,fp1);
	//printf
	DPRINTF("mac = %02X-%02X-%02X-%02X-%02X-%02X\n",
			(hwd.lan_mac[0] & 0xff),(hwd.lan_mac[1] & 0xff),
			(hwd.lan_mac[2] & 0xff),(hwd.lan_mac[3] & 0xff),
			(hwd.lan_mac[4] & 0xff),(hwd.lan_mac[5] & 0xff));
	nBytes += websWrite(wp,T (mac_address_string),
			(hwd.lan_mac[0] & 0xff),(hwd.lan_mac[1] & 0xff),
			(hwd.lan_mac[2] & 0xff),(hwd.lan_mac[3] & 0xff),
			(hwd.lan_mac[4] & 0xff),(hwd.lan_mac[5] & 0xff));
	
	fclose(fp1);
	return nBytes;
	

}

static void formMac(webs_t wp, char_t *path, char_t *query)
{
  char_t *buf;
  FILE* fp;
  char tmpbuf[3];
  HW_DATA_T hwd;
  //int i;
  //store 3 macs to flash
  //lan.mac/wan.mac/wlan.mac

  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac1"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[0] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
//  DPRINTF("mac1 = %s\n",buf);
//  DPRINTF("mac1 = %02X\n",(hwd.lan_mac[0]&0xff));
 
  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac2"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[1] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
//  DPRINTF("mac2 = %s\n",buf);
//  DPRINTF("mac2 = %02X\n",(hwd.lan_mac[1]&0xff));
  
  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac3"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[2] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
//  DPRINTF("mac3 = %s\n",buf);
//  DPRINTF("mac3 = %02X\n",(hwd.lan_mac[2]&0xff));
  
  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac4"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[3] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
//  DPRINTF("mac4 = %s\n",buf);
//  DPRINTF("mac4 = %02X\n",(hwd.lan_mac[3]&0xff));
  
  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac5"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[4] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
//  printf("mac5 = %s\n",buf);
//  printf("mac5 = %02X\n",(hwd.lan_mac[4]&0xff));

  memset(tmpbuf,0,3);
  buf = websGetVar (wp, T ("mac6"), T ("00"));
  memcpy(tmpbuf,buf,2);
  hwd.lan_mac[5] = (__S_Table(tmpbuf[0])<< 4) + __S_Table(tmpbuf[1]);
  //printf("mac6 = %s\n",buf);
  //printf("mac6 = %02X\n",(hwd.lan_mac[5]&0xff));
  
  /* we check wan_mac */
  // 7202: lan_mac
#if 1
	fp = fopen(DEFAULT_MAC1_FN,"wb");
	if (fp == 0)
	{
		printf("%s open failed\n",DEFAULT_MAC1_FN);
		return;
	}
	fwrite(hwd.lan_mac,1,MAC_LENGTH,fp);
	fclose(fp);
#endif
//write to flash
	flash_write_mac();
  //send_back_htm;
  websRedirect(wp, T("mac.asp"));
}	


	
