/*
 *  macf.htm: Mac Filter Configuration
 */
#include "webs.h"
#include "pf_conf.h"
#include "pf.h"
#include "filem.h"
#include "lan_conf.h"
#include "wan.h"
#include "locale.h"
/* KenWang added 2005/06/24 -- begin -- */
#include "arp.h" 
#include "misc.h"
#include <sys/types.h>  
#include <signal.h>
/* KenWang added 2005/06/24 -- end -- */

#include "../iptables-1.2.11/runFunc.h"

extern char *MACFiler_L1[];
extern char *MACFiler_L2[];
extern char *MACFiler_L3[];
extern char *MACFiler_L4[];
extern char *MACFiler_L5[];
extern char *MACFiler_L6[];
extern char *MACFiler_L7[];
extern char *MACFiler_L8[];
extern char *MACFiler_L9[];
extern char *MACFiler_L10[];
extern char *MACFiler_L11[];


extern void drop_newline(char *);
extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

#define MAC_FILTER_CONF_RULE_ADD    "/var/etc/macf.conf.rule.add"
#define MAC_FILTER_CONF_RULE_DEL    "/var/etc/macf.conf.rule.del"

static int MF_MACdfRule = 1;
static void DefineMacFilterConfig();

extern void run_task(char *cmd, ...);
static int GetConfigToMFTable(MF_TABLE_T *table);
static int SetMFTableToConfig(MF_TABLE_T *table);
static int CreateMFTableToScript(MF_TABLE_T *table);
// web pages function
static void formMF(webs_t wp, char_t *path, char_t *query);
static int aspMacFilterShow(int eid, webs_t wp, int argc, char_t **argv);
static int aspMacDefaultRulesShow(int eid, webs_t wp, int argc, char_t **argv);
static int aspMF1_fwNow(int eid, webs_t wp, int argc, char_t **argv);
static int aspMF1_fwNow2(void);
static int aspMF1_Page(int eid, webs_t wp, int argc, char_t **argv);
static void formMF1(webs_t wp, char_t *path, char_t *query);

extern char_t *SelectListOption( char_t **Option_List, int num, int who);
static int get_maclist(int eid, webs_t wp, int argc, char_t **argv); // KenWang added 2005/06/06
/*
 * Mac filter function
 */
extern int MF_Table_Init(MF_TABLE_T *table);
extern int MF_AddRule(MF_TABLE_T *table, MF_RULE_T *rule);
extern int MF_DelRule(MF_TABLE_T *table, int item);
extern int MF_AdjustTable(MF_TABLE_T *table);
extern int MF_SetRule(MF_TABLE_T *table, MF_RULE_T *rule, int item);
extern int MF_CopyTable(MF_TABLE_T *DstTable, MF_TABLE_T *SrcTable);
static void DefineMacFilterConfig();

void DefineWebFunctions_MacFilter() {
	DefineMacFilterConfig();
}

static MF_TABLE_T MF_Table, MF_TableShow;

int mfilterIfAnyRulesActive(MF_TABLE_T *table)	
{
	MF_RULE_T *rule;
	int i;
   for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) 
   {
     rule = &(table->Rule[i]);
     if( rule->Item != 0 ) {
       if( rule->Active == PF_Act_YES )
       {
		return 1;
       }
     }	
   }	
   return 0; 
}




static void DefineMacFilterConfig()
{
	MF_Table_Init(&MF_Table);
	MF_Table_Init(&MF_TableShow);
	GetConfigToMFTable(&MF_Table);
	GetConfigToMFTable(&MF_TableShow);
	
	// KenWang modified 2005/05/6/15
	//if(mfilterIfAnyRulesActive(&MF_Table))
	if(mfilterIfAnyRulesActive(&MF_Table) || MF_MACdfRule != 1)
		CreateMFTableToScript(&MF_Table);
	websAspDefine(T("MAC_default_rules"), aspMacDefaultRulesShow);
	websAspDefine(T("mfList"), aspMacFilterShow);
	websFormDefine(T("mf"), formMF);
	
	websAspDefine(T("MF_Table"), aspMF1_Page);
	websFormDefine(T("mf1"), formMF1);
	websAspDefine(T("fwNow1"), aspMF1_fwNow);
	websAspDefine(T("get_maclist"), get_maclist); // KenWang added 2005/06/06
}

static int aspMacDefaultRulesShow(int eid, webs_t wp, int argc, char_t **argv){
char_t *TableFmt =
"\t<SELECT name=MACdfRule>\n"
"\t\t%s"
"\t</SELECT>\n";
const int PolicyNum=2; 
char_t *PolicyList[]={MACFiler_L1[locale_config.locale], MACFiler_L2[locale_config.locale]};

return	websWrite(wp, T(TableFmt),	SelectListOption(PolicyList,PolicyNum ,MF_MACdfRule-1 ));

}



// MacFilter asp function

static int aspMacFilterShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i=0;
	
	char_t MacAddress[1][20]={{0}};
	char_t *TableFmt="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
		    "<td>&nbsp;%d&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td></tr>\n";
	MF_RULE_T *rule;
		
	for( i = 0; i < MF_TableShow.TotalNum; i++)
	{
		rule=&MF_TableShow.Rule[i];
		if( rule->Item != 0)
		{
			sprintf(MacAddress[0], "%s" ,rule->MAC_Filter_Address);
		
			nBytes += websWrite(wp, T(TableFmt),
			i+1,
			(i == aspMF1_fwNow2() ? "checked" : ""),
			i+1,
			(rule->Active == PF_Act_NO ? MACFiler_L3[locale_config.locale] : MACFiler_L4[locale_config.locale]),
			(rule->Action == PF_Action_DROP ? MACFiler_L2[locale_config.locale]: MACFiler_L1[locale_config.locale]),
			(rule->Log == PF_Log_NO ? MACFiler_L3[locale_config.locale] : MACFiler_L4[locale_config.locale]),
			MacAddress[0]			
			);
		}// end if
	}
	return nBytes;
}

// macf.asp
static enum ClickOption MF_Func = Click_Func_CENCEL;
static int MF_Edit_Index = 0;

static void formMF(webs_t wp, char_t *path, char_t *query)
{
	//enum PFOption Func = CENCEL;
	char_t *fwFUNC, *Idx, *DefaultPolicy;
	//FILE   *fp;

	DefaultPolicy = websGetVar(wp, T("MACdfRule"),"");
	MF_MACdfRule = atoi(DefaultPolicy);
	fwFUNC = websGetVar(wp, T("fwFUNC"), "");
	MF_Func = atoi(fwFUNC);
	Idx = websGetVar(wp, T("Idx"), "");
	MF_Edit_Index = atoi(Idx);
	--MF_Edit_Index;
	#if 0
	websHeader(wp);
	//pstr = websExpand(wp, NULL, "$COMPANY $SERVER_PORT $CONTENT_LENGTH $PATH_INFO", -1);
	//websWrite(wp, T("<body><h2>fwFUNC: %s %d, Idx: %s</h2>\n"), fwFUNC, Func, Idx);
	//websWrite(wp, T("PATH_INFO=%s\n"), gogetenv("PATH_INFO"));
	//websResponse(wp, 302, msgbuf, url);
	websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf1.asp\");</script>"));
	websFooter(wp);
	websDone(wp, 200);
	#else
	websHeader(wp);
	switch(MF_Func)
	{
		case Click_Func_ADD:
		//websWrite(wp, T("<body><h2>ADD: %d, Idx: %s</h2>\n"), Func, Idx);
// Mulder modified 2005-5-24 
//		if(MF_TableShow.NextItem < MAX_RULE)
		if(MF_TableShow.NextItem < MAX_CLIENT_MACFILTER_ENTRY)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_EDIT:
		//websWrite(wp, T("<body><h2>EDIT: %d, Idx: %s</h2>\n"),Func, Idx);
		if(MF_Edit_Index >= 0)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else// no select an item
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		//websRedirect(wp, "/macf.asp");
		break;
		case Click_Func_DEL:
		//websWrite(wp, T("<body><h2>DEL:  %d, Idx: %s</h2>\n"),MF_Func, Idx);
		//websFooter(wp);
		//websDone(wp, 200);
		if(MF_Edit_Index >= 0)
		{
			MF_DelRule(&MF_TableShow, MF_Edit_Index);
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_APPLY:
		{
			char 	funcNum[4];
			char str_wanip[20];
			char buf1[64];
			/* KenWang added 2005/06/24 -- begin -- */
			//int fac_pid = 0; 
			//FILE *fp;
			/* KenWang added 2005/06/24 -- end -- */


			/* KenWang modified 2005/06/24 -- begin -- */
   			//clean all wireless macfilter rule 20050504 bu Julian
			//run_task("iwsta","iwsta","wlan0","macfilter","0",NULL);
			//unlink("/var/tmp/wireless_macfiler_list");

			sprintf(funcNum,"%d",FUNCTION_NUM_MAC_FILTER);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
			SetMFTableToConfig(&MF_TableShow);
			MF_CopyTable(&MF_Table, &MF_TableShow);
			/* if there are no active rules and the default rule is DROP, */
			/* then do nothing and del scripts; otherwise, create script */
			/* which at least accept clients access router GUI */
			/*
			if(mfilterIfAnyRulesActive(&MF_Table))
			{
				CreateMFTableToScript(&MF_Table);
				strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
				if(isValidIP(str_wanip))
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
				//else running when wan_ip ready.
			}
			*/
			if(!mfilterIfAnyRulesActive(&MF_Table) && MF_MACdfRule == 1)
			{
				
				unlink(MAC_FILTER_CONF_RULE_ADD);
				unlink(MAC_FILTER_CONF_RULE_DEL);
			}
			else
			{
				CreateMFTableToScript(&MF_Table);
			     /*	strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
				if(isValidIP(str_wanip)) */
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			}
			/* notify factoryreset to update iptable for wireless client */
			/*
			if((fp = fopen("/var/state/factoryreset.pid", "r")) != NULL)
			{
				fscanf(fp, "%d", &fac_pid);
				kill(fac_pid, SIGUSR2);
				fclose(fp);
			}
			*/
			/* KenWang modified 2005/06/24 -- end -- */
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
		}
				
		websFooter(wp);
		websDone(wp, 200);
		break;

		case Click_Func_CENCEL:
		MF_CopyTable(&MF_TableShow, &MF_Table);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
		default:
			websRedirect(wp, T("macf.asp"));
	}
	#endif
}

// for macf1.asp
// macf1, rule number
static int aspMF1_fwNow(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(MF_Func)
	{
		case Click_Func_ADD:
			return websWrite(wp, T("%d"), MF_TableShow.NextItem);
		case Click_Func_EDIT:
			return websWrite(wp, T("%d"), MF_Edit_Index);
		default:
			return websWrite(wp, T("%d"), MF_TableShow.NextItem);
	}
}
static int aspMF1_fwNow2(void)
{
	switch(MF_Func)
	{
		case Click_Func_EDIT:
		return MF_Edit_Index;
		default:
		return MF_TableShow.TotalNum-1;
	}
}
////// for macf1.asp table format
static int aspMF1_Page(int eid, webs_t wp, int argc, char_t **argv)
{
char_t *mf1_TableFmt1 =
"<TR><TD colSpan=2>%s %d</TD></TR>\n";
char_t *mf1_TableFmt2 =
"\t<TR>\n"
"\t\t<TD class=title width=100>%s</TD>\n"
"\t\t<TD class=title1 width=300>\n"
"\t\t\t<SELECT name=fltrRE>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt3 =
"\t<TR>\n"
"\t\t<TD class=title>%s</TD>\n"
"\t\t<TD class=title1>\n"
"\t\t\t<SELECT name=fltrFD>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt3_1 =
"\t<TR>\n"
"\t\t<TD class=title width=100>%s</TD>\n"
"\t\t<TD class=title1 width=300>\n"
"\t\t\t<SELECT name=fltrLE>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt4 =
"\t<TR>\n"
"\t\t<TD class=title>%s</TD>\n"
"\t\t<TD class=title1>\n"
"\t\t\t<INPUT type=text name=fltrMacAddressFrom maxlength=17 size=17 value=%s><A HREF='javascript:maclist()'> %s <img align=middle vspace=0 hspace=0 border=0 hspace=0 vspace=0 src=link1.gif></a>\n"
"\t\t</TD>\n"
"\t</TR>\n";

//const int FlowNum=2; char *FlowRadio[]={"Out", "In"};
const int ActiveNum=2, ActiveDefault=1; 
char_t *ActiveList[]={MACFiler_L3[locale_config.locale] , MACFiler_L4[locale_config.locale]};
const int ActionNum=2/*, ActionDefault=0*/; 
char_t *ActionList[]={MACFiler_L2[locale_config.locale], MACFiler_L1[locale_config.locale]};
const int LogNum=2, LogDefault=1; 
char_t *LogList[]={MACFiler_L3[locale_config.locale] , MACFiler_L4[locale_config.locale]};
char_t *MacAddress;
	MF_RULE_T *rule;

	switch(MF_Func)
	{
		case Click_Func_ADD:
			websWrite(wp, T(mf1_TableFmt1), MACFiler_L5[locale_config.locale], MF_TableShow.NextItem+1);
			websWrite(wp, T(mf1_TableFmt2), MACFiler_L6[locale_config.locale], SelectListOption(ActiveList, ActiveNum, ActiveDefault));
			websWrite(wp, T(mf1_TableFmt3), MACFiler_L7[locale_config.locale], SelectListOption(ActionList, ActionNum, MF_MACdfRule-1));
			websWrite(wp, T(mf1_TableFmt3_1), MACFiler_L8[locale_config.locale], SelectListOption(LogList, LogNum, LogDefault));
			websWrite(wp, T(mf1_TableFmt4), MACFiler_L9[locale_config.locale], "",MACFiler_L11[locale_config.locale]);
			break;
		case Click_Func_EDIT:
		rule=&MF_TableShow.Rule[MF_Edit_Index];
			websWrite(wp, T(mf1_TableFmt1), MACFiler_L5[locale_config.locale], MF_Edit_Index+1);
			websWrite(wp, T(mf1_TableFmt2), MACFiler_L6[locale_config.locale], SelectListOption(ActiveList, ActiveNum, rule->Active));
			websWrite(wp, T(mf1_TableFmt3), MACFiler_L7[locale_config.locale], SelectListOption(ActionList, ActionNum, rule->Action));
			websWrite(wp, T(mf1_TableFmt3_1), MACFiler_L8[locale_config.locale], SelectListOption(LogList, LogNum, rule->Log));
				MacAddress = rule->MAC_Filter_Address;
			websWrite(wp, T(mf1_TableFmt4), MACFiler_L9[locale_config.locale], MacAddress,MACFiler_L11[locale_config.locale]);
			break;
		default:
		
		break;
	}
	return 0;
}


// for form maf1.asp
static void formMF1(webs_t wp, char_t *path, char_t *query)
{
	char_t *mfwNow, *mfltrRE, *mfltrFD,*mfltrLE;
	char_t *mfltrMacAddressFrom;
	char_t *mfwFUNC;

	MF_RULE_T rule;
	memset(&rule, 0, sizeof(MF_RULE_T));

	mfwFUNC = websGetVar(wp, T("fwFUNC"), "0");
	// 0, Rule number
	mfwNow = websGetVar(wp, T("fwNow"), "0");
	// 1, Active
	mfltrRE = websGetVar(wp, T("fltrRE"), "0");
	// 4, Action
	mfltrFD = websGetVar(wp, T("fltrFD"), "0");
	mfltrLE = websGetVar(wp, T("fltrLE"), "0");
	// 5, Source Ip Start
	mfltrMacAddressFrom = websGetVar(wp, T("fltrMacAddressFrom"), "0");
	

	rule.Item = atoi(mfwNow)+1; //0
	rule.Active = atoi(mfltrRE)-1;//1
	rule.Action = atoi(mfltrFD)-1;//4
	rule.Log = atoi(mfltrLE)-1;//
	strcpy(rule.MAC_Filter_Address,mfltrMacAddressFrom);
	
	
	//DPRINTF("rule.MAC_Filter_Address:%s\n",rule.MAC_Filter_Address);
	//DPRINTF("rule.Log=%d\n", rule.Log);
	
	websHeader(wp);
	
	if ( atoi(mfwFUNC) == 6 )
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf1.asp\");</script>"));
	else {
		switch(MF_Func)	{
			case Click_Func_ADD:
				MF_AddRule(&MF_TableShow, &rule);
				break;
			case Click_Func_EDIT:
				MF_SetRule(&MF_TableShow, &rule, rule.Item-1);
				break;
			default:
			break;
		}
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/macf.asp\");</script>"));
	}

	websFooter(wp);
	websDone(wp, 200);

}// end formMF1








/********************************************************************
  *   Following is for Mac Address filter
 ************************************************************************/
// copy Config to MF_Table
static int GetConfigToMFTable(MF_TABLE_T *table)
{
	int i;
	MF_RULE_T rule;
	FILE *fp;

	fp = fopen("/flash/mf_conf.conf", "r");
	if (!fp) {
		return -1;
	}
	fscanf(fp,"|%d|\n",&MF_MACdfRule);
	for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
		//   1       2      3    4
		// |active|action|Log|MAC_Filter_Address|
		if (fscanf(fp,
			"|%d|%d|%d|%17s",
			(int *)&rule.Active, //1
			(int *)&rule.Action, //2
			(int *)&rule.Log, //3
			rule.MAC_Filter_Address//4
			) < 0 )  break;
		rule.Item = i+1; //0
		MF_AddRule(table, &rule);
		fgetc(fp);
	}
	fclose(fp);
	return 0;
}// end GetScriptToMFTable

// SetMFTableToConfig
static int SetMFTableToConfig(MF_TABLE_T *table)
{
	int i;
	MF_RULE_T *rule;
	FILE *fp;

	fp = fopen("/flash/mf_conf.conf", "w");
	if (!fp) {
		return -1;
	}
	fprintf(fp,"|%d|\n",MF_MACdfRule);

	for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
		rule = &(table->Rule[i]);
		if( rule->Item != 0 ) {
			//   1       2      3    4
			// |active|action|Log|MAC_Filter_Address|
			fprintf(fp,
				"|%d|%d|%d|%s\n",
				rule->Active, //1
				rule->Action, //2
				rule->Log, //3
				rule->MAC_Filter_Address//4
				);
		}
	}

	fclose(fp);
	
	return 0;
}// end SetMFTableToScript


static int CreateMFTableToScript(MF_TABLE_T *table)
{
	int i;//,k=0;,flag=0;
	MF_RULE_T *rule;
	FILE *fp,*fp2,*fp1;
	char str_lanif[10];
	char buf[32];
	//char filename[80];
	char http_port[20]; // KenWang added 2005/06/15

   if ( (fp=fopen(MAC_FILTER_CONF_RULE_ADD, "w")) == NULL )  {
  	    printf( "Can't open file \"%s\"!<br>\n", MAC_FILTER_CONF_RULE_ADD);
  	    return -1;
    }
//	rename(MAC_FILTER_CONF_RULE_DEL, MAC_FILTER_CONF_RULE_DEL_OLD); // keep the old del scripts.
   if ( (fp2=fopen(MAC_FILTER_CONF_RULE_DEL, "w")) == NULL )  {
  	    printf( "Can't open file \"%s\"!<br>\n", MAC_FILTER_CONF_RULE_DEL);
  	    return -1;
    }
   fprintf(fp, "#!/bin/sh\n");
   fprintf(fp2, "#!/bin/sh\n");
   fprintf(fp2, "# mac filter #\n");
   fprintf(fp2, ". /var/etc/status\n");
   fprintf(fp2, "iptables -D FORWARD -j MF_FWD\n");
   fprintf(fp2, "iptables -D INPUT -j MF_INT\n");
   fprintf(fp2, "iptables -F MF_FWD\n");
   fprintf(fp2, "iptables -X MF_FWD\n");
   fprintf(fp2, "iptables -F MF_INT\n");
   fprintf(fp2, "iptables -X MF_INT\n");

   fprintf(fp, ". /var/etc/status\n");
   fprintf(fp, "iptables -N MF_FWD\n");
   fprintf(fp, "iptables -N MF_INT\n");
   fprintf(fp, "iptables -I FORWARD -j MF_FWD\n");
   fprintf(fp, "iptables -I INPUT -j MF_INT\n");

   	// KenWang added 2005/06/15: accept clients access router GUI
   	/* it will not be added to security log, should it? */
	if((fp1 = fopen(EMBEDDED_CONFIG_FILE, "r")) !=NULL)
	{
		fscanf(fp1, "%s ", http_port);
		fclose(fp1);
	}
	//fprintf(fp, "iptables -A MF_FWD -m tcp -p tcp -d $LAN_IP --dport %s -j ACCEPT\n", http_port);
	//fprintf(fp, "iptables -A MF_INT -m tcp -p tcp -d $LAN_IP --dport %s -j ACCEPT\n", http_port);
    
    
    
//   if ( (fp1=fopen("/var/tmp/wireless_macfilter_list", "w")) == NULL )  {
//  	    printf( "Can't open file /var/tmp/wireless_macfilter_list !<br>\n");
//  	    return -1;
//	}
   for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
     rule = &(table->Rule[i]);
     if( rule->Item != 0 ) {
      // flag=1;
       if( rule->Active == PF_Act_YES ) {
	 char action[10]="ACCEPT";
	 if(rule->Action==PF_Action_DROP)
	   strcpy(action,"DROP");
	 //	DPRINTF("mcf log=%d pfvalue=%d\n",rule->Log, PF_Log_YES);
	 if(rule->Log==PF_Log_YES)
	   {
	     fprintf(fp, "iptables -A MF_FWD -m mac --mac-source %s -j LOG --log-level 7 --log-prefix \"MacFilter:%s;\"\n",
		     rule->MAC_Filter_Address,action);
	     //	     fprintf(fp2, "iptables -D FORWARD -m mac --mac-source %s -j LOG --log-level 7 --log-prefix \"MacFilter:%s;\"\n",
	     //		     rule->MAC_Filter_Address,action);
	     fprintf(fp, "iptables -A MF_INT -m mac --mac-source %s -j LOG --log-level 7 --log-prefix \"MacFilter:%s;\"\n",
		     rule->MAC_Filter_Address,action);
	     //	     fprintf(fp2, "iptables -D INPUT -m mac --mac-source %s -j LOG --log-level 7 --log-prefix \"MacFilter:%s;\"\n",
	     //		     rule->MAC_Filter_Address,action);
	   }

	   //Julian add wireless mac filter 20050430
#if 0 // KenWang marked 2005/06/06: do it in wireless_macfilter.c
			if(MF_MACdfRule-1) { //default is Drop
				if (!strcmp(action,"ACCEPT")){
					//DPRINTF("Accpet MAC:%s\n",rule->MAC_Filter_Address);
					fprintf(fp1,"%s\n",rule->MAC_Filter_Address);
					k++;
				}
			}
			if(MF_MACdfRule==1) { //default is forward
				if (!strcmp(action,"DROP")){
					//DPRINTF("DROP MAC:%s\n",rule->MAC_Filter_Address);
					fprintf(fp1,"%s\n",rule->MAC_Filter_Address);
					k++;
				}
			}
#endif
	 fprintf(fp, "iptables -A MF_FWD -m mac --mac-source %s  -j %s\n", rule->MAC_Filter_Address,action);
	 //	 fprintf(fp2, "iptables -D FORWARD -m mac --mac-source %s  -j %s\n", rule->MAC_Filter_Address,action);
	 fprintf(fp, "iptables -A MF_INT -m mac --mac-source %s  -j %s\n", rule->MAC_Filter_Address,action);
	 //	 fprintf(fp2, "iptables -D INPUT -m mac --mac-source %s  -j %s\n",rule->MAC_Filter_Address,action);
       }// end if active == yes
     }// rule != 0
   }// end for loop

//   fclose(fp1);

// default rule setting to drop
//	DPRINTF("MF_MACdfRule:%d\n",MF_MACdfRule);
	if(MF_MACdfRule-1)
	{
	//fprintf(fp, "iptables -A MF_FWD -i eth0  -j DROP\n");
	strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf));
	// Julian add bellow 20050430
	//Should we limit lan mac filter?  It's drop all interface included wan.
	//Answer: if we drop all mac from wan, the packet from wan will not forward to system,so we only drop the mac from lan.	
		fprintf(fp, "iptables -A MF_FWD -i %s -j DROP\n",str_lanif);
	
//		Drop lan PC access Router web GUI 20050506
		fprintf(fp, "iptables -A MF_INT -i %s -j DROP\n",str_lanif);

		/* KenWang markded 2005/06/06
		if(k>0)
		run_task("iwsta","iwsta","wlan0","macfilter","1",NULL);
		*/
	}

// default rule setting to forward
	/* KenWang marked 2005/06/06
	if(MF_MACdfRule==1)
	{
		if(k>0)
		run_task("iwsta","iwsta","wlan0","macfilter","2",NULL);
	}
	*/
   fclose(fp);
   fclose(fp2);

   chmod(MAC_FILTER_CONF_RULE_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
   chmod(MAC_FILTER_CONF_RULE_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;

   return 0;
}
// KenWang added 2005/06/06
static int get_maclist(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *f, *fp2, *fp3;
	char_t line[255];
	char_t buffer[30];
	int i = 0/*, j = 0, k = 0*/;
//	MF_RULE_T *rule;
	unsigned char match = 0;
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("iwsta","iwsta","ra0","stalist",NULL);
#else
	run_task("iwsta","iwsta","wlan0","stalist",NULL);
#endif	
	fp2 = fopen("/var/tmp/mac_list", "r");

	if((f=fopen(SYS_ARP_CONF,"r"))!=0){
		fgets(line, 1024, f);
		for(i=0;i<MAX_ARP;i++){	
			if(fgets(line, 1024, f)){
			sscanf(line,"%s %s %s %s %s %s\n",
				arp_config[i].IP,
				arp_config[i].HW_Type,
				arp_config[i].Flags,
				arp_config[i].HW_Address,
				arp_config[i].Mask,
				arp_config[i].Device);
				drop_newline(arp_config[i].IP);
				drop_newline(arp_config[i].HW_Address);
				
				/* if the mac belongs to wireless, do not show it */
				if(fp2)
				{
					rewind(fp2);
					match = 0;
					while(fgets(buffer, 30, fp2))
					{
						if(strstr(buffer, arp_config[i].HW_Address))
						{
							match = 1;
							break;
						}
					}
					if((fp3 = fopen("/var/tmp/wireless_macfilt_list", "r")) != NULL)
					{
						while(fgets(buffer, 30, fp3))
						{
							if(strstr(buffer, arp_config[i].HW_Address))
							{
								match = 1;
								break;
							}
						}
					}
					if(match)
						continue;
				}

				/* if the mac is not in LAN, do not show it */
				read_file_para_value(VAR_SYS_STATUS_FILE, "LAN_IF=", buffer);
				if(strcmp(arp_config[i].Device, buffer) != 0)
					continue;
#if 0 // Mulder marked 2005-6-30 
				/* if the mac is already in the filter list, do not show it */
				match = 0;
				for(j = 0; j < MF_TableShow.TotalNum; j++)
				{
					rule = &MF_TableShow.Rule[j];
					if(rule->Item != 0)
					{
						if(!strcmp(arp_config[i].HW_Address, rule->MAC_Filter_Address))
						{
							match = 1;
							break;
						}
					}
				}
				if(match)
					continue;
#endif				
//				k++;
//				if(k == 1)
					websWrite(wp, T("<tr><td><nobr><input type='radio' name='mac' value='%s' onClick=returnIP(this.value)>%s</nobr></td><td>%s</td></td>\n"),
							arp_config[i].HW_Address,
							arp_config[i].HW_Address,
							arp_config[i].IP);
//				else
//					websWrite(wp, T("<tr><td><nobr><input type='radio' name='mac' value=%s>%s</nobr></td><td>%s</td></tr>\n"),
//							arp_config[i].HW_Address,
//							arp_config[i].HW_Address,
//							arp_config[i].IP);
			}
		}
		fclose(f);
	}
	if(fp2)	fclose(fp2);
	return 1;
}

