/*
 *  misc.htm: Misc Configuration
 */
#include "webs.h"
#include "misc.h"
//#include "upnp.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"
#include "../net-snmp-5.1.2/include/net-snmp/net-snmp-config1.h"
extern void run_task(char *cmd, ...);
#define ETC_SYS_STATUS_FILE "/etc/default/config"
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
extern int checked_function_enabled (char *parameter, webs_t wp, char_t **argv);
extern void flash_write();
//#ifdef _DPRINTF_
#if 1
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
	
#define JP(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,"\n--\ntest:%d\n--\n",args); \
	fclose(TTYS0) 
#else
#define DPRINTF(args...)  
#endif /* _DPRINTF_ */
/*************************************************/
/*    Misc_Config Files                          */
/*************************************************/

static SNMP_DESC_DATA snmp_desc;

/************************************************/

static void resetCurrentTmssCfg(void);
static void resetCurrentEmbeddedCfg(void);
static void Load_Embedded_Config();
static void Save_Embedded_Config(EMBEDDED_CONFIG_DATA *d);
static void Save_Tmss_Config (TMSS_CONFIG_DATA *d);
static int Load_Misc_Config();
static void Load_TMSS_Config ();
static int get_misc_mod(int eid,webs_t wp,int argc,char_t **argv);
static int get_misc_status(int eid,webs_t wp,int argc,char_t **argv);
static void Misc_Form(webs_t wp,char_t * path,char_t * query);

static void Snmpd_DESC_To_Conf();
static void Snmpd_DESC_Save();
static void Snmpd_DESC_Load();
extern void drop_newline(char *str);
static int get_misc_status(int eid,webs_t wp,int argc,char_t **argv)
{
	if (strcmp(argv[0],"HttpPort")==0)
        {
	        Load_Misc_Config();
 	        websWrite(wp, T("%s"),embedded_config.Http_Port);
	}
	if (strcmp(argv[0],"IP")==0)
        {
 	        websWrite(wp, T("%s"),embedded_config.IP);
	}
	if (strcmp(argv[0],"logouttime")==0)
        {
 	        websWrite(wp, T("%s"),embedded_config.logouttime);
	}
	
	if (strcmp(argv[0],"upnpport")==0)
        {
 	        websWrite(wp, T("%d"), upnp1_config.upnpport);
	}

	// SNMP start
	// struct snmp_desc
	//v1,v2
	if (strcmp(argv[0],"SNMPRCOMM")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.rcomm);
	}
	if (strcmp(argv[0],"SNMPRIP")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.rip);
	}
	if (strcmp(argv[0],"SNMPWCOMM")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.wcomm);
	}
	if (strcmp(argv[0],"SNMPWIP")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.wip);
	}
	if (strcmp(argv[0],"SNMPTCOMM")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.tcomm);
	}
	if (strcmp(argv[0],"SNMPTIP")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.tip);
	}
	//SNMP v3
	if (strcmp(argv[0],"SNMPv3USER")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.v3user);
	}
	if (strcmp(argv[0],"SNMPv3PASS")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.v3pass);
	}
	if (strcmp(argv[0],"SNMPv3IP")==0)
        {
 	        websWrite(wp, T("%s"), snmp_desc.v3accessIP);
	}
	// SNMP end
	
	return 1;
}

static int get_misc_mod(int eid,webs_t wp,int argc,char_t **argv)
{
	int i=0,j;
        Load_Misc_Config();
	j=atoi(argv[1]);
        if (strcmp(argv[0],"upnp")==0)
	        i=upnp1_config.enable;
        if (strcmp(argv[0],"telnet")==0)
	        i=telnet_config.enable;
        if (strcmp(argv[0],"tmss")==0)
	        i=tmss_config.enable;
        if (strcmp(argv[0],"snmp")==0)
	        i=snmp_desc.enable;
	if (strcmp(argv[0],"v3access")==0)
		i=snmp_desc.v3accessRW;
        if (i==j)
	        return websWrite(wp, T("%s"),argv[2]);
	else
	        return websWrite(wp, T(""));
}

static void resetCurrentEmbeddedCfg(void)
{
        EMBEDDED_CONFIG_DATA *d = &embedded_config;
	memset(d,0,sizeof(EMBEDDED_CONFIG_DATA));
}
static void resetCurrentTmssCfg(void)
{
        TMSS_CONFIG_DATA *d = &tmss_config;
	memset(d,0,sizeof(TMSS_CONFIG_DATA));
}
static void resetCurrentUpnp1Cfg(void)
{
        UPNP1_CONFIG_DATA *d = &upnp1_config;
        d->enable=0;
        d->upnpport=2800;
	//strcpy(d->Remote,"");
        //strcpy(d->Http_Port,"");
}

static void Load_Embedded_Config ()
{
	FILE *fp;
	
	resetCurrentEmbeddedCfg();

	if((fp=fopen(EMBEDDED_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%s %s %s\n",embedded_config.Http_Port, embedded_config.IP,embedded_config.logouttime); 
	//DPRINTF("Load Remote Config: Port %d\n",embedded_config.Http_Port);
	fclose(fp);
	}
}

static void Load_Upnp1_Config ()
{
	FILE *fp;
	
	resetCurrentUpnp1Cfg();

	if((fp=fopen(UPNP1_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%d %d\n",&upnp1_config.enable, &upnp1_config.upnpport); 
	//DPRINTF("Load Remote Config:Remote %d Port %d\n",remotecontrol_config.Remote, remotecontrol_config.Http_Port);
	fclose(fp);
	}
}
static void resetCurrentTelnetCfg(void)
{
        TELNET_CONFIG_DATA *d = &telnet_config;
	memset(d,0,sizeof(TELNET_CONFIG_DATA));
}

static void Load_Telnet_Config ()
{
	FILE *fp;
	
	resetCurrentTelnetCfg();

	if((fp=fopen(TELNET_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%d\n",&telnet_config.enable); 
	fclose(fp);
	}
}
static void Save_Telnet_Config (TELNET_CONFIG_DATA *d)
{

	FILE *fp;
	
	if((fp=fopen(TELNET_CONFIG_FILE,"w"))!=NULL){
	fprintf(fp,"%d\n",d->enable);
	fclose(fp);
	}
}
static void Load_TMSS_Config ()
{
	FILE *fp;
	
	resetCurrentTmssCfg();

	if((fp=fopen(TMSS_CONFIG_FILE,"r"))!=NULL){
	fscanf(fp,"%d\n",&tmss_config.enable); 
	fclose(fp);
	}
}
static void Save_Tmss_Config (TMSS_CONFIG_DATA *d)
{

	FILE *fp;
	
	if((fp=fopen(TMSS_CONFIG_FILE,"w"))!=NULL){
	fprintf(fp,"%d\n",d->enable);
	fclose(fp);
	}
	
  	
}
static void Save_Embedded_Config (EMBEDDED_CONFIG_DATA *d)
{

	FILE *fp;
	
	if((fp=fopen(EMBEDDED_CONFIG_FILE,"w"))!=NULL){
	fprintf(fp,"%s %s %s\n",
		d->Http_Port,
		d->IP,
		d->logouttime
		);
	fclose(fp);
	}
	//DPRINTF("Load Remote Config:Remote %d Port %d\n", d->Remote, d->Http_Port);
	
  	
}

static void Save_Upnp1_Config (UPNP1_CONFIG_DATA *d)
{

	FILE *fp;
	//char *argv[2];
	//char *argv1[2];
	//Delete
	//argv[1] = "-D";
	//argv1[1] = "-A";
	//Wan Interface
	//argv[2] = "tnmp0";
	//argv1[2] = "tnmp0";
	
	if((fp=fopen(UPNP1_CONFIG_FILE,"w"))!=NULL){
	fprintf(fp,"%d %d\n",
		d->enable, 
		d->upnpport
		);
	fclose(fp);
	}
	//DPRINTF("Load Remote Config:Remote %d Port %d\n", d->Remote, d->Http_Port);
	
  	
}
static void Init_Misc()
{
 	
    	/*   init upnp_mode */ 
	//upnp_mode=0;
	
  	
}
int Load_Misc_Config()
{

        /*  Load UPnP Config */
	Load_Embedded_Config();
	
	Load_Upnp1_Config();
	Load_TMSS_Config();

        /* Telnet Config */ // fixed telnet setting display error issue 2007/04/23 added begin
	Load_Telnet_Config(); // fixed telnet setting display error issue added end

	/* SNMP */
	Snmpd_DESC_Load();
	Snmpd_DESC_To_Conf();
	

	return 0;
}

static void Misc_Form(webs_t wp, char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char funcNum[4];
	SNMP_DESC_DATA old_snmp_desc;
	EMBEDDED_CONFIG_DATA old_embedded_config;
 	TMSS_CONFIG_DATA old_tmss_config;
 	TELNET_CONFIG_DATA old_telnet_config;
 	char str_is_tmss[32];
	char buf1[32];
      UPNP1_CONFIG_DATA old_upnp1_config;

	
//	strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
	Load_Upnp1_Config();
	memcpy(&old_upnp1_config,&upnp1_config,sizeof(UPNP1_CONFIG_DATA));
	buf=websGetVar(wp, T("UPNPPort"),"");
	upnp1_config.upnpport=atoi(buf);
	buf=websGetVar(wp, T("UPNP"),"");
	upnp1_config.enable=atoi(buf);
	if( (old_upnp1_config.enable!=upnp1_config.enable)||
		(old_upnp1_config.upnpport!=upnp1_config.upnpport) )	
	{
		sprintf(funcNum,"%d",FUNCTION_NUM_UPNP);
//		DPRINTF("upnp:funcNUM:%s\n",funcNum);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
		Save_Upnp1_Config(&upnp1_config);
	
		if (upnp1_config.enable)
		{	
			//DPRINTF("calling runFunc start upnp\n");
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
		}
	}



	//strcpy(remotecontrol_config.Http_Port,buf);
	//if (!strcmp(remotecontrol_config.Remote,"1")) /* Enable remote control */
	
	// SNMP Configuration
	// (read, string)-(ipadd1, ip)
	// (write,string)-(ipadd2, ip)
	// (trap, string)-(ipadd3, ip)
	memcpy(&old_snmp_desc, &snmp_desc, sizeof(snmp_desc));
	memset(&snmp_desc, 0, sizeof(snmp_desc));
	
	buf=websGetVar(wp, T("snmp"),"");
	snmp_desc.enable=atoi(buf);
	buf = websGetVar(wp, T("read"), "");
	strcpy(snmp_desc.rcomm, buf);
	buf = websGetVar(wp, T("ipadd1"), "");
	strcpy(snmp_desc.rip, buf);
	buf = websGetVar(wp, T("write"), "");
	strcpy(snmp_desc.wcomm, buf);
	buf = websGetVar(wp, T("ipadd2"), "");
	strcpy(snmp_desc.wip, buf);
	buf = websGetVar(wp, T("trap"), "");
	strcpy(snmp_desc.tcomm, buf);
	buf = websGetVar(wp, T("ipadd3"), "");
	strcpy(snmp_desc.tip, buf);

	// SNMP v3
	// (v3user, string)-(v3pass, string)
	// ((v3access, 0),(v3access, 1))
	// (v3ip, ip)
	buf = websGetVar(wp, T("v3user"), "");
	strcpy(snmp_desc.v3user, buf);
	buf = websGetVar(wp, T("v3pass"), "");
	strcpy(snmp_desc.v3pass, buf);
	buf = websGetVar(wp, T("v3access"), "");
	snmp_desc.v3accessRW=atoi(buf); // 0:read, 1:read/write
	buf = websGetVar(wp, T("v3ip"), "");
	strcpy(snmp_desc.v3accessIP, buf);

	sprintf(funcNum,"%d",FUNCTION_NUM_SNMP);
	//run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	Snmpd_DESC_Save();
	Snmpd_DESC_To_Conf();

	if(memcmp(&old_snmp_desc, &snmp_desc, sizeof(snmp_desc))) {
	//	DPRINTF("run snmpd 1\n");
		if (old_snmp_desc.enable)
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	//	DPRINTF("run snmpd 2\n");
		//if ((isValidIP(str_wanip)) && (snmp_desc.enable==1))
		if (snmp_desc.enable==1) {
	//		DPRINTF("run snmpd 3\n");
			// snmp need no valid WAN IP to start up.
			// runFunc will run /etc/scripts/snmp_ipt.add and /etc/scripts/snmp_ipt.del
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
		}
	}
	// End SNMP

	//webserver must execute last ,upnp and snmp will work. 
 	Load_Embedded_Config();
	memcpy(&old_embedded_config,&embedded_config,sizeof(EMBEDDED_CONFIG_DATA));
	buf=websGetVar(wp, T("HttpPort"),"");
	strcpy(embedded_config.Http_Port,buf);
	buf=websGetVar(wp, T("IP"),"");
	strcpy(embedded_config.IP,buf);
	buf=websGetVar(wp, T("logouttime"),"");
	strcpy(embedded_config.logouttime,buf);


 	Load_TMSS_Config();
	memcpy(&old_tmss_config,&tmss_config,sizeof(TMSS_CONFIG_DATA));
	buf=websGetVar(wp, T("TMSS"),"");
	tmss_config.enable=atoi(buf);
	
	strcpy(str_is_tmss,(char *)read_file_para_value("/etc/default/config","TMSS=",buf1));
	if((old_tmss_config.enable!=tmss_config.enable&&!strcmp(str_is_tmss,"yes"))){
		Save_Tmss_Config(&tmss_config);
		if (tmss_config.enable==1){
			save_globe_config("/flash/config","TMSS=","yes");
		}
		if (tmss_config.enable==0){
			save_globe_config("/flash/config","TMSS=","no");
		}
		
		//change TMSS need to reboot
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}

 	Load_Telnet_Config();
	memcpy(&old_telnet_config,&telnet_config,sizeof(TELNET_CONFIG_DATA));
	buf=websGetVar(wp, T("Telnet"),"");
	telnet_config.enable=atoi(buf);
	
	if(old_telnet_config.enable!=telnet_config.enable){
		Save_Telnet_Config(&telnet_config);
		sprintf(funcNum,"%d",FUNCTION_NUM_TELNET_CONFIG);
		DPRINTF("RUNNING FUNCTION_NUM_TELNET_CONFIG\n");
		if(telnet_config.enable)
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
		else
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	}
	
	if((strcmp(old_embedded_config.Http_Port,embedded_config.Http_Port)) ||
	(strcmp(old_embedded_config.IP,embedded_config.IP)) ||
	(strcmp(old_embedded_config.logouttime,embedded_config.logouttime)) )
	{
		
		Save_Embedded_Config(&embedded_config);
		if(strcmp(old_embedded_config.Http_Port,embedded_config.Http_Port))
		{
			sprintf(funcNum,"%d",FUNCTION_NUM_REMOTE_CONFIG);
			DPRINTF("RUNNING FUNCTION_NUM_REMOTE_CONFIG\n");
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);// Shall always enabled
		}
		run_script(EMBEDDED_SCRIPT_FILE,old_embedded_config.Http_Port,embedded_config.Http_Port,0);
//		sprintf(funcNum,"%d",FUNCTION_NUM_EMBEDED_WEB_SERVER);
//		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);// Shall always enabled
	}

	
	websRedirect(wp,T("misc.asp"));
}

// argv[0]=0 then return string = "<!--"
// argv[0]!=0 then return string = "-->"
static int is_snmpd_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("SNMPD=",wp,argv);
}

// argv[0]=0 then return string = "<!--"
// argv[0]!=0 then return string = "-->"
static int is_full_ver (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("Full_Ver=",wp,argv);
}
int TC_WD=0;
void Load_TCWD_Config (void)
{
	FILE *fp;
	fp=fopen("/flash/tcwd.conf","r");
	if(fp) {
		fscanf(fp,"%d\n",&TC_WD);
		fclose(fp);
	}
}
void Save_TCWD_Config (int tc_wd)
{
	FILE *fp;
	fp=fopen("/flash/tcwd.conf","w");
	if(fp) {
		fprintf(fp,"%d\n",tc_wd);
		fclose(fp);
	}
}

static void TC_Watchdog_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	Load_TCWD_Config();
	buf = websGetVar(wp, T("tcwd"),"0");
	TC_WD=atoi(buf);
	
	Save_TCWD_Config(TC_WD);
	flash_write();
	websRedirect(wp, T("rbnosv_apply.asp"));
}
static int get_tcwd (int ejid, webs_t wp, int argc, char_t **argv)
{
	Load_TCWD_Config();
	if(TC_WD)
		return websWrite(wp, T("%s"),"checked");
	else
		return websWrite(wp, T(""));
}

int iptv=0;
void Load_iptv_Config (void)
{
	FILE *fp;
	fp=fopen("/flash/iptv.conf","r");
	if(fp) {
		fscanf(fp,"%d\n",&iptv);
		fclose(fp);
	}
}
void Save_iptv_Config (int iptv)
{
	FILE *fp;
	fp=fopen("/flash/iptv.conf","w");
	if(fp) {
		fprintf(fp,"%d\n",iptv);
		fclose(fp);
	}
}

static void iptv_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	Load_iptv_Config();
	buf = websGetVar(wp, T("tc_nr"),"0");
	iptv=atoi(buf);
	
	Save_iptv_Config(iptv);
	flash_write();
	websRedirect(wp, T("rbnosv_apply.asp"));
}
static int get_tc_nr (int ejid, webs_t wp, int argc, char_t **argv)
{
	int j=atoi(argv[0]);
	Load_iptv_Config();
	
	if(j==iptv)
		return websWrite(wp, T("selected"));
	else
		return websWrite(wp, T(""));
}
#define TCP_LARGE_PORT 0
#define MAX_IP_CONNECTION 1
#define MAX_UDP_CONNECTION 2
#define MAX_TCP_LARGE_PORT_CONNECTION 3
#define CURRENT_IP_CONNECTION 4
#define CURRENT_UDP_CONNECTION 5
#define CURRENT_TCP_LARGE_CONNECTION 6
#define CURRENT_TCP_SMALL_CONNECTION 7
#define TCP_LARGE_PORT_TIME 8
#define IGNORE_WLAN_WHEN_ADSL_SYNC 9

static int get_internal_control(int eid,webs_t wp,int argc,char_t **argv)
{
	FILE *fp=NULL;
	char line[64],file_str[64],str_data[64];
	int index=atoi(argv[0]);
	switch(index)
	{
#if 0
		case TCP_LARGE_PORT:
		strcpy(file_str,"/proc/net/tcp_large_port");
		break;
#endif
		case MAX_IP_CONNECTION:
		strcpy(file_str,"/proc/net/max_ip_ct");
		break;
		case MAX_UDP_CONNECTION:
		strcpy(file_str,"/proc/net/max_udp_ct");
		break;
		case MAX_TCP_LARGE_PORT_CONNECTION:
		strcpy(file_str,"/proc/net/max_tcp_large_port_ct");
		break;
		case CURRENT_IP_CONNECTION:
		strcpy(file_str,"/proc/net/ip_ct_count");
		break;
		case CURRENT_UDP_CONNECTION:
		strcpy(file_str,"/proc/net/udp_ct_count");
		break;
		case CURRENT_TCP_LARGE_CONNECTION:
		strcpy(file_str,"/proc/net/tcp_large_port_ct_count");
		break;
		case CURRENT_TCP_SMALL_CONNECTION:
		strcpy(file_str,"/proc/net/tcp_small_port_ct_count");
		break;
		case TCP_LARGE_PORT_TIME:
		strcpy(file_str,"/proc/net/tcp_large_port_timeout");
		break;
		case IGNORE_WLAN_WHEN_ADSL_SYNC:
#ifdef _RALINK_WIRELESS_DRIVER_
		strcpy(file_str,"/proc/rt61ap/ignore_int");
		break;
#else
		websWrite(wp, T("0"));
		return 1;
#endif
		case 10:
#ifdef _RALINK_WIRELESS_DRIVER_
		websWrite(wp, T(""));
#else
		websWrite(wp, T("disabled"));
#endif
		return 1;
	}
	if((fp=fopen(file_str,"r"))!=NULL){
		if(fgets(line,64,fp)){
			sscanf(line,"%s",str_data);
		}
		else
			strcpy(str_data,"0");
		fclose(fp);
	}
	websWrite(wp, T("%s"),str_data);	
	return 1;
}

static void internal_control_Form(webs_t wp,char_t * path,char_t * query)
{
	FILE *fp;
	char_t *buf1;
#ifdef _RALINK_WIRELESS_DRIVER_
	char_t *buf2;
	buf2 = websGetVar(wp, T("ignore_wlan"),"0");
#endif
	buf1 = websGetVar(wp, T("timeout"),"0");
	fp=fopen("/flash/ic.conf","w");
	if(fp) {
#ifdef _RALINK_WIRELESS_DRIVER_
		fprintf(fp,"%s %s\n",buf1,buf2);
#else
		fprintf(fp,"%s 0\n",buf1);
#endif
		fclose(fp);
	}
	if((fp=fopen("/proc/net/tcp_large_port_timeout","w"))!=NULL)
	{
		fprintf(fp,"%s",buf1);
		fclose(fp);
	}
#ifdef _RALINK_WIRELESS_DRIVER_
	if((fp=fopen("/proc/rt61ap/ignore_int","w"))!=NULL)
	{
		fprintf(fp,"%s",buf2);
		fclose(fp);
	}
#endif
	//flash_write();
	websRedirect(wp, T("ic.asp"));
}

void DefineWebFunctions_misc() {
	Init_Misc();
	Load_Misc_Config();
        //websAspDefine(T("Misc_Config_Load"),Misc_Config_Load);
	//websAspDefine(T("UPnPMode"),appGetUPnPRequest);
	websAspDefine(T("is_full_ver"), is_full_ver);
	websAspDefine(T("get_misc_mod"),get_misc_mod);	
	websAspDefine(T("get_misc_status"),get_misc_status);	
	websFormDefine(T("misc"),Misc_Form);
	websAspDefine(T("get_tcwd"),get_tcwd);	
	websFormDefine(T("tc_wd"),TC_Watchdog_Form);
	websAspDefine(T("get_tc_nr"),get_tc_nr);	
	websFormDefine(T("iptv"),iptv_Form);
	websAspDefine(T("is_snmpd_enabled"), is_snmpd_enabled);
	websAspDefine(T("get_ic"), get_internal_control);
	websFormDefine(T("ic"),internal_control_Form);
}

/* SNMP config */
// the snmp_desc is the global variable
//#define DEBUG_MISC_SNMP
static void Snmpd_DESC_Save()
{
	FILE *fp;
	// Access Control
	// Read Community  	 	IP Address
	// Write Community 		IP Address
	// Trap Community               IP Address
	// snmp DEBUG
#ifdef DEBUG_MISC_SNMP
	//v1,v2
	DPRINTF("save rcomm %s\n", snmp_desc.rcomm);
	DPRINTF("save rip %s\n", snmp_desc.rip);
	DPRINTF("save wcomm %s\n", snmp_desc.wcomm);
	DPRINTF("save wip %s\n", snmp_desc.wip);
	DPRINTF("save tcomm %s\n", snmp_desc.tcomm);
	DPRINTF("save tip %s\n", snmp_desc.tip);
	//v3
	DPRINTF("save v3user %s\n", snmp_desc.v3user);
	DPRINTF("save v3pass %s\n", snmp_desc.v3pass);
	DPRINTF("save v3accessRW %d\n", snmp_desc.v3accessRW);
	DPRINTF("save v3accessIP %s\n", snmp_desc.v3accessIP);
#endif 
	// save to SNMPD_DESC_FN 
	fp=fopen(SNMPD_DESC_FN, "w");
	if(fp!=NULL){
		//v1,v2
		fprintf(fp, "%d\n", snmp_desc.enable);
		fprintf(fp, "%s\n", snmp_desc.rcomm);
		fprintf(fp, "%s\n", snmp_desc.rip);
		fprintf(fp, "%s\n", snmp_desc.wcomm);
		fprintf(fp, "%s\n", snmp_desc.wip);
		fprintf(fp, "%s\n", snmp_desc.tcomm);
		fprintf(fp, "%s\n", snmp_desc.tip);
		//v3
		fprintf(fp, "%s\n", snmp_desc.v3user);
		fprintf(fp, "%s\n", snmp_desc.v3pass);
		fprintf(fp, "%d\n", snmp_desc.v3accessRW);
		fprintf(fp, "%s\n", snmp_desc.v3accessIP);
		fclose(fp);
	}
}


static void Snmpd_DESC_Load()
{
	FILE *fp;

	// load to SNMPD_DESC_FN 
	memset(&snmp_desc, 0, sizeof(snmp_desc));
	fp=fopen(SNMPD_DESC_FN, "r");
	if(fp!=NULL){
		fscanf(fp,"%d\n",&snmp_desc.enable); 
		// v1,v2
		fgets(snmp_desc.rcomm, sizeof(snmp_desc.rcomm), fp);
		drop_newline(snmp_desc.rcomm);
		fgets(snmp_desc.rip, sizeof(snmp_desc.rip), fp);
		drop_newline(snmp_desc.rip);
		fgets(snmp_desc.wcomm, sizeof(snmp_desc.wcomm), fp);
		drop_newline(snmp_desc.wcomm);
		fgets(snmp_desc.wip, sizeof(snmp_desc.wip), fp);
		drop_newline(snmp_desc.wip);
		fgets(snmp_desc.tcomm, sizeof(snmp_desc.tcomm), fp);
		drop_newline(snmp_desc.tcomm);
		fgets(snmp_desc.tip, sizeof(snmp_desc.tip), fp);
		drop_newline(snmp_desc.tip);
		// v3
		fgets(snmp_desc.v3user, sizeof(snmp_desc.v3user), fp);
		drop_newline(snmp_desc.v3user);
		fgets(snmp_desc.v3pass, sizeof(snmp_desc.v3pass), fp);
		drop_newline(snmp_desc.v3pass);
		fscanf(fp, "%d\n", &snmp_desc.v3accessRW);
		fgets(snmp_desc.v3accessIP, sizeof(snmp_desc.v3accessIP), fp);
		drop_newline(snmp_desc.v3accessIP);

		fclose(fp);
	}
#ifdef DEBUG_MISC_SNMP
	//v1,v2
	DPRINTF("load rcomm %s\n", snmp_desc.rcomm);
	DPRINTF("load rip %s\n", snmp_desc.rip);
	DPRINTF("load wcomm %s\n", snmp_desc.wcomm);
	DPRINTF("load wip %s\n", snmp_desc.wip);
	DPRINTF("load tcomm %s\n", snmp_desc.tcomm);
	DPRINTF("load tip %s\n", snmp_desc.tip);
	//v3
	DPRINTF("load v3user %s\n", snmp_desc.v3user);
	DPRINTF("load v3pass %s\n", snmp_desc.v3pass);
	DPRINTF("load v3accessRW %d\n", snmp_desc.v3accessRW);
	DPRINTF("load v3accessIP %s\n", snmp_desc.v3accessIP);
#endif 
}

static void Snmpd_DESC_To_Conf()
{
	FILE *fp;
	char wireless_buf[12], model_name_buf[64];//,snmp_enterprise_old[64];

	fp=fopen(SNMPD_CONF_FN, "w");
	if(fp!=NULL){
		// Access Control
		fprintf(fp, "com2sec %s %s %s\n", 
			snmp_desc.rcomm, snmp_desc.rip, snmp_desc.rcomm);
		fprintf(fp, "com2sec %s %s %s\n",
			snmp_desc.wcomm, snmp_desc.wip, snmp_desc.wcomm);
		fprintf(fp, "group ROGroup v1 %s\n", snmp_desc.rcomm);
		fprintf(fp, "group ROGroup v2c %s\n", snmp_desc.rcomm);
		fprintf(fp, "group ROGroup usm %s\n", snmp_desc.rcomm);
		fprintf(fp, "group RWGroup v1 %s\n", snmp_desc.wcomm);
		fprintf(fp, "group RWGroup v2c %s\n", snmp_desc.wcomm);
		fprintf(fp, "group RWGroup usm %s\n", snmp_desc.wcomm);
		fprintf(fp, "view all included .1 80\n");
		fprintf(fp, "access ROGroup \"\" any noauth exact all none none\n");
		fprintf(fp, "access RWGroup \"\" any noauth exact all all none\n");

		// tarp, tip must be correct if web pages have check it
		// note. please check values are correct because it's unsafe
		if(strlen(snmp_desc.tcomm) && strlen(snmp_desc.tip)){
			fprintf(fp, "trapcommunity %s\n", snmp_desc.tcomm);
			// v1 trap receiver
			fprintf(fp, "trapsink %s\n", snmp_desc.tip);
			// v2 trap receiver
			fprintf(fp, "trap2sink %s\n", snmp_desc.tip);
			// v2 inform receiver
			fprintf(fp, "informsink %s\n", snmp_desc.tip);
			// authtrapenable: Should we send traps when authentication failures occur
			// 1:yes
			// 2:no
			fprintf(fp, "authtrapenable 1\n");
		}

		// v3 pass must be at least 8 characters && username can't empty
		if( strlen(snmp_desc.v3user) && (strlen(snmp_desc.v3pass) >= 8 )) {
			if(snmp_desc.v3accessRW)
				fprintf(fp, "rwuser %s auth\n", snmp_desc.v3user);
			else
				fprintf(fp, "rouser %s auth\n", snmp_desc.v3user);
			fprintf(fp, "createUser %s MD5 \"%s\" \n", snmp_desc.v3user, snmp_desc.v3pass);
		}

		// .1.3.6.1.2.1.1
		strcpy(wireless_buf, read_file_para_value("/var/etc/status","WIRELESS=", wireless_buf));
		if (!strcmp(wireless_buf, "yes")) {
			strcpy(model_name_buf,read_file_para_value("/etc/default/config","MODEL_NAME_G=",model_name_buf));
		} else {
			strcpy(model_name_buf,read_file_para_value("/etc/default/config","MODEL_NAME=", model_name_buf));
		}
		//fprintf(fp, "sysdescr \"7202 ADSL Router\"\n");
		//memset(snmp_enterprise_old,0,sizeof(snmp_enterprise_old)
		//strcpy(snmp_enterprise_old,read_file_para_value("/etc/default/config","SNMP_OID=",snmp_enterprise_old));
		fprintf(fp, "sysdescr \"%s\"\n", model_name_buf);
		fprintf(fp, "sysobjectid %s\n",ENTERPRISE_MIB_STR);
		fprintf(fp, "syscontact  \"\"\n");
		fprintf(fp, "sysname     \"\"\n");
		fprintf(fp, "syslocation \"\"\n");
		fprintf(fp, "sysservices 72\n");

		fclose(fp);
	}
}
