/*
 *  pf.htm: Packet Filter Configuration
 */
#include <sys/wait.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "webs.h"
#include "pf.h"
#include "uemf.h"
#include "pf_conf.h"
#include "filem.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"
#include "locale.h"

extern char *PacketFilter_L1[];
extern char *PacketFilter_L2[];
extern char *PacketFilter_L3[];
extern char *PacketFilter_L4[];
extern char *PacketFilter_L5[];
extern char *PacketFilter_L6[];
extern char *PacketFilter_L7[];
extern char *PacketFilter_L8[];
extern char *PacketFilter_L9[];
extern char *PacketFilter_L10[];
extern char *PacketFilter_L11[];
extern char *PacketFilter_L12[];
extern char *PacketFilter_L13[];
extern char *PacketFilter_L14[];
extern char *PacketFilter_L15[];
extern char *PacketFilter_L16[];
extern char *PacketFilter_L17[];
extern char *PacketFilter_L18[];
extern char *PacketFilter_L19[];
extern char *PacketFilter_L20[];
extern char *PacketFilter_L21[];
extern char *PacketFilter_L22[];
extern char *PacketFilter_L23[];
extern char *PacketFilter_L24[];
extern char *PacketFilter_L25[];
extern char *PacketFilter_L26[];
extern char *PacketFilter_L27[];
extern char *PacketFilter_L28[];
extern char *PacketFilter_L29[];
extern char *URL_L7[];
extern char *URL_L8[];
extern char *URL_L9[];
extern char *URL_L10[];
extern char *URL_L11[];
extern char *URL_L12[];
extern char *URL_L13[];
extern char *URL_L14[];


extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

#define PF_APP_SEL_NUM 24
#define PF_APP_SEL_ANY 0
#define PF_APP_SEL_TCP 1
#define PF_APP_SEL_UDP 2
#define PF_APP_SEL_OUTGOING 0
#define PF_APP_SEL_INCOMING 1
static PF_APP_SEL pf_app_sel[PF_APP_SEL_NUM] = {
	{PF_APP_SEL_ANY,PF_APP_SEL_OUTGOING,"User Defined",0,0},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"HTTP Client (port 80)",80,80},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"HTTP Server (port 80)",80,80},
	{PF_APP_SEL_UDP,PF_APP_SEL_OUTGOING,"DNS Client (port 53)",53,53},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"FTP Client (port 20~21)",20,21},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"FTP Server (port 20~21)",20,21},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"Telnet Client (port 23)",23,23},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"Telnet Server (port 23)",23,23},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"SMTP Client (port 25)",25,25},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"SMTP Server (port 25)",25,25},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"POP3 Client (port 110)",110,110},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"POP3 Server (port 110)",110,110},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"NNTP Client (port 119)",119,119},
	{PF_APP_SEL_UDP,PF_APP_SEL_OUTGOING,"RAV Client (port 7070)",7070,7070},
	{PF_APP_SEL_UDP,PF_APP_SEL_INCOMING,"RAV Server (port 7070)",7070,7070},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"H323 Client (port 1720)",1720,1720},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"T120 Client (port 1503)",1503,1503},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"SSH Client (port 22)",22,22},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"SSH Server (port 22)",22,22},
	{PF_APP_SEL_UDP,PF_APP_SEL_OUTGOING,"SNTP Client (port 123)",123,123},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"HTTPS Client (port 443)",443,443},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"HTTPS Server (port 443)",443,443},
	{PF_APP_SEL_TCP,PF_APP_SEL_OUTGOING,"VNC Client (port 5900~5901)",5900,5901},
	{PF_APP_SEL_TCP,PF_APP_SEL_INCOMING,"VNC Server (port 5900~5901)",5900,5901}
};
static int idx_app=1;// User defined shall be last one.  Take 1st applcation level filter
//static	int idx1_app=0;


#define PKT_FILT_CONF_FN_RULE_ADD    "/var/etc/pfilter.conf.rule.add"
#define PKT_FILT_CONF_FN_RULE_DEL   "/var/etc/pfilter.conf.rule.del"
//#define FILT_CONF_FN_RULE_DEL_OLD   "/var/etc/filter.conf.rule.del_old"

static inline char* inet_ntoa_b(struct in_addr inet_addr,char* dest_string) {
	strcpy(dest_string,inet_ntoa(inet_addr));
			return dest_string;
}

extern int print_blank_string(void *d);
extern int load_blank_string(void *d);

// pf.asp
// pf1.asp
// albert 20030128
static void DefinePacketFilterConfig();
//void GetClinetFilterToPFTable(PF_TABLE_T *table);
//void SetPFTableToClinetFilter(PF_TABLE_T *table);
int GetConfigToPFTable(PF_TABLE_T *table);
int SetPFTableToConfig(PF_TABLE_T *table);
int CreatePFTableToScript(PF_TABLE_T *table);
//#define inet_ntoa_b(inet_addr,dest_string) strcpy(dest_string, inet_ntoa(inet_addr))
// web pages function
static void formPF(webs_t wp, char_t *path, char_t *query);
static void formPFapp(webs_t wp, char_t *path, char_t *query);
static int aspPacketFilterShow(int eid, webs_t wp, int argc, char_t **argv);
static int aspPFDefaultRulesShow(int eid, webs_t wp, int argc, char_t **argv);
// pf1.asp
static int aspPF1_fwNow2(void);
static int aspPF1_fwNow(int eid, webs_t wp, int argc, char_t **argv);
static int aspPF1_Page(int eid, webs_t wp, int argc, char_t **argv);
static int aspApplication_List(int eid, webs_t wp, int argc, char_t **argv);
static void formPF1(webs_t wp, char_t *path, char_t *query);
char_t *SelectListOption( char_t **Option_List, int num, int who);
/*
 * packet filter function
 */
// albert 20030128
extern int PF_Table_Init(PF_TABLE_T *table);
extern int PF_AddRule(PF_TABLE_T *table, PF_RULE_T *rule);
extern int PF_DelRule(PF_TABLE_T *table, int item);
extern int PF_AdjustTable(PF_TABLE_T *table);
extern int PF_CopyTable(PF_TABLE_T *DstTable, PF_TABLE_T *SrcTable);
extern int PF_SetRule(PF_TABLE_T *table, PF_RULE_T *rule, int item);
extern void printBlockMode(TIME_BLOCK_T *timeblock,char *blockMode,int isBlocked);

static void DefinePacketFilterConfig();
int chk_ip_range(char *isip, char *ieip);

void DefineWebFunctions_PacketFilter() {
pf_app_sel[0].service = PacketFilter_L1[locale_config.locale];
	DefinePacketFilterConfig();
}

/*
 * albert 20030207 for pf.asp, pf1.asp
 */
PF_TABLE_T PF_Table, PF_TableShow;
static int PF_dfRule = 1;

// select
//char_t StringBuf[1200]={0};
char_t StringBuf[512]={0};
char_t *SelectListOption( char_t **Option_List, int num, int who)
{
	int i=0, j=0;
	memset(StringBuf, 0, sizeof(StringBuf));
	for(i=0;i<who;i++)
		j += sprintf(&StringBuf[j], "<OPTION VALUE=%d>%s</OPTION>\n", i+1, Option_List[i]);
	j += sprintf(&StringBuf[j], "<OPTION VALUE=%d SELECTED>%s</OPTION>\n", ++i, Option_List[who]);
	for(; i<num;i++)
		j += sprintf(&StringBuf[j], "<OPTION VALUE=%d>%s</OPTION>\n", i+1, Option_List[i]);
	return StringBuf;
}

int pfilterIfAnyRulesActive(PF_TABLE_T *table)	
{
	PF_RULE_T *rule;
	int i;
   for (i = 0; i < MAX_CLIENT_FILTER_ENTRY; i++) 
   {
     rule = &(table->Rule[i]);
     if( rule->Item != 0 ) {
       if( rule->Active == PF_Act_YES )
       {
		return 1;
       }
     }	
   }	
   return 0; 
}


static void DefinePacketFilterConfig()
{
	PF_Table_Init(&PF_Table);
	PF_Table_Init(&PF_TableShow);
	// test cf2pf
//	GetClinetFilterToPFTable(&PF_Table);
//	GetClinetFilterToPFTable(&PF_TableShow);
	GetConfigToPFTable(&PF_Table);
	GetConfigToPFTable(&PF_TableShow);

	if(pfilterIfAnyRulesActive(&PF_Table))
		CreatePFTableToScript(&PF_Table);
	
	// pf.asp
	websAspDefine(T("PF_default_rules"), aspPFDefaultRulesShow);
	websAspDefine(T("pfList"), aspPacketFilterShow);
	websFormDefine(T("pf"), formPF);
	//pf1.asp
	websAspDefine(T("PF_Table"), aspPF1_Page);
	websAspDefine(T("PF_Application"), aspApplication_List);

	websFormDefine(T("pf1"), formPF1);
	websFormDefine(T("pfapp_change"), formPFapp);
	websAspDefine(T("fwNow"), aspPF1_fwNow);
}

// PacketFilter asp function
// for pf.asp


static int aspPFDefaultRulesShow(int eid, webs_t wp, int argc, char_t **argv)
{
char_t *TableFmt =
"<SELECT name=PFdfRule>\n"
"%s"
"</SELECT>\n";
const int PolicyNum=2; 
char_t *PolicyList[]={PacketFilter_L2[locale_config.locale], PacketFilter_L3[locale_config.locale]};

idx_app=1;// User defined shall be last one.  Take 1st applcation level filter

return	websWrite(wp, T(TableFmt),SelectListOption(PolicyList,PolicyNum ,PF_dfRule-1 ));
}

static int aspPacketFilterShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i=0;
	char *type2str[]={PacketFilter_L4[locale_config.locale], "Tcp", "Udp", "Icmp","Gre"};
	char flowStr[32];


	char_t *TableFmt="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
	             "<td colSpan=2 align=center>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		     "<td>&nbsp;%s&nbsp;</td>"
		 "</tr>\n";
	PF_RULE_T *rule;

	for( i = 0; i < PF_TableShow.TotalNum; i++)
	{
		rule = &PF_TableShow.Rule[i];
		if( rule->Item != 0)
		{
			char blockMode[60];
			
			printBlockMode(&(rule->timeblock),blockMode,0);	

			
			if(rule->ApplType)
			{
				sprintf(flowStr,"%s/%s",PacketFilter_L8[locale_config.locale],PacketFilter_L7[locale_config.locale]);
			}
			else
			{
				if(rule->Flow == PF_Flow_OUT)
					sprintf(flowStr,"%s",PacketFilter_L7[locale_config.locale]);
				else
					sprintf(flowStr,"%s",PacketFilter_L8[locale_config.locale]);
			}
			nBytes += websWrite(wp, T(TableFmt),
			// Radio value, int
			i+1,
			// checked or not
			(i == aspPF1_fwNow2() ? "checked" : ""),
			// name
			rule->Name,
			// name
			pf_app_sel[rule->ApplType].service,
			// 1 Active, string
			(rule->Active == PF_Act_NO ? PacketFilter_L5[locale_config.locale] : PacketFilter_L6[locale_config.locale]),
			// 2 Flow, string
			flowStr,
			// 3 PacketType, string
			type2str[rule->Type],
			// 4 Action, string
			(rule->Action == PF_Action_DROP ? PacketFilter_L3[locale_config.locale] : PacketFilter_L2[locale_config.locale]),
			// 13 Log, string
			(rule->Log == PF_Log_NO ? PacketFilter_L5[locale_config.locale] : PacketFilter_L6[locale_config.locale]),
			blockMode);
		}// end if
	}
	return nBytes;
}

// pf.asp
static enum ClickOption PF_Func = Click_Func_CENCEL;
static int PF_Edit_Index = 0;
extern char WAN_IP[];

static void formPFapp(webs_t wp, char_t *path, char_t *query)
{
	char_t *Idx/*, *Idx1*/;
//	char findstring[] = "PF_Application();";
//	char findstring1[] = "PF_Table();";
//	char *i=1;
//	int j=0;
	Idx = websGetVar(wp, T("fltrApp"), "0");
//	Idx1 = websGetVar(wp, T("fltrServCli"), "0");
	idx_app = atoi(Idx)-1;
//	idx1_app = atoi(Idx1)-1;
//	DPRINTF("%d/%d\n",idx_app,idx_app);
	
	websHeader(wp);
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf1.asp\");</script>"));
	
			websFooter(wp);
			websDone(wp, 200);
//	DPRINTF("done!\n");


}

static void formPF(webs_t wp, char_t *path, char_t *query)
{
	//enum PFOption Func = CENCEL;
	char_t *fwFUNC, *Idx, *DefaultRule;

	DefaultRule = websGetVar(wp, T("PFdfRule"), "");
	PF_dfRule = atoi(DefaultRule);
	fwFUNC = websGetVar(wp, T("fwFUNC"), "");
	PF_Func = atoi(fwFUNC);
	Idx = websGetVar(wp, T("Idx"), "");
	PF_Edit_Index = atoi(Idx);
	--PF_Edit_Index;
	#if 0
	websHeader(wp);
	//pstr = websExpand(wp, NULL, "$COMPANY $SERVER_PORT $CONTENT_LENGTH $PATH_INFO", -1);
	//websWrite(wp, T("<body><h2>fwFUNC: %s %d, Idx: %s</h2>\n"), fwFUNC, Func, Idx);
	//websWrite(wp, T("PATH_INFO=%s\n"), gogetenv("PATH_INFO"));
	//websResponse(wp, 302, msgbuf, url);
	websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf1.asp\");</script>"));
	websFooter(wp);
	websDone(wp, 200);
	#else
	websHeader(wp);
	switch(PF_Func)
	{
		case Click_Func_ADD:
		// When enter the pf1.asp, we need to set the idx_app
		idx_app=1;// User defined shall be last one.  Take 1st applcation level filter as default
		//websWrite(wp, T("<body><h2>ADD: %d, Idx: %s</h2>\n"), Func, Idx);
		if(PF_TableShow.NextItem < MAX_RULE)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_EDIT:
		// When enter the pf1.asp, we need to set the idx_app
		idx_app=PF_TableShow.Rule[PF_Edit_Index].ApplType;// For adding a new rule, user defined is the default
		if(PF_Edit_Index >= 0)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else// no select an item
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		//websRedirect(wp, "/pf.asp");
		break;
		case Click_Func_DEL:
		//websWrite(wp, T("<body><h2>DEL:  %d, Idx: %s</h2>\n"),PF_Func, Idx);
		//websFooter(wp);
		//websDone(wp, 200);
		if(PF_Edit_Index >= 0)
		{
			PF_DelRule(&PF_TableShow, PF_Edit_Index);
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_APPLY:
		{
			char 	funcNum[4];
			char str_wanip[20];
			       char buf1[64];

			sprintf(funcNum,"%d",FUNCTION_NUM_PACKET_FILTER);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
			SetPFTableToConfig(&PF_TableShow);
			PF_CopyTable(&PF_Table, &PF_TableShow);
//for default rules drop
			if(pfilterIfAnyRulesActive(&PF_Table))
			{
				CreatePFTableToScript(&PF_Table);
				strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
				if(isValidIP(str_wanip))
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
				//else running when wan_ip ready.
				websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
			}
			else
			{	
				if (PF_dfRule==2){//default is drop	
					char *alertmsg = "alert(\"%s\");\nlocation.replace(\"/pf.asp\");\n"; // Julian added 2005/06/23
					websWrite(wp, T("<script language=\"javascript\">\n"));
					websWrite(wp, T(alertmsg),PacketFilter_L28[locale_config.locale]);
					websWrite(wp, T("</script>\n"));
					PF_dfRule--;
					SetPFTableToConfig(&PF_TableShow);
					PF_CopyTable(&PF_Table, &PF_TableShow);
				}else{
					websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
				}
				unlink(PKT_FILT_CONF_FN_RULE_ADD);
				unlink(PKT_FILT_CONF_FN_RULE_DEL);
			}
		}
//		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;

		case Click_Func_CENCEL:
		PF_CopyTable(&PF_TableShow, &PF_Table);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
		default:
			websRedirect(wp, "/pf.asp");
	}
	#endif
}

// for pf1.asp
// pf1, rule number
static int aspPF1_fwNow(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(PF_Func)
	{
		case Click_Func_ADD:
		return websWrite(wp, T("%d"), PF_TableShow.NextItem);
		case Click_Func_EDIT:
		return websWrite(wp, T("%d"), PF_Edit_Index);
		default:
		return websWrite(wp, T("%d"), PF_TableShow.NextItem);
	}
}
static int aspPF1_fwNow2(void)
{
	switch(PF_Func)
	{
		case Click_Func_EDIT:
		return PF_Edit_Index;
		default:
		return PF_TableShow.TotalNum-1;
	}
}
static int aspApplication_List(int eid, webs_t wp, int argc, char_t **argv)
{
	//robertdb1
	int i=0;
	char_t *appLst_TableFmt1 =
	"<TR>  \n"
	"<TD class=title>%s</TD>\n"
	"<TD colSpan=3>\n"
	"<SELECT name=fltrApp onchange=\"change_app();\">\n";

	pf_app_sel[0].service = PacketFilter_L1[locale_config.locale];
	websWrite(wp, T(appLst_TableFmt1),PacketFilter_L9[locale_config.locale]);
	
	//0 is user defined, we need to put it into the end of the selection list. So, here  i starts from 1
	for(i=1;i<PF_APP_SEL_NUM;i++)
	{
		websWrite(wp, T("<OPTION VALUE=%d %s>%s</OPTION>\n"), i+1,(i==idx_app)?"SELECTED":"", pf_app_sel[i].service);
	}
	// put 0: user defined in the last one.
	websWrite(wp, T("<OPTION VALUE=%d %s>%s</OPTION>\n"), 1,(idx_app==0)?"SELECTED":"", pf_app_sel[0].service);
	websWrite(wp, T(PacketFilter_L29[locale_config.locale]));
	return 1;
}
extern char *Qos_L2[];
extern char *Qos_L10[];
extern char *Qos_L11[];
extern char *Qos_L12[];
extern char *Qos_L13[];
extern char *Qos_L14[];
extern char *Qos_L15[];

////// for pf1.asp table format
static int aspPF1_Page(int eid, webs_t wp, int argc, char_t **argv)
{
// rule %d, flow out %s, in %s
char_t *pf1_TableFmt1_1 =
"<TR>\n"
"<TD class=title width=30\%>%s</TD>\n"
"<TD class=title1 width=10\%><INPUT type=text name=pf_name maxlength=22 size=20 value=%s></TD>\n"
"<TD class=title width=30\%>%s</TD>\n"
"<TD class=title1>\n";
char_t *pf1_TableFmt1_2 =
"<INPUT type=radio name=fltrIO value=0 %s>%s <br>\n"
"<INPUT type=radio name=fltrIO value=1 %s>%s \n";
char_t *pf1_TableFmt2 =
"<TR>\n"
"<TD class=title width=30\%>%s</TD>\n"
"<TD class=title1 width=10\%>\n"
"<SELECT name=fltrRE>\n"
"%s"
"</SELECT>\n"
"</TD>  \n";
char_t *pf1_TableFmt2_1 =
"<TD class=title width=30\%>%s</TD>  \n"
"<TD class=title1 width=10\%>  \n"
"%s%s%s"
"</TD>  \n"
"</TR>  \n";
// active %s, packet type %s,
char_t *pf1_TableFmt3 =
"<TR>  \n"
"<TD class=title width=30\%>%s</TD> \n"
"<TD class=title1 width=10\%>  \n"
"<SELECT name=fltrLE>  \n"
"%s"
"</SELECT>  \n"
"</TD>  \n";
char_t *pf1_TableFmt3_1 =
"<TD class=title width=30\%>%s</TD>\n"
"<TD class=title1 width=10\%>\n"
"<SELECT name=fltrFD>\n"
"%s"
"</SELECT>\n"
"</TD>\n"
"</TR>\n";
// Log %s, Action %s
	// Yes, we borrow the timing block from Url filtering
	extern char_t *url1_TableFmt3,*url1_TableFmt3_1;
	extern char_t *qos1_TableFmt4,*qos1_TableFmt6;// Yes. Borrow the IP, Port from Qos.

	//char *type2str[]={"Any", "Tcp", "Udp", "Icmp"};
	//const int FlowNum=2; char *FlowRadio[]={"Out", "In"};
	const int ActiveNum=2, ActiveDefault=1; char *ActiveList[]={PacketFilter_L5[locale_config.locale], PacketFilter_L6[locale_config.locale]};
	const int PacketTypeNum=5, PacketTypeDefault=0; char *PacketTypeList[]={PacketFilter_L4[locale_config.locale], "Tcp", "Udp", "Icmp","Gre"};
	const int LogNum=2, LogDefault=0; char *LogList[]={PacketFilter_L5[locale_config.locale], PacketFilter_L6[locale_config.locale]};
	const int ActionNum=2/*, ActionDefault=0*/; char *ActionList[]={PacketFilter_L3[locale_config.locale], PacketFilter_L2[locale_config.locale]};
	PF_RULE_T *rule;
	char defaultName[10];

	pf_app_sel[0].service = PacketFilter_L1[locale_config.locale];
	switch(PF_Func)
	{
		case Click_Func_ADD:
		sprintf(defaultName,"APPL%d",PF_TableShow.NextItem+1);
		websWrite(wp, T(pf1_TableFmt1_1),
			PacketFilter_L11[locale_config.locale],
			// 0 
			//PF_TableShow.NextItem+1,
			defaultName,
			(idx_app?"":PacketFilter_L12[locale_config.locale]));
		if(!idx_app)
			websWrite(wp, T(pf1_TableFmt1_2),
			// 1 Flow Radio Out or In, string
			"0",
			PacketFilter_L13[locale_config.locale],
			// 2 Flow Radio In, string
			"1 checked",
			PacketFilter_L14[locale_config.locale]
			);
		websWrite(wp,"</TD>\n</TR>\n");

		websWrite(wp, T(pf1_TableFmt2),
			// 3 Active options "Yes" or "No", string
			PacketFilter_L15[locale_config.locale],
			SelectListOption(ActiveList, ActiveNum, ActiveDefault));
		if(!idx_app)
		{
			websWrite(wp, T(pf1_TableFmt2_1),
			PacketFilter_L16[locale_config.locale],
			// 4 PacketType, Any, Tcp, Udp, Icmp, string
			"<SELECT name=fltrPT>  \n",SelectListOption(PacketTypeList, PacketTypeNum, PacketTypeDefault),"</SELECT>  \n");
		}
		else
			websWrite(wp, T(pf1_TableFmt2_1),"","","","");
		websWrite(wp, T(pf1_TableFmt3),
			PacketFilter_L17[locale_config.locale],
			// 5 Log, No, Yes, string
			SelectListOption(LogList, LogNum, LogDefault));
		websWrite(wp, T(pf1_TableFmt3_1),
			PacketFilter_L18[locale_config.locale],
			// 6 Action, string
			SelectListOption(ActionList, ActionNum, PF_dfRule-1));
		websWrite(wp, T(qos1_TableFmt4),
			Qos_L11[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"",
			Qos_L12[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"");
		if(!idx_app)
		{
		websWrite(wp, T(qos1_TableFmt6),
			Qos_L14[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"",
			Qos_L15[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			""
			);
		}
		websWrite(wp, T(url1_TableFmt3),
		PacketFilter_L25[locale_config.locale],
			"checked", // default is always block
		PacketFilter_L26[locale_config.locale],
			"",
		PacketFilter_L27[locale_config.locale],
			DEFAULT_TIME_BLOCK_FROM_HOUR,
			DEFAULT_TIME_BLOCK_FROM_MIN,
		URL_L7[locale_config.locale],
			DEFAULT_TIME_BLOCK_TO_HOUR,
			DEFAULT_TIME_BLOCK_TO_MIN);
		websWrite(wp, T(url1_TableFmt3_1),
			"",URL_L8[locale_config.locale],
			"",URL_L9[locale_config.locale],
			"",URL_L10[locale_config.locale],
			"",URL_L11[locale_config.locale],
			"",URL_L12[locale_config.locale],
			"",URL_L13[locale_config.locale],
			"",URL_L14[locale_config.locale]);
		break;
		case Click_Func_EDIT:
		rule = &PF_TableShow.Rule[PF_Edit_Index];

		websWrite(wp, T(pf1_TableFmt1_1),
			PacketFilter_L11[locale_config.locale],
			// 0 
			//PF_TableShow.NextItem+1,
			rule->Name,
			(idx_app?"":PacketFilter_L12[locale_config.locale]));
		if(!idx_app)
			websWrite(wp, T(pf1_TableFmt1_2),
			// 1 Flow Radio Out or In, string
			(rule->Flow == PF_Flow_OUT ? "1 checked" : "0"),
			PacketFilter_L13[locale_config.locale],
			// 2 Flow Radio In, string
			(rule->Flow == PF_Flow_IN ? "1 checked" : "0"),
			PacketFilter_L14[locale_config.locale]
			);
		websWrite(wp,"</TD>\n</TR>\n");


		websWrite(wp, T(pf1_TableFmt2),
			PacketFilter_L15[locale_config.locale],
			// 3 Active options "Yes" or "No", string
			SelectListOption(ActiveList, ActiveNum,
				rule->Active));
		if(!idx_app)
		{
			websWrite(wp, T(pf1_TableFmt2_1),
			PacketFilter_L16[locale_config.locale],
			// 4 PacketType, Any, Tcp, Udp, Icmp, string
			"<SELECT name=fltrPT>  \n",SelectListOption(PacketTypeList, PacketTypeNum, rule->Type),"</SELECT>  \n");
		}
		else
			websWrite(wp, T(pf1_TableFmt2_1),"","","","");
		websWrite(wp, T(pf1_TableFmt3),
			PacketFilter_L17[locale_config.locale],
			// 5 Log, No, Yes, string
			SelectListOption(LogList, LogNum,
				rule->Log));
		websWrite(wp, T(pf1_TableFmt3_1),
			PacketFilter_L18[locale_config.locale],
			// 6 Action, string
			SelectListOption(ActionList, ActionNum,
			(idx_app)?(PF_dfRule-1):
				rule->Action)
			);

		websWrite(wp, T(qos1_TableFmt4),
			Qos_L11[locale_config.locale],
			Qos_L13[locale_config.locale],
			rule->LocalIpStart,
			Qos_L2[locale_config.locale],
			rule->LocalIpEnd,
			Qos_L12[locale_config.locale],
			Qos_L13[locale_config.locale],
			rule->RemoteIpStart,
			Qos_L2[locale_config.locale],
			rule->RemoteIpEnd);		
		
		if(!idx_app)
		{
			char LocalPortFrom[6]="";
			char LocalPortTo[6]="";
			char RemotePortFrom[6]="";
			char RemotePortTo[6]="";
			if(rule->LocalPortStart)
				sprintf(LocalPortFrom, "%d",rule->LocalPortStart);
			if(rule->LocalPortEnd)
				sprintf(LocalPortTo, "%d",rule->LocalPortEnd);
			if(rule->RemotePortStart)
				sprintf(RemotePortFrom, "%d",rule->RemotePortStart);
			if(rule->RemotePortStart)
				sprintf(RemotePortTo, "%d",rule->RemotePortEnd);
			websWrite(wp, T(qos1_TableFmt6),
			Qos_L14[locale_config.locale],
			Qos_L13[locale_config.locale],
			LocalPortFrom,
			Qos_L2[locale_config.locale],
			LocalPortTo,
			Qos_L15[locale_config.locale],
			Qos_L13[locale_config.locale],
			RemotePortFrom,
			Qos_L2[locale_config.locale],
			RemotePortTo);
		}
		websWrite(wp, T(url1_TableFmt3),
		PacketFilter_L25[locale_config.locale],
			(rule->timeblock.alwaysBlock)?"checked":"", 
		PacketFilter_L26[locale_config.locale],
			(rule->timeblock.alwaysBlock)?"":"checked",
		PacketFilter_L27[locale_config.locale],
			rule->timeblock.time_start/60,
			rule->timeblock.time_start%60,
		URL_L7[locale_config.locale],
			rule->timeblock.time_stop/60,
			rule->timeblock.time_stop%60);
			
		websWrite(wp, T(url1_TableFmt3_1),
			(rule->timeblock.days_match&0x01)?"checked":"",
		        URL_L8[locale_config.locale],	
			(rule->timeblock.days_match&0x02)?"checked":"", 
		        URL_L9[locale_config.locale],	
			(rule->timeblock.days_match&0x04)?"checked":"", 
		        URL_L10[locale_config.locale],	
			(rule->timeblock.days_match&0x08)?"checked":"", 
		        URL_L11[locale_config.locale],	
			(rule->timeblock.days_match&0x10)?"checked":"", 
		        URL_L12[locale_config.locale],	
			(rule->timeblock.days_match&0x20)?"checked":"", 
		        URL_L13[locale_config.locale],	
			(rule->timeblock.days_match&0x40)?"checked":"",
		        URL_L14[locale_config.locale]);	
		break;// case Click_Func_EDIT
		default:
		// do nothing
		break;
	}//end switch

	return 0;
}// end aspPF1_Page

// check ip range
int chk_ip_range(char *isip, char *ieip)
{
	in_addr_t s, e;
	char tmp[20];

	s = inet_addr(isip);
	e = inet_addr(ieip);

	//DPRINTF("isip %s ieip %s\n", isip, ieip);
	//DPRINTF("s %08X e %08X\n", s, e);

	if(s==0 && e==0){
	  strcpy(isip,0x0);
	  strcpy(ieip,0x0);
	  return 0;
	}

	if(!strlen(isip) && !strlen(ieip))
	  return 4;

	if(!strlen(isip) && strlen(ieip)){
	  if(e==0){
	    strcpy(ieip,0x0);
	  }else
	      strcpy(isip, ieip);
	  return 3;
	}

	if(strlen(isip) && !strlen(ieip)){
	  if(s==0){
	    strcpy(isip,0x0);
	  }else
	    strcpy(ieip, isip);
	  return 2;
	}
	  
	if(s > e){
	  strcpy(tmp, isip);
	  strcpy(isip, ieip);
	  strcpy(ieip, tmp);
	  //DPRINTF("a isip %s ieip %s\n", isip, ieip);
	  return 1;
	}

	return 0;
}

// check port range
static int chk_port_range(unsigned short *sp, unsigned short *ep)
{
  unsigned short tmp;
  //DPRINTF("sp %hu ep %hu\n", *sp, *ep);

  if(*sp > *ep){
    tmp = *sp;
    *sp = *ep;
    *ep = tmp;
  }

  //  if(*sp==0 && *ep!=0){
  //  *sp = *ep;
  //  return 2;
  //}
  
  //if(*sp!=0 && *ep==0){
  //  *ep = *sp;
  //  return 1;
  //}

  return 0;
}

// for form pf1.asp
static void formPF1(webs_t wp, char_t *path, char_t *query)
{
//	char_t *pStr;
	char_t *pfwNow, *pfltrRE, *pfltrIO, *pfltrPT, *pfltrFD;
	char_t *pfltrLE;
	char_t *pfltrREV;
	char_t *pfwFUNC,*pfltrApp;
	char_t *purlfBM,*purlfBHour,*purlfBMin,*purlfEHour,*purlfEMin;
	char_t *pBTSun,*pBTMon,*pBTTue,*pBTWed,*pBTThu,*pBTFri,*pBTSat;

	//char_t *symTable[]={"fwNow", "fltrRE", "fltrIO", "fltrPT", "fltrFD",
	//		  "fltrSIpFrom", "fltrSIpTo", "fltrSPF", "fltrSPT","fltrDIpFrom",
	//		  "fltrDIpTo", "fltrDPF", "fltrDPT", "fltrLE"};
	PF_RULE_T rule;
	memset(&rule, 0, sizeof(PF_RULE_T));

	pfwFUNC = websGetVar(wp, T("fwFUNC"), "0");
	// 0, Rule number
	pfwNow = websGetVar(wp, T("fwNow"), "0");
	// 1, Active
	pfltrRE = websGetVar(wp, T("fltrRE"), "0");
	// 2, Flow
	pfltrIO = websGetVar(wp, T("fltrIO"), "0");
	// 3, Type
	pfltrPT = websGetVar(wp, T("fltrPT"), "0");
	// 4, Action
	pfltrFD = websGetVar(wp, T("fltrFD"), "0");


	// 13, Log
	pfltrLE = websGetVar(wp, T("fltrLE"), "0");
	pfltrREV= websGetVar(wp, T("fltrREV"), "0");
//	DPRINTF("pfltrREV = %s\n",pfltrREV);
	purlfBM = websGetVar(wp, T("urlfBM"), "0");
	purlfBHour = websGetVar(wp, T("urlfBHour"), "0");
	purlfBMin = websGetVar(wp, T("urlfBMin"), "0");
	purlfEHour = websGetVar(wp, T("urlfEHour"), "0");
	purlfEMin = websGetVar(wp, T("urlfEMin"), "0");
	pBTSun = websGetVar(wp, T("BTSun"), "0");
	pBTMon = websGetVar(wp, T("BTMon"), "0");
	pBTTue = websGetVar(wp, T("BTTue"), "0");
	pBTWed = websGetVar(wp, T("BTWed"), "0");
	pBTThu = websGetVar(wp, T("BTThu"), "0");
	pBTFri = websGetVar(wp, T("BTFri"), "0");
	pBTSat = websGetVar(wp, T("BTSat"), "0");
	pfltrApp = websGetVar(wp, T("fltrApp"), "1");

	rule.Item = atoi(pfwNow)+1; //0
	rule.Active = atoi(pfltrRE)-1;//1
	rule.Action = atoi(pfltrFD)-1;//4
	rule.ApplType = atoi(pfltrApp)-1; //0

	strcpy(rule.Name, websGetVar(wp, T("pf_name"), "APPL"));// Shall be appl%d????
	strcpy(rule.LocalIpStart,websGetVar(wp, T("qosLocalIpFrom"), "")); 
	strcpy(rule.LocalIpEnd,websGetVar(wp, T("qosLocalIpTo"), "")); 
	chk_ip_range(rule.LocalIpStart, rule.LocalIpEnd);
	strcpy(rule.RemoteIpStart,websGetVar(wp, T("qosRemoteIpFrom"), "")); 
	strcpy(rule.RemoteIpEnd,websGetVar(wp, T("qosRemoteIpTo"), "")); 
	chk_ip_range(rule.RemoteIpStart, rule.RemoteIpEnd);


	if(rule.ApplType)
	{// known application
		rule.Flow = pf_app_sel[idx_app].direction;//2
		rule.Type = pf_app_sel[idx_app].protocol;//3
		rule.LocalPortStart = 0;//7
		rule.LocalPortEnd = 0;//8
		rule.RemotePortStart = pf_app_sel[idx_app].dstprtf;//11
		rule.RemotePortEnd = pf_app_sel[idx_app].dstprte;//12
		rule.reverse = 1;// always reverse (bidirectional for known applciation)
	}
	else
	{
		rule.Flow = atoi(pfltrIO);//2
		rule.Type = atoi(pfltrPT)-1;//3
		rule.LocalPortStart = atoi(websGetVar(wp, T("qosLocalPF"), "0"));
		rule.LocalPortEnd = atoi(websGetVar(wp, T("qosLocalPT"), "0"));
		chk_port_range(&rule.LocalPortStart, &rule.LocalPortEnd);
		rule.RemotePortStart = atoi(websGetVar(wp, T("qosRemotePF"), "0"));
		rule.RemotePortEnd = atoi(websGetVar(wp, T("qosRemotePT"), "0"));
		chk_port_range(&rule.RemotePortStart, &rule.RemotePortEnd);
		rule.reverse = 0;// no support from reverse direction for user defined
	}
	
	rule.Log = atoi(pfltrLE)-1;//13
	rule.timeblock.alwaysBlock = atoi(purlfBM);
	rule.timeblock.time_start=atoi(purlfBHour)*60+atoi(purlfBMin);
	rule.timeblock.time_stop=atoi(purlfEHour)*60+atoi(purlfEMin);
	if(atoi(pBTSun)==1) rule.timeblock.days_match=0x01;
	if(atoi(pBTMon)==1) rule.timeblock.days_match|=0x02;
	if(atoi(pBTTue)==1) rule.timeblock.days_match|=0x04;
	if(atoi(pBTWed)==1) rule.timeblock.days_match|=0x08;
	if(atoi(pBTThu)==1) rule.timeblock.days_match|=0x10;
	if(atoi(pBTFri)==1) rule.timeblock.days_match|=0x20;
	if(atoi(pBTSat)==1) rule.timeblock.days_match|=0x40;

	websHeader(wp);
	#if 0
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"fwFUNC=%s Now=%s RE=%s\");</script>")
		,pfwFUNC, pfwNow, pfltrRE);
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"IO=%s PT=%s FD=%s LE=%s\");</script>")
		,pfltrIO, pfltrPT, pfltrFD, pfltrLE);
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"SIpFrom=%s SIpTo=%s\");</script>")
		,pfltrSIpFrom, pfltrSIpTo);
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"SPF=%s SPT=%s\");</script>")
		,pfltrSPF, pfltrSPT);
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"DIpFrom=%s DIpTo=%s\");</script>")
		,pfltrDIpFrom, pfltrDIpTo);
	websWrite(wp,
		T("<script language=\"JavaScript\">alert(\"DPF=%s DPT=%s\");</script>")
		,pfltrDPF, pfltrDPT);
	#else
	idx_app = 1;// User defined shall be last one.  Take 1st applcation level filter
	if( atoi(pfwFUNC) == 6 )
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf1.asp\");</script>"));
	else
	{
		switch(PF_Func)
		{
			case Click_Func_ADD:
			PF_AddRule(&PF_TableShow, &rule);
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"add\");</script>"));
			break;
			case Click_Func_EDIT:
			PF_SetRule(&PF_TableShow, &rule, rule.Item-1);
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"set\");</script>"));
			break;
			default:
			// do nothing
			break;
		}
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/pf.asp\");</script>"));
	}
	#endif
	websFooter(wp);
	websDone(wp, 200);

}// end formPF1


// copy Config to PF_Tablegen_config
int GetConfigToPFTable(PF_TABLE_T *table)
{
	int i;
	PF_RULE_T rule;
	FILE *fp;

	//fp = fopen(PROGRAM_SCRIPT_FILE, "r");
	fp = fopen("/flash/pf_conf.conf", "r");
	if (!fp) {
		return -1;
	}
	fscanf(fp,"|%d|\n",&PF_dfRule);
	for (i = 0; i < MAX_CLIENT_FILTER_ENTRY; i++) {
			//   1       2    3    4     5     6       7          8          9   10      11         12       13
			// |active|flow|type|action|srcip|srcmask|sportstart|sportend|dstip|dstmask|dportstart|dportend|log|
			if ( fscanf(fp,
				"|%20[^|]|%d|%d|%d|%d|%d|%20[^|]|%20[^|]|%hu|%hu|%20[^|]|%20[^|]|%hu|%hu|%d|%d|%d|%d|%d|%d|\n",
				rule.Name, //1
				(int *)&rule.ApplType, //2
				(int *)&rule.Active, //1
				(int *)&rule.Flow, //2
				(int *)&rule.Type, //3
				(int *)&rule.Action, //4
				rule.LocalIpStart, 
				rule.LocalIpEnd, 
				&rule.LocalPortStart, 
				&rule.LocalPortEnd, 
				rule.RemoteIpStart, 
				rule.RemoteIpEnd, 
				&rule.RemotePortStart, 
				&rule.RemotePortEnd, 
				(int *)&rule.Log, //13
				&rule.timeblock.alwaysBlock, 
				&rule.timeblock.days_match, 
				&rule.timeblock.time_start, 
				&rule.timeblock.time_stop,
				&rule.reverse
				) == -1 ) break;
			rule.Item = i+1; //0
	print_blank_string(rule.LocalIpStart);
	print_blank_string(rule.LocalIpEnd);
	print_blank_string(rule.RemoteIpStart);
	print_blank_string(rule.RemoteIpEnd);
//	DPRINTF("R.rule.SrcIpStart:%s\n",rule.SrcIpStart);	
//	DPRINTF("rule.SrcIpEnd:%s\n",rule.SrcIpEnd);	
//	DPRINTF("rule.DstIpStart:%s\n",rule.DstIpStart);	
//	DPRINTF("rule.DstIpEnd:%s\n",rule.DstIpEnd);	
//	DPRINTF("rule.reverse ===== get   %d\n",rule.reverse);
			PF_AddRule(table, &rule);
	}
	fclose(fp);
 	return 0;
}// end GetScriptToPFTable

// SetPFTableToConfig
int SetPFTableToConfig(PF_TABLE_T *table)
{
	int i;
	PF_RULE_T rule;
	FILE *fp;

	//fp = fopen(PROGRAM_SCRIPT_FILE, "w");
	
	fp = fopen("/flash/pf_conf.conf", "w");
	if (!fp) {
		return -1;
	}
	fprintf(fp,"|%d|\n",PF_dfRule);

	for (i = 0; i < MAX_CLIENT_FILTER_ENTRY; i++) {
		rule = table->Rule[i];
	load_blank_string(rule.LocalIpStart);
	load_blank_string(rule.LocalIpEnd);
	load_blank_string(rule.RemoteIpStart);
	load_blank_string(rule.RemoteIpEnd);

//	DPRINTF("rule.reverse = %d\n",rule.reverse);
	
	/*
	 * DPRINTF("W.rule.SrcIpStart:%s\n",rule.SrcIpStart);	
	DPRINTF("rule.SrcIpEnd:%s\n",rule.SrcIpEnd);	
	DPRINTF("rule.DstIpStart:%s\n",rule.DstIpStart);	
	DPRINTF("rule.DstIpEnd:%s\n",rule.DstIpEnd);	
	*/
		if( rule.Item != 0 ) {
			//rule.Item = i+1; //0
			//   1       2    3    4     5     6       7          8          9   10      11         12       13
			// |active|flow|type|action|srcip|srcmask|sportstart|sportend|dstip|dstmask|dportstart|dportend|log
			fprintf(fp,
				"|%s|%d|%d|%d|%d|%d|%s|%s|%hu|%hu|%s|%s|%hu|%hu|%d|%d|%d|%d|%d|%d|\n",
				rule.Name, //1
				rule.ApplType, //2
				rule.Active, //1
				rule.Flow, //2
				rule.Type, //3
				rule.Action, //4
				rule.LocalIpStart, 
				rule.LocalIpEnd, 
				rule.LocalPortStart, 
				rule.LocalPortEnd, 
				rule.RemoteIpStart, 
				rule.RemoteIpEnd, 
				rule.RemotePortStart, 
				rule.RemotePortEnd, 
				rule.Log, //13
				rule.timeblock.alwaysBlock, 
				rule.timeblock.days_match, 
				rule.timeblock.time_start, 
				rule.timeblock.time_stop,
				rule.reverse
				);
		/*		
		DPRINTF("rule.Active:%d\n",rule.Active);
		DPRINTF("rule.Flow:%d\n",rule.Flow);
		DPRINTF("rule.Type:%d\n",rule.Type);
		DPRINTF("rule.Action:%d\n",rule.Action);
		DPRINTF("rule.SrcIpStart:%s\n",rule.SrcIpStart);
		DPRINTF("rule.SrcIpEnd:%s\n",rule.SrcIpEnd);
		DPRINTF("rule.SrcPortStart:%hu\n",rule.SrcPortStart);
		DPRINTF("rule.SrcPortEnd:%hu\n",rule.SrcPortEnd);
		DPRINTF("rule.DstIpStart:%s\n",rule.DstIpStart);
		DPRINTF("rule.DstIpEnd:%s\n",rule.DstIpEnd);
		DPRINTF("rule.DstPortStart:%hu\n",rule.DstPortStart);
		DPRINTF("rule.DstPortEnd:%hu\n",rule.DstPortEnd);
		DPRINTF("rule.Log:%d\n",rule.Log);
		*/
		}
	}

	fclose(fp);
	
	return 0;
}// end SetPFTableToScript

// CreatePFTableToScript
void outputPFRuleToScript(PF_RULE_T *filter,FILE *outfp,int isReverseRule);
extern void outputTimeBLockForIptables(TIME_BLOCK_T *timeblock,char *timeBlocking);
/*-----------------------------------------------*/
int CreatePFTableToScript(PF_TABLE_T *table)
{
	int i;
	PF_RULE_T *rule;
	FILE *outfp,*outfp2;
//	FILE *fp;
//	char filename[80];
//	rule1 = &tmprule;
 	
 	outfp = fopen(PKT_FILT_CONF_FN_RULE_ADD, "w");
	if(!outfp)
	{
		//DPRINTF("open file %s for write error!\n",PKT_FILT_CONF_FN_RULE_ADD);
		return -1;
	}
	//rename(FILT_CONF_FN_RULE_DEL, FILT_CONF_FN_RULE_DEL_OLD); // keep the old del scripts.
	outfp2 = fopen(PKT_FILT_CONF_FN_RULE_DEL, "w");
	if(!outfp2)
	{
		//DPRINTF("open file %s for write error!\n",PKT_FILT_CONF_FN_RULE_DEL);
		return -1;
	}
	// use one or fw.sh
#if 0
	sprintf(filename, "%s", PKT_FILT_CONF_FN_RULE_DEL_OLD);
	if ((fp = fopen(filename, "r")) != NULL)
	{
		fclose(fp);
		run_script(filename, 0, 0, 0);
	}
#endif

	fprintf(outfp, "#!/bin/sh\n");
	fprintf(outfp, ". /var/etc/status\n");
	fprintf(outfp, "iptables -N PKT_FLT\n");
	fprintf(outfp, "iptables -A FORWARD -j PKT_FLT\n"); //Shall be added. Otherwise, it will go before VS and DMZ
	//fprintf(outfp, "iptables -I FORWARD -j PKT_FLT\n"); // For packet filtering, we only concern the new connections.
	//fprintf(outfp, "iptables -I FORWARD -m state --state NEW -j PKT_FLT\n"); // For packet filtering, we only concern the new connections.
	fprintf(outfp2, "#!/bin/sh\n");
	fprintf(outfp2, ". /var/etc/status\n");
	fprintf(outfp2, "iptables -D FORWARD -j PKT_FLT\n");
	//fprintf(outfp2, "iptables -D FORWARD -m state --state NEW -j PKT_FLT\n");
	fprintf(outfp2,"iptables -F PKT_FLT\n"); 
	fprintf(outfp2,"iptables -X PKT_FLT \n"); 

	for (i = 0; i < MAX_CLIENT_FILTER_ENTRY; i++) {
		rule = &table->Rule[i];
		if( rule->Item != 0 ) {
			if( rule->Active == PF_Act_YES ) {
			outputPFRuleToScript(rule,outfp,0);

			if( rule->reverse )
			{
				outputPFRuleToScript(rule,outfp,1);

			}
			
			}// end if active == yes

		}// rule != 0
	}// end for loop

/* add default rules here */
	if(PF_dfRule-1)
	{
		fprintf(outfp, "iptables -A PKT_FLT -j LOG --log-level 7 --log-prefix \"PacketFilter:DROP;\"\n");
		fprintf(outfp, "iptables -A PKT_FLT -j DROP\n");
	}
   	fclose(outfp);	
	fclose(outfp2);	
	chmod(PKT_FILT_CONF_FN_RULE_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(PKT_FILT_CONF_FN_RULE_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;	
	return 0;
}// end CreatePFTableToScript

extern  u_int32_t aspectou32(char *astr, int dns) ;


void outputPFRuleToScript(PF_RULE_T *rule,FILE *outfp,int isReverseRule)
{	
	u_int32_t fltrSIpFrom,fltrSIpTo,fltrDIpFrom,fltrDIpTo;
 	int pfSPF,pfSPT,pfDPF,pfDPT;
	char *pfSIpFromStr,*pfSIpToStr,*pfDIpFromStr,*pfDIpToStr;
       char action[10]="ACCEPT",direction[15]="";
         char iprange[12]="",sipstr[45]="",dipstr[45]="", protstr[6]="",sportstr[20]="",dportstr[20]="";
	char timeBlocking[128]="";

	if(rule->Action==PF_Action_DROP)
		strcpy(action,"DROP");       	
	if( ((rule->Flow==PF_Flow_OUT)&&(!isReverseRule)) || (((rule->Flow==PF_Flow_IN)&&(isReverseRule))) )
	{
			strcpy(direction,"-i $LAN_IF");  
	}
	else
	{
			strcpy(direction,"-o $LAN_IF");  
	}

	// We need to transfer the local/Remote to Source/Detination
    
    //b028 added 20-09-06
    if(rule->Flow==PF_APP_SEL_INCOMING && rule->ApplType!=0)
    {
        if( ((rule->Flow==PF_Flow_OUT)&&(!isReverseRule)) || (((rule->Flow==PF_Flow_IN)&&(isReverseRule))) )
        {
            pfSIpFromStr=rule->LocalIpStart;
            pfSIpToStr=rule->LocalIpEnd;
            pfDIpFromStr=rule->RemoteIpStart;
            pfDIpToStr=rule->RemoteIpEnd;    
            pfSPF=rule->RemotePortStart;
            pfSPT=rule->RemotePortEnd;
            pfDPF=rule->LocalPortStart;
            pfDPT=rule->LocalPortEnd;        
        }
        else
        {
            pfSIpFromStr=rule->RemoteIpStart;
            pfSIpToStr=rule->RemoteIpEnd;
            pfDIpFromStr=rule->LocalIpStart;
            pfDIpToStr=rule->LocalIpEnd;
            pfSPF=rule->LocalPortStart;
            pfSPT=rule->LocalPortEnd;
            pfDPF=rule->RemotePortStart;
            pfDPT=rule->RemotePortEnd;
        }    
    
    }
    //b028 added 20-09-06
	else 
    {
        if( ((rule->Flow==PF_Flow_OUT)&&(!isReverseRule)) || (((rule->Flow==PF_Flow_IN)&&(isReverseRule))) )
	   {
		  pfSIpFromStr=rule->LocalIpStart;
		  pfSIpToStr=rule->LocalIpEnd;
		  pfDIpFromStr=rule->RemoteIpStart;
		  pfDIpToStr=rule->RemoteIpEnd;
		  pfSPF=rule->LocalPortStart;
		  pfSPT=rule->LocalPortEnd;
		  pfDPF=rule->RemotePortStart;
		  pfDPT=rule->RemotePortEnd;
	   }
	   else
	   {
		  pfSIpFromStr=rule->RemoteIpStart;
		  pfSIpToStr=rule->RemoteIpEnd;
		  pfDIpFromStr=rule->LocalIpStart;
		  pfDIpToStr=rule->LocalIpEnd;
		  pfSPF=rule->RemotePortStart;
		  pfSPT=rule->RemotePortEnd;
		  pfDPF=rule->LocalPortStart;
		  pfDPT=rule->LocalPortEnd;
	   }
    }
	
	fltrSIpFrom = aspectou32(pfSIpFromStr,0);
	fltrSIpTo = aspectou32(pfSIpToStr,0);
	fltrDIpFrom = aspectou32(pfDIpFromStr,0);
	fltrDIpTo = aspectou32(pfDIpToStr,0);


	if((fltrSIpFrom==0)&&(fltrDIpFrom==0))
		;
	else
		strcpy(iprange,"-m iprange");
		
	if(fltrSIpFrom!=0)
	{
		// NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
		if(fltrSIpTo)
			sprintf(sipstr,"--src-range %s-%s",pfSIpFromStr,pfSIpToStr);
		else
			sprintf(sipstr,"--src-range %s",pfSIpFromStr);
	}
	if(fltrDIpFrom!=0)
	{
		// NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
		if(fltrDIpTo)
			sprintf(dipstr,"--dst-range %s-%s",pfDIpFromStr,pfDIpToStr);
		else
			sprintf(dipstr,"--dst-range %s",pfDIpFromStr);
	}
	

	// Process the post string to save code
	switch(rule->Type){
	case PF_Type_TCP:
		strcpy(protstr, "-p TCP");
		break;
	case PF_Type_UDP:
		strcpy(protstr, "-p UDP");
		break;
	case PF_Type_ICMP:
		strcpy(protstr, "-p ICMP");
		break;
	case PF_Type_GRE:
		strcpy(protstr, "-p GRE");
		break;
	case PF_Type_ANY:
		break;
	
	}
	
	if(pfSPF!=0)
	{
		if(pfSPT!=0)
			sprintf(sportstr,"--sport %d:%d", pfSPF,pfSPT);
		else
			sprintf(sportstr,"--sport %d", pfSPF);
	}
	if(pfDPF!=0)
	{
		if(pfDPT!=0)
			sprintf(dportstr,"--dport %d:%d", pfDPF,pfDPT);
		else
			sprintf(dportstr,"--dport %d", pfDPF);
	}
	outputTimeBLockForIptables(&rule->timeblock,timeBlocking);


	switch(rule->Type){
	case PF_Type_TCP:
	case PF_Type_UDP:
	if(rule->Log==PF_Log_YES)
	{
		fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j LOG --log-level 7 --log-prefix \"PacketFilter:%s;\"\n",
			direction ,iprange,sipstr,dipstr,protstr,sportstr,dportstr,timeBlocking,action);
	}
	fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j %s\n",
		 direction,iprange, sipstr,dipstr ,protstr,sportstr,dportstr,timeBlocking,action);

		break;
	case PF_Type_ICMP:
	case PF_Type_GRE:
	if(rule->Log==PF_Log_YES){
		fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s -j LOG --log-level 7 --log-prefix \"PacketFilter:%s;\"\n",
			 direction,iprange,sipstr,dipstr ,protstr,timeBlocking,action);
	}
	fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s -j %s\n",
		 direction,iprange, sipstr,dipstr ,protstr,timeBlocking,action);
		break;
	default:
	if(rule->Log==PF_Log_YES){
		fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j LOG --log-level 7 --log-prefix \"PacketFilter:%s;\"\n",
			 direction,iprange,sipstr,dipstr,"-p TCP",sportstr,dportstr,timeBlocking,action);
		fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j LOG --log-level 7 --log-prefix \"PacketFilter:%s;\"\n",
			direction, iprange,sipstr,dipstr ,"-p UDP",sportstr,dportstr,timeBlocking,action);
		fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s -j LOG --log-level 7 --log-prefix \"PacketFilter:%s;\"\n",
			direction, iprange,sipstr,dipstr,"-p ICMP",timeBlocking,action);
	}
	fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j %s\n",
		direction, iprange, sipstr,dipstr ,"-p TCP",sportstr,dportstr,timeBlocking,action);
	fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s %s %s -j %s\n",
		direction, iprange, sipstr,dipstr ,"-p UDP",sportstr,dportstr,timeBlocking,action);
	fprintf(outfp,"iptables -A PKT_FLT %s %s %s %s %s %s -j %s\n",
		direction, iprange, sipstr,dipstr ,"-p ICMP",timeBlocking,action);

		break;
	}

}
