/* albert 20030128 */
/* packetfilter configure functions */
#include "pf_conf.h"
#include "webs.h"
//PF_TABLE_T PF_Table, PF_TableShow;
int PF_Table_Init(PF_TABLE_T *table);
int PF_AddRule(PF_TABLE_T *table, PF_RULE_T *rule);
int PF_DelRule(PF_TABLE_T *table, int item);
int PF_AdjustTable(PF_TABLE_T *table);
int PF_SetRule(PF_TABLE_T *table, PF_RULE_T *rule, int item);
int PF_CopyTable(PF_TABLE_T *DstTable, PF_TABLE_T *SrcTable);

int MF_Table_Init(MF_TABLE_T *table);
int MF_AddRule(MF_TABLE_T *table, MF_RULE_T *rule);
int MF_DelRule(MF_TABLE_T *table, int item);
int MF_AdjustTable(MF_TABLE_T *table);
int MF_SetRule(MF_TABLE_T *table, MF_RULE_T *rule, int item);
int MF_CopyTable(MF_TABLE_T *DstTable, MF_TABLE_T *SrcTable);

int MF_Table_Init(MF_TABLE_T *table)
{
	memset( (void *)table, 0, sizeof(MF_TABLE_T));
	return 0;
}

int PF_Table_Init(PF_TABLE_T *table)
{
	memset( (void *)table, 0, sizeof(PF_TABLE_T));
	return 0;
}
int MF_AddRule(MF_TABLE_T *table, MF_RULE_T *rule)
{
// Mulder modified 2005-5-24
//	if( table->TotalNum < 0 || table->TotalNum >= MAX_RULE)
	if( table->TotalNum < 0 || table->TotalNum >= MAX_CLIENT_MACFILTER_ENTRY)
		return -1;
	table->Rule[table->NextItem++] = *rule;
	table->TotalNum++;
	return 0;
}

int PF_AddRule(PF_TABLE_T *table, PF_RULE_T *rule)
{
	if( table->TotalNum < 0 || table->TotalNum >= MAX_RULE)
		return -1;
	table->Rule[table->NextItem++] = *rule;
	table->TotalNum++;
	return 0;
}

int PF_SetRule(PF_TABLE_T *table, PF_RULE_T *rule, int item)
{
	if( item < 0 || item > table->NextItem)
		return -1;
	table->Rule[item] = *rule;
	return 0;
}
int MF_SetRule(MF_TABLE_T *table, MF_RULE_T *rule, int item)
{
	if( item < 0 || item > table->NextItem)
		return -1;
	table->Rule[item] = *rule;
	return 0;
}

int MF_DelRule(MF_TABLE_T *table, int item)
{
	if( item < 0 || item >= table->NextItem)
		return -1;
	//table->Rule[item] = (MF_RULE_T){0};
	memset( &(table->Rule[item]), 0, sizeof(MF_RULE_T));
	MF_AdjustTable(table);
	return 0;
}

int PF_DelRule(PF_TABLE_T *table, int item)
{
	if( item < 0 || item >= table->NextItem)
		return -1;
	//table->Rule[item] = (PF_RULE_T){0};
	memset( &(table->Rule[item]), 0, sizeof(PF_RULE_T));
	PF_AdjustTable(table);
	return 0;
}
int MF_AdjustTable(MF_TABLE_T *table)
{
	MF_TABLE_T tableTmp;
	int i = 0;
	
	MF_Table_Init(&tableTmp);
	
// Mulder modified 2005-5-24
//	for( i = 0; i < MAX_RULE; i++)
	for( i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++)
	{
		if( table->Rule[i].Item != 0 )
		{
			memcpy((void*)&(tableTmp.Rule[tableTmp.NextItem++]), (void*)&(table->Rule[i]), sizeof(MF_RULE_T));
			tableTmp.TotalNum++;
		}
	}
	memcpy((void*)table, (void*)&tableTmp, sizeof(MF_TABLE_T));
	return 0;
}

int PF_AdjustTable(PF_TABLE_T *table)
{
	PF_TABLE_T tableTmp;
	int i = 0;
	
	PF_Table_Init(&tableTmp);
	
	for( i = 0; i < MAX_RULE; i++)
	{
		if( table->Rule[i].Item != 0 )
		{
			memcpy((void*)&(tableTmp.Rule[tableTmp.NextItem++]), (void*)&(table->Rule[i]), sizeof(PF_RULE_T));
			tableTmp.TotalNum++;
		}
	}
	memcpy((void*)table, (void*)&tableTmp, sizeof(PF_TABLE_T));
	return 0;
}

int PF_CopyTable(PF_TABLE_T *DstTable, PF_TABLE_T *SrcTable)
{
	PF_Table_Init(DstTable);
	memcpy((void*)DstTable, (void*)SrcTable, sizeof(PF_TABLE_T));
	return 0;
}
int MF_CopyTable(MF_TABLE_T *DstTable, MF_TABLE_T *SrcTable)
{
	MF_Table_Init(DstTable);
	memcpy((void*)DstTable, (void*)SrcTable, sizeof(MF_TABLE_T));
	return 0;
}
