// albert 20030128
// packetfilter configure functions
#ifndef __PF_CONFIG_H
#define __PF_CONFIG_H
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "timeblock.h"

typedef enum PF_Active{
	PF_Act_NO=0,
	PF_Act_YES
} PF_Active_E;

typedef enum PF_Flow{
	PF_Flow_OUT=0,
	PF_Flow_IN
} PF_Flow_E;

typedef enum PF_Type{
	PF_Type_ANY=0,
	PF_Type_TCP,
	PF_Type_UDP,
	PF_Type_ICMP,
	PF_Type_GRE
} PF_Type_E;

typedef enum PF_Action{
	PF_Action_DROP=0,
	PF_Action_FORWARD
} PF_Action_E;

typedef enum PF_Log{
	PF_Log_NO=0,
	PF_Log_YES
} PF_Log_E;



typedef struct PF_RULE {
	int Item;	//0
	char Name[20];
	int ApplType;
	PF_Active_E Active;	//1
	PF_Flow_E Flow;	//2
	PF_Type_E Type;	//3
	PF_Action_E Action;	//4
	char LocalIpStart[20];	//5
	char LocalIpEnd[20];	//6
	unsigned short LocalPortStart;//
	unsigned short LocalPortEnd;	//8
	char RemoteIpStart[20];	//9
	char RemoteIpEnd[20];	//10
	unsigned short RemotePortStart;//11
	unsigned short RemotePortEnd;	//12
	PF_Log_E Log;	//13
	TIME_BLOCK_T timeblock;
	int reverse;
} PF_RULE_T;


//const int MAX_RULE=10;
#define MAX_RULE 30
#define MAX_CLIENT_FILTER_ENTRY MAX_RULE //6
// Mulder modified 2005-5-24 for Ben want to apply to 30 
//#define MAX_CLIENT_MACFILTER_ENTRY MAX_RULE //6
#define MAX_CLIENT_MACFILTER_ENTRY 30 //6

typedef struct pf_table{
	int TotalNum;
	int NextItem;
	PF_RULE_T Rule[MAX_CLIENT_FILTER_ENTRY];
} PF_TABLE_T;

typedef struct MF_RULE {
	int Item;	//0
	PF_Active_E Active;	//1
	PF_Action_E Action;	//2
	PF_Log_E Log;	//2
	char MAC_Filter_Address[20];
} MF_RULE_T;

typedef struct mf_table{
	int TotalNum;
	int NextItem;
	MF_RULE_T Rule[MAX_CLIENT_MACFILTER_ENTRY];
} MF_TABLE_T;

typedef struct pf_App_sel {
	int protocol;
	int direction;
	char* service;
	int dstprtf;
	int dstprte;
} PF_APP_SEL;

#endif /* __PF_CONFIG_H */
