/*
 *  pwduser.htm: User Password Configuration
 */
#include "webs.h"
#include "pwduser.h"
#include "um.h"
#include "locale.h"

extern char *PWDUser_L1[];
extern char *PWDUser_L2[];
extern char *PWDUser_L3[];
extern char *PWDUser_L4[];

static int get_admin_user (int ejid, webs_t wp, int argc, char_t **argv);
static int get_user_pwd (int ejid, webs_t wp, int argc, char_t **argv);
static int get_user_pwd_x (int ejid, webs_t wp, int argc, char_t **argv);
static int get_user_valid (int ejid, webs_t wp, int argc, char_t **argv);
static int get_user_valid_TorF (int ejid, webs_t wp, int argc, char_t **argv);
static int get_js_file (int ejid, webs_t wp, int argc, char_t **argv);

void form_pwdcreate_conf(webs_t wp, char_t * path,char_t * query);
void form_pwduseredit_conf(webs_t wp, char_t * path,char_t * query);
void form_pwduserdelete_conf(webs_t wp, char_t * path,char_t * query);

int get_number_of_user();
int get_number_of_user(){
	int num_of_user=0;
	char_t	*userid;
	userid=umGetFirstUser();
	userid=umGetNextUser(userid);
	while (userid)
	{
		num_of_user++;
		userid=umGetNextUser(userid);
	}
	return num_of_user;
}

static int get_admin_user (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t	*userid;
	//char_t UserName[256];
	//char_t UserPassword[256];
	char_t UserValid[16];
	int i=0;
	userid=umGetFirstUser();
	userid=umGetNextUser(userid);
	while (userid)
	{
		i++;
		if (umGetUserEnabled(userid)==TRUE)
			strcpy(UserValid,PWDUser_L3[locale_config.locale]);
		else
			strcpy(UserValid,PWDUser_L4[locale_config.locale]);
		websWrite(wp,T("<TR><TD>%s</TD>\n"),UserValid);
		websWrite(wp,T("<TD><NOBR><I>%s</I></NOBR></TD>\n"),userid);
		websWrite(wp,T("<form name=pwdedit action=pwduser_edit.asp method=post>\n"));
		websWrite(wp,T("<INPUT type=hidden name=edituserid value=%s>\n"),userid);
		websWrite(wp,T("<td><nobr><a href=\"javascript:pwduser_edit(%d)\">%s<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"),i,PWDUser_L1[locale_config.locale]);
		websWrite(wp,T("</form>\n"));
		websWrite(wp,T("<form name=pwddelete action=pwduser_delete.asp method=post>\n"));
		websWrite(wp,T("<INPUT type=hidden name=deleteuserid value=%s>\n"),userid);
		websWrite(wp,T("<td><nobr><a href=\"javascript:pwduser_delete(%d)\">%s<img align=middle border=0 src=/link1.gif></a></nobr></td></tr>\n"),i,PWDUser_L2[locale_config.locale]);		
		websWrite(wp,T("</form>\n"));
		userid=umGetNextUser(userid);
	}
	return 1;	
}

static int get_js_file (int ejid, webs_t wp, int argc, char_t **argv)
{
	int num;
	num=get_number_of_user();
	//DPRINTF("num:%d\n",num);
	if (num==0)
		websWrite(wp,T(""));
	else if (num==1){
		websWrite(wp,T("<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("function pwduser_edit(){\n"));
		websWrite(wp,T("document.pwdedit.submit();\n"));
		websWrite(wp,T("return true;\n"));
		websWrite(wp,T("}\n"));
		websWrite(wp,T("function pwduser_delete(){\n"));
		websWrite(wp,T("document.pwddelete.submit();\n"));
		websWrite(wp,T("return true;\n"));
		websWrite(wp,T("}\n"));
		websWrite(wp,T("</SCRIPT>\n"));
	}
	else{
		websWrite(wp,T("<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("function pwduser_edit(t){\n"));
		websWrite(wp,T("document.pwdedit[t-1].submit();\n"));
		websWrite(wp,T("return true;\n"));
		websWrite(wp,T("}\n"));
		websWrite(wp,T("function pwduser_delete(t){\n"));
		websWrite(wp,T("document.pwddelete[t-1].submit();\n"));
		websWrite(wp,T("return true;\n"));
		websWrite(wp,T("}\n"));
		websWrite(wp,T("</SCRIPT>\n"));
	}
	return 0;
}

static int get_user_pwd (int ejid, webs_t wp, int argc, char_t **argv)
{
	return	websWrite(wp,T("%s"),umGetUserPassword(argv[0]));
}

static int get_user_pwd_x (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i;
	for (i=0;i<strlen(umGetUserPassword(argv[0]));i++)
		websWrite(wp,T("x"));
	return 0;
}


static int get_user_valid (int ejid, webs_t wp, int argc, char_t **argv)
{
	if (umGetUserEnabled(argv[0])==TRUE)
	{
		websWrite(wp,T("<option value=FALSE>%s</option>\n"),PWDUser_L4[locale_config.locale]);
		websWrite(wp,T("<option value=TRUE selected>%s</option>\n"),PWDUser_L3[locale_config.locale]);
	}
	else
	{
		websWrite(wp,T("<option value=FALSE selected>%s</option>\n"),PWDUser_L4[locale_config.locale]);
		websWrite(wp,T("<option value=TRUE>%s</option>\n"),PWDUser_L3[locale_config.locale]);
	}
	return 0;
}

static int get_user_valid_TorF (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t UserValid[16];
	
	if (umGetUserEnabled(argv[0])==TRUE)
		strcpy(UserValid,PWDUser_L3[locale_config.locale]);
	else
		strcpy(UserValid,PWDUser_L4[locale_config.locale]);
	return 	websWrite(wp,"%s",UserValid);		
}



void form_pwdcreate_conf(webs_t wp, char_t * path, char_t * query)
{
	char_t *buf=NULL;
	char_t UserName[256];
	char_t UserPassword[256];
	char_t UserValid[16];
	int nCheck=0;
	
	buf=websGetVar(wp, T("UserName"), "");
        strcpy(UserName,buf);
        
        buf=websGetVar(wp, T("UserPassword"), "");
        strcpy(UserPassword,buf);
	
	buf=websGetVar(wp, T("UserValid"), "");
        strcpy(UserValid,buf);
	
	if (strcmp(UserValid,"TRUE")!=0)
		nCheck = umAddUser(UserName, UserPassword, T("users"),  FALSE, TRUE);
	else
		nCheck = umAddUser(UserName, UserPassword, T("users"),  FALSE, FALSE);
				
	if (nCheck != 0) {

		char_t * strError;
		char_t *alertmsg = "alert(\"%s\");\nlocation.replace(\"/pwdadmin.asp\");\n"; // KenWang added 2005/05/30

			switch (nCheck) {
			case UM_ERR_DUPLICATE:
				strError = T("User already exists.");
				break;

			case UM_ERR_BAD_NAME:
				strError = T("Invalid user name.");
				break;

			case UM_ERR_BAD_PASSWORD:
				strError = T("Invalid password.");
				break;

			case UM_ERR_NOT_FOUND:
				strError = T("Invalid or unselected group.");
				break;

			default:
				strError = T("Error writing user record.");
				break;
			}

			DPRINTF("Unable to add user, \"%s\".  %s",
				UserName, strError);
			// KenWang added 2005/05/30: show message if error occurs
			if(nCheck == UM_ERR_DUPLICATE || nCheck == UM_ERR_BAD_NAME ||
					nCheck == UM_ERR_BAD_PASSWORD)
			{
				websWrite(wp, T("<script language=\"javascript\">\n"));
				websWrite(wp, T(alertmsg), strError);
				websWrite(wp, T("</script>\n"));
				websFooter(wp);
				websDone(wp, 200);
			}
			
		} else {
			
			if (umCommit(T("webuser.txt")) != 0) {
				
				DPRINTF("ERROR: Unable to save user configuration.");
			} 
			else {
				
				websRedirect(wp, "pwdadmin.asp");
			}
		}
}
void form_pwduseredit_conf(webs_t wp, char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char_t UserName[256];
	char_t UserPassword[256];
	char_t UserValid[16];

	buf=websGetVar(wp, T("UserName"), "");
        strcpy(UserName,buf);
        
        buf=websGetVar(wp, T("UserPassword"), "");
        strcpy(UserPassword,buf);
	
	buf=websGetVar(wp, T("UserValid"), "");
        strcpy(UserValid,buf);
        
        umSetUserPassword(UserName, UserPassword);
        if (strcmp(UserValid,"TRUE")!=0)
		umSetUserEnabled(UserName,FALSE);
	else
		umSetUserEnabled(UserName, TRUE);
	
	if (umCommit(T("webuser.txt")) != 0){ 
		DPRINTF("ERROR: Unable to save user configuration.");
	}
	else 
        	websRedirect(wp, "pwdadmin.asp");
}
void form_pwduserdelete_conf(webs_t wp, char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char_t UserName[256];
	
	buf=websGetVar(wp, T("UserName"), "");
        strcpy(UserName,buf);
        
	umDeleteUser(UserName);	
	
	if (umCommit(T("webuser.txt")) != 0){ 
		DPRINTF("ERROR: Unable to save user configuration.");
	}
	else 
        	websRedirect(wp, "pwdadmin.asp");
}

void DefineWebFunctions_pwduser()
{
	websAspDefine(T("get_admin_user"), get_admin_user);  
	websAspDefine(T("get_user_pwd"), get_user_pwd);  
	websAspDefine(T("get_user_pwd_x"), get_user_pwd_x);  
	websAspDefine(T("get_user_valid"), get_user_valid);  
	websAspDefine(T("get_user_valid_TorF"), get_user_valid_TorF);  
	websAspDefine(T("get_js_file"), get_js_file);  
	
	websFormDefine(T("pwdcreate"), form_pwdcreate_conf);
	websFormDefine(T("pwduseredit"), form_pwduseredit_conf);
	websFormDefine(T("pwduserdelete"), form_pwduserdelete_conf);
}
