/*
 *  qos.c: Packet Filter Configuration
 *   NOTE NOTE our IP QOS provides reserved (guaranteed) bandwith with or without Borrowing Prioirity
 */
#include <sys/wait.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/types.h>
#include "webs.h"
#include "qos.h"
#include "uemf.h"
#include "qos_conf.h"
#include "filem.h"
#include "locale.h"
#include <linux/tc3162dmtctrl.h>
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"

extern char *Qos_L1[];
extern char *Qos_L2[];
extern char *Qos_L3[];
extern char *Qos_L4[];
extern char *Qos_L5[];
extern char *Qos_L6[];
extern char *Qos_L7[];
extern char *Qos_L8[];
extern char *Qos_L9[];
extern char *Qos_L10[];
extern char *Qos_L11[];
extern char *Qos_L12[];
extern char *Qos_L13[];
extern char *Qos_L14[];
extern char *Qos_L15[];
extern char *Qos_L16[];
extern char *Qos_L17[];
extern char *Qos_L18[];
extern char *Qos_L19[];
extern char *Qos_L20[];
extern char *Qos_L21[];
extern char *Qos_L22[];
extern char *Qos_L23[];
extern char *Qos_L24[];

extern char *URL_L7[];
extern char *URL_L8[];
extern char *URL_L9[];
extern char *URL_L10[];
extern char *URL_L11[];
extern char *URL_L12[];
extern char *URL_L13[];
extern char *URL_L14[];

extern int LANGUAGE_INDEX;
extern char *dscpMarkingList[6][15];

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
#if 0
static void formAppl_helper (webs_t wp, char_t * path, char_t * query);
#endif

static inline char* inet_ntoa_b(struct in_addr inet_addr,char* dest_string) {
	strcpy(dest_string,inet_ntoa(inet_addr));
			return dest_string;
}

static char str_wanip[20];
static char buf1[64];
static char 	funcNum[4];
extern void getDownUpStreamRate(int *downlinkspeed,int *uplinkspeed);


// qos.asp
// qos1.asp
// albert 20030128
static void DefineQOSConfig();
//void GetClinetFilterToPFTable(QOS_TABLE_T *table);
//void SetPFTableToClinetFilter(QOS_TABLE_T *table);
int GetConfigToQOSTable(QOS_TABLE_T *table);
int SetQOSSTableToConfig(QOS_TABLE_T *table);
//int CreateQOSTableToScript(QOS_TABLE_T *table,int outBoundRule,int inBoundRule);
//#define inet_ntoa_b(inet_addr,dest_string) strcpy(dest_string, inet_ntoa(inet_addr))
// web pages function
static void formQOS(webs_t wp, char_t *path, char_t *query);
static int aspQOSShow(int eid, webs_t wp, int argc, char_t **argv);
// qos1.asp
static int aspQOS1_Now(int eid, webs_t wp, int argc, char_t **argv);
static int aspQOS1_fwNow2(void);
static int aspQOS1_Page(int eid, webs_t wp, int argc, char_t **argv);
static void formQOS1(webs_t wp, char_t *path, char_t *query);
static int aspIspBandwidthType (int eid, webs_t wp, int argc, char_t ** argv);
static int aspIspBandwidthManualInput (int eid, webs_t wp, int argc, char_t ** argv);
static int aspIspBandwidthManualInputValue (int eid, webs_t wp, int argc, char_t ** argv);


// select
extern char_t StringBuf[];

extern char_t *SelectListOption( char_t **Option_List, int num, int who);
/*
 * qos  function
 */
// albert 20030128
extern int QOS_Table_Init(QOS_TABLE_T *table);
extern int QOS_AddRule(QOS_TABLE_T *table, QOS_RULE_T *rule);
extern int QOS_DelRule(QOS_TABLE_T *table, int item);
extern int QOS_AdjustTable(QOS_TABLE_T *table);
extern int QOS_CopyTable(QOS_TABLE_T *DstTable, QOS_TABLE_T *SrcTable);
extern int QOS_SetRule(QOS_TABLE_T *table, QOS_RULE_T *rule, int item);
extern void printBlockMode(TIME_BLOCK_T *timeblock,char *blockMode,int isBlocked);
extern void run_task(char *cmd, ...);

static void DefineQOSConfig();

void DefineWebFunctions_QOS() {
	DefineQOSConfig();
}

/*
 * albert 20030207 for qos.asp, qos1.asp
 */
QOS_TABLE_T QOS_Table, QOS_TableShow;
int qosIfAnyRulesExist(QOS_TABLE_T *table)
{
	QOS_RULE_T *rule;
	int i;
	
	for (i = 0; i < MAX_RULE; i++) 
	{
		rule = &table->Rule[i];
		if( rule->Item != 0 ) 
		{
			 if(rule->Flow==QOS_Flow_OUT)
			 	return 1;
			 else if(rule->Flow==QOS_Flow_IN)
			 	return 1;
		}// rule != 0
	}	
	return 0;
}

void leftOutgoingIncomingBandwidth(QOS_TABLE_T *table,int currentItem,int *leftOutgoing,int *leftIncoming)
{
	QOS_RULE_T *rule;
	int i;
	int leftOutgoingTmp=100;
	int leftIncomingTmp=100;
	
	for (i = 0; i < MAX_RULE; i++) 
	{
		rule = &table->Rule[i];
		if(( rule->Item != 0 )&&(i!= currentItem))
		{
			 if(rule->Flow==QOS_Flow_OUT)
			 {	
				 leftOutgoingTmp-=rule->gauranteeRate;
			 }
			 else
			 if(rule->Flow==QOS_Flow_IN)
			 {
				 leftIncomingTmp-=rule->gauranteeRate;
			 }
		}// rule != 0
	}		
	*leftOutgoing=leftOutgoingTmp;
	*leftIncoming=leftIncomingTmp;
}

extern int checked_function_enabled (char *parameter, webs_t wp, char_t **argv);

static int is_qos_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("QOS=",wp,argv);
}


static void DefineQOSConfig()
{
	//int outBoundRule,inBoundRule;
	QOS_Table_Init(&QOS_Table);
	QOS_Table_Init(&QOS_TableShow);
	// test cf2pf
//	GetClinetFilterToPFTable(&QOS_Table);
//	GetClinetFilterToPFTable(&QOS_TableShow);
	GetConfigToQOSTable(&QOS_Table);
	memcpy((void*)&QOS_TableShow, (void*)&QOS_Table, sizeof(QOS_TABLE_T));
	
	//GetConfigToQOSTable(&QOS_TableShow);

	/*if(qosIfAnyRulesExist(&QOS_Table,&outBoundRule,&inBoundRule))
	{
		CreateQOSTableToScript(&QOS_Table,outBoundRule,inBoundRule);
	} */
	websAspDefine(T("is_qos_enabled"), is_qos_enabled);
	// qos.asp
	websAspDefine(T("qosList"), aspQOSShow);
	websFormDefine(T("qos"), formQOS);
	//qos1.aspMinimum Guaranteed Rate)
	websAspDefine(T("QOS_Table"), aspQOS1_Page);
//	websAspDefine(T("upstreamRate"), aspUpstreamRate);
//	websAspDefine(T("downstreamRate"), aspDownstreamRate);
	websAspDefine(T("ISPBW"), aspIspBandwidthType);
	websAspDefine(T("ISPBW_MANU"), aspIspBandwidthManualInput);
	websAspDefine(T("ISPBW_MANU_VAL"), aspIspBandwidthManualInputValue);
	websFormDefine(T("qos1"), formQOS1);
#if 0
	websFormDefine (T ("qoshlp"), formAppl_helper);
#endif
	websAspDefine(T("qosNow"), aspQOS1_Now);
}

// PacketFilter asp function
// for qos.asp
static char qosUasgnString[] =
"<OPTION value=0         >Fixed (Maximum)</OPTION>" //49
"<OPTION value=1         >Guaranteed (Minimum)</OPTION>"; //54
static char* qosUasgnsptr[] =
{
	&qosUasgnString[16],
	&qosUasgnString[65],
	NULL
};
static char_t *TableFmtQosAsp="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
			     "<td>&nbsp;%s&nbsp;</td>"
			     "<td>&nbsp;%s&nbsp;</td>"
			     "<td>&nbsp;%s&nbsp;</td>"
			     "<td>&nbsp;%d%%%s %s&nbsp;</td></tr>";

static char_t *NonAssignedBandwidthRatioAsp=
"<tr><td class=header colSpan=5>%s</td></tr>"	
"<tr><td class=title>&nbsp;</td>"
"<td class=title colSpan=2>%s: "
	"<SELECT name=qosUasgn>\n"
	"%s"
	"</SELECT></td>\n"
"<td class=title>%s : <B>%d%%</B></td>"
"<td class=title>%s : <B>%d%%</B></td></tr>";	     		

static char kbpsDisplay[50]="";
static int downlinkspeed=0,uplinkspeed=0;
static int aspQOSShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i=0;
	char *prioStr[]={"High", "Normal", "Low"};
	int remaindingOutboundRate=100,remaindingInboundRate=100;//; 100 % default
	char rateString[60];
	QOS_RULE_T *rule;

	downlinkspeed=0;
	uplinkspeed=0;
	if(QOS_TableShow.ISPBandwidthType)
	{
		uplinkspeed=QOS_TableShow.ISPUpstreamInputRate;
		downlinkspeed=QOS_TableShow.ISPDownstreamInputRate;
	}
	else
	{
		getDownUpStreamRate(&downlinkspeed,&uplinkspeed);
	}
	for( i = 0; i < QOS_TableShow.TotalNum; i++)
	{
		rule = &QOS_TableShow.Rule[i];
		if( rule->Item != 0)
		{
			strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
			//DPRINTF("QOS: the str_wanip=%s\n",str_wanip);
			strcpy(kbpsDisplay,"");
			if((rule->Flow == QOS_Flow_OUT)&&uplinkspeed)
					sprintf(kbpsDisplay," (%dkbps)",(rule->gauranteeRate*((int)(((double)uplinkspeed)*0.9)))/100);
			if((rule->Flow == QOS_Flow_IN)&&downlinkspeed)
					sprintf(kbpsDisplay," (%dkbps)",(rule->gauranteeRate*((int)(((double)downlinkspeed)*0.85)))/100);
				
			if(rule->Flow == QOS_Flow_OUT)
			{
				remaindingOutboundRate-=rule->gauranteeRate;
			}
			else
			{
				remaindingInboundRate-=rule->gauranteeRate;
			}
			if(rule->RateType != QOS_Rate_Type_FIXED) 
				sprintf(rateString, "Minimum Guaranteed Rate with %s priority" ,prioStr[rule->Priority]);
			else
				sprintf(rateString, "Fixed Rate");

			nBytes += websWrite(wp, T(TableFmtQosAsp),
			// Radio value, int
			i+1,
			// checked or not
			(i == aspQOS1_fwNow2() ? "checked" : ""),
			rule->Name,
			(rule->timeblock.alwaysBlock? "Always On": "Day Time"),
			// 2 Flow, string
			(rule->Flow == QOS_Flow_OUT ? Qos_L19[locale_config.locale] : Qos_L20[locale_config.locale]),
			rule->gauranteeRate,kbpsDisplay,
			rateString
			);
			
		}// end if
	}
	
	//display nonassignd rate type
	{
		char* tmpbuf=NULL;
		int i=0;

		while(1)
		{
			tmpbuf =qosUasgnsptr[i];
			if(tmpbuf == NULL)
				break;
			if(QOS_TableShow.NonAsgnRateType == (i))
				memcpy(tmpbuf,"selected",8);
			else
				memset(tmpbuf,' ',8);
			i++;
		}
		
	}
	
	
	nBytes += websWrite(wp, 
	T(NonAssignedBandwidthRatioAsp),
	Qos_L1[locale_config.locale],
	Qos_L7[locale_config.locale],
	qosUasgnString,
	Qos_L19[locale_config.locale],
	remaindingOutboundRate,
	Qos_L20[locale_config.locale],
	remaindingInboundRate);
	return nBytes;
}

// qos.asp
static enum ClickOption QOS_Func = Click_Func_CENCEL;
static int QOS_Edit_Index = 0;

static int aspIspBandwidthType (int eid, webs_t wp, int argc, char_t ** argv)
{
	if(QOS_TableShow.ISPBandwidthType==atoi(argv[0]))// if configure type is the same as the query type
		return websWrite(wp, T("selected"));
	else
		return websWrite(wp, T(""));
}
static int aspIspBandwidthManualInput (int eid, webs_t wp, int argc, char_t ** argv)
{
	if(QOS_TableShow.ISPBandwidthType)// if manual then we allow it to input
		return websWrite(wp, T(""));
	else
		return websWrite(wp, T("disabled"));
}
static int aspIspBandwidthManualInputValue (int eid, webs_t wp, int argc, char_t ** argv)
{
	getDownUpStreamRate(&downlinkspeed,&uplinkspeed);
	if(atoi(argv[0]))//downstream
	{// If selected is Auto and ADSL is up, then take the sync rate
		if( (QOS_TableShow.ISPBandwidthType==0) && // if i Auto
			(downlinkspeed) )  
			return websWrite(wp, T("%d"),downlinkspeed);
		return websWrite(wp, T("%d"),QOS_TableShow.ISPDownstreamInputRate);
	}
	else
	{
		if( (QOS_TableShow.ISPBandwidthType==0) && // if i Auto
			(uplinkspeed) )  
			return websWrite(wp, T("%d"),uplinkspeed);
		return websWrite(wp, T("%d"),QOS_TableShow.ISPUpstreamInputRate);
	}
}

static int aspQOS1_fwNow2(void)
{
	switch(QOS_Func)
	{
		case Click_Func_EDIT:
		return QOS_Edit_Index;
		default:
		return QOS_TableShow.TotalNum-1;
	}
}

static void formQOS(webs_t wp, char_t *path, char_t *query)
{
	//enum PFOption Func = CENCEL;
	char_t *qosFUNC, *Idx;
	int ISPUpstreamInputRate,ISPDownstreamInputRate;

	qosFUNC = websGetVar(wp, T("qosFUNC"), "");
	QOS_Func = atoi(qosFUNC);
	Idx = websGetVar(wp, T("Idx"), "");
	QOS_Edit_Index = atoi(Idx);
	--QOS_Edit_Index;
	
	// Yes, we accept the configuration for ISP bandwidth configuration.
	QOS_TableShow.ISPBandwidthType = atoi(websGetVar(wp, T("ISPBW"), "0"));
	QOS_TableShow.NonAsgnRateType = atoi(websGetVar(wp, T("qosUasgn"), "0"));
	ISPUpstreamInputRate = atoi(websGetVar(wp, T("ISPBW_MANU_UP"), "0"));
	ISPDownstreamInputRate = atoi(websGetVar(wp, T("ISPBW_MANU_DN"), "0"));
	if(ISPUpstreamInputRate)
		QOS_TableShow.ISPUpstreamInputRate=ISPUpstreamInputRate;
	if(ISPDownstreamInputRate)
		QOS_TableShow.ISPDownstreamInputRate=ISPDownstreamInputRate;
	#if 0
	websHeader(wp);
	//pstr = websExpand(wp, NULL, "$COMPANY $SERVER_PORT $CONTENT_LENGTH $PATH_INFO", -1);
	//websWrite(wp, T("<body><h2>qosFUNC: %s %d, Idx: %s</h2>\n"), qosFUNC, Func, Idx);
	//websWrite(wp, T("PATH_INFO=%s\n"), gogetenv("PATH_INFO"));
	//websResponse(wp, 302, msgbuf, url);
	websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos1.asp\");</script>"));
	websFooter(wp);
	websDone(wp, 200);
	#else
	websHeader(wp);
	switch(QOS_Func)
	{
		case Click_Func_ADD:
		//websWrite(wp, T("<body><h2>ADD: %d, Idx: %s</h2>\n"), Func, Idx);
		if(QOS_TableShow.NextItem < MAX_RULE)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_EDIT:
		//websWrite(wp, T("<body><h2>EDIT: %d, Idx: %s</h2>\n"),Func, Idx);
		if(QOS_Edit_Index >= 0)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else// no select an item
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		//websRedirect(wp, "/qos.asp");
		break;
		case Click_Func_DEL:
		//websWrite(wp, T("<body><h2>DEL:  %d, Idx: %s</h2>\n"),QOS_Func, Idx);
		//websFooter(wp);
		//websDone(wp, 200);
		if(QOS_Edit_Index >= 0)
		{
			QOS_DelRule(&QOS_TableShow, QOS_Edit_Index);
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;

		case Click_Func_APPLY:
		{
			//char *pUpstreamRate,*pDownstreamRate;

			sprintf(funcNum,"%d",FUNCTION_NUM_QOS);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
			SetQOSSTableToConfig(&QOS_TableShow);
			QOS_CopyTable(&QOS_Table, &QOS_TableShow);
			if(qosIfAnyRulesExist(&QOS_Table))
			{
				//CreateQOSTableToScript(&QOS_Table,outBoundRule,inBoundRule);
				strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
				if(isValidIP(str_wanip))
					run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
				//else running when wan_ip ready.
			}
			else
			{
				unlink(QOS_CONF_FN_RULE_IPT_ADD);
				unlink(QOS_CONF_FN_RULE_IPT_DEL);
				unlink(QOS_CONF_FN_RULE_SHELL_ADD);
				unlink(QOS_CONF_FN_RULE_SHELL_DEL);
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
			}
		}
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;

		case Click_Func_CENCEL:
		QOS_CopyTable(&QOS_TableShow, &QOS_Table);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
		default:
			websRedirect(wp, "/qos.asp");
	}
	#endif
}

// for qos1.asp
// qos1, rule number
static int aspQOS1_Now(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(QOS_Func)
	{
		case Click_Func_ADD:
		return websWrite(wp, T("%d"), QOS_TableShow.NextItem);
		case Click_Func_EDIT:
		return websWrite(wp, T("%d"), QOS_Edit_Index);
		default:
		return websWrite(wp, T("%d"), QOS_TableShow.NextItem);
	}
}
static int returnFromAppl_helper=0;
static QOS_RULE_T gTmpRule;
static int dscpMarkingNum=12, dscpMarkingDefault=0; 
/*
static char *dscpMarkingList[]={"Disabled","Best Effort", "Premium",
	"Gold service(L)","Gold service(M)","Gold service(H)","Silver service(L)","Silver service(M)","Silver service(H)",
	"Bronze service(L)","Bronze service(M)","Bronze service(H)"};
*/
static	char_t *qos1_TableFmt1 =
	"<TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>\n"
	"<INPUT type=radio name=qosIO onclick=\"outIsClick(this.form);\" value=0 %s>%s &nbsp;&nbsp;&nbsp;\n"
	"<INPUT type=radio name=qosIO onclick=\"inIsClick(this.form);\" value=1 %s>%s &nbsp;&nbsp;&nbsp;\n"
	"</TD>\n"
	"</TR>\n";
static	char_t *qos1_TableFmt2_1 =
	"<TR>\n"
	"<TD class=title colSpan=1><nobr>%s &nbsp;"
//	"<a href=javascript:Helper()> Helper <img align=middle border=0 hspace=0 vspace=0 src=\"/link1.gif\"></a></nobr>"
	"</TD>\n"
 	"<TD class=title1 colSpan=3>\n"
	"<INPUT type=text name=qos_name maxlength=22 size=20 value=%s>\n"
#if 0
    "<INPUT type=\"button\" value=\"Helper\" onclick=\"Helper()\">\n\r"
#endif
	"</TD>\n</TR>\n"
	"<TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>\n"
	"<SELECT name=qosPT>\n"
	"%s"
	"</SELECT>\n"
	"</TD>\n"
	"</TR>\n";
	// active %s, packet type %s,
static	char_t *qos1_TableFmt3 =
	"<TR>  \n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=1>%s:\n"
	"<SELECT name=qosRT ONCHANGE=\"rtOnchange(this);\">\n"
	"%s"
	"</SELECT>\n"
	"</TD>\n"
	"<TD class=title1 colSpan=1>%s:&nbsp;&nbsp;&nbsp;&nbsp;\n"
	"<INPUT  type=text name=qosGR maxLength=12 size=2 value=%s><B>%%</B>\n" 
	"</TD>\n";
	char_t *qos1_TableFmt3_1 =
	"<TD class=title1 colSpan=1>%s:<BR>\n"
	"<SELECT name=qosPrio %s>\n"
	"%s"
	"</SELECT>\n"
	"</TD>\n"
	"</TR>\n";
static char_t *qos1_TableFmt3_5 =
	"<TR>  \n"
	"<TD class=title colSpan=1>%s<BR>%s</TD>\n"
	"<TD class=title1 colSpan=3>\n"
	"<SELECT name=dscpMark  %s>\n"
	"%s"
	"</SELECT>\n"
	"</TD>\n"
	"</TR>\n";
char_t *qos1_TableFmt4 =
	"<TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>&nbsp;%s&nbsp;<INPUT type=text name=qosLocalIpFrom maxlength=17 size=15 value=%s>\n"
	"&nbsp;%s&nbsp;<INPUT type=text name=qosLocalIpTo maxlength=17 size=15 value=%s>\n"
	"</TD>\n"
	"</TR></TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>&nbsp;%s&nbsp;<INPUT type=text name=qosRemoteIpFrom maxlength=17 size=15 value=%s>\n"
	"&nbsp;%s&nbsp;<INPUT type=text name=qosRemoteIpTo maxlength=17 size=15 value=%s>\n"
	"</TD>\n"
	"</TR>\n";
char_t *qos1_TableFmt6 =
	"<TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>&nbsp;%s&nbsp;<INPUT type=text name=qosLocalPF maxlength=17 size=15 value=%s>\n"
	"&nbsp;%s&nbsp;<INPUT type=text name=qosLocalPT maxlength=17 size=15 value=%s>\n"
	"</TD>\n"
	"</TR></TR>\n"
	"<TD class=title colSpan=1>%s</TD>\n"
	"<TD class=title1 colSpan=3>&nbsp;%s&nbsp;<INPUT type=text name=qosRemotePF maxlength=17 size=15 value=%s>\n"
	"&nbsp;%s&nbsp;<INPUT type=text name=qosRemotePT maxlength=17 size=15 value=%s>\n"
	"</TD>\n"
	"</TR>\n"
	"<TR>\n";
// Yes, we borrow the timing block from Url filtering
extern char_t *url1_TableFmt3,*url1_TableFmt3_1;

static int aspQOS1_Page(int eid, webs_t wp, int argc, char_t **argv)
{
	const int PacketTypeNum=5, PacketTypeDefault=0; char *PacketTypeList[]={Qos_L21[locale_config.locale], "TCP", "UDP", "ICMP","GRE"};
	const int RateTypeNum=2, RateTypeDefault=0; char *RateTypeList[]={"Fixed (Maximum)", "Guaranteed (Minimum)"};
	const int PrioNum=3, PrioDefault=1; char *PrioList[]={Qos_L22[locale_config.locale],Qos_L23[locale_config.locale],Qos_L24[locale_config.locale]};
	char LocalPortFrom[6]="";
	char LocalPortTo[6]="";
	char RemotePortFrom[6]="";
	char RemotePortTo[6]="";
	char gRate[10];
	QOS_RULE_T *rule;
	int leftOutgoing,leftIncoming;
	
	//Calulate left outoging and incoming bandwidth
	

	if ((QOS_Func == Click_Func_ADD) && (returnFromAppl_helper == 0))
	{	// A new one and also not return form the helper editing pages		
		char defaultName[10];
		
		sprintf(defaultName,"APPL%d",QOS_TableShow.NextItem+1);
		// caculate the remaining ratio		
		leftOutgoingIncomingBandwidth(&QOS_TableShow,QOS_TableShow.NextItem+1,&leftOutgoing,&leftIncoming);
		websWrite(wp, T("<INPUT type=hidden name=lfOutBw value=%d >"),leftOutgoing);
		websWrite(wp, T("<INPUT type=hidden name=lfInBw value=%d >"),leftIncoming);
		
		websWrite(wp, T(qos1_TableFmt1),
			Qos_L3[locale_config.locale],
			// 1 Flow Radio Out or In, string
			"checked",
			Qos_L19[locale_config.locale],
			// 2 Flow Radio In, string
			"",
			Qos_L20[locale_config.locale]);
		websWrite(wp, T(qos1_TableFmt2_1),
			Qos_L4[locale_config.locale],
			defaultName,
			Qos_L5[locale_config.locale],
			// 4 PacketType, Any, Tcp, Udp, Icmp, string
			SelectListOption(PacketTypeList, PacketTypeNum, PacketTypeDefault));
		websWrite(wp, T(qos1_TableFmt3),
			// 5 assigned data rate
			Qos_L6[locale_config.locale],
			Qos_L7[locale_config.locale],
			SelectListOption(RateTypeList, RateTypeNum, RateTypeDefault),
			Qos_L8[locale_config.locale],
			""			
			); 
			// 6 Priority, string
		websWrite(wp, T(qos1_TableFmt3_1),
			Qos_L9[locale_config.locale],
			"disabled",//default we have the fixed rate and without priority
			SelectListOption(PrioList, PrioNum, PrioDefault));
		websWrite(wp, T(qos1_TableFmt3_5),
			// 14 DCSP Marking
			Qos_L10[locale_config.locale],
			Qos_L19[locale_config.locale],
			"",
			SelectListOption(dscpMarkingList[locale_config.locale], dscpMarkingNum, dscpMarkingDefault));
		websWrite(wp, T(qos1_TableFmt4),
			Qos_L11[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"",
			Qos_L12[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"");
		websWrite(wp, T(qos1_TableFmt6),
			Qos_L14[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			"",
			Qos_L15[locale_config.locale],
			Qos_L13[locale_config.locale],
			"",
			Qos_L2[locale_config.locale],
			""
			);
		websWrite(wp, T(url1_TableFmt3),
		Qos_L16[locale_config.locale],
		"checked", // default is always block
		Qos_L17[locale_config.locale],
			"",
		Qos_L18[locale_config.locale],
			DEFAULT_TIME_BLOCK_FROM_HOUR,
			DEFAULT_TIME_BLOCK_FROM_MIN,
			URL_L7[locale_config.locale],	
			DEFAULT_TIME_BLOCK_TO_HOUR,
			DEFAULT_TIME_BLOCK_TO_MIN);
		websWrite(wp, T(url1_TableFmt3_1),
			"",URL_L8[locale_config.locale],
			"",URL_L9[locale_config.locale],
			"",URL_L10[locale_config.locale],
			"",URL_L11[locale_config.locale],
			"",URL_L12[locale_config.locale],
			"",URL_L13[locale_config.locale],
			"",URL_L14[locale_config.locale]);
	}
	else
    {
		char dscpMarking[10]="";
		if (returnFromAppl_helper)
		{
			rule = &gTmpRule;
			returnFromAppl_helper = 0;	//reset it     
			leftOutgoingIncomingBandwidth(&QOS_TableShow,QOS_TableShow.NextItem+1,&leftOutgoing,&leftIncoming);
		}
		else
		{
			rule = &QOS_TableShow.Rule[QOS_Edit_Index];
			leftOutgoingIncomingBandwidth(&QOS_TableShow,QOS_Edit_Index,&leftOutgoing,&leftIncoming);
		}

		// caculate the remaining ratio		
		websWrite(wp, T("<INPUT type=hidden name=lfOutBw value=%d >"),leftOutgoing);
		websWrite(wp, T("<INPUT type=hidden name=lfInBw value=%d >"),leftIncoming);
		websWrite(wp, T(qos1_TableFmt1),
			// 1 Flow Radio Out or In, string
			Qos_L3[locale_config.locale],
			(rule->Flow == QOS_Flow_OUT ? "checked" : ""),
			Qos_L19[locale_config.locale],
			// 2 Flow Radio In, string
			(rule->Flow == QOS_Flow_IN ? "checked" : ""),
			Qos_L20[locale_config.locale]
			);
		websWrite(wp, T(qos1_TableFmt2_1),
			Qos_L4[locale_config.locale],
			rule->Name,
			Qos_L5[locale_config.locale],
			// 4 PacketType, Any, Tcp, Udp, Icmp, string
			SelectListOption(PacketTypeList,PacketTypeNum,
				rule->AppType)
			);
			
			sprintf(gRate,"%d",rule->gauranteeRate);
		websWrite(wp, T(qos1_TableFmt3),
			// 5 assigned data rate
			Qos_L6[locale_config.locale],
			Qos_L7[locale_config.locale],
			SelectListOption(RateTypeList, RateTypeNum,rule->RateType),
			Qos_L8[locale_config.locale],
			gRate); 
		websWrite(wp, T(qos1_TableFmt3_1),
			Qos_L9[locale_config.locale],
			// 6 Priority, string
			(rule->RateType == QOS_Rate_Type_FIXED ? "disabled" : ""),//default we have the fixed rate and without priority
			SelectListOption(PrioList, PrioNum, rule->Priority));
			
		if(rule->dscpMarking<0)
			rule->dscpMarking=0;
		if(rule->Flow == QOS_Flow_IN)
			strcpy(dscpMarking,"disabled");
		websWrite(wp, T(qos1_TableFmt3_5),
			Qos_L10[locale_config.locale],
			Qos_L19[locale_config.locale],
		dscpMarking,SelectListOption(dscpMarkingList[locale_config.locale], dscpMarkingNum, rule->dscpMarking));				
		if(rule->LocalPortStart)
			sprintf(LocalPortFrom, "%d",rule->LocalPortStart);
		if(rule->LocalPortEnd)
			sprintf(LocalPortTo, "%d",rule->LocalPortEnd);
		if(rule->RemotePortStart)
			sprintf(RemotePortFrom, "%d",rule->RemotePortStart);
		if(rule->RemotePortStart)
			sprintf(RemotePortTo, "%d",rule->RemotePortEnd);

		websWrite(wp, T(qos1_TableFmt4),
			Qos_L11[locale_config.locale],
			Qos_L13[locale_config.locale],
			rule->LocalIpStart,
			Qos_L2[locale_config.locale],
			rule->LocalIpEnd,
			Qos_L12[locale_config.locale],
			Qos_L13[locale_config.locale],
			rule->RemoteIpStart,
			Qos_L2[locale_config.locale],
			rule->RemoteIpEnd);		
		websWrite(wp, T(qos1_TableFmt6),
			Qos_L14[locale_config.locale],
			Qos_L13[locale_config.locale],
			LocalPortFrom,
			Qos_L2[locale_config.locale],
			LocalPortTo,
			Qos_L15[locale_config.locale],
			Qos_L13[locale_config.locale],
			RemotePortFrom,
			Qos_L2[locale_config.locale],
			RemotePortTo);
		websWrite(wp, T(url1_TableFmt3),
		Qos_L16[locale_config.locale],
			(rule->timeblock.alwaysBlock)?"checked":"", 
		Qos_L17[locale_config.locale],
			(rule->timeblock.alwaysBlock)?"":"checked",
		Qos_L18[locale_config.locale],
			rule->timeblock.time_start/60,
			rule->timeblock.time_start%60,
			URL_L7[locale_config.locale],	
			rule->timeblock.time_stop/60,
			rule->timeblock.time_stop%60);
			
		websWrite(wp, T(url1_TableFmt3_1),
			(rule->timeblock.days_match&0x01)?"checked":"",
			URL_L8[locale_config.locale],	
			(rule->timeblock.days_match&0x02)?"checked":"", 
			URL_L9[locale_config.locale],	
			(rule->timeblock.days_match&0x04)?"checked":"", 
			URL_L10[locale_config.locale],	
			(rule->timeblock.days_match&0x08)?"checked":"", 
			URL_L11[locale_config.locale],	
			(rule->timeblock.days_match&0x10)?"checked":"", 
			URL_L12[locale_config.locale],	
			(rule->timeblock.days_match&0x20)?"checked":"", 
			URL_L13[locale_config.locale],	
			(rule->timeblock.days_match&0x40)?"checked":"",
			URL_L14[locale_config.locale]);	
	}
	return 0;
}// end aspQOS1_Page


// for form qos1.asp
static void formQOS1(webs_t wp, char_t *path, char_t *query)
{
	char_t *pqosPrio;
	char_t *pqosFUNC,*pdscpMark;
	char_t *pqosHelper;

	memset(&gTmpRule, 0, sizeof(QOS_RULE_T));

	pqosFUNC = websGetVar(wp, T("qosFUNC"), "0");
	pqosPrio = websGetVar(wp, T("qosPrio"), "0");
	pdscpMark = websGetVar(wp, T("dscpMark"), "0");
	 

	// Shall we check the duplucate name????
	strcpy(gTmpRule.Name, websGetVar(wp, T("qos_name"), "APPL"));// Shall be appl%d????
	gTmpRule.Item = atoi(websGetVar(wp, T("qosNow"), "0"))+1; 
	gTmpRule.Flow = atoi(websGetVar(wp, T("qosIO"), "0"));
	gTmpRule.AppType = atoi(websGetVar(wp, T("qosPT"), "0"))-1;
	gTmpRule.RateType = atoi(websGetVar(wp, T("qosRT"), "0"))-1;//3
	if(atoi(pqosPrio)<=0)
	{// being disabled, give normal priority as default
		gTmpRule.Priority = 1;
	}
	else
		gTmpRule.Priority=atoi(pqosPrio)-1;
	strcpy(gTmpRule.LocalIpStart,websGetVar(wp, T("qosLocalIpFrom"), "")); 
	strcpy(gTmpRule.LocalIpEnd,websGetVar(wp, T("qosLocalIpTo"), "")); 
	gTmpRule.LocalPortStart = atoi(websGetVar(wp, T("qosLocalPF"), "0"));
	gTmpRule.LocalPortEnd = atoi(websGetVar(wp, T("qosLocalPT"), "0"));
	strcpy(gTmpRule.RemoteIpStart,websGetVar(wp, T("qosRemoteIpFrom"), "")); 
	strcpy(gTmpRule.RemoteIpEnd,websGetVar(wp, T("qosRemoteIpTo"), "")); 
	gTmpRule.RemotePortStart = atoi(websGetVar(wp, T("qosRemotePF"), "0"));
	gTmpRule.RemotePortEnd = atoi(websGetVar(wp, T("qosRemotePT"), "0"));
	gTmpRule.gauranteeRate = atoi(websGetVar(wp, T("qosGR"), "0"));
	if(atoi(pdscpMark)<0)
	{// being disabled, give diabled as default
		gTmpRule.dscpMarking = 0;
	}
	else
		gTmpRule.dscpMarking=atoi(pdscpMark)-1;
	gTmpRule.timeblock.alwaysBlock = atoi(websGetVar(wp, T("urlfBM"), "0"));
	gTmpRule.timeblock.time_start=atoi(websGetVar(wp, T("urlfBHour"), "0"))*60+atoi(websGetVar(wp, T("urlfBMin"), "0"));
	gTmpRule.timeblock.time_stop=atoi(websGetVar(wp, T("urlfEHour"), "0"))*60+atoi(websGetVar(wp, T("urlfEMin"), "0"));
	if(atoi(websGetVar(wp, T("BTSun"), "0"))==1) gTmpRule.timeblock.days_match=0x01;
	if(atoi(websGetVar(wp, T("BTMon"), "0"))==1) gTmpRule.timeblock.days_match|=0x02;
	if(atoi(websGetVar(wp, T("BTTue"), "0"))==1) gTmpRule.timeblock.days_match|=0x04;
	if(atoi(websGetVar(wp, T("BTWed"), "0"))==1) gTmpRule.timeblock.days_match|=0x08;
	if(atoi(websGetVar(wp, T("BTThu"), "0"))==1) gTmpRule.timeblock.days_match|=0x10;
	if(atoi(websGetVar(wp, T("BTFri"), "0"))==1) gTmpRule.timeblock.days_match|=0x20;
	if(atoi(websGetVar(wp, T("BTSat"), "0"))==1) gTmpRule.timeblock.days_match|=0x40;

	websHeader(wp);
	if( atoi(pqosFUNC) == 6 )
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos1.asp\");</script>"));
	else
	{
		pqosHelper = websGetVar (wp, T ("qosHelper"), "0");	// if detail press, and which detailed
		if (atoi (pqosHelper) > 0)
		{
			//we shall keep the editing one..
			websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/appl_helper.htm\");</script>"));
		}
		else
		{
		switch(QOS_Func)
		{
			case Click_Func_ADD:
			QOS_AddRule(&QOS_TableShow, &gTmpRule);
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"add\");</script>"));
			break;
			case Click_Func_EDIT:
			//QOS_SetRule(&QOS_TableShow, &gTmpRule, gTmpRule.Item-1);
			memcpy(&QOS_TableShow.Rule[gTmpRule.Item-1],&gTmpRule,sizeof(QOS_RULE_T));
			//websWrite(wp, T("<script language=\"JavaScript\">alert(\"set\");</script>"));
			break;
			default:
			// do nothing
			break;
		}
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/qos.asp\");</script>"));
		}
	}
	websFooter(wp);
	websDone(wp, 200);

}// end formQOS1

#if 0
// for form appl_helper.htm keywords
static void
formAppl_helper (webs_t wp, char_t * path, char_t * query)
{
	int qoshlpNo;
	int portFrom=0,portTo=0;
	int qosConnFr = atoi(websGetVar(wp, T("ConnFr"), "0"));
	qoshlpNo=atoi (websGetVar (wp, T ("qoshlpNo"), "0"));
	gTmpRule.AppType=1;// default is TCP
	returnFromAppl_helper=1;
	gTmpRule.LocalPortStart=0;
	gTmpRule.LocalPortEnd=0;
	gTmpRule.RemotePortStart=0;
	gTmpRule.RemotePortEnd=0;
	switch(qoshlpNo)
	{
		case 1:
		portFrom=20;
		portTo=21;
		strcpy(gTmpRule.Name,"FTP");
		break;
		case 2:
		portFrom=22;
		portTo=22;
		strcpy(gTmpRule.Name,"SSH");
		break;
		case 3:
		portFrom=23;
		portTo=23;
		strcpy(gTmpRule.Name,"TELNET");
		break;
		case 4:
		portFrom=25;
		portTo=25;
		strcpy(gTmpRule.Name,"SMTP");
		break;
		case 5:
		portFrom=80;
		portTo=80;
		strcpy(gTmpRule.Name,"HTTP_Server");
		break;
		case 6:
		portFrom=110;
		portTo=110;
		strcpy(gTmpRule.Name,"POP3");
		break;
		case 7:
		gTmpRule.AppType=2;
		portFrom=123;
		portTo=123;
		strcpy(gTmpRule.Name,"NTP");
		break;
		case 8:
		gTmpRule.AppType=2;
		portFrom=161;
		portTo=161;
		strcpy(gTmpRule.Name,"SNMP");
		break;
		case 9:
		portFrom=443;
		portTo=443;
		strcpy(gTmpRule.Name,"HTTPS");
		break;
		case 10:
		gTmpRule.AppType=2;
		portFrom=500;
		portTo=500;
		strcpy(gTmpRule.Name,"IKE");
		break;
		case 11:
		gTmpRule.AppType=2;
		portFrom=514;
		portTo=514;
		strcpy(gTmpRule.Name,"syslog");
		break;
		case 12:
		portFrom=1503;
		portTo=1503;
		strcpy(gTmpRule.Name,"T_120");
		break;
		case 13:
		gTmpRule.AppType=2;
		portFrom=1701;
		portTo=1701;
		strcpy(gTmpRule.Name,"L2TP");
		break;
		case 14:
		portFrom=1720;
		portTo=1720;
		strcpy(gTmpRule.Name,"H_323");
		break;
		case 15:
		portFrom=1723;
		portTo=1723;
		strcpy(gTmpRule.Name,"PPTP");
		break;
		case 16:
		gTmpRule.AppType=2;
		portFrom=1812;
		portTo=1812;
		strcpy(gTmpRule.Name,"Radius");
		break;
		case 17:
		gTmpRule.AppType=2;
		portFrom=1813;
		portTo=1813;
		strcpy(gTmpRule.Name,"Radacct");
		break;
		case 18:
		portFrom=5631;
		portTo=5631;
		strcpy(gTmpRule.Name,"pcAnywhere");
		break;
		case 19:
		portFrom=5900;
		portTo=5900;
		strcpy(gTmpRule.Name,"VNC");
		break;
		case 20:
		portFrom=7648;
		portTo=7648;
		strcpy(gTmpRule.Name,"CUSeeMe");
		break;
	}
	  
	if(qosConnFr)
	{// connection from Remote Machine
		gTmpRule.LocalPortStart=portFrom;
		gTmpRule.LocalPortEnd=portTo;
	}
	else
	{
		gTmpRule.RemotePortStart=portFrom;
		gTmpRule.RemotePortEnd=portTo;
	}
	websHeader(wp);
	websWrite (wp,T("<script language=\"JavaScript\">location.replace(\"/qos1.asp\");</script>"));
	websFooter (wp);
	websDone (wp, 200);
}// end
#endif

int GetConfigToQOSTable(QOS_TABLE_T *table)
{
	int i;
	char signature[4];
	int version;	
	QOS_RULE_T *rule;
	FILE *fp;
	int ISPBandwidthType,ISPUpstreamInputRate,ISPDownstreamInputRate,NonAsgnRateType;
	

	//fp = fopen(PROGRAM_SCRIPT_FILE, "r");
	fp = fopen("/flash/qos_conf1.conf", "r");
	if (!fp) {
		return -1;
	}
	fscanf(fp,"%s\n", signature);
	if(strcmp(signature,"QOS"))
	{
		fclose(fp);
		DPRINTF("no signature found for QOS....\n");
		return -1;
	}
	fscanf(fp,"%d\n", &version);
	if(version !=0x10)// we can not forward version compatible
	{
		DPRINTF("wrong version ....\n");
		fclose(fp);
		return -1;
	}

	if ( fscanf(fp,"%d\n",&ISPBandwidthType)!=1)
	{
		DPRINTF("old verison, do not have  ISPBandwidthType....\n");
		fclose(fp);
		return -1;
	} 
	if ( fscanf(fp,"|%d|%d|\n",&ISPUpstreamInputRate,&ISPDownstreamInputRate)!=2)
	{
		DPRINTF("old verison, do not have  ISPUpstreamInputRate....\n");
		fclose(fp);
		return -1;
	} 
	memset( (void *)table, 0, sizeof(QOS_TABLE_T));
	table->ISPBandwidthType=ISPBandwidthType;
	table->ISPUpstreamInputRate=ISPUpstreamInputRate;
	table->ISPDownstreamInputRate=ISPDownstreamInputRate;
	for (i = 0; i < MAX_RULE; i++) {
			rule = &table->Rule[i];
			if ( fscanf(fp,
				"|%20[^|]|%d|%d|%d|%d|%20[^|]|%20[^|]|%hu|%hu|%20[^|]|%20[^|]|%hu|%hu|%d|%d|%d|%d|%d|%d|\n",
				rule->Name, 
				(int *)&rule->Flow, 
				(int *)&rule->AppType, 
				(int *)&rule->RateType, 
				(int *)&rule->Priority, 
				rule->LocalIpStart, 
				rule->LocalIpEnd, 
				&rule->LocalPortStart, 
				&rule->LocalPortEnd, 
				rule->RemoteIpStart, 
				rule->RemoteIpEnd, 
				&rule->RemotePortStart, 
				&rule->RemotePortEnd, 
				&rule->gauranteeRate, // ubit of r2q.  For examples, if r2q is 2, then the unit is 2*12k.  so, the rate is (rule->gauranteeRate)*12*2kbit
				&rule->dscpMarking ,//index to the dscpMarkingTable
				&rule->timeblock.alwaysBlock, 
				&rule->timeblock.days_match, 
				&rule->timeblock.time_start, 
				&rule->timeblock.time_stop
				) == -1 ) break;
			if(rule->gauranteeRate == 0) //impossible
				break;
			rule->Item = i+1; 
			if(rule->LocalIpStart[0]=='&')
				rule->LocalIpStart[0]='\0';
			if(rule->LocalIpEnd[0]=='&')
				rule->LocalIpEnd[0]='\0';
			if(rule->RemoteIpStart[0]=='&')
				rule->RemoteIpStart[0]='\0';
			if(rule->RemoteIpEnd[0]=='&')
				rule->RemoteIpEnd[0]='\0';
			table->TotalNum++;
			table->NextItem++;
	}
	if(table->TotalNum == 0)
	fscanf(fp,"\n");
	if ( fscanf(fp,"%d\n",&NonAsgnRateType)!=1)
	{
		DPRINTF("old verison, do not have  NonAsgnRateType....\n");
		fclose(fp);
		return -1;
	} 
	table->NonAsgnRateType=NonAsgnRateType;
	fclose(fp);
 	return 0;
}// end GetConfigToQOSTable

// SetQOSSTableToConfig
int SetQOSSTableToConfig(QOS_TABLE_T *table)
{
	int i;
	QOS_RULE_T rule;
	FILE *fp;

	fp = fopen("/flash/qos_conf1.conf", "w");
	if (!fp) {
		return -1;
	}
	fprintf(fp,"QOS\n");// the QOS signature. Start from 1.0
	fprintf(fp,"%d\n",0x10);// version 1.0
	fprintf(fp,"%d\n",table->ISPBandwidthType);
	fprintf(fp,"|%d|%d|\n",table->ISPUpstreamInputRate,table->ISPDownstreamInputRate);

	for (i = 0; i < MAX_RULE; i++) {
		rule = table->Rule[i];
		if( rule.Item != 0 ) {
			//rule.Item = i+1; //0
			fprintf(fp,
				"|%s|%d|%d|%d|%d|%s|%s|%hu|%hu|%s|%s|%hu|%hu|%d|%d|%d|%d|%d|%d|\n",
				rule.Name,
				rule.Flow, 
				rule.AppType,
				rule.RateType, 
				rule.Priority, 
				(rule.LocalIpStart[0]=='\0')?"&":rule.LocalIpStart, 
				(rule.LocalIpEnd[0]=='\0')?"&":rule.LocalIpEnd,
				rule.LocalPortStart, 
				rule.LocalPortEnd, 
				(rule.RemoteIpStart[0]=='\0')?"&":rule.RemoteIpStart,
				(rule.RemoteIpEnd[0]=='\0')?"&":rule.RemoteIpEnd,
				rule.RemotePortStart,
				rule.RemotePortEnd, 
				rule.gauranteeRate, 
				rule.dscpMarking, 
				rule.timeblock.alwaysBlock, 
				rule.timeblock.days_match, 
				rule.timeblock.time_start, 
				rule.timeblock.time_stop				);
		}
	}
	if(table->TotalNum == 0)
		fprintf(fp,"\n");
	fprintf(fp,"%d\n",table->NonAsgnRateType);

	fclose(fp);	
	return 0;
}// end SetQOSSTableToConfig


