/* albert 20030128 */
/* UrlFlt configure functions */
#include "qos_conf.h"
#include "webs.h"
//QOS_TABLE_T QOS_Table, QOS_TableShow;
int QOS_Table_Init(QOS_TABLE_T *table);
int QOS_AddRule(QOS_TABLE_T *table, QOS_RULE_T *rule);
int QOS_DelRule(QOS_TABLE_T *table, int item);
int QOS_AdjustTable(QOS_TABLE_T *table);
int QOS_SetRule(QOS_TABLE_T *table, QOS_RULE_T *rule, int item);
int QOS_CopyTable(QOS_TABLE_T *DstTable, QOS_TABLE_T *SrcTable);


int QOS_Table_Init(QOS_TABLE_T *table)
{
	memset( (void *)table, 0, sizeof(QOS_TABLE_T));
	// then we give the default adsl substription Rate
	table->ISPBandwidthType=0;//auto ADSL
	table->ISPUpstreamInputRate=256;
	table->ISPDownstreamInputRate=2048;
	return 0;
}

int QOS_AddRule(QOS_TABLE_T *table, QOS_RULE_T *rule)
{
	if( table->TotalNum < 0 || table->TotalNum >= MAX_RULE)
		return -1;
	table->Rule[table->NextItem++] = *rule;
	table->TotalNum++;
	return 0;
}
/*
int QOS_SetRule(QOS_TABLE_T *table, QOS_RULE_T *rule, int item)
{
	if( item < 0 || item > table->NextItem)
		return -1;
	table->Rule[item] = *rule;
	return 0;
}

*/
int QOS_DelRule(QOS_TABLE_T *table, int item)
{
	if( item < 0 || item >= table->NextItem)
		return -1;
	//table->Rule[item] = (QOS_RULE_T){0};
	memset( &(table->Rule[item]), 0, sizeof(QOS_RULE_T));
	QOS_AdjustTable(table);
	return 0;
}

int QOS_AdjustTable(QOS_TABLE_T *table)
{
	QOS_TABLE_T tableTmp;
	int i = 0;
	
	QOS_Table_Init(&tableTmp);
	
	tableTmp.ISPBandwidthType = table->ISPBandwidthType;
	tableTmp.ISPUpstreamInputRate = table->ISPUpstreamInputRate;
	tableTmp.ISPDownstreamInputRate = table->ISPDownstreamInputRate;

	for( i = 0; i < MAX_RULE; i++)
	{
		if( table->Rule[i].Item != 0 )
		{
			memcpy((void*)&(tableTmp.Rule[tableTmp.NextItem++]), (void*)&(table->Rule[i]), sizeof(QOS_RULE_T));
			tableTmp.TotalNum++;
		}
	}
	memcpy((void*)table, (void*)&tableTmp, sizeof(QOS_TABLE_T));
	return 0;
}

int QOS_CopyTable(QOS_TABLE_T *DstTable, QOS_TABLE_T *SrcTable)
{
	QOS_Table_Init(DstTable);
	memcpy((void*)DstTable, (void*)SrcTable, sizeof(QOS_TABLE_T));
	return 0;
}
