// albert 20030128
// packetfilter configure functions
#ifndef __QOS_CONFIG_H
#define __QOS_CONFIG_H
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "timeblock.h"

typedef enum QOS_Active{
	QOS_Act_NO=0,
	QOS_Act_YES
} QOS_Active_E;

typedef enum QOS_Flow{
	QOS_Flow_OUT=0,
	QOS_Flow_IN,
//	QOS_Flow_BOTH
} QOS_Flow_E;

typedef enum QOS_Rate_Type{
	QOS_Rate_Type_FIXED=0,
	QOS_Rate_Type_MIN
} QOS_Rate_Type_E;

typedef enum QOS_APP_Type{
	QOS_APP_Type_ANY=0,
	QOS_APP_Type_TCP,
	QOS_APP_Type_UDP,
	QOS_APP_Type_ICMP,
	QOS_APP_Type_GRE
} QOS_APP_Type_E;

typedef enum QOS_PRIO_Type{
	QOS_PRIO_HIGH=0,
	QOS_PRIO_NORMAL,
	QOS_PRIO_LOW
} QOS_PRIO_Type_E;

#define QOS_DSCP_MARK_DISABLE 0xFF
#define QOS_DSCP_MARK_BESTEFFORT 0x0
#define QOS_DSCP_MARK_PREMIUM 0x2E
#define QOS_DSCP_MARK_GOLD_LOW 0x1A
#define QOS_DSCP_MARK_GOLD_MED 0x1C
#define QOS_DSCP_MARK_GOLD_HIGH 0x1E
#define QOS_DSCP_MARK_SILVER_LOW 0x12
#define QOS_DSCP_MARK_SILVER_MED 0x14
#define QOS_DSCP_MARK_SILVER_HIGH 0x16
#define QOS_DSCP_MARK_BRONZE_LOW 0x0A
#define QOS_DSCP_MARK_BRONZE_MED 0x0C
#define QOS_DSCP_MARK_BRONZE_HIGH 0x0E


#define DEFAULT_TIME_BLOCK_FROM_HOUR 8
#define DEFAULT_TIME_BLOCK_FROM_MIN 0
#define DEFAULT_TIME_BLOCK_TO_HOUR 18
#define DEFAULT_TIME_BLOCK_TO_MIN 0

typedef struct QOS_RULE {
	int Item;	//0
	char Name[20];
	QOS_Flow_E Flow;	//2
	QOS_APP_Type_E AppType;	//3
	QOS_Rate_Type_E RateType;	//3
	QOS_PRIO_Type_E Priority;	//4
	char LocalIpStart[20];	//5
	char LocalIpEnd[20];	//6
	unsigned short LocalPortStart;//
	unsigned short LocalPortEnd;	//8
	char RemoteIpStart[20];	//9
	char RemoteIpEnd[20];	//10
	unsigned short RemotePortStart;//11
	unsigned short RemotePortEnd;	//12
	int gauranteeRate;	//13   n *( # of r2q )
	int  dscpMarking;	//14   DSCP marking
	TIME_BLOCK_T timeblock;
} QOS_RULE_T;


#define MAX_RULE 8

typedef struct qos_table{
	char signature[4];//"QOS"
	unsigned char version; // xxxx.xxxx   0x10 is versoin 1.0
	int ISPBandwidthType;// 0:from ADSL sync rate.  1:manual input
	int ISPUpstreamInputRate;//64 .. 2000
	int ISPDownstreamInputRate;//256 ... 24000	
	int TotalNum;
	int NextItem;
	QOS_RULE_T Rule[MAX_RULE];
	int NonAsgnRateType; //0:Fix,1:Quaranteed
} QOS_TABLE_T;


#define QOS_CONF_FN_RULE_IPT_ADD    "/var/etc/qos.conf.rule.ipt.add"
#define QOS_CONF_FN_RULE_IPT_DEL    "/var/etc/qos.conf.rule.ipt.del"
#define QOS_CONF_FN_RULE_SHELL_ADD    "/var/etc/qos.conf.rule.add.sh"
#define QOS_CONF_FN_RULE_SHELL_DEL    "/var/etc/qos.conf.rule.del.sh"


#endif /* __QOS_CONFIG_H */
