/*
 *  quick.htm: Quick Start
 */
#include "webs.h"
#include "lan_conf.h"
#include "quick.h"
#include "wan.h"
#include "dns_conf.h"
#include "locale.h"

extern char *Quick_L1[];
extern char *Quick_L2[];
extern char *Quick_L3[];
extern char *Quick_L4[];
extern char *Quick_L5[];
extern char *Quick_L6[];
extern char *Quick_L7[];
extern char *Quick_L8[];
extern char *Quick_L9[];
extern char *Quick_L10[];
extern char *Quick_L11[];
extern char *Quick_L12[];
extern LAN_CONFIG_DATA lan_config;

extern void write_ripd_config(LAN_CONFIG_DATA *d1, WAN_CONFIG_DATA *d);

static int read_wan_quick_status1 (int ejid, webs_t wp, int argc, char_t **argv);
static int read_wan_quick_status2 (int ejid, webs_t wp, int argc, char_t **argv);
static int read_wan_quick_status3 (int ejid, webs_t wp, int argc, char_t **argv);
static int read_wan_quick_status4 (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_quick_mod (int ejid, webs_t wp, int argc, char_t **argv);
static void form_quick_conf(webs_t wp, char_t * path,char_t * query);
static void form_quick_change_conf(webs_t wp, char_t * path,char_t * query);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
extern void flash_write();

static int get_wan_quick_mod (int ejid, webs_t wp, int argc, char_t **argv)
{
//	Load_Wan_Config();
	if (wan_config.Quick_Wan_Type==atoi(argv[0]))
		return websWrite(wp,T("selected"));
	else
		return websWrite(wp,T(""));
}

static int read_wan_quick_status1 (int ejid, webs_t wp, int argc, char_t **argv){
	int Wan_Vpi=0;
        int Wan_Vci=0;
        char_t Nat[255]="";
 	char_t *TableFmt1="<tr>\n"
			"<td class=title>VPI</td>\n"
			"<td colSpan=3><INPUT type=text name=Wan_VPI value=%d maxlength=3 size=3></td>\n"
			"</tr>\n"
			"<tr>\n"
			"<td class=title>VCI</td>\n"
			"<td colSpan=3><INPUT type=text name=Wan_VCI value=%d maxlength=5 size=5></td>\n"
			"</tr>\n"
			"%s\n";
       // Load_Wan_Config();
	if (wan_config.Quick_Wan_Type==0){ /* No wan */
		DPRINTF("No wan\n");
		Wan_Vpi=0;
		Wan_Vci=0;
		strcpy(Nat,"");
	}
	else if (wan_config.Quick_Wan_Type==1||wan_config.Quick_Wan_Type==11){ /* PPPOA*/
		DPRINTF("PPPoA\n");
	        Wan_Vpi=wan_config.PPPOA_VPI;
                Wan_Vci=wan_config.PPPOA_VCI;
		if (wan_config.PPPOA_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		
	}
	else if (wan_config.Quick_Wan_Type==2||wan_config.Quick_Wan_Type==12){ /* PPPOE */
		//DPRINTF("PPPoE\n");
		Wan_Vpi=wan_config.PPPOE_VPI;
                Wan_Vci=wan_config.PPPOE_VCI;
		if (wan_config.PPPOE_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		
	}
	else if (wan_config.Quick_Wan_Type==3 || wan_config.Quick_Wan_Type==4 || wan_config.Quick_Wan_Type==5 ){ /* 1483 Routed */
		if (wan_config.Quick_Wan_Type==3){
			//DPRINTF("1483 Routed IP VC-Mux\n");
		}
		else if (wan_config.Quick_Wan_Type==4){
			//DPRINTF("1483 Routed IP LLC\n");
		}
		else{ /* if (wan_config.Quick_Wan_Type==5){ */
			//DPRINTF("1483 LLC MER\n");
		}
		Wan_Vpi=wan_config.Routed_VPI;
		Wan_Vci=wan_config.Routed_VCI;
		
		if (wan_config.Routed_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);

	}
	else if (wan_config.Quick_Wan_Type==6){ /* Classical IP (1577) */
		//DPRINTF("Classsical IP (1577)\n");
		Wan_Vpi=wan_config.IPOA_VPI;
                Wan_Vci=wan_config.IPOA_VCI;
		if (wan_config.IPOA_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);

	}
	else if (wan_config.Quick_Wan_Type==7){ /* 1483 Bridged IP VC-Mux */
		Wan_Vpi=wan_config.Routed_VPI;
		Wan_Vci=wan_config.Routed_VCI;
		if (wan_config.Routed_IP_Assignment==0)
		{	
			//DPRINTF("1483 Bridged IP VC-Mux(dynamic)\n");
		}
		else
		{
			//DPRINTF("1483 Bridged IP VC-Mux(fixed)\n");
		}
		
		if (wan_config.Routed_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		
	}
	else if (wan_config.Quick_Wan_Type==8){ /* 1483 Bridged IP LLC */
		Wan_Vpi=wan_config.Routed_VPI;
		Wan_Vci=wan_config.Routed_VCI;
		if (wan_config.Routed_IP_Assignment==0)
		{	
			//DPRINTF("1483 Bridged IP LLC(dynamic)\n");
		}
		else
		{
			//DPRINTF("1483 Bridged IP LLC(fixed)\n");
		}
		
		if (wan_config.Routed_NAT==0)
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0 checked>%s<INPUT type=radio name=Wan_NAT value=1>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		else
			sprintf(Nat,"<TR><TD class=title>NAT</TD><TD colSpan=3><INPUT type=radio name=Wan_NAT value=0>%s<INPUT type=radio name=Wan_NAT value=1 checked>%s</TD></TR>",Quick_L1[locale_config.locale],Quick_L2[locale_config.locale]);
		
	}
#ifdef _WAN_TYPE_13_14_
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10 || wan_config.Quick_Wan_Type==13 || wan_config.Quick_Wan_Type==14){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#else
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#endif
		if (wan_config.Quick_Wan_Type==9){
			//DPRINTF("Pure Bridged VC-Mux\n");
		}
		else{
			//DPRINTF("Pure Bridged LLC\n");
		}
	        Wan_Vpi=wan_config.Bridged_VPI;
	        Wan_Vci=wan_config.Bridged_VCI;
		strcpy(Nat,"");
	}
	#if 0
	FILE *f;
	char_t enc[32];
	char_t ip[32];
	char_t line[255];
	char_t gateway[32];
	f=fopen("/var/tmp/first_scanpvc_result","r");
	if(f){
		if (fgets(line,255,f)){
		sscanf(line,"VPI %d VCI %d %s %s %s",&Wan_Vpi,&Wan_Vci,enc,ip,gateway);
		if(!strcmp(enc,"DHCPC_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		//Save_Wan_Config(1,&wan_config);
		}
		if(!strcmp(enc,"DHCPC_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		//Save_Wan_Config(1,&wan_config);
		}
		if(!strcmp(enc,"PPPOE_LLC_VALID")){
		wan_config.Quick_Wan_Type=2;
		wan_config.Wan_Type=5;
        	wan_config.PPPOE_VPI=Wan_Vpi;
        	wan_config.PPPOE_VCI=Wan_Vci;
		//Save_Wan_Config(5,&wan_config);
		}
		if(!strcmp(enc,"PPPOA_LLC_VALID")){
		wan_config.Quick_Wan_Type=1;
		wan_config.Wan_Type=3;
        	wan_config.PPPOA_VPI=Wan_Vpi;
        	wan_config.PPPOA_VCI=Wan_Vci;
		//Save_Wan_Config(3,&wan_config);
		}
		if(!strcmp(enc,"FIXIP_2684B_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
		wan_config.Routed_IP_Assignment=1;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		//Save_Wan_Config(1,&wan_config);
		}
		if(!strcmp(enc,"FIXIP_2684B_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
		wan_config.Routed_IP_Assignment=1;
        	wan_config.Routed_VPI=Wan_Vpi;
        	wan_config.Routed_VCI=Wan_Vci;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		//Save_Wan_Config(1,&wan_config);
		}
		}
		fclose(f);
	}
	#endif
	return websWrite(wp, T(TableFmt1),Wan_Vpi,Wan_Vci,Nat);
}
static int read_wan_quick_status2 (int ejid, webs_t wp, int argc, char_t **argv){

        char_t Wan_Ip[20]="0.0.0.0";
        char_t Wan_Netmask[20]="0.0.0.0";
        char_t Wan_Gateway[20]="0.0.0.0";
 	char_t *TableFmt1="<tr>\n"
			"<TD class=header colSpan=4>%s</TD>\n"
			"</TR>\n"
			"<TR>\n"
			"<TD class=title width=35%%>%s</TD>\n"
			"<TD colSpan=3>\n"
			"<INPUT type=text name=Wan_IP value=\"%s\"  maxlength=15 size=20>\n"
			"<BR>\n"
			"%s\n"
			"</TD>\n"
			"</TR>\n"
			"<TR>\n"
			"<TD class=title>%s</TD>\n"
			"<TD colSpan=3><INPUT type=text name=Wan_Netmask value=\"%s\" maxlength=15 size=20>\n"
			"</TD>\n"
			"</TR>\n"
			"<TR>\n"
			"<TD class=title>%s</TD>\n"
			"<TD colSpan=3>\n"
			"<INPUT type=text name=Wan_Gateway value=\"%s\" maxlength=15 size=20>\n"
			"</TD>\n"
			"</TR>\n";   
// Load_Wan_Config();
	
	if (wan_config.Quick_Wan_Type==0){ /* No wan */
		DPRINTF("No wan\n");
		strcpy(Wan_Ip,"0.0.0.0");
		strcpy(Wan_Netmask,"0.0.0.0");
		strcpy(Wan_Gateway,"0.0.0.0");
	}
	else if (wan_config.Quick_Wan_Type==1||wan_config.Quick_Wan_Type==11){ /* PPPOA*/
		//DPRINTF("PPPoA\n");
		strcpy(Wan_Ip,wan_config.PPPOA_IP);
		strcpy(Wan_Netmask,"0.0.0.0");
		strcpy(Wan_Gateway,"0.0.0.0");
	}
	else if (wan_config.Quick_Wan_Type==2||wan_config.Quick_Wan_Type==12){ /* PPPOE */
		//DPRINTF("PPPoE\n");
		strcpy(Wan_Ip,wan_config.PPPOE_IP);
		strcpy(Wan_Netmask,"0.0.0.0");
		strcpy(Wan_Gateway,"0.0.0.0");
	}
	else if (wan_config.Quick_Wan_Type==3 || wan_config.Quick_Wan_Type==4 || wan_config.Quick_Wan_Type==5 ){ /* 1483 Routed */
		if (wan_config.Quick_Wan_Type==3){
			//DPRINTF("1483 Routed IP VC-Mux\n");
		}
		else if (wan_config.Quick_Wan_Type==4){
			//DPRINTF("1483 Routed IP LLC\n");
		}
		else{ /* if (wan_config.Quick_Wan_Type==5){ */
			//DPRINTF("1483 LLC MER\n");
		}
		strcpy(Wan_Ip,wan_config.Routed_IP);
		strcpy(Wan_Netmask,wan_config.Routed_Netmask);
		strcpy(Wan_Gateway,wan_config.Routed_Gateway);
	}
	else if (wan_config.Quick_Wan_Type==6){ /* Classical IP (1577) */
		//DPRINTF("Classsical IP (1577)\n");
		strcpy(Wan_Ip,wan_config.IPOA_IP);
		strcpy(Wan_Netmask,wan_config.IPOA_Netmask);
		strcpy(Wan_Gateway,wan_config.IPOA_Gateway);
	}
	else if (wan_config.Quick_Wan_Type==7){ /* 1483 Bridged IP VC-Mux */
		if (wan_config.Routed_IP_Assignment==0)
		{	
			//DPRINTF("1483 Bridged IP VC-Mux(dynamic)\n");
			strcpy(Wan_Ip,"0.0.0.0");
			strcpy(Wan_Netmask,"0.0.0.0");
			strcpy(Wan_Gateway,"0.0.0.0");
		}
		else
		{
			//DPRINTF("1483 Bridged IP VC-Mux(fixed)\n");
			strcpy(Wan_Ip,wan_config.Routed_IP);
			strcpy(Wan_Netmask,wan_config.Routed_Netmask);
			strcpy(Wan_Gateway,wan_config.Routed_Gateway);
		}
	}
	else if (wan_config.Quick_Wan_Type==8){ /* 1483 Bridged IP LLC */
		if (wan_config.Routed_IP_Assignment==0)
		{	
			//DPRINTF("1483 Bridged IP LLC(dynamic)\n");
			strcpy(Wan_Ip,"0.0.0.0");
			strcpy(Wan_Netmask,"0.0.0.0");
			strcpy(Wan_Gateway,"0.0.0.0");
		}
		else
		{
			//DPRINTF("1483 Bridged IP LLC(fixed)\n");
			strcpy(Wan_Ip,wan_config.Routed_IP);
			strcpy(Wan_Netmask,wan_config.Routed_Netmask);
			strcpy(Wan_Gateway,wan_config.Routed_Gateway);
		}
	}
#ifdef _WAN_TYPE_13_14_
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10 || wan_config.Quick_Wan_Type==13 || wan_config.Quick_Wan_Type==14){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#else
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#endif
		if (wan_config.Quick_Wan_Type==9){
			//DPRINTF("Pure Bridged VC-Mux\n");
		}
		else{
			//DPRINTF("Pure Bridged LLC\n");
		}
		strcpy(Wan_Ip,"0.0.0.0");
		strcpy(Wan_Netmask,"0.0.0.0");
		strcpy(Wan_Gateway,"0.0.0.0");
	}
	return websWrite(wp, T(TableFmt1),
		Quick_L3[locale_config.locale],
		Quick_L4[locale_config.locale],
		Wan_Ip,
		Quick_L5[locale_config.locale],
		Quick_L6[locale_config.locale],
		Wan_Netmask,
		Quick_L7[locale_config.locale],
		Wan_Gateway);

}
static int read_wan_quick_status3 (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t Dns1[20];
        char_t Dns2[20];
        char_t Enable[10];
        Load_Dns_Config(0);
        
	char_t *TableFmt1="<TR>\n"
			"\t<TD class=header colSpan=4>DNS</TD>\n"
			"</TR>\n"
			"<TR>\n"
			"\t<TD class=title width=35%%>%s</TD>\n"
			"\t<TD colSpan=3>\n"
			"\t\t<INPUT type=checkbox name=autodns1 %s>%s\n"
			"\t</TD>\n"
                        "</TR>\n"
                        "<TR>\n"
			"\t<TD class=title width=35%%>%s</TD>\n"
			"\t<TD colSpan=3>\n"
			"\t\t<INPUT type=text name=PrimaryDNS value=\"%s\" maxlength=15 size=20>\n"
			"\t</TD>\n"
                        "</TR>\n"
                        "<TR>\n"
                        "\t<TD class=title width=35%%>%s</TD>\n"
                        "\t<TD colSpan=3>\n"
			"\t\t<INPUT type=text name=SecondaryDNS value=\"%s\" maxlength=15 size=20>\n"
			"\t</TD>\n"
		        "</TR>\n";

	strcpy(Dns1,dns_config.PrimaryDNS);
	strcpy(Dns2,dns_config.SecondaryDNS);
	if (!strcmp(dns_config.Enable,"1"))
		strcpy(Enable,"checked");
	else
		strcpy(Enable,"");
	return websWrite(wp, T(TableFmt1),
		Quick_L8[locale_config.locale],
		Enable,
		Quick_L1[locale_config.locale],
		Quick_L9[locale_config.locale],
		dns_config.PrimaryDNS,
		Quick_L10[locale_config.locale],
		dns_config.SecondaryDNS);

}
static int read_wan_quick_status4 (int ejid, webs_t wp, int argc, char_t **argv)
{
        char_t PPP1[255]="";
        char_t PPP2[255]="";
        char_t PPP3[255]="";
        char_t PPP4[255]="";
        char_t PPP5[255]="";
//        Load_Wan_Config();
        Load_Dns_Config(0);
   
	char_t *TableFmt1="\t%s";
	
	char_t *TableFmt2="%s";
	
	char_t *TableFmt3="%s";
	
	char_t *TableFmt4="%s";
	
	char_t *TableFmt5="%s\n";
			
	
	if (wan_config.Quick_Wan_Type==0){ /* No wan */
		strcpy(PPP1,"");
		strcpy(PPP2,"");
		strcpy(PPP3,"");
		strcpy(PPP4,"");
		strcpy(PPP5,""); 
	}
	else if (wan_config.Quick_Wan_Type==1||wan_config.Quick_Wan_Type==11){ /* PPPOA */
		sprintf(PPP1,"<TR><TD class=header colSpan=4>PPP</TD></TR><TR><TD class=title width=35%%>%s</TD><TD colSpan=3><INPUT type=text name=Wan_Username value='",Quick_L11[locale_config.locale]);
		strcpy(PPP2,wan_config.PPPOA_Username);
		sprintf(PPP3,"'	maxlength=128 size=20></TD></TR><TR><TD class=title width=35%%>%s</TD><TD colSpan=3><INPUT type=PASSWORD name=Wan_Password value='",Quick_L12[locale_config.locale]);
		strcpy(PPP4,wan_config.PPPOA_Password);
		strcpy(PPP5,"' maxlength=128 size=20></TD></TR>\n");

	}
	else if (wan_config.Quick_Wan_Type==2||wan_config.Quick_Wan_Type==12){ /* PPPOE */
		sprintf(PPP1,"<TR><TD class=header colSpan=4>PPP</TD></TR><TR><TD class=title width=35%%>%s</TD><TD colSpan=3><INPUT type=text name=Wan_Username value='",Quick_L11[locale_config.locale]);
		strcpy(PPP2,wan_config.PPPOE_Username);
		sprintf(PPP3,"' maxlength=128 size=20></TD></TR><TR><TD class=title width=35%%>%s</TD><TD colSpan=3><INPUT type=PASSWORD name=Wan_Password value='",Quick_L12[locale_config.locale]);
		strcpy(PPP4,wan_config.PPPOE_Password);
		strcpy(PPP5,"' maxlength=128 size=20></TD></TR>\n");
	}
	else if (wan_config.Quick_Wan_Type==3 || wan_config.Quick_Wan_Type==4 || wan_config.Quick_Wan_Type==5 ||  wan_config.Quick_Wan_Type==7 || wan_config.Quick_Wan_Type==8 ){ /* 1483 Routed */
			strcpy(PPP1,"");
			strcpy(PPP2,"");
			strcpy(PPP3,"");
			strcpy(PPP4,"");
			strcpy(PPP5,""); 

	}
	else if (wan_config.Quick_Wan_Type==6){ /* Classical IP (1577) */
		//DPRINTF("Classsical IP (1577)\n");
		strcpy(PPP1,"");
		strcpy(PPP2,"");
		strcpy(PPP3,"");
		strcpy(PPP4,"");
		strcpy(PPP5,""); 

	}
#ifdef _WAN_TYPE_13_14_
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10 || wan_config.Quick_Wan_Type==13 || wan_config.Quick_Wan_Type==14){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#else
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10){ /* Pure Bridged VC-Mux or Pure Bridged LLC*/
#endif
		strcpy(PPP1,"");
		strcpy(PPP2,"");
		strcpy(PPP3,"");
		strcpy(PPP4,"");
		strcpy(PPP5,"");
	}
	websWrite(wp, T(TableFmt1),PPP1);
	if (!strncmp(PPP2,"&",1))
		websWrite(wp, T(""));
	else	
		websWrite(wp, T(TableFmt2),PPP2);
	
	websWrite(wp, T(TableFmt3),PPP3);
	
	if (!strncmp(PPP4,"&",1))
		websWrite(wp, T(""));
	else	
		websWrite(wp, T(TableFmt4),PPP4);

	websWrite(wp, T(TableFmt5),PPP5);
	return 1;
}								

static void form_quick_change_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
        Load_Wan_Config();
	buf=websGetVar(wp, T("Wan_Type"), "");
        wan_config.Quick_Wan_Type=atoi(buf);
	//DPRINTF("Quick_change:%d\n",wan_config.Quick_Wan_Type);
	/*
	if (wan_config.Quick_Wan_Type==2)
		Save_Wan_Config(5,&wan_config);
	else if ((wan_config.Quick_Wan_Type==3) || (wan_config.Quick_Wan_Type==4) || (wan_config.Quick_Wan_Type==5) || (wan_config.Quick_Wan_Type==7) || (wan_config.Quick_Wan_Type==8))  
		Save_Wan_Config(1,&wan_config);
	else if ((wan_config.Quick_Wan_Type==9) || (wan_config.Quick_Wan_Type==10))
		Save_Wan_Config(2,&wan_config);
	else if (wan_config.Quick_Wan_Type==1)
		Save_Wan_Config(3,&wan_config);
	else if (wan_config.Quick_Wan_Type==6)
		Save_Wan_Config(4,&wan_config);
	else
		Save_Wan_Config(0,&wan_config);
	*/	
	websRedirect(wp, T("quick.asp"));
	  
}
extern void dhcp_change_internal(int enabled);
#ifdef _WAN_TYPE_13_14_
int check_if_wan_quick_type_13_14(void)
{
       Load_Wan_Config();
       if (wan_config.Quick_Wan_Type==13||wan_config.Quick_Wan_Type==14)
	       return 1;
       return 0;
}
#endif

static void form_quick_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
	//FILE *fp;
	//char_t line[512];
	/*
        char_t buf1[64];
        char_t str_router[20];
	char_t str_old_ip[20];
	char_t str_old_if[20];
	char_t str_wan[10];
	char_t is_fw[10];
	char_t line[255];
	*/
	// How to we deal with the DHCP Server in the quick start?
	// Since it is quick start, we need to disabled DHCP server for Bridge and Enabled the DHCP server for router mode.
	
        Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
        
        Load_Dns_Config(0);

	buf=websGetVar(wp, T("Wan_Type"), "");
        wan_config.Quick_Wan_Type=atoi(buf);

	buf=websGetVar(wp, T("autodns"), "");
	strcpy(dns_config.Enable,buf);
	buf=websGetVar(wp, T("PrimaryDNS"),"");
	strcpy(dns_config.PrimaryDNS,buf);
	buf=websGetVar(wp, T("SecondaryDNS"),"");
	strcpy(dns_config.SecondaryDNS,buf);
		
	Save_Dns_Config(0,&dns_config);
	
	//strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1));
	/*
		if (strcmp(str_wan,"fixed")==0)
			Save_Dns_Config(1,&dns_config);
		else if (strcmp(str_wan,"dynamic")==0)
			Save_Dns_Config(2,&dns_config);
		else if (strcmp(str_wan,"pppoa")==0)
			Save_Dns_Config(2,&dns_config);
		else if (strcmp(str_wan,"pppoe")==0)
			Save_Dns_Config(2,&dns_config);
		else if (strcmp(str_wan,"bridge")==0)
			Save_Dns_Config(1,&dns_config);
		else
			Save_Dns_Config(1,&dns_config);
	*/
	if (wan_config.Quick_Wan_Type==0){ /* No wan */
#if 0
// we will not have this condition since web page has checked
//quick.asp , when wan=0 and press apply button, it will alert the warning
		Save_Wan_Config(0,&wan_config);	
		save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
#endif
	}
	else if (wan_config.Quick_Wan_Type==1||wan_config.Quick_Wan_Type==11){ /* PPPOA */
		buf=websGetVar(wp, T("Wan_VPI"),"");
		wan_config.PPPOA_VPI=atoi(buf);
		buf=websGetVar(wp, T("Wan_VCI"),"");
		wan_config.PPPOA_VCI=atoi(buf);
		buf=websGetVar(wp, T("Wan_IP"),"");
		strcpy(wan_config.PPPOA_IP,buf);
		buf=websGetVar(wp, T("Wan_NAT"),"");
		wan_config.PPPOA_NAT=atoi(buf);
		buf=websGetVar(wp, T("Wan_Username"),"");
		strcpy(wan_config.PPPOA_Username,buf);
		buf=websGetVar(wp, T("Wan_Password"),"");
		strcpy(wan_config.PPPOA_Password,buf);
		/*
        	strcpy(wan_config.PPPOA_Description,"PPPOA");
        	wan_config.PPPOA_ATM_Class=0;
        	strcpy(wan_config.PPPOA_Service_Name,"");
        	wan_config.PPPOA_Authentication_Protocol=0;
        	wan_config.PPPOA_Connection=0;
        	wan_config.PPPOA_Idle_Timeout=600;
        	wan_config.PPPOA_MTU=1492;
		*/
		if (wan_config.Quick_Wan_Type==1)
			wan_config.PPPOA_Encapsulation_Method=1; /* Vc-Mux Routed */
		else
			wan_config.PPPOA_Encapsulation_Method=0; /* LLC Routed */

		wan_config.Wan_Type=3; /* PPPOA */
		if (!((wan_config.PPPOA_RIP==old_wan_config.PPPOA_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}
		Save_Wan_Config(3,&wan_config);
		Save_Dns_Config(2,&dns_config);
		dhcp_change_internal(1);
		if(wan_config.Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		RunPPPoA(wp,&old_wan_config,&wan_config,1);
	}
	else if (wan_config.Quick_Wan_Type==2||wan_config.Quick_Wan_Type==12){ /* PPPOE */
	
		buf=websGetVar(wp, T("Wan_VPI"),"");
		wan_config.PPPOE_VPI=atoi(buf);
		buf=websGetVar(wp, T("Wan_VCI"),"");
		wan_config.PPPOE_VCI=atoi(buf);
		buf=websGetVar(wp, T("Wan_IP"),"");
		strcpy(wan_config.PPPOE_IP,buf);
		buf=websGetVar(wp, T("Wan_NAT"),"");
		wan_config.PPPOE_NAT=atoi(buf);
		buf=websGetVar(wp, T("Wan_Username"),"");
		strcpy(wan_config.PPPOE_Username,buf);
		buf=websGetVar(wp, T("Wan_Password"),"");
		strcpy(wan_config.PPPOE_Password,buf);
		/*
        	strcpy(wan_config.PPPOE_Description,"PPPoE");
        	wan_config.PPPOE_ATM_Class=0;
        	strcpy(wan_config.PPPOE_Service_Name,"");
        	wan_config.PPPOE_Authentication_Protocol=0;
        	wan_config.PPPOE_Connection=0;
        	wan_config.PPPOE_Idle_Timeout=600;
        	wan_config.PPPOE_MTU=1492;
		*/
		if (wan_config.Quick_Wan_Type==12)
			wan_config.PPPOE_Encapsulation_Method=1; /* Vc-Mux Routed */
		else
			wan_config.PPPOE_Encapsulation_Method=0; /* LLC Routed */

		wan_config.Wan_Type=5; /* PPPOE */
		if (!((wan_config.PPPOE_RIP==old_wan_config.PPPOE_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}
		Save_Wan_Config(5,&wan_config);
		Save_Dns_Config(2,&dns_config);
		dhcp_change_internal(1);
		if(wan_config.Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		RunPPPoE(wp,&old_wan_config,&wan_config,1);
		}
	else if (wan_config.Quick_Wan_Type==3 || wan_config.Quick_Wan_Type==4){ /* 1483 Routed IP VC-Mux or LLC*/
		buf=websGetVar(wp, T("Wan_VPI"),"");
		wan_config.Routed_VPI=atoi(buf);
		buf=websGetVar(wp, T("Wan_VCI"),"");
		wan_config.Routed_VCI=atoi(buf);
		buf=websGetVar(wp, T("Wan_Netmask"),"");
		strcpy(wan_config.Routed_Netmask,buf);
		buf=websGetVar(wp, T("Wan_Gateway"),"");
		strcpy(wan_config.Routed_Gateway,buf);
		buf=websGetVar(wp, T("Wan_NAT"),"");
		wan_config.Routed_NAT=atoi(buf);
		buf=websGetVar(wp, T("Wan_IP"),"");
		strcpy(wan_config.Routed_IP,buf);
	
		wan_config.Wan_Type=1; /* Routed */
		/*
	        strcpy(wan_config.Routed_Description,"1483_Routed_IP_VC-Mux");
        	wan_config.Routed_ATM_Class=0;
        	wan_config.Routed_Encapsulation_Method=3;
        	wan_config.Routed_IP_Assignment=1;
        	wan_config.Routed_MTU=1492;
		*/
		if (!((wan_config.Routed_RIP==old_wan_config.Routed_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}

		if (!strcmp(wan_config.Routed_IP,"0.0.0.0"))
			wan_config.Routed_IP_Assignment=0; /* dynamic */
		else
			wan_config.Routed_IP_Assignment=1; /* FIXED IP */
		if (wan_config.Quick_Wan_Type==3)
			wan_config.Routed_Encapsulation_Method=3; /* Vc-Mux Routed */
		else
			wan_config.Routed_Encapsulation_Method=2; /* LLC Routed */
		Save_Wan_Config(1,&wan_config);
		Save_Dns_Config(1,&dns_config);
	
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
		dhcp_change_internal(1);
		if(wan_config.Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		Run1483Routed(wp,&old_wan_config,&wan_config,1);
		}
	else if (wan_config.Quick_Wan_Type==5){ /* 1483 LLC MER */
	#if 0
	
		buf=websGetVar(wp, T("Wan_VPI"),"");
		wan_config.Routed_VPI=atoi(buf);
		buf=websGetVar(wp, T("Wan_VCI"),"");
		wan_config.Routed_VCI=atoi(buf);
		buf=websGetVar(wp, T("Wan_Netmask"),"");
		strcpy(wan_config.Routed_Netmask,buf);
		buf=websGetVar(wp, T("Wan_Gateway"),"");
		strcpy(wan_config.Routed_Gateway,buf);
		buf=websGetVar(wp, T("Wan_NAT"),"");
		wan_config.Routed_NAT=atoi(buf);
		buf=websGetVar(wp, T("Wan_IP"),"");
		strcpy(wan_config.Routed_IP,buf);
	
	        strcpy(wan_config.Routed_Description,"1483_LLC_MER");
        	wan_config.Routed_ATM_Class=0;
        	wan_config.Routed_Encapsulation_Method=4;
        	wan_config.Routed_IP_Assignment=1;
        	wan_config.Routed_MTU=1492;

		Save_Wan_Config(1,&wan_config);
	
	#endif
	}
	else if (wan_config.Quick_Wan_Type==6){ /* Classical IP (1577) */

	}
	else if (wan_config.Quick_Wan_Type==7 || wan_config.Quick_Wan_Type==8){ /* 1483 Bridged IP VC-Mux or LLC */
		buf=websGetVar(wp, T("Wan_VPI"),"");
		wan_config.Routed_VPI=atoi(buf);
		buf=websGetVar(wp, T("Wan_VCI"),"");
		wan_config.Routed_VCI=atoi(buf);
		buf=websGetVar(wp, T("Wan_Netmask"),"");
		strcpy(wan_config.Routed_Netmask,buf);
		buf=websGetVar(wp, T("Wan_Gateway"),"");
		strcpy(wan_config.Routed_Gateway,buf);
		buf=websGetVar(wp, T("Wan_NAT"),"");
		wan_config.Routed_NAT=atoi(buf);
		buf=websGetVar(wp, T("Wan_IP"),"");
		strcpy(wan_config.Routed_IP,buf);
		
	
		Save_Dns_Config(1,&dns_config);

		wan_config.Wan_Type=1; /* Routed */
	
		if (!((wan_config.Routed_RIP==old_wan_config.Routed_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
        	}
		if (!strcmp(wan_config.Routed_IP,"0.0.0.0"))
			wan_config.Routed_IP_Assignment=0; /* dynamic */
		else		
			wan_config.Routed_IP_Assignment=1; /* FIXED IP */
		if (wan_config.Quick_Wan_Type==7)
			wan_config.Routed_Encapsulation_Method=1; /* Vc-Mux Routed */
		else
			wan_config.Routed_Encapsulation_Method=0; /* LLC Routed */
		Save_Wan_Config(1,&wan_config);
		dhcp_change_internal(1);
		if(wan_config.Routed_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		Run1483Routed(wp,&old_wan_config,&wan_config,1);
		}
#ifdef _WAN_TYPE_13_14_
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10|| wan_config.Quick_Wan_Type==13|| wan_config.Quick_Wan_Type==14){ /* Pure Bridged VC-Mux or LLC */
		if ((wan_config.Quick_Wan_Type==9)||(wan_config.Quick_Wan_Type==13))
#else
	else if (wan_config.Quick_Wan_Type==9 || wan_config.Quick_Wan_Type==10){ /* Pure Bridged VC-Mux or LLC */
		if (wan_config.Quick_Wan_Type==9)
#endif
			wan_config.Bridged_Encapsulation_Method=1; /* Vc-Mux Routed */
	                        else
			wan_config.Bridged_Encapsulation_Method=0; /* LLC Routed */
	        buf=websGetVar(wp, T("Wan_VPI"), "");
	        wan_config.Bridged_VPI=atoi(buf);
	        buf=websGetVar(wp, T("Wan_VCI"), "");
	        wan_config.Bridged_VCI=atoi(buf);
		wan_config.Wan_Type=2; /* Bridged */
		Save_Wan_Config(2,&wan_config);
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
#ifdef _WAN_TYPE_13_14_
		if(wan_config.Quick_Wan_Type==13|| wan_config.Quick_Wan_Type==14)
			dhcp_change_internal(1);
		else
#endif
		dhcp_change_internal(0);
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
		Run1483Bridged(wp,&old_wan_config,&wan_config,1);
		}
		else
		return;
}
void DefineWebFunctions_quick()
{
        websAspDefine(T("read_wan_quick_status1"), read_wan_quick_status1);
        websAspDefine(T("read_wan_quick_status2"), read_wan_quick_status2);
        websAspDefine(T("read_wan_quick_status3"), read_wan_quick_status3);
        websAspDefine(T("read_wan_quick_status4"), read_wan_quick_status4);
        websAspDefine(T("get_wan_quick_mod"), get_wan_quick_mod);
        websFormDefine ( T("quick"), form_quick_conf);
        websFormDefine ( T("quick_change"), form_quick_change_conf);
}
