/*
 *  quick_voip.asp: manage quick voip page and voip profile
 *  Written by Robert Wu. 04052006
 */
#include "webs.h"
#include <string.h>
#include <signal.h>
#define R_SELECT_OPTION "<option value=%d %s>%s</option>\n"
#define NULL 0

/* define files start */
#define R_QUICKVOIP_DIR "/flash"
#define R_QUICKVOIP_CONF "/flash/quickvoip.conf"
#define R_XCONFIG_TMP "/flash/xconfig.cfg.tmp"
#define R_XCONFIG "/flash/xconfig.cfg"
#define R_CONFIG "/flash/config"
/* define files end */

#define QUICK_VOIP_PRESET_NUM 6
#define QUICK_VOIP_LOGIN_NUM 3
#define QUICK_VOIP_CONFIG_LENGTH 32
#define QUICK_VOIP_CONFIG_LENGTH64 64
#define QUICK_VOIP_LGLIST_NUM ((QUICK_VOIP_PRESET_NUM)*(QUICK_VOIP_LOGIN_NUM))

typedef struct ACT_CONF
{
  char sip;
  char siplines;
  char iax;
  char gw;
  char prov;
} Act_Conf;

Act_Conf ac1;

typedef struct QUICKVOIP_CONF
{
  int sip_port;
  int rtp_port;
  int interface;
  int service_provider;
  char service_list[QUICK_VOIP_PRESET_NUM][QUICK_VOIP_CONFIG_LENGTH];
  int line1;
  int line2;
  char login_list[QUICK_VOIP_LGLIST_NUM][QUICK_VOIP_CONFIG_LENGTH];
} QuickVoIP_Conf;

char QuickVoIP_Movement = 0;	// 0: load from flash, 1: show temp setting only.
QuickVoIP_Conf qc1;		//Temp setting for change

typedef struct QVOIP_LG_CONF
{
  char login_name[QUICK_VOIP_CONFIG_LENGTH];
  char userid[QUICK_VOIP_CONFIG_LENGTH];
  char password[QUICK_VOIP_CONFIG_LENGTH];
  char authid[QUICK_VOIP_CONFIG_LENGTH];
  char display[QUICK_VOIP_CONFIG_LENGTH];
} QVoIP_LG_Conf;

QVoIP_LG_Conf qvlg1;

typedef struct QVOIP_SP_CONF
{
  char service_name[QUICK_VOIP_CONFIG_LENGTH];
  int reg_int;
  char registrar[QUICK_VOIP_CONFIG_LENGTH64];
  int reg_port;
  char proxy[QUICK_VOIP_CONFIG_LENGTH64];
  int proxy_port;
  char outbound[QUICK_VOIP_CONFIG_LENGTH64];
  int outbound_port;
  int regoutbound;
  int rtp_port;
} QVoIP_SP_Conf;

QVoIP_SP_Conf qvsp1;

char login_profile[QUICK_VOIP_PRESET_NUM][QUICK_VOIP_LOGIN_NUM] = {	//login list, 5x3 max
  {0, 1, 2},
  {3, 4, 5},
  {6, 7, 8},
  {9, 10, 11},
  {12, 13, 14},
  {15, 16, 17}
};

/*****************************************************/
/* extern functions start */
extern char *read_file_para_value (char *filename, char *arg1, char *buf);
extern int run_script (char *filename, char *arg1, char *arg2, char *arg3);
/* extern functions end */
/*****************************************************/
/* Start of Scan field of each line in a config file */
/* As we know, login list contains 5*3 lines in login_list field */
#define MAX_FIELD_LINES QUICK_VOIP_LGLIST_NUM	// please adjust it depending on lines of a field in config file
#define MKChar_ARY(N)	typeof(char[N])
#define MKChar_ARYD(N) typeof(char[MAX_FIELD_LINES][N])

#define SCANFIELD(fp, x, wd)				\
 ( {							\
   MKChar_ARY(wd) buf;			\
   MKChar_ARYD(wd) buf1;		\
   if (__builtin_types_compatible_p (typeof(x), int*))	\
   	scanfield_int(fp,buf,buf1,(int*)x,wd);				\
   else if (__builtin_types_compatible_p (typeof(x), char [][]) || \
	   __builtin_types_compatible_p (typeof(x), char []))	\
   	scanfield_char_ary(fp,buf,buf1,(void*)x,wd);				\
   else							\
   	abort();					\
   })

#define SCANFIELD32(fp, x) SCANFIELD(fp, x, 32)
#define SCANFIELD64(fp, x) SCANFIELD(fp, x, 64)
#define SCANFIELD128(fp, x) SCANFIELD(fp, x, 128)

int scanfield (FILE * fp, char buf[], char buf1[][], int size);
void scanfield_int (FILE * fp, char buf[], char buf1[][], int *x, int size);
void scanfield_char_ary (FILE * fp, char buf[], char buf1[][], void *x,
			 int size);
void
scanfield_int (FILE * fp, char buf[], char buf1[][], int *x, int size)
{
  scanfield (fp, buf, buf1, size);
  *x = atoi (*buf1);
}

void
scanfield_char_ary (FILE * fp, char buf[], char buf1[][], void *x, int size)
{
  int i = scanfield (fp, buf, buf1, size);
  memcpy (x, buf1, i * size);
}

int
scanfield (FILE * fp, char buf[], char buf1[][], int size)
{
  int i = 0;
  char *buf2 = (char *) buf1;
  do
    {
      fgets (buf, size, fp);
      if (buf[0] == '#')
	break;
      else
	strcpy ((buf2 + i++ * size), buf);
    }
  while (1);
  return i;
}

/* End of Scan field of each line in a config file */
/*****************************************************/
int login_profile_index = 0;
int service_profile_index = 0;

static int lread_qvoip_lg_conf (int index);
static int lread_qvoip_sp_conf (int index);
static void save_quickvoip_conf ();
static void save_qvoip_lg_conf ();
static void save_qvoip_sp_conf ();
static int quick_voip_sippt (int ejid, webs_t wp, int argc, char_t ** argv);
static int quick_voip_rtppt (int ejid, webs_t wp, int argc, char_t ** argv);
static int quick_voip_if (int ejid, webs_t wp, int argc, char_t ** argv);

static int quick_voip_servicepvdr (int ejid, webs_t wp, int argc,
				   char_t ** argv);
static int read_quickvoip_conf (int ejid, webs_t wp, int argc,
				char_t ** argv);
static int quick_voip_loginacnt (int ejid, webs_t wp, int argc,
				 char_t ** argv);
static int quick_voip_loginacnt1 (int ejid, webs_t wp, int argc,
				  char_t ** argv);
static int qvoip_lg_loginaccnt (int ejid, webs_t wp, int argc,
				char_t ** argv);
static int read_qvoip_lg_conf (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_lg_userid (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_lg_passwd (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_lg_authid (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_lg_name (int ejid, webs_t wp, int argc, char_t ** argv);
static int read_qvoip_sp_conf (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_list (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_rgint (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_regaddr (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_regport (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_pxy (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_pxyPort (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_outpxy (int ejid, webs_t wp, int argc, char_t ** argv);
static int qvoip_sp_outpxyPort (int ejid, webs_t wp, int argc,
				char_t ** argv);
static int qvoip_sp_regoutpxy (int ejid, webs_t wp, int argc, char_t ** argv);
static int is_bekovoip_enabled (int ejid, webs_t wp, int argc,
				char_t ** argv);
static int quick_voip_status1 (int ejid, webs_t wp, int argc, char_t ** argv);
static int quick_voip_status11 (int ejid, webs_t wp, int argc,
				char_t ** argv);
static int quick_voip_status2 (int ejid, webs_t wp, int argc, char_t ** argv);
static int quick_voip_status22 (int ejid, webs_t wp, int argc,
				char_t ** argv);
static void form_quick_voip (webs_t wp, char_t * path, char_t * query);
static void form_quick_voip1 (webs_t wp, char_t * path, char_t * query);
static void form_qvoip_lg1 (webs_t wp, char_t * path, char_t * query);
static void form_qvoip_lg (webs_t wp, char_t * path, char_t * query);
static void form_qvoip_sp2 (webs_t wp, char_t * path, char_t * query);
static void form_qvoip_sp1 (webs_t wp, char_t * path, char_t * query);
static void form_qvoip_sp (webs_t wp, char_t * path, char_t * query);
static void form_provtest (webs_t wp, char_t * path, char_t * query);

void
DefineWebFunctions_QuickVoIP ()
{
  websAspDefine (T ("quick_voip_sippt"), quick_voip_sippt);
  websAspDefine (T ("quick_voip_rtppt"), quick_voip_rtppt);
  websAspDefine (T ("quick_voip_if"), quick_voip_if);
  websAspDefine (T ("quick_voip_servicepvdr"), quick_voip_servicepvdr);
  websAspDefine (T ("read_quickvoip_conf"), read_quickvoip_conf);
  websAspDefine (T ("quick_voip_loginacnt"), quick_voip_loginacnt);
  websAspDefine (T ("quick_voip_loginacnt1"), quick_voip_loginacnt1);
  websAspDefine (T ("read_qvoip_lg_conf"), read_qvoip_lg_conf);
  websAspDefine (T ("qvoip_lg_loginaccnt"), qvoip_lg_loginaccnt);
  websAspDefine (T ("qvoip_lg_userid"), qvoip_lg_userid);
  websAspDefine (T ("qvoip_lg_passwd"), qvoip_lg_passwd);
  websAspDefine (T ("qvoip_lg_authid"), qvoip_lg_authid);
  websAspDefine (T ("qvoip_lg_name"), qvoip_lg_name);
  websAspDefine (T ("read_qvoip_sp_conf"), read_qvoip_sp_conf);
  websAspDefine (T ("qvoip_sp_list"), qvoip_sp_list);
  websAspDefine (T ("qvoip_sp_rgint"), qvoip_sp_rgint);
  websAspDefine (T ("qvoip_sp_regaddr"), qvoip_sp_regaddr);
  websAspDefine (T ("qvoip_sp_regport"), qvoip_sp_regport);
  websAspDefine (T ("qvoip_sp_pxy"), qvoip_sp_pxy);
  websAspDefine (T ("qvoip_sp_pxyPort"), qvoip_sp_pxyPort);
  websAspDefine (T ("qvoip_sp_outpxy"), qvoip_sp_outpxy);
  websAspDefine (T ("qvoip_sp_outpxyPort"), qvoip_sp_outpxyPort);
  websAspDefine (T ("qvoip_sp_regoutpxy"), qvoip_sp_regoutpxy);
  websAspDefine (T ("is_bekovoip_enabled"), is_bekovoip_enabled);
  websAspDefine (T ("quick_voip_status1"), quick_voip_status1);
  websAspDefine (T ("quick_voip_status11"), quick_voip_status11);
  websAspDefine (T ("quick_voip_status2"), quick_voip_status2);
  websAspDefine (T ("quick_voip_status22"), quick_voip_status22);
  websFormDefine (T ("quick_voip"), form_quick_voip);
  websFormDefine (T ("quick_voip1"), form_quick_voip1);
  websFormDefine (T ("qvoip_lg1"), form_qvoip_lg1);
  websFormDefine (T ("qvoip_lg"), form_qvoip_lg);
  websFormDefine (T ("qvoip_sp2"), form_qvoip_sp2);
  websFormDefine (T ("qvoip_sp1"), form_qvoip_sp1);
  websFormDefine (T ("qvoip_sp"), form_qvoip_sp);
  websFormDefine (T ("provtest"), form_provtest);
}


static int
quick_voip_sippt (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qc1.sip_port);
}

static int
quick_voip_rtppt (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qc1.rtp_port);
}
static int
quick_voip_if (int ejid, webs_t wp, int argc, char_t ** argv)
{
  if (atoi (argv[0]) == qc1.interface)
    return websWrite (wp, T ("selected"));
  else
    return websWrite (wp, T (""));

}
static int
quick_voip_servicepvdr (int ejid, webs_t wp, int argc, char_t ** argv)
{
  int i = 0;
  for (i = 0; i < QUICK_VOIP_PRESET_NUM; i++)
    {
      if (strcmp (qc1.service_list[i], "0\n") == 0)
	continue;
      if (i == qc1.service_provider)
	websWrite (wp, T (R_SELECT_OPTION), i, "selected",
		   qc1.service_list[i]);
      else
	websWrite (wp, T (R_SELECT_OPTION), i, "", qc1.service_list[i]);
    }
  //return        websWrite(wp,T(R_SELECT_OPTION),"2", "selected", "ppinet");
  return websWrite (wp, T ("\n"));
}
static void
save_quickvoip_conf ()
{
  FILE *fp;
  FILE *fp1;
  FILE *fp2;
  char buf[QUICK_VOIP_CONFIG_LENGTH];
  char buf1[QUICK_VOIP_CONFIG_LENGTH];
  char *tmpbuf;
  int i = 0;
  int j = 1;
  /* remove the file for safety */
  unlink (R_QUICKVOIP_CONF);
  unlink (R_XCONFIG_TMP);
  fp = fopen (R_QUICKVOIP_CONF, "w");
  fp1 = fopen (R_XCONFIG, "r");
  fp2 = fopen (R_XCONFIG_TMP, "w");
  if (fp1 == 0)
    {
      DPRINTF ("read sip config failed!\n");
      return;
    }
  if (fp2 != 0)
    {
      /* read xconfig.cfg and write xconfig.cfg.tmp */
      /* We only modify three sections: sip,gateway, sipline */
      do
	{
	  tmpbuf = fgets (buf, QUICK_VOIP_CONFIG_LENGTH, fp1);
	  if (strcmp (buf, "[sip]\n") == 0)
	    {
	      ac1.sip = 1;
	      ac1.gw = 0;
	      ac1.siplines = 0;
	    }
	  else if (strcmp (buf, "[siplines]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	      ac1.siplines = 1;
	    }
	  else if (strcmp (buf, "[iax]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	      ac1.siplines = 0;
	    }
	  else if (strcmp (buf, "[gw]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 1;
	      ac1.siplines = 0;
	    }
	  else if (strcmp (buf, "[prov]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	      ac1.siplines = 0;
	    }
	  j = sscanf (buf, "port%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "port %d\n", qc1.sip_port);
	      continue;
	    }
	  j = sscanf (buf, "rtp_port%s\n", buf1);
	  if (j != NULL && ac1.gw)
	    {
	      fprintf (fp2, "rtp_port %d\n", qc1.rtp_port);
	      continue;
	    }
	  j = sscanf (buf, "interface%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      switch (qc1.interface)
		{
		case 0:
		  fprintf (fp2, "interface %s\n",
			   (char *) read_file_para_value (R_CONFIG, "WAN_IF=",
							  buf));
		  break;
		case 1:
		case 2:
		case 3:
		case 4:
		  // need more tests
		  //fprintf (fp2, "interface %s%d\n", "brwan", qc1.interface);
		  fprintf (fp2, "interface\n");
		  break;
		default:
		  fprintf (fp2, "interface %s\n", "br0");
		  break;
		}
	      continue;
	    }
	  /* read service provider config: "/flash/qv_spXX.conf" */
	  lread_qvoip_sp_conf (qc1.service_provider);
	  j = sscanf (buf, "register_expires%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "register_expires %d\n", qvsp1.reg_int);
	      continue;
	    }
	  j = sscanf (buf, "registrar_port%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "registrar_port %d\n", qvsp1.reg_port);
	      continue;
	    }
	  j = sscanf (buf, "registrar%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "registrar %s", qvsp1.registrar);
	      continue;
	    }
	  j = sscanf (buf, "proxy_port%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "proxy_port %d\n", qvsp1.proxy_port);
	      continue;
	    }
	  j = sscanf (buf, "proxy%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "proxy %s", qvsp1.proxy);
	      continue;
	    }
	  j = sscanf (buf, "server_port%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "server_port %d\n", qvsp1.outbound_port);
	      continue;
	    }
	  j = sscanf (buf, "server%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "server %s", qvsp1.outbound);
	      continue;
	    }
	  j = sscanf (buf, "register_outbound%s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      fprintf (fp2, "register_outbound %d\n", qvsp1.regoutbound);
	      continue;
	    }
	  /* read line1 login config: "/flash/qv_lgXX.conf" */
	  lread_qvoip_lg_conf (qc1.line1);
	  j = sscanf (buf, "mreg_name0%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_name0 %s", qvlg1.userid);
	      continue;
	    }
	  j = sscanf (buf, "mreg_pass0%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_pass0 %s", qvlg1.password);
	      continue;
	    }
	  j = sscanf (buf, "mreg_uid0%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_uid0 %s", qvlg1.authid);
	      continue;
	    }
	  j = sscanf (buf, "mreg_display0%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_display0 %s", qvlg1.display);
	      continue;
	    }
	  /* read line2 login config: "/flash/qv_lgXX.conf" */
	  lread_qvoip_lg_conf (qc1.line2);
	  j = sscanf (buf, "mreg_name1%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_name1 %s", qvlg1.userid);
	      continue;
	    }
	  j = sscanf (buf, "mreg_pass1%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_pass1 %s", qvlg1.password);
	      continue;
	    }
	  j = sscanf (buf, "mreg_uid1%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_uid1 %s", qvlg1.authid);
	      continue;
	    }
	  j = sscanf (buf, "mreg_display1%s\n", buf1);
	  if (j != NULL && ac1.siplines)
	    {
	      fprintf (fp2, "mreg_display1 %s", qvlg1.display);
	      continue;
	    }

	  /* normal field */
	  fputs (buf, fp2);
	}
      while (tmpbuf != NULL);
      /* close the file */
      fclose (fp1);
      fclose (fp2);
      /* delete xconfig.cfg and rename xconfig.cfg.tmp to xconfig.cfg */
      unlink (R_XCONFIG);
      rename (R_XCONFIG_TMP, R_XCONFIG);
    }
  else
    {
      DPRINTF ("write failed!\n");
    }
  if (fp != 0)
    {
      /* write qucikvoip.conf */
      /* interface */
      fprintf (fp, "#interface\n");
      fprintf (fp, "%d\n", qc1.interface);
      /* service provider */
      fprintf (fp, "#service provider\n");
      fprintf (fp, "%d\n", qc1.service_provider);
      /* service list, 5 max */
      fprintf (fp, "#service list, 5 max.\n");
      for (i = 0; i < QUICK_VOIP_PRESET_NUM ; i++)
	fprintf (fp, "%s", qc1.service_list[i]);
      /* Line1 login */
      fprintf (fp, "#Line1 login\n");
      fprintf (fp, "%d\n", qc1.line1);
      /* Line2 login */
      fprintf (fp, "#Line2 login\n");
      fprintf (fp, "%d\n", qc1.line2);
      /* login list */
      fprintf (fp, "#login list, 5x3 max.\n");
      for (i = 0; i < QUICK_VOIP_LGLIST_NUM; i++)
	fprintf (fp, "%s", qc1.login_list[i]);
      /* end */
      fprintf (fp, "#\n");

      /* close the file */
      fclose (fp);

    }
  else
    {
      DPRINTF ("write failed!!\n");
    }
}
static int
read_quickvoip_conf (int ejid, webs_t wp, int argc, char_t ** argv)
{
  FILE *fp;
  FILE *fp1;
  char buf[QUICK_VOIP_CONFIG_LENGTH];
  char buf1[QUICK_VOIP_CONFIG_LENGTH];
  char *tmpbuf;
  int i = 0;
  int j = 1;

  /* reset qvoip_lg.asp state */
  login_profile_index = 0;

/* decide load from flash state or show temp setting only */
  if (QuickVoIP_Movement == 1)
    {
//              DPRINTF("show only temp setting\n");
      QuickVoIP_Movement = 0;
      return websWrite (wp, T ("\n"));
    }

  /* reset qvoip_sp.asp state */
  service_profile_index = 0;

  fp = fopen (R_QUICKVOIP_CONF, "r");
  fp1 = fopen (R_XCONFIG, "r");
  if (fp1 == 0)
    {
      DPRINTF ("read sip config failed!\n");
      return 1;
    }
  if (fp != 0)
    {
      /* read xconfig.cfg */
      do
	{
	  tmpbuf = fgets (buf, QUICK_VOIP_CONFIG_LENGTH, fp1);
	  if (strcmp (buf, "[sip]\n") == 0)
	    {
	      ac1.sip = 1;
	      ac1.gw = 0;
	    }
	  else if (strcmp (buf, "[siplines]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	    }
	  else if (strcmp (buf, "[iax]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	    }
	  else if (strcmp (buf, "[gw]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 1;
	    }
	  else if (strcmp (buf, "[prov]\n") == 0)
	    {
	      ac1.sip = 0;
	      ac1.gw = 0;
	    }
	  j = sscanf (buf, "port %s\n", buf1);
	  if (j != NULL && ac1.sip)
	    {
	      qc1.sip_port = atoi (buf1);
	    }
	  j = sscanf (buf, "rtp_port %s\n", buf1);
	  if (j != NULL && ac1.gw)
	    {
	      qc1.rtp_port = atoi (buf1);
	    }
	}
      while (tmpbuf != NULL);
      /* close the file */
      fclose (fp1);
      /* read qucikvoip.conf */
      /* interface */
      fgets (buf, QUICK_VOIP_CONFIG_LENGTH, fp);
      SCANFIELD32 (fp, &(qc1.interface));
      /* service provider */
      SCANFIELD32 (fp, &(qc1.service_provider));
      /* service list, 5 max. */
      SCANFIELD32 (fp, qc1.service_list);
      /* Line1 login */
      SCANFIELD32 (fp, &(qc1.line1));
      /* Line2 login */
      SCANFIELD32 (fp, &(qc1.line2));
      /* login list, 5x3 max. */
      SCANFIELD32 (fp, qc1.login_list);

  service_profile_index = qc1.service_provider;
      /* close the file */
      fclose (fp);
    }
  else
    {
      /* read failed */
      DPRINTF ("read failed!\n");
    }

  return websWrite (wp, T ("\n"));

}
static int
quick_voip_loginacnt (int ejid, webs_t wp, int argc, char_t ** argv)
{
  int i = 0;
  for (i = 0; i < QUICK_VOIP_LOGIN_NUM; i++)
    {
      if (strcmp
	  (qc1.login_list[login_profile[qc1.service_provider][i]],
	   "0\n") == 0)
	continue;
      if (i == qc1.line1)
	websWrite (wp, T (R_SELECT_OPTION), i, "selected",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
      else
	websWrite (wp, T (R_SELECT_OPTION), i, "",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
    }
  return websWrite (wp, T ("\n"));
}
static int
quick_voip_loginacnt1 (int ejid, webs_t wp, int argc, char_t ** argv)
{
  int i = 0;
  for (i = 0; i < QUICK_VOIP_LOGIN_NUM; i++)
    {
      if (strcmp
	  (qc1.login_list[login_profile[qc1.service_provider][i]],
	   "0\n") == 0)
	continue;
      if (i == qc1.line2)
	websWrite (wp, T (R_SELECT_OPTION), i + 1, "selected",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
      else
	websWrite (wp, T (R_SELECT_OPTION), i + 1, "",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
    }
  return websWrite (wp, T ("\n"));
}
static void
save_qvoip_lg_conf ()
{
  FILE *fp;
  char buf[QUICK_VOIP_CONFIG_LENGTH];
  /* locate login conf. */
  sprintf (buf, R_QUICKVOIP_DIR "/qv_lg%d.conf",
	   login_profile[qc1.service_provider][login_profile_index] + 1);
  /*DPRINTF("%s\n",buf); */
  /* delete the file first for safety */
  unlink (buf);
  fp = fopen (buf, "w");
  if (fp != 0)
    {
      /* write qv_lgXX.conf */
      /* login name */
      fprintf (fp, "#login name\n");
      fprintf (fp, "%s", qvlg1.login_name);
      fprintf (fp, "#userid\n");
      fprintf (fp, "%s\n", qvlg1.userid);
      fprintf (fp, "#password\n");
      fprintf (fp, "%s\n", qvlg1.password);
      fprintf (fp, "#authid\n");
      fprintf (fp, "%s\n", qvlg1.authid);
      fprintf (fp, "#display name\n");
      fprintf (fp, "%s\n", qvlg1.display);
      fprintf (fp, "#\n");

      /* close the file */
      fclose (fp);
    }
  else
    {
      DPRINTF ("write failed!\n");
    }

}
static int
read_qvoip_lg_conf (int ejid, webs_t wp, int argc, char_t ** argv)
{
  lread_qvoip_lg_conf (login_profile_index);
}
static int
lread_qvoip_lg_conf (int index)
{
  FILE *fp;
  char buf[QUICK_VOIP_CONFIG_LENGTH];
  /* locate login conf. */
  sprintf (buf, R_QUICKVOIP_DIR "/qv_lg%d.conf",
	   login_profile[qc1.service_provider][index] + 1);
  /*DPRINTF("%s\n",buf); */
  if (index == -1)
    fp = fopen (R_QUICKVOIP_DIR "/qv_null.conf", "r");
  else
    fp = fopen (buf, "r");
  if (fp != 0)
    {
      /* read qv_lgXX.conf */
      /* login name */
      fgets (buf, QUICK_VOIP_CONFIG_LENGTH, fp);
      SCANFIELD32 (fp, qvlg1.login_name);
      /* userid */
      SCANFIELD32 (fp, qvlg1.userid);
      /* password */
      SCANFIELD32 (fp, qvlg1.password);
      /* authid */
      SCANFIELD32 (fp, qvlg1.authid);
      /* display name */
      SCANFIELD32 (fp, qvlg1.display);

      /* close file */
      fclose (fp);

    }
  else
    {
      DPRINTF ("read failed!\n");
    }
}
static int
qvoip_lg_loginaccnt (int ejid, webs_t wp, int argc, char_t ** argv)
{
  int i = 0;
  for (i = 0; i < QUICK_VOIP_LOGIN_NUM; i++)
    {
      if (strcmp
	  (qc1.login_list[login_profile[qc1.service_provider][i]],
	   "0\n") == 0)
	continue;
      if (i == login_profile_index)
	websWrite (wp, T (R_SELECT_OPTION), i, "selected",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
      else
	websWrite (wp, T (R_SELECT_OPTION), i, "",
		   qc1.login_list[login_profile[qc1.service_provider][i]]);
    }
  return websWrite (wp, T ("\n"));
}
static int
qvoip_lg_userid (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvlg1.userid);
}
static int
qvoip_lg_passwd (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvlg1.password);
}
static int
qvoip_lg_authid (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvlg1.authid);
}
static int
qvoip_lg_name (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvlg1.display);
}
static void
save_qvoip_sp_conf ()
{
  FILE *fp;
  char buf[64];
  /* locate service provider conf. */
  sprintf (buf, R_QUICKVOIP_DIR "/qv_sp%d.conf", service_profile_index + 1);
  /* delete the file for safety */
  unlink (buf);
  fp = fopen (buf, "w");
  if (fp != 0)
    {
      /* save qv_spXX.conf */
      /* service name */
      fprintf (fp, "#service name\n");
      fprintf (fp, "%s", qvsp1.service_name);
      fprintf (fp, "#reg. interval\n");
      fprintf (fp, "%d\n", qvsp1.reg_int);
      fprintf (fp, "#registrar\n");
      fprintf (fp, "%s\n", qvsp1.registrar);
      fprintf (fp, "#port\n");
      fprintf (fp, "%d\n", qvsp1.reg_port);
      fprintf (fp, "#proxy\n");
      fprintf (fp, "%s\n", qvsp1.proxy);
      fprintf (fp, "#port\n");
      fprintf (fp, "%d\n", qvsp1.proxy_port);
      fprintf (fp, "#outbound proxy\n");
      fprintf (fp, "%s\n", qvsp1.outbound);
      fprintf (fp, "#port\n");
      fprintf (fp, "%d\n", qvsp1.outbound_port);
      fprintf (fp, "#reg outbound\n");
      fprintf (fp, "%d\n", qvsp1.regoutbound);
      fprintf (fp, "#rtp port\n");
      fprintf (fp, "%d\n", qvsp1.rtp_port);
      fprintf (fp, "#\n");

      /* close the file */
      fclose (fp);

    }
  else
    {
      DPRINTF ("write failed!\n");
    }
}
static int
read_qvoip_sp_conf (int ejid, webs_t wp, int argc, char_t ** argv)
{
  lread_qvoip_sp_conf (service_profile_index);
}
static int
lread_qvoip_sp_conf (int index)
{
  FILE *fp;
  char buf[64];
  /* locate service provider conf. */
  sprintf (buf, R_QUICKVOIP_DIR "/qv_sp%d.conf", index + 1);
  /*DPRINTF("%s\n",buf); */
  fp = fopen (buf, "r");
  if (fp != 0)
    {
      /* read qv_spXX.conf */
      /* service name */
      fgets (buf, QUICK_VOIP_CONFIG_LENGTH, fp);
      SCANFIELD32 (fp, qvsp1.service_name);
      /* reg. interval */
      SCANFIELD32 (fp, &(qvsp1.reg_int));
      /* registrar address */
      SCANFIELD64 (fp, qvsp1.registrar);
      /* registrar port */
      SCANFIELD32 (fp, &(qvsp1.reg_port));
      /* proxy address */
      SCANFIELD64 (fp, qvsp1.proxy);
      /* proxy port */
      SCANFIELD32 (fp, &(qvsp1.proxy_port));
      /* outbound proxy */
      SCANFIELD64 (fp, qvsp1.outbound);
      /* outbound proxy port */
      SCANFIELD32 (fp, &(qvsp1.outbound_port));
      /* register outbound proxy */
      SCANFIELD32 (fp, &(qvsp1.regoutbound));
      /* rtp port */
      SCANFIELD32 (fp, &(qvsp1.rtp_port));

      /* close the file */
      fclose (fp);
    }
  else
    {
      DPRINTF ("read conf. failed!\n");
    }

}
static int
qvoip_sp_list (int ejid, webs_t wp, int argc, char_t ** argv)
{
  int i = 0;
  for (i = 0; i < QUICK_VOIP_PRESET_NUM; i++)
    {
      if (strcmp (qc1.service_list[i], "0\n") == 0)
	continue;
      if (i == service_profile_index)
	websWrite (wp, T (R_SELECT_OPTION), i, "selected",
		   qc1.service_list[i]);
      else
	websWrite (wp, T (R_SELECT_OPTION), i, "", qc1.service_list[i]);
    }
  return websWrite (wp, T ("\n"));
}
static int
qvoip_sp_rgint (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qvsp1.reg_int);
}
static int
qvoip_sp_regaddr (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvsp1.registrar);
}
static int
qvoip_sp_regport (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qvsp1.reg_port);
}
static int
qvoip_sp_pxy (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvsp1.proxy);
}
static int
qvoip_sp_pxyPort (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qvsp1.proxy_port);
}
static int
qvoip_sp_outpxy (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%s"), qvsp1.outbound);

}
static int
qvoip_sp_outpxyPort (int ejid, webs_t wp, int argc, char_t ** argv)
{
  return websWrite (wp, T ("%d"), qvsp1.outbound_port);
}
static void
form_quick_voip (webs_t wp, char_t * path, char_t * query)
{
  char_t *buf = NULL;
  buf = websGetVar (wp, T ("quick_voip_sippt"), "quick_voip_sippt");
  /*DPRINTF("%s\n",buf); */
  qc1.sip_port = atoi (buf);
  buf = websGetVar (wp, T ("quick_voip_rtppt"), "quick_voip_rtppt");
  /*DPRINTF("%s\n",buf); */
  qc1.rtp_port = atoi (buf);
  buf = websGetVar (wp, T ("quick_voip_if"), "quick_voip_if");
  /*DPRINTF("%s\n",buf); */
  qc1.interface = atoi (buf);
  buf =
    websGetVar (wp, T ("quick_voip_servicepvdr"), "quick_voip_servicepvdr");
  /*DPRINTF("%s\n",buf); */
  qc1.service_provider = atoi (buf);
  service_profile_index = atoi (buf);
  buf = websGetVar (wp, T ("quick_voip_loginacnt"), "quick_voip_loginacnt");
  /*DPRINTF("%s\n",buf); */
  qc1.line1 = atoi (buf);
  buf = websGetVar (wp, T ("quick_voip_loginacnt1"), "quick_voip_loginacnt1");
  /*DPRINTF("%s\n",buf); */
  qc1.line2 = atoi (buf) - 1;

  /* save to flash */
  save_quickvoip_conf ();

  /* restart act task */
  KillProcessByName ("act", SIGTERM);
  KillProcessByName ("actact", SIGTERM);
  run_script ("/usr/bin/act_spt", 0, 0, 0);

  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/quick_voip.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);

}
static void
form_quick_voip1 (webs_t wp, char_t * path, char_t * query)
{
  char_t *buf = NULL;
  buf =
    websGetVar (wp, T ("quick_voip_servicepvdr"), "quick_voip_servicepvdr");
  /*DPRINTF("%s\n",buf); */
  qc1.service_provider = atoi (buf);
  service_profile_index = atoi (buf);
  qc1.line1 = 0;
  qc1.line2 = -1;
  lread_qvoip_sp_conf (qc1.service_provider);
  qc1.rtp_port = qvsp1.rtp_port;
  /* Change only service provider, line1, line2, and rtp port */
  QuickVoIP_Movement = 1;
  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/quick_voip.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);

}
static void
form_qvoip_lg1 (webs_t wp, char_t * path, char_t * query)
{

  char_t *buf = NULL;

  buf = websGetVar (wp, T ("qvoip_lg_loginaccnt"), "qvoip_lg_loginaccnt");
  /*DPRINTF("%s\n",buf); */
  login_profile_index = atoi (buf);
  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/qvoip_lg.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);
}
static void
form_qvoip_lg (webs_t wp, char_t * path, char_t * query)
{
  char_t *buf = NULL;
  buf = websGetVar (wp, T ("qvoip_lg_loginaccnt"), "qvoip_lg_loginaccnt");
  /*DPRINTF("%s\n",buf); */
  login_profile_index = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_lg_userid"), "qvoip_lg_userid");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvlg1.userid, buf);
  buf = websGetVar (wp, T ("qvoip_lg_passwd"), "qvoip_lg_passwd");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvlg1.password, buf);
  buf = websGetVar (wp, T ("qvoip_lg_authid"), "qvoip_lg_authid");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvlg1.authid, buf);
  buf = websGetVar (wp, T ("qvoip_lg_name"), "qvoip_lg_name");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvlg1.display, buf);

/* save to flash*/
  save_qvoip_lg_conf ();
  /* Change only service provider, line1, line2 */
  QuickVoIP_Movement = 1;

  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/qvoip_lg.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);
}
static void
form_qvoip_sp2 (webs_t wp, char_t * path, char_t * query)
{
  /* Change only service provider, line1, line2 */
  QuickVoIP_Movement = 1;

  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/quick_voip.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);
}
static void
form_qvoip_sp1 (webs_t wp, char_t * path, char_t * query)
{
  char_t *buf = NULL;
  buf = websGetVar (wp, T ("qvoip_sp_list"), "qvoip_sp_list");
  /*DPRINTF("%s\n",buf); */
  service_profile_index = atoi (buf);
  lread_qvoip_sp_conf (service_profile_index);
  qc1.rtp_port = qvsp1.rtp_port;
  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/qvoip_sp.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);
}
static void
form_qvoip_sp (webs_t wp, char_t * path, char_t * query)
{
  char_t *buf = NULL;
  buf = websGetVar (wp, T ("qvoip_sp_list"), "qvoip_sp_list");
  /*DPRINTF("%s\n",buf); */
  service_profile_index = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_sp_rgint"), "qvoip_sp_rgint");
  /*DPRINTF("%s\n",buf); */
  qvsp1.reg_int = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_sp_regaddr"), "qvoip_sp_regaddr");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvsp1.registrar, buf);
  buf = websGetVar (wp, T ("qvoip_sp_regport"), "qvoip_sp_regport");
  /*DPRINTF("%s\n",buf); */
  qvsp1.reg_port = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_sp_pxy"), "qvoip_sp_pxy");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvsp1.proxy, buf);
  buf = websGetVar (wp, T ("qvoip_sp_pxyPort"), "qvoip_sp_pxyPort");
  /*DPRINTF("%s\n",buf); */
  qvsp1.proxy_port = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_sp_outpxy"), "qvoip_sp_outpxy");
  /*DPRINTF("%s\n",buf); */
  strcpy (qvsp1.outbound, buf);
  buf = websGetVar (wp, T ("qvoip_sp_outpxyPort"), "qvoip_sp_outpxyPort");
  /*DPRINTF("%s\n",buf); */
  qvsp1.outbound_port = atoi (buf);
  buf = websGetVar (wp, T ("qvoip_sp_regoutpxy"), "qvoip_sp_regoutpxy");
  /*DPRINTF("%s\n",buf); */
  qvsp1.regoutbound = atoi (buf);

  /*save to flash */
  save_qvoip_sp_conf ();
  qc1.service_provider = service_profile_index;
  qc1.line1 = 0;
  qc1.line2 = -1;
  /* Change only service provider, line1, line2 */
  QuickVoIP_Movement = 1;

  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/qvoip_sp.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);
}

static void
form_provtest (webs_t wp, char_t * path, char_t * query)
{

  KillProcessByName ("act", SIGTERM);
  KillProcessByName ("actact", SIGTERM);

  /* save to flash */
  run_script ("/usr/bin/autoprov", 0, 0, 0);

  /* restart act task */
  run_script ("/usr/bin/act_spt", 0, 0, 0);


  websHeader (wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/quick.asp\");</script>"));

  websFooter (wp);
  websDone (wp, 200);

}
static int
is_bekovoip_enabled (int ejid, webs_t wp, int argc, char_t ** argv)
{
  if (strcmp (websGetRequestUserName (wp), "keysmart") != 0)
    return checked_function_enabled ("BEKO=", wp, argv);	// user accounts
  else
    return checked_function_enabled ("VOIP=", wp, argv);	// admin account
}
static void
print_voip_status (webs_t wp, char *line, int i)
{
  FILE *fp;
  char buf[64];
  char buf1[64];
  int j;
  int k = 0;
  /* get registrar status and line status */
  fp = fopen (line, "r");
  for (j = 0; j < i; j++)
    {
      if (fp != 0)
	{
	  fgets (buf1, 64, fp);
	  k = sscanf (buf1, "#%20[^#]#\n", buf);
	}
    }
  if (fp != 0 && k != 0)
    {
      websWrite (wp, T ("%s"), buf);
    }
  else
    websWrite (wp, T (""));

  if(fp!=0)
      fclose (fp);
}
static int
quick_voip_status1 (int ejid, webs_t wp, int argc, char_t ** argv)
{
  char line1[] = "/tmp/line0";
  int fac_pid;
  FILE *fp;
  static int i = 0;
#if 0
  /* check if factoryreset is on normal state -- bug of signal */
//  if ((fp = fopen ("/var/state/factoryreset.alive", "r")) == NULL)
if(i>40)
    {
	i = 0;

      //restart factoryreset
      if ((fp = fopen ("/var/state/factoryreset.pid", "r")) != NULL)
	{
	  fscanf (fp, "%d", &fac_pid);
	  kill (fac_pid, SIGTERM);
	  fclose (fp);
	}
      unlink ("/var/state/factoryreset.pid");

      /* restart act task */
      run_script ("/usr/bin/restartfac", 0, 0, 0);

    }
  else
	  i++;
#endif
#if 0
      /* notify factoryreset to update SIP status */
      if ((fp = fopen ("/var/state/actact.pid", "r")) != NULL)
	{
	  fscanf (fp, "%d", &fac_pid);
	  kill (fac_pid, SIGUSR1);
	  fclose (fp);
	}
      /* Robert added 2006/05/09 -- end -- */
#endif
//print_voip_status_here:
  print_voip_status (wp, line1, 1);
  return (websWrite (wp, T ("\n")));

}
static int
quick_voip_status2 (int ejid, webs_t wp, int argc, char_t ** argv)
{
  char line2[] = "/tmp/line1";
  print_voip_status (wp, line2, 1);
  return (websWrite (wp, T ("\n")));
}
static int
quick_voip_status11 (int ejid, webs_t wp, int argc, char_t ** argv)
{
  char line2[] = "/tmp/line0";
  print_voip_status (wp, line2, 2);
  return (websWrite (wp, T ("\n")));
}
static int
quick_voip_status22 (int ejid, webs_t wp, int argc, char_t ** argv)
{
  char line2[] = "/tmp/line1";
  print_voip_status (wp, line2, 2);
  return (websWrite (wp, T ("\n")));
}
static int
qvoip_sp_regoutpxy (int ejid, webs_t wp, int argc, char_t ** argv)
{
  if (atoi (argv[0]) == qvsp1.regoutbound)
    return websWrite (wp, T ("checked"));
  else
    return websWrite (wp, T (""));
}
