/*
 *  rbnosv.asp: Reboot without saving to flash
 */
#include "webs.h"
#include "rbnosv.h"
#include <signal.h>
/* dmt status */
#include <fcntl.h>      /* open */ 
#include <sys/ioctl.h>  /* ioctl */
#include <linux/tc3162dmtctrl.h>
#include "../iptables-1.2.11/runFunc.h"
#include "lan_conf.h"
#include "wan.h" 
extern int KillAllProcess(void);
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
extern void runStopPppoecd();
extern void runStopBr2684ctl();
static int is_upgrade_enabled (int ejid, webs_t wp, int argc, char_t **argv);
static int do_reboot (int, webs_t, int, char_t **);
int ShutDown (int FlashWrite);

void TCDMT_SetDmtClose(void )
{
    unsigned char Arg;
    int nFd = open( "/dev/dmtdev", O_RDWR );
    if( nFd == -1  )
	{
		DPRINTF("getDownUpStreamRate:severe error for open /dev/dmtdev for ADSL device\n");
		return;
	}
    ioctl( nFd, DMTIOCTL_SET_DMTCLOSE, &Arg );
	close(nFd);
} /* TCDMT_SetDmtClose */
int checked_function_enabled1 (char *parameter, webs_t wp, char_t **argv)
{
    char_t buf1[64];
	char_t is_yes[20];
	int i=0;
	strcpy(is_yes,(char *)read_file_para_value("/var/tmp/sysready",parameter,buf1));
 	if(strcmp(is_yes,"yes")==0)
		return websWrite(wp, T(""));
	
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("/*"));
	else
		return websWrite(wp, T("*/"));
}
int checked_function_enabled2 (char *parameter, webs_t wp, char_t **argv)
{
    char_t buf1[64];
	char_t is_yes[20];
	int i=0;
	strcpy(is_yes,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,parameter,buf1));
	/* KenWang modified 2005/06/28 -- begin -- */
	/* use this to comment out the function that we don't want when the parameter is 'yes' */
	i = atoi(argv[0]);
 	if(strcmp(is_yes,"yes")==0)
	{
		if(i == 3)
			return websWrite(wp, T("<!--"));
		else if(i == 4)
			return websWrite(wp, T("-->"));
		else
			return websWrite(wp, T(""));
	}
	
	else
	{
		//Then function is not present
		//i=atoi(argv[0]);
		if(i==0)//comment begin
			return websWrite(wp, T("<!--"));
		else if(i == 1)
			return websWrite(wp, T("-->"));
		else
			return websWrite(wp, T(""));
	}
	/* KenWang modified 2005/06/28 -- end -- */
}
static int is_upgrade_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled1("SYSREADY=",wp,argv);
}
// ShutDown(1) : write to flash
// ShutDown(0) : normal reboot
int ShutDown (int previousFlashWrite){
	char str_wanif[20];
	char str_wan[20];
	char buf[32];
	DPRINTF("close system led\n");
	write_value_to_file("/proc/GPIOUSER/sysled",DISCONNECTED);
	strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
	strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf));

	if (!strcmp(str_wan,"pppoe")){
		runStopPppoecd();
		runStopBr2684ctl();
	}
#ifdef _RALINK_WIRLESS_DRIVER_
	run_task("/sbin/ifconfig","/sbin/ifconfig","ra0","down",NULL);
#else
	run_task("/sbin/ifconfig","/sbin/ifconfig","wlan0","down",NULL);
#endif
	//for Wan_if is null or bridge, we do not do the down.
	if (strcmp(str_wan,"bridge")){
	run_task("/sbin/ifconfig","/sbin/ifconfig",str_wanif,"down",NULL);
	}
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	if(previousFlashWrite)
        {
		sleep(5);// Wait for previous flash write finished.
		KillAllProcess();
	
		//run_script("/etc/scripts/killctl.sh",0,0,0);
//Aki, after adding VLAN default to load, following will cause system hang when firmware update, since only firmware
// update will cause this Shutdown(1), shall we temp come it out or temp change the WAN_IF to ""?
#if 0
		if (!strcmp(str_wanif,"nas0"))
			run_task("/usr/sbin/br2684ctl","/usr/sbin/br2684ctl", "-d","0",NULL);
		if ((!strcmp(str_wanif,"atm0")) && (!strcmp(str_wan,"routed")))
			run_task("/usr/sbin/rt2684d","/usr/sbin/rt2684d", "-d","0",NULL);
#endif		
		sleep(3);
		//dmt_write_cmd(DMT_SHUTDOWN);
		TCDMT_SetDmtClose();
		sleep(2);
	}
	else{
		KillAllProcess();
		//run_script("/etc/scripts/killctl.sh",0,0,0);
		if (!strcmp(str_wanif,"nas0"))
			run_task("/usr/sbin/br2684ctl","/usr/sbin/br2684ctl", "-d","0",NULL);
		if ((!strcmp(str_wanif,"atm0")) && (!strcmp(str_wan,"routed")))
			run_task("/usr/sbin/rt2684d","/usr/sbin/rt2684d", "-d","0",NULL);
		
		//dmt_write_cmd(DMT_SHUTDOWN);
		TCDMT_SetDmtClose();
	}
	return 1;
}
static int do_reboot (int ejid, webs_t wp, int argc, char_t **argv)
{
	ShutDown(0);
	// just 'reboot', don't 'kill -1' for stability
	return run_script("/etc/scripts/reboot.sh",0,0,0);
	//return(kill(1, SIGTERM));
}
void DefineWebFunctions_rbnosv() 
{
	websAspDefine(T("is_upgrade_enabled"), is_upgrade_enabled);
  	websAspDefine (T ("do_reboot"), do_reboot);
}

