/*
 *  remote.asp configuration
 */
#include "webs.h"
#include "remote.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"
REMOTE_CONFIG_DATA remote_config;
extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

void resetCurrentRemoteCfg(void);
static int Load_Remote_Config (void);
static int Save_Remote_Config (REMOTE_CONFIG_DATA *d);
static int get_remote_mod (int eid, webs_t wp, int argc, char_t ** argv);
static void form_remote_config(webs_t wp,char_t * path,char_t * query);

void resetCurrentRemoteCfg(void)
{
	REMOTE_CONFIG_DATA *d=&remote_config;
	memset(d,0,sizeof(REMOTE_CONFIG_DATA));
}

static int Load_Remote_Config (void)
{
	FILE *fp;
	resetCurrentRemoteCfg();
	fp=fopen(REMOTE_CONFIG_FILE,"r");
	if(fp) {
		fscanf(fp,"|%d|%20[^|]|%20[^|]|\n",&remote_config.enable,remote_config.IpStart,remote_config.IpEnd);	
		fclose(fp);
	print_blank_string(remote_config.IpStart);
	print_blank_string(remote_config.IpEnd);
	}
	return 0;
}

static int Save_Remote_Config (REMOTE_CONFIG_DATA *d)
{

	FILE *fp;

	load_blank_string(remote_config.IpStart);
	load_blank_string(remote_config.IpEnd);
	fp=fopen(REMOTE_CONFIG_FILE,"w");
	if(fp){ 
		fprintf(fp,"|%d|%s|%s|\n",remote_config.enable,remote_config.IpStart,remote_config.IpEnd);	
		fclose(fp);
	}
	return 0;
}

static int get_remote_ip (int eid, webs_t wp, int argc, char_t ** argv)
{
	int i;
	i=atoi(argv[0]);
	Load_Remote_Config();
	if (remote_config.enable)
	{
		if(i)			
			return websWrite(wp, T("%s"),remote_config.IpEnd);
		else
			return websWrite(wp, T("%s"),remote_config.IpStart);
	}
	else
	{
		if(i)			
			return websWrite(wp, T("\"%s\" disabled"),remote_config.IpEnd);
		else
			return websWrite(wp, T("\"%s\" disabled"),remote_config.IpStart);
	}
}

static int get_remote_mod (int eid, webs_t wp, int argc, char_t ** argv)
{
	int i;
	i=atoi(argv[0]);
	Load_Remote_Config();
	if (i==remote_config.enable)
		return websWrite(wp, T("checked"));
	else
		return websWrite(wp, T(""));
}

static void form_remote_config(webs_t wp,char_t * path,char_t * query)
{	
	char *buf=NULL;
	REMOTE_CONFIG_DATA old_remote_config;
 	
	Load_Remote_Config();
	memcpy(&old_remote_config,&remote_config,sizeof(REMOTE_CONFIG_DATA));
	
	buf=websGetVar(wp, T("enable"), "0");
	remote_config.enable=atoi(buf);
	strcpy(remote_config.IpStart,websGetVar(wp, T("IpFrom"), "")); 
	strcpy(remote_config.IpEnd,websGetVar(wp, T("IpTo"), "")); 
	Save_Remote_Config(&remote_config);
	if((old_remote_config.enable!=remote_config.enable) ||
	(strcmp(old_remote_config.IpStart,remote_config.IpStart)) ||
	(strcmp(old_remote_config.IpEnd,remote_config.IpEnd)) )
	{
		char funcNum[4];
		char_t str_wanip[20];
		char_t buf1[20];
		sprintf(funcNum,"%d",FUNCTION_NUM_REMOTE_CONFIG);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		// KenWang modified 2005/05/20
		//if ((isValidIP(str_wanip)) && (remote_config_enabled))
		if (isValidIP(str_wanip))
		{	
			//DPRINTF("calling runFunc start upnp\n");
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
		}
	}
	websRedirect(wp,T("remote.asp"));
}

void DefineWebFunctions_remote () {
	websAspDefine(T("get_remote_mod"), get_remote_mod);
	websAspDefine(T("get_remote_ip"), get_remote_ip);
	websFormDefine(T("remote"), form_remote_config);
}
