/*
 *  route.htm: Static Routing Configuration
 */
#include "webs.h"
#include "route.h"
#include "lan_conf.h"
#include "wan.h"
#include "locale.h"

extern char *Route_L1[];
extern char *Route_L2[];
extern char *Route_L3[];
extern char *Route_L4[];
extern char *Route_L5[];

ROUTE_CONFIG_DATA route_config[MAX_ROUTES];
ROUTE_CONFIG_DATA1 route_config1[20];

static void resetCurrentRouteCfg(void);
void Load_Route_Config (void);
int Load_Route_Config1 (void);
void Save_Route_Config (void);
static int read_static_route (int ejid, webs_t wp, int argc, char_t **argv);
static int get_num_route (int ejid, webs_t wp, int argc, char_t **argv);
static int get_num_route1 (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_js (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_js1 (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_status (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_status1 (int ejid, webs_t wp, int argc, char_t **argv);
static int get_interface_status (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_mod (int ejid, webs_t wp, int argc, char_t **argv);
static int get_route_mod1 (int ejid, webs_t wp, int argc, char_t **argv);
static int show_route_status (int ejid, webs_t wp, int argc, char_t **argv);
void form_route_add_conf(webs_t wp, char_t * path,char_t * query);
void form_route_edit_conf(webs_t wp, char_t * path,char_t * query);
void form_route_delete_conf(webs_t wp, char_t * path,char_t * query);
void form_route_add_conf1(webs_t wp, char_t * path,char_t * query);
void form_route_edit_conf1(webs_t wp, char_t * path,char_t * query);
void form_route_delete_conf1(webs_t wp, char_t * path,char_t * query);
int get_number_of_route();
void route_del(void);
void route_add(void);
/*
#define LAN_ROUTE_CONF_FN_RULE_ADD    "/var/etc/lan.route.conf.rule.add"
#define LAN_ROUTE_CONF_FN_RULE_DEL   "/var/etc/lan.route.conf.rule.del"
#define LAN_ROUTE_CONF_FN_RULE_DEL_OLD   "/var/etc/lan.route.conf.rule.del_old"
#define WAN_ROUTE_CONF_FN_RULE_ADD    "/var/etc/wan.route.conf.rule.add"
#define WAN_ROUTE_CONF_FN_RULE_DEL   "/var/etc/wan.route.conf.rule.del"
#define WAN_ROUTE_CONF_FN_RULE_DEL_OLD   "/var/etc/wan.route.conf.rule.del_old"
*/
void route_add1(int i){
	ROUTE_CONFIG_DATA1 *d = &route_config1[i];
	/*
	DPRINTF("add-des:%s\n",d->Destination);
	DPRINTF("add-gw:%s\n",d->Gateway);
	DPRINTF("add-mask:%s\n",d->Mask);
	DPRINTF("add-metric:%s\n",d->Metric);
	DPRINTF("add-Iface:%s\n",d->Iface);
	*/
	if (!strcmp(d->Gateway,"0.0.0.0")){
		char_t *argv1[]={"route","add","-net",d->Destination,"netmask",d->Mask,"metric",d->Metric,d->Iface,NULL};
		route_main(10,argv1);
	}
	else {
		char_t *argv1[]={"route","add","-net",d->Destination,"gw",d->Gateway,"netmask",d->Mask,"metric",d->Metric,d->Iface,NULL};
		route_main(12,argv1);
	}
}
void route_del1(int i){
	ROUTE_CONFIG_DATA1 *d = &route_config1[i];
	/*
	DPRINTF("del-des:%s\n",d->Destination);
	DPRINTF("del-gw:%s\n",d->Gateway);
	DPRINTF("del-mask:%s\n",d->Mask);
	DPRINTF("del-metric:%s\n",d->Metric);
	DPRINTF("del-Iface:%s\n",d->Iface);
	*/
	char_t *argv1[]={"route","del","-net",d->Destination,"gw",d->Gateway,"netmask",d->Mask,"metric",d->Metric,d->Iface,NULL};
	route_main(12,argv1);
}
void route_add(void){
	FILE *fp;
	int i=0;
	char_t buf1[32];
	char_t metric[8];
	char_t str_lanif[10];
	char_t str_wanif[10];
	char_t str_if[10];
	strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf1));
	strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf1));
	Load_Route_Config ();
	if((fp=fopen(TMP_ROUTE_CONFIG_FILE,"w"))!=NULL){
	for(i=0;i<MAX_ROUTES;i++){
		ROUTE_CONFIG_DATA *d = &route_config[i];
			sprintf(metric,"%d",d->cost);
			if (d->interface==1)
				strcpy(str_if,str_lanif);
			else if (d->interface==2)
				strcpy(str_if,str_wanif);
			// KenWang modified 2005/05/17
			else{ // if i > contents of static route, it comes in here.
				break;
				//fclose(fp);
				//CopyFile(TMP_ROUTE_CONFIG_FILE,ROUTE_CONFIG_FILE);
				//return;
			}
			if (!strcmp(d->gateway,"0.0.0.0")){
				char_t *argv1[]={"route","add","-net",d->destination,"netmask",d->netmask,"metric",metric,str_if,NULL};
				//DPRINTF("1.rulenum:%d\n",rulenum);
//				if(route_main(10,argv1))
				fprintf(fp,"|%d|%s|%s|%s|%d|%d|\n",
					route_main(10,argv1),
					d->destination,
					d->netmask,
					d->gateway,
					d->interface,
					d->cost);
			}
			else{
				char_t *argv1[]={"route","add","-net",d->destination,"gw",d->gateway,"netmask",d->netmask,"metric",metric,str_if,NULL};
				fprintf(fp,"|%d|%s|%s|%s|%d|%d|\n",
					route_main(12,argv1),
					d->destination,
					d->netmask,
					d->gateway,
					d->interface,
					d->cost);
				}
			}
			/*
			DPRINTF("add_route\n");
			DPRINTF("destination:%s\n",d->destination);
			DPRINTF("gateway:%s\n",d->gateway);
			DPRINTF("netmask:%s\n",d->netmask);
			DPRINTF("metric:%s\n",metric);
			DPRINTF("cost:%d\n",d->cost);
			DPRINTF("interface:%d\n",d->interface);
			*/
		fclose(fp);
		CopyFile(TMP_ROUTE_CONFIG_FILE,ROUTE_CONFIG_FILE);
	}
}

void route_del(void){
	int i=0;
	char_t buf1[32];
	char_t metric[8];
	char_t str_lanif[10];
	char_t str_if[10];
	char_t str_wanif[10];
	strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf1));
	strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf1));
	for(i=0;i<MAX_ROUTES;i++){
		ROUTE_CONFIG_DATA *d = &route_config[i];
			sprintf(metric,"%d",d->cost);
			if (d->interface==1)
				strcpy(str_if,str_lanif);
			else if (d->interface==2)
				strcpy(str_if,str_wanif);
			else
				return;
			if (!d->valid){
			char_t *argv1[]={"route","del","-net",d->destination,"gw",d->gateway,"netmask",d->netmask,"metric",metric,str_if,NULL};
			route_main(12,argv1);
			}
			/*
			DPRINTF("del_route\n");
			DPRINTF("destination:%s\n",d->destination);
			DPRINTF("gateway:%s\n",d->gateway);
			DPRINTF("netmask:%s\n",d->netmask);
			DPRINTF("metric:%s\n",metric);
			DPRINTF("cost:%d\n",d->cost);
			DPRINTF("interface:%d\n",d->interface);
			*/
	}
	
}

// KenWang modified 2005/05/16: refer to 7202 to fix routing table edit/delete error
static int show_route_status (int ejid, webs_t wp, int argc, char_t **argv){
	int i,num=0,j=0;
	num=Load_Route_Config1();
	
	char_t *TableFmt="<tr>\n\t<td><nobr>%d</nobr></td>\n";
	char_t *TableFmt1="\t<td><nobr>%s</nobr></td>\n";
	char_t *TableFmt2="\t<td><nobr>%s</nobr></td>\n";
	char_t *TableFmt3="\t<td><nobr>%s";
	char_t *TableFmt4="/%s</nobr></td>\n\t<td><nobr>%s</nobr></td>\n";
	char_t *TableFmt5="<form name=routeedit action=route_edit1.asp method=post>\n"
			  "<INPUT type=hidden name=routeid_html value=%d>\n"
			  "<INPUT type=hidden name=routeid value=%d>\n"
			  "<td><nobr><a href=\"javascript:route_edit(%d)\">%s\n"
			  "<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			  "</form>\n";
	char_t *TableFmt6="<form name=routedelete action=route_delete1.asp method=post>\n"
		          "<INPUT type=hidden name=routeid_html value=%d>\n"
		          "<INPUT type=hidden name=routeid value=%d>\n"
		          "<td><nobr><a href=\"javascript:route_delete(%d)\">%s\n"
		          "<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
		          "</form>\n\t</tr>\n";
	
	for (i=0;i<num;i++){
		if( atoi(route_config1[i].Flags) & 0x0001)
		{
		//Julian modify for route 20050516
		websWrite(wp, T(TableFmt),j+1);
		websWrite(wp, T(TableFmt1),route_config1[i].Destination);
		websWrite(wp, T(TableFmt2),route_config1[i].Mask);
		websWrite(wp, T(TableFmt3),route_config1[i].Gateway);
		websWrite(wp, T(TableFmt4),(!strcmp(route_config1[i].Iface,"br0")) ? "iplan" : "ipwan",route_config1[i].Metric);
		websWrite(wp, T(TableFmt5),j,i,j,Route_L1[locale_config.locale]);
		websWrite(wp, T(TableFmt6),j,i,j,Route_L2[locale_config.locale]);
		j++;
		}
	}
	return 1;
}

static void resetCurrentRouteCfg(void)
{
//	int i;
//	for(i=0;i<MAX_ROUTES;i++){
	//ROUTE_CONFIG_DATA *d = &route_config[i];
	//memset(d,0,sizeof(ROUTE_CONFIG_DATA));
	memset(route_config,0,sizeof(ROUTE_CONFIG_DATA)*MAX_ROUTES);
	/*
		d->valid=0;
		strcpy(d->destination,"");
		strcpy(d->netmask,"");
		strcpy(d->gateway,"");
		d->interface=0;
		d->cost=1;
	*/
//	}

}

static void resetCurrentRouteCfg1(void){
	int i;
	for(i=0;i<MAX_ROUTES;i++){
	ROUTE_CONFIG_DATA1 *d1 = &route_config1[i];
	memset(d1,0,sizeof(ROUTE_CONFIG_DATA1));
	}
	
}

void Load_Route_Config (void)
{
	FILE *fp;
	int i=0;
	char_t line[1024];
	resetCurrentRouteCfg();
	if ((fp=fopen(ROUTE_CONFIG_FILE,"r"))!=NULL){
		while (fgets(line, 1024, fp)){
//		DPRINTF("load route line:%s",line);	
		sscanf(line,"|%d|%20[^|]|%20[^|]|%20[^|]|%d|%d|\n",
			&route_config[i].valid,
			route_config[i].destination,
			route_config[i].netmask,
			route_config[i].gateway,
			&route_config[i].interface,
			&route_config[i].cost
			);
		print_blank_string(&route_config[i].destination);
		print_blank_string(&route_config[i].netmask);
		print_blank_string(&route_config[i].gateway);
		i++;
		}
	fclose(fp);
	}	
}
int Load_Route_Config1 (void)
{
	FILE *fp;
	int i=0,num=0;
	char_t buf[32];
	char_t line[512];
	char_t str_Destination[20];
	char_t str_Gateway[20];
	char_t str_Mask[20];
	resetCurrentRouteCfg1();
	if((fp=fopen(SYS_ROUTE_CONF,"r"))!=0){
		fgets(line, 1024, fp);
		for(i=0;i<20;i++){	
			if(fgets(line, 1024, fp)){
				num++;
			sscanf(line,"%s %s %s %s %s %s %s %s %s %s %s\n",
				route_config1[i].Iface,
				str_Destination,
				str_Gateway,
				route_config1[i].Flags,
				route_config1[i].RefCnt,
				route_config1[i].Use,
				route_config1[i].Metric,
				str_Mask,
				route_config1[i].MTU,
				route_config1[i].Window,
				route_config1[i].IRTT);
			sprintf(route_config1[i].Destination,"%s",HextoDec_ip(str_Destination,buf));
			sprintf(route_config1[i].Gateway,"%s",HextoDec_ip(str_Gateway,buf));
			sprintf(route_config1[i].Mask,"%s",HextoDec_ip(str_Mask,buf));
			}
	}
	fclose(fp);
	}
	return num;
}
/*
void Load_Route_Config1 (void)
{
	FILE *fp;
	int i=0;
	char_t line[1024];
	resetCurrentRouteCfg();
	if ((fp=fopen("/var/etc/routes.conf","r"))!=NULL){
	while (fgets(line, 1024, fp)){
		sscanf(line,"|%d|%20[^|]|%20[^|]|%20[^|]|%d|%d|\n",
			&route_config[i].valid,
			route_config[i].destination,
			route_config[i].netmask,
			route_config[i].gateway,
			&route_config[i].interface,
			&route_config[i].cost
			);
		print_blank_string(&route_config[i].destination);
		print_blank_string(&route_config[i].netmask);
		print_blank_string(&route_config[i].gateway);
		i++;
		}
	fclose(fp);
	}	
}
*/
void Save_Route_Config (void){
	FILE *fp;
	int i=0;
	if((fp=fopen(ROUTE_CONFIG_FILE,"w"))!=NULL){
		for(i=0;i<MAX_ROUTES;i++){
			ROUTE_CONFIG_DATA *d = &route_config[i];
			if(d->interface!=0){
			load_blank_string(d->destination);	
			load_blank_string(d->netmask);	
			load_blank_string(d->gateway);	
			fprintf(fp,
				"|%d|%s|%s|%s|%d|%d|\n",
				d->valid,
				d->destination,
				d->netmask,
				d->gateway,
				d->interface,
				d->cost
				);
			}
		}
	fclose(fp);
	}
}
#if 0
int set_config_to_script(void)
{
	int num,i;
	FILE *fp,*outfp,*outfp2,*outfp3,*outfp4;
	char filename[80];
	char buf[32];
	Load_Route_Config ();
	num=get_number_of_route();
	outfp=fopen(LAN_ROUTE_CONF_FN_RULE_ADD,"w");
	if (outfp==NULL) return -1;
	rename(LAN_ROUTE_CONF_FN_RULE_DEL, LAN_ROUTE_CONF_FN_RULE_DEL_OLD);
	outfp2 = fopen(LAN_ROUTE_CONF_FN_RULE_DEL, "w");
	if (outfp2==NULL) return -1;
	outfp3=fopen(WAN_ROUTE_CONF_FN_RULE_ADD,"w");
	if (outfp3==NULL) return -1;
	rename(WAN_ROUTE_CONF_FN_RULE_DEL, WAN_ROUTE_CONF_FN_RULE_DEL_OLD);
	outfp4 = fopen(WAN_ROUTE_CONF_FN_RULE_DEL, "w");
	if (outfp4==NULL) return -1;
	
	if ((fp = fopen(LAN_ROUTE_CONF_FN_RULE_DEL_OLD, "r")) != NULL){
		fclose(fp);
		run_script(LAN_ROUTE_CONF_FN_RULE_DEL_OLD, 0, 0, 0);
	}
	if ((fp = fopen(WAN_ROUTE_CONF_FN_RULE_DEL_OLD, "r")) != NULL){
		fclose(fp);
		run_script(WAN_ROUTE_CONF_FN_RULE_DEL_OLD, 0, 0, 0);
	}
	if (num==0){
		unlink(LAN_ROUTE_CONF_FN_RULE_ADD);
		unlink(LAN_ROUTE_CONF_FN_RULE_DEL);
		unlink(WAN_ROUTE_CONF_FN_RULE_ADD);
		unlink(WAN_ROUTE_CONF_FN_RULE_DEL);
		sprintf(filename, "%s", LAN_ROUTE_CONF_FN_RULE_DEL_OLD);
		sprintf(filename, "%s", WAN_ROUTE_CONF_FN_RULE_DEL_OLD);
		fclose(outfp);
		fclose(outfp2);
		fclose(outfp3);
		fclose(outfp4);
		return 0;
	}
	fprintf(outfp, "#!/bin/sh\n");
	fprintf(outfp, ". /var/etc/status\n");
	fprintf(outfp2, "#!/bin/sh\n");
	fprintf(outfp2, ". /var/etc/status\n");
	fprintf(outfp3, "#!/bin/sh\n");
	fprintf(outfp3, ". /var/etc/status\n");
	fprintf(outfp4, "#!/bin/sh\n");
	fprintf(outfp4, ". /var/etc/status\n");
	for(i=0;i<num;i++){
		ROUTE_CONFIG_DATA *d=&route_config[i];
		if (d->interface==1){
			fprintf(outfp, "route add -net %s gw %s netmask %s metric %d $LAN_IF\n",
				d->destination,
				d->gateway,
				d->netmask,
				d->cost
				);
			fprintf(outfp2, "route del -net %s gw %s netmask %s metric %d $LAN_IF\n",
				d->destination,
				d->gateway,
				d->netmask,
				d->cost
				);
		}
		else { /* if (d->interface==2) */
			fprintf(outfp3, "route add -net %s gw %s netmask %s metric %d $WAN_IF\n",
				d->destination,
				d->gateway,
				d->netmask,
				d->cost
				);
			fprintf(outfp4, "route del -net %s gw %s netmask %s metric %d $WAN_IF\n",
				d->destination,
				d->gateway,
				d->netmask,
				d->cost
				);
		}
	};
   	fclose(outfp);	
	fclose(outfp2);	
   	fclose(outfp3);	
	fclose(outfp4);	
	chmod(LAN_ROUTE_CONF_FN_RULE_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(LAN_ROUTE_CONF_FN_RULE_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(WAN_ROUTE_CONF_FN_RULE_ADD, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	chmod(WAN_ROUTE_CONF_FN_RULE_DEL, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH) ;
	return 0;	
	
}
#endif
static int read_static_route (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i,num;
	char_t buf[32];
	char_t interface[10];
	Load_Route_Config();
	//Load_Route_Config1();
	num=get_number_of_route();
	for (i=0;i<num;i++){
			if (route_config[i].interface==1){ /* lan_interface */
				
				//strcpy(interface,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf));
				strcpy(interface,"iplan");
			}
			else if (route_config[i].interface==2){ /* wan_interface */
				//strcpy(interface,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
				strcpy(interface,"ipwan");
			}
			else
				strcpy(interface,"");
		char_t *TableFmt="<tr>\n"
			"\t<td><nobr>%d</nobr></td>\n"
			"\t<td><nobr>%s</nobr></td>\n"
			"\t\t<td><nobr>%s</nobr></td>\n"
			"\t\t<td><nobr>%s</nobr></td>\n"
			"\t\t<td><nobr>%s/%s</nobr></td>\n"
			"\t\t\t<form name=routeedit action=route_edit.asp method=post>\n"
			"\t\t\t\t<INPUT type=hidden name=routeid value=%d>\n"
			"\t\t<td><nobr><a href=\"javascript:route_edit(%d)\">%s\n"
			"\t\t\t<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			"\t\t\t</form>\n"
			"\t\t\t<form name=routedelete action=route_delete.asp method=post>\n"
			"\t\t\t\t<INPUT type=hidden name=routeid value=%d>\n"
			"\t\t<td><nobr><a href=\"javascript:route_delete(%d)\">%s\n"
			"\t\t\t<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			"\t\t\t</form>\n"
		        "\t</tr>\n";
			websWrite(wp, T(TableFmt),
			i+1,
			((route_config[i].valid==0) ? Route_L3[locale_config.locale] : Route_L4[locale_config.locale]), 		
			route_config[i].destination,
			route_config[i].netmask,
			route_config[i].gateway,
			interface,
			i,
			i,
			Route_L1[locale_config.locale],
			i,
			i,
			Route_L2[locale_config.locale]
			);
	       }
	// KenWang added 2005/05/17: show "Create" if webpage if contents of static route is less then 20
	if(num < 20)
	{
		char_t *TableFmt1 = "\t<TR>\n"
				    "\t\t<TD colSpan=7>\n"
				    "\t\t<BR>\n"
				    "\t\t\t<A href=\"staticroute_create.asp\">%s"
					"<IMG align=middle border=0 src=\"/link1.gif\"></A>\n"
				    "\t\t</TD>\n\t<TR>\n";
		websWrite(wp, T(TableFmt1),Route_L5[locale_config.locale]);
				 
	}
	return 0;
}

static int get_num_route (int ejid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	int i=0;
	char_t line[1024];
	
	if ((fp=fopen(ROUTE_CONFIG_FILE,"r"))!=NULL){
		while (fgets(line, 1024, fp))
		i++;
	fclose(fp);
	}	
	
	return websWrite(wp,T("%d"),i+1);
}

int get_number_of_route()
{
	FILE *fp;
	int i=0;
	char_t line[1024];
	
	if ((fp=fopen(ROUTE_CONFIG_FILE,"r"))!=NULL){
		while (fgets(line, 1024, fp))
		i++;
	fclose(fp);
	}
	return i;
	
}
int get_number_of_route1()
{
	int num=Load_Route_Config1();
	int i,j=0;
	for (i=0;i<num;i++){
		if( atoi(route_config1[i].Flags) & 0x0001)
			j++;
	}
	return j;

}
static int get_num_route1 (int ejid, webs_t wp, int argc, char_t **argv)
{
	int num=Load_Route_Config1();
	int i,j=0;
	for (i=0;i<num;i++){
		if( atoi(route_config1[i].Flags) & 0x0001)
			j++;
	}
	return websWrite(wp,T("%d"),j+1);
}
static int get_route_js1 (int ejid, webs_t wp, int argc, char_t **argv)
{
	int num;
	num=get_number_of_route1();
	if (num==0)
		websWrite(wp,T(""));
	else if (num==1){
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction route_edit(){\n"));
		websWrite(wp,T("\t\t\tdocument.routeedit.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction route_delete(){\n"));
		websWrite(wp,T("\t\t\tdocument.routedelete.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	else{
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction route_edit(t){\n"));
		websWrite(wp,T("\t\t\tdocument.routeedit[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction route_delete(t){\n"));
		websWrite(wp,T("\t\t\tdocument.routedelete[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	return 0;
}
static int get_route_js (int ejid, webs_t wp, int argc, char_t **argv)
{
	int num;
	num=get_number_of_route();
	if (num==0)
		websWrite(wp,T(""));
	else if (num==1){
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction route_edit(){\n"));
		websWrite(wp,T("\t\t\tdocument.routeedit.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction route_delete(){\n"));
		websWrite(wp,T("\t\t\tdocument.routedelete.submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	else{
		websWrite(wp,T("\t\t<SCRIPT language=\"javascript\">\n"));
		websWrite(wp,T("\t\tfunction route_edit(t){\n"));
		websWrite(wp,T("\t\t\tdocument.routeedit[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\tfunction route_delete(t){\n"));
		websWrite(wp,T("\t\t\tdocument.routedelete[t].submit();\n"));
		websWrite(wp,T("\t\t\treturn true;\n"));
		websWrite(wp,T("\t\t}\n"));
		websWrite(wp,T("\t\t</SCRIPT>\n"));
	}
	return 0;
}

static int get_route_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i=atoi(argv[1]);
	if  (strcmp(argv[0],"destination")==0)
	{
		Load_Route_Config(); 	
		return websWrite(wp,T("%s"),route_config[i].destination);
	}
	if  (strcmp(argv[0],"netmask")==0)
		return websWrite(wp,T("%s"),route_config[i].netmask);
	if  (strcmp(argv[0],"gateway")==0)
		return websWrite(wp,T("%s"),route_config[i].gateway);
	if  (strcmp(argv[0],"cost")==0)
		return websWrite(wp,T("%d"),route_config[i].cost);
	return 1;
}
static int get_route_status1 (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i=atoi(argv[1]);
	if  (strcmp(argv[0],"destination")==0)
	{
		Load_Route_Config1(); 	
		return websWrite(wp,T("%s"),route_config1[i].Destination);
	}
	if  (strcmp(argv[0],"netmask")==0)
		return websWrite(wp,T("%s"),route_config1[i].Mask);
	if  (strcmp(argv[0],"gateway")==0)
		return websWrite(wp,T("%s"),route_config1[i].Gateway);
	if  (strcmp(argv[0],"cost")==0)
		return websWrite(wp,T("%s"),route_config1[i].Metric);
	if  (strcmp(argv[0],"interface")==0)
		return websWrite(wp,T("%s"),route_config1[i].Iface);
	return 1;
}

static int get_route_mod (int ejid, webs_t wp, int argc, char_t **argv)
{
       	int i,j=0,k;
	k=atoi(argv[1]);
        j=atoi(argv[0]);
        Load_Route_Config();
        i=route_config[k].interface;
        if (i==j)
               return websWrite(wp, T("selected"));
        else
 	       return websWrite(wp, T(""));

}

static int get_route_mod1 (int ejid, webs_t wp, int argc, char_t **argv)
{
       	int i,j=0,k;
	k=atoi(argv[1]);
        j=atoi(argv[0]);
        Load_Route_Config1();
	char str_lan[32], buf[32];

	// 2005.02 albert modify it to get from config
	strcpy(str_lan,(char *)read_file_para_value(DEFAULT_CONFIG_FILE,"LAN_IF=",buf));

	//if ((!strcmp(route_config1[k].Iface,"eth0")) || (!strcmp(route_config1[k].Iface,"br0")))
	if ((!strcmp(route_config1[k].Iface,str_lan)) || (!strcmp(route_config1[k].Iface,"br0")))
		i=1;
	else
		i=2;
        if (i==j)
               return websWrite(wp, T("selected"));
        else
 	       return websWrite(wp, T(""));

}

static int get_interface_status (int ejid, webs_t wp, int argc, char_t **argv){

	char_t buf[32];
	if(!strcmp(argv[0],"lan")){
		char_t str_lanif[10];
		strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf));
		//return websWrite(wp,T("Lan : %s"),str_lanif);
		return websWrite(wp,T("iplan"));
	}
	else if(!strcmp(argv[0],"wan")){
		char_t str_wanif[10];
		strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf));
		return websWrite(wp,T("ipwan"));
//		if (str_wanif)
//			return websWrite(wp,T("Wan : %s"),str_wanif);
//		else
//			return websWrite(wp,T("No Wan"));
	}
	else
		return 0;
}

void form_route_add_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
	route_del();
	Load_Route_Config(); 	
   	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf)-1;
	route_config[rulenum].valid=1;
	
	buf=websGetVar(wp, T("destination"), "");
        strcpy(route_config[rulenum].destination,buf);
                   	       
	buf=websGetVar(wp, T("netmask"), "");
        strcpy(route_config[rulenum].netmask,buf);
	
	buf=websGetVar(wp, T("gateway"), "");
        strcpy(route_config[rulenum].gateway,buf);
        
	buf=websGetVar(wp, T("interface1"),"0");
	route_config[rulenum].interface=atoi(buf);

	buf=websGetVar(wp, T("cost"),"0");
	route_config[rulenum].cost=atoi(buf);
	
	Save_Route_Config();
	route_add();
	websRedirect(wp,T("StaticRoute.asp"));	

}
void form_route_add_conf1(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
        char buf1[32];
        char str_lanif[10];
        char str_wanif[10];
   	
	Load_Route_Config1(); 	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf);
	
	buf=websGetVar(wp, T("destination"), "");
        strcpy(route_config1[rulenum].Destination,buf);
	buf=websGetVar(wp, T("netmask"), "");
        strcpy(route_config1[rulenum].Mask,buf);
	
	buf=websGetVar(wp, T("gateway"), "");
        strcpy(route_config1[rulenum].Gateway,buf);
        
	buf=websGetVar(wp, T("interface1"),"0");
	if(atoi(buf)==1){
		strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf1));
		strcpy(route_config1[rulenum].Iface,str_lanif);
	}
	else if(atoi(buf)==2){
		strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf1));
		strcpy(route_config1[rulenum].Iface,str_wanif);
	}
	else
		strcpy(route_config1[rulenum].Iface,"");

	buf=websGetVar(wp, T("cost"),"0");
        strcpy(route_config1[rulenum].Metric,buf);
/*	
DPRINTF("form_add:des:%s\n",route_config1[rulenum].Destination);                  	       
DPRINTF("form_add:Mask:%s\n",route_config1[rulenum].Mask);                  	       
DPRINTF("form_add:gw:%s\n",route_config1[rulenum].Gateway);                  	       
DPRINTF("form_add:Iface:%s\n",route_config1[rulenum].Iface);                  	       
DPRINTF("form_add:Metric:%s\n",route_config1[rulenum].Metric);                  	       
*/
	route_add1(rulenum);
	websRedirect(wp,T("routingtable.asp"));	

}

void form_route_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
	route_del();
	Load_Route_Config(); 	
   	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf)-1;
	route_config[rulenum].valid=1;
	
	buf=websGetVar(wp, T("destination"), "");
        strcpy(route_config[rulenum].destination,buf);
                   	       
	buf=websGetVar(wp, T("netmask"), "");
        strcpy(route_config[rulenum].netmask,buf);
	
	buf=websGetVar(wp, T("gateway"), "");
        strcpy(route_config[rulenum].gateway,buf);
        
	buf=websGetVar(wp, T("interface1"),"0");
	route_config[rulenum].interface=atoi(buf);

	buf=websGetVar(wp, T("cost"),"0");
	route_config[rulenum].cost=atoi(buf);
	Save_Route_Config();
	route_add();
	websRedirect(wp,T("StaticRoute.asp"));	

}
void form_route_edit_conf1(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
        char buf1[32];
        char str_lanif[10];
        char str_wanif[10];
	Load_Route_Config1(); 	
   	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf)-1;
/*	
DPRINTF("1.form_edit:des:%s\n",route_config1[rulenum].Destination);                  	       
DPRINTF("1.form_edit:Mask:%s\n",route_config1[rulenum].Mask);                  	       
DPRINTF("1.form_edit:gw:%s\n",route_config1[rulenum].Gateway);                  	       
DPRINTF("1.form_edit:Iface:%s\n",route_config1[rulenum].Iface);                  	       
DPRINTF("1.form_edit:Metric:%s\n",route_config1[rulenum].Metric);                  	       
*/
	route_del1(rulenum);
	
	buf=websGetVar(wp, T("destination"), "");
        strcpy(route_config1[rulenum].Destination,buf);
                   	       
	buf=websGetVar(wp, T("netmask"), "");
        strcpy(route_config1[rulenum].Mask,buf);
	
	buf=websGetVar(wp, T("gateway"), "");
        strcpy(route_config1[rulenum].Gateway,buf);
        
	buf=websGetVar(wp, T("interface1"),"0");
	if(atoi(buf)==1){
		strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf1));
		strcpy(route_config1[rulenum].Iface,str_lanif);
	}
	else if(atoi(buf)==2){
		strcpy(str_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IF=",buf1));
		strcpy(route_config1[rulenum].Iface,str_wanif);
	}
	else
		strcpy(route_config1[rulenum].Iface,"");
	
	buf=websGetVar(wp, T("cost"),"0");
        strcpy(route_config1[rulenum].Metric,buf);
/*	
DPRINTF("2.form_edit:des:%s\n",route_config1[rulenum].Destination);                  	       
DPRINTF("2.form_edit:Mask:%s\n",route_config1[rulenum].Mask);                  	       
DPRINTF("2.form_edit:gw:%s\n",route_config1[rulenum].Gateway);                  	       
DPRINTF("2.form_edit:Iface:%s\n",route_config1[rulenum].Iface);                  	       
DPRINTF("2.form_edit:Metric:%s\n",route_config1[rulenum].Metric);                  	       
*/
	route_add1(rulenum);
	websRedirect(wp,T("routingtable.asp"));	

}
void form_route_delete_conf1(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
	Load_Route_Config1(); 	
   	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf)-1;
/*
DPRINTF("form_del:des:%s\n",route_config1[rulenum].Destination);                  	       
DPRINTF("form_del:Mask:%s\n",route_config1[rulenum].Mask);                  	       
DPRINTF("form_del:gw:%s\n",route_config1[rulenum].Gateway);                  	       
DPRINTF("form_add:Iface:%s\n",route_config1[rulenum].Iface);                  	       
DPRINTF("form_add:Metric:%s\n",route_config1[rulenum].Metric);                  	       
*/
	route_del1(rulenum);
	websRedirect(wp,T("routingtable.asp"));	

}
void form_route_delete_conf(webs_t wp, char_t * path,char_t * query)
{
        char *buf=NULL;
	int rulenum;
	route_del();
	Load_Route_Config(); 	
   	
	buf=websGetVar(wp, T("routeid"), "");
        rulenum=atoi(buf)-1;
	
	route_config[rulenum].valid=1;
	
        strcpy(route_config[rulenum].destination,"");
                   	       
        strcpy(route_config[rulenum].netmask,"");
	
        strcpy(route_config[rulenum].gateway,"");
        
	route_config[rulenum].interface=0;

	route_config[rulenum].cost=1;
	Save_Route_Config();
	route_add();
	websRedirect(wp,T("StaticRoute.asp"));	

}

void DefineWebFunctions_route()
{
	websAspDefine(T("read_static_route"), read_static_route);
	websAspDefine(T("get_route_js"), get_route_js);
	websAspDefine(T("get_route_js1"), get_route_js1);
	websAspDefine(T("get_route_status"), get_route_status);
	websAspDefine(T("get_route_status1"), get_route_status1);
	websAspDefine(T("get_interface_status"), get_interface_status);
	websAspDefine(T("get_route_mod"), get_route_mod);
	websAspDefine(T("get_route_mod1"), get_route_mod1);
	websAspDefine(T("get_num_route"), get_num_route);
	websAspDefine(T("get_num_route1"), get_num_route1);
	websAspDefine(T("show_route_status"), show_route_status);
	websFormDefine(T("routeadd"), form_route_add_conf);
	websFormDefine(T("routeadd1"), form_route_add_conf1);
	websFormDefine(T("routeedit"), form_route_edit_conf);
	websFormDefine(T("routeedit1"), form_route_edit_conf1);
	websFormDefine(T("routedelete"), form_route_delete_conf);
	websFormDefine(T("routedelete1"), form_route_delete_conf1);
}
