/*
 *  scanpvc configuration
 */
#include "webs.h"
#include "scanpvc.h"
#include "lan_conf.h"
#include "wan.h"
#include "locale.h"
#include <sys/syslog.h>
extern char *Scanpvc_L1[];
int reboot_flag=0;
static void form_scanpvc_config(webs_t wp,char_t * path,char_t * query);
static void form_scanpvc_result_config(webs_t wp,char_t * path,char_t * query);
static int do_scanpvc (int ejid, webs_t wp, int argc, char_t **argv);
static int get_scanpvc_status (int ejid, webs_t wp, int argc, char_t **argv);
static int read_scanpvc_result (int ejid, webs_t wp, int argc, char_t **argv);
static int read_scanpvc_result1 (int ejid, webs_t wp, int argc, char_t **argv);
static int get_scanpvc_status (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	char_t line[64];
	char_t ip[32];
	char_t gateway[32];
	int srcIP1=0;
	int srcIP2=0;
	int srcIP3=0;
	int srcIP4=0;
	int destIP1=0;
	int destIP2=0;
	int destIP3=0;
	int destIP4=0;
	int Error=0;	
	f=fopen("/flash/fixscanpvc.conf","r");
	if(f){
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&srcIP1,&srcIP2,&srcIP3,&srcIP4);
			sprintf(ip,"%d.%d.%d.%d",srcIP1,srcIP2,srcIP3,srcIP4);
		}
		else
			Error++;
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&destIP1,&destIP2,&destIP3,&destIP4);
			sprintf(gateway,"%d.%d.%d.%d",destIP1,destIP2,destIP3,destIP4);
		}
		else
			Error++;
		fclose(f);

	
	}else{
			Error++;
	}
	if (Error){
		return websWrite(wp,T(""));
	}else{
		if  (strcmp(argv[0],"SourceIP")==0)
			return websWrite(wp,T("%s"),ip);
		if  (strcmp(argv[0],"DestIP")==0)
			return websWrite(wp,T("%s"),gateway);
	}
	return 1;
}

static int do_scanpvc (int ejid, webs_t wp, int argc, char_t **argv){
	unlink("/var/tmp/scanpvc_result");
	openlog("WEB", LOG_NDELAY, LOG_DAEMON);
	DPRINTF("sardoing 0\n");
	syslog(LOG_INFO,"do sardoing set");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","0",0);
	//sleep(10);
	sleep(18);
	syslog(LOG_INFO,"do sardoing get");
	DPRINTF("sardoing 1\n");
	run_task("/usr/sbin/sardoing","/usr/sbin/sardoing","1",0);
	return 1;
}
static int read_scanpvc_result (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	int vpi=0,vci=0,i=0;
	char enc[32];
	char line[64];
	char_t *TableFmt="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
                 "<td>%d</td>\n"
                 "<td>%d</td>\n"
                 "<td>%d</td>\n"
                 "<td>%s</td></tr>\n";
	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		while(fgets(line,sizeof(line),f)){
			memset(enc,0,sizeof(enc));
			sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
			if(i)
				websWrite(wp,T(TableFmt),i,"",i+1,vpi,vci,enc);
			else
				websWrite(wp,T(TableFmt),i,"checked",i+1,vpi,vci,enc);
				
			i++;
		}
		fclose(f);
	}
	if(i==0)
		websWrite(wp,T("<tr><td colspan=5 align=center>No PVC scanned</td></tr>"));
	return 1;
}
static int read_scanpvc_result1 (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	int i=0;	
	char line[64];
	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		while(fgets(line,sizeof(line),f))
			i++;
		fclose(f);
	}
	if(i!=0)
		websWrite(wp,T("<input type=submit value=%s>"),Scanpvc_L1[locale_config.locale]);
	return 1;
		
}
static void form_scanpvc_config(webs_t wp,char_t * path,char_t * query)
{	
	char_t *buf=NULL;
	int srcIP1=0;
	int srcIP2=0;
	int srcIP3=0;
	int srcIP4=0;
	int destIP1=0;
	int destIP2=0;
	int destIP3=0;
	int destIP4=0;
	FILE *f;
	f=fopen("/flash/fixscanpvc.conf","w");
	if(f){
		buf=websGetVar(wp, T("srcIP"), "");
	//	DPRINTF("srcIP:%s\n",buf);
		if(isValidIP(buf)){
			sscanf(buf,"%d.%d.%d.%d\n",&srcIP1,&srcIP2,&srcIP3,&srcIP4);
			fprintf(f,"|%2x|%2x|%2x|%2x|\n",srcIP1,srcIP2,srcIP3,srcIP4);
		}
		else
			fprintf(f,"|00|00|00|00|\n");
		buf=websGetVar(wp, T("destIP"), "");
	//	DPRINTF("destIP:%s\n",buf);
		if(isValidIP(buf)){
			sscanf(buf,"%d.%d.%d.%d\n",&destIP1,&destIP2,&destIP3,&destIP4);
			fprintf(f,"|%2x|%2x|%2x|%2x|\n",destIP1,destIP2,destIP3,destIP4);
		}
		else
			fprintf(f,"|00|00|00|00|\n");
		fclose(f);
	}
	openlog("WEB", LOG_NDELAY, LOG_DAEMON);
	syslog(LOG_INFO,"do scan");
	websRedirect(wp,T("scanpvc_frame.asp"));
	
}
static void form_scanpvc_result_config(webs_t wp,char_t * path,char_t * query){
	char_t *buf=NULL;
	int slectline=0;
	FILE *f;
	char line[64];
	int vpi=0,vci=0,i=0;
	char enc[32];
	int srcIP1=0;
	int srcIP2=0;
	int srcIP3=0;
	int srcIP4=0;
	int destIP1=0;
	int destIP2=0;
	int destIP3=0;
	int destIP4=0;
	char ip[20];
	char gateway[20];

	buf=websGetVar(wp, T("Idx"), "");
	slectline=atoi(buf);
	f=fopen("/var/tmp/scanpvc_result","r");
	if(f){
		for(i=0;i<slectline+1;i++)
			fgets(line,sizeof(line),f);
			sscanf(line,"VPI %d VCI %d %s\n",&vpi,&vci,enc);
		fclose(f);
	}
	f=fopen("/flash/fixscanpvc.conf","r");
	if(f){
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&srcIP1,&srcIP2,&srcIP3,&srcIP4);
			sprintf(ip,"%d.%d.%d.%d",srcIP1,srcIP2,srcIP3,srcIP4);
		}
		if(fgets(line,sizeof(line),f)){
			sscanf(line,"|%2x|%2x|%2x|%2x|\n",&destIP1,&destIP2,&destIP3,&destIP4);
			sprintf(gateway,"%d.%d.%d.%d",destIP1,destIP2,destIP3,destIP4);
		}
		fclose(f);
	}
	/*
	DPRINTF("vpi=%d vci=%d enc=%s\n",vpi,vci,enc);
	DPRINTF("ip=%s\n",ip);
	DPRINTF("gw=%s\n",gateway);
	*/
        Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
	if(!strcmp(enc,"DHCPC_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=vpi;
        	wan_config.Routed_VCI=vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		//Save_Wan_Config(1,&wan_config);
	}
	if(!strcmp(enc,"DHCPC_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=vpi;
        	wan_config.Routed_VCI=vci;
		wan_config.Routed_IP_Assignment=0;
        	strcpy(wan_config.Routed_IP,"0.0.0.0");
        	strcpy(wan_config.Routed_Netmask,"0.0.0.0");
        	strcpy(wan_config.Routed_Gateway,"0.0.0.0");
		//Save_Wan_Config(1,&wan_config);
	}
	if(!strcmp(enc,"PPPOE_VC_VALID")){
		wan_config.Quick_Wan_Type=12;
		wan_config.Wan_Type=5;
        	wan_config.PPPOE_VPI=vpi;
        	wan_config.PPPOE_VCI=vci;
		//Save_Wan_Config(5,&wan_config);
	}

	if(!strcmp(enc,"PPPOE_LLC_VALID")){
		wan_config.Quick_Wan_Type=2;
		wan_config.Wan_Type=5;
        	wan_config.PPPOE_VPI=vpi;
        	wan_config.PPPOE_VCI=vci;
		//Save_Wan_Config(5,&wan_config);
	}
	//if(!strcmp(enc,"PPPOA_LLC_VALID")){
	if(!strcmp(enc,"PPPOA_VC_VALID")){
		wan_config.Quick_Wan_Type=1;
		wan_config.Wan_Type=3;
        	wan_config.PPPOA_VPI=vpi;
        	wan_config.PPPOA_VCI=vci;
		//Save_Wan_Config(3,&wan_config);
	}
	if(!strcmp(enc,"PPPOA_LLC_VALID")){
		wan_config.Quick_Wan_Type=11;
		wan_config.Wan_Type=3;
        	wan_config.PPPOA_VPI=vpi;
        	wan_config.PPPOA_VCI=vci;
		//Save_Wan_Config(3,&wan_config);
	}

	if(!strcmp(enc,"FIXIP_2684B_LLC_VALID")){
		wan_config.Quick_Wan_Type=8;
		wan_config.Wan_Type=1;
        	wan_config.Routed_VPI=vpi;
        	wan_config.Routed_VCI=vci;
		wan_config.Routed_IP_Assignment=1;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		//Save_Wan_Config(1,&wan_config);
	}
	if(!strcmp(enc,"FIXIP_2684B_VC_VALID")){
		wan_config.Quick_Wan_Type=7;
		wan_config.Wan_Type=1;
		wan_config.Routed_IP_Assignment=1;
        	wan_config.Routed_VPI=vpi;
        	wan_config.Routed_VCI=vci;
        	strcpy(wan_config.Routed_IP,ip);
        	strcpy(wan_config.Routed_Netmask,"255.255.255.0");
        	strcpy(wan_config.Routed_Gateway,gateway);
		//Save_Wan_Config(1,&wan_config);
	}


	if(wan_config.Quick_Wan_Type!=old_wan_config.Quick_Wan_Type)
		reboot_flag=1;
	websRedirect(wp, T("quick.asp"));
}
void DefineWebFunctions_scanpvc () {
        websAspDefine(T("read_scanpvc_result"),read_scanpvc_result);
        websAspDefine(T("read_scanpvc_result1"),read_scanpvc_result1);
        websAspDefine(T("get_scanpvc_status"),get_scanpvc_status);
        websAspDefine(T("do_scanpvc"),do_scanpvc);
	websFormDefine(T("scanpvc"), form_scanpvc_config);
	websFormDefine(T("scanpvc_result"), form_scanpvc_result_config);

}
