/*
 *  timezone.htm: Time Zone 
 */
#include "webs.h"
#include "timezone.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

static int get_timezone_mod (int ejid, webs_t wp, int argc, char_t **argv);
static int get_timezone_status (int ejid, webs_t wp, int argc, char_t **argv);
static void resetCurrentTimezoneCfg(void);
void Load_Timezone_Config (void);
static void Save_Timezone_Config (NTP_CONFIG_DATA *d);

static void resetCurrentTimezoneCfg(void)
{
	NTP_CONFIG_DATA *d = &ntp_config;

	d->enabled=1;
	strcpy(d->ntp_server[0],"192.43.244.18");       // time.nist.gov
        strcpy(d->ntp_server[1],"128.138.140.44"); // india.Colorado.EDU
	strcpy(d->ntp_server[2],"129.6.15.29");         // time-b.nist.gov
	strcpy(d->ntp_server[3],"131.107.1.10");        // time-nw.nist.gov
        strcpy(d->timezone, DEFAULT_TIME_ZONE);
	d->pollintv=DEFAULT_NTP_POLL_INTV;
	d->daylight=1;
}
void Load_Timezone_Config (void)
{
        FILE *fp;
        char_t line[255];
        resetCurrentTimezoneCfg();
        if((fp=fopen(TIMEZONE_CONFIG_FILE,"r"))!=NULL){
	if (fgets(line, 255, fp))
        	sscanf(line,"%d\n",(int *)&ntp_config.enabled);
	if (fgets(line, 255, fp))
        	sscanf(line,"%s\n",ntp_config.timezone);
	if (fgets(line, 255, fp))
        	sscanf(line,"%d\n",(int *)&ntp_config.pollintv);
	if (fgets(line, 255, fp))
        	sscanf(line,"%d\n",(int *)&ntp_config.daylight);
	if (fgets(line, 255, fp))
        	sscanf(line,"%s\n",ntp_config.ntp_server[0]);
	if (fgets(line, 255, fp))
        	sscanf(line,"%s\n",ntp_config.ntp_server[1]);
	if (fgets(line, 255, fp))
        	sscanf(line,"%s\n",ntp_config.ntp_server[2]);
	if (fgets(line, 255, fp))
        	sscanf(line,"%s\n",ntp_config.ntp_server[3]);
	fclose(fp);
	}
#if 0
	DPRINTF("r.enable:%d\n",ntp_config.enabled);
	DPRINTF("timezone:%s\n",ntp_config.timezone);
	DPRINTF("pollintv:%d\n",ntp_config.pollintv);
	DPRINTF("daylight:%d\n",ntp_config.daylight);
	DPRINTF("server1:%s\n",ntp_config.ntp_server[0]);
	DPRINTF("server2:%s\n",ntp_config.ntp_server[1]);
	DPRINTF("server3:%s\n",ntp_config.ntp_server[2]);
	DPRINTF("server4:%s\n",ntp_config.ntp_server[3]);
#endif	
 
}

static void Save_Timezone_Config (NTP_CONFIG_DATA *d)
{
        FILE *fp;
        if((fp=fopen(TIMEZONE_CONFIG_FILE,"w"))!=NULL){
	fprintf(fp,"%d\n",d->enabled);
	fprintf(fp,"%s\n",d->timezone);
	fprintf(fp,"%d\n",d->pollintv);
	fprintf(fp,"%d\n",d->daylight);
	fprintf(fp,"%s\n",d->ntp_server[0]);
	fprintf(fp,"%s\n",d->ntp_server[1]);
	fprintf(fp,"%s\n",d->ntp_server[2]);
	fprintf(fp,"%s\n",d->ntp_server[3]);
      	fclose(fp);
	}
#if 0	
	DPRINTF("w.enable:%d\n",d->enabled);
	DPRINTF("timezone:%s\n",d->timezone);
	DPRINTF("pollintv:%d\n",d->pollintv);
	DPRINTF("daylight:%d\n",d->daylight);
	DPRINTF("server1:%s\n",d->ntp_server[0]);
	DPRINTF("server2:%s\n",d->ntp_server[1]);
	DPRINTF("server3:%s\n",d->ntp_server[2]);
	DPRINTF("server4:%s\n",d->ntp_server[3]);
#endif						
	
}

static int get_timezone_mod (int ejid, webs_t wp, int argc, char_t **argv)
{
        int i,j;
        Load_Timezone_Config();
	j=atoi(argv[0]);
	i=atoi(ntp_config.timezone);
        if (i==j)
                return websWrite(wp, T("%s"),"selected");
        else
                return websWrite(wp, T(""));
}
static int get_timezone_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	if (strcmp(argv[0],"enable")==0)
	{
		Load_Timezone_Config();
		return websWrite(wp,T("%d"),ntp_config.enabled);
	}
	if (strcmp(argv[0],"server1")==0)
		return websWrite(wp,T("%s"),ntp_config.ntp_server[0]);
	if (strcmp(argv[0],"server2")==0)
		return websWrite(wp,T("%s"),ntp_config.ntp_server[1]);
	if (strcmp(argv[0],"server3")==0)
		return websWrite(wp,T("%s"),ntp_config.ntp_server[2]);
	if (strcmp(argv[0],"server4")==0)
		return websWrite(wp,T("%s"),ntp_config.ntp_server[3]);
	if (strcmp(argv[0],"pollintv")==0)
		return websWrite(wp,T("%d"),ntp_config.pollintv);
	if (strcmp(argv[0],"daylight")==0)
		return websWrite(wp,T("%d"),ntp_config.daylight);
	if (strcmp(argv[0],"timezoneSID")==0)
		return websWrite(wp,T("%s"),ntp_config.timezone);
	return 1;
}

static void form_timezone_conf(webs_t wp, char_t * path,char_t * query)
{      
        char *buf=NULL;
	char funcNum[4];
	char str_wanip[20];
	char buf1[64];
	NTP_CONFIG_DATA old_ntp_config;

	
	sprintf(funcNum,"%d",FUNCTION_NUM_TIME_ZONE);

        Load_Timezone_Config();
		
	memcpy(&old_ntp_config, &ntp_config, sizeof(NTP_CONFIG_DATA));
	
        buf=websGetVar(wp, T("TZ_SID"), "");
        strcpy(ntp_config.timezone,buf);
        buf=websGetVar(wp, T("TZ_SERVER1"), "");
	strcpy(ntp_config.ntp_server[0],buf);
        buf=websGetVar(wp, T("TZ_SERVER2"), "");
	strcpy(ntp_config.ntp_server[1],buf);
        buf=websGetVar(wp, T("TZ_SERVER3"), "");
	strcpy(ntp_config.ntp_server[2],buf);
        buf=websGetVar(wp, T("TZ_SERVER4"), "");
	strcpy(ntp_config.ntp_server[3],buf);
        buf=websGetVar(wp, T("TZ_POLLINTV"), "");
        ntp_config.pollintv=atoi(buf);
        buf=websGetVar(wp, T("TZ_DAYLIGHT"), "");
        ntp_config.daylight=atoi(buf);
        buf=websGetVar(wp, T("TZ_ENABLE"), "");
        ntp_config.enabled=atoi(buf);

	// Mulder added 2005-5-17 to compare with old and new configuretion. 
	if (memcmp(&old_ntp_config, &ntp_config, sizeof(NTP_CONFIG_DATA)) != 0)
	{
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
		Save_Timezone_Config(&ntp_config);
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		if( (ntp_config.enabled)&& (isValidIP(str_wanip)))
		{   //NOTE ONLY WHEN WAN INTERFACE is ready, then we start the function
			run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);	
		}
	}
	websRedirect(wp, T("timezone.asp"));
}

static int reload_timezone_config (int ejid, webs_t wp, int argc, char_t **argv){
	 Load_Timezone_Config();
	 return 1;
}

void DefineWebFunctions_timezone()
{
	websAspDefine(T("get_timezone_status"), get_timezone_status);
	websAspDefine(T("reload_timezone_config"),reload_timezone_config );
	websAspDefine(T("get_timezone_mod"), get_timezone_mod);
	websFormDefine ( T("timezone"), form_timezone_conf);
}
