/******************************************************************************
*
*  (C) Copyright 2004 Trend Micro, Inc.
*
*  All Rights Reserved.
*  This program is an unpublished copyrighted work which is proprietary
*  to Trend Micro, Inc. and contains confidential information that is not
*  to be reproduced or disclosed to any other person or entity without
*  prior written consent from Trend Micro, Inc. in each and every instance.
*
*  WARNING:  Unauthorized reproduction of this program as well as
*  unauthorized preparation of derivative works based upon the
*  program or distribution of copies by sale, rental, lease or
*  lending are violations of federal copyright laws and state trade
*  secret laws, punishable by civil and criminal penalties.
*
*****************************************************************************/

/**
*  @file tmGetRouterBuild.c
*  @brief TMOG Get Router Build Version CGI
*/

/*
*  Change Log
*  2004-06-02 Jim Wu    Initialization version
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "webs.h"
#include "TmBuild.h"
#include "tmGetHardwareInfo.h"

//static const char ModuleName[]="tmGetRouterBuildCGI";

#define Get_Build_Command  "GetBuildVersion"

extern void FlushConnectionCGI(webs_t wp,int nSize);

void tmGetRouterBuildCGI( webs_t wp,int nContentLen)
{
   unsigned char   szReadBuff[30];    
    char   szVendorId[TMSS_MAX_BUF_VENDER_ID] = "";
    char   szBoxId[TMSS_MAX_BUF_BOX_ID]    = "";
    char   szBoxInfo[100];
    char   szBoxIp[TMSS_MAX_BUF_BOX_IP];
    char   szBoxVersion[TMSS_MAX_BUF_BOX_VERSION];
    char   szBoxBuild[TMSS_MAX_BUF_BOX_BUILD];
    

    //DPRINTF( "tmGetRouterBuildCGI\n");
    memset(szReadBuff, 0, 30);
    memcpy(szReadBuff,wp->query, nContentLen);

    if (memcmp(szReadBuff, Get_Build_Command, strlen(Get_Build_Command)) != 0)
    {
        DPRINTF("syntax error, szReadBuff is %s\n", szReadBuff);
        /* free (pszDQM); */
        FlushConnectionCGI(wp,0);
        return;
    }

     
    if (tmGetVendorID(szVendorId) < 0)
    {
        strcpy(szVendorId, "");
    }
    
    if (tmGetBoxID(szBoxId) < 0)
    {
        strcpy(szBoxId, "");
    }
    
    if (tmGetBoxIp(szBoxIp) < 0)
    {
        strcpy(szBoxIp, "");
    }
    
    if (tmGetBoxVersion(szBoxVersion) < 0)
    {
        strcpy(szBoxVersion, "");
    }
    
    if (tmGetBoxBuild(szBoxBuild) < 0)
    {
        strcpy(szBoxBuild, "");
    }
        
    //DPRINTF("szReadBuff ok %s, version=%s, build=%s/%s, vid = %s, boxId = %s\n", szReadBuff, szBoxVersion, TM_BUILD_SZ, szBoxBuild, szVendorId, szBoxId);
    
    sprintf(szBoxInfo, "[routerversion]\r\nversion=%s\r\nbuild=%s/%s\r\nconfigurl=%s\r\nvid=%s\r\nboxid=%s", szBoxVersion, TM_BUILD_SZ, szBoxBuild, szBoxIp, szVendorId, szBoxId);    
    websWrite(wp, T("HTTP/1.0 200 OK\n"));
    FlushConnectionCGI(wp,strlen(szBoxInfo));  /* for \r\n */   
    websWrite(wp, T(szBoxInfo));
    websDone(wp, 200);
 
    //DPRINTF("output is %s\n", szBoxInfo);
    //DPRINTF( "Leaving tmGetRouterBuildCGI\n");

    return;
}
