/******************************************************************************
*
*  (C) Copyright 2004 Trend Micro, Inc.
*
*  All Rights Reserved.
*  This program is an unpublished copyrighted work which is proprietary
*  to Trend Micro, Inc. and contains confidential information that is not
*  to be reproduced or disclosed to any other person or entity without
*  prior written consent from Trend Micro, Inc. in each and every instance.
*
*  WARNING:  Unauthorized reproduction of this program as well as
*  unauthorized preparation of derivative works based upon the
*  program or distribution of copies by sale, rental, lease or
*  lending are violations of federal copyright laws and state trade
*  secret laws, punishable by civil and criminal penalties.
*
*****************************************************************************/

/**
*  @file tmLicCheckStart.c
*  @brief TMSS Trigger License Check CGI
*/

/*
*  Change Log
*  2004-08-13 Henry Lin    Initialization version
*/

#include <stdio.h>
#include <sys/types.h> /* for kill */
#include <signal.h> /* for kill */
#include <stdlib.h> /* for strtol */
#include "webs.h"

//#define THPD_PID_PATH                   "/var/run/thpd.pid"
#define LIC_CHK_PID_PATH             "/var/run/tmLicChk.pid"
#define MAX_LINE                        1024

//static const char ModuleName[] = "tmLicCheckStart";

int tmLicCheckStartCGI(webs_t wp)
{
    FILE *fp;
    char szBuf[MAX_LINE];
    long longPid;
    
    //fp = fopen(THPD_PID_PATH, "r");
    fp = fopen(LIC_CHK_PID_PATH, "r");
    
    if (fp == NULL)
    {
        DPRINTF("Open %s pid file fail!\n",LIC_CHK_PID_PATH);
        return -1;
    }
    
    szBuf[MAX_LINE - 1] = '\0';
    fgets(szBuf, MAX_LINE - 1, fp);
    
    longPid = strtol(szBuf, NULL, 10);
   
    //DPRINTF("Sending Signal SIGUSR1 to thpd pid: %lu\n", longPid);
    kill((pid_t)longPid, SIGUSR1);
    
    fclose(fp);
    
    websWrite(wp, T("HTTP/1.0 200 OK\n"));
    websWrite (wp, T ("Content-type: text/html\r\n\r\nOK"));
    websDone(wp, 200);
     
    return 0;
}

