/*
 *  url*.asp: URL Filter Configuration
 */
#include <sys/wait.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/types.h>
#include "webs.h"
#include "urlFlt.h"
#include "uemf.h"
#include "urlFlt_conf.h"
#include "filem.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"
#include "locale.h"



extern char *URL_L1[];
extern char *URL_L2[];
extern char *URL_L3[];
extern char *URL_L4[];
extern char *URL_L5[];
extern char *URL_L6[];
extern char *URL_L7[];
extern char *URL_L8[];
extern char *URL_L9[];
extern char *URL_L10[];
extern char *URL_L11[];
extern char *URL_L12[];
extern char *URL_L13[];
extern char *URL_L14[];
extern char *URL_L15[];
extern char *URL_L16[];
extern char *URL_L17[];
extern char *URL_L18[];
extern char *URL_L19[];
extern char *URL_L20[];
extern char *URL_L21[];
extern char *URL_L22[];
extern char *URL_L23[];
extern char *URL_L24[];
extern char *URL_L25[];
extern char *URL_L26[];
extern char *URL_L27[];
extern char *URL_L28[];
extern char *URL_L29[];
extern char *URL_L30[];
extern char *URL_L31[];

#ifdef m_IPSEC
#include "ipsec_config.h"
extern IPSEC_TABLE_T IPSec_TableShow;
#endif

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
extern int checked_function_enabled (char *parameter, webs_t wp, char_t **argv);

#define URLFLT_CONF_FN    "/var/etc/uf.conf"
#define URLFLT_CONF_FN_RULE_ADD    "/var/etc/uf.conf.rule.add"
#define URLFLT_CONF_FN_RULE_DEL   "/var/etc/uf.conf.rule.del"
//#define URLFLT_CONF_FN_RULE_DEL_OLD   "/var/etc/uf.conf.rule.del_old"

static inline char *
inet_ntoa_b (struct in_addr inet_addr, char *dest_string)
{
  strcpy (dest_string, inet_ntoa (inet_addr));
  return dest_string;
}
extern char WAN_IP[];
// borrow chk_ip_range in pf.c
extern int chk_ip_range(char *isip, char *ieip);

// urlf.asp
// urlf1.asp
static void DefineUrlFltConfig ();
//void GetClinetFilterToPFTable(URLFILTER_TABLE_T *table);
//void SetPFTableToClinetFilter(URLFILTER_TABLE_T *table);
int GetConfigToUrlFltTable (URLFILTER_TABLE_T * table);
int SetUrlFltSTableToConfig (URLFILTER_TABLE_T * table);
int CreateUrlFltTableToScript (URLFILTER_TABLE_T * table);
//#define inet_ntoa_b(inet_addr,dest_string) strcpy(dest_string, inet_ntoa(inet_addr))
// web pages function
static void formUrlFlt (webs_t wp, char_t * path, char_t * query);
static int aspUrlFltShow (int eid, webs_t wp, int argc, char_t ** argv);
// urlf1.asp
static int aspUrlFlt1_Now (int eid, webs_t wp, int argc, char_t ** argv);
static int aspURL1_fwNow2(void);
static int aspUrlFlt1_Page (int eid, webs_t wp, int argc, char_t ** argv);
static void formUrlFlt1 (webs_t wp, char_t * path, char_t * query);
static int aspUrlFltKeywordTable (int eid, webs_t wp, int argc,
				  char_t ** argv);
static int aspUrlFltDomainTable (int eid, webs_t wp, int argc,
				 char_t ** argv);
static int aspUrlFltKeywordInput (int eid, webs_t wp, int argc,
				  char_t ** argv);
static int aspUrlFltDomainInput (int eid, webs_t wp, int argc,
				 char_t ** argv);
static void formUrlFde1 (webs_t wp, char_t * path, char_t * query);	// for keyword
static void formUrlFde2 (webs_t wp, char_t * path, char_t * query);	// for domain


// select
extern char_t StringBuf[];

extern char_t *SelectListOption (char_t ** Option_List, int num, int who);
/*
 * qos  function
 */
extern int UrlFlt_Table_Init (URLFILTER_TABLE_T * table);
extern int UrlFlt_AddRule (URLFILTER_TABLE_T * table,
			   URLFILTER_RULE_T * rule);
extern int UrlFlt_DelRule (URLFILTER_TABLE_T * table, int item);
extern int UrlFlt_AdjustTable (URLFILTER_TABLE_T * table);
extern int UrlFlt_CopyTable (URLFILTER_TABLE_T * DstTable,
			     URLFILTER_TABLE_T * SrcTable);
extern int UrlFlt_SetRule (URLFILTER_TABLE_T * table, URLFILTER_RULE_T * rule,
			   int item);

static void DefineUrlFltConfig ();
static URLFILTER_RULE_T gTmpRule;	// Note, we use this global page to keep the editing values for a rule which has to 

void
DefineWebFunctions_UrlFlt ()
{
  DefineUrlFltConfig ();
}

/*
 *  for urlf.asp, urlf1.asp
 */
URLFILTER_TABLE_T UrlFlt_Table, UrlFlt_TableShow;

int ufilterIfAnyRulesActive(URLFILTER_TABLE_T *table)	
{
	URLFILTER_RULE_T *rule;
	int i;
   for (i = 0; i < MAX_RULE; i++) 
   {
     rule = &(table->Rule[i]);
     if( rule->Item != 0 ) {
       if( rule->RuleActive == UrlFlt_Act_YES )
       {
		return 1;
       }
     }	
   }	
   return 0; 
}

#define RULE_OPERTION_URL_FILTER 1
#define RULE_OPERTION_IPSEC 9

#ifdef m_IPSEC
static int ruleOperation (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i,ruleTotalNum=0;
	char_t *TableFmt = "<TR>\n"
	"<TD class=header colSpan=5>\n<BR>\n"
    "%s"
	"%s"
    "</TD> </TR> \n";
    char editDelAllowedStr[]="<INPUT type=button value=Edit onclick=CB(2)>&nbsp;\n"
    "<INPUT type=button value=Delete onclick=CB(3)>&nbsp;\n";
    char editDelDeniedStr[]="";
	char addAllowedStr[]="<INPUT type=button value=Add onclick=CB(1)>&nbsp;\n";
	char addDeniedStr[]="(Can not add. Max. Rules reach.)\n";
	char *editDelStr=editDelDeniedStr;
	char *addStr=addAllowedStr;
	i=atoi(argv[0]);
	switch(i) {
		case RULE_OPERTION_URL_FILTER:
				ruleTotalNum=UrlFlt_TableShow.TotalNum;
				break;
		case RULE_OPERTION_IPSEC:
				ruleTotalNum=IPSec_TableShow.TotalNum;
				break;
	}
	if(ruleTotalNum <1)
	{// No rules.					
	}
	else if(ruleTotalNum >= MAX_RULE)
	{// reach the max.
		addStr=addDeniedStr;
		editDelStr=editDelAllowedStr;					
	}
	else
	{
		editDelStr=editDelAllowedStr;					
	}
	return websWrite (wp, T (TableFmt), addStr, editDelStr);
}
#endif

#if 0
#ifndef m_IPSEC
static int is_ipsec_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled("IPSEC=",wp,argv);
}


static int ipsec_st_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
	int j;
	FILE *fp;
	char filename[30];

	
	// check if any rules in the whack
	for (j = 0; j < MAX_RULE; j++)
	{		
		//1. how do we know the ipsec rule exist in the  current setup ipsec database (Not the newest modified
		// IPsec configuration one, since we only apply the changes when the fw.sh start.)
		sprintf(filename, "/var/etc/ipsec_ipt%d.add", j);
		if ((fp = fopen(filename, "r")))
		{ 
			fclose(fp);
			break;
		}
	}

 	if(j>=MAX_RULE)
	{ // Not valid active ipsec rules in database
		int i;
		i=atoi(argv[0]);
		if(i==0)//comment begin
			return websWrite(wp, T("<!--"));
		else
			return websWrite(wp, T("-->"));
	}
	return websWrite(wp, T(""));
}
#endif
#endif

static void
DefineUrlFltConfig ()
{
  UrlFlt_Table_Init (&UrlFlt_Table);
  UrlFlt_Table_Init (&UrlFlt_TableShow);
  // test cf2pf
//      GetClinetFilterToPFTable(&UrlFlt_Table);
//      GetClinetFilterToPFTable(&UrlFlt_TableShow);
  GetConfigToUrlFltTable (&UrlFlt_Table);
  GetConfigToUrlFltTable (&UrlFlt_TableShow);

  if(ufilterIfAnyRulesActive(&UrlFlt_Table))
 	  CreateUrlFltTableToScript (&UrlFlt_Table);

  // qos.asp
  websAspDefine (T ("urlfList"), aspUrlFltShow);
#ifdef m_IPSEC
  websAspDefine (T ("ruleOperation"), ruleOperation);
#endif
#ifndef m_IPSEC
//	websAspDefine(T("is_ipsec_enabled"), is_ipsec_enabled);
//	websAspDefine(T("ipsec_st_enabled"), ipsec_st_enabled);
#endif
  
  websFormDefine (T ("urlf"), formUrlFlt);
  websAspDefine (T ("urlf_Table"), aspUrlFlt1_Page);
  websAspDefine (T ("ufkw_Table"), aspUrlFltKeywordTable);
  websAspDefine (T ("ufdn_Table"), aspUrlFltDomainTable);
  websAspDefine (T ("ufkw_input"), aspUrlFltKeywordInput);
  websAspDefine (T ("ufdn_input"), aspUrlFltDomainInput);
  websFormDefine (T ("urlf1"), formUrlFlt1);
  websFormDefine (T ("urlfke"), formUrlFde1);
  websFormDefine (T ("urlfdn"), formUrlFde2);
  websAspDefine (T ("urlfNow"), aspUrlFlt1_Now);
}
char *days_match_str[] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
char *content_match_str[] = { "Java Applet", "ActiveX", "Cookies", "Proxy" };

void
printBlockMode (TIME_BLOCK_T * timeblock, char *blockMode, int isBlocked)
{
  if (!timeblock->alwaysBlock)
    {
      char daysBlock[40];
      memset (daysBlock, 0, sizeof (daysBlock));
      if (timeblock->days_match > 0)
	{
	  int daysMask = 0x01;
	  int firstOne = TRUE, kk;	// No "," for first one
	  sprintf (daysBlock, " On ");
	  for (kk = 0; kk < 7; kk++)
	    {
	      if (timeblock->days_match & daysMask)
		{
		  if (!firstOne)
		    strcat (daysBlock, ",");
		  else
		    firstOne = FALSE;
		  strcat (daysBlock, days_match_str[kk]);
		};
	      daysMask <<= 0x01;
	    }
	}

      sprintf (blockMode, "From %02d:%02d To %02d:%02d%s",
	       timeblock->time_start / 60, timeblock->time_start % 60,
	       timeblock->time_stop / 60, timeblock->time_stop % 60,
	       daysBlock);
    }
  else
    {
      if (isBlocked)
	strcpy (blockMode, URL_L1[locale_config.locale]);
      else
	strcpy (blockMode, URL_L2[locale_config.locale]);
    }
}

// URL Filter asp function
// for qos.asp
static int
aspUrlFltShow (int eid, webs_t wp, int argc, char_t ** argv)
{
  int nBytes = 0, i = 0,j;
  char SIP[2][16] = { {0} };
  URLFILTER_RULE_T *rule;

  char_t *TableFmt =
    "<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
    "<td>&nbsp;%d&nbsp;</td>" "<td>&nbsp;%s&nbsp;</td>"
    "<td>&nbsp;%s&nbsp;</td>" "<td>&nbsp;%s&nbsp;</td>"
    "<td>&nbsp;%s&nbsp;</td>" "<td>&nbsp;%s&nbsp;</td>"
    "<td>&nbsp;%s&nbsp;</td>" "<td>&nbsp;%s&nbsp;</td></tr>\n";

  for (i = 0; i < UrlFlt_TableShow.TotalNum; i++)
    {
      rule = &UrlFlt_TableShow.Rule[i];
      if (rule->Item != 0)
	{
	  char blockMode[60];
	  char otherBlock[50];

	  sprintf (SIP[0], "%s", rule->PCIpStart);
	  sprintf (SIP[1], "%s", rule->PCIpEnd);

	  printBlockMode (&(rule->timeblock), blockMode, 1);
	  memset (otherBlock, 0, sizeof (otherBlock));
	  if (rule->contentFilter)
	    {
	      int contentMask = 0x01;
	      int firstOne = TRUE, kk;	// No "," for first one
	      sprintf (otherBlock, "Block ");
	      for (kk = 0; kk < 4; kk++)
		{
		  if (rule->contentFilter & contentMask)
		    {
		      if (!firstOne)
			strcat (otherBlock, ",");
		      else
			firstOne = FALSE;
		      strcat (otherBlock, content_match_str[kk]);
		    };
		  contentMask <<= 0x01;
		}
	    }

	  nBytes += websWrite (wp, T (TableFmt),
			       // Radio value, int
			       i + 1,
	 		       // checked or not
			       (i == aspURL1_fwNow2() ? "checked" : ""),
			       // 0 Rule's number, int
			       i + 1,
			       // 1 Active, string
			       (rule->RuleActive ==
				UrlFlt_Act_NO) ? URL_L3[locale_config.locale] : URL_L4[locale_config.locale], SIP[0], SIP[1],
			       blockMode,
			       (rule->
				keyFilterEnabled) ? URL_L5[locale_config.locale] : URL_L6[locale_config.locale],
			       (rule->
				domainFilterEnabled) ? URL_L5[locale_config.locale] : URL_L6[locale_config.locale],
			       otherBlock);

	}			// end if
    }

  return nBytes;
}

// urlf.asp
static enum ClickOption UrlFlt_Func = Click_Func_CENCEL;
static int urlfDetailEdit = 0;	// Not the detailed editing.
static int UrlFlt_Edit_Index = 0;


static void
formUrlFlt (webs_t wp, char_t * path, char_t * query)
{
  //enum PFOption Func = CENCEL;
  char_t *urlfFUNC, *Idx;
  //FILE   *fp;

  urlfFUNC = websGetVar (wp, T ("urlfFUNC"), "");
  UrlFlt_Func = atoi (urlfFUNC);
  Idx = websGetVar (wp, T ("Idx"), "");
  UrlFlt_Edit_Index = atoi (Idx);
  --UrlFlt_Edit_Index;
//  DPRINTF("url index %d\n", UrlFlt_Edit_Index);
   websHeader (wp);
  switch (UrlFlt_Func)
    {
    case Click_Func_ADD:
      //websWrite(wp, T("<body><h2>ADD: %d, Idx: %s</h2>\n"), Func, Idx);
      if (UrlFlt_TableShow.NextItem < MAX_RULE)
	{
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf1.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      else
	{
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      break;
    case Click_Func_EDIT:
      //websWrite(wp, T("<body><h2>EDIT: %d, Idx: %s</h2>\n"),Func, Idx);
      if (UrlFlt_Edit_Index >= 0)
	{
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf1.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      else			// no select an item
	{
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      //websRedirect(wp, "/urlf.asp");
      break;
    case Click_Func_DEL:
      //websWrite(wp, T("<body><h2>DEL:  %d, Idx: %s</h2>\n"),UrlFlt_Func, Idx);
      //websFooter(wp);
      //websDone(wp, 200);
      if (UrlFlt_Edit_Index >= 0)
	{
	  UrlFlt_DelRule (&UrlFlt_TableShow, UrlFlt_Edit_Index);
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      else
	{
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
	  websFooter (wp);
	  websDone (wp, 200);
	}
      break;
    case Click_Func_APPLY:
	{
		char funcNum[4];
		char str_wanip[20];
		char buf1[64];

		sprintf(funcNum,"%d",FUNCTION_NUM_URL_FILTER);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
		
		SetUrlFltSTableToConfig (&UrlFlt_TableShow);
		UrlFlt_CopyTable (&UrlFlt_Table, &UrlFlt_TableShow);
		if(ufilterIfAnyRulesActive(&UrlFlt_Table))
		{
			CreateUrlFltTableToScript(&UrlFlt_Table);
			strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
			if(isValidIP(str_wanip))
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			//else running when wan_ip ready.
		}
		else
		{// remove  the old scripts
			unlink(URLFLT_CONF_FN_RULE_ADD);
			unlink(URLFLT_CONF_FN_RULE_DEL);			
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
		}
 	}

      websWrite (wp,
		 T
		 ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
      websFooter (wp);
      websDone (wp, 200);
      break;

    case Click_Func_CENCEL:
      UrlFlt_CopyTable (&UrlFlt_TableShow, &UrlFlt_Table);
      websWrite (wp,
		 T
		 ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
      websFooter (wp);
      websDone (wp, 200);
      break;
    default:
      websRedirect (wp, "/urlf.asp");
    }
}

// for qos1.asp
// qos1, rule number
static int
aspUrlFlt1_Now (int eid, webs_t wp, int argc, char_t ** argv)
{
  switch (UrlFlt_Func)
    {
    case Click_Func_ADD:
      return websWrite (wp, T ("%d"), UrlFlt_TableShow.NextItem);
    case Click_Func_EDIT:
      return websWrite (wp, T ("%d"), UrlFlt_Edit_Index);
    default:
      return websWrite (wp, T ("%d"), UrlFlt_TableShow.NextItem);
    }
}

static int aspURL1_fwNow2(void)
{
	switch(UrlFlt_Func)
	{
		case Click_Func_EDIT:
		return UrlFlt_Edit_Index;
		default:
		return UrlFlt_TableShow.TotalNum-1;
	}
}

				// traverse several pages.

////// for urlf1.asp table format
char_t *url1_TableFmt3 =
  "<TR>  \n\r"
  "<TD class=title rowSpan=3><NOBR>&nbsp; %s</NOBR></TD>  \n\r"
  "<TD colSpan=3><INPUT type=radio name=urlfBM  value=1 %s>%s</TD></TR> \n\r"
  "<TR>  \n\r"
  "<TD colSpan=2><NOBR><INPUT type=radio name=urlfBM  value=0 %s>%s</NOBR></TD> \n\r"
  "<TD><NOBR><SELECT name=urlfBHour> \n\r"
  "<SCRIPT language=JavaScript> \n\r"
  "tmprn(24,%d); \n"
  "</SCRIPT></SELECT><B>: </B> \n\r"
  "<SELECT name=urlfBMin> \n\r"
  "<SCRIPT language=JavaScript> \n\r"
  "tmprn(60,%d); \n\r"
  "</SCRIPT></SELECT> %s \n\r"
  "<SELECT name=urlfEHour> \n\r"
  "<SCRIPT language=JavaScript> \n\r"
  "tmprn(24,%d); \n\r"
  "</SCRIPT></SELECT><B>: </B> \n\r"
  "<SELECT name=urlfEMin> \n"
  "<SCRIPT language=JavaScript> \n\r"
  "tmprn(60,%d); \n\r" "</SCRIPT></SELECT></NOBR></TD>\n\r" "</TR>  \n";
char_t *url1_TableFmt3_1 =
  "<TR><TD colSpan=3><NOBR>\n\r"
  "<INPUT type=checkbox name=BTSun value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTMon value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTTue value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTWed value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTThu value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTFri value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;\n\r"
  "<INPUT type=checkbox name=BTSat value=\"1\" %s>&nbsp;&nbsp;%s&nbsp;</td>\n\r"
  "</NOBR></TR>  \n\r" "<TR>  \n\r";

static int
aspUrlFlt1_Page (int eid, webs_t wp, int argc, char_t ** argv)
{

  char_t *url1_TableFmt1 =
    "<TR>\n"
    "<TD class=title>%s %d</TD>\n\r"
    "<TD class=title1 colSpan=4> &nbsp;%s &nbsp;&nbsp;\n\r"
    "<SELECT name=urlfRE>\n\r"
    "%s" "</SELECT>\n\r" "</TD></TR>\n\r";

  char_t *url1_TableFmt2 =
    "<TR>\n"
    "<TD class=header colSpan=4>%s</TD>\n\r"
    "</TR>\n\r"
    "<TR>\n\r"
    "<TD class=title width=30\%>%s</TD>\n\r"
    "<TD class=title1 width=10\%>\n\r"
    "<INPUT type=text name=urlfIpFrom maxlength=17 size=15 value=%s>\n\r"
    "</TD>\n"
    "<TD class=title width=30\%>%s</TD>\n\r"
    "<TD class=title1 width=10\%>\n\r"
    "<INPUT type=text name=urlfIpTo maxlength=17 size=15 value=%s>\n\r"
    "</TD>\n\r" "</TR>\n\r";

  char_t *url1_TableFmt4 =
    "<INPUT type=\"hidden\" name=\"urlfDetail\" value=\"0\">\n\r"
    "<TR><TD class=title><NOBR>&nbsp; %s</NOBR></TD>\n\r"
    "<TD colSpan=4><NOBR><INPUT type=checkbox name=KFenable value=\"1\" %s > %s &nbsp;\n\r"
    "<INPUT type=\"button\" value=\"%s\" onclick=\"Detail(1)\">\n\r"
    "</NOBR></TD></TR>\n\r" "<TR>\n\r";
  char_t *url1_TableFmt5 =
    "<TD class=title><NOBR>&nbsp; %s</NOBR></TD>\n\r"
    "<TD colSpan=4><NOBR><INPUT type=checkbox name=DFenable value=\"1\" %s > %s &nbsp;\n\r"
    "<INPUT type=\"button\" value=\"%s\" onclick=\"Detail(2)\"> \n\r"
    "</NOBR></TD></TR>\n\r";
  char_t *url1_TableFmt6 =
    "<TR><TD class=title rowSpan=4><NOBR>&nbsp;%s</NOBR></TD>\n\r"
    "<TD colSpan=4><NOBR><INPUT type=checkbox name=BJava value=\"1\" %s > %s Java Applet</NOBR></TD></TR>\n\r"
    "<TR><TD colSpan=4><NOBR><INPUT type=checkbox name=BAct value=\"1\" %s > %s ActiveX</NOBR></TD></TR>\n\r"
    "<TR><TD colSpan=4><NOBR><INPUT type=checkbox name=BCook value=\"1\" %s > %s Cookies</NOBR></TD></TR>\n\r"
    "<TR><TD colSpan=4><NOBR><INPUT type=checkbox name=BProxy value=\"1\" %s > %s Proxy</NOBR></TD></TR>\n\r";

  const int ActiveNum = 2, ActiveDefault = 1;
  char *ActiveList[] = { URL_L3[locale_config.locale], URL_L4[locale_config.locale] };
  char SIP[2][16] = { {0} };
  //int i;

  if ((UrlFlt_Func == Click_Func_ADD) && (urlfDetailEdit == 0))
    {				// A new one and also not return form the keyword or domain editing pages
      memset (&gTmpRule, 0, sizeof (URLFILTER_RULE_T));	//since a new one is adding, we can clear the global rule         
      websWrite (wp, T (url1_TableFmt1), 
			URL_L15[locale_config.locale],
			UrlFlt_TableShow.NextItem + 1,
			URL_L16[locale_config.locale],
		 //  Active options "Yes" or "No", string
		 SelectListOption (ActiveList, ActiveNum, ActiveDefault));
      websWrite (wp, T (url1_TableFmt2),
			URL_L17[locale_config.locale],
			URL_L18[locale_config.locale],
		 //  PC start IP, string
		 "",
			URL_L7[locale_config.locale],
		 //  PC End IP, string
		 "");
      websWrite (wp, T (url1_TableFmt3), 
		URL_L24[locale_config.locale],
		"checked",	// default is always block
		URL_L25[locale_config.locale],
		"",
		URL_L26[locale_config.locale],
		DEFAULT_TIME_BLOCK_FROM_HOUR,
		DEFAULT_TIME_BLOCK_FROM_MIN,
		URL_L7[locale_config.locale],
		DEFAULT_TIME_BLOCK_TO_HOUR, 
		DEFAULT_TIME_BLOCK_TO_MIN);
      websWrite (wp, T (url1_TableFmt3_1),
				 "",URL_L8[locale_config.locale],
				 "",URL_L9[locale_config.locale],
				 "",URL_L10[locale_config.locale],
				 "",URL_L11[locale_config.locale],
				 "",URL_L12[locale_config.locale],
				 "",URL_L13[locale_config.locale],
				 "",URL_L14[locale_config.locale]
				 );
      websWrite (wp, T (url1_TableFmt4), 
				URL_L19[locale_config.locale],
				"",
				URL_L20[locale_config.locale],
				URL_L21[locale_config.locale]);
      websWrite (wp, T (url1_TableFmt5), 
				URL_L31[locale_config.locale],
				"",
				URL_L20[locale_config.locale],
				URL_L21[locale_config.locale]);

      websWrite (wp, T (url1_TableFmt6), 
				URL_L22[locale_config.locale],
				 "",URL_L23[locale_config.locale],
				 "",URL_L23[locale_config.locale],
				 "",URL_L23[locale_config.locale],
				 "",URL_L23[locale_config.locale]);
    }
  else
    {
      URLFILTER_RULE_T *rule;
      //DPRINTF("aspUrlFlt1_Page:urlfDetailEdit=%d,UrlFlt_Edit_Index=%d\n",urlfDetailEdit,UrlFlt_Edit_Index);
      if (urlfDetailEdit)
	{
	  rule = &gTmpRule;
	  urlfDetailEdit = 0;	//reset it     
	}
      else
      {
	rule = &UrlFlt_TableShow.Rule[UrlFlt_Edit_Index];
      }
/*DPRINTF("aspUrlFlt1_Page:domainFilterNumber=%d\n",rule->domainFilterNumber);
   for (i = 0; i < rule->domainFilterNumber; i++)
    {

	    DPRINTF("aspUrlFlt1_Page:i= %d, df=%s\n", i,rule->domainFilter[i]);
    }*/
      if(UrlFlt_Func == Click_Func_ADD){
	websWrite (wp, T (url1_TableFmt1),
		 // 0 Rule's number, int
			URL_L15[locale_config.locale],
		   UrlFlt_TableShow.NextItem + 1,
			URL_L16[locale_config.locale],
		 // 3 Active options "Yes" or "No", string
		 SelectListOption (ActiveList, ActiveNum, rule->RuleActive));
      }else{
	websWrite (wp, T (url1_TableFmt1),
			URL_L15[locale_config.locale],
		 // 0 Rule's number, int
		 UrlFlt_Edit_Index + 1,
			URL_L16[locale_config.locale],
		 // 3 Active options "Yes" or "No", string
		 SelectListOption (ActiveList, ActiveNum, rule->RuleActive));
      }

      sprintf (SIP[0], "%s", rule->PCIpStart);
      sprintf (SIP[1], "%s", rule->PCIpEnd);
      websWrite (wp, T (url1_TableFmt2),
			URL_L17[locale_config.locale],
			URL_L18[locale_config.locale],
		 //  PC start IP, string
		 SIP[0],
			URL_L7[locale_config.locale],
		 //  PC End IP, string
		 SIP[1]);
      websWrite (wp, T (url1_TableFmt3),
		  URL_L24[locale_config.locale],
		 (rule->timeblock.alwaysBlock) ? "checked" : "",
		  URL_L25[locale_config.locale],
		 (rule->timeblock.alwaysBlock) ? "" : "checked",
		  URL_L26[locale_config.locale],
		 rule->timeblock.time_start / 60,
		 rule->timeblock.time_start % 60,
		  URL_L7[locale_config.locale],
		 rule->timeblock.time_stop / 60,
		 rule->timeblock.time_stop % 60);

      websWrite (wp, T (url1_TableFmt3_1),
		 (rule->timeblock.days_match & 0x01) ? "checked" : "",
		 URL_L8[locale_config.locale],
		 (rule->timeblock.days_match & 0x02) ? "checked" : "",
		 URL_L9[locale_config.locale],
		 (rule->timeblock.days_match & 0x04) ? "checked" : "",
		 URL_L10[locale_config.locale],
		 (rule->timeblock.days_match & 0x08) ? "checked" : "",
		 URL_L11[locale_config.locale],
		 (rule->timeblock.days_match & 0x10) ? "checked" : "",
		 URL_L12[locale_config.locale],
		 (rule->timeblock.days_match & 0x20) ? "checked" : "",
		 URL_L13[locale_config.locale],
		 (rule->timeblock.days_match & 0x40) ? "checked" : "",
		 URL_L14[locale_config.locale]);

      websWrite (wp, T (url1_TableFmt4),
		 URL_L19[locale_config.locale],
		 (rule->keyFilterEnabled) ? "checked" : "",
		 URL_L20[locale_config.locale],
		 URL_L21[locale_config.locale]);

      websWrite (wp, T (url1_TableFmt5),
		 URL_L31[locale_config.locale],
		 (rule->domainFilterEnabled) ? "checked" : "",
		 URL_L20[locale_config.locale],
		 URL_L21[locale_config.locale]);

      websWrite (wp, T (url1_TableFmt6),
		 URL_L22[locale_config.locale],
		 (rule->contentFilter & BLK_JAVA) ? "checked" : "",
		 URL_L23[locale_config.locale],
		 (rule->contentFilter & BLK_ACTIVE) ? "checked" : "",
		 URL_L23[locale_config.locale],
		 (rule->contentFilter & BLK_COOKIE) ? "checked" : "",
		 URL_L23[locale_config.locale],
		 (rule->contentFilter & BLK_PROXY) ? "checked" : "",
		 URL_L23[locale_config.locale]);

      memcpy (&gTmpRule, rule, sizeof (URLFILTER_RULE_T));	// put the one in the global tmp for later reference                   
    }
  return 0;
}				// end aspUrlFlt1_Page


////// for urlfde1.asp table format, the keyword table
static int
aspUrlFltKeywordTable (int eid, webs_t wp, int argc, char_t ** argv)
{
  char_t *TableFmt = "<TR>\n"
    "<TD><NOBR>item%d</NOBR></TD>\n"
    "<TD><NOBR>%s</NOBR></TD>\n"
    "<TD><NOBR><INPUT type=\"button\" value=\"%s\" onclick=\"DeleteItem(%d)\"> </NOBR></TD>\n"
    "</TR> \n";
  int nBytes = 0, i;
  URLFILTER_RULE_T *rule = &gTmpRule;

  for (i = 0; i < rule->keyFilterNumber; i++)
    {

      nBytes += websWrite (wp, T (TableFmt),
			   i + 1, rule->keyFilter[i], URL_L27[locale_config.locale],i + 1);
    }
  return nBytes;
}

////// for urlfde1.asp table format, the keyword table
static int
aspUrlFltKeywordInput (int eid, webs_t wp, int argc, char_t ** argv)
{
  char_t *TableFmt = "<TR>\n"
    "<TD class=title>%s</TD>"
    "<TD colSpan=2><INPUT name=urlfkw %s>%s</TD> \n"
    "</TR> \n"
    "<TR> \n"
    "<TD colSpan=3><NOBR><INPUT type=submit value=\"%s\" %s></NOBR></TD> \n"
    "</TR> \n";
  int nBytes = 0;
  URLFILTER_RULE_T *rule = &gTmpRule;

  if (rule->keyFilterNumber >= MAX_KEY_NUMBER)
    {
      char warningMsg[30];
      sprintf (warningMsg, "(Warning Max. %d keywords reach)",
	       MAX_KEY_NUMBER);
      nBytes +=
	websWrite (wp, T (TableFmt),URL_L28[locale_config.locale], "disabled", warningMsg, URL_L29[locale_config.locale],"disabled");
    }
  else
    nBytes += websWrite (wp, T (TableFmt),URL_L28[locale_config.locale], "", "",URL_L29[locale_config.locale], "");

  return nBytes;
}


////// for urlfde1.asp table format, the keyword table
static int
aspUrlFltDomainTable (int eid, webs_t wp, int argc, char_t ** argv)
{
  char_t *TableFmt = "<TR>\n"
    "<TD><NOBR>item%d</NOBR></TD>\n"
    "<TD><NOBR>%s</NOBR></TD>\n"
    "<TD><NOBR><INPUT type=\"button\" value=\"%s\" onclick=\"DeleteItem(%d)\"> </NOBR></TD>\n"
    "</TR> \n";
  int nBytes = 0, i;
  URLFILTER_RULE_T *rule = &gTmpRule;

  for (i = 0; i < rule->domainFilterNumber; i++)
    {

      nBytes += websWrite (wp, T (TableFmt),
			   i + 1, rule->domainFilter[i], URL_L27[locale_config.locale],i + 1);
    }
  return nBytes;
}

//for urlfde1.asp table format, the keyword table
static int
aspUrlFltDomainInput (int eid, webs_t wp, int argc, char_t ** argv)
{
  char_t *TableFmt = "<TR>\n"
    "<TD class=title>%s</TD>"
    "<TD colSpan=2><INPUT name=urlfdn %s>%s</TD> \n"
    "</TR> \n"
    "<TR> \n"
    "<TD colSpan=3><NOBR><INPUT type=submit value=\"%s\" %s></NOBR></TD> \n"
    "</TR> \n";
  int nBytes = 0;
  URLFILTER_RULE_T *rule = &gTmpRule;

  if (rule->domainFilterNumber >= MAX_DOMAIN_NUMBER)
    {
      char warningMsg[30];
      sprintf (warningMsg, "(Warning Max. %d domains reach)",
	       MAX_DOMAIN_NUMBER);
      nBytes +=
	websWrite (wp, T (TableFmt),URL_L30[locale_config.locale], "disabled", warningMsg, URL_L29[locale_config.locale],"disabled");
    }
  else
    nBytes += websWrite (wp, T (TableFmt),URL_L30[locale_config.locale], "", "",URL_L29[locale_config.locale], "");

  return nBytes;
}


// for form urlf1.asp
static void
formUrlFlt1 (webs_t wp, char_t * path, char_t * query)
{
  char_t *purlfNow, *purlfRE, *urlfFUNC;
  char_t *purlfIpFrom, *purlfIpTo;
  char_t *purlfBM, *purlfBHour, *purlfBMin, *purlfEHour, *purlfEMin;
  char_t *pBTSun, *pBTMon, *pBTTue, *pBTWed, *pBTThu, *pBTFri, *pBTSat;
  char_t *pKFenable, *pDFenable, *pBJava, *pBAct, *pBCook, *pBProxy;
  char_t *purlfDetail;

  urlfFUNC = websGetVar (wp, T ("urlfFUNC"), "0");
  purlfNow = websGetVar (wp, T ("urlfNow"), "0");
  purlfRE = websGetVar (wp, T ("urlfRE"), "0");
  purlfIpFrom = websGetVar (wp, T ("urlfIpFrom"), "0");
  purlfIpTo = websGetVar (wp, T ("urlfIpTo"), "0");
  purlfBM = websGetVar (wp, T ("urlfBM"), "0");
  purlfBHour = websGetVar (wp, T ("urlfBHour"), "0");
  purlfBMin = websGetVar (wp, T ("urlfBMin"), "0");
  purlfEHour = websGetVar (wp, T ("urlfEHour"), "0");
  purlfEMin = websGetVar (wp, T ("urlfEMin"), "0");
  pBTSun = websGetVar (wp, T ("BTSun"), "0");
  pBTMon = websGetVar (wp, T ("BTMon"), "0");
  pBTTue = websGetVar (wp, T ("BTTue"), "0");
  pBTWed = websGetVar (wp, T ("BTWed"), "0");
  pBTThu = websGetVar (wp, T ("BTThu"), "0");
  pBTFri = websGetVar (wp, T ("BTFri"), "0");
  pBTSat = websGetVar (wp, T ("BTSat"), "0");
  pKFenable = websGetVar (wp, T ("KFenable"), "0");
  pDFenable = websGetVar (wp, T ("DFenable"), "0");
  pBJava = websGetVar (wp, T ("BJava"), "0");
  pBAct = websGetVar (wp, T ("BAct"), "0");
  pBCook = websGetVar (wp, T ("BCook"), "0");
  pBProxy = websGetVar (wp, T ("BProxy"), "0");
  pBProxy = websGetVar (wp, T ("BProxy"), "0");
  purlfDetail = websGetVar (wp, T ("urlfDetail"), "0");	// if detail press, and which detailed

  gTmpRule.Item = atoi (purlfNow) + 1;	//0
  gTmpRule.RuleActive = atoi (purlfRE) - 1;	//1
  strcpy (gTmpRule.PCIpStart, purlfIpFrom);	//5
  strcpy (gTmpRule.PCIpEnd, purlfIpTo);	//6
  chk_ip_range(gTmpRule.PCIpStart, gTmpRule.PCIpEnd);
  gTmpRule.timeblock.alwaysBlock = atoi (purlfBM);
  gTmpRule.timeblock.time_start = atoi (purlfBHour) * 60 + atoi (purlfBMin);
  gTmpRule.timeblock.time_stop = atoi (purlfEHour) * 60 + atoi (purlfEMin);

  gTmpRule.keyFilterEnabled = 0;
  gTmpRule.domainFilterEnabled = 0;
  memset (&gTmpRule.timeblock.days_match, 0,
	   sizeof (gTmpRule.timeblock.days_match));
  memset (&gTmpRule.contentFilter, 0,
	   sizeof (gTmpRule.contentFilter));
//  DPRINTF ("urlf1.asp Sun %s %d\n", pBTSun, atoi (pBTSun));
  if (atoi (pBTSun) == 1)
    gTmpRule.timeblock.days_match = 0x01;
  if (atoi (pBTMon) == 1)
    gTmpRule.timeblock.days_match |= 0x02;
  if (atoi (pBTTue) == 1)
    gTmpRule.timeblock.days_match |= 0x04;
  if (atoi (pBTWed) == 1)
    gTmpRule.timeblock.days_match |= 0x08;
  if (atoi (pBTThu) == 1)
    gTmpRule.timeblock.days_match |= 0x10;
  if (atoi (pBTFri) == 1)
    gTmpRule.timeblock.days_match |= 0x20;
  if (atoi (pBTSat) == 1)
    gTmpRule.timeblock.days_match |= 0x40;
  if (atoi (pKFenable) == 1)
    gTmpRule.keyFilterEnabled = 1;
  if (atoi (pDFenable) == 1)
    gTmpRule.domainFilterEnabled = 1;
  if (atoi (pBJava) == 1)
    gTmpRule.contentFilter |= BLK_JAVA;
  if (atoi (pBAct) == 1)
    gTmpRule.contentFilter |= BLK_ACTIVE;
  if (atoi (pBCook) == 1)
    gTmpRule.contentFilter |= BLK_COOKIE;
  if (atoi (pBProxy) == 1)
    gTmpRule.contentFilter |= BLK_PROXY;

  websHeader (wp);
  if (atoi (urlfFUNC) == 6)
    websWrite (wp,
	       T
	       ("<script language=\"JavaScript\">location.replace(\"/urlf1.asp\");</script>"));
  else
    {
#define KEYWORD_FILTER_DETAIL 1
#define KEYWORD_DOMAIN_DETAIL 2
      urlfDetailEdit = atoi (purlfDetail);
      if (urlfDetailEdit > 0)
	{
	  //we shall keep the editing gTmpRules.
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlfde%d.asp\");</script>"),
		     urlfDetailEdit);
	}
      else
	{
	  switch (UrlFlt_Func)
	    {
	    case Click_Func_ADD:
	      UrlFlt_AddRule (&UrlFlt_TableShow, &gTmpRule);
	      //websWrite(wp, T("<script language=\"JavaScript\">alert(\"add\");</script>"));
	      break;
	    case Click_Func_EDIT:
	      UrlFlt_SetRule (&UrlFlt_TableShow, &gTmpRule,
			      gTmpRule.Item - 1);
	      //websWrite(wp, T("<script language=\"JavaScript\">alert(\"set\");</script>"));
	      break;
	    default:
	      // do nothing
	      break;
	    }
	  websWrite (wp,
		     T
		     ("<script language=\"JavaScript\">location.replace(\"/urlf.asp\");</script>"));
	  //memset(&gTmpRule, 0, sizeof(URLFILTER_RULE_T));
	}
    }
  websFooter (wp);
  websDone (wp, 200);

}				// end formUrlFlt1


// for form urlfde1.asp keywords
static void
formUrlFde1 (webs_t wp, char_t * path, char_t * query)
{
  char_t *purlfkeD;
  URLFILTER_RULE_T *rule = &gTmpRule;
  int delKeyItem, j;

  purlfkeD = websGetVar (wp, T ("urlfkeD"), "0");

  delKeyItem = atoi (purlfkeD);
  if (delKeyItem)
    {				// User press delete
      if (rule->keyFilterNumber >= 2)
	{			//move from right to left.
	  for (j = delKeyItem; j < rule->keyFilterNumber; j++)
	    strcpy (rule->keyFilter[j - 1], rule->keyFilter[j]);
	}
      rule->keyFilterNumber -= 1;
    }
  else
    {
      char_t *purlfkw;
      purlfkw = websGetVar (wp, T ("urlfkw"), "");
      if (strlen (purlfkw) >= 1)
	strcpy (rule->keyFilter[rule->keyFilterNumber++], purlfkw);
    }
	websHeader(wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/urlfde1.asp\");</script>"));
  websFooter (wp);
  websDone (wp, 200);

}// end

// for form urlfde2.asp domains
static void
formUrlFde2 (webs_t wp, char_t * path, char_t * query)
{
  char_t *purlfdnD;
  URLFILTER_RULE_T *rule = &gTmpRule;
  int delKeyItem, j;

  purlfdnD = websGetVar (wp, T ("urlfdnD"), "0");

  delKeyItem = atoi (purlfdnD);
  if (delKeyItem)
    {				// User press delete
      if (rule->domainFilterNumber >= 2)
	{			//move from right to left.
	  for (j = delKeyItem; j < rule->domainFilterNumber; j++)
	    strcpy (rule->domainFilter[j - 1], rule->domainFilter[j]);
	}
      rule->domainFilterNumber -= 1;
    }
  else
    {
      char_t *purlfdn;
      purlfdn = websGetVar (wp, T ("urlfdn"), "");
      if (strlen (purlfdn) >= 1)
	strcpy (rule->domainFilter[rule->domainFilterNumber++], purlfdn);
    }
	websHeader(wp);
  websWrite (wp,
	     T
	     ("<script language=\"JavaScript\">location.replace(\"/urlfde2.asp\");</script>"));
  websFooter (wp);
  websDone (wp, 200);

}				// end


int
GetConfigToUrlFltTable (URLFILTER_TABLE_T * table)
{
  int i, j;
  URLFILTER_RULE_T aRule, *rule = &aRule;
  char filename[80];
  FILE *fp, *fpKey, *fpDomain;

  //fp = fopen(PROGRAM_SCRIPT_FILE, "r");
  fp = fopen ("/flash/uf_conf1.conf", "r");
  if (!fp)
    {
      return -1;
    }
  for (i = 0; i < MAX_RULE; i++)
    {
      if (fscanf (fp, "|%d|%20[^|]|%20[^|]|%d|%d|%d|%d|%d|%d|%d|%d|%d|\n", (int *) &rule->RuleActive,	//1
		  rule->PCIpStart,	//2
		  rule->PCIpEnd,	//3
		  &rule->timeblock.alwaysBlock,
		  &rule->timeblock.days_match,
		  &rule->timeblock.time_start,
		  &rule->timeblock.time_stop,
		  &rule->contentFilter,
		  &rule->keyFilterEnabled,
		  &rule->keyFilterNumber,
		  &rule->domainFilterEnabled,
		  &rule->domainFilterNumber) == -1)
	break;
      if (rule->PCIpStart[0] == '&')
	rule->PCIpStart[0] = '\0';
      if (rule->PCIpEnd[0] == '&')
	rule->PCIpEnd[0] = '\0';

      sprintf (filename, "/flash/uf_key%d.conf", i);
      fpKey = fopen (filename, "r");
      if (!fpKey)
	{
	  fclose (fp);
	  return -1;
	};
      sprintf (filename, "/flash/uf_dmn%d.conf", i);
      fpDomain = fopen (filename, "r");
      if (!fpDomain)
	{
	  fclose (fp);
	  fclose (fpKey);
	  return -1;
	};

      for (j = 0; j < rule->keyFilterNumber; j++)
	fscanf (fpKey, "|%40[^|]|\n", rule->keyFilter[j]);

      for (j = 0; j < rule->domainFilterNumber; j++)
	fscanf (fpDomain, "|%40[^|]|\n", rule->domainFilter[j]);

      rule->Item = i + 1;	//0

      UrlFlt_AddRule (table, rule);
    }
  fclose (fp);
  return 0;
}				// end GetConfigToUrlFltTable

// SetUrlFltSTableToConfig
int
SetUrlFltSTableToConfig (URLFILTER_TABLE_T * table)
{
  int i, j;
  URLFILTER_RULE_T *rule;
  FILE *fp, *fpKey, *fpDomain;
  char filename[80];

  fp = fopen ("/flash/uf_conf1.conf", "w");
  if (!fp)
    {
      return -1;
    }

  for (i = 0; i < MAX_RULE; i++)
    {
      rule = &table->Rule[i];
      if (rule->Item != 0)
	{
	  //rule.Item = i+1; //0
	  fprintf (fp, "|%d|%s|%s|%d|%d|%d|%d|%d|%d|%d|%d|%d|\n", rule->RuleActive,	//1
		   (rule->PCIpStart[0] == '\0') ? "&" : rule->PCIpStart,	//2
		   (rule->PCIpEnd[0] == '\0') ? "&" : rule->PCIpEnd,	//3
		   rule->timeblock.alwaysBlock,
		   rule->timeblock.days_match,
		   rule->timeblock.time_start,
		   rule->timeblock.time_stop,
		   rule->contentFilter,
		   rule->keyFilterEnabled,
		   rule->keyFilterNumber,
		   rule->domainFilterEnabled, rule->domainFilterNumber);
	  sprintf (filename, "/flash/uf_key%d.conf", i);
	  fpKey = fopen (filename, "w");
	  if (!fpKey)
	    {
	      fclose (fp);
	      return -1;
	    };
	  sprintf (filename, "/flash/uf_dmn%d.conf", i);
	  fpDomain = fopen (filename, "w");
	  if (!fpDomain)
	    {
	      fclose (fp);
	      fclose (fpKey);
	      return -1;
	    };
	  for (j = 0; j < rule->keyFilterNumber; j++)
	    fprintf (fpKey, "|%s|\n", rule->keyFilter[j]);	// Note can not be NULL STRING.
	  fclose (fpKey);

	  for (j = 0; j < rule->domainFilterNumber; j++)
	    fprintf (fpDomain, "|%s|\n", rule->domainFilter[j]);	// Note can not be NULL STRING.
	  fclose (fpDomain);
	}
    }

  fclose (fp);
  return 0;
}				// end SetUrlFltSTableToConfig

// CreateUrlFltTableToScript
void outputUrlFltRuleToScript (URLFILTER_RULE_T * rule, FILE * outfp);
/*-----------------------------------------------*/

int
CreateUrlFltTableToScript (URLFILTER_TABLE_T * table)
{
  URLFILTER_RULE_T *rule;
  FILE *outfp, *outfp2;
// char filename[80];
  int i;//, hasRules = FALSE;

  outfp = fopen (URLFLT_CONF_FN_RULE_ADD, "w");
  if (!outfp)
    {
      //DPRINTF ("open file %s for write error!\n", URLFLT_CONF_FN_RULE_ADD);
      return -1;
    }
  //rename (URLFLT_CONF_FN_RULE_DEL, URLFLT_CONF_FN_RULE_DEL_OLD);	// keep the old del scripts.
  outfp2 = fopen (URLFLT_CONF_FN_RULE_DEL, "w");
  if (!outfp2)
    {
      //DPRINTF ("open file %s for write error!\n", URLFLT_CONF_FN_RULE_DEL);
      return -1;
    }

      fprintf (outfp, "#!/bin/sh\n");
      fprintf (outfp, ". /var/etc/status\n");
      fprintf (outfp, "iptables  -N URL_FLT\n");
      fprintf (outfp, "iptables  -N UF_REJ\n");
      fprintf (outfp,
      	"iptables  -I FORWARD -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP --dport 80 -j URL_FLT\n");
      fprintf (outfp,
	       "iptables  -A UF_REJ -p tcp -j REJECT --reject-with tcp-reset\n");


      // clean existing down- and uplink qdiscs, hide errors
      fprintf (outfp2, "#!/bin/sh\n");
      fprintf (outfp2, ". /var/etc/status\n");
      fprintf (outfp2,
      	"iptables  -D FORWARD -m tcp -p tcp -s $LAN_IP/$LAN_MASK -d ! $LAN_IP --dport 80 -j URL_FLT\n");
      fprintf (outfp2, "iptables  -F URL_FLT\n");
            fprintf (outfp2, "iptables  -X URL_FLT\n");
      fprintf (outfp2, "iptables  -F UF_REJ\n");
            fprintf (outfp2, "iptables  -X UF_REJ\n");
      for (i = 0; i < MAX_RULE; i++)
	{
	  rule = &table->Rule[i];
	  if (rule->Item != 0)
	    {
	      if (rule->RuleActive == UrlFlt_Act_YES)
		outputUrlFltRuleToScript (rule, outfp);
	    }			// rule != 0
	}			// end for loop

  fclose (outfp);
  fclose (outfp2);
  chmod (URLFLT_CONF_FN_RULE_ADD,
	 S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH |
	 S_IWOTH | S_IXOTH);
  chmod (URLFLT_CONF_FN_RULE_DEL,
	 S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH |
	 S_IWOTH | S_IXOTH);


  return 0;
}				// end CreateUrlFltTableToScript

/* aspectou32 should convert the address portion of a spec...
 * "base10"
 * "0base8"
 * "0xbase16"
 * "hostname"
 * "address" */
u_int32_t
aspectou32 (char *astr, int dns)
{
  u_int32_t addr = 0;
  struct in_addr s;

  // So we can input the domain name instead of the IP address.
  if (inet_aton (astr, &s))
    addr = ntohl (s.s_addr);
  else
    fprintf (stderr, "UrlFlt.c: unable to parse \"%s\"\n", astr);
  return (addr);
}

void
outputTimeBLockForIptables (TIME_BLOCK_T * timeblock, char *timeBlocking)
{
  if ((!timeblock->alwaysBlock) && (timeblock->days_match > 0))
    {
      int daysMask = 0x01;
      int firstOne = TRUE, kk;	// No "," for first one
      char daysBlock[40];
      memset (daysBlock, 0, sizeof (daysBlock));
      sprintf (daysBlock, "--days ");
      for (kk = 0; kk < 7; kk++)
	{
	  if (timeblock->days_match & daysMask)
	    {
	      if (!firstOne)
		strcat (daysBlock, ",");
	      else
		firstOne = FALSE;
	      strcat (daysBlock, days_match_str[kk]);
	    }
	  daysMask <<= 0x01;
	}

      sprintf (timeBlocking,
	       "-m time --timestart %02d:%02d --timestop %02d:%02d %s",
	       timeblock->time_start / 60, timeblock->time_start % 60,
	       timeblock->time_stop / 60, timeblock->time_stop % 60,
	       daysBlock);
    }
}

//iptables -t nat -A PREROUTING -m time --timestart 08:00 --timestop 16:00 --days Mon,Tue,Wed,Thu,Fri -j DROP


void
outputUrlFltRuleToScript (URLFILTER_RULE_T * rule, FILE * outfp)
{
  u_int32_t ipFrom, ipTo;
  char iprange[12] = "", ipstr[45] = "";
  ipFrom = aspectou32 (rule->PCIpStart, 0);
  ipTo = aspectou32 (rule->PCIpEnd, 0);
  char timeBlocking[128] = "";
  int i;

  if (ipFrom == 0)
    ;
  else
    strcpy (iprange, "-m iprange");

  if (ipFrom != 0)
    {
      // NOTE, WE would not allow "To" exists w/o "From", Web page shall guarantee this.
      if (ipTo)
	sprintf (ipstr, "--src-range %s-%s", rule->PCIpStart, rule->PCIpEnd);
      else
	sprintf (ipstr, "--src-range %s", rule->PCIpStart);
    }
  outputTimeBLockForIptables (&rule->timeblock, timeBlocking);

  if (rule->contentFilter)
    fprintf (outfp,
	     "iptables -A URL_FLT %s %s -p tcp %s -m webstr --content %d -j UF_REJ\n",
	     iprange, ipstr, timeBlocking, rule->contentFilter);

  if (rule->keyFilterEnabled)
    for (i = 0; i < rule->keyFilterNumber; i++)
      fprintf (outfp,
	       "iptables -A URL_FLT %s %s -p tcp %s -m webstr --url \"%s\" -j UF_REJ\n",
	       iprange, ipstr, timeBlocking, rule->keyFilter[i]);
  if (rule->domainFilterEnabled)
    for (i = 0; i < rule->domainFilterNumber; i++)
      fprintf (outfp,
	       "iptables -A URL_FLT %s %s -p tcp %s -m webstr --host \"%s\" -j UF_REJ\n",
	       iprange, ipstr, timeBlocking, rule->domainFilter[i]);

}
