/* albert 20030128 */
/* UrlFlt configure functions */
#include "urlFlt_conf.h"
#include "webs.h"
//URLFILTER_TABLE_T UrlFlt_Table, UrlFlt_TableShow;
int UrlFlt_Table_Init(URLFILTER_TABLE_T *table);
int UrlFlt_AddRule(URLFILTER_TABLE_T *table, URLFILTER_RULE_T *rule);
int UrlFlt_DelRule(URLFILTER_TABLE_T *table, int item);
int UrlFlt_AdjustTable(URLFILTER_TABLE_T *table);
int UrlFlt_SetRule(URLFILTER_TABLE_T *table, URLFILTER_RULE_T *rule, int item);
int UrlFlt_CopyTable(URLFILTER_TABLE_T *DstTable, URLFILTER_TABLE_T *SrcTable);


int UrlFlt_Table_Init(URLFILTER_TABLE_T *table)
{
	memset( (void *)table, 0, sizeof(URLFILTER_TABLE_T));
	// then we give the default adsl substription Rate
	return 0;
}

int UrlFlt_AddRule(URLFILTER_TABLE_T *table, URLFILTER_RULE_T *rule)
{
	if( table->TotalNum < 0 || table->TotalNum >= MAX_RULE)
		return -1;
	table->Rule[table->NextItem++] = *rule;
	table->TotalNum++;
	return 0;
}

int UrlFlt_SetRule(URLFILTER_TABLE_T *table, URLFILTER_RULE_T *rule, int item)
{
	if( item < 0 || item > table->NextItem)
		return -1;
	table->Rule[item] = *rule;
	return 0;
}


int UrlFlt_DelRule(URLFILTER_TABLE_T *table, int item)
{
	if( item < 0 || item >= table->NextItem)
		return -1;
	//table->Rule[item] = (URLFILTER_RULE_T){0};
	memset( &(table->Rule[item]), 0, sizeof(URLFILTER_RULE_T));
	UrlFlt_AdjustTable(table);
	return 0;
}

int UrlFlt_AdjustTable(URLFILTER_TABLE_T *table)
{
	URLFILTER_TABLE_T tableTmp;
	int i = 0;
	
	UrlFlt_Table_Init(&tableTmp);
	
	for( i = 0; i < MAX_RULE; i++)
	{
		if( table->Rule[i].Item != 0 )
		{
			memcpy((void*)&(tableTmp.Rule[tableTmp.NextItem++]), (void*)&(table->Rule[i]), sizeof(URLFILTER_RULE_T));
			tableTmp.TotalNum++;
		}
	}
	memcpy((void*)table, (void*)&tableTmp, sizeof(URLFILTER_TABLE_T));
	return 0;
}

int UrlFlt_CopyTable(URLFILTER_TABLE_T *DstTable, URLFILTER_TABLE_T *SrcTable)
{
	UrlFlt_Table_Init(DstTable);
	memcpy((void*)DstTable, (void*)SrcTable, sizeof(URLFILTER_TABLE_T));
	return 0;
}
