// albert 20030128
// packetfilter configure functions
#ifndef __URLFLT_CONFIG_H
#define __URLFLT_CONFIG_H
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "timeblock.h"

typedef enum URLFILTER_Active{
	UrlFlt_Act_NO=0,
	UrlFlt_Act_YES
} URLFILTER_Active_E;



/* Same as the file "linux/netfilter_ipv4/ipt_webstr.h" */
#define BLK_JAVA                0x01
#define BLK_ACTIVE              0x02
#define BLK_COOKIE              0x04
#define BLK_PROXY               0x08

#define MAX_KEY_LENGTH 40
#define MAX_KEY_NUMBER 30
#define MAX_DOMAIN_LENGTH 70
#define MAX_DOMAIN_NUMBER 30

#define DEFAULT_TIME_BLOCK_FROM_HOUR 8
#define DEFAULT_TIME_BLOCK_FROM_MIN 0
#define DEFAULT_TIME_BLOCK_TO_HOUR 18
#define DEFAULT_TIME_BLOCK_TO_MIN 0

typedef struct URLFILTER_RULE {
	int Item;	//0
	URLFILTER_Active_E RuleActive;	//1
	char PCIpStart[20];	//5
	char PCIpEnd[20];	//6
	TIME_BLOCK_T timeblock;
	int contentFilter;/* 1 bit per blocking type */
	int keyFilterEnabled;/* No =0 is default */
	int keyFilterNumber;/* No =0 is default */
	int domainFilterEnabled;/* no=0 is default */
	int domainFilterNumber;/* no=0 is default */
	char keyFilter[MAX_KEY_NUMBER][MAX_KEY_LENGTH];
	char domainFilter[MAX_DOMAIN_NUMBER][MAX_DOMAIN_LENGTH];	
} URLFILTER_RULE_T;


#define MAX_RULE 8

typedef struct urlFlt_table{
	int TotalNum;
	int NextItem;
	URLFILTER_RULE_T Rule[MAX_RULE];
} URLFILTER_TABLE_T;






#endif /* __QOS_CONFIG_H */
