/*
 *  vlan_port.asp & vlan_igmp.asp vlan configuration
 */
#include "webs.h"
#include "vlan.h"
#include "../iptables-1.2.11/runFunc.h" // KenWang added 2006/01/02
#include "wan_vod.h" // KenWang added 2006/01/02
#include "locale.h"

#define VLAN_SCRIPT_FILE "/etc/scripts/vlan.sh"
#define VLAN_RST_SCRIPT_FILE "/etc/scripts/vlan_rst.sh"

VLAN_CONFIG_DATA vlan_config;

extern char* read_file_para_value(char *filename, char *arg1,char *buf);
// KenWang added 2006/01/05
extern int save_globe_config(char *filename, char *arg1, char *arg2);
void resetCurrentVlanCfg(VLAN_CONFIG_DATA *d);
// KenWang modified 2006/01/04
// static int Load_Vlan_Config (VLAN_CONFIG_DATA *d);
int Load_Vlan_Config (VLAN_CONFIG_DATA *d);
//static int Save_Vlan_Config (VLAN_CONFIG_DATA *d);
int Save_Vlan_Config (VLAN_CONFIG_DATA *d);
//static int Save_Vlan_Script (VLAN_CONFIG_DATA *d);
static void form_vlan_config(webs_t wp,char_t * path,char_t * query);
extern int LANGUAGE_INDEX;
extern char_t *vlan_TableFmt2[];
extern char_t *vlan_TableFmt4[];
//#define _DPRINTF_
#ifdef _DPRINTF_
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
#else
	#define DPRINTF(args...)  
#endif /* _DPRINTF_ */

// KenWang marked 2006/01/02
#if 0
static void vlan_stop(void);
static void vlan_start(void);
static void vlan_stop(void){
	FILE *f;
	f=fopen("/var/state/vlan.lock","r");
	if(f){
		fclose(f);
		run_task("vpctrl","vpctrl","active","no",0);
		unlink("/var/state/vlan.lock");
	}
}
static void vlan_start(void){
	FILE *in;
	char buffer[128]="";
	int i;
	char vlan_type[2];
	char mask[4];

	printf("1.vlan port setting support\n");

	if ((in = fopen("/flash/vlan.conf", "r")) != NULL) {
		if (fgets(buffer,128,in)){
			fclose(in);
			
			GetParam(buffer, 1, '|', vlan_type);
			if (!strcmp(vlan_type,"1")) { // enable
				for (i=0; i<4; i++) {
					memset(mask,0,sizeof(mask));
					GetParam(buffer, 18+i, '|', mask);
					
					if (strcmp(mask, "0")) {
						run_task("vpctrl","vpctrl","vlan", mask, 0);
					}
				}
				run_task("vpctrl","vpctrl", "rst", "lan", 0);
//				run_script(VLAN_RST_SCRIPT_FILE,0,0,0);
				if ((in = fopen("/var/state/vlan.lock", "w")) != NULL) {
					fclose(in);
				}
			}
			else
			{
			//	do_command("vpctrl","vpctrl", "active", "no", 0);
			}
		}
	}


}
#endif
void resetCurrentVlanCfg(VLAN_CONFIG_DATA *d)
{
	memset(d,0,sizeof(VLAN_CONFIG_DATA));
}

// KenWang modified 2006/01/04
//static int Load_Vlan_Config (VLAN_CONFIG_DATA *d)
int Load_Vlan_Config (VLAN_CONFIG_DATA *d)
{
	int i;
	FILE *fp;

	resetCurrentVlanCfg(d);
	fp=fopen(VLAN_CONFIG_FILE,"r");
	if(!fp) {
		return 0;
	}
	//fscanf(fp,"%d\n",&d->management_vlan_group);
	fscanf(fp, "|%d|%d|%d|%d|%d|%d|\n",
	       &d->VLAN_TAGGING_enable[0],
	       &d->VLAN_TAGGING_enable[1],
	       &d->VLAN_TAGGING_enable[2],
	       &d->VLAN_TAGGING_enable[3],
	       &d->VLAN_TAGGING_enable[4],
	       &d->VLAN_TAGGING_enable[5]);
	for(i=0;i<MAX_RULE;i++) {
			fscanf(fp,"|%24[^|]|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				&d->Rule[i].VLAN_ID, 
				&d->Rule[i].lan_port_enabled[0], 
				&d->Rule[i].lan_port_enabled[1], 
				&d->Rule[i].lan_port_enabled[2], 
				&d->Rule[i].lan_port_enabled[3], 
				&d->Rule[i].lan_port_enabled[4], 
				&d->Rule[i].WAN_connection_index, 
				&d->Rule[i].WAN_TAGGING_enable);	
			print_blank_string(d->Rule[i].Name);
	}
	fclose(fp);
	return 0;
}

//static int Save_Vlan_Config (VLAN_CONFIG_DATA *d)
int Save_Vlan_Config (VLAN_CONFIG_DATA *d)
{

	FILE *fp;
	int i;

	fp=fopen(VLAN_CONFIG_FILE,"w");
	if(!fp) {
		return 0;
	}
	//fprintf(fp,"%d\n",d->management_vlan_group);
	fprintf(fp, "|%d|%d|%d|%d|%d|%d|\n",
		d->VLAN_TAGGING_enable[0],
		d->VLAN_TAGGING_enable[1],
		d->VLAN_TAGGING_enable[2],
		d->VLAN_TAGGING_enable[3],
		d->VLAN_TAGGING_enable[4],
		d->VLAN_TAGGING_enable[5]);
	for(i=0;i<MAX_RULE;i++) {
		fprintf(fp,"|%s|%d|%d|%d|%d|%d|%d|%d|%d|\n",
				d->Rule[i].Name, 
				d->Rule[i].VLAN_ID, 
				d->Rule[i].lan_port_enabled[0], 
				d->Rule[i].lan_port_enabled[1], 
				d->Rule[i].lan_port_enabled[2], 
				d->Rule[i].lan_port_enabled[3], 
				d->Rule[i].lan_port_enabled[4], 
				d->Rule[i].WAN_connection_index, 
				d->Rule[i].WAN_TAGGING_enable);	
		load_blank_string(d->Rule[i].Name);
	}
	fclose(fp);
	return 0;
}

/* KenWang added 2006/01/02 -- begin -- */
void vlan_link_wanbr(VLAN_CONFIG_DATA *d, int vlan_index)
{
	char wan_if[32], vlan_if[32], lan_if[32], wan_type[32], wlan_if[32], w_vlan_if[32];
	OTHER_WAN_BRIDGE_DATA wanbr;
	int wan_conn_index = 0, lan_enabled = 0, wlan_enabled = 0;

	if(d->Rule[vlan_index].WAN_connection_index <= 0 ||
	   d->Rule[vlan_index].WAN_connection_index > (MAX_OTHER_WAN_BRIDGE+1))
		return;

	Load_Other_Wan_Bridge_Config(&wanbr);
	wan_conn_index = d->Rule[vlan_index].WAN_connection_index;
	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", wan_if);
	read_file_para_value(VAR_SYS_STATUS_FILE, "LAN_IF=", lan_if);
	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN=", wan_type);
	read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if);

	/* WLAN tag is not ready yet */
	//sprintf(w_vlan_if, "%s.%d", wlan_if, d->Rule[vlan_index].VLAN_ID);
	strcpy(w_vlan_if, wlan_if);
	sprintf(vlan_if, "vlan%d", d->Rule[vlan_index].VLAN_ID);

	if(d->Rule[vlan_index].lan_port_enabled[0] ||
	   d->Rule[vlan_index].lan_port_enabled[1] ||
	   d->Rule[vlan_index].lan_port_enabled[2] ||
	   d->Rule[vlan_index].lan_port_enabled[3])
		lan_enabled = 1;
	if(d->Rule[vlan_index].lan_port_enabled[4])
		wlan_enabled = 1;

	if(wan_conn_index == 1) {
		/* connect to main wan, it is a management port */
		if(lan_enabled)
			run_task("brctl", "brctl", "addif", "br0", vlan_if, NULL);
		if(wlan_enabled)
			run_task("brctl", "brctl", "addif", "br0", w_vlan_if, NULL);
		if(d->Rule[vlan_index].WAN_TAGGING_enable) {
			sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
			DPRINTF("brctl addif %s %s\n", wan_if, vlan_if);
			run_task("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
		}
	}
	else {
		if(wanbr.usingSamePVCFromExistingWanConnection[wan_conn_index-2] == 1) {
			if(!strncmp(wan_if, "br", 2)) {
				if(lan_enabled) {
					DPRINTF("brctl addif %s %s\n", wan_if, vlan_if);
					run_task("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
				}
				if(wlan_enabled) {
					DPRINTF("brctl addif %s %s\n", wan_if, w_vlan_if);
					run_task("brctl", "brctl", "addif", wan_if, w_vlan_if, NULL);
				}
				if(d->Rule[vlan_index].WAN_TAGGING_enable) {
					sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
					DPRINTF("brctl addif %s %s\n", wan_if, vlan_if);
					run_task("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
				}
			}
			else
			{
				if(lan_enabled)
					run_task("brctl", "brctl", "addif", "brwan", vlan_if, NULL);
				if(wlan_enabled)
					run_task("brctl", "brctl", "addif", "brwan", w_vlan_if, NULL);
				if(d->Rule[vlan_index].WAN_TAGGING_enable) {
					sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
					run_task("brctl", "brctl", "addif", "brwan", vlan_if, NULL);
				}

			}
		}
		else {
			sprintf(wan_if, "br%d", wan_conn_index);
			if(lan_enabled) {
				DPRINTF("brctl addif %s %s\n", wan_if, vlan_if);
				run_task("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
			}
			if(wlan_enabled) {
				DPRINTF("brctl addif %s %s\n", wan_if, w_vlan_if);
				run_task("brctl", "brctl", "addif", wan_if, w_vlan_if, NULL);
			}
			if(d->Rule[vlan_index].WAN_TAGGING_enable) {
				sprintf(vlan_if, "nas%d.%d", wan_conn_index, d->Rule[vlan_index].VLAN_ID);
				DPRINTF("brctl addif %s %s\n", wan_if, vlan_if);
				run_task("brctl", "brctl", "addif", wan_if, vlan_if, NULL);
			}
		}
	}
}

void vlan_unlink_wanbr(VLAN_CONFIG_DATA *d, int vlan_index)
{
	char wan_if[32], vlan_if[32], lan_if[32], wan_type[32], wlan_if[32];
	OTHER_WAN_BRIDGE_DATA wanbr;
	int wan_conn_index = 0, lan_enabled = 0, wlan_enabled = 0;

	if(d->Rule[vlan_index].WAN_connection_index <= 0 ||
	   d->Rule[vlan_index].WAN_connection_index >= MAX_RULE)
		return;

	Load_Other_Wan_Bridge_Config(&wanbr);
	wan_conn_index = d->Rule[vlan_index].WAN_connection_index;
	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", wan_if);
	read_file_para_value(VAR_SYS_STATUS_FILE, "LAN_IF=", lan_if);
	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN=", wan_type);
	read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if); // should be wlan0.x or ra0.x
	
	sprintf(vlan_if, "vlan%d", d->Rule[vlan_index].VLAN_ID);

	if(d->Rule[vlan_index].lan_port_enabled[0] ||
	   d->Rule[vlan_index].lan_port_enabled[1] ||
	   d->Rule[vlan_index].lan_port_enabled[2] ||
	   d->Rule[vlan_index].lan_port_enabled[3])
		lan_enabled = 1;
	if(d->Rule[vlan_index].lan_port_enabled[4])
		wlan_enabled = 1;

	if(wan_conn_index == 1) {
		if(lan_enabled)
			run_task("brctl", "brctl", "delif", "br0", vlan_if, NULL);
		if(wlan_enabled)
			run_task("brctl", "brctl", "delif", "br0", wlan_if, NULL);
		if(d->Rule[vlan_index].WAN_TAGGING_enable) {
			sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
			DPRINTF("brctl delif %s %s\n", wan_if, vlan_if);
			run_task("brctl", "brctl", "delif", wan_if, vlan_if, NULL);
		}
	}
	else {
		if(wanbr.usingSamePVCFromExistingWanConnection[wan_conn_index-2] == 1) {
			if(!strncmp(wan_if, "br", 2)) {
				if(lan_enabled) {
					run_task("brctl", "brctl", "delif", wan_if, vlan_if, NULL);
				}
				if(wlan_enabled) {
					run_task("brctl", "brctl", "delif", wan_if, wlan_if, NULL);
				}
				if(d->Rule[vlan_index].WAN_TAGGING_enable) {
					sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
					run_task("brctl", "brctl", "delif", wan_if, vlan_if, NULL);
				}
			}
			else
			{
				if(lan_enabled) {
					run_task("brctl", "brctl", "delif", "brwan", vlan_if, NULL);
				}
				if(wlan_enabled) {
					run_task("brctl", "brctl", "delif", "brwan", wlan_if, NULL);
				}
				if(d->Rule[vlan_index].WAN_TAGGING_enable) {
					sprintf(vlan_if, "nas0.%d", d->Rule[vlan_index].VLAN_ID);
					run_task("brctl", "brctl", "delif", "brwan", vlan_if, NULL);
				}
			}
		}
		else {
			sprintf(wan_if, "br%d", wan_conn_index);
			if(lan_enabled) {
				DPRINTF("brctl delif %s %s\n", wan_if, vlan_if);
				run_task("brctl", "brctl", "delif", wan_if, vlan_if, NULL);
			}
			if(wlan_enabled) {
				run_task("brctl", "brctl", "delif", wan_if, wlan_if, NULL);
			}
			if(d->Rule[vlan_index].WAN_TAGGING_enable) {
				sprintf(vlan_if, "nas%d.%d", wan_conn_index, d->Rule[vlan_index].VLAN_ID);
				run_task("brctl", "brctl", "delif", wan_if, vlan_if, NULL);
			}
		}
	}
}

/* Check if any port is enabled */
int isActiveVlanGroup(VLAN_CONFIG_DATA *d, int vlan_index)
{
	/* wlan is not considered now */
	if(d->Rule[vlan_index].lan_port_enabled[0] ||
	   d->Rule[vlan_index].lan_port_enabled[1] ||
	   d->Rule[vlan_index].lan_port_enabled[2] ||
	   d->Rule[vlan_index].lan_port_enabled[3] ||
	   d->Rule[vlan_index].lan_port_enabled[4])
		return 1;
	else return 0;
}
/* KenWang added 2006/01/02 -- end -- */

extern int other_wan_bridge_no(void);
void wanConnectionRemoveNotif(int removedWanConnectionIndex)
{
	int i;
	int config_data_changed=0;
	VLAN_CONFIG_DATA *d=&vlan_config;
	Load_Vlan_Config(d);		
	for(i=0;i<MAX_RULE;i++)
	{
		if(d->Rule[i].WAN_connection_index==removedWanConnectionIndex)
		{
			config_data_changed=1;
			d->Rule[i].WAN_connection_index=0;
		}
		else
		{
		//also, since we remove one, then the index shall decrease 1 for the vlan that has wan connection reference great than the removed one.
			if(d->Rule[i].WAN_connection_index>removedWanConnectionIndex)
			{
				config_data_changed=1;
				/* KenWang modified 2006/01/02 -- begin -- */
				if(isActiveVlanGroup(d, i))
				vlan_unlink_wanbr(d, i);
				d->Rule[i].WAN_connection_index-=1;
				if(isActiveVlanGroup(d, i))
				vlan_link_wanbr(d, i);
				/* KenWang modified 2006/01/02 -- end -- */
			}
		}
				
	}
	if(config_data_changed)
		Save_Vlan_Config(d);	
}	

extern void get_other_wan_br_PVC_data(int wanbr,int *vpi,int *vci);

static	char_t *vlan_TableFmt1 =
	"<TR>\n"
	"<TD class=title>%d</TD>\n"
	"<td><INPUT type=text name=vg_name value=\"%s\" maxlength=24 size=24></td>\n"
	"<td><INPUT type=text name=Vlan_id value=%d maxlength=5 size=3></td>\n"
#if 0
	"<td><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n"
        "<td><INPUT type=checkbox name=lan_port value=%d %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n";
#else
	"<td><INPUT type=checkbox name=lan_port value=%d %s ><INPUT type=hidden name=lan_port_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s ><INPUT type=hidden name=lan_port_s></td>\n"
	"<td><INPUT type=checkbox name=lan_port value=%d %s ><INPUT type=hidden name=lan_port_s></td>\n"
        "<td><INPUT type=checkbox name=lan_port value=%d %s ><INPUT type=hidden name=lan_port_s></td>\n"
#ifdef _RALINK_WIRELESS_DRIVER_	
	"<td><INPUT type=checkbox name=lan_port value=%d %s %s onClick=\"switch_lanp(this.value)\"><INPUT type=hidden name=lan_port_s></td>\n";
#else
        "<td><INPUT type=hidden name=lan_port value=%d ><INPUT type=hidden name=lan_port_s>\n";

#endif
#endif
//static 	char_t *vlan_TableFmt2 ="<td><SELECT name=wan_conn>\n"
/*
static 	char_t *vlan_TableFmt2 ="<td><SELECT name=wan_conn onChange=\"change_wanbr();\">\n"
	"<OPTION value=\"1\" %s>No</option>\n"
	"<OPTION value=\"2\" %s>Main WAN connection(Management)</option>\n";
*/
// Camiu removed 2006.05/08 end
static	char_t *vlan_TableFmt3 =
"</SELECT></td>\n"
"<td><INPUT type=checkbox name=wan_tag value=%d %s %s onClick=\"switch_want(this.value);\"><INPUT type=hidden name=wan_tag_s></td></TR>\n";
//"<td><INPUT type=checkbox name=wan_tag value=1 %s><INPUT type=hidden name=wan_tag_s></td></TR>\n";
/* KenWang modified 2006/03/27 for WAN tagging -- end -- */
/* KenWang modified 2006/03/23 for multi vlan map to single port -- begin -- */
/* marked 2007/1/17 begin ---
static  char_t *vlan_TableFmt4 = 
"<TR>\n"
"\t<TD class=header colSpan=10>LAN Tagging</TD>\n"
"</TR>\n"
"<TR>\n"
"\t<TD colSpan=3>&nbsp;</TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=1 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=2 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=3 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=4 %s><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD><INPUT type=checkbox name=lan_tag value=5 %s disabled><INPUT type=hidden name=lan_tag_s></TD>\n"
"\t<TD colSpan=2>&nbsp;</TD>\n"
"</TR>\n";
*/

int wireless_present_fn(void)
{
	char wireless_buf[8];
	char wireless_present=0;

	strcpy(wireless_buf, read_file_para_value("/var/etc/status","WIRELESS=", wireless_buf));
	if (!strcmp(wireless_buf, "yes")) 
		wireless_present=1;
	return wireless_present;
}

static int VLAN_Table(int eid, webs_t wp, int argc, char_t **argv)
{
	int i,j,kk,jj;
	int wireless_present=wireless_present_fn();
	char wan_if[32];
	int MainWanTagEnabled;
	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", wan_if);
	if(strncmp(wan_if, "br", 2) == 0)
		MainWanTagEnabled = 1;
	else
		MainWanTagEnabled = 0;
	
	VLAN_CONFIG_DATA *d=&vlan_config;
	Load_Vlan_Config(d);		
	for(i=0;i<MAX_RULE;i++)
	{
		j=i*5;
		websWrite(wp, T(vlan_TableFmt1),
			i+1,
			d->Rule[i].Name,
			d->Rule[i].VLAN_ID,
			j,(d->Rule[i].lan_port_enabled[0])?"checked":"",
			j+1,(d->Rule[i].lan_port_enabled[1])?"checked":"", 
			j+2,(d->Rule[i].lan_port_enabled[2])?"checked":"",
			j+3,(d->Rule[i].lan_port_enabled[3])?"checked":"",
#ifdef _RALINK_WIRELESS_DRIVER_	
			j+4,wireless_present?((d->Rule[i].lan_port_enabled[4])?"checked":""):"",wireless_present?"":"disabled"); 
#else
			j+4);
#endif
			
		websWrite(wp, T(vlan_TableFmt2[locale_config.locale]),
			((d->Rule[i].WAN_connection_index==0)?"selected":""),
			((d->Rule[i].WAN_connection_index==1)?"selected":""));
		jj=other_wan_bridge_no();
		if(jj)
		{
			for(kk=0;kk<jj;kk++)
			{	
				int vpi,vci;
				get_other_wan_br_PVC_data(kk,&vpi,&vci);
				websWrite(wp, T("<OPTION value=\"%d\" %s>WAN Bridge Connection #%d(%d/%d)</option>\n"),
				kk+3,
				((d->Rule[i].WAN_connection_index==(kk+2))?"selected":""),// start from 2 because 0: no, 1: main wan
				kk+1,vpi,vci);
			}
		}
		//websWrite(wp, T(vlan_TableFmt3),(d->Rule[i].WAN_TAGGING_enable)?"checked":"");	
		websWrite(wp, T(vlan_TableFmt3),
			  i+1,
			  (d->Rule[i].WAN_TAGGING_enable)?"checked":"",
			  (d->Rule[i].WAN_connection_index<2)?(d->Rule[i].WAN_connection_index==1&&MainWanTagEnabled?"":"disabled"):"");
	}
	websWrite(wp, T(vlan_TableFmt4[locale_config.locale]),
		  d->VLAN_TAGGING_enable[0] ? "checked" : "",
		  d->VLAN_TAGGING_enable[1] ? "checked" : "",
		  d->VLAN_TAGGING_enable[2] ? "checked" : "",
		  d->VLAN_TAGGING_enable[3] ? "checked" : "",
		  "");
	return 0;
}

/*
static int get_vlan_mgnmt (int ejid, webs_t wp, int argc, char_t **argv)
{
	int i;
	Load_Vlan_Config(&vlan_config);		
	i=atoi(argv[0]);

	if (i==vlan_config.management_vlan_group)
		return websWrite(wp, T("selected"));
	else
	        return websWrite(wp, T(""));
}
*/

static void form_vlan_config(webs_t wp,char_t * path,char_t * query)
{
	char *buf=NULL;
	int i,j;
	int vport[40];
	char line[32], wlan_if[32]; // KenWang added 2006/01/02
	int k; // KenWang added 2006/01/09
	char wan_tag[MAX_OTHER_WAN_BRIDGE+2], wan_if[32];
	OTHER_WAN_BRIDGE_DATA wanbr;
	Load_Other_Wan_Bridge_Config(&wanbr);
	VLAN_CONFIG_DATA *d=&vlan_config;
	Load_Vlan_Config(d);		
	for(i=0; i<MAX_RULE; i++) {
		if(isActiveVlanGroup(d, i))
			vlan_unlink_wanbr(d, i);
	}
	// Dirty but simple, or we can have large code to search the string???
	buf=websGetVar(wp, T("vg_name"), "");
	DPRINTF("vg_name => %s\n", buf);
     	sscanf(buf,"%s %s %s %s	%s %s %s %s\n",
 	d->Rule[0].Name,
	d->Rule[1].Name,
	d->Rule[2].Name,
	d->Rule[3].Name,
	d->Rule[4].Name,
	d->Rule[5].Name,
	d->Rule[6].Name,
	d->Rule[7].Name);
	for(i=0; i<8; i++)
	{
		if(!strcmp(d->Rule[i].Name, "(null)"))
			sprintf(d->Rule[i].Name, "&");
	}
	
	buf=websGetVar(wp, T("Vlan_id"), "");
  	DPRINTF("Vlan_id => %s\n", buf);
   	sscanf(buf,"%d %d %d %d	%d %d %d %d\n",
	&d->Rule[0].VLAN_ID,
	&d->Rule[1].VLAN_ID,
	&d->Rule[2].VLAN_ID,
	&d->Rule[3].VLAN_ID,
	&d->Rule[4].VLAN_ID,
	&d->Rule[5].VLAN_ID,
	&d->Rule[6].VLAN_ID,
	&d->Rule[7].VLAN_ID);
	
	buf=websGetVar(wp, T("lan_tag_s"), "0 0 0 0 0 0 0 0");
  	DPRINTF("lan_tag => %s\n", buf);
	/*
     	sscanf(buf,"%d %d %d %d	%d %d %d %d\n",
	&d->Rule[0].LAN_TAGGING_enable,
	&d->Rule[1].LAN_TAGGING_enable,
	&d->Rule[2].LAN_TAGGING_enable,
	&d->Rule[3].LAN_TAGGING_enable,
	&d->Rule[4].LAN_TAGGING_enable,
	&d->Rule[5].LAN_TAGGING_enable,
	&d->Rule[6].LAN_TAGGING_enable,
	&d->Rule[7].LAN_TAGGING_enable);
	*/
     	sscanf(buf,"%d %d %d %d	%d\n",
	&d->VLAN_TAGGING_enable[0],
	&d->VLAN_TAGGING_enable[1],
	&d->VLAN_TAGGING_enable[2],
	&d->VLAN_TAGGING_enable[3],
	&d->VLAN_TAGGING_enable[4]);
	buf=websGetVar(wp, T("lan_port_s"), "");
  	DPRINTF("lan_port => %s\n", buf);
	
       	sscanf(buf,
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d "
	"%d %d %d %d %d\n",
	&vport[0],&vport[1],&vport[2],&vport[3],&vport[4],
	&vport[5],&vport[6],&vport[7],&vport[8],&vport[9],
	&vport[10],&vport[11],&vport[12],&vport[13],&vport[14],
	&vport[15],&vport[16],&vport[17],&vport[18],&vport[19],
	&vport[20],&vport[21],&vport[22],&vport[23],&vport[24],
	&vport[25],&vport[26],&vport[27],&vport[28],&vport[29],
	&vport[30],&vport[31],&vport[32],&vport[33],&vport[34],
	&vport[35],&vport[36],&vport[37],&vport[38],&vport[39]);
	
	for(i=0;i<MAX_RULE;i++)
	{
		for(j=0;j<MAX_ETH_LAN_PORT;j++)
		{
			if(vport[i*MAX_ETH_LAN_PORT+j]>0)
				d->Rule[i].lan_port_enabled[j]=1;
			else
				d->Rule[i].lan_port_enabled[j]=0;
		}
	}
	/*
	DPRINTF("vlan_config.port_mask1:%s\n",vlan_config.port_mask1);
	DPRINTF("vlan_config.port_mask2:%s\n",vlan_config.port_mask2);
	DPRINTF("vlan_config.port_mask3:%s\n",vlan_config.port_mask3);
	DPRINTF("vlan_config.port_mask4:%s\n",vlan_config.port_mask4);
	*/
 	buf=websGetVar(wp, T("wan_conn"), "0 0 0 0 0 0 0 0");
    	DPRINTF("wan_conn => %s\n", buf);
   	sscanf(buf,"%d %d %d %d	%d %d %d %d\n",
	&d->Rule[0].WAN_connection_index,
	&d->Rule[1].WAN_connection_index,
	&d->Rule[2].WAN_connection_index,
	&d->Rule[3].WAN_connection_index,
	&d->Rule[4].WAN_connection_index,
	&d->Rule[5].WAN_connection_index,
	&d->Rule[6].WAN_connection_index,
	&d->Rule[7].WAN_connection_index);
	for(i=0;i<MAX_RULE;i++)
		d->Rule[i].WAN_connection_index-=1;// start from 1 for the selected index But WAN_connection_index  is from 0, since
	// Wan Connection Index is starting from 1(for Main WAN connection ), so 0 is for no wan connection index.
	buf=websGetVar(wp, T("wan_tag_s"), "0 0 0 0 0 0 0 0");
   	DPRINTF("wan_tag => %s\n", buf);
     	sscanf(buf,"%d %d %d %d	%d %d %d %d\n",
	&d->Rule[0].WAN_TAGGING_enable,
	&d->Rule[1].WAN_TAGGING_enable,
	&d->Rule[2].WAN_TAGGING_enable,
	&d->Rule[3].WAN_TAGGING_enable,
	&d->Rule[4].WAN_TAGGING_enable,
	&d->Rule[5].WAN_TAGGING_enable,
	&d->Rule[6].WAN_TAGGING_enable,
	&d->Rule[7].WAN_TAGGING_enable);

	/* KenWang added 2006/01/02 -- begin -- */
	sprintf(line, "%d", FUNCTION_NUM_VLAN);
	run_task("runFunc", "runFunc", "stop", line, NULL);
	read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if);
	/* if wlan_if is a vlan if, get the real wlan_if name */
#if 0 /* WLAN_TAG is not ready yet */
	if(strchr(wlan_if, '.') != NULL) {
		sscanf(wlan_if, "%10[^.].%d", line, &j);
		strcpy(wlan_if, line);
		save_globe_config(VAR_SYS_STATUS_FILE, "WLAN_IF=", wlan_if);
	}
#endif
	Save_Vlan_Config(d);
	run_task("runFunc", "runFunc", "start", line, NULL);
	j = k = 0;
	memset(wan_tag, 0, sizeof(wan_tag)); // KenWang added 2006/03/24 for WAN tagging
	for(i=0; i<MAX_RULE; i++) {
		if(isActiveVlanGroup(d, i)) {
			if(d->Rule[i].lan_port_enabled[0] ||
			   d->Rule[i].lan_port_enabled[1] ||
			   d->Rule[i].lan_port_enabled[2] ||
			   d->Rule[i].lan_port_enabled[3]) {
				if(j == 0) {
					run_task("brctl", "brctl", "delif", "br0", "eth0", NULL);
					j = 1;
				}
			}
			if(d->Rule[i].WAN_TAGGING_enable && d->Rule[i].WAN_connection_index>0) {
				if(wan_tag[d->Rule[i].WAN_connection_index] == 0) {
					/* connection to main WAN or Same PVC as main WAN */
					if((d->Rule[i].WAN_connection_index >= 2 &&
					   wanbr.usingSamePVCFromExistingWanConnection[d->Rule[i].WAN_connection_index-2]==1) ||
					   d->Rule[i].WAN_connection_index == 1) {
						read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", line);
						sprintf(wan_if, "nas0");
					}
					else {
						sprintf(line, "br%d", d->Rule[i].WAN_connection_index);
						sprintf(wan_if, "nas%d", d->Rule[i].WAN_connection_index);
					}
					run_task("brctl", "brctl", "delif", line, wan_if, NULL);
					wan_tag[d->Rule[i].WAN_connection_index] = 1;
				}
			}
			if(d->Rule[i].lan_port_enabled[4]) {
#if 0 /* WLAN_TAG is not ready yet */
				sprintf(line, "%s.%d", wlan_if, d->Rule[i].VLAN_ID);
				save_globe_config(VAR_SYS_STATUS_FILE, "WLAN_IF=", line);
#endif
				if(k == 0) {
					run_task("brctl", "brctl", "delif", "br0", wlan_if, NULL);
					k = 1;
			}
		}
			vlan_link_wanbr(d, i);
	}
	}
	if(j == 0) {
		run_task("brctl", "brctl", "addif", "br0", "eth0", NULL);
		if(k == 0)
			run_task("brctl", "brctl", "addif", "br0", wlan_if, NULL);
	}
	for(i=1; i<wanbr.wan_bridge_no+2; i++) {
		if(wan_tag[i] == 0) {
			if(i==1) {
				read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", line);
				sprintf(wan_if, "nas0");
			}
			else {
				sprintf(line, "br%d", i);
				sprintf(wan_if, "nas%d", i);
			}
			run_task("brctl", "brctl", "addif", line, wan_if, NULL);
		}
	}

///	vlan_stop();

		
	websHeader(wp);
	websWrite(wp,T("<script language=\"JavaScript\">location.replace(\"/vlan_port.asp\");</script>"));
	websFooter(wp);
	websDone(wp, 200);
}

static int get_MainWanTagEnabled(int eid, webs_t wp, int argc, char_t **argv)
{
	char wan_if[32];

	read_file_para_value(VAR_SYS_STATUS_FILE, "WAN_IF=", wan_if);
	if(strncmp(wan_if, "br", 2) == 0)
		websWrite(wp, T("1"));
	else
		websWrite(wp, T("0"));

	return 0;
}

static int get_SamePVCAsMainWanIndex(int eid, webs_t wp, int argc, char_t **argv)
{
	int i;
	char index_array[32];
	char str_tmp[5];
	OTHER_WAN_BRIDGE_DATA wanbr;

	Load_Other_Wan_Bridge_Config(&wanbr);
	memset(index_array, 0, sizeof(index_array));

	for(i=0; i<MAX_OTHER_WAN_BRIDGE; i++) {
		if(wanbr.usingSamePVCFromExistingWanConnection[i] == 1) {
			sprintf(str_tmp, "%d ", i+2);
			strcat(index_array, str_tmp);
		}
	}
	websWrite(wp, T(index_array));

	return 0;
}

void DefineWebFunctions_vlan () {
	//websAspDefine(T("get_vlan_mgnmt"), get_vlan_mgnmt);
	websAspDefine(T("VLAN_Table"), VLAN_Table);
	websFormDefine(T("vlan"), form_vlan_config);
	websAspDefine(T("get_MainWanTagEnabled"), get_MainWanTagEnabled);
	websAspDefine(T("get_SamePVCAsMainWanIndex"), get_SamePVCAsMainWanIndex);
}
