/*
 * wan.htm: WAN status
 */
#include "webs.h"
#include "lan_conf.h"
#include "wan.h"
#include "dns_conf.h"
#include "../iptables-1.2.11/runFunc.h"
#include "vlan.h" // KenWang added 2006/01/04
#include "wan_vod.h"
extern void Load_Lan_Config(LAN_CONFIG_DATA *d); // KenWang moved from wan.h 2005/12/01
extern int reboot_flag;
extern LAN_CONFIG_DATA lan_config;
static int initial_quick_wan_type=0;
static int read_connect_disabled_js (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_mod (int ejid, webs_t wp, int argc, char_t **argv);
static int get_wan_status (int ejid, webs_t wp, int argc, char_t **argv);

static int reload_wan_config (int ejid, webs_t wp, int argc, char_t **argv);
static void form_1483routed_edit_conf(webs_t wp, char_t * path,char_t * query);
static void form_1483bridge_edit_conf(webs_t wp, char_t * path,char_t * query);
static void form_pppoa_edit_conf(webs_t wp, char_t * path,char_t * query);
static void form_ipoa_edit_conf(webs_t wp, char_t * path,char_t * query);
static void form_pppoe_edit_conf(webs_t wp, char_t * path,char_t * query);

static void form_1483routed_delete_conf(webs_t wp, char_t * path,char_t * query);
static void form_1483bridge_delete_conf(webs_t wp, char_t * path,char_t * query);
static void form_pppoa_delete_conf(webs_t wp, char_t * path,char_t * query);
static void form_ipoa_delete_conf(webs_t wp, char_t * path,char_t * query);
static void form_pppoe_delete_conf(webs_t wp, char_t * path,char_t * query);

void Run1483Routed(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick);
void Run1483Bridged(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick);
void RunPPPoE(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick);
void RunPPPoA(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick);
static void resetCurrentWanCfg(void);
void Load_Wan_Config (void);
void Save_Wan_Config (int i,WAN_CONFIG_DATA *d);
void set_no_connection();
void set_connect_status(int Connect_v);
void write_ripd_config(LAN_CONFIG_DATA *d1,WAN_CONFIG_DATA *d);

void Check_Wan_Config (void);
//void Write_Wan_Script_File (WAN_CONFIG_DATA *d);
extern int read_status(void);
extern void flash_write();
extern int IsExistProcess(char *ProcessName);

extern long* find_pid_by_name1( char* pidName);
extern char WAN_IF[];
//void DnsInstall();
void runStopRip();
void runStartRip();
void runStopFirewall();
void runStartFirewall();
void runStopPppoecd();
void runStartPppoecd();
void runStopBr2684ctl();
void runStartBr2684ctl(int Vpi,int Vci,int Enc);
void runStopRt2684d();
void runStartRt2684d(int Vpi,int Vci,int Enc);
void runStopFixed();
void runStartFixed();
void runStopDhcpc();
void runStartDhcpc();
void runStopPureBridge();
void runStartPureBridge(int Vpi,int Vci,int Enc);
WAN_CONFIG_DATA wan_config;
WAN_CONFIG_DATA old_wan_config;

void runStopPPPoELogin(void)
{
	FILE *fp;
	//Aki add for pppoE login page.   Once user have used the WEB GUI to add the user name and password, then we will
	// stop the PPPoE proxy .
	//check if 
	
	if((fp = fopen("/tmp/pppoe_login_on", "r")))
	{ // yes, pppoE proxy started
		fclose(fp);
#define PPPOE_PROXY_REDIRECT_STOP "/etc/scripts/pppoe_proxy_stop.sh"
#define FAKED_DNS_PROXY_STOP "/etc/scripts/faked_dns_proxy_stop.sh"
		run_script(PPPOE_PROXY_REDIRECT_STOP,0,0,0);
		run_script(FAKED_DNS_PROXY_STOP,0,0,0);
		//remove the /tmp/pppoe_login_on
		unlink("/tmp/pppoe_login_on");
	}			
}
void runStopRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","stop",0,0);
}

void runStartRip(){
	char funcNum[4];
	sprintf(funcNum,"%d",FUNCTION_NUM_RIP);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
//	run_script("/etc/scripts/rip.sh","start",0,0);
}

void runStopFirewall(){
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	
	//run_script("/etc/scripts/fw.sh","stop",0,0);
}

void runStartFirewall(){
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start","firewall",NULL);
	
	//run_script("/etc/scripts/fw.sh","start",0,0);
}

void runStopFixed(){
	unlink("/etc/resolv.conf");
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/fixed.sh","stop",0,0);
}
void runStartFixed(){
	
//	FILE *f;
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	/*
  	if ((f = fopen("/tmp/ppp/wan_status", "w"))!=NULL){
		fprintf(f,"WAN_IP=\"%s\"\n",Ip);
		fprintf(f,"WAN_MASK=\"%s\"\n",Netmask);
		fprintf(f,"GATEWAY=\"%s\"\n",Gateway);
		fclose(f);
	}
	*/
	run_script("/etc/scripts/fixed.sh","start",0,0);
	//DnsInstall();
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTED);
}


void runStopDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/dhcpc.sh","stop",0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
}
void runStartDhcpc(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	run_script("/etc/scripts/dhcpc.sh","start",0,0);
}

void runStopRt2684d(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	DPRINTF("rt2684d stop\n");
	run_script("/etc/scripts/rt2684d_stop.sh",0,0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
}
void runStartRt2684d(int Vpi,int Vci,int Enc){
	//FILE *f;
	char_t str_vpi[10];
	char_t str_vci[10];
	char_t str_enc[2];
	sprintf(str_vpi,"%d",Vpi);
	sprintf(str_vci,"%d",Vci);
	sprintf(str_enc,"%d",Enc);
	/*
  	if ((f = fopen("/tmp/ppp/wan_status", "w"))!=NULL){
		fprintf(f,"WAN_IP=\"%s\"\n",Ip);
		fprintf(f,"WAN_MASK=\"%s\"\n",Netmask);
		fprintf(f,"GATEWAY=\"%s\"\n",Gateway);
		fclose(f);
	}
	*/
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	DPRINTF("1.rt2684d start\n");
	run_script("/etc/scripts/rt2684d_start.sh",str_enc,str_vpi,str_vci);
	DPRINTF("2.rt2684d start\n");
	//DnsInstall();
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTED);
}
void runStopPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	run_script("/etc/scripts/pppoa.sh","stop",0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

void runStartPppoa(){
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	run_script("/etc/scripts/pppoa.sh","start",0,0);
}

void runStopPppoecd(){
	long *pppoepid;
	char str_pppoepid[10];
	run_task("brctl", "brctl", "delif", "brwan", "nas0", NULL); 
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTING);
	pppoepid=find_pid_by_name1("pppoecd");
	sprintf(str_pppoepid,"%lu",*pppoepid);
	run_task("/usr/sbin/dmt","setpppoe","0");
	run_task("/usr/sbin/dmt","setpid", "0");
	run_task("kill","kill","-15",str_pppoepid,NULL);
	sleep(3);
	run_task("kill","kill","-9",str_pppoepid,NULL);	
	run_task("route","route","del","default","gw","0.0.0.0",NULL);	
	run_task("brctl","brctl","delif","br0","nas0",NULL);	
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
	write_value_to_file("/proc/GPIOUSER/pppled", DISCONNECTED);
}

void runStartPppoecd(){
	char funcNum[4];
	long *pppoepid;
	char str_pppoepid[10];
	write_value_to_file("/tmp/ppp/wan_connect_status", CONNECTING);
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");

	//prevent pppoe run twice on demand mode 20050518
	/*
	Load_Wan_Config();
	if(wan_config.PPPOE_Connection==1)
		runStopPppoecd();
	*/
	// auth fail cause pppoe exist, so if pppoe task exist ,kill it. Julian 20050608
	if (IsExistProcess("pppoecd")){
		runStopPppoecd();
	}
	

	sprintf(funcNum,"%d",FUNCTION_NUM_PPPOE);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	//run_script("/etc/scripts/pppoe.sh","start",0,0);
	pppoepid=find_pid_by_name1("pppoecd");
	sprintf(str_pppoepid,"%lu",*pppoepid);
	run_task("/usr/sbin/dmt","setpppoe","1");
	run_task("/usr/sbin/dmt","setpid", str_pppoepid);
}
void runStopBr2684ctl(){
	long *pid;
	char str_pid[10];
	pid=find_pid_by_name1("br2684ctl");
	sprintf(str_pid,"%lu",*pid);
	run_task("kill","kill","-15",str_pid,NULL);	
	sleep(1);
	run_task("br2684ctl","br2684ctl","-d","0",NULL);	
//	run_script("/etc/scripts/br2684ctl_stop.sh",0,0,0);
}
void runStartBr2684ctl(int Vpi,int Vci,int Enc){
	char_t str_vpi[10];
	char_t str_vci[10];
	char_t str_enc[2];
	sprintf(str_vpi,"%d",Vpi);
	sprintf(str_vci,"%d",Vci);
	sprintf(str_enc,"%d",Enc);
	run_script("/etc/scripts/br2684ctl_start.sh",str_vpi,str_vci,str_enc);
}
void runStopPureBridge(){
	run_script("/etc/scripts/purebridged_stop.sh",0,0,0);
	write_value_to_file("/tmp/ppp/wan_connect_status", DISCONNECTED);
}

/* KenWang added 2006/01/04 -- begin -- */
extern int isActiveVlanGroup(VLAN_CONFIG_DATA *d, int vlan_index);
extern int Load_Vlan_Config (VLAN_CONFIG_DATA *d);
extern void vlan_link_wanbr(VLAN_CONFIG_DATA *d, int vlan_index);
/* KenWang added 2006/01/04 -- end -- */

void runStartPureBridge(int Vpi,int Vci,int Enc){
	char_t str_vpi[10];
	char_t str_vci[10];
	char_t str_enc[2];
	/* KenWang added 2006/01/04 -- begin -- */
	VLAN_CONFIG_DATA d;
	OTHER_WAN_BRIDGE_DATA wanbr;
	int i, j, k;
	char line[32];
	/* KenWang added 2006/01/04 -- end -- */

	sprintf(str_vpi,"%d",Vpi);
	sprintf(str_vci,"%d",Vci);
	sprintf(str_enc,"%d",Enc);
	run_script("/etc/scripts/purebridged_start.sh",str_vpi,str_vci,str_enc);
	/* KenWang added 2006/01/04 -- begin -- */
	Load_Vlan_Config(&d);
	Load_Other_Wan_Bridge_Config(&wanbr);
	j = k = 0;
	for(i=0; i<MAX_RULE; i++) {
		if(isActiveVlanGroup(&d, i)) {
			if(d.Rule[i].WAN_connection_index==1 || 
			   (d.Rule[i].WAN_connection_index>=2 &&
			    wanbr.usingSamePVCFromExistingWanConnection[d.Rule[i].WAN_connection_index-2]==1)) {
				if(d.Rule[i].lan_port_enabled[0] ||
				   d.Rule[i].lan_port_enabled[1] ||
				   d.Rule[i].lan_port_enabled[2] ||
				   d.Rule[i].lan_port_enabled[3]) {
					if(j == 0) {
						run_task("brctl", "brctl", "delif", "br0", "eth0", NULL);
						j = 1;
					}
				}
				if(d.Rule[i].WAN_TAGGING_enable) {
					sprintf(line, "%d", d.Rule[i].VLAN_ID);
					run_task("vconfig", "vconfig", "add", "nas0", line, NULL);
					run_task("brctl", "brctl", "delif", "br0", "nas0", NULL);
				}
				if(d.Rule[i].lan_port_enabled[4]) {
#if 0 /* WLAN_TAG is not ready yet */
					sprintf(line, "%s.%d", wlan_if, d->Rule[i].VLAN_ID);
					save_globe_config(VAR_SYS_STATUS_FILE, "WLAN_IF=", line);
#endif
					read_file_para_value(VAR_SYS_STATUS_FILE, "WLAN_IF=", line);
					if(k == 0) {
						run_task("brctl", "brctl", "delif", "br0", line, NULL);
						k = 1;
					}
				}
				vlan_link_wanbr(&d, i);
			}
		}
	}
	/* KenWang added 2006/01/04 -- end -- */
}
/*
void DnsInstall(){
	FILE *f;
	int is_autodns=1;
	char_t line[2];
  	if ((f = fopen("/flash/dns.conf", "r"))!=NULL){
		if (fgets(line,2,f))
			is_autodns=atoi(line);
		fclose(f);
	}
	if(is_autodns==0)
		CopyFile("/flash/resolv.conf","/etc/resolv.conf");
}
*/

extern char* read_file_para_value(char *filename, char *arg1,char *buf);
static int reload_wan_config (int ejid, webs_t wp, int argc, char_t **argv){
	 Load_Wan_Config();
	 return 1;
}
static int read_connect_disabled_js (int ejid, webs_t wp, int argc, char_t **argv){
	char_t str_wan[10];
	char_t buf[64];
	char_t TableFmt[128];
	strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf));
	if (!strcmp(str_wan,"dynamic")){
		strcpy(TableFmt,"document.home.connect[0].disabled=true; document.home.connect[1].disabled=true;");
	}
	else if (!strcmp(str_wan,"pppoe")){
		strcpy (TableFmt,"document.home.connect.disabled=true;");
	}
	else if (!strcmp(str_wan,"pppoa")){
		strcpy (TableFmt,"document.home.connect.disabled=true;");
	}
	else 
		strcpy (TableFmt,"");
	return websWrite(wp,T("%s"),TableFmt);
}
	
void set_connect_status(int Connect_v){
	FILE *fp;
	if((fp=fopen(WAN_CONNECT_STATUS_FILE,"w"))!=NULL){
		fprintf(fp,"%d",Connect_v);
		fclose(fp);
	}
}

void PFRip(FILE *fp,int KindOfRIP);
void PFRip(FILE *fp,int KindOfRIP){
	if (KindOfRIP==1){
		fprintf(fp,"ip rip receive version 1\n");
		fprintf(fp,"ip rip send version 1\n");
		fprintf(fp,"no multicast\n");
	}
	else if (KindOfRIP==2){
		fprintf(fp,"ip rip receive version 2\n");
		fprintf(fp,"ip rip send version 2\n");
		fprintf(fp,"no multicast\n");
	}
	else if (KindOfRIP==3){
		fprintf(fp,"ip rip receive version 2\n");
		fprintf(fp,"ip rip send version 2\n");
	}
	else if (KindOfRIP==4){
		fprintf(fp,"ip rip receive version 1 2\n");
		fprintf(fp,"ip rip send version 1 2\n");
		fprintf(fp,"no multicast\n");
	}
	else
		return;
	
}

extern int mainWanHasOtherWanBridgeUseTheSamePVC(void);
void write_ripd_config(LAN_CONFIG_DATA *d1,WAN_CONFIG_DATA *d)
{
	FILE *fp;
	char_t str_wan[10];
	char_t str_lan[10];
	char_t buf[64];
//	int is_true=0;
	int rip;

//	Load_Lan_Config();
	
//	Load_Wan_Config();
//	strcpy(str_wan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf));
	if (d->Quick_Wan_Type==0) /* No wan */
		strcpy(str_wan,"");
	else if (d->Quick_Wan_Type==1) /* PPPOA*/
	{
		if(mainWanHasOtherWanBridgeUseTheSamePVC())
			strcpy(str_wan,"brwan");
		else
			strcpy(str_wan,"ppp0");
	}
	else if (d->Quick_Wan_Type==2) /* PPPOE */
	{
		if(mainWanHasOtherWanBridgeUseTheSamePVC())
			strcpy(str_wan,"brwan");
		else
			strcpy(str_wan,"ppp0");
	}
	else if (d->Quick_Wan_Type==3 || d->Quick_Wan_Type==4 || d->Quick_Wan_Type==5 ) /* 1483 Routed */
	{
		if(mainWanHasOtherWanBridgeUseTheSamePVC())
			strcpy(str_wan,"brwan");
		else
			strcpy(str_wan,"atm0");
	}
	else if (d->Quick_Wan_Type==6) /* Classical IP (1577) */
	{
		if(mainWanHasOtherWanBridgeUseTheSamePVC())
			strcpy(str_wan,"brwan");
		else
			strcpy(str_wan,"atm0");
	}
	else if (d->Quick_Wan_Type==7 || d->Quick_Wan_Type==8) /* 1483 Bridged IP VC-Mux or LLC */
	{
		if(mainWanHasOtherWanBridgeUseTheSamePVC())
			strcpy(str_wan,"brwan");
		else
			strcpy(str_wan,"nas0");
	}
	else if (d->Quick_Wan_Type==9 || d->Quick_Wan_Type==10) /* Pure Bridged VC-Mux or Pure Bridged LLC*/
		strcpy(str_wan,"");
	else
		strcpy(str_wan,"");

	strcpy(str_lan,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf));
//	DPRINTF("ripd:%d\n",((!strcmp(d1->RIP,"0")) && (((d->Wan_Type==0) || (d->Wan_Type==2) || (d->Wan_Type==1 && d->Routed_RIP==0) || (d->Wan_Type==3 && d->PPPOA_RIP==0) || (d->Wan_Type==4 && d->IPOA_RIP==0) || (d->Wan_Type==5 && d->PPPOE_RIP==0)))));
	
//	DPRINTF("lan:%d\n",(!strcmp(d1->RIP,"0")));
//	DPRINTF("wan:%d\n",((((d->Wan_Type==0) || (d->Wan_Type==2) || (d->Wan_Type==1 && d->Routed_RIP==0) || (d->Wan_Type==3 && d->PPPOA_RIP==0) || (d->Wan_Type==4 && d->IPOA_RIP==0) || (d->Wan_Type==5 && d->PPPOE_RIP==0)))));
	if ((!strcmp(d1->RIP,"0")) && ((
			(d->Wan_Type==0) || (d->Wan_Type==2) || 
			(d->Wan_Type==1 && d->Routed_RIP==0) ||
			(d->Wan_Type==3 && d->PPPOA_RIP==0) ||
			(d->Wan_Type==4 && d->IPOA_RIP==0) ||
			(d->Wan_Type==5 && d->PPPOE_RIP==0))))
		rip=0; /* no ripd */
	else if (((((d->Wan_Type==0) || (d->Wan_Type==2) || (d->Wan_Type==1 && d->Routed_RIP==0) || (d->Wan_Type==3 && d->PPPOA_RIP==0) || (d->Wan_Type==4 && d->IPOA_RIP==0) || (d->Wan_Type==5 && d->PPPOE_RIP==0)))) && (strcmp(d1->RIP,"0")))
		rip=1; /* only lan */
	else if (!((((d->Wan_Type==0) || (d->Wan_Type==2) || (d->Wan_Type==1 && d->Routed_RIP==0) || (d->Wan_Type==3 && d->PPPOA_RIP==0) || (d->Wan_Type==4 && d->IPOA_RIP==0) || (d->Wan_Type==5 && d->PPPOE_RIP==0)))) && (!strcmp(d1->RIP,"0")))
		rip=2; /* only wan */
	else
		rip=3; /* both */
	//DPRINTF("rip:%d\n",rip);
	
	if((fp=fopen(RIP_CONFIG_FILE,"w"))==NULL)
		return;
	
	fprintf(fp,"!%d\n",rip);
	if (!((!strcmp(d1->RIP,"0")) && ((
			(d->Wan_Type==0) || (d->Wan_Type==2) || 
			(d->Wan_Type==1 && d->Routed_RIP==0) ||
			(d->Wan_Type==3 && d->PPPOA_RIP==0) ||
			(d->Wan_Type==4 && d->IPOA_RIP==0) ||
			(d->Wan_Type==5 && d->PPPOE_RIP==0)))))
	{		
		fprintf(fp,"router rip\n");
		fprintf(fp,"redistribute connected\n");
	//	fprintf(fp,"redistribute kernel\n");
		if (strcmp(d1->RIP,"0"))
			fprintf(fp,"network %s\n",str_lan);
		if (!(((d->Wan_Type==0) || (d->Wan_Type==2) || (d->Wan_Type==1 && d->Routed_RIP==0) || (d->Wan_Type==3 && d->PPPOA_RIP==0) || (d->Wan_Type==4 && d->IPOA_RIP==0) || (d->Wan_Type==5 && d->PPPOE_RIP==0))))
			fprintf(fp,"network %s\n",str_wan);
		if (!(d->Wan_Type==0 || d->Wan_Type==2)) 
		{
			if (d->Wan_Type==1){
				if (d->Routed_RIP!=0){
					fprintf(fp,"interface %s\n",str_wan);
					if (d->Routed_RIP==1)
						PFRip(fp,1);
					else if (d->Routed_RIP==2)
						PFRip(fp,2);
					else if (d->Routed_RIP==3)
						PFRip(fp,3);
					else if (d->Routed_RIP==4)
						PFRip(fp,4);
				}
			}
			else if (d->Wan_Type==3){
				if (d->PPPOA_RIP!=0){
					fprintf(fp,"interface %s\n",str_wan);
					if (d->PPPOA_RIP==1)
						PFRip(fp,1);
					else if (d->PPPOA_RIP==2)
						PFRip(fp,2);
					else if (d->PPPOA_RIP==3)
						PFRip(fp,3);
					else if (d->PPPOA_RIP==4)
						PFRip(fp,4);
				}
			}
			else if (d->Wan_Type==4){
				if (d->IPOA_RIP!=0){
					fprintf(fp,"interface %s\n",str_wan);
					if (d->IPOA_RIP==1)
						PFRip(fp,1);
					else if (d->IPOA_RIP==2)
						PFRip(fp,2);
					else if (d->IPOA_RIP==3)
						PFRip(fp,3);
					else if (d->IPOA_RIP==4)
						PFRip(fp,4);
				}
			}
			else{
				if (d->PPPOE_RIP!=0){
					fprintf(fp,"interface %s\n",str_wan);
					if (d->PPPOE_RIP==1)
						PFRip(fp,1);
					else if (d->PPPOE_RIP==2)
						PFRip(fp,2);
					else if (d->PPPOE_RIP==3)
						PFRip(fp,3);
					else if (d->PPPOE_RIP==4)
						PFRip(fp,4);
				}
			}
		}

		if (strcmp(d1->RIP,"0")){
			fprintf(fp,"interface %s\n",str_lan);
			if (!strcmp(d1->RIP,"1"))
				PFRip(fp,1);
			if (!strcmp(d1->RIP,"2"))
				PFRip(fp,2);
			if (!strcmp(d1->RIP,"3"))
				PFRip(fp,3);
			if (!strcmp(d1->RIP,"4"))
				PFRip(fp,4);
		}
		
	}
	fclose(fp);
}


void write_ripd_config_Internal(void)
{
	Load_Wan_Config();
 	Load_Lan_Config(&lan_config);
	write_ripd_config(&lan_config,&wan_config);	
}

void set_no_connection(){
	Load_Wan_Config();
	Save_Wan_Config(0,&wan_config);
	//unlink(WAN_IP_STATUS_FILE); 
	unlink(WAN_ERROR_LOG_FILE); 
	unlink(TMP_RESOLV_CONF_FILE);	
	unlink(DNS_CONFIG_FILE); 
	unlink(WAN_ROUTE_SCRIPT_FILE);	

	save_globe_config(SYS_STATUS_FILE,"WAN=","no");	
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","no");	
	
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop","firewall",NULL);
	
	//run_script("/etc/scripts/fw.sh","stop",0,0);
	
	read_status();
}

static void resetCurrentWanCfg(void){
	reboot_flag=0;
	WAN_CONFIG_DATA *d = &old_wan_config;
	WAN_CONFIG_DATA *d1 = &wan_config;
	memset(d,0,sizeof(WAN_CONFIG_DATA));
	memset(d1,0,sizeof(WAN_CONFIG_DATA));
	/*
		d->Wan_Type=0;
		d->Quick_Wan_Type=0;
				
		//1483 Routed
		strcpy(d->Routed_Description,"");
		d->Routed_VPI=0;
		d->Routed_VCI=0;
		d->Routed_ATM_Class=0;
		d->Routed_NAT=0;
        	d->Routed_Encapsulation_Method=0;
	        d->Routed_IP_Assignment=0;
		strcpy(d->Routed_IP,"");
		strcpy(d->Routed_Netmask,"");
		strcpy(d->Routed_Gateway,"");
		d->Routed_RIP=0;
		d->Routed_MTU=0;

		//1483 Bridged
	        strcpy(d->Bridged_Description,"");
        	d->Bridged_VPI=0;
	        d->Bridged_VCI=0;
	        d->Bridged_ATM_Class=0;
	        d->Bridged_Encapsulation_Method=0;
	        d->Bridged_Ether_Filter_Type=0;
	        d->Bridged_Spanning_Bridge_Interface=0;
	
		//PPPOA
	        strcpy(d->PPPOA_Description,"");
        	d->PPPOA_VPI=0;
        	d->PPPOA_VCI=0;
        	d->PPPOA_ATM_Class=0;
        	d->PPPOA_NAT=0;
        	strcpy(d->PPPOA_Username,"");
	        strcpy(d->PPPOA_Password,"");
	        strcpy(d->PPPOA_IP,"");
	        d->PPPOA_Authentication_Protocol=0;
	        d->PPPOA_Connection=0;
	        d->PPPOA_Idle_Timeout=0;
		d->PPPOA_RIP=0;
	        d->PPPOA_MTU=0;
	
		//IPOA
	        strcpy(d->IPOA_Description,"");
        	d->IPOA_VPI=0;
        	d->IPOA_VCI=0;
        	d->IPOA_ATM_Class=0;
        	d->IPOA_NAT=0;
        	d->IPOA_IP_Assignment=0;
        	strcpy(d->IPOA_IP,"");
        	strcpy(d->IPOA_Netmask,"");
        	strcpy(d->IPOA_Gateway,"");
        	d->IPOA_RIP=0;
        	d->IPOA_MTU=0;
	
		//PPPOE
	        strcpy(d->PPPOE_Description,"PPPOE");
        	d->PPPOE_VPI=0;
        	d->PPPOE_VCI=0;
        	d->PPPOE_ATM_Class=0;
        	d->PPPOE_NAT=0;
        	strcpy(d->PPPOE_Username,"");
	        strcpy(d->PPPOE_Password,"");
	        strcpy(d->PPPOE_Service_Name,"");
		strcpy(d->PPPOE_IP,"0.0.0.0");
	        d->PPPOE_Authentication_Protocol=0;
	        d->PPPOE_Connection=0;
	        d->PPPOE_Idle_Timeout=0;
		d->PPPOE_RIP=0;
	        d->PPPOE_MTU=0;
	*/	
}

void Load_Wan_Config (void){
	FILE *fp;
	char_t line[1024];
	resetCurrentWanCfg();
	
	if ((fp=fopen(WAN_CONFIG_FILE,"r"))!=NULL)
	{
	if (fgets(line, 1024, fp))
		sscanf(line,"#:%d:%d\n",(int *)&wan_config.Wan_Type,(int *)&wan_config.Quick_Wan_Type);
		
	//1483 Routed
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",
		wan_config.Routed_Description,
		&wan_config.Routed_VPI,
		&wan_config.Routed_VCI,
		(int *)&wan_config.Routed_ATM_Class,
		(int *)&wan_config.Routed_NAT,
        	(int *)&wan_config.Routed_Encapsulation_Method,
	        (int *)&wan_config.Routed_IP_Assignment,
		wan_config.Routed_IP,
		wan_config.Routed_Netmask,
		wan_config.Routed_Gateway,
		(int *)&wan_config.Routed_RIP,
		&wan_config.Routed_MTU
		);
	}
	print_blank_string(&wan_config.Routed_Description);
	print_blank_string(&wan_config.Routed_IP);
	print_blank_string(&wan_config.Routed_Netmask);
	print_blank_string(&wan_config.Routed_Gateway);
	
	//1483 Bridged
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%d|\n",
		wan_config.Bridged_Description,
		&wan_config.Bridged_VPI,
		&wan_config.Bridged_VCI,
		(int *)&wan_config.Bridged_ATM_Class,
		(int *)&wan_config.Bridged_Encapsulation_Method,
        	(int *)&wan_config.Bridged_Ether_Filter_Type,
	        (int *)&wan_config.Bridged_Spanning_Bridge_Interface
		);
	}
	
	print_blank_string(&wan_config.Bridged_Description);	
	//PPPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%20[^|]|%d|%d|%hu|%d|%hu|\n",
		wan_config.PPPOA_Description,
		&wan_config.PPPOA_VPI,
		&wan_config.PPPOA_VCI,
		(int *)&wan_config.PPPOA_ATM_Class,
		(int *)&wan_config.PPPOA_Encapsulation_Method,
		(int *)&wan_config.PPPOA_NAT,
		wan_config.PPPOA_Username,
		wan_config.PPPOA_Password,
		wan_config.PPPOA_IP,
	        (int *)&wan_config.PPPOA_Authentication_Protocol,
	        (int *)&wan_config.PPPOA_Connection,
	        &wan_config.PPPOA_Idle_Timeout,
		(int *)&wan_config.PPPOA_RIP,
		&wan_config.PPPOA_MTU
		);
	}
	
	print_blank_string(&wan_config.PPPOA_Description);
	print_blank_string(&wan_config.PPPOA_Username);
	print_blank_string(&wan_config.PPPOA_Password);
	print_blank_string(&wan_config.PPPOA_IP);	
	//IPOA
	if (fgets(line, 1024, fp))
	{
		sscanf(line,"|%50[^|]|%hu|%hu|%d|%d|%d|%20[^|]|%20[^|]|%20[^|]|%d|%hu|\n",wan_config.IPOA_Description,
		&wan_config.IPOA_VPI,
		&wan_config.IPOA_VCI,
		(int *)&wan_config.IPOA_ATM_Class,
		(int *)&wan_config.IPOA_NAT,
	        (int *)&wan_config.IPOA_IP_Assignment,
		wan_config.IPOA_IP,
		wan_config.IPOA_Netmask,
		wan_config.IPOA_Gateway,
		(int *)&wan_config.IPOA_RIP,
		&wan_config.IPOA_MTU
		);
	}	
	
	print_blank_string(&wan_config.IPOA_Description);
	print_blank_string(&wan_config.IPOA_IP);
	print_blank_string(&wan_config.IPOA_Netmask);
	print_blank_string(&wan_config.IPOA_Gateway);	
	//PPPOE
	if (fgets(line, 1024, fp))
	{
		sscanf(line,
		"|%50[^|]|%hu|%hu|%d|%d|%d|%256[^|]|%256[^|]|%32[^|]|%20[^|]|%d|%d|%hu|%d|%hu|%d|\n",
		wan_config.PPPOE_Description,
		&wan_config.PPPOE_VPI,
		&wan_config.PPPOE_VCI,
		(int *)&wan_config.PPPOE_ATM_Class,
		(int *)&wan_config.PPPOE_Encapsulation_Method,
		(int *)&wan_config.PPPOE_NAT,
		wan_config.PPPOE_Username,
		wan_config.PPPOE_Password,
		wan_config.PPPOE_Service_Name,
		wan_config.PPPOE_IP,
	        (int *)&wan_config.PPPOE_Authentication_Protocol,
	        (int *)&wan_config.PPPOE_Connection,
	        &wan_config.PPPOE_Idle_Timeout,
		(int *)&wan_config.PPPOE_RIP,
	       &wan_config.PPPOE_MTU,
		&wan_config.PPPOE_RELAY
		);
	}
	print_blank_string(&wan_config.PPPOE_Description);
	print_blank_string(&wan_config.PPPOE_Username);
	print_blank_string(&wan_config.PPPOE_Password);
	print_blank_string(&wan_config.PPPOE_Service_Name);
	print_blank_string(&wan_config.PPPOE_IP);
	fclose(fp);
	}
//	if (wan_config.Quick_Wan_Type==0)
//		wan_config.Quick_Wan_Type=wan_config.Wan_Type;	
}

void Save_Wan_Config (int i,WAN_CONFIG_DATA *d){
	
	FILE *fp;
	d->Wan_Type=i;
	if ((fp=fopen(WAN_CONFIG_FILE,"w"))!=NULL)
	{
	
	/*
	 *  i=0 1483 Routed
	 *  i=1 1483 Bridged
	 *  i=2 PPPOA
	 *  i=3 IPOA
	 *  i=4 PPPOE
	 */
	
	fprintf(fp, "#:%d:%d\n",d->Wan_Type,d->Quick_Wan_Type);
	//1483 Routed
	load_blank_string(&d->Routed_Description);
	load_blank_string(&d->Routed_IP);
	load_blank_string(&d->Routed_Netmask);
	load_blank_string(&d->Routed_Gateway);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->Routed_Description,
		d->Routed_VPI,
		d->Routed_VCI,
		d->Routed_ATM_Class,
		d->Routed_NAT,
        	d->Routed_Encapsulation_Method,
	        d->Routed_IP_Assignment,
		d->Routed_IP,
		d->Routed_Netmask,
		d->Routed_Gateway,
		d->Routed_RIP,
		d->Routed_MTU
		);
	
	load_blank_string(&d->Bridged_Description);	
	//1483 Bridged
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%d|\n",
		d->Bridged_Description,
		d->Bridged_VPI,
		d->Bridged_VCI,
		d->Bridged_ATM_Class,
		d->Bridged_Encapsulation_Method,
        	d->Bridged_Ether_Filter_Type,
	        d->Bridged_Spanning_Bridge_Interface
		);

	load_blank_string(&d->PPPOA_Description);
	load_blank_string(&d->PPPOA_Username);
	load_blank_string(&d->PPPOA_Password);
	load_blank_string(&d->PPPOA_IP);
	//PPPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%d|%hu|%d|%hu|\n",
		d->PPPOA_Description,
		d->PPPOA_VPI,
		d->PPPOA_VCI,
		d->PPPOA_ATM_Class,
		d->PPPOA_Encapsulation_Method,
		d->PPPOA_NAT,
		d->PPPOA_Username,
		d->PPPOA_Password,
		d->PPPOA_IP,
	        d->PPPOA_Authentication_Protocol,
	        d->PPPOA_Connection,
	        d->PPPOA_Idle_Timeout,
		d->PPPOA_RIP,
		d->PPPOA_MTU
		);
	
	load_blank_string(&d->IPOA_Description);
	load_blank_string(&d->IPOA_IP);
	load_blank_string(&d->IPOA_Netmask);
	load_blank_string(&d->IPOA_Gateway);
	//IPOA
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%d|%hu|\n",
		d->IPOA_Description,
		d->IPOA_VPI,
		d->IPOA_VCI,
		d->IPOA_ATM_Class,
		d->IPOA_NAT,
	        d->IPOA_IP_Assignment,
		d->IPOA_IP,
		d->IPOA_Netmask,
		d->IPOA_Gateway,
		d->IPOA_RIP,
		d->IPOA_MTU
		);
		
	//PPPOE
	load_blank_string(&d->PPPOE_Description);
	load_blank_string(&d->PPPOE_Username);
	load_blank_string(&d->PPPOE_Password);
	load_blank_string(&d->PPPOE_Service_Name);
	load_blank_string(&d->PPPOE_IP);
	fprintf(fp,
		"|%s|%hu|%hu|%d|%d|%d|%s|%s|%s|%s|%d|%d|%hu|%d|%hu|%d|\n",
		d->PPPOE_Description,
		d->PPPOE_VPI,
		d->PPPOE_VCI,
		d->PPPOE_ATM_Class,
		d->PPPOE_Encapsulation_Method,
		d->PPPOE_NAT,
		d->PPPOE_Username,
		d->PPPOE_Password,
		d->PPPOE_Service_Name,
		d->PPPOE_IP,
	        d->PPPOE_Authentication_Protocol,
	        d->PPPOE_Connection,
	        d->PPPOE_Idle_Timeout,
		d->PPPOE_RIP,
		d->PPPOE_MTU,
		d->PPPOE_RELAY
		);
	fclose(fp);
	}
//	d->Quick_Wan_Type=d->Wan_Type;
	save_globe_config("/flash/config","AUTOSCAN=","no");// If user edit the wan and apply, then autoSCAN PVC shall stop in next reboot.
}


static int get_wan_status (int ejid, webs_t wp, int argc, char_t **argv){
	char_t str_var_wanip[20];
	char_t str_var_wanif[10];
	char_t buf[32];
	if  (strcmp(argv[0],"HostAddress1")==0)
	{
		Load_Wan_Config();
		return websWrite(wp,T("%s"),get_ip_segment(1,wan_config.Routed_IP,buf));
	}
	if  (strcmp(argv[0],"HostAddress2")==0)
		return websWrite(wp,T("%s"),get_ip_segment(2,wan_config.Routed_IP,buf));
	if  (strcmp(argv[0],"HostAddress3")==0)
		return websWrite(wp,T("%s"),get_ip_segment(3,wan_config.Routed_IP,buf));
	if  (strcmp(argv[0],"HostAddress4")==0)
		return websWrite(wp,T("%s"),get_ip_segment(4,wan_config.Routed_IP,buf));
	if  (strcmp(argv[0],"HostNetmask1")==0)
		return websWrite(wp,T("%s"),get_ip_segment(1,wan_config.Routed_Netmask,buf));
	if  (strcmp(argv[0],"HostNetmask2")==0)
		return websWrite(wp,T("%s"),get_ip_segment(2,wan_config.Routed_Netmask,buf));
	if  (strcmp(argv[0],"HostNetmask3")==0)
		return websWrite(wp,T("%s"),get_ip_segment(3,wan_config.Routed_Netmask,buf));
	if  (strcmp(argv[0],"HostNetmask4")==0)
		return websWrite(wp,T("%s"),get_ip_segment(4,wan_config.Routed_Netmask,buf));
	if (strcmp(argv[0],"WAN_TYPE_NUM")==0)
		return websWrite(wp, T("%d"),initial_quick_wan_type);
	if (strcmp(argv[0],"WAN_TYPE")==0)
	{
	
		strcpy(str_var_wanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf));
	
		return websWrite(wp, T("%s"),str_var_wanif);
		/*
		Load_Wan_Config();
		if (wan_config.Wan_Type==0)
			return websWrite(wp, T("no"));
		else if (wan_config.Wan_Type==1)
			return websWrite(wp, T("fixed"));
		else if (wan_config.Wan_Type==5)
			return websWrite(wp, T("pppoe"));
		else
			return websWrite(wp, T(""));
		*/
			
	}
	
	if (strcmp(argv[0],"VAR_WANIP")==0){
		strcpy(str_var_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf));
		if (isValidIP(str_var_wanip))
				return websWrite(wp, T("%s"),str_var_wanip);
		else
			return websWrite(wp, T(""));
	}

	if (strcmp(argv[0],"VPI")==0)
	{
		Load_Wan_Config();
		if (wan_config.Wan_Type==0)
			return websWrite(wp, T("0"));
		else if (wan_config.Wan_Type==1)
			return websWrite(wp, T("%d"),wan_config.Routed_VPI);
		else if (wan_config.Wan_Type==2)
			return websWrite(wp, T("%d"),wan_config.Bridged_VPI);
		else if (wan_config.Wan_Type==3)
			return websWrite(wp, T("%d"),wan_config.PPPOA_VPI);
		else if (wan_config.Wan_Type==4)
			return websWrite(wp, T("%d"),wan_config.IPOA_VPI);
		else if (wan_config.Wan_Type==5)
			return websWrite(wp, T("%d"),wan_config.PPPOE_VPI);
		else
			return websWrite(wp, T("0"));
	}

		
		
	if (strcmp(argv[0],"VCI")==0)
	{
		if (wan_config.Wan_Type==0)
			return websWrite(wp, T("0"));
		else if (wan_config.Wan_Type==1)
			return websWrite(wp, T("%d"),wan_config.Routed_VCI);
		else if (wan_config.Wan_Type==2)
			return websWrite(wp, T("%d"),wan_config.Bridged_VCI);
		else if (wan_config.Wan_Type==3)
			return websWrite(wp, T("%d"),wan_config.PPPOA_VCI);
		else if (wan_config.Wan_Type==4)
			return websWrite(wp, T("%d"),wan_config.IPOA_VCI);
		else if (wan_config.Wan_Type==5)
			return websWrite(wp, T("%d"),wan_config.PPPOE_VCI);
		else
			return websWrite(wp, T("0"));
	}
	

//1483 Routed

	if (strcmp(argv[0],"Routed_Description")==0)
	{
		Load_Wan_Config();
		return websWrite(wp, T("%s"),wan_config.Routed_Description);
	}	
	if (strcmp(argv[0],"Routed_VPI")==0)
		return websWrite(wp, T("%d"),wan_config.Routed_VPI);
	if (strcmp(argv[0],"Routed_VCI")==0)
		return websWrite(wp, T("%d"),wan_config.Routed_VCI);
	if (strcmp(argv[0],"Routed_IP")==0)
		return websWrite(wp, T("%s"),wan_config.Routed_IP);
	if (strcmp(argv[0],"Routed_Netmask")==0)
		return websWrite(wp, T("%s"),wan_config.Routed_Netmask);
	if (strcmp(argv[0],"Routed_Gateway")==0)
		return websWrite(wp, T("%s"),wan_config.Routed_Gateway);
	if (strcmp(argv[0],"Routed_MTU")==0)
		return websWrite(wp, T("%d"),wan_config.Routed_MTU);
	

	
//1483 Bridged 

	if (strcmp(argv[0],"Bridged_Description")==0)
	{
		Load_Wan_Config();
		return websWrite(wp, T("%s"),wan_config.Bridged_Description);
	}	
	if (strcmp(argv[0],"Bridged_VPI")==0)
		return websWrite(wp, T("%d"),wan_config.Bridged_VPI);
	if (strcmp(argv[0],"Bridged_VCI")==0)
		return websWrite(wp, T("%d"),wan_config.Bridged_VCI);


//PPPOA
	if (strcmp(argv[0],"PPPOA_Description")==0)
	{
		Load_Wan_Config();
		return websWrite(wp, T("%s"),wan_config.PPPOA_Description);
	}	
	if (strcmp(argv[0],"PPPOA_VPI")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOA_VPI);
	if (strcmp(argv[0],"PPPOA_VCI")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOA_VCI);
	if (strcmp(argv[0],"PPPOA_Username")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOA_Username);
	if (strcmp(argv[0],"PPPOA_Password")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOA_Password);
	if (strcmp(argv[0],"PPPOA_IP")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOA_IP);
	if (strcmp(argv[0],"PPPOA_Idle_Timeout")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOA_Idle_Timeout);
	if (strcmp(argv[0],"PPPOA_MTU")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOA_MTU);
	
//IPOA

	if (strcmp(argv[0],"IPOA_Description")==0)
	{
		Load_Wan_Config();
		return websWrite(wp, T("%s"),wan_config.IPOA_Description);
	}	
	if (strcmp(argv[0],"IPOA_VPI")==0)
		return websWrite(wp, T("%d"),wan_config.IPOA_VPI);
	if (strcmp(argv[0],"IPOA_VCI")==0)
		return websWrite(wp, T("%d"),wan_config.IPOA_VCI);
	if (strcmp(argv[0],"IPOA_IP")==0)
		return websWrite(wp, T("%s"),wan_config.IPOA_IP);
	if (strcmp(argv[0],"IPOA_Netmask")==0)
		return websWrite(wp, T("%s"),wan_config.IPOA_Netmask);
	if (strcmp(argv[0],"IPOA_Gateway")==0)
		return websWrite(wp, T("%s"),wan_config.IPOA_Gateway);
	if (strcmp(argv[0],"IPOA_MTU")==0)
		return websWrite(wp, T("%d"),wan_config.IPOA_MTU);
	
//PPPOE
	if (strcmp(argv[0],"PPPOE_Description")==0)
	{
		Load_Wan_Config();
		return websWrite(wp, T("%s"),wan_config.PPPOE_Description);
	}	
	if (strcmp(argv[0],"PPPOE_VPI")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOE_VPI);
	if (strcmp(argv[0],"PPPOE_VCI")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOE_VCI);
	if (strcmp(argv[0],"PPPOE_Username")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOE_Username);
	if (strcmp(argv[0],"PPPOE_Password")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOE_Password);
	if (strcmp(argv[0],"PPPOE_Service_Name")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOE_Service_Name);
	if (strcmp(argv[0],"PPPOE_IP")==0)
		return websWrite(wp, T("%s"),wan_config.PPPOE_IP);
	if (strcmp(argv[0],"PPPOE_Idle_Timeout")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOE_Idle_Timeout);
	if (strcmp(argv[0],"PPPOE_MTU")==0)
		return websWrite(wp, T("%d"),wan_config.PPPOE_MTU);
	else
		return 1;	
}

static int get_wan_mod (int ejid, webs_t wp, int argc, char_t **argv){
	int i=0,j;
	Load_Wan_Config();
	j=atoi(argv[1]);

//1483 Routed
	if (strcmp(argv[0],"Routed_ATM_Class")==0)
		i=wan_config.Routed_ATM_Class;
	if (strcmp(argv[0],"Routed_NAT")==0)
		i=wan_config.Routed_NAT;
	if (strcmp(argv[0],"Routed_Encapsulation_Method")==0)
		i=wan_config.Routed_Encapsulation_Method;
	if (strcmp(argv[0],"Routed_IP_Assignment")==0)
		i=wan_config.Routed_IP_Assignment;
	if (strcmp(argv[0],"Routed_RIP")==0)
		i=wan_config.Routed_RIP;

//1483 Bridged
	if (strcmp(argv[0],"Bridged_ATM_Class")==0)
		i=wan_config.Bridged_ATM_Class;
	if (strcmp(argv[0],"Bridged_Encapsulation_Method")==0)
	        i=wan_config.Bridged_Encapsulation_Method;
	if (strcmp(argv[0],"Bridged_Ether_Filter_Type")==0)
	        i=wan_config.Bridged_Ether_Filter_Type;
	if (strcmp(argv[0],"Bridged_Spanning_Bridge_Interface")==0)
	        i=wan_config.Bridged_Spanning_Bridge_Interface;
		
//PPPOA	
	if (strcmp(argv[0],"PPPOA_ATM_Class")==0)
		i=wan_config.PPPOA_ATM_Class;
	if (strcmp(argv[0],"PPPOA_Encapsulation_Method")==0)
		i=wan_config.PPPOA_Encapsulation_Method;
	if (strcmp(argv[0],"PPPOA_NAT")==0)
		i=wan_config.PPPOA_NAT;
	if (strcmp(argv[0],"PPPOA_Authentication_Protocol")==0)
		i=wan_config.PPPOA_Authentication_Protocol;
	if (strcmp(argv[0],"PPPOA_Connection")==0)
		i=wan_config.PPPOA_Connection;
	if (strcmp(argv[0],"PPPOA_RIP")==0)
		i=wan_config.PPPOA_RIP;

//IPOA
	if (strcmp(argv[0],"IPOA_ATM_Class")==0)
		i=wan_config.IPOA_ATM_Class;
	if (strcmp(argv[0],"IPOA_NAT")==0)
		i=wan_config.IPOA_NAT;
	if (strcmp(argv[0],"IPOA_IP_Assignment")==0)
		i=wan_config.IPOA_IP_Assignment;
	if (strcmp(argv[0],"IPOA_RIP")==0)
		i=wan_config.IPOA_RIP;
//PPPOE	
	if (strcmp(argv[0],"PPPOE_ATM_Class")==0)
		i=wan_config.PPPOE_ATM_Class;
	if (strcmp(argv[0],"PPPOE_Encapsulation_Method")==0)
		i=wan_config.PPPOE_Encapsulation_Method;
	if (strcmp(argv[0],"PPPOE_NAT")==0)
		i=wan_config.PPPOE_NAT;
	if (strcmp(argv[0],"PPPOE_Authentication_Protocol")==0)
		i=wan_config.PPPOE_Authentication_Protocol;
	if (strcmp(argv[0],"PPPOE_Connection")==0)
		i=wan_config.PPPOE_Connection;
	if (strcmp(argv[0],"PPPOE_RIP")==0)
		i=wan_config.PPPOE_RIP;
	if (strcmp(argv[0],"PPPOE_RELAY")==0)
		i=wan_config.PPPOE_RELAY;

	if (i==j)
		return websWrite(wp, T("%s"),argv[2]);
	else
	        return websWrite(wp, T(""));
}

static void form_1483routed_edit_conf(webs_t wp, char_t * path,char_t * query){
	char_t *buf=NULL;
	Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
        
	buf=websGetVar(wp, T("Description"), "");
        strcpy(wan_config.Routed_Description,buf);
        buf=websGetVar(wp, T("VPI"), "");
        wan_config.Routed_VPI=atoi(buf);
        buf=websGetVar(wp, T("VCI"), "");
        wan_config.Routed_VCI=atoi(buf);
        buf=websGetVar(wp, T("ATM_Class"), "");
        wan_config.Routed_ATM_Class=atoi(buf);
        buf=websGetVar(wp, T("NAT"), "");
        wan_config.Routed_NAT=atoi(buf);
        buf=websGetVar(wp, T("Encapsulation_Method"), "");
        wan_config.Routed_Encapsulation_Method=atoi(buf);
        buf=websGetVar(wp, T("IP_Assignment"), "");
        wan_config.Routed_IP_Assignment=atoi(buf);
        buf=websGetVar(wp, T("IP_Origin"), "");
        strcpy(wan_config.Routed_IP,buf);
        buf=websGetVar(wp, T("Netmask_Origin"), "");
        strcpy(wan_config.Routed_Netmask,buf);
        buf=websGetVar(wp, T("Gateway_Origin"), "");
        strcpy(wan_config.Routed_Gateway,buf);
        buf=websGetVar(wp, T("RIP"), "");
        wan_config.Routed_RIP=atoi(buf);
        buf=websGetVar(wp, T("MTU"), "");
        wan_config.Routed_MTU=atoi(buf);

	if (wan_config.Routed_Encapsulation_Method==0) /* LLC Bridged */
		wan_config.Quick_Wan_Type=8; /* quick - 1483 Bridged IP LLC */
	if (wan_config.Routed_Encapsulation_Method==1) /* Vc-Mux Bridged */
		wan_config.Quick_Wan_Type=7; /* quick - 1483 Bridged IP VC-Mux */
	if (wan_config.Routed_Encapsulation_Method==2) /* LLC Routed */
		wan_config.Quick_Wan_Type=4; /* quick - 1483 Routed IP LLC */
	if (wan_config.Routed_Encapsulation_Method==3) /* Vc-Mux Routed */
		wan_config.Quick_Wan_Type=3; /* quick - 1483 Routed IP VC-Mux */
	if (wan_config.Routed_Encapsulation_Method==4) /* LLC MER */
		wan_config.Quick_Wan_Type=5; /* quick - 1483 LLC MER */
	
	wan_config.Wan_Type=1; /* Routed */

	if (!((wan_config.Routed_RIP==old_wan_config.Routed_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
		Load_Lan_Config(&lan_config);
		write_ripd_config(&lan_config,&wan_config);
	}
	
	Save_Wan_Config(1,&wan_config);
		
	Run1483Routed(wp,&old_wan_config,&wan_config,0);
}
extern void dhcp_change_internal(int enabled);

static void form_1483bridge_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
        
	Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
        
	buf=websGetVar(wp, T("Description"), "");
        strcpy(wan_config.Bridged_Description,buf);
        buf=websGetVar(wp, T("VPI"), "");
        wan_config.Bridged_VPI=atoi(buf);
        buf=websGetVar(wp, T("VCI"), "");
        wan_config.Bridged_VCI=atoi(buf);
        buf=websGetVar(wp, T("ATM_Class"), "");
        wan_config.Bridged_ATM_Class=atoi(buf);
        buf=websGetVar(wp, T("Encapsulation_Method"), "");
        wan_config.Bridged_Encapsulation_Method=atoi(buf);
        buf=websGetVar(wp, T("Ether_Filter_Type"), "");
        wan_config.Bridged_Ether_Filter_Type=atoi(buf);
        buf=websGetVar(wp, T("Spanning_Bridge_Interface"), "");
        wan_config.Bridged_Spanning_Bridge_Interface=atoi(buf);
	
	if (wan_config.Bridged_Encapsulation_Method==0) /* Pure LLC Bridged */
		wan_config.Quick_Wan_Type=10; /* quick - Pure Bridged LLC */
	if (wan_config.Bridged_Encapsulation_Method==1) /* Pure Vc-Mux Bridged */
		wan_config.Quick_Wan_Type=9; /* quick - Pure Bridged VC-Mux */
	
	wan_config.Wan_Type=2; /* Bridged */
	
	Save_Wan_Config(2,&wan_config);
	dhcp_change_internal(0);
	Run1483Bridged(wp,&old_wan_config,&wan_config,0);
	/*
	save_globe_config(SYS_STATUS_FILE,"WAN=","bridge");	
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","bridge");	

	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
	
	save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
	save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
	
	save_globe_config(SYS_STATUS_FILE,"LAN_IF=","br0");
	save_globe_config(VAR_SYS_STATUS_FILE,"LAN_IF=","br0");

	//Write_Wan_Script_File(&wan_config);
	if (REBOOT==1){
		flash_write();
		websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
		run_script(WAN_SCRIPT_FILE,"stop","bridge",0);
		run_script(WAN_SCRIPT_FILE,"start","bridge",0);
		websRedirect(wp, T("wan_adv.asp"));
	}
	*/

}
static void form_pppoa_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
        
	Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
        
	buf=websGetVar(wp, T("Description"), "");
        strcpy(wan_config.PPPOA_Description,buf);
        buf=websGetVar(wp, T("VPI"), "");
        wan_config.PPPOA_VPI=atoi(buf);
        buf=websGetVar(wp, T("VCI"), "");
        wan_config.PPPOA_VCI=atoi(buf);
        buf=websGetVar(wp, T("ATM_Class"), "");
        wan_config.PPPOA_ATM_Class=atoi(buf);
        buf=websGetVar(wp, T("Encapsulation_Method"), "");
        wan_config.PPPOA_Encapsulation_Method=atoi(buf);
        buf=websGetVar(wp, T("NAT"), "");
        wan_config.PPPOA_NAT=atoi(buf);
        buf=websGetVar(wp, T("Username"), "");
        strcpy(wan_config.PPPOA_Username,buf);
        buf=websGetVar(wp, T("Password"), "");
        strcpy(wan_config.PPPOA_Password,buf);
        buf=websGetVar(wp, T("IP"), "");
        strcpy(wan_config.PPPOA_IP,buf);
        buf=websGetVar(wp, T("Authentication_Protocol"), "");
        wan_config.PPPOA_Authentication_Protocol=atoi(buf);
        buf=websGetVar(wp, T("Connection"), "");
        wan_config.PPPOA_Connection=atoi(buf);
        buf=websGetVar(wp, T("Idle_Timeout"), "");
        wan_config.PPPOA_Idle_Timeout=atoi(buf);
        buf=websGetVar(wp, T("RIP"), "");
        wan_config.PPPOA_RIP=atoi(buf);
        buf=websGetVar(wp, T("MTU"), "");
        wan_config.PPPOA_MTU=atoi(buf);
	
	
	wan_config.Quick_Wan_Type=1; /* quick - PPPOA */
	wan_config.Wan_Type=3; /* PPPOA */
	if (!((wan_config.PPPOA_RIP==old_wan_config.PPPOA_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
		Load_Lan_Config(&lan_config);
		write_ripd_config(&lan_config,&wan_config);
	}
	Save_Wan_Config(3,&wan_config);
	RunPPPoA(wp,&old_wan_config,&wan_config,0);
}
static void form_ipoa_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
	Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));	
        
	buf=websGetVar(wp, T("Description"), "");
        strcpy(wan_config.IPOA_Description,buf);
        buf=websGetVar(wp, T("VPI"), "");
        wan_config.IPOA_VPI=atoi(buf);
        buf=websGetVar(wp, T("VCI"), "");
        wan_config.IPOA_VCI=atoi(buf);
        buf=websGetVar(wp, T("ATM_Class"), "");
        wan_config.IPOA_ATM_Class=atoi(buf);
        buf=websGetVar(wp, T("NAT"), "");
        wan_config.IPOA_NAT=atoi(buf);
        buf=websGetVar(wp, T("IP_Assignment"), "");
        wan_config.IPOA_IP_Assignment=atoi(buf);
        buf=websGetVar(wp, T("IP"), "");
        strcpy(wan_config.IPOA_IP,buf);
        buf=websGetVar(wp, T("Netmask"), "");
        strcpy(wan_config.IPOA_Netmask,buf);
        buf=websGetVar(wp, T("Gateway"), "");
        strcpy(wan_config.IPOA_Gateway,buf);
        buf=websGetVar(wp, T("RIP"), "");
        wan_config.IPOA_RIP=atoi(buf);
        buf=websGetVar(wp, T("MTU"), "");
        wan_config.IPOA_MTU=atoi(buf);
	
	if (!((wan_config.IPOA_RIP==old_wan_config.IPOA_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
		Load_Lan_Config(&lan_config);
		write_ripd_config(&lan_config,&wan_config);
	}
	Save_Wan_Config(4,&wan_config);
	if (REBOOT==1){
		flash_write();
		websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else
		websRedirect(wp, T("wan_adv.asp"));

}
static void form_pppoe_edit_conf(webs_t wp, char_t * path,char_t * query)
{
        char_t *buf=NULL;
	Load_Wan_Config();
	memcpy(&old_wan_config,&wan_config,sizeof(WAN_CONFIG_DATA));
	FILE *fp;
	 
	buf=websGetVar(wp, T("Description"), "");
        strcpy(wan_config.PPPOE_Description,buf);
        buf=websGetVar(wp, T("VPI"), "");
        wan_config.PPPOE_VPI=atoi(buf);
        buf=websGetVar(wp, T("VCI"), "");
        wan_config.PPPOE_VCI=atoi(buf);
        buf=websGetVar(wp, T("ATM_Class"), "");
        wan_config.PPPOE_ATM_Class=atoi(buf);
        buf=websGetVar(wp, T("Encapsulation_Method"), "");
        wan_config.PPPOE_Encapsulation_Method=atoi(buf);
        buf=websGetVar(wp, T("NAT"), "");
        wan_config.PPPOE_NAT=atoi(buf);
        buf=websGetVar(wp, T("Username"), "");
        strcpy(wan_config.PPPOE_Username,buf);
        buf=websGetVar(wp, T("Password"), "");
        strcpy(wan_config.PPPOE_Password,buf);
        buf=websGetVar(wp, T("Service_Name"), "");
        strcpy(wan_config.PPPOE_Service_Name,buf);
        buf=websGetVar(wp, T("IP"), "");
        strcpy(wan_config.PPPOE_IP,buf);
        buf=websGetVar(wp, T("Authentication_Protocol"), "");
        wan_config.PPPOE_Authentication_Protocol=atoi(buf);
        buf=websGetVar(wp, T("Connection"), "");
        wan_config.PPPOE_Connection=atoi(buf);
        buf=websGetVar(wp, T("Idle_Timeout_Origin"), "");
        wan_config.PPPOE_Idle_Timeout=atoi(buf);
        buf=websGetVar(wp, T("RIP"), "");
        wan_config.PPPOE_RIP=atoi(buf);
        buf=websGetVar(wp, T("MTU"), "");
        wan_config.PPPOE_MTU=atoi(buf);
        buf=websGetVar(wp, T("RELAY"), "");
        wan_config.PPPOE_RELAY=atoi(buf);
	
	wan_config.Quick_Wan_Type=2; /* quick - PPPOE */
	wan_config.Wan_Type=5; /* PPPOE */

	if (!((wan_config.PPPOE_RIP==old_wan_config.PPPOE_RIP) && (wan_config.Quick_Wan_Type==old_wan_config.Quick_Wan_Type))){
		Load_Lan_Config(&lan_config);
		write_ripd_config(&lan_config,&wan_config);
	}
	Save_Wan_Config(5,&wan_config);
	RunPPPoE(wp,&old_wan_config,&wan_config,0);
	
	runStopPPPoELogin();
}

void Run1483Routed(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick){
	int IsRipChange=0;
	int IsFirewallChange=0;
	int IsFixedChange=0;
	int IsDhcpcChange=0;
	int IsBr2684ctlChange=0;
	int IsRt2684dChange=0;
	int ISREBOOT=0;
	int Enc;
	a_assert(websValid(wp));
	
	if(d->Wan_Type!=0){ /* Not No Wan */
		/*
		DPRINTF("d->Wan_Type:%d\n",d->Wan_Type);		
		DPRINTF("d1->Wan_Type:%d\n",d1->Wan_Type);		
		DPRINTF("d->Quick_Wan_Type:%d\n",d->Quick_Wan_Type);		
		DPRINTF("d1->Quick_Wan_Type:%d\n",d1->Quick_Wan_Type);		
		DPRINTF("d->Routed_IP_Assignment:%d\n",d->Routed_IP_Assignment);		
		DPRINTF("d1->Routed_IP_Assignment:%d\n",d1->Routed_IP_Assignment);		
		DPRINTF("d->Routed_Encapsulation_Method:%d\n",d->Routed_Encapsulation_Method);		
		DPRINTF("d1->Routed_Encapsulation_Method:%d\n",d1->Routed_Encapsulation_Method);		
		*/
		if (reboot_flag)
			ISREBOOT=1;
		if(d->Wan_Type!=d1->Wan_Type)
			ISREBOOT=1;

		if(d->Quick_Wan_Type!=d1->Quick_Wan_Type)
			ISREBOOT=1;
	
		if((((d->Routed_Encapsulation_Method==0)||(d->Routed_Encapsulation_Method==1))&&((d1->Routed_Encapsulation_Method!=0)&&(d1->Routed_Encapsulation_Method!=1)))||(((d->Routed_Encapsulation_Method==2)||(d->Routed_Encapsulation_Method==3))&&((d1->Routed_Encapsulation_Method!=2)&&(d1->Routed_Encapsulation_Method!=3))))
			ISREBOOT=1;
	
//		if((d->Routed_IP_Assignment!=d1->Routed_IP_Assignment))
//			ISREBOOT=1;
			
		/* for the issue of ping fail if NAT Change */ 
		if(d->Routed_NAT!=d1->Routed_NAT)
			ISREBOOT=1;
	}	
	

	if(!ISREBOOT){
		if (d1->Routed_IP_Assignment){ /* FIXED IP */
			save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=",d1->Routed_IP);
			save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=",d1->Routed_Netmask);
			save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=",d1->Routed_Gateway);	
		}
		else{
	//		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
	//		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
	//		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		}
			if(d1->Routed_NAT==0)
				save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else
				save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
	}

	
	if (d1->Routed_IP_Assignment){ /* FIXED IP */
		save_globe_config(SYS_STATUS_FILE,"WAN_IP=",d1->Routed_IP);
		save_globe_config(SYS_STATUS_FILE,"WAN_MASK=",d1->Routed_Netmask);
		save_globe_config(SYS_STATUS_FILE,"GATEWAY=",d1->Routed_Gateway);
	}
	else{
	//	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	//	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	//	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	}
	if(d1->Routed_NAT==0)
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
	else	
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
	
	/* LLC Routed or Vc-Mux Routed */
#if 0	
	if (Quick){
		if ((d1->Quick_Wan_Type==3) || (d1->Quick_Wan_Type==4)){
			if(!ISREBOOT){
				save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","routed");
				save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","atm0");
			}
		
			save_globe_config(SYS_STATUS_FILE,"WAN=","routed");
			save_globe_config(SYS_STATUS_FILE,"WAN_IF=","atm0");
		}
		else{
			if (d1->Routed_IP_Assignment==1){ /* FIXED IP */
				if(!ISREBOOT){
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","fixed");
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
				}	
				save_globe_config(SYS_STATUS_FILE,"WAN=","fixed");
			}
			else{
				if(!ISREBOOT){
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","dynamic");
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
				}
				save_globe_config(SYS_STATUS_FILE,"WAN=","dynamic");	
			}	
			save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
		}
	
	}
	else
	{
#endif			
		if ((d1->Routed_Encapsulation_Method==2) || (d1->Routed_Encapsulation_Method==3)){
			if(!ISREBOOT){
				save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","routed");
				save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","atm0");
			}
			
			save_globe_config(SYS_STATUS_FILE,"WAN=","routed");
			save_globe_config(SYS_STATUS_FILE,"WAN_IF=","atm0");
		}
		else{/* LLC Bridged or Vc-Mux Bridged */
			if (d1->Routed_IP_Assignment==1){ /* FIXED IP */
				if(!ISREBOOT){
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","fixed");
					/* KenWang modifiied 2005/11/25 for telewell one pvc -- begin -- */
			if(mainWanHasOtherWanBridgeUseTheSamePVC())
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","brwan");
			else
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
				}	
				save_globe_config(SYS_STATUS_FILE,"WAN=","fixed");
			}
			else{ /* dhclient */
				if(!ISREBOOT){
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","dynamic");
			if(mainWanHasOtherWanBridgeUseTheSamePVC())
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","brwan");
			else
					save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
				}
				save_globe_config(SYS_STATUS_FILE,"WAN=","dynamic");	
			}	
			if(mainWanHasOtherWanBridgeUseTheSamePVC())
				save_globe_config(SYS_STATUS_FILE,"WAN_IF=","brwan");
			else
			save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
//		}
	}
//	write_ripd_config();
	if (ISREBOOT==1){
/*		
		save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
*/		
		/*
		if (d->Wan_Type==2)
			save_globe_config(SYS_STATUS_FILE,"LAN_IF=","br0");
		*/	
		if(Quick){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
		if((d->Routed_VPI!=d1->Routed_VPI)||
		   (d->Routed_VCI!=d1->Routed_VCI)||
		   (d->Routed_ATM_Class!=d->Routed_ATM_Class)){
#if 0
			if (Quick){
				if ((d1->Quick_Wan_Type==3) || (d1->Quick_Wan_Type==4))
					IsRt2684dChange=1;
				else{
					IsBr2684ctlChange=1;
					if (d1->Routed_IP_Assignment==1) /* FIXED IP */
						IsFixedChange=1;
					else
						IsDhcpcChange=1;
				}
			}
			else{
#endif				
				if ((d1->Routed_Encapsulation_Method==2) || (d1->Routed_Encapsulation_Method==3))
					IsRt2684dChange=1;
				else{
					IsBr2684ctlChange=1;
					if (d1->Routed_IP_Assignment) /* Fixed */
						IsFixedChange=1;
					else
						IsDhcpcChange=1;
				}
//			}
			IsFirewallChange=1;
			IsRipChange=1;
			runStopPPPoELogin();
		}
	
			
		/* if solve NAT change issue 
		if(d->Routed_NAT!=d1->Routed_NAT)
			IsFirewallChange=1;
		*/
		if (d->Routed_IP_Assignment!=d1->Routed_IP_Assignment){
			if ((d1->Routed_Encapsulation_Method==2) || (d1->Routed_Encapsulation_Method==3))
					IsRt2684dChange=1;
			else{
				if (d1->Routed_IP_Assignment) /* Fixed */
					IsFixedChange=1;
				else	
					IsDhcpcChange=1;
			}
			IsFirewallChange=1;
			IsRipChange=1;
			runStopPPPoELogin();
		}
		else{
			if (d1->Routed_IP_Assignment){ /* Fixed */
				if((strcmp(d->Routed_IP,d1->Routed_IP)!=0)||
                   		   (strcmp(d->Routed_Netmask,d1->Routed_Netmask)!=0)||
	                	   (strcmp(d->Routed_Gateway,d1->Routed_Gateway)!=0)){
		         		if ((d1->Routed_Encapsulation_Method==2) || (d1->Routed_Encapsulation_Method==3)){
			        		if (d1->Routed_IP_Assignment) /* Routed */
				        		IsRt2684dChange=1;
		       			}
	        	 		else{				
		        			if (d1->Routed_IP_Assignment) /* Fixed */
			        	 		IsFixedChange=1;
	         			}
		         		IsFirewallChange=1;
			        	IsRipChange=1;
					runStopPPPoELogin();
				}
			}
		}
				
		if (d->Routed_RIP!=d1->Routed_RIP)
			IsRipChange=1;
		
		if(IsRipChange)
			runStopRip();
		if(IsFirewallChange)
			runStopFirewall();
		if(IsFixedChange){
			runStopDhcpc();
			runStopFixed();
		}
		if(IsDhcpcChange)
			runStopDhcpc();
		if(IsRt2684dChange){
			runStopRt2684d();
			//albert: sleep for preventing device crash due to slow atm open
			sleep(10);
			runStartRt2684d(d1->Routed_VPI,d1->Routed_VCI,d1->Routed_Encapsulation_Method);
			runStartFirewall();
		}
		else if(IsBr2684ctlChange){
			runStopBr2684ctl();
			if (d1->Routed_Encapsulation_Method==0)
				Enc=0;
			else	
				Enc=1;
			runStartBr2684ctl(d1->Routed_VPI,d1->Routed_VCI,Enc);
			if (d1->Routed_IP_Assignment==0) /* Dhcpclient */
				runStartDhcpc();
			else{
				runStartFixed();
				runStartFirewall();
			}
				
		}
		else if(IsDhcpcChange){
			runStartDhcpc();
		}
		else if(IsFixedChange){
			runStartFixed();
			runStartFirewall();
		}	
		else if(IsFirewallChange){
			runStartFirewall();
		}
		else if(IsRipChange){
			runStartRip();
		}

		if (Quick)
			websRedirect(wp, T("quick.asp"));
		else
			websRedirect(wp, T("wan_adv.asp"));
	}

}

void Run1483Bridged(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick){
	int IsPureBridgeChange=0;
	int ISREBOOT=0;
	a_assert(websValid(wp));
	if(d->Wan_Type!=0){ /* Not No Wan */
		
		if (reboot_flag)
			ISREBOOT=1;
		if(d->Wan_Type!=d1->Wan_Type)
			ISREBOOT=1;
		if(d->Quick_Wan_Type!=d1->Quick_Wan_Type)
			ISREBOOT=1;
	}
	
	if(!ISREBOOT){
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","bridge");	
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","br0"); // KenWang test 2006/01/04
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
		//save_globe_config(VAR_SYS_STATUS_FILE,"LAN_IF=","br0");
	}
	save_globe_config(SYS_STATUS_FILE,"WAN=","bridge");	
	save_globe_config(SYS_STATUS_FILE,"WAN_IF=","br0"); // KenWang test 2006/01/04
	//save_globe_config(SYS_STATUS_FILE,"LAN_IF=","br0");
	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
	if (ISREBOOT){
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
		if((d->Bridged_VPI!=d1->Bridged_VPI)||
		   (d->Bridged_VCI!=d1->Bridged_VCI)||
		   (d->Bridged_ATM_Class!=d1->Bridged_ATM_Class)||
		   (d->Bridged_Encapsulation_Method!=d1->Bridged_Encapsulation_Method)
		   )
			IsPureBridgeChange=1;
			runStopPPPoELogin();
		if(IsPureBridgeChange)
		{
			runStopPureBridge();
			runStartPureBridge(d1->Bridged_VPI,d1->Bridged_VCI,d1->Bridged_Encapsulation_Method);
		}
		if (Quick)
			websRedirect(wp, T("quick.asp"));
		else
			websRedirect(wp, T("wan_adv.asp"));
	}
	
	
}
/*what changes need to reset WAN status:
1: VPI VCI ATM CLASS
2.PPPOE_Username,PPPOE_Password,PPPOE_IP,PPPOE_Service_Name,,PPPOE_Authentication_Protocol,
PPPOE_Connection,PPPOE_Idle_Timeout,PPPOE_MTU,PPPOE_RELAY


RIP change will not call this func.
*/
void reset_WAN_Status(int ppp_nat)
{
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","pppoe");	
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
	if (ppp_nat==0)
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
	else	
		save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");			
}

void RunPPPoE(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick){
	int IsRipChange=0;
	int IsFirewallChange=0;
	int IsPppoecdChange=0;
	int IsBr2684ctlChange=0;
	int ISREBOOT=0;
	a_assert(websValid(wp));
	
	VLAN_CONFIG_DATA vlan;
	OTHER_WAN_BRIDGE_DATA wanbr;
	int i, usingBrwan = 0;

	/*
	DPRINTF("old_pppoe_ip:%s\n",d->PPPOE_IP);
	DPRINTF("new_pppoe_ip:%s\n",d1->PPPOE_IP);
	DPRINTF("ols_Wan_Type:%d\n",d->Wan_Type);
	DPRINTF("new_Wan_Type:%d\n",d1->Wan_Type);
	DPRINTF("quick_old_Wan_Type:%d\n",d->Quick_Wan_Type);
	DPRINTF("quick_new_Wan_Type:%d\n",d1->Quick_Wan_Type);
	*/
	if(d->Wan_Type!=0){ /* Not No Wan */
		
		if (reboot_flag)
			ISREBOOT=1;
		if(d->Wan_Type!=d1->Wan_Type)
			ISREBOOT=1;
		if(d->Quick_Wan_Type!=d1->Quick_Wan_Type)
			ISREBOOT=1;
		if(d->PPPOE_Encapsulation_Method!=d1->PPPOE_Encapsulation_Method)
			ISREBOOT=1;
		/* for the issue of ping fail if NAT Change */ 
		if(d->PPPOE_NAT!=d1->PPPOE_NAT)
			ISREBOOT=1;
	}	
	
	Load_Vlan_Config(&vlan);
	Load_Other_Wan_Bridge_Config(&wanbr);
	for(i=0; i<MAX_RULE; i++)
	{
		if(isActiveVlanGroup(&vlan, i))
		{
			if(vlan.Rule[i].WAN_connection_index >=2 &&
			   wanbr.usingSamePVCFromExistingWanConnection[vlan.Rule[i].WAN_connection_index-2]==1)
			{
				usingBrwan = 1;
			}
		}
	}
#if 1
	if(!ISREBOOT){
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","pppoe");	
		if(usingBrwan)
			save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","brwan");
		else
			save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","nas0");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		if (d1->PPPOE_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else	
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
			
	}
	
	save_globe_config(SYS_STATUS_FILE,"WAN=","pppoe");	
	if(usingBrwan)
		save_globe_config(SYS_STATUS_FILE, "WAN_IF=", "brwan");
	else
		save_globe_config(SYS_STATUS_FILE,"WAN_IF=","nas0");
	save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	if (d1->PPPOE_NAT==0)
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
	else	
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");
#endif	
		
	if (ISREBOOT){
		/*
		if (d->Wan_Type==2)
			save_globe_config(SYS_STATUS_FILE,"LAN_IF=","br0");
		*/	
		if(Quick){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
		if((d->PPPOE_VPI!=d1->PPPOE_VPI)||
		   (d->PPPOE_VCI!=d1->PPPOE_VCI)||
		   (d->PPPOE_ATM_Class!=d1->PPPOE_ATM_Class)){
			IsBr2684ctlChange=1;
			IsPppoecdChange=1;
			IsFirewallChange=1;
			IsRipChange=1;
#if 0
		reset_WAN_Status(d1->PPPOE_NAT);
#endif
			runStopPPPoELogin();
		}
	
		/* if solve NAT change issue 
		if(d->PPPOE_NAT!=d1->PPPOE_NAT)
			IsFirewallChange=1;
		*/
		if (!strcmp(d1->PPPOE_Service_Name,"&"))
			strcpy(d1->PPPOE_Service_Name,"");
		if((strcmp(d->PPPOE_Username,d1->PPPOE_Username)!=0)||
		   (strcmp(d->PPPOE_Password,d1->PPPOE_Password)!=0)||
		   (strcmp(d->PPPOE_IP,d1->PPPOE_IP)!=0)||
		   (strcmp(d->PPPOE_Service_Name,d1->PPPOE_Service_Name)!=0)||
		   (d->PPPOE_Authentication_Protocol!=d1->PPPOE_Authentication_Protocol)||
		   (d->PPPOE_Connection!=d1->PPPOE_Connection)||
		   (d->PPPOE_Idle_Timeout!=d1->PPPOE_Idle_Timeout)||
		   (d->PPPOE_MTU!=d1->PPPOE_MTU) ||
		   (d->PPPOE_RELAY!=d1->PPPOE_RELAY)
			){
		/*	
			DPRINTF("old_username:%s\n",d->PPPOE_Username);
			DPRINTF("username:%s\n",d1->PPPOE_Username);
			DPRINTF("old_Password:%s\n",d->PPPOE_Password);
			DPRINTF("Password:%s\n",d1->PPPOE_Password);
			DPRINTF("old_IP:%s\n",d->PPPOE_IP);
			DPRINTF("IP:%s\n",d1->PPPOE_IP);
			DPRINTF("old_service_name:%s\n",d->PPPOE_Service_Name);
			DPRINTF("service_name:%s\n",d1->PPPOE_Service_Name);
			DPRINTF("old_Auth:%d\n",d->PPPOE_Authentication_Protocol);
			DPRINTF("Auth:%d\n",d1->PPPOE_Authentication_Protocol);
			DPRINTF("old_Connection:%d\n",d->PPPOE_Connection);
			DPRINTF("Connection:%d\n",d1->PPPOE_Connection);
			DPRINTF("old_idletime:%d\n",d->PPPOE_Idle_Timeout);
			DPRINTF("idletime:%d\n",d1->PPPOE_Idle_Timeout);
			DPRINTF("old_mtu:%d\n",d->PPPOE_MTU);
			DPRINTF("mtu:%d\n",d1->PPPOE_MTU);
			DPRINTF("old_relay:%d\n",d->PPPOE_RELAY);
			DPRINTF("relay:%d\n",d1->PPPOE_RELAY);
		*/
			//DPRINTF("old_relay:%d\n",d->PPPOE_RELAY);
			//DPRINTF("relay:%d\n",d1->PPPOE_RELAY);

			IsPppoecdChange=1;
			IsFirewallChange=1;
			IsRipChange=1;
#if 0
		reset_WAN_Status(d1->PPPOE_NAT);
#endif
			runStopPPPoELogin();
		}
	
		if (d->PPPOE_RIP!=d1->PPPOE_RIP)
			IsRipChange=1;
		
		if(IsRipChange)
			runStopRip();
		if(IsFirewallChange)
			runStopFirewall();
		if(IsPppoecdChange)
			runStopPppoecd();
		if(IsBr2684ctlChange)
		{
			runStopBr2684ctl();
			//runStartBr2684ctl(d1->PPPOE_VPI,d1->PPPOE_VCI,0);
			runStartBr2684ctl(d1->PPPOE_VPI,d1->PPPOE_VCI,d1->PPPOE_Encapsulation_Method);
			DPRINTF("PPPoE Encapsulation method:%d\n",d1->PPPOE_Encapsulation_Method);
			runStartPppoecd();
		}
		else if(IsPppoecdChange)
			runStartPppoecd();
		else if(IsFirewallChange)
			runStartFirewall();
		else if(IsRipChange)
			runStartRip();
		if (Quick)
			websRedirect(wp, T("quick.asp"));
		else
			websRedirect(wp, T("wan_adv.asp"));
	}
}

void RunPPPoA(webs_t wp,WAN_CONFIG_DATA *d,WAN_CONFIG_DATA *d1,int Quick){
	int IsRipChange=0;
	int IsFirewallChange=0;
	int IsPppoaChange=0;
	int ISREBOOT=0;
	a_assert(websValid(wp));
	/*
	DPRINTF("ols_Wan_Type:%d\n",d->Wan_Type);
	DPRINTF("new_Wan_Type:%d\n",d1->Wan_Type);
	DPRINTF("quick_old_Wan_Type:%d\n",d->Quick_Wan_Type);
	DPRINTF("quick_new_Wan_Type:%d\n",d1->Quick_Wan_Type);
	DPRINTF("old_username:%s\n",d->PPPOA_Username);
	DPRINTF("username:%s\n",d1->PPPOA_Username);
	DPRINTF("old_Password:%s\n",d->PPPOA_Password);
	DPRINTF("Password:%s\n",d1->PPPOA_Password);
	DPRINTF("old_IP:%s\n",d->PPPOA_IP);
	DPRINTF("IP:%s\n",d1->PPPOA_IP);
	DPRINTF("old_Auth:%d\n",d->PPPOA_Authentication_Protocol);
	DPRINTF("Auth:%d\n",d1->PPPOA_Authentication_Protocol);
	DPRINTF("old_Connection:%d\n",d->PPPOA_Connection);
	DPRINTF("Connection:%d\n",d1->PPPOA_Connection);
	DPRINTF("old_idletime:%d\n",d->PPPOA_Idle_Timeout);
	DPRINTF("idletime:%d\n",d1->PPPOA_Idle_Timeout);
	DPRINTF("old_mtu:%d\n",d->PPPOA_MTU);
	DPRINTF("mtu:%d\n",d1->PPPOA_MTU);
*/
	if(d->Wan_Type!=0){ /* Not No Wan */
		if (reboot_flag)
			ISREBOOT=1;
		if(d->Wan_Type!=d1->Wan_Type)
			ISREBOOT=1;
		if(d->Quick_Wan_Type!=d1->Quick_Wan_Type)
			ISREBOOT=1;
		if(d->PPPOA_Encapsulation_Method!=d1->PPPOA_Encapsulation_Method)
			ISREBOOT=1;
		/* for the issue of ping fail if NAT Change */ 
		if(d->PPPOA_NAT!=d1->PPPOA_NAT)
			ISREBOOT=1;
	}

	if(!ISREBOOT){
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN=","pppoa");
		save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IF=","ppp0");
		//save_globe_config(VAR_SYS_STATUS_FILE,"WAN_IP=","");
		//save_globe_config(VAR_SYS_STATUS_FILE,"WAN_MASK=","");
		//save_globe_config(VAR_SYS_STATUS_FILE,"GATEWAY=","");
		if (d1->PPPOA_NAT==0)
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","nat");
		else	
			save_globe_config(VAR_SYS_STATUS_FILE,"ROUTER=","no");
			
	}
	
	save_globe_config(SYS_STATUS_FILE,"WAN=","pppoa");
	save_globe_config(SYS_STATUS_FILE,"WAN_IF=","ppp0");
	//save_globe_config(SYS_STATUS_FILE,"WAN_IP=","");
	//save_globe_config(SYS_STATUS_FILE,"WAN_MASK=","");
	//save_globe_config(SYS_STATUS_FILE,"GATEWAY=","");
	if (d1->PPPOA_NAT==0)
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","nat");
	else
		save_globe_config(SYS_STATUS_FILE,"ROUTER=","no");

	
	if (ISREBOOT){
		/*
		if (d->Wan_Type==2)
			save_globe_config(SYS_STATUS_FILE,"LAN_IF=","br0");
		*/
		if(Quick){
			Load_Lan_Config(&lan_config);
			write_ripd_config(&lan_config,&wan_config);
		}
		flash_write();
		return websRedirect(wp, T("rbnosv_apply.asp"));
	}
	else{
		if((d->PPPOA_VPI!=d1->PPPOA_VPI)||
		   (d->PPPOA_VCI!=d1->PPPOA_VCI)||
		   (d->PPPOA_ATM_Class!=d1->PPPOA_ATM_Class)){
			IsPppoaChange=1;
			IsFirewallChange=1;
			IsRipChange=1;
 			runStopPPPoELogin();
		}
	
		/* if solve NAT change issue 
		if(d->PPPOA_NAT!=d1->PPPOA_NAT)
			IsFirewallChange=1;
		*/
		
		if((strcmp(d->PPPOA_Username,d1->PPPOA_Username)!=0)||
		   (strcmp(d->PPPOA_Password,d1->PPPOA_Password)!=0)||
		   (strcmp(d->PPPOA_IP,d1->PPPOA_IP)!=0)||
//		   (strcmp(d->PPPOA_Service_Name,d1->PPPOA_Service_Name)!=0)||
		   (d->PPPOA_Authentication_Protocol!=d1->PPPOA_Authentication_Protocol)||
		   (d->PPPOA_Connection!=d1->PPPOA_Connection)||
		   (d->PPPOA_Idle_Timeout!=d1->PPPOA_Idle_Timeout)||
		   (d->PPPOA_MTU!=d1->PPPOA_MTU)){
			/*
			DPRINTF("old_username:%s\n",d->PPPOA_Username);
			DPRINTF("username:%s\n",d1->PPPOA_Username);
			DPRINTF("old_Password:%s\n",d->PPPOA_Password);
			DPRINTF("Password:%s\n",d1->PPPOA_Password);
			DPRINTF("old_IP:%s\n",d->PPPOA_IP);
			DPRINTF("IP:%s\n",d1->PPPOA_IP);
			DPRINTF("old_Auth:%d\n",d->PPPOA_Authentication_Protocol);
			DPRINTF("Auth:%d\n",d1->PPPOA_Authentication_Protocol);
			DPRINTF("old_Connection:%d\n",d->PPPOA_Connection);
			DPRINTF("Connection:%d\n",d1->PPPOA_Connection);
			DPRINTF("old_idletime:%d\n",d->PPPOA_Idle_Timeout);
			DPRINTF("idletime:%d\n",d1->PPPOA_Idle_Timeout);
			DPRINTF("old_mtu:%d\n",d->PPPOA_MTU);
			DPRINTF("mtu:%d\n",d1->PPPOA_MTU);
			*/
			IsPppoaChange=1;
			IsFirewallChange=1;
			IsRipChange=1;
			runStopPPPoELogin();
		}
	
		if (d->PPPOA_RIP!=d1->PPPOA_RIP)
			IsRipChange=1;
		
		if(IsRipChange)
			runStopRip();
		if(IsFirewallChange)
			runStopFirewall();
		if(IsPppoaChange)
		{
			runStopPppoa();
			//albert: sleep for preventing device crash due to slow atm open
			sleep(10);
		}
		if(IsPppoaChange)
			runStartPppoa();
		else if(IsFirewallChange)
			runStartFirewall();
		else if(IsRipChange)
			runStartRip();
		if (Quick)
			websRedirect(wp, T("quick.asp"));
		else
			websRedirect(wp, T("wan_adv.asp"));
	}
}

static void form_1483routed_delete_conf(webs_t wp, char_t * path,char_t * query)
{
	set_no_connection();
	run_script(WAN_SCRIPT_FILE,"stop","dynamic",0);
   	websRedirect(wp, T("wan_adv.asp"));
}
static void form_1483bridge_delete_conf(webs_t wp, char_t * path,char_t * query)
{
	set_no_connection();
   	websRedirect(wp, T("wan_adv.asp"));
}
static void form_pppoa_delete_conf(webs_t wp, char_t * path,char_t * query)
{
	
	set_no_connection();
	websRedirect(wp, T("wan_adv.asp"));
}
static void form_ipoa_delete_conf(webs_t wp, char_t * path,char_t * query)
{
	set_no_connection();
   	websRedirect(wp, T("wan_adv.asp"));
}
static void form_pppoe_delete_conf(webs_t wp, char_t * path,char_t * query)
{
	set_no_connection();
	run_script(WAN_SCRIPT_FILE,"stop","pppoe",0);
   	websRedirect(wp, T("wan_adv.asp"));
}
int checked_function_enabled3 (char *parameter, webs_t wp, char_t **argv)
{
	char_t buf1[32];
	char_t is_pppoe[10];
	int i=0;
	strcpy(is_pppoe,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,parameter,buf1));
 	if(strcmp(is_pppoe,"pppoe")==0)
		return websWrite(wp, T(""));
	
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else
		return websWrite(wp, T("-->"));
}
static int wan_is_pppoe (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled3("WAN=",wp,argv);
}
int wan_is_bridge (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t buf1[32];
	char_t wan_type[16];
	int i=0;
	strcpy(wan_type,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN=",buf1));
 	if(strcmp(wan_type,"bridge")!=0)
		return websWrite(wp, T(""));
	
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else
		return websWrite(wp, T("-->"));
}

static int is_wipca_present (int ejid, webs_t wp, int argc, char_t **argv)
{
#if _SUPPORT_WIPCA_
		return websWrite(wp, T(""));
#else	
 	int i=0;
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else
		return websWrite(wp, T("-->"));
#endif
}


void DefineWebFunctions_wan() {
	//initial wan for restart
	Load_Wan_Config();
	initial_quick_wan_type=wan_config.Quick_Wan_Type;
	websAspDefine(T("is_wipca_present"), is_wipca_present);
	websAspDefine(T("read_connect_disabled_js"), read_connect_disabled_js);
	websAspDefine(T("get_wan_mod"), get_wan_mod);
	websAspDefine(T("wan_is_pppoe"), wan_is_pppoe);
	websAspDefine(T("reload_wan_config"), reload_wan_config);
        websAspDefine(T("get_wan_status"), get_wan_status);
	websFormDefine(T("wan_1483routed_edit"), form_1483routed_edit_conf);
	websFormDefine(T("wan_1483bridged_edit"), form_1483bridge_edit_conf);
	websFormDefine(T("wan_pppoa_edit"), form_pppoa_edit_conf);
	websFormDefine(T("wan_ipoa_edit"), form_ipoa_edit_conf);
	websFormDefine(T("wan_pppoe_edit"), form_pppoe_edit_conf);
	websFormDefine(T("wan_1483routed_delete"), form_1483routed_delete_conf);
	websFormDefine(T("wan_1483bridged_delete"), form_1483bridge_delete_conf);
	websFormDefine(T("wan_pppoa_delete"), form_pppoa_delete_conf);
	websFormDefine(T("wan_ipoa_delete"), form_ipoa_delete_conf);
	websFormDefine(T("wan_pppoe_delete"), form_pppoe_delete_conf);
}

