/*
 * wan.htm: WAN status
 */

#define WAN_CONFIG_FILE 		"/flash/wan.conf"
#define RIP_CONFIG_FILE 		"/flash/ripd.conf"
#define CONNECT_WAN_SCRIPT_FILE		"/etc/scripts/wan_connect.sh"
#define WAN_SCRIPT_FILE 		"/etc/scripts/wan.sh"
#define PING_SCRIPT_FILE 		"/etc/scripts/ping.sh"
#define VAR_SYS_STATUS_FILE 		"/var/etc/status"
#define SYS_STATUS_FILE 		"/flash/config"
#define TMP_RESOLV_CONF_FILE 		"/tmp/ppp/resolv.conf"
//#define WAN_IP_STATUS_FILE 		"/tmp/ppp/wan_status"
#define WAN_CONNECT_STATUS_FILE 	"/tmp/ppp/wan_connect_status"
#define WAN_ERROR_LOG_FILE 		"/tmp/ppp/log"
#define WAN_ROUTE_SCRIPT_FILE		"/tmp/ppp/route.sh"
#define DEFAULT_CONFIG_FILE 		"/etc/default/config"
#define REBOOT	0	

//#define PPPOE_IPUP_SCRIPT_FILE 		"/tmp/ppp/pppoe-ipup"
//#define PPPOE_IPDOWN_SCRIPT_FILE 	"/tmp/ppp/pppoe-ipdown"
//#define DHCLIENT_RENEW_SCRIPT_FILE 	"/tmp/ppp/dhclient-renew"
//#define DHCLIENT_RELEASE_SCRIPT_FILE 	"/tmp/ppp/dhclient-release"

void DefineWebFunctions_wan();
extern int print_blank_string(void *d);
extern int load_blank_string(void *d);
extern void Load_Lan_Config(LAN_CONFIG_DATA *d);
extern int run_script(char *filename, char *arg1, char *arg2, char *arg3);
extern int save_globe_config(char *filename, char *arg1, char *arg2);
extern int write_value_to_file(char *filename, int arg1);
extern int isValidIP(char *IPaddr);
extern void CopyFile(char *filename1,char *filename2);
extern void run_task(char *cmd, ...);


typedef struct {
	
	int Wan_Type; 
	int Quick_Wan_Type;		
	// 1483 Routed
	char Routed_Description[50];
	unsigned short Routed_VPI;
	unsigned short Routed_VCI;
	int Routed_ATM_Class;
	int Routed_NAT;
	int Routed_Encapsulation_Method;
	int Routed_IP_Assignment;
	char Routed_IP[20];
	char Routed_Netmask[20];
	char Routed_Gateway[20];
	int Routed_RIP;
	unsigned short Routed_MTU;	

	//1483 Bridge
        char Bridged_Description[50];
	unsigned short Bridged_VPI;
        unsigned short Bridged_VCI;
	int Bridged_ATM_Class;
	int Bridged_Encapsulation_Method;
	int Bridged_Ether_Filter_Type;
	int Bridged_Spanning_Bridge_Interface;

	//PPPOA
        char PPPOA_Description[50];
	unsigned short PPPOA_VPI;
        unsigned short PPPOA_VCI;
        int PPPOA_ATM_Class;
	int PPPOA_Encapsulation_Method;
	int PPPOA_NAT;
	char PPPOA_Username[256];
        char PPPOA_Password[256];
	char PPPOA_IP[20];
	int PPPOA_Authentication_Protocol;
	int PPPOA_Connection;
	unsigned short PPPOA_Idle_Timeout;
        int PPPOA_RIP;
	unsigned short PPPOA_MTU;
		
	//IPOA
	char IPOA_Description[50];
	unsigned short IPOA_VPI;
	unsigned short IPOA_VCI;
	int IPOA_ATM_Class;
	int IPOA_NAT;
	int IPOA_IP_Assignment;
	char IPOA_IP[20];
	char IPOA_Netmask[20];
	char IPOA_Gateway[20];
	int IPOA_RIP;
	unsigned short IPOA_MTU;
		
	//PPPOE
        char PPPOE_Description[50];
	unsigned short PPPOE_VPI;
        unsigned short PPPOE_VCI;
        int PPPOE_ATM_Class;
	int PPPOE_Encapsulation_Method;
	int PPPOE_NAT;
	char PPPOE_Username[257];
        char PPPOE_Password[257];
	char PPPOE_Service_Name[32];
	char PPPOE_IP[20];
	int PPPOE_Authentication_Protocol;
	int PPPOE_Connection;
	unsigned short PPPOE_Idle_Timeout;
        int PPPOE_RIP;
	unsigned short PPPOE_MTU;
	int PPPOE_RELAY;
} WAN_CONFIG_DATA;
extern WAN_CONFIG_DATA wan_config;
extern WAN_CONFIG_DATA old_wan_config;
