/*
 *  wan_adv.htm: WAN Configuration
 */
#include "webs.h"
#include "wan_adv.h"
#include "lan_conf.h"
#include "wan.h"
#include "locale.h"

#define R_ADMIN_LOGIN "admin"

extern char *WAN_ADV_L1[];
extern char *WAN_ADV_L2[];
extern char *WAN_ADV_L3[];
extern char *WAN_ADV_L4[];

static int read_wan_status (int ejid, webs_t wp, int argc, char_t **argv);

void read_wan_pvc (int *Wan_Vpi, int *Wan_Vci)
{
	Load_Wan_Config();
	if (wan_config.Wan_Type==1){
		*Wan_Vpi=wan_config.Routed_VPI;
		*Wan_Vci=wan_config.Routed_VCI;
	}
	else if (wan_config.Wan_Type==2){
		*Wan_Vpi=wan_config.Bridged_VPI;
		*Wan_Vci=wan_config.Bridged_VCI;
	}
	else if (wan_config.Wan_Type==3){
		*Wan_Vpi=wan_config.PPPOA_VPI;
		*Wan_Vci=wan_config.PPPOA_VCI;
	}
	else if (wan_config.Wan_Type==4){
		*Wan_Vpi=wan_config.IPOA_VPI;
		*Wan_Vci=wan_config.IPOA_VCI;
	}
	else if (wan_config.Wan_Type==5){
		*Wan_Vpi=wan_config.PPPOE_VPI;
		*Wan_Vci=wan_config.PPPOE_VCI;
	}
}

static int read_wan_status (int ejid, webs_t wp, int argc, char_t **argv)
{
	char_t Wan_Name[20];
	char_t Wan_Description[30];
	char_t Action_Edit[30];
	char_t Action_Change[30];
	int Wan_Vpi;
	int Wan_Vci;
	
	
	Load_Wan_Config();
	strcpy(Action_Change,"wan_create_service.asp");
	//DPRINTF("\nwan_config.wan_type:%d\n",wan_config.Wan_Type);	
	if (wan_config.Wan_Type==1){
		sprintf(Wan_Name,"RFC1483 %s",WAN_ADV_L3[locale_config.locale]);
		strcpy(Wan_Description,wan_config.Routed_Description);
		Wan_Vpi=wan_config.Routed_VPI;
		Wan_Vci=wan_config.Routed_VCI;
		strcpy(Action_Edit,"rfc1483_routed_edit.asp");
	}
	else if (wan_config.Wan_Type==2){
		sprintf(Wan_Name,"RFC1483 %s",WAN_ADV_L4[locale_config.locale]);
		strcpy(Wan_Description,wan_config.Bridged_Description);
		Wan_Vpi=wan_config.Bridged_VPI;
		Wan_Vci=wan_config.Bridged_VCI;
		strcpy(Action_Edit,"rfc1483_bridge_edit.asp");
	}
	else if (wan_config.Wan_Type==3){
		sprintf(Wan_Name,"PPPoA %s",WAN_ADV_L3[locale_config.locale]);
		strcpy(Wan_Description,wan_config.PPPOA_Description);
		Wan_Vpi=wan_config.PPPOA_VPI;
		Wan_Vci=wan_config.PPPOA_VCI;
		strcpy(Action_Edit,"pppoa_edit.asp");
	}
	else if (wan_config.Wan_Type==4){
		sprintf(Wan_Name,"IPoA %s",WAN_ADV_L3[locale_config.locale]);
		strcpy(Wan_Description,wan_config.IPOA_Description);
		Wan_Vpi=wan_config.IPOA_VPI;
		Wan_Vci=wan_config.IPOA_VCI;
		strcpy(Action_Edit,"ipoa_edit.asp");
	}
	else if (wan_config.Wan_Type==5){
		sprintf(Wan_Name,"PPPoE %s",WAN_ADV_L3[locale_config.locale]);
		strcpy(Wan_Description,wan_config.PPPOE_Description);
		Wan_Vpi=wan_config.PPPOE_VPI;
		Wan_Vci=wan_config.PPPOE_VCI;
		strcpy(Action_Edit,"pppoe_edit.asp");
	}
	else
		return websWrite(wp, T(""));

	char_t *TableFmt="<tr>\n"
	                "\t<td><nobr>%s</nobr></td>\n"
		        "\t\t<td><nobr>%s</nobr></td>\n"
			"\t\t<td><nobr>%s</nobr></td>\n"
			"\t\t<td><nobr>%d</nobr></td>\n"
			"\t\t<td><nobr>%d</nobr></td>\n"
			"\t\t<td><nobr><a href=\"%s\">%s\n"
			"\t\t\t<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
			"\t\t<td><nobr><a href=\"%s\">%s\n"
			"\t\t\t<img align=middle border=0 src=/link1.gif></a></nobr></td>\n"
		        "\t</tr>\n";
	return websWrite(wp, T(TableFmt),
			Wan_Name,
			Wan_Description,
			R_ADMIN_LOGIN ,
			Wan_Vpi,
			Wan_Vci,
			Action_Edit,
			WAN_ADV_L1[locale_config.locale],
			Action_Change,
			WAN_ADV_L2[locale_config.locale]
			);
}

void DefineWebFunctions_WanAdv() {
         websAspDefine (T ("read_wan_status"), read_wan_status);
}
