/*
 * Functions for webpages
 */
/*****************************************************************************/
/*       Status                                                              */
/*****************************************************************************/
#include "lan_conf.h"
#include "home.h"
/*****************************************************************************/
/*           |_ ADSL Status                                                  */    
/*****************************************************************************/
#include "lstat.h"
/*****************************************************************************/
/*                    |_ WAN Status                                          */
/*****************************************************************************/
#include "wan.h"
/*****************************************************************************/
/*                    |_ ATM Status                                          */
/*****************************************************************************/
#include "atm.h"
/*****************************************************************************/
/*           |_ LAN Status                                                   */
/*****************************************************************************/
#include "lan1.h"
/*****************************************************************************/
/*                    |_ TCP Status                                          */
/*****************************************************************************/
#include "tcp.h"
/*****************************************************************************/
/*           |_ PPP Status                                                   */
/*****************************************************************************/
#include "ppp.h"
/*****************************************************************************/
/*           |_ Learned MAC Table Status                                     */
/*****************************************************************************/
#include "mactable.h"
/*****************************************************************************/
/*           |_ Routing Table Status                                         */
/*****************************************************************************/
#include "croute.h"
/*****************************************************************************/
/*           |_ System Log Status                                            */
/*****************************************************************************/
#include "syslog.h"
/*****************************************************************************/
/*           |_ Security Log Status                                          */
/*****************************************************************************/
#include "seclog.h"


/*****************************************************************************/
/*       Quick Start                                                         */
/*****************************************************************************/
#include "quick.h"

/*****************************************************************************/
/*       Configuration                                                       */
/*****************************************************************************/
/*****************************************************************************/
/*           |_ WAN                                                          */
/*****************************************************************************/
#include "wan_adv.h"
/*****************************************************************************/
/*           |_ LAN                                                          */
/*****************************************************************************/
#include "dhcp.h"

/*****************************************************************************/
/*           |_ Wireless LAN						     */
/*****************************************************************************/
//#include "wlan.h"
/*****************************************************************************/
/*           |_ System                                                       */
/*****************************************************************************/
/*****************************************************************************/
/*                    |_ Password                                            */
/*****************************************************************************/
/*****************************************************************************/
/*                           |_ Admin                                        */
/*****************************************************************************/
#include "pwdadmin.h"
/*****************************************************************************/
/*                           |_ User                                         */
/*****************************************************************************/
#include "pwduser.h"
/*****************************************************************************/
/*                    |_ Time zone                                           */
/*****************************************************************************/
#include "timezone.h"
/*****************************************************************************/
/*                    |_ Upgrade                                             */
/*****************************************************************************/
#include "update.h"
/*****************************************************************************/
/*                    |_ Factory Setting                                     */
/*****************************************************************************/
#include "default.h"
/*****************************************************************************/
/*                    |_ Reboot                                              */
/*****************************************************************************/
#include "rbnosv.h"
/*****************************************************************************/
/*           |_ Firewall                                                     */
/*****************************************************************************/
/*****************************************************************************/
/*                    |_ Packet Filtering                                    */
/*****************************************************************************/
#include "pf.h"
/*****************************************************************************/
/*                    |_ Intrusion Detection                                 */
/*****************************************************************************/
#include "blk_hack.h"
/*****************************************************************************/
/*                    |_ Block WAN Request                                   */
/*****************************************************************************/
#include "blockwan.h"
/*****************************************************************************/
/*           |_ VPN                                                          */
/*****************************************************************************/
/*****************************************************************************/
/*                    |_ PPTP                                                */
/*****************************************************************************/
#include "pptp.h"
/*****************************************************************************/
/*                    |_ IPSEC                                               */
/*****************************************************************************/
#include "ipsec.h"
/*****************************************************************************/
/*           |_ Virtual Server                                               */
/*****************************************************************************/
#include "setvs.h"
/*****************************************************************************/
/*           |_ Advanced                                                     */
/*****************************************************************************/
/*****************************************************************************/
/*                    |_ ADSL                                                */
/*****************************************************************************/
#include "adsl.h"
/*****************************************************************************/
/*                    |_ DNS                                                 */
/*****************************************************************************/
#include "dns_conf.h"
/*****************************************************************************/
/*                    |_ Dynamic DNS                                         */
/*****************************************************************************/
#include "ddns.h"
/*****************************************************************************/
/*                    |_ NAT                                                 */
/*****************************************************************************/
#include "nat_conf.h"
/*****************************************************************************/
/*                    |_ RIP                                                 */
/*****************************************************************************/
#include "rip_conf.h"
/*****************************************************************************/
/*                    |_ UPNP                                                */
/*****************************************************************************/
#include "upnp.h"
/*****************************************************************************/
/*                    |_ Static Route                                        */
/*****************************************************************************/
#include "route.h"
/*****************************************************************************/
/*                    |_ Misc Configuration                                  */
/*****************************************************************************/
#include "misc.h"
/*****************************************************************************/
/*                    |_ Diagnostic Test                                     */
/*****************************************************************************/
#include "diagtest.h"
/*****************************************************************************/
/*                    |_ QOS                                   */
/*****************************************************************************/
#include "qos.h"

/*****************************************************************************/
/*                    |_ Url Filter                                  */
/*****************************************************************************/
#include "urlFlt.h"

/*****************************************************************************/
/*                    |_ Vlan                                  */
/*****************************************************************************/
#include "vlan.h"

/*****************************************************************************/
/*                    |_ ARP                                  */
/*****************************************************************************/
#include "arp.h"
/*****************************************************************************/
/*                    |_ Config                                  */
/*****************************************************************************/
#include "config.h"
/*                    |_ IPSec Filter                                  */
/*****************************************************************************/
/*                    |_ Remote Access                                  */
/*****************************************************************************/
#include "remote.h"
/*****************************************************************************/
/*                    |_ Scan PVC                                            */
/*****************************************************************************/
#include "scanpvc.h"
/*****************************************************************************/
/*                    |_ IGMP                                                */
/*****************************************************************************/
#include "igmp.h"
/*****************************************************************************/
/*                    |_Wireless                                             */
/*****************************************************************************/
#include "wireless.h"
/*****************************************************************************/
/*                    |_locale                                               */
/*****************************************************************************/
#include "locale.h"
/*****************************************************************************/
/*                    |_WanIPChangeAlert                                     */
/*****************************************************************************/
#include "wipca.h"


/*****************************************************************************/
/*       Save Config to Flash                                                */
/*****************************************************************************/
#include "save.h"
//#include "errno.h"
#include "webs.h"

//#define _TMSS_
#ifdef _TMSS_
extern void DefineWebFunctions_TMSS();
#endif
extern void defineMacCnf();
#include "webdefine.h"
/*
 * Define All Web Functions
 */
extern void DefineWebFunctions_WanVod(void);

#define ETC_SYS_STATUS_FILE "/etc/default/config"
extern char* read_file_para_value(char *filename, char *arg1,char *buf);
int checked_function_enabled (char *parameter, webs_t wp, char_t **argv)
{
    char_t buf1[64];
	char_t is_yes[20];
	int i=0;
	strcpy(is_yes,(char *)read_file_para_value(ETC_SYS_STATUS_FILE,parameter,buf1));
 	if(strcmp(is_yes,"yes")==0)
		return websWrite(wp, T(""));
	
	//Then function is not present
	i=atoi(argv[0]);
 	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else
		return websWrite(wp, T("-->"));
}

void DefineWebFunctions() {
	DefineWebFunctions_home();
	DefineWebFunctions_lan();
 	DefineWebFunctions_upgrade();
	//DefineWebFunctions_checkEmail();
	DefineWebFunctions_save();
	DefineWebFunctions_ddns();
	DefineWebFunctions_dns();
	DefineWebFunctions_rbnosv();
	DefineWebFunctions_dhcp();
	DefineWebFunctions_pwdadmin();
	DefineWebFunctions_pwduser();	
	DefineWebFunctions_route();
	DefineWebFunctions_blockwan();
	DefineWebFunctions_blkhack ();
	DefineWebFunctions_MacFilter();
	DefineWebFunctions_PacketFilter();
	DefineWebFunctions_VirtualServer();
	DefineWebFunctions_SecurityLog();
	DefineWebFunctions_SystemLog();
	DefineWebFunctions_WanAdv();
	DefineWebFunctions_wan();
	DefineWebFunctions_timezone();
#ifdef VOIP
	DefineWebFunctions_VoIPLOG();
#endif
	//DefineWebFunctions_upnp();
	DefineWebFunctions_quick();
	DefineWebFunctions_misc();
	DefineWebFunctions_UrlFlt();
	DefineWebFunctions_vlan();
	DefineWebFunctions_WanVod();
	DefineWebFunctions_arp();
	DefineWebFunctions_cfg();
	DefineWebFunctions_remote();
	DefineWebFunctions_scanpvc();
	DefineWebFunctions_igmp();
	DefineWebFunctions_adsl();
	DefineWebFunctions_wireless();
	defineMacCnf();
	DefineWebFunctions_locale();
	//DefineWLANTestFunctions(); // KenWang added 2005/06/03
	DefineWirelessMacFilterConfig(); // KenWang added 2005/06/08
#ifdef _TMSS_
	DefineWebFunctions_TMSS();
#endif
 	DefineWebFunctions_QOS();
#ifdef m_IPSEC
    DefineWebFunctions_IPSec();
#endif
	
#ifdef _SUPPORT_WIPCA_
	DefineWebFunctions_wipca();
#endif
	DefineWebFunctions_QuickVoIP();
	DefineWebFunction_port_status();
	//Define_ADSLStatus_lstat();
	//Define_ATMStatus_atm();
	//Define_LANStatus_lan1();
	//Define_TCPStatus_tcp();
	//Define_PPPStatus_ppp();
	//Define_MACTableStatus_mactable();
	//Define_RouteTableStatus_croute();
	//Define_FactorySetting_default();
	//Define_PPTP_pptp();
	//Define_ADSLAdvancedConf_adslconf();
	//Define_NAT_nat_conf();
 	//Define_RIP_rip_conf();
	//Define_DiagnosticTest_diagtest();

}
