/*
 *  wipca.asp: WAN IP Change Alert
 */
#include "webs.h"
#include "wipca.h"
#include "lan_conf.h"
#include "wan.h"
#include "../iptables-1.2.11/runFunc.h"

extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

WAN_IP_CHANGE_ALERT_CONFIG_DATA wipca_config;

extern char WAN_IP[];
static int Load_Wipca_Config (void);

void resetCurrentWipcaCfg(void)
{
	WAN_IP_CHANGE_ALERT_CONFIG_DATA *d=&wipca_config;
 	memset(d,0,sizeof(WAN_IP_CHANGE_ALERT_CONFIG_DATA));
}

static int wipca_Enable (int eid, webs_t wp, int argc, char_t ** argv)
{
	Load_Wipca_Config();
	if  (wipca_config.enable==0) 
   		return websWrite(wp, T("0"));
  	else
  		return	websWrite(wp, T("1"));
}

static int Alert_Mail_Addr (int eid, webs_t wp, int argc, char_t ** argv)
{
	char_t palertaddr[128];
	Load_Wipca_Config();
	strcpy(palertaddr,wipca_config.alertaddr);
//if (palertaddr!=NULL)
		return  websWrite (wp, T ("%s"), palertaddr);
//	else
//		return  websWrite (wp, T ("%s"), "");
}

static int Alert_Mail_SMTP_Server (int eid, webs_t wp, int argc, char_t ** argv)
{
	char_t palertsmtp[128];
	Load_Wipca_Config();
	strcpy(palertsmtp,wipca_config.alertsmtp);
	//if (palertsmtp==NULL)
		return  websWrite (wp, T ("%s"), palertsmtp);
	//else
	//	return  websWrite (wp, T ("%s"), "");
}
static int Save_Wipca_Config (WAN_IP_CHANGE_ALERT_CONFIG_DATA *d);

static void WIPCA_Form (webs_t wp,char_t * path, char_t * query)
{
	char_t *pEnable;
	char_t *palertaddr;
	char_t *palertsmtp;
	WAN_IP_CHANGE_ALERT_CONFIG_DATA old_wipca;
	char funcNum[4];
	

	
	pEnable = websGetVar(wp, T("EnableWIPCA"), "0");
	memcpy(&old_wipca,&wipca_config,sizeof(WAN_IP_CHANGE_ALERT_CONFIG_DATA));
 	wipca_config.enable=atoi(pEnable); 
	if (wipca_config.enable==1)
	{
		palertaddr = websGetVar(wp, T("alertaddr"), "");
		palertsmtp = websGetVar(wp, T("alertsmtp"), "");
	
   		strcpy(wipca_config.alertaddr,palertaddr);
    	strcpy(wipca_config.alertsmtp,palertsmtp);
	}
	if (memcmp(&old_wipca,&wipca_config,sizeof(WAN_IP_CHANGE_ALERT_CONFIG_DATA)) == 0)  
	{
		if(wipca_config.enable==1)
			websRedirect(wp, T("wipcaEnable.asp"));
		else
			websRedirect(wp, T("wipcaDisable.asp"));
		return;
	}
	Save_Wipca_Config (&wipca_config);
	
	// Now check if need to stop old WIPCA email alert task
	if( (old_wipca.enable!=wipca_config.enable) ||
		(wipca_config.alertsmtp!=old_wipca.alertsmtp) ||
		(wipca_config.alertaddr!=old_wipca.alertaddr) ) 
	{   
		sprintf(funcNum,"%d",FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
	}
	
	// Now check if need to start  WIPCA email alert task
	if(wipca_config.enable==1)
	{   
		char_t str_wanip[20];
		char_t buf1[64];
		
		strcpy(str_wanip,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"WAN_IP=",buf1));
		if(isValidIP(str_wanip))
		{
			if(wipca_config.enable!=old_wipca.enable)
			{
				sprintf(funcNum,"%d",FUNCTION_NUM_WAN_IP_CHANGE_EMAIL_ALERT);
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
			}
		}
		websRedirect(wp, T("wipcaEnable.asp"));
	}
	else
	{
  		websRedirect(wp, T("wipcaDisable.asp"));
	}
}



static int Load_Wipca_Config (void)
{

	FILE *fp;

	resetCurrentWipcaCfg();
	fp=fopen(WIPCA_CFG_FILE,"r");
	if(fp) {
		fscanf(fp,"%d %s %s\n",
				&wipca_config.enable, 
				wipca_config.alertaddr, 
				wipca_config.alertsmtp);
			if(wipca_config.alertaddr[0]=='&')
				wipca_config.alertaddr[0]='\0';
			if(wipca_config.alertsmtp[0]=='&')
				wipca_config.alertsmtp[0]='\0';
		fclose(fp);
	}
	return 0;
}

static int Save_Wipca_Config (WAN_IP_CHANGE_ALERT_CONFIG_DATA *d)
{

	FILE *fp;

	fp=fopen(WIPCA_CFG_FILE,"w");
	if(!fp) {
		return -1;
	}			
	fprintf(fp,"%d %s %s\n",d->enable,
	(d->alertaddr[0]=='\0')?"&":d->alertaddr,
	(d->alertsmtp[0]=='\0')?"&":d->alertsmtp);
	fflush(fp);
	fclose(fp);

	return 0;
}



void DefineWebFunctions_wipca () {
	resetCurrentWipcaCfg();  	
 	Load_Wipca_Config();
	websAspDefine(T("WIPCA_Enable"), wipca_Enable);
	websAspDefine(T("WIPCA_ADDR"), Alert_Mail_Addr);
	websAspDefine(T("WIPCA_SMTP"), Alert_Mail_SMTP_Server);
	websFormDefine(T("wipca"), WIPCA_Form);

}
