/*
 *  wireless.asp: wireless
 */
#include "webs.h"
#include "lan_conf.h"
#include "wan.h"
#include "arp.h"
#include "wireless.h"
#include "../iptables-1.2.11/runFunc.h"
char TxPower[10];
extern void drop_newline(char *str);
extern int checked_function_enabled2 (char *parameter, webs_t wp, char_t **argv);
void resetCurrentWirelessCfg(void);
static int Load_Wireless_Config (void);
static int Save_Wireless_Config (WIRELESS_CONFIG_DATA *d);
static int Load_Wireless_Txpower_Config (void);
static int Save_Wireless_Txpower_Config (void);
static void Wireless_Form(webs_t wp,char_t * path,char_t * query);
static void Wireless_Sec_Disable_Form(webs_t wp,char_t * path,char_t * query);
static void Wireless_Sec_WPA_Form(webs_t wp,char_t * path,char_t * query);
#ifdef _RALINK_WIRELESS_DRIVER_	
static void Wireless_Sec_WPA2_Form(webs_t wp,char_t * path,char_t * query);
#endif
static void Wireless_Sec_WEP_Form(webs_t wp,char_t * path,char_t * query);
static int get_wireless_mac(int eid, webs_t wp, int argc, char_t **argv);
static int get_wireless_status(int eid, webs_t wp, int argc, char_t **argv);
static int get_wireless_version(int eid, webs_t wp, int argc, char_t **argv);
static int is_wireless_enabled (int ejid, webs_t wp, int argc, char_t **argv);
static int is_wireless_connected (int ejid, webs_t wp, int argc, char_t **argv);
static int get_txpower (int ejid, webs_t wp, int argc, char_t **argv);
static int get_txpower (int ejid, webs_t wp, int argc, char_t **argv){
	
	Load_Wireless_Txpower_Config();
	return websWrite(wp, T("%s"),TxPower);
}
static int is_wireless_connected (int ejid, webs_t wp, int argc, char_t **argv){
	FILE *fp; 
	char_t line[255];
	char_t str_mac[255];
	memset(line,0,sizeof(line));
	memset(str_mac,0,sizeof(str_mac));
	Load_Wireless_Config();
	if (wireless_config.Enable==0){
		return websWrite(wp, T("<img src=cross.gif border=0>"));
	}
#ifndef _RALINK_WIRELESS_DRIVER_
	if((fp=fopen("/proc/net/wlan0/info","r"))!=NULL){
		if(fgets(line,255,fp)){
			sscanf(line,"HwAddr = %s\n",str_mac);
		}
		else
			strcpy(str_mac,"");
		fclose(fp);
	}
	else
		strcpy(str_mac,"");
#else
	if((fp=fopen("/proc/rt61ap/info","r"))!=NULL){
		fgets(line,255,fp);
		if(fgets(line,255,fp)){
			sscanf(line,"MacAddress = %s\n",str_mac);
	//		DPRINTF("MacAddress = %s\n",str_mac);
		}
		else
			strcpy(str_mac,"");
		fclose(fp);
	}
	else
		strcpy(str_mac,"");

#endif	
	if (strlen(str_mac)>0)
		return websWrite(wp, T("<img src=tick.gif border=0>"));
	else
		return websWrite(wp, T("<img src=cross.gif border=0>"));

}
static int is_wireless_enabled (int ejid, webs_t wp, int argc, char_t **argv)
{
 	return checked_function_enabled2("WIRELESS=",wp,argv);
}
static int is_qwireless (int ejid, webs_t wp, int argc, char_t **argv)
{// Need for qwireless left page?  This is current for Spray now.  For other, this shall reply comments
	int i;
	i = atoi(argv[0]);
#ifdef _sso_spary
	if(i==3)//comment begin
		return websWrite(wp, T("<!--"));
	else if(i == 4)
		return websWrite(wp, T("-->"));
	else
		return checked_function_enabled2("WIRELESS=",wp,argv);
#else
	if(i==0)//comment begin
		return websWrite(wp, T("<!--"));
	else if(i == 1)
		return websWrite(wp, T("-->"));
	else
		return websWrite(wp, T(""));
#endif
}
static int get_wireless_version(int eid, webs_t wp, int argc, char_t **argv){
	FILE *fp; 
	char_t line[255];
	char_t str_version_name[32];
	char_t str_version[32];
	memset(line,0,sizeof(line));
	memset(str_version_name,0,sizeof(str_version_name));
	memset(str_version,0,sizeof(str_version));
#ifndef _RALINK_WIRELESS_DRIVER_
	if((fp=fopen("/proc/net/wlan0/version","r"))!=NULL){
		if(fgets(line,255,fp)){
			sscanf(line,"version = %s %s\n",str_version_name,str_version);
		//	DPRINTF("version_name:%s\n",str_version_name);
		//	DPRINTF("version:%s\n",str_version);
		}
		else{
			strcpy(str_version_name,"");
			strcpy(str_version,"");
		}
		fclose(fp);
	}
	else{
		strcpy(str_version_name,"");
		strcpy(str_version,"");
	}
	return websWrite(wp,T("%s %s"),str_version_name,str_version);
#else
	#if 0
	if((fp=fopen("/proc/rt61ap/info","r"))!=NULL){
		if(fgets(line,255,fp)){
			sscanf(line,"Version = %s\n",str_version);
			strcpy(str_version_name,"RT2561T");
		//	DPRINTF("version_name:%s\n",str_version_name);
		//	DPRINTF("version:%s\n",str_version);
		}
		else{
			strcpy(str_version_name,"");
			strcpy(str_version,"");
		}
		fclose(fp);
	}
	else{
		strcpy(str_version_name,"");
		strcpy(str_version,"");
	}
	return websWrite(wp,T("%s %s"),str_version_name,str_version);
	#else
	if((fp=fopen("/proc/rt61ap/info","r"))!=NULL){
		if(fgets(line,255,fp)){
			sscanf(line,"Version = %s %s\n",str_version_name,str_version);
		//	DPRINTF("version_name:%s\n",str_version_name);
		//	DPRINTF("version:%s\n",str_version);
		}
		else{
			strcpy(str_version_name,"");
			strcpy(str_version,"");
		}
		fclose(fp);
	}
	else{
		strcpy(str_version_name,"");
		strcpy(str_version,"");
	}
	return websWrite(wp,T("%s %s"),str_version_name,str_version);
	#endif
#endif	

}
static int get_wireless_mac(int eid, webs_t wp, int argc, char_t **argv){

	FILE *fp; 
	char_t line[255];
	char_t str_mac[255];
	memset(line,0,sizeof(line));
	memset(str_mac,0,sizeof(str_mac));
#ifndef _RALINK_WIRELESS_DRIVER_
	if((fp=fopen("/proc/net/wlan0/info","r"))!=NULL){
		if(fgets(line,255,fp)){
			sscanf(line,"HwAddr = %s\n",str_mac);
	//		DPRINTF("HwAddr:%s\n",str_mac);
		}
		else
			strcpy(str_mac,"");
		fclose(fp);
	}
	else
		strcpy(str_mac,"");
#else
	if((fp=fopen("/proc/rt61ap/info","r"))!=NULL){
		fgets(line,255,fp);
		if(fgets(line,255,fp)){
			sscanf(line,"MacAddress = %s\n",str_mac);
		//	DPRINTF("HwAddr:%s\n",str_mac);
		}
		else
			strcpy(str_mac,"");
		fclose(fp);
	}
	else
		strcpy(str_mac,"");

#endif	
	return websWrite(wp,T("%s"),str_mac);

	
}
static int get_wireless_status(int eid, webs_t wp, int argc, char_t **argv){
	if (strcmp(argv[0],"Enable")==0){
		Load_Wireless_Config();
		return websWrite(wp,T("%d"),wireless_config.Enable);
	}
	if (strcmp(argv[0],"Mode")==0)
		return websWrite(wp,T("%d"),wireless_config.Mode);
	if (strcmp(argv[0],"Essid")==0)
		return websWrite(wp,T("%s"),wireless_config.Essid);
	if (strcmp(argv[0],"HIDE_ESSID")==0) // KenWang added 2005/06/14
		return websWrite(wp,T("%d"),wireless_config.HideEssid);
	if (strcmp(argv[0],"RegulationDomain")==0)
		return websWrite(wp,T("%d"),wireless_config.RegulationDomain);
	if (strcmp(argv[0],"ChannelID")==0)
		return websWrite(wp,T("%d"),wireless_config.ChannelID);
	if (strcmp(argv[0],"WDSEnable")==0)
		return websWrite(wp,T("%d"),wireless_config.WDSEnable);
#ifdef _RALINK_WIRELESS_DRIVER_	
	if (strcmp(argv[0],"WDSMAC1")==0)
		return websWrite(wp,T("%s"),wireless_config.WDSMAC1);
	if (strcmp(argv[0],"WDSMAC2")==0)
		return websWrite(wp,T("%s"),wireless_config.WDSMAC2);
	if (strcmp(argv[0],"WDSMAC3")==0)
		return websWrite(wp,T("%s"),wireless_config.WDSMAC3);
	if (strcmp(argv[0],"WDSMAC4")==0)
		return websWrite(wp,T("%s"),wireless_config.WDSMAC4);
#else
	if (strcmp(argv[0],"WDSMAC")==0)
		return websWrite(wp,T("%s"),wireless_config.WDSMAC);
#endif
	if (strcmp(argv[0],"SEC_MODE")==0){
		Load_Wireless_Config();
#ifdef _RALINK_WIRELESS_DRIVER_	
		if (strcmp(wireless_config.Sec_Mode,"WPA")==0){
			return websWrite(wp,T("1"));
		}else if (strcmp(wireless_config.Sec_Mode,"WEP")==0){
			return websWrite(wp,T("2"));
		}else if (strcmp(wireless_config.Sec_Mode,"WPA2")==0){
			return websWrite(wp,T("3"));
		}else{
			return websWrite(wp,T("0"));
		}
#else
		if (!strcmp(wireless_config.Sec_Mode,"WPA"))
			return websWrite(wp,T("1"));
		else if (!strcmp(wireless_config.Sec_Mode,"WEP"))
			return websWrite(wp,T("2"));
		else
			return websWrite(wp,T("0"));
#endif
	}
	if (strcmp(argv[0],"WLAN_SEC_MODE")==0)
		return websWrite(wp,T("%s"),wireless_config.Sec_Mode);
	if (strcmp(argv[0],"WPA_Algorithm")==0)
		return websWrite(wp,T("%s"),wireless_config.WPA_Algorithm);
	if (strcmp(argv[0],"WPA_Shared_Key")==0)
		return websWrite(wp,T("%s"),wireless_config.WPA_Shared_Key);
	if (strcmp(argv[0],"WPA_Group_Key_Renewal")==0)
		return websWrite(wp,T("%d"),wireless_config.WPA_Group_Key_Renewal);
#ifdef _RALINK_WIRELESS_DRIVER_	
	if (strcmp(argv[0],"WPA2_Algorithm")==0)
		return websWrite(wp,T("%s"),wireless_config.WPA2_Algorithm);
	if (strcmp(argv[0],"WPA2_Shared_Key")==0)
		return websWrite(wp,T("%s"),wireless_config.WPA2_Shared_Key);
	if (strcmp(argv[0],"WPA2_Group_Key_Renewal")==0)
		return websWrite(wp,T("%d"),wireless_config.WPA2_Group_Key_Renewal);
#endif
	// KenWang marked 2005/06/14
	//if (strcmp(argv[0],"WPA_Hide_Essid")==0)
	//	return websWrite(wp,T("%d"),wireless_config.WPA_Hide_Essid);
	if (strcmp(argv[0],"WEP_Encryption")==0)
		return websWrite(wp,T("%d"),wireless_config.WEP_Encryption);
	if (strcmp(argv[0],"WEP_Authentication")==0) // KenWang added 2005/06/14
		return websWrite(wp,T("%d"),wireless_config.WEP_Authentication);
	if (strcmp(argv[0],"WEP_Phrase_Type")==0)
		return websWrite(wp,T("%d"),wireless_config.WEP_Phrase_Type);
	if (strcmp(argv[0],"WEP_Keyid")==0)
		return websWrite(wp,T("%d"),wireless_config.WEP_Keyid);
	if (strcmp(argv[0],"WEP_Key1")==0)
		return websWrite(wp,T("%s"),wireless_config.WEP_Key1);
	if (strcmp(argv[0],"WEP_Key2")==0)
		return websWrite(wp,T("%s"),wireless_config.WEP_Key2);
	if (strcmp(argv[0],"WEP_Key3")==0)
		return websWrite(wp,T("%s"),wireless_config.WEP_Key3);
	if (strcmp(argv[0],"WEP_Key4")==0)
		return websWrite(wp,T("%s"),wireless_config.WEP_Key4);
	if (strcmp(argv[0],"WEP_Passphrase")==0)
		return websWrite(wp,T("%s"),wireless_config.WEP_Passphrase);
	// KenWang marked 2005/06/14
	//if (strcmp(argv[0],"WEP_Hide_Essid")==0)
	//	return websWrite(wp,T("%d"),wireless_config.WEP_Hide_Essid);
	else
		return websWrite(wp,T(""));
}
static void Wireless_Sec_Disable_Form(webs_t wp,char_t * path,char_t * query){
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
	Load_Wireless_Config();
	buf = websGetVar(wp, T("wlan_sec_mode"),"");
 	strcpy(wireless_config.Sec_Mode,buf); 
	
	Save_Wireless_Config(&wireless_config);
	
	sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_SEC);		
	sprintf(funcNum1,"%d",FUNCTION_NUM_WIRELESS);		
//	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
//	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum1,NULL);		
	//if (!strcmp(wireless_config.Sec_Mode,"no"))
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
#else
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
#endif	
	websRedirect(wp, T("wireless_security_disable.asp"));

}
static void Wireless_Sec_WEP_Form(webs_t wp,char_t * path,char_t * query){
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
	Load_Wireless_Config();
	
	buf = websGetVar(wp, T("wlan_sec_mode"),"");
 	strcpy(wireless_config.Sec_Mode,buf); 
	buf = websGetVar(wp, T("wep_phrase_type"),"");
 	wireless_config.WEP_Phrase_Type=atoi(buf); 
	// KenWang added 2005/06/14
	buf = websGetVar(wp, T("wep_authentication"),"");
	wireless_config.WEP_Authentication=atoi(buf);	
	buf = websGetVar(wp, T("wep_encryption"),"");
 	wireless_config.WEP_Encryption=atoi(buf); 
	buf = websGetVar(wp, T("keyid"),"");
 	wireless_config.WEP_Keyid=atoi(buf); 
	buf = websGetVar(wp, T("WEP_KEY1"),"");
	strcpy(wireless_config.WEP_Key1,buf);
	buf = websGetVar(wp, T("WEP_KEY2"),"");
	strcpy(wireless_config.WEP_Key2,buf);
	buf = websGetVar(wp, T("WEP_KEY3"),"");
	strcpy(wireless_config.WEP_Key3,buf);
	buf = websGetVar(wp, T("WEP_KEY4"),"");
	strcpy(wireless_config.WEP_Key4,buf);
	buf = websGetVar(wp, T("WEP_PASSPHRASE"),"");
 	strcpy(wireless_config.WEP_Passphrase,buf); 
	// KenWang markded 2005/06/14
	//buf = websGetVar(wp, T("wlan_hide_essid"),"");
 	//wireless_config.WEP_Hide_Essid=atoi(buf); 
	
	Save_Wireless_Config(&wireless_config);
	
	sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_SEC);		
	sprintf(funcNum1,"%d",FUNCTION_NUM_WIRELESS);		
	//run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
	//if (!strcmp(wireless_config.Sec_Mode,"WEP"))
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
#else
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
#endif	
	websRedirect(wp, T("wireless_security2.asp"));


}
static void Wireless_Sec_WPA_Form(webs_t wp,char_t * path,char_t * query){
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
	Load_Wireless_Config();
	
	buf = websGetVar(wp, T("wlan_sec_mode"),"");
 	strcpy(wireless_config.Sec_Mode,buf); 
	buf = websGetVar(wp, T("WPA_SHARED_KEY"),"");
 	strcpy(wireless_config.WPA_Shared_Key,buf); 
#ifdef _RALINK_WIRELESS_DRIVER_	
	buf = websGetVar(wp, T("WPA_Algorithm"),"");
 	strcpy(wireless_config.WPA_Algorithm,buf); 
#endif
	buf = websGetVar(wp, T("WPA_KEY_RENEWAL"),"");
 	wireless_config.WPA_Group_Key_Renewal=atoi(buf); 
	// KenWang marked 2005/06/14
	//buf = websGetVar(wp, T("wlan_hide_essid"),"");
 	//wireless_config.WPA_Hide_Essid=atoi(buf); 
	
	Save_Wireless_Config(&wireless_config);
	
	sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_SEC);		
	sprintf(funcNum1,"%d",FUNCTION_NUM_WIRELESS);		
	//run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
	//if (!strcmp(wireless_config.Sec_Mode,"WPA"))
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
#else
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
#endif	
	websRedirect(wp, T("wireless_security1.asp"));

}
#ifdef _RALINK_WIRELESS_DRIVER_	
static void Wireless_Sec_WPA2_Form(webs_t wp,char_t * path,char_t * query){
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
	Load_Wireless_Config();
	
	buf = websGetVar(wp, T("wlan_sec_mode"),"");
 	strcpy(wireless_config.Sec_Mode,buf); 
	buf = websGetVar(wp, T("WPA_SHARED_KEY"),"");
 	strcpy(wireless_config.WPA2_Shared_Key,buf); 
	buf = websGetVar(wp, T("WPA_Algorithm"),"");
 	strcpy(wireless_config.WPA2_Algorithm,buf); 
	buf = websGetVar(wp, T("WPA_KEY_RENEWAL"),"");
 	wireless_config.WPA2_Group_Key_Renewal=atoi(buf); 
	// KenWang marked 2005/06/14
	//buf = websGetVar(wp, T("wlan_hide_essid"),"");
 	//wireless_config.WPA_Hide_Essid=atoi(buf); 
	
	Save_Wireless_Config(&wireless_config);
	
	sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_SEC);		
	sprintf(funcNum1,"%d",FUNCTION_NUM_WIRELESS);		
	//run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);		
	//if (!strcmp(wireless_config.Sec_Mode,"WPA"))
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
	run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
	websRedirect(wp, T("wireless_security3.asp"));
}
#endif
static void Wireless_Txpower_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char real_txpower[10];
	Load_Wireless_Txpower_Config();
	Load_Wireless_Config();
	buf = websGetVar(wp, T("txpower"),"");
	memset(TxPower,0,sizeof(TxPower));
 	strcpy(TxPower,buf); 
	
	Save_Wireless_Txpower_Config();
	if (wireless_config.Enable==1){
#ifdef _RALINK_WIRELESS_DRIVER_	
		memset(real_txpower,0,sizeof(real_txpower));
		sprintf(real_txpower,"TxPower=%s",TxPower);
		run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv","ra0","set",real_txpower,NULL);
		DPRINTF("/usr/sbin/iwpriv ra0 set %s\n",real_txpower);
#else
		memset(real_txpower,0,sizeof(real_txpower));
		sprintf(real_txpower,"0x%s",TxPower);
		run_task("/usr/sbin/iwpriv","/usr/sbin/iwpriv","wlan0","rftest_power",real_txpower,NULL);
		DPRINTF("/usr/sbin/iwpriv wlan0 rftest_power %s\n",real_txpower);
#endif		
	}	
	websRedirect(wp, T("wireless_txpower.asp"));
}
static void Wireless_Form(webs_t wp,char_t * path,char_t * query)
{
	char_t *buf=NULL;
	char funcNum[4];
	char funcNum1[4];
#ifdef _RALINK_WIRELESS_DRIVER_	
	char line[256];
#endif
	Load_Wireless_Config();
#ifdef _RALINK_WIRELESS_DRIVER_	
	FILE *f=NULL;
#endif
	buf = websGetVar(wp, T("wlan_enable"),"");
 	wireless_config.Enable=atoi(buf); 
	buf = websGetVar(wp, T("wlan_mode"),"");
 	wireless_config.Mode=atoi(buf); 
	buf = websGetVar(wp, T("WLAN_SSID"),"");
 	strcpy(wireless_config.Essid,buf); 
	// KenWang added 2005/06/14
	buf = websGetVar(wp, T("wlan_hide_essid"),"");
	wireless_config.HideEssid = atoi(buf);
	buf = websGetVar(wp, T("wlan_domain"),"");
 	wireless_config.RegulationDomain=atoi(buf); 
	buf = websGetVar(wp, T("wlan_channel"),"");
 	wireless_config.ChannelID=atoi(buf);	
	buf = websGetVar(wp, T("wds_enable"),"");
 	wireless_config.WDSEnable=atoi(buf); 
#ifdef _RALINK_WIRELESS_DRIVER_	
	buf = websGetVar(wp, T("WDS_PEER_MAC1"),"");
 	strcpy(wireless_config.WDSMAC1,buf); 
	buf = websGetVar(wp, T("WDS_PEER_MAC2"),"");
 	strcpy(wireless_config.WDSMAC2,buf); 
	buf = websGetVar(wp, T("WDS_PEER_MAC3"),"");
 	strcpy(wireless_config.WDSMAC3,buf); 
	buf = websGetVar(wp, T("WDS_PEER_MAC4"),"");
 	strcpy(wireless_config.WDSMAC4,buf); 
	unlink("/var/state/temp_wdsmac");
	f=fopen("/var/state/temp_wdsmac","w");
	if(f){
		if(!(!strcmp(wireless_config.WDSMAC1,"00:00:00:00:00:00")||!strcmp(wireless_config.WDSMAC1,"")))
			fprintf(f,"%s\n",wireless_config.WDSMAC1);
		if(!(!strcmp(wireless_config.WDSMAC2,"00:00:00:00:00:00")||!strcmp(wireless_config.WDSMAC2,"")))
			fprintf(f,"%s\n",wireless_config.WDSMAC2);
		if(!(!strcmp(wireless_config.WDSMAC3,"00:00:00:00:00:00")||!strcmp(wireless_config.WDSMAC3,"")))
			fprintf(f,"%s\n",wireless_config.WDSMAC3);
		if(!(!strcmp(wireless_config.WDSMAC4,"00:00:00:00:00:00")||!strcmp(wireless_config.WDSMAC4,"")))
			fprintf(f,"%s\n",wireless_config.WDSMAC4);
		fclose(f);
	}
	f=fopen("/var/state/temp_wdsmac","r");
	if(f){
		if (fgets(line,sizeof(line),f))
			strcpy(wireless_config.WDSMAC1,line);
		else
			strcpy(wireless_config.WDSMAC1,"");
		if (fgets(line,sizeof(line),f))
			strcpy(wireless_config.WDSMAC2,line);
		else
			strcpy(wireless_config.WDSMAC2,"");
		if (fgets(line,sizeof(line),f))
			strcpy(wireless_config.WDSMAC3,line);
		else
			strcpy(wireless_config.WDSMAC3,"");
		if (fgets(line,sizeof(line),f))
			strcpy(wireless_config.WDSMAC4,line);
		else
			strcpy(wireless_config.WDSMAC4,"");
		fclose(f);
		drop_newline(wireless_config.WDSMAC1);
		drop_newline(wireless_config.WDSMAC2);
		drop_newline(wireless_config.WDSMAC3);
		drop_newline(wireless_config.WDSMAC4);
	}
	
	DPRINTF("websconfig:WDSMAC1:%s\n",wireless_config.WDSMAC1);
	DPRINTF("websconfig:WDSMAC2:%s\n",wireless_config.WDSMAC2);
	DPRINTF("websconfig:WDSMAC3:%s\n",wireless_config.WDSMAC3);
	DPRINTF("websconfig:WDSMAC4:%s\n",wireless_config.WDSMAC4);
#else
	buf = websGetVar(wp, T("WDS_PEER_MAC"),"");
 	strcpy(wireless_config.WDSMAC,buf); 
#endif
	
	Save_Wireless_Config(&wireless_config);
	
	sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_SEC);		
	sprintf(funcNum1,"%d",FUNCTION_NUM_WIRELESS);		
	
	if (wireless_config.Enable==1){
#ifndef _RALINK_WIRELESS_DRIVER_		
		run_task("ifconfig","ifconfig","wlan0","up",NULL);
		run_task("brctl","brctl","addif","br0","wlan0",NULL);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
#else
		run_task("ifconfig","ifconfig","ra0","up",NULL);
		run_task("brctl","brctl","addif","br0","ra0",NULL);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum1,NULL);
		run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
#endif		
	}
	else{
#ifndef _RALINK_WIRELESS_DRIVER_		
		run_task("iwpriv","iwpriv","wlan0","nostation","1",NULL);
		run_task("ifconfig","ifconfig","wlan0","down",NULL);
		run_task("brctl","brctl","delif","br0","wlan0",NULL);
		run_task("ifconfig","ifconfig","wlan0wds0","down",NULL);
		run_task("brctl","brctl","delif","br0","wlan0wds0",NULL);
#else
		run_task("ifconfig","ifconfig","ra0","down",NULL);
		run_task("brctl","brctl","delif","br0","ra0",NULL);
#endif		
	}
	websRedirect(wp, T("wireless.asp"));
}

void resetCurrentWirelessCfg(void)
{
	WIRELESS_CONFIG_DATA *d=&wireless_config;
	memset(d,0,sizeof(WIRELESS_CONFIG_DATA));
}

static int Load_Wireless_Txpower_Config (void)
{
	FILE *fp;
#ifdef _RALINK_WIRELESS_DRIVER_	
	fp=fopen("/flash/ralink_txpower.conf","r");
#else
	fp=fopen("/flash/txpower.conf","r");
#endif	
	if(fp) {
		fscanf(fp,"%s\n",TxPower);
		fclose(fp);
	}
	return 1;
}
static int Save_Wireless_Txpower_Config (void)
{
	FILE *fp;
#ifdef _RALINK_WIRELESS_DRIVER_	
	fp=fopen("/flash/ralink_txpower.conf","w");
#else
	fp=fopen("/flash/txpower.conf","w");
#endif	
	
	if(fp) {
		fprintf(fp,"%s\n",TxPower);
		fclose(fp);
	}
	return 1;
}
static int Load_Wireless_Config (void)
{
	FILE *fp;
	resetCurrentWirelessCfg();
	fp=fopen(WIRELESS_CONFIG_FILE,"r");
	if(fp) {
		// KenWang modified 2005/06/14
		//fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%32[^|]|\n",
#ifdef _RALINK_WIRELESS_DRIVER_	
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|\n",
#else
		fscanf(fp,"|%d|%d|%32[^|]|%d|%d|%d|%d|%32[^|]|\n",
#endif
			&wireless_config.Enable,
			&wireless_config.Mode,
			wireless_config.Essid,
			&wireless_config.HideEssid,
			&wireless_config.RegulationDomain,
			&wireless_config.ChannelID,
			&wireless_config.WMM_QOS_Enable,
			&wireless_config.QMM_Power_Saving_Enable,
			&wireless_config.WDSEnable,
#ifdef _RALINK_WIRELESS_DRIVER_	
			wireless_config.WDSMAC1,
			wireless_config.WDSMAC2,
			wireless_config.WDSMAC3,
			wireless_config.WDSMAC4
			);
#else
			wireless_config.WDSMAC);
#endif
		//fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|%d|\n",
#ifdef _RALINK_WIRELESS_DRIVER_	
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
#else
		fscanf(fp,"|%8[^|]|%16[^|]|%65[^|]|%d|%d|%d|%d|%d|%32[^|]|%32[^|]|%32[^|]|%32[^|]|%128[^|]|\n",
#endif
			wireless_config.Sec_Mode,
			wireless_config.WPA_Algorithm,
			wireless_config.WPA_Shared_Key,
			&wireless_config.WPA_Group_Key_Renewal,
#ifdef _RALINK_WIRELESS_DRIVER_	
			wireless_config.WPA2_Algorithm,
			wireless_config.WPA2_Shared_Key,
			&wireless_config.WPA2_Group_Key_Renewal,
//			&wireless_config.WPA_Hide_Essid,
#endif
			&wireless_config.WEP_Encryption,
			&wireless_config.WEP_Authentication,
			&wireless_config.WEP_Phrase_Type,
			&wireless_config.WEP_Keyid,
			wireless_config.WEP_Key1,
			wireless_config.WEP_Key2,
			wireless_config.WEP_Key3,
			wireless_config.WEP_Key4,
			wireless_config.WEP_Passphrase);
//			&wireless_config.WEP_Hide_Essid);
			
	print_blank_string(&wireless_config.Essid);
#ifdef _RALINK_WIRELESS_DRIVER_	
	print_blank_string(&wireless_config.WDSMAC1);
	print_blank_string(&wireless_config.WDSMAC2);
	print_blank_string(&wireless_config.WDSMAC3);
	print_blank_string(&wireless_config.WDSMAC4);
#else
	print_blank_string(&wireless_config.WDSMAC);
#endif
	print_blank_string(&wireless_config.Sec_Mode);
	print_blank_string(&wireless_config.WPA_Algorithm);
	print_blank_string(&wireless_config.WPA_Shared_Key);
#ifdef _RALINK_WIRELESS_DRIVER_	
	print_blank_string(&wireless_config.WPA2_Algorithm);
	print_blank_string(&wireless_config.WPA2_Shared_Key);
#endif
	print_blank_string(&wireless_config.WEP_Key1);
	print_blank_string(&wireless_config.WEP_Key2);
	print_blank_string(&wireless_config.WEP_Key3);
	print_blank_string(&wireless_config.WEP_Key4);
	print_blank_string(&wireless_config.WEP_Passphrase);
		fclose(fp);
	}
	return 0;
}

static int Save_Wireless_Config (WIRELESS_CONFIG_DATA *d)
{
	FILE *fp;
	fp=fopen(WIRELESS_CONFIG_FILE,"w");
	if(fp) {
	load_blank_string(&d->Essid);
#ifdef _RALINK_WIRELESS_DRIVER_	
	load_blank_string(&d->WDSMAC1);
	load_blank_string(&d->WDSMAC2);
	load_blank_string(&d->WDSMAC3);
	load_blank_string(&d->WDSMAC4);
#else
	load_blank_string(&d->WDSMAC);
#endif
	load_blank_string(&d->Sec_Mode);
	load_blank_string(&d->WPA_Algorithm);
	load_blank_string(&d->WPA_Shared_Key);
#ifdef _RALINK_WIRELESS_DRIVER_	
	load_blank_string(&d->WPA2_Algorithm);
	load_blank_string(&d->WPA2_Shared_Key);
#endif
	load_blank_string(&d->WEP_Key1);
	load_blank_string(&d->WEP_Key2);
	load_blank_string(&d->WEP_Key3);
	load_blank_string(&d->WEP_Key4);
	load_blank_string(&d->WEP_Passphrase);
		// KenWang modified 2005/06/14
		//fprintf(fp,"|%d|%d|%s|%d|%d|%d|%s|\n",
#ifdef _RALINK_WIRELESS_DRIVER_	
		fprintf(fp,"|%d|%d|%s|%d|%d|%d|%d|%d|%d|%s|%s|%s|%s|\n",
#else
		fprintf(fp,"|%d|%d|%s|%d|%d|%d|%d|%s|\n",
#endif
			d->Enable,
			d->Mode,
			d->Essid,
			d->HideEssid,
			d->RegulationDomain,
			d->ChannelID,
			d->WMM_QOS_Enable,
			d->QMM_Power_Saving_Enable,
			d->WDSEnable,
#ifdef _RALINK_WIRELESS_DRIVER_	
			d->WDSMAC1,
			d->WDSMAC2,
			d->WDSMAC3,
			d->WDSMAC4
			);
#else
			d->WDSMAC);
#endif
		//fprintf(fp,"|%s|%s|%s|%d|%d|%d|%d|%d|%s|%s|%s|%s|%s|%d|\n",
#ifdef _RALINK_WIRELESS_DRIVER_	
		fprintf(fp,"|%s|%s|%s|%d|%s|%s|%d|%d|%d|%d|%d|%s|%s|%s|%s|%s|\n",
#else
		fprintf(fp,"|%s|%s|%s|%d|%d|%d|%d|%d|%s|%s|%s|%s|%s|\n",
#endif
			d->Sec_Mode,
			d->WPA_Algorithm,
			d->WPA_Shared_Key,
			d->WPA_Group_Key_Renewal,
#ifdef _RALINK_WIRELESS_DRIVER_	
			d->WPA2_Algorithm,
			d->WPA2_Shared_Key,
			d->WPA2_Group_Key_Renewal,
#endif
//			d->WPA_Hide_Essid,			// KenWang marked 2005/06/14
			d->WEP_Encryption,
			d->WEP_Authentication,
			d->WEP_Phrase_Type,
			d->WEP_Keyid,
			d->WEP_Key1,
			d->WEP_Key2,
			d->WEP_Key3,
			d->WEP_Key4,
			d->WEP_Passphrase);
//			d->WEP_Hide_Essid);			// KenWang marked 2005/06/14
		fclose(fp);
	}
	return 0;
}
static int wireless_maclist(int eid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	char_t line[255];
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("iwsta","iwsta","ra0","stalist",NULL);
#else
	run_task("iwsta","iwsta","wlan0","stalist",NULL);
#endif	
	int i,num=0,j=0,have_ip=0;

	if((f=fopen(SYS_ARP_CONF,"r"))!=0){
		fgets(line, 1024, f);
		for(i=0;i<MAX_ARP;i++){	
			if(fgets(line, 1024, f)){
				num++;
			sscanf(line,"%s %s %s %s %s %s\n",
				arp_config[i].IP,
				arp_config[i].HW_Type,
				arp_config[i].Flags,
				arp_config[i].HW_Address,
				arp_config[i].Mask,
				arp_config[i].Device);
			}
	}
	fclose(f);
	}
	
	f=fopen("/var/tmp/mac_list","r");
	if(f){
		while(fgets(line,255,f)){
			have_ip=0;
			for(j=0;j<num;j++){
				if(!strncmp(line,arp_config[j].HW_Address,17)){
					have_ip++;
					drop_newline(arp_config[j].IP);
					drop_newline(arp_config[j].HW_Address);
					websWrite(wp,T("<TR><TD>%s</TD><TD>%s</TD></TR>\n"),arp_config[j].IP,arp_config[j].HW_Address);
				break;
				}
			}
			if(have_ip==0){
				drop_newline(line);
				websWrite(wp,T("<TR><TD>unknown</TD><TD>%s</TD></TR>\n"),line);
			}
		}
		fclose(f);
	}
	
	return 1;
}

// KenWang marked 2005/06/07: moved to wireless_macfilter.c
#if 0
static int get_wireless_maclist(int eid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	char_t line[255];
	run_task("iwsta","iwsta","wlan0","stalist",NULL);
	int i,num=0,j=0,have_ip=0,k=0;
	char_t buf1[32];
	char_t str_lanif[32];
	strcpy(str_lanif,(char *)read_file_para_value(VAR_SYS_STATUS_FILE,"LAN_IF=",buf1));

	if((f=fopen(SYS_ARP_CONF,"r"))!=0){
		fgets(line, 1024, f);
		for(i=0;i<MAX_ARP;i++){	
			if(fgets(line, 1024, f)){
				num++;
			sscanf(line,"%s %s %s %s %s %s\n",
				arp_config[i].IP,
				arp_config[i].HW_Type,
				arp_config[i].Flags,
				arp_config[i].HW_Address,
				arp_config[i].Mask,
				arp_config[i].Device);
				drop_newline(arp_config[i].IP);
				drop_newline(arp_config[i].HW_Address);
				if(strncmp(str_lanif,arp_config[i].Device,"3")==0){
				k++;
				if (k==1){
				websWrite(wp,T("<TR><TD><input type=radio name=mac value=%s checked>%s</td><td>%s</TD></TR>\n"),
					arp_config[i].HW_Address,
					arp_config[i].HW_Address,
					arp_config[i].IP
					);
				
				}else{
					websWrite(wp,T("<TR><TD><input type=radio name=mac value=%s>%s</td><td>%s</TD></TR>\n"),
					arp_config[i].HW_Address,
					arp_config[i].HW_Address,
					arp_config[i].IP
					);
				}
				}
			}
	}
	fclose(f);
	
	f=fopen("/var/tmp/mac_list","r");
	if(f){
		while(fgets(line,255,f)){
			have_ip=0;
			for(j=0;j<num;j++){
				if(!strncmp(line,arp_config[j].HW_Address,17)){
					have_ip++;
					/*
					websWrite(wp,T("<TR><TD><input type=radio name=mac value=%s>%s</td><td>%s</TD></TR>\n"),
					arp_config[j].HW_Address,
					arp_config[j].HW_Address,
					arp_config[j].IP
					);
					*/
				break;
				}
			}
			if(have_ip==0){
				drop_newline(line);
				if(k==0){
				websWrite(wp,T("<TR><TD><input type=radio name=mac value=%s checked>%s</td><td>unknown</TD></TR>\n"),
					line,
					line
				);
				}else{
					websWrite(wp,T("<TR><TD><input type=radio name=mac value=%s>%s</td><td>unknown</TD></TR>\n"),
					line,
					line
				);
				}
			}
		}
		fclose(f);
	}
	}
	return 1;		
}
#endif

static int reload_wireless_config (int ejid, webs_t wp, int argc, char_t **argv){
	 Load_Wireless_Config();
	 return 1;
}
void DefineWebFunctions_wireless() {
	websAspDefine(T("get_wireless_status"), get_wireless_status);
	websAspDefine(T("get_txpower"), get_txpower);
	websAspDefine(T("reload_wireless_config"),reload_wireless_config);
//	websAspDefine(T("get_wireless_maclist"), get_wireless_maclist);
	websAspDefine(T("is_wireless_enabled"), is_wireless_enabled);
	websAspDefine(T("get_wireless_mac"), get_wireless_mac);
	websAspDefine(T("get_wireless_version"), get_wireless_version);
	websAspDefine(T("wireless_maclist"), wireless_maclist);
	websAspDefine(T("is_wireless_connected"), is_wireless_connected);
	websAspDefine(T("is_qwireless"), is_qwireless);
	websFormDefine(T("txpower"), Wireless_Txpower_Form);
	websFormDefine(T("wireless"), Wireless_Form);
	websFormDefine(T("wireless_sec_wpa"), Wireless_Sec_WPA_Form);
#ifdef _RALINK_WIRELESS_DRIVER_	
	websFormDefine(T("wireless_sec_wpa2"), Wireless_Sec_WPA2_Form);
#endif
	websFormDefine(T("wireless_sec_wep"), Wireless_Sec_WEP_Form);
	websFormDefine(T("wireless_sec_disable"), Wireless_Sec_Disable_Form);
}
