/*
 *  wireless_macfilger: Wireless Mac Filter Configuration
 */
#include "webs.h"
#include "pf_conf.h"
#include "pf.h"
#include "filem.h"
#include "lan_conf.h"
#include "wan.h"
#include "arp.h"
#include "../iptables-1.2.11/runFunc.h"
#include "locale.h"
extern char *MACFiler_L1[];
extern char *MACFiler_L2[];
extern char *MACFiler_L3[];
extern char *MACFiler_L4[];
extern char *MACFiler_L5[];
extern char *MACFiler_L6[];
extern char *MACFiler_L7[];
extern char *MACFiler_L8[];
extern char *MACFiler_L9[];
extern char *MACFiler_L10[];
extern char *MACFiler_L11[];

extern void drop_newline(char *);
extern void run_task(char *cmd, ...);
extern char* read_file_para_value(char *filename, char *arg1,char *buf);

#define WIRELESS_MAC_LIST_LENGTH	1024
#define WIRELESS_MF_FILE		"/var/tmp/wireless_macfilter_list"

static int MF_MACdfRule = 1;
void DefineMacWirelessFilterConfig();

extern void run_task(char *cmd, ...);
static int GetWirelessConfigToMFTable(MF_TABLE_T *table);
static int SetWirelessMFTableToConfig(MF_TABLE_T *table);
static void CreateWirelessMFTableToFile(MF_TABLE_T *table);
// web pages function
static int wireless_MF1_fwNow(int eid, webs_t wp, int argc, char_t **argv);
static int aspMF1_fwNow2(void);
static int wireless_MF1_Page(int eid, webs_t wp, int argc, char_t **argv);
static void wireless_MF1(webs_t wp, char_t *path, char_t *query);
extern char_t *SelectListOption( char_t **Option_List, int num, int who);
static int get_wireless_maclist(int eid, webs_t wp, int argc, char_t **argv);
static int wireless_filter_action(int eid, webs_t wp, int argc, char_t **argv);
static int wireless_mfList(int eid, webs_t wp, int argc, char_t **argv);
static void wireless_mf(webs_t wp, char_t *path, char_t *query);
static int get_wireless_MFdfRule(int eid, webs_t wp, int argc, char_t **argv);
/*
 * Mac filter function
 */
extern int MF_Table_Init(MF_TABLE_T *table);
extern int MF_AddRule(MF_TABLE_T *table, MF_RULE_T *rule);
extern int MF_DelRule(MF_TABLE_T *table, int item);
extern int MF_AdjustTable(MF_TABLE_T *table);
extern int MF_SetRule(MF_TABLE_T *table, MF_RULE_T *rule, int item);
extern int MF_CopyTable(MF_TABLE_T *DstTable, MF_TABLE_T *SrcTable);
extern int mfilterIfAnyRulesActive(MF_TABLE_T *table);

static MF_TABLE_T MF_Table, MF_TableShow;

void DefineWirelessMacFilterConfig()
{
	MF_Table_Init(&MF_Table);
	MF_Table_Init(&MF_TableShow);
	GetWirelessConfigToMFTable(&MF_Table);
	GetWirelessConfigToMFTable(&MF_TableShow);
	
	if(mfilterIfAnyRulesActive(&MF_Table))
		CreateWirelessMFTableToFile(&MF_Table);
	else
	{
		if(MF_MACdfRule == 2)
#ifdef _RALINK_WIRLESS_DRIVER_
			unlink(WIRELESS_MF_FILE);
#else
			unlink("/var/tmp/wireless_macfilter_list");
#endif
	}
	websAspDefine(T("wireless_filter_action"), wireless_filter_action);
	websAspDefine(T("wireless_mfList"), wireless_mfList);
	websFormDefine(T("wireless_mf"), wireless_mf);
	
	websAspDefine(T("wireless_MF_Table"), wireless_MF1_Page);
	websFormDefine(T("wireless_mf1"), wireless_MF1);
	websAspDefine(T("wireless_fwNow1"), wireless_MF1_fwNow);
	websAspDefine(T("get_wireless_maclist"), get_wireless_maclist); 
	websAspDefine(T("get_wireless_MFdfRule"), get_wireless_MFdfRule);
}

static int wireless_filter_action(int eid, webs_t wp, int argc, char_t **argv){
char_t *TableFmt =
"\t<SELECT name=MACdfRule>\n"
"\t\t%s"
"\t</SELECT>\n";
const int PolicyNum=2;
char_t *PolicyList[]={MACFiler_L1[locale_config.locale], MACFiler_L2[locale_config.locale]};

return	websWrite(wp, T(TableFmt),	SelectListOption(PolicyList,PolicyNum ,MF_MACdfRule-1 ));

}

static int wireless_mfList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytes=0, i=0;
	
	char_t MacAddress[1][20]={{0}};
	char_t *TableFmt="<tr><td><input type=\"radio\" name=\"Idx\" value=\"%d\" %s></td>"
		    "<td>&nbsp;%d&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td>"
		    "<td>&nbsp;%s&nbsp;</td></tr>\n";
	MF_RULE_T *rule;
		
	for( i = 0; i < MF_TableShow.TotalNum; i++)
	{
		rule=&MF_TableShow.Rule[i];
		if( rule->Item != 0)
		{
			sprintf(MacAddress[0], "%s" ,rule->MAC_Filter_Address);
		
			nBytes += websWrite(wp, T(TableFmt),
			i+1,
			(i == aspMF1_fwNow2() ? "checked" : ""),
			i+1,
			(rule->Active == PF_Act_NO ? MACFiler_L3[locale_config.locale] : MACFiler_L4[locale_config.locale]),
			(rule->Action == PF_Action_DROP ? MACFiler_L2[locale_config.locale]: MACFiler_L1[locale_config.locale]),
			(rule->Log == PF_Log_NO ? MACFiler_L3[locale_config.locale] : MACFiler_L4[locale_config.locale]),
			MacAddress[0]			
			);
		}// end if
	}
	return nBytes;
}

static enum ClickOption MF_Func = Click_Func_CENCEL;
static int MF_Edit_Index = 0;

static void wireless_mf(webs_t wp, char_t *path, char_t *query)
{
	char_t *fwFUNC, *Idx, *DefaultPolicy;
	DefaultPolicy = websGetVar(wp, T("MACdfRule"),"");
	MF_MACdfRule = atoi(DefaultPolicy);
	fwFUNC = websGetVar(wp, T("fwFUNC"), "");
	MF_Func = atoi(fwFUNC);
	Idx = websGetVar(wp, T("Idx"), "");
	MF_Edit_Index = atoi(Idx);
	--MF_Edit_Index;
	websHeader(wp);
	switch(MF_Func)
	{
		case Click_Func_ADD:
		if(MF_TableShow.NextItem < MAX_CLIENT_MACFILTER_ENTRY)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_EDIT:
		//websWrite(wp, T("<body><h2>EDIT: %d, Idx: %s</h2>\n"),Func, Idx);
		if(MF_Edit_Index >= 0)
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter1.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else// no select an item
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_DEL:
		if(MF_Edit_Index >= 0)
		{
			MF_DelRule(&MF_TableShow, MF_Edit_Index);
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		else
		{
			websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
			websFooter(wp);
			websDone(wp, 200);
		}
		break;
		case Click_Func_APPLY:
		{
#ifdef _RALINK_WIRELESS_DRIVER_			

			run_task("iwpriv","iwpriv","ra0","set","AccessPolicy=0",NULL);
			DPRINTF("iwpriv ra0 set AccessPolicy=0\n");
			unlink(WIRELESS_MF_FILE);

			SetWirelessMFTableToConfig(&MF_TableShow);
			MF_CopyTable(&MF_Table, &MF_TableShow);
			if(mfilterIfAnyRulesActive(&MF_Table))
			{
				CreateWirelessMFTableToFile(&MF_Table);
				char 	funcNum[4];
				sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_MAC_FILTER);
				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "start",funcNum,NULL);
				//run_task("/usr/sbin/iwsta", "/usr/sbin/iwsta", "wlan0", "macfilter", action, NULL);
			}
			else
			{ 
				/* no rule is active and default rule is DROP, then block all! */
                if(MF_MACdfRule == 1)
                { 
                    unlink(WIRELESS_MF_FILE);
                    run_task("iwpriv", "iwpriv", "ra0", "set", "AccessPolicy=0", NULL);
                    DPRINTF("iwpriv ra0 set AccessPolicy=0\n");
                }    
                //#b028 added 28-12-06 so that it knows how to set  default rule back to Forward 
                                
				if(MF_MACdfRule == 2)
				{
					/* only allow client mac 00:00:00:00:00:00 connect to AP */
					unlink(WIRELESS_MF_FILE);
					run_task("iwpriv", "iwpriv", "ra0", "set", "AccessPolicy=1", NULL);
					DPRINTF("iwpriv ra0 set AccessPolicy=1\n");
//				sprintf(funcNum,"%d",FUNCTION_NUM_WIRELESS_MAC_FILTER);
//				run_task("/usr/sbin/runFunc","/usr/sbin/runFunc", "stop",funcNum,NULL);
//					run_task("/usr/sbin/iwsta", "/usr/sbin/iwsta", "wlan0", "macfilter", "1", NULL);
				}
			}
		}
#else
			char action[4];

			run_task("iwsta","iwsta","wlan0","macfilter","0",NULL);
			unlink(WIRELESS_MF_FILE);

			SetWirelessMFTableToConfig(&MF_TableShow);
			MF_CopyTable(&MF_Table, &MF_TableShow);
			if(mfilterIfAnyRulesActive(&MF_Table))
			{
				if(MF_MACdfRule == 1)
					sprintf(action, "%d", 2);
				if(MF_MACdfRule == 2)
					sprintf(action, "%d", 1);
				CreateWirelessMFTableToFile(&MF_Table);
				run_task("/usr/sbin/iwsta", "/usr/sbin/iwsta", "wlan0", "macfilter", action, NULL);
			}
			else
			{ 
				/* no rule is active and default rule is DROP, then block all! */
				if(MF_MACdfRule == 2)
				{
					/* only allow client mac 00:00:00:00:00:00 connect to AP */
#ifdef _RALINK_WIRLESS_DRIVER_
					unlink(WIRELESS_MF_FILE);
#else
					unlink("/var/tmp/wireless_macfilter_list");
#endif
					run_task("/usr/sbin/iwsta", "/usr/sbin/iwsta", "wlan0", "macfilter", "1", NULL);
				}
			}
		}
				
#endif		
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;

		case Click_Func_CENCEL:
		MF_CopyTable(&MF_TableShow, &MF_Table);
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
		websFooter(wp);
		websDone(wp, 200);
		break;
		default:
			websRedirect(wp, T("/wireless_macfilter.asp"));
	}
}

// for macf1.asp
// macf1, rule number
static int wireless_MF1_fwNow(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(MF_Func)
	{
		case Click_Func_ADD:
			return websWrite(wp, T("%d"), MF_TableShow.NextItem);
		case Click_Func_EDIT:
			return websWrite(wp, T("%d"), MF_Edit_Index);
		default:
			return websWrite(wp, T("%d"), MF_TableShow.NextItem);
	}
}
static int aspMF1_fwNow2(void)
{
	switch(MF_Func)
	{
		case Click_Func_EDIT:
		return MF_Edit_Index;
		default:
		return MF_TableShow.TotalNum-1;
	}
}
////// for macf1.asp table format
static int wireless_MF1_Page(int eid, webs_t wp, int argc, char_t **argv)
{
char_t *mf1_TableFmt1 =
"<TR><TD colSpan=2>%s %d</TD></TR>\n";
char_t *mf1_TableFmt2 =
"\t<TR>\n"
"\t\t<TD class=title width=100>%s</TD>\n"
"\t\t<TD class=title1 width=300>\n"
"\t\t\t<SELECT name=fltrRE>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt3 =
"\t<TR>\n"
"\t\t<TD class=title>%s</TD>\n"
"\t\t<TD class=title1>\n"
"\t\t\t<SELECT name=fltrFD onChange='SetLog(this.selectedIndex);'>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt3_1 =
"\t<TR>\n"
"\t\t<TD class=title width=100>%s</TD>\n"
"\t\t<TD class=title1 width=300>\n"
"\t\t\t<SELECT name=fltrLE>\n"
"\t\t\t\t%s"
"\t\t\t</SELECT>\n"
"\t\t</TD>\n"
"\t</TR>\n";
char_t *mf1_TableFmt4 =
"\t<TR>\n"
"\t\t<TD class=title>%s</TD>\n"
"\t\t<TD class=title1>\n"
"\t\t\t<INPUT type=text name=fltrMacAddressFrom maxlength=17 size=17 value=%s><A HREF='javascript:maclist()'> %s <img align=middle vspace=0 hspace=0 border=0 hspace=0 vspace=0 src=link1.gif></a>\n"
"\t\t</TD>\n"
"\t</TR>\n";

const int ActiveNum=2, ActiveDefault=1; 
char_t *ActiveList[]={MACFiler_L3[locale_config.locale] , MACFiler_L4[locale_config.locale]};
const int ActionNum=2/*, ActionDefault=0*/; 
char_t *ActionList[]={MACFiler_L2[locale_config.locale], MACFiler_L1[locale_config.locale]};
const int LogNum=2, LogDefault=1; 
char_t *LogList[]={MACFiler_L3[locale_config.locale] , MACFiler_L4[locale_config.locale]};
char_t *MacAddress;
	MF_RULE_T *rule;

	switch(MF_Func)
	{
		case Click_Func_ADD:
			websWrite(wp, T(mf1_TableFmt1), MACFiler_L5[locale_config.locale], MF_TableShow.NextItem+1);
			websWrite(wp, T(mf1_TableFmt2), MACFiler_L6[locale_config.locale], SelectListOption(ActiveList, ActiveNum, ActiveDefault));
			websWrite(wp, T(mf1_TableFmt3), MACFiler_L7[locale_config.locale], SelectListOption(ActionList, ActionNum, MF_MACdfRule-1));
			websWrite(wp, T(mf1_TableFmt3_1), MACFiler_L8[locale_config.locale], SelectListOption(LogList, LogNum, LogDefault));
			websWrite(wp, T(mf1_TableFmt4), MACFiler_L9[locale_config.locale], "",MACFiler_L11[locale_config.locale]);
			break;
		case Click_Func_EDIT:
		rule=&MF_TableShow.Rule[MF_Edit_Index];
			websWrite(wp, T(mf1_TableFmt1), MACFiler_L5[locale_config.locale], MF_Edit_Index+1);
			websWrite(wp, T(mf1_TableFmt2), MACFiler_L6[locale_config.locale], SelectListOption(ActiveList, ActiveNum, rule->Active));
			websWrite(wp, T(mf1_TableFmt3), MACFiler_L7[locale_config.locale], SelectListOption(ActionList, ActionNum, rule->Action));
			websWrite(wp, T(mf1_TableFmt3_1), MACFiler_L8[locale_config.locale], SelectListOption(LogList, LogNum, rule->Log));
				MacAddress = rule->MAC_Filter_Address;
			websWrite(wp, T(mf1_TableFmt4), MACFiler_L9[locale_config.locale], MacAddress,MACFiler_L11[locale_config.locale]);
			break;
		default:
		
		break;
	}
	return 0;
}

// for form maf1.asp
static void wireless_MF1(webs_t wp, char_t *path, char_t *query)
{
	char_t *mfwNow, *mfltrRE, *mfltrFD, *mfltrLE;

	char_t *mfltrMacAddressFrom;
	char_t *mfwFUNC;

	MF_RULE_T rule;
	memset(&rule, 0, sizeof(MF_RULE_T));

	mfwFUNC = websGetVar(wp, T("fwFUNC"), "0");
	mfwNow = websGetVar(wp, T("fwNow"), "0");
	mfltrRE = websGetVar(wp, T("fltrRE"), "0");
	mfltrFD = websGetVar(wp, T("fltrFD"), "0");
	mfltrLE = websGetVar(wp, T("fltrLE"), "1");
	mfltrMacAddressFrom = websGetVar(wp, T("fltrMacAddressFrom"), "0");
	
	rule.Item = atoi(mfwNow)+1; //0
	rule.Active = atoi(mfltrRE)-1;//1
	rule.Action = atoi(mfltrFD)-1;//4
	/* if default rule is "Forward" and rule action is also "Forward", set Log to "No" and vice versa */
	/* because we have problem to log messages in these cases */
	rule.Log = atoi(mfltrLE)-1;//
	strcpy(rule.MAC_Filter_Address,mfltrMacAddressFrom);
	
	websHeader(wp);
	
	if ( atoi(mfwFUNC) == 6 )
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter1.asp\");</script>"));
	else {
		switch(MF_Func)	{
			case Click_Func_ADD:
				MF_AddRule(&MF_TableShow, &rule);
				break;
			case Click_Func_EDIT:
				MF_SetRule(&MF_TableShow, &rule, rule.Item-1);
				break;
			default:
			break;
		}
		websWrite(wp, T("<script language=\"JavaScript\">location.replace(\"/wireless_macfilter.asp\");</script>"));
	}

	websFooter(wp);
	websDone(wp, 200);

}// end formMF1

// copy Config to MF_Table
static int GetWirelessConfigToMFTable(MF_TABLE_T *table)
{
	int i;
	MF_RULE_T rule;
	FILE *fp;

	fp = fopen("/flash/wireless_mf.conf", "r");
	if (!fp) {
		return -1;
	}
	fscanf(fp,"|%d|\n",&MF_MACdfRule);
	for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
		//   1       2      3    4
		// |active|action|Log|MAC_Filter_Address|
		if (fscanf(fp,
			"|%d|%d|%d|%17s",
			(int *)&rule.Active, //1
			(int *)&rule.Action, //2
			(int *)&rule.Log, //3
			rule.MAC_Filter_Address//4
			) < 0 )  break;
		rule.Item = i+1; //0
		MF_AddRule(table, &rule);
		fgetc(fp);
	}
	fclose(fp);
	return 0;
}

static int SetWirelessMFTableToConfig(MF_TABLE_T *table)
{
	int i;
	MF_RULE_T *rule;
	FILE *fp;

	fp = fopen("/flash/wireless_mf.conf", "w");
	if (!fp) {
		return -1;
	}
	fprintf(fp,"|%d|\n",MF_MACdfRule);

	for(i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
		rule = &(table->Rule[i]);
		if( rule->Item != 0 ) {
			/* If default rule is "DROP" and rule Action is also "DROP", or default rule is "FORWARD" */
			/* and rule Action is also "FORWARD", set Log to "NO".*/
			/* Because we have problem to log messages in these cases */
			if((MF_MACdfRule == 1 && rule->Action == 1) || (MF_MACdfRule == 2 && rule->Action == 0))
				rule->Log = PF_Log_NO;
			//   1       2      3    4
			// |active|action|Log|MAC_Filter_Address|
			fprintf(fp,
				"|%d|%d|%d|%s\n",
				rule->Active, //1
				rule->Action, //2
				rule->Log, //3
				rule->MAC_Filter_Address//4
				);
		}
	}

	fclose(fp);
	
	return 0;
}

static int get_wireless_maclist(int eid, webs_t wp, int argc, char_t **argv){
	FILE *f;
	char_t line[1024];
	int i,num=0,j=0,have_ip=0;//,k=0;
	//MF_RULE_T *rule;
	//unsigned char match = 0;

	if((f=fopen(SYS_ARP_CONF,"r"))!=0){
		fgets(line, 1024, f);
		for(i=0;i<MAX_ARP;i++){	
			if(fgets(line, 1024, f)){
				num++;
			sscanf(line,"%s %s %s %s %s %s\n",
				arp_config[i].IP,
				arp_config[i].HW_Type,
				arp_config[i].Flags,
				arp_config[i].HW_Address,
				arp_config[i].Mask,
				arp_config[i].Device);
				drop_newline(arp_config[i].IP);
				drop_newline(arp_config[i].HW_Address);
			}
		}
		fclose(f);
	}
	else
		return 0;
#ifdef _RALINK_WIRELESS_DRIVER_	
	run_task("iwsta","iwsta","ra0","stalist",NULL);
#else
	run_task("iwsta","iwsta","wlan0","stalist",NULL);
#endif	
	f=fopen("/var/tmp/mac_list","r");
	if(f){
		//k = 0;
		while(fgets(line,1024,f)){
			//k++;
			have_ip=0;
			
#if 0 // Mulder marked 2005-6-30 
			/* if the mac is already in the filter list, do not show it */
			match = 0;
			for(i = 0; i < MF_TableShow.TotalNum; i++)
			{
				rule = &MF_TableShow.Rule[i];
				if(rule->Item != 0)
				{
					if(!strcmp(line, rule->MAC_Filter_Address))
					{
						match = 1;
						break;
					}
				}
			}
			if(match)
				continue;
#endif			
			for(j=0;j<num;j++){
				if(!strncmp(line,arp_config[j].HW_Address,17)){
					have_ip++;
					break;
				}
			}
			if(have_ip==0){
				drop_newline(line);
//				if(k == 1)
					websWrite(wp,T("<tr><td><input type='radio' name='mac' value='%s' onClick=returnIP(this.value)>%s</td><td>unknown</td></tr>\n"),
						line,
						line);
//				else
//					websWrite(wp,T("<tr><td><input type='radio' name='mac' value='%s'>%s</td><td>unknown</td></tr>\n"),
//						line,
//						line);
			}
			else
			{
//				if(k == 1)
					websWrite(wp, T("<tr><td><input type='radio' name='mac' value='%s' onClick=returnIP(this.value)>%s</td><td>%s</td></tr>\n"),
						arp_config[j].HW_Address,
						arp_config[j].HW_Address,
						arp_config[j].IP);
//				else
//					websWrite(wp, T("<tr><td><input type='radio' name='mac' value='%s'>%s</td><td>%s</td></tr>\n"),
//						arp_config[j].HW_Address,
//						arp_config[j].HW_Address,
//						arp_config[j].IP);
			}
		}
		fclose(f);
	}
	return 1;		
}

static void CreateWirelessMFTableToFile(MF_TABLE_T *table)
{
	FILE *fp;
	MF_RULE_T *rule;
	int i;

	fp = fopen(WIRELESS_MF_FILE, "w");
	if(!fp)
	{
#ifdef _RALINK_WIRELESS_DRIVER_			
		DPRINTF("unabled to write %s\n",WIRELESS_MF_FILE);
#else
		DPRINTF("unabled to write wireless_macfilter_list\n");
#endif
		return;
	}

     	for (i = 0; i < MAX_CLIENT_MACFILTER_ENTRY; i++) {
     		rule = &(table->Rule[i]);
		if( rule->Item != 0 ) {
		/* if default rule is Forward, we only add the rule that action is 'Drop' to the list and vice versa. */
       			if( rule->Active == PF_Act_YES && (
						(rule->Action == 0 && MF_MACdfRule == 1) || 
						(rule->Action == 1 && MF_MACdfRule == 2))) {
				fprintf(fp, "%s|%d|\n", rule->MAC_Filter_Address, rule->Log);
			}
		}
	}
	fclose(fp);
}

static int get_wireless_MFdfRule(int eid, webs_t wp, int argc, char_t **argv)
{
	return websWrite(wp, T("%d"), MF_MACdfRule);
}
