/*
 *	Define Wireless LAN Web Pages
 *  wlan.asp
 *  Albert, Nov. 11 2003
 */
#ifndef _WLAN_CONF_H
#define _WLAN_CONF_H

/****************************************************************************
 * includes
 ****************************************************************************/

/****************************************************************************
 * definitions (types)
 ****************************************************************************/
#define OEM_PassPhrase_Flag 		"0"
#define OEM_Wireless_ESSID			"wlan-linux"
#define OEM_Wireless_Channel		"6"
#define OEM_Wireless_Encryption		"0"
#define OEM_Wireless_Key_HexorChar	"0"
#define OEM_Wireless_Key_ID			"0"
#define OEM_Wireless_Key1			""
#define OEM_Wireless_Key2			""
#define OEM_Wireless_Key3			""
#define OEM_Wireless_Key4			""
#define OEM_Wireless_PassPhrase		""
#define OEM_Wireless_Hide_ESSID		"0"

#define WLAN_WEP_NKEYS				4
#define WLAN_WEP_MAXKEYLEN			13
#define WLAN_SSID_MAXLEN			32
// #define WLAN_MAX_SSID_LENGTH		64
#define PASS_PHRASE_MAXLEN			127

#define WLAN_MAX_VERSION_LENGTH		64

typedef struct {
		int Enabled;
		char Essid[WLAN_SSID_MAXLEN+1];
		int Channel_Id;
		int Encryption;
		int Key_Len;
		int Key_HexorChar;
		int Key_Id;
		char WEP_Key[WLAN_WEP_NKEYS][WLAN_WEP_MAXKEYLEN];
		char PassPhraseString[PASS_PHRASE_MAXLEN+1];
		int Hidden_ESSID;
		unsigned char Version[WLAN_MAX_VERSION_LENGTH];
		unsigned long Beacon_Rate;
} WLAN_CONFIG_S;

/****************************************************************************
 * definitions (literals)
 ****************************************************************************/
#define WLAN1_CONFIG_FILE "/flash/wlan1.conf"
#define WLAN_SCRIPT_FILE "/flash/wlan.vars"

/****************************************************************************
 * function prototypes
 ****************************************************************************/
int wlan_conf_save();
int wlan_conf_load();

int wlan_conf_get_status(int *status);
int wlan_conf_get_essid(char id[WLAN_SSID_MAXLEN+1]);
int wlan_conf_get_channel_id(int *id);
int wlan_conf_get_encryption(int *encryption);
int wlan_conf_get_key_len(int *len);
int wlan_conf_get_key_hexorchar(int *hexorchar);
int wlan_conf_get_key_id(int *id);
int wlan_conf_get_wep_key(char key[WLAN_WEP_MAXKEYLEN], int keyid);
int wlan_conf_get_passphrase_string(char str[PASS_PHRASE_MAXLEN+1]);
int wlan_conf_get_hidden_essid(int *hidden);
int wlan_conf_get_version(char ver[WLAN_MAX_VERSION_LENGTH]);
int wlan_conf_get_beacon_rate(unsigned long *rate);

int wlan_conf_set_enabled(int status);
int wlan_conf_set_essid(char id[WLAN_SSID_MAXLEN+1]);
int wlan_conf_set_channel_id(int id);
int wlan_conf_set_encryption(int encryption);
int wlan_conf_set_key_len(int len);
int wlan_conf_set_key_hexorchar(int hexorchar);
int wlan_conf_set_key_id(int id);
int wlan_conf_set_wep_key(char key[WLAN_WEP_MAXKEYLEN], int keyid);
int wlan_conf_set_passphrase_string(char str[PASS_PHRASE_MAXLEN+1]);
int wlan_conf_set_hidden_essid(int hidden);
int wlan_conf_set_version(char ver[WLAN_MAX_VERSION_LENGTH]);
int wlan_conf_set_beacon_rate(unsigned long rate);

void HexToCharString(char hex[], char charstring[], int len);
char HexToChar(char hex[]);

extern void wlan_config_printf();
extern int wlan_conf_on_the_system(void);

#endif /* _WLAN_CONF_H */
