#include "webs.h"

struct WLAN_FCC_STRUCT
{
	char channel[10];
	char datarate[15];
	char rftest_power[10];
	int rftest_mode;
}wlan_fcc;

static void EMI_Channel_Num(int eid, webs_t wp, int argc, char_t **argv);
static void EMI_Test_Mode(int eid, webs_t wp, int argc, char_t **argv);
static void EMI_TX_Rate(int eid, webs_t wp, int argc, char_t **argv);
static void EMI_Tx_Power(int eid, webs_t wp, int argc, char_t **argv);
static void form_emitest(webs_t wp, char_t *path, char_t *query);

void DefineWLANTestFunctions()
{
// ---------------------- for Wireless FCC test -------------------- 
	websAspDefine(T("EMI_Channel_Num"), EMI_Channel_Num);
	websAspDefine(T("EMI_Test_Mode"), EMI_Test_Mode);
	websAspDefine(T("EMI_TX_Rate"), EMI_TX_Rate);
	websAspDefine(T("EMI_Tx_Power"), EMI_Tx_Power);

	websFormDefine(T("emitest"), form_emitest);
}

// ---------------------- for Wireless FCC test -------------------- 
static void EMI_Channel_Num(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp,"%s",wlan_fcc.channel);
}

static void EMI_Test_Mode(int eid, webs_t wp, int argc, char_t **argv)
{
	int mode=-1;
	
	if ( ejArgs(argc, argv, T("%d"), &mode) < 1 ) {
		websError(wp, 400, T("Insufficient args\n"));
		return; 
	}
	if( mode == (wlan_fcc.rftest_mode))
		websWrite(wp, "Checked");
	else
		websWrite(wp, "");
}

static void EMI_TX_Rate(int eid, webs_t wp, int argc, char_t **argv)
{
	char *rate = NULL;
	
	if( ejArgs(argc, argv, T("%s"), &rate) < 1)
	{
		websError(wp, 400, T("Insufficient args\n"));
		return;
	}
	if(!strcmp(rate, wlan_fcc.datarate))
		websWrite(wp, "Selected");
	else
		websWrite(wp, "");
}

static void EMI_Tx_Power(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp,"%s",wlan_fcc.rftest_power);
}

static void do_emitest()
{
	char mode[5];
	sprintf(mode, "%d", wlan_fcc.rftest_mode);
	run_task("/usr/sbin/iwpriv", "/usr/sbin/iwpriv", "wlan0", "domain", "0x40", NULL);
	run_task("/usr/sbin/iwpriv", "/usr/sbin/iwpriv", "wlan0", "channel", wlan_fcc.channel, NULL);
	run_task("/usr/sbin/iwpriv", "/usr/sbin/iwpriv", "wlan0", "datarate", wlan_fcc.datarate, NULL);
	run_task("/usr/sbin/iwpriv", "/usr/sbin/iwpriv", "wlan0", "rftest_power", wlan_fcc.rftest_power, NULL);
	run_task("/usr/sbin/iwpriv", "/usr/sbin/iwpriv", "wlan0", "rftest_mode", mode, NULL);
}

static void form_emitest(webs_t wp, char_t *path, char_t *query)
{
	char_t  * buf;
		
	buf = websGetVar(wp, T("EMI_Channel_Num"), T("0"));
	strcpy(wlan_fcc.channel, buf);
	DPRINTF("EMI channel = %s\n", wlan_fcc.channel);

	buf = websGetVar(wp, T("EMI_Test_Mode"), T("0"));
	wlan_fcc.rftest_mode = atoi(buf);
	DPRINTF("EMI test_mode = %d\n", wlan_fcc.rftest_mode);

	buf = websGetVar(wp, T("EMI_TX_Rate"), T("0"));
	strcpy(wlan_fcc.datarate, buf);
	DPRINTF("EMI datarate = %s\n", wlan_fcc.datarate);

	buf = websGetVar(wp, T("EMI_Tx_Power"), T("0"));
	strcpy(wlan_fcc.rftest_power, buf);
	DPRINTF("EMI test_power = %s\n", wlan_fcc.rftest_power);

	do_emitest();

	websRedirect(wp, T("wireless_test.asp"));
}	

