/*
 *	Suppliment to iwpriv 
 *
 *		Jane Chang, Inprocomm, Inc.
 *      jane@inprocomm.com
 */

/******************************************************************************
Copyright (c) 2000-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/
/* Compile: 
     1. make wireless_tools
     2. gcc iwsta.c libiw.a -lm     (libiw.a is provided by wireless_tools)
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

#include "iwlib.h"
/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/* Backward compatibility */
#ifndef IW_PRIV_TYPE_ADDR
#define IW_PRIV_TYPE_ADDR	0x6000
#endif	/* IW_PRIV_TYPE_ADDR */

#ifndef MAC2STR
#define MAC2STR(a) (a)[0], (a)[1], (a)[2], (a)[3], (a)[4], (a)[5]
#define MACSTR "%02X:%02X:%02X:%02X:%02X:%02X"
#endif

// Sam add for support Ralink
#ifndef _RALINK_WIRELESS_DRIVER_
	#define INPROCOMM	1
#else
	#define RALINK		1
#endif
// End Sam add

#if INPROCOMM
#define IOCTL_GET_STRUCT	(SIOCIWFIRSTPRIV + 9)
#endif

#if RALINK
#define IOCTL_GET_STRUCT	(SIOCIWFIRSTPRIV + 9)
#define RTPRIV_IOCTL_GET_MAC_TABLE (SIOCIWFIRSTPRIV + 0x0F)
#endif


// Sam add for wlan mac filter
#define IOCTL_SET_STRUCT	SIOCIWFIRSTPRIV + 8 
#define WLAN_MAC_FILTER	1
FILE* TTYS0;
#define DPRINTF(args...) \
	TTYS0=fopen("/dev/ttyS0","w"); \
	fprintf(TTYS0,args); \
	fclose(TTYS0) 
/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/
#if INPROCOMM
typedef struct sta_status_ {
        short           aid;         /* STA's unique AID (1 .. 2007) or 0 if not yet assigned */
        unsigned char   adAddr[6];      /* address of associated station */
        unsigned char   auth_state;  /* station status */
        unsigned char   ps_state;    /* station power save status */
        unsigned long assoc_time;
} sta_status_t;
#endif

#if RALINK
typedef struct _COUNTER_HOTSPOT {
    // ULONG           LinkUpTime;
    unsigned long      LastDataPacketTime;
    unsigned long      TotalTxByteCount;
    unsigned long      TotalRxByteCount;
} COUNTER_HOTSPOT, *PCOUNTER_HOTSPOT;

typedef struct _RT_802_11_MAC_ENTRY {
    unsigned char       Addr[6];
    unsigned char       Aid;
    unsigned char       Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
    COUNTER_HOTSPOT HSCounter;
} RT_802_11_MAC_ENTRY, *PRT_802_11_MAC_ENTRY;
                                                                                                                                                                                    
typedef struct _RT_802_11_MAC_TABLE {
    unsigned long       Num;
    // RT_802_11_MAC_ENTRY Entry[MAX_LEN_OF_MAC_TABLE];
    RT_802_11_MAC_ENTRY Entry[64];
} RT_802_11_MAC_TABLE, *PRT_802_11_MAC_TABLE;
#endif



/*
 * Structure used by wlan to store the log.
 */
struct net_stat
{
        unsigned long   txunicastframes;
        unsigned long   txmulticastframes;
        unsigned long   txfragments	;
        unsigned long   txsingleretryframes;
        unsigned long   txmultipleretryframes;
        unsigned long   txretrylimitexceeded;
        unsigned long   txdiscards;
	unsigned long   txbytes;
        unsigned long   rxmulticastframes;
	unsigned long   rxbytes;
        unsigned long   rxfragments	;
        unsigned long   rxfcserrors;
        unsigned long   rxdiscardsnobuffer;
        unsigned long   rxdiscardswepundecr;
};

#if WLAN_MAC_FILTER
#define MAX_SIZE_OF_MACFILTER	16
typedef struct sta_macaddr_s {
	unsigned char addr[6];
} sta_macaddress_t;

typedef struct macfilter_tbl_s
{
	unsigned char macfilter_type;
	unsigned char macfilter_count;
	sta_macaddress_t macaddr_array[MAX_SIZE_OF_MACFILTER];
} macfilter_tbl_t;
macfilter_tbl_t macfilter_tbl;
//macfilter_tbl_t macfilter_tbl={1,6,{{0x00,0xe0,0x98,0xbe,0x16,0xf4},{0x00,0xe0,0x98,0xbe,0x16,0xf5},{0x00,0x0d,0x88,0x8f,0x1f,0xef},{0x00,0x01,0x02,0x03,0x04,0xef},
//{0x00,0x01,0x02,0x03,0x04,0xee},{0x00,0x02,0x00,0x03,0x04,0x05},{},{},{},{},{},{},{},{},{},{}}};

#endif
/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/
#if INPROCOMM
int st_info_ioctl(int skfd,  char *	ifname)
{
        struct iwreq iwr;
        sta_status_t *staS;
	
	FILE *f;
	unlink("/var/tmp/mac_list");

        int i=0, n=128; /*n=128, the maximum AID, define as sMaxAId */


        staS = malloc(sizeof(sta_status_t)*n);
	if (!staS)
	{
		return 1; // malloc fail
	}
	memset(staS,0,sizeof(sta_status_t)*n);
        memset(&iwr, 0, sizeof(iwr));

        strcpy(iwr.ifr_name,ifname);
        iwr.u.data.flags = 1; /* subcmd = StaList*/
        iwr.u.data.pointer = (caddr_t)staS;
        iwr.u.data.length = sizeof(sta_status_t)*n;

        if (ioctl(skfd, IOCTL_GET_STRUCT, &iwr) < 0) {
              perror("ioctl[IOCTL_GET_STRUCT]");
              return -1;
        }

	f=fopen("/var/tmp/mac_list","w");
	if(f){
        for(i=0;i<n;i++)
        {
                if (staS[i].aid) {
                        printf("MAC Addr:"MACSTR"\n",MAC2STR(staS[i].adAddr));
                        fprintf(f,""MACSTR"\n",MAC2STR(staS[i].adAddr));
                }
                else
                        break;
        }
	fclose(f);
	}
	free(staS);
        return 0;
}
#endif

#if RALINK
int st_info_ioctl(int skfd,  char *	ifname)
{
        struct iwreq iwr;
	FILE *f;
	unlink("/var/tmp/mac_list");
	RT_802_11_MAC_TABLE* staS;

        int i=0, n=128; /*n=128, the maximum AID, define as sMaxAId */


        staS = malloc(sizeof(RT_802_11_MAC_TABLE));

	if (!staS)
	{
		return 1; // malloc fail
	}

	memset(staS,0,sizeof(RT_802_11_MAC_TABLE));
        memset(&iwr, 0, sizeof(iwr));

        strcpy(iwr.ifr_name,ifname);
        //iwr.u.data.flags = 1; /* subcmd = StaList*/
        iwr.u.data.pointer = (caddr_t)staS;
        iwr.u.data.length = sizeof(RT_802_11_MAC_TABLE);

        if (ioctl(skfd, RTPRIV_IOCTL_GET_MAC_TABLE, &iwr) < 0) {
              perror("ioctl[RTPRIV_IOCTL_GET_MAC_TABLE]");
              return -1;
        }

	//printf("Return Mac table Num is %d\n",staS->Num);	
	f=fopen("/var/tmp/mac_list","w");
	if(f){
        for(i=0;i<staS->Num;i++)
        {
                if (staS->Entry[i].Aid) {
                        printf("MAC Addr:"MACSTR"\n",MAC2STR(staS->Entry[i].Addr));
                        fprintf(f,""MACSTR"\n",MAC2STR(staS->Entry[i].Addr));

                }
                else
                        break;
        }
	fclose(f);
	}
	free(staS);
        return 0;
}
#endif





int ap_stat_ioctl(int skfd,  char *	ifname)
{
        struct iwreq iwr;
        struct net_stat tmp_stat;
	//        int i=0;
        memset(&tmp_stat,0,sizeof(tmp_stat));
        memset(&iwr, 0, sizeof(iwr));

        strcpy(iwr.ifr_name,ifname);
        iwr.u.data.flags = 50; /* subcmd = ap_statistic*/
        iwr.u.data.pointer = (caddr_t)&tmp_stat;
        iwr.u.data.length = sizeof(tmp_stat);

        if (ioctl(skfd, IOCTL_GET_STRUCT, &iwr) < 0) {
              perror("ioctl[IOCTL_GET_STRUCT]");
              return -1;
        }

        printf("txbyes: %lu\n",tmp_stat.txbytes);
        printf("txunicastframes: %lu\n",tmp_stat.txunicastframes);
        printf("txmulticastframes: %lu\n",tmp_stat.txmulticastframes);
        printf("txfragments: %lu\n",tmp_stat.txfragments);
        printf("txsingleretryframes: %lu\n",tmp_stat.txsingleretryframes);
        printf("txmultipleretryfram: %lu\n",tmp_stat.txmultipleretryframes);
        printf("txretrylimitexceede: %lu\n",tmp_stat.txretrylimitexceeded);
        printf("txdiscards: %lu\n",tmp_stat.txdiscards);
        printf("rxbyes: %lu\n",tmp_stat.rxbytes);
        printf("rxmulticastframes: %lu\n",tmp_stat.rxmulticastframes);
        printf("rxfragments: %lu\n",tmp_stat.rxfragments);
        printf("rxfcserrors: %lu\n",tmp_stat.rxfcserrors);
        printf("rxdiscardswepundecr: %lu\n",tmp_stat.rxdiscardswepundecr);

        return 0;
}

#if WLAN_MAC_FILTER  // Sam add wlan Mac filter
int ap_set_macfilter_ioctl(int skfd, char* ifname,int command)
{
	
	struct iwreq iwr;
	
	if (command > 3 || command < 0 )
		return -1;	

	
	macfilter_tbl.macfilter_type = command;  // 0 for disable mac filter,1 for allow, 2 for deny

	//macfilter_tbl.macfilter_count = ; //MAX_SIZE_OF_MACFILTER;

        memset(&iwr, 0, sizeof(iwr));
        strcpy(iwr.ifr_name,ifname);

	iwr.u.data.flags = 51;  // define in net/wireless/linux/ap_wext.c

        iwr.u.data.pointer = (caddr_t)(&macfilter_tbl);
        iwr.u.data.length = sizeof(macfilter_tbl);
	if (ioctl(skfd, IOCTL_SET_STRUCT, &iwr) < 0) {
		perror("ioctl[IOCTL_SET_STRUCT]");
		return -1;
	}
return 0;
}
#endif

int main(int    argc, char **    argv){
        int skfd;		/* generic raw socket desc.	*/
        int goterr = 0;

        /* Create a channel to the NET kernel. */
        if((skfd = iw_sockets_open()) < 0) {
                printf("open socket fail\n");
                return(-1);
        }

        if(!argv[1] || !argv[2]){
                printf("Please use ""iwsta [WLAN interface] [command] ""!.\n");
                printf("Available commands:stalist, apstat, macfilter.\n");
                return -1;
        }
        
        if(!strncmp(argv[2], "stalist", 7))
                goterr = st_info_ioctl(skfd, argv[1]);
        else if(!strncmp(argv[2], "apstat", 6))
                goterr = ap_stat_ioctl(skfd, argv[1]);
#if WLAN_MAC_FILTER  // Sam add wlan Mac filter
	else if(!strncmp(argv[2],"macfilter",9))
	{
		int command;
		FILE *f;
		int rule_num=0,mac1,mac2,mac3,mac4,mac5,mac6;
		char line[255];
		command = atoi(argv[3]);
		if (command!=0) {
		f=fopen("/var/tmp/wireless_macfilter_list","r");
		if (f){
			while(fgets(line,255,f)){
			
			sscanf(line,"%2x:%2x:%2x:%2x:%2x:%2x"
			,&mac1
			,&mac2
			,&mac3
			,&mac4
			,&mac5
			,&mac6
			);
			/*
			DPRINTF("mac1:%2x\n",mac1);
			DPRINTF("mac2:%2x\n",mac2);
			DPRINTF("mac3:%2x\n",mac3);
			DPRINTF("mac4:%2x\n",mac4);
			DPRINTF("mac5:%2x\n",mac5);
			DPRINTF("mac6:%2x\n",mac6);
			*/
			macfilter_tbl.macaddr_array[rule_num].addr[0]=mac1;
			macfilter_tbl.macaddr_array[rule_num].addr[1]=mac2;
			macfilter_tbl.macaddr_array[rule_num].addr[2]=mac3;
			macfilter_tbl.macaddr_array[rule_num].addr[3]=mac4;
			macfilter_tbl.macaddr_array[rule_num].addr[4]=mac5;
			macfilter_tbl.macaddr_array[rule_num].addr[5]=mac6;
			/*
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[0]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[0]);
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[1]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[1]);
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[2]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[2]);
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[3]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[3]);
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[4]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[4]);
			DPRINTF("macfilter_tbl.macaddr_array[%d].addr[5]:%2x\n",rule_num,macfilter_tbl.macaddr_array[rule_num].addr[5]);
			
			*/
				rule_num++;
			}
				
			macfilter_tbl.macfilter_count=rule_num;
			//DPRINTF("macfilter_tbl.macfilter_count:%d\n",macfilter_tbl.macfilter_count);
			//DPRINTF("macfilter_tbl.macfilter_command:%d\n",command);
			fclose(f);
		}
		}
		goterr = ap_set_macfilter_ioctl(skfd, argv[1],command);
	}
#endif
        else{
                printf("Please use ""iwsta [WLAN interface] [command] ""!.\n");
                printf("Available commands:stalist, apstat, macfilter.\n");
                return -1;
        }

        /* Close the socket. */
        close(skfd);

        return(goterr);
}

