#include <asm/asm.h>
#include <asm/mipsregs.h>
#include <asm/regdef.h>
#include <asm/stackframe.h>

	/* A lot of complication here is taken away because:
	 *
	 * 1) We handle one interrupt and return, sitting in a loop
	 *    and moving across all the pending IRQ bits in the cause
	 *    register is _NOT_ the answer, the common case is one
	 *    pending IRQ so optimize in that direction.
	 *
	 * 2) We need not check against bits in the status register
	 *    IRQ mask, that would make this routine slow as hell.
	 *
	 * 3) Linux only thinks in terms of all IRQs on or all IRQs
	 *    off, nothing in between like BSD spl() brain-damage.
	 */

	.text
	.set	noreorder
	.set	noat
	.align	5
	NESTED(dvd_handle_int, PT_SIZE, sp)
	SAVE_ALL
	CLI
	.set	at

	/*
	* It is not necessary to investigate CP0 Register,
	* because we use only interrupt 2.
	*/
1:	jal	dvd_irq_disp
	 move	a0, sp
	j	ret_from_irq
	nop				# delay slot
	END(dvd_handle_int)
