#include <asm/sunplus/regmap.h>
#include <asm/sunplus/memmap.h>
#include <asm/sunplus/interrupt.h>

extern volatile RegisterFile *dvd_regs;


/* board_time_init() -
 *      a) (optional) set up RTC routines,
 *      b) (optional) calibrate and set the mips_counter_frequency
 *          (only needed if you intended to use fixed_rate_gettimeoffset
 *           or use cpu counter as timer interrupt source)
 */     
void dvd_time_init(void)
{
    /* initial timer */
#if 1  //from dvd linux
//    unsigned int intr_mask;
    unsigned int reg_status;
    __asm__ __volatile__ (
        "mfc0\t%0,$12\t\n"
        "nop\t\n"
        //"ori\t%0,0x0401\t\n"
        "ori\t%0,0x0400\t\n"
        "mtc0\t%0,$12\t\n"
        "nop\t\n"
        :"=r" (reg_status)
    );
    /* setup STC 90kHz (81MHz/900) */
    //dvd_regs->stc_divisor= 900-1; /* 81MHz / 900  */
    dvd_regs->stc_divisor= STC_DIVISOR; /* 108 MHz / 900  */
    dvd_regs->timer0_ctrl= TIMER_CONFIG_10ms;
#endif
//    printk("in dvd_time_init\n");
#if 0
    dvd_regs->stc_divisor= STC_DIVISOR; /* 108 MHz / 900  */
#endif
}

/* board_timer_setup() -
 *      a) (optional) over-write any choices made above by time_init().
 *      b) machine specific code should setup the timer irqaction.
 *      c) enable the timer interrupt
 */

void dvd_timer_setup(struct irqaction *irq)
{
    volatile unsigned int mask;
    /* enable timer0 interrupt */
    mask = dvd_regs->intr_mask;
    dvd_regs->intr_mask = (mask | TIMER0_INTR_BIT);
    setup_irq(TIMER0_INTR,irq);
}
