/*
 * cmdline.c: read the command line passed to us by the PROM.
 */
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/string.h>

#include <asm/bootinfo.h>

char arcs_cmdline[COMMAND_LINE_SIZE];

#ifdef SUNPLUS_NETWORK_BOOTROM
static void ksprintf(char* buf,const char *fmt, ...)
{
   va_list args;
   va_start(args, fmt);
   vsprintf(buf, fmt, args);
   va_end(args);
}
#endif

void __init prom_init_cmdline(int argc, char **argv, unsigned long magic)
{

#ifdef SUNPLUS_NETWORK_BOOTROM
   char ip[16],gw[16],mask[16];
   volatile unsigned char *p;
#endif

   arcs_cmdline[0] = 0;

#ifdef CONFIG_BLK_DEV_INITRD
   strcpy(arcs_cmdline,"root=/dev/ram0");
#else
   #ifdef SUNPLUS_NETWORK_BOOTROM
      p = (unsigned char*)0x80000008;
      ksprintf(ip,"%d.%d.%d.%d",*(p+3),*(p+2),*(p+1),*p);
      p += 4;
      ksprintf(mask,"%d.%d.%d.%d",*(p+3),*(p+2),*(p+1),*p);
      p += 4;
      ksprintf(gw,"%d.%d.%d.%d",*(p+3),*(p+2),*(p+1),*p); 
      ksprintf(arcs_cmdline,"root=/dev/nfs ip=%s:140.96.120.148:%s:%s:dvd_player:eth0:off nfsroot=140.96.120.148:/mips_nfs/",ip,gw,mask);
   #else

      strcpy(arcs_cmdline, "root=/dev/nfs ip=172.16.132.206:172.16.131.160:172.16.131.254:255.255.0.0:dvd_player:eth0:off nfsroot=172.16.131.160:/uclinux/");
   #endif
#endif
   strcat(arcs_cmdline,"  console=tty console=ttyS0");
   return;
}

