/*
 *  Copyright (C) 2001 SunPlus Technology CO.,LTD.  All Rights Reserved.
 *  File:  serial.c
 *
 *  Contents: Debug routines
 *
 *  History:
 *  Date        By              Reason              Ver.
 *  ========   =========       =================   ======
 *  03/26/01   Aladdin Chang   Create it           0.1
 */

#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/stddef.h>
#include <linux/unistd.h>
#include <linux/ptrace.h>
#include <linux/malloc.h>
#include <linux/user.h>
#include <linux/a.out.h>
#include <linux/tty.h>
#include <linux/delay.h>
#include <linux/config.h>
#include <linux/fs.h>
#include <linux/kdev_t.h>
#include <linux/major.h>
#include <linux/string.h>
#include <linux/blk.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/console.h>
#include <asm/bootinfo.h>

#include <asm/io.h>

#define DVD730_EVB_MEMSIZE 16		/* (MB) */

char arcs_cmdline[COMMAND_LINE_SIZE];

extern void bsp_outbyte(unsigned char ch);
extern void bspInit(void);

static void dbg_write(struct console *con, const char *str, unsigned count)
{
   int	i;
	
   for (i = 0; i < count; i++) {
       bsp_outbyte(*str);
       if (*str == 10) {
	  bsp_outbyte(13); /* LF */
       }
       str++;
   }
}               

static int dbg_wait_key(struct console *console)
{
   return 0;
}

static kdev_t dbg_device(struct console *console)
{
   return MKDEV(TTY_MAJOR, 64 + console->index);
}

static int __init dbg_setup(struct console *console, char *options)
{
   return 0;
}


struct console dbg_console = {
        name:     "ttyZ",
        write:    dbg_write,
        device:   dbg_device,
        wait_key: dbg_wait_key,
        setup:    dbg_setup,
        flags:    CON_PRINTBUFFER,
        index:    -1
};


void __init prom_init(void)
{
   bspInit();
   register_console(&dbg_console);
   dbg_setup( &dbg_console, NULL);
   printk("printk test OK\n");
   add_memory_region(0, DVD730_EVB_MEMSIZE << 20, BOOT_MEM_RAM);
}

void prom_free_prom_memory(void)
{
}
