/*
 * init.c: PROM library initialisation code.
 */
#include <linux/init.h>
#include <linux/config.h>
#include <asm/bootinfo.h>
#include <asm/cpu.h>

extern void prom_meminit(unsigned int);
extern void prom_identify_arch(unsigned int);
extern void prom_init_cmdline(int, char **, unsigned long);

extern struct console dbg_console;
extern void uart_prints(unsigned char*);

/*
 * Set the callback vectors.
 */
void __init which_prom(unsigned long magic, int *prom_vec)
{
} 

#include <linux/console.h>
#include <linux/tty.h>


static void dbg_write(struct console *con, const char *str, unsigned count)
{
   int	i;
	
   for (i = 0; i < count; i++) {
       uart_put_char(*str);
       if (*str == 10) {
	  uart_put_char(13); /* LF */
       }
       str++;
   }
}               

static int dbg_wait_key(struct console *console)
{
   return 0;
}

static kdev_t dbg_device(struct console *console)
{
   return MKDEV(TTY_MAJOR, 64 + console->index);
}

static int __init dbg_setup(struct console *console, char *options)
{
   return 0;
}


struct console dbg_console = {
        name:     "ttyZ",
        write:    dbg_write,
        device:   dbg_device,
        wait_key: dbg_wait_key,
        setup:    dbg_setup,
        flags:    CON_PRINTBUFFER,
        index:    -1
};

int __init prom_init(int argc, char **argv,
	       unsigned long magic, int *prom_vec)
{

//memset(0x88800000,0,8*1024*1024);
	which_prom(magic, prom_vec);
	prom_meminit(magic);
	prom_identify_arch(magic);
	prom_init_cmdline(argc, argv, magic);
	
	dvd_sys_init();
        uart_prints("test...........\r\n");   
//   bspInit();
//   register_console(&dbg_console);
//   dbg_setup( &dbg_console, NULL);
	printk("printk test\n");
	return 0;


}

void print_tlb_exception(u32 sr, u32 cause, u32 epc, u32 badvaddr)
{

   printk("TLB exception:\n");
   printk("sr=0x%x,cause=0x%x,epc=0x%x,badvaddr=0x%x\n",sr,cause,epc,badvaddr);
}
