/*
 * memory.c: memory initialisation code.
 */
#include <linux/init.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/bootmem.h>

#include <asm/addrspace.h>
#include <asm/page.h>

#include <asm/bootinfo.h>

#define PFN_ALIGN(x)    (((unsigned long)(x) + (PAGE_SIZE - 1)) & PAGE_MASK)

static void __init setup_memory_region(void)
{
//	extern char _end;
//	unsigned long mem_start, mem_size;
/*
	mem_start = 0x08200000;
	mem_size = virt_to_phys(PFN_ALIGN(&_end)) - mem_start; //reserved
	add_memory_region(mem_start, mem_size, BOOT_MEM_RESERVED);
	
	mem_start = virt_to_phys(PFN_ALIGN(&_end));
	mem_size  = (16 << 20) - (mem_start - 0x08000000);	//16 Mega
	add_memory_region(mem_start, mem_size, BOOT_MEM_RAM);	
*/
        add_memory_region(0x08000000,0x00200000,BOOT_MEM_RESERVED);
        add_memory_region(0x08200000,0x00e00000,BOOT_MEM_RAM);
}

void __init prom_meminit(unsigned int magic)
{
		setup_memory_region();
}

void prom_free_prom_memory (void)
{
        int i;
        unsigned long freed = 0;
        unsigned long addr;
                        
        for (i = 0; i < boot_mem_map.nr_map; i++) {
        	if (boot_mem_map.map[i].type != BOOT_MEM_ROM_DATA)
            		continue;
                                               
            	addr = boot_mem_map.map[i].addr;
                while (addr < boot_mem_map.map[i].addr
                        + boot_mem_map.map[i].size) {
                        ClearPageReserved(virt_to_page(__va(addr)));
                        set_page_count(virt_to_page(__va(addr)), 1);
                        free_page(__va(addr));
                        addr += PAGE_SIZE;
                        freed += PAGE_SIZE;
                }
        }
	printk("Freeing prom memory: %ldkb freed\n", freed >> 10);
}