/*
 *  arch/mips/ddb5074/setup.c -- NEC DDB Vrc-5074 setup routines
 *
 *  Copyright (C) 2000 Geert Uytterhoeven <geert@sonycom.com>
 *                     Sony Software Development Center Europe (SDCE), Brussels
 */

#include <asm/reboot.h>
#include <asm/irq.h>
#include <asm/mipsregs.h>
#include <linux/init.h>

#include <asm/sunplus/interrupt.h>	
#include <asm/sunplus/regmap.h>

extern volatile RegisterFile *dvd_regs;


void __init sunplus_setup(void)
{
    extern void (*board_time_init)(void);
    extern void (*board_timer_setup)(struct irqaction *irq);
    extern void dvd_machine_restart(char *command);
    extern void dvd_machine_halt(void);
    extern void dvd_machine_power_off(void);
    extern void dvd_time_init(void);
    extern void dvd_timer_setup(struct irqaction *irq);
    
    board_time_init = dvd_time_init;
    board_timer_setup = dvd_timer_setup;

    _machine_restart = dvd_machine_restart;
    _machine_halt = dvd_machine_halt;
    _machine_power_off = dvd_machine_power_off;
    
}
