#include <asm/sunplus/uart.h>
#include <asm/sunplus/regmap.h>
#include <asm/sunplus/interrupt.h>

void uart_put_char(unsigned char ch);
void uart_prints(unsigned char *s);

volatile RegisterFile *dvd_regs;

void dvd_sys_init(void)         // called before start_kernel
{
    /* set the dvd_regs variable, that will point to register file base*/
    dvd_regs=(volatile RegisterFile *)RGST_OFFSET;
    //    dvd_uart_init();
    // set A20 & A21 to address pin
    dvd_regs->gpio_sel_aux &= (~0x0007);
}

void dvd_uart_init(void)
{
    dvd_regs->uart1_lsr=0x80; /* soft-reset */
    dvd_regs->uart1_isc=0x00;
    dvd_regs->uart1_div_l=0x2b; /* 115200 */
    dvd_regs->uart1_div_h=0x00;
    dvd_regs->uart1_mcr=0x03;
    dvd_regs->uart1_lcr=0x03; /* 8-N-1 */
    //dvd_regs->gpio_sel=0x0020;  /* since we use EJTAG: enable uart1 */
    //dvd_regs->gpio_sel |= 0x0002;  /* no EJTAG: enable uart1 */
    
}

void uart_put_char(unsigned char ch)
{
   volatile unsigned int lsr=0;
    lsr=dvd_regs->uart1_lsr;
    while (!(lsr & TX_READY)) /* check for TX_READY */
       lsr=dvd_regs->uart1_lsr;
    /* now, we are ready to send character out */
    dvd_regs->uart1_data=ch;
}
	
void uart_prints(unsigned char *s)
{
   unsigned char i;

   for (i=0;s[i];i++) {
      if (s[i]=='\n')
         uart_put_char('\r');
      uart_put_char(s[i]);
   }
}

