#ifndef __XDescriptor_H__
#define __XDescriptor_H__



/*****************************************************************************************
*	MAC TxDescriptor structure
*
*****************************************************************************************/

#define		TX_DESCRIPTOR_SIZE	16
#define		RX_DESCRIPTOR_SIZE	16

typedef struct	
//typedef union
{
	unsigned int nValue;
/*
	struct
	{
		unsigned int	OWN			:1;
		unsigned int	UD			:15;
		unsigned int	ES			:1;
		unsigned int	UD2			:13;
		unsigned int	UF			:1;
		unsigned int	reserved	:1;		
	}Reg;*/
}tDesStruc0;

typedef struct
//typedef union
{
	unsigned int nValue;
/*	
	struct
	{
		unsigned int	IC			:1;
		unsigned int	LS			:1;
		unsigned int	FS			:1;
		unsigned int	reserved	:2;
		unsigned int	AC			:1;
		unsigned int	TER			:1;
		unsigned int	TCH			:1;
		unsigned int	DPD			:1;
		unsigned int	reserved2	:1;
		unsigned int	TBS2		:11;
		unsigned int	TBS1		:11;
	}Reg;		*/
}tDesStruc1;

typedef struct
{
	char* nData;
}tDesStruc2;

typedef struct
{
	unsigned int nValue;
}tDesStruc3;

/*****************************************************************************************
*	MAC RxDescriptor structure
*
*****************************************************************************************/

typedef struct	
{
	unsigned int nValue;
/*	
	struct
	{
		unsigned int	OWN			:1;
		unsigned int	reserved	:1;
		unsigned int	FL			:14;
		unsigned int	ES			:1;
		unsigned int	DE			:1;
		unsigned int	UD			:4;	
		unsigned int	FS			:1;
		unsigned int	LS			:1;
		unsigned int	UD2			:7;
		unsigned int	P0			:1;
	}Reg;
	
	*/
}rDesStruc0;

typedef struct
{
	unsigned int nValue;
/*	
	struct
	{
		unsigned int	Reserved	:6;
		unsigned int	RER			:1;
		unsigned int	RCH			:1;
		unsigned int	Reserved2	:2;
		unsigned int 	RBS2		:11;
		unsigned int	RBS1		:11;
	}Reg;		*/
}rDesStruc1;

typedef struct
{
	char* nData;
}rDesStruc2;


typedef struct
{
	unsigned int nValue;
}rDesStruc3;


/*****************************************************************************************
*	structure
*
*****************************************************************************************/
typedef struct
{
	tDesStruc0	RDES0;
	tDesStruc1	RDES1;
	tDesStruc2	RDES2;
	tDesStruc3	RDES3;
}	txDescriptorStruc;


typedef struct
{
	rDesStruc0	RDES0;
	rDesStruc1	RDES1;
	rDesStruc2	RDES2;
	rDesStruc3	RDES3;
}	rxDescriptorStruc;

//txDescriptorStruc TxDescriptor[TX_DESCRIPTOR_SIZE];
//rxDescriptorStruc RxDescriptor[RX_DESCRIPTOR_SIZE];


/*************************************************************************************
*			SAR Descriptor structure
*
***************************************************************************************/


typedef	union
{
	unsigned int nValue;
	struct
	{
		unsigned int 	Reserved		:18;
		unsigned int	Reserved10_13	:4;
		unsigned int	Reserved7_9		:3;
		unsigned int	ReservedU6		:1;
		unsigned int	UIRQ			:1;
		unsigned int	OWN				:1;
		unsigned int	CLP				:1;
		unsigned int	EndAAL5			:1;
		unsigned int	Reserved0_1		:2;
	}Reg;
}s_tx_Des0;

typedef union
{
	unsigned int nValue;
	struct
	{
		unsigned int	Reserved		:10;
		unsigned int	Num				:11;
		unsigned int	Size			:11;
	}Reg;
}s_tx_Des1;

typedef struct
{
	unsigned int 	nValue;
}s_tx_Des2;

typedef struct
{
	unsigned int	nValue;
}s_tx_Des3;

typedef union
{
	unsigned int nValue;
	struct
	{
		unsigned int	Reserved14_31	:18;
		unsigned int	ReservedU10_13	:4;
		unsigned int	Reserved7_9		:3;
		unsigned int	AAL5OF			:1;
		unsigned int	UIRQ			:1;
		unsigned int	OWN				:1;
		unsigned int	CRC				:1;
		unsigned int	EndAAL5			:1;
		unsigned int	Reserved0_1		:2;
	}Reg;
}s_rx_Des0;

typedef union
{
	unsigned int nValue;
	struct
	{
		unsigned int	Reserved		:10;
		unsigned int	Num				:11;
		unsigned int	Size			:11;
	}Reg;
}s_rx_Des1;

typedef struct
{
	unsigned int	nValue;
}s_rx_Des2;

typedef struct
{
	unsigned int	nValue;
}s_rx_Des3;

	

typedef struct
{
	s_tx_Des0	TDES0;
	s_tx_Des1	TDES1;
	s_tx_Des2	TDES2;
	s_tx_Des3	TDES3;
}stxDescriptorStruc;

typedef struct
{
	s_rx_Des0	RDES0;
	s_rx_Des1	RDES1;
	s_rx_Des2	RDES2;
	s_rx_Des3	RDES3;
}srxDescriptorStruc;

/**********************************************************************************/



txDescriptorStruc* TxDescriptor;
rxDescriptorStruc* RxDescriptor;

#endif

