/*  
 * Implementations used  for DMT Control Task.
 *
 * Written by Brad Huang, Billion Co. 2005/1/7
 * 
 */


#include <linux/config.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/spinlock.h>
//#include <linux/proc_fs.h>
#include <linux/reboot.h>
#include <linux/spinlock.h>
#include <linux/interrupt.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/compatmac.h>
#include <linux/string.h>
#include <linux/slab.h>
#include <linux/mm.h>
#include <linux/init.h>
#include <linux/timer.h>
#include <linux/delay.h>
#include <asm/tc3162/tc3162.h>	
#include <linux/tc3162dmtctrl.h>
#include <asm/tc3162/gpio.h>

//open for built-in kernel version modules
//#define ACT
//#undef ACT
#ifdef CONFIG_NEW_PCI 
#define TC3162_WLAN_POLL
#else
#undef TC3162_WLAN_POLL
#endif
//#undef TC3162_WLAN_POLL

//#pragma weak tc3162_wlan_poll
#define READ_OP 1
#define WRITE_OP 2
#define NULL_DMT_OP 99
#define NULL_CMD_OPTION 0
//////////////////////////////////////////////TrendChip API interface and SYSCALLS///////////
extern void TCIfQuery( unsigned int query_id, void *result1, void *result2 );
extern void TCIfSet( unsigned int set_id, void *value1, void *value2 );
extern long sys_kill(int pid, int sig);
extern int RtsCiCmd(int argc, char *argv[], void *p);
//extern int dmt_ci_cmd(int argc, char *argv[], void *p);
//extern int dmt2_ci_cmd(int argc, char *argv[], void *p);
//extern int hw_ci_cmd(int argc, char *argv[], void *p);
//extern int SwCiCmd(int argc, char *argv[], void *p);
extern int ghs_ci_cmd(int argc, char *argv[], void *p);
//extern int TCIfCiCmd(int argc, char *argv[], void *p);
////////////////////////////////////////////////////////////////////////////////////////////
typedef void (*DMT_CTRL_IOCTL) (unsigned long arg);
static int dmt_notify_sys(struct notifier_block *, unsigned long , void *);
static struct notifier_block dmt_notifier = {dmt_notify_sys , NULL, 0};
/* Prototypes. */
static int __init tc3162_dmtstat_init( void );
static void __exit tc3162_dmtstat_exit( void );
static int dmt_open( struct inode *inode, struct file *filp );
static void DoSetDmtClose( unsigned long arg );
static int dmt_ioctl( struct inode *inode, struct file *flip,unsigned int command, unsigned long arg );
static void DoGetConnectionInfo( unsigned long arg );
static void DoGetLineInfo( unsigned long arg );
static void DoGetDmtInfo( unsigned long arg );
static void DoSetDmtReset( unsigned long arg );
static void DoSetDmtClose( unsigned long arg );
static void DoSetDmtOpmode( unsigned long arg );
static void DoGetDmtOpmode( unsigned long arg );
static void DoGetLineDataN( unsigned long arg );
static void DoGetLineDataFADSL( unsigned long arg );
static void DoGetDmtFwVersion( unsigned long arg );
static void DoGetLineDataFADSL2P( unsigned long arg );
static void DoSetPID( unsigned long arg );
static void DoSetDmtAnnex( unsigned long arg );
static void DoGetLineUptime( unsigned long arg );
static void DoSetDmtRtsDbg( unsigned long arg );
static void DoSetPPPOE( unsigned long arg );
/* Timer */
static struct timer_list ADSL_timer;
spinlock_t mylock=SPIN_LOCK_UNLOCKED;
unsigned char modem_status;
unsigned char modem_status_current;
unsigned char modem_status_privous=ADSL_DOWN;
unsigned long dmtshowtime_stamp=0;
void *data;
//unsigned char dmttask;
unsigned int PID;
int myatoi(char s[])
{
	int i,n;
	n=0;
	for(i=0;s[i]>= '0' && s[i] <= '9';i++)
	n=10*n+(s[i]-'0');
	return n;
}

void GPIO1_LOW(void)
{
  *(volatile unsigned short *)TC3162_GPDATA_REG &= ~0x00000002; 
}

void GPIO1_HI(void)
{
  *(volatile unsigned short*)TC3162_GPDATA_REG |= 0x00000002;
}


// current_modem_status must be ADSL_DOWN or ADSL_UP
static unsigned int adsl_status_count=0;
static int current_modem_status=ADSL_DOWN;
#define ADSL_DOWN_COUNT 12
#define ADSL_UP_COUNT 6
static char LINK_PPPOE=0;
#define PPPOE_DOWN_COUNT 5
/* Monitor the status of ADSL link */
static void tc3162_dmt_link_monitor(unsigned long dummy)
{
	
	TCIfQuery(0x02, &modem_status, 0);

	if(PID)
	if((modem_status==ADSL_DOWN) || (modem_status==ADSL_UP)){
	  if(modem_status != current_modem_status) {
	    adsl_status_count=0;
	    current_modem_status=modem_status;
	    if(modem_status==ADSL_DOWN) {
	      printk("Linesync lost\n");
	      if(LINK_PPPOE)
		sys_kill(PID, SIGHUP);
	    } else {
	      printk("Linesync achieved\n");
    		DMTCTRL_CONNECTION_INFO KArg;
        	TCIfQuery(0x0007, &(KArg), 0);
		if(KArg.actualBitrateNearInt)
              		printk("Downstream rate: %d kbps\n",KArg.actualBitrateNearInt);
		if(KArg.actualBitrateNearFast)
              		printk("Downstream rate: %d kbps\n",KArg.actualBitrateNearFast);		
		if(KArg.actualBitrateFarInt)
	        	printk("Upstream rate: %d kbps\n",KArg.actualBitrateFarInt);
		if(KArg.actualBitrateFarFast)
			printk("Upstream rate: %d kbps\n",KArg.actualBitrateFarFast);
	    }
	  }else{
	    adsl_status_count++;
	    if(!LINK_PPPOE) {
	      if((modem_status==ADSL_DOWN) && (adsl_status_count == ADSL_DOWN_COUNT)){
		sys_kill(PID, SIGUSR2);
	      }
	      if((modem_status==ADSL_UP) && (adsl_status_count == ADSL_UP_COUNT)){
		sys_kill(PID, SIGUSR1);
	      }
	    }
	  }
	}

	if(modem_status==ADSL_DOWN || modem_status==ADSL_TRAINING_1)
           {
             
#ifdef BOARD_5102G_B_3162P
             GPIO1_HI();
#else
	     GPIO1_LOW();
#endif
            /* polling ethernet */
           if( modem_status==ADSL_TRAINING_1)
           {  
	    if (!(VPint(CR_INTC_IMR) & (1 << MAC_INT)))
		tc3162_emac_poll();
#ifdef TC3162_WLAN_POLL
	    if (!(VPint(CR_INTC_IMR) & (1 << PCI_A_INT)))
		tc3162_wlan_poll();
#if 0
#ifdef CONFIG_RT2561_AP_0_0_2_1
	    else  // Sam add
		*(volatile unsigned int*)(CR_INTC_IMR) &= ~((0x01) << PCI_A_INT);	
#endif
#endif
#endif
#ifdef ACT
	    if (!(VPint(CR_INTC_IMR) & (1 << GPIO_INT)))
		act_poll_isr();
#endif
            }
            dmtshowtime_stamp=0;
           }
	   else if ( modem_status==ADSL_TRAINING_2)
	   {
             
           *(volatile unsigned short*)(TC3162_GPDATA_REG) ^= 0x00000002;
            /* polling ethernet */
	   if (!(VPint(CR_INTC_IMR) & (1 << MAC_INT)))
		tc3162_emac_poll();
#ifdef TC3162_WLAN_POLL
	   if (!(VPint(CR_INTC_IMR) & (1 << PCI_A_INT)))
		tc3162_wlan_poll();
#if 0
#ifdef CONFIG_RT2561_AP_0_0_2_1
	   else  // Sam add
		*(volatile unsigned int*)(CR_INTC_IMR) &= ~((0x01) << PCI_A_INT);	
#endif
#endif
#endif
#ifdef ACT
            if (!(VPint(CR_INTC_IMR) & (1 << GPIO_INT)))
                act_poll_isr();
#endif
	   }
	    else
             {
	       
#ifdef BOARD_5102G_B_3162P
             GPIO1_LOW();
#else
	     GPIO1_HI();
#endif
#if 0
#ifdef CONFIG_RT2561_AP_0_0_2_1
	// Sam add
	*(volatile unsigned int*)(CR_INTC_IMR) |= (0x01 << PCI_A_INT);
	// End Sam add
#endif
#endif
             if(dmtshowtime_stamp==0)
              dmtshowtime_stamp=jiffies;
         }

	mod_timer(&ADSL_timer, jiffies + 50);
}


static struct file_operations dmt_fops =
{
    ioctl:      dmt_ioctl,
    open:       dmt_open,
    
};

/* Driver installation: this is where the thing starts */
static int __init tc3162_dmtstat_init(void)
{
  int j;
  //int rv = 0;
    /* Close DMT first, but we have to do DMT reset after booting*/
    TCIfSet(0x001a,0,0);
  j = *(volatile unsigned int*)(TC3162_GPCTL_REG);
  printk("init ADSL status timer\n");
  init_timer(&ADSL_timer);
  ADSL_timer.function = tc3162_dmt_link_monitor;
  ADSL_timer.data = 0;
  mod_timer(&ADSL_timer, jiffies + 1500);
   j= *(volatile unsigned int*)(TC3162_GPCTL_REG);
  *(volatile unsigned long*)TC3162_GPCTL_REG |= 0x00000004;
  register_chrdev( DMTCTRL_MAJOR, "dmtdev", &dmt_fops );
  register_reboot_notifier(&dmt_notifier);
  GPIO1_HI();
  return 0;
}

static void __exit tc3162_dmtstat_exit(void)
{
   del_timer_sync(&ADSL_timer);
   unregister_chrdev( DMTCTRL_MAJOR, "dmtdev" );
   
	
}
/***************************************************************************
 * Function Name: dmt_open
 * Description  : Called when an application opens this device.
 * Returns      : 0 - success
 ***************************************************************************/
static int dmt_open( struct inode *inode, struct file *filp )
{
    return( 0 );
} /* dmt_open */

/***************************************************************************
 * Function Name: dmt_close
 * Description  : Called when an application close this device.
 * Returns      : 0 - success
 ***************************************************************************/
static int dmt_notify_sys(struct notifier_block *this, unsigned long code , void *unused)
{
    unsigned int mask = 0xFFFFFFFE;               
    unsigned short flag = 1;
     if(code==SYS_DOWN || code==SYS_HALT)
        {
	       printk("release dmtdev\n");
               //TCIfSet(0x0019,0,0);
               TCIfSet(0x0019,&flag,0); 
               //printk("end 19, next 1b\n");
               //TCIfSet(0x001b,0,0);
               
               TCIfSet(0x001b,&mask,0); 
               //printk("end 1b, next 1a\n");   
               TCIfSet(0x001a,0,0);
               //printk("end 1a\n");
        }
        return NOTIFY_DONE;
} /* dmt_notify_sys */

/***************************************************************************
 * Function Name: dmt_ioctl
 * Description  : 
 * Returns      : 0 - success or error
 ***************************************************************************/
static int dmt_ioctl( struct inode *inode, struct file *flip,unsigned int command, unsigned long arg )
{
	int ret = 0;
    unsigned int cmdnr = _IOC_NR(command);

    DMT_CTRL_IOCTL IoctlFuncs[] = {DoGetDmtInfo,DoGetConnectionInfo,DoGetLineInfo,DoSetDmtReset,DoSetDmtClose,DoGetDmtOpmode,DoSetDmtOpmode,DoGetLineDataN,DoGetLineDataFADSL,DoGetDmtFwVersion,DoGetLineDataFADSL2P,DoSetPID,DoSetDmtAnnex,DoGetLineUptime,DoSetDmtRtsDbg,DoSetPPPOE};

    if( cmdnr >= 0 && cmdnr <  MAX_DMTCTRL_IOCTL_COMMANDS )
        (*IoctlFuncs[cmdnr]) (arg);
    else
        ret = -EINVAL;

    return( ret );
} /* dmt_ioctl */


/***************************************************************************
 * Function Name: DoGetDmtInfo
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetDmtInfo( unsigned long arg )
{
   DMTCTRL_DMT_INFO KArg;
#ifdef TC3162_WLAN_POLL 
   // Sam add
	extern int tc_processor;
#endif
   //     
    KArg.dmt_status=0;
    spin_lock(&mylock);
    TCIfQuery(0x02, &(KArg.dmt_status), 0);
#ifdef TC3162_WLAN_POLL 
    // Sam add for pass processor type to user space 
    KArg.tc_processor_type = tc_processor;
#endif
    //
    copy_to_user( (void *) arg, &(KArg.dmt_status), sizeof(DMTCTRL_DMT_INFO) );
    spin_unlock(&mylock);
} /* DoGetLineInfo */



/***************************************************************************
 * Function Name: DoGetConnectionInfo
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetConnectionInfo( unsigned long arg )
{
    DMTCTRL_CONNECTION_INFO KArg;
    unsigned char dmt_status1=0; 

    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status1), 0);
    spin_unlock(&mylock);
    memset(&KArg,0,sizeof(DMTCTRL_CONNECTION_INFO));
    if(dmt_status1 != ADSL_UP)
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_CONNECTION_INFO) );
    else
      {
        TCIfQuery(0x0007, &(KArg), 0);
        copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_CONNECTION_INFO) );
      }
} /* DoGetConnectionInfo */

/***************************************************************************
 * Function Name: DoGetLineInfo
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetLineInfo( unsigned long arg )
{
    DMTCTRL_LINE_INFO KArg;
    unsigned char dmt_status2=0;  
    
    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status2), 0);
    spin_unlock(&mylock);
    memset(&KArg,0,sizeof(DMTCTRL_LINE_INFO));
    if(dmt_status2 != ADSL_UP)
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_LINE_INFO) );
    else
      {
       TCIfQuery(0x0008, &(KArg), 0);
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_LINE_INFO) );
      }
        
} /* DoGetLineInfo */

/***************************************************************************
 * Function Name: DoSetDmtReset
 * Description  : Force DMT to re-sync
 * Returns      : None.
 ***************************************************************************/
static void DoSetDmtReset( unsigned long arg )
{
   unsigned int mask = 0xFFFFFFFE;               
   unsigned short flag = 1;

    TCIfSet(0x001a, NULL, NULL);
    TCIfSet(0x0019, &flag, NULL); 
    TCIfSet(0x001b, &mask, NULL );   
    
    //TCIfSet(0x0019,0,0);
    //TCIfSet(0x001b,0,0); 

} /* DoSetDmtReset */


/***************************************************************************
 * Function Name: DoSetDmtClose
 * Description  : Force DMT to shutdown
 * Returns      : None.
 ***************************************************************************/
static void DoSetDmtClose( unsigned long arg )
{
     unsigned int mask = 0xFFFFFFFE;               
     unsigned short flag = 1;
     TCIfSet(0x0019, &flag,0);
     TCIfSet(0x001b,&mask,0);    
     TCIfSet(0x001a,0,0);
} /* DoSetDmtClose */

/***************************************************************************
 * Function Name: DoSetDmtOpmode
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoSetDmtOpmode( unsigned long arg )
{
    
    unsigned int dmt_opmode=0;  
    
    char *argv[]={"ghs","set","std","adsl1_multi"};

    if( copy_from_user( &dmt_opmode, (void *) arg, sizeof(dmt_opmode) ) == 0 )
    {
       if(dmt_opmode == ADSL1_MultiMode)
          ghs_ci_cmd(4,argv,NULL); 
       else 
         TCIfSet(dmt_opmode,0,0);      
    }
            
} /* DoSetDmtOpmode */

/***************************************************************************
 * Function Name: DoGetDmtOpmode
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetDmtOpmode( unsigned long arg )
{
    
    unsigned char KArg=0;
    unsigned char dmt_status2=0;  
    
    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status2), 0);
    spin_unlock(&mylock);
    
    if(dmt_status2 != ADSL_UP)
       copy_to_user( (void *) arg, &(KArg), sizeof(unsigned char) );
    else
      {
       TCIfQuery(0x0001, &(KArg), 0);
       copy_to_user( (void *) arg, &(KArg), sizeof(unsigned char) );
      }
            
} /* DoSetDmtOpmode */

/***************************************************************************
 * Function Name: DoGetLineDataN
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetLineDataN( unsigned long arg )
{
    DMTCTRL_LINE_DATA_N_INFO KArg;
    unsigned char dmt_status2=0;  
    
    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status2), 0);
    spin_unlock(&mylock);
    memset(&KArg,0,sizeof(DMTCTRL_LINE_DATA_N_INFO));
    if(dmt_status2 != ADSL_UP)
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_LINE_DATA_N_INFO) );
    else
      {
       TCIfQuery(0x0005, &(KArg), 0);
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_LINE_DATA_N_INFO) );
      }
        
} /* DoGetLineDataN */

/***************************************************************************
 * Function Name: DoGetLineDataFADSL
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetLineDataFADSL( unsigned long arg )
{
    
    unsigned char dmt_status2=0;  
    
    
    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status2), 0);
    spin_unlock(&mylock);
    (DMTCTRL_LINE_DATA_F_INFO_ADSL *)data=kmalloc(sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL), GFP_ATOMIC);
    if(data)
    {
      memset((DMTCTRL_LINE_DATA_F_INFO_ADSL *)data,0,sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL));
    
      if(dmt_status2 != ADSL_UP)
        copy_to_user( (void *) arg, (DMTCTRL_LINE_DATA_F_INFO_ADSL *)data, sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL) );
      else
      {
          TCIfQuery(0x0006, (DMTCTRL_LINE_DATA_F_INFO_ADSL *)data, 0);
          copy_to_user( (void *) arg, (DMTCTRL_LINE_DATA_F_INFO_ADSL *)data, sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL) );
      }
    }    
     if(data)
        kfree((DMTCTRL_LINE_DATA_F_INFO_ADSL *)data); 
} /* DoGetLineDataF */

/***************************************************************************
 * Function Name: DoGetLineDataFADSL2P
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetLineDataFADSL2P( unsigned long arg )
{
    
    unsigned char dmt_status2=0;  
    
    
    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status2), 0);
    spin_unlock(&mylock);
    (DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data=kmalloc(sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL2P), GFP_ATOMIC);
    if(data)
    {
      memset((DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data,0,sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL2P));
    
      if(dmt_status2 != ADSL_UP)
        copy_to_user( (void *) arg, (DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data, sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL2P) );
      else
      {
          TCIfQuery(0x0006, (DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data, 0);
          copy_to_user( (void *) arg, (DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data, sizeof(DMTCTRL_LINE_DATA_F_INFO_ADSL2P) );
      }
    }    
     if(data)
        kfree((DMTCTRL_LINE_DATA_F_INFO_ADSL2P *)data); 
} /* DoGetLineDataFADSL2P */




/***************************************************************************
 * Function Name: DoGetDmtfwVersion
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetDmtFwVersion( unsigned long arg )
{
    
    DMTCTRL_DMT_VERSION KArg;


    TCIfQuery(0x001a, &(KArg.major), &(KArg.minor));
    TCIfQuery(0x0014, &(KArg.fw_ver_r), &(KArg.fw_ver_p));
    TCIfQuery(0x0015, &(KArg.fw_rev), &(KArg.annex_afe));
    TCIfQuery(0x0016, &(KArg.tdm_ver), &(KArg.fdm_ver)); 
    TCIfQuery(0x001d, &(KArg.b_ver), 0);
    copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_DMT_VERSION) );
   
            
} /* DoSetDmtOpmode */



/***************************************************************************
 * Function Name: DoSetPID
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoSetPID( unsigned long arg )
{
    
    unsigned int app_pid=0;  
    

    if( copy_from_user( &app_pid, (void *) arg, sizeof(app_pid) ) == 0 )
    {
        spin_lock(&mylock);	 
        PID=app_pid;
	printk("pid=%d\n", PID);
       spin_unlock(&mylock);
    }
            
} /* DoSetDmtOpmode */

/***************************************************************************
 * Function Name: DoSetDmtAnnex
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoSetDmtAnnex( unsigned long arg )
{
    
    unsigned char dmtannex;  
    char *argva[]={"ghs","set","annex","a"};
    char *argvb[]={"ghs","set","annex","b"};
    char *argvl[]={"ghs","set","annex","al"};
    char *argvi[]={"ghs","set","annex","i"};
    char *argvj[]={"ghs","set","annex","j"};
    char *argvm[]={"ghs","set","annex","m"};
    char *argvbjm[]={"ghs","set","annex","bjm"};
    char *argvaijlm[]={"ghs","set","annex","aijlm"};
    
   // printk("Set DMT Annex Type\n");
    if( copy_from_user( &dmtannex, (void *) arg, sizeof(dmtannex) ) == 0 )
    {
       //printk("Annex %d\n",dmtannex); 
       if(dmtannex==ANNEX_A)
          ghs_ci_cmd(4,argva,NULL);
       if(dmtannex==ANNEX_B)
          ghs_ci_cmd(4,argvb,NULL);
       if(dmtannex==ANNEX_L)
          ghs_ci_cmd(4,argvl,NULL);
       if(dmtannex==ANNEX_M)
          ghs_ci_cmd(4,argvm,NULL);
       if(dmtannex==ANNEX_I)
          ghs_ci_cmd(4,argvi,NULL);
       if(dmtannex==ANNEX_J)
          ghs_ci_cmd(4,argvj,NULL);
       if(dmtannex==ANNEX_BJM)
          ghs_ci_cmd(4,argvbjm,NULL);
       if(dmtannex==ANNEX_AIJLM)
          ghs_ci_cmd(4,argvaijlm,NULL); 
          
    }
            
} /* DoSetDmtAnnex */

/***************************************************************************
 * Function Name: DoGetLineUptime
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoGetLineUptime( unsigned long arg )
{
    DMTCTRL_ADSL_UPTIME KArg;
    unsigned char dmt_status_uptime=0; 

    spin_lock(&mylock);
    TCIfQuery(0x02, &(dmt_status_uptime), 0);
    spin_unlock(&mylock);
    memset(&KArg,0,sizeof(DMTCTRL_ADSL_UPTIME));
    if(dmt_status_uptime != ADSL_UP)
       copy_to_user( (void *) arg, &(KArg), sizeof(DMTCTRL_CONNECTION_INFO) );
    else
      {
        spin_lock(&mylock);
        KArg.dmtstatus=dmt_status_uptime;
        KArg.showtime_stamp=(dmtshowtime_stamp/100);
        KArg.currenttime_stamp=(jiffies/100);
        copy_to_user( (void *) arg, &(KArg), sizeof( DMTCTRL_ADSL_UPTIME) );
       spin_unlock(&mylock);  
      }
} /* DoGetLineUptime */


/***************************************************************************
 * Function Name: DoSetDmtRtsDbg
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoSetDmtRtsDbg( unsigned long arg )
{
    
    unsigned char dmtrtsdbg=0;  
    char *argvon[]={"rts","dbgmsg","on"};
    char *argvoff[]={"rts","dbgmsg","off"};
   
    
    //printk("Set DMT RTS DBG\n");
    if( copy_from_user( &dmtrtsdbg, (void *) arg, sizeof(dmtrtsdbg) ) == 0 )
    {
      // printk("RTSDBG %d\n",dmtrtsdbg); 
       if(dmtrtsdbg==DMTRTSON)
          RtsCiCmd(3,argvon,NULL);
       if(dmtrtsdbg==DMTRTSOFF)
          RtsCiCmd(3,argvoff,NULL);
     
          
    }
            
} /* DoSetDmtRtsDbg */

/***************************************************************************
 * Function Name: DoSetPPPOE
 * Description  : 
 * Returns      : None.
 ***************************************************************************/
static void DoSetPPPOE( unsigned long arg )
{
    
    unsigned int app_pid=0;  
    

    if( copy_from_user( &app_pid, (void *) arg, sizeof(app_pid) ) == 0 )
    {
        spin_lock(&mylock);	 
        LINK_PPPOE=app_pid;
	printk("LINK_PPPOE=%d\n", LINK_PPPOE);
       spin_unlock(&mylock);
    }
            
} /* DoSetPPPOE */

#if 0
void macSend(uint32 chanId, struct sk_buff *skb)
{
}

uint32 GetIpAddr(void)
{
 return 0;
}
 
uint8 *GetMacAddr(void)
{
 return "0004ed012345";
}
 
void TCConsole(uint8 mode)
{
}
 
void uartMacPutchar(int ch)
{
}
#endif



/* Register startup/shutdown routines */
module_init(tc3162_dmtstat_init);
module_exit(tc3162_dmtstat_exit);

