/*
** atm.c, version 2.0 2006/Jan/16
*/
/************************************************************************
 *
 *	Copyright (C) 2003 Trendchip Technologies, Corp.
 *	All Rights Reserved.
 *
 * Trendchip Confidential; Need to Know only.
 * Protected as an unpublished work.
 *
 * The computer program listings, specifications and documentation
 * herein are the property of Trendchip Technologies, Co. and shall
 * not be reproduced, copied, disclosed, or used in whole or in part
 * for any reason without the prior express written permission of
 * Trendchip Technologeis, Co.
 *
 *************************************************************************/
/*
** $Log: tc3162l2sar.c,v $
**
** $Log: atm.c $
** version 1.4.1 RobertWu/Billion
** Porting the TrendChip tc3162l2sar.c to BiNos source atm.c
**
** version 2.0   SamHung/Billion
** Add debug define and re-version to 2.0 for TC3162L2/P2
**
*/
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/atmdev.h>
#include <linux/spinlock.h>
#include <linux/interrupt.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/compatmac.h>
#include <linux/mm.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <asm/addrspace.h>
#include <asm/virtconvert.h>
#include <asm/tc3162/tc3162.h>	
#include <asm/tc3162/tsarm.h>	
#include <asm/tc3162/TCIfSetQuery.h>	
/* Sam add 28,Dec */
#include <asm/tc3162/tc3162_atm_ioc.h>
#include <linux/timer.h>

/* End of Sam add */
#include <asm/tc3162/ledcetrl.h>	
// Sam add debug
#define SCANPVC_DBG	0
#define ATM_TIMER_DBG	0
#define FINLAND_DEBUG	0
#define ATM_DRIVER_VERSION "2.0.D3"
#if FINLAND_DEBUG
unsigned long vcc_val=0;
//int tx_count=0;
#endif
// End Sam add debug
/************************************************************************
*				E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*							C O N S T A N T S
*************************************************************************
*/
#define RX_BUF_LEN 	(2048 - 16 - 64 - (sizeof(struct skb_shared_info)))		

//#define QOS_UBR_ENHANCE			1

#define SAVED_IRQ_MAX_ENTRY	16

/************************************************************************
*							D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*							M A C R O S
*************************************************************************
*/
#define dbg_pline_1(x)		printk("%s", x)
#define dbg_plineb_1(x, y)	printk("%s%02x", x, (uint8) y)
#define dbg_plinew_1(x, y)	printk("%s%04x", x, (uint16) y)
#define dbg_plinel_1(x, y)	printk("%s%08x", x, (uint32) y)

#define puts(s)				printk("%s", s)
#define printf				printk
//#define delay1ms(x)			mdelay(x)
/************************************************************************
*				F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/
void atmTxDescrInit(void);
void atmRxDescrInit(void);
void atmRxIrqQueueSet( uint32 irqBase, uint32 irqLength );
void atmTxDescrFree(uint8 vc);
#if FINLAND_DEBUG
//void atmTxDescrForceFree(uint8 vc);
#endif
void atmIsr(int irq , void *dev , struct pt_regs *regs);

uint8 atmCcHandler(uint8 *cellp);
uint8 atmOamHandler(atmRxCcDescr_t *atmRxCcDescrp, uint8 vc);
uint8 atmOamDataReq(uint8 *data_p, uint8 pti, uint8 vc);
uint8 atmVcNumberGet(uint8 vpi, uint16 vci);
struct sk_buff  *atmAal5DataInd(struct sk_buff     *skb, uint8 vc);
void atmReset(void);
uint8 atmDataReq(struct sk_buff *skb, uint8 vc, uint8 priority);
void sarDrvDescripReset(void);
int atmOamOpen(void);
void atmIrqStSaved(uint32 irqst, uint8 vc);
extern int getXdslSpeed(void);

/************************************************************************
*						P U B L I C   D A T A
*************************************************************************
*/
atmCtrl_t atmCtrl;
atmCtrl_t *atm_p = &atmCtrl;
//__DMEM atmCtrl_t atmCtrl;
//__DMEM atmCtrl_t *atm_p = &atmCtrl;

/************************************************************************
*						E X T E R N A L   D A T A
*************************************************************************
*/
static uint8 sarDebugFlag = 0;
static uint8 sarSoftReset = 0;
static uint8 isAdslUp = 0;
/************************************************************************
*						P R I V A T E   D A T A
*************************************************************************
*/
//atmTxDescr_t *atmTxVcFreeDescrp[ATM_VC_MAX];
//atmTxDescr_t *atmTxVcBusyDescrp[ATM_VC_MAX];
atmRxDescr_t *atmRxVcDescrp[ATM_VC_MAX];
//__DMEM atmRxDescr_t *atmRxVcDescrp[ATM_VC_MAX];

uint32 volatile atmTxVcTotalCnt;
uint8 volatile atmTxVcCnt[ATM_VC_MAX];
uint8 atmTxCcCnt; 
atmTxDescr_t *atmTxVcFreeDescrp[ATM_TX_PRIORITY_MAX][ATM_VC_MAX];  // ATM_TX_PRIORITY_MAX 4; ATM_VC_MAX 8
atmTxDescr_t *atmTxVcBusyDescrp[ATM_TX_PRIORITY_MAX][ATM_VC_MAX];
uint8 volatile atmTxPriVcCnt[ATM_TX_PRIORITY_MAX][ATM_VC_MAX];

atmTxCcDescr_t *atmTxCcFreeDescrp;
atmRxCcDescr_t *atmRxCcBusyDescrp; 

atmTxCcDescrPool_t atmTxCcDescrPool;
atmRxCcDescrPool_t atmRxCcDescrPool;  
atmRxCcCell_t ccBuf[ATM_RX_CC_DESCR_NUMMAX];
atmTxDescrPool_t atmTxDescrPool[ATM_VC_MAX];
atmRxDescrPool_t atmRxDescrPool[ATM_VC_MAX];

atmTxCcDescr_t *atmTxOamFreeDescrp[ATM_VC_MAX];
atmRxCcDescr_t *atmRxOamBusyDescrp[ATM_VC_MAX];

atmRxOamDescrPool_t oamBuf[ATM_VC_MAX];

uint32 atmRxIrq[IRQ_MAX_ENTRY];
atmConfig_t atmCfgTable = { 0 };
//__DMEM atmConfig_t atmCfgTable = { 0 };

typedef struct saved_atm_irq_st_s {
	uint32 irqst;
	uint8  vc;
} saved_atm_irq_st_t;

saved_atm_irq_st_t savedAtmIrqSt[SAVED_IRQ_MAX_ENTRY] = { 0 };
uint32 savedAtmIrqIndex = 0;

atmConfig_t atmCfgBackup = { 0 };
qosProfile_t qosRecord[ATM_VC_MAX];

uint32 ccDropCnt = 0;
volatile uint32 sarTaskId = 0;

volatile uint8 ATM_TX_VC_DESCR_PRIORITY_NUMMAX[] = {	ATM_TX_VC_DESCR_P0_NUMMAX,
														ATM_TX_VC_DESCR_P1_NUMMAX,
														ATM_TX_VC_DESCR_P2_NUMMAX,
														ATM_TX_VC_DESCR_P3_NUMMAX};

uint8 oamAisCell[52] = {
	/* ATM Header, without HEC */
	0x00, 0x00, 0x00, 0x00,
	/* 48 octets payload */
	0x10, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0xB9
};

uint8 oamRdiCell[52] = {
	/* ATM Header, without HEC */
	0x00, 0x00, 0x00, 0x00,
	/* 48 octets payload */
	0x11, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x00, 0xAF
};

uint8 oamLoopBackReqCell[52] = {
	/* ATM Header, without HEC */
	0x00, 0x00, 0x00, 0x00,
	/* 48 octets payload */
	0x18, 0x01, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0x93
};

uint8 oamContinuityCheckReqCell[52] = {
	/* ATM Header, without HEC */
	0x00, 0x00, 0x00, 0x00,
	/* 48 octets payload */
	0x14, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0x87
};

uint8 oamF5AisCell[48] = {
	/* 48 octets payload */
	0x10, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0xB9
};

uint8 oamF5RdiCell[48] = {
	/* 48 octets payload */
	0x11, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x00, 0xAF
};

uint8 oamF5LoopBackReqCell[48] = {
	/* 48 octets payload */
	0x18, 0x01, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0x93
};

uint8 oamF5ContinuityCheckReqCell[48] = {
	/* 48 octets payload */
	0x14, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A,
	0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x6A, 0x03, 0x87
};
                                                                                                                                    
uint32 treg_irqm = 0x403;		//TX_SW_DIS_M, TX_M_DONE_M, and TX_U_DONE_M been masked
uint32 treg_tstbr = 59;	   //for ASIC
uint32 treg_tslr = 65537;	//0x00010001		default value

/************************************************************************
*			    L I N U X   S P E C I F I C     S E C T I O N
*************************************************************************
*/
static int tc3162_atm_open(struct atm_vcc *vcc, short vpi, int vci);
static void tc3162_atm_close(struct atm_vcc *vcc);
static int tc3162_atm_ioctl(struct atm_dev *dev, unsigned int cmd, void *arg);
static int tc3162_atm_send(struct atm_vcc *vcc, struct sk_buff *skb);
static int tc3162_atm_change_qos (struct atm_vcc *vcc, struct atm_qos *qos,int flags);

typedef struct tc3162_atm_prv_s {
  struct tc3162_atm_prv_s *next;
  struct atm_dev *dev;
  struct net_device_stats stats;
  char *name;
  char *proc_name;
} tc3162_atm_prv;

struct atm_dev *tc3162_atm_dev;
static const struct atmdev_ops tc3162_atm_ops = {
	open:		tc3162_atm_open,
	close:      tc3162_atm_close,
	ioctl:      tc3162_atm_ioctl,
	getsockopt: NULL,
	setsockopt: NULL,
	send:       tc3162_atm_send,
	sg_send:    NULL,
	phy_put:    NULL,
	phy_get:    NULL,
	change_qos: tc3162_atm_change_qos,
};


/* Sam declartion */
atmConfig_t scanpvc_backup_atmConfig = {0};
qosProfile_t scanpvc_backup_qosProfile[ATM_VC_MAX];

static struct timer_list atm_scanpvc_timer;
#if ATM_TIMER_DBG
static struct timer_list atm_dbg_timer;
static void atm_timer_1min(unsigned long);
int incoming_packet_count=0;
#endif
pvcmap_t scanpvcConfigTbl[ATM_VC_MAX];
int fill_the_test_pattern_done = 0;
int run_scanpvc_round = 0;
int scanpvc_flag = 0;
int scanpvc_needip_flag = 0;
int read_scanpvc_done = 0;

pvc_table_list_t* pvc_table_list_p;
pvc_table_list_t ret_pvc_table;

qosProfile_t scanpvc_qosprofile = {0,0,0,0};
static void tc3162_atm_scanpvc_monitor(unsigned long);
int tc3162_init_scanpvc(pvc_table_list_t *);
void fill_the_test_pattern(uint8_t *);
void fill_the_ipinfo(uint8_t*, uint8_t* );
void scanpvc_send_test_pattern(void);
void scanpvc_parse_rxpacket(struct sk_buff*, uint8);
int fill_scanpvc_ret_table(uint8 , uint16);
void setNet16(uint8 *, uint16 );
uint16 getNet16(uint8 *);
uint16 calculateIPheaderChecksum(uint8 , uint8 *);
uint16 udp_sum_calc(uint16 , uint8 *);
/* End of Sam*/


/************************************************************************
*				F U N C T I O N   D E F I N I T I O N S
*************************************************************************
*/

static void
delay1ms(
        int ms
)
{
        volatile uint32 timer_now, timer_last;
        volatile uint32 tick_acc;
        uint32 one_tick_unit = 1 * SYS_HCLK * 1000 / 2;
        volatile uint32 tick_wait = ms * one_tick_unit;
        volatile uint32 timer1_ldv = VPint(CR_TIMER1_LDV);

        tick_acc = 0;
        timer_last = VPint(CR_TIMER1_VLR);
        do {
                timer_now = VPint(CR_TIMER1_VLR);
                if (timer_last >= timer_now)
                        tick_acc += timer_last - timer_now;
                else
                        tick_acc += timer1_ldv - timer_now + timer_last;
                timer_last = timer_now;
        } while (tick_acc < tick_wait);
}

/*______________________________________________________________________________
**  atmInit
**
**  descriptions: the intialization function of ATM SAR module
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmInit(
	void
)
{
	uint8 i;

	//disable Tx/Rx first to prevent error
    TSARM_GFR = 0x0;
	//reset SAR Module
	delay1ms(50);	

	TSARM_RAI = RAI_RESET_ENB(1);
	delay1ms(5);
	TSARM_RAI = RAI_RESET_ENB(0);

	/* free mbuf descriptor allocation */
	sarDrvDescripReset();

	TSARM_TSTBR = treg_tstbr;
	TSARM_TXSLRC = treg_tslr;
		
	/* Clear ATM SAR registers */
	//there are 10 VCs inside 3162L2
	for (i = 0; i < ATM_VC_MAX; i++)
	{
		// VC configuration
		TSARM_VCCR(i) = 0;
		// Transmit Buffer Descriptor
		TSARM_TXDCBDA(i) = 0;
		TSARM_VC_TX_BD_PRIORITY01(i) = 0;
		TSARM_VC_TX_BD_PRIORITY23(i) = 0;
		// OAM Transmit Buffer Descriptor
		TSARM_TXMCBDA(i)=0;		
		// Receive Buffer Descriptor
		TSARM_RXDCBDA(i)=0;
		TSARM_VC_RX_DATA(i) = 0;
		// OAM Receive Buffer Descriptor
		TSARM_RXMCBDA(i) = 0;		
		// Traffic Scheduler - PCR
		TSARM_PCR(i) = 0;
		// Traffic Scheduler - SCR
		TSARM_SCR(i) = 0;
		// Traffic Scheduler - MBSTP
		TSARM_MBSTP(i) = 0;
		TSARM_IRQM(i) = 0;
		TSARM_VC_MPOA_CTRL(i) = 0;		
	}
	//mpoa registers
	TSARM_MPOA_GCR = 0x0;
	//MPOA header insertion field values
	TSARM_MPOA_HFIV11 = 0xaaaa03;
	TSARM_MPOA_HFIV12 = 0xfefe03;
	TSARM_MPOA_HFIV13 = 0x0;
	TSARM_MPOA_HFIV21 = 0x0080c2;
	TSARM_MPOA_HFIV22 = 0x000000;
	TSARM_MPOA_HFIV23 = 0x0;
	TSARM_MPOA_HFIV31 = 0x0001;
	TSARM_MPOA_HFIV32 = 0x0007;
	TSARM_MPOA_HFIV33 = 0xfefe;
	TSARM_MPOA_HFIV41 = 0x0000;
	TSARM_MPOA_HFIV42 = 0x0800;
	TSARM_MPOA_HFIV43 = 0x03cf;
	
	TSARM_CCCR = 0x0;
	TSARM_IRQMCC = 0x0;
	
	// CC channel current Tx/Rx descriptor
	TSARM_CC_TX_BD_BASE = 0;
	TSARM_CC_TX_BD_MNG_BASE = 0;
	TSARM_CC_RX_BD_BASE = 0;
	TSARM_CC_RX_BD_MNG_BASE = 0;

	/* Set up tx/rx descriptors */
	atmTxDescrInit();
	atmRxDescrInit();

	/* Reset ATM rx IRQ queue */
	atmRxIrqQueueSet((uint32) atmRxIrq, IRQ_MAX_ENTRY);
	
	atmOamOpen(); 
	if( sarSoftReset == 0) {	
		atm_p = &atmCtrl;
		/* clear atm counters */
		memset((char *)&(atm_p->MIB_II), 0, sizeof(atmMIB_II_t));
		memset( (uint8*)&atmCfgTable, 0, sizeof(atmConfig_t));
	}
	/* Hook Isr */
	isAdslUp = 1;
	TSARM_GFR = GFR_TXENB | GFR_RXENB |	GFR_GIRQEN | GFR_BIGENDIAN | GFR_RX_INACT_VC_M;
}

/*______________________________________________________________________________
**  atmTxDescrInit
**
**  descriptions: Initialize atm Tx descriptors
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmTxDescrInit(
	void
)
{
	uint8 vc;
	uint8 descrId;
	atmTxDescrPool_t *atmTxDescrVcPool;
	atmTxDescr_t *atmTxDescrp;
	atmTxCcDescr_t *atmTxOamDescrp;
	atmTxCcDescrPool_t *atmTxCcDescrVcPoolp;
	atmTxCcDescr_t *atmTxCcDescrp;
	uint32 P0_offset, P1_offset, P2_offset, P3_offset, Oam_offset, Cc_offset;
	uint8 priority;

	atmTxVcTotalCnt = 0;
	// init data and management buffer descriptor
	for (vc = 0; vc < ATM_VC_MAX; vc++)	{
		atmTxDescrVcPool = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
		//fill in address values
		atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[0] = (uint32)atmTxDescrVcPool->txP0DescrPool;
		atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[1] = (uint32)atmTxDescrVcPool->txP1DescrPool;
		atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[2] = (uint32)atmTxDescrVcPool->txP2DescrPool;
		atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[3] = (uint32)atmTxDescrVcPool->txP3DescrPool;
		//calcute each priority offset from base address
		P0_offset = ((uint32)atmTxDescrVcPool->txP0DescrPool - (uint32)atmTxDescrVcPool);
		P1_offset = ((uint32)atmTxDescrVcPool->txP1DescrPool - (uint32)atmTxDescrVcPool);
		P2_offset = ((uint32)atmTxDescrVcPool->txP2DescrPool - (uint32)atmTxDescrVcPool);	
		P3_offset = ((uint32)atmTxDescrVcPool->txP3DescrPool - (uint32)atmTxDescrVcPool);	
		Oam_offset = ((uint32)atmTxDescrVcPool->txOamDescrPool - (uint32)atmTxDescrVcPool);
		//fill in Register
		TSARM_TXDCBDA(vc) = K1_TO_PHYSICAL(atmTxDescrVcPool);
		TSARM_VC_TX_BD_PRIORITY01(vc) = K1_TO_PHYSICAL(((P1_offset << 16) + P0_offset));
		TSARM_VC_TX_BD_PRIORITY23(vc) = K1_TO_PHYSICAL(((P3_offset << 16) + P2_offset));	
		TSARM_TXMCBDA(vc) = K1_TO_PHYSICAL(Oam_offset);		

		//initialize each priority
		for(priority = 0; priority < ATM_TX_PRIORITY_MAX; priority ++){
		// Free and Busy Descriptor
			atmTxVcFreeDescrp[priority][vc] = (atmTxDescr_t *)atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[priority];
			atmTxVcBusyDescrp[priority][vc] = (atmTxDescr_t *)atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[priority];
			atmTxPriVcCnt[priority][vc] = 0;

			//init each descriptor
			for ( descrId = 0; descrId < ATM_TX_VC_DESCR_PRIORITY_NUMMAX[priority]; descrId++ )
			{
				atmTxDescrp = (atmTxDescr_t *)atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[priority]+ descrId;
				if ( descrId == ATM_TX_VC_DESCR_PRIORITY_NUMMAX[priority] - 1 ) {
					//BD_GAP, others = 0; EOR = 1
					atmTxDescrp->tdes0 = TSARM_TX_DESCR_BD_GAP(TSARM_TX_DATA_BD_GAP) 
						| TSARM_TX_DESCR_EOR;		
				}else{
					//BD_GAP, others = 0
					atmTxDescrp->tdes0 = TSARM_TX_DESCR_BD_GAP(TSARM_TX_DATA_BD_GAP);
				}
				// TDES1 =0 ; Buffer length =0;
				atmTxDescrp->tdes1 = 0x0;
				// TDES2 = 0x0; buffer address = null
				atmTxDescrp->tdes2 = 0x0;
				atmTxDescrp->tdes3 = 0x0;
				atmTxDescrp->skb = NULL;
			}
			
		}
	
		atmTxOamFreeDescrp[vc] = atmTxDescrVcPool->txOamDescrPool;
		atmTxVcCnt[vc] = 0;
		// management
		for ( descrId = 0; descrId < ATM_TX_CC_DESCR_NUMMAX; descrId++ ) 
		{
			atmTxOamDescrp = atmTxDescrVcPool->txOamDescrPool + descrId;
			if ( descrId == ATM_TX_CC_DESCR_NUMMAX - 1 ) {
				//BD_GAP, EOR = 1, others=0;
				atmTxOamDescrp->tdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_TX_CC_BD_GAP)
						| TSARM_TX_DESCR_EOR;		
			} else {
				//BD_GAP, others = 0
				atmTxOamDescrp->tdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_TX_CC_BD_GAP);
			}
			// TDES1 =0 ; Buffer length =0;
			atmTxOamDescrp->tdes1 = 0x0;
			// TDES2 = 0x0; buffer address = null
			atmTxOamDescrp->tdes2 = 0x0;
			atmTxOamDescrp->tdes3 = 0x0;
		}
	}

	// init Cc
	atmTxCcDescrVcPoolp = (atmTxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmTxCcDescrPool);
	TSARM_CC_TX_BD_BASE = K1_TO_PHYSICAL(atmTxCcDescrVcPoolp);
	// calculate the offset value
	Cc_offset = ((uint32)atmTxCcDescrVcPoolp->txCcDescrPool - (uint32)atmTxCcDescrVcPoolp);
	TSARM_CC_TX_BD_MNG_BASE = K1_TO_PHYSICAL(Cc_offset);
	atmTxCcFreeDescrp = atmTxCcDescrVcPoolp->txCcDescrPool;
	for ( descrId = 0; descrId < ATM_TX_CC_DESCR_NUMMAX; descrId++ )
	{
		atmTxCcDescrp = atmTxCcDescrVcPoolp->txCcDescrPool+ descrId;
		if ( descrId == ATM_TX_CC_DESCR_NUMMAX - 1 ) {
			//BD_GAP, EOR = 1, others=0;
			atmTxCcDescrp->tdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_TX_CC_BD_GAP)
						| TSARM_TX_DESCR_EOR;
		}else{
			//BD_GAP, others=0;
			atmTxCcDescrp->tdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_TX_CC_BD_GAP);
		}
		// TDES1 =0 ; Buffer length =0;
		atmTxCcDescrp->tdes1 = 0x0;
		// TDES2 = 0x0; buffer address = null
		atmTxCcDescrp->tdes2 = 0x0;
		atmTxCcDescrp->tdes3 = 0x0;
	}
}

/*______________________________________________________________________________
**  atmRxDescrInit
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmRxDescrInit(
	void
)
{
	uint8 vc;
	uint8 descrId;
	struct sk_buff *skb;
	atmRxDescrPool_t *atmRxDescrVcPoolp;
	atmRxDescr_t *atmRxDataDescrp;
	atmRxCcDescr_t *atmRxMngDescrp;
	atmRxCcDescrPool_t *atmRxCcDescrPoolp;
	atmRxCcDescr_t *atmRxCcDescrp;
	uint32 Data_offset, Oam_offset, Cc_offset;

	// init vc data and management descriptor
	for (vc =0; vc <ATM_VC_MAX;vc++) {
		atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
		//calculate the offset value
		Data_offset = (uint32)atmRxDescrVcPoolp->rxDescrPool - (uint32)atmRxDescrVcPoolp;
		Oam_offset = (uint32)atmRxDescrVcPoolp->rxOamDescrPool - (uint32)atmRxDescrVcPoolp;
		//fill in Register
		TSARM_RXDCBDA(vc)=K1_TO_PHYSICAL(atmRxDescrVcPoolp);
		TSARM_VC_RX_DATA(vc) = K1_TO_PHYSICAL(Data_offset);
		TSARM_RXMCBDA(vc)=K1_TO_PHYSICAL(Oam_offset);

		atmRxVcDescrp[vc] = atmRxDescrVcPoolp->rxDescrPool;
		atmRxOamBusyDescrp[vc] = atmRxDescrVcPoolp->rxOamDescrPool;

		// data
		for ( descrId = 0; descrId < ATM_RX_VC_DESCR_NUMMAX; descrId++ ) 
		{
			skb = dev_alloc_skb(RX_BUF_LEN);
			atmRxDataDescrp = atmRxDescrVcPoolp->rxDescrPool + descrId;
			if ( descrId == ATM_RX_VC_DESCR_NUMMAX - 1 ) {
				// BD_GAP, Rx Descriptor own by DMA; EOR=1
				atmRxDataDescrp->rdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_RX_DATA_BD_GAP)
							|  TSARM_RX_DESCR_EOR | TSARM_RX_DESCR_VALID;		
			}else{
				// BD_GAP, Rx Descriptor own by DMA
				atmRxDataDescrp->rdes0 = TSARM_TX_DESCR_BD_GAP(TSARM_RX_DATA_BD_GAP) 
							| TSARM_RX_DESCR_VALID;
		}
			// RDES1 = 1776; Set Rx Buffer size = 1776, reference zynos configure
			atmRxDataDescrp->rdes1 = 1776 << 16;
			// RDES2 = point the Rx Buffer to mbuf
			atmRxDataDescrp->rdes2 = K1_TO_PHYSICAL(skb->data);
			atmRxDataDescrp->rdes3 = 0x0;
			atmRxDataDescrp->skb = skb;
	}

		// management
		for ( descrId = 0; descrId < ATM_RX_CC_DESCR_NUMMAX; descrId++ ) 
		{
			atmRxMngDescrp = atmRxDescrVcPoolp->rxOamDescrPool+ descrId;
			if ( descrId == ATM_RX_CC_DESCR_NUMMAX - 1 ) {
				// BD_GAP, Rx Descriptor own by DMA; EOR=1
				atmRxMngDescrp->rdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_RX_CC_BD_GAP)
							| TSARM_RX_DESCR_EOR | TSARM_RX_DESCR_VALID;		
			}else{
				// BD_GAP, Rx Descriptor own by DMA
				atmRxMngDescrp->rdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_RX_CC_BD_GAP)
							| TSARM_RX_DESCR_VALID;
			}
			// RDES1 = 48; Set Rx Buffer size = 48, reference zynos configure
			atmRxMngDescrp->rdes1 = 48 << 16;
			// RDES2 = point the Rx Buffer to mbuf
			atmRxMngDescrp->rdes2 = K1_TO_PHYSICAL(CACHE_TO_NONCACHE(&(oamBuf[vc].rxOamDescrPool[descrId])));
			atmRxMngDescrp->rdes3 = 0x0;
		}
	}

	// init Cc
	atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);
	//calcute Cc offset value
	Cc_offset = (uint32)atmRxCcDescrPoolp->rxCcDescrPool - (uint32)atmRxCcDescrPoolp;
	//fill in register
	TSARM_CC_RX_BD_BASE = K1_TO_PHYSICAL(atmRxCcDescrPoolp);
	TSARM_CC_RX_BD_MNG_BASE = K1_TO_PHYSICAL(Cc_offset);
	atmRxCcBusyDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
	for ( descrId = 0; descrId < ATM_RX_CC_DESCR_NUMMAX; descrId++ ) {
		atmRxCcDescrp = atmRxCcDescrPoolp->rxCcDescrPool + descrId;
		if ( descrId == ATM_RX_CC_DESCR_NUMMAX - 1 ) {
			// BD_GAP, Rx Descriptor own by DMA; EOR=1
			atmRxCcDescrp->rdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_RX_CC_BD_GAP)
						| TSARM_RX_DESCR_EOR | TSARM_RX_DESCR_VALID;		
		}else{
			// BD_GAP, Rx Descriptor own by DMA
			atmRxCcDescrp->rdes0 =TSARM_TX_DESCR_BD_GAP(TSARM_RX_CC_BD_GAP)
						| TSARM_RX_DESCR_VALID;
		}
		atmRxCcDescrp->rdes1 = (96 << 16);
		atmRxCcDescrp->rdes2 = K1_TO_PHYSICAL(CACHE_TO_NONCACHE((ccBuf + descrId)));
		atmRxCcDescrp->rdes3 = 0x0;
	}
}

/*______________________________________________________________________________
**  atmAal5RealDataReq
**
**  descriptions: API for sending an AAL5 frame
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmAal5RealDataReq(
	struct sk_buff *skb,
	uint8 vc
)
{
	uint8 atmTxVcDescrNummax;
	uint8 priority = 3;
	int i;
	
	// ATM_TX_VC_DESCR_P0_NUMMAX 5  ATM_TX_VC_DESCR_P1_NUMMAX 5 
	// ATM_TX_VC_DESCR_P2_NUMMAX 5  ATM_TX_VC_DESCR_P3_NUMMAX 50 

	atmTxVcDescrNummax = ATM_TX_VC_DESCR_P0_NUMMAX + ATM_TX_VC_DESCR_P1_NUMMAX 
					+ ATM_TX_VC_DESCR_P2_NUMMAX + ATM_TX_VC_DESCR_P3_NUMMAX;

	// ATM_TX_BUF_RELEASE_THRESHOLD 4
	if ( atmTxVcCnt[vc] >= ATM_TX_BUF_RELEASE_THRESHOLD ) {
		//printk("atm.c 810 atmTxVcCnt[%d]=%d\n",vc,atmTxVcCnt[vc]);
		atmTxDescrFree(vc);

	}  
	if ( atmTxVcCnt[vc] >= atmTxVcDescrNummax ) {
#if FINLAND_DEBUG
		printk("atmTxVcCnt > atmTxVcDescrNummax\n");
#endif 
		atm_p->MIB_II.outDiscards++;
		if (ATM_SKB(skb)->vcc->pop) {
			ATM_SKB(skb)->vcc->pop (ATM_SKB(skb)->vcc, skb);
		} else {
		        //dev_kfree_skb(skb); 
			dev_kfree_skb_any(skb); 
		}
		for (i = 0; i < ATM_VC_MAX; i++) 
		        atmTxDescrFree(i);
		return 1;
	}

	if ( atmTxPriVcCnt[priority][vc] >= ATM_TX_VC_DESCR_PRIORITY_NUMMAX[priority]) {
		atm_p->MIB_II.outDiscards++;
		if (ATM_SKB(skb)->vcc->pop) {
			ATM_SKB(skb)->vcc->pop (ATM_SKB(skb)->vcc, skb);
		} else {
			//dev_kfree_skb(skb); 
			dev_kfree_skb_any(skb); 
		}
		for (i = 0; i < ATM_VC_MAX; i++) 
		        atmTxDescrFree(i);
		return 1;
	}

	atmDataReq(skb, vc, priority);

	return 0;
}

void atmTxPolling(uint8 priority, uint8 vc){
	switch(priority){
	case 0:	
		TSARM_TXDBCSR_P01 |= 1 << vc;
		break;
	case 1:	
		TSARM_TXDBCSR_P01 |= 1 << (vc+16);
		break;
	case 2:	
		TSARM_TXDBCSR_P23 |= 1 << vc;
		break;
	case 3:	
		TSARM_TXDBCSR_P23 |= 1 << (vc+16);
		break;
	default:
		break;
	}
	return 0;
}

uint8 atmDataReq(struct sk_buff *skb, uint8 vc, uint8 priority){
	volatile atmTxDescr_t *atmTxDescrp;
	atmTxDescrPool_t * atmTxDescrVcPoolp;
	uint8 offset;
	uint8 * ptr;
	uint8 * ptr2;
int i;
	uint8 * offset_ptr;

	atmTxDescrp = atmTxVcFreeDescrp[priority][vc];
	if ( !(atmTxDescrp->tdes0 & TSARM_TX_DESCR_VALID) && (atmTxDescrp->skb == NULL)) {
		atm_p->MIB_II.outPkts++; 
		atmTxDescrp->tdes1 = skb->len << 16;
		atmTxDescrp->tdes2 = K1_TO_PHYSICAL(skb->data);
		atmTxDescrp->skb = skb;
		atmTxDescrp->tdes0 |= TSARM_TX_DESCR_VALID;
		if(atmTxDescrp->tdes0 & TSARM_TX_DESCR_EOR){
			atmTxDescrVcPoolp = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
			atmTxVcFreeDescrp[priority][vc] = (atmTxDescr_t *)atmTxDescrVcPoolp->txPriDescrPoolPhysicalAddr[priority];
		}else
			atmTxVcFreeDescrp[priority][vc]++;

		atmTxPriVcCnt[priority][vc]++;
		atmTxVcCnt[vc]++;
		atmTxVcTotalCnt++;

		atmTxPolling(priority, vc);

//		ledTurnOn(LED_DSL_ACT_STATUS);
	}else {
#if FINLAND_DEBUG
	printk("TSARM_TX_DESCR is invalid\n");
#endif
		atm_p->MIB_II.outDiscards++;
		if (ATM_SKB(skb)->vcc->pop) {
			ATM_SKB(skb)->vcc->pop (ATM_SKB(skb)->vcc, skb);
		} else {
		//dev_kfree_skb(skb);
			dev_kfree_skb_any(skb); 
		}
#if 0 // FINLAND_DEBUG
	atmTxDescrForceFree(vc);
	atmReset();
#endif
	}
	return 0;
}

/*______________________________________________________________________________
**  atmAal5DataReq
**
**  descriptions: API for sending an AAL5 frame
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmAal5DataReq(
	struct sk_buff *skb,
	uint8 vpi,
	uint16 vci
)
{
	uint8 vc;
	
	vc = atmVcNumberGet(vpi, vci);
#if 0 //FINLAND_DEBUG
	tx_count++;
	if (tx_count==50)
	{
		tx_count=0;
		//atmTxDescrForceFree(vc);
		atmReset();
		return 0;
	}
	else
	{
#endif
	// Sam mark if ( vc == ATM_DUMMY_VC ) {
	if ( vc == ATM_DUMMY_VC || scanpvc_flag == ATM_SCANPVC_MODE ) {
		if (ATM_SKB(skb)->vcc->pop) {
			ATM_SKB(skb)->vcc->pop (ATM_SKB(skb)->vcc, skb);
		} else {
			//dev_kfree_skb(skb);
			dev_kfree_skb_any(skb);
		}
		return 1;
	}
 	return atmAal5RealDataReq(skb, vc);
#if 0 // FINLAND_DEBUG
	}
#endif
}

/*______________________________________________________________________________
**  atmCcDataReq
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmCcDataReq(
	uint8 *data_p
)
{
	atmTxCcDescr_t *atmTxCcDescrp;
	atmTxCcDescrPool_t *atmTxCcDescrVcPoolp;

	atmTxCcDescrp = atmTxCcFreeDescrp;
	if ( !(atmTxCcDescrp->tdes0 & TSARM_TX_DESCR_VALID) ) {
		atmTxCcDescrp->tdes1 = 50 << 16;
		atmTxCcDescrp->tdes2 = K1_TO_PHYSICAL(data_p);
		atmTxCcDescrp->tdes0 |= TSARM_TX_DESCR_VALID;
		if(atmTxCcDescrp->tdes0 & TSARM_TX_DESCR_EOR){
			atmTxCcDescrVcPoolp = (atmTxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmTxCcDescrPool);
			atmTxCcFreeDescrp = atmTxCcDescrVcPoolp->txCcDescrPool;
		}else{
			atmTxCcFreeDescrp++;
		}
		atmTxCcCnt++;		
		TSARM_TXMBCSR |= 1 << 16; 
	}
	else {
		ccDropCnt++;
		return 1;
	}
	return 0;
}

/*______________________________________________________________________________
**  atmOamDataReq
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmOamDataReq(
	uint8 *data_p, 
	uint8 pti,
	uint8 vc
)
{
	atmTxCcDescr_t *atmTxCcDescrp;
	atmTxDescrPool_t *atmTxDescrVcPoolp;

	atmTxCcDescrp = atmTxOamFreeDescrp[vc];
	if ( !(atmTxCcDescrp->tdes0 & TSARM_TX_DESCR_VALID) ) {
		atmTxCcDescrp->tdes1 = (pti << 28) | (48 << 16);
		atmTxCcDescrp->tdes2 = K1_TO_PHYSICAL(data_p);
		atmTxCcDescrp->tdes0 |= TSARM_TX_DESCR_VALID;
		if(atmTxCcDescrp->tdes0 & TSARM_TX_DESCR_EOR){
			atmTxDescrVcPoolp = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
			atmTxOamFreeDescrp[vc] = atmTxDescrVcPoolp->txOamDescrPool;
		}else{
			atmTxOamFreeDescrp[vc]++;
		}
		atmTxCcCnt++;		
		TSARM_TXMBCSR |= 1 << vc; 
	}
	else {
		ccDropCnt++;
		return 1;
	}
	return 0;
}

/*______________________________________________________________________________
**  atmOamF4F5DataReq
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint32
atmOamF4F5DataReq(
	uint8 vpi,
	uint16 vci,
	uint8 f5,
	uint8 endToEnd,
	uint8 funcType
)
{
	atmOamCell_t *oamCellp;
	atmOamCellPayload_t *oamCellPayloadp;
	uint8 vc;
	uint8 pti;

	if ( f5 ) { /* F5: by PTI */
		/* Move to non-cacheable region */
		switch ( funcType ) {
		case 0: /* AIS */
			oamCellPayloadp = (atmOamCellPayload_t *)(CACHE_TO_NONCACHE(oamF5AisCell));
			break;
		case 1: /* RDI */
			oamCellPayloadp = (atmOamCellPayload_t *)(CACHE_TO_NONCACHE(oamF5RdiCell));
			break;
		case 2: /* Loopback */
			oamCellPayloadp = (atmOamCellPayload_t *)(CACHE_TO_NONCACHE(oamF5LoopBackReqCell));
			break;
		case 3: /* Continuity check */
			oamCellPayloadp = (atmOamCellPayload_t *)(CACHE_TO_NONCACHE(oamF5ContinuityCheckReqCell));
			break;
		default:
			return 1;
		}
		vc = atmVcNumberGet(vpi, vci);
		if (  vc == ATM_DUMMY_VC ) {
			/* This is not a opened VC */			
			return 1;
		}
		if ( endToEnd ) {
			pti = 5;
		}
		else {
			pti = 4;
		}
		if(!atmOamDataReq((uint8 *)oamCellPayloadp, pti, vc)){
			atm_p->MIB_II.outF5Pkts++;
			atm_p->MIB_II.outPkts++;
		}	
	}
	else { /* F4: by VCI */
		/* Move to non-cacheable region */
		switch ( funcType ) {
		case 0: /* AIS */
			oamCellp = (atmOamCell_t *)(CACHE_TO_NONCACHE(oamAisCell));
			break;
		case 1: /* RDI */
			oamCellp = (atmOamCell_t *)(CACHE_TO_NONCACHE(oamRdiCell));
			break;
		case 2: /* Loopback */
			oamCellp = (atmOamCell_t *)(CACHE_TO_NONCACHE(oamLoopBackReqCell));
			break;
		case 3: /* Continuity check */
			oamCellp = (atmOamCell_t *)(CACHE_TO_NONCACHE(oamContinuityCheckReqCell));
			break;
		default:
			return 1;
		}
		oamCellp->vpi = vpi;
		if ( endToEnd ) {
			oamCellp->vci = 4;
		}
		else {
			oamCellp->vci = 3;
		}
		if(!atmCcDataReq((uint8 *)oamCellp)){
			atm_p->MIB_II.outF4Pkts++;
			atm_p->MIB_II.outPkts++;
		}	
	}
	return 0;
}

void
atmRxIrqQueueSet(
	uint32 irqBase, 
	uint32 irqLength
)
{
	TSARM_IRQBA = K0_TO_PHYSICAL(irqBase);
	TSARM_IRQLEN = irqLength;
}

void initMPOA(uint32 vc, qosProfile_t *qos_p){

	//re-init reg
	TSARM_MPOA_GCR = 0x0;
	TSARM_VC_MPOA_CTRL(vc) = 0x0;

	//MPOA global control register
	if(qos_p->mode == MODE_ROUTER){				//router mode
			if(qos_p->encapType == ENCAP_RFC2364)
				TSARM_MPOA_GCR |= 1 << (vc+16) | 1 << vc;
			else
				TSARM_MPOA_GCR |= 0 << (vc+16) | 1 << vc;				
	}else if(qos_p->mode == MODE_BRIDGE){		//bridge mode
		TSARM_MPOA_GCR |= 0 << (vc+16) | 0 << vc;
	}
	//VC 0 ~ 9 control register
	if(qos_p->muxType == MUX_VC){
		switch(qos_p->encapType){
			case ENCAP_RFC1483:
				if(qos_p->mode == MODE_ROUTER){				//router mode
					TSARM_VC_MPOA_CTRL(vc) |= 0x0;
				}else if(qos_p->mode == MODE_BRIDGE){		//bridge mode
					TSARM_VC_MPOA_CTRL(vc) |= 0x0340;	//(00001, 0100, 0000){Field4Value1}
				}
				break;
			case ENCAP_RFC2364:		//PPPoA
				TSARM_VC_MPOA_CTRL(vc) |= 0x0;
				break;
			case ENCAP_MER:
				TSARM_VC_MPOA_CTRL(vc) |= 0x0340;	//(00001, 0100, 0000){Field4Value1}
				break;
			case ENCAP_POE:
				TSARM_VC_MPOA_CTRL(vc) |= 0x0340;	//(00001, 0100, 0000){Field4Value1}
			default:
				break;
		}
	}else if(qos_p->muxType == MUX_LLC){			//MUX_LLC
		switch(qos_p->encapType){
			case ENCAP_RFC1483:
				if(qos_p->mode == MODE_ROUTER){				//router mode
					//(00001, 1000, 1001){Field4Value2, Field2Value2, Field1Value1}
					TSARM_VC_MPOA_CTRL(vc) |= 0x0389;	
				}else if(qos_p->mode == MODE_BRIDGE){		//bridge mode
					//(00001, 0110, 0101){Field4Value1, Field3Value2, Field2Value1, Field1Value1}
					TSARM_VC_MPOA_CTRL(vc) |= 0x0365;	
				}
				break;
			case ENCAP_RFC2364:		//PPPoA
				//(0001, 1111, 0000){Field4Valu3, Field3Value3}
				TSARM_VC_MPOA_CTRL(vc) |= 0x03f0;	
				break;
			case ENCAP_MER:
				//(00001, 0110, 0101){Field4Value1, Field3Value2, Field2Value1, Field1Value1}
				TSARM_VC_MPOA_CTRL(vc) |= 0x0365;	
				break;
			case ENCAP_POE:
				//(00001, 0110, 0101){Field4Value1, Field3Value2, Field2Value1, Field1Value1}
				TSARM_VC_MPOA_CTRL(vc) |= 0x0365;	
			default:
				break;
		}
	}
}

extern uint32 tc3162l2AtmMbsCalCulate(uint16 pcr, uint16 scr, uint16 mbs);
extern void tc3162l2AtmRateCalCulate(uint16 tb, uint16 cellRate, uint8 *dec_p, uint16 *init_p);

#if 0
uint32
tc3162l2AtmMbsCalCulate(
	uint16 pcr,
	uint16 scr,
	uint16 mbs
)
{
	uint32 cal_mbs;
	cal_mbs = (uint32)(mbs*(1-(scr * (1 /(float)pcr))));
	if(cal_mbs == 0)
		cal_mbs = 1;
	return cal_mbs;
}


void
tc3162l2AtmRateCalCulate(
	uint16 tb,
	uint16 cellRate,
	uint8 *dec_p,
	uint16 *init_p
)
{
	uint16 dec, init;
	uint32 calCellRate;
	uint32 diffSquare = 0xffffffff;
//	uint32 diffSquare = 0;
//	uint32 closesetSquare = 0xffffffff;
	uint32 closesetSquare = 0xff;	

	for ( dec = 1; dec <= 0x07f; dec++ ) {  /* PCR_dec or SCR_dec are both 7 bits long */
#if 1
		diffSquare = 0xffffffff;
		for ( init = 1; init <= 0x0fff; init++ ) {  /* PCR_init or SCR_init are both 12 bits long */
			//for FPGA 25 MHz			
			//calCellRate = 625000 * dec * (1/(float)init); //10* 1/(9+1), timebase=9, SAR_CLK=6.25
			//for ASIC 133 MHz
			//calCellRate = ((float)SAR_CLK * 100000)*dec* (1/(float)init);//10*1/(9+1), timebase=9			
			calCellRate = 33333333 * dec * (1/(float)(tb+1)) * (1/(float)init);	// 10*1/(9+1), timebase=9, SAR_CLK=33.25			
			diffSquare = calCellRate - cellRate;
		//	diffSquare = (calCellRate - cellRate) * (calCellRate - cellRate);
			if ( diffSquare < closesetSquare ) {
				closesetSquare = diffSquare;
				*dec_p = dec;
				*init_p = init;
				if ( diffSquare == 0 ) {
					/* Perfectly match */
					return;
				}
			}
		/*
			if ( diffSquare >= closesetSquare ){
				calCellRate = 625000 * dec * (1/init); //10* 1/(9+1), timebase=9
			//	calCellRate = (6250000) / (11 * (float)(init / dec));
			//	calCellRate = ((float)SAR_CLK * 1000000) / (float)((tb+1) * (init / dec));
			//	diffSquare = (calCellRate - cellRate) * (calCellRate - cellRate);
				diffSquare = calCellRate - cellRate;
			}else{
			//	if(((tb+1) * init *(1/(float)dec)) <=0)
			//			continue;
				calCellRate = 625000 * dec * (1/(float)init); //10* 1/(9+1), timebase=9, SAR_CLK=6.25
			//	calCellRate = (6250000) / (11 * (init / (float)dec));
			//	calCellRate = ((float)SAR_CLK * 1000000) / ((tb+1) * init *(1/(float)dec));	
			//	diffSquare = (calCellRate - cellRate) * (calCellRate - cellRate);
				diffSquare = calCellRate - cellRate;
				if ( diffSquare == 0 ) {
					*dec_p = dec;
					*init_p = init;
					return;		//Perfectly match 
				}
			}
		*/
#else
		for ( init = 1; init <= 0x0fff; init++ ) {  /* PCR_init or SCR_init are both 12 bits long */
			if((float)((tb+1) * (init / dec)) <=0)
					continue;
			calCellRate = ((float)SAR_CLK * 1000000) / (float)((tb+1) * (init / dec));
		//	diffSquare = calCellRate - cellRate;
			diffSquare = (calCellRate - cellRate) * (calCellRate - cellRate);
			if ( diffSquare < closesetSquare ) {
				closesetSquare = diffSquare;
				*dec_p = dec;
				*init_p = init;
				if ( diffSquare == 0 ) {
					/* Perfectly match */
					return;
				}
			}
#endif
		}
	}
}
#endif

/*______________________________________________________________________________
**  atmAal5VcOpen
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
int
atmAal5VcOpen(
	uint8 vpi,
	uint16 vci,
	qosProfile_t *qos_p,
	struct atm_vcc *vcc
)
{
	uint32 i, vc = ATM_VC_MAX;
	uint8 pcr_dec;
	uint8 scr_dec;
	uint8 lr_dec;
	uint16 pcr_init;
	uint16 scr_init;
	uint16 lr_init;
	uint32 temp;
	uint32 dslUpRate;
	uint32 cal_mbs;

	if (sarDebugFlag) {
		dbg_plineb_1("\r\n open vpi=", vpi);
		dbg_plinew_1(" vci=", vci);
		dbg_plinew_1(" type=", qos_p->type);
		dbg_plinew_1(" pcr=", qos_p->pcr);
		dbg_plinew_1(" scr=", qos_p->scr);
		dbg_plinew_1(" mbs=", qos_p->mbs);
	}
#if FINLAND_DEBUG
	printk("atmAal5VcOpen vpi=%d vci=%d\n",vpi,vci);
#endif
	/* ----- Check the number of total opened vc ----- */
	if ( atmCfgTable.vcNumber >= ATM_VC_MAX ) {
		return 1;
	}

	for ( i = 0; i < ATM_VC_MAX; i++ ) {	
		if ( atmCfgTable.openFlag[i] == 0 ) {
			atmCfgTable.openFlag[i] = 1;
			vc = i;
			atmCfgTable.vpi[vc] = vpi;
			atmCfgTable.vci[vc] = vci;
			memcpy( (uint8*)&qosRecord[vc],(uint8*)qos_p, sizeof(qosProfile_t)); 
			atmCfgTable.vcc[vc] = vcc;
			atmCfgTable.vcNumber++;			
			break;
		}
	}
	if (vc == ATM_VC_MAX)
		return 1;

    switch (qos_p->type) 
    {
        case CBR	: qos_p->type = TSARM_QOS_CBR;		break;
        case UBR    : qos_p->type = TSARM_QOS_UBR;		break;
        case VBR    : qos_p->type = TSARM_QOS_rtVBR;	break;
        // Sam add for support nrtVBR
        case nrtVBR : qos_p->type = TSARM_QOS_nrtVBR;   break;
        // End Sam add
        default     : qos_p->type = TSARM_QOS_UBR;		break;
    }			

    dslUpRate = getXdslSpeed(); /* Kbps */	
    if (dslUpRate <= 0)
    {
		dslUpRate = 2560;
    }
    dslUpRate = (dslUpRate * 1000) / (53 * 8);	/* cell rate */

    if ((qos_p->pcr == 0) || (qos_p->pcr > dslUpRate))
    	qos_p->pcr = dslUpRate;
    	
    if ((qos_p->scr == 0) || (qos_p->scr > qos_p->pcr))
    	qos_p->scr = qos_p->pcr;    	

    if (qos_p->mbs == 0)
		qos_p->mbs = 1;

	//init line rate
	tc3162l2AtmRateCalCulate((uint16)treg_tstbr, (uint16)dslUpRate, &lr_dec, &lr_init);
	TSARM_TXSLRC = (lr_dec << 16) | lr_init;

	/* ----- Set up vpi, vci, and QoS parameters of the vc ----- */
	//calculate rate.......
	if (( qos_p->type == TSARM_QOS_CBR) || (qos_p->type == TSARM_QOS_UBR) ) {
		tc3162l2AtmRateCalCulate((uint16)treg_tstbr, qos_p->pcr, &scr_dec, &scr_init);
		qos_p->mbs = 1; 								// if CBR, mbs must be 1
		TSARM_SCR(vc) = (scr_dec << 16) | scr_init;
		TSARM_PCR(vc) = (scr_dec << 16) | scr_init;
		if(qos_p->type == TSARM_QOS_CBR)
			TSARM_MBSTP(vc) = (1 << 28) |(0 << 26) |(qos_p->mbs << 2) | qos_p->type;		
		else
			TSARM_MBSTP(vc) = (1 << 28) |(3 << 26) |(qos_p->mbs << 2) | qos_p->type;
	} else {
		tc3162l2AtmRateCalCulate((uint16)treg_tstbr, qos_p->pcr, &pcr_dec, &pcr_init);
		tc3162l2AtmRateCalCulate((uint16)treg_tstbr, qos_p->scr, &scr_dec, &scr_init);
		TSARM_PCR(vc) = (pcr_dec << 16) | pcr_init;
		TSARM_SCR(vc) = (scr_dec << 16) | scr_init;
		cal_mbs = tc3162l2AtmMbsCalCulate(qos_p->pcr, qos_p->scr, qos_p->mbs);
		if(qos_p->type == TSARM_QOS_rtVBR)
			TSARM_MBSTP(vc) = (1 << 28) |(1 << 26) | (cal_mbs << 2) | qos_p->type;    //for new L2 SAR
		else
			TSARM_MBSTP(vc) = (1 << 28) |(2 << 26) | (cal_mbs << 2) | (2 << 0);
	}

	if (sarDebugFlag){
		dbg_plinel_1("\r\n vc:", vc);	
		dbg_plinel_1(" PCR:", TSARM_PCR(vc));
		dbg_plinel_1(" SCR:", TSARM_SCR(vc));	
		dbg_plinel_1(" MBSTP:", TSARM_MBSTP(vc));
		dbg_plinel_1("\r\n TSARM_MPOA_GCR:", TSARM_MPOA_GCR);	
		dbg_plinel_1(" TSARM_VC_MPOA_CTRL:", TSARM_VC_MPOA_CTRL(vc));
		dbg_pline_1("\r\n");		
	}
	TSARM_IRQM(vc) = treg_irqm;
	// read to clear Receive Counter
	temp = TSARM_TDCNT(vc);
	temp = TSARM_RDCNT(vc);

	// set up VC Configuration as valid =1, raw =0(AAL5 mode), port =0, VPI, VCI
	TSARM_VCCR(vc) =
		VCCFGR_VPI(vpi) | VCCFGR_VCI(vci) |
		VCCFGR_PORT(VCCFGR_ATM_PHY0) | VCCFGR_VALID;

	// to prevent 1/2^(28) error chance
	VPint(0xbfb60128) = 0x1;

	// workaround for abnormal irq report
	TSARM_VCCR(10) = VCCFGR_VPI(vpi) | VCCFGR_VCI(vci) |
		VCCFGR_PORT(VCCFGR_ATM_PHY0) | VCCFGR_VALID;

	/* data cell */
	TSARM_RXDBCSR |= 1 << vc;
	/* management cell */
	TSARM_RXMBCSR |= 1 << vc;	
	
	return 0;
}

/*______________________________________________________________________________
**  atmAal5VcClose
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmAal5VcClose(
	uint8 vpi,
	uint16 vci
)
{
	uint8 vc, i;
//printk("atmAal5VcClose %d %d \n",vpi,vci);
	vc = atmVcNumberGet(vpi, vci);
	if ( vc == ATM_DUMMY_VC ) 
		return 1;

	if (sarDebugFlag) {
		dbg_plineb_1("\r\n close vpi=", vpi);
		dbg_plinew_1(" vci=", vci);
	}

	// VC configuration
	TSARM_VCCR(vc) = 0;
	// Transmit Buffer Descriptor
	//TSARM_TXDCBDA(vc) = 0;
	// OAM Transmit Buffer Descriptor
	//TSARM_TXMCBDA(vc)=0;		
	// Receive Buffer Descriptor
	//TSARM_RXDCBDA(vc)=0;
	// OAM Receive Buffer Descriptor
	//TSARM_RXMCBDA(vc) = 0;		
	// Traffic Scheduler - PCR
	TSARM_PCR(vc) = 0;
	// Traffic Scheduler - SCR
	TSARM_SCR(vc) = 0;
	// Traffic Scheduler - MBSTP
	TSARM_MBSTP(vc) = 0;
	
	atmCfgTable.openFlag[vc] = 0;
	atmCfgTable.vpi[vc] = atmCfgTable.vci[vc] = 0;
	atmCfgTable.vcNumber--; 

	local_irq_disable();
	atmTxDescrFree(vc);
	local_irq_enable();

	// workaround for abnormal irq report
	for ( i = 0; i < ATM_VC_MAX; i++ ) {
		if ( atmCfgTable.openFlag[i] == 1 ) {
			TSARM_VCCR(10) = 
				VCCFGR_VPI(atmCfgTable.vpi[i]) | VCCFGR_VCI(atmCfgTable.vci[i]) |
				VCCFGR_PORT(VCCFGR_ATM_PHY0) | VCCFGR_VALID;
			break;
		}
	}
	if (i == ATM_VC_MAX)
		TSARM_VCCR(10) = VCCFGR_VPI(0) | VCCFGR_VCI(0) |
			VCCFGR_PORT(VCCFGR_ATM_PHY0) | VCCFGR_VALID;

	return 0;
}

/*______________________________________________________________________________
**  atmOamOpen
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
int
atmOamOpen(
	void
)
{
	TSARM_CCCR = VCCFGR_VPI(0) | VCCFGR_VCI(0) | 
		VCCFGR_PORT(VCCFGR_ATM_PHY0) | VCCFGR_VALID;

	TSARM_IRQMCC = 0x202;
	
	TSARM_RXMBCSR |= 1 << 16;

	return 0;
}

void atmTxPriDescrFree(uint8 vc, uint8 priority){
	volatile atmTxDescr_t *atmTxBusyDescrp;
	uint8 i;
	uint8 len = atmTxPriVcCnt[priority][vc];
	atmTxDescrPool_t * atmTxDescrVcPoolp;

	for (i = 0; i < len; i++) {
		atmTxBusyDescrp = atmTxVcBusyDescrp[priority][vc];
		if (!(atmTxBusyDescrp->tdes0 & TSARM_TX_DESCR_VALID)) {
			if ( atmTxBusyDescrp->skb ) {
				/* Free descr */
#if 0
				// Sam add debug
				if( scanpvc_flag == ATM_AAL5_MODE )  // Sam add this condition
				{
				if (ATM_SKB(atmTxBusyDescrp->skb)->vcc->pop) {
					ATM_SKB(atmTxBusyDescrp->skb)->vcc->pop (ATM_SKB(atmTxBusyDescrp->skb)->vcc, atmTxBusyDescrp->skb);
				} else {
					dev_kfree_skb_any(atmTxBusyDescrp->skb);
				}
				}
				else
					dev_kfree_skb_any(atmTxBusyDescrp->skb);  // End Sam add
#else
				dev_kfree_skb(atmTxBusyDescrp->skb);  // End Sam add
#endif

				atmTxBusyDescrp->tdes1 = 0x0;
				atmTxBusyDescrp->skb = NULL;
				if(atmTxBusyDescrp->tdes0 & TSARM_TX_DESCR_EOR){
					atmTxDescrVcPoolp = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
					atmTxVcBusyDescrp[priority][vc] = (atmTxDescr_t *)atmTxDescrVcPoolp->txPriDescrPoolPhysicalAddr[priority];
				}else{
					atmTxVcBusyDescrp[priority][vc]++;
				}
				atmTxPriVcCnt[priority][vc]--;
				atmTxVcCnt[vc]--;
				atmTxVcTotalCnt--;						
			}
		} else {
			break;
		}
	}
}

#if  0 //FINLAND_DEBUG
void atmTxPriDescrForceFree(uint8 vc, uint8 priority){
	volatile atmTxDescr_t *atmTxBusyDescrp;
	uint8 i;
	uint8 len = atmTxPriVcCnt[priority][vc];
	atmTxDescrPool_t * atmTxDescrVcPoolp;

	for (i = 0; i < len; i++) {
		atmTxBusyDescrp = atmTxVcBusyDescrp[priority][vc];
#if FINLAND_DEBUG
		if ((atmTxBusyDescrp->tdes0))  // own by hardware
		{
		atmTxBusyDescrp->tdes0 &= 0xfffffffe; // 	
		}
#endif 
			if ( atmTxBusyDescrp->skb ) {
				/* Free descr */
				// Sam add debug
				if( scanpvc_flag == ATM_AAL5_MODE )  // Sam add this condition
				{
					if (ATM_SKB(atmTxBusyDescrp->skb)->vcc->pop) {
					ATM_SKB(atmTxBusyDescrp->skb)->vcc->pop (ATM_SKB(atmTxBusyDescrp->skb)->vcc, atmTxBusyDescrp->skb);
					} 
					else {
					dev_kfree_skb(atmTxBusyDescrp->skb);
					}
				}
				else
					dev_kfree_skb(atmTxBusyDescrp->skb);  // End Sam add

				atmTxBusyDescrp->tdes1 = 0x0;
				atmTxBusyDescrp->skb = NULL;
				if(atmTxBusyDescrp->tdes0 & TSARM_TX_DESCR_EOR){
					atmTxDescrVcPoolp = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
					atmTxVcBusyDescrp[priority][vc] = (atmTxDescr_t *)atmTxDescrVcPoolp->txPriDescrPoolPhysicalAddr[priority];
				}	
				else{
					atmTxVcBusyDescrp[priority][vc]++;
				}
				atmTxPriVcCnt[priority][vc]--;
				atmTxVcCnt[vc]--;
				atmTxVcTotalCnt--;						
			}
		}  // for loop
}
#endif

/*______________________________________________________________________________
**  atmTxDescrFree
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmTxDescrFree(
	uint8 vc
)
{
	uint8 priority;
	// ATM_TX_PRIORITY_MAX = 4
	for(priority = 0; priority < ATM_TX_PRIORITY_MAX; priority++){
		atmTxPriDescrFree(vc, priority);
	}
}
#if 0 //FINLAND_DEBUG
void
atmTxDescrForceFree(
	uint8 vc
)
{
	uint8 priority;
	// ATM_TX_PRIORITY_MAX = 4
	printk("TxDescr Force Free \n");
	for(priority = 0; priority < ATM_TX_PRIORITY_MAX; priority++){
		atmTxPriDescrForceFree(vc, priority);
	}
}
#endif

/*______________________________________________________________________________
**  atmIsr
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
//__IMEM void
atmIsr(
	int irq , void *dev , struct pt_regs *regs
)
{
	register uint32 atmRxIrqReport;
	uint32 atmRxIrqHeadOffset;
	uint8 vc;
	register atmRxDescr_t *atmRxDescrp;
	atmRxCcDescr_t *atmRxCcDescrp;
	struct sk_buff *skb;
	atmRxDescrPool_t *atmRxDescrVcPoolp;
	atmRxCcDescrPool_t *atmRxCcDescrPoolp;

//	ledTurnOn(LED_DSL_ACT_STATUS);

	VPint(CR_INTC_IMR)&= ~(1<<SAR_INT); 
	//loop while there are irq entries on irq queue
	while ((TSARM_IRQH & 0x00fff000) >> 12) { 
		//get the irq offset value
		atmRxIrqHeadOffset = TSARM_IRQH & 0x00000fff;
		//get the irq entry content
		atmRxIrqReport = *(volatile uint32 *) PHYSICAL_TO_K1(TSARM_IRQBA + (atmRxIrqHeadOffset << 2));
		vc = LIRQ_GET_VC_NO(atmRxIrqReport);
		/* mask the vc field out */
		atmRxIrqReport = atmRxIrqReport & 0xfe0fffff; 
		//the successful receive user data done event will be handled first, the others handled below. 
		if (atmRxIrqReport == LIRQ_RX_U_DONE) {
			atmRxDescrp = atmRxVcDescrp[vc];
				skb = atmRxDescrp->skb;
			if (!(atmRxDescrp->rdes0 & TSARM_RX_DESCR_VALID)) {
			//	skb->len = (uint16) (atmRxDescrp->rdes1 & 0xffff);
			
				/* 0800 dev bug, solved by Jennifer, 01102005 */
			//	skb->tail = skb->data + skb->len;
                        //modified by TC. need test, robert 02152006
				skb_put(skb, atmRxDescrp->rdes1 & 0xffff);
			
				/* Pass to upper layer */					
				if (skb->len)
				skb = atmAal5DataInd(skb, vc);
			} else {
				atm_p->MIB_II.inDiscards++;
				atm_p->MIB_II.inBufErr++;
			}
				atmRxDescrp->rdes1 = 1776 << 16;	/* Buffer size */
				atmRxDescrp->rdes2 = K1_TO_PHYSICAL(skb->data);
				atmRxDescrp->skb = skb; 
			atmRxDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
			if(atmRxDescrp->rdes0 & TSARM_RX_DESCR_EOR){
				atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
				atmRxVcDescrp[vc] = atmRxDescrVcPoolp->rxDescrPool;
			} else {
				atmRxVcDescrp[vc]++;
			}
	//	} else if (atmRxIrqReport & LIRQ_TX_U_DONE) {
		} else if (atmRxIrqReport & LIRQ_RX_U_BD_OV) {
			if( vc < 10 ) {
			atmRxDescrp = atmRxVcDescrp[vc];
			if (!(atmRxDescrp->rdes0 & TSARM_RX_DESCR_VALID)) {
				atm_p->MIB_II.inDiscards++;
				atm_p->MIB_II.inBufErr++;

				skb = atmRxDescrp->skb;
				atmRxDescrp->rdes1 = 1776 << 16;	/* Buffer size */
				atmRxDescrp->rdes2 = K1_TO_PHYSICAL(skb->data);
				atmRxDescrp->skb = skb; 
				atmRxDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
					atmRxVcDescrp[vc] = atmRxDescrVcPoolp->rxDescrPool;
				}else{
					atmRxVcDescrp[vc]++;
				}
			}
			TSARM_RXDBCSR |= 1 << vc;			
			atm_p->MIB_II.inBufDescrOverflow++;
			} else {
				atmIrqStSaved(atmRxIrqReport, vc);
				atm_p->MIB_II.inCcUBDOV++;
				atmReset();
				return;
			}			
		} else if ((atmRxIrqReport & LIRQ_RX_CRC32E) ||
			(atmRxIrqReport & LIRQ_RX_U_BOV) ||
			(atmRxIrqReport & LIRQ_RX_MAXLENE) || 
			(atmRxIrqReport & LIRQ_RX_LENE)) {

			// The VC should be leass than 10, but we can get the VC=10. 
			// workaround the abnormal situation. // Jason_20060105
			if( vc < 10 ) {
			atmRxDescrp = atmRxVcDescrp[vc];
		
			atm_p->MIB_II.inDiscards++;
			if (atmRxIrqReport & LIRQ_RX_CRC32E)
				atm_p->MIB_II.inCrcErr++;						
			else if (atmRxIrqReport & LIRQ_RX_U_BOV)
				atm_p->MIB_II.inBufOverflow++;						
			else if (atmRxIrqReport & LIRQ_RX_MAXLENE)
				atm_p->MIB_II.inBufMaxLenErr++;						
			else if (atmRxIrqReport & LIRQ_RX_LENE)
				atm_p->MIB_II.inBufLenErr++;						
		
			skb = atmRxDescrp->skb;
                        //modified by TC. need test, robert 02152006
			//skb->len = (uint16) (atmRxDescrp->rdes1 & 0xffff);

			atmRxDescrp->rdes1 = 1776 << 16;	/* Buffer size */
			atmRxDescrp->rdes2 = K1_TO_PHYSICAL(skb->data);
			atmRxDescrp->skb = skb; 
			atmRxDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
			
			if(atmRxDescrp->rdes0 & TSARM_RX_DESCR_EOR){
				atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
				atmRxVcDescrp[vc] = atmRxDescrVcPoolp->rxDescrPool;
			}else{
				atmRxVcDescrp[vc]++;
			}
			} else {
				atmIrqStSaved(atmRxIrqReport, vc);
				atm_p->MIB_II.inCcUDoneErr++;
				atmReset();
				return;
			}			
		} else if (atmRxIrqReport & LIRQ_IRQ_Q_FULL) {
			atmReset();
			break; //jjreturn;
		} else if (atmRxIrqReport & LIRQ_RX_M_BD_OV) {
			//atmReset(); mark tmp. by Robert, need test below TC's code!! 11092005
			if (vc == 0x0a) {		/* CC ...for L2-> vc = 0x0a means oam or cc cell.*/
				atmRxCcDescrp = atmRxCcBusyDescrp;
		 		atmRxCcDescrp->rdes1 = (96 << 16);
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);
					atmRxCcBusyDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
				}else{
					atmRxCcBusyDescrp++;
				}
				TSARM_RXMBCSR |= 1 << 16;
				atm_p->MIB_II.inCcBufDescrOverflow++;
			} else {				/* OAM ...for L2-> vc = 0x0a means oam or cc cell. */
				atmRxCcDescrp = atmRxOamBusyDescrp[vc];
				atmRxCcDescrp->rdes1 = (48 << 16);
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
					atmRxOamBusyDescrp[vc] = atmRxDescrVcPoolp->rxOamDescrPool;
				}else{
					atmRxOamBusyDescrp[vc]++;
				}
				TSARM_RXMBCSR |= 1 << vc;
				atm_p->MIB_II.inMngBufDescrOverflow++;
			}
			break; //jjreturn;
		} else if (atmRxIrqReport & LIRQ_RX_CRC10E) {
			if (vc == 0x0a) {		/* CC ...for L2-> vc = 0x0a means oam or cc cell.*/
				atmRxCcDescrp = atmRxCcBusyDescrp;
		 		atmRxCcDescrp->rdes1 = (96 << 16); 
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);
					atmRxCcBusyDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
				}else{
					atmRxCcBusyDescrp++;
				}
			} else {				/* OAM ...for L2-> vc = 0x0a means oam or cc cell. */
				atmRxCcDescrp = atmRxOamBusyDescrp[vc];
				atmRxCcDescrp->rdes1 = (48 << 16); 
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
					atmRxOamBusyDescrp[vc] = atmRxDescrVcPoolp->rxOamDescrPool;
				}else{
					atmRxOamBusyDescrp[vc]++;
			}
			}
			atm_p->MIB_II.inCrc10Err++;
		} else if (atmRxIrqReport & LIRQ_RX_M_DONE) {
			if (vc == 0x0a) {		/* CC ...for L2-> vc = 0x0a means oam or cc cell. */
				atmRxCcDescrp = atmRxCcBusyDescrp;
				if ( !(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_VALID) ) {
					atmCcHandler((uint8 *)PHYSICAL_TO_K1(atmRxCcDescrp->rdes2));
				}
				atmRxCcDescrp->rdes1 = (96 << 16); 
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);
					atmRxCcBusyDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
				}else{
					atmRxCcBusyDescrp++;
				}
			} else {				/* OAM ...for L2-> vc = 0x0a means oam or cc cell. */
				atmRxCcDescrp = atmRxOamBusyDescrp[vc];
				if ( !(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_VALID) ) {
					atmOamHandler(atmRxCcDescrp, vc);
				}
				atmRxCcDescrp->rdes1 = (48 << 16); 
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
					atmRxOamBusyDescrp[vc] = atmRxDescrVcPoolp->rxOamDescrPool;
				}else{
					atmRxOamBusyDescrp[vc]++;
				}
			}
		} else if (atmRxIrqReport == LIRQ_RX_INACT_VC) {
			/* inactive cell, just need to remove irq */
			if (sarDebugFlag)
				dbg_plinel_1("\r\n atmRxIrqReport=", atmRxIrqReport);
		}
		else if(atmRxIrqReport & LIRQ_RX_M_BOV){
			if (vc == 0x0a) {		/* CC ...for L2-> vc = 0x0a means oam or cc cell.*/
				atmRxCcDescrp = atmRxCcBusyDescrp;
		 		atmRxCcDescrp->rdes1 = (96 << 16);
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);
					atmRxCcBusyDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
		} else {		
					atmRxCcBusyDescrp++;
				}
				atm_p->MIB_II.inCcBufOverflow++;
			} else {				/* OAM ...for L2-> vc = 0x0a means oam or cc cell. */
				atmRxCcDescrp = atmRxOamBusyDescrp[vc];
				atmRxCcDescrp->rdes1 = (48 << 16);
				atmRxCcDescrp->rdes0 |= TSARM_RX_DESCR_VALID;
				if(atmRxCcDescrp->rdes0 & TSARM_RX_DESCR_EOR){
					atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
					atmRxOamBusyDescrp[vc] = atmRxDescrVcPoolp->rxOamDescrPool;
				}else{
					atmRxOamBusyDescrp[vc]++;
				}
				atm_p->MIB_II.inMngBufOverflow++;
			}
		} 		
		else {
			atmIrqStSaved(atmRxIrqReport, vc);
			dbg_plinel_1("\r\n Invalid atmRxIrqReport=", atmRxIrqReport);
			dbg_plineb_1(" vc=", vc);
			if (sarDebugFlag)
				dbg_plinel_1("\r\n atmRxIrqReport=", atmRxIrqReport);
			atmReset();
			return;
		}
		TSARM_IRQC = 1;
	}
	VPint(CR_INTC_IMR)|= (1 << SAR_INT);
}

/*______________________________________________________________________________
**  atmRegDump
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
int
atmRegDump(
	char *buf,
	uint8 vc
)
{
	uint16	index=0;

	index += sprintf( buf+index, "\n\r***** ATM SAR Module: Common Register Dump *****");
	index += sprintf( buf+index, "\n\rReset&Identify reg   = 0x%08x, General CFG reg       = 0x%08x",
		TSARM_RAI, TSARM_GFR);
	index += sprintf( buf+index, "\n\rTraffic Sched. TB reg= 0x%08x, RX Max Length reg     = 0x%08x",
		TSARM_TSTBR, TSARM_RMPLR);
	index += sprintf( buf+index, "\n\rP23 Data c /s reg    = 0x%08x, TX Traffic Sched. LR reg= 0x%08x",
		TSARM_TXDBCSR_P23, TSARM_TXSLRC);
	index += sprintf( buf+index, "\n\rP01 Data c /s reg    = 0x%08x, TX OAM ctrl/stat reg    = 0x%08x",
		TSARM_TXDBCSR_P01, TSARM_TXMBCSR);
	index += sprintf( buf+index, "\n\rRX Data ctrl/stat reg= 0x%08x, RX OAM ctrl/stat reg  = 0x%08x",
		TSARM_RXDBCSR, TSARM_RXMBCSR);
	index += sprintf( buf+index, "\n\rLast IRQ Status reg  = 0x%08x, IRQ Queue Base reg    = 0x%08x",
		TSARM_LIRQ, TSARM_IRQBA);
	index += sprintf( buf+index, "\n\rIRQ Queue Entry len  = 0x%08x, IRQ Head ind. reg     = 0x%08x",
		TSARM_IRQLEN, TSARM_IRQH);
	index += sprintf( buf+index, "\n\r");
	index += sprintf( buf+index, "\n\r***** ATM SAR Module: VC(%02d) Register Dump *****\n\r", vc);
	index += sprintf( buf+index, "\n\rVC IRQ Mask register = 0x%08x, VC Configuration reg  = 0x%08x",
		TSARM_IRQM(vc), TSARM_VCCR(vc));
	index += sprintf( buf+index, "\n\rTX Data Current descr= 0x%08x, TX OAM Current descr  = 0x%08x",
		TSARM_TXDCBDA(vc), TSARM_TXMCBDA(vc));
	index += sprintf( buf+index, "\n\rRX Data Current descr= 0x%08x, RX OAM Current descr  = 0x%08x",
		TSARM_RXDCBDA(vc), TSARM_RXMCBDA(vc));
	index += sprintf( buf+index, "\n\rTX Traffic PCR       = 0x%08x, TX Traffic SCR        = 0x%08x",
		TSARM_PCR(vc), TSARM_SCR(vc));
	index += sprintf( buf+index, "\n\rTX Traffic MBS/Type  = 0x%08x",
		TSARM_MBSTP(vc));
	index += sprintf( buf+index, "\n\rTX Total Data Count  = 0x%08x, RX Total Data Count   = 0x%08x",
		TSARM_TDCNT(vc), TSARM_RDCNT(vc));
	index += sprintf( buf+index, "\n\rVC IRQ CC Mask reg   = 0x%08x, VC CC Config reg      = 0x%08x",
		TSARM_IRQMCC, TSARM_CCCR);
	index += sprintf( buf+index, "\n\rTX CC Current descr  = 0x%08x, RX CC Current descr   = 0x%08x",
		TSARM_CC_TX_BD_BASE, TSARM_CC_RX_BD_BASE);
	index += sprintf( buf+index, "\n\rTX CC Total Count    = 0x%08x, RX CC Total Count     = 0x%08x",
		TSARM_TDCNTCC, TSARM_RDCNTCC);
	index += sprintf( buf+index, "\n\rRX Mis-insert Cnt.   = 0x%08x, TX AAL5 Count           = 0x%08x",
		TSARM_MISCNT, atmTxVcCnt[vc]);
	index += sprintf( buf+index, "\n\r");

	return index;
}

/*______________________________________________________________________________
**  atmCounterDisplay
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmCounterDisplay(
	void
)
{
	int		index = 0;
	char	stateATM[800];

	index = getATMState( stateATM );

	printf("%s", stateATM);
}


int
getATMState(char *stateATM)
{
	uint16	index=0;

	index += sprintf( stateATM+index, "\n[ SAR Counters ]\n");
	index += sprintf( stateATM+index, "inPkts        = 0x%08x, inDiscards    = 0x%08x\n",
		atm_p->MIB_II.inPkts, atm_p->MIB_II.inDiscards);
	index += sprintf( stateATM+index, "inF4Pkts      = 0x%08x, inF5Pkts      = 0x%08x\n",
		atm_p->MIB_II.inF4Pkts, atm_p->MIB_II.inF5Pkts);		
	index += sprintf( stateATM+index, "inDMATaskEnd  = 0x%08x, inBufErr      = 0x%08x\n",
		atm_p->MIB_II.inDMATaskEnd, atm_p->MIB_II.inBufErr);		
	index += sprintf( stateATM+index, "inCrcErr      = 0x%08x\n", atm_p->MIB_II.inCrcErr);				
	index += sprintf( stateATM+index, "inBufOverflow = 0x%08x, inBufMaxLenErr= 0x%08x\n",
		atm_p->MIB_II.inBufOverflow, atm_p->MIB_II.inBufMaxLenErr);		
	index += sprintf( stateATM+index, "inBufLenErr   = 0x%08x, inBufDescrOV  = 0x%08x\n",
		atm_p->MIB_II.inBufLenErr, atm_p->MIB_II.inBufDescrOverflow);		
	index += sprintf( stateATM+index, "outPkts       = 0x%08x, outDiscards   = 0x%08x\n",
		atm_p->MIB_II.outPkts, atm_p->MIB_II.outDiscards);
	index += sprintf( stateATM+index, "outF4Pkts     = 0x%08x, outF5Pkts     = 0x%08x\n",
		atm_p->MIB_II.outF4Pkts, atm_p->MIB_II.outF5Pkts);
	index += sprintf( stateATM+index, "softRstCnt    = 0x%08x\n", atm_p->MIB_II.softRstCnt);	
	index += sprintf( stateATM+index, "inCrc10Err     = 0x%08x\n", atm_p->MIB_II.inCrc10Err);
	index += sprintf( stateATM+index, "inMngBufOV     = 0x%08x, inCcBufOV      = 0x%08x\n",
		atm_p->MIB_II.inMngBufOverflow, atm_p->MIB_II.inCcBufOverflow);
	index += sprintf( stateATM+index, "inMngBufDescrOV= 0x%08x, inCcBufDescrOV = 0x%08x\n",
		atm_p->MIB_II.inMngBufDescrOverflow, atm_p->MIB_II.inCcBufDescrOverflow);
	index += sprintf( stateATM+index, "inMpoaErr      = 0x%08x, inVlanHit      = 0x%08x\n",
		atm_p->MIB_II.inMpoaErr, atm_p->MIB_II.inVlanHit);
	index += sprintf( stateATM+index, "inCcUDoneErr   = 0x%08x, inCcUBDOV      = 0x%08x\n",
		atm_p->MIB_II.inCcUDoneErr, atm_p->MIB_II.inCcUBDOV);	

	return index;
}
	

/*______________________________________________________________________________
**  atmCounterClear
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmCounterClear(
	void
)
{
	memset((char *)&(atm_p->MIB_II), 0, sizeof(atmMIB_II_t));
}

int
getATMQueState(char *stateATM)
{
	uint16	index=0;
        uint8 vc;
	int i;

        index += sprintf( stateATM+index, "ATM SAR Queue Information:\n\n");
        for (vc = 0; vc < ATM_VC_MAX; vc++)
        {
                index += sprintf( stateATM+index, "VC%d %d/%d: open=%d txVcCnt=%d P0=%d, P1=%d, P2=%d, P3=%d\n",
			vc, atmCfgTable.vpi[vc], atmCfgTable.vci[vc], atmCfgTable.openFlag[vc],
                      	atmTxVcCnt[vc], atmTxPriVcCnt[0][vc], atmTxPriVcCnt[1][vc], atmTxPriVcCnt[2][vc],
			atmTxPriVcCnt[3][vc]);

        }
	

        index += sprintf( stateATM+index, "\nSaved IRQ st: index=%x\n", savedAtmIrqIndex);
	for (i = 0; i < SAVED_IRQ_MAX_ENTRY; i++) {
		if ((i & 0x3) == 0)
        		index += sprintf( stateATM+index, "\n");
       		index += sprintf( stateATM+index, "%08x:%02x ", 
			savedAtmIrqSt[i].irqst, savedAtmIrqSt[i].vc);
	}
  	index += sprintf( stateATM+index, "\n");
	return index;
}

int
getATMVcTxDescrDump(char *stateATM, uint8 vc)
{
	uint16	index=0;
        int i;
        uint8 descrId;
        atmTxDescrPool_t *atmTxDescrVcPool;
        atmTxDescr_t *atmTxDescrp;
        atmTxCcDescr_t *atmTxOamDescrp;
        uint8 priority;

        atmTxDescrVcPool = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool
+ vc);
        index += sprintf( stateATM+index, "VC=%d atmTxDescrPool = %08x \n", vc, (uint32)atmTxDescrPool);
        index += sprintf( stateATM+index, " atmTxVCDescrVcPool = %08x \n", (uint32)atmTxDescrVcPool);

        for(priority = 0; priority < ATM_TX_PRIORITY_MAX; priority++){
                index += sprintf( stateATM+index, " --- Tx Priority %d ---\n", priority);
                index += sprintf( stateATM+index, " atmTxVcBusyDescrp = %08x\n", (uint32) atmTxVcBusyDescrp[priority][vc]);
                index += sprintf( stateATM+index, " atmTxVcFreeDescrp = %08x\n", (uint32) atmTxVcFreeDescrp[priority][vc]);
                atmTxDescrp = (atmTxDescr_t *)atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[priority];
                for (i=0; i < ATM_TX_VC_DESCR_PRIORITY_NUMMAX[priority]; i++, atmTxDescrp++){
                        index += sprintf( stateATM+index, " --- i=%d ", i);
                        index += sprintf( stateATM+index, " atmTxDescrp = %08x --- \n", (uint32)atmTxDescrp);
                        index += sprintf( stateATM+index, "  ->tdes0 = %08x\n", (uint32) atmTxDescrp->tdes0);
                        index += sprintf( stateATM+index, "  ->tdes1 = %08x\n", (uint32) atmTxDescrp->tdes1);
                        index += sprintf( stateATM+index, "  ->tdes2 = %08x\n", (uint32) atmTxDescrp->tdes2);
                        index += sprintf( stateATM+index, "  ->tdes3 = %08x\n", (uint32) atmTxDescrp->tdes3);
                        index += sprintf( stateATM+index, "  ->skb = %08x\n", (uint32) atmTxDescrp->skb);
                }
        }
        // management
        index += sprintf( stateATM+index, " --- Tx Oam descriptor dump ---\n");
        index += sprintf( stateATM+index, " atmTxOamFreeDescrp = %08x\n", (uint32) atmTxOamFreeDescrp[vc]);
        atmTxOamDescrp = atmTxDescrVcPool->txOamDescrPool;
        for (i=0; i<ATM_TX_CC_DESCR_NUMMAX; i++, atmTxOamDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmTxOamDescrp = %08x --- \n", i, (uint32)atmTxOamDescrp);
                index += sprintf( stateATM+index, "  ->tdes0 = %08x\n", (uint32) atmTxOamDescrp->tdes0);
                index += sprintf( stateATM+index, "  ->tdes1 = %08x\n", (uint32) atmTxOamDescrp->tdes1);
                index += sprintf( stateATM+index, "  ->tdes2 = %08x\n", (uint32) atmTxOamDescrp->tdes2);
                index += sprintf( stateATM+index, "  ->tdes3 = %08x\n", (uint32) atmTxOamDescrp->tdes3);
        }
	return index;
}

int
getATMVcRxDescrDump(char *stateATM, uint8 vc)
{
	uint16	index=0;
        uint32 i;
        atmRxDescrPool_t *atmRxDescrVcPoolp;
        atmRxDescr_t *atmRxDataDescrp;
        atmRxCcDescr_t *atmRxMngDescrp;

        atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);

        index += sprintf( stateATM+index, " atmRxDescrPool = %08x\n", (uint32)atmRxDescrPool);
        index += sprintf( stateATM+index, " atmRxDataDescrVcPoolp = %08x\n", (uint32)atmRxDescrVcPoolp);

        // data
        index += sprintf( stateATM+index, " --- Rx Data Descriptor dump ---");
        atmRxDataDescrp = atmRxDescrVcPoolp->rxDescrPool;
        for (i=0; i<ATM_RX_VC_DESCR_NUMMAX; i++, atmRxDataDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmRxDataDescrp = %08x ---\n", i, (uint32)atmRxDataDescrp);
                index += sprintf( stateATM+index, "  ->rdes0 = %08x\n", (uint32) atmRxDataDescrp->rdes0);
                index += sprintf( stateATM+index, "  ->rdes1 = %08x\n", (uint32) atmRxDataDescrp->rdes1);
                index += sprintf( stateATM+index, "  ->rdes2 = %08x\n", (uint32) atmRxDataDescrp->rdes2);
                index += sprintf( stateATM+index, "  ->rdes3 = %08x\n", (uint32) atmRxDataDescrp->rdes3);
                index += sprintf( stateATM+index, "  ->skb = %08x\n", (uint32) atmRxDataDescrp->skb);
        }

        // management
        index += sprintf( stateATM+index, " --- Rx Mng Descriptor dump ---\n");
        atmRxMngDescrp = atmRxDescrVcPoolp->rxOamDescrPool;
        for (i=0; i<ATM_RX_CC_DESCR_NUMMAX; i++, atmRxMngDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmRxMngDescrp = %08x ---\n", i, (uint32)atmRxMngDescrp);
                index += sprintf( stateATM+index, "  ->rdes0 = %08x\n", atmRxMngDescrp->rdes0);
                index += sprintf( stateATM+index, "  ->rdes1 = %08x\n", atmRxMngDescrp->rdes1);
                index += sprintf( stateATM+index, "  ->rdes2 = %08x\n", atmRxMngDescrp->rdes2);
                index += sprintf( stateATM+index, "  ->rdes3 = %08x\n", atmRxMngDescrp->rdes3);
        }
	return index;	
}

void atmIrqStSaved(uint32 irqst, uint8 vc)
{
	savedAtmIrqSt[savedAtmIrqIndex].irqst = irqst;
	savedAtmIrqSt[savedAtmIrqIndex].vc = vc;
	savedAtmIrqIndex++;
	if (savedAtmIrqIndex >= SAVED_IRQ_MAX_ENTRY)
		savedAtmIrqIndex = 0;
}

int
atmDebugOn(
	void
)
{	
	sarDebugFlag = 1;
	printf("debug = on\n");
	return 0;	
}		

int
atmDebugOff(
	void
)
{
	sarDebugFlag = 0;
	printf("debug = off\n");
	return 0;	
}		

/*______________________________________________________________________________
**  atmCcHandler
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmCcHandler(
	uint8 *cellp
)
{
	atmOamCell_t *oamCellp;
	uint8 ret = 0;
	uint8 isF4 = 0;	
	uint32 i;

	oamCellp = (atmOamCell_t *)(CACHE_TO_NONCACHE(cellp));
	if (sarDebugFlag) {
		dbg_plinew_1("\n\r gfc=", oamCellp->gfc);
		dbg_plinew_1("\n\r vpi=", oamCellp->vpi);
		dbg_plinew_1("\n\r vci=", oamCellp->vci);
		dbg_plinew_1("\n\r pti=", oamCellp->pti);
		dbg_plinew_1("\n\r clp=", oamCellp->clp);
		dbg_plinew_1("\n\r cellType=", oamCellp->oamCellType);
		dbg_plinew_1("\n\r funcType=", oamCellp->oamFuncType);
		dbg_pline_1("\n\r payload=");
		for (i = 0; i < 45; i++) {
			if ((i & 0x7) == 0)
				dbg_pline_1("\n\r");
			dbg_plineb_1(" ", oamCellp->payload[i]);
		}
	}
	if ( oamCellp->oamCellType != OAM_FAULT_MANAGEMENT ) {
		ret = 1;
	}
	if ((oamCellp->vci == 3) || (oamCellp->vci == 4)) {
		isF4 = 1;
		atm_p->MIB_II.inF4Pkts++;
	}	
	
	switch ( oamCellp->oamFuncType ) {
	case OAM_LOOPBACK:
		/* Loopback Indication field:
		** 1 - source point, 0 - loopback point
		*/
		if ( oamCellp->payload[0] == 0x00 ) {
			ret = 1;
		}
		else {
			oamCellp->payload[0] = 0x00;
		}
		break;
	case OAM_AIS:
		oamCellp->oamFuncType = OAM_RDI;
		break;
	default:
		ret = 1;
		break;
	}
	if ( !ret ) {
		if(!atmCcDataReq((uint8 *)oamCellp)){
			if(isF4){
				atm_p->MIB_II.outF4Pkts++;
			}
			atm_p->MIB_II.outPkts++;
		}	
	}

	return ret;
}

/*______________________________________________________________________________
**  atmOamHandler
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
atmOamHandler(
	atmRxCcDescr_t *atmRxCcDescrp,
	uint8 vc
)
{
	atmOamCellPayload_t *oamCellPayloadp;
	uint8 pti;
	uint8 ret = 0;
	uint8 isF4 = 0;	
	uint32 i;

	oamCellPayloadp = (atmOamCellPayload_t *)(CACHE_TO_NONCACHE(PHYSICAL_TO_K1(atmRxCcDescrp->rdes2)));
	pti = (atmRxCcDescrp->rdes1 & 0x70000000) >> 28;
	if (sarDebugFlag) {
		dbg_plinew_1("\n\r vpi=", atmCfgTable.vpi[vc]);
		dbg_plinew_1("\n\r vci=", atmCfgTable.vci[vc]);
		dbg_plinew_1("\n\r pti=", pti);
		dbg_plinew_1("\n\r cellType=", oamCellPayloadp->oamCellType);
		dbg_plinew_1("\n\r funcType=", oamCellPayloadp->oamFuncType);
		dbg_pline_1("\n\r payload=");
		for (i = 0; i < 45; i++) {
			if ((i & 0x7) == 0)
				dbg_pline_1("\n\r");
			dbg_plineb_1(" ", oamCellPayloadp->payload[i]);
		}
	}
	if ( oamCellPayloadp->oamCellType != OAM_FAULT_MANAGEMENT ) {
		ret = 1;
	}
	if ((pti == 4) || (pti == 5)) {
		isF4 = 0;
		atm_p->MIB_II.inF5Pkts++;
	}			
	
	switch ( oamCellPayloadp->oamFuncType ) {
	case OAM_LOOPBACK:
		/* Loopback Indication field:
		** 1 - source point, 0 - loopback point
		*/
		if ( oamCellPayloadp->payload[0] == 0x00 ) {
			ret = 1;
			/* Sam add for scanpvc */
			if ( scanpvc_flag == ATM_SCANPVC_MODE && !isF4)
			{
				fill_scanpvc_ret_table(vc, OAM_F5_VALID);	
			}/* End Sam add for scanpvc */
		}
		else {
			oamCellPayloadp->payload[0] = 0x00;
		}
		break;
	case OAM_AIS:
		oamCellPayloadp->oamFuncType = OAM_RDI;
		break;
	default:
		ret = 1;
		break;
	}
	if ( !ret ) {
		if(!atmOamDataReq((uint8 *)oamCellPayloadp, pti, vc)) {
			if(!isF4){
				atm_p->MIB_II.outF5Pkts++;
			}
			atm_p->MIB_II.outPkts++;
		}	
	}

	return ret;
}

/*______________________________________________________________________________
**  atmVcNumberGet
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
uint8
//__IMEM uint8
atmVcNumberGet(
	uint8 vpi,
	uint16 vci
)
{
	uint8 vc;

	for ( vc = 0; vc < ATM_VC_MAX; vc++ ) {
		if ( atmCfgTable.openFlag[vc] &&
			 (atmCfgTable.vpi[vc] == vpi) &&
		     (atmCfgTable.vci[vc] == vci) ) {
			return vc;
		}
	}

	return ATM_DUMMY_VC; 
}

/*______________________________________________________________________________
**  atmAal5DataInd
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
struct sk_buff  *
//__IMEM struct sk_buff  *
atmAal5DataInd(
	struct sk_buff *skb,
	uint8 vc
)
{
	struct sk_buff *freeSkb = NULL;
	struct atm_vcc *vcc;

	atm_p->MIB_II.inPkts++;
	//freeSkb = dev_alloc_skb(0x700); //mark tmp. by Robert,need test below TC's code
	freeSkb = dev_alloc_skb(RX_BUF_LEN);
	if ( freeSkb ) {
		// Sam add for scanpvc
		if (scanpvc_flag == ATM_AAL5_MODE)
		{
			#if 0
			unsigned char *tempidx;
			int kkk;
			#endif

			vcc = atmCfgTable.vcc[vc];
			ATM_SKB(skb)->vcc = vcc;
			skb->stamp = vcc->timestamp = xtime;

			#if 0
			tempidx = skb->data;
			for (kkk=1;kkk<200;kkk++,tempidx++)
			{
			if (kkk%64 == 0)
			printk("\n");
			printk("%02x ",*tempidx);
			}
			printk("\n");
			#endif

/* added by Robert, TC's code, need to test, 11092005 */
		if (atm_charge(vcc, skb->truesize) == 0) {
			//dev_kfree_skb(skb);
			dev_kfree_skb_any(skb);
			atm_p->MIB_II.inDiscards++;
			return freeSkb;
		}
/* end of added by Robert, TC's code, need to test, 11092005 */
			/*pass it up to kernel networking layer and update stats*/
			vcc->push(vcc, skb);

			atomic_inc(&vcc->stats->rx);
		}
		else
		{
			scanpvc_parse_rxpacket(skb,vc);
#if ATM_TIMER_DBG
			incoming_packet_count++;
#endif
/* added by Robert, need to test */
			atm_p->MIB_II.inDiscards++;
			return freeSkb;
/* end of added by Robert, need to test */
		}
	}
	else {
		atm_p->MIB_II.inDiscards++;
		freeSkb = skb;
	}

	return freeSkb;
}

/*______________________________________________________________________________
**  atm
**
**  descriptions:
**  execution sequence:
**  commands process:
**  parameters:
**  local:
**  global:
**  return:
**  called by:
**  call:
**____________________________________________________________________________*/
void
atmReset(
	void
)
{
	uint32 i; 
	unsigned long flags;

	if (1) { //jjsarDebugFlag) {
		dbg_pline_1("\r\n atmReset");
	}
#if FINLAND_DEBUG
//printk("ATM_RESET\n");
#endif 
	save_flags(flags);
	cli();	

	// disable rx
	TSARM_GFR = 0x0;
	delay1ms(1);

	atm_p->MIB_II.softRstCnt++;
	while ((TSARM_IRQH & 0x00fff000) >> 12) 
		TSARM_IRQC = 1;
	sarSoftReset = 1;
	//sarDrvDescripReset(); //movedown
	memcpy( (uint8*)&atmCfgBackup, (uint8*)&atmCfgTable ,sizeof(atmConfig_t));	/* backup control table */
	for( i = 0; i < atmCfgBackup.vcNumber; i++ ){	/* open vc according to backup table*/
		atmAal5VcClose( atmCfgTable.vpi[i], atmCfgTable.vci[i]);
	}
	sarDrvDescripReset();
	memset( (uint8*)&atmCfgTable, 0, sizeof(atmConfig_t));
	memset( (uint8*)&atmTxCcDescrPool, 0 ,sizeof(atmTxCcDescrPool_t));
	memset( (uint8*)(atmRxCcDescrPool_t*)&atmRxCcDescrPool, 0, sizeof(atmRxCcDescrPool_t));
	memset( (uint8*)&ccBuf, 0, sizeof(atmRxCcCell_t)*ATM_RX_CC_DESCR_NUMMAX);
	memset( (uint8*)&oamBuf, 0, sizeof(atmRxOamDescrPool_t)*ATM_VC_MAX);
/* mark by TC's code, need to test, 11092005 */
/*
	memset( (uint8*)&atmTxOamDescrPool, 0, sizeof(atmTxCcDescrPool_t)*ATM_VC_MAX);
	memset( (uint8*)&atmRxOamDescrPool, 0, sizeof(atmRxCcDescrPool_t)*ATM_VC_MAX);
*/
/* end of mark by TC's code, need to test, 11092005 */
	memset( (uint8*)&atmTxDescrPool, 0 ,sizeof(atmTxDescrPool_t)*ATM_VC_MAX);
	memset( (uint8*)&atmRxDescrPool, 0 ,sizeof(atmRxDescrPool_t)*ATM_VC_MAX);

	atmInit();	/* reset sar & init descriptor */

	// Sam add if condition, scanpvc_flag ATM_AAL5_MODE=0; ATM_SCANPVC_MODE=1
	// If we enter ATM_SCANPVC_MODE , we dont restore the original atmCfgBackup
	if (!scanpvc_flag)
	for( i = 0; i < atmCfgBackup.vcNumber; i++ ){	/* open vc according to backup table*/
		atmAal5VcOpen( atmCfgBackup.vpi[i], atmCfgBackup.vci[i], &qosRecord[i], atmCfgBackup.vcc[i]);
	}
	
	restore_flags(flags);	
}


void
sarDrvDescripReset(
	void
)
{
	uint8 vc;
	uint8 descrId;
	atmTxDescrPool_t *atmTxDescrVcPool;
	atmTxDescr_t *atmTxDescrp;
	atmRxDescrPool_t *atmRxDescrVcPoolp;
	atmRxDescr_t *atmRxDescrp;
	struct sk_buff *skb;
	uint32 rxData_offset;

	for ( vc = 0; vc < ATM_VC_MAX; vc++ ) {
		atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);
		rxData_offset = (uint32)atmRxDescrVcPoolp->rxDescrPool - (uint32)atmRxDescrVcPoolp;
		TSARM_RXDCBDA(vc)=K1_TO_PHYSICAL(atmRxDescrVcPoolp);
		TSARM_VC_RX_DATA(vc) = K1_TO_PHYSICAL(rxData_offset);
		atmRxVcDescrp[vc] = atmRxDescrVcPoolp->rxDescrPool;
		for ( descrId = 0; descrId < ATM_RX_VC_DESCR_NUMMAX; descrId++ ) {
			atmRxDescrp = atmRxDescrVcPoolp->rxDescrPool+ descrId;
			skb = atmRxDescrp->skb;
			if( skb != NULL ){
				//dev_kfree_skb(skb);
				dev_kfree_skb_any(skb);
				atmRxDescrp->skb = NULL;	
			}
		}
	}
	for ( vc = 0; vc < ATM_VC_MAX; vc++ ) {
		atmTxDescrVcPool = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool + vc);
		// Clear tx packet count and initialize free pointer per vc 
		//Set up VC(n)'s current tx descr pointer 
		//////////////////
		//Tx Data Priority 0
		for ( descrId = 0; descrId < ATM_TX_VC_DESCR_P0_NUMMAX; descrId++ ) {
			atmTxDescrp = atmTxDescrVcPool->txP0DescrPool+ descrId;
			skb = atmTxDescrp->skb;	
			if( skb != NULL ){
				//dev_kfree_skb(skb);
				dev_kfree_skb_any(skb);
				atmTxDescrp->skb = NULL;	
			}
		}
		//////////////////
		//Tx Data Priority 1
		for ( descrId = 0; descrId < ATM_TX_VC_DESCR_P1_NUMMAX; descrId++ ) {
			atmTxDescrp = atmTxDescrVcPool->txP1DescrPool+ descrId;
			skb = atmTxDescrp->skb;	
			if( skb != NULL ){
				//dev_kfree_skb(skb);
				dev_kfree_skb_any(skb);
				atmTxDescrp->skb = NULL;	
			}
		}
		//////////////////
		//Tx Data Priority 2
		for ( descrId = 0; descrId < ATM_TX_VC_DESCR_P2_NUMMAX; descrId++ ) {
			atmTxDescrp = atmTxDescrVcPool->txP2DescrPool+ descrId;
			skb = atmTxDescrp->skb;	
			if( skb != NULL ){
				//dev_kfree_skb(skb);
				dev_kfree_skb_any(skb);
				atmTxDescrp->skb = NULL;	
			}
		}
		//////////////////
		//Tx Data Priority 3
		for ( descrId = 0; descrId < ATM_TX_VC_DESCR_P3_NUMMAX; descrId++ ) {
			atmTxDescrp = atmTxDescrVcPool->txP3DescrPool + descrId;
			skb = atmTxDescrp->skb;	
			if( skb != NULL ){
				//dev_kfree_skb(skb);
				dev_kfree_skb_any(skb);
				atmTxDescrp->skb = NULL;	
			}
		}
	}
}

#if 1
typedef struct {
	uint16          actualBitrateNearInt;
	uint16          actualBitrateNearFast;
	uint16          actualBitrateFarInt;
	uint16          actualBitrateFarFast;
} T_adslChannelOperData;

int 
getXdslSpeed(void)
{
	uint8 modemst;
	T_adslChannelOperData adslChannelOperData;

	TCIfQuery(ADSL_QUERY_STATUS, &modemst, NULL );		   //Jason_920527
	if (modemst != ADSL_MODEM_STATE_UP)
		return 0;

	TCIfQuery(ADSL_QUERY_CH_OP_DATA, &adslChannelOperData, NULL); 		 //Jason_920527
	return (adslChannelOperData.actualBitrateFarFast+adslChannelOperData.actualBitrateFarInt);
}    
#endif
/************************************************************************
*		     A T M    D E V I C E   O P S  D E F I N I T I O N S
*************************************************************************
*/
static int tc3162_atm_open(struct atm_vcc *vcc, short vpi, int vci)
{
	struct atm_dev *dev = vcc->dev;
	tc3162_atm_prv *prv;
	qosProfile_t qos;
	uint8 vc;
#if FINLAND_DEBUG
	printk("tc3162_atm_open vcc=%08X vpi=%d vci=%d\n",vcc, vpi, vci);
#endif
	prv = (tc3162_atm_prv *) dev->dev_data;

	vcc->vpi = vpi;
	vcc->vci = vci;

	set_bit(ATM_VF_ADDR, &vcc->flags);	/* claim address	*/		  
	vcc->itf = vcc->dev->number;		/* interface number */

	qos.pcr = 0;
	qos.scr = 0;
	qos.mbs = 0;
	qos.type = UBR;

	switch (vcc->qos.txtp.traffic_class) {
	case ATM_CBR: 
		qos.type = CBR;
		qos.pcr = vcc->qos.txtp.pcr;
		break;
  	case ATM_UBR:
		qos.type = UBR;
		qos.pcr = vcc->qos.txtp.pcr;
		break;
  	case ATM_VBR: 
		qos.type = VBR;
		qos.pcr = vcc->qos.txtp.pcr;
		qos.scr = vcc->qos.txtp.scr;
		qos.mbs = vcc->qos.txtp.mbs;
		break;
// Sam add for support nrtVBR
        case ATM_nrtVBR:
                qos.type = nrtVBR;
                qos.pcr = vcc->qos.txtp.pcr;
                qos.scr = vcc->qos.txtp.scr;
                qos.mbs = vcc->qos.txtp.mbs;
                break;
// End Sam add
	default:
		/* default is UBR */
		break;
	}

	//printk("tc3162_atm_open qos type=%d pcr=%d scr=%d mbs=%d\n", qos.type, qos.pcr, qos.scr, qos.mbs);
	if (atmAal5VcOpen(vpi, vci, &qos, vcc)) 
    	return -EBUSY;

	#if 0
	vc = atmVcNumberGet(vpi, vci);
	if ( vc == ATM_DUMMY_VC ) 
		return -EBUSY;

	atmCfgTable.vcc[vc] = vcc;
	#endif

	set_bit(ATM_VF_READY, &vcc->flags);

	MOD_INC_USE_COUNT;

	//printk("tc3162_atm_open vpi=%d vci=%d done\n", vpi, vci);
	return 0;
}

static void tc3162_atm_close(struct atm_vcc *vcc)
{
	//printk("tc3162_atm_close vpi=%d vci=%d\n", vcc->vpi, vcc->vci);
	
	clear_bit(ATM_VF_ADDR, &vcc->flags);  
	atmAal5VcClose(vcc->vpi, vcc->vci);
	clear_bit(ATM_VF_READY, &vcc->flags);  

	MOD_DEC_USE_COUNT;

	//printk("tc3162_atm_close done\n");
}

static int tc3162_atm_ioctl(struct atm_dev *dev, unsigned int cmd, void *arg)
{
	uint32 ret;
	oamdatareq_t* oamparam;
	//pvcmap_t* pvctable;
	//pvc_table_list_t* pvc_list;
	//pvc_table_list_t ret_pvc_table;
	
	uint8 modemst;
	int ret1;	
int index;
#if ATM_TIMER_DBG
unsigned long dbg_val;
#endif

#if FINLAND_DEBUG
printk("ATM IOCTL DEV:%08X CMD:%08X\n",dev,cmd);
#endif
// Sam add 12/27 
	
	switch(cmd)
	{
		case ATM_SETOAM:
#if FINLAND_DEBUG
		printk("IOCTL ATM_SETOAM:%08X\n",ATM_SETOAM);
#endif
			oamparam = (oamdatareq_t *)(arg);
			ret = atmOamF4F5DataReq(oamparam->vpi,oamparam->vci,oamparam->f5,oamparam->endtoEnd,oamparam->funcType);
#if ATM_TIMER_DBG
			printk("Sam tc3162/atm.c 1954 ret=%d\n",ret);
			init_timer(&atm_dbg_timer);
			atm_dbg_timer.function = atm_timer_1min;
			atm_dbg_timer.data = (unsigned long)dev;
			mod_timer(&atm_dbg_timer,jiffies+(HZ*60));
#endif
			return ret;
		case ATM_SET_SCANPVC:
#if SCANPVC_DBG
			printk("Sam ad debug at atm.c line 2509 ATM_SET_SCANPVC\n");	
#endif
#if FINLAND_DEBUG
		printk("IOCTL ATM_SET_SCANPVC:%08X\n",ATM_SET_SCANPVC);
#endif
			if ((ret1 = tc3162_init_scanpvc((pvc_table_list_t *)arg))!=0)
				return ret1;
			read_scanpvc_done = 0;
			// create scanpvc time out timer 
			init_timer(&atm_scanpvc_timer);

			// Query ADSL line status , it marked for test and it will be unmark before release
			TCIfQuery(ADSL_QUERY_STATUS, &modemst, NULL );  // Check ADSL Line Status first
			if (modemst == ADSL_MODEM_STATE_UP)
			scanpvc_send_test_pattern();
			
			atm_scanpvc_timer.function = tc3162_atm_scanpvc_monitor;
			atm_scanpvc_timer.data = (unsigned long)dev;
#if ATM_TIMER_DBG
			dbg_val = jiffies;
#endif
			mod_timer(&atm_scanpvc_timer,jiffies+( HZ*4 )); // set 4 secs timeout value
#if ATM_TIMER_DBG
			printk("start jiffies = %d\n",dbg_val);
#endif
			// End timer declartion
 			#if 0 
			pvc_list = (pvc_table_list_t *)arg;
			for ( index=0; index < pvc_list->pvc_count; index++)
			printk("index = %d vpi=%d vci=%d\n",index,pvc_list->pvc_table[index].vpi,pvc_list->pvc_table[index].vci);
			printk("Sam tc3162/atm.c 1960 ATM_SET_SCANPVC\n");
			#endif
			break;
		case ATM_GET_SCANPVC:
#if SCANPVC_DBG 
			printk("Sam add debug at atm.c line 2533 ATM_GET_SCANPVC\n");
#endif
#if FINLAND_DEBUG
		printk("IOCTL ATM_GET_SCANPVC:%08X\n",ATM_GET_SCANPVC);
#endif
			//if (scanpvc_done)
			if (scanpvc_flag == ATM_AAL5_MODE && read_scanpvc_done == 0)
			{
				read_scanpvc_done = 1;
				return	copy_to_user((pvc_table_list_t *)(arg),&ret_pvc_table,sizeof(pvc_table_list_t));
			}
			else
			{
#if SCANPVC_DBG
				printk("check scanpvc_flag=%d read_scanpvc_done=%d\n",scanpvc_flag,read_scanpvc_done);
#endif
				return -EAGAIN;
			}
			//break;
		default:
			return -ENOIOCTLCMD;	
	}
// End Sam add
	return 0;
}

static int tc3162_atm_send(struct atm_vcc *vcc, struct sk_buff *skb)
{
	int ret;
	uint32 flags;
#if FINLAND_DEBUG
	unsigned long temp_vcc;
	temp_vcc = vcc;
	if (temp_vcc != vcc_val)
	{
		vcc_val = temp_vcc;
		printk("atm send but VCC change to %08X\n",vcc_val);
	}
#endif
	save_flags(flags);
	cli();
	ATM_SKB(skb)->vcc = vcc;
	ret = atmAal5DataReq(skb, vcc->vpi, vcc->vci);
	if (!ret)
		atomic_inc(&vcc->stats->tx);
#if FINLAND_DEBUG
	else
		printk("atm send fail\n");
#endif
	restore_flags(flags);
	return ret;
}

static int tc3162_atm_change_qos (struct atm_vcc *vcc, struct atm_qos *qos,int flags)
{
	printk("tc3162_atm_change_qos\n");
	return 0;
}

/************************************************************************
*		     A T M    D E V I C E   P R O C  D E F I N I T I O N S
*************************************************************************
*/

extern struct proc_dir_entry *proc_tc3162;
int proc_vc[ATM_VC_MAX];
char proc_vc_name[ATM_VC_MAX][16];

static int tsarm_stats_read_proc(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
	int len = getATMState(buf);
	if (len <= off+count) 
		*eof = 1;
	*start = buf + off;
	len -= off;
	if (len>count) 
		len = count;
	if (len<0) 
		len = 0;
	return len;
}

static int tsarm_stats_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[32];
	unsigned long val;


	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';

	memset((char *)&(atm_p->MIB_II), 0, sizeof(atmMIB_II_t));

	return count;
}

static int tsarm_questats_read_proc(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
        int len = getATMQueState(buf);
        if (len <= off+count)
                *eof = 1;
        *start = buf + off;
        len -= off;
        if (len>count)
                len = count;
        if (len<0)
                len = 0;
        return len;
}

static int tsarm_proc_reg(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
	int len;
	int *vc;

	vc = (int *) data;
	len = atmRegDump(buf, *vc);
	if (len <= off+count) 
		*eof = 1;
	*start = buf + off;
	len -= off;
	if (len>count) 
		len = count;
	if (len<0) 
		len = 0;
	return len;
}

static uint32 savedInF5Pkts = 0;
static uint32 savedInF4Pkts = 0;

static int oam_ping_read_proc(char *page, char **start, off_t off,
	int count, int *eof, void *data)
{
	int len;
	int result;

	result = (savedInF5Pkts != atm_p->MIB_II.inF5Pkts) || (savedInF4Pkts != atm_p->MIB_II.inF4Pkts);
	if (result) {
		savedInF5Pkts = atm_p->MIB_II.inF5Pkts;
		savedInF4Pkts = atm_p->MIB_II.inF4Pkts;
	}

	len = sprintf(page, "%d\n", result);

	len -= off;
	*start = page + off;

	if (len > count)
		len = count;
	else
		*eof = 1;

	if (len < 0)
		len = 0;

	return len;
}

static int oam_ping_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[32];
	unsigned long val;
	uint32 vpi;
	uint32 vci;
	uint32 f5;
	uint32 endToEnd;
	uint32 funcType;


	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';

	if (sscanf(val_string, "%d %d %d %d %d", &vpi, &vci, &f5, &endToEnd, &funcType) != 5) {
		printk("usage: <vpi> <vci> <f5> <end-to-end> <type:0(AIS) 1(RDI) 2(Loopback)>\n");
		return count;
	}

	savedInF5Pkts = atm_p->MIB_II.inF5Pkts;
	savedInF4Pkts = atm_p->MIB_II.inF4Pkts;

	atmOamF4F5DataReq((uint8 )vpi, (uint16 )vci, f5, endToEnd, funcType);
	return count;
}

static int tsarm_debug_read_proc(char *page, char **start, off_t off,
	int count, int *eof, void *data)
{
	int len;

	len = sprintf(page, "%d\n", sarDebugFlag);

	len -= off;
	*start = page + off;

	if (len > count)
		len = count;
	else
		*eof = 1;

	if (len < 0)
		len = 0;

	return len;
}

static int tsarm_debug_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[8];
	unsigned long val;

	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';

	val = simple_strtoul(val_string, NULL, 10);
	if (val != 0)
		sarDebugFlag = 1;
	else
		sarDebugFlag = 0;

	return count;
}

static uint32 vcTxDescrDump = 0;
static uint32 vcRxDescrDump = 0;

#define CHK_BUF() pos = begin + index; if (pos < off) { index = 0; begin = pos; }; if (pos > off + count) goto done;

static int tsarm_txdescrdump_read_proc(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
	int index=0;
	off_t pos = 0;
	off_t begin = 0;
        int i;
        atmTxDescrPool_t *atmTxDescrVcPool;
        atmTxDescr_t *atmTxDescrp;
        atmTxCcDescr_t *atmTxOamDescrp;
        uint8 priority;
	uint32 vc;
	char *stateATM = buf;	

	vc = vcTxDescrDump;
        atmTxDescrVcPool = (atmTxDescrPool_t *)CACHE_TO_NONCACHE(atmTxDescrPool
+ vc);
        index += sprintf( stateATM+index, "VC=%d atmTxDescrPool = %08x \n", vc, (uint32)atmTxDescrPool);
	CHK_BUF();
        index += sprintf( stateATM+index, " atmTxVCDescrVcPool = %08x \n", (uint32)atmTxDescrVcPool);
	CHK_BUF();

        for(priority = 0; priority < ATM_TX_PRIORITY_MAX; priority++){
                index += sprintf( stateATM+index, " --- Tx Priority %d ---\n", priority);
		CHK_BUF();
                index += sprintf( stateATM+index, " atmTxVcBusyDescrp = %08x\n", (uint32) atmTxVcBusyDescrp[priority][vc]);
		CHK_BUF();
                index += sprintf( stateATM+index, " atmTxVcFreeDescrp = %08x\n", (uint32) atmTxVcFreeDescrp[priority][vc]);
		CHK_BUF();
                atmTxDescrp = (atmTxDescr_t *)atmTxDescrVcPool->txPriDescrPoolPhysicalAddr[priority];
                for (i=0; i < ATM_TX_VC_DESCR_PRIORITY_NUMMAX[priority]; i++, atmTxDescrp++){
                        index += sprintf( stateATM+index, " --- i=%d ", i);
			CHK_BUF();
                        index += sprintf( stateATM+index, " atmTxDescrp = %08x --- \n", (uint32)atmTxDescrp);
			CHK_BUF();
                        index += sprintf( stateATM+index, "  ->tdes0 = %08x\n", (uint32) atmTxDescrp->tdes0);
			CHK_BUF();
                        index += sprintf( stateATM+index, "  ->tdes1 = %08x\n", (uint32) atmTxDescrp->tdes1);
			CHK_BUF();
                        index += sprintf( stateATM+index, "  ->tdes2 = %08x\n", (uint32) atmTxDescrp->tdes2);
			CHK_BUF();
                        index += sprintf( stateATM+index, "  ->tdes3 = %08x\n", (uint32) atmTxDescrp->tdes3);
			CHK_BUF();
                        index += sprintf( stateATM+index, "  ->skb = %08x\n", (uint32) atmTxDescrp->skb);
			CHK_BUF();
                }
        }
        // management
        index += sprintf( stateATM+index, " --- Tx Oam descriptor dump ---\n");
	CHK_BUF();
        index += sprintf( stateATM+index, " atmTxOamFreeDescrp = %08x\n", (uint32) atmTxOamFreeDescrp[vc]);
	CHK_BUF();
        atmTxOamDescrp = atmTxDescrVcPool->txOamDescrPool;
        for (i=0; i<ATM_TX_CC_DESCR_NUMMAX; i++, atmTxOamDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmTxOamDescrp = %08x --- \n", i, (uint32)atmTxOamDescrp);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes0 = %08x\n", (uint32) atmTxOamDescrp->tdes0);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes1 = %08x\n", (uint32) atmTxOamDescrp->tdes1);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes2 = %08x\n", (uint32) atmTxOamDescrp->tdes2);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes3 = %08x\n", (uint32) atmTxOamDescrp->tdes3);
		CHK_BUF();
        }
	*eof = 1;

done:
	*start = buf + (off - begin);
	index -= (off - begin);
	if (index<0) 
		index = 0;
	if (index>count) 
		index = count;
	return index;
}

static int tsarm_txdescrdump_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[32];

	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';
	vcTxDescrDump = simple_strtoul(val_string, NULL, 10);

	return count;
}

static int tsarm_rxdescrdump_read_proc(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
	int index=0;
	off_t pos = 0;
	off_t begin = 0;
        uint32 i;
        atmRxDescrPool_t *atmRxDescrVcPoolp;
        atmRxDescr_t *atmRxDataDescrp;
        atmRxCcDescr_t *atmRxMngDescrp;
	uint32 vc;
	char *stateATM = buf;	

	vc = vcTxDescrDump;
        atmRxDescrVcPoolp = (atmRxDescrPool_t *)CACHE_TO_NONCACHE(atmRxDescrPool + vc);

        index += sprintf( stateATM+index, " atmRxDescrPool = %08x\n", (uint32)atmRxDescrPool);
	CHK_BUF();
        index += sprintf( stateATM+index, " atmRxDataDescrVcPoolp = %08x\n", (uint32)atmRxDescrVcPoolp);
	CHK_BUF();

        // data
        index += sprintf( stateATM+index, " --- Rx Data Descriptor dump ---\n");
	CHK_BUF();
        atmRxDataDescrp = atmRxDescrVcPoolp->rxDescrPool;
        for (i=0; i<ATM_RX_VC_DESCR_NUMMAX; i++, atmRxDataDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmRxDataDescrp = %08x ---\n", i, (uint32)atmRxDataDescrp);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes0 = %08x\n", (uint32) atmRxDataDescrp->rdes0);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes1 = %08x\n", (uint32) atmRxDataDescrp->rdes1);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes2 = %08x\n", (uint32) atmRxDataDescrp->rdes2);
		CHK_BUF();//added by TC, 02152006,robert
                index += sprintf( stateATM+index, "  ->rdes3 = %08x\n", (uint32) atmRxDataDescrp->rdes3);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->skb = %08x\n", (uint32) atmRxDataDescrp->skb);
		CHK_BUF();
        }

        // management
        index += sprintf( stateATM+index, " --- Rx Mng Descriptor dump ---\n");
	CHK_BUF();
        atmRxMngDescrp = atmRxDescrVcPoolp->rxOamDescrPool;
        for (i=0; i<ATM_RX_CC_DESCR_NUMMAX; i++, atmRxMngDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmRxMngDescrp = %08x ---\n", i, (uint32)atmRxMngDescrp);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes0 = %08x\n", atmRxMngDescrp->rdes0);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes1 = %08x\n", atmRxMngDescrp->rdes1);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes2 = %08x\n", atmRxMngDescrp->rdes2);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes3 = %08x\n", atmRxMngDescrp->rdes3);
		CHK_BUF();
        }
	*eof = 1;

done:
	*start = buf + (off - begin);
	index -= (off - begin);
	if (index<0) 
		index = 0;
	if (index>count) 
		index = count;
	return index;
}

static int tsarm_rxdescrdump_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[32];

	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';
	vcRxDescrDump = simple_strtoul(val_string, NULL, 10);

	return count;
}

static int tsarm_ccdescrdump_read_proc(char *buf, char **start, off_t off, int count,
                 int *eof, void *data)
{
	int index=0;
	off_t pos = 0;
	off_t begin = 0;
        int i;
        atmRxCcDescrPool_t *atmRxCcDescrPoolp;
        atmRxCcDescr_t *atmRxCcDescrp;
        atmTxCcDescrPool_t *atmTxCcDescrVcPoolp;
        atmTxCcDescr_t *atmTxCcDescrp;
	char *stateATM = buf;	

        atmTxCcDescrVcPoolp = (atmTxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmTxCcDescrPool);

        index += sprintf( stateATM+index, " atmTxCcFreeDescrp = %08x\n", (uint32)&atmTxCcFreeDescrp);
	CHK_BUF();
        index += sprintf( stateATM+index, " atmTxCcDescrPool = %08x\n", (uint32)&atmTxCcDescrPool);
	CHK_BUF();
        index += sprintf( stateATM+index, " atmTxCcDescrVcPool = %08x\n", (uint32)atmTxCcDescrVcPoolp);
	CHK_BUF();

        index += sprintf( stateATM+index, " --- Tx Cc descriptor dump ---\n");
	CHK_BUF();
        atmTxCcDescrp = atmTxCcDescrVcPoolp->txCcDescrPool;
        for (i=0; i<ATM_TX_CC_DESCR_NUMMAX; i++, atmTxCcDescrp++){
                index += sprintf( stateATM+index, " -- i=%d atmTxCcDescrp = %08x ---\n", i, (uint32)atmTxCcDescrp);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes0 = %08x\n", atmTxCcDescrp->tdes0);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes1 = %08x\n", atmTxCcDescrp->tdes1);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes2 = %08x\n", atmTxCcDescrp->tdes2);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->tdes3 = %08x\n", atmTxCcDescrp->tdes3);
		CHK_BUF();
        }

        atmRxCcDescrPoolp = (atmRxCcDescrPool_t *)CACHE_TO_NONCACHE(&atmRxCcDescrPool);

        index += sprintf( stateATM+index, " atmRxCcDescrPool = %08x\n", (uint32)&atmRxCcDescrPool);
	CHK_BUF();
        index += sprintf( stateATM+index, " atmRxCcDescrVcPoolp = %08x\n", (uint32)atmRxCcDescrPoolp);
	CHK_BUF();

        index += sprintf( stateATM+index, " --- Rx Cc Descriptor dump ---\n");
	CHK_BUF();
        atmRxCcDescrp = atmRxCcDescrPoolp->rxCcDescrPool;
        for (i=0; i<ATM_RX_CC_DESCR_NUMMAX; i++, atmRxCcDescrp++){
                index += sprintf( stateATM+index, " --- i=%d atmRxCcDescrp = %08x ---\n", i, (uint32)atmRxCcDescrp);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes0 = %08x\n", atmRxCcDescrp->rdes0);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes1 = %08x\n", atmRxCcDescrp->rdes1);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes2 = %08x\n", atmRxCcDescrp->rdes2);
		CHK_BUF();
                index += sprintf( stateATM+index, "  ->rdes3 = %08x\n", atmRxCcDescrp->rdes3);
		CHK_BUF();
	}

	*eof = 1;

done:
	*start = buf + (off - begin);
	index -= (off - begin);
	if (index<0) 
		index = 0;
	if (index>count) 
		index = count;
	return index;
}

static int tsarm_reset_read_proc(char *page, char **start, off_t off,
	int count, int *eof, void *data)
{
	int len;

	len = sprintf(page, "\n");

	len -= off;
	*start = page + off;

	if (len > count)
		len = count;
	else
		*eof = 1;

	if (len < 0)
		len = 0;

	return len;
}

static int tsarm_reset_write_proc(struct file *file, const char *buffer,
	unsigned long count, void *data)
{
	char val_string[8];
	unsigned long val;

	if (count > sizeof(val_string) - 1)
		return -EINVAL;

	if (copy_from_user(val_string, buffer, count))
		return -EFAULT;

	val_string[count] = '\0';

	atmReset();

	return count;
}



static int __init tc3162_atm_init(void)
{
	struct proc_dir_entry *tsarm_proc;
	tc3162_atm_prv *prv;
	int vc;
	int err=0;

	printk("TSARM: TC3162 ATM SAR driver %s init\n",ATM_DRIVER_VERSION);
	if ((prv = kmalloc(sizeof(tc3162_atm_prv), GFP_KERNEL)) == NULL) {
		printk("unable to kmalloc priv structure.\n");
  	    return -ENOMEM;
	}
	memset(prv, 0, sizeof(tc3162_atm_prv));
	prv->name = "TC3162 ATM Driver";
	prv->proc_name = "tsarm";

	// Sam if ((tc3162_atm_dev = atm_dev_register(prv->proc_name, &tc3162_atm_ops, -1, NULL)) == NULL) {
	if ((tc3162_atm_dev = atm_dev_register(prv->proc_name, &tc3162_atm_ops, 0, NULL)) == NULL) {
		printk("atm dev register fail.\n");
  	    return -EIO;
	}

	prv->dev = tc3162_atm_dev;
	tc3162_atm_dev->dev_data = prv;

	tc3162_atm_dev->ci_range.vpi_bits = ATM_CI_MAX;        /* atm VPI supports 8 bits */
	tc3162_atm_dev->ci_range.vci_bits = ATM_CI_MAX;        /* atm VCI supports 16 bits */	

	/* init tsarm hardware module */
	atmInit();

	if (request_irq(SAR_INT, atmIsr, SA_INTERRUPT, "TSARM", tc3162_atm_dev) != 0) {
		printk("can not allocate IRQ.\n");
  	    err = -EIO;
		goto failed;
	}

	/* proc_tc3162 = proc_mkdir("tc3162", NULL); */

	/* atm related stats */
	tsarm_proc = create_proc_entry("tsarm_stats", 0, proc_tc3162);
	tsarm_proc->read_proc = tsarm_stats_read_proc;
	tsarm_proc->write_proc = tsarm_stats_write_proc;
	create_proc_read_entry("tsarm_questats", 0, proc_tc3162, tsarm_questats_read_proc, NULL);
	for (vc = 0; vc < ATM_VC_MAX; vc++) {
		proc_vc[vc] = vc;
		sprintf(proc_vc_name[vc], "tsarm_vc%d", vc);
		create_proc_read_entry(proc_vc_name[vc], 0, proc_tc3162, tsarm_proc_reg, &proc_vc[vc]);
	}
	/* atm oam loopback */
	tsarm_proc = create_proc_entry("oam_ping", 0, proc_tc3162);
	tsarm_proc->read_proc = oam_ping_read_proc;
	tsarm_proc->write_proc = oam_ping_write_proc;
	/* atm debug */
	tsarm_proc = create_proc_entry("tsarm_debug", 0, proc_tc3162);
	tsarm_proc->read_proc = tsarm_debug_read_proc;
	tsarm_proc->write_proc = tsarm_debug_write_proc;
	/* atm tx descr dump */
	tsarm_proc = create_proc_entry("tsarm_txdescr", 0, proc_tc3162);
	tsarm_proc->read_proc = tsarm_txdescrdump_read_proc;
	tsarm_proc->write_proc = tsarm_txdescrdump_write_proc;
	/* atm rx descr dump */
	tsarm_proc = create_proc_entry("tsarm_rxdescr", 0, proc_tc3162);
	tsarm_proc->read_proc = tsarm_rxdescrdump_read_proc;
	tsarm_proc->write_proc = tsarm_rxdescrdump_write_proc;
	/* atm cc descr dump */
	create_proc_read_entry("tsarm_ccdescr", 0, proc_tc3162, tsarm_ccdescrdump_read_proc, NULL);
	/* atm reset */
	tsarm_proc = create_proc_entry("tsarm_reset", 0, proc_tc3162);
	tsarm_proc->read_proc = tsarm_reset_read_proc;
	tsarm_proc->write_proc = tsarm_reset_write_proc;

	printk("TSARM: TC3162 ATM SAR driver %s done\n",ATM_DRIVER_VERSION);
	return 0;

failed:
	if (prv)
		kfree(prv);
	if (tc3162_atm_dev) 
		atm_dev_deregister(tc3162_atm_dev);
	tc3162_atm_dev = NULL;
    return err;
}

static int __exit tc3162_atm_exit(void)
{
	tc3162_atm_prv *prv;
	int vc;
	
	printk("tc3162_atm_exit\n");

	free_irq(SAR_INT, tc3162_atm_dev);

	prv = (tc3162_atm_prv *) tc3162_atm_dev->dev_data;
	kfree(prv);

	atm_dev_deregister(tc3162_atm_dev);
	tc3162_atm_dev = NULL;
	
	remove_proc_entry("tsarm_stats", proc_tc3162);
	remove_proc_entry("tsarm_questats", proc_tc3162);
	for (vc = 0; vc < ATM_VC_MAX; vc++) {
		remove_proc_entry(proc_vc_name[vc], proc_tc3162);
		}
	remove_proc_entry("oam_ping", proc_tc3162);
	remove_proc_entry("tsarm_debug", proc_tc3162);
	remove_proc_entry("tsarm_txdescr", proc_tc3162);
	remove_proc_entry("tsarm_rxdescr", proc_tc3162);
	remove_proc_entry("tsarm_ccdescr", proc_tc3162);
	remove_proc_entry("tsarm_reset", proc_tc3162);
	return 0;

}

int tc3162_init_scanpvc(pvc_table_list_t* scanpvc_info_p)
{
	uint8 modemst;
	int i;
	uint8* data_p;
	
	if (scanpvc_flag == ATM_SCANPVC_MODE)
		return -EINPROGRESS;

	// Its nessery to detect the ADSL line status , if its not ADSL line up ,discard to do this.

	// Query ADSL line status , it marked for test and it will be unmark before release
	TCIfQuery(ADSL_QUERY_STATUS, &modemst, NULL );  // Check ADSL Line Status first
	if (modemst != ADSL_MODEM_STATE_UP)
		return -ENETDOWN;
	

	// Fill the test pattern 
	if (!fill_the_test_pattern_done)	
	fill_the_test_pattern(scanpvc_info_p->mac_addr);
	
	// If the ip information is not NULL, fill the IP information
	scanpvc_needip_flag = 1;  // yes, we assume its the valid ip address information
	
	data_p = scanpvc_info_p -> src_ip; // Check source ip is valid ??
	if ( *data_p == 0 && *(data_p + 1) == 0 && *(data_p + 2) == 0 && *(data_p + 3) == 0)
		scanpvc_needip_flag = 0; // The source ip is not valid, we dont need ip information

	if (scanpvc_needip_flag) // source ip is valid, check destination ip if its vaild
	{
		data_p = scanpvc_info_p -> dst_ip;
		if ( *data_p == 0 && *(data_p + 1) == 0 && *(data_p + 2) ==0 && *(data_p + 3) == 0)
			scanpvc_needip_flag = 0; // destination ip is not valid, we cant use this ip information
		else	// destination ip is valid ,too. set flag and fill ip information in test packet
		{
			scanpvc_needip_flag = 1;
			fill_the_ipinfo(scanpvc_info_p->src_ip, scanpvc_info_p->dst_ip);
		}
	}
	
	
	// Initial the scanpvc result report
	ret_pvc_table.pvc_count = 0;
	for (i = 0; i < MAX_SCANPVC; i++)
	{
		ret_pvc_table.pvc_table[i].vpi = 0;
		ret_pvc_table.pvc_table[i].vci = 0;
		ret_pvc_table.pvc_table[i].result = 0;
	}

	// Backup running config and qos config
	memcpy((uint8 *)&scanpvc_backup_atmConfig,(uint8 *)&atmCfgTable,sizeof(atmConfig_t));
	memcpy((uint8 *)scanpvc_backup_qosProfile,(uint8 *)qosRecord,sizeof(qosRecord)); 

	// Set scanpvc_flag to do special action
	scanpvc_flag = ATM_SCANPVC_MODE;
	
	//scanpvc_done = SCANPVC_RUNNING;

	// close all data pvc at first
	for (i = 0; i < ATM_VC_MAX; i++ )
	{
		/* close original pvc */
		TSARM_VCCR(i) = 0;
		// Traffic Scheduler - PCR
		TSARM_PCR(i) = 0;
		// Traffic Scheduler - SCR
		TSARM_SCR(i) = 0;
		// Traffic Scheduler - MBSTP
		TSARM_MBSTP(i) = 0;
		atmCfgTable.openFlag[i] = 0;
		atmCfgTable.vcNumber=0; 
	
	atmCfgTable.vpi[i] = atmCfgTable.vci[i] = 0;
			//atmCfgTable.vcNumber--;

	// VC configuration

	local_irq_disable();
	atmTxDescrFree(i);
	local_irq_enable();



		/* end close pvc */
	}

	// If the scanpvc table bigger than the ATM_VC_MAX, we need do twice or more  
	if (scanpvc_info_p -> pvc_count >  ATM_VC_MAX) 
	{
		pvc_table_list_p = scanpvc_info_p;  //keep the pvc info structure for timer function using

		for (i = 0; i < ATM_VC_MAX; i++ )
		{	
			// prepare the each qos profile 
			scanpvc_qosprofile.type = 0;	
			scanpvc_qosprofile.pcr = 0;	
			scanpvc_qosprofile.scr = 0;	
			scanpvc_qosprofile.mbs = 0;

			// create the first round ATM_VC_MAX PVCs
			atmAal5VcOpen(scanpvc_info_p->pvc_table[i].vpi,scanpvc_info_p->pvc_table[i].vci,&scanpvc_qosprofile,0);
			run_scanpvc_round = 1;
		}
	}
	else // the scanpvc table is less or equal the ATM_VC_MAX
		for (i = 0; i < scanpvc_info_p->pvc_count; i++)
		{
			// prepare the each pvc qos profile
			scanpvc_qosprofile.type = 0;	
			scanpvc_qosprofile.pcr = 0;	
			scanpvc_qosprofile.scr = 0;	
			scanpvc_qosprofile.mbs = 0;	

			// create the final round PVCs
			atmAal5VcOpen(scanpvc_info_p->pvc_table[i].vpi,scanpvc_info_p->pvc_table[i].vci,&scanpvc_qosprofile,0);
			run_scanpvc_round = 0;
		}
	return 0;

}

void fill_the_test_pattern(uint8_t* mac_addr_p)
{
        int j;
                                                                                                                                                                              
        for (j=0;j<MAC_ADDR_SIZE;j++)
        {
             pppoe_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
             pppoe_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
                                                                                                                                                                              
             dhcpclient_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
             dhcpclient_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + BOOTP_CLI_HWADR_OFFSET + j ]=*mac_addr_p;
             dhcpclient_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + BOOTP_CLI_ID_HWADR_OFFSET + j ]=*mac_addr_p;
                                                                                                                                                                              
             dhcpclient_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
             dhcpclient_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + BOOTP_CLI_HWADR_OFFSET + j ]=*mac_addr_p;
             dhcpclient_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + BOOTP_CLI_ID_HWADR_OFFSET + j ]=*mac_addr_p;
                                                                                                                                                                              
             rfc2684b_llc_arp_pattern[ RFC2684B_LLC_HEADER_LEN + ETH_SRC_MAC_OFFSET +j ]=*mac_addr_p;
             rfc2684b_llc_arp_pattern[ RFC2684B_LLC_HEADER_LEN + ARP_SRC_MAC_OFFSET +j ]=*mac_addr_p;
             rfc2684b_vc_arp_pattern[ RFC2684B_VC_HEADER_LEN + ETH_SRC_MAC_OFFSET +j ]=*mac_addr_p;
             rfc2684b_vc_arp_pattern[ RFC2684B_VC_HEADER_LEN + ARP_SRC_MAC_OFFSET +j ]=*mac_addr_p;
                                                                                                                                                                              
#ifdef _SEND_DHCPC_RELEASE_
             // Shall we also fill teh DHCP release here???
             dhcpclient_release_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
             dhcpclient_release_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + BOOTP_CLI_HWADR_OFFSET + j ]=*mac_addr_p;
             dhcpclient_release_2684_llc_pattern[ RFC2684B_LLC_HEADER_LEN + BOOTP_CLI_ID_HWADR_OFFSET + j ]=*mac_addr_p;
                                                                                                                                                                              
             dhcpclient_release_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + ETH_SRC_MAC_OFFSET + j ]=*mac_addr_p;
             dhcpclient_release_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + BOOTP_CLI_HWADR_OFFSET + j ]=*mac_addr_p;
             dhcpclient_release_2684_vc_pattern[ RFC2684B_VC_HEADER_LEN + BOOTP_CLI_ID_HWADR_OFFSET + j ]=*mac_addr_p;
#endif
            ret_pvc_table.mac_addr[j] = *mac_addr_p; /* Keep the MAC address iformation to compare the ioncoming packet */
                mac_addr_p++;
        }

// Sam add for fill udp checksum
        setNet16(&dhcpclient_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + ETH_UDP_OFFSET_CHECKSUM], \
udp_sum_calc( (SIZE_DHCPC_LLC_2684_TESTPKT - RFC2684B_LLC_HEADER_LEN - IP_OFFSET_HEADER_START - IP_HEADER_SIZE), \
&dhcpclient_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + IP_OFFSET_HEADER_START + IP_HEADER_SIZE]));
       
        setNet16(&dhcpclient_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + ETH_UDP_OFFSET_CHECKSUM], \
udp_sum_calc( (SIZE_DHCPC_VC_2684_TESTPKT - RFC2684B_VC_HEADER_LEN - IP_OFFSET_HEADER_START - IP_HEADER_SIZE), \
&dhcpclient_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + IP_OFFSET_HEADER_START + IP_HEADER_SIZE]));
// End Sam add 


        setNet16(&dhcpclient_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + ETH_IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&dhcpclient_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + IP_OFFSET_HEADER_START]));
                                                                                                                                                                              
        setNet16(&dhcpclient_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + ETH_IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&dhcpclient_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + IP_OFFSET_HEADER_START]));

#ifdef _SEND_DHCPC_RELEASE_
	// Also, we need to add the check sum for DHCP release
        setNet16(&dhcpclient_release_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + ETH_UDP_OFFSET_CHECKSUM], \
udp_sum_calc( (SIZE_DHCPC_LLC_2684_TESTPKT - RFC2684B_LLC_HEADER_LEN - IP_OFFSET_HEADER_START - IP_HEADER_SIZE), \
&dhcpclient_release_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + IP_OFFSET_HEADER_START + IP_HEADER_SIZE]));
       
        setNet16(&dhcpclient_release_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + ETH_UDP_OFFSET_CHECKSUM], \
udp_sum_calc( (SIZE_DHCPC_VC_2684_TESTPKT - RFC2684B_VC_HEADER_LEN - IP_OFFSET_HEADER_START - IP_HEADER_SIZE), \
&dhcpclient_release_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + IP_OFFSET_HEADER_START + IP_HEADER_SIZE]));

        setNet16(&dhcpclient_release_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + ETH_IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&dhcpclient_release_2684_llc_pattern[RFC2684B_LLC_HEADER_LEN + IP_OFFSET_HEADER_START]));
                                                                                                                                                                              
        setNet16(&dhcpclient_release_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + ETH_IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&dhcpclient_release_2684_vc_pattern[RFC2684B_VC_HEADER_LEN + IP_OFFSET_HEADER_START]));
#endif
        fill_the_test_pattern_done = 1;
}

void fill_the_ipinfo(uint8_t* srcip_p, uint8_t* dstip_p)
{
        int i;
//      printk("2341 fill the ip packet \n");
        for (i = 0; i < IP_ADDR_SIZE; i++)
        {
             rfc2684b_llc_arp_pattern[ RFC2684B_LLC_HEADER_LEN + ARP_SRC_IP_OFFSET + i ] = *srcip_p;
             rfc2684b_llc_arp_pattern[ RFC2684B_LLC_HEADER_LEN + ARP_DST_IP_OFFSET + i ] = *dstip_p;
             rfc2684b_vc_arp_pattern[ RFC2684B_VC_HEADER_LEN + ARP_SRC_IP_OFFSET + i ] = *srcip_p;
             rfc2684b_vc_arp_pattern[ RFC2684B_VC_HEADER_LEN + ARP_DST_IP_OFFSET + i ] = *dstip_p;
             rfc2684r_llc_icmp_pattern[ RFC2684R_LLC_HEADER_LEN + ICMP_SRC_IP_OFFSET + i ] = *srcip_p;
             rfc2684r_llc_icmp_pattern[ RFC2684R_LLC_HEADER_LEN + ICMP_DST_IP_OFFSET + i ] = *dstip_p;
             rfc2684r_vc_icmp_pattern[ RFC2684R_VC_HEADER_LEN + ICMP_SRC_IP_OFFSET + i ] = *srcip_p;
             rfc2684r_vc_icmp_pattern[ RFC2684R_VC_HEADER_LEN + ICMP_DST_IP_OFFSET + i ] = *dstip_p;
                srcip_p++;
                dstip_p++;
        }
        // Calcute ip header checksum
        setNet16(&rfc2684r_llc_icmp_pattern[RFC2684R_LLC_HEADER_LEN+IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&rfc2684r_llc_icmp_pattern[RFC2684R_LLC_HEADER_LEN]));
        setNet16(&rfc2684r_vc_icmp_pattern[RFC2684R_VC_HEADER_LEN+IP_OFFSET_CHECKSUM],calculateIPheaderChecksum(1,&rfc2684r_vc_icmp_pattern[RFC2684R_VC_HEADER_LEN]));
        // Calcute icmp checksum
        setNet16(&rfc2684r_llc_icmp_pattern[RFC2684R_LLC_HEADER_LEN+ICMP_OFFSET_CHECKSUM],calculateIPheaderChecksum(2,&rfc2684r_llc_icmp_pattern[RFC2684R_LLC_HEADER_LEN]));
        setNet16(&rfc2684r_vc_icmp_pattern[RFC2684R_VC_HEADER_LEN+ICMP_OFFSET_CHECKSUM],calculateIPheaderChecksum(2,&rfc2684r_vc_icmp_pattern[RFC2684R_VC_HEADER_LEN]));
        scanpvc_needip_flag = 1;
}


/* Sam add timer function */
static void tc3162_atm_scanpvc_monitor(unsigned long dummy)
{ 
	int i,ret;
#if ATM_TIMER_DBG
unsigned long dbg_val;
#endif
	//printk("timer touch down\n");

//	if (scanpvc_done == SCANPVC_RUNNING)
	if ( run_scanpvc_round > 0)
	{	
		uint8 modemst;
		for ( i=0; i < ATM_VC_MAX; i++ )
		{
		//	atmAal5VcClose(atmCfgTable.vpi[i],atmCfgTable.vci[i]);
			// VC configuration
			TSARM_VCCR(i) = 0;
			// Traffic Scheduler - PCR
			TSARM_PCR(i) = 0;
			// Traffic Scheduler - SCR
			TSARM_SCR(i) = 0;
			// Traffic Scheduler - MBSTP
			TSARM_MBSTP(i) = 0;
			atmCfgTable.openFlag[i] = 0;

	atmCfgTable.vpi[i] = atmCfgTable.vci[i] = 0;
			atmCfgTable.vcNumber--;

	// VC configuration

	local_irq_disable();
	atmTxDescrFree(i);
	local_irq_enable();
 
		}
		for (i = 0; i < ATM_VC_MAX; i++ )
		{
			// prepare the each qos profile 
			scanpvc_qosprofile.type = 0;	
			scanpvc_qosprofile.pcr = 0;	
			scanpvc_qosprofile.scr = 0;	
			scanpvc_qosprofile.mbs = 0;

			// create the first round ATM_VC_MAX PVCs
			atmAal5VcOpen(pvc_table_list_p->pvc_table[8+i].vpi,pvc_table_list_p->pvc_table[8+i].vci,&scanpvc_qosprofile,0);
		}
		run_scanpvc_round--;

		// Query ADSL line status , it marked for test and it will be unmark before release
		TCIfQuery(ADSL_QUERY_STATUS, &modemst, NULL );  // Check ADSL Line Status first
		if (modemst == ADSL_MODEM_STATE_UP)
		scanpvc_send_test_pattern();

		mod_timer(&atm_scanpvc_timer,jiffies+( HZ*4 )); // set 4 secs timeout value
	}
	else // scanpvc time up ,we must close the test PVCs and restore the original PVC setting
	{ 
		// printk("2367 SCANPVC_DONE\n");
		for (i=0; i < ATM_VC_MAX; i++)
		{
			// VC configuration
			TSARM_VCCR(i) = 0;
			// Traffic Scheduler - PCR
			TSARM_PCR(i) = 0;
			// Traffic Scheduler - SCR
			TSARM_SCR(i) = 0;
			// Traffic Scheduler - MBSTP
			TSARM_MBSTP(i) = 0;
			atmCfgTable.openFlag[i] = 0;
			atmCfgTable.vcNumber--; 

	atmCfgTable.vpi[i] = atmCfgTable.vci[i] = 0;

	// VC configuration

	local_irq_disable();
	atmTxDescrFree(i);
	local_irq_enable();

		}
		// Restore original  Running config
		/*
		memcpy((uint8 *)&atmCfgTable,(uint8 *)&scanpvc_backup_atmConfig,sizeof(atmConfig_t));
		memcpy((uint8 *)qosRecord,(uint8 *)scanpvc_backup_qosProfile,sizeof(qosRecord)); 
		*/
		for( i = 0;i < scanpvc_backup_atmConfig.vcNumber;i++ )
		{
			ret = tc3162_atm_open(scanpvc_backup_atmConfig.vcc[i],scanpvc_backup_atmConfig.vpi[i],scanpvc_backup_atmConfig.vci[i]);
			//printk("ret - %d\n",ret);
		}
		scanpvc_flag = ATM_AAL5_MODE;
		/* all send scanpvc finish , need restore the atmCfgtable  */
#if ATM_TIMER_DBG
		dbg_val = jiffies;
		printk("scan pvc done, delete timer incoming_packet %d jiffies:%d\n",incoming_packet_count,dbg_val);
		incoming_packet_count = 0;
#endif
		del_timer(&atm_scanpvc_timer);
	}
}
/*  End of Sam add timer function */

void scanpvc_send_test_pattern(void)
{
	struct sk_buff* skb_test_p;
	uint vcindex,sendcount;
	for( vcindex=0; vcindex < ATM_VC_MAX; vcindex++ )
	{
		for(sendcount=0;sendcount < 3;sendcount ++)
		{
		// Alloc buffer for dhcp client llc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_DHCPC_LLC_2684_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{
			skb_test_p -> data = dhcpclient_2684_llc_pattern;
			skb_test_p -> len = SIZE_DHCPC_LLC_2684_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}
		
		// Alloc buffer for dhcp client vc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_DHCPC_VC_2684_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{
			skb_test_p -> data = dhcpclient_2684_vc_pattern;
			skb_test_p -> len = SIZE_DHCPC_VC_2684_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}

		// Alloc buffer for pppoe discover llc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_PPPOE_LLC_2684_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{

			skb_test_p -> data = pppoe_2684_llc_pattern;
			skb_test_p -> len = SIZE_PPPOE_LLC_2684_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}

		// Alloc buffer for pppoe discover vc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_PPPOE_VC_2684_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{
			skb_test_p -> data = pppoe_2684_vc_pattern;
			skb_test_p -> len = SIZE_PPPOE_VC_2684_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}

		// Alloc buffer for pppoa lcp request llc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_PPPOA_LLC_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{
			skb_test_p -> data = pppoa_llc_pattern;
			skb_test_p -> len = SIZE_PPPOA_LLC_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}

		// Alloc buffer for pppoa lcp request vc encap. and send it out
		//skb_test_p = dev_alloc_skb(SIZE_PPPOA_VC_TESTPKT);
		skb_test_p = dev_alloc_skb(0);
		if(skb_test_p)
		{
			skb_test_p -> data = pppoa_vc_pattern;
			skb_test_p -> len = SIZE_PPPOA_VC_TESTPKT;
			atmAal5RealDataReq(skb_test_p, vcindex);
		}
		
		// Check is it need send arp packet with ip address
		if ( scanpvc_needip_flag )
		{
			// Alloc buffer for ARP packet rfc2684b llc encap. and send it out
			skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
				skb_test_p -> data = rfc2684b_llc_arp_pattern;
				skb_test_p -> len = SIZE_RFC2684B_LLC_ARP_TESTPKT;
				atmAal5RealDataReq(skb_test_p, vcindex);
			}
			
			// Alloc buffer for ARP packet frc2684b vc encap. and send it out
			skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
				skb_test_p -> data = rfc2684b_vc_arp_pattern;
				skb_test_p -> len = SIZE_RFC2684B_VC_ARP_TESTPKT;
				atmAal5RealDataReq(skb_test_p, vcindex);
			}

                        // Alloc buffer for ICMP packet rfc2684r llc encap. and send it out
                        skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
                        	skb_test_p -> data = rfc2684r_llc_icmp_pattern;
                 	        skb_test_p -> len = SIZE_RFC2684R_LLC_ICMP_TESTPKT;
                        	atmAal5RealDataReq(skb_test_p, vcindex);
                         }                                                                                                                                                     
                        // Alloc buffer for ICMP packet frc2684r vc encap. and send it out
                        skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
                        	skb_test_p -> data = rfc2684r_vc_icmp_pattern;
                        	skb_test_p -> len = SIZE_RFC2684R_VC_ICMP_TESTPKT;
                        	atmAal5RealDataReq(skb_test_p, vcindex);
			}
		}

		// Send OAM F5 loopback packet
		// atmOamF4F5DataReq(vpi, vci, F5/F4, EndtoEnd/SegtoSeg, Function Type)
		atmOamF4F5DataReq(atmCfgTable.vpi[vcindex], atmCfgTable.vci[vcindex], OAM_F5_TYPE, OAM_END2END, OAM_FUNC_LOOPBACK);
		} // End sendcount for loop
	}

}

void scanpvc_parse_rxpacket(struct sk_buff* skb, uint8 vc)
{
	unsigned char* parse_data_p;
	uint16 result = 0;
#ifdef _SEND_DHCPC_RELEASE_
	struct sk_buff* skb_test_p;
#endif
#if SCANPVC_DBG
	unsigned char* testdump_p;
	int dump_idx1;
	testdump_p = parse_data_p = skb -> data;
#endif
	parse_data_p = skb -> data;

		// Sam add for debug
#if SCANPVC_DBG 
		for(dump_idx1=0;dump_idx1 < 40;dump_idx1++,testdump_p++)
		printk("%02x ",*testdump_p);
		printk("\n");
#endif

        if ( *parse_data_p == 0xaa && *(parse_data_p+1) == 0xaa && *(parse_data_p+2) == 0x03)
        {       /* uh... it seems like  rfc2684 llc header */
           
	   if ( *(parse_data_p + 3)== 0x00 && *(parse_data_p + 4) == 0x80 && *(parse_data_p + 5) == 0xc2)
           {
                parse_data_p = skb->data + RFC2684B_LLC_HEADER_LEN;

             if ( *parse_data_p == ret_pvc_table.mac_addr[0] && *(parse_data_p+1) == ret_pvc_table.mac_addr[1] &&
                        *(parse_data_p + 2)== ret_pvc_table.mac_addr[2] && *(parse_data_p + 3)== ret_pvc_table.mac_addr[3] &&
                        *(parse_data_p + 4)== ret_pvc_table.mac_addr[4] && *(parse_data_p + 5) == ret_pvc_table.mac_addr[5])
             {

                if (*(parse_data_p + MAC_PROTOCOL_OFFSET) == 0x88 && *(parse_data_p + MAC_PROTOCOL_OFFSET + 1) == 0x63)
                {
#if SCANPVC_DBG
                        printk("2617 Parse to pppoe llc protocol\n");
#endif
                        result = PPPOE_LLC_VALID;
                }
                else if (*(parse_data_p + MAC_PROTOCOL_OFFSET) == 0x08 && *(parse_data_p + MAC_PROTOCOL_OFFSET +1) == 0x06)
                {
                        if (scanpvc_needip_flag)
                        {
#if SCANPVC_DBG
				printk("2624 Parse to fixip 2684B LLC protocol\n");
#endif
                                result = FIXIP_2684B_LLC_VALID;
                        }
                }
                else if (*(parse_data_p + UDP_DST_PORT_OFFSET) == 0x00 && *(parse_data_p + UDP_DST_PORT_OFFSET +1) == 0x44)
                {

#if SCANPVC_DBG
                        printk("2630 Parse to dhcp client llc protocol\n");
#endif
                        result = DHCPC_LLC_VALID;
                }
                else
                {

#if SCANPVC_DBG
                        printk("2635 encap is llc but protocol unknown\n");
#endif
                        result = RFC2684B_LLC_VALID;
                }
             }
             else if (*(parse_data_p + UDP_DST_PORT_OFFSET) == 0x00 && *(parse_data_p + UDP_DST_PORT_OFFSET +1) == 0x44)
             {
#if SCANPVC_DBG
                        printk("2641 Parse to dhcp client llc protocol\n");
#endif
                        result = DHCPC_LLC_VALID;
#ifdef _SEND_DHCPC_RELEASE_
 			//Need to send the DHCP release for bridge mode
			// Alloc buffer for dhcp client llc encap. and send it out
			//skb_test_p = dev_alloc_skb(SIZE_DHCPC_LLC_2684_TESTPKT);
			skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
				skb_test_p -> data = dhcpclient_release_2684_llc_pattern;
				skb_test_p -> len = SIZE_DHCPC_LLC_2684_TESTPKT;
				atmAal5RealDataReq(skb_test_p, vc);
			}
#endif
           }
           }
           else if ( *(parse_data_p + 3)== 0x00 && *(parse_data_p + 4) == 0x00 && *(parse_data_p + 5) == 0x00)
           {
                parse_data_p = skb->data + RFC2684R_LLC_HEADER_LEN;
                if ( scanpvc_needip_flag && *(parse_data_p+IP_HEADER_PROTOCOL_OFFSET) == 0x01 && *(parse_data_p+IP_ICMP_TYPE_OFFSET) == 0x00)
                {        result = FIXIP_2684R_LLC_VALID;
#if SCANPVC_DBG
			printk("2650 FIXIP_2684R_LLC_VALID\n");
#endif
		}
           }
        }
	else if ( *parse_data_p == 0x00 && *(parse_data_p+1) == 0x00 )
	{	/* uh... it seems like rfc2684 vc header */
                 parse_data_p = skb->data + RFC2684B_VC_HEADER_LEN;

	     if ( *parse_data_p == ret_pvc_table.mac_addr[0] && *(parse_data_p+1) == ret_pvc_table.mac_addr[1] &&
			*(parse_data_p + 2)== ret_pvc_table.mac_addr[2] && *(parse_data_p + 3)== ret_pvc_table.mac_addr[3] &&
			*(parse_data_p + 4)== ret_pvc_table.mac_addr[4] && *(parse_data_p + 5) == ret_pvc_table.mac_addr[5])
	     {
		if (*(parse_data_p + MAC_PROTOCOL_OFFSET) == 0x88 && *(parse_data_p + MAC_PROTOCOL_OFFSET + 1) == 0x63)
		{
#if SCANPVC_DBG
			printk("2664 Parse to pppoe vc protocol\n");
#endif
			result = PPPOE_VC_VALID;
		}
	        else if (*(parse_data_p + MAC_PROTOCOL_OFFSET) == 0x08 && *(parse_data_p + MAC_PROTOCOL_OFFSET +1) == 0x06)
		{	
			if (scanpvc_needip_flag)
			{
#if SCANPVC_DBG
				printk("2671 Parse to fixip 2684B VC protocol\n");
#endif
				result = FIXIP_2684B_VC_VALID;
			} 
		}
	        else if (*(parse_data_p + UDP_DST_PORT_OFFSET) == 0x00 && *(parse_data_p + UDP_DST_PORT_OFFSET +1) == 0x44)
	        {
#if SCANPVC_DBG
			printk("2677 Parse to dhcp client vc protocol\n");
#endif
			result = DHCPC_VC_VALID;
	        }
		else
		{
#if SCANPVC_DBG
			printk("2682 encap is vc but protocol unknown\n");
#endif
			result = RFC2684B_VC_VALID;
		}
	     }
	     else if (*(parse_data_p + UDP_DST_PORT_OFFSET) == 0x00 && *(parse_data_p + UDP_DST_PORT_OFFSET +1) == 0x44)
	     {
#if SCANPVC_DBG
			printk("2688 Parse to dhcp client vc protocol\n");
#endif
			result = DHCPC_VC_VALID;
#ifdef _SEND_DHCPC_RELEASE_
			//Need to send the DHCP release for bridge mode
		
			// Alloc buffer for dhcp client vc encap. and send it out
			//skb_test_p = dev_alloc_skb(SIZE_DHCPC_VC_2684_TESTPKT);
			skb_test_p = dev_alloc_skb(0);
			if(skb_test_p)
			{
				skb_test_p -> data = dhcpclient_release_2684_vc_pattern;
				skb_test_p -> len = SIZE_DHCPC_VC_2684_TESTPKT;
				atmAal5RealDataReq(skb_test_p, vc);
			}
#endif
	     }
	}

	else if ( *parse_data_p == 0xfe && *(parse_data_p+1) == 0xfe && *(parse_data_p+2) == 0x03 && *(parse_data_p+3) == 0xcf )
	{
#if SCANPVC_DBG
		printk("2695 Surely Its PPPoA LLC header\n");
#endif
		result = PPPOA_LLC_VALID;
	}
	
	else if ( *parse_data_p == 0xc0 && *(parse_data_p+1) == 0x21 )
	{
#if SCANPVC_DBG
		printk("2700 Surely Its PPPoA VCC header\n");
#endif
		result = PPPOA_VC_VALID;
	}
	else if (  *parse_data_p == 0xff && *(parse_data_p+1) == 0x03 && *(parse_data_p +2) == 0xc0 && *(parse_data_p+3) == 0x21 )
	{
#if SCANPVC_DBG
		printk("2706 Surely Its PPPoA VCC header\n");
#endif
		result = PPPOA_VC_VALID;
	}
        else if ( *parse_data_p == 0x45 && *(parse_data_p+IP_HEADER_PROTOCOL_OFFSET) == 0x01 && *(parse_data_p+IP_ICMP_TYPE_OFFSET) == 0x00)
        {
                if (scanpvc_needip_flag)
		{
                result = FIXIP_2684R_VC_VALID;
#if SCANPVC_DBG
		printk("2714 FIXIP_2684R_VC_VALID\n");
#endif
		}
        }
	else
	{ 
		//int dump_idx;
		//printk("2720 vc %d Unknown packet coming... \n",vc);
		// Sam add for debug
		#if 0
		for(dump_idx=0;dump_idx < 20;dump_idx++,parse_data_p++)
		printk("%02x ",*parse_data_p);
		printk("\n");
		#endif
		
	}
	if (result > 0)
		fill_scanpvc_ret_table(vc, result);

	dev_kfree_skb(skb);	
}

int fill_scanpvc_ret_table(uint8 vc, uint16 result)
{	
	int i;

	if (ret_pvc_table.pvc_count > 0) //some one fill the report before , check it the same pvc and update the result 
	for ( i = 0; i < ret_pvc_table.pvc_count ; i++)
	{
		if (ret_pvc_table.pvc_table[i].vpi == atmCfgTable.vpi[vc] &&
			ret_pvc_table.pvc_table[i].vci == atmCfgTable.vci[vc] ) // yes, the same pvc, update the result
		{
			//if ( ret_pvc_table.pvc_table[i].result < result )
			ret_pvc_table.pvc_table[i].result |= result;
#if SCANPVC_DBG
			printk("2537 ret_pvc_table.pvc_table[i].result=%04x,result=%04x\n",ret_pvc_table.pvc_table[i].result,result);
			printk("2744 vpi=%d vci=%d result=%04x\n",ret_pvc_table.pvc_table[i].vpi,ret_pvc_table.pvc_table[i].vci,ret_pvc_table.pvc_table[i].result);
#endif
			  // yes ,we update the result , not add result anymore
			return 0;
		}
	}
	
	ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].vpi = atmCfgTable.vpi[vc];
	ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].vci = atmCfgTable.vci[vc];
	ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].result = result;
	//printk("2755 vpi=%d vci=%d result=%04x\n",ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].vpi,ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].vci,ret_pvc_table.pvc_table[ret_pvc_table.pvc_count].result);
	ret_pvc_table.pvc_count++;
	return 0;
}

uint16 getNet16(uint8 *address)
{
    return (((uint16)(*(uint8 *)address)) << 8) | (uint16)(*(uint8 *)(address + 1));
}

void setNet16(uint8 *address, uint16 data)
{
    *(uint8 *) address      = (uint8)(data >> 8);
    *(uint8 *)(address + 1) = (uint8) data;
}

uint16 calculateIPheaderChecksum(uint8 mode, uint8 *rawPacketPtr)
{
    uint16* hdrPtr;
    uint16   length;
    uint32  checksum = 0;
                                                                                                                                       
    /* use a passed in pointer as this function is in both tx and rx paths. */
    if (mode == 1)
    {  // IP Header checksum
        hdrPtr = (uint16 *)&rawPacketPtr[0];
        length = IP_HEADER_HALF_WORDS;
    }
    else if(mode == 2)// ICMP Header checksum
    {
        hdrPtr = (uint16 *)&rawPacketPtr[ICMP_OFFSET_HEADER_START];
        length = SIZE_ICMP_TESTPKT_HALFWORDS;
    }
                                                                                                                                       
    /* calculate checksum */
    //for (length  = IP_HEADER_HALF_WORDS, checksum = 0; length != 0; length--, hdrPtr++)
    for (length, checksum = 0; length != 0; length--, hdrPtr++)
    {
        checksum += (uint32)getNet16((uint8 *)hdrPtr);
    }
    /* use the carries to compute the 1's complement sum as per the RFC.    */
    checksum  = (checksum >> 16) + (checksum & 0xFFFF);
    checksum += (checksum >> 16);
    /* return the inverted */
    return (uint16)~checksum;
} /* calculateIPheaderChecksum */



uint16 udp_sum_calc(uint16 len_udp, uint8 buff[])
{
    uint8 src_addr[4]={0x0000,0x0000,0x00,0x00};
    uint8 dest_addr[4]={0xff,0xff,0xff,0xff};
    uint16 prot_udp=17;
    uint16 word16;
    uint32 sum;
    int i;
	
	// Find out if the length of data is even or odd number. If odd,
	// add a padding byte = 0 at the end of packet
	#if 0 // Sam:The tesk packet is fit multiple of 2 , we dont need paddign
	if (padding&1==1){
		padd=1;
		buff[len_udp]=0;
	}
	#endif
	
	//initialize sum to zero
	sum=0;
	
	// make 16 bit words out of every two adjacent 8 bit words and 
	// calculate the sum of all 16 bit words
	for ( i=0; i<len_udp; i=i+2 ){
		word16 =((buff[i]<<8)&0xFF00)+(buff[i+1]&0xFF);
		sum = sum + (unsigned long)word16;
	}	
	// add the UDP pseudo header which contains the IP source and destinationn addresses
	for (i=0;i<4;i=i+2){
		word16 =((src_addr[i]<<8)&0xFF00)+(src_addr[i+1]&0xFF);
		sum=sum+word16;	
	}
	for (i=0;i<4;i=i+2){
		word16 =((dest_addr[i]<<8)&0xFF00)+(dest_addr[i+1]&0xFF);
		sum=sum+word16; 	
	}
	// the protocol number and the length of the UDP packet
	sum = sum + prot_udp + len_udp;

	// keep only the last 16 bits of the 32 bit calculated sum and add the carries
    	while (sum>>16)
		sum = (sum & 0xFFFF)+(sum >> 16);
		
	// Take the one's complement of sum
	sum = ~sum;

return ((uint16) sum);
}

#if ATM_TIMER_DBG
void atm_timer_1min(unsigned long dummy)
{
	printk("Sam add debug in ATM.c 1 minutes count down\n");
	mod_timer(&atm_dbg_timer,jiffies+(HZ*60));
}
#endif

module_init (tc3162_atm_init);
module_exit (tc3162_atm_exit);

