#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

int main(int argc, char ** argv)
{
    int fd;
    struct stat st_buf;
    char buf[3] = {'Y', 'M', 'W'};

    if (argc == 1) {
	printf("usage: padbyte <filename>\n"); 
	exit(1);
    }

    fd = open(argv[1], O_WRONLY);
    if (fd < 0) {
        printf("open file failed!!\n");
	exit(1);
    }

    fstat(fd, &st_buf);
    printf("file size = %d\n", st_buf.st_size);

    lseek(fd, 0, SEEK_END);
    if (!(st_buf.st_size%4))
        printf("no padding, 0\n");
    else if ((st_buf.st_size%4) == 1) {
        write(fd, buf, 3);
        printf("padding 3 bytes.\n");
    }
    else if ((st_buf.st_size%4) == 2) {
        write(fd, buf, 2);
        printf("padding 2 bytes.\n");
    }
    else {
        write(fd, buf, 1);
        printf("padding 1 byte.\n");
    }



    close(fd);

    printf("padding complete.\n");
}

