#ifndef __defaultValue_H__
#define __defaultValue_H__

#include <asm/addrspace.h>
#include <asm/virtconvert.h>

//static unsigned long __sartx[4 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __sarrx[4 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __sartxbuf[504 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __sarrxbuf[504 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __sartxbuf[120 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __sarrxbuf[120 * 16 * 20]  __attribute__ ((__aligned__(16)));
//static unsigned long __irq_entries[1024]  __attribute__ ((__aligned__(16)));

#define TX_DESCRIPTOR_SIZE		16				//Tx descriptor size for each
#define RX_DESCRIPTOR_SIZE		16				//Rx descriptor size
#ifdef MAXDESC
#error ERROR
#endif
#define MAXDESC				2
#define BUFFER_SIZE			2016				// Each located data buffer
#define VC_BUFFER_SIZE			BUFFER_SIZE*MAXDESC

#define NUM_BUF     			100				// Total located buffer
/* SAR TX,RX Descriptor and Buffer Base */
//#define HS_SARTX0DBASE		(unsigned long)(&__sartx[0])
//#define HS_SARRX0DBASE		(unsigned long)(&__sarrx[0])
//#define HS_SARTXBUFBASE0	(unsigned long)(&__sartxbuf[0])
//#define HS_SARRXBUFBASE0	(unsigned long)(&__sarrxbuf[0])
#define HS_SARCCTXD				HS_SARRXBUFBASE0+VC_BUFFER_SIZE*20
#define HS_SARCCRXD				HS_SARCCTXD+0x10*MAXDESC
#define HS_SARCCTXB				HS_SARCCRXD+0x10*MAXDESC
#define HS_SARCCRXB				HS_SARCCTXB+52*MAXDESC

#define HS_SARMTXD				0xa00d0000
#define HS_SARMTXB				0xa00d1000
//#define HS_SARMRXD				HS_SARMTXD+
//#define HS_SARRXBUFBASE0		0xa0017000
//#define HS_IRQHIGHBOUNDADDR		(unsigned long)(&__irq_entries[1023])
//#define HS_IRQLOWBOUNDADDR		(unsigned long)(&__irq_entries[0])
//#define HS_IRQHEADADDR			HS_IRQLOWBOUNDADDR
//#define HS_IRQTAILADDR			HS_IRQLOWBOUNDADDR
#define HS_SARDMAENABLE			0x01
#define HS_SARDMADISABLE		0x00
#define HS_SARDMAIRQENABLE		0x00000010
#define HS_SARAAL5IRQ			0x00000020
#define HS_SARDESCIRQ			0x00000100


/* function return */
#define	OK					0
#define	ERROR					1
#define DISABLE					0
#define ENABLE					1
#define SUCCESS					0
#define FAIL					1
#define TRXCOMPLETE				1
#define WAIT					0

//#define MIIAR	0xB2000114
//#define MIIDR	0xB2000118
#define PHYADDRESS	0x0

#define PHYCONTROL	0x00
#define PHYSTATUS	0x01
#define PHYID1		0x02
#define PHYID2		0x03
#define	PHYADV		0x04
#define PHYSTATUS2	0x11

#define MIIARWRITE	0x01
#define MIIARREAD	0x00

#define SPEED100	1
#define SPEED10		0
#define MACFULLDUPLEX	1
#define MACHALFDUPLEX	0

// control register
#define SP100	0x2000
#define SP10	0x0
#define AUTONEGOEN	0x1000
#define AUTONEGODIS	0x0
#define FULLDUPLEX	0x0100
#define HALFDUPLEX	0x0

// advertise register capability
#define C100F	0x0100	//also used for manual speed check
#define C100H	0x0080
#define C10F	0x0040
#define C10H	0x0020
#define MIIB		1

#define	MAXTCNUM	20
#define MAXRDB		2016


typedef struct 
{
	unsigned int 	GFC1;						// General configuration register 1
	unsigned int 	GFC2;						// General configuration register 2
	unsigned int 	GFC3;						// General configuration register 3
	unsigned int	GISR;						// General interrupt status register
	unsigned int	vcconfig[MAXTCNUM];			// vc config register
	unsigned int	cctransmitc;				// cc transmit control/status register
	unsigned int	vctransmitc[MAXTCNUM];		// vc transmit control/status register
	
	
	
	unsigned int	cctrafficc;					// cc traffic control
	unsigned int	vctrafficc1[MAXTCNUM];		// vc traffic control 1
	unsigned int	vctrafficc2[MAXTCNUM];		// vc traffic control 2
	unsigned int	cccurrentDP;				// cc FIFO current transmit descriptor pointer
	
	unsigned int	vccurrentDP[MAXTCNUM];		// vc user data current descriptor pointer
	unsigned int	vcmcurrentDP[MAXTCNUM];		// vc management cell buffer pointer
	unsigned int	vccurrenttdi[MAXTCNUM];		// vc current transmit descriptor image
	unsigned int	vctranstatistic[MAXTCNUM];	// vc user transmit traffic statistic
	unsigned int	vcAAL5Tail[MAXTCNUM];		// vc aal5 payload trailer reg.
//	unsigned int	vcTCRC[MAXTCNUM];			// vc CRC accumulator for transmit
//	unsigned int	vcAAL5tcount[MAXTCNUM];		// vc aal5 transfer count	
	unsigned int	HS_SARTDBASE[MAXTCNUM];
	unsigned int	HS_SARRDBASE[MAXTCNUM];
	unsigned int 	HS_SARTBBASE[MAXTCNUM];
	unsigned int	HS_SARRBBASE[MAXTCNUM];
	unsigned int	HS_SARCCTD;
	unsigned int	HS_SARCCRD;
	unsigned int	HS_SARCCTDB;
	unsigned int	HS_SARCCRDB;
	unsigned int    HS_SARMTDBASE[MAXTCNUM];
	unsigned int	HS_SARMTBBASE[MAXTCNUM];
//	unsigned short	HS_VPI[MAXTCNUM];
//	unsigned short	HS_VCI[MAXTCNUM];
}AtmFace;

typedef struct
{
	AtmFace	AtmDev;
}TCSTRUCT;



extern TCSTRUCT		TCdefault;
	
	
	


extern int MacMiiStationWrite (unsigned int ,unsigned int Reg, unsigned int ndata);
extern unsigned int MacMiiStationRead (unsigned int,unsigned int Reg);
extern void RegistWrite (unsigned int data,unsigned int addr);
extern volatile unsigned int RegistRead(unsigned int addr);


#endif
