/*
 * memory.c: memory initialisation code.
 */
#include <linux/init.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/bootmem.h>

#include <asm/addrspace.h>
#include <asm/page.h>

#include <asm/bootinfo.h>

#define START_MEMORY_REGION 0x00000000 // added by KWU
static void __init setup_memory_region(void)
{
	add_memory_region(START_MEMORY_REGION/*0*/, CONFIG_TC3162_RAMSIZE, BOOT_MEM_RAM); // modified by KWU
}

void __init prom_meminit(unsigned int magic)
{
	setup_memory_region();
}

void prom_free_prom_memory (void)
{
        int i;
        unsigned long freed = 0;
        unsigned long addr;
                        
        for (i = 0; i < boot_mem_map.nr_map; i++) {
        	if (boot_mem_map.map[i].type != BOOT_MEM_ROM_DATA)
            		continue;
                                               
            	addr = boot_mem_map.map[i].addr;
                while (addr < boot_mem_map.map[i].addr
                        + boot_mem_map.map[i].size) {
                        ClearPageReserved(virt_to_page(__va(addr)));
                        set_page_count(virt_to_page(__va(addr)), 1);
                        free_page(__va(addr));
                        addr += PAGE_SIZE;
                        freed += PAGE_SIZE;
                }
        }
	//printk("Freeing prom memory: %ldkb freed\n", freed >> 10);
}

