
// v0.1 create by  HS T. 2003/01/16

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <asm/tc3160/interrupts.h>
#include <asm/tc3160/gpio.h>
#include <asm/tc3160/atm.h>
#include "defaultValue.h"
#include "XDescriptor.h"
#include "sar.h"

#define EXECUTIOMTIMES	10


#define HSI_REG_READ(reg,var)    var = *((volatile unsigned long *)(reg))
#define HSI_REG_WRITE(reg,val)   *((volatile unsigned long *)(reg)) = val

extern volatile unsigned long *int_mask_reg; 

void sar_main(void);
void setGFC0(unsigned long cti, unsigned long loopback, unsigned long endian);
void sar_init(void);
void MasterEnable(unsigned long enable);
void setVCConfigure(unsigned char vc_no,unsigned short vpi_no, unsigned short vci_no, unsigned char aal5_enable);
void setIRQ(unsigned long irq_hi, unsigned long irq_low, unsigned long irq_head, unsigned long irq_tail);
void extloopbackEnable(int enable);
void setTxTraffic(unsigned char vc_no,unsigned short RC_init, unsigned short BC_init, unsigned short RC_dec, unsigned long BC_dec, unsigned long RC_lim, unsigned char TC_type);
void setSarTxDesp(unsigned char vc_no,unsigned char own,unsigned char clp, unsigned char d_irq,unsigned char aal5_end,unsigned long buf_size);
void setSarRxDesp(unsigned char vc_no, unsigned char own, unsigned char d_irq,unsigned long buf_size);
void descriptorList(void);
void setSarTxDma(unsigned char vc_no, int enable);
void setSarRxDma(unsigned char vc_no, int enable);
void setTxRxCDP(unsigned char vc_no);
void registerDump(void);
void packetDisplay(unsigned long pAddr);
void setOneVc(unsigned char vc_no,unsigned char own,unsigned long buf_size,unsigned char des_id);
void cellBufferFill(unsigned char vc_no,void* src,unsigned long buf_size);

void vcRun(unsigned char vc_no,unsigned long buf_size);
unsigned long patternCompare(unsigned char vc_no,unsigned long pattern);
void desbufClear(unsigned char vc_no);
unsigned long maxAAL5Test(void);
void singleVcTest(unsigned long patternsize);
void multiVcTest(unsigned long patternsize);
unsigned long checkTRComplete(unsigned char vc_no,unsigned long patternsize);
void initCCTxDescriptor(void);
void initCCRxDescriptor(void);
void CCChannelTest(void);
void OAMcellTest(void);
void oamCellCopy(unsigned char vc_no);
unsigned long managecellCompare(unsigned char vc_no, unsigned char []);
void reEnableTransmit(unsigned char vc_no,unsigned long patternsize);
unsigned long allVCComplete(void);


extern const char dataPattern[];
extern const char ccPattern[];
extern const char oamAisCell[];
extern const unsigned char llc_icmp_packet[];

unsigned long ErrorCount[MAXTCNUM];
unsigned long ExceedAAL5[MAXTCNUM];
unsigned long vcError[MAXTCNUM];
unsigned long vcExecNum[MAXTCNUM];
unsigned char vcComplete[MAXTCNUM];
// test for 4 cases, size=88,size=91,size=96,size=79
// 						88		137		144		127
void SysIntAtmHnd(void * id)
{
static unsigned long counter;
    //unsigned long old = SysIntDisable();
    counter++;
    //SysIntRestore(old);
    
}

static void patch_up(void)
{
  register int i;
  for (i = 0; i < 20; i++) {
    TCdefault.AtmDev.HS_SARTDBASE[i] += HS_SARTX0DBASE;
    TCdefault.AtmDev.HS_SARRDBASE[i] += HS_SARRX0DBASE;
    TCdefault.AtmDev.HS_SARTBBASE[i] += HS_SARTXBUFBASE0;
    TCdefault.AtmDev.HS_SARRBBASE[i] += HS_SARRXBUFBASE0;
  }
}

void sar_main(void)
{
	unsigned long cti;
	unsigned long nReg=0;
	unsigned long i,temp=0;
	unsigned long patternsize=0;
//	unsigned long testCase[4]={1968,1960,1964,1948};
	unsigned long testCase[4]={96,88,92,76};
	unsigned long patternIndex;
	unsigned long flag=0;
//48n    =1968
//48n-8  =1960
//48n-4  =1964
//48n-20 =1948

printk("IMR is 0x%08lx\n", *int_mask_reg);
// *int_mask_reg = 0x00000409;
printk("IMR is 0x%08lx\n", *int_mask_reg);
printk("DMT IMR is 0x%08lx\n", *((volatile unsigned long *)(0xb400000c)));
printk("GPIO IMR is 0x%08lx\n", *((volatile unsigned long *)(0xb2000518)));

	MasterEnable(MASTERDISABLE);
// Enlarge scale to see the multi VC test result	
// to set et smaller to save the time
	cti=0x3370;
	setGFC0 (cti,0 /*SARLOOPBACK*/,SARBIG);
	
// master enable	
	MasterEnable(MASTERENABLE);

	printk ("\nSingle VC test...\n");
	for (patternIndex=0;patternIndex<1;patternIndex++)

	{
		memset ((void *)ErrorCount,80,0);	
		memset ((void*)ExceedAAL5,80,0);
		setIRQ(KSEG1ADDR(HS_IRQHIGHBOUNDADDR),KSEG1ADDR(HS_IRQLOWBOUNDADDR),KSEG1ADDR(HS_IRQHEADADDR),KSEG1ADDR(HS_IRQTAILADDR));
		sar_init();
		patternsize=testCase[patternIndex];
		singleVcTest(patternsize);
	}

printk("IMR is 0x%08lx\n", *int_mask_reg);
printk("DMT IMR is 0x%08lx\n", *((volatile unsigned long *)(0xb400000c)));
printk("GPIO IMR is 0x%08lx\n", *((volatile unsigned long *)(0xb2000518)));

}

void sar_init()
{

	unsigned long i;
	
	patch_up();
	HSI_REG_WRITE (TC3160_HWC_GCFG1_REG+4,0);
	HSI_REG_WRITE (TC3160_HWC_GCFG1_REG+8,0);
	
	for (i=0;i<MAXTCNUM;i++)
	{	
		// 0xb2001010 init all vc configuration (vpi,vci,aal5 mode)
		HSI_REG_WRITE (TC3160_HWC_VC0_REG+i*4,0x0);	
		// 0xb2001940 init vc user data transmit traffic statistics
		HSI_REG_WRITE (HS_VC0UDTTS+i*4,0x0);
		// 0xb2001db0 init vc user data receive traffic statistics
		HSI_REG_WRITE (HS_VC0UDRTS+i*4,0x0);
		// 0xb2001c04 init vc user data fifo current receive descriptor
		HSI_REG_WRITE (HS_VC0RDP+i*4,0x0);
		// 0xb20019e0 init vc CRC accumulator for transmit
		HSI_REG_WRITE (HS_VC0TCRC+i*4,0x0);
		// 0xb2001e00 init vc CRC accumulator for receive
		HSI_REG_WRITE (HS_VC0RCRC+i*4,0x0);	
		// 0xbc001754 init vc user data fifo current transmit descriptor pointer
		HSI_REG_WRITE (HS_VC0TDP+i*4,0x0);	
		// 0xbc0017b0 init vc management cell buffer pointer
		HSI_REG_WRITE (HS_VC0MMP+i*4,0x0);	
		// 0xbc001990 CPCS-UU and CPI fiele
		HSI_REG_WRITE (HS_VC0AAL5E+i*4,0x0);
		
		setSarTxDma(i, DISABLE);
		setSarRxDma(i, DISABLE);

	}
	// 0xb2001600 to 0xb2001750 init cc & vc traffic control register
	for (i=0;i<84;i++)
		HSI_REG_WRITE (HS_CCTRAFFIC+i*4,0x0);
	// init cc fifo current receive descriptor pointer
	HSI_REG_WRITE (HS_CCTDP,0x0);
	HSI_REG_WRITE (HS_CCRDP,0x0);
printk("sar_init completed\n");
	return;
}


void setGFC0(unsigned long cti, unsigned long loopback, unsigned long endian)
{
	unsigned long word;
	
	word = (cti)|(loopback<<24)|(endian<<25);
	HSI_REG_WRITE(TC3160_HWC_GCFG1_REG, word);
}

void MasterEnable(unsigned long enable)
{
	unsigned long word;
	
	if ( enable == MASTERENABLE)
	{
		HSI_REG_READ(TC3160_HWC_GCFG1_REG, word);
		word &= 0x070fffff;
		HSI_REG_WRITE(TC3160_HWC_GCFG1_REG, (enable <<26)|word);				
	}
	else
		HSI_REG_WRITE(TC3160_HWC_GCFG1_REG, 0x0);
}

void setVCConfigure(unsigned char vc_no,unsigned short vpi_no, unsigned short vci_no, unsigned char aal5_enable)
{
	unsigned long word=0;

	word = (vpi_no)|(vci_no<<8)|(aal5_enable<<24);
	HSI_REG_WRITE(TC3160_HWC_VC0_REG+vc_no*4, word);	
}
	
void setIRQ(unsigned long irq_hi, unsigned long irq_low, unsigned long irq_head, unsigned long irq_tail)
{
	HSI_REG_WRITE(HS_IRQCONTROL, SARIRQRESET);	
	HSI_REG_WRITE(HS_IRQLO, irq_low);
	HSI_REG_WRITE(HS_IRQHI, irq_hi);
	HSI_REG_WRITE(HS_IRQHEAD, irq_head);
	HSI_REG_WRITE(HS_IRQTAIL, irq_tail);
	HSI_REG_WRITE(HS_IRQCONTROL, SARIRQENABLE);	
}


//enable external phy loopback
void extloopbackEnable(int enable)
{
	HSI_REG_WRITE(0xb4000008,0xffffffff);
	HSI_REG_WRITE(0xb4000010,0xffffffff);
	HSI_REG_WRITE(0xb4000018,0x00000100);
}
	
void setTxTraffic(unsigned char vc_no,unsigned short RC_init, unsigned short BC_init, unsigned short RC_dec, unsigned long BC_dec, unsigned long RC_lim,unsigned char TC_type)
{
	unsigned long word=0;
	word = (RC_init)|(BC_init<<12)|(RC_dec<<24)|(BC_dec << 31);
	HSI_REG_WRITE(HS_VC0TRAFFIC2+vc_no*0x10, word);
	word = (BC_dec >> 1)|(RC_lim<<7)|(TC_type<<30);	
	HSI_REG_WRITE(HS_VC0TRAFFIC2+vc_no*0x10+4, word);
}

void setOneVc(unsigned char vc_no,unsigned char own,unsigned long buf_size,unsigned char des_id)
{
	stxDescriptorStruc* TxDescriptor = (stxDescriptorStruc*) (TCdefault.AtmDev.HS_SARTDBASE[vc_no]);
	unsigned long bufP = TCdefault.AtmDev.HS_SARTBBASE[vc_no];

	TxDescriptor+=des_id;
	bufP += des_id*256;
//	memcpy ((void*)bufP,&dataPattern[0],buf_size);
	memcpy((void *)bufP, &llc_icmp_packet[0], 56);

	
//	TxDescriptor->TDES0.Reg.EndAAL5 = aal5_end;
//	TxDescriptor->TDES0.Reg.CLP = clp;
	TxDescriptor->TDES0.Reg.OWN = own;
//	TxDescriptor->TDES0.Reg.UIRQ = d_irq;
//	TxDescriptor->TDES1.Reg.Size = buf_size & 0x03ff;
	TxDescriptor->TDES1.Reg.Size = 56 & 0x03ff;
//	TxDescriptor->TDES2.nValue = bufP + i*256;
	printk (" VC %d   %d th descriptor set %04lx  %04lx  %04lx  %04lx \n",vc_no,des_id,TxDescriptor->TDES0.nValue,TxDescriptor->TDES1.nValue,TxDescriptor->TDES2.nValue,TxDescriptor->TDES3.nValue);
}



void setSarTxDesp(unsigned char vc_no,unsigned char own,unsigned char clp, unsigned char d_irq,unsigned char aal5_end,unsigned long buf_size)
{
	unsigned long i;
	stxDescriptorStruc* TxDescriptor = (stxDescriptorStruc*) KSEG1ADDR(TCdefault.AtmDev.HS_SARTDBASE[vc_no]);
	unsigned long bufP = KSEG1ADDR(TCdefault.AtmDev.HS_SARTBBASE[vc_no]);

//	printk("VC#: %d, TxDesc: 0x%08lx, bufP: 0x%08lx\n", vc_no, (unsigned long) TxDescriptor, bufP);
	
	for (i=0;i<MAXDESC;i++,TxDescriptor++)
	{
                TxDescriptor->TDES0.nValue=0;
		TxDescriptor->TDES1.nValue=0;
		TxDescriptor->TDES2.nValue=0;
		TxDescriptor->TDES3.nValue=0;
		TxDescriptor->TDES0.Reg.EndAAL5 = aal5_end;
		TxDescriptor->TDES0.Reg.CLP = clp;
		TxDescriptor->TDES0.Reg.OWN = own;
		TxDescriptor->TDES0.Reg.UIRQ = d_irq;
		TxDescriptor->TDES1.Reg.Size = buf_size;
		TxDescriptor->TDES2.nValue = (unsigned long)PHYSADDR(bufP + i*BUFFER_SIZE);
		TxDescriptor->TDES3.nValue = (unsigned long)PHYSADDR(TxDescriptor + 1); 
//		printk ("  Tdes 0:%08x    %08x    %08x    %08x    %08x    \n",TxDescriptor,TxDescriptor->TDES0.nValue,TxDescriptor->TDES1.nValue,TxDescriptor->TDES2.nValue,TxDescriptor->TDES3.nValue);
	}
		TxDescriptor --;
		TxDescriptor->TDES3.nValue = (unsigned long)PHYSADDR(TCdefault.AtmDev.HS_SARTDBASE[vc_no]);
}

void setSarRxDesp(unsigned char vc_no, unsigned char own, unsigned char d_irq,unsigned long buf_size)
{
	unsigned long i;
	srxDescriptorStruc* RxDescriptor = (srxDescriptorStruc*)KSEG1ADDR(TCdefault.AtmDev.HS_SARRDBASE[vc_no]);
	unsigned long bufP = KSEG1ADDR(TCdefault.AtmDev.HS_SARRBBASE[vc_no]);
	
//	printk("VC#: %d, RxDesc: 0x%08lx, bufP: 0x%08lx\n", vc_no, (unsigned long) RxDescriptor, bufP);
	for (i=0;i<MAXDESC;i++ ,RxDescriptor++)
	{
                RxDescriptor->RDES0.nValue=0;
                RxDescriptor->RDES1.nValue=0;
                RxDescriptor->RDES2.nValue=0;
                RxDescriptor->RDES3.nValue=0;
		RxDescriptor->RDES0.Reg.OWN = own;
		RxDescriptor->RDES0.Reg.UIRQ = d_irq;
//		RxDescriptor->RDES1.Reg.Size = buf_size;
		RxDescriptor->RDES1.Reg.Size = MAXRDB;
		RxDescriptor->RDES1.Reg.Size = 480;
// rx buf_size shoule be multiple of 48
		RxDescriptor->RDES2.nValue = (unsigned long)PHYSADDR(bufP + i*BUFFER_SIZE);
		RxDescriptor->RDES3.nValue = (unsigned long)PHYSADDR(RxDescriptor+1); 
//		printk ("  Rdes 0:%08x    %08x    %08x    %08x    %08x    \n",RxDescriptor,RxDescriptor->RDES0.nValue,RxDescriptor->RDES1.nValue,RxDescriptor->RDES2.nValue,RxDescriptor->RDES3.nValue);
	}
	RxDescriptor --;
	RxDescriptor->RDES3.nValue = (unsigned long)PHYSADDR(TCdefault.AtmDev.HS_SARRDBASE[vc_no]);
}


void descriptorList()
{
	
	srxDescriptorStruc* RxDescriptor;	
	stxDescriptorStruc* TxDescriptor;

	unsigned char i;// vc
	unsigned char j;// Descriptor
	
	printk ("Tx Descriptor: \n");
	for (i=0;i<MAXTCNUM;i++)
	{
		RxDescriptor = (srxDescriptorStruc*) KSEG1ADDR(TCdefault.AtmDev.HS_SARRDBASE[i]);
		TxDescriptor = (stxDescriptorStruc*) KSEG1ADDR(TCdefault.AtmDev.HS_SARTDBASE[i]);
		printk ("VC %d -- Tx Descriptor: \n",i);
		for (j=0;j<MAXDESC;j++,TxDescriptor++)
			printk ("Tdes 0:%08x    %08x    %08x    %08x    %08x    \n",TxDescriptor,TxDescriptor->TDES0.nValue,TxDescriptor->TDES1.nValue,TxDescriptor->TDES2.nValue,TxDescriptor->TDES3.nValue);
			
		printk ("VC %d -- Rx Descriptor: \n",i);
		for (j=0;j<MAXDESC;j++,RxDescriptor++)
			printk ("Tdes 0:%08x    %08x    %08x    %08x    %08x    \n",RxDescriptor,RxDescriptor->RDES0.nValue,RxDescriptor->RDES1.nValue,RxDescriptor->RDES2.nValue,RxDescriptor->RDES3.nValue);
	}
}

void setSarTxDma(unsigned char vc_no, int enable)
{
	unsigned long word,i;
	
	HSI_REG_READ(HS_VC0TCONTROL + vc_no*4, word);
	if (enable == ENABLE)
	{
		word |= HS_SARDMAENABLE| HS_SARDMAIRQENABLE| HS_SARAAL5IRQ|HS_SARDESCIRQ;
		word = 0x00000131;
		HSI_REG_READ(HS_VC0TDP, i);
		HSI_REG_READ(HS_VC0RDP, i);
		HSI_REG_WRITE(HS_VC0TCONTROL + vc_no*4, word);
	}
	else
	{
		word &= 0xfffffffe;
		HSI_REG_WRITE(HS_VC0TCONTROL + vc_no*4, word);		
	}
}

void setSarRxDma(unsigned char vc_no, int enable)
{
	unsigned long word;
	
	HSI_REG_READ(HS_VC0RCONTROL+vc_no*4, word);
	if (enable == ENABLE)
	{
//		word |= 1;
		word=1;
		HSI_REG_WRITE(HS_VC0RCONTROL+vc_no*4,word);		
	}
	else
	{
//		word &=0xfffffffe;
		word =0;
		HSI_REG_WRITE(HS_VC0RCONTROL+vc_no*4,word);
	}
}

void setTxRxCDP(unsigned char vc_no)
{
	HSI_REG_WRITE(HS_VC0TDP+vc_no*4,TCdefault.AtmDev.HS_SARTDBASE[vc_no]);	
	HSI_REG_WRITE(HS_VC0RDP+vc_no*4,TCdefault.AtmDev.HS_SARRDBASE[vc_no]);
}


void registerDump()
{
	unsigned long i;
	printk ("Register Dump: \n");
	printk ("GENERAL CONFIGURE 0                 %04lx\n", *(volatile unsigned long *) (TC3160_HWC_GCFG1_REG));
	printk ("GENERAL INTERRUPT STATUS            %04lx\n", *(volatile unsigned long *) (HS_GISR));
	printk ("CURRENT TRANSMIT DESCRIPTOR         %04lx\n", *(volatile unsigned long *) (HS_VC0TDP));
	printk ("CURRENT RECEIVE DESCRIPTOR          %04lx\n", *(volatile unsigned long *) (HS_VC0RDP));
	printk ("LO IRQ                              %04lx\n", *(volatile unsigned long *) (HS_IRQLO));
	printk ("HI IRQ                              %04lx\n", *(volatile unsigned long *) (HS_IRQHI));
	printk ("HEAD IRQ                            %04lx\n", *(volatile unsigned long *) (HS_IRQHEAD));
	printk ("TAIL IRQ                            %04lx\n", *(volatile unsigned long *) (HS_IRQTAIL));
	
/*
	printk ("CC Transmit                            %04lx\n", *(volatile unsigned long *) (0xb2001100));
	printk ("CC Receive                             %04lx\n", *(volatile unsigned long *) (0xb2001200));
	printk ("CC Traffic1_1                             %04lx\n", *(volatile unsigned long *) (0xb2001600));
	printk ("CC Traffic1_2                             %04lx\n", *(volatile unsigned long *) (0xb2001604));

	printk ("CC Traffic2_1                             %04lx\n", *(volatile unsigned long *) (0xb2001608));
	printk ("CC Traffic2_2                             %04lx\n", *(volatile unsigned long *) (0xb200160c));

	printk ("CC currenttd                             %04lx\n", *(volatile unsigned long *) (0xb2001750));
	printk ("CC currentrd                             %04lx\n", *(volatile unsigned long *) (HS_CCRDP));

*/
	
	for (i=0;i<2;i++)
	{
		printk ("VC %d CONFIGURATION                 %04lx\n",i, *(((volatile unsigned long *) TC3160_HWC_VC0_REG)+i));
		printk ("VC %d TRANSMIT CONTROL STATUS       %04lx\n",i, *(((volatile unsigned long *) HS_VC0TCONTROL)+i));
		printk ("VC %d RECEIVE  CONTROL STATUS       %04lx\n",i, *(((volatile unsigned long *) HS_VC0RCONTROL)+i));
		printk ("VC %d TRAFFIC CONTROL 1_1           %04lx\n",i, *(volatile unsigned long *) (HS_VC0TRAFFIC1+i*0x10));
		printk ("VC %d TRAFFIC CONTROL 1_2           %04lx\n",i, *(volatile unsigned long *) (HS_VC0TRAFFIC1+i*0x10+4));
		printk ("VC %d TRAFFIC CONTROL 2_1           %04lx\n",i, *(volatile unsigned long *) (HS_VC0TRAFFIC2+i*0x10));
		printk ("VC %d TRAFFIC CONTROL 2_2           %04lx\n",i, *(volatile unsigned long *) (HS_VC0TRAFFIC2+i*0x10+4));
	}
}


void packetDisplay(unsigned long pAddr)
{
	unsigned char i,j;
	unsigned char* temp;
	temp =(unsigned char*)pAddr;
	printk ("Data pattern: %04lx\n",pAddr);
	for (j=0;j<MAXDESC;j++)
	{
		printk ("Descriptor %d buffer \n",j);
		for (i=0;i<126;i++)
//		for (i=0;i<20;i++)
		{
//			printk ("Address %04lx\n",temp);
			printk ("%d:  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  %02x  \n",i,\
			*temp,*(temp+1),*(temp+2),*(temp+3),*(temp+4),*(temp+5),*(temp+6),*(temp+7),\
			*(temp+8),*(temp+9),*(temp+10),*(temp+11),*(temp+12),*(temp+13),*(temp+14),*(temp+15));
			temp+=16;
		}
	}
}

void cellBufferFill(unsigned char vc_no,void* src,unsigned long buf_size)
{
	unsigned long i;
	unsigned long bufP = TCdefault.AtmDev.HS_SARTBBASE[vc_no];
	
	for (i=0;i<MAXDESC;i++)
	{
//		printk ("copy to buffer address %04lx \n",bufP+i*BUFFER_SIZE);
//		memcpy ((void*)bufP+i*BUFFER_SIZE,dataPattern+i,buf_size);	
		memcpy ((void*)bufP+i*BUFFER_SIZE,llc_icmp_packet+i,56);	
	}
}


void vcRun(unsigned char vc_no,unsigned long buf_size)
{
//	cellBufferFill(vc_no,(void*)dataPattern,buf_size);
	cellBufferFill(vc_no,(void*)llc_icmp_packet,56);
	setSarTxDesp(vc_no,1,0,0,1,buf_size);
	setSarRxDesp(vc_no,1,0,MAXRDB);
	setTxRxCDP(vc_no);
//		registerDump();
//		descriptorList();
	setSarRxDma(vc_no, ENABLE);
	setSarTxDma(vc_no, ENABLE);
}

unsigned long patternCompare(unsigned char vc_no,unsigned long pattern)
{
	unsigned long i,j,temp;
	unsigned char *src,*dst,*r_src;
	unsigned long d_size;
	unsigned short r_size;
	srxDescriptorStruc* RxDescriptor;

//	printk("Transmit pattern size %d \n",pattern);
	RxDescriptor = (srxDescriptorStruc*) (TCdefault.AtmDev.HS_SARRDBASE[vc_no]);
	temp = RxDescriptor->RDES1.Reg.Num;
//	printk ("Descritpro receive num %04lx\n\n\n",temp);
	

	for (i=0;i<MAXDESC;i++)
	{
		src = (unsigned char*)TCdefault.AtmDev.HS_SARRBBASE[vc_no] +i*BUFFER_SIZE;
		r_src =src+temp-6;
		r_size = *(unsigned short*)r_src;	
//		printk ("data size %04lx\n",r_size);
		
//		dst =(unsigned char*)( dataPattern + i);
		dst =(unsigned char*)( llc_icmp_packet + i);
//		printk ("Compare vc%d descriptor %d  src %04lx with pattern address %04lx\n",vc_no,i,src,dst);
		for (j=0;j<r_size;j++)
		{
//			printk ("size %d ... src %02x  dst %02x \n",j,*(src+j),*(dst+j));
			if (*(src+j) != *(dst+j))
			{
				ErrorCount[vc_no]++;
				printk ("error at size %04lx\n",j);
				printk ("VC %d descriptor %d fail",vc_no,j);
				return FAIL;
			}
		}
	}
	
	return SUCCESS;
}



void desbufClear(unsigned char vc_no)
{
	srxDescriptorStruc* RxDescriptor = (srxDescriptorStruc*) (TCdefault.AtmDev.HS_SARRDBASE[vc_no]);
	unsigned long bufRP = TCdefault.AtmDev.HS_SARRBBASE[vc_no];
	stxDescriptorStruc* TxDescriptor = (stxDescriptorStruc*) (TCdefault.AtmDev.HS_SARTDBASE[vc_no]);
	unsigned long bufTP = TCdefault.AtmDev.HS_SARTBBASE[vc_no];
	
	memset ((char*)RxDescriptor,MAXDESC*0x10,0);
	memset ((char*)bufRP,MAXDESC*BUFFER_SIZE,0);
	memset ((char*)TxDescriptor,MAXDESC*0x10,0);
	memset ((char*)bufTP,MAXDESC*BUFFER_SIZE,0);
}







void singleVcTest(unsigned long patternsize)
{
	unsigned long flag=0;
	unsigned long i;
	unsigned long nReg,temp;
	
	printk ("\nTesting pattern with size %d\n", patternsize);
	for (i=0;i<MAXTCNUM;i++)
	{
	//	setVCConfigure(i,100+i*2, 100+i*2+3, 1);	
		setVCConfigure(i,0, 33, 1);	
			
		setTxTraffic(i,2,2,1,1,4,3);
		desbufClear(i);		
		setSarTxDesp(i,0,0,0,1,patternsize);
		setSarRxDesp(i,0,0,MAXRDB);
	}
	printk("VCC config done.\n");
	for (i=0;i<1 /*MAXTCNUM*/;i++)	
	{		
                vcRun(i,patternsize);
		printk ("Wait transfer complete...\n");		

		while ( ((*(volatile unsigned long*)(HS_VC0TCONTROL+i*4)) & 0x00000040)==0);
		HSI_REG_READ(HS_VC0TCONTROL+i*4, nReg);
		HSI_REG_WRITE(HS_VC0TCONTROL+i*4, nReg);
		HSI_REG_READ(HS_VC0TCONTROL+i*4, nReg);
		printk ("Wait Receive complete...\n");
		
		while((*(volatile unsigned long *)HS_GISR & 0x00200000)==0);

//		printk ("RX statistics (How many cells received) : %d\n",*((volatile unsigned long *)(HS_VC0UDRTS+i*4)));
		HSI_REG_READ(HS_IRQHEAD, nReg);

		while ((*(volatile unsigned long *)HS_IRQTAIL)!=nReg) 
		{
			HSI_REG_READ(HS_IRQTAIL, nReg);
//		  		printk("Interrupt queue read pointer: %x\n", nReg);
	 		HSI_REG_READ(nReg, temp);
//	 	 		printk("Interrupt cause and status : %x\n", temp);		
			if (temp & 0x80)
			{
				temp &= 0x1f -1;
				printk ("Vc %d Error -- aal5 paylord\n",temp);	
				flag=1;
				ExceedAAL5[temp]++;			
			}
	 		HSI_REG_WRITE(HS_IRQSTATUS, 1);
	 		HSI_REG_READ(HS_IRQSTATUS, nReg);
//	  			printk("Interrupt status register : %x\n", nReg);
			HSI_REG_READ(HS_IRQHEAD, nReg);
		}
//		packetDisplay(TCdefault.AtmDev.HS_SARRBBASE[i]);	
			if (flag)
			{
				if (patternCompare (i,patternsize))
				{
					printk("Transmit Fail\n\n");
				}
				else
				{
					printk ("VC %d Test ok\n",i);
					printk ("All descriptor compare success \n\n");
				}
			}
			printk ("*************************************************************************\n");			
		}// end fo vc

		printk ("Summary...of pattern %d\n",patternsize);
		for (i=0;i<MAXTCNUM;i++)
		{
			if (ErrorCount[i]!=0)
			{
				printk (" VC %d compare error.. %d",i,ErrorCount[i]);
				flag=1;
			}
			if (ExceedAAL5[i]!=0)
			{
				printk (" VC %d aal5 error.. %d\n",i,ExceedAAL5[i]);
				flag=1;
			}
		}
		if (!flag)
			printk ("\nAll test pass in pattern %d\n",patternsize);
	return ;
}



unsigned long checkTRComplete(unsigned char vc_no,unsigned long patternsize)
{
	unsigned long nReg;
	
	// if dma transmit and receive not complete return
	if ((((*(volatile unsigned long*)(HS_VC0TCONTROL+vc_no*4)) & 0x00000040)==0) \
		&& (((*(volatile unsigned long*)(HS_VC0RCONTROL+vc_no*4)) & 0x00000001)==1))
		return WAIT;
	else  // if transmit complete clear the transmit interrupt
	{
		HSI_REG_READ(HS_VC0TCONTROL+vc_no*4, nReg);
		HSI_REG_WRITE(HS_VC0TCONTROL+vc_no*4, nReg);
	}
	// compare content here
	if (patternCompare(vc_no,patternsize))
	{
		printk ("vc %d compare error\n",vc_no);	
		ErrorCount[vc_no]=1;
		vcComplete[vc_no]=1;
		return WAIT;
	}
	else
	{
		printk ("vc %d compare pass\n",vc_no);
	}
	return TRXCOMPLETE;
}

void reEnableTransmit(unsigned char vc_no,unsigned long pattensize)
{
	// clear the vc descriptor and buffer;
	desbufClear(vc_no);
	vcRun(vc_no,pattensize);
	vcExecNum[vc_no]++;
	if (vcExecNum[vc_no] == EXECUTIOMTIMES)
		vcComplete[vc_no]=1;
	printk ("current vc %d execution %d times\n",vc_no,vcExecNum[vc_no]);
}

unsigned long allVCComplete()
{
	unsigned char i=0;
	
	for (i=0;i<MAXTCNUM;i++)
		if (vcComplete[i]==0)
			return 0;
	return 1;
}

