#include <asm/uaccess.h>

#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/proc_fs.h>
#include <linux/stat.h>
#include <linux/config.h>
#include <linux/init.h>
#include <linux/module.h>
#include <asm/bitops.h>

struct proc_dir_entry *proc_tc3162 = NULL;

static spinlock_t proc_tc3162_lock;

void proc_tc3162_init(void)
{
	/*
	 * Create TC3162 proc directory.
	 */
	spin_lock(&proc_tc3162_lock);
	if (proc_tc3162 == NULL) {
		proc_tc3162 = proc_mkdir("tc3162dmt", 0);
		if (!proc_tc3162) {
			spin_unlock(&proc_tc3162_lock);	
			return;
		}
	}
	spin_unlock(&proc_tc3162_lock);	
}

EXPORT_SYMBOL(proc_tc3162);

