#ifndef __SUNPLUS_CONFIG_H
#define __SUNPLUS_CONFIG_H




/*
** configuration of mpeg2/mpeg1 core controller
*/
#define	CONFIG_VCD	0
#define	CONFIG_SVCD	1
#define	CONFIG_DVD	2

#define	CONFIG		CONFIG_DVD


#define	SUPPORT_CVD		1
#define	SUPPORT_SVCD		1
#define	SUPPORT_MPEG2		1
//#define SUPPORT_IR		1
//#define SUPPORT_VFD		1
//#define SUPPORT_OGT		1
//#define SUPPORT_MP3		1
#define SUPPORT_OSD		1

//#define SUPPORT_DEVICE_CDROM	1	
//#define SUPPORT_DEVICE_DVDROM	1

/*
#ifdef	DISABLE_EPP
#define	SUPPORT_EPP		0
#else
#define	SUPPORT_EPP		1
#endif*/

#if defined(mips) || defined(__LX4080)
#define	PRODUCTION
#else
#if defined(arm) || defined(__arm)
#define	ARM_EVM
#define	inline	__inline
#endif
#endif


/*
**
*/
#ifdef  mips

//#define GLOBAL_REGISTER //by jacky 
#if     (CONFIG==CONFIG_DVD)
#define RGST_OFFSET     0xafff0000
#elif   (CONFIG==CONFIG_SVCD)
#define RGST_OFFSET     0x00510000
#elif   (CONFIG==CONFIG_VCD)
#define RGST_OFFSET     0x00510000
#endif
#else
#ifdef  ARM_EVM
#define RGST_OFFSET     0x0B800000
#else
#define RGST_OFFSET     0x0B800000
#endif
#endif

#ifdef	EMULATION
#define	RTC_TICKS	(12)
#else
#define	RTC_TICKS	(100)
#endif

//#define	QUANT_ZIGZAG
#define	OLDAGDC		0

#define	POLLING_VIDEO_DECODE
#define	CHECK_PARSING_BARRIER
#define	PIC_INFO_SDRAM
#define	PIC_INFO_ENTRIES	32

#define	PAL
//#define	NTSC
#define	PARSE_GOP
//#define	PARSE_USER_DATA

#define	FRAME_DECODING
//#define FIELD_DECODING

#define MEMORY_LARGE                    0x80
#define MEMORY_SMALL                    0x00

#define MEMORY_PAL                      0x04
#define MEMORY_NTSC                     0x00
#define MEMORY_NTSCPAL_MASK             (MEMORY_PAL | MEMORY_NTSC)

#define MEMORY_ROM_MASK                 0x03
#define MEMORY_ROM_NONE                 0x00
#define MEMORY_ROM_1M                   0x01
#define MEMORY_ROM_2M                   0x02
#define MEMORY_ROM_4M                   0x03

#define	SYSTEM_LEN_MAX		2324

#define	CDDSP_CRC_RETRY		1
#define	CDDSP_RETRY_LOW		16
#define	CDDSP_RETRY		20
#define	CDDSP_GOBACK		-5
#define	CDDSP_RESTART_TIME	(2*RTC_TICKS)

/*
** GNU c specific definitions.
*/
#ifdef	__GNUC__
#define	ENABLE_INLINE
#if defined(ARM_EVM)
#define __value_in_regs
#define	ENABLE_INLINE
#endif
#endif

#ifdef	ENABLE_INLINE
#ifdef 	ARM_EVM
#define	INLINE	__inline
#else
#define	INLINE	inline
#endif
#else
#define	INLINE
#endif

/*
** decoding start criteria
*/
#define	VBV_START		512	/* ROWs to start first decoding */
#define	VBV_START_PICTURE	(PIC_INFO_ENTRIES/2)	/* PICs to start first decoding */

/*
** cd restart criteria
*/
#define	VBV_LOW			1024	/* ROWs to restart CD		*/
#define	VBV_PIC_LOW		12	/* PICs to restart CD		*/

#define	ABV_LOW			32	/* ROWs to restart CD 		*/

/*
** parsing pause criteria
*/
#define	VBV_LIMIT		2	/* ROWs to stop parsing		*/
#define	ABV_LIMIT		4
#define	CBV_LIMIT		8

/*
** DMA batch, deprecated
*/
#define	DMA_BATCH		64

/*
** system input buffer (0-63)
*/
#define	SRV_IN_BUF		0
#define	SRV_IN_BATCH		DMA_BATCH

/*
** video output buffer (64-95)
*/
#define	VIDEO_OUT_BUF		(SRV_IN_BUF+SRV_IN_BATCH)
#define	VIDEO_OUT_BATCH		32	

/*
** audio output buffer (96-127)
*/
#define	AUDIO_OUT_BUF		(VIDEO_OUT_BUF+VIDEO_OUT_BATCH)
#define	AUDIO_OUT_BATCH		32	

/*
** OGT output buffer (128-160)
*/
#define	OGT_OUT_BUF		(AUDIO_OUT_BUF+AUDIO_OUT_BATCH)
#define	OGT_OUT_BATCH		32	

/*
**
*/
#define TEMP_DMA_RAM		(OGT_OUT_BUF+OGT_OUT_BATCH)

/*
** MACRO
** assert_marker_bit(b)
**
** macro to check against marker-bit.
*/
#define assert_marker_bit(b)

#define	POWERON_DELAY		1
#define	VIDEO_RESET_DELAY	1





#ifdef SUPPORT_EXT_HW_DSA
#define DISABLE_VFD               1 //kenny add 891129 to disable vfd
#endif
#define	AUDIO_VOLUME_AMP	8

//#define SUP_DEB_VFD		//Note,Must mark on Release ,terry,2001/3/31 05:07PM
//#define	SUPPORT_EPP		1
#define SUPPORT_VFDDBG          1
//#define SUPPORT_SFT_DSA         1 //kenny add 891117 for supporting software dsa
//#define SUPPORT_SFT_SERVO         1 //kenny add 891121 for supporting GPIO0,GPIO12,GPIO13 to control MCLK, MDATA, MLD of servo DSP
//#define SUPPORT_EXT_HW_DSA        1 //kenny add 891122 for supporting dsa comunication with  external host by hardware DSA pins (DSA_DATA,DSA_ACK,DSA_STB)
//#define FWD_ACCR_TRK				//terry,2000/12/13 02:40PM
#ifdef SUPPORT_EXT_HW_DSA
#define DISABLE_VFD               1 //kenny add 891129 to disable vfd
#endif

#ifdef SUPPORT_EPP
#define SUPPORT_VFD           1
	#undef SUPPORT_VFDDBG
#endif
#ifdef SUPPORT_VFDDBG
        // 1k rs232 debugger buffer
        #define RS232BUFF_BASE	SDRAM_BASE+7*1024
	#undef SUPPORT_VFD
	#undef SUPPORT_EPP
#else 
	#define SUPPORT_VFD           1
#endif

#ifdef SUP_DEB_VFD
	#define SUPPORT_VFD           1
	#define SUPPORT_VFDDBG        1
	#define RS232BUFF_BASE	SDRAM_BASE+22*1024
#endif

#define REVISE_GOTO_ERR
#define REVISE_STATE_ERR

#define	SUPPORT_DSA		1
#define SUPPORT_I2C		0
#define	SUPPORT_IROUT		1

#define GAME_NO_BGN //terry,0-11-30 14:03 Game no background

#ifdef CAR_VCD//kenny 2001/2/20

#define	CDDSP_GOBACK	-20
#else
#define	CDDSP_GOBACK	-5
#endif
//#define SUPPORT_AUDIO
#endif/*__SUNPLUS_CONFIG_H*/

