/*
** dvd720.h
** The data that the device driver need;
** defined by Jacky
*/

#ifndef __DVD720_H_
#define __DVD720_H_

#include "types.h"
#include "config.h"
#include <asm/sunplus/regmap.h>
#include <asm/sunplus/memmap.h>
//#include "regmap.h"
#include "gpio.h"



#define TV_DEVICE_NAME "dvd720"
//#define TV_DEVICE_MAJOR 0;
//static int tv_device_major = 16;

/* graphic function head*/

#define BASE_LUMA	0 //(dvd_regs->ref0_luma)
#define BASE_CHROMA	(dvd_regs->ref0_chroma)

#define OFFSET_LUMA	(BASE_LUMA * 1024)			/* 1024 */
#define OFFSET_CHROMA	(BASE_CHROMA *1024)			/* 1024 */

#define LUMA_START_ADDR		(SDRAM_BASE+ BASE_LUMA * 1024)		/* 1024 */
#define CHROMA_START_ADDR	(SDRAM_BASE+ BASE_CHROMA *1024)		/* 1024 */

#define LINE_OFFSET	1024    /* for LUMA */

#define OFFSET_Y(Y)	(((Y)*LINE_OFFSET)) //(((Y)*LINE_OFFSET)^1)
#define OFFSET_C(Y)	((Y>>1)*LINE_OFFSET)

#define SFF(X)		(((X & 0x08) << 1) | ((X&0x10)>>1) | (X&0x7fe7))

#define Y_XY(X,Y)	((BYTE *)(SDRAM_BASE + OFFSET_Y(Y)+ SFF(X) ))
#define C_XY(X,Y)	((UINT16 *)(SDRAM_BASE + dvd_regs->ref0_chroma*1024 +OFFSET_C(Y) + 2*(SFF(X)>>1)))

#define virtY_XY(X,Y)	((BYTE *)((UINT32)(ivideo.video_vbase) + OFFSET_Y(Y)+ SFF(X))) 
#define virtC_XY(X,Y)	((UINT16 *)((UINT32)(ivideo.video_vbase) + dvd_regs->ref0_chroma*1024 +OFFSET_C(Y) + 2*(SFF(X)>>1)))


#define swap_luma(X) (((X & 0x08) << 1) | ((X&0x10)>>1) | (X&0x7fe7)) 
#define swap_chroma(X) (((X & 0x08) << 1) | ((X&0x10)>>1) | (X&0x7fe6))
void	setColor(UINT32);
void	plotXY(int, int);
void	DrawLine(int SX, int SY, int EX, int EY);

#endif /* __DVD720_H_ */
