/*
** dvd_public.h;
** This is the TV screen driver's head file;
** Here,we defined the commands called by the ioctl() in user mode;
**
** start by jacky
*/

#ifndef __TV_PUBLIC_H_
#define __TV_PUBLIC_H_

#include <linux/ioctl.h>

//TODO: Datasize that the user space and the kernel space translate each other;
int drawpixel;
int readpixel;
int drawhline;
int drawvline;
int fillrect;

/* All of following the commands were defined */ 
//#define TV_SCREEN_IOC_MAGIC 'k'

//#define TV_SCREEN_DRAWIMAGE _IO(TV_SCREEN_IOC_MAGIC, 0)

/*
 * S means "Set" through a ptr,
 * T means "Tell" directly with the argument value
 * G means "Get": reply by setting through a pointer
 * Q means "Query": response is on the return value
 * X means "eXchange": G and S atomically
 * H means "sHift": T and Q atomically
 */

//#define TV_SCREEN_VIDEOINIT	 _IO(TV_SCREEN_IOC_MAGIC, )	
//#define TV_SCREEN_DRAWPIXEL  _IOR(TV_SCREEN_IOC_MAGIC, 1, int)
//#define TV_SCREEN_READPIXEL  _IOW(TV_SCREEN_IOC_MAGIC, 2, int)
//#define TV_SCREEN_DRAWHLINE  _IOR(TV_SCREEN_IOC_MAGIC, 3, int)
//#define TV_SCREEN_DRAWVLINE  _IOR(TV_SCREEN_IOC_MAGIC, 4, int)
//#define TV_SCREEN_FILLRECT   _IOR(TV_SCREEN_IOC_MAGIC, 5, int)
//#define MODULE_INC_USE_COUNT _IO(TV_SCREEN_IOC_MAGIC, 6)
//#define MODULE_DEC_USE_COUNT _IO(TV_SCREEN_IOC_MAGIC, 7)
#define KEYBOARD_READ		 _IO(TV_SCREEN_IOC_MAGIC, 8) 

//#define TV_SCREEN_SET_INFO   _IOW(TV_SCREEN_IOC_MAGIC, 9,  int)
//#define TV_SCREEN_GET_INFO   _IOR(TV_SCREEN_IOC_MAGIC, 10, int)
//#define TV_SCREEN_DRAWBLIT	 _IOR(TV_SCREEN_IOC_MAGIC, 11, int)



//#define TV_SCREEN_IOC_MAXNR 11

//define screen information mode
#define VPPMODE1	1	//720*480 24bit color
#define	VPPMODE2	2	//360*240 24bit color
#define OSDMODE		3	//720*480 8bit palette

// the following structure added by pangbo;

typedef struct _pixel {
       int x;
       int y;
       int color;
}TV_SCREEN_PIXEL ;

typedef struct _hlinecoord {
       int x1;
       int x2;
       int y;
       int color;
} TV_SCREEN_HLINE;

typedef struct _vlinecoord {
        int x;
        int y1;
        int y2;
        int color;
} TV_SCREEN_VLINE;

typedef struct _fillrectcoord {
        int x1;
		int y1;
        int x2;
        int y2;
        int color;      
} TV_SCREEN_FILLRECTANGLE;

typedef struct _blit {
		int dstx;
		int dsty;
		int w;
		int h;
		int srcx;
		int srcy;
} TV_SCREEN_BLIT;
				

/*
typedef struct _getscreeninformation {
		int width;
		int height;		
		int bpp;
} TV_SCREEN_INFO;
*/
/*typedef struct _setscreeninformation {
		int width;
		int height;		
		int bpp;
} TV_SCREEN_SETINFO;
*/
#endif //__TV_PUBLIC_H_
/* dvd_public.h ended; */ 

