/*
 * Sunplus 720 frame buffer device For Kernal 2.2.x
 *
 *
 */

#ifndef MODULE
#define EXPORT_SYMTAB
#endif

#undef  SPFBDEBUG

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/slab.h>
#include <linux/delay.h>
#include <linux/fb.h>
#include <linux/console.h>
#include <linux/selection.h>
#include <linux/ioport.h>
#include <linux/init.h>
#include <linux/pci.h>
#include <linux/vt_kern.h>
#include <asm/sunplus/sp720fb.h>

#include <asm/io.h>
//#include <asm/mtrr.h>

#include <video/fbcon.h>
#include <video/fbcon-cfb8.h>
#include <video/fbcon-cfb16.h>
#include <video/fbcon-cfb24.h>
#include <video/fbcon-cfb32.h>
#include <video/fbcon-sp720.h>

#include "dvd_public.h"
#include "dvd720.h"
#include "func.h"
#include <asm/sunplus/memmap.h>

#define	TV0	1
#define DEFAULT_TV_MODE 0

extern volatile RegisterFile *dvd_regs; //define in arch/mipsnommu/sunplus/uart.c

/* ------------------- Global Variables ----------------------------- */

struct video_info ivideo;

struct GlyInfo
{
    unsigned char ch;
    int      fontwidth;
    int      fontheight;
    u8       gmask[72];
    int      ngmask;
};

/* Supported Sunplus Chips list */


/* mode */
int  video_type = FB_TYPE_PACKED_PIXELS;
int  video_linelength;
int  video_cmap_len;
int  sp720fb_off = 0;

static struct fb_var_screeninfo default_var = 
{
  0, 0, 0, 0, 0, 0, 0, 0,
  {0, 8, 0}, {0, 8, 0}, {0, 8, 0}, {0, 0, 0},
  0, FB_ACTIVATE_NOW, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
  0,
  FB_VMODE_INTERLACED,
  {0,0,0,0,0,0}
};

static struct display disp;
static struct fb_info fb_info;

static struct { u_short blue, green, red, pad; } palette[256];

#if 0
static union {
#ifdef FBCON_HAS_CFB16
    u16 cfb16[16];
#endif
#ifdef FBCON_HAS_CFB24
    u32 cfb24[16];
#endif
#ifdef FBCON_HAS_CFB32
    u32 cfb32[16];
#endif
/*
#ifdef FBCON_HAS_SP720
    u32 cfb24[16];
#endif
*/
} fbcon_cmap;
#endif

static int    inverse   = 0;
static int    currcon   = 0;

static struct display_switch sp720fb_sw;

u8 caps = 0;

/* ModeSet stuff */
int     mode_idx     = -1;
u8      mode_no      =  0;
u8      rate_idx     =  0;

u8      VBConnect = 0;

static const struct _sp720bios_mode{
    char  name[15];
    u8    mode_no;
    u_short xres;
    u_short yres;
    u_short bpp;
    u_short rate_idx;
    u_short cols;
    u_short rows;
} sp720bios_mode[] = {
    {"720x480x24",    0,  720,  480,  24, 1,  90, 30},
    {"640x480x24",    0,  640,  480,  24, 1,  80, 30},
    {"\0",         0x00,    0,    0,  0, 0,   0,  0}
};


	/* 
	 *  Macro definitions
	 */
#ifdef SPFBDEBUG
#define DPRINTK(fmt, args...) printk(KERN_DEBUG "%s: " fmt, __FUNCTION__ , ## args)
#else
#define DPRINTK(fmt, args...)
#endif


	/*
 	 * Interface used by the world 
	 */
int sp720fb_setup (char *options);
static int sp720fb_open (struct fb_info *info, int user);
static int sp720fb_release (struct fb_info *info, int user);
static int sp720fb_get_fix (struct fb_fix_screeninfo *fix, int con,
             		  struct fb_info *info);
static int sp720fb_get_var (struct fb_var_screeninfo *var, int con,
             		  struct fb_info *info);
static int sp720fb_set_var (struct fb_var_screeninfo *var, int con,
              		  struct fb_info *info);
static int sp720fb_get_cmap (struct fb_cmap *cmap, int kspc, int con,
               		   struct fb_info *info);
static int sp720fb_set_cmap (struct fb_cmap *cmap, int kspc, int con,
               		   struct fb_info *info);
static int sp720fb_pan_display (struct fb_var_screeninfo *var, int con,
               		      struct fb_info *info);
static int sp720fb_ioctl (struct inode *inode, struct file *file, 
     			unsigned int cmd, unsigned long arg, int con, 
               		struct fb_info *info);

	/* 
	 * Interface to the low level console driver 
	 */
int sp720fb_init(void);
static int sp720fb_update_var (int con, struct fb_info *info);
static int sp720fb_switch (int con, struct fb_info *info);
//static void sp720fb_blank (int blank, struct fb_info *info);

	/*
	 * Internal routines
	 */
static void sp720fb_set_disp (int con, struct fb_var_screeninfo *var);
static int sp720fb_getcolreg (unsigned regno, unsigned *red, unsigned *green,
              		   unsigned *blue, unsigned *transp, struct fb_info *fb_info);
static int sp720fb_setcolreg (unsigned regno, unsigned red, unsigned green,
              		   unsigned blue, unsigned transp, struct fb_info *fb_info);

//static void sp720fb_resetall(void);
static void sp720fb_inithw(struct fb_var_screeninfo *var);
//static int do_set_var (struct fb_var_screeninfo *var, int isactive, 
//              	       struct fb_info *info);
//static void do_install_cmap (int con, struct fb_info *info);
static void tvc_to_var (struct fb_var_screeninfo *var);
static void search_mode(const char *name);


/*
** The following we define the graphic function:
** drawplot, drawline, Fillrectangle and drawstring;
*/
UINT32 color = 0x00ff8080;

void setColor(UINT32 c)
{
	color = c;
}

static inline void __plotXY(int X, int Y)
{
	UINT32	c = color;

	/* store the Y */
	X=(X<<1);
	Y=(Y<<1);
	
	*Y_XY(X, Y) = (c>>16)&0xff;
	*Y_XY((X+1), Y) = (c>>16)&0xff;
    *Y_XY(X, (Y+1)) = (c>>16)&0xff;
	*Y_XY((X+1), (Y+1)) = (c>>16)&0xff;	
	/* store CbCr (using 420 format) */
	
	*C_XY(X, Y) = (c&0xffff);
}

static inline void __plotXYC(int X, int Y, UINT32 c)
{
	X=(X<<1);
	Y=(Y<<1);
	*Y_XY(X, Y) = (c>>16)&0xff;
	*Y_XY((X+1), Y) = (c>>16)&0xff;
    *Y_XY(X, (Y+1)) = (c>>16)&0xff;
	*Y_XY((X+1), (Y+1)) = (c>>16)&0xff;	
	/* store CbCr (using 420 format) */
	
	*C_XY(X, Y) = (c&0xffff);
}

void DrawPixel(int X, int Y)
{
	__plotXY(X, Y);
}

void DrawPixelCol(int X, int Y, UINT32 c)
{
	__plotXYC(X,  Y, c);
}

void DrawVLine(int SX, int SY, int EY, UINT32 col)
{
	void *p;
	register int cnt;
	register int i;
	register BYTE lum;
	
	if(SY > EY)
	{
		i = SY; SY = EY; EY = i;
	}
	cnt = EY-SY+1;
	// Draw Y area;
	lum = (col>>16)&0xff;
	p = Y_XY(SX, SY);
	for(i=0; i<cnt; i++ )
	{
		DrawPixelCol(SX, SY+i, col);
	}
}


void DrawHLine( int SX, int EX, int Y, UINT32 col)
{
	/*
	** Since the addr bit of 3,4 should swap, 
	** the alignment is 32 and hard to block fill in line edge
	*/
	register UINT32 tmp, base;
	register int r;
	if(SX > EX)
	{
		r = SX; SX = EX; EX = r;
	}
	// Draw Y area;
	base = (UINT32)Y_XY(0, Y);
	tmp = (col>>16)&0xff;
	for(r=SX; r<=EX; r++)
		DrawPixelCol(r, Y, col);

}

int ReadPixel(int X, int Y)
{
	unsigned long col=0;
	#ifdef _DEBUG_
	unsigned long colluma=0;
	unsigned long colchro=0;
	#endif
	X=(X<<1);
	Y=(Y<<1);
	col = (*Y_XY(X, Y)<<16 ) | ((*C_XY(X, Y))&0xffff);
	#ifdef _DEBUG_
	colluma = (*Y_XY(X, Y)<<16 );
	colchro = ((*C_XY(X, Y))&0xffff);
	printk("*Y_XY(X, Y)=%X, *C_XY(X, Y)=%X \n", colluma, colchro);
	#endif
	return col;
}

void FillRectangle(int SX, int SY, int EX, int EY, UINT32 c)
{
	int i, j;

	for(i=SX; i<=EX; i++)
	{
		for(j=SY; j<=EY; j++)
		{
			DrawPixelCol(i, j, c);
		}
	}
		
//	for(i=SY; i<=EY; i++)
//	{
//		DrawHLine(SX, SY, i, c);
//	}

//	for(i=SX; i<=EX; i++)
//	{
//		DrawVLine(i, SY, EY, c);
//	}

}

void BufferBlit(int srcx, int srcy, int dstx, int dsty, int height, int width)
{
	register int i, j;
	int coordx, coordy;
	int blitcol;
	int bltsx, bltsy;
	int bltdx, bltdy, bltw, blth;
	if( (srcx=dstx) && (srcy>dsty) )
	{
		bltdx	= dstx;
		bltdy	= dsty;
		bltsx	= srcx; 
		bltsy	= srcy;
		bltw	= width;
		blth	= height;
	
		for(i = bltsy; i<=(srcy+height); i++ )
		{
			coordy =i;
			bltdx = dstx;
			for(j=bltsx; j<=(srcx+width); j++ )
			{
				coordx	=j;
				blitcol=ReadPixel(coordx, coordy);
				DrawPixelCol(bltdx, bltdy, blitcol);
				//if( (bltdx<=(dstx+width) )&&(bltdy<=(dsty+height)) )
				{
					bltdx++;
				}
			}

			bltdy++;
		}
		
	}
}	
			

/* graphic end */





#if 0
static
void sp720fb_resetall(void)
{
//    InitRegFile();
    reset_gpio();
    dvd_regs->gpio_out[3]  |=0x0700;
    dvd_regs->gpio_oe[3]   |=0x0600;
    dvd_regs->gpio_oe[3]   &=~0x0100;
    dvd_regs->emulation        = 0;
    dvd_regs->reset            = 0x038;//0x070;
    tv_setup();
}
#endif

static
void sp720fb_inithw(struct fb_var_screeninfo *var)
{
    int ref1_start;
    extern u_char *pLumaFrm;
    extern u_short *pChromaFrm;

//    sp720fb_resetall();		// Michue remove
    //dvd_regs->intr_mask        &= ~0x0c00;//0xf3ff; //shutdown the vpp INT
    //disable_init_video();

    pLumaFrm = (u_char *) SDRAM_BASE;
    pChromaFrm = (u_short *) (SDRAM_BASE + var->yres*FRAMEBUF_LINE);

    ref1_start = var->yres + var->yres/2;
    
    //smwang. we just 
    //ivideo.video_size 	= var->yres * var->xres * 3; 	//3 = 1+1+0.5+0.5
    ivideo.video_size 	= var->yres * var->xres;
 
    dvd_regs->ref0_luma	= 0;
    dvd_regs->ref0_chroma 	= var->yres;
    dvd_regs->ref1_luma    = ref1_start;
    dvd_regs->ref1_chroma  = ref1_start + var->yres;

    dvd_regs->dis_tv_std   = 0; 	//NTSC
    tv_setup_ntsc();
    dvd_regs->dis_pic_id   = 0;	//display control;//frame 0
    dvd_regs->dis_tv_out   = 0x04;	// ( 0x02 swap Cr/Cb and 0x04  swap luma/chroma)
    dvd_regs->dis_mixer    = 0; 	//added 9-27
    dvd_regs->h_size       = var->xres;
    dvd_regs->v_size       = var->yres;

    dvd_regs->h_offset     = 12;
    dvd_regs->v_offset	= 8; 	// no effect!

    dvd_regs->dis_x_start  = 0;	//VPP control frame size
    dvd_regs->dis_y_start  = 0;
    dvd_regs->dis_x_size   = var->xres;                  /* default */
    dvd_regs->dis_y_size   = var->yres;


    dvd_regs->h_exp_mode   = 0x800;
    dvd_regs->v_filter_mode	=0x0200;
    //dvd_regs->field_exchange	= 0x000e; //0x000c;
    dvd_regs->field_exchange= 0x0006;


    dvd_regs->video_compress=0;	// RF_COMPRESS_DITHER_OFF;
                            	//RF_VIDEO_COMPRESS_888|RF_COMPRESS_DITHER_OFF;
    //enable_init_video();
}


	/* 
	 *    Get TVC registers to set var 
	 */
static 
void tvc_to_var(struct fb_var_screeninfo *var)
{
	
    var->bits_per_pixel = ivideo.video_bpp;	
    switch(var->bits_per_pixel)
    {
    case 8:
        var->red.length   = 6;
        var->green.length = 6;
        var->blue.length  = 6;
        video_cmap_len = 256;
        break;
    case 16:    /* RGB 565 */
        var->red.offset    = 11;
        var->red.length    = 5; 
        var->green.offset  = 5;
        var->green.length  = 6;
        var->blue.offset   = 0;
        var->blue.length   = 5;
        var->transp.offset = 0;
        var->transp.length = 0;
        video_cmap_len = 16;

        break;
    case 24:    /* RGB 888 */
        var->red.offset    = 16;
        var->red.length    = 8;
        var->green.offset  = 8;
        var->green.length  = 8;
        var->blue.offset   = 0;
        var->blue.length   = 8;
        var->transp.offset = 0;
        var->transp.length = 0;
        video_cmap_len = 16;
        break;
    case 32:    
        var->red.offset    = 16;
        var->red.length    = 8;
        var->green.offset  = 8;
        var->green.length  = 8;
        var->blue.offset   = 0;
        var->blue.length   = 8;
        var->transp.offset = 24;
        var->transp.length = 8;
        video_cmap_len = 16;
        break;
    }

    var->yres = var->yres_virtual = ivideo.video_height; 
    var->upper_margin = 0;
    var->lower_margin = 0;
    var->vsync_len    = 0;

    var->xres = var->xres_virtual = ivideo.video_width; 
    var->left_margin  = 0;
    var->right_margin = 0;
    var->hsync_len    = 0;

    var->activate = FB_ACTIVATE_NOW;

    var->sync = 0;
}


static 
void sp720fb_set_disp(int con, struct fb_var_screeninfo *var)
{
    struct fb_fix_screeninfo fix;
    struct display *display;
    struct display_switch *sw;
//    u32    flags;
   
//    printk("...sp720fb_set_disp...\n");
 
    if (con >= 0)
        display = &fb_display[con];
    else
        display = &disp;    /* used during initialization */

    sp720fb_get_fix(&fix, con, 0);

    display->screen_base = ivideo.video_vbase;
    display->visual = fix.visual;
    display->type = fix.type;
    display->type_aux = fix.type_aux;
    display->ypanstep = fix.ypanstep;
    display->ywrapstep = fix.ywrapstep;
    display->line_length = fix.line_length;
    display->next_line = fix.line_length;
//    display->can_soft_blank = 1;
    display->can_soft_blank = 0;
    display->inverse = inverse;
    display->var = *var;

    //save_flags(flags);
    switch (ivideo.video_bpp) {
#ifdef FBCON_HAS_CFB8
    case 8:
        sw = &fbcon_cfb8;
        break;
#endif
#ifdef FBCON_HAS_CFB16
    case 15:
    case 16:
        sw = &fbcon_cfb16;
        display->dispsw_data = fbcon_cmap.cfb16;
        break;
#endif
#ifdef FBCON_HAS_CFB24
    case 24:
        sw = &fbcon_cfb24;
        display->dispsw_data = fbcon_cmap.cfb24;
        break;
#endif
#ifdef FBCON_HAS_CFB32
    case 32:
        sw = &fbcon_cfb32;
        display->dispsw_data = fbcon_cmap.cfb32;
        break;
#endif
#ifdef FBCON_HAS_SP720
    case 24:      
        sw = &fbcon_sp720;
        display->dispsw_data = NULL;
        break;
#endif
    default:
        sw = &fbcon_dummy;
        return;
    }
    memcpy(&sp720fb_sw, sw, sizeof(*sw));
    display->dispsw = &sp720fb_sw;
    //restore_flags(flags);

    display->scrollmode = SCROLL_YREDRAW;
    sp720fb_sw.bmove = fbcon_redraw_bmove;
}


	/*
	 *    Read a single color register and split it into colors/transparent. 
	 *    Return != 0 for invalid regno.
	 */
static 
int sp720fb_getcolreg(unsigned regno, unsigned *red, unsigned *green,
              unsigned *blue, unsigned *transp,
              struct fb_info *fb_info)
{

    //printk("...sp720fb_getcolreg...\n");

    //if (regno >= video_cmap_len)
    //    return 1;

    //*red   = palette[regno].red;
    //*green = palette[regno].green;
    //*blue  = palette[regno].blue;
    //*transp = 0;
    return 0;
}


	/*
	 *    Set a single color register. The values supplied are already
	 *    rounded down to the hardware's capabilities (according to the
	 *    entries in the var structure). Return != 0 for invalid regno.
	 */
static 
int sp720fb_setcolreg(unsigned regno, unsigned red, unsigned green,
              unsigned blue, unsigned transp,
              struct fb_info *fb_info)
{
    
    //printk("...sp720fb_setcolreg...\n");

    if (regno >= video_cmap_len)
        return 1;

    palette[regno].red   = red;
    palette[regno].green = green;
    palette[regno].blue  = blue;
    
    switch (ivideo.video_bpp) 
    {
#ifdef FBCON_HAS_CFB8
    case 8:
        //vgawb(DAC_ADR,  regno);
        //vgawb(DAC_DATA, red   >> 10);
        //vgawb(DAC_DATA, green >> 10);
        //vgawb(DAC_DATA, blue  >> 10);

        //if(VBConnect)
       // {
        //    vgawb(DAC2_ADR,  regno);
        //    vgawb(DAC2_DATA, red   >> 8);
        //    vgawb(DAC2_DATA, green >> 8);
        //    vgawb(DAC2_DATA, blue  >> 8);
        //}

        break;
#endif
#ifdef FBCON_HAS_CFB16
    case 15:
    case 16:
        fbcon_cmap.cfb16[regno] =
            ((red   & 0xf800)      ) |
            ((green & 0xfc00) >>  5) |
            ((blue  & 0xf800) >> 11);
        break;
#endif
#ifdef FBCON_HAS_CFB24
    case 24:
        red   >>= 8;
        green >>= 8;
        blue  >>= 8;
        fbcon_cmap.cfb24[regno] =
            (red   << 16)  |
            (green <<  8)  |
            (blue       );
        break;
#endif
#ifdef FBCON_HAS_CFB32
    case 32:
        red   >>= 8;
        green >>= 8;
        blue  >>= 8;
        fbcon_cmap.cfb32[regno] =
            (red   << 16) |
            (green <<  8) |
            (blue       );
        break;
#endif
    }
    return 0;
}

#if 0
static 
void do_install_cmap(int con, struct fb_info *info)
{
    if (con != currcon)
        return;

    if (fb_display[con].cmap.len)
        fb_set_cmap(&fb_display[con].cmap, 1, sp720fb_setcolreg, info);
    else
        fb_set_cmap(fb_default_cmap(video_cmap_len), 1, sp720fb_setcolreg, info);
}
#endif

#if 0
static 
int do_set_var(struct fb_var_screeninfo *var, int isactive, struct fb_info *info)
{
    //u_int   htotal = var->left_margin + var->xres + var->right_margin + var->hsync_len;
    //u_int   vtotal = var->upper_margin + var->yres + var->lower_margin + var->vsync_len;
    //double  drate = 0, hrate= 0;
    int     found_mode = 0;

    mode_idx = 0;

//    printk("......do_set_var...\n");

    if (var->xres == 720){
	mode_idx = 0;
	found_mode = 1;
    } 
    else if (var->xres == 640) {
	     mode_idx = 1;		
	     found_mode = 1;
    } 
    else {
        printk(KERN_DEBUG "sp720 does not support mode %dx%d-%d\n for TV output", 
               var->xres, var->yres, var->bits_per_pixel);
        return 1;
    }

    if (found_mode) {
	if (((var->activate & FB_ACTIVATE_MASK) == FB_ACTIVATE_NOW) && isactive) {
            ivideo.video_bpp	= sp720bios_mode[mode_idx].bpp;
            ivideo.video_width	= sp720bios_mode[mode_idx].xres;
            ivideo.video_height	= sp720bios_mode[mode_idx].yres; 
            video_linelength	= ivideo.video_width;

            DPRINTK("Current Mode: %dx%d-%d line_length=%d\n", 
                    ivideo.video_width, ivideo.video_height, ivideo.video_bpp, video_linelength);
	}
    }

    return 0;
}
#endif

/* ---------------------- Draw Funtions ----------------------------- */
/*
static 
void sp720fb_get_glyph(struct GlyInfo *gly)
{
    struct display *p = &fb_display[currcon];
    u16 c;
    u8 *cdat;
	int widthb;
	u8 *gbuf = gly->gmask;
	int size;


	gly->fontheight = fontheight(p);
	gly->fontwidth  = fontwidth(p);
    widthb = (fontwidth(p) + 7) / 8;

    c = gly->ch & p->charmask;
    if (fontwidth(p) <= 8)
        cdat = p->fontdata + c * fontheight(p);
    else
        cdat = p->fontdata + (c * fontheight(p) << 1);

	size = fontheight(p) * widthb;
	memcpy(gbuf, cdat, size);
	gly->ngmask = size;
}
*/

static 
void search_mode(const char *name)
{
    int i = 0;
//    printk("......search_mode...\n");
    
    if(name == NULL)
        return ;

    while(sp720bios_mode[i].mode_no != 0)
    {
        if (!strcmp(name, sp720bios_mode[i].name)) 
        {
            mode_idx = i;
            break;
        }
        i++;
    }
    if(mode_idx < 0)
        DPRINTK("Invalid user mode : %s\n", name);
}


/* ------------------ Public Routines ------------------------------- */

	/*
	 *  Open/Release the frame buffer device
	 */
static 
int sp720fb_open(struct fb_info *info, int user)
{
    MOD_INC_USE_COUNT;
    return(0);
}


static 
int sp720fb_release(struct fb_info *info, int user)
{
    MOD_DEC_USE_COUNT;
    return(0);
}


	/*
	 *  Get the Fixed Part of the Display
	 */
static 
int sp720fb_get_fix(struct fb_fix_screeninfo *fix, int con,
    	          struct fb_info *info)
{
    DPRINTK("sp720: sp720fb_get_fix:[%d]\n", con);
//    printk("...sp720fb_get_fix...\n");

    memset(fix, 0, sizeof(struct fb_fix_screeninfo));
    strcpy(fix->id, fb_info.modename);

    fix->smem_start  = (char *)ivideo.video_base;
    
    fix->smem_len    = ivideo.video_size;
    fix->type        = video_type;
    fix->type_aux    = 0;
    if (ivideo.video_bpp == 8)
        fix->visual  = FB_VISUAL_PSEUDOCOLOR;
    else
        fix->visual  = FB_VISUAL_TRUECOLOR;
    fix->xpanstep    = 0;
    fix->ypanstep    = 0;
    fix->ywrapstep   = 0;
    fix->line_length = video_linelength;
    //fix->mmio_start  = (char *)ivideo.mmio_base;
    //fix->mmio_len    = MMIO_SIZE;

    return 0;
}


	/*
	 *  Get the User Defined Part of the Display
	 */
static 
int sp720fb_get_var(struct fb_var_screeninfo *var, int con,
 	          struct fb_info *info)
{
    DPRINTK("sp720: sp720fb_get_var:[%d]\n", con);
//    printk("...sp720fb_get_var...\n");

    if(con==-1)
        memcpy(var, &default_var, sizeof(struct fb_var_screeninfo));
    else
        *var=fb_display[con].var;
    return 0;
}


	/*
	 *  Set the User Defined Part of the Display
	 */
static 
int sp720fb_set_var(struct fb_var_screeninfo *var, int con,
              	  struct fb_info *info)
{
//    int   err;
    //u_int cols, rows;
//    printk("...sp720fb_set_var...\n");

    fb_display[con].var.activate = FB_ACTIVATE_NOW;

    /* Set mode */
    //if (do_set_var(var, con == currcon, info))
    //{
    //    tvc_to_var(var);   /* return current mode to user */
    //    return -EINVAL;
    //}

    /* get actual setting value */
    //tvc_to_var(var);

    /* update display of current console */
    //sp720fb_set_disp(con, var);

    //if (info->changevar)
    //    (*info->changevar)(con);

    //if ((err = fb_alloc_cmap(&fb_display[con].cmap, 0, 0)))
    //    return err;

    //do_install_cmap(con, info);

    /* inform console to update struct display */
    //cols = sp720bios_mode[mode_idx].cols;
    //rows = sp720bios_mode[mode_idx].rows;
    //vc_resize_con(rows, cols, fb_display[con].conp->vc_num);

    return 0;
}


	/*
	 *  Get the Colormap
	 */
static 
int sp720fb_get_cmap(struct fb_cmap *cmap, int kspc, int con,
 	           struct fb_info *info)
{
    DPRINTK("sp720: sp720fb_get_cmap:[%d]\n", con);
//    printk("...sp720fb_get_cmap...\n");

    if (con == currcon)
        return fb_get_cmap(cmap, kspc, sp720fb_getcolreg, info);
    else if (fb_display[con].cmap.len) /* non default colormap? */
        fb_copy_cmap(&fb_display[con].cmap, cmap, kspc ? 0 : 2);
    else
        fb_copy_cmap(fb_default_cmap(video_cmap_len),
             cmap, kspc ? 0 : 2);
    return 0;
}


	/*
	 *  Set the Colormap
	 */
static int a =0;	 
static 
int sp720fb_set_cmap(struct fb_cmap *cmap, int kspc, int con,
	           struct fb_info *info)
{
    int err;
    a++;
    if (a <3)
    printk("...sp720fb_set_cmap...\n");

    if (!fb_display[con].cmap.len) {    /* no colormap allocated */
        err = fb_alloc_cmap(&fb_display[con].cmap,video_cmap_len,0);
        if (err)
            return err;
    }
    if (con == currcon)            /* current console */
        return fb_set_cmap(cmap, kspc, sp720fb_setcolreg, info);
    else
        fb_copy_cmap(cmap, &fb_display[con].cmap, kspc ? 0 : 1);
    return 0;
}


	/*
	 *  Pan or Wrap the Display
	 */
static 
int sp720fb_pan_display(struct fb_var_screeninfo *var, int con,
                      struct fb_info *info)
{
    /* not support virtual screen yet */
    return -EINVAL;
}


static 
int sp720fb_ioctl(struct inode *inode, struct file *file, unsigned int cmd, 
		unsigned long arg, int con, struct fb_info *info)
{
//    printk("...sp720fb_ioctl...\n");
    switch (cmd) {
    case FBIODRAW_PIXEL:
	{
	    TV_SCREEN_PIXEL *coord = (TV_SCREEN_PIXEL *)arg;
	    #ifdef _DEBUG_
		printk("TV_SCREEN_DRAWPIXEL:%d\n", TV_SCREEN_DRAWPIXEL);
		printk("pixel coordinat x:%d,y:%d, col:%d\n",coord->x,
                       coord->y, coord->color);
	    #endif
	    DrawPixelCol(coord->x, coord->y, coord->color);
            break;
	}
	
    case FBIOREAD_PIXEL:
        {
            unsigned long col=0;
            TV_SCREEN_PIXEL *pixel = (TV_SCREEN_PIXEL *)arg;
            col = ReadPixel(pixel->x, pixel->y);
            return col;
        }

    case FBIODRAW_VLINE:
	{
	    TV_SCREEN_VLINE *vline = (TV_SCREEN_VLINE *)arg;
	    #ifdef _DEBUG_
	    printk("The vline coordinate: X:%d,Y1:%d, Y2:%d,color:%d\n",
                   vline->x, vline->y1,vline->y2, vline->color);
            #endif
            DrawVLine( vline->x, vline->y1, vline->y2, vline->color);
            break;
	}

    case FBIODRAW_HLINE:
        {
	    TV_SCREEN_HLINE *hline = (TV_SCREEN_HLINE *)arg;
	    #ifdef _DEBUG_
	    printk("The hline coordinate: X1:%d, X2:%d, Y:%d, color:%d\n",                                             hline->x1, hline->x2, hline->y, hline->color);
            #endif
            DrawHLine(hline->x1, hline->x2, hline->y, hline->color);
            break;
	}

    case FBIOFILL_RECT:
        {
            TV_SCREEN_FILLRECTANGLE *rect = (TV_SCREEN_FILLRECTANGLE *)arg;
            FillRectangle(rect->x1, rect->y1, rect->x2, rect->y2, rect->color);
            break;
        }

    case FBIODRAW_BLIT:
        {
            TV_SCREEN_BLIT *blit = (TV_SCREEN_BLIT *)arg;
            //printk("blit->srcx=%d,blit->srcy=%d, blit->dstx=%d, blit->dsty=%d\n",
            //       blit->srcx, blit->srcy, blit->dstx, blit->dsty);

            BufferBlit(blit->srcx, blit->srcy, blit->dstx, blit->dsty,                                                     blit->h, blit->w);
            break;
        }    
    default:
        return -EINVAL;
    }

    return 0;

}


static 
int sp720fb_mmap(struct fb_info *info, struct file *file, struct vm_area_struct * vma)
{
//	struct fb_var_screeninfo var;
#ifndef NO_MM
	unsigned long start;
	u32 len;

	/* frame buffer memory */
	start = (unsigned long)ivideo.video_base;
	len = (start & ~PAGE_MASK)+ivideo.video_size;
	len = (len+~PAGE_MASK) & PAGE_MASK;

	//if (vma->vm_offset >= len) {
		/* memory mapped io */
		vma->vm_offset -= len;
        //sp720fb_get_var(&var, currcon, info);
	//	if (var.accel_flags)
	//		return -EINVAL;
	//	start = (unsigned long)ivideo.mmio_base;
	//	len = (start & ~PAGE_MASK)+MMIO_SIZE;
	//	len = (len+~PAGE_MASK) & PAGE_MASK;
	//}

	start &= PAGE_MASK;
	if ((vma->vm_end - vma->vm_start + vma->vm_offset) > len)
		return -EINVAL;
	vma->vm_offset += start;
	if (vma->vm_offset & ~PAGE_MASK)
		return -ENXIO;

	if (remap_page_range(vma->vm_start, vma->vm_offset,
			     vma->vm_end - vma->vm_start, vma->vm_page_prot))
		return -EAGAIN;
#else /* NO_MM */
			/* maybe has some problem */
		vma->vm_start = ivideo.video_base;
		return vma->vm_start;		
#endif
	return 0;

}


static struct fb_ops sp720fb_ops = {
    owner : 		THIS_MODULE,
    fb_open:		sp720fb_open,
    fb_release:		sp720fb_release,
    fb_get_fix:		sp720fb_get_fix,
    fb_get_var:		sp720fb_get_var,
    fb_set_var:		sp720fb_set_var,
    fb_get_cmap:	sp720fb_get_cmap,
    fb_set_cmap:	sp720fb_set_cmap,
    fb_pan_display:	sp720fb_pan_display,
    fb_ioctl:		sp720fb_ioctl,
    fb_mmap:		sp720fb_mmap,
};


int __init sp720fb_setup(char *options)
{
    char *this_opt;
    
    fb_info.fontname[0] = '\0';
    ivideo.refresh_rate = 0;
//    printk("...sp720fb_setup...\n");
    
    if (!options || !*options)
        return 1;
    
    for(this_opt=strtok(options,","); this_opt; this_opt=strtok(NULL,",")) {
        if (!*this_opt) continue;
        
        if (! strcmp(this_opt, "inverse"))
        {
            inverse=1;
            fb_invert_cmaps();
        }
        else if (!strncmp(this_opt, "font:", 5))
        {
            strcpy(fb_info.fontname, this_opt+5);
        }
        else if (!strncmp(this_opt, "mode:", 5))
        {
            search_mode(this_opt+5);
        }/*
        else if (!strncmp(this_opt, "vrate:", 6))
        {
            ivideo.refresh_rate = simple_strtoul(this_opt+6, NULL, 0);
        }*/
        else if (!strncmp(this_opt, "off", 3))
        {
            sp720fb_off = 1;
        }
        else
            DPRINTK("invalid parameter %s\n", this_opt);
    }
    return 1;
}


static 
int sp720fb_update_var(int con, struct fb_info *info)
{
    return 0;
}


	/*
	 *  Switch Console (called by fbcon.c)
	 */
static 
int sp720fb_switch(int con, struct fb_info *info)
{
//    int cols, rows; //lobo del

    DPRINTK("sp720: switch console from [%d] to [%d]\n",currcon, con);
//    printk("...sp720fb_switch...\n");

    /* update colormap of current console */
    if (fb_display[currcon].cmap.len)
        fb_get_cmap(&fb_display[currcon].cmap, 1, sp720fb_getcolreg, info);
    
    fb_display[con].var.activate = FB_ACTIVATE_NOW;

    /* same mode, needn't change mode actually */
    if(!memcmp(&fb_display[con].var, &fb_display[currcon].var, sizeof(struct fb_var_screeninfo)))
    {
        currcon = con;
        return 1;
    }

    currcon = con;

    //do_set_var(&fb_display[con].var, 1, info);

    //sp720fb_set_disp(con, &fb_display[con].var);

    /* Install new colormap */
    //do_install_cmap(con, info);

    //cols = sp720bios_mode[mode_idx].cols;
    //rows = sp720bios_mode[mode_idx].rows;
    //vc_resize_con(rows, cols, fb_display[con].conp->vc_num);

    sp720fb_update_var(con,info);

    return 1;

}

#if 0
	/* 0 unblank, 1 blank, 2 no vsync, 3 no hsync, 4 off */

static void sp720fb_blank(int blank, struct fb_info *info)
{

}
#endif

int __init sp720fb_init(void)
{
//    u_int yuv_color;
    
    if(sp720fb_off)
        return 1;

//    printk("...sp720fb_init...\n");

    ivideo.video_base = SDRAM_BASE;
    ivideo.mmio_base  = RGST_OFFSET;


    if (mode_idx < 0)
    {
	mode_idx = DEFAULT_TV_MODE;  /* 0:720x480x24 */ 
    }

    ivideo.video_bpp	= sp720bios_mode[mode_idx].bpp;
    ivideo.video_width	= sp720bios_mode[mode_idx].xres;
    ivideo.video_height	= sp720bios_mode[mode_idx].yres;
    //ivideo.video_size	= ivideo.video_height * FRAMEBUF_LINE;
    video_linelength    = ivideo.video_width * (ivideo.video_bpp >> 3);


    tvc_to_var(&default_var);

    sp720fb_inithw(&default_var);	

    //{
    //yuv_color = sunplus_rgb2yuv(128, 128, 128);
    //sunplus_fillrect(0, 0, ivideo.video_width, ivideo.video_height, yuv_color);
    //}
    

   /* 
    *  On MIPS, we have the whole physical address space mapped at all
    *  times, so "ioremap()" and "iounmap()" do not need to do anything.
    *  (This isn't true for all machines but we still handle these cases
    *  with wired TLB entries anyway ...)
    */
    //ivideo.video_vbase = ioremap((u_long)ivideo.video_base, ivideo.video_size);
    //ivideo.mmio_vbase  = ioremap((u_long)ivideo.mmio_base,  MMIO_SIZE);

    ivideo.video_vbase = ((char *)(SDRAM_BASE));
    ivideo.mmio_vbase  = ((char *)(RGST_OFFSET));


    printk(KERN_INFO "sp720: framebuffer at 0x%p, mapped to 0x%p, size %dk\n",
           ivideo.video_base, ivideo.video_vbase, ivideo.video_size/1024);
    //printk(KERN_INFO "sp720: mmio at 0x%p, mapped to 0x%p, size %dk\n",
    //       ivideo.mmio_base, ivideo.mmio_vbase, MMIO_SIZE/1024);
    printk(KERN_INFO "sp720: mode is %dx%dx%d, linelength=%d\n",
           ivideo.video_width, ivideo.video_height, ivideo.video_bpp, video_linelength);


    strcpy(fb_info.modename, "SUNPLUS 720");
    fb_info.changevar = NULL;
    fb_info.node = -1;
    fb_info.fbops = &sp720fb_ops;
    fb_info.disp = &disp;
    fb_info.switch_con = &sp720fb_switch;
    //fb_info.updatevar=&sp720fb_update_var;
    //fb_info.blank=&sp720fb_blank;
    fb_info.flags = FBINFO_FLAG_DEFAULT;

    sp720fb_set_disp(-1,&default_var);


    /* to avoid the inversed bgcolor bug of the initial state */
    //vc_resize_con(1, 1, 0);

    if (register_framebuffer(&fb_info)<0)
        return 0;

    ivideo.status = TV0;

    printk(KERN_INFO "fb%d: %s frame buffer device\n",
           GET_FB_IDX(fb_info.node), fb_info.modename);
    return 1;

}


#ifdef MODULE

static char *mode = NULL;
static u_int rate = 0;

MODULE_PARM(mode, "s");
MODULE_PARM(rate, "i");


int init_module(void)
{
    if(mode)
        search_mode(mode);

    sp720fb_init();

    return 0;
}


void cleanup_module(void)
{
    unregister_framebuffer(&fb_info);
}
MODULE_AUTHOR("Sunplus Dev");
MODULE_DESCRIPTION("Sunplus DVD 720 framebuffer driver");
MODULE_LICENSE("GPL");
#endif /* MODULE */


EXPORT_SYMBOL (ivideo);

