/*
 * Branch and jump emulation.
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1996, 1997, 1998, 2001 by Ralf Baechle
 *
 * $Id: branch.h,v 1.1.1.1 2005/09/15 13:38:16 root Exp $
 */
#ifndef _ASM_BRANCH_H
#define _ASM_BRANCH_H

#include <asm/ptrace.h>

#ifdef CONFIG_TRENDCHIP_TC3162L2
static inline int delay_slot(struct pt_regs *regs)
#else
extern inline int delay_slot(struct pt_regs *regs)
#endif
{
	return regs->cp0_cause & CAUSEF_BD;
}

#ifdef CONFIG_TRENDCHIP_TC3162L2
static inline unsigned long exception_epc(struct pt_regs *regs)
{
	if (!delay_slot(regs))
		return regs->cp0_epc;

	return regs->cp0_epc + 4;
}
#endif
extern int __compute_return_epc(struct pt_regs *regs);

#ifdef CONFIG_TRENDCHIP_TC3162L2
static inline int compute_return_epc(struct pt_regs *regs)
#else
extern inline int compute_return_epc(struct pt_regs *regs)
#endif
{
	if (!delay_slot(regs)) {
		regs->cp0_epc += 4;
		return 0;
	}

	return __compute_return_epc(regs);
}

#endif /* _ASM_BRANCH_H */
