#ifndef __sp720fb_h_
#define __sp720fb_h_

#include <linux/types.h>
#include <asm/ioctl.h>

#define FB_IOC_MAGIC 'F'
#define SPFB_IOC_MAXNR 20

#define FBIOREAD_PIXEL 0x4614
#define FBIODRAW_PIXEL 0x4615
#define FBIODRAW_VLINE 0x4617	
#define FBIODRAW_HLINE 0x4616
#define FBIOFILL_RECT  0x4618
#define FBIODRAW_BLIT  0x4619



struct video_info
{
    /*** card parameters ***/	
    int  	chip_id;
    int    	video_size;
    u_long	video_base;
    char   	*video_vbase;
    u_long 	mmio_base;
    char	*mmio_vbase;
    u_long  	vga_base;

    /*** mode ***/
    int    	video_bpp;
    int    	video_width;
    int    	video_height;
    u_int  	refresh_rate;
    u8     	status;
};


#ifdef __KERNEL__
extern struct video_info ivideo;
#endif


/*
 * drawing function --- be used by fb driver and fb console 
 * In R3000,  u_int: 32 bits, u_short: 16 bits, u_char: 8 bits.
 */

extern u_int   	sunplus_rgb2yuv (u_char r, u_char g, u_char b);
extern void     sunplus_setpixel (int x, int y, u_int yuv_color);
extern void     sunplus_fillrect (int sx, int sy, int width, int height, 
				  u_int yuv_color);
#endif


