//******************************************************************************
//
// Copyright (C) 2003 TrendChip Technologies Corp.
//
// Module name
// -----------
// TCIfSetQuery.h
//
// Abstract
// --------
// This file contains the set and query id definition with ZyNOS
//              
// Modification History
// --------------------
// Date   : 2003/5/27 Jason
// Rev.   : 001
// Modify : 
//
//*****************************************************************************
// $Id: TCIfSetQuery.h,v 1.5 2004/11/10 05:40:52 wheellenni Exp $
// $Log: TCIfSetQuery.h,v $
// Revision 1.1.1.1  2005/09/15 13:38:16  root
// BINOS
//
// Revision 1.5  2004/11/10 05:40:52  wheellenni
// wheellenni_931110
// compatible for the previous firmware
//
// Revision 1.4  2004/11/09 08:51:15  wheellenni
// 931109_wheellenni
// Add adsl2/adsl2plus to CI command "wan adsl opencmd xxxx"
// "adsl2" only support G.992.3	and "adsl2plus" support G.992.5
//
// Revision 1.3  2004/10/04 12:46:58  bright
// bright_931004
//
// Revision 1.2  2004/09/14 08:50:21  bright
// bright_930914
//
// Revision 1.1.1.1  2004/08/17 07:06:46  jeffrey
// Import framework code from V3.0.0.
//
// Revision 1.1.1.1  2003/08/22 06:19:18  jasonlin
// no message
//
//*****************************************************************************

#ifndef _TCIFSETQUERY_H
#define _TCIFSETQUERY_H

// ADSL Query ID list   Jason_920527
#define ADSL_QUERY_MODESET          0x0000              
#define ADSL_QUERY_MODE             0x0001
#define ADSL_QUERY_STATUS           0x0002
#define ADSL_QUERY_SW_VER           0x0003
#define ADSL_QUERY_VENDOR_ID        0x0004
#define ADSL_QUERY_NEAR_OP_DATA     0x0005
#define ADSL_QUERY_FAR_OP_DATA      0x0006
#define ADSL_QUERY_CH_OP_DATA       0x0007
#define ADSL_QUERY_DEFECT_CNT       0x0008
#define ADSL_QUERY_DEFECT           0x0009
#define ADSL_QUERY_NEAR_ITUID       0x000a
#define ADSL_QUERY_FAR_ITUID        0x000b
#define ADSL_QUERY_WATCHDOG         0x000c
#define ADSL_QUERY_AUTOLINK         0x000d
#define ADSL_QUERY_CELL_CNT         0x000e
#define ADSL_QUERY_TX_GAIN          0x000f
#define ADSL_QUERY_TX_FILTER_TYPE   0x0010
#define ADSL_QUERY_TX_MEDLEY_TONE   0x0011
#define ADSL_QUERY_SNR_OFFSET       0x0012
#define ADSL_QUERY_MIN_SNR_M        0x0013
#define ADSL_QUERY_FW_VER           0x0014
#define ADSL_QUERY_FW_REV           0x0015
#define ADSL_QUERY_TDM_FDM_VER      0x0016
#define ADSL_QUERY_RTS_LOG_SIZE_STR 0x0017
#define ADSL_QUERY_RTS_ADDR_STR     0x0018
#define ADSL_QUERY_RTS_LOG_SIZE     0x0019
#define ADSL_QUERY_HW_VER           0x001a
#define ADSL_QUERY_DGASP_CNTR		0x001b
#define ADSL_QUERY_SHOW_DIAG		0x001c
//#define ADSL_QUERY_CUSTOMER 		0x001d //bright_930914_1
#define ADSL_QUERY_BUILD_VERSION	0x001d //bright_930914_1

#define ADSL_SET_MODE_A43           0x1000
#define ADSL_SET_MODE_LITE          0x1001
#define ADSL_SET_MODE_MULTIMODE     0x1002
#define ADSL_SET_MODE_ANSI          0x1003
#define ADSL_SET_MODE_ADSL2         0x1004   // wheellenni_931110
#define ADSL_SET_MODE_ADSL2PLUS     0x1005   // wheellenni_931110
#define ADSL_SET_R_VENDOR_ID        0x1010
#define ADSL_SET_TX_GAIN            0x1011
#define ADSL_SET_TX_FILTER_TYPE     0x1012
#define ADSL_SET_TX_MEDLEY_TONE     0x1013
#define ADSL_SET_SNR_OFFSET         0x1014
#define ADSL_SET_MIN_SNR_M          0x1015
#define ADSL_SET_RTS_LOG_STOP       0x0016
#define ADSL_SET_RTS_LOG_RESUME     0x0017
#define ADSL_SET_RTS_LOG_FREE       0x0018
#define ADSL_SET_R_SOFT_RESET       0x0019
#define ADSL_SET_DMT_CLOSE          0x001a
#define ADSL_SET_INT_MASK0          0x001b
#define ADSL_SET_DGASP_CNTR_ZERO	0x001c		// Gilb_920901_1
#define ADSL_SET_CONSOLE_DATA		0x001d		// Jason_930315

#define ADSL_MODEM_STATE_DOWN       0x00
#define ADSL_MODEM_STATE_WAIT_INIT  0x08
#define ADSL_MODEM_STATE_INIT       0x10
#define ADSL_MODEM_STATE_UP         0x20

#define         ME_CMD_ADSL_SELFTEST1               0x01
#define         ME_CMD_ADSL_SELFTEST2               0x02
#define         ME_CMD_ADSL_OPEN                    0x03
#define         ME_CMD_ADSL_CLOSE                   0x04
/*
#define         ME_CMD_ADSL_ANSI                    0x05
#define         ME_CMD_ADSL_OPEN_GDMT  				0x06
#define 		ME_CMD_ADSL_OPEN_GLITE 				0x07
#define 		ME_CMD_ADSL_OPEN_MULTIMODE			0x08
//xzwang 041103
#define          ME_CMD_ADSL_OPEN_GDMT_GLITE              0x0B
*/
//Jason_930706
#define    		ME_CMD_ADSL2						0x09
#define    		ME_CMD_ADSL2PLUS					0x0A

//xzwang
#define         ME_CMD_ADSL_ANSI                    0x05
#define         ME_CMD_ADSL_OPEN_GDMT  				0x06
#define 		ME_CMD_ADSL_OPEN_GLITE 				0x07
#define 		ME_CMD_ADSL_OPEN_MULTIMODE		       0x08
#define         ME_CMD_ADSL_GDMT_OR_LITE                     0x91 //yyfeng_041015_14
#define         ME_CMD_ADSL_AUTO_GDMT_FIRST              0x92
#define         ME_CMD_ADSL_AUTO_T1413_FIRST             0x93

void TCIfQuery( unsigned short query_id, void *result1, void *result2 );
void TCIfSet( unsigned short set_id, void *value1, void *value2 );

#endif
