/*  
 * Definitions used to for ABH arbiter/decoder operation register
 *
 * Written by Robert Wu, Billion Co.
 * Support for TrendChip TC3162
 */

#ifndef __TC3162_ARB_H__ 
#define __TC3162_ARB_H__ 

#include <asm/addrspace.h>

#define TC3162_ARB_BASE		(KSEG1 + 0x1FB00000)
#define TC3162_AACS_REG		(TC3162_ARB_BASE + 0x0)
#define TC3162_ABEM_REG		(TC3162_ARB_BASE + 0x8)
#define TC3162_ABEA_REG		(TC3162_ARB_BASE + 0xC)
#define TC3162_DMB0_REG		(TC3162_ARB_BASE + 0x10)
#define TC3162_DMB1_REG		(TC3162_ARB_BASE + 0x14)
#define TC3162_DMB2_REG		(TC3162_ARB_BASE + 0x18)
#define TC3162_DMB3_REG		(TC3162_ARB_BASE + 0x1C)
#define TC3162_SMB0_REG		(TC3162_ARB_BASE + 0x20)
#define TC3162_SMB1_REG		(TC3162_ARB_BASE + 0x24)
#define TC3162_SMB2_REG		(TC3162_ARB_BASE + 0x28)
#define TC3162_SMB3_REG		(TC3162_ARB_BASE + 0x2C)
#define TC3162_SMB4_REG		(TC3162_ARB_BASE + 0x30)
#define TC3162_SMB5_REG		(TC3162_ARB_BASE + 0x34)
#define TC3162_PMC_REG		(TC3162_ARB_BASE + 0x80)
#define TC3162_DMT_Ctl_REG	(TC3162_ARB_BASE + 0x84)
#define TC3162_SYS_REG		(TC3162_ARB_BASE + 0x90)


#ifndef __ASSEMBLY__
#endif /* !__ASSEMBLY__ */

#endif /* __TC3162_ARB_H__ */

