#ifndef __MIPSNOMMU_VIRT_CONVERT__
#define __MIPSNOMMU_VIRT_CONVERT__

#ifdef __KERNEL__

#include <asm/addrspace.h>

#include <asm/page.h>

/*
 * Change virtual addresses to physical addresses and vv.
 * These are trivial on the 1:1 Linux/MIPS mapping
 */
extern inline unsigned long virt_to_phys(volatile void * address)
{
	//return (unsigned long)(address-PAGE_OFFSET) ;
	return PHYSADDR(address);
}

extern inline void * phys_to_virt(unsigned long address)
{
	//return (void *)(address +PAGE_OFFSET);
	return (void *)KSEG0ADDR(address);
}

/*
 * IO bus memory addresses are also 1:1 with the physical address
 */
extern inline unsigned long virt_to_bus(volatile void * address)
{
	//return (unsigned long)(address-PAGE_OFFSET) ;
	return PHYSADDR(address);
}

extern inline void * bus_to_virt(unsigned long address)
{
	//return (void *)(address +PAGE_OFFSET);
#ifdef CONFIG_TRENDCHIP_TC3162L2
	return (void *)KSEG1ADDR(address);
/* return (void *)KSEG0ADDR(address); */
#else
	return (void *)KSEG0ADDR(address);
#endif
	
}

#endif
#endif
