/****************************************************************************
 *
 *  Copyright (c) 2001 by LSI Logic Corporation, all rights reserved.
 *
 *                         LSI Logic confidential
 *  The information contained herein is proprietary of LSI Logic Corporation.
 *
 *  This software is provided "as is" without any express or implied warranty.
 *  LSI Logic disclaims all representations and warranties with regard to
 *  this software, including all implied warranties of merchantability and
 *  fitness for a particular purpose. In no event shall LSI Logic be liable
 *  for any special, indirect or consequential damages or any damages
 *  whatsoever resulting from loss of use, data or profits, whether in an
 *  action of contract, negligence or other tortious act or omission,
 *  arising out of or in connection with the use or performance of this
 *  software.
 *
 *  File Description:
 *  This file contains the definitions of the types for the 'apps' which
 *  includes the bootrom, bootloader, and makflash
 *
 ****************************************************************************/

#ifndef _APPS_TYPES_H
#define _APPS_TYPES_H

/****************************************************************************
 * includes
 ****************************************************************************/

/****************************************************************************
 * definitions (literals)
 ****************************************************************************/

/* 'PUBLIC' & 'GLOBAL' don't do anything but are used to emphasise the      */
/* scope of functions and variables.                                        */
#define PUBLIC
#define GLOBAL

#define PRIVATE                     static
#define EXTERNAL                    extern
 
/****************************************************************************
 * definitions (types)
 ****************************************************************************/

#ifdef __KERNEL__
#include <asm/types.h>
#else
typedef char                        __s8;
typedef unsigned char               __u8;
typedef short                       __s16;
typedef unsigned short              __u16;
typedef int                         __s32;
typedef unsigned int                __u32;
#endif /* ndef _I386_TYPES_H */

typedef enum { _FALSE = 0, _TRUE = 1} TrueFalseFlag;
typedef TrueFalseFlag               __bool;

/****************************************************************************
 * definitions (macros)
 ****************************************************************************/

#define BYTE_SIZE                   (sizeof(__u8))
#define HALF_SIZE                   (sizeof(__u16))
#define WORD_SIZE                   (sizeof(__u32))
#define NIBBLES_PER_BYTE            2

#ifndef NULL
#define NULL                        ((void *)0)
#endif

/****************************************************************************
 * variable definitions
 ****************************************************************************/

/****************************************************************************
 * function prototypes
 ****************************************************************************/


#endif /* _APPS_TYPES_H */


/* apps_types.h */

