#ifndef _TC3162DMTCTRL_
#define _TC3162DMTCTRL_


enum {
 SET_PID=0,
 DMT_LINESTATUS,
 DMT_LINERATE,
 DMT_COUNTER,
 DMT_MODE,
 DMT_SHUTDOWN,
 DMT_RESET,
 DMT_LINEDATAN,
 DMT_LINEDATAF
};
//**************************************************************************
// Type Definitions
//**************************************************************************

// Return status values
typedef enum DmtCtrlStatus
{
    DmtCtrl_STATUS_SUCCESS = 0,
    DmtCtrl_STATUS_ERROR
} DmtCtrl_STATUS;

// ADSL_LINK_STATE
#define ADSL_DOWN 0x00
#define ADSL_TRAINING_1 0x08
#define ADSL_TRAINING_2 0x10
#define ADSL_UP 0x20


//DMT capability

#define  QueryMode 101
#define  GDMT 0x1000
#define  GLite 0x1001
#define  Multi 0x1002
#define  ANSI  0x1003
#define  ADSL2 0x1004
#define  ADSL2Plus 0x1005
#define  ADSL1_MultiMode 0x1006

//DMT Operational Mode
#define T1413_Mode 5
#define GDMT_Mode 6
#define GLite_Mode 7
#define ADSL2_Mode 9
#define ADSL2Plus_Mode 10

//DMT Annex Type

#define ANNEX_A 1
#define ANNEX_B 2
#define ANNEX_C 3
#define ANNEX_I 4
#define ANNEX_J 5
#define ANNEX_L 6
#define ANNEX_M 7
#define ANNEX_BJM 8
#define ANNEX_AIJLM 9
//DMT Rts Dump ON/OFF
#define DMTRTSON 99
#define DMTRTSOFF 101


/* Typedefs. */
typedef struct {
unsigned short	actualBitrateNearInt;// Near end rate of interleave path
unsigned short	actualBitrateNearFast;// Near end rate of fast path
unsigned short	actualBitrateFarInt;	//Far end rate of interleave path
unsigned short	actualBitrateFarFast;//Far end rate of fast path
} DMTCTRL_CONNECTION_INFO;

typedef struct {
unsigned short          FecNotInterleaved; // Fast path FEC error
unsigned short          FecInterleaved; // Interleave path FEC error
unsigned short          CrcNotInterleaved; // Fast path FEC error
unsigned short          CrcInterleaved; // Interleave path FEC error
unsigned short          HecNotInterleaved; // Fast path HEC error
unsigned short          HecInterleaved;//Interleave path HEC error
} DEFECT_CTR;

typedef struct {
        DEFECT_CTR     near_end;	// Near end(ATUR)
        DEFECT_CTR     far_end;		// Far end(ATUC)
} DMTCTRL_LINE_INFO;


typedef struct {
unsigned short	relCapacityOccupationDnstr;
short    noiseMarginDnstr; // Downstream Noise Margin (x10)
short    outputPowerUpstr;
unsigned short    attenuationDnstr;
} DMTCTRL_LINE_DATA_N_INFO;

typedef struct {
unsigned short    relCapacityOccupationUpstr;
short    noiseMarginUpstr; // Upstream Noise Margin (x10)
short    outputPowerDnstr;
unsigned short    attenuationUpstr;
unsigned char     carrierLoad[128];
} DMTCTRL_LINE_DATA_F_INFO_ADSL;

typedef struct {
unsigned short    relCapacityOccupationUpstr;
short    noiseMarginUpstr; // Upstream Noise Margin (x10)
short    outputPowerDnstr;
unsigned short    attenuationUpstr;
unsigned char     carrierLoad[256];
} DMTCTRL_LINE_DATA_F_INFO_ADSL2P;


typedef struct
{
    DmtCtrl_STATUS DmtioctlStatus;
} DMTCTRL_STATUS_ONLY, *PDMTCTRL_STATUS_ONLY;

typedef struct
{
  unsigned char  dmt_status;
	// Sam add for determine processor type 
  unsigned char  tc_processor_type;
	// End Sam add
} DMTCTRL_DMT_INFO, *PDMTCTRL_DMT_INFO;


typedef struct
{
  unsigned char  major;
  unsigned char  minor;
  unsigned char  fw_ver_r;
  unsigned char  fw_ver_p;
  unsigned char  fw_rev;
  unsigned char  tdm_ver;
  unsigned char  fdm_ver;
  unsigned char  annex_afe;
  unsigned char  b_ver;   
} DMTCTRL_DMT_VERSION;


typedef struct
{
  unsigned long showtime_stamp;
  unsigned long currenttime_stamp;
  unsigned char dmtstatus;
} DMTCTRL_ADSL_UPTIME;

/* Defines. */
#define DMTCTRL_MAJOR            208 /* arbitrary unused value */



                   
#define DMTIOCTL_GET_DMT_INFO _IOR(DMTCTRL_MAJOR, 0, DMTCTRL_DMT_INFO)
#define DMTIOCTL_GET_CONNECTION_INFO _IOR(DMTCTRL_MAJOR, 1, DMTCTRL_CONNECTION_INFO)
#define DMTIOCTL_GET_LINE_INFO _IOR(DMTCTRL_MAJOR, 2, DMTCTRL_LINE_INFO)
#define DMTIOCTL_SET_DMTRESET _IOWR(DMTCTRL_MAJOR, 3, unsigned char)
#define DMTIOCTL_SET_DMTCLOSE _IOWR(DMTCTRL_MAJOR, 4, unsigned char)
#define DMTIOCTL_GET_LINE_OPINFO _IOR(DMTCTRL_MAJOR, 5, unsigned char)
#define DMTIOCTL_SET_LINE_OPMODE _IOWR(DMTCTRL_MAJOR, 6, unsigned int)
#define DMTIOCTL_GET_LINE_DATA_N_INFO _IOR(DMTCTRL_MAJOR, 7, DMTCTRL_LINE_DATA_N_INFO)
#define DMTIOCTL_GET_LINE_DATA_F_INFO_ADSL _IOR(DMTCTRL_MAJOR, 8, DMTCTRL_LINE_DATA_F_INFO_ADSL)
#define DMTIOCTL_GET_DMT_FW_VERSION _IOR(DMTCTRL_MAJOR, 9, DMTCTRL_DMT_VERSION)
#define DMTIOCTL_GET_LINE_DATA_F_INFO_ADSL2P _IOR(DMTCTRL_MAJOR, 10, DMTCTRL_LINE_DATA_F_INFO_ADSL2P)
#define DMTIOCTL_SET_PID _IOWR(DMTCTRL_MAJOR, 11, unsigned int)
#define DMTIOCTL_SET_ANNEX _IOWR(DMTCTRL_MAJOR, 12, unsigned char)
#define DMTIOCTL_GET_LINE_UPTIME _IOR(DMTCTRL_MAJOR, 13, DMTCTRL_ADSL_UPTIME)
#define DMTIOCTL_SET_RTS_DBG _IOWR(DMTCTRL_MAJOR, 14, unsigned char)
#define DMTIOCTL_SET_PPPOE _IOWR(DMTCTRL_MAJOR, 15, unsigned int)

#define MAX_DMTCTRL_IOCTL_COMMANDS   16

#define ENABLE 1
#define DISABLE 0

#define MODULE_VERSION "1.0"
#define MODULE_NAME "dmtctrl"

#endif 
