/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attempt
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	rtmp_data.c

	Abstract:
	Data path subroutines

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	John        Aug/17/04       major modification for RT2561/2661
*/

#include "rt_config.h"

// Sam add debug
extern unsigned char modem_status;
#define MEASURE_TX_TIME 0
#if MEASURE_TX_TIME
unsigned long tx_time_sum=0;
unsigned long tx_time_sum1=0;
int tx_measure_count=0;
int tx_measure_count1=0;
#endif
// end Sam add

#ifdef RTL865X_SOC
static inline BOOLEAN RTMPBridgeToWdsAndWirelessSta(
    IN  PRTMP_ADAPTER   pAdapter,
    IN  PUCHAR          pHeader802_3,
    IN  UINT            HdrLen,
    IN  PUCHAR          pData,
    IN  UINT            DataLen,
    IN  UINT            FromWhichBSSID);

static inline BOOLEAN RTMPCheckDHCPFrame(
	IN	PRTMP_ADAPTER	pAd, 
	IN  struct sk_buff	*pSkb);

static inline NDIS_STATUS RTMPCloneNdisPacket(
    IN  PRTMP_ADAPTER   pAdapter,
    IN  struct sk_buff  *pInSkb,
    OUT struct sk_buff  **ppOutSkb);

static void rtl865x_rx(PRTMP_ADAPTER pAd, struct sk_buff *skb);

//#define netif_rx	rtl865x_rx
#endif /* RTL865X_SOC */


UCHAR	SNAP_802_1H[] = {0xaa, 0xaa, 0x03, 0x00, 0x00, 0x00};
UCHAR	SNAP_BRIDGE_TUNNEL[] = {0xaa, 0xaa, 0x03, 0x00, 0x00, 0xf8};
// Add Cisco Aironet SNAP heade for CCX2 support
UCHAR	SNAP_AIRONET[] = {0xaa, 0xaa, 0x03, 0x00, 0x40, 0x96, 0x00, 0x00};

UCHAR	EAPOL[]			= {0x88, 0x8E};
UCHAR	IPX[]			= {0x81, 0x37};
UCHAR	APPLE_TALK[]	= {0x80, 0xF3};

//static  UCHAR   TPID[]			= {0x81, 0x00};

static  UCHAR   RateIdToPlcpSignal[12] = { 
	 0, /* RATE_1 */    1, /* RATE_2 */     2, /* RATE_5_5 */   3, /* RATE_11 */    // see BBP spec
	11, /* RATE_6 */   15, /* RATE_9 */    10, /* RATE_12 */   14, /* RATE_18 */    // see IEEE802.11a-1999 p.14
	 9, /* RATE_24 */  13, /* RATE_36 */    8, /* RATE_48 */   12  /* RATE_54 */ }; // see IEEE802.11a-1999 p.14

// Macro for rx indication
VOID REPORT_ETHERNET_FRAME_TO_LLC(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			p8023hdr,
	IN	PUCHAR			pData,
	IN	ULONG			DataSize,
	IN	struct net_device	*net_dev)
{
	struct sk_buff	*pSkb;

    if ((pSkb = __dev_alloc_skb(DataSize + LENGTH_802_3 + 2, MEM_ALLOC_FLAG)) != NULL)
    {
        	pSkb->dev = net_dev;
        	skb_reserve(pSkb, 2);	// 16 byte align the IP header
        	memcpy(skb_put(pSkb, LENGTH_802_3), p8023hdr, LENGTH_802_3);
        	memcpy(skb_put(pSkb, DataSize), pData, DataSize);
        	pSkb->protocol = eth_type_trans(pSkb, net_dev);
#ifdef RTL865X_SOC
	        skb_push(pSkb, net_dev->hard_header_len);
			rtl865x_rx(pAd, pSkb);
#else
        	netif_rx(pSkb);
#endif
        	pAd->net_dev->last_rx = jiffies;
        	pAd->stats.rx_packets++;
    }
}

#ifdef RTL865X_SOC
// Macro for rx indication
VOID REPORT_ETHERNET_FRAME_TO_LLC_RTL865X(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			p8023hdr,
	IN	PUCHAR			pData,
	IN	ULONG			DataSize,
	IN	struct net_device	*net_dev)
{
	struct sk_buff	*pSkb;

    if ((pSkb = __dev_alloc_skb(DataSize + LENGTH_802_3 + 2, MEM_ALLOC_FLAG)) != NULL)
    {
        	pSkb->dev = net_dev;
        	skb_reserve(pSkb, 2);	// 16 byte align the IP header
        	memcpy(skb_put(pSkb, LENGTH_802_3), p8023hdr, LENGTH_802_3);
        	memcpy(skb_put(pSkb, DataSize), pData, DataSize);
        	pSkb->protocol = eth_type_trans(pSkb, net_dev);
        	netif_rx(pSkb);
        	pAd->net_dev->last_rx = jiffies;
        	pAd->stats.rx_packets++;
    }
}
#endif

// Macro for rx indication
VOID REPORT_ETHERNET_FRAME_TO_LLC_WITH_NON_COPY(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			p8023hdr,
	IN	PUCHAR			pData,
	IN	ULONG			DataSize,
	IN	struct net_device	*net_dev)
{
#ifdef NONCOPY_RX 
//   	PRXD_STRUC		pRxD;
	struct sk_buff	*pRxSkb = pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.pSkb;
	struct sk_buff  *pSkb = NULL;
	
	// allocate a new one and update RxD
    if ((pSkb = __dev_alloc_skb(RX_DMA_BUFFER_SIZE, MEM_ALLOC_FLAG)) != NULL)
    {    
	    pRxSkb->dev = net_dev;
	    pRxSkb->data = pData;
    	pRxSkb->len = DataSize;
	    pRxSkb->tail = pRxSkb->data + pRxSkb->len;
	    memcpy(skb_push(pRxSkb, LENGTH_802_3), p8023hdr, LENGTH_802_3);

	    pRxSkb->protocol = eth_type_trans(pRxSkb, net_dev);
#ifdef RTL865X_SOC
	    skb_push(pRxSkb, net_dev->hard_header_len);
		rtl865x_rx(pAd, pRxSkb);
#else
		netif_rx(pRxSkb);
#endif
		pAd->net_dev->last_rx = jiffies;
		pAd->stats.rx_packets++;
    		
	    RTMP_SET_PACKET_SOURCE(pSkb, PKTSRC_DRIVER);
	    pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocSize	= RX_DMA_BUFFER_SIZE;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.pSkb		= pSkb;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa		= pSkb->data;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa		= pci_map_single(pAd->pPci_Dev, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocSize, PCI_DMA_FROMDEVICE);

		// Write RxD buffer address & allocated buffer length
		//pRxD = (PRXD_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
		//pRxD->BufPhyAddr = pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa;
    } else {
		RTMP_SET_PACKET_SOURCE(pRxSkb, PKTSRC_DRIVER);
	    pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocSize	= RX_DMA_BUFFER_SIZE;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.pSkb		= pRxSkb;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa		= pRxSkb->data;
		pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa		= pci_map_single(pAd->pPci_Dev, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocSize, PCI_DMA_FROMDEVICE);

		// Write RxD buffer address & allocated buffer length
		//pRxD = (PRXD_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
		//pRxD->BufPhyAddr = pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa;    	
    }
#else
	struct sk_buff	*pSkb;

    if ((pSkb = __dev_alloc_skb(DataSize + LENGTH_802_3 + 2, MEM_ALLOC_FLAG)) != NULL)
    {
        	pSkb->dev = net_dev;
        	skb_reserve(pSkb, 2);	// 16 byte align the IP header
        	memcpy(skb_put(pSkb, LENGTH_802_3), p8023hdr, LENGTH_802_3);
        	memcpy(skb_put(pSkb, DataSize), pData, DataSize);
        	pSkb->protocol = eth_type_trans(pSkb, net_dev);
#ifdef RTL865X_SOC
	        skb_push(pSkb, net_dev->hard_header_len);
			rtl865x_rx(pAd, pSkb);
#else
        	netif_rx(pSkb);
#endif
        	pAd->net_dev->last_rx = jiffies;
        	pAd->stats.rx_packets++;
    }
#endif
}

// Enqueue this frame to MLME engine
// We need to enqueue the whole frame because MLME need to pass data type
// information from 802.11 header
#define REPORT_MGMT_FRAME_TO_MLME(_pAd, _pFrame, _FrameSize, _Rssi, _Offset)                     \
{                                                                                       \
    ULONG High32TSF, Low32TSF;                                                          \
	RTMP_IO_READ32(_pAd, TXRX_CSR13, &High32TSF);                                       \
	RTMP_IO_READ32(_pAd, TXRX_CSR12, &Low32TSF);                                        \
	MlmeEnqueueForRecv(_pAd, High32TSF,	Low32TSF, (UCHAR)_Rssi, _FrameSize, _pFrame, _Offset);   \
}

/*
	========================================================================

	Routine	Description:
		Process	RxDone interrupt, running in DPC level

	Arguments:
		pAdapter	Pointer	to our adapter

	Return Value:
		None

	Note:
		This routine has to	maintain Rx	ring read pointer.
		Need to consider QOS DATA format when converting to 802.3
	========================================================================
*/
VOID	RTMPHandleRxDoneInterrupt(
	IN	PRTMP_ADAPTER	pAd)
{
// Sam add
#ifndef NOT_CHANGE_ENDIAN_2
    PRXD_STRUC		pRxD;
#ifdef BIG_ENDIAN
    PRXD_STRUC      	pDestRxD;
    RXD_STRUC       	RxD;
#endif
#else
    PRXD_STRUC		pRxD;
    PRXD_BIG_STRUC	pRxBD,pDestRxD;
    RXD_STRUC		RxD;	
    //int rx_int_count = 0;
#endif // End Sam add
	PHEADER_802_11				pHeader;
	PUCHAR						pData;
	USHORT						DataSize, Msdu2Size;
	PUCHAR						pDA, pSA;
	UCHAR						Header802_3[14];
	INT							Count, apidx = MAIN_MBSSID, i;
	MAC_TABLE_ENTRY				*pEntry = NULL;
    NDIS_802_11_PRIVACY_FILTER	Privacy;
    WPA_STATE					WpaState;
    struct net_device			*net_dev = pAd->net_dev;
    BOOLEAN         			bWdsPacket = FALSE;
    UCHAR                       Offset = 0;
    ULONG						IrqFlags;

    // Make sure Rx ring resource won't be used by other threads
#ifndef TC_NO_SPIN_LOCK // Sam add
    spin_lock_irqsave(&pAd->RxRingLock, IrqFlags);
#endif

    DBGPRINT(RT_DEBUG_INFO, "RTMPHandleRxDoneInterrupt --->\n");

    for (Count=0; Count<MAX_RX_PROCESS; Count++)
 // Sam    for (Count=0; Count<4; Count++)
    {
	
#ifndef NOT_CHANGE_ENDIAN_2 // Sam add
#ifndef BIG_ENDIAN

        // Point to Rx indexed rx ring descriptor
        pRxD = (PRXD_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
#else
        pDestRxD = (PRXD_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
        RxD = *pDestRxD;
        pRxD = &RxD;
        RTMPDescriptorEndianChange((PUCHAR)pRxD, TYPE_RXD);
#endif
#else
	#if 1
	if(Count == 1) 
	//if((modem_status == 0x08 || modem_status == 0x10) && Count == 1)	
	if(modem_status == 0x08 || modem_status == 0x10)
	{
//		printk("modem_status low\n");
		break;
	}
	//else rx_int_count++;
	
	#endif

        pDestRxD = (PRXD_BIG_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
	pRxD = (PRXD_STRUC) pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].AllocVa;
        RxD = *pRxD;
	pRxD = &RxD;
	pRxBD = (PRXD_BIG_STRUC)pRxD;
	pRxBD -> ulword0 = SWAP32(pRxBD -> ulword0);
	pRxBD -> ulword1 = SWAP32(pRxBD -> ulword1);
        // RTMPDescriptorEndianChange((PUCHAR)pRxD, TYPE_RXD);
#endif // End Sam add		        
        // In case of false alarm or processed at last instance
        if (pRxD->Owner != DESC_OWN_HOST)
            break;

        // beak out this "do {...} while FALSE" loop whenever RX frame error without indicating 
        // to upper layer
        do
        {
        // Sam M	pci_unmap_single(pAd->pPci_Dev, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa, pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocSize, PCI_DMA_FROMDEVICE);
	// Sam add debug
	// printk("After pci_unmap_single address is %08x\n",pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa); //0x80xxxxxx
	// End Sam add
            pData   = (PUCHAR) (pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa);
            ///pData   = (PUCHAR)(KSEG1ADDR( pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocVa ));
            pHeader = (PHEADER_802_11) pData;

#ifdef BIG_ENDIAN
	        RTMPFrameEndianChange(pAd, (PUCHAR)pHeader, DIR_READ, FALSE);
#endif
            // Increase Total receive byte counter after real data received no mater any error or not
            pAd->RalinkCounters.ReceivedByteCount +=  pRxD->DataByteCnt;
            pAd->RalinkCounters.RxCount ++;
            
            // Check for all RxD errors
            if (RTMPCheckRxError(pRxD) != NDIS_STATUS_SUCCESS)
            {
                if (pRxD->U2M && pRxD->CipherErr)
                {
                	if ((pRxD->CipherAlg == CIPHER_TKIP) && (pRxD->CipherErr == 2))	//MIC error
                	{
                		pEntry = PACInquiry(pAd, pHeader->Addr2, &Privacy, &WpaState);

                		if (pEntry)
                		{
                			HandleCounterMeasure(pAd, pEntry);
                		}
                	}
                    DBGPRINT(RT_DEBUG_ERROR, "Rx u2me DATA Cipger Err(len=%d,Alg=%d,keyidx=%d,ciphererr=%d)\n", 
                    	pRxD->DataByteCnt, pRxD->CipherAlg, pRxD->KeyIndex, pRxD->CipherErr);
                }
                
                pAd->Counters8023.RxErrors++;
                break;  // give up this frame
            }			  

            pAd->WlanCounters.ReceivedFragmentCount++;

            // All frames to AP are directed except probe_req. IEEE 802.11/1999 - p.463
            // Do this before checking "duplicate frame".
            // 2003-08-20 accept BEACON to decide if OLBC (Overlapping Legacy BSS Condition) happens
            // TODO: consider move this code to be inside "APCheckRxError()"
            if (pRxD->U2M)
            {
                if (pHeader->FC.Type == BTYPE_DATA)
                {
                    CHAR RealRssi;
                    
                    RealRssi = ConvertToRssi(pAd, (UCHAR)pRxD->PlcpRssi, RSSI_NO_1);
                    pAd->PortCfg.LastRssi  = RealRssi + pAd->BbpRssiToDbmDelta;
                    pAd->PortCfg.AvgRssiX8  = (pAd->PortCfg.AvgRssiX8 - pAd->PortCfg.AvgRssi) + pAd->PortCfg.LastRssi;
                    pAd->PortCfg.AvgRssi = pAd->PortCfg.AvgRssiX8 >> 3;
                    
                    if ((pAd->RfIcType == RFIC_5325) || (pAd->RfIcType == RFIC_2529))
                    {
                    	pAd->PortCfg.LastRssi2  = ConvertToRssi(pAd, (UCHAR)pRxD->PlcpSignal, RSSI_NO_2) + pAd->BbpRssiToDbmDelta;
                    }
                    
                    // Gather PowerSave information from all valid DATA frames. IEEE 802.11/1999 p.461
                    if (pHeader->FC.PwrMgmt)
                        PsIndicate(pAd, pHeader->Addr2, pAd->PortCfg.LastRssi, PWR_SAVE);
                    else
                        PsIndicate(pAd, pHeader->Addr2, pAd->PortCfg.LastRssi, PWR_ACTIVE);
                }
            
                // ignore all CNTL frames except PS-POLL
                else if ((pHeader->FC.Type == BTYPE_CNTL) && (pHeader->FC.SubType != SUBTYPE_PS_POLL))
                    break;
            }
            else 
            { 
#ifdef RALINK_ATE
				if(pAd->ate.Mode != ATE_APSTART)
				{
	            	CHAR RealRssi;
	                    
	                RealRssi = ConvertToRssi(pAd, (UCHAR)pRxD->PlcpRssi, RSSI_NO_1);
	                pAd->PortCfg.LastRssi  = RealRssi + pAd->BbpRssiToDbmDelta;
	                pAd->PortCfg.AvgRssiX8  = (pAd->PortCfg.AvgRssiX8 - pAd->PortCfg.AvgRssi) + pAd->PortCfg.LastRssi;
	                pAd->PortCfg.AvgRssi = pAd->PortCfg.AvgRssiX8 >> 3;

	                if ((pAd->RfIcType == RFIC_5325) || (pAd->RfIcType == RFIC_2529))
                    {
                    	pAd->PortCfg.LastRssi2  = ConvertToRssi(pAd, (UCHAR)pRxD->PlcpSignal, RSSI_NO_2) + pAd->BbpRssiToDbmDelta;
                    }
				}
#endif	// RALINK_ATE
                    
                if ((pHeader->FC.Type == BTYPE_MGMT) && 
                    ((pHeader->FC.SubType == SUBTYPE_BEACON) || (pHeader->FC.SubType == SUBTYPE_PROBE_REQ)))
                    ;
                else
                    break; // give up this frame
            }

            // DUPLICATE FRAME CHECK:
            //   Check retry bit. If this bit is on, search the cache with SA & sequence
            //   as index, if matched, discard this frame, otherwise, update cache
            //   This check only apply to unicast data & management frames
            if ((pRxD->U2M) && 
                (pHeader->FC.Retry) &&
                (RTMPSearchTupleCache(pAd, pHeader) == TRUE))
            {
                DBGPRINT(RT_DEBUG_INFO,"RxDone- drop DUPLICATE frame(len=%d)\n",pRxD->DataByteCnt);
                pAd->WlanCounters.FrameDuplicateCount++;
                break; // give up this frame
            }
            else    // Update Tuple Cache
                RTMPUpdateTupleCache(pAd, pHeader);

            pAd->Counters8023.GoodReceives++;

#ifdef RALINK_ATE
			if(pAd->ate.Mode != ATE_APSTART)
			{
				break;
			}
#endif

            //
            // CASE I. receive a DATA frame
            //
            if (pHeader->FC.Type == BTYPE_DATA)
            {
            	if (pHeader->FC.ToDs == 0)
                    break; // give up this frame

                // Drop NULL, CF-ACK(no data), CF-POLL(no data), and CF-ACK+CF-POLL(no data) data frame
                if (pHeader->FC.SubType & 0x04) // bit 2 : no DATA
                    break; // give up this frame

                pEntry = PACInquiry(pAd, pHeader->Addr2, &Privacy, &WpaState);
				if(pEntry)
				{
				    apidx = pEntry->ApIdx;
				    net_dev = pAd->PortCfg.MBSSID[apidx].MSSIDDev;
				    DBGPRINT(RT_DEBUG_INFO, "Rcv packet to IF(ra%d)\n", apidx);
				}
				
                // check if Class2 or 3 error
                if ((pHeader->FC.FrDs == 0) && (CheckClass2Class3Error(pAd, pHeader, pEntry)))
                    break; // give up this frame

                if(pAd->PortCfg.MBSSID[apidx].BANClass3Data == TRUE)
                    break; // give up this frame

                if ((pEntry) && (pAd->PortCfg.bEnableHSCounter))
                {
                    pEntry->HSCounter.TotalRxByteCount += pRxD->DataByteCnt;
                    pEntry->HSCounter.LastDataPacketTime = jiffies;
                }

                // pData : Pointer skip the first 24 bytes, 802.11 HEADER
                if ((pHeader->FC.FrDs == 1) && (pHeader->FC.ToDs == 1))
                {
                    pData += LENGTH_802_11_WITH_ADDR4;
                    DataSize = (USHORT)pRxD->DataByteCnt - LENGTH_802_11_WITH_ADDR4;
                }
                else
                {
                    pData += LENGTH_802_11;
                    DataSize = (USHORT)pRxD->DataByteCnt - LENGTH_802_11;
                }

                // remove the 2 extra QOS CNTL bytes
                if (pHeader->FC.SubType & 0x08)
                {
                    pData += 2;
                    DataSize -= 2;
                    Offset += 2;
                }
                    
                // remove the 2 extra AGGREGATION bytes
                Msdu2Size = 0;
                if (pHeader->FC.Order)
                {
                    Msdu2Size = *pData + (*(pData+1) << 8);
                    if ((Msdu2Size <= 1536) && (Msdu2Size < DataSize))
                    {
                        pData += 2;
                        DataSize -= 2;
                    }
                    else
                        Msdu2Size = 0;
                }
                    
                //
                // handle WDS
                //
#if 1 
                bWdsPacket = FALSE;
                if ((pHeader->FC.FrDs == 1) && (pHeader->FC.ToDs == 1))
                {
					if (pAd->WdsTab.Mode != WDS_DISABLE_MODE)
					{
						for (i = 0; i < MAX_WDS_ENTRY; i++)
						{
							if ((pAd->WdsTab.WdsEntry[i].Valid == TRUE) && (MAC_ADDR_EQUAL(&pAd->WdsTab.WdsEntry[i].WdsAddr, &pHeader->Addr2)))
							{
								net_dev = pAd->WdsTab.WdsEntry[i].dev;
								bWdsPacket = TRUE;
								DBGPRINT(RT_DEBUG_INFO, "WDS packet from (%d)!!!\n", i);
								break;
							}
						}
						if (i == MAX_WDS_ENTRY)
						{
							DBGPRINT(RT_DEBUG_WARN, "WDS packet, but not our WDS group, give it up!!!\n");
							break;
						}
					}
                }

                // WDS packet's DA & SA is not the same
                if (bWdsPacket)
                {
                    Privacy = Ndis802_11PrivFilterAcceptAll; // no 802.1x PAC for WDS frame
                    pDA = pHeader->Addr3;
                    pSA = (PUCHAR)pHeader + sizeof(HEADER_802_11);
                }
                else
#endif // Sam 
                {
                    pDA = pHeader->Addr3;
                    pSA = pHeader->Addr2;
                }

                // Determine the destination of 802.1x frame (WPA state machine or upper layer TCPIP)
                // drop all non-802.1x DATA frame before this client's Port-Access-Control is secured
                if (Privacy != Ndis802_11PrivFilterAcceptAll)
                {
                    //needs to handle fragmented EAP packets specially
					if (pHeader->Frag == 0)     // Frag. Number is 0 : First frag or only one pkt
                    {
						// One & The only fragment
                    	if (pHeader->FC.MoreFrag == FALSE)
		                {
		                	if (!RTMPCheckWPAframe(pAd, (PUCHAR)pHeader, pRxD->DataByteCnt, Offset))
		                		break;

		                	if ((pEntry) && (pEntry->WpaState < AS_INITPMK) && 
		                		((pEntry->AuthMode == Ndis802_11AuthModeWPA) || (pEntry->AuthMode == Ndis802_11AuthModeWPA2) || pAd->PortCfg.MBSSID[apidx].IEEE8021X == TRUE))
		                	{
		                		UCHAR           LLC_Len[2];
		                		
		                		NdisMoveMemory(LLC_Len, EAPOL, 2);
		                		MAKE_802_3_HEADER(Header802_3, pDA, pSA, ((PUCHAR) LLC_Len));
#ifdef RTL865X_SOC
		                		REPORT_ETHERNET_FRAME_TO_LLC_RTL865X(pAd, Header802_3, pData, DataSize, net_dev);						
#else
		                		REPORT_ETHERNET_FRAME_TO_LLC(pAd, Header802_3, pData, DataSize, net_dev);
#endif
		                		DBGPRINT(RT_DEBUG_OFF, "Apidx=%d,pDA %x %x %x %x %x %x,pSA %x %x %x %x %x %x,pData %x %x %x %x %x \n",apidx,*pDA,*(pDA+1),*(pDA+2),*(pDA+3),*(pDA+4),*(pDA+5),
		                			*pSA,*(pSA+1),*(pSA+2),*(pSA+3),*(pSA+4),*(pSA+5),*pData,*(pData+1),*(pData+2),*(pData+3),*(pData+4));
		                	}
		                	else
		                	{
		                		REPORT_MGMT_FRAME_TO_MLME(pAd, pHeader, pRxD->DataByteCnt, pRxD->PlcpRssi, Offset);
		                	}

		                }
                    	else	//the first pkt of fragment, record it.
                    	{
                    		UCHAR           LLC_Len[2];
                    		
                    		DBGPRINT(RT_DEBUG_OFF, "Apidx=%d,Frag.0 (len:%d):pData %x %x %x %x %x \n",apidx,DataSize,*pData,*(pData+1),*(pData+2),*(pData+3),*(pData+4));
                    		NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                                NdisZeroMemory(Header802_3, LENGTH_802_3);
                    		
                    		// create 802.3 MAC header
                                NdisMoveMemory(LLC_Len, EAPOL, 2);
                                MAKE_802_3_HEADER(Header802_3, pDA, pSA, ((PUCHAR) LLC_Len));

                                NdisMoveMemory(&pAd->FragFrame.Buffer[LENGTH_802_3], pData, DataSize);
                                NdisMoveMemory(pAd->FragFrame.Header802_3, Header802_3, LENGTH_802_3);
                                NdisZeroMemory(Header802_3, LENGTH_802_3);
                                pAd->FragFrame.RxSize   = DataSize;
                                pAd->FragFrame.Sequence = pHeader->Sequence;
                                pAd->FragFrame.LastFrag = pHeader->Frag;       // Should be 0
			}
					}
 
		else	//Middle & End of fragment
                    {
                    	// Fragment is not the same sequence or out of fragment number order 
                    	if ((pHeader->Sequence != pAd->FragFrame.Sequence) ||
                        	(pHeader->Frag != (pAd->FragFrame.LastFrag + 1)))
                    	{
                        	// Fragment is not the same sequence or out of fragment number order
                        	// Clear Fragment frame contents
                        	NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                        	DBGPRINT(RT_DEBUG_ERROR, "Fragment is not the same sequence or out of fragment number order.\n");
                        	break; // give up this frame
                    	}   
                    	else if ((pAd->FragFrame.RxSize + DataSize) > MAX_FRAME_SIZE)
                    	{
                        	// Fragment frame is too large, it exeeds the maximum frame size.
                        	// Clear Fragment frame contents
                        	NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                        	DBGPRINT(RT_DEBUG_ERROR, "Fragment frame is too large, it exeeds the maximum frame size.\n");
                        	break; // give up this frame
                    	}
                    	// concatenate this fragment into the re-assembly buffer
                    	DBGPRINT(RT_DEBUG_OFF, "Apidx=%d,Frag.%d (len:%d):pData %x %x %x %x %x \n",apidx,pHeader->Frag,DataSize,*pData,*(pData+1),*(pData+2),*(pData+3),*(pData+4));
                        NdisMoveMemory(&pAd->FragFrame.Buffer[LENGTH_802_3 + pAd->FragFrame.RxSize], pData, DataSize);
                    	pAd->FragFrame.RxSize  += DataSize;
                    	pAd->FragFrame.LastFrag = pHeader->Frag;       // Update fragment number
                                
						// Last fragment
                    	if (pHeader->FC.MoreFrag == FALSE)                    	
                        {
                        	BOOLEAN CheckPktSanity = TRUE;
                        	
                        	if(pAd->FragFrame.RxSize < (LENGTH_802_1_H + LENGTH_EAPOL_H))
                        	{
                        		CheckPktSanity = FALSE;
                        		DBGPRINT(RT_DEBUG_ERROR, "Total pkts size is too small.\n");
							}	
                        	else if (!RTMPEqualMemory(SNAP_802_1H, (PUCHAR)&pAd->FragFrame.Buffer[LENGTH_802_3], 6))
                        	{
                        		CheckPktSanity = FALSE;	
                        		DBGPRINT(RT_DEBUG_ERROR, "Can't find SNAP_802_1H parameter.\n");
                        	}	 
                        	else if (!RTMPEqualMemory(EAPOL, (PUCHAR)&pAd->FragFrame.Buffer[LENGTH_802_3 + 6], 2))
                        	{
                        		CheckPktSanity = FALSE;	
                        		DBGPRINT(RT_DEBUG_ERROR, "Can't find EAPOL parameter.\n");	
                        	}	
                        	else if(pAd->FragFrame.Buffer[LENGTH_802_3 + 9] > EAPOLASFAlert)
                        	{
                        		CheckPktSanity = FALSE;	
                        		DBGPRINT(RT_DEBUG_ERROR, "Unknown EAP type(%d).\n",pAd->FragFrame.Buffer[LENGTH_802_3+9]);	
                        	}
                        	
                        	if(CheckPktSanity == FALSE)
                        	{
                        		NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                        		break;
                        	}	
                        	
                        	if ((pEntry) && (pEntry->WpaState < AS_INITPMK) && 
                				((pEntry->AuthMode == Ndis802_11AuthModeWPA) || (pEntry->AuthMode == Ndis802_11AuthModeWPA2) || pAd->PortCfg.MBSSID[apidx].IEEE8021X == TRUE))
                			{
                				UCHAR           LLC_Len[2];
                		
                				NdisMoveMemory(LLC_Len, EAPOL, 2);
                				MAKE_802_3_HEADER(Header802_3, pDA, pSA, ((PUCHAR) LLC_Len));
#ifdef RTL865X_SOC
		                		REPORT_ETHERNET_FRAME_TO_LLC_RTL865X(pAd, Header802_3, &pAd->FragFrame.Buffer[LENGTH_802_3], pAd->FragFrame.RxSize, net_dev);						
#else

                				REPORT_ETHERNET_FRAME_TO_LLC(pAd, Header802_3, &pAd->FragFrame.Buffer[LENGTH_802_3], pAd->FragFrame.RxSize, net_dev);
#endif
                				DBGPRINT(RT_DEBUG_OFF, "Apidx=%d,sned whole pkt: pDA %x %x %x %x %x %x,pSA %x %x %x %x %x %x\n",apidx,*pDA,*(pDA+1),*(pDA+2),*(pDA+3),*(pDA+4),*(pDA+5),
                										*pSA,*(pSA+1),*(pSA+2),*(pSA+3),*(pSA+4),*(pSA+5));
                			}
                        
                        	// Clear Fragment frame contents
                            NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                            DBGPRINT(RT_DEBUG_INFO, "!!! Frame with Fragment Indicated !!!\n");	
                        }	                                    
                    }
                	break; // end of processing this frame
                }
                if (RTMPCheckWPAframe(pAd, (PUCHAR)pHeader, pRxD->DataByteCnt, Offset))
                {
                	REPORT_MGMT_FRAME_TO_MLME(pAd, pHeader, pRxD->DataByteCnt, pRxD->PlcpRssi, Offset);
                	break;
                }

                // First or Only fragment
                if (pHeader->Frag == 0)     
                {
                    PUCHAR pRemovedLLCSNAP;
                           
                    CONVERT_TO_802_3(Header802_3, pDA, pSA, pData, DataSize, pRemovedLLCSNAP);
                                                                      
                    // One & The only fragment
                    if (pHeader->FC.MoreFrag == FALSE)
                    {
                        if ((pHeader->FC.Order == 1) && (Msdu2Size > 0)) // this is an aggregation
                        {
                            USHORT Payload1Size, Payload2Size;
                            PUCHAR pData2;
                           
                            pAd->RalinkCounters.OneSecRxAggregationCount ++;
                            Payload1Size = DataSize - Msdu2Size;
                            Payload2Size = Msdu2Size - LENGTH_802_3;
                                       
                            // check if DA is another associted WSTA reachable via wireless bridging,
                            // if it is, then no need to indicate to LLC
                            if (RTMPBridgeToWdsAndWirelessSta(pAd, Header802_3, LENGTH_802_3, pData, Payload1Size, apidx))
                            {
                                pData2 = pData + Payload1Size + LENGTH_802_3;
                                RTMPBridgeToWdsAndWirelessSta(pAd, Header802_3, LENGTH_802_3, pData2, Payload2Size, apidx);
                            }
                            else
                            {
                                REPORT_ETHERNET_FRAME_TO_LLC(pAd, Header802_3, pData, Payload1Size, net_dev);
                                DBGPRINT(RT_DEBUG_INFO, "!!! report segregated MSDU1 to LLC (len=%d, proto=%02x:%02x) %02x:%02x:%02x:%02x-%02x:%02x:%02x:%02x\n",
                                    LENGTH_802_3+Payload1Size, Header802_3[12], Header802_3[13],
                                    *pData, *(pData+1),*(pData+2),*(pData+3),*(pData+4),*(pData+5),*(pData+6),*(pData+7));
                                    
                                pData2 = pData + Payload1Size + LENGTH_802_3;
                                REPORT_ETHERNET_FRAME_TO_LLC(pAd, pData + Payload1Size, pData2, Payload2Size, net_dev);
                                DBGPRINT(RT_DEBUG_INFO, "!!! report segregated MSDU2 to LLC (len=%d, proto=%02x:%02x) %02x:%02x:%02x:%02x-%02x:%02x:%02x:%02x\n",
                                    LENGTH_802_3+Payload2Size, *(pData2 -2), *(pData2 - 1),
                                    *pData2, *(pData2+1),*(pData2+2),*(pData2+3),*(pData2+4),*(pData2+5),*(pData2+6),*(pData2+7));
                            }
                        }
                        else
                        {
                            // check if DA is another associted WSTA reachable via wireless bridging,
                            // if it is, then no need to indicate to LLC
                            if (RTMPBridgeToWdsAndWirelessSta(pAd, Header802_3, LENGTH_802_3, pData, DataSize, apidx))
                                break;
                                   
                            REPORT_ETHERNET_FRAME_TO_LLC_WITH_NON_COPY(pAd, Header802_3, pData, DataSize, net_dev);
#ifdef NONCOPY_RX
		#ifndef NOT_CHANGE_ENDIAN_2 // Sam add
                            pRxD->BufPhyAddr = pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa;
		#else
                            pRxD->BufPhyAddr = SWAP32(pAd->RxRing.Cell[pAd->RxRing.CurRxIndex].DmaBuf.AllocPa);
			    pDestRxD -> BufPhyAddr = pRxD -> BufPhyAddr;
		#endif // End Sam add
#endif
                            DBGPRINT(RT_DEBUG_INFO, "!!! report DATA (no frag) to LLC (len=%d, proto=%02x:%02x) %02x:%02x:%02x:%02x-%02x:%02x:%02x:%02x\n",
                                DataSize, Header802_3[12], Header802_3[13],
                                *pData, *(pData+1),*(pData+2),*(pData+3),*(pData+4),*(pData+5),*(pData+6),*(pData+7));
                        }
                    }
                                
                    // First fragment - record the 802.3 header and frame body
                    else
                    {
                    	pAd->FragFrame.Flags &= 0xFFFFFFFE;

                    	// Firt Fragment & LLC/SNAP been removed. Keep the removed LLC/SNAP for later on
	                    // TKIP MIC verification.
	                    if (pHeader->FC.MoreFrag && pRemovedLLCSNAP)
	                    {
	                        NdisMoveMemory(pAd->FragFrame.Header_LLC, pRemovedLLCSNAP, LENGTH_802_1_H);
	                        pAd->FragFrame.Flags |= 0x01;
	                    }
	                    
                        NdisMoveMemory(&pAd->FragFrame.Buffer[LENGTH_802_3], pData, DataSize);
                        NdisMoveMemory(pAd->FragFrame.Header802_3, Header802_3, LENGTH_802_3);
                        pAd->FragFrame.RxSize   = DataSize;
                        pAd->FragFrame.Sequence = pHeader->Sequence;
                        pAd->FragFrame.LastFrag = pHeader->Frag;       // Should be 0
                    }
                }

                // Middle & End of fragment burst
                else
                {
                    // No LLC-SNAP header in except the first fragment frame
                    if ((pHeader->Sequence != pAd->FragFrame.Sequence) ||
                        (pHeader->Frag != (pAd->FragFrame.LastFrag + 1)))
                    {
                        // Fragment is not the same sequence or out of fragment number order
                        // Clear Fragment frame contents
                        NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                        break; // give up this frame
                    }   
                    else if ((pAd->FragFrame.RxSize + DataSize) > MAX_FRAME_SIZE)
                    {
                        // Fragment frame is too large, it exeeds the maximum frame size.
                        // Clear Fragment frame contents
                        NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                        break; // give up this frame
                    }
                                                    
                    // concatenate this fragment into the re-assembly buffer
                    NdisMoveMemory(&pAd->FragFrame.Buffer[LENGTH_802_3 + pAd->FragFrame.RxSize], pData, DataSize);
                    pAd->FragFrame.RxSize  += DataSize;
                    pAd->FragFrame.LastFrag = pHeader->Frag;       // Update fragment number
                                                            

                    // Last fragment
                    if (pHeader->FC.MoreFrag == FALSE)
                    {
                        // For TKIP frame, calculate the MIC value
                        if (pRxD->CipherAlg == CIPHER_TKIP)
                        {
                            PCIPHER_KEY pWpaKey;

                            if (!pEntry)
                        		break;
                       		pWpaKey = &pEntry->PairwiseKey;
                        
                            // Minus MIC length
                            pAd->FragFrame.RxSize -= 8;
                                                                    
                            if (pAd->FragFrame.Flags & 0x00000001)
                            {
                                // originally there's an LLC/SNAP field in the first fragment
                                // but been removed in re-assembly buffer. here we have to include
                                // this LLC/SNAP field upon calculating TKIP MIC
                                // pData = pAd->FragFrame.Header_LLC;
                                // Copy LLC data to the position in front of real data for MIC calculation
                                NdisMoveMemory(&pAd->FragFrame.Buffer[LENGTH_802_3 - LENGTH_802_1_H],
                                    pAd->FragFrame.Header_LLC, 
                                    LENGTH_802_1_H);
                                pData = (PUCHAR) &pAd->FragFrame.Buffer[LENGTH_802_3 - LENGTH_802_1_H];                                        
                                DataSize = (USHORT)pAd->FragFrame.RxSize + LENGTH_802_1_H;
                            }
                            else
                            {
                                pData = (PUCHAR) &pAd->FragFrame.Buffer[LENGTH_802_3];
                                DataSize = (USHORT)pAd->FragFrame.RxSize;
                            }
                        
                            if (RTMPTkipCompareMICValue(pAd,
                                                        pData,
                                                        pDA,
                                                        pSA,
                                                        pWpaKey->RxMic,
                                                        DataSize) == FALSE)
                            {
                                DBGPRINT(RT_DEBUG_ERROR,"Rx MIC Value error 2\n");                            
                                if (pEntry)
                                {
                                	HandleCounterMeasure(pAd, pEntry);
                                }
                                break;  // give up this frame
                            }
                                                    
                        }               

                        // check if DA is another associted WSTA reachable via wireless bridging,
                        // if it is, then no need to indicate to LLC
                        if (RTMPBridgeToWdsAndWirelessSta(pAd, pAd->FragFrame.Header802_3, LENGTH_802_3, &pAd->FragFrame.Buffer[LENGTH_802_3], pAd->FragFrame.RxSize, apidx) == FALSE)
                        {
                            pData = &pAd->FragFrame.Buffer[LENGTH_802_3];
                            REPORT_ETHERNET_FRAME_TO_LLC(pAd, pAd->FragFrame.Header802_3, pData, pAd->FragFrame.RxSize, net_dev);
							DBGPRINT(RT_DEBUG_INFO, "!!! report DATA (fragmented) to LLC (len=%d) !!!\n", pAd->FragFrame.RxSize);
                        }
                        // Clear Fragment frame contents
                        NdisZeroMemory(&pAd->FragFrame, sizeof(FRAGMENT_FRAME));
                    }
                }
                break;
            }

            //
            // CASE II. receive a MGMT frame
            //
            else if (pHeader->FC.Type == BTYPE_MGMT)
            {
                if (pAd->PortCfg.MBSSID[apidx].BANClass3Data == TRUE)
                {
                    // disallow new association
                    if ((pHeader->FC.SubType == SUBTYPE_ASSOC_REQ) || (pHeader->FC.SubType == SUBTYPE_AUTH))
                    {
                        DBGPRINT(RT_DEBUG_TRACE, "Disallow new Association \n ");
                        break; // give up this frame
                    }
                }
                
                REPORT_MGMT_FRAME_TO_MLME(pAd, pHeader, pRxD->DataByteCnt, pRxD->PlcpRssi, Offset);
                break;  // end of processing this frame
            }

            //
            // CASE III. receive a CNTL frame
            //
            else if (pHeader->FC.Type == BTYPE_CNTL)
            {
                // handle PS-POLL here
                if ((pRxD->U2M) && (pHeader->FC.SubType == SUBTYPE_PS_POLL))
                {
                    PUCHAR pAddr = pHeader->Addr2;
                                        
                    pEntry = MacTableLookup(pAd, pAddr);
                	if (pEntry)
                	{
                    	RTMPHandleRxPsPoll(pAd, pAddr, pEntry);
                	}
                }
                else
                {
                     DBGPRINT(RT_DEBUG_TRACE,"ignore CNTL (subtype=%d)\n", pHeader->FC.SubType);
                }
                break; // end of processing this frame
            }

            //
            // CASE IV. receive a frame of invalid type
            //
            else
                break; // give up this frame
        
        } while (FALSE);

        pRxD->Owner = DESC_OWN_NIC;

#ifndef NOT_CHANGE_ENDIAN_2  // Sam add
#ifdef BIG_ENDIAN
        RTMPDescriptorEndianChange((PUCHAR)pRxD, TYPE_RXD);    
        WriteBackToDescriptor((PUCHAR)pDestRxD, (PUCHAR)pRxD, FALSE, TYPE_RXD);
#endif
#else
	pRxBD -> ulword0 = SWAP32(pRxBD -> ulword0);
	pRxBD -> ulword1 = SWAP32(pRxBD -> ulword1);
	pDestRxD -> ulword1 = pRxBD -> ulword1;
	pDestRxD -> ulword0 = pRxBD -> ulword0;
#endif // End Sam add
        INC_RING_INDEX(pAd->RxRing.CurRxIndex, RX_RING_SIZE);
    }
        
    // Make sure to release Rx ring resource

#ifndef TC_NO_SPIN_LOCK // Sam add
    spin_unlock_irqrestore(&pAd->RxRingLock, IrqFlags);
#endif
}

/*
	========================================================================

	Routine	Description:
		Process	TxDone interrupt, running in	DPC	level

	Arguments:
		Adapter		Pointer	to our adapter

	Return Value:
		None

	Note:

	========================================================================
*/
VOID	RTMPHandleTxDoneInterrupt(
	IN	PRTMP_ADAPTER	pAd)
{
	STA_CSR4_STRUC csr;
	int i;
	UCHAR UpRate;
	int txdone_int_count=0;

//	DBGPRINT(RT_DEBUG_INFO, ("====> RTMPHandleTxDoneInterrupt\n"));

    for (i=0; i<MAX_TX_DONE_PROCESS; i++)
    // Sam for (i=0; i<4; i++)
    {
	#if 0 
	if((modem_status == 0x08 || modem_status == 0x10) && txdone_int_count == 1)	
	//if(modem_status == 0x08 || modem_status == 0x10)
		break;
	else txdone_int_count++;
	#endif



        RTMP_IO_READ32(pAd, STA_CSR4, &csr.word);
        if (! csr.field.bValid)
            break;

        pAd->RalinkCounters.OneSecTxDoneCount++;
        switch (csr.field.TxResult)
        {
    		case TX_RESULT_SUCCESS:			// Success with or without retry
		    	// DBGPRINT(RT_DEBUG_INFO, ("TX Success without retry<<<\n"));
	    		pAd->WlanCounters.TransmittedFragmentCount++;
    			pAd->Counters8023.GoodTransmits++;

                if ((csr.field.PidType == (PTYPE_SPECIAL >> 6)) && (csr.field.PidSubtype == PSUBTYPE_RTS))
                    pAd->WlanCounters.RTSSuccessCount++;
                    
                // case 1. no retry
                if (csr.field.RetryCount == 0)
                {
                    // update DRS related counters
                    if (csr.field.PidType == (PTYPE_DATA_REQUIRE_ACK >> 6))
                    {
                        pAd->RalinkCounters.OneSecTxNoRetryOkCount ++;

                        // AP mode
                        if (csr.field.PidSubtype < WDS_PAIRWISE_KEY_OFFSET)
                            pAd->MacTab.Content[csr.field.PidSubtype].OneSecTxOkCount++;
                        else
                            pAd->WdsTab.WdsEntry[csr.field.PidSubtype - WDS_PAIRWISE_KEY_OFFSET].OneSecTxOkCount++;
                    }
                }
                else
                {
                    // case 2. one or multiple retry
    			    pAd->WlanCounters.RetryCount++;
        			pAd->WlanCounters.ACKFailureCount++;
    			    if (csr.field.RetryCount > 1)
    			    {
    				    pAd->WlanCounters.MultipleRetryCount++;
    				    pAd->Counters8023.MoreCollisions++;
        			}
    	    		else
        				pAd->Counters8023.OneCollision++;
			
                    // update DRS related counters
                    if (csr.field.PidType == (PTYPE_NULL_AT_HIGH_RATE >> 6))
                    {
                        // DRS - must be NULL frame retried @ UpRate; downgrade 
                        //       TxQuality[UpRate] so that not upgrade TX rate
                        if (csr.field.PidSubtype < WDS_PAIRWISE_KEY_OFFSET) // operate in AP mode
                        {
                        	if (pAd->PortCfg.Channel > 14)
                        		UpRate = Phy11ANextRateUpward[pAd->MacTab.Content[csr.field.PidSubtype].CurrTxRate];
                        	else
                        	UpRate = Phy11BGNextRateUpward[pAd->MacTab.Content[csr.field.PidSubtype].CurrTxRate];
                        	
                            pAd->MacTab.Content[csr.field.PidSubtype].TxQuality[UpRate] += 2;
                            if (pAd->MacTab.Content[csr.field.PidSubtype].TxQuality[UpRate] > DRS_TX_QUALITY_WORST_BOUND)
                                pAd->MacTab.Content[csr.field.PidSubtype].TxQuality[UpRate] = DRS_TX_QUALITY_WORST_BOUND;
                        }
                        else // operate in AP mode
                        {
                            UCHAR WdsIdx = (UCHAR)(csr.field.PidSubtype - WDS_PAIRWISE_KEY_OFFSET);

                            if (pAd->PortCfg.Channel > 14)
                            	UpRate = Phy11ANextRateUpward[pAd->WdsTab.WdsEntry[WdsIdx].CurrTxRate];
                            else
                            UpRate = Phy11BGNextRateUpward[pAd->WdsTab.WdsEntry[WdsIdx].CurrTxRate];
                            
                            pAd->WdsTab.WdsEntry[WdsIdx].TxQuality[UpRate] += 2;
                            if (pAd->WdsTab.WdsEntry[WdsIdx].TxQuality[UpRate] > DRS_TX_QUALITY_WORST_BOUND)
                                pAd->WdsTab.WdsEntry[WdsIdx].TxQuality[UpRate] = DRS_TX_QUALITY_WORST_BOUND;
                        }
                    }
                    else if (csr.field.PidType == (PTYPE_DATA_REQUIRE_ACK >> 6))
                    {
                        pAd->RalinkCounters.OneSecTxRetryOkCount ++;

                        // AP mode
                        if (csr.field.PidSubtype < WDS_PAIRWISE_KEY_OFFSET)
                            pAd->MacTab.Content[csr.field.PidSubtype].OneSecTxRetryOkCount++;
                        else
                            pAd->WdsTab.WdsEntry[csr.field.PidSubtype - WDS_PAIRWISE_KEY_OFFSET].OneSecTxRetryOkCount++;
                    }
                }
			    break;
			  
		    case TX_RESULT_RETRY_FAIL:				// Fail on hitting retry count limit
			    DBGPRINT(RT_DEBUG_INFO, "TX Failed (RETRY LIMIT)<<<\n");
			    pAd->WlanCounters.FailedCount++;
			    pAd->WlanCounters.ACKFailureCount++;
			    pAd->Counters8023.TxErrors++;
                if ((csr.field.PidType == (PTYPE_SPECIAL >> 6)) && (csr.field.PidSubtype == PSUBTYPE_RTS))
                    pAd->WlanCounters.RTSFailureCount++;
			
                // update DRS related counters
                if (csr.field.PidType == (PTYPE_NULL_AT_HIGH_RATE >> 6))
                {
                    // DRS - must be NULL frame failed @ UpRate; downgrade 
                    //       TxQuality[UpRate] so that not upgrade TX rate
                    if (csr.field.PidSubtype < WDS_PAIRWISE_KEY_OFFSET) // operate in AP mode
                    {
                    	UpRate = Phy11BGNextRateUpward[pAd->MacTab.Content[csr.field.PidSubtype].CurrTxRate];
                        pAd->MacTab.Content[csr.field.PidSubtype].TxQuality[UpRate] = DRS_TX_QUALITY_WORST_BOUND;
                    }
                    else // operate in AP mode
                    {
                        UCHAR WdsIdx = (UCHAR)(csr.field.PidSubtype - WDS_PAIRWISE_KEY_OFFSET);

                        UpRate = Phy11BGNextRateUpward[pAd->WdsTab.WdsEntry[WdsIdx].CurrTxRate];
                        pAd->WdsTab.WdsEntry[WdsIdx].TxQuality[UpRate] = DRS_TX_QUALITY_WORST_BOUND;
                    }
                }
                else if (csr.field.PidType == (PTYPE_DATA_REQUIRE_ACK >> 6))
                {
                    pAd->RalinkCounters.OneSecTxFailCount ++;

                    // for AP
                    if (csr.field.PidSubtype < WDS_PAIRWISE_KEY_OFFSET)
                        pAd->MacTab.Content[csr.field.PidSubtype].OneSecTxFailCount ++;
                    else
                    {
                        UCHAR WdsIdx = (UCHAR)(csr.field.PidSubtype - WDS_PAIRWISE_KEY_OFFSET);
                        pAd->WdsTab.WdsEntry[WdsIdx].OneSecTxFailCount ++;
                    }
                }

			    break;
			
		    default:
			    DBGPRINT(RT_DEBUG_ERROR, "TX Failed (%04x)<<<\n",csr.word);
			    pAd->WlanCounters.FailedCount++;
			    pAd->WlanCounters.ACKFailureCount++;
			    pAd->Counters8023.TxErrors++;
			    break;			
        }

#ifdef RALINK_ATE
		if(pAd->ate.Mode == ATE_TXFRAME)
		{
			if (pAd->ate.TxDoneCount < pAd->ate.TxCount)
			{
				PTXD_STRUC		pTxD;
				PRTMP_TX_RING   pTxRing = &pAd->TxRing[QID_AC_BE];
				PRTMP_DMABUF    pDmaBuf = &pAd->TxRing[QID_AC_BE].Cell[pTxRing->CurTxIndex].DmaBuf;

				pAd->ate.TxDoneCount++;
				
			    pTxD = (PTXD_STRUC)pAd->TxRing[QID_AC_BE].Cell[pTxRing->CurTxIndex].AllocVa;

				RTMPWriteTxDescriptor(pAd, pTxD, CIPHER_NONE, 0, 0, FALSE, FALSE, FALSE, SHORT_RETRY,
					IFS_BACKOFF, pAd->ate.TxRate, pAd->ate.TxLength, QID_AC_BE, 0, pDmaBuf->pSkb, NULL, FALSE);

				INC_RING_INDEX(pTxRing->CurTxIndex, TX_RING_SIZE);

				RTMP_IO_WRITE32(pAd, TX_CNTL_CSR, BIT8[QID_AC_BE]);
			}
			else
			{
				DBGPRINT(RT_DEBUG_INFO, "ATE TXFRAME completed!\n");
			}
		}
#endif	//#ifdef RALINK_ATE
    }
}

/*
	========================================================================

	Routine	Description:
		Process	TX Rings DMA Done interrupt, running in	DPC	level

	Arguments:
		Adapter		Pointer	to our adapter

	Return Value:
		None

	========================================================================
*/
VOID    RTMPHandleTxRingDmaDoneInterrupt(
	IN	PRTMP_ADAPTER	pAdapter,
	IN  INT_SOURCE_CSR_STRUC TxRingBitmap)
{
	ULONG			IrqFlags;

	// Make sure Tx ring resource won't be used by other threads

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_lock_irqsave(&pAdapter->TxRingLock, IrqFlags);
#endif
    if (TxRingBitmap.field.Ac0DmaDone)
        RTMPFreeTXDUponTxDmaDone(pAdapter, QID_AC_BE, TX_RING_SIZE);
    
    if (TxRingBitmap.field.HccaDmaDone)
        RTMPFreeTXDUponTxDmaDone(pAdapter, QID_HCCA, TX_RING_SIZE);

    if (TxRingBitmap.field.Ac3DmaDone)
        RTMPFreeTXDUponTxDmaDone(pAdapter, QID_AC_VO, TX_RING_SIZE);

    if (TxRingBitmap.field.Ac2DmaDone)
        RTMPFreeTXDUponTxDmaDone(pAdapter, QID_AC_VI, TX_RING_SIZE);

    if (TxRingBitmap.field.Ac1DmaDone)
        RTMPFreeTXDUponTxDmaDone(pAdapter, QID_AC_BK, TX_RING_SIZE);
    
	// Make sure to release Tx ring resource

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_unlock_irqrestore(&pAdapter->TxRingLock, IrqFlags);
#endif	
	// Dequeue one frame from TxSwQueue[] and process it
	if ((!RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS)) && 
		(!RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_RESET_IN_PROGRESS)) &&
		(!RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_HALT_IN_PROGRESS)))
	{
		// let the subroutine select the right priority Tx software queue
		RTMPDeQueuePacket(pAdapter, FALSE);
	}
}

/*
	========================================================================

	Routine	Description:
		Process	MGMT ring DMA done interrupt, running in DPC level

	Arguments:
		pAdapter		Pointer	to our adapter

	Return Value:
		None

	Note:

	========================================================================
*/
// Sam add
#ifndef NOT_CHANGE_ENDIAN_3
VOID	RTMPHandleMgmtRingDmaDoneInterrupt(
	IN	PRTMP_ADAPTER	pAdapter)
{
    PTXD_STRUC		pTxD;
#ifdef BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
    struct sk_buff	*pSkb;
    int				i;
    ULONG			IrqFlags;

    DBGPRINT(RT_DEBUG_INFO, "RTMPHandleMgmtRingDmaDoneInterrupt...\n");

	spin_lock_irqsave(&pAdapter->MgmtRingLock, IrqFlags);
    for (i=0; i<MGMT_RING_SIZE; i++)
    {

#ifndef BIG_ENDIAN
	    pTxD = (PTXD_STRUC)	(pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.NextTxDmaDoneIndex].AllocVa);
#else
        pDestTxD = (PTXD_STRUC) (pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.NextTxDmaDoneIndex].AllocVa);
        TxD = *pDestTxD;
        pTxD = &TxD;
		RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif /* BIG_ENDIAN */

        if ((pTxD->Owner == DESC_OWN_NIC) || (pTxD->bWaitingDmaDoneInt == 0))
	        break;

		pci_unmap_single(pAdapter->pPci_Dev, pTxD->BufPhyAddr0, pTxD->BufLen0, PCI_DMA_TODEVICE);
		
	    pSkb = pTxD->pSkb;
        if (pSkb)
        {
            pTxD->pSkb = 0;
            RELEASE_NDIS_PACKET(pAdapter, pSkb);
        }

	    pTxD->bWaitingDmaDoneInt = 0;
	    INC_RING_INDEX(pAdapter->MgmtRing.NextTxDmaDoneIndex, MGMT_RING_SIZE);
//      pAdapter->RalinkCounters.TransmittedByteCount +=  pTxD->DataByteCnt;

#ifdef BIG_ENDIAN
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
        WriteBackToDescriptor((PUCHAR)pDestTxD, (PUCHAR)pTxD, TRUE, TYPE_TXD);
#endif			
		
    }
	spin_unlock_irqrestore(&pAdapter->MgmtRingLock, IrqFlags);
}
#else  // NOT_CHANGE_ENDIAN_3

VOID	RTMPHandleMgmtRingDmaDoneInterrupt(
	IN	PRTMP_ADAPTER	pAdapter)
{
     PTXD_STRUC		pTxD;
     PTXD_BIG_STRUC		pTxBD;

#ifdef BIG_ENDIAN
//unsigned int BufLen;
// Sam    PTXD_STRUC      pDestTxD;
// Sam    TXD_STRUC       TxD;
#endif
    struct sk_buff	*pSkb;
    int				i;
    ULONG			IrqFlags;

    DBGPRINT(RT_DEBUG_INFO, "RTMPHandleMgmtRingDmaDoneInterrupt...\n");

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_lock_irqsave(&pAdapter->MgmtRingLock, IrqFlags);
#endif
    for (i=0; i<MGMT_RING_SIZE; i++)
    {

#ifndef BIG_ENDIAN
	    pTxD = (PTXD_STRUC)	(pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.NextTxDmaDoneIndex].AllocVa);
#else
        // Sam pDestTxD = (PTXD_STRUC) (pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.NextTxDmaDoneIndex].AllocVa);
        pTxBD = (PTXD_BIG_STRUC) (pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.NextTxDmaDoneIndex].AllocVa);
	pTxD  = (PTXD_STRUC)pTxBD;

	pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
		// Sam RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif /* BIG_ENDIAN */

        // Sam if ((pTxD->Owner == DESC_OWN_NIC) || (pTxD->bWaitingDmaDoneInt == 0))
        if ((pTxBD->ulword0 & 0x01000000) || !(pTxBD->ulword5 & 0x00000001))
	        break;

		// Sam pci_unmap_single(pAdapter->pPci_Dev, pTxD->BufPhyAddr0, pTxD->BufLen0, PCI_DMA_TODEVICE);
		// BufLen = (SWAP32(pTxBD->ulword11) & 0x00000fff);
		// Sam M pci_unmap_single(pAdapter->pPci_Dev, SWAP32(pTxBD->BufPhyAddr0),pTxD->BufLen0, PCI_DMA_TODEVICE);
		
	    // Sam pSkb = pTxD->pSkb;
	    pSkb = SWAP32(pTxBD->pSkb);
        if (pSkb)
        {
            pTxBD->pSkb = 0;
            RELEASE_NDIS_PACKET(pAdapter, pSkb);
        }

	    // Sam pTxD->bWaitingDmaDoneInt = 0;
	    pTxBD->ulword5 &= 0xfffffffe;

	    INC_RING_INDEX(pAdapter->MgmtRing.NextTxDmaDoneIndex, MGMT_RING_SIZE);

	    pTxBD->ulword11 = SWAP32(pTxBD->ulword11);

//      pAdapter->RalinkCounters.TransmittedByteCount +=  pTxD->DataByteCnt;

#ifdef BIG_ENDIAN
        // Sam RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
        // Sam WriteBackToDescriptor((PUCHAR)pDestTxD, (PUCHAR)pTxD, TRUE, TYPE_TXD);
#endif			
		
    }

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_unlock_irqrestore(&pAdapter->MgmtRingLock, IrqFlags);
#endif
}
#endif // NOT_CHANGE_ENDIAN_3
// End Sam add


/*
	========================================================================

	Routine	Description:
		API for MLME to transmit management frame to AP (BSS Mode)
	or station (IBSS Mode)
	
	Arguments:
		pAdapter	Pointer	to our adapter
		pData		Pointer to the outgoing 802.11 frame
		Length		Size of outgoing management frame
		
	Return Value:
		NDIS_STATUS_FAILURE
		NDIS_STATUS_PENDING
		NDIS_STATUS_SUCCESS

	Note:
	
	========================================================================
*/
NDIS_STATUS	MiniportMMRequest(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	PUCHAR			pData,
	IN	UINT			Length)
{
    struct sk_buff	*pSkb = NULL;
    NDIS_STATUS		Status = NDIS_STATUS_SUCCESS;
    UCHAR			FreeNum;

    ASSERT(Length <= MGMT_DMA_BUFFER_SIZE);

    do 
    {
    	// Reset is in progress, stop immediately
	    if ( RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_RESET_IN_PROGRESS) ||
	         RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_HALT_IN_PROGRESS))
	    {
	    	DBGPRINT(RT_DEBUG_WARN, "MiniportMMRequest-Card in abnormal state!!!\n");
		    Status = NDIS_STATUS_FAILURE;
			break;
		}

    	// Check Free priority queue
    	Status = RTMPFreeTXDRequest(pAdapter, QID_MGMT, 1, &FreeNum);
	    if (Status == NDIS_STATUS_SUCCESS)
    	{
            Status = RTMPAllocateNdisPacket(pAdapter, &pSkb, pData, Length);
            if (Status != NDIS_STATUS_SUCCESS)
            {
    	    	DBGPRINT(RT_DEBUG_WARN, "MiniportMMRequest (error:: can't allocate skb buffer)\n");
	    	    break;
            }
            
			Status = MlmeHardTransmit(pAdapter, pSkb);
			if (Status != NDIS_STATUS_SUCCESS)
                RELEASE_NDIS_PACKET(pAdapter, pSkb);
		}
    	else
	    {
    		pAdapter->RalinkCounters.MgmtRingFullCount++;
    		
    		// Kick MGMT ring transmit
    		RTMP_IO_WRITE32(pAdapter, TX_CNTL_CSR, 0x00000010);
    		
		    DBGPRINT(RT_DEBUG_TRACE, "Not enough space in MgmtRing\n");
    	}
    } while (FALSE);

    return Status;
}

/*
	========================================================================

	Routine	Description:
		Copy frame from waiting queue into relative ring buffer and set 
	appropriate ASIC register to kick hardware transmit function
	
	Arguments:
		pAdapter	Pointer	to our adapter
		pBuffer		Pointer to  memory of outgoing frame
		Length		Size of outgoing management frame
		
	Return Value:
		NDIS_STATUS_FAILURE
		NDIS_STATUS_PENDING
		NDIS_STATUS_SUCCESS

	Note:
	
	========================================================================
*/
NDIS_STATUS	MlmeHardTransmit(
	IN	PRTMP_ADAPTER	pAdapter,
	IN  struct sk_buff	*pSkb)
{
	PUCHAR			pSrcBufVA;
	ULONG			SrcBufLen;
#ifndef NOT_CHANGE_ENDIAN_3
	PTXD_STRUC		pTxD;
#ifdef BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
#else
	PTXD_STRUC		pTxD;
	PTXD_BIG_STRUC      	pTxBD;
#endif
	PHEADER_802_11	pHeader_802_11;
	BOOLEAN         bAckRequired, bInsertTimestamp;
	UCHAR			MlmeRate;
	ULONG			IrqFlags;
	
	DBGPRINT(RT_DEBUG_INFO, "MlmeHardTransmit\n");

	if (pAdapter->PortCfg.RadarDetect.RDMode != RD_NORMAL_MODE)
	{
        return (NDIS_STATUS_FAILURE);
	}

    // only one buffer is used in MGMT packet
    pSrcBufVA = (PVOID)pSkb->data;
    SrcBufLen = pSkb->len;

	// Make sure MGMT ring resource won't be used by other threads

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_lock_irqsave(&pAdapter->MgmtRingLock, IrqFlags);
#endif

#ifndef NOT_CHANGE_ENDIAN_3
#ifndef BIG_ENDIAN
	pTxD  = (PTXD_STRUC) pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.CurTxIndex].AllocVa;
#else
    pDestTxD  = (PTXD_STRUC) pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.CurTxIndex].AllocVa;
    TxD = *pDestTxD;
    pTxD = &TxD;
    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif
#else
    pTxD  = (PTXD_STRUC) pAdapter->MgmtRing.Cell[pAdapter->MgmtRing.CurTxIndex].AllocVa;
    pTxBD = (PTXD_BIG_STRUC)pTxD;
//    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
    pTxBD->ulword1 = SWAP32(pTxBD->ulword1);
    pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
#endif

#ifndef NOT_CHANGE_ENDIAN_3
	if ((pTxD->Owner == DESC_OWN_NIC) || (pTxD->bWaitingDmaDoneInt == 1))
#else
        if ((pTxBD->ulword0 & 0x01000000) || (pTxBD->ulword5 & 0x00000001))
#endif
	{
		// Descriptor owned by NIC. No descriptor avaliable
		// This should not happen since caller guaranteed.
		// Make sure to release MGMT ring resource
		DBGPRINT_ERR("MlmeHardTransmit: MGMT RING full\n");

#ifndef TC_NO_SPIN_LOCK // Sam add
		spin_unlock_irqrestore(&pAdapter->MgmtRingLock, IrqFlags);
#endif
		return NDIS_STATUS_FAILURE;
	}
	if (pSrcBufVA == NULL)
	{
		// The buffer shouldn't be NULL
		DBGPRINT_ERR("MlmeHardTransmit: buffer NULL\n");

#ifndef TC_NO_SPIN_LOCK // Sam add
		spin_unlock_irqrestore(&pAdapter->MgmtRingLock, IrqFlags);
#endif
		return NDIS_STATUS_FAILURE;
	}

	pHeader_802_11           = (PHEADER_802_11) pSrcBufVA;
	bInsertTimestamp = FALSE;
	if (pHeader_802_11->FC.Type == BTYPE_CNTL) // must be PS-POLL
	{
		bAckRequired = FALSE;
	}
	else // BTYPE_MGMT or BTYPE_DATA(must be NULL frame)
	{
        pAdapter->Sequence++;
		pHeader_802_11->Sequence = pAdapter->Sequence;

		if (pHeader_802_11->Addr1[0] & 0x01) // MULTICAST, BROADCAST
		{
			bAckRequired = FALSE;
			pHeader_802_11->Duration = 0;
		}
		else
		{
			bAckRequired = TRUE;
			pHeader_802_11->Duration = RTMPCalcDuration(pAdapter, pAdapter->PortCfg.MlmeRate, 14) + pAdapter->PortCfg.Dsifs;
			if (pHeader_802_11->FC.SubType == SUBTYPE_PROBE_RSP)
			{
				bInsertTimestamp = TRUE;
			}
		}
	}

#ifdef BIG_ENDIAN
    RTMPFrameEndianChange(pAdapter, (PUCHAR)pHeader_802_11, DIR_WRITE, FALSE);
#endif 

    //
    // fill scatter-and-gather buffer list into TXD
    //
    pTxD->BufCount = 1;
    pTxD->BufLen0  = SrcBufLen;
#ifndef NOT_CHANGE_ENDIAN_3
    pTxD->BufPhyAddr0 = pci_map_single(pAdapter->pPci_Dev, (PVOID)pSrcBufVA, SrcBufLen, PCI_DMA_TODEVICE);
#else
    pTxD->BufPhyAddr0 = SWAP32(pci_map_single(pAdapter->pPci_Dev, (PVOID)pSrcBufVA, SrcBufLen, PCI_DMA_TODEVICE));
#endif
	// Verify Mlme rate for a / g bands.
	MlmeRate = pAdapter->PortCfg.MlmeRate;
	if (pAdapter->LatchRfRegs.Channel > 14)
	{
		// A band
		if (MlmeRate < RATE_6)
			MlmeRate = RATE_6;
	}

#ifndef NOT_CHANGE_ENDIAN_3	
#ifdef BIG_ENDIAN
    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
    *pDestTxD = TxD;
    pTxD = pDestTxD;
#endif
#else
    pTxBD->ulword1 = SWAP32(pTxBD->ulword1);
    pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
#endif

	// Initialize TX Descriptor
	// For inter-frame gap, the number is for this frame and next frame
	// For MLME rate, we will fix as 2Mb to match other vendor's implement
	RTMPWriteTxDescriptor(pAdapter, pTxD, CIPHER_NONE, 0,0, bAckRequired, FALSE, bInsertTimestamp,
		SHORT_RETRY, IFS_BACKOFF, MlmeRate, SrcBufLen, 
		QID_MGMT, PTYPE_SPECIAL|PSUBTYPE_MGMT, pSkb, NULL, FALSE);

	DBGPRINT(RT_DEBUG_INFO,"MLMEHardTransmit use rate %d\n", MlmeRate);
	
    INC_RING_INDEX(pAdapter->MgmtRing.CurTxIndex, MGMT_RING_SIZE);
	pAdapter->RalinkCounters.KickTxCount++;
		
	// Kick MGMT ring transmit
	RTMP_IO_WRITE32(pAdapter, TX_CNTL_CSR, 0x00000010);

	// Make sure to release MGMT ring resource

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_unlock_irqrestore(&pAdapter->MgmtRingLock, IrqFlags);
#endif
    return NDIS_STATUS_SUCCESS;
}   

// should be called only when -
// 1. MEADIA_CONNECTED
// 2. AGGREGATION_IN_USED
// 3. Fragmentation not in used
// 4. either no previous frame (pPrevAddr1=NULL) .OR. previoud frame is aggregatible
BOOLEAN TxFrameIsAggregatible(
    IN  PRTMP_ADAPTER   pAd,
    IN  PUCHAR          pPrevAddr1,
    IN  PUCHAR          p8023hdr)
{
    // can't aggregate EAPOL (802.1x) frame
    if ((p8023hdr[12] == 0x88) && (p8023hdr[13] == 0x8e))
        return FALSE;

    // can't aggregate multicast/broadcast frame
    if (p8023hdr[0] & 0x01)
        return FALSE;
    
    if ((pPrevAddr1 == NULL) || MAC_ADDR_EQUAL(pPrevAddr1, p8023hdr)) // unicast to same STA
        return TRUE;
    else
        return FALSE;
}

// NOTE: we do have an assumption here, that Byte0 and Byte1 always reasid at the same 
//       scatter gather buffer
NDIS_STATUS Sniff2BytesFromNdisBuffer(
    IN  struct sk_buff	*pFirstSkb,
    IN  UCHAR           DesiredOffset,
    OUT PUCHAR          pByte0,
    OUT PUCHAR          pByte1)
{
    PUCHAR pBufferVA;
    ULONG  BufferLen, AccumulateBufferLen, BufferBeginOffset;
    
    pBufferVA = (PVOID)pFirstSkb->data;
    BufferLen = pFirstSkb->len;
    BufferBeginOffset   = 0;
    AccumulateBufferLen = BufferLen;

    *pByte0 = *(PUCHAR)(pBufferVA + DesiredOffset - BufferBeginOffset);
    *pByte1 = *(PUCHAR)(pBufferVA + DesiredOffset - BufferBeginOffset + 1);
    return NDIS_STATUS_SUCCESS;
}

/*
	========================================================================

	Routine	Description:
		To do the enqueue operation and extract the first item of waiting 
		list. If a number of available shared memory segments could meet 
		the request of extracted item, the extracted item will be fragmented
		into shared memory segments.
		
	Arguments:
		pAdapter	Pointer	to our adapter
		pQueue		Pointer to Waiting Queue
		
	Return Value:
		None

	Note:
	
	========================================================================
*/
VOID	RTMPDeQueuePacket(
	IN	PRTMP_ADAPTER	pAdapter,
	IN  BOOLEAN			bMoreData)
{
	struct sk_buff  *pSkb;
	UCHAR			MpduRequired;
	NDIS_STATUS		Status;
	UCHAR			Count = 0;
	PQUEUE_HEADER	pQueue;
	ULONG			Number;
	UCHAR           QueIdx, FreeNumber;
	ULONG			IrqFlags;
	
	// Make sure SendTxWait queue resource won't be used by other threads

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_lock_irqsave(&pAdapter->TxSwQueueLock, IrqFlags);
#endif
	while (((pQueue = RTMPCheckTxSwQueue(pAdapter, &Number, &QueIdx)) != NULL) && (Count < MAX_TX_PROCESS))
	// Sam add while (((pQueue = RTMPCheckTxSwQueue(pAdapter, &Number, &QueIdx)) != NULL) && (Count < 2))
	{
		// Reset is in progress, stop immediately
		if ( RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_RESET_IN_PROGRESS) ||
		     RTMP_TEST_FLAG(pAdapter, fRTMP_ADAPTER_HALT_IN_PROGRESS))
		{
			break;
		}
			
		// Dequeue the first entry from head of queue list
		pSkb = (struct sk_buff*)RemoveHeadQueue(pQueue);

		// RTS or CTS-to-self for B/G protection mode has been set already.
		// There is no need to re-do it here. 
		// Total fragment required = number of fragment + RST if required
		MpduRequired = RTMP_GET_PACKET_FRAGMENTS(pSkb) + RTMP_GET_PACKET_RTS(pSkb);
		
		if (RTMPFreeTXDRequest(pAdapter, QueIdx, MpduRequired, &FreeNumber) == NDIS_STATUS_SUCCESS)
		{
			if (FreeNumber != TX_RING_SIZE && pAdapter->TxSwQueue[QueIdx].Number == 0)
			{
				InsertHeadQueue(pQueue, pSkb);
				break;
			}
			// 2004-10-12 if HardTransmit returns SUCCESS, then the skb buffer should be 
			//            released in later on DMADoneIsr. If HardTransmit returns FAIL, the
			//            the skb buffer should already be released inside RTMPHardTransmit
			Status = RTMPHardTransmit(pAdapter, pSkb, QueIdx, bMoreData);

            if (Status != NDIS_STATUS_SUCCESS)
				break;
		}	
		else
		{
			InsertHeadQueue(pQueue, pSkb);
			pAdapter->PrivateInfo.TxRingFullCnt++;
			DBGPRINT(RT_DEBUG_INFO,"RTMPDequeuePacket --> Not enough free TxD (CurTxIndex=%d, NextTxDmaDoneIndex=%d)!!!\n",
			    pAdapter->TxRing[QueIdx].CurTxIndex, pAdapter->TxRing[QueIdx].NextTxDmaDoneIndex);			
			break;
		}
		Count++;
	#if 0 // Sam add 
	if((modem_status == 0x08 || modem_status == 0x10) && Count == 1)	
	//if(modem_status == 0x08 || modem_status == 0x10)
		break;
	#endif

	}

	// Release TxSwQueue resources

#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_unlock_irqrestore(&pAdapter->TxSwQueueLock, IrqFlags);
#endif

}    

/*
	========================================================================

	Routine	Description:
		This routine classifies outgoing frames into several AC (Access
		Category) and enqueue them into corresponding s/w waiting queues.
		
	Arguments:
		pAdapter	Pointer	to our adapter
		pPacket		Pointer to send packet
		
	Return Value:
		None

	Note:
	
	========================================================================
*/
UCHAR MapUserPriorityToAccessCategory[8] = {QID_AC_BE, QID_AC_BK, QID_AC_BK, QID_AC_BE, QID_AC_VI, QID_AC_VI, QID_AC_VO, QID_AC_VO};
NDIS_STATUS	RTMPSendPacket(
	IN	PRTMP_ADAPTER	pAd,
	IN	struct sk_buff  *pSkb)
{
    PUCHAR          pSrcBufVA;
    UINT            AllowFragSize;
    UCHAR           NumberOfFrag;
    UCHAR           RTSRequired;
    UCHAR           QueIdx, UserPriority, apidx = MAIN_MBSSID;
    USHORT          Aid;
    SST             Sst = SST_ASSOC;
    UCHAR           PsMode = PWR_ACTIVE, Rate;
    MAC_TABLE_ENTRY *pMacEntry = NULL;
    ULONG			IrqFlags;
    
    DBGPRINT(RT_DEBUG_INFO, "====> RTMPSendPacket\n");

    // Prepare packet information
    pSrcBufVA = (PVOID)pSkb->data;

    if (pSrcBufVA == NULL)
    {
        // Resource is low, system did not allocate virtual address
        // release packet resource and return NDIS_STATUS_FAILURE to upper layer
        RELEASE_NDIS_PACKET(pAd, pSkb);
        return NDIS_STATUS_FAILURE;
    }

    // Get the tx rate and BSSID index
    if (RTMP_GET_PACKET_NET_DEVICE(pSkb) >= MIN_NET_DEVICE_FOR_WDS)
    {// WDS packet
    	Rate = pAd->WdsTab.WdsEntry[RTMP_GET_PACKET_NET_DEVICE(pSkb)- MIN_NET_DEVICE_FOR_WDS].CurrTxRate;

    	// The security policy of WDS packets will follow with MAIN_MBSSID's policy, and we don't support encrypt algorithm(TKIPAES) under WDS
    	if ((pAd->WdsTab.WepStatus >= Ndis802_11Encryption4Enabled))
    	{
    		RELEASE_NDIS_PACKET(pAd, pSkb);
    		return NDIS_STATUS_FAILURE;
    	}
    }
    else
    {// Normal packet or MBSSID packet
    	// Get the BSSID index
        apidx = RTMP_GET_PACKET_NET_DEVICE(pSkb);
	    
    	// check if target STA is in power-saving mode. care only those associated STAs
        pMacEntry = SsPsInquiry(pAd, pSrcBufVA, &Sst, &Aid, &PsMode, &Rate);
		
    	if (pMacEntry)
    	{
    		RTMP_SET_PACKET_AID(pSkb, Aid);
    	}
    }

    // STEP 1. Decide number of fragments required to deliver this MSDU. 
    //     The estimation here is not very accurate because difficult to 
    //     take encryption overhead into consideration here. The result 
    //     "NumberOfFrag" is then just used to pre-check if enough free 
    //     TXD are available to hold this MSDU.

    if (*pSrcBufVA & 0x01)  // fragmentation not allowed on multicast & broadcast
        NumberOfFrag = 1;    
    else  if (pMacEntry && CLIENT_STATUS_TEST_FLAG(pMacEntry, fCLIENT_STATUS_AGGREGATION_CAPABLE))
        NumberOfFrag = 1;   // Aggregation overwhelms fragmentation
    else
    {
        // The calculated "NumberOfFrag" is a rough estimation because of various 
        // encryption/encapsulation overhead not taken into consideration. This number is just
        // used to make sure enough free TXD are available before fragmentation takes place.
        // In case the actual required number of fragments of an skb buffer 
        // excceeds "NumberOfFrag"caculated here and not enough free TXD available, the
        // last fragment (i.e. last MPDU) will be dropped in RTMPHardTransmit() due to out of 
        // resource, and the skb buffer will be indicated NDIS_STATUS_FAILURE. This should 
        // rarely happen and the penalty is just like a TX RETRY fail. Affordable.
        
        AllowFragSize = (pAd->PortCfg.FragmentThreshold) - LENGTH_802_11 - LENGTH_CRC;
        NumberOfFrag = ((pSkb->len - LENGTH_802_3 + LENGTH_802_1_H) / AllowFragSize) + 1;
    }
    // Save fragment number to Ndis packet reserved field
    RTMP_SET_PACKET_FRAGMENTS(pSkb, NumberOfFrag);  

    // STEP 2. Check the requirement of RTS; decide packet TX rate
    //     If multiple fragment required, RTS is required only for the first fragment
    //     if the fragment size large than RTS threshold
    if (NumberOfFrag > 1)
        RTSRequired = (pAd->PortCfg.FragmentThreshold > pAd->PortCfg.RtsThreshold) ? 1 : 0;
    else
        RTSRequired = (pSkb->len > pAd->PortCfg.RtsThreshold) ? 1 : 0;

    // RTS/CTS may also be required in order to protect OFDM frame
    if ((Rate >= RATE_FIRST_OFDM_RATE) && 
        ERP_IS_USE_PROTECTION(pAd->Mlme.ErpIeContent))
        RTSRequired = 1;

    // HotSpot counter
    if (pMacEntry && pAd->PortCfg.bEnableHSCounter)
    {
        pMacEntry->HSCounter.TotalTxByteCount += pSkb->len;
        pMacEntry->HSCounter.LastDataPacketTime = jiffies;
    }

    // Save RTS requirement to Ndis packet reserved field
    RTMP_SET_PACKET_RTS(pSkb, RTSRequired);
    RTMP_SET_PACKET_TXRATE(pSkb, Rate);

    //
    // STEP 3. Traffic classification. outcome = <UserPriority, QueIdx>
    //
    UserPriority = 0;
    QueIdx       = QID_AC_BE;
    if (pAd->PortCfg.MBSSID[apidx].bWmmCapable)
    {
        USHORT Protocol;
        UCHAR  LlcSnapLen = 0, Byte0, Byte1;
        do
        {
            // get Ethernet protocol field
            Protocol = (USHORT)((pSrcBufVA[12] << 8) + pSrcBufVA[13]);
            if (Protocol <= 1500)
            {
                // get Ethernet protocol field from LLC/SNAP
                if (Sniff2BytesFromNdisBuffer(pSkb, LENGTH_802_3 + 6, &Byte0, &Byte1) != NDIS_STATUS_SUCCESS)
                    break;
        
                Protocol = (USHORT)((Byte0 << 8) + Byte1);
                LlcSnapLen = 8;
            }

            // Use AC_BE as default value
			if (Protocol == 0x8100)
			{
				UserPriority = (pSrcBufVA[14] & 0xe0) >> 5;

				if (Sniff2BytesFromNdisBuffer(pSkb, LENGTH_802_3 + 4, &Byte0, &Byte1) != NDIS_STATUS_SUCCESS)
					break;
			}
			else if (Protocol != 0x0800)
			{
				break;
			}
			else if (Sniff2BytesFromNdisBuffer(pSkb, LENGTH_802_3 + LlcSnapLen, &Byte0, &Byte1) == NDIS_STATUS_SUCCESS) // Get IP header
			{
				UserPriority = (Byte1 & 0xe0) >> 5;
			}
			else
			{
				RELEASE_NDIS_PACKET(pAd, pSkb);
				return NDIS_STATUS_FAILURE;
			}

            // return AC_BE if packet is not IPv4
            if ((Byte0 & 0xf0) != 0x40)
                break;

            QueIdx = MapUserPriorityToAccessCategory[UserPriority];

            // have to check ACM bit. downgrade UP & QueIdx before passing ACM
            // NOTE: AP doesn't have to negotiate TSPEC. ACM is controlled purely via user setup, not protocol handshaking
            if (pAd->PortCfg.APEdcaParm.bACM[QueIdx])
            {
                UserPriority = 0;
                QueIdx       = QID_AC_BE;
            }
        } while (FALSE);
    }
    
    RTMP_SET_PACKET_UP(pSkb, UserPriority);

    //
    // 4. put to corrsponding TxSwQueue or Power-saving queue
    //

    // WDS link should never go into power-save mode; just send out the frame
    if (RTMP_GET_PACKET_NET_DEVICE(pSkb) >= MIN_NET_DEVICE_FOR_WDS)
    {

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_lock_irqsave(&pAd->TxSwQueueLock, IrqFlags);
#endif
        InsertTailQueue(&pAd->TxSwQueue[QueIdx], pSkb);

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_unlock_irqrestore(&pAd->TxSwQueueLock, IrqFlags);
#endif
    }
    // M/BCAST frames are put to PSQ as long as there's any associated STA in power-save mode
    else if ((*pSrcBufVA & 0x01) && pAd->MacTab.fAnyStationInPsm)
    {
        // we don't want too many MCAST/BCAST backlog frames to eat up all buffers. So in case number of backlog 
        // MCAST/BCAST frames exceeds a pre-defined watermark within a DTIM period, simply drop coming new 
        // MCAST/BCAST frames. This design is similiar to "BROADCAST throttling in most manageable Ethernet Switch chip.
        if (pAd->MacTab.McastPsQueue.Number >= MAX_PACKETS_IN_QUEUE)
        {
            RELEASE_NDIS_PACKET(pAd, pSkb);
            DBGPRINT(RT_DEBUG_TRACE, "too many frames (=%d) in M/BCAST PSQ, drop this one\n", pAd->MacTab.McastPsQueue.Number);
            return NDIS_STATUS_FAILURE;
        }
        else
        {

#ifndef TC_NO_SPIN_LOCK // Sam add
            spin_lock_irqsave(&pAd->MacTabLock, IrqFlags);
#endif
            InsertTailQueue(&pAd->MacTab.McastPsQueue, pSkb);

#ifndef TC_NO_SPIN_LOCK // Sam add
            spin_unlock_irqrestore(&pAd->MacTabLock, IrqFlags);
#endif                
            pAd->PortCfg.MBSSID[apidx].TimBitmap |= BIT8[0];  // mark MCAST/BCAST TIM bit
            DBGPRINT(RT_DEBUG_INFO, "at least 1 STA in psm, move M/BCAST to PSQ, TIM bitmap=%08x\n", pAd->PortCfg.MBSSID[apidx].TimBitmap);
        }
    }
    // else if the associted STA in power-save mode, frame also goes to PSQ
    else if (pMacEntry && (Sst == SST_ASSOC) && (PsMode == PWR_SAVE))
    {

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_lock_irqsave(&pAd->MacTabLock, IrqFlags);
#endif
        InsertTailQueue(&pMacEntry->PsQueue, pSkb);
      
#ifndef TC_NO_SPIN_LOCK // Sam add
	spin_unlock_irqrestore(&pAd->MacTabLock, IrqFlags);
#endif
        // mark corresponding TIM bit in outgoing BEACON frame
        if (Aid >= 32)
            pAd->PortCfg.MBSSID[apidx].TimBitmap2 |= BIT32[Aid-32];
        else
            pAd->PortCfg.MBSSID[apidx].TimBitmap |= BIT32[Aid];
        DBGPRINT(RT_DEBUG_TRACE, "target (AID=%d) in psm, move to PSQ, TIM bitmap=%02x-%02x\n", Aid, pAd->PortCfg.MBSSID[apidx].TimBitmap, pAd->PortCfg.MBSSID[apidx].TimBitmap2);
    }
    // 3. otherwise, transmit the frame
    else // (PsMode == PWR_ACTIVE) || (PsMode == PWR_UNKNOWN)
    {

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_lock_irqsave(&pAd->TxSwQueueLock, IrqFlags);
#endif
        InsertTailQueue(&pAd->TxSwQueue[QueIdx], pSkb);

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_unlock_irqrestore(&pAd->TxSwQueueLock, IrqFlags);
#endif
        DBGPRINT(RT_DEBUG_INFO, "TxSwQueue[%d] size=%d\n", QueIdx, pAd->TxSwQueue[QueIdx].Number);
    }

    pAd->RalinkCounters.OneSecOsTxCount[QueIdx]++; // TODO: for debug only. to be removed
    return NDIS_STATUS_SUCCESS;
}

/*
	========================================================================

	Routine	Description:
		This subroutine will scan through releative ring descriptor to find
		out avaliable free ring descriptor and compare with request size.
		
	Arguments:
		pAdapter	Pointer	to our adapter
		QueIdx	    Selected TX Ring
		
	Return Value:
		NDIS_STATUS_FAILURE		Not enough free descriptor
		NDIS_STATUS_SUCCESS		Enough free descriptor

	Note:
	
	========================================================================
*/
// Sam add
#ifndef NOT_CHANGE_ENDIAN_3 
NDIS_STATUS	RTMPFreeTXDRequest(
	IN		PRTMP_ADAPTER	pAdapter,
	IN		UCHAR			QueIdx,
	IN		UCHAR			NumberRequired,
	IN 		PUCHAR			FreeNumberIs)
{
	INT			    FreeNumber = 0;
	PTXD_STRUC		pTxD;
#ifdef BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
	PRTMP_TX_RING   pTxRing;
	PRTMP_MGMT_RING pMgmtRing;
	NDIS_STATUS		Status = NDIS_STATUS_FAILURE;

	switch (QueIdx)
	{
		case QID_AC_BK:
		case QID_AC_BE:
		case QID_AC_VI:
		case QID_AC_VO:
		case QID_HCCA:
// TODO: do we need to wrap the code by SpinLock?
	        pTxRing = &pAdapter->TxRing[QueIdx];
#ifndef BIG_ENDIAN
			pTxD  = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
#else
		    pDestTxD  = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
		    TxD = *pDestTxD;
		    pTxD = &TxD;
		    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

            // ring full waiting for DmaDoneInt() to release skb buffer
            if (pTxD->bWaitingDmaDoneInt == 1)
                FreeNumber = 0;
            else 
            {
                FreeNumber = TX_RING_SIZE + pTxRing->NextTxDmaDoneIndex - pTxRing->CurTxIndex;
                if (FreeNumber > TX_RING_SIZE)     
                    FreeNumber -= TX_RING_SIZE;
            }

			if (FreeNumber >= NumberRequired)
				Status = NDIS_STATUS_SUCCESS;
			break;
			
		case QID_MGMT:
		    pMgmtRing = &pAdapter->MgmtRing;
#ifndef BIG_ENDIAN
			pTxD  = (PTXD_STRUC) pMgmtRing->Cell[pMgmtRing->CurTxIndex].AllocVa;
#else
		    pDestTxD  = (PTXD_STRUC) pMgmtRing->Cell[pMgmtRing->CurTxIndex].AllocVa;
		    TxD = *pDestTxD;
		    pTxD = &TxD;
		    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif
			

            if (pTxD->bWaitingDmaDoneInt == 1)
                FreeNumber = 0;
            else
            {
                FreeNumber = MGMT_RING_SIZE + pMgmtRing->NextTxDmaDoneIndex - pMgmtRing->CurTxIndex;
                if (FreeNumber > MGMT_RING_SIZE) 
                    FreeNumber -= MGMT_RING_SIZE;
            }

			if (FreeNumber >= NumberRequired)
				Status = NDIS_STATUS_SUCCESS;
			break;

		default:
			break;
	}
	
	*FreeNumberIs = (UCHAR)FreeNumber;
	return (Status);
}
#else // NOT_CHANGE_ENDIAN_3

NDIS_STATUS	RTMPFreeTXDRequest(
	IN		PRTMP_ADAPTER	pAdapter,
	IN		UCHAR			QueIdx,
	IN		UCHAR			NumberRequired,
	IN 		PUCHAR			FreeNumberIs)
{
	INT			    FreeNumber = 0;

	// Sam PTXD_STRUC		pTxD;
	PTXD_BIG_STRUC		pTxBD;
#ifdef BIG_ENDIAN
//    PTXD_STRUC      pDestTxD;
//    TXD_STRUC       TxD;
#endif
	PRTMP_TX_RING   pTxRing;
	PRTMP_MGMT_RING pMgmtRing;
	NDIS_STATUS		Status = NDIS_STATUS_FAILURE;

	switch (QueIdx)
	{
		case QID_AC_BK:
		case QID_AC_BE:
		case QID_AC_VI:
		case QID_AC_VO:
		case QID_HCCA:
// TODO: do we need to wrap the code by SpinLock?
	        pTxRing = &pAdapter->TxRing[QueIdx];
#ifndef BIG_ENDIAN
			pTxD  = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
#else
			
		    // Sam pDestTxD  = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
		    pTxBD  = (PTXD_BIG_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
		    // Sam TxD = *pDestTxD;
		    // Sam pTxD = &TxD;
		    // Sam RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

       	    // ring full waiting for DmaDoneInt() to release skb buffer
            		// Sam if (pTxD->bWaitingDmaDoneInt == 1)
            		if (pTxBD->ulword5 & 0x00000001)
                		FreeNumber = 0;
            		else 
            		{
                		FreeNumber = TX_RING_SIZE + pTxRing->NextTxDmaDoneIndex - pTxRing->CurTxIndex;
               			if (FreeNumber > TX_RING_SIZE)     
                    		FreeNumber -= TX_RING_SIZE;
            		}

		    	if (FreeNumber >= NumberRequired)
				Status = NDIS_STATUS_SUCCESS;
			break;
			
		case QID_MGMT:
		    pMgmtRing = &pAdapter->MgmtRing;
#ifndef BIG_ENDIAN
			pTxD  = (PTXD_STRUC) pMgmtRing->Cell[pMgmtRing->CurTxIndex].AllocVa;
#else
		    // Sam pDestTxD  = (PTXD_STRUC) pMgmtRing->Cell[pMgmtRing->CurTxIndex].AllocVa;
			pTxBD  = (PTXD_BIG_STRUC) pMgmtRing->Cell[pMgmtRing->CurTxIndex].AllocVa;
		    // Sam TxD = *pDestTxD;
		    // Sam pTxD = &TxD;
		    // Sam RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif
			

            // if (pTxD->bWaitingDmaDoneInt == 1)
            if (pTxBD->ulword5 & 0x00000001)
                FreeNumber = 0;
            else
            {
                FreeNumber = MGMT_RING_SIZE + pMgmtRing->NextTxDmaDoneIndex - pMgmtRing->CurTxIndex;
                if (FreeNumber > MGMT_RING_SIZE) 
                    FreeNumber -= MGMT_RING_SIZE;
            }

			if (FreeNumber >= NumberRequired)
				Status = NDIS_STATUS_SUCCESS;
			break;

		default:
			break;
	}
	
	*FreeNumberIs = (UCHAR)FreeNumber;
	return (Status);
}
#endif // NOT_CHANGE_ENDIAN_3
// End Sam add



#if 1  // Sam add for debug
void dump_descriptor_content(void *address)
{
int i;
unsigned long *dump_idx=address;
for (i=0;i<16;i++,dump_idx++)
printk("%08X ",*dump_idx);
printk("\n");
}
#endif

/*
	========================================================================

	Routine	Description:
		Copy frame from waiting queue into relative ring buffer and set 
	appropriate ASIC register to kick hardware encryption before really
	sent out to air.
		
	Arguments:
		pAdapter		Pointer	to our adapter
		PNDIS_PACKET	Pointer to outgoing Ndis frame
		NumberOfFrag	Number of fragment required
		
	Return Value:
		None

	Note:
	
	========================================================================
*/
NDIS_STATUS	RTMPHardTransmit(
	IN	PRTMP_ADAPTER	pAd,
	IN	struct sk_buff  *pSkb,
	IN  UCHAR           QueIdx,
	IN  BOOLEAN			bMoreData)
{
    PUCHAR          pSrcBufVA, pNextPacketBufVA;
    ULONG           SrcBufLen, NextPacketBufLen=0;
    UCHAR           SrcBufIdx;
    ULONG           SrcBufPA;
    USHORT          SrcRemainingBytes;
    UCHAR           FrameGap;
    HEADER_802_11   Header_802_11;
    PHEADER_802_11  pHeader80211;
    PUCHAR          pExtraLlcSnapEncap; // NULL: no extra LLC/SNAP is required
    UCHAR           CipherAlg = CIPHER_NONE;
// Sam add NOT_CHANGE_ENDIAN_3
#ifndef NOT_CHANGE_ENDIAN_3
    PTXD_STRUC      pTxD;
#ifdef BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
#else
    PTXD_STRUC	    pTxD;
    PTXD_BIG_STRUC  pTxBD;
#endif
// End Sam add
    BOOLEAN         bEAPOLFrame;
    BOOLEAN         bAckRequired;
    ULONG           Iv16, Iv32;
    UCHAR           RetryMode = SHORT_RETRY;
    USHORT          AckDuration = 0;
    UCHAR           KeyIdx = 0, KeyTable = SHARED_KEY_TABLE;
    PCIPHER_KEY     pKey;
    UCHAR           PID;
    PRTMP_TX_RING   pTxRing = &pAd->TxRing[QueIdx];
    PRTMP_SCATTER_GATHER_LIST   pSGList = NULL;
    RTMP_SCATTER_GATHER_LIST    LocalSGList;
    struct sk_buff  *pNextSkb;
    BOOLEAN         bClonePacket;
    UCHAR           MpduRequired, RtsRequired, UserPriority;
    UCHAR           TxRate;
    PMAC_TABLE_ENTRY pMacEntry = NULL;
    BOOLEAN         bWdsPacket = FALSE;
    NDIS_802_11_WEP_STATUS	EncryptType = Ndis802_11EncryptionDisabled;
    UCHAR           apidx;
    UCHAR           WdsIdx = 0;
    ULONG			IrqFlags;
    USHORT          EncryptionOverhead = 0;
    UCHAR	    SrcAddr[6];

#if MEASURE_TX_TIME
unsigned long intime=0,outtime=0;
#endif
#if MEASURE_TX_TIME
tx_measure_count1++;
RTMP_IO_READ32(pAd, TXRX_CSR12, &intime);
#endif


    if (pAd->PortCfg.RadarDetect.RDMode != RD_NORMAL_MODE)
	{
		RELEASE_NDIS_PACKET(pAd, pSkb);
        return (NDIS_STATUS_FAILURE);
	}

    //
    // Prepare packet information structure which will be query for buffer descriptor
    //
    pSrcBufVA = (PVOID)pSkb->data;
    SrcBufLen = pSkb->len;

    MpduRequired = RTMP_GET_PACKET_FRAGMENTS(pSkb);
    RtsRequired  = RTMP_GET_PACKET_RTS(pSkb);
    UserPriority = RTMP_GET_PACKET_UP(pSkb);
    TxRate       = RTMP_GET_PACKET_TXRATE(pSkb);

    // Find out the packet comes from which interface(MBSSID/WDS/MAIN_SSID)
    if (RTMP_GET_PACKET_NET_DEVICE(pSkb) >= MIN_NET_DEVICE_FOR_WDS)
    {// WDS packet
        bWdsPacket = TRUE;
        WdsIdx = RTMP_GET_PACKET_NET_DEVICE(pSkb) - MIN_NET_DEVICE_FOR_WDS;
        apidx = MAIN_MBSSID;
    }
    else
    {// Multiple BSSID packet
        bWdsPacket = FALSE;
        apidx = RTMP_GET_PACKET_NET_DEVICE(pSkb);
        if ((*pSrcBufVA & 0x01) == 0)
        {
	        pMacEntry = &pAd->MacTab.Content[(UCHAR)RTMP_GET_PACKET_AID(pSkb)];
        }
    }

    DBGPRINT(RT_DEBUG_INFO,"HardTransmit(RTS=%d,Frag=%d,UP=%d,TxRate=%d,apidx=%d,bWds=%d)\n",RtsRequired,MpduRequired,UserPriority,TxRate,apidx,bWdsPacket);

    if (SrcBufLen < 14)
    {
        DBGPRINT(RT_DEBUG_ERROR,"RTMPHardTransmit --> Skb buffer error !!!\n");
        RELEASE_NDIS_PACKET(pAd, pSkb);
        return (NDIS_STATUS_FAILURE);
    }

    //
	// If DHCP datagram or ARP datagram , we need to send it as Low rates.
	//
	if (pAd->PortCfg.Channel <= 14)
	{
		//
		// Case 802.11 b/g
		// basic channel means that we can use CCKM's low rate as RATE_1.
		//		
		if ((TxRate != RATE_1) && RTMPCheckDHCPFrame(pAd, pSkb))
			TxRate = RATE_1;
	}
	else
	{
		//
		// Case 802.11a
		// We must used OFDM's low rate as RATE_6, note RATE_1 is not allow
		// Only OFDM support on Channel > 14
		//
		if ((TxRate != RATE_6) && RTMPCheckDHCPFrame(pAd, pSkb))
			TxRate = RATE_6;
	}

    bClonePacket = FALSE;  // cloning is not necessary
    pNextSkb  = NULL;   // no aggregation is required

    if (((*((PUCHAR) pSrcBufVA) & 0x01) == 0) && pMacEntry)
    {// Unicast packet
    	EncryptType = pMacEntry->WepStatus;
    }
    else if (bWdsPacket == TRUE)
    {// WDS packet
    	EncryptType = pAd->WdsTab.WepStatus;
    }
    else
    {// multicast packet
    	EncryptType = pAd->PortCfg.MBSSID[apidx].GroupKeyWepStatus;
    }

    // check if aggregation applicable on this MSDU and the next one.
    // NOTE: aggregation not applicable when CKIP inused. because it's difficult for driver
    //       to calculate CMIC on the aggregated MSDU
    // If packet's MpduRequired > 1, then turn off aggregation due to receiver can not receive this kind of packets
	if (pAd->PortCfg.bAggregationCapable &&
		pMacEntry                                                         &&
        CLIENT_STATUS_TEST_FLAG(pMacEntry, fCLIENT_STATUS_AGGREGATION_CAPABLE) &&
        (pAd->TxSwQueue[QueIdx].Head != NULL)                             &&
        (TxRate >= RATE_6)                                                &&
        TxFrameIsAggregatible(pAd, NULL, pSrcBufVA))
    {
        DBGPRINT(RT_DEBUG_INFO,"AGGRE: 1st MSDU aggregatible(len=%d)\n", pSkb->len);

        pNextSkb = (struct sk_buff*)RemoveHeadQueue(&pAd->TxSwQueue[QueIdx]);

        pNextPacketBufVA = (PVOID)pNextSkb->data;
        NextPacketBufLen = pNextSkb->len;

        if (TxFrameIsAggregatible(pAd, pSrcBufVA, pNextPacketBufVA))
        {
            // need to clone pNextPacket to assure it uses only 1 scatter buffer
           	DBGPRINT(RT_DEBUG_INFO,"AGGRE: 2nd MSDU aggregatible(len=%d)\n", NextPacketBufLen);
        }
        else
        {
            // can't aggregate. put next packe back to TxSwQueue
            InsertHeadQueue(&pAd->TxSwQueue[QueIdx], pNextSkb);
            pNextSkb = NULL;  
        }
    }

    // Decide if Packet Cloning is required -
    // 1. when fragmentation && TKIP is inused, we have to clone it into a single buffer
    //    NDIS_PACKET so that driver can pre-cluculate and append TKIP MIC at tail of the
    //    source packet before hardware fragmentation can be performed
    // 2. if too many physical buffers in scatter-gather list (>4), we have to clone it into
    //    a single buffer NDIS_PACKET before furthur processing
    if ((RTMP_GET_PACKET_SOURCE(pSkb) == PKTSRC_NDIS) && (bClonePacket == FALSE))
    {
        if ((MpduRequired > 1) && (EncryptType == Ndis802_11Encryption2Enabled))
        {
            bClonePacket = TRUE;
        }
        else
        {
        	if (skb_shinfo(pSkb)->nr_frags != 0)
        	{
        		DBGPRINT(RT_DEBUG_WARN,"\nnr_frags=%d\n\n", skb_shinfo(pSkb)->nr_frags);
        	}
        	if (skb_shinfo(pSkb)->nr_frags == 0)
        	{
	            LocalSGList.NumberOfElements = 1;
		        LocalSGList.Elements[0].Length = SrcBufLen;
		        LocalSGList.Elements[0].Address = pSkb->data;
		        LocalSGList.Elements[1].Length = 0;
		        LocalSGList.Elements[1].Address = NULL;
        	}
        	else
        	{
        		DBGPRINT(RT_DEBUG_WARN,"Scatter-gather packet (nr_frags=%d)\n\n\n", skb_shinfo(pSkb)->nr_frags);
        		bClonePacket = TRUE;
        	}
        }
    }

    // Clone then release the original skb buffer
    if (bClonePacket)
    {
        struct sk_buff  *pOutSkb;
        NDIS_STATUS  Status;
	
        Status = RTMPCloneNdisPacket(pAd, pSkb, &pOutSkb);
        RELEASE_NDIS_PACKET(pAd, pSkb);
        if (Status != NDIS_STATUS_SUCCESS)
        {
        	DBGPRINT(RT_DEBUG_ERROR,"RTMPHardTransmit --> RTMPCloneNdisPacket error !!!\n");
            return Status;
        }

        // Use the new cloned packet from now on
        pSkb = pOutSkb;
        RTMP_SET_PACKET_UP(pSkb, UserPriority);
        
        pSrcBufVA = (PVOID)pSkb->data;
        SrcBufLen = pSkb->len;
    }

    // use local scatter-gather structure for internally created skb buffer
    // Can't use NDIS_PER_PACKET_INFO() to get scatter gather list
    //if (RTMP_GET_PACKET_SOURCE(pSkb) != PKTSRC_NDIS)
    {
        LocalSGList.NumberOfElements = 1;
        LocalSGList.Elements[0].Length = SrcBufLen;
        LocalSGList.Elements[0].Address = pSkb->data;
        LocalSGList.Elements[1].Length = 0;
        LocalSGList.Elements[1].Address = NULL;

        // link next MSDU into scatter list, if any
        if (pNextSkb)
        {
            LocalSGList.NumberOfElements = 2;
            LocalSGList.Elements[0].Length = SrcBufLen;
	        LocalSGList.Elements[0].Address = pSkb->data;
            LocalSGList.Elements[1].Length = NextPacketBufLen;
            LocalSGList.Elements[1].Address = pNextSkb->data;
            pSkb->len += NextPacketBufLen;
        }
    }
    pSGList = &LocalSGList;

    // ----------------------------------------
    // STEP 0.1 Add 802.1x protocol check.
    // ----------------------------------------
    
    // For non-WPA network, 802.1x message should not encrypt even privacy is on.
    if (NdisEqualMemory(EAPOL, pSrcBufVA + 12, 2))
        bEAPOLFrame = TRUE;
    else
        bEAPOLFrame = FALSE;

    // WPA 802.1x secured port control
    if(!bWdsPacket)
    {
        // in WPA mode, AP does not send packets before port secured.
        if (((pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA2)
        	|| (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPAPSK) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA2PSK)
        	|| (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPAPSKWPA2PSK) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA1WPA2))
        	&& (pAd->PortCfg.MBSSID[apidx].PortSecured == WPA_802_1X_PORT_NOT_SECURED) && (bEAPOLFrame == FALSE))
        {
            DBGPRINT(RT_DEBUG_INFO,"I/F(ra%d) RTMPHardTransmit --> Drop packet before AP secured !!!\n", apidx);
            RELEASE_NDIS_PACKET(pAd, pSkb);
            return (NDIS_STATUS_FAILURE);
        }
        // if 802.1x, AP does not send packets other than EAPOL before this session control port set to "accept all".
		if ((pAd->PortCfg.MBSSID[apidx].IEEE8021X == TRUE) && (pMacEntry) &&
			(pMacEntry->PrivacyFilter == Ndis802_11PrivFilter8021xWEP) && (bEAPOLFrame == FALSE))
		{
			DBGPRINT(RT_DEBUG_TRACE,"RTMPHardTransmit --> Drop packet before this control port accept all !!!\n");
			RELEASE_NDIS_PACKET(pAd, pSkb);
			return (NDIS_STATUS_FAILURE);
		}
    }

    // -------------------------------------------
    // STEP 0.2. some early parsing
    // -------------------------------------------
    
    // 1. traditional TX burst
    if (pAd->PortCfg.bEnableTxBurst && (pAd->Sequence & 0x7))
        FrameGap = IFS_SIFS;
    // 2. frame belonging to AC that has non-zero TXOP
    else if (pAd->PortCfg.MBSSID[apidx].bWmmCapable && pAd->PortCfg.APEdcaParm.bValid && pAd->PortCfg.APEdcaParm.Txop[QueIdx])
        FrameGap = IFS_SIFS;
    // 3. otherwise, always BACKOFF before transmission
    else
        FrameGap = IFS_BACKOFF;     // Default frame gap mode

    // if orginal Ethernet frame contains no LLC/SNAP, then an extra LLC/SNAP encap is required 
    if (((*(pSrcBufVA + 12) << 8) + *(pSrcBufVA + 13)) > 1500)
    {
        pExtraLlcSnapEncap = SNAP_802_1H;
        if (NdisEqualMemory(IPX, pSrcBufVA + 12, 2) || 
            NdisEqualMemory(APPLE_TALK, pSrcBufVA + 12, 2))
        {
            pExtraLlcSnapEncap = SNAP_BRIDGE_TUNNEL;
        }
    }
    else
        pExtraLlcSnapEncap = NULL;

    // -----------------------------------------------------------------
    // STEP 2. MAKE A COMMON 802.11 HEADER SHARED BY ENTIRE FRAGMENT BURST.
    // -----------------------------------------------------------------

    pAd->Sequence ++;

    NdisZeroMemory(&Header_802_11, sizeof(HEADER_802_11));
    Header_802_11.FC.FrDs = 1;
    Header_802_11.FC.Type = BTYPE_DATA;
    Header_802_11.FC.SubType = SUBTYPE_DATA;
    Header_802_11.Sequence   = pAd->Sequence;
    
    // Inform STA not fail in sleep state when STA in power saving mode
    if (bMoreData == TRUE)
    {
    	Header_802_11.FC.MoreData = 1;
    }
    
    if (bWdsPacket)
    {
        Header_802_11.FC.ToDs = 1;
        COPY_MAC_ADDR(Header_802_11.Addr1, pAd->WdsTab.WdsEntry[(RTMP_GET_PACKET_NET_DEVICE(pSkb) - MIN_NET_DEVICE_FOR_WDS)].WdsAddr);    // to AP2
        COPY_MAC_ADDR(Header_802_11.Addr2, pAd->PortCfg.MBSSID[MAIN_MBSSID].Bssid);                // from AP1
        COPY_MAC_ADDR(Header_802_11.Addr3, pSrcBufVA);                                      // DA
         
        // NOTE: ADDR4(=SA) will be appended later directly into pTxD->TxBuf0
    }
    else
    {
        // TODO: how about "MoreData" bit? AP need to set this bit especially for PS-POLL response
        COPY_MAC_ADDR(Header_802_11.Addr1, pSrcBufVA);                // DA
        COPY_MAC_ADDR(Header_802_11.Addr2, pAd->PortCfg.MBSSID[apidx].Bssid);  // BSSID
        COPY_MAC_ADDR(Header_802_11.Addr3, pSrcBufVA + MAC_ADDR_LEN); // SA
    }

    //  AP's WMM-inused or not should depends on MAC table. It's per-client not per-system
    if (pAd->PortCfg.MBSSID[apidx].bWmmCapable && pMacEntry && CLIENT_STATUS_TEST_FLAG(pMacEntry, fCLIENT_STATUS_WMM_CAPABLE))
        Header_802_11.FC.SubType = SUBTYPE_QDATA;

    if (Header_802_11.Addr1[0] & 0x01) // Multicast or Broadcast
    {
        bAckRequired = FALSE;
        PID = PTYPE_SPECIAL|PSUBTYPE_DATA_NO_ACK;
        pAd->WlanCounters.MulticastTransmittedFrameCount++;
    }
    else
    {
        bAckRequired = TRUE;
        // PID is used in TxDoneIsr to calculate per-client/WDS TX statistics 
        // b6-7 marks this frame requires an ACK; b0-5: 0-59 client AID, 60-63 WDS link 0-3
        PID = PTYPE_DATA_REQUIRE_ACK; 
        if (bWdsPacket)
            PID += WdsIdx + WDS_PAIRWISE_KEY_OFFSET;
        else if (pMacEntry)
            PID += pMacEntry->Aid;
    }

    // --------------------------------------------------------
    // STEP 3. FIND ENCRYPT KEY AND DECIDE CIPHER ALGORITHM
    //      Find the WPA key, either Group or Pairwise Key
    //      LEAP + TKIP also use WPA key.
    // --------------------------------------------------------
    // Decide WEP bit and cipher suite to be used. Same cipher suite should be used for whole fragment burst
    // In Cisco CCX 2.0 Leap Authentication
    //         WepStatus is Ndis802_11Encryption1Enabled but the key will use PairwiseKey
    //         Instead of the SharedKey, SharedKey Length may be Zero.
    // APFindEncryptKey(pAd, WdsOrAid, bEAPOLFrame, Header_802_11.Addr1[0] & 0x01, &CipherAlg, &KeyTable, &KeyIdx, &pKey);
    pKey = NULL;

    if ((bEAPOLFrame) ||
        (EncryptType == Ndis802_11Encryption2Enabled)  ||
        (EncryptType == Ndis802_11Encryption3Enabled)  ||
        (EncryptType == Ndis802_11Encryption4Enabled))
    {
        if (bWdsPacket)        // to WDS link
        {
            KeyIdx     = WDS_PAIRWISE_KEY_OFFSET + WdsIdx;
            KeyTable   = PAIRWISE_KEY_TABLE;
            CipherAlg  = pAd->WdsTab.Wpa_key.CipherAlg;
            if (CipherAlg)
                pKey = &pAd->WdsTab.Wpa_key;
        }
        else if (Header_802_11.Addr1[0] & 0x01)        // M/BCAST to local BSS, use default key in shared key table
        {
            KeyTable   = SHARED_KEY_TABLE; 
            CipherAlg  = pAd->PortCfg.MBSSID[apidx].SharedKey[pAd->PortCfg.MBSSID[apidx].DefaultKeyId].CipherAlg;
            if (CipherAlg)
                pKey = &pAd->PortCfg.MBSSID[apidx].SharedKey[pAd->PortCfg.MBSSID[apidx].DefaultKeyId];
            KeyIdx     = pAd->PortCfg.MBSSID[apidx].DefaultKeyId + (MAX_MBSSID_NUM * apidx);
        }
        else if (pMacEntry)                      // unicast to local BSS
        {
            KeyIdx     = pMacEntry->Aid;
            KeyTable   = PAIRWISE_KEY_TABLE;
            CipherAlg  = pMacEntry->PairwiseKey.CipherAlg;
            if (CipherAlg)
                pKey = &pMacEntry->PairwiseKey;
        }
    }
    else if (EncryptType == Ndis802_11Encryption1Enabled) // WEP or CKIP, always use shared key table
    {
        KeyTable   = SHARED_KEY_TABLE;    // shared key table
        CipherAlg  = pAd->PortCfg.MBSSID[apidx].SharedKey[pAd->PortCfg.MBSSID[apidx].DefaultKeyId].CipherAlg;
        if (CipherAlg)
            pKey = &pAd->PortCfg.MBSSID[apidx].SharedKey[pAd->PortCfg.MBSSID[apidx].DefaultKeyId];
        KeyIdx     = pAd->PortCfg.MBSSID[apidx].DefaultKeyId + (MAX_MBSSID_NUM * apidx);
    }
    else
    {
        CipherAlg = CIPHER_NONE;
        KeyTable  = SHARED_KEY_TABLE;
        KeyIdx    = 0;
        pKey      = NULL;
    }

	if ((Header_802_11.Addr1[0] & 0x01) == 0)
	{
	    DBGPRINT(RT_DEBUG_INFO,"HardTransmit(apidx=%d,EAPOL=%d, Mcast=%d), Alg=%s, Ktab=%d, key#=%d\n", 
	        apidx, bEAPOLFrame, Header_802_11.Addr1[0] & 0x01, CipherName[CipherAlg], KeyTable, KeyIdx);
	}

    if (CipherAlg != CIPHER_NONE)
        Header_802_11.FC.Wep = 1;
    
    // STEP 3.1 if TKIP is used and fragmentation is required. Driver has to
    //          append TKIP MIC at tail of the scatter buffer (This must be the
    //          ONLY scatter buffer in the skb buffer). 
    //          MAC ASIC will only perform IV/EIV/ICV insertion but no TKIP MIC
    if ((MpduRequired > 1) && (CipherAlg == CIPHER_TKIP))
    {
        ASSERT(pSGList->NumberOfElements == 1);
        RTMPCalculateMICValue(pAd, pSkb, pExtraLlcSnapEncap, pKey);
        NdisMoveMemory(pSrcBufVA + SrcBufLen, pAd->PrivateInfo.Tx.MIC, 8);
        SrcBufLen += 8;
        pSkb->len += 8;
        CipherAlg = CIPHER_TKIP_NO_MIC;
    }

    // ----------------------------------------------------------------
    // STEP 3. Make RTS frame or CTS-to-self frame if required
    // ----------------------------------------------------------------

    //
    // calcuate the overhead bytes that encryption algorithm may add. This
    // affects the calculate of "duration" field
    //
	if ((CipherAlg == CIPHER_WEP64) || (CipherAlg == CIPHER_WEP128)) 
		EncryptionOverhead = 8; //WEP: IV[4] + ICV[4];
	else if (CipherAlg == CIPHER_TKIP_NO_MIC)
		EncryptionOverhead = 12;//TKIP: IV[4] + EIV[4] + ICV[4], MIC will be added to TotalPacketLength
	else if (CipherAlg == CIPHER_TKIP)
		EncryptionOverhead = 20;//TKIP: IV[4] + EIV[4] + ICV[4] + MIC[8]
	else if (CipherAlg == CIPHER_AES)
		EncryptionOverhead = 16;    // AES: IV[4] + EIV[4] + MIC[8]
	else
		EncryptionOverhead = 0;

    // decide how much time an ACK/CTS frame will consume in the air
    AckDuration = RTMPCalcDuration(pAd, pAd->PortCfg.ExpectedACKRate[TxRate], 14);

    if (RtsRequired)
    {
        unsigned int NextMpduSize;

        // If fragment required, MPDU size is maximum fragment size
        // Else, MPDU size should be frame with 802.11 header & CRC
        if (MpduRequired > 1)
            NextMpduSize = pAd->PortCfg.FragmentThreshold;
        else
        {
            NextMpduSize = pSkb->len + LENGTH_802_11 + LENGTH_CRC - LENGTH_802_3;
            if (pExtraLlcSnapEncap)
                NextMpduSize += LENGTH_802_1_H;
        }

        RTMPSendRTSFrame(pAd, Header_802_11.Addr1, NextMpduSize + EncryptionOverhead,TxRate,
        	pAd->PortCfg.ExpectedACKRate[TxRate], AckDuration, QueIdx, FrameGap, apidx);
        
        // RTS/CTS-protected frame should use LONG_RETRY (=4) and SIFS
        RetryMode = LONG_RETRY;
        FrameGap = IFS_SIFS;
    }

    // --------------------------------------------------------
    // STEP 5. START MAKING MPDU(s)
    //      Start Copy Ndis Packet into Ring buffer.
    //      For frame required more than one ring buffer (fragment), all ring buffers
    //      have to be filled before kicking start tx bit.
    //      Make sure TX ring resource won't be used by other threads
    // --------------------------------------------------------
    
    SrcBufIdx         = 0;
	SrcBufPA		  = pci_map_single(pAd->pPci_Dev, pSGList->Elements[0].Address, SrcBufLen, PCI_DMA_TODEVICE);
    SrcBufPA         += LENGTH_802_3;  // skip 802.3 header
    SrcBufLen        -= LENGTH_802_3;  // skip 802.3 header
    SrcRemainingBytes = pSkb->len - LENGTH_802_3;

    // If having VLAN tag, skip it when transmit
	if (((pSrcBufVA[12] << 8) + pSrcBufVA[13]) == 0x8100)
	{
		COPY_MAC_ADDR(&SrcAddr, pSrcBufVA + MAC_ADDR_LEN);
		SrcBufPA += 4;
		SrcBufLen -= 4;
		SrcRemainingBytes -= 4;
		pSrcBufVA += 4;
	}


#ifndef TC_NO_SPIN_LOCK // Sam add
    spin_lock_irqsave(&pAd->TxRingLock, IrqFlags);
#endif
    do
    {
        PUCHAR pDestBufVA, pDest;
        UINT   SrcBytesCopied;
        UINT   FreeMpduSize, MpduSize = 0;
        
        //
        // STEP 5.1 ACQUIRE TXD
        //
        pDestBufVA = (PUCHAR) pTxRing->Cell[pTxRing->CurTxIndex].DmaBuf.AllocVa;              

// Sam add
#ifndef NOT_CHANGE_ENDIAN_3
#ifndef BIG_ENDIAN
        pTxD  = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
#else
        pDestTxD = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
        TxD = *pDestTxD;
        pTxD = &TxD;
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif
#else // NOT_CHANGE_ENDIAN_3 defined
	pTxD = (PTXD_STRUC) pTxRing->Cell[pTxRing->CurTxIndex].AllocVa;
	pTxBD = (PTXD_BIG_STRUC)pTxD;

	pTxBD->ulword1 = SWAP32(pTxBD->ulword1);
	pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
	pTxBD->ulword12 = SWAP32(pTxBD->ulword12);
	pTxBD->ulword13 = SWAP32(pTxBD->ulword13);
#endif // NOT_CHANGE_ENDIAN_3


        
#ifndef NOT_CHANGE_ENDIAN_3
        if ((pTxD->Owner == DESC_OWN_NIC) || (pTxD->bWaitingDmaDoneInt == 1))  // DESC_OWN_NIC = 1
#else
        if ((pTxBD->ulword0 & 0x01000000) || (pTxBD->ulword5 & 0x00000001))
#endif
        {
            // Descriptor owned by NIC. No descriptor avaliable
            // This should not happen since caller guaranteed.
            DBGPRINT_ERR("RTMPHardTransmit: TX RING full\n");
            pAd->RalinkCounters.TxRingErrCount++;

#ifndef TC_NO_SPIN_LOCK // Sam add
            spin_unlock_irqrestore(&pAd->TxRingLock, IrqFlags);
#endif   
            RELEASE_NDIS_PACKET(pAd, pSkb);
            if (pNextSkb)
            {
                RELEASE_NDIS_PACKET(pAd, pNextSkb);
            }
            return (NDIS_STATUS_RESOURCES);
        }

        //
        // STEP 5.2 PUT IVOFFSET, IV, EIV INTO TXD
        //
        if (bWdsPacket)    // NOTE: no QOS DATA format on WDS link so far
            pTxD->IvOffset = LENGTH_802_11_WITH_ADDR4;
        else 
        {
            pTxD->IvOffset  = LENGTH_802_11;
        
            if (pAd->PortCfg.MBSSID[apidx].bWmmCapable && pMacEntry && CLIENT_STATUS_TEST_FLAG(pMacEntry, fCLIENT_STATUS_WMM_CAPABLE))
                pTxD->IvOffset += 2;  // add QOS CONTROL bytes
        }
        
        if ((CipherAlg == CIPHER_WEP64) || (CipherAlg == CIPHER_WEP128))
        {
            PUCHAR pTmp;
#ifndef NOT_CHANGE_ENDIAN_3 // Sam add
            pTmp = (PUCHAR) &pTxD->Iv;
#else
	   pTmp = (PCHAR) &pTxBD->Iv;  // Iv and Eiv are not need endian change
#endif // End Sam add
            *pTmp       = RandomByte(pAd);
            *(pTmp + 1) = RandomByte(pAd);
            *(pTmp + 2) = RandomByte(pAd);
            *(pTmp + 3) = (pAd->PortCfg.MBSSID[apidx].DefaultKeyId << 6);
        }
        else if ((CipherAlg == CIPHER_TKIP) || (CipherAlg == CIPHER_TKIP_NO_MIC))
        {
        	UCHAR	kidx;

        	if (Header_802_11.Addr1[0] & 0x01)
        		kidx = pAd->PortCfg.MBSSID[apidx].DefaultKeyId;
        	else
        		kidx = 0;
        	
            RTMPInitTkipEngine(
                pAd,
                pKey->Key,
                kidx,
                Header_802_11.Addr2,
                pKey->TxMic,
                pKey->TxTsc,
                &Iv16,
                &Iv32);
#ifndef NOT_CHANGE_ENDIAN_3 // Sam add
            NdisMoveMemory(&pTxD->Iv, &Iv16, 4);   // Copy IV
            NdisMoveMemory(&pTxD->Eiv, &Iv32, 4);  // Copy EIV
#else
            NdisMoveMemory(&pTxBD->Iv, &Iv16, 4);   // Copy IV
            NdisMoveMemory(&pTxBD->Eiv, &Iv32, 4);  // Copy EIV
#endif
            INC_TX_TSC(pKey->TxTsc);               // Increase TxTsc for next transmission
        }
        else if (CipherAlg == CIPHER_AES)
        {
            PUCHAR  pTmp;
            UCHAR	kidx;

        	if (Header_802_11.Addr1[0] & 0x01)
        		kidx = pAd->PortCfg.MBSSID[apidx].DefaultKeyId;
        	else
        		kidx = 0;
        	
            pTmp = (PUCHAR) &Iv16;
            *pTmp       = pKey->TxTsc[0];
            *(pTmp + 1) = pKey->TxTsc[1];
            *(pTmp + 2) = 0;
            *(pTmp + 3) = (kidx << 6) | 0x20;
            //Iv32 = *(PULONG)(&pKey->TxTsc[2]);
			NdisMoveMemory(&Iv32, &pKey->TxTsc[2], 4);

#ifndef NOT_CHANGE_ENDIAN_3 // Sam add
            NdisMoveMemory(&pTxD->Iv, &Iv16, 4);    // Copy IV
            NdisMoveMemory(&pTxD->Eiv, &Iv32, 4);   // Copy EIV
#else
            NdisMoveMemory(&pTxBD->Iv, &Iv16, 4);    // Copy IV
            NdisMoveMemory(&pTxBD->Eiv, &Iv32, 4);   // Copy EIV
#endif // End Sam add

            INC_TX_TSC(pKey->TxTsc);                // Increase TxTsc for next transmission
        }

        //
        // STEP 5.3 COPY 802.11 HEADER INTO 1ST DMA BUFFER
        //
        pDest = pDestBufVA;
        NdisMoveMemory(pDest, &Header_802_11, sizeof(Header_802_11));
        pDest       += sizeof(Header_802_11);
        FreeMpduSize = pAd->PortCfg.FragmentThreshold - sizeof(Header_802_11) - LENGTH_CRC;

        // TODO: 2004-12-27 add ADDR4 field if WDS frame
        if (bWdsPacket)
        {
            COPY_MAC_ADDR(pDest, &SrcAddr); // ADDR4 = SA
            pDest        += MAC_ADDR_LEN;
            FreeMpduSize -= MAC_ADDR_LEN;
        }
        else
        {
            // TODO: 2005-02-10 also check if the STA is WMM capable
            // NOTE: no QOS DATA format on WDS link so far
            if (pAd->PortCfg.MBSSID[apidx].bWmmCapable && pMacEntry && CLIENT_STATUS_TEST_FLAG(pMacEntry, fCLIENT_STATUS_WMM_CAPABLE))
            {
                // copy QOS CONTROL bytes
                *pDest        =  (UserPriority & 0x0f) | pAd->PortCfg.AckPolicy[QueIdx];
                *(pDest+1)    =  0;
                pDest         += 2;
                FreeMpduSize  -= 2;
                if (pAd->PortCfg.AckPolicy[QueIdx] != NORMAL_ACK) // ?????
                {
                    bAckRequired = FALSE;
                    PID = PTYPE_SPECIAL|PSUBTYPE_DATA_NO_ACK;
                }
            }
        }

        // if aggregation, put the 2nd MSDU length(extra 2-byte field) after QOS_CONTROL. little endian
        if (pNextSkb)
        {
            *pDest        =  (UCHAR)NextPacketBufLen & 0xff;
            *(pDest+1)    =  (UCHAR)(NextPacketBufLen >> 8);
            pDest         += 2;
            FreeMpduSize  = MAX_AGGREGATION_SIZE;
            ((PHEADER_802_11)pDestBufVA)->FC.Order = 1; // steal "order" bit to mark "aggregation"
        }

        //
        // STEP 5.4 COPY LLC/SNAP, CKIP MIC INTO 1ST DMA BUFFER ONLY WHEN THIS 
        //          MPDU IS THE 1ST OR ONLY FRAGMENT 
        //
        if (Header_802_11.Frag == 0)
        {
            if (pExtraLlcSnapEncap)
            {
                // Insert LLC-SNAP encapsulation
                NdisMoveMemory(pDest, pExtraLlcSnapEncap, 6);
                pDest += 6;
                NdisMoveMemory(pDest, pSrcBufVA + 12, 2);
                pDest += 2;
                FreeMpduSize -= LENGTH_802_1_H;
            }
        }

        // TX buf0 size fixed here
        pTxD->BufLen0    = (ULONG)(pDest - pDestBufVA);
        pTxD->BufCount   = 1;

        //
        // STEP 5.5 TRAVERSE scatter-gather list TO BUILD THE MPDU PAYLOAD
        //

        MpduSize         = pTxD->BufLen0;
        SrcBytesCopied   = 0;
        do
        {
            if (SrcBufLen == 0)
            {
                // do nothing. skip to next scatter-gather buffer
            }
            else if (SrcBufLen <= FreeMpduSize)
            {
                // scatter-gather buffer still fit into current MPDU
                switch (pTxD->BufCount) {
#ifndef NOT_CHANGE_ENDIAN_3
                    case 1: pTxD->BufPhyAddr1 = SrcBufPA;
                            pTxD->BufLen1     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 2: pTxD->BufPhyAddr2 = SrcBufPA;
                            pTxD->BufLen2     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 3: pTxD->BufPhyAddr3 = SrcBufPA;
                            pTxD->BufLen3     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 4: pTxD->BufPhyAddr4 = SrcBufPA;
                            pTxD->BufLen4     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    default:    // should never happen
                            break;
#else
                    case 1: pTxD->BufPhyAddr1 = SWAP32(SrcBufPA);
                            pTxD->BufLen1     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 2: pTxD->BufPhyAddr2 = SWAP32(SrcBufPA);
                            pTxD->BufLen2     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 3: pTxD->BufPhyAddr3 = SWAP32(SrcBufPA);
                            pTxD->BufLen3     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    case 4: pTxD->BufPhyAddr4 = SWAP32(SrcBufPA);
                            pTxD->BufLen4     = SrcBufLen;
                            pTxD->BufCount ++;
                            break;
                    default:    // should never happen
                            break;

#endif
                }

                SrcBytesCopied  += SrcBufLen;
                pDest           += SrcBufLen;
                FreeMpduSize    -= SrcBufLen;
                MpduSize        += SrcBufLen;
                SrcBufPA        += SrcBufLen;
                SrcBufLen        = 0;
            }
            else
            {
                // scatter-gather buffer exceed current MPDU. leave some of the buffer to next MPDU
                switch (pTxD->BufCount) {
#ifndef NOT_CHANGE_ENDIAN_3
                    case 1: pTxD->BufPhyAddr1 = SrcBufPA;
                            pTxD->BufLen1     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 2: pTxD->BufPhyAddr2 = SrcBufPA;
                            pTxD->BufLen2     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 3: pTxD->BufPhyAddr3 = SrcBufPA;
                            pTxD->BufLen3     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 4: pTxD->BufPhyAddr4 = SrcBufPA;
                            pTxD->BufLen4     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    default:    // should never happen
                            break;
#else
                    case 1: pTxD->BufPhyAddr1 = SWAP32(SrcBufPA);
                            pTxD->BufLen1     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 2: pTxD->BufPhyAddr2 = SWAP32(SrcBufPA);
                            pTxD->BufLen2     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 3: pTxD->BufPhyAddr3 = SWAP32(SrcBufPA);
                            pTxD->BufLen3     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    case 4: pTxD->BufPhyAddr4 = SWAP32(SrcBufPA);
                            pTxD->BufLen4     = FreeMpduSize;
                            pTxD->BufCount ++;
                            break;
                    default:    // should never happen
                            break;
#endif
                }
                SrcBytesCopied += FreeMpduSize;
                pDest          += FreeMpduSize;
                MpduSize       += FreeMpduSize;
                SrcBufPA       += FreeMpduSize;
                SrcBufLen      -= FreeMpduSize;

                // a complete MPDU is built. break out to write TXD of this MPDU
                break;
            }

            // advance to next scatter-gather BUFFER
            SrcBufIdx++;
            if (SrcBufIdx < pSGList->NumberOfElements)
            {
				SrcBufPA = pci_map_single(pAd->pPci_Dev, pSGList->Elements[SrcBufIdx].Address, pSGList->Elements[SrcBufIdx].Length, PCI_DMA_TODEVICE);
                SrcBufLen = pSGList->Elements[SrcBufIdx].Length;
            }
            else
                SrcBufLen = 0;

            if (SrcBufLen == 0)
                break;

        }   while (TRUE);       // End of copying payload

        // remaining size of the skb buffer payload
        SrcRemainingBytes -= SrcBytesCopied;

        //
        // STEP 5.6 MODIFY MORE_FRAGMENT BIT & DURATION FIELD. WRITE TXD
        //
        pHeader80211 = (PHEADER_802_11)pDestBufVA;
        if (SrcRemainingBytes > 0) // more fragment is required
        {
            UINT NextMpduSize;

            pHeader80211->FC.MoreFrag = 1;
            NextMpduSize = min(SrcRemainingBytes, pAd->PortCfg.FragmentThreshold);
            if (NextMpduSize == SrcRemainingBytes)
   			{
   				// In this case, the NextMpduSize doesn't include LENGTH_802_11 and LENGTH_CRC
				pHeader80211->Duration = (3 * pAd->PortCfg.Dsifs) + (2 * AckDuration) + 
					RTMPCalcDuration(pAd, TxRate, NextMpduSize + EncryptionOverhead + LENGTH_802_11 + LENGTH_CRC);
   			}
   			else
   			{
   				// In this case, the NextMpduSize doesn't include LENGTH_CRC
				pHeader80211->Duration = (3 * pAd->PortCfg.Dsifs) + (2 * AckDuration) + 
					RTMPCalcDuration(pAd, TxRate, NextMpduSize + EncryptionOverhead + LENGTH_CRC);
   			}
#ifndef NOT_CHANGE_ENDIAN_3 // Sam add
#ifdef BIG_ENDIAN
            RTMPFrameEndianChange(pAd, (PUCHAR)pHeader80211, DIR_WRITE, FALSE);
            RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
            *pDestTxD = TxD;
            pTxD = pDestTxD;
#endif
            RTMPWriteTxDescriptor(pAd, pTxD, CipherAlg, KeyTable, KeyIdx, bAckRequired, TRUE, FALSE,
            	RetryMode, FrameGap, TxRate, MpduSize, QueIdx, PID, NULL, NULL, pAd->PortCfg.MBSSID[apidx].bWmmCapable);

#else	// NOT_CHANGE_ENDIAN_3 defined
            RTMPFrameEndianChange(pAd, (PUCHAR)pHeader80211, DIR_WRITE, FALSE);

            //RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
	    pTxBD->ulword1 = SWAP32(pTxBD->ulword1);
	    pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
	    pTxBD->ulword12 = SWAP32(pTxBD->ulword12);
	    pTxBD->ulword13 = SWAP32(pTxBD->ulword13);

            RTMPWriteTxDescriptor(pAd, pTxD, CipherAlg, KeyTable, KeyIdx, bAckRequired, TRUE, FALSE,
            	RetryMode, FrameGap, TxRate, MpduSize, QueIdx, PID, NULL, NULL, pAd->PortCfg.MBSSID[apidx].bWmmCapable);
#endif // End Sam add

            FrameGap = IFS_SIFS;     // use SIFS for all subsequent fragments
            Header_802_11.Frag ++;   // increase Frag #
        }
        else // this is the last or only fragment
        {
            pHeader80211->FC.MoreFrag = 0;
            if (pHeader80211->Addr1[0] & 0x01) // multicast/broadcast
                pHeader80211->Duration = 0;
            else
                pHeader80211->Duration = pAd->PortCfg.Dsifs + AckDuration;

            if ((bEAPOLFrame) && (TxRate > RATE_6))
                TxRate = RATE_6;

#ifndef NOT_CHANGE_ENDIAN_3 // Sam add
#ifdef BIG_ENDIAN
            RTMPFrameEndianChange(pAd, (PUCHAR)pHeader80211, DIR_WRITE, FALSE);
            RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
            *pDestTxD = TxD;
            pTxD = pDestTxD;
#endif            
            RTMPWriteTxDescriptor(pAd, pTxD, CipherAlg, KeyTable, KeyIdx, bAckRequired, FALSE, FALSE, 
            	RetryMode, FrameGap, TxRate, MpduSize, QueIdx, PID, pSkb, pNextSkb, pAd->PortCfg.MBSSID[apidx].bWmmCapable);
#else	// NOT_CHANGE_ENDIAN_3 defined
            RTMPFrameEndianChange(pAd, (PUCHAR)pHeader80211, DIR_WRITE, FALSE);
            //RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
	    pTxBD->ulword1 = SWAP32(pTxBD->ulword1);
	    pTxBD->ulword11 = SWAP32(pTxBD->ulword11);
	    pTxBD->ulword12 = SWAP32(pTxBD->ulword12);
	    pTxBD->ulword13 = SWAP32(pTxBD->ulword13);

            RTMPWriteTxDescriptor(pAd, pTxD, CipherAlg, KeyTable, KeyIdx, bAckRequired, FALSE, FALSE, 
            	RetryMode, FrameGap, TxRate, MpduSize, QueIdx, PID, pSkb, pNextSkb, pAd->PortCfg.MBSSID[apidx].bWmmCapable);

#endif // End Sam add
        }

        INC_RING_INDEX(pTxRing->CurTxIndex, TX_RING_SIZE);
        pAd->RalinkCounters.KickTxCount++;
        
    } while (SrcRemainingBytes > 0);

    // Make sure to release Tx ring resource

#ifndef TC_NO_SPIN_LOCK // Sam add
    spin_unlock_irqrestore(&pAd->TxRingLock, IrqFlags);
#endif
    // -------------------------------------------------
    // STEP 6. KICK TX AND EXIT
    // -------------------------------------------------
    
    if (QueIdx <= QID_AC_VO)
    {
        RTMP_IO_WRITE32(pAd, TX_CNTL_CSR, BIT8[QueIdx]); 
    }

#if MEASURE_TX_TIME
RTMP_IO_READ32(pAd, TXRX_CSR12, &outtime);
tx_time_sum1 += (outtime - intime);
if(tx_measure_count1 == 10000){
printk(" Wlan RTMPHardTransmit Avg Time %d\n",(tx_time_sum1/10000));
tx_time_sum1=0;tx_measure_count1=0;}
#endif

    // the skb buffer will be released at DMA done interrupt service routine
    return (NDIS_STATUS_SUCCESS);

}

/*
	========================================================================

	Routine	Description:
		Calculates the duration which is required to transmit out frames 
	with given size and specified rate.
		
	Arguments:
		pAdapter		Pointer	to our adapter
		Rate			Transmit rate
		Size			Frame size in units of byte
		
	Return Value:
		Duration number in units of usec

	Note:
	
	========================================================================
*/
USHORT	RTMPCalcDuration(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	UCHAR			Rate,
	IN	ULONG			Size)
{
	ULONG	Duration = 0;

	if (Rate < RATE_FIRST_OFDM_RATE) // CCK
	{
	    if ((Rate > RATE_1) && (pAdapter->PortCfg.TxPreambleInUsed == Rt802_11PreambleShort))
    		Duration = 96;  // 72+24 preamble+plcp
  		else
            Duration = 192; // 144+48 preamble+plcp
    		
		Duration += (USHORT)((Size << 4) / RateIdTo500Kbps[Rate]);
		if ((Size << 4) % RateIdTo500Kbps[Rate])
			Duration ++;
	}
	else // OFDM rates
	{
		Duration = 20 + 6;      // 16+4 preamble+plcp + Signal Extension
		Duration += 4 * (USHORT)((11 + Size * 4) / RateIdTo500Kbps[Rate]);
		if ((11 + Size * 4) % RateIdTo500Kbps[Rate])
			Duration += 4;
	}
	
	return (USHORT)Duration;
	
}

/*
	========================================================================
	
	Routine	Description:
		Calculates the duration which is required to transmit out frames 
	with given size and specified rate.
		
	Arguments:
		pTxD		Pointer to transmit descriptor
		Ack			Setting for Ack requirement bit
		Fragment	Setting for Fragment bit
		RetryMode	Setting for retry mode
		Ifs			Setting for IFS gap
		Rate		Setting for transmit rate
		Service		Setting for service
		Length		Frame length
		TxPreamble  Short or Long preamble when using CCK rates
		QueIdx - 0-3, according to 802.11e/d4.4 June/2003
		
	Return Value:
		None
		
	========================================================================
*/
#ifndef NOT_CHANGE_ENDIAN_3   // Sam add
VOID	RTMPWriteTxDescriptor(
    IN  PRTMP_ADAPTER pAd,
 	IN	PTXD_STRUC	pSourceTxD,
	IN	UCHAR		CipherAlg,
	IN  UCHAR       KeyTable,
	IN  UCHAR       KeyIdx,
	IN	BOOLEAN		Ack,
	IN	BOOLEAN		Fragment,
	IN  BOOLEAN     InsTimestamp,
	IN	UCHAR		RetryMode,
	IN	UCHAR		Ifs,
	IN	UINT		Rate,
	IN	ULONG		Length,
	IN  UCHAR       QueIdx,
	IN  UCHAR       PID,
	IN  struct sk_buff *pSkb,
	IN  struct sk_buff *pNextSkb,
	IN  BOOLEAN     bWmmCapable)
{
	UINT	Residual;

    PTXD_STRUC      pTxD;
    
#ifndef BIG_ENDIAN
    pTxD = pSourceTxD;
#else
    TXD_STRUC       TxD;
// Sam add for debug
//printk("Enter RTMPWriteTxDescriptor \n");
//printk("CipherAlg=%02X KeyTable=%02X KeyIdx=%02X Ack=%X Fragment=%X InsTimestamp=%X RetryMode=%02X\n",CipherAlg,KeyTable,KeyIdx,Ack,Fragment,InsTimestamp,RetryMode);
//printk("Ifs=%02X Rate=%04X Length=%08X QueIdx=%02X PID=%02X pSkb=%08X pNextSkb=%08X\n",Ifs, Rate,Length,QueIdx,PID,pSkb,pNextSkb);
// End Sam add    
    TxD = *pSourceTxD;
    pTxD = &TxD;
    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

    DBGPRINT(RT_DEBUG_INFO,"WriteTxD: scatter #%d = %d + %d + %d ... = %d\n", 
        pTxD->BufCount, pTxD->BufLen0, pTxD->BufLen1, pTxD->BufLen2, Length);
    
    pTxD->HostQId     = QueIdx;
	pTxD->MoreFrag    = Fragment;
	pTxD->ACK         = Ack;
	pTxD->Timestamp   = InsTimestamp;
	pTxD->RetryMd     = RetryMode;
    pTxD->Ofdm        = (Rate < RATE_FIRST_OFDM_RATE)? 0:1;
	pTxD->IFS         = Ifs;
    pTxD->PktId       = PID;
    pTxD->Drop        = 1;   // 1:valid, 0:drop
    pTxD->HwSeq       = (QueIdx == QID_MGMT)? 1:0; 
    pTxD->BbpTxPower  = DEFAULT_BBP_TX_POWER; // TODO: to be modified
	pTxD->DataByteCnt = Length;
    
    // fill encryption related information, if required
	pTxD->CipherAlg   = CipherAlg;
    if (CipherAlg != CIPHER_NONE)
    {
        pTxD->KeyTable    = KeyTable;
        pTxD->KeyIndex    = KeyIdx;
    	pTxD->TkipMic     = 1;
    }

    // In TKIP+fragmentation. TKIP MIC is already appended by driver. MAC needs not generate MIC
    if (CipherAlg == CIPHER_TKIP_NO_MIC)
    {
        pTxD->CipherAlg   = CIPHER_TKIP;
    	pTxD->TkipMic     = 0;   // tell MAC need not insert TKIP MIC
    }
        
    if ((bWmmCapable) && (pAd->PortCfg.APEdcaParm.bValid) && (QueIdx <= QID_AC_VO))
    {
        pTxD->Cwmin = pAd->PortCfg.APEdcaParm.Cwmin[QueIdx];
        pTxD->Cwmax = pAd->PortCfg.APEdcaParm.Cwmax[QueIdx];
        pTxD->Aifsn = pAd->PortCfg.APEdcaParm.Aifsn[QueIdx];
    }
    else
    {
        pTxD->Cwmin = CW_MIN_IN_BITS;
        pTxD->Cwmax = CW_MAX_IN_BITS;
        pTxD->Aifsn = 2;
    }

	// fill up PLCP SIGNAL field
	pTxD->PlcpSignal = RateIdToPlcpSignal[Rate];
	if (((Rate == RATE_2) || (Rate == RATE_5_5) || (Rate == RATE_11)) && 
	    (pAd->PortCfg.TxPreambleInUsed == Rt802_11PreambleShort))
	{
		pTxD->PlcpSignal |= 0x0008;
	}

	// fill up PLCP SERVICE field, not used for OFDM rates
	pTxD->PlcpService = 4; // Service;

	// file up PLCP LENGTH_LOW and LENGTH_HIGH fields
	Length += LENGTH_CRC;   // CRC length
	switch (CipherAlg) 
    {
        case CIPHER_WEP64:       Length += 8;    break;  // IV + ICV
        case CIPHER_WEP128:      Length += 8;    break;  // IV + ICV
        case CIPHER_TKIP:        Length += 20;   break;  // IV + EIV + MIC + ICV
        case CIPHER_AES:         Length += 16;   break;  // IV + EIV + MIC
        case CIPHER_CKIP64:      Length += 8;    break;  // IV + CMIC + ICV, but CMIC already inserted by driver
        case CIPHER_CKIP128:     Length += 8;    break;  // IV + CMIC + ICV, but CMIC already inserted by driver
        case CIPHER_TKIP_NO_MIC: Length += 12;   break;  // IV + EIV + ICV
        default:                                 break;
    }

    // TODO: to be removed
    if (pNextSkb)
    {
        DBGPRINT(RT_DEBUG_INFO,"WriteTxD (%s, Len=%d PLCPlen=%d\n)",CipherName[CipherAlg], pTxD->DataByteCnt, Length);
        pAd->RalinkCounters.OneSecTxAggregationCount ++;
    }
    
	if (Rate < RATE_FIRST_OFDM_RATE)    // 11b - RATE_1, RATE_2, RATE_5_5, RATE_11
	{
		if ((Rate == RATE_1) || ( Rate == RATE_2))
		{
			Length = Length * 8 / (Rate + 1);
		}
		else
		{
			Residual = ((Length * 16) % (11 * (1 + Rate - RATE_5_5)));
			Length = Length * 16 / (11 * (1 + Rate - RATE_5_5));
			if (Residual != 0)
			{
				Length++;
			}
			if ((Residual <= (3 * (1 + Rate - RATE_5_5))) && (Residual != 0))
			{
				if (Rate == RATE_11)			// Only 11Mbps require length extension bit
					pTxD->PlcpService |= 0x80; // 11b's PLCP Length extension bit
			}
		}

		pTxD->PlcpLengthHigh = Length >> 8; // 256;
		pTxD->PlcpLengthLow = Length % 256;
	}
	else    // OFDM - RATE_6, RATE_9, RATE_12, RATE_18, RATE_24, RATE_36, RATE_48, RATE_54
	{
		pTxD->PlcpLengthHigh = Length >> 6; // 64;  // high 6-bit of total byte count
		pTxD->PlcpLengthLow = Length % 64;   // low 6-bit of total byte count
	}

    pTxD->pSkb					= pSkb;
    pTxD->pNextSkb				= pNextSkb;
    pTxD->bWaitingDmaDoneInt    = 1;
	pTxD->Owner                 = DESC_OWN_NIC;     // change OWNER bit at the last	

// Sam add debug
//printk("Write TXDESCRIPTOR...\n");
//dump_descriptor_content(pTxD);
// End Sam add debug

#ifdef BIG_ENDIAN
    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
    *pSourceTxD = *pTxD;
#endif
}
#else   // NOT_CHANGE_ENDIAN_3
VOID	RTMPWriteTxDescriptor(
    IN  PRTMP_ADAPTER pAd,
 	IN	PTXD_STRUC	pSourceTxD,
	IN	UCHAR		CipherAlg,
	IN  UCHAR       KeyTable,
	IN  UCHAR       KeyIdx,
	IN	BOOLEAN		Ack,
	IN	BOOLEAN		Fragment,
	IN  BOOLEAN     InsTimestamp,
	IN	UCHAR		RetryMode,
	IN	UCHAR		Ifs,
	IN	UINT		Rate,
	IN	ULONG		Length,
	IN  UCHAR       QueIdx,
	IN  UCHAR       PID,
	IN  struct sk_buff *pSkb,
	IN  struct sk_buff *pNextSkb,
	IN  BOOLEAN     bWmmCapable)
{
	UINT	Residual;

    // Sam add
    TXD_STRUC		tempTxD = *pSourceTxD;
    // End Sam add

    PTXD_BIG_STRUC      pTxBD;
    PTXD_STRUC		pTxD;

    //pTxD = pSourceTxD;
    pTxD = &(tempTxD);

    pTxBD = (PTXD_BIG_STRUC)(&tempTxD);
    

//   printk("pTxD-%08x pTxBD-%08x\n",pTxD,pTxBD);

// Sam add
//   unsigned long rateflag,ulword0,ulword2,ulwor5;
//   unsigned long bytecount;
// End Sam add

    //DBGPRINT(RT_DEBUG_INFO,"WriteTxD: scatter #%d = %d + %d + %d ... = %d\n", 
    //    pTxD->BufCount, pTxD->BufLen0, pTxD->BufLen1, pTxD->BufLen2, Length);

    // ulword0

	pTxBD -> ulword0 = SWAP32(pTxBD -> ulword0);

	#if 1 
	pTxD->MoreFrag    = Fragment;
	pTxD->ACK         = Ack;
	pTxD->Timestamp   = InsTimestamp;
	pTxD->RetryMd     = RetryMode;
    	pTxD->Ofdm        = (Rate < RATE_FIRST_OFDM_RATE)? 0:1;
	pTxD->IFS         = Ifs;
    	pTxD->Drop        = 1;   // 1:valid, 0:drop
	pTxD->DataByteCnt = Length;
	pTxD->CipherAlg   = CipherAlg;

//printk("%d %d %d %d %d %d %d %d %d\n",pTxD->MoreFrag,pTxD->ACK,pTxD->Timestamp,pTxD->RetryMd,pTxD->Ofdm,pTxD->IFS,pTxD->Drop,pTxD->DataByteCnt,pTxD->CipherAlg);
//printk("%08x\n",pTxBD->ulword0);
//printk("\n");
	#endif

    // ulword1
	pTxBD -> ulword1 = SWAP32(pTxBD->ulword1);

	pTxD->HostQId    = QueIdx;
	pTxD->HwSeq      = (QueIdx == QID_MGMT)? 1:0; 

    // ulword2
	pTxBD -> ulword2 = SWAP32(pTxBD->ulword2);
    
    // ulword5
	pTxBD -> ulword5 = SWAP32(pTxBD -> ulword5);	

	pTxD->PktId      = PID;
   	pTxD->BbpTxPower = DEFAULT_BBP_TX_POWER; // TODO: to be modified

    // fill encryption related information, if required

    if (CipherAlg != CIPHER_NONE)
    {
        pTxD->KeyTable    = KeyTable;
        pTxD->KeyIndex    = KeyIdx;
    	pTxD->TkipMic     = 1;
    }

    // In TKIP+fragmentation. TKIP MIC is already appended by driver. MAC needs not generate MIC
    if (CipherAlg == CIPHER_TKIP_NO_MIC)
    {
        pTxD->CipherAlg   = CIPHER_TKIP;
    	pTxD->TkipMic     = 0;   // tell MAC need not insert TKIP MIC
    }
        
    if ((bWmmCapable) && (pAd->PortCfg.APEdcaParm.bValid) && (QueIdx <= QID_AC_VO))
    {
        pTxD->Cwmin = pAd->PortCfg.APEdcaParm.Cwmin[QueIdx];
        pTxD->Cwmax = pAd->PortCfg.APEdcaParm.Cwmax[QueIdx];
        pTxD->Aifsn = pAd->PortCfg.APEdcaParm.Aifsn[QueIdx];
    }
    else
    {
        pTxD->Cwmin = CW_MIN_IN_BITS;
        pTxD->Cwmax = CW_MAX_IN_BITS;
        pTxD->Aifsn = 2;
    }

	// fill up PLCP SIGNAL field
	pTxD->PlcpSignal = RateIdToPlcpSignal[Rate];
	if (((Rate == RATE_2) || (Rate == RATE_5_5) || (Rate == RATE_11)) && 
	    (pAd->PortCfg.TxPreambleInUsed == Rt802_11PreambleShort))
	{
		pTxD->PlcpSignal |= 0x0008;
	}

	// fill up PLCP SERVICE field, not used for OFDM rates
	pTxD->PlcpService = 4; // Service;

	// file up PLCP LENGTH_LOW and LENGTH_HIGH fields
	Length += LENGTH_CRC;   // CRC length
	switch (CipherAlg) 
    {
        case CIPHER_WEP64:       Length += 8;    break;  // IV + ICV
        case CIPHER_WEP128:      Length += 8;    break;  // IV + ICV
        case CIPHER_TKIP:        Length += 20;   break;  // IV + EIV + MIC + ICV
        case CIPHER_AES:         Length += 16;   break;  // IV + EIV + MIC
        case CIPHER_CKIP64:      Length += 8;    break;  // IV + CMIC + ICV, but CMIC already inserted by driver
        case CIPHER_CKIP128:     Length += 8;    break;  // IV + CMIC + ICV, but CMIC already inserted by driver
        case CIPHER_TKIP_NO_MIC: Length += 12;   break;  // IV + EIV + ICV
        default:                                 break;
    }

    // TODO: to be removed
    if (pNextSkb)
    {
        DBGPRINT(RT_DEBUG_INFO,"WriteTxD (%s, Len=%d PLCPlen=%d\n)",CipherName[CipherAlg], pTxD->DataByteCnt, Length);
        pAd->RalinkCounters.OneSecTxAggregationCount ++;
    }
    
	if (Rate < RATE_FIRST_OFDM_RATE)    // 11b - RATE_1, RATE_2, RATE_5_5, RATE_11
	{
		if ((Rate == RATE_1) || ( Rate == RATE_2))
		{
			Length = Length * 8 / (Rate + 1);
		}
		else
		{
			Residual = ((Length * 16) % (11 * (1 + Rate - RATE_5_5)));
			Length = Length * 16 / (11 * (1 + Rate - RATE_5_5));
			if (Residual != 0)
			{
				Length++;
			}
			if ((Residual <= (3 * (1 + Rate - RATE_5_5))) && (Residual != 0))
			{
				if (Rate == RATE_11)			// Only 11Mbps require length extension bit
					pTxD->PlcpService |= 0x80; // 11b's PLCP Length extension bit
			}
		}

		pTxD->PlcpLengthHigh = Length >> 8; // 256;
		pTxD->PlcpLengthLow = Length % 256;
	}
	else    // OFDM - RATE_6, RATE_9, RATE_12, RATE_18, RATE_24, RATE_36, RATE_48, RATE_54
	{
		pTxD->PlcpLengthHigh = Length >> 6; // 64;  // high 6-bit of total byte count
		pTxD->PlcpLengthLow = Length % 64;   // low 6-bit of total byte count
	}

// Sam    pTxD->pSkb					= pSkb;
// Sam    pTxD->pNextSkb				= pNextSkb;
    pTxBD->pSkb		= SWAP32(pSkb);
    pTxBD->pNextSkb	= SWAP32(pNextSkb);
    pTxD->bWaitingDmaDoneInt    = 1;
    pTxBD -> ulword1 = SWAP32(pTxBD -> ulword1);
    pTxBD -> ulword2 = SWAP32(pTxBD -> ulword2);
    pTxBD -> ulword5 = SWAP32(pTxBD -> ulword5);
    
    pTxD->Owner                 = DESC_OWN_NIC;     // change OWNER bit at the last	
    pTxBD -> ulword0 = SWAP32(pTxBD -> ulword0);
    //pTxBD -> ulword0 |= 0x10000000 ;     // change OWNER bit at the last	

// Sam add debug
//printk("Write TXDESCRIPTOR...\n");
//dump_descriptor_content(pTxD);
// End Sam add debug

#ifdef BIG_ENDIAN
//    RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
    *pSourceTxD = *pTxD;
#endif
}
#endif  // End Sam add NOT_CHANGE_ENDIAN_3



/*
	========================================================================

	Routine	Description:
		Search tuple cache for receive duplicate frame from unicast frames.
		
	Arguments:
		pAdapter		Pointer	to our adapter
		pHeader			802.11 header of receiving frame
		
	Return Value:
		TRUE			found matched tuple cache
		FALSE			no matched found

	Note:
	
	========================================================================
*/
BOOLEAN	RTMPSearchTupleCache(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	PHEADER_802_11	pHeader)
{
	INT	Index;

	for (Index = 0; Index < MAX_CLIENT; Index++)
	{
		if (pAdapter->TupleCache[Index].Valid == FALSE)
		    continue;
		
		if (MAC_ADDR_EQUAL(pAdapter->TupleCache[Index].MacAddress, pHeader->Addr2) &&
			(pAdapter->TupleCache[Index].Sequence == pHeader->Sequence) &&
			(pAdapter->TupleCache[Index].Frag == pHeader->Frag))
		{
//			DBGPRINT(RT_DEBUG_TRACE,("DUPCHECK - duplicate frame hit entry %d\n", Index)); 
			return (TRUE);
		}
	}
	return (FALSE);
}

/*
	========================================================================

	Routine	Description:
		Update tuple cache for new received unicast frames.
		
	Arguments:
		pAdapter		Pointer	to our adapter
		pHeader			802.11 header of receiving frame
		
	Return Value:
		None
		
	Note:
	
	========================================================================
*/
VOID	RTMPUpdateTupleCache(
	IN	PRTMP_ADAPTER	pAdapter,
	IN	PHEADER_802_11	pHeader)
{
	UCHAR	Index;

	for (Index = 0; Index < MAX_CLIENT; Index++)
	{
		if (pAdapter->TupleCache[Index].Valid == FALSE)
		{
			// Add new entry
			COPY_MAC_ADDR(pAdapter->TupleCache[Index].MacAddress, pHeader->Addr2);
			pAdapter->TupleCache[Index].Sequence = pHeader->Sequence;
			pAdapter->TupleCache[Index].Frag     = pHeader->Frag;
			pAdapter->TupleCache[Index].Valid    = TRUE;
			pAdapter->TupleCacheLastUpdateIndex  = Index;
			DBGPRINT(RT_DEBUG_INFO,"DUPCHECK - Add Entry %d, MAC=%02x:%02x:%02x:%02x:%02x:%02x\n", Index,
			    pAdapter->TupleCache[Index].MacAddress[0], pAdapter->TupleCache[Index].MacAddress[1],
			    pAdapter->TupleCache[Index].MacAddress[2], pAdapter->TupleCache[Index].MacAddress[3],
			    pAdapter->TupleCache[Index].MacAddress[4], pAdapter->TupleCache[Index].MacAddress[5]);
			return;
		}
		else if (MAC_ADDR_EQUAL(pAdapter->TupleCache[Index].MacAddress, pHeader->Addr2))
		{
			// Update old entry
			pAdapter->TupleCache[Index].Sequence = pHeader->Sequence;
			pAdapter->TupleCache[Index].Frag     = pHeader->Frag;
			return;
		}
	}

    // tuple cache full, replace the first inserted one (even though it may not be
    // least referenced one)
	if (Index == MAX_CLIENT)
	{
	    pAdapter->TupleCacheLastUpdateIndex ++;
	    if (pAdapter->TupleCacheLastUpdateIndex >= MAX_CLIENT)
	        pAdapter->TupleCacheLastUpdateIndex = 0;
	    Index = pAdapter->TupleCacheLastUpdateIndex;

		// replace with new entry
		COPY_MAC_ADDR(pAdapter->TupleCache[Index].MacAddress, pHeader->Addr2);
		pAdapter->TupleCache[Index].Sequence = pHeader->Sequence;
		pAdapter->TupleCache[Index].Frag     = pHeader->Frag;
		pAdapter->TupleCache[Index].Valid    = TRUE;
		DBGPRINT(RT_DEBUG_INFO,"DUPCHECK - replace Entry %d, MAC=%02x:%02x:%02x:%02x:%02x:%02x\n", Index,
		    pAdapter->TupleCache[Index].MacAddress[0], pAdapter->TupleCache[Index].MacAddress[1],
		    pAdapter->TupleCache[Index].MacAddress[2], pAdapter->TupleCache[Index].MacAddress[3],
		    pAdapter->TupleCache[Index].MacAddress[4], pAdapter->TupleCache[Index].MacAddress[5]);
	}
}

/*
	========================================================================

	Routine	Description:
		Suspend MSDU transmission
		
	Arguments:
		pAdapter		Pointer	to our adapter
		
	Return Value:
		None
		
	Note:
	
	========================================================================
*/
VOID    RTMPSuspendMsduTransmission(
	IN	PRTMP_ADAPTER	pAd)
{
	DBGPRINT(RT_DEBUG_TRACE,"SCANNING, suspend MSDU transmission ...\n");

	RTMP_SET_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS);
	RTMP_IO_WRITE32(pAd, TX_CNTL_CSR, 0x000f0000);      // abort all TX rings
}

/*
	========================================================================

	Routine	Description:
		Resume MSDU transmission
		
	Arguments:
		pAdapter		Pointer	to our adapter
		
	Return Value:
		None
		
	Note:
	
	========================================================================
*/
VOID    RTMPResumeMsduTransmission(
	IN	PRTMP_ADAPTER	pAd)
{
	DBGPRINT(RT_DEBUG_TRACE,"SCAN done, resume MSDU transmission ...\n");
	RTMP_CLEAR_FLAG(pAd, fRTMP_ADAPTER_BSS_SCAN_IN_PROGRESS);
    RTMPDeQueuePacket(pAd, FALSE);
  	RTMP_IO_WRITE32(pAd, TX_CNTL_CSR, 0x0000000f);      // kick all TX rings
}

/*
	========================================================================

	Routine	Description:
		Check Rx descriptor, return NDIS_STATUS_FAILURE if any error dound
		
	Arguments:
		pRxD		Pointer	to the Rx descriptor
		
	Return Value:
		NDIS_STATUS_SUCCESS		No err
		NDIS_STATUS_FAILURE		Error
		
	Note:
	
	========================================================================
*/
NDIS_STATUS	RTMPCheckRxError(
	IN	PRXD_STRUC		pRxD)
{
	if (pRxD->Crc || pRxD->CipherErr)
        return NDIS_STATUS_FAILURE;
    else
        return NDIS_STATUS_SUCCESS;
}

/*
	========================================================================

	Routine	Description:
		Check and fine the packet waiting in SW queue with highest priority
		
	Arguments:
		pAdapter	Pointer	to our adapter
		
	Return Value:
		pQueue		Pointer to Waiting Queue

	Note:
	
	========================================================================
*/
PQUEUE_HEADER	RTMPCheckTxSwQueue(
	IN	PRTMP_ADAPTER	pAdapter,
	OUT	PULONG			pNumber,
	OUT PUCHAR           pQueIdx)
{
	// Sam: The major queue is QID_AC_BE
	// Calculate total number of packets waiting in queues for Nitro mode 
	*pNumber = pAdapter->TxSwQueue[QID_AC_BK].Number 
	         + pAdapter->TxSwQueue[QID_AC_BE].Number 
	         + pAdapter->TxSwQueue[QID_AC_VI].Number 
	         + pAdapter->TxSwQueue[QID_AC_VO].Number
	         + pAdapter->TxSwQueue[QID_HCCA].Number;

#if 1 // Sam
	if (pAdapter->TxSwQueue[QID_AC_VO].Head != NULL)
	{
	    *pQueIdx = QID_AC_VO;
		return (&pAdapter->TxSwQueue[QID_AC_VO]);
	}
	else if (pAdapter->TxSwQueue[QID_AC_VI].Head != NULL)
	{
	    *pQueIdx = QID_AC_VI;
		return (&pAdapter->TxSwQueue[QID_AC_VI]);
	}
	else if (pAdapter->TxSwQueue[QID_AC_BE].Head != NULL)
	{
	    *pQueIdx = QID_AC_BE;
		return (&pAdapter->TxSwQueue[QID_AC_BE]);
	}
	else if (pAdapter->TxSwQueue[QID_AC_BK].Head != NULL)
	{
	    *pQueIdx = QID_AC_BK;
		return (&pAdapter->TxSwQueue[QID_AC_BK]);
	}
	else if (pAdapter->TxSwQueue[QID_HCCA].Head != NULL)
	{
	    *pQueIdx = QID_HCCA;
		return (&pAdapter->TxSwQueue[QID_HCCA]);
	}
#else
	if (pAdapter->TxSwQueue[QID_AC_BE].Head != NULL)
	{
	    *pQueIdx = QID_AC_BE;
		return (&pAdapter->TxSwQueue[QID_AC_BE]);
	}
#endif

	// No packet pending in Tx Sw queue
    *pQueIdx = QID_AC_BK;
	return (NULL);
}

/*
	========================================================================

	Routine	Description:
		Process MIC error indication and record MIC error timer.
		
	Arguments:
		pAdapter		Pointer	to our adapter
		pWpaKey			Pointer	to the WPA key structure
		
	Return Value:
		None
		
	Note:
	
	========================================================================
*/
VOID	RTMPReportMicError(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PCIPHER_KEY		pWpaKey)
{
}

// clone an input skb buffer to another one.
// NOTE: internally created NDIS_PACKET should be destroyed by RTMPFreeNdisPacket
#ifndef RTL865X_SOC 
NDIS_STATUS RTMPCloneNdisPacket(
#else
static inline NDIS_STATUS RTMPCloneNdisPacket(
#endif
    IN  PRTMP_ADAPTER   pAdapter,
    IN  struct sk_buff  *pInSkb,
    OUT struct sk_buff  **ppOutSkb)
{
    if ((*ppOutSkb = skb_clone(pInSkb, MEM_ALLOC_FLAG)) == NULL)
    	return NDIS_STATUS_FAILURE;

    RTMP_SET_PACKET_SOURCE(*ppOutSkb, PKTSRC_DRIVER);

    return NDIS_STATUS_SUCCESS;
}

// the allocated Skb buffer must be freed via RTMPFreeNdisPacket()
NDIS_STATUS RTMPAllocateNdisPacket(
    IN  PRTMP_ADAPTER   pAdapter,
    OUT struct sk_buff  **ppSkb,
    IN  PUCHAR          pData,
    IN  UINT            DataLen)
{
    // 1. Allocate Skb buffer
    *ppSkb = __dev_alloc_skb(DataLen + 2, MEM_ALLOC_FLAG);
    if (*ppSkb == NULL)
        return NDIS_STATUS_RESOURCES;

    // 2. Set packet flag
	skb_reserve(*ppSkb, 2);	// 16 byte align the IP header
	RTMP_SET_PACKET_SOURCE(*ppSkb, PKTSRC_DRIVER);

    // 3. clone the frame content
    NdisMoveMemory(skb_put(*ppSkb, DataLen), pData, DataLen);
    
    return NDIS_STATUS_SUCCESS;
}

// Sam add 
#ifndef NOT_CHANGE_ENDIAN_3
VOID RTMPFreeTXDUponTxDmaDone(
    IN PRTMP_ADAPTER    pAd, 
    IN UCHAR            QueIdx,
    IN UINT             RingSize)
{
    PRTMP_TX_RING	pTxRing;
    PTXD_STRUC		pTxD;
#ifdef	BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
    struct sk_buff	*pSkb;
    int				i;

    ASSERT(QueIdx < NUM_OF_TX_RING);
    pTxRing = &pAd->TxRing[QueIdx];
    
    for (i=0; i<MAX_DMA_DONE_PROCESS; i++)
    {
#ifndef BIG_ENDIAN
	    pTxD = (PTXD_STRUC)	(pTxRing->Cell[pTxRing->NextTxDmaDoneIndex].AllocVa);
#else
        pDestTxD = (PTXD_STRUC) (pTxRing->Cell[pTxRing->NextTxDmaDoneIndex].AllocVa);
        TxD = *pDestTxD;
        pTxD = &TxD;
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

        if (pTxD->Owner == DESC_OWN_NIC) 
	        break;
        if (pTxD->bWaitingDmaDoneInt == 0)
        {
            if (pTxRing->NextTxDmaDoneIndex != pTxRing->CurTxIndex)
            {
                // should never reach here!!!!
                DBGPRINT_TX_RING(pAd, QueIdx);
                // dump TXD at NextTxDmaDoneIndex, check sequence#, check Airopeek if
                // the frame been transmitted out or not.
                DBGPRINT_ERR("pNdisPacket[%d]=0x%08x\n",pTxRing->NextTxDmaDoneIndex, (ULONG) pTxD->pSkb);
                INC_RING_INDEX(pTxRing->NextTxDmaDoneIndex, RingSize);
                continue;
            }
            else
                break;
        }

        pTxD->bWaitingDmaDoneInt = 0;
	    INC_RING_INDEX(pTxRing->NextTxDmaDoneIndex, RingSize);
        pAd->RalinkCounters.TransmittedByteCount +=  pTxD->DataByteCnt;
        pAd->RalinkCounters.OneSecDmaDoneCount[QueIdx] ++;

#ifdef RALINK_ATE
		if (pAd->ate.Mode == ATE_TXFRAME) {
#ifdef BIG_ENDIAN
	        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
	        *pDestTxD = TxD;
#endif
			continue;
		}			
#endif

	    pSkb = pTxD->pSkb;
        if (pSkb)
        {
        	pci_unmap_single(pAd->pPci_Dev, pTxD->BufPhyAddr1, pTxD->BufLen1, PCI_DMA_TODEVICE);
            pTxD->pSkb = 0;
            RELEASE_NDIS_PACKET(pAd, pSkb);
        }
        pSkb = pTxD->pNextSkb;
        if (pSkb)
        {
        	pci_unmap_single(pAd->pPci_Dev, pTxD->BufPhyAddr2, pTxD->BufLen2, PCI_DMA_TODEVICE);
            pTxD->pNextSkb = 0;
            RELEASE_NDIS_PACKET(pAd, pSkb);
        }
#ifdef BIG_ENDIAN
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
        *pDestTxD = TxD;
#endif
    }
}   
#else  // NOT_CHANGE_ENDIAN_3
VOID RTMPFreeTXDUponTxDmaDone(
    IN PRTMP_ADAPTER    pAd, 
    IN UCHAR            QueIdx,
    IN UINT             RingSize)
{
    PRTMP_TX_RING	pTxRing;
// Sam     PTXD_STRUC		pTxD;
    PTXD_BIG_STRUC	pTxBD;
    int bytecount = 0;
#ifdef	BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif

    struct sk_buff	*pSkb;
    int				i;

    ASSERT(QueIdx < NUM_OF_TX_RING);
    pTxRing = &pAd->TxRing[QueIdx];
    
    for (i=0; i<MAX_DMA_DONE_PROCESS; i++)
    {
	pTxBD = (PTXD_BIG_STRUC)(pTxRing->Cell[pTxRing->NextTxDmaDoneIndex].AllocVa);

	// Sam if (pTxD->Owner == DESC_OWN_NIC) 
	if ( pTxBD -> ulword0 & 0x01000000 ) 
	        break;

        // Sam if (pTxD->bWaitingDmaDoneInt == 0)
        if (!(pTxBD -> ulword5 & 0x00000001))
        {
            if (pTxRing->NextTxDmaDoneIndex != pTxRing->CurTxIndex)
            {
                // should never reach here!!!!
                DBGPRINT_TX_RING(pAd, QueIdx);
                // dump TXD at NextTxDmaDoneIndex, check sequence#, check Airopeek if
                // the frame been transmitted out or not.
                // Sam DBGPRINT_ERR("pNdisPacket[%d]=0x%08x\n",pTxRing->NextTxDmaDoneIndex, (ULONG) pTxD->pSkb);
                DBGPRINT_ERR("pNdisPacket[%d]=0x%08x\n",pTxRing->NextTxDmaDoneIndex, (ULONG)(SWAP32(pTxBD->pSkb)));
                INC_RING_INDEX(pTxRing->NextTxDmaDoneIndex, RingSize);
                continue;
            }
            else
                break;
        }

	// Sam pTxD->bWaitingDmaDoneInt = 0;
	pTxBD -> ulword5 &= 0xfffffffe;

	    INC_RING_INDEX(pTxRing->NextTxDmaDoneIndex, RingSize);
        // Sam pAd->RalinkCounters.TransmittedByteCount +=  pTxD->DataByteCnt;
	bytecount = ((SWAP32( pTxBD -> ulword0))& 0x0fff0000) >> 16;
        pAd->RalinkCounters.TransmittedByteCount +=  bytecount ;

        pAd->RalinkCounters.OneSecDmaDoneCount[QueIdx] ++;

#ifdef RALINK_ATE
		if (pAd->ate.Mode == ATE_TXFRAME) {
#ifdef BIG_ENDIAN
//	        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
//	        *pDestTxD = TxD;
#endif
			continue;
		}			
#endif

	// Sam pSkb = pTxD->pSkb;
	pSkb = SWAP32(pTxBD->pSkb);
        if (pSkb)
        {
	    unsigned int BufLen;
	    BufLen = (SWAP32(pTxBD->ulword11) & 0x0fff0000 )>> 16;
        	// Sam pci_unmap_single(pAd->pPci_Dev, pTxD->BufPhyAddr1, pTxD->BufLen1, PCI_DMA_TODEVICE);

        	// pci_unmap_single(pAd->pPci_Dev, SWAP32(pTxBD->BufPhyAddr1), BufLen, PCI_DMA_TODEVICE);

            // Sam pTxD->pSkb = 0;
            pTxBD->pSkb = 0;
            RELEASE_NDIS_PACKET(pAd, pSkb);
        }
        // Sam pSkb = pTxD->pNextSkb;
        pSkb = SWAP32(pTxBD->pNextSkb);
        if (pSkb)
        {
	    unsigned int BufLen;
	    BufLen = (SWAP32(pTxBD->ulword12) & 0x00000fff);
        	// Sam pci_unmap_single(pAd->pPci_Dev, pTxD->BufPhyAddr2, pTxD->BufLen2, PCI_DMA_TODEVICE);

        	// pci_unmap_single(pAd->pPci_Dev, SWAP32(pTxBD->BufPhyAddr2), BufLen, PCI_DMA_TODEVICE);

            // Sam pTxD->pNextSkb = 0;
            pTxBD->pNextSkb = 0;
            RELEASE_NDIS_PACKET(pAd, pSkb);
        }
#ifdef BIG_ENDIAN
        // Sam RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
        // Sam *pDestTxD = TxD;
#endif
    }
}   
#endif // NOT_CHANGE_ENDIAN_3
// End Sam add



VOID DBGPRINT_TX_RING(
    IN PRTMP_ADAPTER  pAdapter,
    IN UCHAR          QueIdx)
{
    ULONG      PbfCsr, Ac0Base, Ac0CurAddr;
    ULONG      Ac0HwIdx, Ac0SwIdx, AC0DmaDoneIdx;
    PTXD_STRUC pTxD;
#ifdef	BIG_ENDIAN
    PTXD_STRUC      pDestTxD;
    TXD_STRUC       TxD;
#endif
    int        i;
        
    RTMP_IO_READ32(pAdapter, PBF_QUEUE_CSR, &PbfCsr);
    switch (QueIdx)
    {
        case QID_AC_BE:
            RTMP_IO_READ32(pAdapter, AC0_BASE_CSR, &Ac0Base);
            RTMP_IO_READ32(pAdapter, AC0_TXPTR_CSR, &Ac0CurAddr);
            break;
        case QID_AC_BK:
            RTMP_IO_READ32(pAdapter, AC1_BASE_CSR, &Ac0Base);
            RTMP_IO_READ32(pAdapter, AC1_TXPTR_CSR, &Ac0CurAddr);
            break;
        case QID_AC_VI:
            RTMP_IO_READ32(pAdapter, AC2_BASE_CSR, &Ac0Base);
            RTMP_IO_READ32(pAdapter, AC2_TXPTR_CSR, &Ac0CurAddr);
            break;
        case QID_AC_VO:
            RTMP_IO_READ32(pAdapter, AC3_BASE_CSR, &Ac0Base);
            RTMP_IO_READ32(pAdapter, AC3_TXPTR_CSR, &Ac0CurAddr);
            break;
        default:
            DBGPRINT_ERR("DBGPRINT_TX_RING(Ring %d) not supported\n", QueIdx);
            break;
    }
    Ac0HwIdx = (Ac0CurAddr - Ac0Base) / TXD_SIZE;
    Ac0SwIdx = pAdapter->TxRing[QueIdx].CurTxIndex;
    AC0DmaDoneIdx = pAdapter->TxRing[QueIdx].NextTxDmaDoneIndex;
    
    printk("TxRing%d PBF=%08x, HwIdx=%d, SwIdx[%d]=", QueIdx, PbfCsr, Ac0HwIdx, Ac0SwIdx);
    for (i=0;i<4;i++)
    {
#ifndef BIG_ENDIAN
        pTxD = (PTXD_STRUC)pAdapter->TxRing[QueIdx].Cell[Ac0SwIdx].AllocVa;
#else
        pDestTxD = (PTXD_STRUC)pAdapter->TxRing[QueIdx].Cell[Ac0SwIdx].AllocVa;
        TxD = *pDestTxD;
        pTxD = &TxD;
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

        printk("%d%d.", pTxD->Owner, pTxD->bWaitingDmaDoneInt);
        INC_RING_INDEX(Ac0SwIdx, TX_RING_SIZE);
    }
    printk("DmaIdx[%d]=", AC0DmaDoneIdx);
    for (i=0;i<4;i++)
    {
#ifndef BIG_ENDIAN
        pTxD = (PTXD_STRUC)pAdapter->TxRing[QueIdx].Cell[AC0DmaDoneIdx].AllocVa;
#else
        pDestTxD = (PTXD_STRUC)pAdapter->TxRing[QueIdx].Cell[AC0DmaDoneIdx].AllocVa;
        TxD = *pDestTxD;
        pTxD = &TxD;
        RTMPDescriptorEndianChange((PUCHAR)pTxD, TYPE_TXD);
#endif

        printk("%d%d.", pTxD->Owner, pTxD->bWaitingDmaDoneInt);
        INC_RING_INDEX(AC0DmaDoneIdx, TX_RING_SIZE);
    }
    DBGPRINT(RT_DEBUG_TRACE,"p-NDIS=%d\n", pAdapter->RalinkCounters.PendingNdisPacketCount);
}

VOID RTMPHandleRxPsPoll(
    IN  PRTMP_ADAPTER   pAd,
    IN  PUCHAR          pAddr,
    IN  MAC_TABLE_ENTRY *pMacEntry)
{
	PQUEUE_ENTRY	pEntry;
	USHORT			Aid;
	BOOLEAN			bMoreData  = FALSE;
	ULONG			IrqFlags;
    
    DBGPRINT(RT_DEBUG_TRACE,"rcv PS-POLL from %02x:%02x:%02x:%02x:%02x:%02x\n", 
        pAddr[0], pAddr[1], pAddr[2], pAddr[3], pAddr[4], pAddr[5]);

    if (pMacEntry)
    {
        Aid = pMacEntry->Aid;

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_lock_irqsave(&pAd->MacTabLock, IrqFlags);
        spin_lock_irqsave(&pAd->TxSwQueueLock, IrqFlags);
#endif
        // cleanup all backlogged frames in PSQ
        if(pMacEntry->PsQueue.Number >1)
        {
            bMoreData = TRUE;
        }

        if (((pAddr[0] == 0x00) && (pAddr[1]==0x30) && (pAddr[2]== 0xb4)) || ((pAddr[0] == 0x00) && (pAddr[1] == 0x10) && (pAddr[2] == 0x18)))
		{
			if (pMacEntry->PsQueue.Head)
			{
				pEntry = RemoveHeadQueue(&pMacEntry->PsQueue);
				InsertTailQueue(&pAd->TxSwQueue[QID_AC_BE], pEntry);
			}
		}
		else
		{
			while (pMacEntry->PsQueue.Head)
			{
				pEntry = RemoveHeadQueue(&pMacEntry->PsQueue);
				InsertTailQueue(&pAd->TxSwQueue[QID_AC_BE],pEntry);
			}
		}

#ifndef TC_NO_SPIN_LOCK // Sam add
        spin_unlock_irqrestore(&pAd->TxSwQueueLock, IrqFlags);
        spin_unlock_irqrestore(&pAd->MacTabLock, IrqFlags);
#endif
        if ((Aid > 0) && (Aid < MAX_LEN_OF_MAC_TABLE) && (pMacEntry->PsQueue.Number == 0))
        {
            // clear corresponding TIM bit
            if (Aid >= 32)
                pAd->PortCfg.MBSSID[pMacEntry->ApIdx].TimBitmap2 &= (~BIT32[Aid-32]);  
            else
                pAd->PortCfg.MBSSID[pMacEntry->ApIdx].TimBitmap &= (~BIT32[Aid]);  
            pMacEntry->PsQIdleCount = 0;
        }

        // Dequeue outgoing frames from TxSwQueue0..3 queue and process it
        // TODO: 2004-12-27 it's not a good idea to handle "More Data" bit here. because the
        // RTMPDeQueue process doesn't guarantee to de-queue the desired MSDU from the corresponding
        // TxSwQueue/PsQueue when QOS in-used. We should consider "HardTransmt" this MPDU
        // using MGMT queue or things like that.
        RTMPDeQueuePacket(pAd, bMoreData);

    }
}

VOID	RTMPPrepareRDCTSFrame(
	IN	PRTMP_ADAPTER	pAd,
	IN	PUCHAR			pDA,
	IN	ULONG			Duration,
	IN  UCHAR           RTSRate,
	IN  UCHAR           CTSIdx,
	IN  UCHAR			FrameGap)
{
	RTS_FRAME		    RtsFrame;
	PRTS_FRAME		    pRtsFrame;
	TXD_STRUC		    TxD;
	PTXD_STRUC		    pTxD;
	UCHAR				*ptr;
	UINT				i;
		
   	pRtsFrame = &RtsFrame;
    pTxD = &TxD;
				
	NdisZeroMemory(pRtsFrame, sizeof(RTS_FRAME));
	pRtsFrame->FC.Type    = BTYPE_CNTL;
	pRtsFrame->Duration = (USHORT)Duration;

	// Write Tx descriptor
	pRtsFrame->FC.SubType = SUBTYPE_CTS;
	COPY_MAC_ADDR(pRtsFrame->Addr1, pAd->CurrentAddress);
	RTMPWriteTxDescriptor(pAd, pTxD, CIPHER_NONE, 0,0, FALSE, TRUE, FALSE, SHORT_RETRY,
		FrameGap, RTSRate, 10, QID_OTHER, PTYPE_SPECIAL|PSUBTYPE_OTHER_CNTL, NULL, NULL, pAd->PortCfg.MBSSID[MAIN_MBSSID].bWmmCapable);

	ptr = (PUCHAR)pTxD;
    for (i=0; i<TXINFO_SIZE; i++)  // 24-byte TXINFO field
    {
        RTMP_IO_WRITE8(pAd, HW_CTS_FRAME_BASE + CTSIdx * HW_CTS_FRAME_SIZE + i, *ptr);
        ptr ++;
    }

    // update CTS frame content. start right after the 24-byte TXINFO field
    ptr = (PUCHAR)pRtsFrame;
    for (i=0; i<10; i++)
    {
        RTMP_IO_WRITE8(pAd, HW_CTS_FRAME_BASE + CTSIdx * HW_CTS_FRAME_SIZE + TXINFO_SIZE + i, *ptr); 
        ptr ++;
    }
}

/*
    ========================================================================
    Routine Description:
        This function checks if the received frames should be sent out to the 
        wireless media based on DA look-up in the wirelss MAC table.
        
    Arguments:
        pRxD        Pointer to the Rx descriptor
        
    Return Value:
        TRUE -  the input frame is destined to a known wireless STA 
                and had being sent out to the wireless media. It's not 
                necessary to make another copy up to LLC nor Portal function.
        FALSE - the input frame still need to deliver to the upper LLC
    ========================================================================
*/
#ifndef RTL865X_SOC
BOOLEAN RTMPBridgeToWdsAndWirelessSta(
#else
static inline BOOLEAN RTMPBridgeToWdsAndWirelessSta(
#endif
    IN  PRTMP_ADAPTER   pAdapter,
    IN  PUCHAR          pHeader802_3,
    IN  UINT            HdrLen,
    IN  PUCHAR          pData,
    IN  UINT            DataLen,
    IN  UINT            FromWhichBSSID)
{
    SST				Sst;
    USHORT			Aid;
    UCHAR			PsMode, Rate;
    MAC_TABLE_ENTRY	*pEntry;
    BOOLEAN			result = FALSE;
    struct sk_buff *skb;

    // decide the return value. TRUE if no need to indicate to LLC, FALSE otherwise
    pEntry = SsPsInquiry(pAdapter, pHeader802_3, &Sst, &Aid, &PsMode, &Rate);
    if (pHeader802_3[0] & 0x01)
        result = FALSE;
    else if (pEntry && (Sst == SST_ASSOC)) 
        result = TRUE;
    else
        result = FALSE;
    
	// unicast packet
    if ((pHeader802_3[0] & 0x01) != 0x01)
    {
	    if(!pEntry)
	    {// STAs not in wireless
	        return FALSE;
	    }
	    else if (FromWhichBSSID == pEntry->ApIdx)
	    {// STAs in same SSID
	        if ((pAdapter->PortCfg.MBSSID[pEntry->ApIdx].IsolateInterStaTraffic == 1))
	        {
	            return result;
	        }
	        else
	        {   
	        }
	    }
	    else
	    {// STAs in different SSID
	        if (pAdapter->PortCfg.IsolateInterStaTrafficBTNBSSID == 1)
	        {
	            return TRUE;
	        }
	        else
	        {
	        }
	    }
	}

    if ((pHeader802_3[0] & 0x01) || (pEntry && (Sst == SST_ASSOC)))
    {
        do {
            // 1. build a skb buffer and call RTMPSendPacket();
            //    be careful about how/when to release this internal allocated skb buffer buffer
            if ((skb = __dev_alloc_skb(HdrLen + DataLen + 2, MEM_ALLOC_FLAG)) != NULL)
            {
                skb->len = HdrLen + DataLen;
                memcpy((skb->data), pHeader802_3, HdrLen);
                memcpy((skb->data + HdrLen), pData, DataLen);
            }
            else
            {
                break;
            }
            	
            // 1.1 apidx != 0, then we need set packet mbssid attribute.
			RTMP_SET_PACKET_NET_DEVICE_MBSSID(skb, MAIN_MBSSID);	// set a default value
            if(pEntry && (pEntry->ApIdx != 0))
                RTMP_SET_PACKET_NET_DEVICE_MBSSID(skb, pEntry->ApIdx);
			/* send bc/mc frame back to the same bss */
			if (!pEntry)
				RTMP_SET_PACKET_NET_DEVICE_MBSSID(skb, FromWhichBSSID);
            RTMP_SET_PACKET_SOURCE(skb, PKTSRC_DRIVER);
            	
            // 2. send out the packet
            DBGPRINT(RT_DEBUG_INFO,"WBRG - len=%d, DA=%02x:%02x:%02x:%02x:%02x:%02x, SA=%02x:%02x:%02x:%02x:%02x:%02x\n", 
                HdrLen+DataLen,pHeader802_3[0],pHeader802_3[1],pHeader802_3[2],pHeader802_3[3],pHeader802_3[4],pHeader802_3[5],
                pHeader802_3[6],pHeader802_3[7],pHeader802_3[8],pHeader802_3[9],pHeader802_3[10],pHeader802_3[11]);

            RTMPSendPacket(pAdapter, skb);
        } while (FALSE);
    }
    RTMPDeQueuePacket(pAdapter, FALSE);

    return result;
}

/*
	========================================================================

	Routine	Description:
		Check the out going frame, if this is an DHCP or ARP datagram
	will be duplicate another frame at low data rate transmit.
		
	Arguments:
		pAd			Pointer	to our adapter
		pSkb		Pointer to outgoing skb buffer
		
	Return Value:		
		TRUE		To be transmitted at Low data rate transmit. (1Mbps/6Mbps)
		FALSE		Do nothing.

	Note:

		MAC header + IP Header + UDP Header
		  14 Bytes    20 Bytes
		  
		UDP Header
		00|01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|
						Source Port
		16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|
					Destination Port

		port 0x43 means Bootstrap Protocol, server. 
		Port 0x44 means Bootstrap Protocol, client. 

	========================================================================
*/
#ifdef RTL865X_SOC
static inline BOOLEAN RTMPCheckDHCPFrame(
#else
BOOLEAN RTMPCheckDHCPFrame(
#endif
	IN	PRTMP_ADAPTER	pAd, 
	IN  struct sk_buff	*pSkb)
{
	PUCHAR			pSrc;
	ULONG			SrcLen = 0;

	pSrc = (PVOID)pSkb->data;
    SrcLen = pSkb->len;

	// Check ARP packet
    if (SrcLen >= 13)
    {
    	if ((pSrc[12] == 0x08) && (pSrc[13] == 0x06))
    	{
    		DBGPRINT(RT_DEBUG_INFO,"RTMPCheckDHCPFrame - ARP packet\n");
    		return TRUE;
    	}
    }

	// Check foe DHCP & BOOTP protocol
	if (SrcLen >= 37)
	{
		if ((pSrc[35] == 0x43) && (pSrc[37] == 0x44))
		{
			DBGPRINT(RT_DEBUG_INFO,"RTMPCheckDHCPFrame - DHCP packet\n");
			return TRUE;
		}
	}

	return FALSE;
}

#ifdef BIG_ENDIAN
#ifdef RTL865X_SOC
//extern unsigned int mylinkid;	/* Remember your link id */
__IRAM static void rtl865x_rx(PRTMP_ADAPTER pAd, struct sk_buff *skb)
{
	UINT32	retval;
	INT		index;
	unsigned int mylinkid;

#if 0	
{
	int i;
	for (i=0; i<32; i++) {
		printk("%02x ", skb->data[i]);
		if (i%16 == 15) printk("\n");
	}
	printk("\n");
}
#endif
	for(index = 0; index < pAd->PortCfg.BssidNum; index++)
	{
		if (pAd->PortCfg.MBSSID[index].MSSIDDev == skb->dev) 
		{
			mylinkid = pAd->PortCfg.MBSSID[index].mylinkid;
			retval = rtl8651_fwdEngineExtPortRecv(skb, skb->data, skb->len,
					CONFIG_8139CP_VID, 1<<CONFIG_RTL865XB_WLAN1_PORT, mylinkid);
			if (retval != SUCCESS) 
			{
				/* exception. Drop it */
				dev_kfree_skb_irq(skb);
			}
			return;
		}							
	}


	if (pAd->WdsTab.Mode != WDS_DISABLE_MODE) {
	    for (index = 0; index < MAX_WDS_ENTRY; index++)
	    {
	        if ((pAd->WdsTab.WdsEntry[index].Valid == TRUE) && (pAd->WdsTab.WdsEntry[index].dev == skb->dev))
	        {
				mylinkid = pAd->WdsTab.WdsEntry[index].mylinkid;
				retval = rtl8651_fwdEngineExtPortRecv(skb, skb->data, skb->len,
						CONFIG_8139CP_VID, 1<<CONFIG_RTL865XB_WLAN1_PORT, mylinkid);
				if (retval != SUCCESS) 
				{
					/* exception. Drop it */
					dev_kfree_skb_irq(skb);
				}
				return;
	        }
		}							
	}
}
#endif /* RTL865X_SOC */
#endif	//#ifdef BIG_ENDIAN

