/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attempt
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	connect.c

	Abstract:

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	John		2004-08-08		Major modification from RT2560
*/
#include "rt_config.h"

UCHAR PowerConstraintIE[3] = {IE_POWER_CONSTRAINT, 1, 3};

/*
    ==========================================================================
    Description:
        Pre-build All BEACON frame in the shared memory
    ==========================================================================
*/
VOID MakeAllBssBeacon(
    IN PRTMP_ADAPTER pAd)
{
	INT		i, j;
	ULONG	csr5;

	// before MakeBssBeacon, clear all beacon TxD's valid bit
	for(i=0; i<4; i++)
	{
		for (j=0; j<TXINFO_SIZE; j++)  // 24-byte TXINFO field
	    {
	        RTMP_IO_WRITE8(pAd, HW_BEACON_BASE0 + (i * HW_BEACON_OFFSET) + j, 0);
	    }
	}

	for(i=0; i<pAd->PortCfg.BssidNum; i++)
	{
		MakeBssBeacon(pAd, i);
	}

	// set MAC_CSR5 to turn on Unicast_to_me report
	RTMP_IO_READ32(pAd, MAC_CSR5, &csr5);
	csr5 &= 0xFFFCFFFF;
	csr5 |= 0x00030000;
	RTMP_IO_WRITE32(pAd, MAC_CSR5, csr5);
}

/*
    ==========================================================================
    Description:
        Pre-build All BEACON frame in the shared memory
    ==========================================================================
*/
VOID UpdateAllBeaconFrame(
    IN PRTMP_ADAPTER pAd)
{
	INT		i;

	for(i=0; i<pAd->PortCfg.BssidNum; i++)
	{
		UpdateBeaconFrame(pAd, i);
	}
}

/*
    ==========================================================================
    Description:
        Update BEACON frame in the shared memory per TBTT
    ==========================================================================
*/
VOID MakeBssBeacon(
    IN PRTMP_ADAPTER	pAd,
    IN INT				apidx) 
{
	UCHAR         SsidIe = IE_SSID, DsIe = IE_DS_PARM, SuppIe = IE_SUPP_RATES, RSNIe = IE_WPA, RSNIe2 = IE_WPA2,
					SupportedRatesLen;
    UCHAR         DsLen = 1, SsidLen;
    HEADER_802_11 BcnHdr;
    LARGE_INTEGER FakeTimestamp;
    ULONG         FrameLen;
    PTXD_STRUC    pTxD = &pAd->PortCfg.MBSSID[apidx].BeaconTxD;
    PUCHAR        pBeaconFrame = pAd->PortCfg.MBSSID[apidx].BeaconBuf;

    // Bridge mode doesn't send beacon.
    if (pAd->WdsTab.Mode == WDS_BRIDGE_MODE)
        return;

    if ((pAd->PortCfg.PhyMode == PHY_11BG_MIXED) || (pAd->PortCfg.PhyMode == PHY_11G))
        SupportedRatesLen = 4;
    else	// include A band
        SupportedRatesLen = pAd->PortCfg.SupportedRatesLen;

    if (pAd->PortCfg.MBSSID[apidx].bHideSsid)
        SsidLen = 0;
    else
        SsidLen = pAd->PortCfg.MBSSID[apidx].SsidLen;

    MgtMacHeaderInit(pAd, &BcnHdr, SUBTYPE_BEACON, 0, pAd->PortCfg.Broadcast, pAd->PortCfg.MBSSID[apidx].Bssid);

    if ((pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPAPSK))
    	RSNIe = IE_WPA;
    else if ((pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA2) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA2PSK))
    	RSNIe = IE_WPA2;
    
	if ((pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPA1WPA2) || (pAd->PortCfg.MBSSID[apidx].AuthMode == Ndis802_11AuthModeWPAPSKWPA2PSK))
    {
        MakeOutgoingFrame(pBeaconFrame,                             &FrameLen,
                        sizeof(HEADER_802_11),                      &BcnHdr,
                        TIMESTAMP_LEN,                              &FakeTimestamp,
                        2,                                          &pAd->PortCfg.BeaconPeriod,
                        2,                                          &pAd->PortCfg.MBSSID[apidx].CapabilityInfo,
                        1,                                          &SsidIe,
                        1,                                          &SsidLen,
                        SsidLen,                                    pAd->PortCfg.MBSSID[apidx].Ssid,
                        1,                                          &SuppIe,
                        1,                                          &SupportedRatesLen,
                        SupportedRatesLen,                          pAd->PortCfg.SupportedRates,
                        1,                                          &DsIe,
                        1,                                          &DsLen,
                        1,                                          &pAd->PortCfg.Channel,
                        1,                                          &RSNIe,
                        1,                                          &pAd->PortCfg.MBSSID[apidx].RSNIE_Len[0],
                        pAd->PortCfg.MBSSID[apidx].RSNIE_Len[0],     pAd->PortCfg.MBSSID[apidx].RSN_IE[0],
                        1,                                          &RSNIe2,
                        1,                                          &pAd->PortCfg.MBSSID[apidx].RSNIE_Len[1],
                        pAd->PortCfg.MBSSID[apidx].RSNIE_Len[1],     pAd->PortCfg.MBSSID[apidx].RSN_IE[1],
                        END_OF_ARGS);
    }
	else if (pAd->PortCfg.MBSSID[apidx].AuthMode >= Ndis802_11AuthModeWPA)
    {
        MakeOutgoingFrame(pBeaconFrame,                             &FrameLen,
                        sizeof(HEADER_802_11),                      &BcnHdr,
                        TIMESTAMP_LEN,                              &FakeTimestamp,
                        2,                                          &pAd->PortCfg.BeaconPeriod,
                        2,                                          &pAd->PortCfg.MBSSID[apidx].CapabilityInfo,
                        1,                                          &SsidIe,
                        1,                                          &SsidLen,
                        SsidLen,                                    pAd->PortCfg.MBSSID[apidx].Ssid,
                        1,                                          &SuppIe,
                        1,                                          &SupportedRatesLen,
                        SupportedRatesLen,                          pAd->PortCfg.SupportedRates,
                        1,                                          &DsIe,
                        1,                                          &DsLen,
                        1,                                          &pAd->PortCfg.Channel,
                        1,                                          &RSNIe,
                        1,                                          &pAd->PortCfg.MBSSID[apidx].RSNIE_Len[0],
                        pAd->PortCfg.MBSSID[apidx].RSNIE_Len[0],   pAd->PortCfg.MBSSID[apidx].RSN_IE[0],
                        END_OF_ARGS);
    }
    else
    {
        MakeOutgoingFrame(pBeaconFrame,                  &FrameLen,
                        sizeof(HEADER_802_11),           &BcnHdr,
                        TIMESTAMP_LEN,                   &FakeTimestamp,
                        2,                               &pAd->PortCfg.BeaconPeriod,
                        2,                               &pAd->PortCfg.MBSSID[apidx].CapabilityInfo,
                        1,                               &SsidIe,
                        1,                               &SsidLen,
                        SsidLen,                         pAd->PortCfg.MBSSID[apidx].Ssid,
                        1,                               &SuppIe,
                        1,                               &SupportedRatesLen,
                        SupportedRatesLen,               pAd->PortCfg.SupportedRates,
                        1,                               &DsIe,
                        1,                               &DsLen,
                        1,                               &pAd->PortCfg.Channel,
                        END_OF_ARGS);
    }

    // add WMM IE here
    if (pAd->PortCfg.MBSSID[apidx].bWmmCapable)
    {
        ULONG TmpLen;
        UCHAR i;
        UCHAR WmeParmIe[26] = {IE_VENDOR_SPECIFIC, 24, 0x00, 0x50, 0xf2, 0x02, 0x01, 0x01, 0, 0}; 
        
        WmeParmIe[8] = pAd->PortCfg.BssEdcaParm.EdcaUpdateCount & 0x0f;
        WmeParmIe[8] |= (pAd->PortCfg.bAPSDCapable) ? 0x80 : 0x00;
        for (i=QID_AC_BE; i<=QID_AC_VO; i++)
        {
            WmeParmIe[10+ (i*4)] = (i << 5)                                         +     // b5-6 is ACI
                                   ((UCHAR)pAd->PortCfg.BssEdcaParm.bACM[i] << 4)     +     // b4 is ACM
                                   (pAd->PortCfg.BssEdcaParm.Aifsn[i] & 0x0f);              // b0-3 is AIFSN
            WmeParmIe[11+ (i*4)] = (pAd->PortCfg.BssEdcaParm.Cwmax[i] << 4)           +     // b5-8 is CWMAX
                                   (pAd->PortCfg.BssEdcaParm.Cwmin[i] & 0x0f);              // b0-3 is CWMIN
            WmeParmIe[12+ (i*4)] = (UCHAR)(pAd->PortCfg.BssEdcaParm.Txop[i] & 0xff);        // low byte of TXOP
            WmeParmIe[13+ (i*4)] = (UCHAR)(pAd->PortCfg.BssEdcaParm.Txop[i] >> 8);          // high byte of TXOP
        }

        MakeOutgoingFrame(pBeaconFrame+FrameLen,         &TmpLen,
                          26,                            WmeParmIe,
                          END_OF_ARGS);
        FrameLen += TmpLen;
    }

    // add country IE, power constraint IE
    if (pAd->PortCfg.bCountryFlag)
    {
        ULONG TmpLen, TmpLen2=0;
        UCHAR TmpFrame[256];
        UCHAR CountryIe = IE_COUNTRY;
        UCHAR MaxTxPower=16;

        // prepare power constraint IE
        MakeOutgoingFrame(pBeaconFrame+FrameLen,	&TmpLen,
                          3,							PowerConstraintIE,
                          END_OF_ARGS);
        FrameLen += TmpLen;

        NdisZeroMemory(TmpFrame, sizeof(TmpFrame));

		// prepare channel information
        MakeOutgoingFrame(TmpFrame+TmpLen2,     &TmpLen,
                          1,                 	&pAd->ChannelList[0].Channel,
                          1,                 	&pAd->ChannelListNum,
                          1,                 	&MaxTxPower,
                          END_OF_ARGS);
        TmpLen2 += TmpLen;

        // need to do the padding bit check, and concatenate it
        if ((TmpLen2%2) == 0)
        {
        	UCHAR	TmpLen3 = TmpLen2+4;
	        MakeOutgoingFrame(pBeaconFrame+FrameLen,&TmpLen,
	                          1,                 	&CountryIe,
	                          1,                 	&TmpLen3,
	                          3,                 	pAd->PortCfg.CountryCode,
	                          TmpLen2+1,				TmpFrame,
	                          END_OF_ARGS);
        }
        else
        {
        	UCHAR	TmpLen3 = TmpLen2+3;
	        MakeOutgoingFrame(pBeaconFrame+FrameLen,&TmpLen,
	                          1,                 	&CountryIe,
	                          1,                 	&TmpLen3,
	                          3,                 	pAd->PortCfg.CountryCode,
	                          TmpLen2,				TmpFrame,
	                          END_OF_ARGS);
        }
        FrameLen += TmpLen;
    }

#ifdef BIG_ENDIAN
    RTMPFrameEndianChange(pAd, pBeaconFrame, DIR_WRITE, FALSE);
#endif

    RTMPWriteTxDescriptor(pAd, pTxD, CIPHER_NONE, 0, 0, FALSE, FALSE, TRUE, SHORT_RETRY, IFS_BACKOFF, 
        pAd->PortCfg.MlmeRate, FrameLen, QID_MGMT, PTYPE_SPECIAL|PSUBTYPE_MGMT, NULL, NULL, pAd->PortCfg.MBSSID[apidx].bWmmCapable, FALSE, FALSE, FALSE);

    pAd->PortCfg.MBSSID[apidx].TimIELocationInBeacon = (UCHAR)FrameLen; 
    pAd->PortCfg.MBSSID[apidx].CapabilityInfoLocationInBeacon = sizeof(HEADER_802_11) + TIMESTAMP_LEN + 2;

    DBGPRINT(RT_DEBUG_TRACE,"MakeBssBeacon(ra%d)(FrameLen=%d,TimIELocateInBeacon=%d,CapInfoLocateInBeacon=%d)\n", apidx, FrameLen, pAd->PortCfg.MBSSID[apidx].TimIELocationInBeacon,pAd->PortCfg.MBSSID[apidx].CapabilityInfoLocationInBeacon);
}

VOID UpdateBeaconFrame(
    IN PRTMP_ADAPTER	pAd,
    IN INT				apidx) 
{
	PTXD_STRUC		pTxD = &pAd->PortCfg.MBSSID[apidx].BeaconTxD;
    PHEADER_802_11	pBcnHdr = (PHEADER_802_11)pAd->PortCfg.MBSSID[apidx].BeaconBuf;
    UCHAR			*ptr;
    ULONG			FrameLen = pAd->PortCfg.MBSSID[apidx].TimIELocationInBeacon;
    UCHAR			byte0 = (UCHAR)(pAd->PortCfg.MBSSID[apidx].TimBitmap & 0x000000fe);  // skip AID#0
    UCHAR			byte1 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap & 0x0000ff00) >> 8);
    UCHAR			byte2 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap & 0x00ff0000) >> 16);
    UCHAR			byte3 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap & 0xff000000) >> 24);
    UCHAR			byte4 = (UCHAR)(pAd->PortCfg.MBSSID[apidx].TimBitmap2 & 0x000000ff);
    UCHAR			byte5 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap2 & 0x0000ff00) >> 8);
    UCHAR			byte6 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap2 & 0x00ff0000) >> 16);
    UCHAR			byte7 = (UCHAR)((pAd->PortCfg.MBSSID[apidx].TimBitmap2 & 0xff000000) >> 24);
    UINT			i;

    // Bridge mode doesn't send beacon.
    if (pAd->WdsTab.Mode == WDS_BRIDGE_MODE)
        return;
    
    // update BEACON's Capability
    ptr = (UCHAR *)pBcnHdr + pAd->PortCfg.MBSSID[apidx].CapabilityInfoLocationInBeacon;
    *ptr = (UCHAR)(pAd->PortCfg.MBSSID[apidx].CapabilityInfo & 0x00ff);
    *(ptr+1) = (UCHAR)((pAd->PortCfg.MBSSID[apidx].CapabilityInfo & 0xff00) >> 8);

	// step 2 - update TIM IE
    if (pAd->Mlme.DtimCount == 0)
        pAd->Mlme.DtimCount = pAd->Mlme.DtimPeriod - 1;
    else
        pAd->Mlme.DtimCount -= 1;
    
    ptr = (UCHAR *)pBcnHdr + pAd->PortCfg.MBSSID[apidx].TimIELocationInBeacon;
    *ptr = IE_TIM;
    *(ptr + 2) = pAd->Mlme.DtimCount;
    *(ptr + 3) = pAd->Mlme.DtimPeriod;

    if (byte0 || byte1) // there's some backlog frame for AID 1-15
    {
        *(ptr + 4) = 0;      // Virtual TIM bitmap stars from AID #0
        *(ptr + 5) = byte0;
        *(ptr + 6) = byte1;
        *(ptr + 7) = byte2;
        *(ptr + 8) = byte3;
        *(ptr + 9) = byte4;
        *(ptr + 10) = byte5;
        *(ptr + 11) = byte6;
        *(ptr + 12) = byte7;
        if (byte7)      *(ptr + 1) = 11; // IE length
        else if (byte6) *(ptr + 1) = 10; // IE length
        else if (byte5) *(ptr + 1) = 9;  // IE length
        else if (byte4) *(ptr + 1) = 8;  // IE length
        else if (byte3) *(ptr + 1) = 7;  // IE length
        else if (byte2) *(ptr + 1) = 6;  // IE length
        else if (byte1) *(ptr + 1) = 5;  // IE length
        else            *(ptr + 1) = 4;  // IE length
    }
    else if (byte2 || byte3) // there's some backlogged frame for AID 16-31
    {
        *(ptr + 4) = 2;      // Virtual TIM bitmap starts from AID #16
        *(ptr + 5) = byte2;
        *(ptr + 6) = byte3;
        *(ptr + 7) = byte4;
        *(ptr + 8) = byte5;
        *(ptr + 9) = byte6;
        *(ptr + 10) = byte7;
        if (byte7)      *(ptr + 1) = 9; // IE length
        else if (byte6) *(ptr + 1) = 8; // IE length
        else if (byte5) *(ptr + 1) = 7; // IE length
        else if (byte4) *(ptr + 1) = 6; // IE length
        else if (byte3) *(ptr + 1) = 5; // IE length
        else            *(ptr + 1) = 4; // IE length
    }
    else if (byte4 || byte5) // there's some backlogged frame for AID 32-47
    {
        *(ptr + 4) = 4;      // Virtual TIM bitmap starts from AID #32
        *(ptr + 5) = byte4;
        *(ptr + 6) = byte5;
        *(ptr + 7) = byte6;
        *(ptr + 8) = byte7;
        if (byte7)      *(ptr + 1) = 7; // IE length
        else if (byte6) *(ptr + 1) = 6; // IE length
        else if (byte5) *(ptr + 1) = 5; // IE length
        else            *(ptr + 1) = 4; // IE length
    }
    else if (byte6 || byte7) // there's some backlogged frame for AID 48-63
    {
        *(ptr + 4) = 6;      // Virtual TIM bitmap starts from AID #48
        *(ptr + 5) = byte6;
        *(ptr + 6) = byte7;
        if (byte7)      *(ptr + 1) = 5; // IE length
        else            *(ptr + 1) = 4; // IE length
    }
    else // no backlogged frames
    {
        *(ptr + 1) = 4; // IE length
        *(ptr + 4) = 0;
        *(ptr + 5) = 0;
    }
    
    // bit0 means backlogged mcast/bcast
    *(ptr + 4) |= (pAd->PortCfg.MBSSID[apidx].TimBitmap & 0x01); 
    
    // adjust BEACON length according to the new TIM
    FrameLen += (2 + *(ptr+1)); 

	// Update ERP and extended tx rate
    if ((pAd->PortCfg.PhyMode == PHY_11BG_MIXED) || (pAd->PortCfg.PhyMode == PHY_11G))
    {
        UCHAR ExtendedRatesLen = pAd->PortCfg.SupportedRatesLen - 4;
        
        //
        // fill ERP IE
        // 
        ptr = (UCHAR *)pBcnHdr + FrameLen; // pTxD->DataByteCnt;
        *ptr = IE_ERP;
        *(ptr + 1) = 1;
        *(ptr + 2) = pAd->Mlme.ErpIeContent;

        //
        // fill up EXTENDED RATE IE.
        // 
        *(ptr + 3) = IE_EXT_SUPP_RATES;
        *(ptr + 4) = ExtendedRatesLen;
        NdisMoveMemory(ptr + 5, &pAd->PortCfg.SupportedRates[4], *(ptr + 4));
        ptr      += (3 + 2 + ExtendedRatesLen);
        FrameLen += (3 + 2 + ExtendedRatesLen);
    }

    //
    // fill up Channel Switch Announcement Element
    //
    if ((pAd->PortCfg.PhyMode == PHY_11A) && (pAd->PortCfg.RadarDetect.IEEE80211H == TRUE) && (pAd->PortCfg.RadarDetect.RDMode == RD_SWITCHING_MODE))
    {
    	ptr = (UCHAR *)pBcnHdr + FrameLen;
    	*ptr = IE_CHANNEL_SWITCH_ANNOUNCEMENT;
        *(ptr + 1) = 3;
        *(ptr + 2) = 1;
        *(ptr + 3) = pAd->PortCfg.Channel;
        *(ptr + 4) = pAd->PortCfg.RadarDetect.CSCount;
        ptr      += 5;
        FrameLen += 5;
    }

	// add Ralink-specific IE here - Byte0.b0=1 for aggregation, Byte0.b1=1 for piggy-back
    if (pAd->PortCfg.bAggregationCapable)
    {
    	if ((pAd->PortCfg.bPiggyBackCapable) && (!pAd->PortCfg.bOneClientUsePiggyBack))
    	{
    		ULONG TmpLen;
	        UCHAR RalinkSpecificIe[9] = {IE_VENDOR_SPECIFIC, 7, 0x00, 0x0c, 0x43, 0x03, 0x00, 0x00, 0x00};
	        MakeOutgoingFrame((UCHAR *)pBcnHdr+FrameLen, &TmpLen,
	                          9,                         RalinkSpecificIe,
	                          END_OF_ARGS);
	        FrameLen += TmpLen;
    	}
    	else
    	{
	        ULONG TmpLen;
	        UCHAR RalinkSpecificIe[9] = {IE_VENDOR_SPECIFIC, 7, 0x00, 0x0c, 0x43, 0x01, 0x00, 0x00, 0x00}; 
	        MakeOutgoingFrame((UCHAR *)pBcnHdr+FrameLen, &TmpLen,
	                          9,                         RalinkSpecificIe,
	                          END_OF_ARGS);
	        FrameLen += TmpLen;
    	}
    }

    // Since FrameLen may change, update TXD
    RTMPWriteTxDescriptor(pAd, pTxD, CIPHER_NONE, 0, 0, FALSE, FALSE, TRUE, SHORT_RETRY, IFS_BACKOFF, 
        pAd->PortCfg.MlmeRate, FrameLen, QID_MGMT, PTYPE_SPECIAL|PSUBTYPE_MGMT, NULL, NULL, pAd->PortCfg.MBSSID[apidx].bWmmCapable, FALSE, FALSE, FALSE);

    // move BEACON TXD and frame content to on-chip memory
    ptr = (PUCHAR)&pAd->PortCfg.MBSSID[apidx].BeaconTxD;
    for (i=0; i<TXINFO_SIZE; i++)  // 24-byte TXINFO field
    {
        RTMP_IO_WRITE8(pAd, HW_BEACON_BASE0 + (apidx * HW_BEACON_OFFSET) + i, *ptr);
        ptr ++;
    }

    // start right after the 24-byte TXINFO field
    ptr = pAd->PortCfg.MBSSID[apidx].BeaconBuf;
//    for (i=0; i< pAd->PortCfg.MBSSID[apidx].BeaconTxD.DataByteCnt; i++)
	 for (i=0; i< FrameLen; i++)
    {
        RTMP_IO_WRITE8(pAd, HW_BEACON_BASE0 + (apidx * HW_BEACON_OFFSET) + TXINFO_SIZE + i, *ptr);
        ptr ++;
    }

    //
    // if DTIM, then move backlogged bcast/mcast frames from PSQ to TXQ whenever DtimCount==0
#if 0    
    // NOTE: This updated BEACON frame will be sent at "next" TBTT instead of at cureent TBTT. The reason is
    //       because ASIC already fetch the BEACON content down to TX FIFO before driver can make any
    //       modification. To compenstate this effect, the actual time to deilver PSQ frames will be
    //       at the time that we wrapping around DtimCount from 0 to DtimPeriod-1
    if ((pAd->ApCfg.DtimCount + 1) == pAd->ApCfg.DtimPeriod)
#else
    if (pAd->Mlme.DtimCount == 0)
#endif
    {
        PQUEUE_ENTRY    pEntry;
        ULONG			IrqFlags;

        spin_lock_irqsave(&pAd->MacTabLock, IrqFlags);
        spin_lock_irqsave(&pAd->TxSwQueueLock, IrqFlags);
        while (pAd->MacTab.McastPsQueue.Head)
        {
            pEntry = RemoveHeadQueue(&pAd->MacTab.McastPsQueue);
            InsertTailQueue(&pAd->TxSwQueue[QID_AC_BE], pEntry);
            DBGPRINT(RT_DEBUG_TRACE, "DTIM=%d/%d, tx mcast/bcast out...\n",pAd->Mlme.DtimCount,pAd->Mlme.DtimPeriod);
        }
        spin_unlock_irqrestore(&pAd->TxSwQueueLock, IrqFlags);
        spin_unlock_irqrestore(&pAd->MacTabLock, IrqFlags);
        pAd->PortCfg.MBSSID[apidx].TimBitmap &= ~BIT32[0]; // clear MCAST/BCAST backlog bit
        pAd->MacTab.PsQIdleCount = 0;

        // Dequeue outgoing framea from TxSwQueue0..3 queue and process it
        RTMPDeQueuePacket(pAd, FALSE);
    }
}

