/*
** $Id: ap_proto.h 2.7 2004/10/04 17:23:44 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

#ifndef _AP_PROTOTYPE_DECLARATION_H
#define _AP_PROTOTYPE_DECLARATION_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
extern int x_NumTFCB;
extern int x_NumTBB;
extern int x_NumRFB;
extern int x_channel;
extern int x_preTBTT;
extern int x_MAX_AID;
extern int x_CfbBurst;
extern int x_hide_ssid;

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/*----------------------------------------------------------
*       dot11_if.c
*---------------------------------------------------------*/
int env_PHY_SAP_RX(i2220mgmt_t *priv_p, rfb_t *rfb_p);
int env_PHY_SAP_TX(i2220mgmt_t *priv_p, FragSdu_t* fsdu);

FragSdu_t *sdlu_sdu2fsdu(i2220mgmt_t *priv_p, Frame_t *sdu, UINT8 cipherSuite);
int sdu_send_request(i2220mgmt_t *priv_p, Frame_t *tsdu, sta_info_t *sta_p, CfPriority_t pri);

void sdlu_init_defrag(i2220mgmt_t *priv_p);
void sdlu_destroy_defrag(i2220mgmt_t *priv_p);
int sdlu_defragment(i2220mgmt_t *priv_p, Frame_t **pdu_pp);

int wlanhdr_to_wlanhdr(i2220mgmt_t *priv_p, Frame_t *tpdu, Frame_t *pdu);
void sdlu_PM_monitor(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);

/*----------------------------------------------------------
*       dot3_if.c
*---------------------------------------------------------*/
int wlanhdr_from_ether(kal_skb_t *skb);
int wlanhdr_to_ether(kal_net_device_t *dev, Frame_t *rsdu);
void append_vlang_tag(kal_skb_t * skb, ssid_info_t* which_ssid);
int remove_vlang_tag(kal_skb_t * skb,unsigned int* pri,unsigned int* vlan_id);
extern unsigned char rfc1042_header[6];
extern TypMacAddr nullAddr;

/*----------------------------------------------------------
*       proc.c
*---------------------------------------------------------*/
#if WLAN_INCLUDE_PROC
void add_sta_proc(i2220mgmt_t *priv_p, sta_info_t *sta_p);
#endif

/*----------------------------------------------------------
*       i2220subr.c
*---------------------------------------------------------*/
int sdlu_tx_FragSdu(i2220mgmt_t *priv_p, FragSdu_t* fsdu, int tdmaChannel, bool chk_res);
int sdlu_mk_FragSdu_TFCB(i2220mgmt_t *priv_p, FragSdu_t *fsdu, tdma_parameters_t *tdma_p);

void sdlu_release_sdu(Frame_t * sdu);
void sdlu_release_fsdu(FragSdu_t *fsdu);
void sdlu_release_tfcb(struct _tfcb_t *tfcb_p);

bool sdlhw_send_beacon(i2220mgmt_t *priv_p, beacon_frame_t *tpdu, int lenInfo);

void auto_txrate_switch(i2220mgmt_t *priv_p, sta_info_t *sta_p, tfcb_t *tfcb_p);
void set_txTimeout(i2220mgmt_t *priv_p);

/*----------------------------------------------------------
*       sdl_MLME_AP.c
*---------------------------------------------------------*/
void* __search_infoElem(UINT8 eid, UINT8 *infoElem, int infoLen);
txRate_info_t* __get_txRate_info(i2220mgmt_t *priv_p, UINT8 txRate);
StatusCode_t __convert_rates(RateString_t rate_p, RateSet_t *suptRateSet_p,
                        RateSet_t *basicRateSet_p, int numRates);
UINT8* __set_beacon_probrsp_frame(i2220mgmt_t *priv_p, beacon_frame_t *yTdu, bool hide_ssid, int which_ssid);
UINT8* __mkTim(i2220mgmt_t *priv_p, UINT8* cp, bool bcast);
void rx_process_ps_poll(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_beacon(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_probe_req(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_reasoc_req(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_disasoc(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_auth(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
void rx_process_deauth(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
Frame_t *sdl_mkFrame(i2220mgmt_t *priv_p, int max_size, TypeSubtype_t ft,
                        UINT8 *da, UINT8 *bssid);
void sdlf_send_deauth(i2220mgmt_t *priv_p, MacAddr_t da, ReasonCode_t reason);

void MlmeStart_request(i2220mgmt_t *priv_p);
void MlmeScan_request(unsigned long data);

/*----------------------------------------------------------
*       sdl_Dist_serv.c
*---------------------------------------------------------*/
KAL_IRAM int rx_do_forward(i2220mgmt_t *priv_p, Frame_t *pdu,
                        sta_info_t *sta_p);
int rx_process_data(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p,
                        rfb_t *rfb_p);
int wds_rx_do_forward(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p);
int wds_rx_process_data(i2220mgmt_t *priv_p, Frame_t *pdu, sta_info_t *sta_p,
                        rfb_t *rfb_p);

/*----------------------------------------------------------
*       sdl_subr.c
*---------------------------------------------------------*/
void mib_initialize(i2220mgmt_t *priv_p);

sta_info_t* create_sta(i2220mgmt_t *priv_p, MacAddr_t addr);
void leave_assoc_state(i2220mgmt_t *priv_p, sta_info_t *sta_p);
void free_sta(i2220mgmt_t *priv_p, sta_info_t *sta_p);

sta_info_t* sdlu_query_sta(i2220mgmt_t *priv_p, MacAddr_t addr);
sta_info_t* task_sta_lookup(i2220mgmt_t *priv_p, MacAddr_t addr);
int task_assign_AId(i2220mgmt_t *priv_p, sta_info_t *SSta_p);

void sdlu_init_ap(i2220mgmt_t *priv_p);
void sdlu_destroy_ap(i2220mgmt_t *priv_p);
void task_free_sta(sta_info_t *sta);

int  task_find_authAlg(i2220mgmt_t *priv_p, AuthType_t alg);

void ap_timer_func(unsigned long data);
void update_bss_operating(i2220mgmt_t *priv_p);

#ifdef IPN_NEW_KAL
UINT32 __swap32(UINT32 i);
UINT16 __swap16(UINT16 i);
#if 0  // Sam do it 
void* ipn_memcpy(void* dest, void* src, int len);
void* ipn_memset(void* dest, int value, int len);
int ipn_memcmp(void* dest, void* src, int len);
#endif
#define ipn_memcpy      memcpy
#define ipn_memset      memset
#define ipn_memcmp      memcmp

#else
#define ipn_memcpy      memcpy
#define ipn_memset      memset
#define ipn_memcmp      memcmp
#endif /* end of IPN_NEW_KAL */

/*----------------------------------------------------------
*       i2220hw.c
*---------------------------------------------------------*/
#if WLAN_INCLUDE_DEBUG
void dbg_tx_tdma(i2220mgmt_t *priv_p, int tdmaChannel, int chkNum);
void dbg_tx_packet(i2220mgmt_t *priv_p, void *ptr, UINT32 flag);
void dbg_rx_rdma(i2220mgmt_t *priv_p, int chkNum);
void dbg_rx_packet(i2220mgmt_t *priv_p, rfb_t *rfb_p, UINT32 flag);
void dbg_frame_header(const Frame_t *sdu);
void dbg_frame_header2(const Frame_t *sdu, int dbg_level);
#else
#define dbg_tx_tdma(priv_p,tdmaChannel,chkNum)
#define dbg_tx_packet(priv_p,ptr,flag)
#define dbg_rx_rdma(priv_p,chkNum)
#define dbg_rx_packet(priv_p,rfb_p,flag)
#define dbg_frame_header2(sdu,level)
#define dbg_frame_header(sdu)
#endif

void i2220hw_reset_mac(i2220mgmt_t *priv_p);
int i2220hw_interrupt(void *dev_priv);
int i2220hw_create( i2220mgmt_t *priv_p);
void i2220hw_destroy( i2220mgmt_t *priv_p);
int i2220hw_drvr_stop(i2220mgmt_t *priv_p);
int i2220hw_drvr_start(i2220mgmt_t *priv_p);

int tx_prepare_TBB(i2220mgmt_t *priv_p,
                UINT8 *data[], int len[], tfcb_t *tfcb_p);
KAL_IRAM void tx_setup_TFCB_ctrl_info(i2220mgmt_t *priv_p, tfcb_t *tfcb_p,
                tfcb_t *prev_tfcb_p);

void hw_getChannelBoundaries(i2220mgmt_t *priv_p);
int hw_read_adapter_info(i2220mgmt_t *priv_p);
void hw_setOwnMacAddress(i2220mgmt_t *priv_p, UINT8 *ownMacAddr_p);
int hw_initializeAdapter(i2220mgmt_t *priv_p);
void hw_set_rate_table(i2220mgmt_t *priv_p);
void hw_set_rate_info(i2220mgmt_t *priv_p);
void hw_set_channel(i2220mgmt_t *priv_p, UINT8 txPowerLimit);
void hw_set_beacon(i2220mgmt_t *priv_p, BOOLEAN genesis);

/*----------------------------------------------------------
*       wep.c
*---------------------------------------------------------*/
UCHAR
wepHwMpduEncapsulate(IN PMP_ADAPTER adapter_p,
                     IN OUT PTFCB_STRUC  tfcb_p,
                     IN ULONG keyId,
                     IN PUCHAR key_p,
                     IN ULONG keyLen,
                     IN UCHAR cipher_suite);

/*----------------------------------------------------------
*       privacy.c
*---------------------------------------------------------*/
VOID    privacyInitialize(IN PMP_ADAPTER adapter_p);

BOOLEAN privacySeekForEntry(IN PMP_ADAPTER priv_p,
                    IN IPN_KEY_STRUC *key_p,
                    OUT PULONG keyIndex_p);

BOOLEAN privacySeekForEmptyEntry(IN PMP_ADAPTER priv_p,
                         IN BOOLEAN isGroupKey,
                         OUT PULONG keyIndex_p);

BOOLEAN privacyFindMappingAddr(PMP_ADAPTER adapter_p, PUCHAR macAddr_p, PUCHAR mappingKeyID_p);
VOID    privacyConstructSwKeyTable(PMP_ADAPTER adapter_p);
UINT    privacySeekKeyInSwKeyTable(PMP_ADAPTER adapter_p, ULONG keyIndex,PUCHAR keyMappingAddr_p);
UINT    privacySeekNullKeyEntry(PMP_ADAPTER adapter_p, ULONG keyIndex);
VOID    privacyAddKeyToHwKeyTable(PMP_ADAPTER adapter_p, UINT hwIndex,
            UCHAR entryIndex, ULONG keyIndex, PUCHAR key_p, ULONG keyLength, PUCHAR keyMappingAddr_p);
VOID    privacySetRsnUnicastCipherSuite(IN PMP_ADAPTER adapter_p,
                                IN BOOLEAN none,
                                IN BOOLEAN wep40,
                                IN BOOLEAN tkip,
                                IN BOOLEAN wrap,
                                IN BOOLEAN ccmp,
                                IN BOOLEAN wep104,
                                IN BOOLEAN wep128);
VOID    privacyClearSwKeyTable(IN PMP_ADAPTER adapter_p);

/*----------------------------------------------------------
*       wep_func.c
*---------------------------------------------------------*/
extern unsigned char ETH_P_PAE[2];
extern unsigned char ETH_P_PAE_PA[2];
extern unsigned char ETH_P_PAE_START[2];
extern unsigned char ETH_P_PAE_KEY[2];
extern unsigned char IE_WPA_OUI[4];

UINT8*      __mkWpaIE(i2220mgmt_t * priv_p, UINT8 *cp);
BOOLEAN     CheckFor1xFrame(UINT8 *snapHeader_p, UINT16 bodyLen);
void        IEEE8021x_reassoc(i2220mgmt_t *priv_p,sta_info_t *sta_p);
void        IEEE8021x_deauth(i2220mgmt_t *priv_p,sta_info_t *sta_p);
int         SetPTK(i2220mgmt_t *priv_p, UINT8 *macAddr, cmd_key_t *key_p);
int         SetGTK(i2220mgmt_t *priv_p, cmd_key_t *key_p);
int         ClearPTK(i2220mgmt_t *priv_p, UINT8 *macAddr, UINT8 keyId);
int         ClearGTK(i2220mgmt_t *priv_p, UINT8 keyId);
ULONG       getRandomNumber(PMP_ADAPTER priv_p);
int wlanoidSetAuthenticationMode(i2220mgmt_t *priv_p, param_authMode_t newAuthMode);

int wlanoidSetEncryptionStatus(IN i2220mgmt_t *priv_p,
                               IN param_cipherMode_t cipherSuite);
int wlanoidSetAddKey(i2220mgmt_t *priv_p, IPN_KEY_STRUC *newKey_p);
int wlanoidSetClearKey(i2220mgmt_t *priv_p, IPN_KEY_STRUC *key_p);

/*----------------------------------------------------------
*       crypt.c
*---------------------------------------------------------*/
BOOLEAN MsduEncapsulate(i2220mgmt_t *priv_p,
                sta_info_t *sta_p, Frame_t *tsdu,
                PUINT keyId_p,
                PUCHAR *mickey_p,
                PBOOLEAN tkipused_p);
UINT8 TxMsduEncrypt(IN i2220mgmt_t *priv_p,
                 IN Frame_t *pdu,
                 IN sta_info_t *sta_p,
                 OUT UINT8 *keyId_p,
                 OUT UINT8 **key_pp);

UCHAR
TxMpduEncrypt(IN i2220mgmt_t *priv_p,
                 IN hw_tfcb_t *hw_tfcb_p,
                 IN FragSdu_t *fsdu);

int RxMsduDecrypt(i2220mgmt_t *priv_p,
                IN sta_info_t *sta_p,
                IN Frame_t *pdu,
                OUT PUINT keyId_p,
                OUT PUCHAR *mickey_pp);
BOOLEAN RxMpduDecrypt(i2220mgmt_t * priv_p,
                rfb_t *rfb_p,
                UINT32 cipherSuite);

/*----------------------------------------------------------
*       fow win ccmp.c
*---------------------------------------------------------*/
UCHAR
ccmpHwMpduEncapsulate(IN PMP_ADAPTER adapter_p,
                      IN OUT PTFCB_STRUC  tfcb_p,
                      IN UCHAR keyId,
                      IN PUCHAR key_p);


#if SUPPORT_TKIP
/*----------------------------------------------------------
*       fow win tkip.c
*---------------------------------------------------------*/
void    Decide_Sa_Da(Frame_t *macHeader_p, PUCHAR *sa_p, PUCHAR *da_p);

int tkipHwGenMic(i2220mgmt_t *priv_p, FragSdu_t *fsdu, TX_QUEUE_NUM qNo, bool chk_res);

VOID tkipSwGenMic(PUINT_8 mickey_p,
                PUINT_8 data_p,
                UINT_32 dataLen,
                PUINT_8 sa_p,
                PUINT_8 da_p,
                UINT_8 priority,
                PUINT_8 mic_p);

FragSdu_t* mk_fsdu(i2220mgmt_t * priv_p,sta_info_t *sta_p, Frame_t *sdu);

UCHAR   tkipHwMpduEncapsulate(IN PMP_ADAPTER adapter_p,
                OUT PTFCB_STRUC  tfcb_p,
                UCHAR keyId,
                PUCHAR key_p);
#endif

#if SUPPORT_IPNRSN
/*----------------------------------------------------------
*       11i-rsn.c
*---------------------------------------------------------*/
BOOLEAN rsnGenWPAIE(PMP_ADAPTER adapter_p);
BOOLEAN rsnParseWPAIE(i2220mgmt_t *priv_p, sta_info_t *sta_p, eREQ_WPA_t *wpa_p);

/*----------------------------------------------------------
*       11i-rsn_sm.c
*---------------------------------------------------------*/
void    randomGK(i2220mgmt_t * priv_p);
void    InitializeWPA_PSK (i2220mgmt_t * priv_p, int ssid_id);
void    IEEE80211i_event(i2220mgmt_t * priv_p,TypMacAddr staAddr ,UINT8 event);
void    Author_sm_step(i2220mgmt_t *priv_p, struct Author_state_machine *sm);
void    ProcEapolKey(i2220mgmt_t *priv_p, EAPoL_KEY_MSG_t *eapMsg_p, struct Author_state_machine *sm);
void    Author_key_timers_tick(i2220mgmt_t *priv_p, sta_info_t *sta_p);
struct  Author_state_machine* Author_sm_alloc(i2220mgmt_t *priv_p, sta_info_t *sta_p);

/*----------------------------------------------------------
*       rc4.c
*---------------------------------------------------------*/
BOOLEAN
rc4SwGenKeySeq(IN  PUCHAR seed_p,
               IN  ULONG  seedLen,
               IN  ULONG  discardLen,
               IN  ULONG  keySeqLen,
               OUT PUCHAR keySeq_p);

/*----------------------------------------------------------
*       Sha1.c
*---------------------------------------------------------*/
VOID    prf(PUCHAR key_p, ULONG keyLen, PUCHAR prefix_p, ULONG prefixLen,
          PUCHAR data_p,ULONG dataLen,PUCHAR output_p,ULONG outputLen);
VOID    hmacSha1(PUCHAR data_p,ULONG dataLen,PUCHAR key_p,ULONG keyLen,PUCHAR digest_p);

/*----------------------------------------------------------
*       Md5.c
*---------------------------------------------------------*/
VOID    hmacMd5(PUCHAR data_p, ULONG dataLen,PUCHAR key_p, ULONG keyLen, PUCHAR digest_p);

#endif

/*----------------------------------------------------------
*       rftest.c
*---------------------------------------------------------*/
void i2220_rftest_power(i2220mgmt_t *priv_p, UINT8 power);
void i2220_rftest_burst(i2220mgmt_t *priv_p);
void i2220_rftest_mode(i2220mgmt_t *priv_p, UINT8 mode);

/*----------------------------------------------------------
*       mempool.c
*---------------------------------------------------------*/
#if WLAN_USE_MEMPOOL
int init_mgt_mem_pool(i2220mgmt_t *priv_p);
void *slab_mem_alloc(int sz);
void slab_mem_free(void *buf);
void destroy_mgt_mem_pool(i2220mgmt_t *priv_p);
#endif


/*----------------------------------------------------------
*       domain.c
*---------------------------------------------------------*/
BOOLEAN
domainCheckForSupportedDomain(IN UINT_16 countryCode,
                              OUT PDOMAIN_INFO_ENTRY *domainInfo_p);
VOID
domainInitCurrentRegDomain(IN PMP_ADAPTER adapter_p,
                           IN UINT_16 eepromDomainSetting);

BOOLEAN
domainCheckForValidChannel(IN PMP_ADAPTER adapter_p,
#if SUPPORT_802_11A
                           IN UINT_8 channelNum,
                           IN UINT_8 channelBand);
#else
                           IN UINT_8 channelNum);
#endif

/************************************************************************
*           I N L I N E   F U N C T I O N   D E F I N I T I O N S
*************************************************************************
*/

#endif
