/*
** $Id: i2220win.h 1.30 2004/10/04 17:25:23 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

#ifndef __WINDRIVER_COMPATIBLE_WRAPPER_H
#define __WINDRIVER_COMPATIBLE_WRAPPER_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/
#define DBG             0

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

//
// NDIS_STATUS values
//
#define NDIS_STATUS_SUCCESS                     ((NDIS_STATUS) 0)
#define NDIS_STATUS_PENDING                     ((NDIS_STATUS) 1)
#define NDIS_STATUS_NOT_RECOGNIZED              ((NDIS_STATUS)0x00010001L)
#define NDIS_STATUS_NOT_COPIED                  ((NDIS_STATUS)0x00010002L)
#define NDIS_STATUS_NOT_ACCEPTED                ((NDIS_STATUS)0x00010003L)
#define NDIS_STATUS_CALL_ACTIVE                 ((NDIS_STATUS)0x00010007L)

#define NDIS_STATUS_ONLINE                      ((NDIS_STATUS)0x40010003L)
#define NDIS_STATUS_RESET_START                 ((NDIS_STATUS)0x40010004L)
#define NDIS_STATUS_RESET_END                   ((NDIS_STATUS)0x40010005L)
#define NDIS_STATUS_RING_STATUS                 ((NDIS_STATUS)0x40010006L)
#define NDIS_STATUS_CLOSED                      ((NDIS_STATUS)0x40010007L)
#define NDIS_STATUS_WAN_LINE_UP                 ((NDIS_STATUS)0x40010008L)
#define NDIS_STATUS_WAN_LINE_DOWN               ((NDIS_STATUS)0x40010009L)
#define NDIS_STATUS_WAN_FRAGMENT                ((NDIS_STATUS)0x4001000AL)
#define NDIS_STATUS_MEDIA_CONNECT               ((NDIS_STATUS)0x4001000BL)
#define NDIS_STATUS_MEDIA_DISCONNECT            ((NDIS_STATUS)0x4001000CL)
#define NDIS_STATUS_HARDWARE_LINE_UP            ((NDIS_STATUS)0x4001000DL)
#define NDIS_STATUS_HARDWARE_LINE_DOWN          ((NDIS_STATUS)0x4001000EL)
#define NDIS_STATUS_INTERFACE_UP                ((NDIS_STATUS)0x4001000FL)
#define NDIS_STATUS_INTERFACE_DOWN              ((NDIS_STATUS)0x40010010L)
#define NDIS_STATUS_MEDIA_BUSY                  ((NDIS_STATUS)0x40010011L)
#define NDIS_STATUS_MEDIA_SPECIFIC_INDICATION   ((NDIS_STATUS)0x40010012L)
#define NDIS_STATUS_WW_INDICATION               NDIS_STATUS_MEDIA_SPECIFIC_INDICATION
#define NDIS_STATUS_LINK_SPEED_CHANGE           ((NDIS_STATUS)0x40010013L)
#define NDIS_STATUS_INTERFACE_DOWN              ((NDIS_STATUS)0x40010010L)
#define NDIS_STATUS_MEDIA_BUSY                  ((NDIS_STATUS)0x40010011L)
#define NDIS_STATUS_MEDIA_SPECIFIC_INDICATION   ((NDIS_STATUS)0x40010012L)
#define NDIS_STATUS_WW_INDICATION               NDIS_STATUS_MEDIA_SPECIFIC_INDICATION
#define NDIS_STATUS_LINK_SPEED_CHANGE           ((NDIS_STATUS)0x40010013L)
#define NDIS_STATUS_WAN_GET_STATS               ((NDIS_STATUS)0x40010014L)
#define NDIS_STATUS_WAN_CO_FRAGMENT             ((NDIS_STATUS)0x40010015L)
#define NDIS_STATUS_WAN_CO_LINKPARAMS           ((NDIS_STATUS)0x40010016L)

#define NDIS_STATUS_NOT_RESETTABLE              ((NDIS_STATUS)0x80010001L)
#define NDIS_STATUS_SOFT_ERRORS                 ((NDIS_STATUS)0x80010003L)
#define NDIS_STATUS_HARD_ERRORS                 ((NDIS_STATUS)0x80010004L)
#define NDIS_STATUS_BUFFER_OVERFLOW             ((NDIS_STATUS)0x80010005L)

#define NDIS_STATUS_FAILURE                     ((NDIS_STATUS)0xC0010000L)
#define NDIS_STATUS_RESOURCES                   ((NDIS_STATUS)0xC0010001L)
#define NDIS_STATUS_CLOSING                     ((NDIS_STATUS)0xC0010002L)
#define NDIS_STATUS_BAD_VERSION                 ((NDIS_STATUS)0xC0010004L)
#define NDIS_STATUS_BAD_CHARACTERISTICS         ((NDIS_STATUS)0xC0010005L)
#define NDIS_STATUS_ADAPTER_NOT_FOUND           ((NDIS_STATUS)0xC0010006L)
#define NDIS_STATUS_OPEN_FAILED                 ((NDIS_STATUS)0xC0010007L)
#define NDIS_STATUS_DEVICE_FAILED               ((NDIS_STATUS)0xC0010008L)
#define NDIS_STATUS_MULTICAST_FULL              ((NDIS_STATUS)0xC0010009L)
#define NDIS_STATUS_MULTICAST_EXISTS            ((NDIS_STATUS)0xC001000AL)
#define NDIS_STATUS_MULTICAST_NOT_FOUND         ((NDIS_STATUS)0xC001000BL)
#define NDIS_STATUS_REQUEST_ABORTED             ((NDIS_STATUS)0xC001000CL)
#define NDIS_STATUS_RESET_IN_PROGRESS           ((NDIS_STATUS)0xC001000DL)
#define NDIS_STATUS_CLOSING_INDICATING          ((NDIS_STATUS)0xC001000EL)
#define NDIS_STATUS_NOT_SUPPORTED               ((NDIS_STATUS)0xC001000EL)
#define NDIS_STATUS_INVALID_PACKET              ((NDIS_STATUS)0xC001000FL)
#define NDIS_STATUS_OPEN_LIST_FULL              ((NDIS_STATUS)0xC0010010L)
#define NDIS_STATUS_ADAPTER_NOT_READY           ((NDIS_STATUS)0xC0010011L)
#define NDIS_STATUS_ADAPTER_NOT_OPEN            ((NDIS_STATUS)0xC0010012L)
#define NDIS_STATUS_NOT_INDICATING              ((NDIS_STATUS)0xC0010013L)
#define NDIS_STATUS_INVALID_LENGTH              ((NDIS_STATUS)0xC0010014L)
#define NDIS_STATUS_INVALID_DATA                ((NDIS_STATUS)0xC0010015L)
#define NDIS_STATUS_BUFFER_TOO_SHORT            ((NDIS_STATUS)0xC0010016L)
#define NDIS_STATUS_INVALID_OID                 ((NDIS_STATUS)0xC0010017L)
#define NDIS_STATUS_ADAPTER_REMOVED             ((NDIS_STATUS)0xC0010018L)
#define NDIS_STATUS_UNSUPPORTED_MEDIA           ((NDIS_STATUS)0xC0010019L)
#define NDIS_STATUS_GROUP_ADDRESS_IN_USE        ((NDIS_STATUS)0xC001001AL)
#define NDIS_STATUS_FILE_NOT_FOUND              ((NDIS_STATUS)0xC001001BL)
#define NDIS_STATUS_ERROR_READING_FILE          ((NDIS_STATUS)0xC001001CL)
#define NDIS_STATUS_ALREADY_MAPPED              ((NDIS_STATUS)0xC001001DL)
#define NDIS_STATUS_RESOURCE_CONFLICT           ((NDIS_STATUS)0xC001001EL)
#define NDIS_STATUS_NO_CABLE                    ((NDIS_STATUS)0xC001001FL)

#define NDIS_STATUS_INVALID_SAP                 ((NDIS_STATUS)0xC0010020L)
#define NDIS_STATUS_SAP_IN_USE                  ((NDIS_STATUS)0xC0010021L)
#define NDIS_STATUS_INVALID_ADDRESS             ((NDIS_STATUS)0xC0010022L)
#define NDIS_STATUS_VC_NOT_ACTIVATED            ((NDIS_STATUS)0xC0010023L)
#define NDIS_STATUS_DEST_OUT_OF_ORDER           ((NDIS_STATUS)0xC0010024L)  // cause 27
#define NDIS_STATUS_VC_NOT_AVAILABLE            ((NDIS_STATUS)0xC0010025L)  // cause 35,45
#define NDIS_STATUS_CELLRATE_NOT_AVAILABLE      ((NDIS_STATUS)0xC0010026L)  // cause 37
#define NDIS_STATUS_INCOMPATABLE_QOS            ((NDIS_STATUS)0xC0010027L)  // cause 49
#define NDIS_STATUS_AAL_PARAMS_UNSUPPORTED      ((NDIS_STATUS)0xC0010028L)  // cause 93
#define NDIS_STATUS_NO_ROUTE_TO_DESTINATION     ((NDIS_STATUS)0xC0010029L)  // cause 3

#define NDIS_STATUS_TOKEN_RING_OPEN_ERROR       ((NDIS_STATUS)0xC0011000L)
#define NDIS_STATUS_INVALID_DEVICE_REQUEST      ((NDIS_STATUS)0xC0011001L)
#define NDIS_STATUS_NETWORK_UNREACHABLE         ((NDIS_STATUS)0xC0011002L)

#define NDIS_ERROR_CODE_NETWORK_ADDRESS		12345678

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*      W I N D O W S   D D K   C O M P A T I B L E   W R A P P E R
*************************************************************************
*/
/* type definitions for signed integers */
#define INT_8                           INT8
#define INT_16                          INT16
#define INT_32                          INT32
#define INT_64                          INT64

/* type definitions for signed integer pointers */
typedef INT_8*                          PINT_8;
typedef INT_16*                         PINT_16;
typedef INT_32*                         PINT_32;
typedef INT_64*                         PINT_64;

/* type definitions for unsigned integers */
#define UINT_8                          UINT8
#define UINT_16                         UINT16
#define UINT_32                         UINT32
#define UINT_64                         UINT64

/* type definitions for unsigned integer pointers */
typedef UINT_8*                         PUINT_8;
typedef UINT_16*                        PUINT_16;
typedef UINT_32*                        PUINT_32;
typedef UINT_64*                        PUINT_64;

#define VOID                            void

typedef BOOLEAN*                        PBOOLEAN;
typedef bool*                           PBOOL;
typedef VOID*                           PVOID;

typedef CHAR*                           PCHAR;
typedef SHORT*                          PSHORT;
typedef LONG*                           PLONG;
typedef LONGLONG*                       PLONGLONG;

typedef UCHAR*                          PUCHAR;
typedef USHORT*                         PUSHORT;
typedef ULONG*                          PULONG;
typedef ULONGLONG*                      PULONGLONG;

typedef INT*                            PINT;
typedef UINT*                           PUINT;

/* --------------------------------------------------*
 * Conversion definitions for the convenience of directly code transfer here
 * from the project of _mac_win_ -- MS Windows based device driver.
 * --------------------------------------------------*/
#define PMP_ADAPTER                     i2220mgmt_t*
#define PIPN2220_SW_RFB                 rfb_t*
#define NdisStallExecution              kal_udelay
#define mpStallExecutionMsec            kal_mdelay
#define NDIS_STATUS                     int
#define NDIS_PHYSICAL_ADDRESS           kal_dma_addr_t
#define DbgPrint                        printk
#define NdisMoveMemory			ipn_memcpy
#define NdisZeroMemory(a,s)             ipn_memset(a,0,s)
#define DbgBreakPoint()
#define IN
#define OUT
#define _INLINE_FUNC                    __KAL_INLINE__

#define DEBUGFILE(_File)
#define INITLOG(_Fmt)
#define ERRORLOG(_Fmt)
#define WARNLOG(_Fmt)
#define DBGLOG(_Module, _Level, _Fmt)
#define DBGLOG_INIT(_Fmt)
#define DBGLOG_ERR(_Fmt)
#define DBGLOG_WARN(_Fmt)
#define DBGLOG_TRACE(_Module, _Fmt)
#define DBGLOG_INFO(_Module, _Fmt)
#define DBGLOG_LOUD(_Module, _Fmt)
#define DBGLOG_MEM8(_Module, _Level, _StartAddr, _Length)
#define DBGLOG_MEM32(_Module, _Level, _StartAddr, _Length)

#define DBGPRINT(_Level, _Module, _Fmt)
#define DBGPRINT_RAW(_Level, _Module, _Fmt)

#define InitAdapterMembers(adapter_p)
#define IPN2220LogError(_Adapt, _ProcId, _ErrCode, _Spec1)

#define COPY_MAC_ADDR(dst_p, src_p) \
	NdisMoveMemory((PVOID) (dst_p), (PVOID) (src_p), 6)

/* Macros to read and write from memory-mapped registers (MCR) */
#define NIC_MCR_READ(_pAdapter, _register, _pValue) \
        *(_pValue) = kal_pci_readl((_pAdapter)->membase, _register)

#define NIC_MCR_WRITE(_pAdapter, _register, _value) \
        kal_pci_writel((UINT32)(_value), (_pAdapter)->membase , _register)

/* This macro is to resume rxQ, not used now */
#define rdmaResumeRDMA(_pAdapter)       IPN2220_RXQ_RESUME(_pAdapter)

#define NIC_NOT_ACCESSIBLE(_pAdapter)   FALSE
#define MP_TEST_FLAG(_M, _F)            FALSE

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*           I N L I N E   F U N C T I O N   D E F I N I T I O N S
*************************************************************************
*/

#endif  /* __WINDRIVER_COMPATIBLE_WRAPPER_H */

