/*
** $Id: precomp.h 1.64 2004/10/04 17:34:18 cmchang Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

#ifndef __PRECOMPILING_H
#define __PRECOMPILING_H

#include "shared/equates.h"     /* For the following compiler flags */

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

#define __STACK_FRAME_CHECK__

#if !defined(__IPC_AP_MOD__) && !defined(__IPC_STA_MOD__)
    #error "Hey, either __IPC_AP_MOD__ or __IPC_STA_MOD__ should be defined"
#endif

/* Define CPU endian */
#define __LITTLE_ENDIAN__       0
#define __BIG_ENDIAN__          1

#ifndef __CPU_ENDIAN__
#define __CPU_ENDIAN__          __LITTLE_ENDIAN__
#endif

/* Define if debug is enabled */
#ifndef WLAN_INCLUDE_DEBUG
#define WLAN_INCLUDE_DEBUG      0
#endif

/* Define if proc file system is supported */
#ifndef WLAN_INCLUDE_PROC
#define WLAN_INCLUDE_PROC       0
#endif

/* Define if WDS is supported */
#ifndef WLAN_INCLUDE_WDS
#define WLAN_INCLUDE_WDS        0
#endif

/* Define if WDSFULL is supported */
#ifndef WLAN_INCLUDE_WDSFULL
#define WLAN_INCLUDE_WDSFULL    0
#endif

/* Define if RF testing is supported */
#ifndef WLAN_SUPPORT_RFTEST
#define WLAN_SUPPORT_RFTEST     0
#endif

/* Define do we want to use kdbg inline or null to define kdbg debug macro */
#ifndef KDBG_INLINE
#define KDBG_INLINE             0
#endif

/* Using Mempool or System Malloc */
#ifndef WLAN_USE_MEMPOOL
#define WLAN_USE_MEMPOOL        0
#endif

/* Include WPA code */
#ifndef SUPPORT_IPNRSN
#define SUPPORT_IPNRSN          0
#define SUPPORT_WPA             0
#endif
#ifndef SUPPORT_WPA2
#define SUPPORT_WPA             0
#define SUPPORT_WPA2            0
#endif

/* Define if TKIP security mode */
#ifndef SUPPORT_TKIP
#define SUPPORT_TKIP            0
#endif

/* Define if shorter packet is decrypted by software */
#ifndef SUPPORT_SW_TKIP_MIC
#define SUPPORT_SW_TKIP_MIC     0
#endif

/* The WavePlus WP3210 for ecos workaround define */
#ifdef __ARCH_WAVEPLUS_WP3210__
#define WP_3210_WORKAROUND      1
#else
#define WP_3210_WORKAROUND      0
#endif

/*
** If you want to verify DMA operation, open this.
*/
#define SUPPORT_LOOPBACK        0
#define LOOP_PRINT              printk

/* Define support chip ID, IPN5320 is the default chip2host_16
 * Note: IPN5320 code also supports IPN2220, but code size is larger.
 */
#ifndef IPN5320
#define IPN2220                 1
#endif

/* --------------------------------------------------------------- */
/* Additional macro definitions for compiler directives. */

/*-------------------------------------------------------*/
/*   H/W or platform dependent settings                  */
/*-------------------------------------------------------*/
/* The definition of driver supported platform */
/* We need to set this definiton for all proper HW setting. */
/* Note: If you use socket test board, remember set registry
         MisSet as 0x01 */
#ifdef IPN2220
#define DRV_PLATFORM                            VENUS_G_CHIP_A0
//#define DRV_PLATFORM                            VENUS_G_FPGA_A0
#endif

#ifdef IPN5320
#define DRV_PLATFORM                            VENUS_AG_CHIP_A0
//#define DRV_PLATFORM                            VENUS_AG_FPGA_A0
#endif

/* Define chip ID and version in the CHIP MCR_PCICR */
#if (DRV_PLATFORM & VENUS_PHY_MODE_MASK) == VENUS_PHY_11G
#if (DRV_PLATFORM & VENUS_VERSION_MASK) == VENUS_VERSION_A0
#define IPN_CHIP_ID_REV                         IPN2220_A0
#endif
#elif (DRV_PLATFORM & VENUS_PHY_MODE_MASK) == VENUS_PHY_11AG
#if (DRV_PLATFORM & VENUS_VERSION_MASK) == VENUS_VERSION_A0
#define IPN_CHIP_ID_REV                         IPN5320_A0
#endif
#endif


/* Define supported BB version */
#if (DRV_PLATFORM & VENUS_HW_MODE_MASK) == VENUS_HW_FPGA
#define BB_FPGA_VERSION_TABLE                   1
#else
#define BB_FPGA_VERSION_TABLE                   0
#endif

/* BCI work around compiler flag */
#if (DRV_PLATFORM & VENUS_VERSION_MASK) == VENUS_VERSION_A0
#define BCI_WORKAROUND                          1
/* Workaround for stop TX queue (stop rx first) */
#define WORKAROUND_STOP_TX_BUG760               1
/* Workaround for stop status between PAU and Arbiter */
#define WORKAROUND_TX_STOP_STATUS               1
/* Workaround for stop SEC Q */
#define WORKAROUND_STOP_SEC_ARBITER_STATUS      1
/* Workaround for CLK20M gating */
#define WORKAROUND_CLK20M_GATING_BUG790         1
/* Workaround for TX 80M CLK Always ON */
#define WORKAROUND_TXDAC_POWER_CONSUMPTION      1
#endif

/* work around for RFMD rf chip for frequency un-locking */
#define WORKAROUND_RFMD_UNLOCK                  0

/* Define MAC only mode in FPGA emu */
#if (DRV_PLATFORM & VENUS_HW_MODE_MASK) == VENUS_HW_FPGA
#define MAC_ONLY_MODE                           1
/* Define the Maxim RF PAEN Polarity for Mini-PCI and Card-Bus
   For Socket Test Borad, used registry misSetting to change the polarity
*/
#define MAXIM_PAEN_ACTIVE_HIGH                  0

#else
#define MAC_ONLY_MODE                           0
/* Define the Maxim RF PAEN Polarity for Mini-PCI and Card-Bus
   For Socket Test Borad, used registry misSetting to change the polarity
*/
#define MAXIM_PAEN_ACTIVE_HIGH                  1

#endif

/* HW Radio Button */
#define SUPPORT_RADIO_BUTTON                    0

/* Fix ED adjustment for interference */
// Sam mark it 05122005 for Inprocomm suggestion  #define SUPPORT_ED_ADJUST                       1
#define SUPPORT_ED_ADJUST                       0 
#define SUPPORT_ED_FORCETO_FLOAT                1

/* This mechanism limit the operation of Fix/Float ED adjustment
	according to current rssi.
*/
#define SUPPORT_ED_ADJUST_BOUND_BY_RSSI         0

/* This mechanism makes a fast jump of ED
	according to current rssi.
*/
#define SUPPORT_ED_ADJUST_FAST_FIND             0

/* Float ED is split to multiple level of margins */
#define SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE 1

/* The macro is defined to support dynamic threshold between fixed and floating
   mechanisms. */
#define SUPPORT_DYNAMIC_THRESHOLD_FOR_ED        0

/* The marco is definedd to support automatic level control*/
#define SUPPORT_ALC                             0



/*-------------------------------------------------------*/
/*   Driver supported features                           */
/*-------------------------------------------------------*/
/* The macro is defined to support IEEE 802.11g. */
#if (DRV_PLATFORM & VENUS_PHY_11G)
#define SUPPORT_802_11G                         1
#else
#define SUPPORT_802_11G                         0
#endif

/* The macro is defined to support IEEE 802.11a. */
#if (DRV_PLATFORM & VENUS_PHY_11A)
#define SUPPORT_802_11A                         1
#else
#define SUPPORT_802_11A                         0
#endif

/* The macro is defined to support IEEE 802.11h. */
#if (DRV_PLATFORM & VENUS_PHY_11A)
#define SUPPORT_802_11H                         0
#else
#define SUPPORT_802_11H                         0
#endif

/* The macro is defined to support IEEE 802.11d. */
#define SUPPORT_802_11D                         0

/* The macro is defined to support IEEE 802.11e. */
#define SUPPORT_802_11E                         0

/* The macro is defined to support Wireless Multimedia Enhancements (WME). */
#define SUPPORT_WME                             0


/* --------------------------------------------------------------- */
#define SINGLE_SEC_QUEUE        0
#define SUPPORT_PERF_MEASURE    0
#define SUPPORT_HOSTAPD_ACL     1 /* SUPPORT the ACL check in hostapd */
#define RX_MIC_PARTIAL_CHECK    0 /* Define if only check partial rx TKIP MIC */
#define SUPPORT_MSSID           0 //jj change to 0 /* Include multiple ssid function */

/* --------------------------------------------------------------- */
/* Bug 711 when header size of rx packet is not 4-multiple */
#define RX_HEAD_SIZE_WORKAROUND                 1


/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/*================================================================*/
/* System Includes */
#include "wlan_kal.h"

/*================================================================*/
#include "basic.h"
#include <linux/config.h>
#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/ip.h>
#include <linux/udp.h>
#include <linux/icmp.h>
#include <linux/list.h>
//#include "mgmt_list.h"
#include "mgmt_timer.h"
#include "generaldef.h"
#include "ap_dbg.h"
#include "i2220win.h"

#include "shared/i2220reg.h"
#include "shared/eeprom.h"
#include "shared/wlandef.h"
#include "shared/nic.h"

#include "domain.h"
#include "80211mib.h"
#include "wlanmac.h"
#include "sdl_macsorts.h"

#if WLAN_INCLUDE_WDS
#include "wds.h"
#endif
#if SUPPORT_IPNRSN
#include "rsn_auth/11i-rsn.h"
#include "rsn_auth/aes.h"
#endif
#include "wlanbox.h"

#include "i2220hw.h"
#include "i2220mgmt.h"

#include "shared/sharedpr.h"
#include "shared/inlinef.h"

#include "wlan_lib.h"
#include "wep_func.h"

#include "ap_proto.h"

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*           I N L I N E   F U N C T I O N   D E F I N I T I O N S
*************************************************************************
*/

#endif  /* __PRECOMPILING_H */

