/*
** $Id: mempool.h 1.12 2004/08/23 18:44:41 whsu Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Inprocomm, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with Inprocomm, Inc.
******************************************************************************/

#ifndef _MEMPOOL_H
#define _MEMPOOL_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
typedef enum {
        LEN_BLOCK_S,
        LEN_BLOCK_M,
        LEN_BLOCK_L,
        TOTAL_MEM_TYPE
} mgt_mem_type_t;

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

typedef struct ipn_slab_item_s {
        struct ipn_slab_item_s  *next;
        int                     sz_index;    /* It's a index */
        UINT8                   data[1];     /* Header size = 8 bytes */
} ipn_slab_item_t;

typedef struct ipn_slab_anchor_s {
        int                     block_sz;    /* Slab size */
        int                     num_block;   /* Desired block number */
        ipn_slab_item_t         *next;       /* Address of head slab */
        void                    *virt_addr;  /* Record virtual of slab */

        /* For debugging use */
        int                     alloc_count;
        int                     max_alloc;
} ipn_slab_anchor_t;

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/
#if SUPPORT_IPNRSN | SUPPORT_WPA2
/* TFCB + PS-Bcast + PS-STA */
#define NUM_BLOCK_S(maxAid)     (120 + 30 + 4*(maxAid))
#define NUM_BLOCK_M(maxAid)     (120 + 30 + 3*(maxAid))
#define NUM_BLOCK_L(maxAid)     ((maxAid)+3+10) /* STA, WPA and b-BSS Records */
                                                  /* 10 reserved for frag */
#else
/* TFCB + PS-Bcast + PS-STA */
#define NUM_BLOCK_S(maxAid)     (120 + 30 + 3*(maxAid))
#define NUM_BLOCK_M(maxAid)     (120 + 30 + 3*(maxAid))
#define NUM_BLOCK_L(maxAid)     ((maxAid)+3+10) /* STA and b-BSS Records */
                                                /* 10 reserved for frag */
#endif

/* Overhead size of each memory slab */
#define SLAB_HEAD_SZ            offsetof(ipn_slab_item_t, data[0])

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

#endif /* end of _MEMPOOL_H */

