/*
** $Id: ap_wext.c,v 1.1.1.1 2005/09/15 13:37:48 root Exp $
*/

/******************************************************************************
Copyright (c) 2002-2003 Inprocomm, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with Inprocomm, Inc.
******************************************************************************/

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
/*================================================================*/
/* System Includes */
#include "wlan_os.h"
#include "wlan_kal.h"
#include "wlan_lib.h"
#include "ap_wext.h"

extern int param_set_passphrase(void*dev, unsigned char *data);
extern int param_set_loopBack(void * dev, unsigned int enable);
extern int linux_add_wdslink(void *main_dev, unsigned char *remote_addr);
extern int linux_del_wdslink(void *main_dev, unsigned char *remote_addr);
#if SUPPORT_IPNRSN
extern int linux_set_ssid(void *dev, param_ssid_t *data);
extern int linux_set_m_ssid(void *dev, param_ssid_t *data);
extern int linux_set_m_enable(void *dev, int enable);
extern int linux_set_auth_mode(void* dev, param_authMode_t newAuthMode);
extern int linux_set_cipher_mode(void *dev, param_cipherMode_t data);
extern int linux_set_passphrase(void *dev, unsigned char *data);
extern int linux_set_GKRekeyTimer(struct net_device *dev, int data);
#endif
#if SUPPORT_IPNRSN | SUPPORT_WPA2
extern int  param_set_1xport(void *dev, unsigned char* staAddr, int port_enable);
extern void param_set_1x_key(void *dev, unsigned char* staAddr , int res,
                        unsigned char *RadiusKey, unsigned char len);
extern void linux_set_11i_mode(void *dev, unsigned int data);
#endif

// Sam add for wlan mac filter
#include "asm/tc3162/tc3162_ipnwlan_ioc.h"
#define WLAN_MAC_FILTER	1
macfilter_tbl_t macfilter_tbl;
// end Sam add
// KenWang added 2005/06/24: factoryreset pid
int fac_pid;

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
enum {  /* subcmd used range = 0~34, 41~42, 50, 91~97, 99 */
        PARAM_MLMERestart=0,
        PARAM_StaList=1, /* MUST NOT CHANGE! */
        PARAM_StaNum=2,
        PARAM_KillMacAddr=3,

        PARAM_BeaconPeriod=4,
        PARAM_DTIMPeriod=5,
        PARAM_BroadcastSSID=6,
        PARAM_CTSProtect=7,
        PARAM_PreambleMode=8,
        PARAM_BurstMode=9,

        PARAM_RateMode=10,
        PARAM_BasicRateSet=11,

        PARAM_AuthMode=12,
        PARAM_Cipher=13,
        PARAM_MCipher=14,
        PARAM_WEPDefaultKeyID=15,
        PARAM_WEPKeyID=16,
        PARAM_WEPKeyValue=17,
        PARAM_PassPhrase=18,
        PARAM_GKRekeyPeriod=19,
        PARAM_hwmicthreshold=20,

        PARAM_CurrentChan=21,
        PARAM_NoStation=22,
        PARAM_Domain=23,
        PARAM_Country=24,        
        PARAM_NoAirRelay=25,
        PARAM_RxAntenna=26,

        PARAM_RfBand=28,
        PARAM_iwchan=29,        /* SIOCSIWFREQ  SIOCGIWFREQ  */
        PARAM_iwessid=30,       /* SIOCSIWESSID SIOCGIWESSID */
        PARAM_iwnick=31,        /* SIOCSIWNICKN SIOCGIWNICKN */
        PARAM_iwrate=32,        /* SIOCSIWRATE  SIOCGIWRATE  */
        PARAM_iwrts=33,         /* SIOCSIWRTS   SIOCGIWRTS   */
        PARAM_iwfrag=34,        /* SIOCSIWFRAG  SIOCGIWFRAG  */

        PARAM_RftestMode=41,
        PARAM_RftestPower=42,
        PARAM_loopback=43,
        PARAM_APStatistics= 50,/* MUST NOT CHANGE! Because iwsta.c needs this*/
#if WLAN_MAC_FILTER // Sam add for wlan mac filter
	PARAM_APSetMacfilter = 51,
	PARAM_FacPid = 52, // KenWang added 2005/06/24: to set factoryreset pid from ioctl
#endif
        PARAM_ssidid=70,
        PARAM_setmssid=71,
        PARAM_setvlanid=72,
        PARAM_setvlanenable = 73,
        PARAM_setssidenable = 74,
        PARAM_wdsAddMacAddr=91,
        PARAM_wdsDelMacAddr=92,
        PARAM_wdsRmtStatus=93,
        PARAM_wdsCipher=94,
        PARAM_wdsKeyValue=95,
        PARAM_wdsRemoteAPProtol=96,
        PARAM_wdsTxFailureTimes=97,
        PARAM_wdsDisableLimit=98
};

static const struct iw_priv_args i2220_iwpriv[] = {

        /*=====================Int===========================================*/
        /* --- sub-ioctls handlers --- */
        {IOCTL_SET_INT, IW_PRIV_TYPE_INT | IW_PRIV_SIZE_FIXED | 1, 0, ""},
        {IOCTL_GET_INT, 0, IW_PRIV_TYPE_INT | IW_PRIV_SIZE_FIXED | 1, ""},
        /* --- sub-ioctls definitions --- */

        /*---------------------Set-------------------------------------------*/

        {PARAM_BeaconPeriod,    IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "beaconperiod"},
        {PARAM_DTIMPeriod,      IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "dtimperiod"},
        {PARAM_BroadcastSSID,   IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "broadcastssid"},
        {PARAM_CTSProtect,      IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "ctsprotect"},
        {PARAM_PreambleMode,    IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "preamble"},
        {PARAM_BurstMode,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "burstmode"},
        {PARAM_RateMode,        IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "ratemode"},
        {PARAM_BasicRateSet,    IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "basicrateset"},
#if !SUPPORT_WPA2
        {PARAM_AuthMode,        IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "authmode"},
        {PARAM_Cipher,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "cipher"},
#endif

#if SUPPORT_TKIP & SUPPORT_SW_TKIP_MIC
        {PARAM_hwmicthreshold,  IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "hwmicthreshold"},
#endif
#if !SUPPORT_WPA2
        {PARAM_WEPKeyID,        IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "wepkeyid"},
        {PARAM_WEPDefaultKeyID, IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "defwepkeyid"},
#endif
        {PARAM_RfBand,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "rfband"},
        {PARAM_iwchan,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "channel"},
        {PARAM_iwrate,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "datarate"},
        {PARAM_iwrts,           IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "rts"},
        {PARAM_iwfrag,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "frag"},
        {PARAM_Domain,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "domain"},
        {PARAM_NoAirRelay,      IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "norelay"},
        {PARAM_RxAntenna,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "antenna"},
        {PARAM_RftestMode,      IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "rftest_mode"},
        {PARAM_RftestPower,     IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "rftest_power"},
#if !SUPPORT_WPA2
        {PARAM_ssidid,          IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "ssidid"},
        {PARAM_setvlanid,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "vlanid"},
        {PARAM_setvlanenable,   IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "vlanenable"},
        {PARAM_setssidenable,   IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "ssidenable"},
#endif
        {PARAM_NoStation,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "nostation"},
        {PARAM_loopback,        IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "loopback"},
#if SUPPORT_IPNRSN
        {PARAM_GKRekeyPeriod,   IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "gkrekeyperiod"},
#endif
#if WLAN_INCLUDE_WDS
        {PARAM_wdsCipher,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "wdscipher"},
        {PARAM_wdsRemoteAPProtol,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "wdsapprotocol"},
        {PARAM_wdsTxFailureTimes,       IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "wdstxfailtimes"},
        {PARAM_wdsDisableLimit,         IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "wdsdisablelimit"},
#endif
        /*---------------------Get-------------------------------------------*/
        {PARAM_CurrentChan,     0, IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, "g_currentchan"},
        /*=====================Key===========================================*/
        /* --- raw access to sub-ioctls --- */
        /* --- sub-ioctls handlers --- */
        {IOCTL_SET_KEY, IW_PRIV_TYPE_CHAR | 32, 0, ""},
        {IOCTL_GET_KEY, 0, IW_PRIV_TYPE_CHAR | IW_PRIV_SIZE_FIXED | 32, ""},
        /* --- sub-ioctls definitions --- */

        /*---------------------Set-------------------------------------------*/
#if !SUPPORT_WPA2
        {PARAM_WEPKeyValue,     IW_PRIV_TYPE_CHAR|32,0, "wepkey"},
#endif
#if WLAN_INCLUDE_WDS
        {PARAM_wdsKeyValue,     IW_PRIV_TYPE_CHAR|32,0, "wdskey"},
#endif
        /*---------------------Get-------------------------------------------*/

        /*=====================String========================================*/
        /* --- sub-ioctls handlers --- */
        {IOCTL_SET_STR, IW_PRIV_TYPE_CHAR | 128, 0, ""},
        {IOCTL_GET_STR, 0, IW_PRIV_TYPE_CHAR | 128, ""},
        /* --- sub-ioctls definitions --- */

        /*---------------------Set-------------------------------------------*/
#if !SUPPORT_WPA2
        {PARAM_iwessid,         IW_PRIV_TYPE_CHAR|128, 0, "essid"},
        {PARAM_setmssid,        IW_PRIV_TYPE_CHAR|128, 0, "setmssid"},
#endif
#if SUPPORT_IPNRSN
        {PARAM_PassPhrase,      IW_PRIV_TYPE_CHAR|128, 0, "passphrase"},
#endif /* SUPPORT_RSN */
#if WLAN_INCLUDE_WDS
        {PARAM_wdsAddMacAddr,   IW_PRIV_TYPE_CHAR|128, 0, "wdsaddmac"},
        {PARAM_wdsDelMacAddr,   IW_PRIV_TYPE_CHAR|128, 0, "wdsdelmac"},
#endif /* WLAN_INCLUDE_WDS */
        {PARAM_KillMacAddr,     IW_PRIV_TYPE_CHAR|128, 0, "killmac"},
        {PARAM_Country,         IW_PRIV_TYPE_CHAR|128, 0, "country"},
        /*---------------------Get-------------------------------------------*/
        /*=====================Structure=====================================*/
        /* --- sub-ioctls handlers --- */
        {IOCTL_SET_STRUCT, 1, 0, ""},
        {IOCTL_GET_STRUCT, 0, 1, ""},
        /* --- sub-ioctls definitions --- */
        /*---------------------Set-------------------------------------------*/
#if 1 // Sam add wlan mac filter
	{PARAM_APSetMacfilter, 1, 0, ""},
	// KenWang added 2005/06/24: set factoryreset pid
	{PARAM_FacPid, IW_PRIV_TYPE_INT|IW_PRIV_SIZE_FIXED|1, 0, "facpid"},
#endif
        /*---------------------Get-------------------------------------------*/
        {PARAM_StaList,         0, 1, ""},
        {PARAM_StaList,         0, 1, ""}
};

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/

/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/
#define WLAN_HOSTAPD_MAX_BUF_SIZE 1024
/* Maximum length for algorithm names (-1 for nul termination) used in ioctl()
 */
#define HOSTAP_CRYPT_ALG_NAME_LEN 16

struct wlan_hostapd_param {
        u32 cmd;
        u8 sta_addr[ETH_ALEN];
        u8 ssid;
        union {
                struct {
                        u16 aid;
                        u16 capability;
                        u8 tx_supp_rates;
                } add_sta;
                struct {
                        u32 inactive_sec;
                        u32 txexc;
                } get_info_sta;
                struct {
                        u8 alg[HOSTAP_CRYPT_ALG_NAME_LEN];
                        u32 flags;
                        u32 err;
                        u8 idx;
                        u8 seq[8]; /* sequence counter (set: RX, get: TX) */
                        u16 key_len;
                        u8 key[0];
                } crypt;
                struct {
                        u32 flags_and;
                        u32 flags_or;
                } set_flags_sta;
                struct {
                        u16 rid;
                        u16 len;
                        u8 data[0];
                } rid;
                struct {
                        u8 len;
                        u8 data[0];
                } generic_elem;
                struct {
                        u8 ssid_len;
                        u8 ssid[32];
                        u8 ssid_id;
                        u8 enable;
                        int vlanid;
                } ssid_req;
        } u;
};

/* WLAN_IOCTL_HOSTAPD ioctl() cmd: */
enum {
        WLAN_HOSTAPD_FLUSH = 1,
        WLAN_HOSTAPD_ADD_STA = 2,
        WLAN_HOSTAPD_REMOVE_STA = 3,
        WLAN_HOSTAPD_GET_INFO_STA = 4,
        WLAN_SET_ENCRYPTION = 6,
        WLAN_GET_ENCRYPTION = 7,
        WLAN_HOSTAPD_SET_FLAGS_STA = 8,
        WLAN_HOSTAPD_SET_GENERIC_ELEMENT = 12,
        WLAN_HOSTAPD_SET_SSID = 15,
};



/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/
/*
**   Convert string mac address into numeric format. Output must hold 6 byte array.
**   str must be 11:22:33:44:55:AA or 11-22-33-44-55-bb
**   RST: 0: Success 1: Fail
*/
int macaddr2array(unsigned char* output, char* str){
        int len = 17;
        int j = 0;

        memset(output, 0 ,ETH_ALEN);
        len = strlen(str);
        if(len != 17)
                return 1;

        for(j=0; j<len; j+=3){
                if((str[j] <= 'f') && (str[j] >= 'a')){
                        output[j/3]=(str[j]-'a'+10)*16;
                }
                else if((str[j] <= 'F') && (str[j] >= 'A')){
                        output[j/3]=(str[j]-'A'+10)*16;
                }
                else if((str[j] <= '9') && (str[j] >= '0')){
                        output[j/3]=(str[j]-'0')*16;
                }
                else{
                        return 1;
                        }

                if((str[j+1] <= 'f') && ((str[j+1]) >= 'a'))
                        output[j/3]+=(str[j+1]-'a'+10);
                else if((str[j+1] <= 'F') && ((str[j+1]) >= 'A'))
                        output[j/3]+=(str[j+1]-'A'+10);
                else if((str[j+1] <= '9') && ((str[j+1]) >= '0'))
                        output[(j/3)]+=(str[j+1]-'0');
                else{
                        return 1;
                }

                if((str[j+2] != ':') && (str[j+2] != '-') && (str[j+2] != '\0')){
                        return 1;
                }
        }
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  priv_p    card private information
* \param  iwr       pointer to iwreq structure
* \param  param     private sub-command
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EINVAL  if a value is out of range
*               EOPNOTSUPP  if un-supported sub-command is entered
*/
/*----------------------------------------------------------------*/
static int ioctl_priv_set_int(struct net_device *dev, struct iwreq *iwr, int param)
{
        int     value = *(&(iwr->u.mode) + 1);

        switch (param) {
        case PARAM_BeaconPeriod:
                return param_set_bcnPeriod(dev, value);
        case PARAM_DTIMPeriod:
                return param_set_dtimPeriod(dev, value);
        case PARAM_BroadcastSSID:
                return param_set_bcastSSID(dev, value);
        case PARAM_CTSProtect:
                return param_set_ctsProtect(dev, value);
        case PARAM_PreambleMode:
                return param_set_preambleMode(dev, value);
        case PARAM_BurstMode:
                return param_set_burstMode(dev, value);
        case PARAM_RateMode:
                return param_set_rateMode(dev, value);
        case PARAM_BasicRateSet:
                return param_set_basicRateSet(dev, value);
#if SUPPORT_SW_TKIP_MIC
        case PARAM_hwmicthreshold:
                return param_set_hwMICthreshold(dev, value);
#endif
#if !SUPPORT_WPA2
        case PARAM_AuthMode:
                /* For revsion reason (v1.35) */
                if (value == 1) {
                        value = (int)AuthMode_OPEN_1X;
                }
                else if (value == 2) {
                        value = (int)AuthMode_SHARED;
                }
                else if (value == 3) {
                        value = (int)AuthMode_SWITCH;
                }

                #if SUPPORT_IPNRSN
                        return linux_set_auth_mode(dev, (param_authMode_t)value);
                #else
                        return param_set_authmode(dev, (param_authMode_t)value);
                #endif
        case PARAM_Cipher:
                #if SUPPORT_IPNRSN
                        return linux_set_cipher_mode(dev, (param_cipherMode_t)value);
                #else
                        return param_set_cipherMode(dev, (param_cipherMode_t)value);
                #endif
#endif
        case PARAM_NoStation:
                return param_set_noStation(dev, value);

#if SUPPORT_IPNRSN
        case PARAM_GKRekeyPeriod:
                return linux_set_GKRekeyTimer(dev, value);
#endif

#if WLAN_INCLUDE_WDS
        case PARAM_wdsCipher:
                return param_set_wds_cipherMode(dev, (param_cipherMode_t)value);
        case PARAM_wdsRemoteAPProtol:
                return param_set_wds_rateMode(dev, value);
        case PARAM_wdsTxFailureTimes:
                return param_set_wds_tx_failure_limit(dev, value);
        case PARAM_wdsDisableLimit:
                return param_set_wds_disable_limit(dev, value);
#endif /* WLAN_INCLUDE_WDS */
#if !SUPPORT_WPA2
        case PARAM_WEPKeyID:
                return param_set_wepKeyId(dev, value);
        case PARAM_WEPDefaultKeyID:
                return param_set_wepDefaultKeyId(dev, value);
#endif
        case PARAM_RfBand:
                return param_set_setRFBand(dev, value);
        case PARAM_iwchan:
                return param_set_setChannel(dev, value);
        case PARAM_iwrate:
                return param_set_dataRate(dev, value);
        case PARAM_iwrts:
                return param_set_rts(dev, value);
        case PARAM_iwfrag:
                return param_set_frag(dev, value);
        case PARAM_Domain:
                return param_set_regDomain(dev, value);
        case PARAM_NoAirRelay:
                return param_set_noRelay(dev, value);
        case PARAM_RxAntenna:
                return param_set_rxAntenna(dev, value);
        case PARAM_RftestMode:
                return param_set_rftestMode(dev, value);
        case PARAM_RftestPower:
                return param_set_rftestPower(dev, value);
        case PARAM_loopback:
                return param_set_loopBack(dev, value);
#if !SUPPORT_WPA2
        case PARAM_ssidid:
                return param_set_ssid_id(dev, value);
        case PARAM_setvlanid:
                return param_set_m_vlanid(dev, value);
        case PARAM_setvlanenable:
                return param_set_m_vlantag_enable(dev, value);
        case PARAM_setssidenable:
                #if SUPPORT_IPNRSN
                        return linux_set_m_enable(dev, value);
                #else
                        return param_set_m_enable(dev, value);
                #endif
#endif
	/* KenWang added 2005/06/24 -- begin -- */			
#if WLAN_MAC_FILTER
	case PARAM_FacPid:
		printk("value: %d\n", value);
		fac_pid = value;
		return 0;
#endif
	/* KenWang added 2005/06/24 -- end -- */			
        default:
               return -EOPNOTSUPP;
        } /* end of switch */

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  priv_p    card private information
* \param  iwr       pointer to iwreq structure
* \param  param     private sub-command
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EOPNOTSUPP  if un-supported sub-command is entered
* \return  param    the requested value
*/
/*----------------------------------------------------------------*/
static int ioctl_priv_get_int(struct net_device *dev, struct iwreq *iwr, int *param)
{
        switch (*param) {
        case PARAM_CurrentChan:
                param_get_curChannel(dev, param);
                break;
        default:
                return -EOPNOTSUPP;
        }
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  priv_p    card private information
* \param  iwr       pointer to iwreq structure
* \param  param     private sub-command
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EFAULT  if something goes wrong with copy_from_user
*               EOPNOTSUPP  if un-supported sub-command is entered
*/
/*----------------------------------------------------------------*/
static int ioctl_priv_set_addr(struct net_device *dev, struct iwreq *iwr, int param)
{
        unsigned char   buf[PARAM_MAC_ADDR_LEN*3];
        unsigned char   mac_buf[PARAM_MAC_ADDR_LEN];

        if (!iwr->u.data.pointer)
                return -EFAULT;

        if (copy_from_user(buf, iwr->u.data.pointer, iwr->u.data.length > sizeof(buf)?sizeof(buf):iwr->u.data.length))
                return -EFAULT;

        if(macaddr2array(mac_buf,buf))
                return -EOPNOTSUPP;

        switch (param) {
        case PARAM_KillMacAddr:
                return param_set_killmac(dev, mac_buf);

#if WLAN_INCLUDE_WDS
        case PARAM_wdsAddMacAddr:
                return linux_add_wdslink(dev,mac_buf);
        case PARAM_wdsDelMacAddr:
                return linux_del_wdslink(dev,mac_buf);
#endif /* WLAN_INCLUDE_WDS */

        default:
                return -EOPNOTSUPP;
        } /* end of switch */

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  priv_p    card private information
* \param  iwr       pointer to iwreq structure
* \param  param     private sub-command
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EFAULT  if something goes wrong with copy_from_user or null pointer
*               EOPNOTSUPP  if un-supported sub-command is entered
*/
/*----------------------------------------------------------------*/
static int ioctl_priv_set_string(struct net_device *dev, struct iwreq *iwr, int param)
{
        param_req_t     buf;

        if (!iwr->u.data.pointer)
                return -EFAULT;

        if (copy_from_user(&buf, iwr->u.data.pointer, sizeof(param_req_t)))
                return -EFAULT;

        switch (param) {
                case PARAM_wdsAddMacAddr:
                case PARAM_wdsDelMacAddr:
                case PARAM_KillMacAddr:
                        return ioctl_priv_set_addr(dev,iwr,param);

            #if !SUPPORT_WPA2
                case PARAM_iwessid:
                        buf.ssid.len = strlen(buf.ssid.ssid);
                #if SUPPORT_IPNRSN
                        return linux_set_ssid(dev, (param_ssid_t*)&buf);
                #else
                        return param_set_ssid(dev, (param_ssid_t*)&buf);
                #endif
                case PARAM_setmssid:
                        buf.ssid.len = strlen(buf.ssid.ssid);
                #if SUPPORT_IPNRSN
                        return linux_set_m_ssid(dev, (param_ssid_t*)&buf);
                #else
                        return param_set_m_ssid(dev, (param_ssid_t*)&buf);
                #endif
            #endif
        #if SUPPORT_IPNRSN
                case PARAM_PassPhrase:
                        return linux_set_passphrase(dev, (unsigned char *)&buf);
        #endif
                case PARAM_Country:
                        return param_set_country(dev, (char*)&buf);
                default:
                        return -EOPNOTSUPP;
        }

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  priv_p    card private information
* \param  iwr       pointer to iwreq structure
* \param  param     private sub-command
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EFAULT  if something goes wrong with copy_from_user or null pointer
*               EINVAL  if a value is out of range
*               EOPNOTSUPP  if un-supported sub-command is entered
*/
/*----------------------------------------------------------------*/
static int ioctl_priv_set_key(struct net_device *dev, struct iwreq *iwr, int param)
{
        param_cipher_key_t      wep_key;
        unsigned char           buf[2*sizeof(wep_key.key) + 1];
        int                     i, j;

        if (!iwr->u.data.pointer)
                return -EFAULT;
        if (copy_from_user(buf, iwr->u.data.pointer, 33))
                return -EFAULT;

        /* Now only WEP is needed to set manually */
        wep_key.len = strlen(buf) / 2;
        if (wep_key.len != 5 && wep_key.len != 13 && wep_key.len != 16)
                return -EINVAL;

        for (i = 0; i < wep_key.len; i++) {
                for (j = 0; j < 2; j++) {
                        if (buf[2*i+j] >= '0' && buf[2*i+j] <= '9')
                                buf[2*i+j] = buf[2*i+j] - '0';
                        else if (buf[2*i+j] >= 'a' && buf[2*i+j] <= 'f')
                                buf[2*i+j] = buf[2*i+j] - 'a' + 10;
                        else if (buf[2*i+j] >= 'A' && buf[2*i+j] <= 'F')
                                buf[2*i+j] = buf[2*i+j] - 'A' + 10;
                        else return -EINVAL;
                }
                wep_key.key[i] = buf[2*i] * 16 + buf[2*i+1];
        }

        switch (param) {
#if !SUPPORT_WPA2
        case PARAM_WEPKeyValue:
                return param_set_wepKey(dev, (param_cipher_key_t*)&wep_key);
#endif
#if WLAN_INCLUDE_WDS
        case PARAM_wdsKeyValue:
                return param_set_wds_cipherKey(dev, (param_cipher_key_t*)&wep_key);
#endif /* WLAN_INCLUDE_WDS */

        default:
                return -EOPNOTSUPP;
        }
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  private ioctl() routines for AP driver. compact with iwpriv
*
* \param  dev
* \param  iwr       pointer to iwreq structure
*
* \return  zero on success, a negative errno on failure.  Possible values:
*               EFAULT  if something goes wrong with copy_from_user or null pointer
*               EINVAL  if a value is out of range
*               EOPNOTSUPP  if un-supported sub-command is entered
* \return
*/
/*----------------------------------------------------------------*/
int ioctl_priv_get_struct(struct net_device *dev, struct iwreq* iwr, unsigned short param)
{
        int ret=0;
        int     num_elem = 0;
        struct iw_point *p = (struct iw_point *) &iwr->u.data;
        sta_status_t* tmp;
        struct net_stat tmp_stat;

        switch (param) {
                case PARAM_StaList:
                        if((p->length) < sizeof(sta_status_t))
                                return -EFAULT;

                        num_elem = (p->length)/sizeof(sta_status_t);
                        tmp = kal_malloc(sizeof(sta_status_t) * num_elem);
			if (tmp == NULL) {
				printk("ioctl_priv_get_struct: malloc fail\n");
				ret =  -EFAULT;
				break;
			}
                        memset(tmp,0, sizeof(sta_status_t) * num_elem);
                        param_get_StaList(dev, p->length, tmp);
                        if (copy_to_user(p->pointer, tmp, sizeof(sta_status_t) * num_elem))
                                ret = -EFAULT;
                        kal_free(tmp);
                        break;
                case PARAM_APStatistics:
                        if((p->length) < sizeof(struct net_stat))
                                return -EFAULT;

                        param_get_Statistic(dev,&tmp_stat);
                        if (copy_to_user(p->pointer, &tmp_stat, sizeof(struct net_stat)))
                                ret = -EFAULT;
                        break;
                default:
                        ret = (-EOPNOTSUPP);
                break;
        };
        return ret;
}

#if WLAN_MAC_FILTER
int ioctl_priv_set_struct(struct net_device *dev, struct iwreq* iwr, unsigned short param)
{
        int ret=0;
        int num_elem = 0;
        struct iw_point *p = (struct iw_point *) &iwr->u.data;

        switch (param) {
                case PARAM_APSetMacfilter:
			{
				//printk("Enter ioctl_priv_set_struct\n");
				if (copy_from_user(&macfilter_tbl,p->pointer,p->length))
				{
					ret = -EFAULT;
					break;
				}
				if (macfilter_tbl.macfilter_count > MAX_SIZE_OF_MACFILTER)
				{
					ret = -EFAULT;
					break;
				}
				if (macfilter_tbl.macfilter_type) // enable BLACK_LIST or WHITE_LIST, dosconnect all connection at first
				{
					unsigned char bcstAddr[6]={0xff,0xff,0xff,0xff,0xff,0xff};
			                cmd_deauth_sta(dev, bcstAddr);
				}
				else  // disable mac filter ,do clear mac filter table 
					memset(&macfilter_tbl,0,sizeof(macfilter_tbl_t));
				#if 0
				for (num_elem=0; num_elem < macfilter_tbl.macfilter_count; num_elem++)
				{
					int i;
					unsigned char* addr_p;
					sta_macaddress_t* sta_adr_p;
					sta_adr_p = &macfilter_tbl.macaddr_array_ptr[num_elem]; 
					addr_p = sta_adr_p->addr;
					printk("MACADDRESS is :");
					for (i=0; i<6; i++,addr_p++)
					{
					printk("%02x ",*addr_p);
					}
					printk("\n");	
				}
				#endif
			}
                        break;
                default:
                        ret = (-EOPNOTSUPP);
                break;
        };
        return ret;
}
#endif

/*----------------------------------------------------------------*/
/*!
* \brief  Private ioctl() (Linux Wireless Extensions) routines for AP driver.
*
* \param  ifr   the ifreq structure for seting the private data
* \param  cmd   the SIOCDEVPRIVATE ~ SIOCDEVPRIVATE +15 ioctl command
* \return  zero on success, a negative errno on failure.  Possible values:
*               EOPNOTSUPP if the cmd is not supported
*               EPERM if not capable
*/
/*----------------------------------------------------------------*/
int private_support_ioctl(struct net_device *dev, struct iwreq *iwr, int cmd)
{
        switch (cmd) {
        case IOCTL_SET_INT:
                return ioctl_priv_set_int(dev, iwr, iwr->u.mode);
        case IOCTL_SET_STR:
                return ioctl_priv_set_string(dev, iwr, iwr->u.data.flags);
        case IOCTL_SET_KEY:
                return ioctl_priv_set_key(dev, iwr, iwr->u.data.flags);
        case IOCTL_GET_INT:
                return ioctl_priv_get_int(dev, iwr, &iwr->u.mode);
        case IOCTL_GET_STRUCT:
                return ioctl_priv_get_struct(dev, iwr, iwr->u.data.flags);
#if WLAN_MAC_FILTER // Sam add for wlan mac filter
	case IOCTL_SET_STRUCT:
		return ioctl_priv_set_struct(dev, iwr, iwr->u.data.flags);
#endif
        default:
                return -EOPNOTSUPP;
        } /* end of switch */

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  To get the private supported ioctl structure.
*
* \param  priv_p    card private information
* \param  data      pointer to iw_point structure
* \return  zero on success, a negative errno on failure.  Possible values:
*               EFAULT  if copy_to_user goes wrong
* \return  data     pointer to the private structure i2220_iwpriv
*/
/*----------------------------------------------------------------*/
/***********Merlin 20041104***********/
//static int wext_giwpriv(struct net_device *dev, struct iw_point *data)
int wext_giwpriv(struct net_device *dev, struct iw_point *data)
/************************************/
{
#if 0
        if (!data->pointer ||
            verify_area(VERIFY_WRITE, data->pointer, sizeof(i2220_iwpriv)))
                return -EFAULT;
#endif
        data->length = sizeof(i2220_iwpriv) / sizeof(i2220_iwpriv[0]);
        if (copy_to_user(data->pointer, i2220_iwpriv, sizeof(i2220_iwpriv)))
                return -EFAULT;

        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  ioctl() (Linux Wireless Extensions) routines for AP driver.
*
* \param  priv_p    card private information
* \param  ifr       the ifreq structure for seeting the wireless extension
* \param  cmd       the wireless extension ioctl command
* \return  zero on success, a negative errno on failure.  Possible values:
*               EOPNOTSUPP if the cmd is not supported
*               EFAULT if copy_to_user goes wrong
*               EINVAL if any value's out of range
* \return  ifreq    the structure containing requested value (by "get" commands)
*/
/*----------------------------------------------------------------*/
int wext_support_ioctl(struct net_device *dev, struct iwreq *iwr, int cmd)
{
        switch (cmd) {
        case SIOCGIWPRIV:
                return wext_giwpriv(dev, &iwr->u.data );
        default:
                return -EOPNOTSUPP;
        }
        return 0;
}

/*----------------------------------------------------------------*/
/*!
* \brief  ioctl_plugin: routines for plug_in module.
*
* \param  priv_p    card private information
* \param  ifr       the ifreq structure for seeting the wireless extension
* \param  cmd       the wireless extension ioctl command
* \return
*/
/*----------------------------------------------------------------*/
#if SUPPORT_IPNRSN | SUPPORT_WPA2
static int linux_hostapd_set_flags_sta(struct net_device *apdev,
                                        struct wlan_hostapd_param *param)
{
    int ret = 0;

    if ( param->u.set_flags_sta.flags_or == 0 )
        param_set_1xport(apdev, param->sta_addr, 0);
    else
        param_set_1xport(apdev, param->sta_addr, 1);
        return ret;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
static int linux_ioctl_set_encryption(struct net_device *apdev,
                                       struct wlan_hostapd_param *param,
                                       int param_len)
{
        int ret = 0;

#if SUPPORT_IPNRSN
        if (strcmp(param->u.crypt.alg, "WPA") == 0) {
                param_set_1x_key( apdev, param->sta_addr, 1, param->u.crypt.key , param->u.crypt.key_len);
        } else if (strcmp(param->u.crypt.alg, "WEP") == 0){
                param_set_1x_key( apdev, param->sta_addr, 1, param->u.crypt.key, param->u.crypt.key_len);
        }
#else /* SUPPORT_WPA2 */
        param_set_1x_key( apdev, param->sta_addr, param->u.crypt.idx, param->u.crypt.key , param->u.crypt.key_len);
#endif
        return ret;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
static int linux_ioctl_get_encryption(struct net_device *apdev,
                                       struct wlan_hostapd_param *param,
                                       int param_len)
{
        return 0;
}


#if SUPPORT_WPA2
static int linux_hostapd_set_ie(struct net_device *apdev,
                                       struct wlan_hostapd_param *param,
                                       int param_len)
{
        if (param->ssid == 0)
                cmd_set_RsnIE(apdev, param->u.generic_elem.data, param_len);
        linux_set_11i_mode(apdev, 1);
        return 0;
}
#endif

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int linux_ioctl_priv_hostapd(struct net_device* dev, struct iw_point *p)
{
        struct wlan_hostapd_param *param;
        int ret = 0;
        int ap_ioctl = 0;

        if (p->length < sizeof(struct wlan_hostapd_param) ||
            p->length > WLAN_HOSTAPD_MAX_BUF_SIZE || !p->pointer)
                return -EINVAL;

        param = (struct wlan_hostapd_param *) kal_malloc(p->length);
        if (param == NULL) {
		printk("linux_ioctl_priv_hostapd: malloc fail\n");
                return -ENOMEM;
	}

        if (copy_from_user(param, p->pointer, p->length)) {
                ret = -EFAULT;
                goto out;
        }

        switch (param->cmd) {
        case WLAN_SET_ENCRYPTION:
                ret = linux_ioctl_set_encryption(dev, param, p->length);
                break;
        case WLAN_GET_ENCRYPTION:
                ret = linux_ioctl_get_encryption(dev, param, p->length);
                break;
        case WLAN_HOSTAPD_FLUSH:
                break;
        case WLAN_HOSTAPD_ADD_STA:
                break;
        case WLAN_HOSTAPD_REMOVE_STA:
                break;
        case WLAN_HOSTAPD_GET_INFO_STA:
                break;
        case WLAN_HOSTAPD_SET_FLAGS_STA:
                ret = linux_hostapd_set_flags_sta(dev, param);
                goto out;
        #if SUPPORT_WPA2
        case WLAN_HOSTAPD_SET_GENERIC_ELEMENT:
                ret = linux_hostapd_set_ie(dev, param, param->u.generic_elem.len);
                break;
        case WLAN_HOSTAPD_SET_SSID:
                ret = param_set_ssid_id(dev, param->u.ssid_req.ssid_id);
                if (ret==0) {
                        if (param->u.ssid_req.enable) {
                                param_ssid_t            ssid;
                                memcpy(ssid.ssid, param->u.ssid_req.ssid, param->u.ssid_req.ssid_len);
                                ssid.len = param->u.ssid_req.ssid_len;
                                ret = param_set_m_ssid(dev, (param_ssid_t*)&ssid);
                                if (ret==0 && param->u.ssid_req.ssid_id!=0)
                                        ret = param_set_m_enable(dev, param->u.ssid_req.enable);
                        } else {
                                if (param->u.ssid_req.ssid_id!=0)
                                        ret = param_set_m_enable(dev, param->u.ssid_req.enable);
                        }
                        if (ret==0) {
                                if (param->u.ssid_req.vlanid == 4096)
                                        ret = param_set_m_vlantag_enable(dev, 0);
                                else {
                                        ret = param_set_m_vlanid(dev, param->u.ssid_req.vlanid);
                                        if (ret==0)
                                                ret = param_set_m_vlantag_enable(dev, 1);
                                }
                        }
                }
                break;
        #endif
        default:
                ret = -EOPNOTSUPP;
                goto out;
        }

        if (ret == 1 || !ap_ioctl) {
                if (copy_to_user(p->pointer, param, p->length)) {
                        ret = -EFAULT;
                        goto out;
                } else if (ap_ioctl)
                        ret = 0;
        }

 out:
        if (param != NULL)
                kfree(param);

        return ret;
}

/*----------------------------------------------------------------*/
/*!
* \brief
*
* \param
*
* \return
*/
/*----------------------------------------------------------------*/
int do_hostap_ioctl(struct net_device *dev,  struct iwreq *ifreq,int sub_cmd)
{
        int ret;
        int cmd = sub_cmd;
        struct iwreq *wrq = (struct iwreq *) ifreq;

        switch (cmd) {
        case WLAN_IOCTL_WLAN_PARAM:
                if (!capable(CAP_NET_ADMIN)) {
                    ret = -EPERM;
                }
                else {
                    ret = 0;//linux_ioctl_priv_param(dev,(char *) &wrq->u);
                }
                break;
        case WLAN_IOCTL_HOSTAPD:
                if (!capable(CAP_NET_ADMIN)) {
                    ret = -EPERM;
                }
                else {
                    ret = linux_ioctl_priv_hostapd(dev, &wrq->u.data);
                }
                break;
        default:
                ret = -EOPNOTSUPP;
                break;
        }
        return ret;
}
#endif

