/*
** $Id: rf_rfmd.c 1.7 2004/09/13 15:33:56 patlu Exp $
*/

/*************************************************************************
* Copyright (c) 2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define PAU_TNTDR_RFMD_LONG_SLOT                0x01fc0072
#define PAU_TNTDR_RFMD_SHORT_SLOT               0x01200072

#define PAU_STDR_RFMD_LONG_SLOT                 0x01900198
#define PAU_STDR_RFMD_SHORT_SLOT                0x00b400bc

#define RF_INIT_WAIT_DELAY_RFMD                 0

#define RSSI_AT_NOISE_FLOOR_BASELINE_RFMD_24    -74

#define TX_POWER_GAIN_RFMD_CCK                  0xA0
#define TX_POWER_GAIN_RFMD_OFDM_24              0xA8

#define TX_POWER_GAIN_STEP_RFMD_NUM             1
#define TX_POWER_GAIN_STEP_RFMD_DENOM           4

#define RSSI_COEFF_A_2_RFMD_24                  0
#define RSSI_COEFF_A_1_RFMD_24                  -24592
#define RSSI_COEFF_A_0_RFMD_24                  178503
#define RSSI_COEFF_C_LNA_0_RFMD_24              0
#define RSSI_COEFF_C_LNA_1_RFMD_24              -343229

#define NIC_PM_WAKE_UP_TIME_RFMD                2000


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
const NIC_MCR_CONFIG_ENTRY pauInitTableForRFMD_24[] = {
    {MCR_PCICR,     0x00000180},
    {MCR_PSCR,      0x3d821a22},
    {MCR_PPORCR0,   0x0000002c},
    {MCR_PPORCR1,   0x00560056},
    {MCR_PPDRCR0,   0x0024000a},
    {MCR_PPDRCR1,   0x00140014},
    {MCR_PPDRCR2,   0x00000050},
    {MCR_MPDR,      0x0006641e},
    {MCR_TNTDR,     PAU_TNTDR_RFMD_LONG_SLOT},
    {MCR_STDR,      PAU_STDR_RFMD_LONG_SLOT},
    {MCR_BGCR0,     (TX_POWER_GAIN_RFMD_CCK << 8)},
    {MCR_RFTPCR,    (TX_POWER_GAIN_RFMD_CCK | (TX_POWER_GAIN_RFMD_OFDM_24 << 8))}
};

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForRFMD[] = {
    {"CR01", 01,  0x10},
    {"CR05", 05,  0x01},
    {"CR68", 68,  0x50},
    {"CR69", 69,  0x28},
    {"CR81", 81,  0x10},
    {"CR82", 82,  0x00},
    {"CR83", 83,  0xf0},
    {"CR88", 88,  0x80},
    {"CR45", 45,  0x00},
    {"CR46", 46,  0x22},
    {"CR45", 45,  0x5a},
    {"CR46", 46,  0x2A},
    {"CR45", 45,  0x5b},
    {"CR46", 46,  0x06},
    {"CR45", 45,  0x5c},
    {"CR46", 46,  0xE0},
    {"CR45", 45,  0x7d},
    {"CR46", 46,  0x0E},
    {"CR45", 45,  0x54},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x55},
    {"CR46", 46,  0x1b},
    {"CR45", 45,  0x52},
    {"CR46", 46,  0x1e},
    {"CR45", 45,  0x56},
    {"CR46", 46,  0x91},
    {"CR45", 45,  0x57},
    {"CR46", 46,  0x98},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x21},
    {"CR45", 45,  0x03},
    {"CR46", 46,  0x32},
    {"CR45", 45,  0x04},
    {"CR46", 46,  0x22},
    {"CR49", 49,  0x2e},
    {"CR77", 77,  0x90},
    {"CR45", 45,  0x4b},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x78},
    {"CR46", 46,  0x16},
    {"CR45", 45,  0x79},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x5d},
    {"CR46", 46,  0x83},
    {"CR45", 45,  0x5e},
    {"CR46", 46,  0x57},
    {"CR45", 45,  0x5f},
    {"CR46", 46,  0x39},
    {"CR45", 45,  0x60},
    {"CR46", 46,  0x26},
    {"CR45", 45,  0x61},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x62},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x63},
    {"CR46", 46,  0x0a},

#if BB_FPGA_VERSION_TABLE
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x49},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0x66},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0xe1},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0xa7},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x2f},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xbf},
#else
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x24},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0xb3},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0x50},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x97},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xe6},
#endif
    {"CR45", 45,  0x6a},
    {"CR46", 46,  0x80},
    {"CR45", 45,  0x6b},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x6c},
    {"CR46", 46,  0x33},
    {"CR45", 45,  0x6d},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x6e},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x6f},
    {"CR46", 46,  0x0c},
    {"CR45", 45,  0x70},
    {"CR46", 46,  0x08},
    {"CR45", 45,  0x71},
    {"CR46", 46,  0x1c},
    {"CR45", 45,  0x72},
    {"CR46", 46,  0x82},
    {"CR45", 45,  0x73},
    {"CR46", 46,  0xce},
    {"CR45", 45,  0x74},
    {"CR46", 46,  0x45},
    {"CR45", 45,  0x75},
    {"CR46", 46,  0x67},
    {"CR45", 45,  0x76},
    {"CR46", 46,  0x23},
    {"CR45", 45,  0x7a},
    {"CR46", 46,  0xa2},

    {"CR49", 49,  0x04},
    {"CR50", 50,  0x84},
    {"CR45", 45,  0x00},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x4c},
    {"CR46", 46,  0xd0},
    {"CR45", 45,  0x71},
    {"CR46", 46,  0x00},
    {"CR45", 45,  0x01},
    {"CR46", 46,  0xa4},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x23},
    {"CR45", 45,  0x6a},
    {"CR46", 46,  0x52},
    {"CR45", 45,  0x72},
    {"CR46", 46,  0x02}
/**/
};

const UINT_32 phyRFInitTableForRFMD2959[] = {
    0x8000C007,
    0x8006FDB3,
    0x80080959,
    0x800E6666,
    0x80116A7F,
    0x8016DDB3,
    0x801819F9,
    0x801E6666,
    0x8021457F,
    0x8027FFF8,
    0x80280079,
    0x802C0000,
    0x80300000,
    0x80340000,
    0x80381E0F
};

const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForRFMD2959_24[] = {
    { 1,    2,  { 0x80181979, 0x801E6666, 0 } },
    { 2,    2,  { 0x80181989, 0x801E6666, 0 } },
    { 3,    2,  { 0x80181999, 0x801E6666, 0 } },
    { 4,    2,  { 0x801819A9, 0x801E6666, 0 } },
    { 5,    2,  { 0x801819B9, 0x801E6666, 0 } },
    { 6,    2,  { 0x801819C9, 0x801E6666, 0 } },
    { 7,    2,  { 0x801819D9, 0x801E6666, 0 } },
    { 8,    2,  { 0x801819E9, 0x801E6666, 0 } },
    { 9,    2,  { 0x801819F9, 0x801E6666, 0 } },
    { 10,   2,  { 0x80181A09, 0x801E6666, 0 } },
    { 11,   2,  { 0x80181A19, 0x801E6666, 0 } },
    { 12,   2,  { 0x80181A29, 0x801E6666, 0 } },
    { 13,   2,  { 0x80181A39, 0x801E6666, 0 } },
    { 14,   2,  { 0x80181A60, 0x801C0000, 0 } }
};

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
const ED_FLOATED_MARGIN_STRUC edFloatedMarginsForRFMD[ED_FLOAT_ED_LEVELS] = {
        {0x14, 0x16, 0x14},
        {0x18, 0x1a, 0x1a},
        {0x1f, 0x1f, 0x1f}
};
#endif


static
VOID
phyRFInitForRFMD(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterActiveForRFMD(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterSleepForRFMD(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFSwitchChannelForRFMD(IN PMP_ADAPTER adapter_p,
                          IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p);

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
static
BOOLEAN
edGetFloatedMarginsForRFMD(IN PMP_ADAPTER adapter_p,
                           IN UINT floatLevel,
                           OUT PUINT_8 marginAGCED_p,
                           OUT PUINT_8 marginCCK_p,
                           OUT PUINT_8 marginOFDM_p);
#endif


NIC_RF_SPECIFIC_CONFIG rfConfigRFMD2959 = {
    NIC_RF_RFMD_2959,
    "RFMD RF2959",

    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForRFMD_24,
    sizeof(pauInitTableForRFMD_24) / sizeof(NIC_MCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    PAU_TNTDR_RFMD_LONG_SLOT,
    PAU_STDR_RFMD_LONG_SLOT,

    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForRFMD,
    sizeof(phyBBInitTableForRFMD) / sizeof(NIC_BBCR_CONFIG_ENTRY),
    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif
    RF_INIT_WAIT_DELAY_RFMD,

    phyRFInitForRFMD,
    phyRFEnterActiveForRFMD,
    phyRFEnterSleepForRFMD,
    phyRFSwitchChannelForRFMD,
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    edGetFloatedMarginsForRFMD,
#endif

    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForRFMD2959_24,
    sizeof(phyRFChnlTableForRFMD2959_24) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    RSSI_AT_NOISE_FLOOR_BASELINE_RFMD_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_RFMD_CCK,
    TX_POWER_GAIN_RFMD_OFDM_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_STEP_RFMD_NUM,
    TX_POWER_GAIN_STEP_RFMD_DENOM,

    RSSI_COEFF_A_2_RFMD_24,
    RSSI_COEFF_A_1_RFMD_24,
    RSSI_COEFF_A_0_RFMD_24,
    RSSI_COEFF_C_LNA_0_RFMD_24,
    RSSI_COEFF_C_LNA_1_RFMD_24,
#if SUPPORT_802_11A
    0,
    0,
    0,
    0,
    0,
#endif

    NIC_PM_WAKE_UP_TIME_RFMD,

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    TRUE
#endif
};


/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
DEBUGFILE("rf_rfmd.c");


/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*_________________________________________________________________________
**  phyRFInitForRFMD
**
**  descriptions: This routine is called to initialize RFMD RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFInitForRFMD(IN PMP_ADAPTER adapter_p)
{
    DEBUGFUNC("phyRFInitForRFMD");

    INITLOG(("\n"));

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFInitTableForRFMD2959,
        sizeof(phyRFInitTableForRFMD2959) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_RFMD);

}   /* phyRFInitForRFMD */

/*_________________________________________________________________________
**  phyRFEnterActiveForRFMD
**
**  descriptions: This routine is called to let RFMD RF chipset enter RF
**                active state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterActiveForRFMD(IN PMP_ADAPTER adapter_p)
{
    UINT_32 tmp32;

    DEBUGFUNC("phyRFEnterActiveForRFMD");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &tmp32);
    tmp32 &= ~(PPMCR_GPIO_RF_RX | PPMCR_GPIO_RF_TX);
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, tmp32);
}   /* phyRFEnterActiveForRFMD */

/*_________________________________________________________________________
**  phyRFEnterSleepForRFMD
**
**  descriptions: This routine is called to let RFMD RF chipset enter RF
**                sleep state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterSleepForRFMD(IN PMP_ADAPTER adapter_p)
{
    UINT_32 tmp32;

    DEBUGFUNC("phyRFEnterSleepForRFMD");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &tmp32);
    tmp32 |= PPMCR_GPIO_RF_RX | PPMCR_GPIO_RF_TX;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, tmp32);
}   /* phyRFEnterSleepForRFMD */

/*_________________________________________________________________________
**  phyRFSwitchChannelForRFMD
**
**  descriptions: This routine is called to switch channel for RFMD RF
**                chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFSwitchChannelForRFMD(IN PMP_ADAPTER adapter_p,
                          IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p)
{
    UINT i;
    BOOLEAN status;

    DEBUGFUNC("phyRFSwitchChannelForRFMD");

    DBGLOG(HW, TRACE, ("\n"));

    for (i = 0; i < entry_p->numSynthProgWords; i++) {
        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, entry_p->synthProgWords[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);

        ASSERT(status);
    }
}   /* phyRFSwitchChannelForRFMD */

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
/*_________________________________________________________________________
**  edGetFloatedMarginsForRFMD
**
**  descriptions: This routine is called to get a set of floated ED margins
**                for RFMD RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      floatLevel - The current ED float level
**  results:
**      marginAGCED_p - Pointer to the AGC ED margin
**      marginCCK_p - Pointer to the CCK margin
**      marginOFDM_p - Pointer to the OFDM margin
**  return:
**      TRUE
**  note:
**__________________________________________________________________________*/
static
BOOLEAN
edGetFloatedMarginsForRFMD(IN PMP_ADAPTER adapter_p,
                           IN UINT floatLevel,
                           OUT PUINT_8 marginAGCED_p,
                           OUT PUINT_8 marginCCK_p,
                           OUT PUINT_8 marginOFDM_p)
{
    DEBUGFUNC("edGetFloatedMarginsForRFMD");

    DBGLOG(HW, INFO, ("\n"));

    *marginAGCED_p = edFloatedMarginsForRFMD[floatLevel].AGCEDMargin;
    *marginCCK_p = edFloatedMarginsForRFMD[floatLevel].CCKMargin;
    *marginOFDM_p = edFloatedMarginsForRFMD[floatLevel].OFDMMargin;

    return TRUE;
}   /* edGetFloatedMarginsForRFMD */
#endif

