/*
 *  $Id: reset.c,v 1.1.1.1 2005/11/02 05:45:19 lino Exp $
 *
 *  Reset on TC3162 board.
 *
 */
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/delay.h>
#include <asm/tc3162/tc3162.h>
#include <asm/tc3162/TCIfSetQuery.h>	

void hw_init(void)
{
	int i;

#ifdef CONFIG_TC3162_ADSL
    /* stop adsl */
	if (adsl_dev_ops)
	    adsl_dev_ops->set(ADSL_SET_DMT_CLOSE, NULL, NULL); 
#endif

    /* lino: stop each module dma task */
	tc_outl(CR_INTC_IMR, 0x0);
	tc_outl(CR_TIMER_CTL, 0x0);

	/* stop mac dma */
	tc_outl(CR_MAC_MACCR, 0);

	/* stop atm sar dma */	
	TSARM_GFR &= ~((1 << 1) | (1 << 0));

	/* reset USB */
	/* reset USB DMA */
	VPint(CR_USB_SYS_CTRL_REG) |= (1 << 31);
	/* reset USB SIE */
	VPint(CR_USB_DEV_CTRL_REG) |= (1 << 30);
	mdelay(5);

	/* restore USB SIE */
	VPint(CR_USB_DEV_CTRL_REG) &= ~(1 << 30);
	mdelay(5);
	VPint(CR_USB_SYS_CTRL_REG) &= ~(1 << 31);
}

void lexra_machine_restart(char *command)
{
	printk("delete all module ..\n");
	printk("Machine restart ... \n");
	hw_init();
        printk("active the watchdog ..\n");
        timerSet(5, 1 * TIMERTICKS_10MS, ENABLE, TIMER_TOGGLEMODE, TIMER_HALTDISABLE);
        timer_WatchDogConfigure(DISABLE, ENABLE);
        while (1);
}

void lexra_machine_halt(void)
{
	printk("Machine halted ... \n");
	while (1);
}

void lexra_machine_power_off(void)
{
	printk("Machine poweroff ... \n");
	while (1);
}
