/*
** $Id: wep_func.h 1.35 2004/06/02 17:51:36 chyeh Exp $
*/

/******************************************************************************
Copyright (c) 2000-2002 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************
This header file consists of the definitions for AP / STA wlan-boxes.
******************************************************************************/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/*-----------------------------------------------------------------------*/
/* copy from i2120sw.h                                                   */
/*-----------------------------------------------------------------------*/
/* The macro to copy the two 32-bit values */
#define COPY_32_BITS(dst_p, src_p) \
{ \
    *((dst_p) + 0) = *((src_p) + 0); \
    *((dst_p) + 1) = *((src_p) + 1); \
    *((dst_p) + 2) = *((src_p) + 2); \
    *((dst_p) + 3) = *((src_p) + 3); \
}

/* The macro to copy the two 16-bit values */
#define COPY_16_BITS(dst_p, src_p) \
{ \
    *((dst_p) + 0) = *((src_p) + 0); \
    *((dst_p) + 1) = *((src_p) + 1); \
}

/* The macro set 32-bit values to zero */
#define ZERO_32_BITS(value_p) \
{ \
    *((value_p) + 0) = 0; \
    *((value_p) + 1) = 0; \
    *((value_p) + 2) = 0; \
    *((value_p) + 3) = 0; \
}


/* The macro to copy the two 48-bit values */
#define COPY_48_BITS(dst_p, src_p) \
{ \
    *((dst_p) + 0) = *((src_p) + 0); \
    *((dst_p) + 1) = *((src_p) + 1); \
    *((dst_p) + 2) = *((src_p) + 2); \
    *((dst_p) + 3) = *((src_p) + 3); \
    *((dst_p) + 4) = *((src_p) + 4); \
    *((dst_p) + 5) = *((src_p) + 5); \
}


/* The macro to compare if 48-bit value 1 is greater then value 2 */
#define GREATER_48_BITS(x1_p, x2_p) \
   ((*((x1_p) + 5) >  *((x2_p) + 5)) || \
    (*((x1_p) + 5) == *((x2_p) + 5) && *((x1_p) + 4) >  *((x2_p) + 4)) || \
    (*((x1_p) + 5) == *((x2_p) + 5) && *((x1_p) + 4) == *((x2_p) + 4) && *((x1_p) + 3) >  *((x2_p) +3)) || \
    (*((x1_p) + 5) == *((x2_p) + 5) && *((x1_p) + 4) == *((x2_p) + 4) && *((x1_p) + 3) == *((x2_p) +3) && *((x1_p) + 2) >  *((x2_p) + 2)) || \
    (*((x1_p) + 5) == *((x2_p) + 5) && *((x1_p) + 4) == *((x2_p) + 4) && *((x1_p) + 3) == *((x2_p) +3) && *((x1_p) + 2) == *((x2_p) + 2) && *((x1_p) + 1) >  *((x2_p) + 1)) || \
    (*((x1_p) + 5) == *((x2_p) + 5) && *((x1_p) + 4) == *((x2_p) + 4) && *((x1_p) + 3) == *((x2_p) +3) && *((x1_p) + 2) == *((x2_p) + 2) && *((x1_p) + 1) == *((x2_p) + 1) \
    && *((x1_p) + 0) > *((x2_p) +0)))

/* The macro set 48-bit values to zero */
#define ZERO_48_BITS(value_p) \
{ \
    *((value_p) + 0) = 0; \
    *((value_p) + 1) = 0; \
    *((value_p) + 2) = 0; \
    *((value_p) + 3) = 0; \
    *((value_p) + 4) = 0; \
    *((value_p) + 5) = 0; \
}

/* This macro increase 48-bit value by 1 */
#define INC_48_BITS(value_p) \
{\
    *((value_p) + 0) += 1; \
    if (*((value_p) + 0) == 0) { \
        *((value_p) + 1) += 1; \
        if (*((value_p) + 1) == 0) { \
            *((value_p) + 2) += 1; \
            if (*((value_p) + 2) == 0) { \
                *((value_p) + 3) += 1; \
                if (*((value_p) + 3) == 0) { \
                    *((value_p) + 4) += 1; \
                    if (*((value_p) + 4) == 0) { \
                        *((value_p) + 5) += 1; \
                    } \
                } \
            } \
        } \
    } \
}

/* This macro increase 64-bit value by 1 */
#define INC_64_BITS(value_p) \
{\
    *((value_p) + 0) += 1; \
    if (*((value_p) + 0) == 0) { \
        *((value_p) + 1) += 1; \
        if (*((value_p) + 1) == 0) { \
            *((value_p) + 2) += 1; \
            if (*((value_p) + 2) == 0) { \
                *((value_p) + 3) += 1; \
                if (*((value_p) + 3) == 0) { \
                    *((value_p) + 4) += 1; \
                    if (*((value_p) + 4) == 0) { \
                        *((value_p) + 5) += 1; \
                        if (*((value_p) + 5) == 0) { \
                            *((value_p) + 6) += 1; \
                            if (*((value_p) + 6) == 0) { \
                                *((value_p) + 7) += 1; \
                            } \
                        } \
                    } \
                } \
            } \
        } \
    } \
}

/* The macro to check if two 64-bit values are equal */
#define EQUAL_64_BITS(value1_p, value2_p) \
    (ipn_memcmp(value1_p, value2_p, 8)==0)

/* The macro to check if two 48-bit values are equal */
#define EQUAL_48_BITS(value1_p, value2_p) \
    (ipn_memcmp(value1_p, value2_p, 6)==0)

#define EQUAL_MAC_ADDR(dst_p, src_p) EQUAL_48_BITS(dst_p, src_p)

/* The macro to copy the 48-bit TSC counter to CCM counter */
#define COPY_TSC_CTR(dst_p, src_p) COPY_48_BITS(dst_p, src_p)
/* The macro to check if 48-bit TSC counter and CCM counter are equal */
#define EQUAL_TSC_CTR(dst_p, src_p) EQUAL_48_BITS(dst_p, src_p)

/* ----- Constants defined for cipher suite selectors ----- */
/* Encryption mode in the registry */
#define ENCRYPTION_MODE_NONE            CIPHER_SUITE_NONE
#define ENCRYPTION_MODE_WEP40           CIPHER_SUITE_WEP40
#define ENCRYPTION_MODE_WEP104          CIPHER_SUITE_WEP104
#define ENCRYPTION_MODE_WEP128          CIPHER_SUITE_WEP128

/* Security Error Message */
#define ENCRYPT_SUCCESS                 0
#define DECRYPT_SUCCESS                 0
#define ENCAPSULATE_SUCCESS             0
#define DECAPSULATE_SUCCESS             0
#define CIPHER_ERROR                    6
#define ENCRYPT_ERROR                   1
#define DECRYPT_ERROR                   1
#define ENCAPSULATE_ERROR               1
#define DECAPSULATE_ERROR               1

#define WEP_ENCAPSULATE_SUCCESS         ENCAPSULATE_SUCCESS
#define WEP_DECAPSULATE_SUCCESS         DECAPSULATE_SUCCESS
#define WEP_ENCRYPT_SUCCESS             ENCRYPT_SUCCESS
#define WEP_DECRYPT_SUCCESS             DECRYPT_SUCCESS
#define WEP_ICV_ERROR                   11
#define WEP_FRAME_FORMAT_ERROR          14
#define WEP_NULL_KEY_ERROR              15

/* CRC32 context structure */
typedef struct _CRC32_CTX{
    ULONG  crc32;
} CRC32_CTX, *PCRC32_CTX;

/* RC4 context structure */
typedef struct _RC4_CTX{
    INT i, j, k;
    UCHAR SBOX[256];   /* state array */
    UCHAR KEYBOX[256]; /* temp secret key sequence */
} RC4_CTX, *PRC4_CTX;

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/



