/*
** $Id: 11i-rsn_sm.c 1.36 2004/10/04 17:51:03 cmchang Exp $
*/

/*! \file 11i-rsn_sm.c
    \brief IEEE 802.11i rsn standard SDL, Authenticator key management state machine

*/

/******************************************************************************
Copyright (c) 2000-2002 Integrated Programmable Communications, Inc.

All rights reserved. Copying, compilation, modification, distribution
or any other use whatsoever of this material is strictly prohibited
except in accordance with a Software License Agreement with
Integrated Programmable Communications, Inc.
******************************************************************************/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/

/* System Includes */
#include "wlan_os.h"
#include "precomp.h"

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
UINT8 KeyIdx =3;
/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

#if 0
#define SM_ENTRY(machine, _state, _data) \
        sm->_data.state = machine ## _ ## _state; \
                printk("[" MACSTR "]" #machine " enter " #_state "\n", MAC2STR(sm->sta_p->asoc.adAddr));
#else
#define SM_ENTRY(machine, _state, _data) \
        sm->_data.state = machine ## _ ## _state;
#endif

#define set_Ebit(E,S)    do {E->key.data[eop_len+keyInfo1] = (E->key.data[eop_len+keyInfo1] & ~BIT(4 )) | ((S) << 4 ); } while (0)
#define set_Sbit(E,S)    do {E->key.data[eop_len+keyInfo1] = (E->key.data[eop_len+keyInfo1] & ~BIT(1 )) | ((S) << 1 ); } while (0)
#define set_Mbit(E,S)    do {E->key.data[eop_len+keyInfo1] = (E->key.data[eop_len+keyInfo1] & ~BIT(0 )) | ((S) << 0 ); } while (0)
#define set_Abit(E,S)    do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(7 )) | ((S) << 7 ); } while (0)
#define set_Tbit(E,S)    do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(6 )) | ((S) << 6 ); } while (0)
#define set_Nbit1(E,S)   do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(4 )) | ((S) << 4 ); } while (0)
#define set_Nbit2(E,S)   do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(5 )) | ((S) << 5 ); } while (0)
#define set_Nbit3(E,S)   do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] | BITS(4,5 )); } while (0)
#define set_Kbit(E,S)    do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(3 )) | ((S) << 3 ); } while (0)

#define set_Dbit2(E,S)   do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(2 ))  | ((S) << 2 ); } while (0)
#define set_Dbit3(E,S)   do {E->key.data[eop_len+keyInfo2] = (E->key.data[eop_len+keyInfo2] & ~BIT(3 ))  | ((S) << 3 ); } while (0)

#define Gen_Current(Nonce) do {\
        int i,j; \
        unsigned long nonce_xor= kal_jiffies; \
        for (i = 0; i < 4; i++) { \
                for (j = 0; j < 8; j++) { \
                        Nonce[8*i+j] = (UINT8)((nonce_xor>>i) ^ ((UINT32)nonce_xor>>j)); \
                } \
        } \
} while (0)

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/
/*********************************************************************************************/
/*            standard define                                                                */
/*********************************************************************************************/

void    STADisconnect(void);
VOID    CalcPTK(PUCHAR key, PUCHAR ANonce_p, PUCHAR AA_p, PUCHAR SNonce_p,
                  PUCHAR SA_p,ULONG  PTKLen, PUCHAR PTK_p);
void    CalcGTK(PUCHAR key, PUCHAR GNonce_p,PUCHAR AA_p,ULONG  GTKLen,PUCHAR GTK_p);
BOOLEAN RemoveGTK(UINT8* TK);
BOOLEAN MIC(UCHAR option, PUCHAR data_p,ULONG dataLen,PUCHAR Mic,PUCHAR mic_p);
BOOLEAN CheckMIC(EAPoL_KEY_MSG_t *eapMsg_p,PUCHAR Mic);
void    SendEAPoL(i2220mgmt_t *priv_p, UINT8 *sta_addr,UINT8 sequence,
                    int S, int M, int A, int T, int N, int K,
                    UINT8 *KeyRSC, UINT8 *Nonce, UINT8 *Mic, UINT8 *GTK);
VOID    passwordHash(PCHAR password_p,PUCHAR ssid_p,INT ssidLen,PUCHAR output_p);
void    randomGK(i2220mgmt_t * priv_p);
/*********************************************************************************************/
/*            state machine                                                                  */
/*********************************************************************************************/
struct  Author_state_machine* Author_sm_alloc(i2220mgmt_t *priv_p, sta_info_t *sta);
void    Author_sm_step(i2220mgmt_t *priv_p, struct Author_state_machine *sm);
void    Author_sm_initialize(i2220mgmt_t *priv_p, struct Author_state_machine *sm);
static void sm_Step(i2220mgmt_t *priv_p, struct Author_state_machine *sm);
/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/
void IEEE8021x_reassoc(i2220mgmt_t *priv_p,sta_info_t *sta_p)
{
        if (mib_import(dot11Pure1XEnabled)&&(priv_p->authMode == AuthMode_WPAPSK)){
                KDBG_LOG_SDL(KDBG_DEBUG, "sta_reassoc \n");
        } else if ((priv_p->authMode == AuthMode_WPAPSK)){
                sta_p->author_sm->Disconnect = true;
                Author_sm_step(priv_p, sta_p->author_sm);
        } else {
        }
}

void IEEE8021x_deauth(i2220mgmt_t *priv_p,sta_info_t *sta_p)
{
        if ((sta_p==NULL)||(sta_p->aid <= 0))
                return;
        if (mib_import(dot11Pure1XEnabled)){
               // sta_p->portenable_1x=false;
        }
        else {
                if ((priv_p->authMode == AuthMode_WPAPSK)){
                        sta_p->author_sm->Disconnect=true;
                        priv_p->GNoStations--;
                        KDBG_LOG_SDL(KDBG_DEBUG, "rcv deauth \n");
                }
                //printk(KERN_ALERT "rcv deauth frame from "MACSTR"\n",MAC2STR(sta_p->asoc.adAddr));
                Author_sm_step(priv_p, sta_p->author_sm);
        }
}

void IEEE80211i_event(i2220mgmt_t *priv_p,TypMacAddr staAddr ,UINT8 event)
{
        sta_info_t              *sta_p;
        struct list_head        *lst;

        switch (event)
        {
                case PAIRWISE_REKEY:
                     //sta_p->author_sm->GUpdateStationKeys = true;
                     KDBG_LOG_SDL(KDBG_DEBUG,MACSTR " PAIRWISE REKEY \n",MAC2STR(staAddr));
                break;
                case GROUP_REKEY_TIME:
                     //KDBG_LOG_SDL(KDBG_DEBUG,"GROUP REKEY \n");
                     randomGK(priv_p);
                     list_for_each(lst,&priv_p->ap.sta_chain.head) {
                             sta_p = list_entry(lst, sta_info_t, sw.link);

                             if ((sta_p->aid > 0) && (sta_p->KeyMapOn) &&  //author_sm->rsn_4way_success) &&
                                 (sta_p->author_sm->Author_hs.state==GTK_sm_REKEYESTABLISHED) ){
                                     sta_p->author_sm->GUpdateStationKeys = true;
                                     KDBG_LOG_SDL(KDBG_DEBUG,"AID[%d]\n",sta_p->aid);
                                     Author_sm_step(priv_p, sta_p->author_sm);
                             }
                     }
                     priv_p->GroupKeyUpdate = false;
                     priv_p->GKRekeyTimer = 0;
                break;
                case DATA_MIC_FAILURE:
                case EAPOL_MIC_FAILURE:
                        KDBG_LOG_SDL(KDBG_DEBUG,"MIC_FAILURE["MACSTR"]\n",MAC2STR(staAddr));
                        cmd_deauth_sta(priv_p->netdev, bcstAddr);
                        //sdlf_send_deauth(priv_p, bcstAddr, SYN_mic_failure);
                        kal_mdelay(2); /* let these two frames sent out */
                default:
                break;
        }

}

void STADisconnect()
{
        return;
}

VOID CalcPTK(PUCHAR key, PUCHAR ANonce_p, PUCHAR AA_p, PUCHAR SNonce_p,
                                PUCHAR SA_p,ULONG  PTKLen, PUCHAR PTK_p)
{
        INT i;
        UCHAR prefix[22] = {'P','a','i','r','w','i','s','e',
                            ' ','k','e','y',' ','e','x','p',
                            'a','n','s','i','o','n'};
        UCHAR data[76];
        UCHAR tmp[128];
        PUCHAR data_p, key_p;//, prefix_p;
        PUCHAR max_p, min_p;
        BOOLEAN maxA=false;

        /* compare Min(AA, SA) and Max(AA, SA) */
        for (i = 0; i < 6; i++) {
                if (AA_p[i] != SA_p[i]) {
                        maxA = (AA_p[i] > SA_p[i]) ? TRUE : FALSE;
                        break;
                }
        }
        if (maxA) {
                max_p = AA_p;
                min_p = SA_p;
        }
        else {
                max_p = SA_p;
                min_p = AA_p;
        }

        /* concatenation: Min(AA, SA) || Max(AA, SA) */
        data_p = &data[0];
        for (i = 0; i < 6; i++) {
                data_p[i    ] = min_p[i];
                data_p[i + 6] = max_p[i];
        }

        /* compare Min(ANonce, SNonce) and Max(ANonce, SNonce) */
        for (i = 0; i < 32; i++) {
                if (ANonce_p[i] != SNonce_p[i]) {
                        maxA = (ANonce_p[i] > SNonce_p[i]) ? TRUE : FALSE;
                        break;
                }
        }
        if (maxA) {
                max_p = ANonce_p;
                min_p = SNonce_p;
        }
        else {
                max_p = SNonce_p;
                min_p = ANonce_p;
        }

        /* concatenation Min(ANonce, SNonce) || Max(ANonce, SNonce) */
        data_p = &data[12];
        for (i = 0; i < 32; i++) {
                data_p[i     ] = min_p[i];
                data_p[i + 32] = max_p[i];
        }

        key_p = &key[0];

        //prf(key_p, 32, prefix, 22, data, 76, PTK_p, PTKLen);
        prf(key_p, 32, prefix, 22, data, 76, tmp, PTKLen);
        ipn_memcpy(PTK_p, tmp, 64);
    //#if 0
        for (i=0;i<64;i+=16)
                KDBG_LOG_TX(KDBG_DEBUG,"PTK %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n",
                        PTK_p[i],PTK_p[i+1],PTK_p[i+2],PTK_p[i+3],
                        PTK_p[i+4],PTK_p[i+5],PTK_p[i+6],PTK_p[i+7],
                        PTK_p[i+8],PTK_p[i+9],PTK_p[i+10],PTK_p[i+11],
                        PTK_p[i+12],PTK_p[i+13],PTK_p[i+14],PTK_p[i+15]);
    //#endif
}

void CalcGTK(PUCHAR key, PUCHAR GNonce_p,PUCHAR AA_p,ULONG  GTKLen,PUCHAR GTK_p)
{
        INT i;
        UCHAR prefix[19] = {'G','r','o','u','p',' ','k','e',
                            'y',' ','e','x','p','a','n','s',
                            'i','o','n'};
        UCHAR data[38];

        PUCHAR key_p, prefix_p, data_p;

        key_p = &key[0];
        prefix_p = &prefix[0];
        data_p = &data[0];

        for (i = 0; i < 6; i++) {
                data_p[i] = AA_p[i];
        }

        data_p += 6;
        for (i = 0; i < 32; i++) {
                data_p[i] = GNonce_p[i];
        }

        prf(key_p, 16, prefix_p, 19, data_p, 38, GTK_p, GTKLen);
}

BOOLEAN RemoveGTK(UINT8* TK)
{
        return true;
}

BOOLEAN MIC(UCHAR option, PUCHAR data_p,ULONG dataLen,PUCHAR Mic, PUCHAR mic_p)
{
        switch (option) {
                case 1: /* Type 1, HMAC-MD5 MIC */
                        hmacMd5(data_p, dataLen, Mic, 16, mic_p);
                        break;
                case 2: /* Type 2, HMAC-SHA MIC */
                        hmacSha1(data_p, dataLen, Mic, 16, mic_p);
                        break;
                default:
                        break;
        }

        return true;
}

BOOLEAN CheckMIC(EAPoL_KEY_MSG_t *eapMsg_p,PUCHAR Mic)
{
        INT    i;
        UCHAR  originalMic[16], calcMic[80];
        USHORT keyVersion;

        /* copy original MIC out and then clear it */
        for (i = 0; i < 16; i ++) {
                originalMic[i] = eapMsg_p->data[eop_len+keyMic+i];
                eapMsg_p->data[eop_len+keyMic+i] = 0;
                calcMic[0]=0;
        }

        keyVersion = (eapMsg_p->data[eop_len+keyInfo2] & BYTE_MASK_EAPOL_KI_DESCR_VER); /* Key Version */

        MIC(keyVersion, &eapMsg_p->data[eopver], (ULONG)eapMsg_p->data[eoplen2]+4, Mic, calcMic);

        switch (keyVersion) {
        case 1: /* Type 1, HMAC-MD5 MIC */
        case 2: /* Type 2, AES-CBC-MAC MIC */
                for (i=0;i<16;i++)
                        if (originalMic[i] != calcMic[i])
                                return FALSE;
                        return TRUE;
        default:
        return FALSE;
        }
}

/*----------------------------------------------------------------*/
/*!
* \brief  aesKeyWrap() routines for EAPOL descripter 2
*
* \param  key       the encrypt key
* \param  ptext     pointer to plain text to be encrypt
* \param  plen      the lens of ptext , must be multiple of 8 bytes,
*                   now the code support 16 and 24 byets
*
* \return  ctext    the encrypted data
*/
/*----------------------------------------------------------------*/
VOID aesKeyWrap( UCHAR *key, UCHAR *ptext, UCHAR plen, UCHAR *ctext)
{
        UCHAR A[8], BIN[16], BOUT[16];
        UCHAR R[16][8];
        INT i,j;
        INT num_blocks = plen/8;
        UCHAR t;
        aes_context aesctx;

        for (i = 0; i < 8; i++)
                A[i] = 0xa6;

        //printk( "num_block %d\n", num_blocks);
        for (j=0;j<num_blocks;j++)
                ipn_memcpy(R[j], &ptext[j*8], 8);
        aes_set_key(&aesctx, key, 128);

        for (i = 0; i < 6; i++)
        {
                ipn_memcpy(BIN, A, 8);
                ipn_memcpy(&BIN[8], R[0], 8);
                aes_encrypt(&aesctx, BIN, BOUT );
                t=num_blocks*i +1;
                ipn_memcpy(A, &BOUT[0], 8);
                A[7] = BOUT[7] ^ t;
                ipn_memcpy(R[0], &BOUT[8], 8);

                for (j=2; j<=num_blocks ; j++)
                {
                        t=num_blocks*i+j;
                        ipn_memcpy(BIN, A, 8);
                        ipn_memcpy(&BIN[8], R[j-1], 8);
                aes_encrypt(&aesctx, BIN, BOUT );
                ipn_memcpy(A, &BOUT[0], 8);
                A[7] = BOUT[7] ^ t;
                        ipn_memcpy(R[j-1], &BOUT[8], 8);
                }
        }

        /* OUTPUT */
        ipn_memcpy(ctext, A, 8);
        for (j=1 ; j<= num_blocks; j++)
                ipn_memcpy(&ctext[j*8], R[j-1], 8);
}

void ProcEapolKey(i2220mgmt_t *priv_p, EAPoL_KEY_MSG_t *eapMsg_p, struct Author_state_machine *sm)
{
        UINT8  TSNonce, UpdatePtk, state;
        UINT16 S, M, A, T, N, K, R, E;
        UINT8  i;
        UINT8  *cp1,*cp2;
        UINT8  PSKValue[32],SNonce[32];

        R = ((eapMsg_p->data[eop_len+keyInfo1]) & BYTE_MASK_EAPOL_KI_REQUEST) >> 3;
        E = ((eapMsg_p->data[eop_len+keyInfo1]) & BYTE_MASK_EAPOL_KI_ERROR)   >> 2;
        S = ((eapMsg_p->data[eop_len+keyInfo1]) & BYTE_MASK_EAPOL_KI_SECURE)  >> 1;
        M = ((eapMsg_p->data[eop_len+keyInfo1]) & BYTE_MASK_EAPOL_KI_MIC)     >> 0;
        A = ((eapMsg_p->data[eop_len+keyInfo2]) & BYTE_MASK_EAPOL_KI_ACK)     >> 7;
        T = ((eapMsg_p->data[eop_len+keyInfo2]) & BYTE_MASK_EAPOL_KI_INSTALL) >> 6;
        N = ((eapMsg_p->data[eop_len+keyInfo2]) & BYTE_MASK_EAPOL_KI_INDEX)   >> 4;
        K = ((eapMsg_p->data[eop_len+keyInfo2]) & BYTE_MASK_EAPOL_KI_TYPE)    >> 3;

        KDBG_LOG_RX(KDBG_DEBUG,"Proc EAPOL frame: 0x%02x%02x S[%d] M[%d] A[%d] T[%d] N[%d] K[%d]\n",
                eapMsg_p->data[eop_len+keyInfo1],eapMsg_p->data[eop_len+keyInfo2],S,M,A,T,N,K);

        TSNonce = 0;
        UpdatePtk = 0;
        state = 0;

        if (!sm->sta_p->rsnBlockingTraffic && (R == 1 && E == 1)) {
                //printk("Rcv micError from STA, jiffies=0x%08lx\n", jiffies);
                kal_tkip_micFailure(priv_p->netdev, sm->sta_p->asoc.adAddr);
        }

        if (sm->Author_hs.state ==  PTK_sm_PTKSTART) {
                for (i=0;i<32;i++){
                        SNonce[i] = eapMsg_p->data[eop_len+keyNonce+i];
                }

        #if SUPPORT_MSSID
                ipn_memcpy(PSKValue, priv_p->ap.ssid_list[sm->sta_p->whichSsid].dot11RSNConfigPSKValue, 32);
        #else
                ipn_memcpy(PSKValue, mib_import(dot11RSNConfigTable).dot11RSNConfigPSKValue, 32);
        #endif
                CalcPTK(PSKValue
                        ,(PUCHAR)sm->ANonce
                        ,mib_import(dot11MACAddress)
                        ,SNonce
                        ,sm->sta_p->asoc.adAddr
                        ,64
                        ,(PUCHAR)sm->PTK);
        }
        if (M == 1) {
                if (!CheckMIC(eapMsg_p,(PUCHAR)sm->MIC)||(R==1)) {
                        KDBG_LOG_SYS(KDBG_DEBUG, "MICVerified fail\n");
                        sm->MICVerified = false;
                        state = false;
                } else {
                        KDBG_LOG_SYS(KDBG_DEBUG, "MICVerified true\n");
                        sm->MICVerified = true;
                        state = true;//MICOK;
                }
        }

        if (K == 1) { /* K = P (P = 1, G = 0) */
                if (sm->Author_hs.state ==  PTK_sm_PTKSTART) {
                        if (eapMsg_p->data[eop_len+keyMaterialLen2]!= sm->sta_p->wpaIE_p->length+2){
                                KDBG_LOG_SYS(KDBG_DEBUG,"RSN IE len error!! %d %d\n",
                                        eapMsg_p->data[eop_len+keyMaterialLen2],sm->sta_p->wpaIE_p->length+2);
                        } else {
                                eREQ_WPA_t       tmpWPAIE;
                                ipn_memcpy(&tmpWPAIE,&sm->sta_p->wpaIE_p->elemId,sizeof(eREQ_WPA_t));
                                tmpWPAIE.version = host2ieee16(tmpWPAIE.version);
                                tmpWPAIE.pairwiseKeyCipherSuiteCount= host2ieee16(tmpWPAIE.pairwiseKeyCipherSuiteCount);
                                tmpWPAIE.authKeyMgtSuiteCount = host2ieee16(tmpWPAIE.authKeyMgtSuiteCount);
                                cp1 = (UINT8*)&tmpWPAIE;
//                                cp1 = &sm->sta_p->wpaIE_p->elemId;
                                cp2 = &eapMsg_p->data[eop_len+keyData];
                                for (i=0;i<eapMsg_p->data[eop_len+keyMaterialLen2]-2;i++) { //skip the cap ???
                                        if (cp1[i] != cp2[i]) {
                                                KDBG_LOG_SYS(KDBG_DEBUG,"%02x %02x \n",cp1[i],cp2[i]);
                                                KDBG_LOG_SYS(KDBG_DEBUG,"RSN IE erroe!!\n");
                                                sm->IntegrityFailed = true;
                                                break;
                                        }
                                 }
                        }
                } else if (sm->Author_hs.state == PTK_sm_PTKINITNEGOTIATING) {
                        // Get RSC from supplicant
                        for (i=0;i<6;i++){
                                sm->PRSC[i] = eapMsg_p->data[eop_len+keyRSC+i];
                        }
//                        sm->sta_p->rsnBlockingTraffic = false;
                        cmd_macPort_ctl(sm->priv_p->netdev,sm->sta_p->asoc.adAddr, false);
                        KDBG_LOG_SYS(KDBG_DEBUG, "rsn_4way_success start!! \n");
                }

                if (state != false){
                        KDBG_LOG_SYS(KDBG_DEBUG, "EAPoLKeyReceived true\n");
                        //printk(KERN_ALERT "EAPoLKeyReceived true %d %d\n", sm->Author_hs.state,PTK_sm_PTKINITNEGOTIATING);
                        sm->EAPoLKeyReceived = true;
                        //KDBG_LOG_SYS(KDBG_DEBUG,"EAPoL MICVerified %d!!!\n",sm->MICVerified );
                }
        } else {
                KDBG_LOG_SYS(KDBG_DEBUG, "Group key frame!! \n");
                if ((state == true) && (S == 1)) {
                        for (i=0;i<6;i++){ // from 0~6 or 2 ~ 8
                            sm->GRSC[i] = eapMsg_p->data[eop_len+keyRSC+i];
                        }
                        sm->EAPoLKeyReceived = true;
                        sm->MICVerified = true;
                        sm->portSecure = true;
                        KDBG_LOG_SYS(KDBG_DEBUG,"Install Group Key !!!\n");
                        //802.1X::VirturalSecure = TRUE;
                }
        }


        // reset the timer
        sm->Timeout4UP = 0;

        if ((A == 1) && (state != false)) {
                UpdatePtk = 1;
        }
        if (sm->MICVerified) {
                if (sm->EAPoLKeyReceived == true)
                        sm->EAPoLOK = 1;
                sm->TimeoutCtr = 0;
                Author_sm_step(priv_p, sm);
        }

        return ;
}

void encEAPoLData(i2220mgmt_t *priv_p,sta_info_t* sta_p, UINT8 sequence, UINT8* wpa_cp, UINT8* rsn_cp,UINT8* cp)
{
        UINT8           i,offset=0,ie_off=0;
        UINT8           div=0;
        //UINT8           MicTemp[80];
        UINT8           GTKTemp[120];
        UINT8           GTKTemp2[120];
        UINT8           GTKTemp3[120];
        UINT8           Gkey[120];

        if (sta_p->rsnMode)  offset = 8;

        for (i=0;i<120;i++) {
                GTKTemp[i]=0x00;
                GTKTemp2[i]=0x00;
                GTKTemp3[i]=0x00;
                Gkey[i]=0x00;
        }

        if (sequence == 3) {
                if (wpa_cp) { /* WPA */
                        ipn_memcpy(&GTKTemp3[0],&wpa_cp[0],wpa_cp[1]+2);/* Key Data              */
                        ie_off = (wpa_cp[1]+2);
                }
                if (rsn_cp) { /* RSN */
                         ipn_memcpy(&GTKTemp3[ie_off],&rsn_cp[0],rsn_cp[1]+2);/* Key Data              */
                         ie_off += (rsn_cp[1]+2);
                }
        }

        GTKTemp3[ie_off+0] = 0xdd;
        //GTKTemp3[adv_off+1] = 6+32;
        GTKTemp3[ie_off+2] = 0x00;
        GTKTemp3[ie_off+3] = 0x0f;
        GTKTemp3[ie_off+4] = 0xac;
        GTKTemp3[ie_off+5] = 0x01;
        GTKTemp3[ie_off+6] = 0x04 | KeyIdx;
        GTKTemp3[ie_off+7] = 0x00;

        if (sta_p->keydescripter==1)
        {
                ipn_memcpy(&Gkey[16],sta_p->author_sm->EK,16);
                //rc4SwGenKeySeq(Gkey, 32, 256, 32, GTKTemp);
                rc4SwGenKeySeq(Gkey, 32, 256, 32+ie_off+offset, GTKTemp);
                GTKTemp3[ie_off+1] = 6+32;
                ipn_memcpy(&GTKTemp3[ie_off+offset],priv_p->GTK,32);
                //for (i=0;i< 32+ie_off+offset;i+=8)
                //printk("%02x %02x %02x %02x %02x %02x %02x %02x \n",
                //        GTKTemp3[0+i],GTKTemp3[1+i],GTKTemp3[2+i],GTKTemp3[3+i],
                //        GTKTemp3[4+i],GTKTemp3[5+i],GTKTemp3[6+i],GTKTemp3[7+i]);

                // Xor the GTKTemp
                for (i=0;i<32+ie_off+offset;i++)
                        GTKTemp2[i] = GTKTemp[i] ^ GTKTemp3[i];
                ipn_memcpy(cp,GTKTemp2, ie_off+offset+32);
         }
         else if (priv_p->BCcipherSuite == CIPHER_SUITE_TKIP) /* if (sta_p->keydescripter==2) */
         {
                GTKTemp3[ie_off+1] = 6+32;
                ipn_memcpy(&GTKTemp3[ie_off+offset],priv_p->GTK,32);
                if (ie_off%8) {
                        GTKTemp3[ie_off+offset+32] = 0xdd;
                        div = 1;
                }
                //for (i=0;i< 32+((ie_off/8+div)*8 )+offset;i+=8)
                //printk("%02x %02x %02x %02x %02x %02x %02x %02x \n",
                //        GTKTemp3[0+i],GTKTemp3[1+i],GTKTemp3[2+i],GTKTemp3[3+i],
                //        GTKTemp3[4+i],GTKTemp3[5+i],GTKTemp3[6+i],GTKTemp3[7+i]);
                aesKeyWrap((UCHAR *)sta_p->author_sm->EK, GTKTemp3, 32+((ie_off/8+div)*8)+offset, GTKTemp2);
                ipn_memcpy(cp,GTKTemp2,((ie_off/8+div)*8 )+offset+32+8);
         }
         else
         {
                GTKTemp3[ie_off+1] = 6+16;
                ipn_memcpy(&GTKTemp3[ie_off+offset],priv_p->GTK,16);
                if (ie_off%8) {
                        GTKTemp3[ie_off+offset+16] = 0xdd;
                        div = 1;
                }

                aesKeyWrap((UCHAR *)sta_p->author_sm->EK, GTKTemp3, 16+((ie_off/8+div)*8)+offset, GTKTemp2);
                ipn_memcpy(cp,GTKTemp2,((ie_off/8+div)*8 )+offset+16+8);
         }
}

/************************************************************************************************/
/*
        parameter set:

        1. Authenticator R Supplicant:  EAPoL-Key(0,0,1,0,0    ,P,0  ,ANonce,0  ,0)
        2. Supplicant R Authenticator:  EAPoL-Key(0,1,0,0,0    ,P,0  ,SNonce,MIC,RSN IE)
        3. Authenticator R Supplicant:  EAPoL-Key(0,1,1,1,0    ,P,RSC,ANonce,MIC,RSN IE)
        4. Supplicant R Authenticator:  EAPoL-Key(0,1,0,0,0    ,P,0  ,0     ,MIC,0)

        1. Authenticator R Supplicant:  EAPOL-Key(1,1,1,0,KeyId,G,RSC,GNonce,MIC,GTK)
        2. Supplicant R Authenticator:  EAPOL-Key(1,0,0,0,?     G,0  ,0     ,MIC,0)

        EAPoL-Key(S, M, A, T, N, K, KeyRSC, ANonce/SNonce, GNonce, MIC, GTK)

        P      S: Initial Key exchange is complete. This is the EAPoL-Key Information Secure bit.
        P      M: MIC is available in message. This should be set in all messages except the first 4-way handshake message. This is the EAPoL-Key Information Key MIC bit.
        P      A: Response is required to this message. Used when the receiver should respond to this message. This is the EAPoL-Key Information Key Ack bit.
        P      T: Tx/Rx for Group key and Install/Not install for Pairwise key. This is the EAPoL-Key Information Tx/Rx Flag bit.
        P      N: Key Index. Specifies which index should be used for this Group Key. Index 0 shall not be used for Group keys. This is the EAPoL-Key Information key index bits.
        P      K: Key type - P (Pairwise), G (Group). This is the EAPoL-Key Information Key Type bit.
        P      KeyRSC: Key RSC. This is the EAPoL-Key KeyRSC field.
        P      ANonce/SNonce/GNonce: Authenticator/Supplicant/Group Nonce. This is the EAPoL-Key Key Nonce field.
        P      MIC: Integrity check which is generated using the EAPoL-Key MIC Key. This is the EAPoL-Key MIC field.
        P      GTK: Group temporal key which is encrypted using the EAPoL-Key Encryption Key. This is the EAPoL-Key Data field.
*************************************************************************************************/
void SendEAPoL(i2220mgmt_t *priv_p, UINT8 *sta_addr,UINT8 sequence,
                    int S, int M, int A, int T, int N, int K,
                    UINT8 *KeyRSC, UINT8 *Nonce, UINT8 *Mic, UINT8 *GTK)
{
        //UINT16     keyLen=0;
        UINT8     MicTemp[80];
        //UINT8     GTKTemp[32];
        //UINT8     GTKTemp2[32];
        //UINT8     Gkey[32];
        //UINT8     *cp;
        UINT8     *wpa_cp;
        kal_skb_t *skb;
        UINT16    i,skb_len;
        Frame_t   *sdu;
        Frame1xKey_t *frame1xkey;
        sta_info_t *sta_p;
        UINT8      wpa_len;
        eWPA_t     w_wpaie;

        sta_p = task_sta_lookup(priv_p, (MacAddr_t)sta_addr);
        if (!sta_p)
                return ;

        ipn_memcpy(&w_wpaie, priv_p->addIE, sizeof(w_wpaie));
        wpa_cp = (UINT8*)&w_wpaie;
        wpa_len = (wpa_cp[1]==0) ? 0 : wpa_cp[1]+2;

        if (sequence==1){
                skb_len = eop_len + keyData; //sizeof(Frame1xKey_t)-38;
        } else if (sequence==3) {
                skb_len = eop_len + keyData;
                skb_len += wpa_len;
        } else {
                switch (sta_p->keydescripter) /* sta_p->cipherSuite) */
                {
                    case 1:
                        skb_len = eop_len + keyData +32;
                        break;
                    case 2:
                        if (priv_p->BCcipherSuite == CIPHER_SUITE_TKIP)
                                skb_len = eop_len + keyData +32+8;
                        else
                                skb_len = eop_len + keyData +16+8;
                        break;
                    default:    return ;
                }
        }

        if ((skb = kal_alloc_skb(skb_len)) == NULL) {
		printk("SendEAPoL alloc skb fail\n");
                return;
        }
        kal_skb_put(skb,skb_len);
        for (i=0;i<skb_len;i++)
                kal_skb_data(skb)[i]=0x00;

        frame1xkey = (Frame1xKey_t*)kal_skb_data(skb);

        ipn_memcpy( &frame1xkey->key.data[eophdr], rfc1042_header, sizeof (rfc1042_header));
        ipn_memcpy( &frame1xkey->key.data[eophdr+6], ETH_P_PAE, sizeof (ETH_P_PAE));
        frame1xkey->key.data[eopver]  = ETH_P_PAE_KEY[0];
        frame1xkey->key.data[eoptype] = ETH_P_PAE_KEY[1];

        frame1xkey->key.data[eop_len+keytype] = 0xfe;      /* Descriptor Type       */
                                                                    /* Key Information       */
        KDBG_LOG_SYS(KDBG_DEBUG,"SendEAPoL " MACSTR "[%d] len %d, S[%d]M[%d]A[%d]T[%d]N[%d]K[%d]\n",
                               MAC2STR(sta_addr),sequence,kal_skb_len(skb),S,M,A,T,N,K);

        frame1xkey->key.data[eop_len+keyInfo2] = sta_p->keydescripter;  //__cpu_to_be16,whsu say, use type 2 ???
        if (S)  set_Sbit(frame1xkey,1);
        if (M)  set_Mbit(frame1xkey,1);
        if (A)  set_Abit(frame1xkey,1);
        if (T)  set_Tbit(frame1xkey,1);
        if (N==1)  set_Nbit1(frame1xkey,1);
        if (N==2)  set_Nbit2(frame1xkey,1);
        if (N==3)  set_Nbit3(frame1xkey,1);
        if (K)  set_Kbit(frame1xkey,1);

        /*According to standard draft 7.0 table 5 Keylength depents on Cipher suite*/
        if ((sequence==1) || (sequence==3)) {
            switch (sta_p->cipherSuite)
            {
                case CIPHER_SUITE_WEP40 :
                        frame1xkey->key.data[eop_len+keyLen2] = 5;
                        break;
                case CIPHER_SUITE_TKIP :
                        frame1xkey->key.data[eop_len+keyLen2] = 32;
                        break;
                case CIPHER_SUITE_CCMP :
                        frame1xkey->key.data[eop_len+keyLen2] = 16;
                        break;
                case CIPHER_SUITE_WEP104 :
                        frame1xkey->key.data[eop_len+keyLen2] = 13;
                        break;
                case CIPHER_SUITE_WEP128 :
                        frame1xkey->key.data[eop_len+keyLen2] = 19;
                        break;
                    default:
                        break;
            }
        }
        else {
            switch (priv_p->BCcipherSuite)
            {
                case CIPHER_SUITE_WEP40 :
                        frame1xkey->key.data[eop_len+keyLen2] = 5;
                        break;
                case CIPHER_SUITE_TKIP :
                        frame1xkey->key.data[eop_len+keyLen2] = 32;
                        break;
                case CIPHER_SUITE_CCMP :
                        frame1xkey->key.data[eop_len+keyLen2] = 16;
                        break;
                case CIPHER_SUITE_WEP104 :
                        frame1xkey->key.data[eop_len+keyLen2] = 13;
                        break;
                case CIPHER_SUITE_WEP128 :
                        frame1xkey->key.data[eop_len+keyLen2] = 19;
                        break;
                default:
                        break;
            }
        }

        for (i=0;i<8;i++)
                frame1xkey->key.data[eop_len+replayCtr+i]=priv_p->Counter[7-i];     /* Replay Counter        */

        for (i=0;i<32;i++)                                                  /* Key Nonce             */
                frame1xkey->key.data[eop_len+keyNonce+i]=Nonce[i];

        ipn_memset(&frame1xkey->key.data[eop_len+keyIv],0,16);          /* EAPoL-Key IV          */
        //ipn_memset(MicTemp,0,16);

        if (sequence==1){
                //ipn_memset(&frame1xkey->key.data[eop_len+keyRSC],0,8);        /* Key RSC               */
                //ipn_memset(&frame1xkey->key.data[eop_len+keyIde],0,8);        /* Key ID                */
                //ipn_memset(&frame1xkey->key.data[eop_len+keyMic],0,16);       /* Key MIC               */
                frame1xkey->key.data[eop_len+keyMaterialLen1]=0;            /* Key Material Length   */
                //ipn_memset(&frame1xkey->key.data[eop_len+keyData],0,38);      /* Key Data              */
                frame1xkey->key.data[eoplen2] = keyData;
        } else if (sequence==3) { /* 4-way sequence ==3 */
                //ipn_memcpy(&frame1xkey->key.data[eop_len+keyRSC],KeyRSC,8);   /* Key RSC               */
                ipn_memset(&frame1xkey->key.data[eop_len+keyRSC],0,8);          /* Key ID                */
                //ipn_memset(&frame1xkey->key.data[eop_len+keyIde],0,8);        /* Key ID                */
                //ipn_memcpy(&frame1xkey->key.data[eop_len+keyMic],Mic,16);     /* Key MIC               */
                ipn_memset(&frame1xkey->key.data[eop_len+keyMic],0,16);
                frame1xkey->key.data[eoplen2] = keyData;
                #if SUPPORT_IPNRSN
                frame1xkey->key.data[eoplen2] += (wpa_cp[1]+2);
                frame1xkey->key.data[eop_len+keyMaterialLen2] = wpa_cp[1]+2;      /* Key Material Length   */
                ipn_memcpy(&frame1xkey->key.data[eop_len+keyData],&wpa_cp[0],wpa_cp[1]+2);/* Key Data              */
                #else
                if (!sta_p->rsnMode) {  /* RSN */
                        if (wpa_cp[0]) { /* WPA */
                                frame1xkey->key.data[eoplen2] += (wpa_cp[1]+2);
                                frame1xkey->key.data[eop_len+keyMaterialLen2] = wpa_cp[1]+2;      /* Key Material Length   */
                                ipn_memcpy(&frame1xkey->key.data[eop_len+keyData],&wpa_cp[0],wpa_cp[1]+2);/* Key Data              */
                        }
                }
                else if (sta_p->rsnMode) {  /* RSN */
                        if (wpa_cp[0]) { /* WPA */
                                frame1xkey->key.data[eoplen2] += (wpa_cp[1]+2);
                                frame1xkey->key.data[eop_len+keyMaterialLen2] = wpa_cp[1]+2;      /* Key Material Length   */
                                ipn_memcpy(&frame1xkey->key.data[eop_len+keyData],&wpa_cp[0],wpa_cp[1]+2);/* Key Data              */
                        }
                        if (rsn_cp[0]) { /* RSN */
                                frame1xkey->key.data[eoplen2] += (rsn_cp[1]+2);
                                frame1xkey->key.data[eop_len+keyMaterialLen2] += rsn_cp[1]+2;      /* Key Material Length   */
                                if (wpa_cp[0])
                                         ipn_memcpy(&frame1xkey->key.data[eop_len+keyData+wpa_cp[1]+2],&rsn_cp[0],rsn_cp[1]+2);/* Key Data              */
                                else
                                         ipn_memcpy(&frame1xkey->key.data[eop_len+keyData],&rsn_cp[0],rsn_cp[1]+2);/* Key Data              */
                        }
                        /* Add the encapsulate GTK when already negptiated */
                        #if 1
                        if (priv_p->NoGpkHs)
                                if (sta_p->keydescripter==1) {
                                        frame1xkey->key.data[eoplen2] += (32+8);
                                        frame1xkey->key.data[eop_len+keyMaterialLen2] += (32+8);
                                } else if (priv_p->BCcipherSuite == CIPHER_SUITE_TKIP) {
                                        frame1xkey->key.data[eoplen2] += (8+32+8);
                                        frame1xkey->key.data[eop_len+keyMaterialLen2] += (8+32+8);
                                } else {
                                        frame1xkey->key.data[eoplen2] += (8+16+8);
                                        frame1xkey->key.data[eop_len+keyMaterialLen2] += (8+16+8);
                                }
                        #endif
                }
                if ((priv_p->NoGpkHs) && (sta_p->rsnMode)){
                        set_Ebit(frame1xkey,1);
                        set_Sbit(frame1xkey,1);
                        if (sta_p->keydescripter==2) {
                                frame1xkey->key.data[eoplen2] += (8-((wpa_len+rsn_len)%8));
                                frame1xkey->key.data[eop_len+keyMaterialLen2] += (8-((wpa_len+rsn_len)%8));
                        }
                        encEAPoLData(priv_p, sta_p, sequence, wpa_cp, rsn_cp, &frame1xkey->key.data[eop_len+keyData]);
                }
                #endif
                MIC(sta_p->keydescripter,
                        &frame1xkey->key.data[eopver],
                        frame1xkey->key.data[eoplen2]+4,
                        (PUCHAR)sta_p->author_sm->MIC,MicTemp);
                ipn_memcpy(&frame1xkey->key.data[eop_len+keyMic],MicTemp,16);
                #if SUPPORT_IPNRSN
                frame1xkey->key.data[eop_len+keyData+24]=0x00;
                frame1xkey->key.data[eop_len+keyData+25]=0x00;
                #endif
        } else {/* G-key sequence == 5 */
                //ipn_memcpy(&frame1xkey->key.data[eop_len+keyRSC],KeyRSC,8);   /* Key RSC               */
                /* Set the Encrypt bit for WPA2 */
                ipn_memset(&frame1xkey->key.data[eop_len+keyRSC],0,8);          /* Key RSC               */
                //ipn_memset(&frame1xkey->key.data[eop_len+keyIde],0,8);        /* Key ID                */
                //ipn_memcpy(&frame1xkey->key.data[eop_len+keyMic],MIC,16);     /* Key MIC               */
                ipn_memset(&frame1xkey->key.data[eop_len+keyMic],0,16);
                if (sta_p->keydescripter == 1 ) { /* cipherSuite == CIPHER_SUITE_CCMP) */
                //if (priv_p->BCcipherSuite == CIPHER_SUITE_TKIP) {
                        frame1xkey->key.data[eop_len+keyMaterialLen2]=32;           /* Key Material Length   */
                        frame1xkey->key.data[eoplen2] = keyData +32;
                }
                #if 1
                else if (priv_p->BCcipherSuite == CIPHER_SUITE_TKIP) {
                        frame1xkey->key.data[eop_len+keyMaterialLen2]=32+8;         /* Key Material Length   */
                        frame1xkey->key.data[eoplen2] = keyData +32+8;
                }
                #endif
                else {
                        frame1xkey->key.data[eop_len+keyMaterialLen2]=16+8;         /* Key Material Length   */
                        frame1xkey->key.data[eoplen2] = keyData +16+8;
                }
                encEAPoLData(priv_p, sta_p, sequence, wpa_cp, NULL, &frame1xkey->key.data[eop_len+keyData]);
                MIC(sta_p->keydescripter,
                    &frame1xkey->key.data[eopver],
                    frame1xkey->key.data[eoplen2]+4,
                    (PUCHAR)sta_p->author_sm->MIC,
                    MicTemp);
                ipn_memcpy(&frame1xkey->key.data[eop_len+keyMic],MicTemp,16);
        }

        sdl_mkLlcFrame(sdu,sta_addr,mib_import(dot11MACAddress),NULL,skb);
        if (sdu == NULL) {
                kal_free_skb(skb);
                return;
        }
        sdl_setFrDs(sdu,1);

        sdu_send_request(priv_p, sdu, sta_p, SYN_contention);
}


/*************************************************************************************************/
/*                           11i-rsn Authenticator State Machine                                 */
/*************************************************************************************************/
/*                           state machine                                                       */
/*************************************************************************************************/

/* Port Timers state machine - implemented as a function that will be called
 * once a second as a registered event loop timeout */
void Author_key_timers_tick(i2220mgmt_t *priv_p, sta_info_t *sta_p)
{

        //KDBG_LOG_MLME(KDBG_DEBUG, "MAC addr" MACSTR" TICK "
        //                   "(%lu) \n", MAC2STR(sta_p->author_sm->staAddr),sta_p->author_sm->TimeoutInc);
        //sta_p->author_sm->TimeoutInc++;

        if (sta_p->author_sm->Author_hs.state==GTK_sm_REKEYESTABLISHED)
        {
                Author_sm_step(priv_p, sta_p->author_sm);
                //KDBG_LOG_MLME(KDBG_DEBUG, "Wait for Group Rekey timer\n");
                return;
        }

        if (sta_p->author_sm->Author_hs.state==PTK_sm_PTKSTART)
        {
                sta_p->author_sm->Timeout4UP++;
                if (sta_p->author_sm->Timeout4UP > priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPairwiseUpdateTimeout/100)
                {
                        //sta_p->author_sm->rsn_4way_success = FALSE;
                        //sta_p->KeyMapOn = false;
                        sta_p->author_sm->TimeoutEvt = true;
                        sta_p->author_sm->Timeout4UP = 0;
                }
        }
        else if (sta_p->author_sm->Author_hs.state==PTK_sm_PTKINITNEGOTIATING)
        {
                sta_p->author_sm->Timeout4UP++;
                if (sta_p->author_sm->Timeout4UP > priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPairwiseUpdateTimeout/100)
                {
                        //sta_p->author_sm->rsn_4way_success = FALSE;
                        sta_p->author_sm->TimeoutEvt = true;
                        sta_p->author_sm->Timeout4UP = 0;
                        #if 1 /* Use the new key after EAPoL fourth frame rcv timeout */
                        //if (sta_p->KeyMapOn)
                        {
                                struct cmd_key_s *key = NULL;
                                cmd_key_t       k;

                                key = &k;
                                key->cipherMode = sta_p->author_sm->sta_p->cipherSuite;
                                key->keyId = 0;
                                if (key->cipherMode == CIPHER_SUITE_TKIP)
                                        key->keyLen = 32;
                                else if (key->cipherMode == CIPHER_SUITE_CCMP)
                                        key->keyLen = 16;
                                else if (key->cipherMode == CIPHER_SUITE_WEP40)
                                        key->keyLen = 5;
                                else if (key->cipherMode == CIPHER_SUITE_WEP104)
                                        key->keyLen = 13;
                                ipn_memcpy(key->key, (UINT8 *)sta_p->author_sm->TK, key->keyLen);
                                cmd_set_macKey(priv_p->netdev, sta_p->author_sm->sta_p->asoc.adAddr, key);
                        }
                        #endif
                }
        }
        else if (sta_p->author_sm->Author_hs.state==GTK_sm_REKEYNEGOTIATING)
        {
                sta_p->author_sm->Timeout4UP++;
                if (sta_p->author_sm->Timeout4UP > priv_p->mib.dot11RSNConfigTable.dot11RSNConfigGroupUpdateTimeout/100)
                {
                        if (priv_p->mib.dot11RSNConfigTable.dot11RSNConfigGroupRekeyMethod==2)
                        {
                                sta_p->author_sm->GUpdateStationKeys = true;
                        }
                        sta_p->author_sm->TimeoutEvt = true;
                        sta_p->author_sm->Timeout4UP=0;
                }
         }
        Author_sm_step(priv_p, sta_p->author_sm);

}

//SM_STATE(PTK_sm, INITIALIZE)
static void sm_PTK_INITIALIZE_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        int i;

        SM_ENTRY(PTK_sm, INITIALIZE, Author_hs);

        if (sm->Init == false){
        } else {
               //for (i=0;i<32;i++) sm->PMK[i] = 0; // MSK ??? in standard

               sm->GInitAKeys =  sm->IntegrityFailed = false; // =sm->PInitAKeys
               //if (Unicast cipher supported by Authenticator)
               //sm->Pair = 1;
               //sm->portMode = false;
               for (i=0;i<64;i++) sm->PTK[i] = 0;

               sm->portSecure = 0;

               if (!priv_p->WPA_PSK) {
                #if SUPPORT_MSSID
                        ipn_memset(priv_p->ap.ssid_list[sm->sta_p->whichSsid].dot11RSNConfigPSKValue, 0, 32);
                #else
                        ipn_memset(mib_import(dot11RSNConfigTable).dot11RSNConfigPSKValue, 0, 32);
                #endif
               }

               sm->TimeoutCtr=0;
               //SM_STEP_RUN(PTK_sm);
               sm_Step(priv_p, sm);
        }

}

//SM_STATE(PTK_sm, DISCONNECT)
static void sm_PTK_DISCONNECT_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, DISCONNECT, Author_hs);
        //sm->Init = false;
        STADisconnect();
        //SM_STEP_RUN(PTK_sm);
}

//SM_STATE(PTK_sm, DISCONNECTED)
static void sm_PTK_DISCONNECTED_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, DISCONNECTED, Author_hs);
        sm->Disconnect=false;
        KDBG_LOG_SYS(KDBG_DEBUG, "rsn_4way_success stop\n");
        //sm->rsn_4way_success=false;
        sm->EAPoLOK=0;
        sm->sta_p->KeyMapOn = false;
        //SM_STEP_RUN(PTK_sm);
        sm_Step(priv_p, sm);
}

//SM_STATE(PTK_sm, AUTHENTICATION)
static void sm_PTK_AUTHENTICATION_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        int i;
        SM_ENTRY(PTK_sm, AUTHENTICATION, Author_hs);
        for (i=0;i<64;i++) sm->PTK[i]=0;
        //sm->portControl = Auto;
        //sm->portMode = false;
        sm->Init = false;
        //SM_STEP_RUN(PTK_sm);
        sm_Step(priv_p, sm);
}

//SM_STATE(PTK_sm, AUTHENTICATION2)
static void sm_PTK_AUTHENTICATION2_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, AUTHENTICATION2, Author_hs);
        if (!priv_p->WPA_PSK) {
                KDBG_LOG_SDL(KDBG_DEBUG, "auth success %d\n",sm->authSuccess);
        }
        if ((priv_p->WPA_PSK)&&(sm->sta_p->author_sm!=NULL)) {
                //SM_STEP_RUN(PTK_sm);
                sm_Step(priv_p, sm);
        } else if (sm->authSuccess) {
                //SM_STEP_RUN(PTK_sm);
                sm_Step(priv_p, sm);
        }
}

//SM_STATE(PTK_sm, INITPMK)
static void sm_PTK_INITPMK_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, INITPMK, Author_hs);
        sm->authSuccess=false;
        //SM_STEP_RUN(PTK_sm);
        sm_Step(priv_p, sm);
}

//SM_STATE(PTK_sm, INITPSK)
static void sm_PTK_INITPSK_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, INITPSK, Author_hs);
        //ipn_memcpy(mib_import(dot11RSNConfigTable).dot11RSNConfigPSKValue, sm->PSK,32);
        //SM_STEP_RUN(PTK_sm);
        sm_Step(priv_p, sm);
}

//SM_STATE(PTK_sm, PTKSTART)
static void sm_PTK_PTKSTART_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        UINT8 P=1;
        SM_ENTRY(PTK_sm, PTKSTART, Author_hs);

        Gen_Current(sm->ANonce);

        if (sm->sta_p->aid > 0){
                SendEAPoL(priv_p, (UINT8*)sm->sta_p->asoc.adAddr,1,0,0,1,0,0,P,'\0',(UINT8*)sm->ANonce,'\0','\0');
                sm->EAPoLKeyReceived = false;
                INC_64_BITS(priv_p->Counter);
                sm->TimeoutCtr++;
        }
}

//SM_STATE(PTK_sm, PTKINITNEGOTIATING)
static void sm_PTK_PTKINITNEGOTIATING_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        UINT8 P = 1;

        SM_ENTRY(PTK_sm, PTKINITNEGOTIATING, Author_hs);
        SendEAPoL(priv_p, (UINT8*)sm->sta_p->asoc.adAddr,3,0,1,1,1,0,P,'\0',(UINT8 *)sm->ANonce,(UINT8 *)sm->MIC,'\0');
        sm->EAPoLKeyReceived = false;
        INC_64_BITS(priv_p->Counter);
        sm->TimeoutCtr++;
}

//SM_STATE(PTK_sm, PTKINITDONE)
static void sm_PTK_PTKINITDONE_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        struct cmd_key_s *key = NULL;
        cmd_key_t       k;

        SM_ENTRY(PTK_sm, PTKINITDONE, Author_hs);

        //  TimeoutCtr???
        sm->IntegrityFailed = !sm->MICVerified;
        //if (sm->Pair==1)
        key = &k;
        key->cipherMode = sm->sta_p->cipherSuite;
        key->keyId = 0;
        if (key->cipherMode == CIPHER_SUITE_TKIP)
                key->keyLen = 32;
        else if (key->cipherMode == CIPHER_SUITE_CCMP)
                key->keyLen = 16;
        else if (key->cipherMode == CIPHER_SUITE_WEP40)
                key->keyLen = 5;
        else if (key->cipherMode == CIPHER_SUITE_WEP104)
                key->keyLen = 13;

        ipn_memcpy(key->key, (UINT8 *)sm->TK, key->keyLen);

        cmd_set_macKey(priv_p->netdev, sm->sta_p->asoc.adAddr, key);

        //sm->rsn_4way_success = true;
        sm->GInitAKeys = true;//= sm->PInitAKeys
        sm->EAPoLKeyReceived = false;
        sm->EAPoLOK=0;
        sm->GUpdateStationKeys = true;// for into GTK_sm_REKEYNEGOTIATING
}

//SM_STATE(PTK_sm, UPDATEKEYS)
static void sm_PTK_UPDATEKEYS_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, UPDATEKEYS, Author_hs);
        //CheckMIC(sm->PTK);
        //MicOK = CheckMIC(EAPoL_KEY_MSG_t eapMsg_p);
        sm->IntegrityFailed = !sm->MICVerified;
}

//SM_STATE(PTK_sm, INTEGRITYFAILURE)
static void sm_PTK_INTEGRITYFAILURE_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(PTK_sm, INTEGRITYFAILURE, Author_hs);
        sm->IntegrityFailed = false;
        //if (Group key fail)
        sm->GTKRekey = true;
        //Waitupto60();
}

#if 0
SM_STATE(PTK_sm, KEYUPDATE)
{
        SM_ENTRY(PTK_sm, KEYUPDATE, Author_hs);
        INC_64_BITS(priv_p->Counter);
        //sm->ANonce[0] = priv_p->Counter[0];
        //INC_64_BITS(priv_p->Counter);
        //sm->SNonce[0] = priv_p->Counter[0];
}
#endif

//////////////////////////////////////////////////////////////////////////////////////////
/*                                                                                      */
//////////////////////////////////////////////////////////////////////////////////////////
//SM_STATE(GTK_sm, REKEYNEGOTIATING)
static void sm_GTK_REKEYNEGOTIATING_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        UINT G=0;
//        UINT8 i;

        SM_ENTRY(GTK_sm, REKEYNEGOTIATING, Author_hs);

        //sm->PInitAKeys = false;
        sm->GUpdateStationKeys = false;
#if 0
        for ( i = 0; i < priv_p->mib.dot11WEPKeyMappingLength; i++ )
               ipn_memset(priv_p->mib.dot11RSNStatsTable[i].dot11RSNStatsKeyRSC ,0,6);
#endif
        // Group Key update
        // Gen_Current(sm->GMK);
        // IEEE8021x_event(NULL,GROUP_REKEY_TIME);
        SendEAPoL(priv_p, (UINT8*)sm->sta_p->asoc.adAddr,5,1,1,1,0,KeyIdx,G,'\0',(UINT8 *)priv_p->GNonce,(UINT8 *)sm->MIC,(UINT8 *)priv_p->GTK);
        INC_64_BITS(priv_p->Counter);
        sm->TimeoutCtr++;
        sm->EAPoLKeyReceived = false;
}


//SM_STATE(GTK_sm, KEYERROR)
static void sm_GTK_KEYERROR_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(GTK_sm, KEYERROR, Author_hs);
        sm->GKeyDoneStations--;
        sm->TimeoutCtr=0;
}

//SM_STATE(GTK_sm, REKEYESTABLISHED)
static void sm_GTK_REKEYESTABLISHED_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        UINT i,keylen=0;
        struct cmd_key_s *key = NULL;
        cmd_key_t       k;

        SM_ENTRY(GTK_sm, REKEYESTABLISHED, Author_hs);

        key = &k;
        //CheckMIC(sm->PTK);
        //MicOK = CheckMIC(EAPoL_KEY_MSG_t eapMsg_p);

        for (i=0;i<32;i+=16)
                KDBG_LOG_TX(KDBG_DEBUG,"Set GTK %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n",
                    (UINT8)priv_p->GTK[i],(UINT8)priv_p->GTK[i+1],(UINT8)priv_p->GTK[i+2],(UINT8)priv_p->GTK[i+3],
                    (UINT8)priv_p->GTK[i+4],(UINT8)priv_p->GTK[i+5],(UINT8)priv_p->GTK[i+6],(UINT8)priv_p->GTK[i+7],
                    (UINT8)priv_p->GTK[i+8],(UINT8)priv_p->GTK[i+9],(UINT8)priv_p->GTK[i+10],(UINT8)priv_p->GTK[i+11],
                    (UINT8)priv_p->GTK[i+12],(UINT8)priv_p->GTK[i+13],(UINT8)priv_p->GTK[i+14],(UINT8)priv_p->GTK[i+15]);

        if ((sm->MICVerified)&&(sm->portSecure)) {
                sm->MICVerified = false;
                sm->EAPoLKeyReceived = true;
                sm->GKeyDoneStations--;
                priv_p->GNoStations--;
                // do a record for the sta
        }
        if (sm->portSecure) {
                switch (priv_p->BCcipherSuite) { //get_wpa_oui_type(priv_p->mib.dot11RSNConfigTable.dot11RSNConfigMulticastCipher.u.suiteSelector)) {
                    case CIPHER_SUITE_WEP40 :
                        keylen = 5;
                        key->cipherMode = CIPHER_SUITE_WEP40;
                        break;
                    case CIPHER_SUITE_TKIP :
                        keylen = 32;
                        key->cipherMode = CIPHER_SUITE_TKIP;
                        break;
                    case CIPHER_SUITE_CCMP :
                        keylen = 16;
                        key->cipherMode = CIPHER_SUITE_CCMP;
                        break;
                    case CIPHER_SUITE_WEP104 :
                        keylen = 13;
                        key->cipherMode = CIPHER_SUITE_WEP104;
                        break;
                    case CIPHER_SUITE_WEP128 :
                        keylen = 19;
                        key->cipherMode = CIPHER_SUITE_WEP128;
                        break;
                    default:
                        break;
                }

                ipn_memcpy(key->key,(UINT8 *)priv_p->GTK,keylen);
                key->keyId = KeyIdx;
                key->keyLen = keylen;
                cmd_set_macKey(priv_p->netdev, bcstAddr, key);

                if (priv_p->GNoStations==0)
                        KDBG_LOG_SYS(KDBG_DEBUG,"Group key update all sta!!\n");
                sm->TimeoutCtr = 0;
                sm->portSecure = 1;
        }
}

//SM_STATE(GTKUP_sm, SETKEYS)
static void sm_GTKUP_SETKEYS_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{

        SM_ENTRY(GTKUP_sm, SETKEYS, Author_hs);
        sm->GTKRekey = false;
        //if (sm->GInitDone == false) {
        //        sm->GN = 0;
        //        sm->GM = 1;
        //} else {
        //        sm->GN=1;
        //        sm->GM=0;
        //        //Swap(GM,GN);
        //}
        sm->GInitDone = true;
        sm->GKeyDoneStations = priv_p->GNoStations;
        INC_64_BITS(priv_p->Counter);

        //CalcGTK(sm->GMK,sm->GNonce,mib_import(dot11MACAddress),32,sm->GTK);
        sm->GUpdateStationKeys = true;
}

//SM_STATE(GTKUP_sm, SETKEYSDONE)
static void sm_GTKUP_SETKEYSDONE_Enter(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        SM_ENTRY(GTKUP_sm, SETKEYSDONE, Author_hs);
        //SetGTK(GN,Tx/Rx,GTK[GN])
        sm->GKeyReady = true;
}


//SM_STEP(PTK)
static void sm_Step(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        if (sm->Disconnect)
                //SM_ENTER(PTK, DISCONNECTED);
                sm_PTK_DISCONNECTED_Enter(priv_p, sm);
        else if ((sm->Init)&&(sm->Author_hs.state!=PTK_sm_INITIALIZE))
                //SM_ENTER(PTK, INITIALIZE);
                sm_PTK_INITIALIZE_Enter(priv_p, sm);
        //else if (sm->DeauthenticationRequest){
        //        //SM_ENTER(PTK, DISCONNECTED);
        //        sm_PTK_DISCONNECTED_Enter(priv_p, sm);
        //}
        //else if (sm->ReAuthenticationRequest) {
        //        //SM_ENTER(PTK, AUTHENTICATION2);
        //        sm_PTK_AUTHENTICATION2_Enter(priv_p, sm);
        //}
#if 0 /* SUPPORT_WPA2 */
        else if (sm->Disconnect) {
                //SM_ENTER(PTK, DISCONNECT);
                sm_PTK_DISCONNECT_Enter(priv_p, sm);
        }
#endif
        // Group Key handshack
        else if (sm->GUpdateStationKeys||(sm->GKeyReady && sm->GInitAKeys)){
                //SM_ENTER(GTK, REKEYNEGOTIATING);
                sm_GTK_REKEYNEGOTIATING_Enter(priv_p, sm);
        }
        // Group Key Update
        else if (sm->GTKAuthenticator && ((sm->GTKRekey)||(sm->GInitAKeys&&!sm->GInitDone)))
                //SM_ENTER(GTKUP, SETKEYS);
                sm_GTKUP_SETKEYS_Enter(priv_p, sm);
        else if ((sm->GKeyDoneStations==0)&&(sm->Author_hs.state == GTKUP_sm_SETKEYS ))
                //SM_ENTER(GTKUP, SETKEYSDONE);
                sm_GTKUP_SETKEYSDONE_Enter(priv_p, sm);
        else switch (sm->Author_hs.state) {
                case PTK_sm_DISCONNECT:
                        //SM_ENTER(PTK, DISCONNECTED);
                        sm_PTK_DISCONNECTED_Enter(priv_p, sm);
                break;
                case PTK_sm_DISCONNECTED:
                        //SM_ENTER(PTK, INITIALIZE);
                        sm_PTK_INITIALIZE_Enter(priv_p, sm);
                break;
                case PTK_sm_INITIALIZE:
                         if (sm->Init)//(sm->AuthenticationRequest){
                                //SM_ENTER(PTK, AUTHENTICATION);
                                sm_PTK_AUTHENTICATION_Enter(priv_p, sm);
#if 0 /* SUPPORT_WPA2 */
                         else
                                //SM_ENTER(PTK, INITIALIZE);
                                sm_PTK_INITIALIZE_Enter(priv_p, sm);
#endif
                break;
                case PTK_sm_AUTHENTICATION:
                        //SM_ENTER(PTK, AUTHENTICATION2);
                        sm_PTK_AUTHENTICATION2_Enter(priv_p, sm);
                break;
                case PTK_sm_AUTHENTICATION2:
                         if (priv_p->WPA_PSK){
                                if (sm->sta_p->author_sm !=NULL)
                                        //SM_ENTER(PTK, INITPSK);
                                        sm_PTK_INITPSK_Enter(priv_p, sm);
                                else {
                                        //printk(KERN_ALERT "enter none author_sm stage \n");
                                        //SM_ENTER(PTK, AUTHENTICATION2);
                                        sm_PTK_AUTHENTICATION2_Enter(priv_p, sm);
                                     }
                                 }
                         else {
                                if (sm->authSuccess)
                                        //SM_ENTER(PTK, INITPMK);
                                        sm_PTK_INITPMK_Enter(priv_p, sm);
#if 0 /* SUPPORT_WPA2 */
                                else {
                                        printk(KERN_ALERT "enter sm_PTK_AUTHENTICATION2_Enter stage \n");
                                        //SM_ENTER(PTK, AUTHENTICATION2);
                                        sm_PTK_AUTHENTICATION2_Enter(priv_p, sm);
                                }
#endif
                         }
                break;
                case PTK_sm_INITPMK:
                    #if 0
                                //SM_ENTER(PTK, DISCONNECT);
                                sm_PTK_DISCONNECT_Enter(priv_p, sm);
                    #endif
                                //SM_ENTER(PTK, PTKSTART);
                                sm_PTK_PTKSTART_Enter(priv_p, sm);
                break;
                case PTK_sm_INITPSK:
                        //SM_ENTER(PTK, PTKSTART);
                        sm_PTK_PTKSTART_Enter(priv_p, sm);
                break;
                case PTK_sm_PTKSTART:
                         if (sm->EAPoLOK) {
                                sm->EAPoLOK=0;
                                //SM_ENTER(PTK_sm, PTKINITNEGOTIATING);
                                sm_PTK_PTKINITNEGOTIATING_Enter(priv_p, sm);
                         } else
                         if ((sm->EAPoLKeyReceived)&&(sm->MICVerified)) {//(K=Pairwise)&&
                                //SM_ENTER(PTK, PTKINITNEGOTIATING);
                                sm_PTK_PTKINITNEGOTIATING_Enter(priv_p, sm);
                         } else if (sm->TimeoutCtr == priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPairwiseUpdateCount){
                                //sdlf_send_deauth(priv_p, sm->sta_p->asoc.adAddr, SYN_pairwise_hs_timeout);
                                cmd_deauth_sta_with_reason(priv_p->netdev,sm->sta_p->asoc.adAddr, SYN_pairwise_hs_timeout);
                                //SM_ENTER(PTK, DISCONNECT);
                                sm_PTK_DISCONNECT_Enter(priv_p, sm);
                         } else if (sm->TimeoutEvt){
                                sm->TimeoutEvt = false;
                                //SM_ENTER(PTK, PTKSTART);
                                sm_PTK_PTKSTART_Enter(priv_p, sm);
                         }
                break;
                case PTK_sm_PTKINITNEGOTIATING:
                         if (sm->EAPoLOK) {
                                //SM_ENTER(PTK_sm, PTKINITDONE);
                                //SM_ENTER(PTK, PTKINITDONE);
                                sm_PTK_PTKINITDONE_Enter(priv_p, sm);
                         } else
                         if ((sm->EAPoLKeyReceived)&&(sm->MICVerified)){//(K=Pairwise)&&
                                //SM_ENTER(PTK, PTKINITDONE);
                                sm_PTK_PTKINITDONE_Enter(priv_p, sm);
                         } else if (sm->TimeoutCtr == priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPairwiseUpdateCount){
                                 //sdlf_send_deauth(priv_p, sm->sta_p->asoc.adAddr, SYN_group_update_timeout);
                                 cmd_deauth_sta_with_reason(priv_p->netdev,sm->sta_p->asoc.adAddr, SYN_group_update_timeout);
                                 //SM_ENTER(PTK, DISCONNECT);
                                 sm_PTK_DISCONNECT_Enter(priv_p, sm);
                         } else if (sm->TimeoutEvt){
                                //printk(KERN_ALERT "EAPoLKeyReceived %d MICVerified %d\n",
                                //        sm->EAPoLKeyReceived, sm->MICVerified);

                                sm->TimeoutEvt = false;
                                //SM_ENTER(PTK, PTKINITNEGOTIATING);
                                sm_PTK_PTKINITNEGOTIATING_Enter(priv_p, sm);
                        } else {
                                //printk(KERN_ALERT "EAPoLKeyReceived %d MICVerified %d\n",
                                //        sm->EAPoLKeyReceived, sm->MICVerified);
                         }
                break;
                case PTK_sm_PTKINITDONE:
                        if ((sm->EAPoLKeyReceived)&&(sm->MICVerified))//&&(sm->Request)
                                //SM_ENTER(PTK, UPDATEKEYS);
                                sm_PTK_UPDATEKEYS_Enter(priv_p, sm);
                        else if (!sm->IntegrityFailed)
                                //SM_ENTER(PTK, INTEGRITYFAILURE);
                                sm_PTK_INTEGRITYFAILURE_Enter(priv_p, sm);
                break;
                case PTK_sm_UPDATEKEYS:
                         if (sm->IntegrityFailed)//(Error == true)
                                //SM_ENTER(PTK, INTEGRITYFAILURE);
                                sm_PTK_INTEGRITYFAILURE_Enter(priv_p, sm);
                         else
                                //SM_ENTER(PTK, PTKSTART);
                                sm_PTK_PTKSTART_Enter(priv_p, sm);
                break;
                case PTK_sm_INTEGRITYFAILURE:
                break;
                case PTK_sm_KEYUPDATE:
                        //SM_ENTER(PTK, PTKSTART);
                        sm_PTK_PTKSTART_Enter(priv_p, sm);
                break;
                // Group Key handshake
                case GTK_sm_REKEYNEGOTIATING:
                         if (sm->EAPoLOK){
                                sm->EAPoLOK=0;
                                //SM_ENTER(GTK_sm, REKEYESTABLISHED);
                                sm_GTK_REKEYESTABLISHED_Enter(priv_p, sm);
                         } else
                         if ((sm->EAPoLKeyReceived)&&(sm->MICVerified)){//(K==Group)&&
                                //SM_ENTER(GTK, REKEYESTABLISHED);
                                sm_GTK_REKEYESTABLISHED_Enter(priv_p, sm);
                         } else if (sm->TimeoutCtr==priv_p->mib.dot11RSNConfigTable.dot11RSNConfigGroupUpdateCount) {
                                //sdlf_send_deauth(priv_p, sm->sta_p->asoc.adAddr, SYN_pairwise_hs_timeout);
                                cmd_deauth_sta_with_reason(priv_p->netdev,sm->sta_p->asoc.adAddr, SYN_group_update_timeout);
                                //SM_ENTER(GTK, KEYERROR);
                                sm_GTK_KEYERROR_Enter(priv_p, sm);
                         }
                         else if (sm->TimeoutEvt){
                                //printk(KERN_ALERT "EAPoLKeyReceived %d MICVerified %d\n",
                                //        sm->EAPoLKeyReceived, sm->MICVerified);
                                //SM_ENTER(GTK, REKEYNEGOTIATING);
                                sm_GTK_REKEYNEGOTIATING_Enter(priv_p, sm);
                                sm->TimeoutEvt=false;
                         }
                break;
                case GTK_sm_KEYERROR:
                         /* send deauth frame to sta */
                         //sdlf_send_deauth(priv_p, sm->sta_p->asoc.adAddr, SYN_group_update_timeout);
                        //SM_ENTER(PTK, DISCONNECT);
                        sm_PTK_DISCONNECT_Enter(priv_p, sm);
                break;
                case GTK_sm_REKEYESTABLISHED:
                         //if (priv_p->WPA_PSK)
                        //        SM_ENTER(PTK, INITPSK);
                        //        sm_PTK_INITPSK_Enter(priv_p, sm);
                         //else {
                        #if 0
                                if (sm->authSuccess){
                                         //sm->rsn_4way_success = false;
                                        //SM_ENTER(PTK, INITPMK);
                                        sm_PTK_INITPMK_Enter(priv_p, sm);
                                }
                        #else
                                sm->authSuccess=false;
                                //SM_STEP_RUN(PTK_sm);
                                //sm_Step(priv_p, sm);
                        #endif
                        //        else if (!sm->MICVerified) {
                        //                printk(KERN_ALERT "mic failure \n");
                        //                sm_GTK_REKEYNEGOTIATING_Enter(priv_p, sm);
                        //        }

                         //     else
                        //              SM_ENTER(PTK, AUTHENTICATION2);
                        //              sm_PTK_AUTHENTICATION2_Enter(priv_p, sm);
                         //     }
                break;
                // Group Key Update
                case GTKUP_sm_SETKEYS:
                break;
                case GTKUP_sm_SETKEYSDONE:
                break;
        }

}


void Author_sm_step(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        int prev_Author_hs;

        /* FIX: could re-run Author_sm_step from registered timeout (after
         * 0 sec) to make sure that other possible timeouts/events are
         * processed */
        do {
                prev_Author_hs = sm->Author_hs.state;
                //SM_STEP_RUN(PTK_sm);
                sm_Step(priv_p, sm);
        } while (prev_Author_hs != sm->Author_hs.state );

}

void randomGK(i2220mgmt_t * priv_p)
{
        UINT32  rn;
        int i;

        for (i = 0; i < 8; i++) {
                NIC_MCR_READ(priv_p, MCR_DRNGR, &rn);
                priv_p->GMK[4*i] = (UINT32)rn;
        }
        CalcGTK((PUCHAR)priv_p->GMK,(PUCHAR)priv_p->GNonce,mib_import(dot11MACAddress),32,(PUCHAR)priv_p->GTK);
}

void InitializeWPA_PSK (i2220mgmt_t * priv_p, int ssid_id)
{
        int i;
        UINT8  key[40];

        //Initialize the group key
        randomGK(priv_p);
        if (priv_p->WPA_PSK) {
                // The PTK should be do once when in PTKSTART sm
                for (i=0;i<40;i++)
                        key[i]=0x00;

#if SUPPORT_MSSID
                        passwordHash(priv_p->ap.ssid_list[ssid_id].dot11RSNConfigPSKPassPhrase,
                                priv_p->ap.ssid_list[ssid_id].ssid,
                                priv_p->ap.ssid_list[ssid_id].ssid_len,
                                key);
                        //whsu say: Notice! the key be be 40bytes length, otherwise ......
                        ipn_memcpy(priv_p->ap.ssid_list[ssid_id].dot11RSNConfigPSKValue,key,32);
#else
                        passwordHash((PCHAR)priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPSKPassPhrase,
                                priv_p->mib.dot11DesiredSSID.ssid,
                                priv_p->mib.dot11DesiredSSID.ssidLen,
                                key);
                        //whsu say: Notice! the key be be 40bytes length, otherwise ......
                        ipn_memcpy(priv_p->mib.dot11RSNConfigTable.dot11RSNConfigPSKValue,key,32);
#endif
        }

}

void Author_sm_initialize(i2220mgmt_t *priv_p, struct Author_state_machine *sm)
{
        /* Initialize the state machines by asserting initialize and then
         * deasserting it after one step */
        sm->Init = FALSE;
        Author_sm_step(priv_p,sm);
        sm->Disconnect=FALSE;
        /* Start one second tick for port timers state machine */
}

struct Author_state_machine* Author_sm_alloc(i2220mgmt_t *priv_p, sta_info_t *sta_p)
{
        struct Author_state_machine *sm;
        KDBG_LOG_SYS(KDBG_DEBUG,"start allocation\n");
        sm = sta_p->author_sm;
        ipn_memset(sm, 0, sizeof(*sm));
        sm->sta_p = sta_p;
        //ipn_memcpy(sm->staAddr,sta_p->asoc.adAddr, MAC_ADDR_LEN);

        sm->MIC = &sm->PTK[0];
        sm->EK  = &sm->PTK[16];
        sm->TK  = &sm->PTK[32];

        /* Set default values for state machine constants */
        sm->Author_hs.state = PTK_sm_INITIALIZE;

        if (priv_p->WPA_PSK)
                sm->authSuccess = 0;

        //sm->portEnable = true;
        //sm->portControl = Auto;
        //sm->GN = 0;
        //sm->GM = 1;
        KDBG_LOG_SYS(KDBG_DEBUG,MACSTR" sta initialize done!\n",MAC2STR(sm->sta_p->asoc.adAddr));
        sm->priv_p = priv_p;
        Author_sm_initialize(priv_p, sm);
        return sm;
}

