/*
** $Id: equates.h 1.23 2004/10/04 18:10:54 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2002-2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

#ifndef _EQUATES_H
#define _EQUATES_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define IPN2220_A0              0x22200000
#define IPN5320_A0              0x53200000

#define VENUS_VERSION_MASK              0x0000000F
#define VENUS_PHY_MODE_MASK             0x000000F0
#define VENUS_HW_MODE_MASK              0x00000F00

#define VENUS_VERSION_A0                0x00000000

#define VENUS_PHY_11B                   0x00000010
#define VENUS_PHY_11G                   0x00000020
#define VENUS_PHY_11A                   0x00000040
#define VENUS_PHY_11AG                  0x00000060

#define VENUS_HW_FPGA                   0x00000100

#define VENUS_G_FPGA_A0                 (VENUS_PHY_11G | VENUS_HW_FPGA)
#define VENUS_AG_FPGA_A0                (VENUS_PHY_11AG | VENUS_HW_FPGA)
#define VENUS_G_CHIP_A0                 VENUS_PHY_11G
#define VENUS_AG_CHIP_A0                VENUS_PHY_11AG

#define NIC_TYPE_PCI                    0x10
#define NIC_TYPE_MINI_PCI               0x11
#define NIC_TYPE_CARDBUS                0x12

#define NIC_RF_MAXIM_2825_2827          0
#define NIC_RF_RFMD_2959                1
#define NIC_RF_MAXIM_2829               2
#define NIC_RF_THETA_5024               3
#define NIC_RF_AIROHA_2230              5
#define NIC_RF_UBEC_2451                6

#define MAC_ADDR_LEN                    6

#define DEFAULT_MAC_ADDR                {0x00, 0x08, 0x22, 0xFE, 0x00, 0x01}
#define NULL_MAC_ADDR                   {0x00, 0x00, 0x00, 0x00, 0x00, 0x00}
#define BROADCAST_MAC_ADDR              {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF}

#define ETHERNET_HEADER_SIZE            14
#define ETHERNET_MIN_PACKET_SIZE        60
#define ETHERNET_MAX_PACKET_SIZE        1514

#define WLAN_MAC_HEADER_SIZE            24
#define WLAN_MAC_HEADER_A4_SIZE         30
#define WLAN_MAC_HEADER_QOS_SIZE        26
#define WLAN_MAC_HEADER_A4_QOS_SIZE     32
#define WLAN_MIN_PACKET_SIZE            16
#define WLAN_MAX_PACKET_SIZE            4096

#define WLAN_MAC_FCS_LEN                4
#define WLAN_MAC_IV_LEN                 4
#define WLAN_MAC_ICV_LEN                4
#define WLAN_MAC_EXT_IV_LEN             4
#define WLAN_MAC_MIC_LEN                8
#define WLAN_MAC_REPLAY_CTR_LEN         4
#define WLAN_MAC_CKIP_MIC_LEN           4
#define WLAN_MAC_CKIP_SEQ_LEN           4

#define CCM_IB_FLAGS                    0x59
#define CCM_CTR_FLAGS                   0x01

#define WLAN_PACKET_BUFFER_SIZE         (((WLAN_MAX_PACKET_SIZE + 15) >> 4) << 4)

#define TX_BUFFER_SIZE                  WLAN_PACKET_BUFFER_SIZE

#define RX_BUFFER_SIZE                  WLAN_PACKET_BUFFER_SIZE

#define MAX_NUM_SUPPORTED_DATA_RATES    16


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*                    D A T A   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/


#endif  /* _EQUATES_H */

