/*
** $Id: nic.h 1.19 2004/10/04 18:05:43 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2002-2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

#ifndef _NIC_H
#define _NIC_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define MAX_NUM_2G_RF_CHANNELS          14
#define MAX_NUM_5G_RF_CHANNELS          34

#if SUPPORT_802_11A
#define MAX_NUM_OPERATING_CHANNELS      (MAX_NUM_2G_RF_CHANNELS + MAX_NUM_5G_RF_CHANNELS)
#else
#define MAX_NUM_OPERATING_CHANNELS      MAX_NUM_2G_RF_CHANNELS
#endif


#if SUPPORT_ED_ADJUST
#define NOISE_STATE_LOW                         0
#define NOISE_STATE_HIGH                        1
#define NOISE_STATE_HIGH_START			        2
#define NOISE_STATE_HIGH_SEARCH			        3
#define NOISE_STATE_HIGH_TUNE			        4


#define ED_TARGET_NOT_FOUND			            (-100)
#define ED_TARGET_OFFSET_MAX		            (3)

#define OSD_SQ_FA_THRESHOLD                     20
#define OFDM_DETECTION_FA_THRESHOLD             20
#define CCK_DETECTION_FA_THRESHOLD              60
#define ED_FA_THRESHOLD                         600
#define MAC_SUCCESS_THRESHOLD                   20
#define ED_THRESHOLD_MIN                        140
#if SUPPORT_ED_ADJUST_BOUND_BY_RSSI
#define ED_THRESHOLD_MAX                        8192
#else
// Sam #define ED_THRESHOLD_MAX                        3000
#define ED_THRESHOLD_MAX                        1900
#endif

#define ED_THRESHOLD_START                      350
#define ED_FA_COMPARE_THRESHOLD                 20

#if SUPPORT_ED_ADJUST_BOUND_BY_RSSI
#define ED_NOISE_FLOOR_BASELINE                 1000
#define ED_RSSI_MARGIN_DB                       10
#define ED_RSSI_VALID_LOWER_LIMIT               -100

#define ED_RSSI_THRESHOLD_FLOAT_TO_FIX          -75
#define ED_RSSI_THRESHOLD_FIX_TO_FLOAT          -78

#if SUPPORT_ED_ADJUST_FAST_FIND
#define ED_FAST_FIND_RSSI_MARGIN_DB             15
#define ED_FAST_FIND_THRESHOLD_RATIO            3
#define ED_FAST_FIND_ED_THRESHOLD_MAX           4096

#endif

#endif

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
#define ED_FLOAT_ED_LEVELS                      3
#endif

// Sam add for inprocomm suggestion
#else  // SUPPORT_ED_ADJUST
	#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
	#define ED_FLOAT_ED_LEVELS                      3
	#endif
#endif  // End SUPPORT_ED_ADJUST


#define RF_CAL_ADDR_PORT                BBCR_CR121
#define RF_CAL_DATA_PORT                BBCR_CR122
#define RF_CAL_TX_TABLE_START_ADDR      1
#define RF_CAL_RX_TABLE_START_ADDR      8
#define RF_CAL_TX_CR_NO                 7
#define RF_CAL_RX_CR_NO                 16



#define NIC_LED_OUTPUT_GPIO             0
#define NIC_LED_OUTPUT_TX               1
#define NIC_LED_OUTPUT_RX               2
#define NIC_LED_OUTPUT_TX_RX            3

#define NIC_LED_NO_TRIGGER_OFF          0
#define NIC_LED_NO_TRIGGER_ON           1

#define NIC_ANT_MODE_FIXED_0            0
#define NIC_ANT_MODE_FIXED_1            1
#define NIC_ANT_MODE_DIVERSITY          2


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/
typedef struct _NIC_MCR_CONFIG_ENTRY {
	UINT        offset;
	UINT_32     value;
} NIC_MCR_CONFIG_ENTRY, *PNIC_MCR_CONFIG_ENTRY;

typedef struct _NIC_BBCR_CONFIG_ENTRY {
    PINT_8      name_p;
    UINT_8      offset;
    UINT_8      value;
} NIC_BBCR_CONFIG_ENTRY, *PNIC_BBCR_CONFIG_ENTRY;

typedef struct _NIC_RF_CHANNEL_PROG_ENTRY {
    UINT_8      channelNum;
    UINT        numSynthProgWords;
    UINT_32     synthProgWords[3];
} NIC_RF_CHANNEL_PROG_ENTRY, *PNIC_RF_CHANNEL_PROG_ENTRY;

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
typedef struct _ED_FLOATED_MARGIN_STRUC {
    UINT_8      AGCEDMargin;
    UINT_8      CCKMargin;
    UINT_8      OFDMMargin;
} ED_FLOATED_MARGIN_STRUC, *PED_FLOATED_MARGIN_STRUC;
#endif

typedef VOID (*NIC_RF_INIT_HANDLER)(IN PMP_ADAPTER);
typedef VOID (*NIC_RF_ACTIVE_HANDLER)(IN PMP_ADAPTER);
typedef VOID (*NIC_RF_SLEEP_HANDLER)(IN PMP_ADAPTER);
typedef VOID (*NIC_RF_SWITCH_CHANNEL_HANDLER)(IN PMP_ADAPTER,
                                              IN PNIC_RF_CHANNEL_PROG_ENTRY);
typedef BOOLEAN (*NIC_ED_GET_MARGINS_HANDLER)(IN PMP_ADAPTER,
                                              IN UINT,
                                              OUT PUINT_8,
                                              OUT PUINT_8,
                                              OUT PUINT_8);

typedef struct _NIC_RF_SPECIFIC_CONFIG {
    UINT_32                     rfCtrlMode;

    PINT_8                      rfName_p;

    PNIC_MCR_CONFIG_ENTRY       pauInitTable24_p;
    UINT                        pauInitTableLen24;
#if SUPPORT_802_11A
    PNIC_MCR_CONFIG_ENTRY       pauInitTable5_p;
    UINT                        pauInitTableLen5;
#endif

    UINT_32                     pauTntdrValue;
    UINT_32                     pauStdrValue;

    PNIC_BBCR_CONFIG_ENTRY      phyBBInitCommonTable_p;
    UINT                        phyBBInitCommonTableLen;
    PNIC_BBCR_CONFIG_ENTRY      phyBBInitTable24_p;
    UINT                        phyBBInitTableLen24;
#if SUPPORT_802_11A
    PNIC_BBCR_CONFIG_ENTRY      phyBBInitTable5_p;
    UINT                        phyBBInitTableLen5;
#endif

    PUINT_32                    phyRFInitTable24_p;
    UINT                        phyRFInitTableLen24;
#if SUPPORT_802_11A
    PUINT_32                    phyRFInitTable5_p;
    UINT                        phyRFInitTableLen5;
#endif
    UINT                        phyRFInitWaitDelay;

    NIC_RF_INIT_HANDLER         phyRFInitHandler;
    NIC_RF_ACTIVE_HANDLER       phyRFEnterActiveHandler;
    NIC_RF_SLEEP_HANDLER        phyRFEnterSleepHandler;
    NIC_RF_SWITCH_CHANNEL_HANDLER phyRFSwitchChannelHandler;
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    NIC_ED_GET_MARGINS_HANDLER  edGetMarginsHandler;
#endif

    PNIC_RF_CHANNEL_PROG_ENTRY  phyRFChannelTable24_p;
    UINT                        phyRFChannelTableLen24;
#if SUPPORT_802_11A
    PNIC_RF_CHANNEL_PROG_ENTRY  phyRFChannelTable5_p;
    UINT                        phyRFChannelTableLen5;
#endif

    INT_32                      rssiAtNoiseFloorBaseline24;
#if SUPPORT_802_11A
    INT_32                      rssiAtNoiseFloorBaseline5;
#endif

    UINT_8                      txPowerGainCCK;
    UINT_8                      txPowerGainOFDM24;
#if SUPPORT_802_11A
    UINT_8                      txPowerGainOFDM5;
#endif

    INT_32                      txPowerGainStepNum;
    INT_32                      txPowerGainStepDenom;

    INT_32                      rssiCoeffA2_24;
    INT_32                      rssiCoeffA1_24;
    INT_32                      rssiCoeffA0_24;
    INT_32                      rssiCoeffCLNA0_24;
    INT_32                      rssiCoeffCLNA1_24;
#if SUPPORT_802_11A
    INT_32                      rssiCoeffA2_5;
    INT_32                      rssiCoeffA1_5;
    INT_32                      rssiCoeffA0_5;
    INT_32                      rssiCoeffCLNA0_5;
    INT_32                      rssiCoeffCLNA1_5;
#endif

    UINT_16                     nicPMWakeupTime;

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    BOOLEAN                     txDACon;
#endif
} NIC_RF_SPECIFIC_CONFIG, *PNIC_RF_SPECIFIC_CONFIG;


typedef struct _TX_POWER_GAIN {
    UINT_8              gainMax;
    BOOLEAN             tpcEnabled;
    UINT_8              maxTxPower_dBm;
    UINT_8              gain0dBm;
    UINT_8              gain5dBm;
    UINT_8              gain10dBm;
} TX_POWER_GAIN, *PTX_POWER_GAIN;

typedef struct _NIC_PER_CHANNEL_CONFIG {
    //BOOLEAN             tpcEnabled;
    TX_POWER_GAIN       txPowerGainCCK;
    TX_POWER_GAIN       txPowerGainOFDM;

    BOOLEAN             txCalEnabled;
    UINT_8              txCalSet[RF_CAL_TX_CR_NO];

    BOOLEAN             rxCalEnabled;
    UINT_8              rxCalSet[RF_CAL_RX_CR_NO];
} NIC_PER_CHANNEL_CONFIG, *PNIC_PER_CHANNEL_CONFIG;


#if SUPPORT_ED_ADJUST
typedef enum _ED_ADJUST_MODE {
    ED_NORMAL,
    ED_FLOAT,
    ED_NOT_ADJUST
} ED_ADJUST_MODE, *PED_ADJUST_MODE;
#endif


/************************************************************************
*                             M A C R O S
*************************************************************************
*/
#define NIC_MCR_WRITE_SAFE(_pAdapter, _register, _value, _succeeded) \
        { \
            UINT count; \
            UINT maxLoopCount = 2; \
            UINT_32 tmp32; \
            _succeeded = FALSE; \
            NIC_MCR_WRITE(_pAdapter, _register, _value); \
            for (count = 0; count < maxLoopCount; count++) { \
                NIC_MCR_READ(_pAdapter, _register, &tmp32); \
                if (tmp32 == _value) { \
                    _succeeded = TRUE; \
                    break; \
                } \
                NIC_MCR_READ(_pAdapter, _register, &tmp32); \
                if (tmp32 == _value) { \
                    _succeeded = TRUE; \
                    break; \
                } \
            } \
        }

#define NIC_MCR_READ_AND_WAIT(_pAdapter, _register, _pReadValue, _waitCondition, _waitDelay, _waitCount, _status) \
        { \
            UINT count; \
            _status = FALSE; \
            for (count = 0; count < _waitCount; count++) { \
                NIC_MCR_READ(_pAdapter, _register, _pReadValue); \
                if (_waitCondition) { \
                    _status = TRUE; \
                    break; \
                } \
                NdisStallExecution(_waitDelay); \
            } \
        }

#define NIC_MCR_WRITE_AND_WAIT(_pAdapter, _register, _writeValue, _busyMask, _waitDelay, _waitCount, _status) \
        { \
            UINT_32 tmp32; \
            UINT count = _waitCount; \
            _status = FALSE; \
            NIC_MCR_WRITE(_pAdapter, _register, _writeValue); \
            do { \
                NdisStallExecution(_waitDelay); \
                NIC_MCR_READ(_pAdapter, _register, &tmp32); \
                if (!(tmp32 & _busyMask)) { \
                    _status = TRUE; \
                    break; \
                } \
                count--; \
            } while (count); \
        }


#define NIC_BBCR_READ(_pAdapter, _register, _pValue) \
        BCIRead8(_pAdapter, _register, _pValue, FALSE, 0)

#define NIC_BBCR_WRITE(_pAdapter, _register, _value, _reqCHK, _chkMask) \
        BCIWrite8(_pAdapter, _register, _value, _reqCHK, _chkMask)


#define NIC_MASK_INTERRUPT(_pAdapter, _intBits) \
        { \
            UINT_32 tmpUlong; \
            (_pAdapter)->interruptEnable &= ~(_intBits); \
            (_pAdapter)->interruptEnable &= ~IER_GLOBAL_ENABLE; \
            NIC_MCR_READ(_pAdapter, MCR_IER, &tmpUlong); \
            tmpUlong &= IER_GLOBAL_ENABLE; \
            tmpUlong |= (_pAdapter)->interruptEnable; \
            NIC_MCR_WRITE(_pAdapter, MCR_IER, tmpUlong); \
        }

#define NIC_UNMASK_INTERRUPT(_pAdapter, _intBits) \
        { \
            ULONG tmpUlong; \
            (_pAdapter)->interruptEnable |= _intBits; \
            (_pAdapter)->interruptEnable &= ~IER_GLOBAL_ENABLE; \
            NIC_MCR_READ(_pAdapter, MCR_IER, &tmpUlong); \
            tmpUlong &= IER_GLOBAL_ENABLE; \
            tmpUlong |= (_pAdapter)->interruptEnable; \
            NIC_MCR_WRITE(_pAdapter, MCR_IER, tmpUlong); \
        }

#define NIC_MASK_TXQ_INTERRUPT(_pAdapter, _intBits) \
        { \
            (_pAdapter)->qInterruptEnable &= ~(_intBits); \
            NIC_MCR_WRITE(_pAdapter, MCR_TXQIER, (_pAdapter)->qInterruptEnable); \
        }

#define NIC_UNMASK_TXQ_INTERRUPT(_pAdapter, _intBits) \
        { \
            (_pAdapter)->qInterruptEnable |= _intBits; \
            NIC_MCR_WRITE(_pAdapter, MCR_TXQIER, (_pAdapter)->qInterruptEnable); \
        }


#define NIC_DISABLE_CLOCK_GATE(_adapter_p) \
        NIC_MCR_WRITE(_adapter_p, MCR_SCR, SCR_CLK_ALL_EN | SCR_GPIO_PD_N)

#define NIC_ENABLE_CLOCK_GATE(_adapter_p) \
        NIC_MCR_WRITE(_adapter_p, MCR_SCR, 0x00)


#if DBG
#define NIC_LAUNCH_DBG_SIG(_adapter_p, _offset) \
        NIC_MCR_WRITE(_adapter_p, _offset, 0x55)
#else
#define NIC_LAUNCH_DBG_SIG(_adapter_p, _offset)
#endif

#define IPN2220_RXQ_RESUME(_adapter_p) \
        NIC_MCR_WRITE(_adapter_p, MCR_QRCR, QRCR_RXQ_RESUME)


/************************************************************************
*                    D A T A   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/


#endif /* _NIC_H */

