/*
** $Id: rf_ah.c 1.9 2004/09/14 16:22:35 patlu Exp $
*/

/*************************************************************************
* Copyright (c) 2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

/************************************************************************
*                E X T E R N A L   R E F E R E N C E S
*************************************************************************
*/
#include "precomp.h"


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define PAU_TNTDR_AIROHA_LONG_SLOT              0x01fc0072
#define PAU_TNTDR_AIROHA_SHORT_SLOT             0x01200072

#define PAU_STDR_AIROHA_LONG_SLOT               0x01900198
#define PAU_STDR_AIROHA_SHORT_SLOT              0x00b400bc

#define RF_INIT_WAIT_DELAY_AIROHA               0

#define RSSI_AT_NOISE_FLOOR_BASELINE_AIROHA_24  -74

#define TX_POWER_GAIN_AIROHA_CCK                0x2C
#define TX_POWER_GAIN_AIROHA_OFDM_24            0x32

#define TX_POWER_GAIN_STEP_AIROHA_NUM           1
#define TX_POWER_GAIN_STEP_AIROHA_DENOM         2

#define RSSI_COEFF_A_2_AIROHA_24                -71
#define RSSI_COEFF_A_1_AIROHA_24                -18481
#define RSSI_COEFF_A_0_AIROHA_24                -298941
#define RSSI_COEFF_C_LNA_0_AIROHA_24            220000
#define RSSI_COEFF_C_LNA_1_AIROHA_24            0

#define NIC_PM_WAKE_UP_TIME_AIROHA              500


/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                        P U B L I C   D A T A
*************************************************************************
*/
const NIC_MCR_CONFIG_ENTRY pauInitTableForAiroha2230_24[] = {
    {MCR_PCICR,     0x00000180},
    {MCR_PSCR,      0x39421222},
    {MCR_PPORCR0,   0x0000002c},
    {MCR_PPORCR1,   0x00560056},
    {MCR_PPDRCR0,   0x0024000a},
    {MCR_PPDRCR1,   0x00140014},
    {MCR_PPDRCR2,   0x00000050},
    {MCR_MPDR,      0x0006641e},
    {MCR_TNTDR,     PAU_TNTDR_AIROHA_LONG_SLOT},
    {MCR_STDR,      PAU_STDR_AIROHA_LONG_SLOT},
    {MCR_BGCR0,     (TX_POWER_GAIN_AIROHA_CCK << 8)},
    {MCR_RFTPCR,    (TX_POWER_GAIN_AIROHA_CCK | (TX_POWER_GAIN_AIROHA_OFDM_24 << 8))}
};

const NIC_BBCR_CONFIG_ENTRY phyBBInitTableForAiroha2230[] = {
    {"CR1 ",  1,  0x00},
    {"CR81", 81,  0x10},
    {"CR82", 82,  0x80},
    {"CR83", 83,  0xff},
    {"CR68", 68,  0x50},
    {"CR69", 69,  0x28},
    {"CR45", 45,  0x7d},
    {"CR46", 46,  0x4f},
    {"CR45", 45,  0x5a},
    {"CR46", 46,  0x40},
    {"CR45", 45,  0x54},
    {"CR46", 46,  0x1d},
    {"CR45", 45,  0x55},
    {"CR46", 46,  0x1e},
    {"CR45", 45,  0x52},
    {"CR46", 46,  0x1e},
    {"CR45", 45,  0x56},
#if BB_FPGA_VERSION_TABLE
    {"CR46", 46,  0xa1},
#else
    {"CR46", 46,  0x88},
#endif
    {"CR45", 45,  0x57},
    {"CR46", 46,  0x50},
    {"CR45", 45,  0x00},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x01},
    {"CR46", 46,  0xa2},
    {"CR45", 45,  0x02},
    {"CR46", 46,  0x30},
    {"CR45", 45,  0x03},
    {"CR46", 46,  0x32},
    {"CR45", 45,  0x04},
    {"CR46", 46,  0x32},

    {"CR49", 49,  0x04},
    {"CR50", 50,  0x84},
#if BB_FPGA_VERSION_TABLE
    {"CR77", 77,  0xe4},
#else
    {"CR77", 77,  0x4c},
#endif
    {"CR45", 45,  0x4b},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x78},
    {"CR46", 46,  0x16},
    {"CR45", 45,  0x79},
    {"CR46", 46,  0x12},
    {"CR45", 45,  0x4c},
    {"CR46", 46,  0xd0},
    {"CR45", 45,  0x4d},
    {"CR46", 46,  0x04},
    {"CR45", 45,  0x5d},
    {"CR46", 46,  0x83},
    {"CR45", 45,  0x5e},
    {"CR46", 46,  0x57},
    {"CR45", 45,  0x5f},
    {"CR46", 46,  0x39},
    {"CR45", 45,  0x60},
    {"CR46", 46,  0x26},
    {"CR45", 45,  0x61},
    {"CR46", 46,  0x19},
    {"CR45", 45,  0x62},
    {"CR46", 46,  0x10},
    {"CR45", 45,  0x63},
    {"CR46", 46,  0x0a},
#if BB_FPGA_VERSION_TABLE
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x49},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0x66},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0xe1},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0xa7},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x2f},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xbf},
#else
    {"CR45", 45,  0x64},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x65},
    {"CR46", 46,  0xb3},
    {"CR45", 45,  0x66},
    {"CR46", 46,  0x50},
    {"CR45", 45,  0x67},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x68},
    {"CR46", 46,  0x97},
    {"CR45", 45,  0x69},
    {"CR46", 46,  0xe6},
#endif
    {"CR45", 45,  0x6a},
    {"CR46", 46,  0xc0},
    {"CR45", 45,  0x6b},
    {"CR46", 46,  0x51},
    {"CR45", 45,  0x6c},
    {"CR46", 46,  0x33},
    {"CR45", 45,  0x6d},
    {"CR46", 46,  0x20},
    {"CR45", 45,  0x6e},
    {"CR46", 46,  0x14},
    {"CR45", 45,  0x6f},
    {"CR46", 46,  0x0c},
    {"CR45", 45,  0x70},
    {"CR46", 46,  0x08},
    {"CR45", 45,  0x71},
    {"CR46", 46,  0x00},
    {"CR45", 45,  0x72},
    {"CR46", 46,  0x82},
    {"CR45", 45,  0x73},
    {"CR46", 46,  0xce},
    {"CR45", 45,  0x74},
    {"CR46", 46,  0x45},
    {"CR45", 45,  0x75},
    {"CR46", 46,  0x67},
    {"CR45", 45,  0x76},
    {"CR46", 46,  0x23}
};

const UINT_32 phyRFInitTableForAiroha24[] = {
    0x8001B802,
    0x8000FFF3,
    0x800001B4,
    0x80044DC5,
    0x800805B6,
    0x800147C7,
    0x80000688,
    0x800403B9,
    0x8000DBBA,
    0x8000099B,
    0x800BDFFC,
    0x8000003D,
    0x8000580F
};

const NIC_RF_CHANNEL_PROG_ENTRY phyRFChnlTableForAiroha2230_24[] = {
    { 1,    3,  { 0x8001F790, 0x80033331, 0x8000003D } },
    { 2,    3,  { 0x8001F790, 0x800B3331, 0x8000003D } },
    { 3,    3,  { 0x8001E790, 0x80033331, 0x8000003D } },
    { 4,    3,  { 0x8001E790, 0x800B3331, 0x8000003D } },
    { 5,    3,  { 0x8001F7A0, 0x80033331, 0x8000003D } },
    { 6,    3,  { 0x8001F7A0, 0x800B3331, 0x8000003D } },
    { 7,    3,  { 0x8001E7A0, 0x80033331, 0x8000003D } },
    { 8,    3,  { 0x8001E7A0, 0x800B3331, 0x8000003D } },
    { 9,    3,  { 0x8001F7B0, 0x80033331, 0x8000003D } },
    { 10,   3,  { 0x8001F7B0, 0x800B3331, 0x8000003D } },
    { 11,   3,  { 0x8001E7B0, 0x80033331, 0x8000003D } },
    { 12,   3,  { 0x8001E7B0, 0x800B3331, 0x8000003D } },
    { 13,   3,  { 0x8001F7C0, 0x80033331, 0x8000003D } },
    { 14,   3,  { 0x8001E7C0, 0x80066661, 0x8000003D } }
};

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
const ED_FLOATED_MARGIN_STRUC edFloatedMarginsForAirohaCh7[ED_FLOAT_ED_LEVELS] = {
        {0x10, 0x16, 0x14},
        {0x18, 0x1a, 0x1a},
        {0x1f, 0x1f, 0x1f}
};

const ED_FLOATED_MARGIN_STRUC edFloatedMarginsForAirohaChNone7[ED_FLOAT_ED_LEVELS] = {
        {0x10, 0x16, 0x12},
        {0x18, 0x1a, 0x1a},
        {0x1f, 0x1f, 0x1f}
};
#endif

static
VOID
phyRFInitForAiroha(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterActiveForAiroha(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFEnterSleepForAiroha(IN PMP_ADAPTER adapter_p);

static
VOID
phyRFSwitchChannelForAiroha(IN PMP_ADAPTER adapter_p,
                            IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p);

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
static
BOOLEAN
edGetFloatedMarginsForAiroha(IN PMP_ADAPTER adapter_p,
                             IN UINT floatLevel,
                             OUT PUINT_8 marginAGCED_p,
                             OUT PUINT_8 marginCCK_p,
                             OUT PUINT_8 marginOFDM_p);
#endif


NIC_RF_SPECIFIC_CONFIG rfConfigAiroha2230 = {
    NIC_RF_AIROHA_2230,
    "Airoha AL2230",

    (PNIC_MCR_CONFIG_ENTRY) pauInitTableForAiroha2230_24,
    sizeof(pauInitTableForAiroha2230_24) / sizeof(NIC_MCR_CONFIG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    PAU_TNTDR_AIROHA_LONG_SLOT,
    PAU_STDR_AIROHA_LONG_SLOT,

    (PNIC_BBCR_CONFIG_ENTRY) phyBBInitTableForAiroha2230,
    sizeof(phyBBInitTableForAiroha2230) / sizeof(NIC_BBCR_CONFIG_ENTRY),
    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    NULL,
    0,
#if SUPPORT_802_11A
    NULL,
    0,
#endif
    RF_INIT_WAIT_DELAY_AIROHA,

    phyRFInitForAiroha,
    phyRFEnterActiveForAiroha,
    phyRFEnterSleepForAiroha,
    phyRFSwitchChannelForAiroha,
#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
    edGetFloatedMarginsForAiroha,
#endif

    (PNIC_RF_CHANNEL_PROG_ENTRY) phyRFChnlTableForAiroha2230_24,
    sizeof(phyRFChnlTableForAiroha2230_24) / sizeof(NIC_RF_CHANNEL_PROG_ENTRY),
#if SUPPORT_802_11A
    NULL,
    0,
#endif

    RSSI_AT_NOISE_FLOOR_BASELINE_AIROHA_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_AIROHA_CCK,
    TX_POWER_GAIN_AIROHA_OFDM_24,
#if SUPPORT_802_11A
    0,
#endif

    TX_POWER_GAIN_STEP_AIROHA_NUM,
    TX_POWER_GAIN_STEP_AIROHA_DENOM,

    RSSI_COEFF_A_2_AIROHA_24,
    RSSI_COEFF_A_1_AIROHA_24,
    RSSI_COEFF_A_0_AIROHA_24,
    RSSI_COEFF_C_LNA_0_AIROHA_24,
    RSSI_COEFF_C_LNA_1_AIROHA_24,
#if SUPPORT_802_11A
    0,
    0,
    0,
    0,
    0,
#endif

    NIC_PM_WAKE_UP_TIME_AIROHA,

#if WORKAROUND_TXDAC_POWER_CONSUMPTION
    FALSE
#endif
};


/************************************************************************
*                       P R I V A T E   D A T A
*************************************************************************
*/
DEBUGFILE("rf_ah.c");


/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*              F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                          F U N C T I O N S
*************************************************************************
*/

/*_________________________________________________________________________
**  phyAirohaCal
**
**  descriptions: This routine is called to do power on calibration for
**                  Airoha AL2230 RF chip.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
VOID
phyAirohaCal(IN PMP_ADAPTER adapter_p)
{
    UINT i;
    UINT_8 oldCR82;
    UINT_32 temp32;
    BOOLEAN status;

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);

    for (i = 0; i < 3; i++) {
        NdisStallExecution(50);
    }

    BCIRead8(adapter_p, BBCR_CR82, &oldCR82, TRUE, 0xff);
    BCIWrite8(adapter_p, BBCR_CR82, 0x8c, TRUE, 0xff);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x8000D80F,
        PSPR_SYNTH_PROG_START, 2, 5, status);
    NdisStallExecution(30);

    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x8000780F,
        PSPR_SYNTH_PROG_START, 2, 5, status);
    NdisStallExecution(30);


    NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, 0x8000580F,
        PSPR_SYNTH_PROG_START, 2, 5, status);

    if (!BCIWrite8(adapter_p, BBCR_CR82, oldCR82, TRUE, 0xff)) {
        ERRORLOG(("Can not return to normal operation after calibration\n"));
        ASSERT(0);
    }
}   /* phyAirohaCal */

/*_________________________________________________________________________
**  phyRFInitForAiroha
**
**  descriptions: This routine is called to initialize Airoha RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFInitForAiroha(IN PMP_ADAPTER adapter_p)
{
    UINT_32 temp32;

    DEBUGFUNC("phyRFInitForAiroha");

    INITLOG(("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &temp32);
    temp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, temp32);

    phyWriteRFInitTable(adapter_p, (PUINT_32) phyRFInitTableForAiroha24,
        sizeof(phyRFInitTableForAiroha24) / sizeof(UINT_32),
        RF_INIT_WAIT_DELAY_AIROHA);

    phyAirohaCal(adapter_p);
}   /* phyRFInitForAiroha */

/*_________________________________________________________________________
**  phyRFEnterActiveForAiroha
**
**  descriptions: This routine is called to let Airoha RF chipset enter RF
**                active state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterActiveForAiroha(IN PMP_ADAPTER adapter_p)
{
    UINT_32 tmp32;

    DEBUGFUNC("phyRFEnterActiveForAiroha");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &tmp32);
    tmp32 |= PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, tmp32);
}   /* phyRFEnterActiveForAiroha */

/*_________________________________________________________________________
**  phyRFEnterSleepForAiroha
**
**  descriptions: This routine is called to let Airoha RF chipset enter RF
**                sleep state.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:       (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFEnterSleepForAiroha(IN PMP_ADAPTER adapter_p)
{
    UINT_32 tmp32;

    DEBUGFUNC("phyRFEnterSleepForAiroha");

    DBGLOG(HW, TRACE, ("\n"));

    NIC_MCR_READ(adapter_p, MCR_PPMCR, &tmp32);
    tmp32 &= ~PPMCR_GPIO_RF_SHDN;
    NIC_MCR_WRITE(adapter_p, MCR_PPMCR, tmp32);
}   /* phyRFEnterSleepForAiroha */

/*_________________________________________________________________________
**  phyRFSwitchChannelForAiroha
**
**  descriptions: This routine is called to switch channel for Airoha RF
**                chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**  return:         (none)
**  note:
**__________________________________________________________________________*/
static
VOID
phyRFSwitchChannelForAiroha(IN PMP_ADAPTER adapter_p,
                            IN PNIC_RF_CHANNEL_PROG_ENTRY entry_p)
{
    UINT i;
    BOOLEAN status;

    DEBUGFUNC("phyRFSwitchChannelForAiroha");

    DBGLOG(HW, TRACE, ("\n"));

    for (i = 0; i < entry_p->numSynthProgWords; i++) {
        NIC_MCR_WRITE_AND_WAIT(adapter_p, MCR_PSPR, entry_p->synthProgWords[i],
            PSPR_SYNTH_PROG_START, 2, 5, status);

        ASSERT(status);
    }

    if (entry_p->channelNum == 7) {
        phyBBWriteAGCTable(adapter_p, 0x79, 0x14);
    } else {
        phyBBWriteAGCTable(adapter_p, 0x79, 0x12);
    }
}   /* phyRFSwitchChannelForAiroha */

#if SUPPORT_ED_ADJUST_MULTI_LEVEL_FLOAT_STATE
/*_________________________________________________________________________
**  edGetFloatedMarginsForAiroha
**
**  descriptions: This routine is called to get a set of floated ED margins
**                for Airoha RF chipset.
**  parameters:
**      adapter_p - Pointer to the Adapter structure
**      floatLevel - The current ED float level
**  results:
**      marginAGCED_p - Pointer to the AGC ED margin
**      marginCCK_p - Pointer to the CCK margin
**      marginOFDM_p - Pointer to the OFDM margin
**  return:
**      FALSE
**  note:
**__________________________________________________________________________*/
static
BOOLEAN
edGetFloatedMarginsForAiroha(IN PMP_ADAPTER adapter_p,
                             IN UINT floatLevel,
                             OUT PUINT_8 marginAGCED_p,
                             OUT PUINT_8 marginCCK_p,
                             OUT PUINT_8 marginOFDM_p)
{
    PED_FLOATED_MARGIN_STRUC entry_p;

    DEBUGFUNC("edGetFloatedMarginsForAiroha");

    DBGLOG(HW, INFO, ("\n"));

    if (MP_TEST_FLAG(adapter_p, MP_ADAPTER_FLAG_LINK_DETECTION |
                                 MP_ADAPTER_FLAG_ON_LINE_SITE_SURVEY |
                                 MP_ADAPTER_FLAG_DEDICATED_MEASUREMENT)) {
        return FALSE;
    } else {
        if (adapter_p->mib.dot11CurrentChannel  == 7) {
             entry_p =
                 (PED_FLOATED_MARGIN_STRUC) &edFloatedMarginsForAirohaCh7[floatLevel];
        } else {
            entry_p =
                 (PED_FLOATED_MARGIN_STRUC) &edFloatedMarginsForAirohaChNone7[floatLevel];
        }
    }

    *marginAGCED_p = entry_p->AGCEDMargin;
    *marginCCK_p = entry_p->CCKMargin;
    *marginOFDM_p = entry_p->OFDMMargin;

    return TRUE;
}   /* edGetFloatedMarginsForAiroha */
#endif

