/*
** $Id: sharedpr.h 1.26 2004/10/04 18:11:39 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2002-2004 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

#ifndef _SHAREDPR_H
#define _SHAREDPR_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/


/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/

/************************************************************************
*                             M A C R O S
*************************************************************************
*/

/************************************************************************
*                    D A T A   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/
/***** Routines in bci.c *****/
BOOLEAN
BCIWrite8(IN PMP_ADAPTER adapter_p,
          IN UINT_8 bciIndex,
          IN UINT_8 bciData,
          IN BOOLEAN requireCHK,
          IN UINT_8 chkMask);

BOOLEAN
BCIRead8(IN PMP_ADAPTER adapter_p,
         IN UINT_8 bciIndex,
         OUT PUINT_8 bciData_p,
         IN BOOLEAN requireCHK,
         IN UINT_8 chkMask);

BOOLEAN
bciRead16(IN PMP_ADAPTER adapter_p,
          IN UINT_8 bciIndexHigh,
          IN UINT_8 bciIndexLow,
          OUT PUINT_16 bciData_p,
          IN BOOLEAN checkRequired,
          IN UINT_16 checkMask);


/***** Routines in eeprom.c *****/
UINT_8
WriteEEProm16(IN PMP_ADAPTER adapter_p,
              IN UINT_8 EEPromOffset,
              IN UINT_16 EEPromData);

UINT_16
ReadEEProm16(IN PMP_ADAPTER adapter_p,
             IN UINT_8 EEPromOffset);

UINT_8
VerifyCheckSum(IN PMP_ADAPTER adapter_p);


/***** Routines in phy.c *****/
VOID
phyWriteRFInitTable(IN PMP_ADAPTER adapter_p,
                    IN PUINT_32 rfInitTable_p,
                    IN UINT rfInitTableSize,
                    IN UINT waitDelay);

BOOLEAN
phyBBWriteAGCTable(IN PMP_ADAPTER adapter_p,
                   IN UINT_8 agcTableAddr,
                   IN UINT_8 agcTableData);

BOOLEAN
phyBBReadAGCTable(IN PMP_ADAPTER adapter_p,
                  IN UINT_8 agcTableAddr,
                  OUT PUINT_8 agcTableData_p);

#if SUPPORT_802_11A
BOOLEAN
phyChangePhyType(IN PMP_ADAPTER adapter_p,
                   IN UINT_32 newPhyType);
#endif

VOID
phyRFInitAndWait(IN PMP_ADAPTER adapter_p);

VOID
phyRFEnterActive(IN PMP_ADAPTER adapter_p);

VOID
phyRFEnterSleep(IN PMP_ADAPTER adapter_p);

VOID
phyRFCalibration(IN PMP_ADAPTER adapter_p,
                 IN PNIC_PER_CHANNEL_CONFIG configEntry_p);

VOID
phyBBInit(IN PMP_ADAPTER adapter_p);

VOID
phySetTxSpectrumMask(IN PMP_ADAPTER adapter_p);

VOID
phyRFInitChannelList(IN PMP_ADAPTER adapter_p);

BOOLEAN
phyRFCheckForValidChannel(IN PMP_ADAPTER adapter_p,
                          IN UINT_8 channelNum,
#if SUPPORT_802_11A
                          IN UINT_8 channelBand,
#endif
                          OUT PVOID *channelProgEntry_p);

BOOLEAN
phyRFSwitchChannel(IN PMP_ADAPTER adapter_p,
                   IN UINT_8 channelNum,
#if SUPPORT_802_11A
                   IN UINT_8 channelBand,
#endif
                   IN UINT_8 txPowerLimit);

BOOLEAN
phySetRxAntenna(IN PMP_ADAPTER adapter_p,
                IN UINT_32 newAntennaMode);

VOID
phySetTXBackoff(IN PMP_ADAPTER adapter_p,
                IN UINT_32 regulationDomain);


/***** Routines in pau.c *****/
VOID
pauSoftwareReset(IN PMP_ADAPTER adapter_p);

BOOLEAN
pauDisable(IN PMP_ADAPTER adapter_p);

BOOLEAN
pauEnable(IN PMP_ADAPTER adapter_p);

VOID
pauMCRInit(IN PMP_ADAPTER adapter_p);

VOID
pauSetOwnMacAddress(IN PMP_ADAPTER adapter_p,
                    IN PUINT_8 ownMacAddr_p);

VOID
pauSetCurrentBssid(IN PMP_ADAPTER adapter_p,
                   IN PUINT_8 currentBssid_p);

VOID
pauEnablePromiscuousMode(IN PMP_ADAPTER adapter_p);

VOID
pauDisablePromiscuousMode(IN PMP_ADAPTER adapter_p);

VOID
pauEnableSnifferMode(IN PMP_ADAPTER adapter_p);

VOID
pauDisableSnifferMode(IN PMP_ADAPTER adapter_p);

VOID
pauSetupReceiverAddrMatching(IN PMP_ADAPTER adapter_p,
                             IN UINT_32 addrMatchingMask);

VOID
pauSetAllowedMcAddr(IN PMP_ADAPTER adapter_p,
                    IN UINT_32 mcAddrIndex,
                    IN PUINT_8 mcAddr_p);

VOID
pauSetMacOperationMode(IN PMP_ADAPTER adapter_p,
                       IN UINT_32 macOperationMode);

VOID
pauSetCtrlRspTxRate(IN PMP_ADAPTER adapter_p,
                    IN UINT_32 basicRateSet);

VOID
pauSetCtrlRspTxRateNew(IN PMP_ADAPTER adapter_p,
                       IN PSUPPORTED_RATE_INFO supRatesArray_p,
                       IN UINT numSupRates);

BOOLEAN
pauSetBeaconContent(IN PMP_ADAPTER adapter_p,
                    IN UINT_32 offset,
                    IN PUINT_8 content_p,
                    IN UINT_32 contentLen);

#if SUPPORT_802_11G
BOOLEAN
pauChangeSlotTime(IN PMP_ADAPTER adapter_p,
                  IN UINT_8 slotTime,
                  IN UINT_32 useED);
#endif

BOOLEAN
pauSetACParameters(IN PMP_ADAPTER adapter_p,
                   IN TX_QUEUE_NUM txQueueNum,
                   IN UINT_32 cwmin,
                   IN UINT_32 cwmax,
                   IN UINT_32 aifsn,
                   IN UINT_32 txopLimit);

BOOLEAN
pauUpdateNAV(IN PMP_ADAPTER adapter_p,
             IN UINT_32 nav);

VOID
pauClearHwKeyTable(IN PMP_ADAPTER adapter_p);

BOOLEAN
pauAccessHwKey(IN PMP_ADAPTER adapter_p,
               IN PIPN_KEY_CFG_ENTRY key_p,
               IN BOOLEAN writeKey);

BOOLEAN
pauCheckSKACRAccessStart(IN PMP_ADAPTER adapter_p);

VOID
pauConfigureLED(IN PMP_ADAPTER adapter_p,
                IN UINT_32 ledMode,
                IN UINT_32 ledPolarity);


/***** Routines in nic.c *****/
#if SUPPORT_802_11A
VOID
nicSetupRFSpecificConfig(IN PMP_ADAPTER adapter_p,
                         IN UINT_16 eepromPhyModeSetting);
#else
VOID
nicSetupRFSpecificConfig(IN PMP_ADAPTER adapter_p);
#endif

#if SUPPORT_802_11A
BOOLEAN
nicGetPerChannelConfigIndex5(IN UINT_8 channelNum,
                             OUT PUINT index_p);
#endif

VOID
nicSetTxPowerGain(IN PMP_ADAPTER adapter_p,
                  IN PNIC_PER_CHANNEL_CONFIG configEntry_p,
#if SUPPORT_802_11A
                  IN UINT_8 channelBand,
#endif
                  IN UINT_8 txPowerLimit);

VOID
nicReadPerChannelConfig(IN PMP_ADAPTER adapter_p);


/***** Routines in dma.c *****/
BOOLEAN
dmaStartTxQueue(IN PMP_ADAPTER adapter_p,
                IN TX_QUEUE_NUM txQNum,
                IN UINT_32 startingAddress);

BOOLEAN
dmaStopTxQueue(IN PMP_ADAPTER adapter_p,
               IN TX_QUEUE_NUM txQNum,
               IN BOOLEAN chkStopStatus);

BOOLEAN
dmaResumeTxQueue(IN PMP_ADAPTER adapter_p,
                 IN TX_QUEUE_NUM txQNum);

#if WORKAROUND_TX_STOP_STATUS
BOOLEAN
dmaCheckTxQueueStopStatus(IN PMP_ADAPTER adapter_p);
#endif

BOOLEAN
dmaStartRxQueue(IN PMP_ADAPTER adapter_p,
                IN UINT_32 startingAddress);

BOOLEAN
dmaStopRxQueue(IN PMP_ADAPTER adapter_p);

BOOLEAN
dmaStartSecQueue(IN PMP_ADAPTER adapter_p,
                 IN TX_QUEUE_NUM secQNum,
                 IN UINT_32 startingAddress);

BOOLEAN
dmaStopSecQueue(IN PMP_ADAPTER adapter_p,
                IN TX_QUEUE_NUM secQNum);

BOOLEAN
dmaResumeSecQueue(IN PMP_ADAPTER adapter_p,
                  IN TX_QUEUE_NUM secQNum);


/***** Routines in tsftimer.c *****/
VOID
tsftimerInitializeTsfTimer(IN PMP_ADAPTER adapter_p);

VOID
tsftimerEnableTbttTimer(IN PMP_ADAPTER adapter_p,
                        IN UINT_32 nextTbttTime,
                        IN UINT_32 tbttPeriod);

VOID
tsftimerDisableTbttTimer(IN PMP_ADAPTER adapter_p);

VOID
tsftimerEnablePreTbttTimer(IN PMP_ADAPTER adapter_p,
                           IN UINT_32 nextPreTbttTime,
                           IN UINT_32 preTbttPeriod);

VOID
tsftimerDisablePreTbttTimer(IN PMP_ADAPTER adapter_p);

VOID
tsftimerEnableDtimTimer(IN PMP_ADAPTER adapter_p,
                        IN UINT_32 nextDtimTime,
                        IN UINT_32 dtimPeriod);

VOID
tsftimerDisableDtimTimer(IN PMP_ADAPTER adapter_p);


/***** Routines in ed.c *****/
#if SUPPORT_ED_ADJUST
VOID
edSetNoiseFloorFixed(IN PMP_ADAPTER adapter_p);

VOID
edSetNoiseFloorFloat(IN PMP_ADAPTER adapter_p);

UINT_16
edStepEDThreshold(IN PMP_ADAPTER adapter_p,
                  IN INT step);

VOID
edUpdateNoiseFloor(IN PMP_ADAPTER adapter_p,
                   IN UINT_32 updateInterval,
                   IN UINT_32 macSuccessCount,
                   IN ED_ADJUST_MODE edMode);

#if SUPPORT_DYNAMIC_THRESHOLD_FOR_ED
VOID
edCalculateAverageNoiseFloor(IN PMP_ADAPTER adapter_p,
                             IN UINT_8 cr114,
                             IN UINT_8 cr115);
#endif
#endif


/***** Routines in rate.c *****/
BOOLEAN
rateGetDataRateInfo(IN UINT_8 dataRate,
                    OUT PDATA_RATE_INFO *dataRateInfo_p);

VOID
rateGetRatesFromRateSet(IN UINT_32 supportedRateSet,
                        IN UINT_32 basicRateSet,
                        OUT PUINT_8 rates_p,
                        IN UINT maxNumOfRates,
                        OUT PUINT numOfRates_p);

BOOLEAN
rateGetHighestRate(IN UINT_32 rateSet,
                   IN UINT_8 upperLimit,
                   OUT PUINT_8 highestRate_p,
                   OUT PUINT_32 phyMode_p);

BOOLEAN
rateGetLowestRate(IN UINT_32 rateSet,
                  IN UINT_8 lowerLimit,
                  OUT PUINT_8 lowestRate_p,
                  OUT PUINT_32 phyMode_p);

BOOLEAN
rateGetTxRateCode(IN UINT_8 rate,
                  IN BOOLEAN shortPreambleUsed,
                  OUT PUINT_32 rateCode_p);

BOOLEAN
rateGetRateByRateCode(IN UINT_32 rateCode,
                      OUT PUINT_8 rate_p);

VOID
rateComputePpduDuration(IN UINT_32 mpduLen,
                        IN UINT_8 dataRate,
                        IN BOOLEAN shortPreambleUsed,
                        OUT PUINT_16 ppduDuration_p);

VOID
rateComputeCtsAckDuration(IN UINT_8 dataRate,
                          IN BOOLEAN shortPreambleUsed,
                          OUT PUINT_16 ctsAckDuration_p);

VOID
rateSetupSupportedRateInfo(IN OUT PSUPPORTED_RATE_INFO supRatesArray_p,
                           IN UINT numSupRates,
                           IN UINT_32 bssBasicRateSet);

VOID
rateUpgradeTxRate(IN UINT_32 txRateSet,
                  IN UINT_8 currentTxRate,
                  OUT PUINT_8 nextRate_p,
                  OUT PUINT_32 phyMode_p);

VOID
rateDegradeTxRate(IN UINT_32 txRateSet,
                  IN UINT_8 currentTxRate,
                  OUT PUINT_8 nextRate_p,
                  OUT PUINT_32 phyMode_p);


/***** Routines in ant.c *****/
VOID
antInitAntennaList(IN PMP_ADAPTER adapter_p,
#if SUPPORT_802_11A
                   IN UINT_16 eepromAntennaSettings,
                   IN UINT_16 eepromPhyModeSetting);
#else
                   IN UINT_16 eepromAntennaSettings);
#endif

VOID
antSetRxAntennaMode(IN PMP_ADAPTER adapter_p);

NDIS_STATUS
antSetTxAntennaSelected(IN PMP_ADAPTER adapter_p,
                        IN UINT_32 newTxAntenna);

NDIS_STATUS
antSetRxAntennaSelected(IN PMP_ADAPTER adapter_p,
                        IN UINT_32 newRxAntenna);



#endif  /* _SHAREDPR_H */

