/*
** $Id: wlandef.h 1.24 2004/10/04 18:12:17 cmchang Exp $
*/

/*************************************************************************
* Copyright (c) 2002 Inprocomm, Inc.
*
* All rights reserved. Copying, compilation, modification, distribution
* or any other use whatsoever of this material is strictly prohibited
* except in accordance with a Software License Agreement with
* Inprocomm, Inc.
**************************************************************************/
/*************************************************************************
GENERAL DESCRIPTION
********************
*/

#ifndef _WLANDEF_H
#define _WLANDEF_H

/************************************************************************
*                     C O M P I L E R   F L A G S
*************************************************************************
*/

/************************************************************************
*                          C O N S T A N T S
*************************************************************************
*/
#define SIFS_TIME_HR_DSSS           10
#define SIFS_TIME_OFDM              16
#define SIFS_TIME_ERP               10

#define SLOT_TIME_LONG              20
#define SLOT_TIME_SHORT             9

#define SLOT_TIME_HR_DSSS           SLOT_TIME_LONG
#define SLOT_TIME_OFDM              SLOT_TIME_SHORT
#define SLOT_TIME_ERP_LONG          SLOT_TIME_LONG
#define SLOT_TIME_ERP_SHORT         SLOT_TIME_SHORT

#define RX_RF_DELAY                 0

#define RX_PLCP_DELAY               3

#define TX_RF_DELAY                 0

#define TX_PLCP_DELAY               4

#define TSF_TIMER_ACCURACY          1 / 10000

#define CWMIN_HR_DSSS                   31
#define CWMIN_OFDM                      15
#define CWMIN_ERP_0                     31
#define CWMIN_ERP_1                     15

#define CWMAX_HR_DSSS                   1023
#define CWMAX_OFDM                      1023
#define CWMAX_ERP                       1023

#define PHY_TYPE_DSSS                   0x00010000
#define PHY_TYPE_HR_DSSS                0x00020000
#define PHY_TYPE_OFDM                   0x00040000
#define PHY_TYPE_ERP                    0x00080000

#define PHY_MODULATION_DSSS             0x00000001
#define PHY_MODULATION_CCK              0x00000002
#define PHY_MODULATION_DSSS_CCK \
        (PHY_MODULATION_DSSS | PHY_MODULATION_CCK)
#define PHY_MODULATION_PBCC             0x00000004
#define PHY_MODULATION_OFDM             0x00000008
#define PHY_MODULATION_DSSS_OFDM        0x00000010

#define PHY_PREAMBLE_NULL               0x00000000
#define PHY_PREAMBLE_LONG               0x00001000
#define PHY_PREAMBLE_SHORT              0x00002000

#define PHY_MODE_MODULATION_MASK        0x00000FFF
#define PHY_MODE_PREAMBLE_MASK          0x0000F000
#define PHY_MODE_TYPE_MASK              0xFFFF0000

#define PHY_MODE_HR_DSSS \
        (PHY_TYPE_HR_DSSS | PHY_MODULATION_DSSS_CCK)

#define PHY_MODE_ERP_DSSS_CCK \
        (PHY_TYPE_ERP | PHY_MODULATION_DSSS_CCK)
#define PHY_MODE_ERP_OFDM \
        (PHY_TYPE_ERP | PHY_MODULATION_OFDM)
#define PHY_MODE_ER_PBCC \
        (PHY_TYPE_ERP | PHY_MODULATION_PBCC)
#define PHY_MODE_DSSS_OFDM \
        (PHY_TYPE_ERP | PHY_MODULATION_DSSS_OFDM)

#define PHY_MODE_OFDM_5 \
        (PHY_TYPE_OFDM | PHY_MODULATION_OFDM)

#define CHANNEL_BAND_24             0
#define CHANNEL_BAND_5              1

#define MAC_OPERATION_MODE_ESS_STA  0x00000000
#define MAC_OPERATION_MODE_IBSS     0x00000001
#define MAC_OPERATION_MODE_ESS_AP   0x00000002

#define ERP_STA_MODE_DSSS_CCK       PHY_MODE_ERP_DSSS_CCK
#define ERP_STA_MODE_OFDM           PHY_MODE_ERP_OFDM
#define ERP_STA_MODE_MIXED          (PHY_MODE_ERP_DSSS_CCK | PHY_MODE_ERP_OFDM)

#define BSS_TYPE_INFRASTRUCTURE     0x01
#define BSS_TYPE_INDEPENDENT        0x02
#define BSS_TYPE_ANY_BSS            0x03
#define BSS_TYPE_PSEUDO_IBSS        0x82

#define BSS_TYPE_ESS                BSS_TYPE_INFRASTRUCTURE
#define BSS_TYPE_IBSS               BSS_TYPE_INDEPENDENT

#define AD_HOC_MODE_11B             0
#define AD_HOC_MODE_MIXED_11B_G     1
#define AD_HOC_MODE_11G             2

#define AP_MODE_11B                 0
#define AP_MODE_MIXED_11B_G         1
#define AP_MODE_11G                 2
#define AP_MODE_11A                 3

#define BROADCAST_BSSID             BROADCAST_MAC_ADDR

#define BROADCAST_SSID              ""
#define BROADCAST_SSID_LEN          0

#define RATE_1M                     0x02
#define RATE_2M                     0x04
#define RATE_5_5M                   0x0B
#define RATE_11M                    0x16
#define RATE_22M                    0x2C
#define RATE_33M                    0x42
#define RATE_6M                     0x0C
#define RATE_9M                     0x12
#define RATE_12M                    0x18
#define RATE_18M                    0x24
#define RATE_24M                    0x30
#define RATE_36M                    0x48
#define RATE_48M                    0x60
#define RATE_54M                    0x6C
#define RATE_MASK                   0x7F
#define RATE_BASIC_BIT              0x80

#define RATE_SET_BIT_1M             BIT(0)
#define RATE_SET_BIT_2M             BIT(1)
#define RATE_SET_BIT_5_5M           BIT(2)
#define RATE_SET_BIT_11M            BIT(3)
#define RATE_SET_BIT_22M            BIT(4)
#define RATE_SET_BIT_33M            BIT(5)
#define RATE_SET_BIT_6M             BIT(8)
#define RATE_SET_BIT_9M             BIT(9)
#define RATE_SET_BIT_12M            BIT(10)
#define RATE_SET_BIT_18M            BIT(11)
#define RATE_SET_BIT_24M            BIT(12)
#define RATE_SET_BIT_36M            BIT(13)
#define RATE_SET_BIT_48M            BIT(14)
#define RATE_SET_BIT_54M            BIT(15)

#define RATE_SET_MASK_DSSS          BITS(0,1)
#define RATE_SET_MASK_CCK           BITS(2,3)
#define RATE_SET_MASK_DSSS_CCK      (RATE_SET_MASK_DSSS | RATE_SET_MASK_CCK)
#define RATE_SET_MASK_OFDM          BITS(8,15)
#define RATE_SET_MASK_PBCC          BITS(2,5)
#define RATE_SET_MASK_DSSS_OFDM     BITS(8,15)

#define RATE_SET_MASK_HR_DSSS       RATE_SET_MASK_DSSS_CCK

#define RATE_SET_MASK_ERP_DSSS      RATE_SET_MASK_DSSS
#define RATE_SET_MASK_ERP_CCK       RATE_SET_MASK_CCK
#define RATE_SET_MASK_ERP_DSSS_CCK  RATE_SET_MASK_DSSS_CCK
#define RATE_SET_MASK_ERP_OFDM      RATE_SET_MASK_OFDM
#define RATE_SET_MASK_ER_PBCC       RATE_SET_MASK_PBCC
#define RATE_SET_MASK_ERP_DSSS_OFDM RATE_SET_MASK_DSSS_OFDM
#define RATE_SET_MASK_ERP           (RATE_SET_MASK_ERP_DSSS_CCK | \
                                    RATE_SET_MASK_ERP_OFDM | \
                                    RATE_SET_MASK_ER_PBCC | \
                                    RATE_SET_MASK_ERP_DSSS_OFDM)

#define RATE_SET_MASK_OFDM_5        RATE_SET_MASK_OFDM

#define STA_STATE_AUTH_BIT          0x01
#define STA_STATE_ASSOC_BIT         0x02
#define STA_STATE_1                 0x00
#define STA_STATE_2                 STA_STATE_AUTH_BIT
#define STA_STATE_3                 (STA_STATE_AUTH_BIT | STA_STATE_ASSOC_BIT)


#define MASK_FC_PROTOCOL_VER            BITS(0,1)
#define MASK_FC_TYPE                    BITS(2,3)
#define MASK_FC_SUBTYPE                 BITS(4,7)
#define MASK_FC_TO_DS                   BIT(8)
#define MASK_FC_FROM_DS                 BIT(9)
#define MASK_FC_MORE_FRAG               BIT(10)
#define MASK_FC_RETRY                   BIT(11)
#define MASK_FC_PWR_MGT                 BIT(12)
#define MASK_FC_MORE_DATA               BIT(13)
#define MASK_FC_WEP                     BIT(14)
#define MASK_FC_ORDER                   BIT(15)

#define MASK_EXT_IV                     BIT(5)

#define MASK_FRAME_TYPE                 (MASK_FC_TYPE | MASK_FC_SUBTYPE)

#define MASK_TO_DS_FROM_DS              (MASK_FC_TO_DS | MASK_FC_FROM_DS)

#define MAC_FRAME_TYPE_MGT              0x0000
#define MAC_FRAME_TYPE_CTRL             BIT(2)
#define MAC_FRAME_TYPE_DATA             BIT(3)
#define MAC_FRAME_TYPE_QOS_DATA         BIT(7)

#define MAC_FRAME_ASSOC_REQ                 (MAC_FRAME_TYPE_MGT | 0x0000)
#define MAC_FRAME_ASSOC_RSP                 (MAC_FRAME_TYPE_MGT | 0x0010)
#define MAC_FRAME_REASSOC_REQ               (MAC_FRAME_TYPE_MGT | 0x0020)
#define MAC_FRAME_REASSOC_RSP               (MAC_FRAME_TYPE_MGT | 0x0030)
#define MAC_FRAME_PROBE_REQ                 (MAC_FRAME_TYPE_MGT | 0x0040)
#define MAC_FRAME_PROBE_RSP                 (MAC_FRAME_TYPE_MGT | 0x0050)
#define MAC_FRAME_BEACON                    (MAC_FRAME_TYPE_MGT | 0x0080)
#define MAC_FRAME_ATIM                      (MAC_FRAME_TYPE_MGT | 0x0090)
#define MAC_FRAME_DISASSOC                  (MAC_FRAME_TYPE_MGT | 0x00A0)
#define MAC_FRAME_AUTH                      (MAC_FRAME_TYPE_MGT | 0x00B0)
#define MAC_FRAME_DEAUTH                    (MAC_FRAME_TYPE_MGT | 0x00C0)
#define MAC_FRAME_ACTION                    (MAC_FRAME_TYPE_MGT | 0x00D0)

#define MAC_FRAME_BLOCK_ACK_REQ             (MAC_FRAME_TYPE_CTRL | 0x0080)
#define MAC_FRAME_BLOCK_ACK                 (MAC_FRAME_TYPE_CTRL | 0x0090)
#define MAC_FRAME_PS_POLL                   (MAC_FRAME_TYPE_CTRL | 0x00A0)
#define MAC_FRAME_RTS                       (MAC_FRAME_TYPE_CTRL | 0x00B0)
#define MAC_FRAME_CTS                       (MAC_FRAME_TYPE_CTRL | 0x00C0)
#define MAC_FRAME_ACK                       (MAC_FRAME_TYPE_CTRL | 0x00D0)
#define MAC_FRAME_CF_END                    (MAC_FRAME_TYPE_CTRL | 0x00E0)
#define MAC_FRAME_CF_END_CF_ACK             (MAC_FRAME_TYPE_CTRL | 0x00F0)

#define MAC_FRAME_DATA                      (MAC_FRAME_TYPE_DATA | 0x0000)
#define MAC_FRAME_DATA_CF_ACK               (MAC_FRAME_TYPE_DATA | 0x0010)
#define MAC_FRAME_DATA_CF_POLL              (MAC_FRAME_TYPE_DATA | 0x0020)
#define MAC_FRAME_DATA_CF_ACK_CF_POLL       (MAC_FRAME_TYPE_DATA | 0x0030)
#define MAC_FRAME_NULL                      (MAC_FRAME_TYPE_DATA | 0x0040)
#define MAC_FRAME_CF_ACK                    (MAC_FRAME_TYPE_DATA | 0x0050)
#define MAC_FRAME_CF_POLL                   (MAC_FRAME_TYPE_DATA | 0x0060)
#define MAC_FRAME_CF_ACK_CF_POLL            (MAC_FRAME_TYPE_DATA | 0x0070)
#define MAC_FRAME_QOS_DATA                  (MAC_FRAME_TYPE_DATA | 0x0080)
#define MAC_FRAME_QOS_DATA_CF_ACK           (MAC_FRAME_TYPE_DATA | 0x0090)
#define MAC_FRAME_QOS_DATA_CF_POLL          (MAC_FRAME_TYPE_DATA | 0x00A0)
#define MAC_FRAME_QOS_DATA_CF_ACK_CF_POLL   (MAC_FRAME_TYPE_DATA | 0x00B0)
#define MAC_FRAME_QOS_NULL                  (MAC_FRAME_TYPE_DATA | 0x00C0)
#define MAC_FRAME_QOS_CF_ACK                (MAC_FRAME_TYPE_DATA | 0x00D0)
#define MAC_FRAME_QOS_CF_POLL               (MAC_FRAME_TYPE_DATA | 0x00E0)
#define MAC_FRAME_QOS_CF_ACK_CF_POLL        (MAC_FRAME_TYPE_DATA | 0x00F0)

#define MASK_DI_DURATION                BITS(0,14)
#define MASK_DI_CFP_FIXED_VALUE         BIT(15)
#define MASK_DI_AID                     BITS(0,13)
#define MASK_DI_AID_MSB                 BITS(14,15)

#define MASK_QOSCTL_TID                 BITS(0,3)
#if SUPPORT_WME
#define MASK_QOSCTL_802_1D_TAG          BITS(0,2)
#endif
#define MASK_QOSCTL_ACK_POLICY          BITS(5,6)
#define MASK_QOSCTL_ACK                 0x0000
#define MASK_QOSCTL_NO_ACK              BIT(5)
#define MASK_QOSCTL_SCHEDULE            BIT(7)
#define MASK_QOSCTL_TXOPLIM             BITS(8,15)
#define MASK_QOSCTL_TXOPREQ             BITS(8,15)
#define MASK_QOSCTL_Q_SIZE              BITS(8,15)

#define MASK_SC_SEQ_NUM                 BITS(4,15)
#define MASK_SC_FRAG_NUM                BITS(0,3)
#define BROADCOMM_CCMP_SC_MASK          0xFFFF

#define AUTH_ALGORITHM_NUM_OPEN_SYSTEM      0
#define AUTH_ALGORITHM_NUM_SHARED_KEY       1
#if SUPPORT_CCX_V1
#define AUTH_ALGORITHM_NUM_NETWORK_EAP      128
#endif


#define CAP_INFO_ESS                    BIT(0)
#define CAP_INFO_IBSS                   BIT(1)
#define CAP_INFO_BSS_TYPE               (CAP_INFO_ESS | CAP_INFO_IBSS)
#define CAP_INFO_CF_POLLABLE            BIT(2)
#define CAP_INFO_CF_POLL_REQ            BIT(3)
#define CAP_INFO_CF                     (CAP_INFO_CF_POLLABLE | CAP_INFO_CF_POLL_REQ)
#define CAP_INFO_PRIVACY                BIT(4)
#define CAP_INFO_SHORT_PREAMBLE         BIT(5)
#define CAP_INFO_PBCC                   BIT(6)
#define CAP_INFO_CHNL_AGILITY           BIT(7)
#if SUPPORT_802_11H
#define CAP_INFO_SPEC_MGT               BIT(8)
#endif
#define CAP_INFO_SHORT_SLOT_TIME        BIT(10)
#define CAP_INFO_RSN                    BIT(11)
#define CAP_INFO_DSSS_OFDM              BIT(13)

#define CAP_ESS                         CAP_INFO_ESS
#define CAP_IBSS                        CAP_INFO_IBSS

#define CAP_CF_STA_NOT_POLLABLE         0x0000
#define CAP_CF_STA_NOT_ON_LIST          CAP_INFO_CF_POLL_REQ
#define CAP_CF_STA_ON_LIST              CAP_INFO_CF_POLLABLE
#define CAP_CF_STA_NEVER_POLLED         (CAP_INFO_CF_POLLABLE | CAP_INFO_CF_POLL_REQ)

#define CAP_CF_AP_NO_PC                 0x0000
#define CAP_CF_AP_DELIVERY_ONLY         CAP_INFO_CF_POLL_REQ
#define CAP_CF_AP_DELIVERY_POLLING      CAP_INFO_CF_POLLABLE

#define ASSOC_ID_MASK                   BITS(0,13)
#define ASSOC_ID_MSB                    BITS(14,15)

#define REASON_CODE_UNSPECIFIED                     1
#define REASON_CODE_PREV_AUTH_INVALID               2
#define REASON_CODE_DEAUTH_LEAVING_BSS              3
#define REASON_CODE_DISASSOC_INACTIVITY             4
#define REASON_CODE_DISASSOC_AP_OVERLOAD            5
#define REASON_CODE_CLASS_2_ERR                     6
#define REASON_CODE_CLASS_3_ERR                     7
#define REASON_CODE_DISASSOC_LEAVING_BSS            8
#define REASON_CODE_ASSOC_BEFORE_AUTH               9
#if SUPPORT_802_11H
#define REASON_CODE_DISASSOC_PWR_CAP_UNACCEPTABLE   10
#define REASON_CODE_DISASSOC_SUP_CHNLS_UNACCEPTABLE 11
#endif
#define REASON_CODE_INVALID_INFO_ELEM               13
#define REASON_CODE_MIC_FAILURE                     14
#define REASON_CODE_4_WAY_HANDSHAKE_TIMEOUT         15
#define REASON_CODE_GROUP_KEY_UPDATE_TIMEOUT        16
#define REASON_CODE_DIFFERENT_INFO_ELEM             17
#define REASON_CODE_MULTICAST_CIPHER_NOT_VALID      18
#define REASON_CODE_UNICAST_CIPHER_NOT_VALID        19
#define REASON_CODE_AKMP_NOT_VALID                  20
#define REASON_CODE_UNSUPPORTED_RSNE_VERSION        21
#define REASON_CODE_INVALID_RSNE_CAPABILITIES       22
#define REASON_CODE_IEEE_802_1X_AUTH_FAILED         23

#define STATUS_CODE_SUCCESSFUL                      0
#define STATUS_CODE_UNSPECIFIED_FAILURE             1
#define STATUS_CODE_CAP_NOT_SUPPORTED               10
#define STATUS_CODE_REASSOC_DENIED_WITHOUT_ASSOC    11
#define STATUS_CODE_ASSOC_DENIED_OUTSIDE_STANDARD   12
#define STATUS_CODE_AUTH_ALGORITHM_NOT_SUPPORTED    13
#define STATUS_CODE_AUTH_OUT_OF_SEQ                 14
#define STATUS_CODE_AUTH_REJECTED_CHAL_FAIL         15
#define STATUS_CODE_AUTH_REJECTED_TIMEOUT           16
#define STATUS_CODE_ASSOC_DENIED_AP_OVERLOAD        17
#define STATUS_CODE_ASSOC_DENIED_RATE_NOT_SUPPORTED 18

#define STATUS_CODE_ASSOC_DENIED_NO_SHORT_PREAMBLE  19
#define STATUS_CODE_ASSOC_DENIED_NO_PBCC            20
#define STATUS_CODE_ASSOC_DENIED_NO_CHNL_AGILITY    21
#if SUPPORT_802_11H
#define STATUS_CODE_ASSOC_REJECTED_NO_SPEC_MGT      22
#define STATUS_CODE_ASSOC_REJECTED_PWR_CAP          23
#define STATUS_CODE_ASSOC_REJECTED_SUP_CHNLS        24
#endif
#define STATUS_CODE_ASSOC_DENIED_NO_SHORT_SLOT_TIME 25
#define STATUS_CODE_ASSOC_DENIED_NO_DSSS_OFDM       26

#define STATUS_CODE_JOIN_TIMEOUT                    0xFFF0
#define STATUS_CODE_AUTH_TIMEOUT                    0xFFF1
#define STATUS_CODE_ASSOC_TIMEOUT                   0xFFF2
#define STATUS_CODE_CCX_CCKM_REASSOC_FAILURE        0xFFF3

#define CATEGORY_SPEC_MGT               0
#define CATEGORY_QOS_ACTION             1
#define CATEGORY_DLP_ACTION             2
#define CATEGORY_BLOCK_ACK_ACTION       3
#define CATEGORY_WME_MGT_NOTIFICATION   17

#define ACTION_MEASUREMENT_REQ          0
#define ACTION_MEASUREMENT_REPORT       1
#define ACTION_TPC_REQ                  2
#define ACTION_TPC_REPORT               3
#define ACTION_CHNL_SW_ANNOUNCE         4

#define ACTION_ADDTS_REQ                0
#define ACTION_ADDTS_RSP                1
#define ACTION_DELTS                    2
#define ACTION_SCHEDULE                 4

#define ACTION_DLP_REQ                  0
#define ACTION_DLP_RSP                  1
#define ACTION_DLP_TEARDOWN             2

#define ACTION_ADDBA_REQ                0
#define ACTION_ADDBA_RSP                1
#define ACTION_DELBA                    2

#define ACTION_WME_SETUP_REQ            0
#define ACTION_WME_SETUP_RSP            1
#define ACTION_WME_TEARDOWN             2

#define DFS_MAP_BSS                     BIT(0)
#define DFS_MAP_OFDM_PREAMBLE           BIT(1)
#define DFS_MAP_UNIDENTIFIED_SIGNAL     BIT(2)
#define DFS_MAP_RADAR                   BIT(3)
#define DFS_MAP_UNMEASURED              BIT(4)

#define MASK_EAPOL_KI_DESCR_VER         BITS(0,2)
#define MASK_EAPOL_KI_TYPE              BIT(3)
#define MASK_EAPOL_KI_INDEX             BITS(4,5)
#define MASK_EAPOL_KI_INSTALL           BIT(6)
#define MASK_EAPOL_KI_ACK               BIT(7)
#define MASK_EAPOL_KI_MIC               BIT(8)
#define MASK_EAPOL_KI_SECURE            BIT(9)
#define MASK_EAPOL_KI_ERROR             BIT(10)
#define MASK_EAPOL_KI_REQUEST           BIT(11)
#define MASK_EAPOL_KI_RESERVE           BITS(12,15)

#define VENDOR_OUI_WPA                  { 0x00, 0x50, 0xF2 }
#define VENDOR_OUI_INPROCOMM            { 0x00, 0x08, 0x22 }
#define VENDOR_OUI_CISCO                { 0x00, 0x40, 0x96 }
#define VENDOR_OUI_BROADCOM             { 0x00, 0x10, 0x18 }
#if SUPPORT_WME
#define VENDOR_OUI_WME                  { 0x00, 0x50, 0xF2 }
#endif

#define VENDOR_OUI_TYPE_WPA             1
#if SUPPORT_WME
#define VENDOR_OUI_TYPE_WMEWSM          2
#endif

#if SUPPORT_WME
#define VENDOR_OUI_SUBTYPE_WME_INFO         0
#define VENDOR_OUI_SUBTYPE_WME_PARAM        1
#define VENDOR_OUI_SUBTYPE_TSPEC            2
#define VENDOR_OUI_SUBTYPE_WSM_QOSCAP       5
#define VENDOR_OUI_SUBTYPE_WSM_TCLASS       6
#define VENDOR_OUI_SUBTYPE_WSM_TCLASS_PROC  7
#define VENDOR_OUI_SUBTYPE_WSM_TSDELAY      8
#define VENDOR_OUI_SUBTYPE_WSM_SCHEDULE     9
#endif


#if SUPPORT_WME
#define WME_QOS_INFO_PARAM_SET_COUNT            BITS(0,3)

#define WME_ACIAIFSN_AIFSN                      BITS(0,3)
#define WME_ACIAIFSN_ACM                        BIT(4)
#define WME_ACIAIFSN_ACI                        BITS(5,6)

#define WME_ACI_AC_BEST_EFFORT                  0
#define WME_ACI_AC_BACKGROUND                   BIT(5)
#define WME_ACI_AC_VIDEO                        BIT(6)
#define WME_ACI_AC_VOICE                        BITS(5,6)

#define WME_ACI_AC_BE                           WME_ACI_AC_BEST_EFFORT
#define WME_ACI_AC_BK                           WME_ACI_AC_BACKGROUND
#define WME_ACI_AC_VI                           WME_ACI_AC_VIDEO
#define WME_ACI_AC_VO                           WME_ACI_AC_VOICE

#define WME_AC_BE                               0
#define WME_AC_BK                               1
#define WME_AC_VI                               2
#define WME_AC_VO                               3

#define WME_ECWMINECWMAX_ECWMIN                 BITS(0,3)
#define WME_ECWMINECWMAX_ECWMAX                 BITS(4,7)

#define WME_SETUP_RSP_STATUS_CODE_ACCEPTED      0
#define WME_SETUP_RSP_STATUS_CODE_INVALID_PARAM 1
#define WME_SETUP_RSP_STATUS_CODE_REFUSED       2

#define WSM_TCLASS_TYPE0_LENGTH                 23
#define WSM_TCLASS_TYPE1IPV4_LENGTH             25
#define WSM_TCLASS_TYPE1IPV6_LENGTH             49
#define WSM_TCLASS_TYPE2_LENGTH                 5
#endif


#define ELEM_ID_SSID                    0
#define ELEM_ID_SUP_RATES               1
#define ELEM_ID_FH_PARAM_SET            2
#define ELEM_ID_DS_PARAM_SET            3
#define ELEM_ID_CF_PARAM_SET            4
#define ELEM_ID_TIM                     5
#define ELEM_ID_IBSS_PARAM_SET          6

#define ELEM_ID_COUNTRY_INFO            7
#define ELEM_ID_HOPPING_PATTERN_PARAM   8
#define ELEM_ID_HOPPING_PATTERN_TABLE   9
#define ELEM_ID_REQUEST                 10

#define ELEM_ID_QBSS_LOAD               11
#define ELEM_ID_EDCA_PARAM_SET          12
#define ELEM_ID_TSPEC                   13
#define ELEM_ID_TCLAS                   14
#define ELEM_ID_SCHEDULE                15
#define ELEM_ID_CHALLENGE_TEXT          16

#define ELEM_ID_PWR_CONSTRAINT          32
#define ELEM_ID_PWR_CAP                 33
#define ELEM_ID_TPC_REQ                 34
#define ELEM_ID_TPC_REPORT              35
#define ELEM_ID_SUP_CHNLS               36
#define ELEM_ID_CHNL_SW_ANNOUNCEMENT    37
#define ELEM_ID_MEASUREMENT_REQ         38
#define ELEM_ID_MEASUREMENT_REPORT      39
#define ELEM_ID_QUIET                   40
#define ELEM_ID_IBSS_DFS                41

#define ELEM_ID_ERP_INFO                42

#define ELEM_ID_TS_DELAY                43
#define ELEM_ID_TCLAS_PROCESSING        44
#define ELEM_ID_QOS_MGT_ACTION          45
#define ELEM_ID_QOS_CAP                 46

#define ELEM_ID_RSN                     48

#define ELEM_ID_EXTENDED_SUP_RATES      50

#define ELEM_ID_VENDOR                  221
#define ELEM_ID_WPA                     ELEM_ID_VENDOR

#if SUPPORT_CCX_V1
#define ELEM_ID_CCX_AIRONET             133
#define ELEM_ID_CCX_ENCAPSULATION       136
#define ELEM_ID_CCX_AP_IP_ADDR          149
#define ELEM_ID_CCX_SYMBOL              173
#define ELEM_ID_CCX_VER_NUM             ELEM_ID_VENDOR
#endif

#if SUPPORT_CCX_V2
#define ELEM_ID_CCX_CELL_PWR_LIMIT      150
#define ELEM_ID_CCX_CCKM_REASSOC_REQ    156
#define ELEM_ID_CCX_CCKM_REASSOC_RSP    156
#define ELEM_ID_CCX_RADIO_MGT_CAP       ELEM_ID_VENDOR
#define ELEM_ID_CCX_QOS_PARAM_SET       ELEM_ID_VENDOR
#endif

#if SUPPORT_WME
#define ELEM_ID_WME                     ELEM_ID_VENDOR
#define ELEM_ID_WSM                     ELEM_ID_VENDOR
#endif


#define TIM_BITMAP_CTRL_TI_AID_0                ((UINT_8) BIT(0))
#define TIM_BITMAP_CTRL_BITMAP_OFFSET           ((UINT_8) BITS(1,7))

#define MEASUREMENT_TYPE_BASIC                  0
#define MEASUREMENT_TYPE_CCA                    1
#define MEASUREMENT_TYPE_RPI_HISTOGRAM          2

#define MEASUREMENT_REQ_MODE_ENABLE             BIT(1)
#define MEASUREMENT_REQ_MODE_REQ                BIT(2)
#define MEASUREMENT_REQ_MODE_REPORT             BIT(3)

#define MEASUREMENT_REPORT_MODE_LATE            BIT(0)
#define MEASUREMENT_REPORT_MODE_INCAPABLE       BIT(1)
#define MEASUREMENT_REPORT_MODE_REFUSED         BIT(2)

#define ERP_INFO_NON_ERP_PRESENT        BIT(0)
#define ERP_INFO_USE_PROTECTION         BIT(1)
#define ERP_INFO_BARKER_PREAMBLE_MODE   BIT(2)


#define SCAN_TYPE_ACTIVE                1
#define SCAN_TYPE_PASSIVE               2


#define AUTH_TYPE_OPEN_SYSTEM           AUTH_ALGORITHM_NUM_OPEN_SYSTEM
#define AUTH_TYPE_SHARED_KEY            AUTH_ALGORITHM_NUM_SHARED_KEY
#if SUPPORT_CCX_V1
#define AUTH_TYPE_NETWORK_EAP           AUTH_ALGORITHM_NUM_NETWORK_EAP
#endif

#define CIPHER_SUITE_NONE               0
#define CIPHER_SUITE_WEP40              1
#define CIPHER_SUITE_TKIP               2
#define CIPHER_SUITE_CCMP               4
#define CIPHER_SUITE_WEP104             5
#define CIPHER_SUITE_WEP128             6
#define CIPHER_SUITE_CCMP_2120          7

#define ENCRYPTION_MODE_NONE            CIPHER_SUITE_NONE
#define ENCRYPTION_MODE_WEP40           CIPHER_SUITE_WEP40
#define ENCRYPTION_MODE_WEP104          CIPHER_SUITE_WEP104
#define ENCRYPTION_MODE_WEP128          CIPHER_SUITE_WEP128

#define MASK_CHANGE_CIPHER_SUITE        BIT(27)

#define ENCRYPT_SUCCESS                 0
#define DECRYPT_SUCCESS                 0
#define ENCAPSULATE_SUCCESS             0
#define DECAPSULATE_SUCCESS             0
#define ENCRYPT_ERROR                   1
#define DECRYPT_ERROR                   1
#define ENCAPSULATE_ERROR               1
#define DECAPSULATE_ERROR               1
#define NULL_KEY_ERROR                  5
#define CIPHER_ERROR                    6
#define ENCAPSULATE_PENDING             7
#define DECAPSULATE_PENDING             7

#define WEP_ENCAPSULATE_SUCCESS         ENCAPSULATE_SUCCESS
#define WEP_DECAPSULATE_SUCCESS         DECAPSULATE_SUCCESS
#define WEP_ENCRYPT_SUCCESS             ENCRYPT_SUCCESS
#define WEP_DECRYPT_SUCCESS             DECRYPT_SUCCESS
#define WEP_ICV_ERROR                   11
#define WEP_FRAME_FORMAT_ERROR          14
#define WEP_NULL_KEY_ERROR              15

#define TKIP_ENCAPSULATE_SUCCESS        ENCAPSULATE_SUCCESS
#define TKIP_DECAPSULATE_SUCCESS        DECAPSULATE_SUCCESS
#define TKIP_ENCRYPT_SUCCESS            ENCRYPT_SUCCESS
#define TKIP_DECRYPT_SUCCESS            DECRYPT_SUCCESS
#define TKIP_ENCAPSULATE_PENDING        ENCAPSULATE_PENDING
#define TKIP_DECAPSULATE_PENDING        DECAPSULATE_PENDING
#define TKIP_ICV_ERROR                  21
#define TKIP_MIC_ERROR                  22
#define TKIP_REPLAY_ERROR               23
#define TKIP_FRAME_FORMAT_ERROR         24
#define TKIP_NULL_KEY_ERROR             25

#define CCMP_ENCAPSULATE_SUCCESS        ENCAPSULATE_SUCCESS
#define CCMP_DECAPSULATE_SUCCESS        DECAPSULATE_SUCCESS
#define CCMP_ENCRYPT_SUCCESS            ENCRYPT_SUCCESS
#define CCMP_DECRYPT_SUCCESS            DECRYPT_SUCCESS
#define CCMP_MIC_ERROR                  42
#define CCMP_REPLAY_ERROR               43
#define CCMP_FRAME_FORMAT_ERROR         44
#define CCMP_NULL_KEY_ERROR             45

#define CKIP_ENCAPSULATE_SUCCESS        ENCAPSULATE_SUCCESS
#define CKIP_DECAPSULATE_SUCCESS        DECAPSULATE_SUCCESS
#define CKIP_ENCRYPT_SUCCESS            ENCRYPT_SUCCESS
#define CKIP_DECRYPT_SUCCESS            DECRYPT_SUCCESS
#define CKIP_ICV_ERROR                  51
#define CKIP_MIC_ERROR                  52
#define CKIP_SEQ_REPLAY_ERROR           53
#define CKIP_FRAME_FORMAT_ERROR         54
#define CKIP_NULL_KEY_ERROR             55
#define CKIP_SEQ_ODD_ERROR              56
#define CKIP_SEQ_EVEN_ERROR             57

#define RSN_CIPHER_SUITE_USE_GROUP_KEY  0x00AC0F00
#define RSN_CIPHER_SUITE_WEP40          0x01AC0F00
#define RSN_CIPHER_SUITE_TKIP           0x02AC0F00
#define RSN_CIPHER_SUITE_CCMP           0x04AC0F00
#define RSN_CIPHER_SUITE_WEP104         0x05AC0F00

#define WPA_CIPHER_SUITE_NONE           0x00F25000
#define WPA_CIPHER_SUITE_WEP40          0x01F25000
#define WPA_CIPHER_SUITE_TKIP           0x02F25000
#define WPA_CIPHER_SUITE_CCMP           0x04F25000
#define WPA_CIPHER_SUITE_WEP104         0x05F25000

#define IPC_CIPHER_SUITE_WEP128         0x06220800

#define CCX_CIPHER_SUITE_CKIP40         0x01964000
#define CCX_CIPHER_SUITE_CKIP104        0x05964000

#define RSN_AKM_SUITE_NONE              0x00AC0F00
#define RSN_AKM_SUITE_802_1X            0x01AC0F00
#define RSN_AKM_SUITE_PSK               0x02AC0F00

#define WPA_AKM_SUITE_NONE              0x00F25000
#define WPA_AKM_SUITE_802_1X            0x01F25000
#define WPA_AKM_SUITE_PSK               0x02F25000

#if SUPPORT_CCX_V2
#define CCX_AKM_SUITE_CCKM              0x00964000
#endif

#define MASK_RSNIE_CAP_PREAUTH                BIT(0)
#define MASK_RSNIE_CAP_NO_PAIRWISE            BIT(1)
#define MASK_RSNIE_CAP_PKTSA_REPLAY_COUNTER   BITS(2,3)
#define MASK_RSNIE_CAP_GKTSA_REPLAY_COUNTER   BITS(4,5)
#define MASK_RSNIE_CAP_RESERVED               BITS(6,15)

/************************************************************************
*                         D A T A   T Y P E S
*************************************************************************
*/
typedef struct _DATA_RATE_INFO {
    UINT_8 rate;
    UINT_8 displayString[5];
    UINT_32 rateSetBit;
    UINT_32 rateCode;
    UINT_32 phyMode;
} DATA_RATE_INFO, *PDATA_RATE_INFO;

typedef struct _SUPPORTED_RATE_INFO {
    UINT_8 rate;
    BOOLEAN basicRate;
    UINT_32 phyMode;
    UINT_8 ackTxRate;
    UINT_8 protectFrameTxRate;
    UINT_16 txDuration;
} SUPPORTED_RATE_INFO, *PSUPPORTED_RATE_INFO;

typedef struct _IPN_KEY_STRUC {
    BOOLEAN             chkKeyId;
    BOOLEAN             chkAddr1;
    BOOLEAN             chkAddr2;
    UINT_8              keyId;
    UINT_8              cipher;
    UINT_8              addr[6];
    UINT_8              keyMaterial[32];
} IPN_KEY_STRUC, *PIPN_KEY_STRUC;

typedef struct _IPN_SW_KEY_TABLE_ENTRY {
    BOOLEAN             entryUsed;
    IPN_KEY_STRUC       key;
} IPN_SW_KEY_TABLE_ENTRY, *PIPN_SW_KEY_TABLE_ENTRY;

typedef struct _IPN_KEY_CFG_ENTRY {
    UINT_32             entryIndex;
    UINT_8              keyTable;
    IPN_KEY_STRUC       key;
} IPN_KEY_CFG_ENTRY, *PIPN_KEY_CFG_ENTRY;

/************************************************************************
*                             M A C R O S
*************************************************************************
*/
#define USEC_TO_MSEC(usec)              ((usec) / 1000)
#define USEC_TO_SYSTIME(usec)           ((INT_64) (usec) * 10)
#define USEC_TO_TU(usec)                ((usec) >> 10)

#define MSEC_TO_USEC(msec)              ((UINT_32) (msec) * 1000)
#define MSEC_TO_SYSTIME(msec)           ((INT_64) (msec) * 10000)

#define SEC_TO_SYSTIME(sec)             ((INT_64) (sec) * 10000000)

#define TU_TO_USEC(tu)                  ((UINT_32) (tu) << 10)
#define TU_TO_MSEC(tu)                  USEC_TO_MSEC(TU_TO_USEC(tu))
#define TU_TO_SYSTIME(tu)               USEC_TO_SYSTIME(TU_TO_USEC(tu))


/************************************************************************
*                    D A T A   D E C L A R A T I O N S
*************************************************************************
*/

/************************************************************************
*                 F U N C T I O N   D E C L A R A T I O N S
*************************************************************************
*/


#endif /* _WLANDEF_H */

